# Copyright (c) 2016 - 2021 Intel Corporation
# For licensing information, see the file 'LICENSE' in the root folder
#
# codeprep.sed -- sed script used for pre-processing of irdma driver code
#
s/= IRDMA_SUCCESS/= 0/
s/return IRDMA_SUCCESS/return 0/
s/return IRDMA_ERR_NO_MEMORY/return -ENOMEM/
s/= IRDMA_ERR_NO_MEMORY/= -ENOMEM/
s/return IRDMA_ERR_QP_TOOMANY_WRS_POSTED/return -ENOMEM/
s/= IRDMA_ERR_QP_TOOMANY_WRS_POSTED/= -ENOMEM/
s/return IRDMA_ERR_REG_CQ_FULL/return -ENOMEM/
s/= IRDMA_ERR_REG_CQ_FULL/= -ENOMEM/
s/return IRDMA_ERR_RING_FULL/return -ENOMEM/
s/= IRDMA_ERR_RING_FULL/= -ENOMEM/
s/return IRDMA_ERR_NOT_READY/return -EBUSY/
s/= IRDMA_ERR_NOT_READY/= -EBUSY/
s/return IRDMA_ERR_PARAM/return -EINVAL/
s/= IRDMA_ERR_PARAM/= -EINVAL/
s/return IRDMA_ERR_TIMEOUT/return -ETIMEDOUT/
s/= IRDMA_ERR_TIMEOUT/= -ETIMEDOUT/
s/return IRDMA_ERR_BAD_PTR/return -EFAULT/
s/= IRDMA_ERR_BAD_PTR/= -EFAULT/
s/return IRDMA_ERR_DEVICE_NOT_SUPPORTED/return -EOPNOTSUPP/
s/= IRDMA_ERR_DEVICE_NOT_SUPPORTED/= -EOPNOTSUPP/
s/return IRDMA_ERR_NO_TXBUFS/return -ENOBUFS/
s/= IRDMA_ERR_NO_TXBUFS/= -ENOBUFS/
s/return IRDMA_ERR_CQP_COMPL_ERROR/return -EIO/
s/= IRDMA_ERR_CQP_COMPL_ERROR/= -EIO/
s/return IRDMA_ERR_FEATURES_OP/return -EIO/
s/= IRDMA_ERR_FEATURES_OP/= -EIO/
s/return IRDMA_ERR_FEATURES_OP/return -EIO/
s/= IRDMA_ERR_FEATURES_OP/= -EIO/
s/return IRDMA_ERR_CQ_COMPL_ERROR/return -EIO/
s/= IRDMA_ERR_CQ_COMPL_ERROR/= -EIO/
s/return IRDMA_ERR_MPA_CRC/return -EINVAL/
s/= IRDMA_ERR_MPA_CRC/= -EINVAL/
s/return IRDMA_ERR_INVALID_.*;/return -EINVAL;/
s/= IRDMA_ERR_INVALID_.*/= -EINVAL;/
s/return IRDMA_ERR_CFG/return -EINVAL/
s/= IRDMA_ERR_CFG/= -EINVAL/
s/return IRDMA_ERR_REG_QSET/return -EINVAL/
s/= IRDMA_ERR_REG_QSET/= -EINVAL/
s/return IRDMA_ERR_NO_INTR/return -EINVAL/
s/= IRDMA_ERR_NO_INTR/= -EINVAL/
s/return IRDMA_ERR_NOT_IMPL/return -EOPNOTSUPP/
s/= IRDMA_ERR_NOT_IMPL/= -EOPNOTSUPP/
s/return IRDMA_ERR_VF_MSG_ERROR/return -EBADMSG/
s/= IRDMA_ERR_VF_MSG_ERROR/= -EOPNOTSUPP/
s/return IRDMA_NOT_SUPPORTED/return -EOPNOTSUPP/
s/= IRDMA_NOT_SUPPORTED/= -EOPNOTSUPP/
s/return IRDMA_ERR_LIST_EMPTY/return -ENOBUFS/
s/= IRDMA_ERR_LIST_EMPTY/= -ENOBUFS/
s/return IRDMA_ERR_NO_VF_AVAILABLE/return -ENODEV/
s/= IRDMA_ERR_NO_VF_AVAILABLE/= -ENODEV/
s/return IRDMA_ERR_PE_DOORBELL_NOT_ENA/return -ENODEV/
s/= IRDMA_ERR_PE_DOORBELL_NOT_ENA/= -ENODEV/
s/return IRDMA_ERR_SEQ_NUM/return -ERANGE/
s/= IRDMA_ERR_SEQ_NUM/= -ERANGE/
s/return IRDMA_ERR_FLUSHED_Q/return -EALREADY/
s/= IRDMA_ERR_FLUSHED_Q/= -EALREADY/
s/return IRDMA_ERR_BUF_TOO_SHORT/return -ENOMEM/
s/= IRDMA_ERR_BUF_TOO_SHORT/= -ENOMEM/
s/return IRDMA_ERR_Q_EMPTY/return -ENOENT/
s/= IRDMA_ERR_Q_EMPTY/= -ENOENT/
s/return IRDMA_ERR_Q_DESTROYED/return -EFAULT/
s/= IRDMA_ERR_Q_DESTROYED/= -EFAULT/
s/IRDMA_SUCCESS/0/
s/IRDMA_NOT_SUPPORTED/-EOPNOTSUPP/
s/return IRDMA_ERR_INVALID_SRQ_ID/return -EINVAL/
s/= IRDMA_ERR_INVALID_SRQ_ID/= -EINVAL/
s/return IRDMA_ERR_RSRC_LMTS/return -EINVAL/
s/= IRDMA_ERR_RSRC_LMTS/= -EINVAL/
/define IRDMA_HTONS/d
/define IRDMA_NTOHL/d
/define INLINE/d
/define irdma_memset/d
/define irdma_memcpy/d
/define irdma_mmio_memcpy/d
/define CPU_TO_LE16/d
/define CPU_TO_LE32/d
/define CPU_TO_LE64/d
/define LE16_TO_CPU/d
/define LE32_TO_CPU/d
/define LE64_TO_CPU/d
/define IW_KZALLOC/d
/define IW_KFREE/d
/define irdma_mb/d
/define irdma_wmb/d
/define irdma_rmb/d
/define irdma_barrier/d
/define irdma_smp_mb/d
/define irdma_smp_wmb/d
/define irdma_smp_rmb/d
/define OSTIMER/d
/define LIST_EMPTY/d
/define LIST_ADD_TAIL/d
/define LIST_DELETE_ENTRY/d
/define OS_LIST_ENTRY/d
/define OS_LIST_HEAD/d
/define OS_HASH_DESC/d
/define LIST_ADD/d
/define LIST_MOVE/d
/define IOMEM/d
/define ATOMIC/d
/define ATOMIC_INC/d
/define irdma_usec_delay/d
/define irdma_get_virt_to_phy/d
/define OS_TIMER/d
/define IRDMA_BYTE_/d
/define db_wr32/d
/define KCALLOC/d
/define KFREE/d
/long irdma_uintptr/d
/__be16 BE16/d
/__be32 BE32/d
/__be64 BE64/d
/__le16 LE16/d
/__le32 LE32/d
/__le64 LE64/d
/irdma_bits_t;/d
/IRDMA_IF_ADDR_RLOCK/d
/IRDMA_IF_ADDR_RUNLOCK/d
s/IRDMA_MAX_TRAFFIC_CLASS/IEEE_8021QAZ_MAX_TCS/
s/IRDMA_NTOHS/ntohs/
s/IRDMA_HTONS/htons/
s/IRDMA_NTOHL/ntohl/
s/\bINLINE\b/inline/
s/irdma_memset/memset/
s/irdma_memcpy/memcpy/
s/irdma_mmio_memcpy/memcpy/
s/CPU_TO_LE16/cpu_to_le16/
s/CPU_TO_LE32/cpu_to_le32/
s/CPU_TO_LE64/cpu_to_le64/
s/LE16_TO_CPU/le16_to_cpu/
s/LE32_TO_CPU/le32_to_cpu/
s/LE64_TO_CPU/le64_to_cpu/
s/IW_KZALLOC/kzalloc/
s/IW_KFREE/kfree/
s/KCALLOC/kcalloc/
s/KFREE_RCU/kfree_rcu/
s/KFREE/kfree/
s/irdma_mb/mb/
s/irdma_wmb/dma_wmb/
s/irdma_rmb/dma_rmb/
s/irdma_barrier/barrier/
s/irdma_smp_mb/smp_mb/
s/irdma_smp_wmb/smp_wmb/
s/irdma_smp_rmb/smp_rmb/
s/irdma_mac_to_u64/ether_addr_to_u64/
s/OS_TIMER/timer_list/
s/IRDMA_MUTEX/struct mutex/
s/LIST_EMPTY/list_empty/
s/LIST_ADD_RCU/list_add_rcu/
s/LIST_ADD_TAIL/list_add_tail/
s/LIST_DELETE_ENTRY/list_del/
s/LIST_DEL_RCU/list_del_rcu/
s/LIST_FOR_EACH_ENTRY_RCU/list_for_each_entry_rcu/
s/HASH_FOR_EACH_POSSIBLE_RCU/hash_for_each_possible_rcu/
s/HASH_FOR_EACH_POSSIBLE/hash_for_each_possible/
s/HASH_FOR_EACH_RCU/hash_for_each_rcu/
s/HASH_ADD_RCU/hash_add_rcu/
s/\<HASH_ADD\>/hash_add/
s/OS_LIST_ENTRY/list_head/
s/OS_LIST_HEAD/list_head/
s/OS_HASH_DESC/shash_desc/
s/\bLIST_ADD\b/list_add/
s/\bLIST_MOVE\b/list_move/
s/FOR_EACH_NETDEV(\(.*\))/for_each_netdev(\&init_net, \1)/
s/irdma_uintptr/unsigned long/
s/BE16/__be16/
s/BE32/__be32/
s/BE64/__be64/
s/LE16/__le16/
s/LE32/__le32/
s/LE64/__le64/
s/irdma_usec_delay/udelay/
s/irdma_get_virt_to_phy/virt_to_phys/
s/irdma_bits_t /unsigned long */
s/IOMEM/__iomem/
s/\bATOMIC\b/atomic_t/
s/REFCOUNT/refcount_t/
s/ATOMIC_INC/atomic_inc/
s/ATOMIC_INIT/atomic_set/
s/\bATOMIC64\b/atomic64_t/
s/ATOMIC64_INC/atomic64_inc/
s/ATOMIC64_INIT/atomic64_set/
s/ATOMIC64_READ/atomic64_read/
s/IRDMA_BYTE_//
s/db_wr32/writel/
s/{ 0 }/{}/
s/{0}/{}/
s/irdma_mutex_lock/mutex_lock/
s/irdma_mutex_unlock/mutex_unlock/
s/irdma_mutex_init/mutex_init/
/irdma_mutex_deinit/d
/spin_lock_destroy/d
s/volatile //
s/UK_SPINLOCK_T/spinlock_t/
s/rd32v/readl/
s/irdma_vmalloc_to_page/vmalloc_to_page/
s/QUEUE_WORK/queue_work/
s/WORKQUEUE_STRUCT/workqueue_struct/
s/WORK_STRUCT/work_struct/
s/\x0d$//
/CURVNET/d
