#!/bin/bash

# build from source
mkdir irdma_xeon_silicon
cd irdma_xeon_silicon
git clone ~/bsp/sources/lan/rdma nd_linux-cpk_rdma_ext
cd nd_linux-cpk_rdma_ext

# if the SHARED and COMPAT repos don't exist, please create them
mkdir -p src/SHARED
mkdir -p src/COMPAT
cd src/SHARED
git clone ~/bsp/sources/lan/rdma/src/SHARED .
cd ../COMPAT
git clone ~/bsp/sources/lan/rdma/src/COMPAT .
cd ../../

# copy over idpf_devids.h and iavf_devids.h
cp ~/sources/lan/idpf/src/CORE/idpf/idpf_devids.h src/SHARED/
cp ~/sources/lan/idpf/src/CORE/iavf/iavf_devids.h src/SHARED
cd src

# prepare source code
make -f build.mk BUILD=MEV_SILICON

# prepared source code placed in created dir ./src/irdma
cd irdma
chmod ugo+x build.sh
cp build.sh ../..
cd ../..

# create irdma.ko file
# <version>: ex: 0.0.365
./build.sh ~/sources/lan/idpf/silicon/idpf-<version> noinstall
# will create ./src/irdma/irdma.ko
