#!/bin/bash

# create top level directory
mkdir -p libirdma
cd libirdma

# if the following dirs don't exist, make them
sudo mkdir -p /root/rpmbuild/SOURCES
sudo mkdir -p /root/rpmbuild/SPECS

# download rdma-core v27
wget https://github.com/linux-rdma/rdma-core/releases/download/v27.0/rdma-core-27.0.tar.gz
tar xvaf rdma-core-27.0.tar.gz

# clone library repo
git clone ~/bsp/sources/lan/rdma-core nd_linux-lib_cpk_rdma_ext
cd nd_linux-lib_cpk_rdma_ext

# if the following dirs don't exist, make them
mkdir -p src/DRIVER_CORE
mkdir -p src/SHARED
mkdir -p src/COMPAT

# clone SHARED, COMPAT, and DRIVER_CORE repos
cd src/SHARED
git clone ~/bsp/sources/lan/rdma/src/SHARED .
cd ../COMPAT
git clone ~/bsp/sources/lan/rdma/src/COMPAT .
cd ../DRIVER_CORE
git clone ~/bsp/sources/lan/rdma .

# if SHARED and COMPAT dirs don't exist, make them
mkdir -p src/SHARED
mkdir -p src/COMPAT

# clone SHARED and COMPAT repos
cd src/SHARED
git clone ~/bsp/sources/lan/rdma/src/SHARED .
cd ../COMPAT
git clone ~/bsp/sources/lan/rdma/src/COMPAT .

# libirdma/nd_linux-lib_cpk_rdma_ext/src/DRIVER_CORE
cd ../../

# nd_linux-lib_cpk_rdma_ext
cd ../../

# copy over idpf_devids.h and iavf_devids.h
cp ~/sources/lan/idpf/src/CORE/idpf/idpf_devids.h src/SHARED/
cp ~/sources/lan/idpf/src/CORE/iavf/iavf_devids.h src/SHARED

# libirdma
cd ../

#clone core repo
git clone ~/bsp/sources/lan/rdma nd_linux-cpk_rdma_ext

#prepare rdma-core
gcc nd_linux-lib_cpk_rdma_ext/src/COMPAT/scripts/unifdef.c -o unifdef
./nd_linux-cpk_rdma_ext/build_prj_acc_irdma_core.sh MEV_SILICON `pwd`/nd_linux-lib_cpk_rdma_ext `pwd`/rdma-core-27.0 `pwd`/unifdef

tar -cvzf rdma-core-27.0.tgz rdma-core-27.0
sudo cp -v rdma-core-27.0.tgz /root/rpmbuild/SOURCES/
sudo cp -v rdma-core-27.0/redhat/rdma-core.spec /root/rpmbuild/SPECS/

#build rdma-core
sudo rpmbuild -ba /root/rpmbuild/SPECS/rdma-core.spec --with pyverbs
