#!/usr/bin/perl

# use diagnostics;

# include the definitions of some driver specific strings
require SpecSetup;

print <<EOF;
Name:		hp-$name
Version:	$driver_version
Release:	$release
Group:		System/Kernel
Vendor:		Intel Corporation
URL:		$HP_URL$name.htm
Packager:	Hewlett-Packard Company
License:	GPL
Source0:	%{name}-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
Summary:	$hp_summary

%define debug_package %{nil}

%if "%{_host_vendor}" == "redhat"
BuildRequires: %kernel_module_package_buildreqs
%define install_mod_dir extra/%{name}
%else
BuildRequires: kernel-source kernel-syms
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%define install_mod_dir updates
%endif

%if "%{_host_vendor}" == "suse"
%if "%{_arch}" == "x86_64"
%{suse_kernel_module_package -x default smp xen kdump}
%else
%{suse_kernel_module_package -x default smp xen kdump bigsmp xenpae pae}
%endif
%endif

%if "%{_host_vendor}" == "redhat"
%{kernel_module_package -x debug kdump um}
%endif
%description
$hp_summary

%package KMP
Summary: $hp_summary
Group: System/Kernel

%description KMP
$hp_summary

%package doc
Summary: Documentation for the %{name} kernel module
Group: System/Kernel
%if "%{_host_vendor}" == "redhat"
Provides: %{name}-kmod-common = %{version}-%{release}
Requires: %{name}-kmod = %{version}-%{release}
%else
Provides: %{name}-kmp-common = %{version}-%{release}
Requires: %{name}-kmp = %{version}_%(uname -r | cut -d- -f1)_%(uname -r | cut -d- -f2)
%endif

%description doc
Documentation for the $hp_summary

%prep
%setup
mkdir source
set -- $name/*
mv $name/* source/
mkdir obj

%build
export EXTRA_CFLAGS='-DVERSION=\"%version\"'
for flavor in %flavors_to_build; do
	rm -rf obj/\$flavor
	cp -r source obj/\$flavor
	make -C %{kernel_source \$flavor} M=\$PWD/obj/\$flavor
done
gzip < $name.7 > $name.7.gz

%install
export INSTALL_MOD_PATH=\$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
for flavor in %flavors_to_build; do
	make -C %{kernel_source \$flavor} modules_install M=\$PWD/obj/\$flavor
done
install -D -m 644 $name.7.gz \$RPM_BUILD_ROOT/%{_mandir}/man7/$name.7.gz

%postun doc
if [ -f %{_mandir}/man7/$name.7.gz ]; then
	exit 0
fi

%clean
rm -rf %{buildroot}

%files doc
%defattr(-, root, root)
%{_mandir}/man7/$name.7.gz
%doc COPYING README

%changelog
* Tue Oct 6 2009 - Intel Corporatino <linuxnics@mailbox.intel.com>>%{version}-%{release}
- Initial package

EOF
