#!/usr/bin/perl

# use diagnostics;

# include the definitions of some driver specific strings
require SpecSetup;

print <<EOF;
Name: intel-$name
Summary: $summary
Version: $driver_version
Release: 1
Source0: %{name}-%{version}.tar.gz
Source1: preamble
License: GPL
Vendor: Intel Corporation
Group: System/Kernel
URL: $URL
BuildRequires: kernel-source kernel-syms pciutils-ids module-init-tools
Requires: pciutils
BuildRoot: %{_tmppath}/%{name}-%{version}-build
Provides: %{name}
%suse_kernel_module_package kdump um -p %_sourcedir/preamble

%description
$description

%debug_package
%package KMP

Summary: $name Kernel Module
Group: System/Kernel

%description KMP
This is one of the sub-packages for a specific kernel.  All the
sub-packages will share the same summary, group, and description.

%prep
%setup
set -- *
mv $name source
echo "$name.ko external" > source/Module.supported
mkdir obj

%build
export EXTRA_CFLAGS='-DVERSION=\"%version\"'
for flavor in %flavors_to_build; do
    rm -rf obj/\$flavor
    cp -r source obj/\$flavor
    make -C /usr/src/linux-obj/%_target_cpu/\$flavor modules \
        M=\$PWD/obj/\$flavor
done

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=updates
for flavor in %flavors_to_build; do
    make -C /usr/src/linux-obj/%_target_cpu/\$flavor modules_install \
        M=\$PWD/obj/\$flavor
done
mkdir -p \$RPM_BUILD_ROOT/usr/share/pci.ids.d
install -D -m 644 pci.updates \$RPM_BUILD_ROOT/usr/share/pci.ids.d/pci.ids.intel-$name-%{version}
mkdir -p \$RPM_BUILD_ROOT/%{_mandir}/man7
install -m 644 -D $name.7 \$RPM_BUILD_ROOT/%{_mandir}/man7
gzip -9nf \$RPM_BUILD_ROOT/%{_mandir}/man7/*.?

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%{_mandir}/man7/$name.7.gz
/usr/share/pci.ids.d/pci.ids.intel-$name-%{version}
%doc COPYING
%doc README

%post
if [ -x /usr/bin/merge-pciids -a -x /usr/bin/perl ]; then
    /usr/bin/merge-pciids
else
    echo "ERROR: merge-pciids or perl not found"
fi

%postun
if [ -x /usr/bin/merge-pciids -a -x /usr/bin/perl ]; then
    /usr/bin/merge-pciids
else
    echo "ERROR: merge-pciids or perl not found"
fi

%changelog

EOF
