#! /bin/bash
# Date: Oct. 14, 2008
# Author: Jeff Kirsher
# This script is used to create a modules.pcimap file which is required
# for generating a Red Hat Driver disk image.  This script is used in 
# the generation of the DKMS tarball.
#
# Usage: mkpcimap.sh <location>/pci.updates <location>/modules.pcimap <driver name>
#
# $1 = pci.updates file for input
# #2 = modules.pcimap file for RH driver disk
# $3 = driver name

input=$1
output=$2
driver=$3

# pattern matching strings
ID="[[:xdigit:]][[:xdigit:]][[:xdigit:]][[:xdigit:]]"
DEV="${ID}*"

line=
vender=8086
device=
mask=0xffffffff
empty=0x00000000
data=0x0

echo "# pci module         vendor     device     subvendor  subdevice  class      class_mask driver_data" > $output

# get the first line of input
cat $input | while read -r line
do
	if [[ $line == $DEV ]]
	then
		vender=0x00008086
		device=`echo 0x0000${line:0:4} | tr "[:upper:]" "[:lower:]"`
		if [[ $device != $vender ]]
		then
			echo "$driver                $vender $device $mask $mask $empty $empty $data" >> $output
		fi
	fi
done
