#!/usr/bin/perl -w

#
# mkxmlpcitable.pl
#
# Creates a XML-style pci device id list for VMware ESX
# stdin: pci.updates file from a single vendor
# stdout: i40e.xml output
#
# Written by : Auke Kok (LAD Sw Eng) - 2006
#

my $vendor;

print "<?xml version='1.0' encoding='iso-8859-1'?>\n";
print "<pcitable>\n";

while (<>) {
	chomp;

	# delete comments
	m/^#.*/ && next;

	# vendor declaration
	/^([0-9a-f]+)  (.*)/ && do {
		print "  <vendor id=\"$1\">\n";
		print "    <short>$2</short>\n";
		print "    <name>$2</name>\n";
		$vendor = $2;
		next;
	};

	# device ID
	/^\t([0-9a-f]+)  (.*)/ && do {
		print "    <device id=\"$1\">\n";
		print "      <vmware label=\"nic\">\n";
		print "        <driver>i40e</driver>\n";
		print "      </vmware>\n";
		print "      <name>$2</name>\n";
		print "      <table file=\"pcitable\" module=\"ignore\" />\n";
		print "      <table file=\"pcitable.Linux\" module=\"i40e\">\n";
		print "        <desc>$vendor|$2</desc>\n";
		print "      </table>\n";
		print "    </device>\n";
		next;
	};

	print "# $_\n";

}
print "  </vendor>\n";
print "</pcitable>\n";

