#!/usr/bin/env python

"""
Author: TNguyenphuc
Date: 08/24/2011
Project: FVL @ Intel
"""
import sys

first_type19 = False
between_sw   = False
indent_count = 0

def indent_str(count):
	tmp = '            '
	for i in range(count):
		tmp += '|            '
	return tmp

def main(args):
	global first_type19
	global indent_count
	global between_sw
	#print args
	
	#use list object to store the data while parse the input file
	olst = []
        item_str = ''
	
	#Read from input file and write to output file
	for line in sys.stdin.readlines():
		if line.find('header') >= 0:
			olst.append('')
			olst.append(line)
			item_str = 'MAC:' # restart item_str
			
			first_type19 = True
			between_sw = False
			indent_count = 0
		elif line.find('type=17') >= 0:
			if between_sw:
				indent_count = indent_count - 1
				olst.append(indent_str(indent_count))
				item_str = indent_str(indent_count - 1) + '+---------- '
				
			item_str += 'VEB:'
			
			start = line.find('seid=') + 5
			end = line.find('uplink')
			item_str += line[start:end] + '---- '
			
			indent_count = indent_count + 1

		elif line.find('type=19') >= 0:
			if first_type19:
				item_str += 'VSI:'
				
				start = line.find('seid=') + 5
				end = line.find('uplink')
				item_str += line[start:end]
				item_str += '---- PF:'
				
				start = line.find('downlink=') + 9
				end = line.find('\r\n')
				item_str += line[start:end]
				olst.append(item_str)
				item_str = '' # reset item_str
				
				first_type19 = False
			else:
				olst.append(indent_str(indent_count))
				item_str += indent_str(indent_count-1) + '+--------- VSI:'
				
				start = line.find('seid=') + 5
				end = line.find('uplink')
				item_str += line[start:end] + '------+'
				olst.append(item_str)
				item_str = '' # reset item_str
				
		elif line.find('type=1') >= 0:
			start = line.find('seid=') + 5
			end = line.find('uplink')
			item_str += line[start:end] + '---- '			
			
		elif line.find('type=2') >= 0:
			between_sw = True
			first_type19 = True
	
	#print output to screen
	for item in olst:
		print item
	
if __name__ == '__main__':
	sys.exit(main(sys.argv))

