/* Copyright (c) 2018 - 2021 Intel Corporation */

#define TEST_AEQE_VALID GENMASK_ULL(63, 63) //0x8000000000000000
#define TEST_Q2_DATA_WRITTEN GENMASK_ULL(62, 61) //0x6000000000000000
#define TEST_TCP_STATE GENMASK_ULL(60, 57) //0x1E00000000000000
#define TEST_RDMA_STATE GENMASK_ULL(56, 54) //0x01C0000000000000
#define TEST_AE_SOURCE GENMASK_ULL(53, 50) //0x003C000000000000
#define TEST_RESERVED GENMASK_ULL(49, 47) //0x0003800000000000
#define TEST_QP_CQ_ID_HIGH GENMASK_ULL(46, 46) //0x0000400000000000
#define TEST_AE_CODE GENMASK_ULL(45, 34) //0x00003FFC00000000
#define TEST_AEQE_OVERFLOW GENMASK_ULL(33, 33) //0x0000000200000000
#define TEST_WQ_DESC_INDEX GENMASK_ULL(32, 18) //0x00000001FFFC0000
#define TEST_QP_CQ_ID_LOW GENMASK_ULL(17, 0) //0x000000000003FFFF


/* ------------ 2.  AE ID Codes ------------- */
#define TEST_AE_AMP_UNALLOCATED_STAG                                  0x102
#define TEST_AE_AMP_INVALID_STAG                                      0x103
#define TEST_AE_AMP_BAD_QP                                            0x104
#define TEST_AE_AMP_BAD_PD                                            0x105
#define TEST_AE_AMP_STAG_KEY                                          0x106
#define TEST_AE_AMP_STAG_INDEX                                        0x107
#define TEST_AE_AMP_BOUNDS_VIOLATION                                  0x108
#define TEST_AE_AMP_RIGHTS_VIOLATION                                  0x109
#define TEST_AE_AMP_TO_WRAP                                           0x10a

#define TEST_AE_AMP_FASTREG_VALID_STAG                                0x10c
#define TEST_AE_AMP_FASTREG_MW_STAG                                   0x10d
#define TEST_AE_AMP_FASTREG_INVALID_RIGHTS                            0x10e

#define TEST_AE_AMP_FASTREG_INVALID_LENGTH                            0x110
#define TEST_AE_AMP_INVALIDATE_SHARED                                 0x111
#define TEST_AE_AMP_INVALIDATE_NO_REMOTE_ACCESS_RIGHTS                0x112
#define TEST_AE_AMP_INVALIDATE_MR_WITH_BOUND_WINDOWS                  0x113
#define TEST_AE_AMP_MWBIND_VALID_STAG                                 0x114
#define TEST_AE_AMP_MWBIND_OF_MR_STAG                                 0x115
#define TEST_AE_AMP_MWBIND_TO_ZERO_BASED_STAG                         0x116
#define TEST_AE_AMP_MWBIND_TO_MW_STAG                                 0x117
#define TEST_AE_AMP_MWBIND_INVALID_RIGHTS                             0x118
#define TEST_AE_AMP_MWBIND_INVALID_BOUNDS                             0x119
#define TEST_AE_AMP_MWBIND_TO_INVALID_PARENT                          0x11a
#define TEST_AE_AMP_MWBIND_BIND_DISABLED                              0x11b
#define TEST_AE_PRIV_OPERATION_DENIED                                 0x11c
#define TEST_AE_AMP_INVALIDATE_TYPE1_MW                               0x11d
#define TEST_AE_AMP_MWBIND_ZERO_BASED_TYPE1_MW                        0x11e
#define TEST_AE_AMP_FASTREG_INVALID_PBL_HPS_CFG                       0x11f

#define TEST_AE_UDA_XMIT_DGRAM_TOO_LONG                               0x132
#define TEST_AE_UDA_XMIT_BAD_PD                                       0x133
#define TEST_AE_UDA_XMIT_DGRAM_TOO_SHORT                              0x134
#define TEST_AE_UDA_L4LEN_INVALID                                     0x135

#define TEST_AE_BAD_CLOSE                                             0x201
#define TEST_AE_RDMAP_ROE_BAD_LLP_CLOSE                               0x202
#define TEST_AE_CQ_OPERATION_ERROR                                    0x203

#define TEST_AE_RDMA_READ_WHILE_ORD_ZERO                              0x205
#define TEST_AE_STAG_ZERO_INVALID                                     0x206
#define TEST_AE_IB_RREQ_AND_Q1_FULL                                   0x207
#define TEST_AE_IB_INVALID_REQUEST                                    0x208

#define TEST_AE_WQE_UNEXPECTED_OPCODE                                 0x20a
#define TEST_AE_WQE_INVALID_PARAMETER                                 0x20b
#define TEST_AE_WQE_INVALID_FRAG_DATA                                 0x20c
#define TEST_AE_IB_REMOTE_ACCESS_ERROR                                0x20d
#define TEST_AE_IB_REMOTE_OP_ERROR                                    0x20e

#define TEST_AE_WQE_LSMM_TOO_LONG                                     0x220

#define TEST_AE_DDP_INVALID_MSN_GAP_IN_MSN                            0x301

#define TEST_AE_DDP_UBE_DDP_MESSAGE_TOO_LONG_FOR_AVAILABLE_BUFFER     0x303
#define TEST_AE_DDP_UBE_INVALID_DDP_VERSION                           0x304
#define TEST_AE_DDP_UBE_INVALID_MO                                    0x305
#define TEST_AE_DDP_UBE_INVALID_MSN_NO_BUFFER_AVAILABLE               0x306
#define TEST_AE_DDP_UBE_INVALID_QN                                   0x307
#define TEST_AE_DDP_NO_L_BIT                                          0x308

#define TEST_AE_RDMAP_ROE_INVALID_RDMAP_VERSION                       0x311
#define TEST_AE_RDMAP_ROE_UNEXPECTED_OPCODE                           0x312
#define TEST_AE_ROE_INVALID_RDMA_READ_REQUEST                         0x313
#define TEST_AE_ROE_INVALID_RDMA_WRITE_OR_READ_RESP                   0x314

#define TEST_AE_ROCE_RSP_LENGTH_ERROR                                 0x316

#define TEST_AE_ROCE_EMPTY_MCG                                        0x380
#define TEST_AE_BAD_MC_IP_ADDR                                        0x381
#define TEST_AE_MCG_QP_PROTOCOL_MISMATCH                              0x383

#define TEST_AE_INVALID_ARP_ENTRY                                     0x401
#define TEST_AE_INVALID_TCP_OPTION_RCVD                               0x402

#define TEST_AE_INVALID_AH_ENTRY                                      0x406

#define TEST_AE_LLP_CLOSE_COMPLETE                                    0x501
#define TEST_AE_LLP_CONNECTION_RESET                                  0x502
#define TEST_AE_LLP_FIN_RECEIVED                                      0x503

#define TEST_AE_LLP_RECEIVED_MPA_CRC_ERROR                            0x505

#define TEST_AE_LLP_SEGMENT_TOO_SMALL                                 0x507
#define TEST_AE_LLP_SYN_RECEIVED                                      0x508
#define TEST_AE_LLP_TERMINATE_RECEIVED                                0x509
#define TEST_AE_LLP_TOO_MANY_RETRIES                                  0x50a

#define TEST_AE_LLP_DOUBT_REACHABILITY                                0x50c

#define TEST_AE_LLP_CONNECTION_ESTABLISHED                            0x50e

#define TEST_AE_RESOURCE_EXHAUSTION                                   0x520

#define TEST_AE_RESET_SENT                                            0x601
#define TEST_AE_TERMINATE_SENT                                        0x602
#define TEST_AE_RESET_NOT_SENT                                        0x603

#define TEST_AE_LCE_QP_CATASTROPHIC                                   0x700
#define TEST_AE_LCE_FUNCTION_CATASTROPHIC                             0x701
#define TEST_AE_LCE_CQ_CATASTROPHIC                                   0x702

#define TEST_AE_QP_SUSPEND_COMPLETE                                   0x900

/* ------------- 3. Array to hold "Good" values of AEs (Used for Randomization)---------- */

u16 ae_codes[81] = {
		  TEST_AE_AMP_UNALLOCATED_STAG,
		  TEST_AE_AMP_INVALID_STAG,
		  TEST_AE_AMP_BAD_QP,
		  TEST_AE_AMP_BAD_PD,
		  TEST_AE_AMP_STAG_KEY,
		  TEST_AE_AMP_STAG_INDEX,
		  TEST_AE_AMP_BOUNDS_VIOLATION,
		  TEST_AE_AMP_RIGHTS_VIOLATION,
		  TEST_AE_AMP_TO_WRAP,
		  TEST_AE_AMP_FASTREG_VALID_STAG,
		  TEST_AE_AMP_FASTREG_MW_STAG,
		  TEST_AE_AMP_FASTREG_INVALID_RIGHTS,
		  TEST_AE_AMP_FASTREG_INVALID_LENGTH,
		  TEST_AE_AMP_INVALIDATE_SHARED,
		  TEST_AE_AMP_INVALIDATE_NO_REMOTE_ACCESS_RIGHTS,
		  TEST_AE_AMP_INVALIDATE_MR_WITH_BOUND_WINDOWS,
		  TEST_AE_AMP_MWBIND_VALID_STAG,
		  TEST_AE_AMP_MWBIND_OF_MR_STAG,
		  TEST_AE_AMP_MWBIND_TO_ZERO_BASED_STAG,
		  TEST_AE_AMP_MWBIND_TO_MW_STAG,
		  TEST_AE_AMP_MWBIND_INVALID_RIGHTS,
		  TEST_AE_AMP_MWBIND_INVALID_BOUNDS,
		  TEST_AE_AMP_MWBIND_TO_INVALID_PARENT,
		  TEST_AE_AMP_MWBIND_BIND_DISABLED,
		  TEST_AE_PRIV_OPERATION_DENIED,
		  TEST_AE_AMP_INVALIDATE_TYPE1_MW,
		  TEST_AE_AMP_MWBIND_ZERO_BASED_TYPE1_MW,
		  TEST_AE_AMP_FASTREG_INVALID_PBL_HPS_CFG,
		  TEST_AE_UDA_XMIT_DGRAM_TOO_LONG,
		  TEST_AE_UDA_XMIT_BAD_PD,
		  TEST_AE_UDA_XMIT_DGRAM_TOO_SHORT,
		  TEST_AE_UDA_L4LEN_INVALID,
		  TEST_AE_BAD_CLOSE,
		  TEST_AE_RDMAP_ROE_BAD_LLP_CLOSE,
		  TEST_AE_CQ_OPERATION_ERROR,
		  TEST_AE_RDMA_READ_WHILE_ORD_ZERO,
		  TEST_AE_STAG_ZERO_INVALID,
		  TEST_AE_IB_RREQ_AND_Q1_FULL,
		  TEST_AE_IB_INVALID_REQUEST,
		  TEST_AE_WQE_UNEXPECTED_OPCODE,
		  TEST_AE_WQE_INVALID_PARAMETER,
		  TEST_AE_WQE_INVALID_FRAG_DATA,
		  TEST_AE_IB_REMOTE_ACCESS_ERROR,
		  TEST_AE_IB_REMOTE_OP_ERROR,
		  TEST_AE_WQE_LSMM_TOO_LONG,
		  TEST_AE_DDP_INVALID_MSN_GAP_IN_MSN,
		  TEST_AE_DDP_UBE_DDP_MESSAGE_TOO_LONG_FOR_AVAILABLE_BUFFER,
		  TEST_AE_DDP_UBE_INVALID_DDP_VERSION,
		  TEST_AE_DDP_UBE_INVALID_MO,
		  TEST_AE_DDP_UBE_INVALID_MSN_NO_BUFFER_AVAILABLE,
		  TEST_AE_DDP_UBE_INVALID_QN,
		  TEST_AE_DDP_NO_L_BIT,
		  TEST_AE_RDMAP_ROE_INVALID_RDMAP_VERSION,
		  TEST_AE_RDMAP_ROE_UNEXPECTED_OPCODE,
		  TEST_AE_ROE_INVALID_RDMA_READ_REQUEST,
		  TEST_AE_ROE_INVALID_RDMA_WRITE_OR_READ_RESP,
		  TEST_AE_ROCE_RSP_LENGTH_ERROR,
		  TEST_AE_ROCE_EMPTY_MCG,
		  TEST_AE_BAD_MC_IP_ADDR,
		  TEST_AE_MCG_QP_PROTOCOL_MISMATCH,
		  TEST_AE_INVALID_ARP_ENTRY,
		  TEST_AE_INVALID_TCP_OPTION_RCVD,
		  TEST_AE_INVALID_AH_ENTRY,
		  TEST_AE_LLP_CLOSE_COMPLETE,
		  TEST_AE_LLP_CONNECTION_RESET,
		  TEST_AE_LLP_FIN_RECEIVED,
		  TEST_AE_LLP_RECEIVED_MPA_CRC_ERROR,
		  TEST_AE_LLP_SEGMENT_TOO_SMALL,
		  TEST_AE_LLP_SYN_RECEIVED,
		  TEST_AE_LLP_TERMINATE_RECEIVED,
		  TEST_AE_LLP_TOO_MANY_RETRIES,
		  TEST_AE_LLP_DOUBT_REACHABILITY,
		  TEST_AE_LLP_CONNECTION_ESTABLISHED,
		  TEST_AE_RESOURCE_EXHAUSTION,
		  TEST_AE_RESET_SENT,
		  TEST_AE_TERMINATE_SENT,
		  TEST_AE_RESET_NOT_SENT,
		  TEST_AE_LCE_QP_CATASTROPHIC,
		  TEST_AE_LCE_FUNCTION_CATASTROPHIC,
		  TEST_AE_LCE_CQ_CATASTROPHIC,
		  TEST_AE_QP_SUSPEND_COMPLETE,
		 };
/* --------  AE iWARP State After AE ------- */

/* --------  AE RoCE State After AE ------- */

/* -------- 4. AE Sources ------- */

#define AE_SOURCE          0x0
#define AE_SOURCE_RQ1      0x1
#define AE_SOURCE_RQ3      0x3
#define AE_SOURCE_CQ2      0x2
#define AE_SOURCE_CQ6      0x6
#define AE_SOURCE_CQe      0xe
#define AE_SOURCE_CQa      0xa
#define AE_SOURCE_SQ5      0x5
#define AE_SOURCE_SQ7      0x7
#define AE_SOURCE_IN_RSP9  0x9
#define AE_SOURCE_IN_RSPb  0xb
#define AE_SOURCE_OUT_RSPd 0xd
#define AE_SOURCE_OUT_RSPf 0xf

/* ------------- 5. Array of "Good" AE Source Values (Used for Randomization) ---------- */

 u8 ae_source_list[13] = {
	AE_SOURCE,
	AE_SOURCE_RQ1,
	AE_SOURCE_RQ3,
	AE_SOURCE_CQ2,
	AE_SOURCE_CQ6,
	AE_SOURCE_CQe,
	AE_SOURCE_CQa,
	AE_SOURCE_SQ5,
	AE_SOURCE_SQ7,
	AE_SOURCE_IN_RSP9,
	AE_SOURCE_IN_RSPb,
	AE_SOURCE_OUT_RSPd,
	AE_SOURCE_OUT_RSPf
};

/* --------  AE Source Masks ------- */


#define AE_SOURCE_RSVD_CHECK(a)    ((a)==0x0)
#define AE_SOURCE_RQ_CHECK(a)      ((a)==0x1 || (a)==0x3)
#define AE_SOURCE_CQ_CHECK(a)      ((a)==0x2 || (a)==0x6 || (a)==0xe || (a)==0xa)
#define AE_SOURCE_SQ_CHECK(a)      ((a)==0x5 || (a)==0x7)
#define AE_SOURCE_IN_RSP_CHECK(a)  ((a)==0x9 || (a)==0xb)
#define AE_SOURCE_OUT_RSP_CHECK(a) ((a)==0xd || (a)==0xf)



/* ----------- 7. Check Flags (one-hot-encoding) ------------ */
               // check format
               // bit 1: aeq id
               // bit 2: iwarp/roce state
               // bit 3: source
               // bit 4: rsrc id

#define CHECK_FLAG_BAD_AEQ_ID           0x1
#define CHECK_FLAG_BAD_IWARP_ROCE_STATE 0x2
#define CHECK_FLAG_BAD_SOURCE           0x4
#define CHECK_FLAG_BAD_RSRC_ID          0x8
//#define CHECK_FLAG_BAD_VALID            0x10
#define CHECK_FLAG_BAD_COMPLETION_CONTEXT 0x10
#define CHECK_FLAG_BAD_AEQE_OVERFLOW    0x20
#define CHECK_FLAG_BAD_Q2_DATA_WRITTEN  0x40
#define CHECK_FLAG_BAD_WQ_DESC_INDEX    0x80

/* ------------ 8. Enum for SW AE Info source flags (one-hot-encoding) --------- */

enum ae_one_hot_source {
	ae_src_rsvd_oh = 0,
	ae_src_qp_oh   = 1,
	ae_src_cq_oh   = 2,
	ae_src_sq_oh   = 4,
	ae_src_in_oh   = 8,
	ae_src_out_oh  = 16
};

/* ------------ 9. Enum for ae_protocol (not used) ------------- */

enum ae_protocol {
	IWARP,
	ROCE_V2,
	UDA
};

/* --------------- 10. TB Masks for AEQE ------------- */

#define MASK_AE_CODE 0xfff
#define MASK_AE_TCP_STATE 0xf
#define MASK_AE_RDMA_STATE 0x7
#define MASK_AE_SOURCE 0xf
#define MASK_AE_VALID 0x1
#define MASK_AE_Q2_DATA_WRITTEN 0x3
#define MASK_AE_RESERVED 0x7
#define MASK_AE_AEQE_OVERFLOW 0x1
#define MASK_AE_WQ_DESC_INDEX 0x7fff
#define MASK_AE_QP_CQ_ID 0x3ffff
#define MASK_AE_QP_CQ_ID_HI 0x1
#define MASK_AE_QP_CQ_ID_LOW 0x1fff

/* ------------ 11. Check Flags for Rings (one-hot-encoding) ------------- */

#define CHECKS_AEQ_BAD_RING_HEAD          0x1
#define CHECKS_AEQ_BAD_RING_TAIL          0x2
#define CHECKS_AEQ_BAD_RING_TAIL_POLARITY 0x4
#define CHECKS_AEQ_MOVE_TAIL_OVERFLOW     0x8
#define CHECKS_AEQ_MOVE_HEAD_OVERFLOW     0x10

