#ifndef CQP_FIELDS_H
#define CQP_FIELDS_H

#define TB_MAX_QPS			256000
#define TB_MAX_INLINE_LEN		224 //Arch imposed limitation instead of 225
#define TB_64B_WORDS_PER_QUANTA		4
#define TB_MAX_HW_SQ_CHUNK_CPK		8
#define TB_BYTES_PER_QUANTA_CPK		32
#define TB_INLINE_BYTES_PER_QUANTA_CPK	31
#define TB_MAX_MSG_SIZE			2147483647

/* CQP SQ CREATE QP */
enum cqp_sq_create_qp {
	CQPSQ_CREATE_QP_FIELD_RSVD0,
	CQPSQ_CREATE_QP_FIELD_RSVD1,
	CQPSQ_CREATE_QP_FIELD_TERM_LEN,
	CQPSQ_CREATE_QP_FIELD_RSVD3,
	CQPSQ_CREATE_QP_FIELD_NEW_MSS_VAL,
	CQPSQ_CREATE_QP_FIELD_RSVD4,
	CQPSQ_CREATE_QP_FIELD_QP_CTX_ADDR,
	CQPSQ_CREATE_QP_FIELD_WQE_VALID,
	CQPSQ_CREATE_QP_FIELD_NEXT_RDMA_STATE,
	CQPSQ_CREATE_QP_FIELD_ARP_TABLE_IDX_VALID,
	CQPSQ_CREATE_QP_FIELD_RESET_CONNECTION,
	CQPSQ_CREATE_QP_FIELD_TERMINATE_ACTIONS,
	CQPSQ_CREATE_QP_FIELD_REMOVE_HASH_ENTRY,
	CQPSQ_CREATE_QP_FIELD_IGNORE_MW_BOUND,
	CQPSQ_CREATE_QP_FIELD_RSVD5,
	CQPSQ_CREATE_QP_FIELD_MSS_CHANGE,
	CQPSQ_CREATE_QP_FIELD_MAC_VALID,
	CQPSQ_CREATE_QP_FIELD_QP_TYPE,
	CQPSQ_CREATE_QP_FIELD_CQ_NUMBERS_VALID,
	CQPSQ_CREATE_QP_FIELD_FORCE_LOOPBACK,
	CQPSQ_CREATE_QP_FIELD_VIRTUAL_WQS,
	CQPSQ_CREATE_QP_FIELD_CACHED_VARS_VALID,
	CQPSQ_CREATE_QP_FIELD_TOE_CTX_VALID,
	CQPSQ_CREATE_QP_FIELD_ORD_VALID,
	CQPSQ_CREATE_QP_FIELD_ADD_FRAG_COUNT,
	CQPSQ_CREATE_QP_FIELD_OP,
	CQPSQ_CREATE_QP_FIELD_RSVD7,
	CQPSQ_CREATE_QP_FIELD_QP_ID,
	CQPSQ_CREATE_QP_FIELD_RSVD8,
	CQPSQ_CREATE_QP_FIELD_DB_SHADOW_ACCESS,
	CQPSQ_CREATE_QP_FIELD_RSVD9,
	CQPSQ_CREATE_QP_FIELD_RSVD10,
	CQPSQ_CREATE_QP_FIELD_RSVD11,
	CQPSQ_CREATE_QP_FIELD_NUM_FIELDS
	
};

/* CQP SQ MCG */
enum cqp_sq_mcg {
	CQPSQ_MCG_FIELD_RSVD0,
	CQPSQ_MCG_FIELD_DEST_MAC_ADDR_5,
	CQPSQ_MCG_FIELD_DEST_MAC_ADDR_4,
	CQPSQ_MCG_FIELD_DEST_MAC_ADDR_3,
	CQPSQ_MCG_FIELD_DEST_MAC_ADDR_2,
	CQPSQ_MCG_FIELD_DEST_MAC_ADDR_1,
	CQPSQ_MCG_FIELD_DEST_MAC_ADDR_0,
	CQPSQ_MCG_FIELD_RSVD1,
	CQPSQ_MCG_FIELD_HMC_FCN_ID,
	CQPSQ_MCG_FIELD_RSVD2,
	CQPSQ_MCG_FIELD_VLAN_ID,
	CQPSQ_MCG_FIELD_RSVD3,
	CQPSQ_MCG_FIELD_QS_HANDLE,
	CQPSQ_MCG_FIELD_WQE_VALID,
	CQPSQ_MCG_FIELD_RSVD4,
	CQPSQ_MCG_FIELD_IPV4_VALID,
	CQPSQ_MCG_FIELD_VLAN_VALID,
	CQPSQ_MCG_FIELD_RSVD5, //Additional Frag Count
	CQPSQ_MCG_FIELD_OP,
	CQPSQ_MCG_FIELD_RSVD6,
	CQPSQ_MCG_FIELD_MG_ID,
	CQPSQ_MCG_FIELD_MG_CONTEXT_ADDR,
	CQPSQ_MCG_FIELD_RSVD7,
	CQPSQ_MCG_FIELD_DEST_IP_ADDR_2,
	CQPSQ_MCG_FIELD_DEST_IP_ADDR_3,
	CQPSQ_MCG_FIELD_DEST_IP_ADDR_0,
	CQPSQ_MCG_FIELD_DEST_IP_ADDR_1,
	CQPSQ_MCG_FIELD_NUM_FIELDS
};

/* CQP SQ MCG */
enum cqp_sq_ws {
	CQPSQ_WS_FIELD_RSVD0,
	CQPSQ_WS_FIELD_RSVD1,
	CQPSQ_WS_FIELD_RSVD2,
	CQPSQ_WS_FIELD_WQE_VALID,
	CQPSQ_WS_FIELD_ENABLE_NODE,
	CQPSQ_WS_FIELD_NODE_TYPE,
	CQPSQ_WS_FIELD_PRIORITY_TYPE,
	CQPSQ_WS_FIELD_TRAFFIC_CLASS,
	CQPSQ_WS_FIELD_VM_VF_TYPE,
	CQPSQ_WS_FIELD_NODE_OP,
	CQPSQ_WS_FIELD_VM_VF_NUM,
	CQPSQ_WS_FIELD_RSVD3, //Additional Frag Count
	CQPSQ_WS_FIELD_OP,
	CQPSQ_WS_FIELD_RSVD4,
	CQPSQ_WS_FIELD_PARENT_NODE_ID,
	CQPSQ_WS_FIELD_RSVD5,
	CQPSQ_WS_FIELD_NODE_ID,
	CQPSQ_WS_FIELD_RSVD6,
	CQPSQ_WS_FIELD_VSI_INDEX,
	CQPSQ_WS_FIELD_RSVD7,
	CQPSQ_WS_FIELD_WEIGHT,
	CQPSQ_WS_FIELD_RSVD8,
	CQPSQ_WS_FIELD_RSVD9,
	CQPSQ_WS_FIELD_RSVD10,
	CQPSQ_WS_FIELD_RSVD11,
	CQPSQ_WS_FIELD_NUM_FIELDS
};


enum cqp_sq_umap {
	CQPSQ_UMAP_FIELD_UP_MAP_7,
	CQPSQ_UMAP_FIELD_UP_MAP_6,
	CQPSQ_UMAP_FIELD_UP_MAP_5,
	CQPSQ_UMAP_FIELD_UP_MAP_4,
	CQPSQ_UMAP_FIELD_UP_MAP_3,
	CQPSQ_UMAP_FIELD_UP_MAP_2,
	CQPSQ_UMAP_FIELD_UP_MAP_1,
	CQPSQ_UMAP_FIELD_UP_MAP_0,
	CQPSQ_UMAP_FIELD_RSVD0,
	CQPSQ_UMAP_FIELD_RSVD1,
	CQPSQ_UMAP_FIELD_WQE_VALID,
	CQPSQ_UMAP_FIELD_USE_VLAN,
	CQPSQ_UMAP_FIELD_USE_CNP_UP_OVERRIDE,
	CQPSQ_UMAP_FIELD_RSVD2,
	CQPSQ_UMAP_FIELD_RSVD3,
	CQPSQ_UMAP_FIELD_OP,
	CQPSQ_UMAP_FIELD_RSVD4,
	CQPSQ_UMAP_FIELD_RSVD5,
	CQPSQ_UMAP_FIELD_RSVD6,
	CQPSQ_UMAP_FIELD_CNP_UP_OVERRIDE,
	CQPSQ_UMAP_FIELD_RSVD7,
	CQPSQ_UMAP_FIELD_HMC_FCN_IDX,
	CQPSQ_UMAP_FIELD_RSVD8,
	CQPSQ_UMAP_FIELD_RSVD9,
	CQPSQ_UMAP_FIELD_NUM_FIELDS
};

enum cqp_sq_qf {
	CQPSQ_QF_FIELD_RSVD0,
	CQPSQ_QF_FIELD_RSVD1,
	CQPSQ_QF_FIELD_RSVD2,
	CQPSQ_QF_FIELD_WQE_VALID,
	CQPSQ_QF_FIELD_RSVD3,
	CQPSQ_QF_FIELD_OP,
	CQPSQ_QF_FIELD_BUFFER_LEN,
	CQPSQ_QF_FIELD_PHY_BUF_ADDRESS,
	CQPSQ_QF_FIELD_RSVD4,
	CQPSQ_QF_FIELD_RSVD5,
	CQPSQ_QF_FIELD_RSVD6,
	CQPSQ_QF_FIELD_NUM_FIELDS
};

enum cqp_sq_ah {
	CQPSQ_AH_FIELD_SRC_MAC_ADDR_5,
	CQPSQ_AH_FIELD_SRC_MAC_ADDR_4,
	CQPSQ_AH_FIELD_SRC_MAC_ADDR_3,
	CQPSQ_AH_FIELD_SRC_MAC_ADDR_2,
	CQPSQ_AH_FIELD_SRC_MAC_ADDR_1,
	CQPSQ_AH_FIELD_SRC_MAC_ADDR_0,
	CQPSQ_AH_FIELD_RSVD0,
	CQPSQ_AH_FIELD_PD_IDX,
	CQPSQ_AH_FIELD_RSVD1,
	CQPSQ_AH_FIELD_TRAFFIC_CLASS_OR_TOS,
	CQPSQ_AH_FIELD_RSVD2,
	CQPSQ_AH_FIELD_RSVD3,
	CQPSQ_AH_FIELD_RSVD4,
	CQPSQ_AH_FIELD_VLAN_TAG,
	CQPSQ_AH_FIELD_ARP_IDX,
	CQPSQ_AH_FIELD_RSVD5,
	CQPSQ_AH_FIELD_HOP_LIMIT_OR_TTL,
	CQPSQ_AH_FIELD_RSVD6,
	CQPSQ_AH_FIELD_RSVD7,
	CQPSQ_AH_FIELD_PD_IDX_HIGH,
	CQPSQ_AH_FIELD_FLOW_LABEL,
	CQPSQ_AH_FIELD_WQE_VALID,
	CQPSQ_AH_FIELD_DO_LOOPBACK,
	CQPSQ_AH_FIELD_RSVD8,
	CQPSQ_AH_FIELD_INSERT_VLAN_TAG,
	CQPSQ_AH_FIELD_IPV4_VALID,
	CQPSQ_AH_FIELD_RSVD9,
	CQPSQ_AH_FIELD_RSVD10, // Additional Frag Count
	CQPSQ_AH_FIELD_OP,
	CQPSQ_AH_FIELD_RSVD11,
	CQPSQ_AH_FIELD_AH_ID,
	CQPSQ_AH_FIELD_DEST_IP_ADDR_3,
	CQPSQ_AH_FIELD_DEST_IP_ADDR_2,
	CQPSQ_AH_FIELD_DEST_IP_ADDR_1,
	CQPSQ_AH_FIELD_DEST_IP_ADDR_0,
	CQPSQ_AH_FIELD_SRC_IP_ADDR_3,
	CQPSQ_AH_FIELD_SRC_IP_ADDR_2,
	CQPSQ_AH_FIELD_SRC_IP_ADDR_1,
	CQPSQ_AH_FIELD_SRC_IP_ADDR_0,
	CQPSQ_AH_FIELD_NUM_FIELDS
};

enum cqp_sq_vf_pble {
	CQPSQ_VF_PBLE_FIELD_RSVD0,
	CQPSQ_VF_PBLE_FIELD_RSVD1,
	CQPSQ_VF_PBLE_FIELD_RSVD2,
	CQPSQ_VF_PBLE_FIELD_SD_IDX,
	CQPSQ_VF_PBLE_FIELD_RSVD3,
	CQPSQ_VF_PBLE_FIELD_FIRST_PD_IDX,
	CQPSQ_VF_PBLE_FIELD_RSVD4,
	CQPSQ_VF_PBLE_FIELD_PD_ENTRY_CNT,
	CQPSQ_VF_PBLE_FIELD_WQE_VALID,
	CQPSQ_VF_PBLE_FIELD_INVALIDATE_PD_ENTRIES,
	CQPSQ_VF_PBLE_FIELD_RSVD5,
	CQPSQ_VF_PBLE_FIELD_RSVD6, //Additional Frag Count
	CQPSQ_VF_PBLE_FIELD_OP,
	CQPSQ_VF_PBLE_FIELD_RSVD7,
	CQPSQ_VF_PBLE_FIELD_PD_PAGE_LIST_PHY_BUF_ADDR,
	CQPSQ_VF_PBLE_FIELD_RSVD8,
	CQPSQ_VF_PBLE_FIELD_RSVD9,
	CQPSQ_VF_PBLE_FIELD_RSVD10,
	CQPSQ_VF_PBLE_FIELD_RSVD11,
	CQPSQ_VF_PBLE_FIELD_NUM_FIELDS
}; /* enum cqp_sq_vf_pble */

enum cqp_sq_REPLACE {
	CQPSQ_REPLACE_FIELD_OP,
	CQPSQ_REPLACE_FIELD_NUM_FIELDS
}; /* enum cqp_sq_REPLACE */

enum test_cqp_ops {
	TB_IRDMA_CQP_OP_CREATE_QP                  =0,
	TB_IRDMA_CQP_OP_MODIFY_QP                  =0x1,
	TB_IRDMA_CQP_OP_DESTROY_QP                 =0x03,
	TB_IRDMA_CQP_OP_CREATE_CQ                  =0x03,
	TB_IRDMA_CQP_OP_MODIFY_CQ                  =0x04,
	TB_IRDMA_CQP_OP_DESTROY_CQ                 =0x05,
	TB_IRDMA_CQP_OP_RSVD_0x06                  =0x06,
	TB_IRDMA_CQP_OP_RSVD_0x07                  =0x07,
        TB_IRDMA_CQP_OP_RSVD_0x08                  =0x08,
	TB_IRDMA_CQP_OP_ALLOC_STAG                 =0x09,
	TB_IRDMA_CQP_OP_REG_MR                     =0x0a,
	TB_IRDMA_CQP_OP_QUERY_STAG                 =0x0b,
	TB_IRDMA_CQP_OP_REG_SMR                    =0x0c,
	TB_IRDMA_CQP_OP_DEALLOC_STAG               =0x0d,
        TB_IRDMA_CQP_OP_RSVD_0x0E                  =0x0e,
	TB_IRDMA_CQP_OP_MANAGE_ARP                 =0x0f,
	TB_IRDMA_CQP_OP_MANAGE_VF_PBLE_BP          =0x10,
	TB_IRDMA_CQP_OP_MANAGE_PUSH_PAGES          =0x11,
	TB_IRDMA_CQP_OP_RDMA_GET_FEATURES          =0x12,
	TB_IRDMA_CQP_OP_UPLOAD_CONTEXT             =0x13,
        TB_IRDMA_CQP_OP_RSVD_0x14                  =0x14,
	TB_IRDMA_CQP_OP_MANAGE_HMC_PM_FUNC_TABLE   =0x15,
	TB_IRDMA_CQP_OP_CREATE_CEQ                 =0x16,
        TB_IRDMA_CQP_OP_RSVD_0x17                  =0x14,
	TB_IRDMA_CQP_OP_DESTROY_CEQ                =0x18,
	TB_IRDMA_CQP_OP_CREATE_AEQ                 =0x19,
        TB_IRDMA_CQP_OP_RSVD_0x1A                  =0x1a,
	TB_IRDMA_CQP_OP_DESTROY_AEQ                =0x1b,
	TB_IRDMA_CQP_OP_CREATE_ADDR_HANDLE         =0x1c,
	TB_IRDMA_CQP_OP_MODIFY_ADDR_HANDLE         =0x1d,
	TB_IRDMA_CQP_OP_DESTROY_ADDR_HANDLE        =0x1e,
	TB_IRDMA_CQP_OP_UPDATE_PE_SDS              =0x1f,
	TB_IRDMA_CQP_OP_QUERY_FPM_VALUES           =0x20,
	TB_IRDMA_CQP_OP_COMMIT_FPM_VALUES          =0x21,
	TB_IRDMA_CQP_OP_FLUSH_WQES                 =0x22,
	TB_IRDMA_CQP_OP_GEN_AE                     =0x22,
	TB_IRDMA_CQP_OP_MANAGE_APBVT               =0x23,
	TB_IRDMA_CQP_OP_NOP                        =0x24,
	TB_IRDMA_CQP_OP_MANAGE_QUAD_HASH_TABLE_ENTRY =0x25,
	TB_IRDMA_CQP_OP_CREATE_MCAST_GROUP         =0x26,
	TB_IRDMA_CQP_OP_MODIFY_MCAST_GROUP         =0x27,
	TB_IRDMA_CQP_OP_DESTROY_MCAST_GROUP        =0x28,
	TB_IRDMA_CQP_OP_SUSPEND_QP                 =0x29,
	TB_IRDMA_CQP_OP_RESUME_QP                  =0x2a,
	TB_IRDMA_CQP_OP_SHMC_PAGES_ALLOCATED       =0x2b,
	TB_IRDMA_CQP_OP_WORK_SCHED_NODE            =0x2c,
	TB_IRDMA_CQP_OP_MANAGE_STATS               =0x2d,
	TB_IRDMA_CQP_OP_GATHER_STATS               =0x2e,
	TB_IRDMA_CQP_OP_UP_MAP                     =0x2f
};

/******************* QP OPS **************************/

enum test_qp_ops {
	TB_IRDMA_OP_TYPE_WRITE = 0x0,
	TB_IRDMA_OP_TYPE_READ = 0x1,
	TB_IRDMA_OP_TYPE_SEND = 0x3,
	TB_IRDMA_OP_TYPE_SEND_INV = 0x4,
	TB_IRDMA_OP_TYPE_SEND_SE = 0x5,
	TB_IRDMA_OP_TYPE_SEND_SE_INV = 0x6,
	TB_IRDMA_OP_TYPE_MW_BIND = 0x8,
	TB_IRDMA_OP_TYPE_FAST_REG_MR = 0x9,
	TB_IRDMA_OP_TYPE_LOCAL_INV_STAG = 0xa,
	TB_IRDMA_OP_TYPE_READ_LOCAL_INV = 0xb,
	TB_IRDMA_OP_TYPE_NOP = 0xc,
	TB_IRDMA_OP_TYPE_WRITE_SE = 0xd,
	TB_IRDMA_OP_TYPE_CONN_EST = 0x30,
};

enum qp_sq_send {
	QPSQ_SEND_FIELD_IW_RSVD0,
	QPSQ_SEND_FIELD_UD_RSVD0,
	QPSQ_SEND_FIELD_UD_DEST_QPN,
	QPSQ_SEND_FIELD_UD_DEST_QKEY,
	QPSQ_SEND_FIELD_WQE_VALID,
	QPSQ_SEND_FIELD_SIGNALED_CMPL,
	QPSQ_SEND_FIELD_IW_LOCAL_FENCE,
	QPSQ_SEND_FIELD_IW_READ_FENCE,
	QPSQ_SEND_FIELD_IW_WAIT_FOR_RCVFPDU,
	QPSQ_SEND_FIELD_IW_STREAMING_MODE,
	QPSQ_SEND_FIELD_UDP_HEADER,
	QPSQ_SEND_FIELD_UD_RSVD1,
	QPSQ_SEND_FIELD_UD_RSVD2,
	QPSQ_SEND_FIELD_UD_RSVD3,
	QPSQ_SEND_FIELD_INLINE_DATA_FLAG,
	QPSQ_SEND_FIELD_PUSH_WQE,
	QPSQ_SEND_FIELD_UD_RSVD4,
	QPSQ_SEND_FIELD_IW_RSVD1,
	QPSQ_SEND_FIELD_INLINE_DATA_LENGTH,
	QPSQ_SEND_FIELD_IMM_DATA_FLAG,
	QPSQ_SEND_FIELD_REPORT_RTT,
	QPSQ_SEND_FIELD_UD_L4LEN,
	QPSQ_SEND_FIELD_ADDITIONAL_FRAG_COUNT,
	QPSQ_SEND_FIELD_OP,
	QPSQ_SEND_FIELD_UD_RSVD5,
	QPSQ_SEND_FIELD_UD_AH_ID,
	QPSQ_SEND_FIELD_IW_REMOTE_INV_STAG,
	QPSQ_SEND_QP_TYPE,
	QPSQ_SEND_FIELD_UD_IMM_DATA,
	QPSQ_WRITE_FIELD_RC_REMOTE_TAG_OFFSET,
	QPSQ_WRITE_FIELD_RC_REMOTE_STAG,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_0,
	QPSQ_SEND_FIELD_FRAG_0_VALID,
	QPSQ_SEND_FIELD_FRAG_0_LENGTH,
	QPSQ_SEND_FIELD_STAG_0,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_1,
	QPSQ_SEND_FIELD_FRAG_1_VALID,
	QPSQ_SEND_FIELD_FRAG_1_LENGTH,
	QPSQ_SEND_FIELD_STAG_1,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_2,
	QPSQ_SEND_FIELD_FRAG_2_VALID,
	QPSQ_SEND_FIELD_FRAG_2_LENGTH,
	QPSQ_SEND_FIELD_STAG_2,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_3,
	QPSQ_SEND_FIELD_FRAG_3_VALID,
	QPSQ_SEND_FIELD_FRAG_3_LENGTH,
	QPSQ_SEND_FIELD_STAG_3,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_4,
	QPSQ_SEND_FIELD_FRAG_4_VALID,
	QPSQ_SEND_FIELD_FRAG_4_LENGTH,
	QPSQ_SEND_FIELD_STAG_4,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_5,
	QPSQ_SEND_FIELD_FRAG_5_VALID,
	QPSQ_SEND_FIELD_FRAG_5_LENGTH,
	QPSQ_SEND_FIELD_STAG_5,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_6,
	QPSQ_SEND_FIELD_FRAG_6_VALID,
	QPSQ_SEND_FIELD_FRAG_6_LENGTH,
	QPSQ_SEND_FIELD_STAG_6,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_7,
	QPSQ_SEND_FIELD_FRAG_7_VALID,
	QPSQ_SEND_FIELD_FRAG_7_LENGTH,
	QPSQ_SEND_FIELD_STAG_7,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_8,
	QPSQ_SEND_FIELD_FRAG_8_VALID,
	QPSQ_SEND_FIELD_FRAG_8_LENGTH,
	QPSQ_SEND_FIELD_STAG_8,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_9,
	QPSQ_SEND_FIELD_FRAG_9_VALID,
	QPSQ_SEND_FIELD_FRAG_9_LENGTH,
	QPSQ_SEND_FIELD_STAG_9,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_10,
	QPSQ_SEND_FIELD_FRAG_10_VALID,
	QPSQ_SEND_FIELD_FRAG_10_LENGTH,
	QPSQ_SEND_FIELD_STAG_10,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_11,
	QPSQ_SEND_FIELD_FRAG_11_VALID,
	QPSQ_SEND_FIELD_FRAG_11_LENGTH,
	QPSQ_SEND_FIELD_STAG_11,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_12,
	QPSQ_SEND_FIELD_FRAG_12_VALID,
	QPSQ_SEND_FIELD_FRAG_12_LENGTH,
	QPSQ_SEND_FIELD_STAG_12,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_13,
	QPSQ_SEND_FIELD_FRAG_13_VALID,
	QPSQ_SEND_FIELD_FRAG_13_LENGTH,
	QPSQ_SEND_FIELD_STAG_13,
	QPSQ_SEND_FIELD_TAGGED_OFFSET_14,
	QPSQ_SEND_FIELD_FRAG_14_VALID,
	QPSQ_SEND_FIELD_FRAG_14_LENGTH,
	QPSQ_SEND_FIELD_STAG_14,
	QPSQ_SEND_FIELD_NOP_0_0,
	QPSQ_SEND_FIELD_NOP_0_1,
	QPSQ_SEND_FIELD_NOP_0_2,
	QPSQ_SEND_FIELD_NOP_0_3,
	QPSQ_SEND_FIELD_NOP_1_0,
	QPSQ_SEND_FIELD_NOP_1_1,
	QPSQ_SEND_FIELD_NOP_1_2,
	QPSQ_SEND_FIELD_NOP_1_3,
	QPSQ_SEND_FIELD_NOP_2_0,
	QPSQ_SEND_FIELD_NOP_2_1,
	QPSQ_SEND_FIELD_NOP_2_2,
	QPSQ_SEND_FIELD_NOP_2_3,
	QPSQ_SEND_FIELD_NOP_3_0,
	QPSQ_SEND_FIELD_NOP_3_1,
	QPSQ_SEND_FIELD_NOP_3_2,
	QPSQ_SEND_FIELD_NOP_3_3,
	QPSQ_SEND_FIELD_NOP_4_0,
	QPSQ_SEND_FIELD_NOP_4_1,
	QPSQ_SEND_FIELD_NOP_4_2,
	QPSQ_SEND_FIELD_NOP_4_3,
	QPSQ_SEND_FIELD_NOP_5_0,
	QPSQ_SEND_FIELD_NOP_5_1,
	QPSQ_SEND_FIELD_NOP_5_2,
	QPSQ_SEND_FIELD_NOP_5_3,
	QPSQ_SEND_FIELD_NOP_6_0,
	QPSQ_SEND_FIELD_NOP_6_1,
	QPSQ_SEND_FIELD_NOP_6_2,
	QPSQ_SEND_FIELD_NOP_6_3,
	QPSQ_SEND_FIELD_NOP_7_0,
	QPSQ_SEND_FIELD_NOP_7_1,
	QPSQ_SEND_FIELD_NOP_7_2,
	QPSQ_SEND_FIELD_NOP_7_3,
	QPSQ_SEND_FIELD_INLINE_DATA_0,
	QPSQ_SEND_FIELD_INLINE_DATA_1,
	QPSQ_SEND_FIELD_INLINE_DATA_2,
	QPSQ_SEND_FIELD_INLINE_DATA_3,
	QPSQ_SEND_FIELD_INLINE_DATA_4,
	QPSQ_SEND_FIELD_INLINE_DATA_VALID_4,
	QPSQ_SEND_FIELD_INLINE_DATA_RSVD_4,
	QPSQ_SEND_FIELD_INLINE_DATA_5,
	QPSQ_SEND_FIELD_INLINE_DATA_6,
	QPSQ_SEND_FIELD_INLINE_DATA_7,
	QPSQ_SEND_FIELD_INLINE_DATA_8,
	QPSQ_SEND_FIELD_INLINE_DATA_VALID_8,
	QPSQ_SEND_FIELD_INLINE_DATA_RSVD_8,
	QPSQ_SEND_FIELD_INLINE_DATA_9,
	QPSQ_SEND_FIELD_INLINE_DATA_10,
	QPSQ_SEND_FIELD_INLINE_DATA_11,
	QPSQ_SEND_FIELD_INLINE_DATA_12,
	QPSQ_SEND_FIELD_INLINE_DATA_VALID_12,
	QPSQ_SEND_FIELD_INLINE_DATA_RSVD_12,
	QPSQ_SEND_FIELD_INLINE_DATA_13,
	QPSQ_SEND_FIELD_INLINE_DATA_14,
	QPSQ_SEND_FIELD_INLINE_DATA_15,
	QPSQ_SEND_FIELD_INLINE_DATA_16,
	QPSQ_SEND_FIELD_INLINE_DATA_VALID_16,
	QPSQ_SEND_FIELD_INLINE_DATA_RSVD_16,
	QPSQ_SEND_FIELD_INLINE_DATA_17,
	QPSQ_SEND_FIELD_INLINE_DATA_18,
	QPSQ_SEND_FIELD_INLINE_DATA_19,
	QPSQ_SEND_FIELD_INLINE_DATA_20,
	QPSQ_SEND_FIELD_INLINE_DATA_VALID_20,
	QPSQ_SEND_FIELD_INLINE_DATA_RSVD_20,
	QPSQ_SEND_FIELD_INLINE_DATA_21,
	QPSQ_SEND_FIELD_INLINE_DATA_22,
	QPSQ_SEND_FIELD_INLINE_DATA_23,
	QPSQ_SEND_FIELD_INLINE_DATA_24,
	QPSQ_SEND_FIELD_INLINE_DATA_VALID_24,
	QPSQ_SEND_FIELD_INLINE_DATA_RSVD_24,
	QPSQ_SEND_FIELD_INLINE_DATA_25,
	QPSQ_SEND_FIELD_INLINE_DATA_26,
	QPSQ_SEND_FIELD_INLINE_DATA_27,
	QPSQ_SEND_FIELD_INLINE_DATA_28,
	QPSQ_SEND_FIELD_INLINE_DATA_VALID_28,
	QPSQ_SEND_FIELD_INLINE_DATA_RSVD_28,
	QPSQ_SEND_FIELD_NUM_FIELDS
}; /* enum qp_sq_send */

enum mcg_ctx_fields {
	MCG_CTX_FIELD_RSVD0,
	MCG_CTX_FIELD_DEST_PORT,
	MCG_CTX_FIELD_VALID,
	MCG_CTX_FIELD_RSVD1,
	MCG_CTX_FIELD_QP_ID,
	MCG_CTX_FIELD_NUM_FIELDS
}; /* enum mcg_ctx_fields */

enum qp_sq_REPLACE {
	QPSQ_REPLACE_FIELD_OP,
	QPSQ_REPLACE_FIELD_NUM_FIELDS
}; /* enum qp_sq_REPLACE */


enum tb_qp_type {
	QP_TYPE_CQP, //0
	QP_TYPE_IWARP, //1
	QP_TYPE_UDA, //2
	QP_TYPE_ROCEV2_RC, //3
	QP_TYPE_ROCEV2_UD //4
};

enum fpm_query_fields {
	FPM_QUERY_FIELD_RSVD0,
	FPM_QUERY_FIELD_MAX_PE_SDS,
	FPM_QUERY_FIELD_RSVD1,
	FPM_QUERY_FIELD_FIRST_PE_SD_IDX,
	FPM_QUERY_FIELD_GLHMC_PEQPOBJSZ,
	FPM_QUERY_FIELD_RSVD2,
	FPM_QUERY_FIELD_MAX_QPS,
	FPM_QUERY_FIELD_GLHMC_PECQOBJSZ,
	FPM_QUERY_FIELD_RSVD3,
	FPM_QUERY_FIELD_MAX_CQS,
	FPM_QUERY_FIELD_RSVD4,
	FPM_QUERY_FIELD_RSVD5,
	FPM_QUERY_FIELD_GLHMC_PEHTEOBJSZ,
	FPM_QUERY_FIELD_GLHMC_PEHTMAX,
	FPM_QUERY_FIELD_GLHMC_PEARPOBJSZ,
	FPM_QUERY_FIELD_GLHMC_PEARPMAX,
	FPM_QUERY_FIELD_GLHMC_PEMROBJSZ,
	FPM_QUERY_FIELD_GLHMC_PEMRMAX,
	FPM_QUERY_FIELD_GLHMC_PEXFOBJSZ,
	FPM_QUERY_FIELD_GLHMC_PEXFMAX,
	FPM_QUERY_FIELD_XFBLOCKSIZE,
	FPM_QUERY_FIELD_GLHMC_PEXFFLMAX,
	FPM_QUERY_FIELD_GLHMC_PEQ1OBJSZ,
	FPM_QUERY_FIELD_GLHMC_PEQ1MAX,
	FPM_QUERY_FIELD_Q1BLOCKSIZE,
	FPM_QUERY_FIELD_GLHMC_PEQ1FLMAX,
	FPM_QUERY_FIELD_GLHMC_PETIMEROBJSZ,
	FPM_QUERY_FIELD_GLHMC_PETIMERMAX,
	FPM_QUERY_FIELD_GLHMC_FSIMCOBJSZ,
	FPM_QUERY_FIELD_GLHMC_FSIMCMAX,
	FPM_QUERY_FIELD_GLHMC_FSIAVOBJSZ,
	FPM_QUERY_FIELD_GLHMC_FSIAVMAX,
	FPM_QUERY_FIELD_RSVD6,
	FPM_QUERY_FIELD_GLHMC_PEPBLMAX,
	FPM_QUERY_FIELD_RSVD7,
	FPM_QUERY_FIELD_TIMERBUCKETCNT,
	FPM_QUERY_FIELD_RSVD8,
	FPM_QUERY_FIELD_HTMULTIPLIER,
	FPM_QUERY_FIELD_RSVD9,
	FPM_QUERY_FIELD_MAX_CEQS,
	FPM_QUERY_FIELD_GLHMC_PERRFOBJSZ,
	FPM_QUERY_FIELD_GLHMC_PERRFMAX,
	FPM_QUERY_FIELD_RRFBLOCKSIZE,
	FPM_QUERY_FIELD_GLHMC_PERRFFLMAX,
	FPM_QUERY_FIELD_GLHMC_PEHDROBJSZ,
	FPM_QUERY_FIELD_GLHMC_PEHDRMAX,
	FPM_QUERY_FIELD_GLHMC_PEMDOBJSZ,
	FPM_QUERY_FIELD_GLHMC_PEMDMAX,
	FPM_QUERY_FIELD_GLHMC_PEOOISCOBJSZ,
	FPM_QUERY_FIELD_GLHMC_PEOOISCMAX,
	FPM_QUERY_FIELD_OOISCFBLOCKSIZE,
	FPM_QUERY_FIELD_GLHMC_PEOOISCFFLMAX,
	FPM_QUERY_FIELD_NUM_FIELDS
};

enum fpm_commit_fields {
	FPM_COMMIT_FIELD_GLHMC_PEQPBASE,
	FPM_COMMIT_FIELD_RSVD0,
	FPM_COMMIT_FIELD_GLHMC_PEQPCNT,
	FPM_COMMIT_FIELD_GLHMC_PECQBASE,
	FPM_COMMIT_FIELD_RSVD1,
	FPM_COMMIT_FIELD_GLHMC_PECQCNT,
	FPM_COMMIT_FIELD_RSVD2,
	FPM_COMMIT_FIELD_RSVD3,
	FPM_COMMIT_FIELD_GLHMC_HTEBASE,
	FPM_COMMIT_FIELD_GLHMC_HTCNT,
	FPM_COMMIT_FIELD_GLHMC_PEARPBASE,
	FPM_COMMIT_FIELD_GLHMC_PEARPCNT,
	FPM_COMMIT_FIELD_GLHMC_APBVTINUSEBASE,
	FPM_COMMIT_FIELD_RSVD4,
	FPM_COMMIT_FIELD_GLHMC_PEMRBASE,
	FPM_COMMIT_FIELD_GLHMC_PEMRCNT,
	FPM_COMMIT_FIELD_GLHMC_PEXFBASE,
	FPM_COMMIT_FIELD_GLHMC_PEXFCNT,
	FPM_COMMIT_FIELD_GLHMC_PEXFFLBASE,
	FPM_COMMIT_FIELD_GLHMC_PEXFFLCNT,
	FPM_COMMIT_FIELD_GLHMC_PEQ1BASE,
	FPM_COMMIT_FIELD_GLHMC_PEQ1CNT,
	FPM_COMMIT_FIELD_GLHMC_PEQ1FLBASE,
	FPM_COMMIT_FIELD_GLHMC_PEQ1FLCNT,
	FPM_COMMIT_FIELD_GLHMC_TIMERBASE,
	FPM_COMMIT_FIELD_GLHMC_TIMERCNT,
	FPM_COMMIT_FIELD_GLHMC_FSIMCBASE,
	FPM_COMMIT_FIELD_GLHMC_FSIMCCNT,
	FPM_COMMIT_FIELD_GLHMC_FSIAVBASE,
	FPM_COMMIT_FIELD_GLHMC_FSIAVCNT,
	FPM_COMMIT_FIELD_GLHMC_PEPBLBASE,
	FPM_COMMIT_FIELD_GLHMC_PEPBLCNT,
	FPM_COMMIT_FIELD_RSVD5,
	FPM_COMMIT_FIELD_GLHMC_PERRFBASE,
	FPM_COMMIT_FIELD_GLHMC_PERRFCNT,
	FPM_COMMIT_FIELD_GLHMC_PERRFFLBASE,
	FPM_COMMIT_FIELD_GLHMC_PERRFFLCNT,
	FPM_COMMIT_FIELD_GLHMC_PEHDRBASE,
	FPM_COMMIT_FIELD_GLHMC_PEHDRCNT,
	FPM_COMMIT_FIELD_GLHMC_PEMDBASE,
	FPM_COMMIT_FIELD_GLHMC_PEMDCNT,
	FPM_COMMIT_FIELD_GLHMC_PEOOISCBASE,
	FPM_COMMIT_FIELD_GLHMC_PEOOISCCNT,
	FPM_COMMIT_FIELD_GLHMC_PEOOISCFFLBASE,
	FPM_COMMIT_FIELD_GLHMC_PEOOISCFFLCNT,
	FPM_COMMIT_FIELD_NUM_FIELDS
};

enum cqp_cmd_qp_ctx_roce_fields {
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD0,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD1,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD2,
	CQP_CMD_QP_CTX_ROCE_FIELD_ACK_CREDITS,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD3,
	CQP_CMD_QP_CTX_ROCE_FIELD_DCTCP_STATE,
	CQP_CMD_QP_CTX_ROCE_FIELD_ROCE_STATE_RX,
	CQP_CMD_QP_CTX_ROCE_FIELD_ROCE_STATE_TX,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD4,
	CQP_CMD_QP_CTX_ROCE_FIELD_XMIT_TAIL,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD5,
	CQP_CMD_QP_CTX_ROCE_FIELD_Q1_TAIL,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD6,
	CQP_CMD_QP_CTX_ROCE_FIELD_RDRRESP_TAIL,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD7,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD8,
	CQP_CMD_QP_CTX_ROCE_FIELD_PSN_UNA,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD9,
	CQP_CMD_QP_CTX_ROCE_FIELD_SSN_UNA,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD10,
	CQP_CMD_QP_CTX_ROCE_FIELD_PSN_NXT,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD11,
	CQP_CMD_QP_CTX_ROCE_FIELD_RTT_VAR,
	CQP_CMD_QP_CTX_ROCE_FIELD_SRTT,
	CQP_CMD_QP_CTX_ROCE_FIELD_CWND,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD12,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD13,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD14,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD15,
	CQP_CMD_QP_CTX_ROCE_FIELD_REXMIT_COUNT,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD16,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD17,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD18,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD19,
	CQP_CMD_QP_CTX_ROCE_FIELD_SQ_TAIL,
	CQP_CMD_QP_CTX_ROCE_FIELD_SQ_WA,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD20,
	CQP_CMD_QP_CTX_ROCE_FIELD_PROBE_CNT,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD21,
	CQP_CMD_QP_CTX_ROCE_FIELD_RSVD22,
	CQP_CMD_QP_CTX_ROCE_FIELD_RQ_TAIL,
	CQP_CMD_QP_CTX_ROCE_FIELD_NUM_FIELDS
};

enum qp_ctx_roce_fields {
	QP_CTX_ROCE_FIELD_ROCE_TVER,
	QP_CTX_ROCE_FIELD_PUSH_MODE_EN,
	QP_CTX_ROCE_FIELD_PUSH_PAGE_IDX,
	QP_CTX_ROCE_FIELD_SQ_TPH_EN,
	QP_CTX_ROCE_FIELD_RQ_TPH_EN,
	QP_CTX_ROCE_FIELD_XMIT_TPH_EN,
	QP_CTX_ROCE_FIELD_RCV_TPH_EN,
	QP_CTX_ROCE_FIELD_DCTCP_EN,
	QP_CTX_ROCE_FIELD_PD_IDX_HIGH,
	QP_CTX_ROCE_FIELD_ECN_EN,
	QP_CTX_ROCE_FIELD_RQ_WQE_SIZE,
	QP_CTX_ROCE_FIELD_IS_QP1,
	QP_CTX_ROCE_FIELD_INSERT_VLAN_TAG,
	QP_CTX_ROCE_FIELD_IPV4,
	QP_CTX_ROCE_FIELD_SQ_ADDR,
	QP_CTX_ROCE_FIELD_RQ_ADDR,
	QP_CTX_ROCE_FIELD_DEST_PORT_NUM,
	QP_CTX_ROCE_FIELD_SRC_PORT_NUM,
	QP_CTX_ROCE_FIELD_TRAFFIC_CLASS,
	QP_CTX_ROCE_FIELD_TOS,
	QP_CTX_ROCE_FIELD_SQ_SIZE,
	QP_CTX_ROCE_FIELD_RQ_SIZE,
	QP_CTX_ROCE_FIELD_HOP_LIMIT,
	QP_CTX_ROCE_FIELD_TTL,
	QP_CTX_ROCE_FIELD_DEST_IP_ADDR_2,
	QP_CTX_ROCE_FIELD_DEST_IP_ADDR_3,
	QP_CTX_ROCE_FIELD_DEST_IP_ADDR_0,
	QP_CTX_ROCE_FIELD_DEST_IP_ADDR_1,
	QP_CTX_ROCE_FIELD_ARP_IDX,
	QP_CTX_ROCE_FIELD_VLAN_TAG,
	QP_CTX_ROCE_FIELD_MTU,
	QP_CTX_ROCE_FIELD_PD_IDX,
	QP_CTX_ROCE_FIELD_P_KEY,
	QP_CTX_ROCE_FIELD_ACK_CREDITS,
	QP_CTX_ROCE_FIELD_FLOW_LABEL,
	QP_CTX_ROCE_FIELD_Q_KEY,
	QP_CTX_ROCE_FIELD_DEST_QPN,
	QP_CTX_ROCE_FIELD_LSN,
	QP_CTX_ROCE_FIELD_PSN_NXT,
	QP_CTX_ROCE_FIELD_EPSN,
	QP_CTX_ROCE_FIELD_PSN_UNA,
	QP_CTX_ROCE_FIELD_PSN_MAX,
	QP_CTX_ROCE_FIELD_CWND,
	QP_CTX_ROCE_FIELD_RNR_NAK_THRESH,
	QP_CTX_ROCE_FIELD_REXMIT_THRESH,
	QP_CTX_ROCE_FIELD_RX_CMP_QUEUE_NUM,
	QP_CTX_ROCE_FIELD_TX_CMP_QUEUE_NUM,
	QP_CTX_ROCE_FIELD_STATS_INST_IDX,
	QP_CTX_ROCE_FIELD_SRC_MAC_ADDR_5,
	QP_CTX_ROCE_FIELD_SRC_MAC_ADDR_4,
	QP_CTX_ROCE_FIELD_SRC_MAC_ADDR_3,
	QP_CTX_ROCE_FIELD_SRC_MAC_ADDR_2,
	QP_CTX_ROCE_FIELD_SRC_MAC_ADDR_1,
	QP_CTX_ROCE_FIELD_SRC_MAC_ADDR_0,
	QP_CTX_ROCE_FIELD_LAST_BYTE_SENT,
	QP_CTX_ROCE_FIELD_TIMELY_EN,
	QP_CTX_ROCE_FIELD_USE_STATS_INST,
	QP_CTX_ROCE_FIELD_PRIV_EN,
	QP_CTX_ROCE_FIELD_FAST_REG_EN,
	QP_CTX_ROCE_FIELD_BIND_EN,
	QP_CTX_ROCE_FIELD_DCQCN_EN,
	QP_CTX_ROCE_FIELD_RDMARD_OK,
	QP_CTX_ROCE_FIELD_RDMAWR_RDRESP_OK,
	QP_CTX_ROCE_FIELD_UD_PRIV_CQ_EN,
	QP_CTX_ROCE_FIELD_IRD_SIZE,
	QP_CTX_ROCE_FIELD_ORD_SIZE,
	QP_CTX_ROCE_FIELD_QP_COMPL_CTX,
	QP_CTX_ROCE_FIELD_QS_HANDLE,
	QP_CTX_ROCE_FIELD_RQ_TPH_VAL,
	QP_CTX_ROCE_FIELD_SQ_TPH_VAL,
	QP_CTX_ROCE_FIELD_LOCAL_IP_ADDR_2,
	QP_CTX_ROCE_FIELD_LOCAL_IP_ADDR_3,
	QP_CTX_ROCE_FIELD_LOCAL_IP_ADDR_1,
	QP_CTX_ROCE_FIELD_LOCAL_IP_ADDR_0,
	QP_CTX_ROCE_FIELD_NUM_FIELDS
};

#define TB_MAX_WQE_SIZE 0x100
#define TB_MAX_FRAG_COUNT 14
#define TB_MIN_WQE_SIZE_BYTES 32
#define TB_FRAG_SIZE_BYTES 16
#define TB_FPM_QUERY_BYTE_SIZE 176
#define TB_FPM_COMMIT_BYTE_SIZE 176

#endif /* CQP_FIELDS_H */
