#ifndef TB_BASE_H
#define TB_BASE_H

#include <string>
#include "CppUTest/TestHarness.h"
#include "CppUTest/CommandLineTestRunner.h"
#include "CppUTestExt/MockSupport.h"

#define RDMA_CHECK_EQUAL(A, B, MSG) \
	do { \
		printf(("\t%s\n"),(MSG)); \
		CHECK_EQUAL((A), (B)); \
	} while (0)

#define RDMA_CHECK_NOT_EQUAL(A, B, MSG) \
	do { \
		printf(("\t%s\n"),(MSG)); \
		CHECK((A) != (B)); \
	} while (0)

#define tb_debug(level, x, ...) \
	do {\
		if (debug >= level) \
			printf("TB: %s:%s@%d: ", __FILE__, __func__, __LINE__); \
			printf((x), ##__VA_ARGS__); \
	} while (0)

enum debug_level {
	DEBUG_NONE,
	DEBUG_LOW,
	DEBUG_MEDIUM,
	DEBUG_HIGH,
};

class TB_OBJ
{
	protected:
	std::string name;
	public:
	void *parent;
	enum debug_level debug = DEBUG_NONE;
	virtual void set_debug(enum debug_level level);
	virtual void clear_debug(void);
};

#endif /* TB_BASE_H */
