#ifndef _WR_H
#define _WR_H

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include "kernel_abstract.h"
#include <list.h>
#include <wait.h>
//#include <timer.h>
//#define __packed __attribute__ ((packed))
//#include "status.h"
//#include <tdd_local/osdep.h>
//#include "defs.h"
//#include "type.h"
////#include "vf.h"
//#include "uda.h"
//#include "uda_d.h"
#include "tb_base.h"
#include "wqe.h"
#include "interface.h"
#include "cqp_fields.h"

#define CURRENT_BYTE_OFFESET(i) i
#define NEXT_BYTE_OFFSET(i) i+1

enum config_ver {
	MIXED_QP_TYPES,
	MUTEX_QP_TYPES
};

// one-hot encoding
enum qp_send_setup {
	NO_INLINE = 1,
	NO_IMM_DATA = 2,
	WRITE_WR = 4,
	CONSTRAIN_SGE_LEN = 8,
	SEND_WR = 16,
	RELIABLE_CONN = 32
};

class QP_SEND : public QP_SQ_WR
{
	public:
	u8 inline_data[256]; //should be 256 Bytes
	enum config_ver config=MUTEX_QP_TYPES;
	u16 setup_config = 0;
	enum permissions frag_perm = RSVD;
	enum permissions nop_perm = RSVD;
	enum permissions inline_perm = RSVD;
	bool set_next_valid = false; //needed if last frag only takes up half of min_wqe_size

	virtual void set_debug(enum debug_level level);
	virtual void set_setup_config(enum qp_send_setup var);
	QP_SEND(void);
	~QP_SEND(void);
	virtual void update_frag_perm(void);
	virtual void init(void);
	virtual void randomize(void);
	virtual u64 concat_sge_fields(Field *sge_field_array);
	virtual void fill_rdma_send_intf_mixed(struct irdma_post_sq_info *info);
	virtual void fill_rdma_send_intf_mixed_inline(struct irdma_post_sq_info *info);
	virtual void fill_rdma_send_intf_mutex(struct irdma_post_sq_info *info);
	virtual void fill_rdma_send_intf_mutex_inline(struct irdma_post_sq_info *info);
	virtual void fill_rdma_write_intf_mixed(struct irdma_post_sq_info *info);
	virtual void fill_rdma_write_intf_mixed_inline(struct irdma_post_sq_info *info);
	virtual void fill_rdma_write_intf_mutex(struct irdma_post_sq_info *info);
	virtual void fill_rdma_write_intf_mutex_inline(struct irdma_post_sq_info *info);
	virtual void fill_nops(struct irdma_sc_qp *sc_qp, u16 wqe_size_bytes, u8 polarity);
	virtual void fill_nops(struct irdma_ring *sqr, struct irdma_sc_qp *sc_qp, u16 wqe_size_bytes, u8 polarity);
	virtual void enable_inline_fields(u16 inline_wqes);
	virtual void fill_rdma_send_intf(struct irdma_sc_qp *sc_qp,
					 struct irdma_post_sq_info *info,
					 struct irdma_sge *sges);
	virtual void enable_write_fields(void);
	virtual void fill_rdma_write_intf(struct irdma_sc_qp *sc_qp,
					  struct irdma_post_sq_info *info, u64 *sges);
	virtual void rule_not_used_for_iw(u64 *field_data);
	virtual void rule_not_used_for_cqp(u64 *field_data);
	virtual void rule_not_used_for_uda(u64 *field_data);
	virtual void rule_not_used_for_rocev2_rc(u64 *field_data);
	virtual void rule_not_used_for_rocev2_ud(u64 *field_data);
	virtual void rule_only_used_for_rc_qps(u64 *field_data);
	virtual void rule_only_used_for_ud_qps(u64 *field_data);
	virtual void rule_only_used_for_iw(u64 *field_data);
	virtual void rule_should_always_be(u64 *field_data, u64 x);
	virtual void rule_not_valid_if_flag_set(u64 *field_data, enum qp_sq_send send_enum);
	virtual void rule_not_valid_if_flag_clear(u64 *field_data, enum qp_sq_send send_enum);
	virtual void rule_based_on_num_add_frags(u64 *field_data, enum qp_sq_send send_enum, u64 imm_data);
	virtual void rule_has_valid_number_of_frags(u64 *field_data);
	virtual void rule_only_used_for_connection_setup(u64 *field_data);
	virtual void rule_based_on_avail_wqes(int field_idx, u64 *field_data);
	virtual void rule_honor_head_tail_gap(int field_idx, u64 *field_data);
	virtual void rule_valid_sq_data(int field_idx, u64 *field_data);
	virtual void rule_wqe_fits_in_avail_space(int field_idx, u64 *field_data);
	virtual void rule_not_used_for_inline(u64 *field_data);
	virtual void rule_only_for_uda(u64 *field_data);
	virtual void rule_only_used_for_inv_ops(u64 *field_data);
	virtual void rule_not_used_for_write(u64 *field_data);
	virtual void gen_field_vs_rules(int field_idx, u64 *field_data);
	virtual void fill_fields(struct irdma_ring *sqr, struct irdma_qp *iwqp,
				 struct ib_send_wr *ib_wr, u64 polarity);
	virtual void fill_fields_send(struct irdma_ring *sqr, struct irdma_qp *iwqp,
				      struct ib_send_wr *ib_wr, u64 polarity);
	virtual void set_polarity(u8*, bool);
	void enable_frags(u16);
	void set_inline_data(u16*, u16*, struct ib_send_wr*);
};

#endif /* _WR_H */
