Name: irdma
Version: 0.0.0
Release: 1.3
Summary: Intel(R) Ethernet Connection RDMA Driver

Group: System Environment/Kernel
License: Dual BSD/GPL
Source0: %{name}-%{version}.tar.gz

%description
This package contains the Intel(R) Ethernet Connection RDMA Driver

%define debug_package %{nil}

%if "%{_host_vendor}" == "redhat"
#BuildRequires: %kernel_module_package_buildreqs
%define install_mod_dir updates/drivers/infiniband/hw/%{name}
%else
BuildRequires: kernel-source kernel-syms
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%define install_mod_dir updates
%endif

%define current_kernel %(uname -r)

%if "%{_host_vendor}" == "suse"
%if "%{_arch}" == "x86_64"
%{suse_kernel_module_package -x default smp xen kdump}
%else
%{suse_kernel_module_package -x default smp xen kdump bigsmp xenpae pae}
%endif
%endif

%if "%{_host_vendor}" == "redhat"
%{kernel_module_package -x debug kdump um}
%endif

%prep
%setup -q
set -- *
mkdir source
mv "$@" source/
mkdir obj

%build
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
rm -rf obj
cp -r source obj/
cd obj/
./build.sh

%install
export INSTALL_MOD_PATH=%{buildroot}
echo SDE_INSTALL_MOD_PATH:$INSTALL_MOD_PATH
export INSTALL_MOD_DIR=%install_mod_dir
echo SDE_INSTALL_MOD_DIR:$INSTALL_MOD_DIR
export MANDIR=%{_mandir}

install -D -m 755 obj/src/irdma/%{name}.ko ${INSTALL_MOD_PATH}/lib/modules/%current_kernel/${INSTALL_MOD_DIR}/%{name}.ko
modprobe irdma

%files
%defattr(-,root,root,-)
/lib/modules/%current_kernel/updates/drivers/infiniband/hw/irdma/%{name}.ko

%clean
rm -rf %{buildroot}

%changelog
* Thu Apr 23 2020 - Intel Corporation <linuxnics.intel.com>>%{version}-%{release}
- Initial package
 
