/* SPDX-License-Identifier: GPL-2.0 or Linux-OpenIB */
/* Copyright (C) 2019 Intel Corporation */

#ifndef IG3RDMA_REGS_H
#define IG3RDMA_REGS_H

#include "irdma.h"

#define IG3_CPUW_GLPE_CONFIGPKT_LIMIT 0x4200D7AC
#define IG3_CPUW_GLPE_CONFIGPKT_LIMIT_RSVD0_S 6
#define IG3_CPUW_GLPE_CONFIGPKT_LIMIT_RSVD0_M RDMA_MASK3(32, 0x3FFFFFF, IG3_CPUW_GLPE_CONFIGPKT_LIMIT_RSVD0_S)
#define IG3_CPUW_GLPE_CONFIGPKT_LIMIT_PECONFIGPKTLIMIT_S 0
#define IG3_CPUW_GLPE_CONFIGPKT_LIMIT_PECONFIGPKTLIMIT_M RDMA_MASK3(32, 0x3F, IG3_CPUW_GLPE_CONFIGPKT_LIMIT_PECONFIGPKTLIMIT_S)
#define IG3_CPUW_GLPE_CPUGP(_i) 0x4200D020 + ((_i) * 4) /* _i=0...383 */
#define IG3_CPUW_GLPE_CPUGP_MAX_INDEX_I 383
#define IG3_CPUW_GLPE_CPUGP_PECPUGP_S 0
#define IG3_CPUW_GLPE_CPUGP_PECPUGP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUGP_PECPUGP_S)
#define IG3_CPUW_GLPE_CPUSTATUS0 0x4200D620
#define IG3_CPUW_GLPE_CPUSTATUS0_PECPUSTATUS0_S 0
#define IG3_CPUW_GLPE_CPUSTATUS0_PECPUSTATUS0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUSTATUS0_PECPUSTATUS0_S)
#define IG3_CPUW_GLPE_CPUSTATUS1 0x4200D624
#define IG3_CPUW_GLPE_CPUSTATUS1_PECPUSTATUS1_S 0
#define IG3_CPUW_GLPE_CPUSTATUS1_PECPUSTATUS1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUSTATUS1_PECPUSTATUS1_S)
#define IG3_CPUW_GLPE_CPUSTATUS2 0x4200D628
#define IG3_CPUW_GLPE_CPUSTATUS2_PECPUSTATUS2_S 0
#define IG3_CPUW_GLPE_CPUSTATUS2_PECPUSTATUS2_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUSTATUS2_PECPUSTATUS2_S)
#define IG3_CPUW_GLPE_CPUTRIG0 0x4200D62C
#define IG3_CPUW_GLPE_CPUTRIG0_RSVD1_S 20
#define IG3_CPUW_GLPE_CPUTRIG0_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_CPUTRIG0_RSVD1_S)
#define IG3_CPUW_GLPE_CPUTRIG0_IMC_REQUEST0_S 19
#define IG3_CPUW_GLPE_CPUTRIG0_IMC_REQUEST0_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUTRIG0_IMC_REQUEST0_S)
#define IG3_CPUW_GLPE_CPUTRIG0_OOP_REQUEST0_S 18
#define IG3_CPUW_GLPE_CPUTRIG0_OOP_REQUEST0_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUTRIG0_OOP_REQUEST0_S)
#define IG3_CPUW_GLPE_CPUTRIG0_TEP_REQUEST0_S 17
#define IG3_CPUW_GLPE_CPUTRIG0_TEP_REQUEST0_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUTRIG0_TEP_REQUEST0_S)
#define IG3_CPUW_GLPE_CPUTRIG0_RSVD0_S 16
#define IG3_CPUW_GLPE_CPUTRIG0_RSVD0_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUTRIG0_RSVD0_S)
#define IG3_CPUW_GLPE_CPUTRIG0_PECPUTRIG0_S 0
#define IG3_CPUW_GLPE_CPUTRIG0_PECPUTRIG0_M RDMA_MASK3(32, 0xFFFF, IG3_CPUW_GLPE_CPUTRIG0_PECPUTRIG0_S)
#define IG3_CPUW_GLPE_CPUTRIG1 0x4200D630
#define IG3_CPUW_GLPE_CPUTRIG1_RSVD1_S 20
#define IG3_CPUW_GLPE_CPUTRIG1_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_CPUTRIG1_RSVD1_S)
#define IG3_CPUW_GLPE_CPUTRIG1_IMC_REQUEST1_S 19
#define IG3_CPUW_GLPE_CPUTRIG1_IMC_REQUEST1_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUTRIG1_IMC_REQUEST1_S)
#define IG3_CPUW_GLPE_CPUTRIG1_OOP_REQUEST1_S 18
#define IG3_CPUW_GLPE_CPUTRIG1_OOP_REQUEST1_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUTRIG1_OOP_REQUEST1_S)
#define IG3_CPUW_GLPE_CPUTRIG1_RSVD0_S 17
#define IG3_CPUW_GLPE_CPUTRIG1_RSVD0_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUTRIG1_RSVD0_S)
#define IG3_CPUW_GLPE_CPUTRIG1_CQP_REQUEST1_S 16
#define IG3_CPUW_GLPE_CPUTRIG1_CQP_REQUEST1_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUTRIG1_CQP_REQUEST1_S)
#define IG3_CPUW_GLPE_CPUTRIG1_PECPUTRIG1_S 0
#define IG3_CPUW_GLPE_CPUTRIG1_PECPUTRIG1_M RDMA_MASK3(32, 0xFFFF, IG3_CPUW_GLPE_CPUTRIG1_PECPUTRIG1_S)
#define IG3_CPUW_GLPE_CPUTRIG2 0x4200D634
#define IG3_CPUW_GLPE_CPUTRIG2_RSVD1_S 20
#define IG3_CPUW_GLPE_CPUTRIG2_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_CPUTRIG2_RSVD1_S)
#define IG3_CPUW_GLPE_CPUTRIG2_IMC_REQUEST2_S 19
#define IG3_CPUW_GLPE_CPUTRIG2_IMC_REQUEST2_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUTRIG2_IMC_REQUEST2_S)
#define IG3_CPUW_GLPE_CPUTRIG2_RSVD0_S 18
#define IG3_CPUW_GLPE_CPUTRIG2_RSVD0_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUTRIG2_RSVD0_S)
#define IG3_CPUW_GLPE_CPUTRIG2_TEP_REQUEST2_S 17
#define IG3_CPUW_GLPE_CPUTRIG2_TEP_REQUEST2_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUTRIG2_TEP_REQUEST2_S)
#define IG3_CPUW_GLPE_CPUTRIG2_CQP_REQUEST2_S 16
#define IG3_CPUW_GLPE_CPUTRIG2_CQP_REQUEST2_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUTRIG2_CQP_REQUEST2_S)
#define IG3_CPUW_GLPE_CPUTRIG2_PECPUTRIG2_S 0
#define IG3_CPUW_GLPE_CPUTRIG2_PECPUTRIG2_M RDMA_MASK3(32, 0xFFFF, IG3_CPUW_GLPE_CPUTRIG2_PECPUTRIG2_S)
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_COUNT 0x4200D838
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_CPUW_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CPUW_GLPE_CPUW_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_CMD 0x4200D84C
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_DATA_H 0x4200D858
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_DATA_L 0x4200D854
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_PTR 0x4200D850
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CPUW_GLPE_CPUW_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_CMD 0x4200D83C
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_DATA_H 0x4200D848
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_DATA_L 0x4200D844
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_PTR 0x4200D840
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CPUW_GLPE_CPUW_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL 0x4200D800
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_RSVD1_S 25
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_CPUW_GLPE_CPUW_DTM_CONTROL_RSVD1_S)
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_RSVD2_S 17
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CPUW_GLPE_CPUW_DTM_CONTROL_RSVD2_S)
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_RSVD3_S 9
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_CPUW_GLPE_CPUW_DTM_CONTROL_RSVD3_S)
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_BYPASS_S 8
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_CONTROL_BYPASS_S)
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_RSVD4_S 1
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_CPUW_GLPE_CPUW_DTM_CONTROL_RSVD4_S)
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_CONTROL_LOCAL_EN_S)
#define IG3_CPUW_GLPE_CPUW_DTM_ECC_COR_ERR 0x4200D868
#define IG3_CPUW_GLPE_CPUW_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_CPUW_GLPE_CPUW_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CPUW_GLPE_CPUW_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_CPUW_GLPE_CPUW_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_CPUW_DTM_ECC_COR_ERR_CNT_S)
#define IG3_CPUW_GLPE_CPUW_DTM_ECC_UNCOR_ERR 0x4200D864
#define IG3_CPUW_GLPE_CPUW_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CPUW_GLPE_CPUW_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CPUW_GLPE_CPUW_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CPUW_GLPE_CPUW_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_CPUW_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_CPUW_GLPE_CPUW_DTM_GROUP_CFG 0x4200D80C
#define IG3_CPUW_GLPE_CPUW_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_CPUW_GLPE_CPUW_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_CPUW_DTM_GROUP_CFG_RSVD1_S)
#define IG3_CPUW_GLPE_CPUW_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_CPUW_GLPE_CPUW_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_CPUW_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_CPUW_GLPE_CPUW_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_CPUW_GLPE_CPUW_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_CPUW_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_CPUW_GLPE_CPUW_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_CPUW_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_CPUW_GLPE_CPUW_DTM_LOG_CFG 0x4200D810
#define IG3_CPUW_GLPE_CPUW_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_CPUW_GLPE_CPUW_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_CPUW_GLPE_CPUW_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_CPUW_GLPE_CPUW_DTM_LOG_CFG_RSVD1_S 2
#define IG3_CPUW_GLPE_CPUW_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CPUW_GLPE_CPUW_DTM_LOG_CFG_RSVD1_S)
#define IG3_CPUW_GLPE_CPUW_DTM_LOG_CFG_MODE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CPUW_DTM_LOG_CFG_MODE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_LOG_MASK 0x4200D818
#define IG3_CPUW_GLPE_CPUW_DTM_LOG_MASK_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUW_DTM_LOG_MASK_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_LOG_PATTERN 0x4200D814
#define IG3_CPUW_GLPE_CPUW_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUW_DTM_LOG_PATTERN_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG 0x4200D804
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_RSVD1_S)
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_RSVD2_S)
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_RSVD3_S)
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_STS 0x4200D808
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_STS_RSVD1_S 9
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_CPUW_GLPE_CPUW_DTM_MAIN_STS_RSVD1_S)
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_STS_RSVD2_S 1
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CPUW_GLPE_CPUW_DTM_MAIN_STS_RSVD2_S)
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TIMESTAMP 0x4200D830
#define IG3_CPUW_GLPE_CPUW_DTM_TIMESTAMP_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUW_DTM_TIMESTAMP_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TIMESTAMP_ROLLOVER 0x4200D834
#define IG3_CPUW_GLPE_CPUW_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUW_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG 0x4200D85C
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS 0x4200D860
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPUW_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG 0x4200D81C
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_RSVD1_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_RSVD2_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_MODE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_CPUW_DTM_TRIG_CFG_MODE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_COUNT 0x4200D828
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUW_DTM_TRIG_COUNT_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_MASK 0x4200D824
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_MASK_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUW_DTM_TRIG_MASK_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_PATTERN 0x4200D820
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUW_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_TIMESTAMP 0x4200D82C
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_CPUW_GLPE_CPUW_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_CPUW_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_CPUW_GLPE_CPUW_ECC_COR_ERR 0x4200D8BC
#define IG3_CPUW_GLPE_CPUW_ECC_COR_ERR_RSVD_S 12
#define IG3_CPUW_GLPE_CPUW_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CPUW_GLPE_CPUW_ECC_COR_ERR_RSVD_S)
#define IG3_CPUW_GLPE_CPUW_ECC_COR_ERR_CNT_S 0
#define IG3_CPUW_GLPE_CPUW_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_CPUW_ECC_COR_ERR_CNT_S)
#define IG3_CPUW_GLPE_CPUW_ECC_UNCOR_ERR 0x4200D8B8
#define IG3_CPUW_GLPE_CPUW_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CPUW_GLPE_CPUW_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CPUW_GLPE_CPUW_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CPUW_GLPE_CPUW_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CPUW_GLPE_CPUW_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_CPUW_ECC_UNCOR_ERR_CNT_S)
#define IG3_CPUW_GLPE_CPUW_FLR_TXCMP_MKR_CNT 0x4200D7D8
#define IG3_CPUW_GLPE_CPUW_FLR_TXCMP_MKR_CNT_RSVD_S 6
#define IG3_CPUW_GLPE_CPUW_FLR_TXCMP_MKR_CNT_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_CPUW_GLPE_CPUW_FLR_TXCMP_MKR_CNT_RSVD_S)
#define IG3_CPUW_GLPE_CPUW_FLR_TXCMP_MKR_CNT_MKR_CNT_S 0
#define IG3_CPUW_GLPE_CPUW_FLR_TXCMP_MKR_CNT_MKR_CNT_M RDMA_MASK3(32, 0x3F, IG3_CPUW_GLPE_CPUW_FLR_TXCMP_MKR_CNT_MKR_CNT_S)
#define IG3_CPUW_GLPE_CPU_CONFIG 0x4200D7B4
#define IG3_CPUW_GLPE_CPU_CONFIG_RSVD_S 1
#define IG3_CPUW_GLPE_CPU_CONFIG_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CPUW_GLPE_CPU_CONFIG_RSVD_S)
#define IG3_CPUW_GLPE_CPU_CONFIG_PRIVILEGED_S 0
#define IG3_CPUW_GLPE_CPU_CONFIG_PRIVILEGED_M RDMA_BIT2(32, IG3_CPUW_GLPE_CPU_CONFIG_PRIVILEGED_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG 0x4200D880
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RSVD3_S 20
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RSVD3_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RM_S 16
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RM_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RSVD2_S 14
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RSVD2_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RME_S 12
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RME_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RSVD1_S 10
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RSVD1_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ERR_CNT_S 9
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ERR_CNT_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_FIX_CNT_S 8
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_FIX_CNT_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RSVD0_S 6
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_RSVD0_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_MASK_INT_S 5
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_MASK_INT_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_LS_BYPASS_S 4
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_LS_BYPASS_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_LS_FORCE_S 3
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_LS_FORCE_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ECC_EN_S 0
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_DRAM_MEM_CFG_ECC_EN_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS 0x4200D884
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_RSVD1_S 30
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_RSVD1_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_RSVD0_S 4
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_RSVD0_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_INIT_DONE_S 2
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_INIT_DONE_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_ECC_FIX_S 1
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_ECC_FIX_S)
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_ECC_ERR_S 0
#define IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_DRAM_MEM_STATUS_ECC_ERR_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG 0x4200D888
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RSVD3_S 20
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RSVD3_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RM_S 16
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RM_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RSVD2_S 14
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RSVD2_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RME_S 12
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RME_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RSVD1_S 10
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RSVD1_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ERR_CNT_S 9
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ERR_CNT_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_FIX_CNT_S 8
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_FIX_CNT_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RSVD0_S 6
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_RSVD0_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_MASK_INT_S 5
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_MASK_INT_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_LS_BYPASS_S 4
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_LS_BYPASS_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_LS_FORCE_S 3
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_LS_FORCE_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ECC_EN_S 0
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_IRAM_MEM_CFG_ECC_EN_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS 0x4200D88C
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_RSVD1_S 30
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_RSVD1_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_RSVD0_S 4
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_RSVD0_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_INIT_DONE_S 2
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_INIT_DONE_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_ECC_FIX_S 1
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_ECC_FIX_S)
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_ECC_ERR_S 0
#define IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CPUW_GLPE_CQP_IRAM_MEM_STATUS_ECC_ERR_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG 0x4200D8B0
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RSVD3_S 20
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RSVD3_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RM_S 16
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RM_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RSVD2_S 14
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RSVD2_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RME_S 12
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RME_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RSVD1_S 10
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RSVD1_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ERR_CNT_S 9
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ERR_CNT_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_FIX_CNT_S 8
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_FIX_CNT_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RSVD0_S 6
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_RSVD0_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_MASK_INT_S 5
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_MASK_INT_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_LS_BYPASS_S 4
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_LS_BYPASS_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_LS_FORCE_S 3
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_LS_FORCE_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ECC_EN_S 0
#define IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_CSR_RAM_MEM_CFG_ECC_EN_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS 0x4200D8B4
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_RSVD1_S 30
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_RSVD1_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_RSVD0_S 4
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_RSVD0_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_INIT_DONE_S 2
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_INIT_DONE_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_ECC_FIX_S 1
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_ECC_FIX_S)
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_ECC_ERR_S 0
#define IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CPUW_GLPE_CSR_RAM_MEM_STATUS_ECC_ERR_S)
#define IG3_CPUW_GLPE_DRAIN_MARKER_CNT 0x4200D7BC
#define IG3_CPUW_GLPE_DRAIN_MARKER_CNT_RSVD_S 8
#define IG3_CPUW_GLPE_DRAIN_MARKER_CNT_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CPUW_GLPE_DRAIN_MARKER_CNT_RSVD_S)
#define IG3_CPUW_GLPE_DRAIN_MARKER_CNT_COUNT_S 0
#define IG3_CPUW_GLPE_DRAIN_MARKER_CNT_COUNT_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_DRAIN_MARKER_CNT_COUNT_S)
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG 0x4200D7B8
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_RSVD1_S 16
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_RSVD1_M RDMA_MASK3(32, 0xFFFF, IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_RSVD1_S)
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_FUNCTION_VALID_S 15
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_FUNCTION_VALID_M RDMA_BIT2(32, IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_FUNCTION_VALID_S)
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_HOST_S 12
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_HOST_M RDMA_MASK3(32, 0x7, IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_HOST_S)
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_SRC_PE_DEST_PE_S 10
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_SRC_PE_DEST_PE_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_SRC_PE_DEST_PE_S)
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_PORT_ID_S 8
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_PORT_ID_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_PORT_ID_S)
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_TRAFFIC_CLASS_S 5
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_TRAFFIC_CLASS_M RDMA_MASK3(32, 0x7, IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_TRAFFIC_CLASS_S)
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_PKT_TYPE_S 3
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_PKT_TYPE_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_PKT_TYPE_S)
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_CONTROL_COMMAND_S 2
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_CONTROL_COMMAND_M RDMA_BIT2(32, IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_CONTROL_COMMAND_S)
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_LOOPBACK_S 1
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_LOOPBACK_M RDMA_BIT2(32, IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_LOOPBACK_S)
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_DIRECTION_S 0
#define IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_DIRECTION_M RDMA_BIT2(32, IG3_CPUW_GLPE_DRAIN_MARKER_TRIG_DIRECTION_S)
#define IG3_CPUW_GLPE_FWLD_DATA(_i) 0x4200D648 + ((_i) * 4) /* _i=0...63 */
#define IG3_CPUW_GLPE_FWLD_DATA_MAX_INDEX_I 63
#define IG3_CPUW_GLPE_FWLD_DATA_DATA_S 0
#define IG3_CPUW_GLPE_FWLD_DATA_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_FWLD_DATA_DATA_S)
#define IG3_CPUW_GLPE_FWLD_DATA_LEGACY 0x4200D748
#define IG3_CPUW_GLPE_FWLD_DATA_LEGACY_DATA_S 0
#define IG3_CPUW_GLPE_FWLD_DATA_LEGACY_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_FWLD_DATA_LEGACY_DATA_S)
#define IG3_CPUW_GLPE_FWLD_ENABLE 0x4200D644
#define IG3_CPUW_GLPE_FWLD_ENABLE_RSVD0_S 1
#define IG3_CPUW_GLPE_FWLD_ENABLE_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CPUW_GLPE_FWLD_ENABLE_RSVD0_S)
#define IG3_CPUW_GLPE_FWLD_ENABLE_CPU_ENABLE_S 0
#define IG3_CPUW_GLPE_FWLD_ENABLE_CPU_ENABLE_M RDMA_BIT2(32, IG3_CPUW_GLPE_FWLD_ENABLE_CPU_ENABLE_S)
#define IG3_CPUW_GLPE_FWLD_STATUS 0x4200D640
#define IG3_CPUW_GLPE_FWLD_STATUS_RSVD0_S 2
#define IG3_CPUW_GLPE_FWLD_STATUS_RSVD0_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_CPUW_GLPE_FWLD_STATUS_RSVD0_S)
#define IG3_CPUW_GLPE_FWLD_STATUS_DONE_S 1
#define IG3_CPUW_GLPE_FWLD_STATUS_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_FWLD_STATUS_DONE_S)
#define IG3_CPUW_GLPE_FWLD_STATUS_AUTOLOAD_REQUESTED_S 0
#define IG3_CPUW_GLPE_FWLD_STATUS_AUTOLOAD_REQUESTED_M RDMA_BIT2(32, IG3_CPUW_GLPE_FWLD_STATUS_AUTOLOAD_REQUESTED_S)
#define IG3_CPUW_GLPE_FW_PRODUCT_ID 0x4200D638
#define IG3_CPUW_GLPE_FW_PRODUCT_ID_PROD_ID_S 0
#define IG3_CPUW_GLPE_FW_PRODUCT_ID_PROD_ID_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_FW_PRODUCT_ID_PROD_ID_S)
#define IG3_CPUW_GLPE_FW_REV 0x4200D63C
#define IG3_CPUW_GLPE_FW_REV_MAJOR_REV_S 16
#define IG3_CPUW_GLPE_FW_REV_MAJOR_REV_M RDMA_MASK3(32, 0xFFFF, IG3_CPUW_GLPE_FW_REV_MAJOR_REV_S)
#define IG3_CPUW_GLPE_FW_REV_MINOR_REV_S 0
#define IG3_CPUW_GLPE_FW_REV_MINOR_REV_M RDMA_MASK3(32, 0xFFFF, IG3_CPUW_GLPE_FW_REV_MINOR_REV_S)
#define IG3_CPUW_GLPE_IMCREQ(_i) 0x4200D74C + ((_i) * 4) /* _i=0...7 */
#define IG3_CPUW_GLPE_IMCREQ_MAX_INDEX_I 7
#define IG3_CPUW_GLPE_IMCREQ_PE_IMCREQ_DATA_S 0
#define IG3_CPUW_GLPE_IMCREQ_PE_IMCREQ_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_IMCREQ_PE_IMCREQ_DATA_S)
#define IG3_CPUW_GLPE_IMCRESP(_i) 0x4200D76C + ((_i) * 4) /* _i=0...15 */
#define IG3_CPUW_GLPE_IMCRESP_MAX_INDEX_I 15
#define IG3_CPUW_GLPE_IMCRESP_PE_IMCRESP_DATA_S 0
#define IG3_CPUW_GLPE_IMCRESP_PE_IMCRESP_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_GLPE_IMCRESP_PE_IMCRESP_DATA_S)
#define IG3_CPUW_GLPE_IPF_CONFIG 0x4200D7B0
#define IG3_CPUW_GLPE_IPF_CONFIG_RSVD_S 6
#define IG3_CPUW_GLPE_IPF_CONFIG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_CPUW_GLPE_IPF_CONFIG_RSVD_S)
#define IG3_CPUW_GLPE_IPF_CONFIG_IPF_PF_NUM_S 0
#define IG3_CPUW_GLPE_IPF_CONFIG_IPF_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_CPUW_GLPE_IPF_CONFIG_IPF_PF_NUM_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG 0x4200D8A0
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RSVD3_S 20
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RSVD3_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RM_S 16
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RM_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RSVD2_S 14
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RSVD2_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RME_S 12
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RME_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RSVD1_S 10
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RSVD1_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ERR_CNT_S 9
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ERR_CNT_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_FIX_CNT_S 8
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_FIX_CNT_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RSVD0_S 6
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_RSVD0_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_MASK_INT_S 5
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_MASK_INT_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_LS_BYPASS_S 4
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_LS_BYPASS_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_LS_FORCE_S 3
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_LS_FORCE_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ECC_EN_S 0
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_DRAM_MEM_CFG_ECC_EN_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS 0x4200D8A4
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_RSVD1_S 30
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_RSVD1_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_RSVD0_S 4
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_RSVD0_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_INIT_DONE_S 2
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_INIT_DONE_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_ECC_FIX_S 1
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_ECC_FIX_S)
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_ECC_ERR_S 0
#define IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_DRAM_MEM_STATUS_ECC_ERR_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG 0x4200D8A8
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RSVD3_S 20
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RSVD3_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RM_S 16
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RM_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RSVD2_S 14
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RSVD2_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RME_S 12
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RME_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RSVD1_S 10
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RSVD1_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ERR_CNT_S 9
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ERR_CNT_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_FIX_CNT_S 8
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_FIX_CNT_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RSVD0_S 6
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_RSVD0_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_MASK_INT_S 5
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_MASK_INT_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_LS_BYPASS_S 4
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_LS_BYPASS_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_LS_FORCE_S 3
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_LS_FORCE_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ECC_EN_S 0
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_IRAM_MEM_CFG_ECC_EN_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS 0x4200D8AC
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_RSVD1_S 30
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_RSVD1_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_RSVD0_S 4
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_RSVD0_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_INIT_DONE_S 2
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_INIT_DONE_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_ECC_FIX_S 1
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_ECC_FIX_S)
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_ECC_ERR_S 0
#define IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CPUW_GLPE_OOP_IRAM_MEM_STATUS_ECC_ERR_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG 0x4200D890
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RSVD3_S 20
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RSVD3_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RM_S 16
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RM_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RSVD2_S 14
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RSVD2_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RME_S 12
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RME_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RSVD1_S 10
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RSVD1_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ERR_CNT_S 9
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ERR_CNT_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_FIX_CNT_S 8
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_FIX_CNT_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RSVD0_S 6
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_RSVD0_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_MASK_INT_S 5
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_MASK_INT_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_LS_BYPASS_S 4
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_LS_BYPASS_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_LS_FORCE_S 3
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_LS_FORCE_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ECC_EN_S 0
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_DRAM_MEM_CFG_ECC_EN_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS 0x4200D894
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_RSVD1_S 30
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_RSVD1_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_RSVD0_S 4
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_RSVD0_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_INIT_DONE_S 2
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_INIT_DONE_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_ECC_FIX_S 1
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_ECC_FIX_S)
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_ECC_ERR_S 0
#define IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_DRAM_MEM_STATUS_ECC_ERR_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG 0x4200D898
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RSVD3_S 20
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RSVD3_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RM_S 16
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RM_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RSVD2_S 14
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RSVD2_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RME_S 12
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RME_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RSVD1_S 10
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RSVD1_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ERR_CNT_S 9
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ERR_CNT_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_FIX_CNT_S 8
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_FIX_CNT_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RSVD0_S 6
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_RSVD0_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_MASK_INT_S 5
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_MASK_INT_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_LS_BYPASS_S 4
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_LS_BYPASS_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_LS_FORCE_S 3
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_LS_FORCE_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ECC_EN_S 0
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_IRAM_MEM_CFG_ECC_EN_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS 0x4200D89C
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_RSVD1_S 30
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_RSVD1_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_RSVD0_S 4
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_RSVD0_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_INIT_DONE_S 2
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_INIT_DONE_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_ECC_FIX_S 1
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_ECC_FIX_S)
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_ECC_ERR_S 0
#define IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CPUW_GLPE_TEP_IRAM_MEM_STATUS_ECC_ERR_S)
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS 0x4200D7CC
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_DONE_S 31
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_DONE_S)
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_RSVD1_S 27
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_RSVD1_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_RSVD1_S)
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_PORT_NUM_S 24
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_PORT_NUM_M RDMA_MASK3(32, 0x7, IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_PORT_NUM_S)
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_RSVD0_S 20
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_RSVD0_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_RSVD0_S)
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_FUNC_TYPE_S 18
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_FUNC_TYPE_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_FUNC_TYPE_S)
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_FUNC_NUM_S 6
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_FUNC_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_FUNC_NUM_S)
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_PHY_FUNC_S 0
#define IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_PHY_FUNC_M RDMA_MASK3(32, 0x3F, IG3_CPUW_GLPE_XLR_CLNCACHE_STATUS_PHY_FUNC_S)
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG 0x4200D7C8
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_BUSY_S 31
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_BUSY_M RDMA_BIT2(32, IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_BUSY_S)
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_RSVD1_S 27
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_RSVD1_S)
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_PORT_NUM_S 24
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_PORT_NUM_M RDMA_MASK3(32, 0x7, IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_PORT_NUM_S)
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_RSVD0_S 20
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_RSVD0_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_RSVD0_S)
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_FUNC_TYPE_S 18
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_FUNC_TYPE_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_FUNC_TYPE_S)
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_FUNC_NUM_S 6
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_FUNC_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_FUNC_NUM_S)
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_PHY_FUNC_S 0
#define IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_PHY_FUNC_M RDMA_MASK3(32, 0x3F, IG3_CPUW_GLPE_XLR_CLNCACHE_TRIG_PHY_FUNC_S)
#define IG3_CPUW_GLPE_XLR_OOP_REQ 0x4200D7E0
#define IG3_CPUW_GLPE_XLR_OOP_REQ_BUSY_S 31
#define IG3_CPUW_GLPE_XLR_OOP_REQ_BUSY_M RDMA_BIT2(32, IG3_CPUW_GLPE_XLR_OOP_REQ_BUSY_S)
#define IG3_CPUW_GLPE_XLR_OOP_REQ_OP_S 30
#define IG3_CPUW_GLPE_XLR_OOP_REQ_OP_M RDMA_BIT2(32, IG3_CPUW_GLPE_XLR_OOP_REQ_OP_S)
#define IG3_CPUW_GLPE_XLR_OOP_REQ_RSVD_S 20
#define IG3_CPUW_GLPE_XLR_OOP_REQ_RSVD_M RDMA_MASK3(32, 0x3FF, IG3_CPUW_GLPE_XLR_OOP_REQ_RSVD_S)
#define IG3_CPUW_GLPE_XLR_OOP_REQ_VDEV_VF_TYPE_S 18
#define IG3_CPUW_GLPE_XLR_OOP_REQ_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_XLR_OOP_REQ_VDEV_VF_TYPE_S)
#define IG3_CPUW_GLPE_XLR_OOP_REQ_VDEV_VF_NUM_S 6
#define IG3_CPUW_GLPE_XLR_OOP_REQ_VDEV_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_XLR_OOP_REQ_VDEV_VF_NUM_S)
#define IG3_CPUW_GLPE_XLR_OOP_REQ_PF_NUM_S 0
#define IG3_CPUW_GLPE_XLR_OOP_REQ_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_CPUW_GLPE_XLR_OOP_REQ_PF_NUM_S)
#define IG3_CPUW_GLPE_XLR_POST 0x4200D7D0
#define IG3_CPUW_GLPE_XLR_POST_BUSY_S 31
#define IG3_CPUW_GLPE_XLR_POST_BUSY_M RDMA_BIT2(32, IG3_CPUW_GLPE_XLR_POST_BUSY_S)
#define IG3_CPUW_GLPE_XLR_POST_RSVD1_S 27
#define IG3_CPUW_GLPE_XLR_POST_RSVD1_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_XLR_POST_RSVD1_S)
#define IG3_CPUW_GLPE_XLR_POST_PORT_NUM_S 24
#define IG3_CPUW_GLPE_XLR_POST_PORT_NUM_M RDMA_MASK3(32, 0x7, IG3_CPUW_GLPE_XLR_POST_PORT_NUM_S)
#define IG3_CPUW_GLPE_XLR_POST_RSVD0_S 20
#define IG3_CPUW_GLPE_XLR_POST_RSVD0_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_XLR_POST_RSVD0_S)
#define IG3_CPUW_GLPE_XLR_POST_FUNC_TYPE_S 18
#define IG3_CPUW_GLPE_XLR_POST_FUNC_TYPE_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_XLR_POST_FUNC_TYPE_S)
#define IG3_CPUW_GLPE_XLR_POST_FUNC_NUM_S 6
#define IG3_CPUW_GLPE_XLR_POST_FUNC_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_XLR_POST_FUNC_NUM_S)
#define IG3_CPUW_GLPE_XLR_POST_PHY_FUNC_S 0
#define IG3_CPUW_GLPE_XLR_POST_PHY_FUNC_M RDMA_MASK3(32, 0x3F, IG3_CPUW_GLPE_XLR_POST_PHY_FUNC_S)
#define IG3_CPUW_GLPE_XLR_POST_STATUS 0x4200D7D4
#define IG3_CPUW_GLPE_XLR_POST_STATUS_DONE_S 31
#define IG3_CPUW_GLPE_XLR_POST_STATUS_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_XLR_POST_STATUS_DONE_S)
#define IG3_CPUW_GLPE_XLR_POST_STATUS_RSVD1_S 27
#define IG3_CPUW_GLPE_XLR_POST_STATUS_RSVD1_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_XLR_POST_STATUS_RSVD1_S)
#define IG3_CPUW_GLPE_XLR_POST_STATUS_PORT_NUM_S 24
#define IG3_CPUW_GLPE_XLR_POST_STATUS_PORT_NUM_M RDMA_MASK3(32, 0x7, IG3_CPUW_GLPE_XLR_POST_STATUS_PORT_NUM_S)
#define IG3_CPUW_GLPE_XLR_POST_STATUS_RSVD0_S 20
#define IG3_CPUW_GLPE_XLR_POST_STATUS_RSVD0_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_XLR_POST_STATUS_RSVD0_S)
#define IG3_CPUW_GLPE_XLR_POST_STATUS_FUNC_TYPE_S 18
#define IG3_CPUW_GLPE_XLR_POST_STATUS_FUNC_TYPE_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_XLR_POST_STATUS_FUNC_TYPE_S)
#define IG3_CPUW_GLPE_XLR_POST_STATUS_FUNC_NUM_S 6
#define IG3_CPUW_GLPE_XLR_POST_STATUS_FUNC_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_XLR_POST_STATUS_FUNC_NUM_S)
#define IG3_CPUW_GLPE_XLR_POST_STATUS_PHY_FUNC_S 0
#define IG3_CPUW_GLPE_XLR_POST_STATUS_PHY_FUNC_M RDMA_MASK3(32, 0x3F, IG3_CPUW_GLPE_XLR_POST_STATUS_PHY_FUNC_S)
#define IG3_CPUW_GLPE_XLR_STP_FUNC 0x4200D7C0
#define IG3_CPUW_GLPE_XLR_STP_FUNC_BUSY_S 31
#define IG3_CPUW_GLPE_XLR_STP_FUNC_BUSY_M RDMA_BIT2(32, IG3_CPUW_GLPE_XLR_STP_FUNC_BUSY_S)
#define IG3_CPUW_GLPE_XLR_STP_FUNC_RSVD1_S 27
#define IG3_CPUW_GLPE_XLR_STP_FUNC_RSVD1_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_XLR_STP_FUNC_RSVD1_S)
#define IG3_CPUW_GLPE_XLR_STP_FUNC_PORT_NUM_S 24
#define IG3_CPUW_GLPE_XLR_STP_FUNC_PORT_NUM_M RDMA_MASK3(32, 0x7, IG3_CPUW_GLPE_XLR_STP_FUNC_PORT_NUM_S)
#define IG3_CPUW_GLPE_XLR_STP_FUNC_RSVD0_S 20
#define IG3_CPUW_GLPE_XLR_STP_FUNC_RSVD0_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_XLR_STP_FUNC_RSVD0_S)
#define IG3_CPUW_GLPE_XLR_STP_FUNC_FUNC_TYPE_S 18
#define IG3_CPUW_GLPE_XLR_STP_FUNC_FUNC_TYPE_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_XLR_STP_FUNC_FUNC_TYPE_S)
#define IG3_CPUW_GLPE_XLR_STP_FUNC_FUNC_NUM_S 6
#define IG3_CPUW_GLPE_XLR_STP_FUNC_FUNC_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_XLR_STP_FUNC_FUNC_NUM_S)
#define IG3_CPUW_GLPE_XLR_STP_FUNC_PHY_FUNC_S 0
#define IG3_CPUW_GLPE_XLR_STP_FUNC_PHY_FUNC_M RDMA_MASK3(32, 0x3F, IG3_CPUW_GLPE_XLR_STP_FUNC_PHY_FUNC_S)
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS 0x4200D7C4
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_DONE_S 31
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_DONE_M RDMA_BIT2(32, IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_DONE_S)
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_RSVD1_S 27
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_RSVD1_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_RSVD1_S)
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_PORT_NUM_S 24
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_PORT_NUM_M RDMA_MASK3(32, 0x7, IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_PORT_NUM_S)
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_RSVD0_S 20
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_RSVD0_M RDMA_MASK3(32, 0xF, IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_RSVD0_S)
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_FUNC_TYPE_S 18
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_FUNC_TYPE_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_FUNC_TYPE_S)
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_FUNC_NUM_S 6
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_FUNC_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_FUNC_NUM_S)
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_PHY_FUNC_S 0
#define IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_PHY_FUNC_M RDMA_MASK3(32, 0x3F, IG3_CPUW_GLPE_XLR_STP_FUNC_STATUS_PHY_FUNC_S)
#define IG3_CPUW_GLPE_XLR_TEP_REQ 0x4200D7DC
#define IG3_CPUW_GLPE_XLR_TEP_REQ_BUSY_S 31
#define IG3_CPUW_GLPE_XLR_TEP_REQ_BUSY_M RDMA_BIT2(32, IG3_CPUW_GLPE_XLR_TEP_REQ_BUSY_S)
#define IG3_CPUW_GLPE_XLR_TEP_REQ_OP_S 30
#define IG3_CPUW_GLPE_XLR_TEP_REQ_OP_M RDMA_BIT2(32, IG3_CPUW_GLPE_XLR_TEP_REQ_OP_S)
#define IG3_CPUW_GLPE_XLR_TEP_REQ_RSVD_S 20
#define IG3_CPUW_GLPE_XLR_TEP_REQ_RSVD_M RDMA_MASK3(32, 0x3FF, IG3_CPUW_GLPE_XLR_TEP_REQ_RSVD_S)
#define IG3_CPUW_GLPE_XLR_TEP_REQ_VDEV_VF_TYPE_S 18
#define IG3_CPUW_GLPE_XLR_TEP_REQ_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_CPUW_GLPE_XLR_TEP_REQ_VDEV_VF_TYPE_S)
#define IG3_CPUW_GLPE_XLR_TEP_REQ_VDEV_VF_NUM_S 6
#define IG3_CPUW_GLPE_XLR_TEP_REQ_VDEV_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_GLPE_XLR_TEP_REQ_VDEV_VF_NUM_S)
#define IG3_CPUW_GLPE_XLR_TEP_REQ_PF_NUM_S 0
#define IG3_CPUW_GLPE_XLR_TEP_REQ_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_CPUW_GLPE_XLR_TEP_REQ_PF_NUM_S)
#define IG3_CPUW_PMFPE_CCQPEXTSTATUS(_i) 0x42002000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_CPUW_PMFPE_CCQPEXTSTATUS_MAX_INDEX_I 1031
#define IG3_CPUW_PMFPE_CCQPEXTSTATUS_RSVD_S 16
#define IG3_CPUW_PMFPE_CCQPEXTSTATUS_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_CPUW_PMFPE_CCQPEXTSTATUS_RSVD_S)
#define IG3_CPUW_PMFPE_CCQPEXTSTATUS_DBPT_INDEX_S 0
#define IG3_CPUW_PMFPE_CCQPEXTSTATUS_DBPT_INDEX_M RDMA_MASK3(32, 0xFFFF, IG3_CPUW_PMFPE_CCQPEXTSTATUS_DBPT_INDEX_S)
#define IG3_CPUW_PMFPE_CCQPHIGH(_i) 0x42006000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_CPUW_PMFPE_CCQPHIGH_MAX_INDEX_I 1031
#define IG3_CPUW_PMFPE_CCQPHIGH_PECCQPHIGH_S 0
#define IG3_CPUW_PMFPE_CCQPHIGH_PECCQPHIGH_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_PMFPE_CCQPHIGH_PECCQPHIGH_S)
#define IG3_CPUW_PMFPE_CCQPLOW(_i) 0x42004000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_CPUW_PMFPE_CCQPLOW_MAX_INDEX_I 1031
#define IG3_CPUW_PMFPE_CCQPLOW_PECCQPLOW_S 0
#define IG3_CPUW_PMFPE_CCQPLOW_PECCQPLOW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CPUW_PMFPE_CCQPLOW_PECCQPLOW_S)
#define IG3_CPUW_PMFPE_CCQPSTATUS(_i) 0x42000000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_CPUW_PMFPE_CCQPSTATUS_MAX_INDEX_I 1031
#define IG3_CPUW_PMFPE_CCQPSTATUS_CCQP_ERR_S 31
#define IG3_CPUW_PMFPE_CCQPSTATUS_CCQP_ERR_M RDMA_BIT2(32, IG3_CPUW_PMFPE_CCQPSTATUS_CCQP_ERR_S)
#define IG3_CPUW_PMFPE_CCQPSTATUS_RSVD2_S 28
#define IG3_CPUW_PMFPE_CCQPSTATUS_RSVD2_M RDMA_MASK3(32, 0x7, IG3_CPUW_PMFPE_CCQPSTATUS_RSVD2_S)
#define IG3_CPUW_PMFPE_CCQPSTATUS_RDMA_EN_VFS_S 16
#define IG3_CPUW_PMFPE_CCQPSTATUS_RDMA_EN_VFS_M RDMA_MASK3(32, 0xFFF, IG3_CPUW_PMFPE_CCQPSTATUS_RDMA_EN_VFS_S)
#define IG3_CPUW_PMFPE_CCQPSTATUS_RSVD1_S 7
#define IG3_CPUW_PMFPE_CCQPSTATUS_RSVD1_M RDMA_MASK3(32, 0x1FF, IG3_CPUW_PMFPE_CCQPSTATUS_RSVD1_S)
#define IG3_CPUW_PMFPE_CCQPSTATUS_HMC_PROFILE_S 4
#define IG3_CPUW_PMFPE_CCQPSTATUS_HMC_PROFILE_M RDMA_MASK3(32, 0x7, IG3_CPUW_PMFPE_CCQPSTATUS_HMC_PROFILE_S)
#define IG3_CPUW_PMFPE_CCQPSTATUS_RSVD0_S 1
#define IG3_CPUW_PMFPE_CCQPSTATUS_RSVD0_M RDMA_MASK3(32, 0x7, IG3_CPUW_PMFPE_CCQPSTATUS_RSVD0_S)
#define IG3_CPUW_PMFPE_CCQPSTATUS_CCQP_DONE_S 0
#define IG3_CPUW_PMFPE_CCQPSTATUS_CCQP_DONE_M RDMA_BIT2(32, IG3_CPUW_PMFPE_CCQPSTATUS_CCQP_DONE_S)
#define IG3_CPUW_PMFPE_CQPDB(_i) 0x4200A000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_CPUW_PMFPE_CQPDB_MAX_INDEX_I 1031
#define IG3_CPUW_PMFPE_CQPDB_RSVD_S 11
#define IG3_CPUW_PMFPE_CQPDB_RSVD_M RDMA_MASK3(32, 0x1FFFFF, IG3_CPUW_PMFPE_CQPDB_RSVD_S)
#define IG3_CPUW_PMFPE_CQPDB_WQHEAD_S 0
#define IG3_CPUW_PMFPE_CQPDB_WQHEAD_M RDMA_MASK3(32, 0x7FF, IG3_CPUW_PMFPE_CQPDB_WQHEAD_S)
#define IG3_CPUW_PMFPE_CQPERRCODES(_i) 0x42008000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_CPUW_PMFPE_CQPERRCODES_MAX_INDEX_I 1031
#define IG3_CPUW_PMFPE_CQPERRCODES_CQP_MAJOR_CODE_S 16
#define IG3_CPUW_PMFPE_CQPERRCODES_CQP_MAJOR_CODE_M RDMA_MASK3(32, 0xFFFF, IG3_CPUW_PMFPE_CQPERRCODES_CQP_MAJOR_CODE_S)
#define IG3_CPUW_PMFPE_CQPERRCODES_CQP_MINOR_CODE_S 0
#define IG3_CPUW_PMFPE_CQPERRCODES_CQP_MINOR_CODE_M RDMA_MASK3(32, 0xFFFF, IG3_CPUW_PMFPE_CQPERRCODES_CQP_MINOR_CODE_S)
#define IG3_CPUW_PMFPE_CQPTAIL(_i) 0x4200C000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_CPUW_PMFPE_CQPTAIL_MAX_INDEX_I 1031
#define IG3_CPUW_PMFPE_CQPTAIL_CQP_OP_ERR_S 31
#define IG3_CPUW_PMFPE_CQPTAIL_CQP_OP_ERR_M RDMA_BIT2(32, IG3_CPUW_PMFPE_CQPTAIL_CQP_OP_ERR_S)
#define IG3_CPUW_PMFPE_CQPTAIL_RSVD_S 11
#define IG3_CPUW_PMFPE_CQPTAIL_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CPUW_PMFPE_CQPTAIL_RSVD_S)
#define IG3_CPUW_PMFPE_CQPTAIL_WQTAIL_S 0
#define IG3_CPUW_PMFPE_CQPTAIL_WQTAIL_M RDMA_MASK3(32, 0x7FF, IG3_CPUW_PMFPE_CQPTAIL_WQTAIL_S)
#define IG3_CPUW_RDMA_FUSE 0x4200D7E4
#define IG3_CPUW_RDMA_FUSE_RSVD_S 16
#define IG3_CPUW_RDMA_FUSE_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_CPUW_RDMA_FUSE_RSVD_S)
#define IG3_CPUW_RDMA_FUSE_RDMA_ASO_ENABLE_S 8
#define IG3_CPUW_RDMA_FUSE_RDMA_ASO_ENABLE_M RDMA_MASK3(32, 0xFF, IG3_CPUW_RDMA_FUSE_RDMA_ASO_ENABLE_S)
#define IG3_CPUW_RDMA_FUSE_RDMA_RESERVED_S 7
#define IG3_CPUW_RDMA_FUSE_RDMA_RESERVED_M RDMA_BIT2(32, IG3_CPUW_RDMA_FUSE_RDMA_RESERVED_S)
#define IG3_CPUW_RDMA_FUSE_RDMA_SWFWLD_DISABLE_S 6
#define IG3_CPUW_RDMA_FUSE_RDMA_SWFWLD_DISABLE_M RDMA_BIT2(32, IG3_CPUW_RDMA_FUSE_RDMA_SWFWLD_DISABLE_S)
#define IG3_CPUW_RDMA_FUSE_RDMA_CRT_DISABLE_S 5
#define IG3_CPUW_RDMA_FUSE_RDMA_CRT_DISABLE_M RDMA_BIT2(32, IG3_CPUW_RDMA_FUSE_RDMA_CRT_DISABLE_S)
#define IG3_CPUW_RDMA_FUSE_RDMA_TILECLK_DISABLE_S 0
#define IG3_CPUW_RDMA_FUSE_RDMA_TILECLK_DISABLE_M RDMA_MASK3(32, 0x1F, IG3_CPUW_RDMA_FUSE_RDMA_TILECLK_DISABLE_S)
#define IG3_FLM_GLHMC_PEOOISCFFLCNT_PE(_i) 0x42086000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_FLM_GLHMC_PEOOISCFFLCNT_PE_MAX_INDEX_I 1031
#define IG3_FLM_GLHMC_PEOOISCFFLCNT_PE_RSVD_S 29
#define IG3_FLM_GLHMC_PEOOISCFFLCNT_PE_RSVD_M RDMA_MASK3(32, 0x7, IG3_FLM_GLHMC_PEOOISCFFLCNT_PE_RSVD_S)
#define IG3_FLM_GLHMC_PEOOISCFFLCNT_PE_FPMPEOOISCFFLCNT_S 0
#define IG3_FLM_GLHMC_PEOOISCFFLCNT_PE_FPMPEOOISCFFLCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_FLM_GLHMC_PEOOISCFFLCNT_PE_FPMPEOOISCFFLCNT_S)
#define IG3_FLM_GLHMC_PEQ1FLCNT_PE(_i) 0x42082000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_FLM_GLHMC_PEQ1FLCNT_PE_MAX_INDEX_I 1031
#define IG3_FLM_GLHMC_PEQ1FLCNT_PE_RSVD_S 29
#define IG3_FLM_GLHMC_PEQ1FLCNT_PE_RSVD_M RDMA_MASK3(32, 0x7, IG3_FLM_GLHMC_PEQ1FLCNT_PE_RSVD_S)
#define IG3_FLM_GLHMC_PEQ1FLCNT_PE_FPMPEQ1FLCNT_S 0
#define IG3_FLM_GLHMC_PEQ1FLCNT_PE_FPMPEQ1FLCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_FLM_GLHMC_PEQ1FLCNT_PE_FPMPEQ1FLCNT_S)
#define IG3_FLM_GLHMC_PERRFFLCNT_PE(_i) 0x42084000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_FLM_GLHMC_PERRFFLCNT_PE_MAX_INDEX_I 1031
#define IG3_FLM_GLHMC_PERRFFLCNT_PE_RSVD_S 29
#define IG3_FLM_GLHMC_PERRFFLCNT_PE_RSVD_M RDMA_MASK3(32, 0x7, IG3_FLM_GLHMC_PERRFFLCNT_PE_RSVD_S)
#define IG3_FLM_GLHMC_PERRFFLCNT_PE_FPMPERRFFLCNT_S 0
#define IG3_FLM_GLHMC_PERRFFLCNT_PE_FPMPERRFFLCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_FLM_GLHMC_PERRFFLCNT_PE_FPMPERRFFLCNT_S)
#define IG3_FLM_GLHMC_PEXFFLCNT_PE(_i) 0x42080000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_FLM_GLHMC_PEXFFLCNT_PE_MAX_INDEX_I 1031
#define IG3_FLM_GLHMC_PEXFFLCNT_PE_RSVD_S 29
#define IG3_FLM_GLHMC_PEXFFLCNT_PE_RSVD_M RDMA_MASK3(32, 0x7, IG3_FLM_GLHMC_PEXFFLCNT_PE_RSVD_S)
#define IG3_FLM_GLHMC_PEXFFLCNT_PE_FPMPEXFFLCNT_S 0
#define IG3_FLM_GLHMC_PEXFFLCNT_PE_FPMPEXFFLCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_FLM_GLHMC_PEXFFLCNT_PE_FPMPEXFFLCNT_S)
#define IG3_FLM_GLPE_FLMCTRL0 0x42090000
#define IG3_FLM_GLPE_FLMCTRL0_DISABLE_S 31
#define IG3_FLM_GLPE_FLMCTRL0_DISABLE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLMCTRL0_DISABLE_S)
#define IG3_FLM_GLPE_FLMCTRL0_RSVD2_S 20
#define IG3_FLM_GLPE_FLMCTRL0_RSVD2_M RDMA_MASK3(32, 0x7FF, IG3_FLM_GLPE_FLMCTRL0_RSVD2_S)
#define IG3_FLM_GLPE_FLMCTRL0_PMF_S 8
#define IG3_FLM_GLPE_FLMCTRL0_PMF_M RDMA_MASK3(32, 0xFFF, IG3_FLM_GLPE_FLMCTRL0_PMF_S)
#define IG3_FLM_GLPE_FLMCTRL0_RSVD1_S 6
#define IG3_FLM_GLPE_FLMCTRL0_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLMCTRL0_RSVD1_S)
#define IG3_FLM_GLPE_FLMCTRL0_FLIST_S 4
#define IG3_FLM_GLPE_FLMCTRL0_FLIST_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLMCTRL0_FLIST_S)
#define IG3_FLM_GLPE_FLMCTRL0_RSVD0_S 3
#define IG3_FLM_GLPE_FLMCTRL0_RSVD0_M RDMA_BIT2(32, IG3_FLM_GLPE_FLMCTRL0_RSVD0_S)
#define IG3_FLM_GLPE_FLMCTRL0_OPCODE_S 0
#define IG3_FLM_GLPE_FLMCTRL0_OPCODE_M RDMA_MASK3(32, 0x7, IG3_FLM_GLPE_FLMCTRL0_OPCODE_S)
#define IG3_FLM_GLPE_FLMCTRL1 0x42090004
#define IG3_FLM_GLPE_FLMCTRL1_RSVD_S 20
#define IG3_FLM_GLPE_FLMCTRL1_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_FLM_GLPE_FLMCTRL1_RSVD_S)
#define IG3_FLM_GLPE_FLMCTRL1_VDEV_VF_TYPE_S 18
#define IG3_FLM_GLPE_FLMCTRL1_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLMCTRL1_VDEV_VF_TYPE_S)
#define IG3_FLM_GLPE_FLMCTRL1_VDEV_VF_NUM_S 6
#define IG3_FLM_GLPE_FLMCTRL1_VDEV_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_FLM_GLPE_FLMCTRL1_VDEV_VF_NUM_S)
#define IG3_FLM_GLPE_FLMCTRL1_PF_NUM_S 0
#define IG3_FLM_GLPE_FLMCTRL1_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_FLM_GLPE_FLMCTRL1_PF_NUM_S)
#define IG3_FLM_GLPE_FLMPTR 0x4209000C
#define IG3_FLM_GLPE_FLMPTR_RSVD_S 28
#define IG3_FLM_GLPE_FLMPTR_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLM_GLPE_FLMPTR_RSVD_S)
#define IG3_FLM_GLPE_FLMPTR_PEFLMPTR_S 0
#define IG3_FLM_GLPE_FLMPTR_PEFLMPTR_M RDMA_MASK3(32, 0xFFFFFFF, IG3_FLM_GLPE_FLMPTR_PEFLMPTR_S)
#define IG3_FLM_GLPE_FLMPTRHEAD 0x42090014
#define IG3_FLM_GLPE_FLMPTRHEAD_RSVD_S 28
#define IG3_FLM_GLPE_FLMPTRHEAD_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLM_GLPE_FLMPTRHEAD_RSVD_S)
#define IG3_FLM_GLPE_FLMPTRHEAD_PTR_S 0
#define IG3_FLM_GLPE_FLMPTRHEAD_PTR_M RDMA_MASK3(32, 0xFFFFFFF, IG3_FLM_GLPE_FLMPTRHEAD_PTR_S)
#define IG3_FLM_GLPE_FLMPTRHEADMAX 0x42090018
#define IG3_FLM_GLPE_FLMPTRHEADMAX_RSVD_S 28
#define IG3_FLM_GLPE_FLMPTRHEADMAX_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLM_GLPE_FLMPTRHEADMAX_RSVD_S)
#define IG3_FLM_GLPE_FLMPTRHEADMAX_PTR_S 0
#define IG3_FLM_GLPE_FLMPTRHEADMAX_PTR_M RDMA_MASK3(32, 0xFFFFFFF, IG3_FLM_GLPE_FLMPTRHEADMAX_PTR_S)
#define IG3_FLM_GLPE_FLMPTRTAIL 0x42090010
#define IG3_FLM_GLPE_FLMPTRTAIL_RSVD_S 28
#define IG3_FLM_GLPE_FLMPTRTAIL_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLM_GLPE_FLMPTRTAIL_RSVD_S)
#define IG3_FLM_GLPE_FLMPTRTAIL_PTR_S 0
#define IG3_FLM_GLPE_FLMPTRTAIL_PTR_M RDMA_MASK3(32, 0xFFFFFFF, IG3_FLM_GLPE_FLMPTRTAIL_PTR_S)
#define IG3_FLM_GLPE_FLMSTATUS 0x42090008
#define IG3_FLM_GLPE_FLMSTATUS_BUSY_S 31
#define IG3_FLM_GLPE_FLMSTATUS_BUSY_M RDMA_BIT2(32, IG3_FLM_GLPE_FLMSTATUS_BUSY_S)
#define IG3_FLM_GLPE_FLMSTATUS_RSVD_S 4
#define IG3_FLM_GLPE_FLMSTATUS_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_FLM_GLPE_FLMSTATUS_RSVD_S)
#define IG3_FLM_GLPE_FLMSTATUS_STATUS_S 0
#define IG3_FLM_GLPE_FLMSTATUS_STATUS_M RDMA_MASK3(32, 0xF, IG3_FLM_GLPE_FLMSTATUS_STATUS_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG 0x42090040
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RSVD3_S 20
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RSVD3_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RM_S 16
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RM_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RSVD2_S 14
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RSVD2_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RME_S 12
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RME_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RSVD1_S 10
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RSVD1_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ERR_CNT_S 9
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ERR_CNT_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_FIX_CNT_S 8
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_FIX_CNT_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RSVD0_S 6
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_RSVD0_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_MASK_INT_S 5
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_MASK_INT_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_LS_BYPASS_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_LS_FORCE_S 3
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_LS_FORCE_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ECC_EN_S 0
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_CFG_ECC_EN_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS 0x42090044
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_RSVD1_S 30
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_RSVD1_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_RSVD0_S 4
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_RSVD0_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_INIT_DONE_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_ECC_FIX_S)
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_CNT_MEM_STATUS_ECC_ERR_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG 0x42090048
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RSVD3_S 20
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RSVD3_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RM_S 16
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RM_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RSVD2_S 14
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RSVD2_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RME_S 12
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RME_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RSVD1_S 10
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RSVD1_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ERR_CNT_S 9
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ERR_CNT_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_FIX_CNT_S 8
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_FIX_CNT_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RSVD0_S 6
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_RSVD0_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_MASK_INT_S 5
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_MASK_INT_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_LS_BYPASS_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_LS_FORCE_S 3
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_LS_FORCE_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ECC_EN_S 0
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_CFG_ECC_EN_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS 0x4209004C
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_RSVD1_S 30
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_RSVD1_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_RSVD0_S 4
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_RSVD0_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_INIT_DONE_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_ECC_FIX_S)
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_CSR_ERR_MEM_STATUS_ECC_ERR_S)
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_COUNT 0x420900B8
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_FLM_GLPE_FLM_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_FLM_GLPE_FLM_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_CMD 0x420900CC
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_DATA_H 0x420900D8
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_DATA_L 0x420900D4
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_PTR 0x420900D0
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_FLM_GLPE_FLM_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_CMD 0x420900BC
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_DATA_H 0x420900C8
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_DATA_L 0x420900C4
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_PTR 0x420900C0
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_FLM_GLPE_FLM_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_CONTROL 0x42090080
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_RSVD1_S 25
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_FLM_GLPE_FLM_DTM_CONTROL_RSVD1_S)
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_RSVD2_S 17
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_FLM_GLPE_FLM_DTM_CONTROL_RSVD2_S)
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_RSVD3_S 9
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_FLM_GLPE_FLM_DTM_CONTROL_RSVD3_S)
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_BYPASS_S 8
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_CONTROL_BYPASS_S)
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_RSVD4_S 1
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_FLM_GLPE_FLM_DTM_CONTROL_RSVD4_S)
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_FLM_GLPE_FLM_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_CONTROL_LOCAL_EN_S)
#define IG3_FLM_GLPE_FLM_DTM_ECC_COR_ERR 0x420900E8
#define IG3_FLM_GLPE_FLM_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_FLM_GLPE_FLM_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_FLM_GLPE_FLM_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_FLM_GLPE_FLM_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_FLM_GLPE_FLM_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_FLM_GLPE_FLM_DTM_ECC_COR_ERR_CNT_S)
#define IG3_FLM_GLPE_FLM_DTM_ECC_UNCOR_ERR 0x420900E4
#define IG3_FLM_GLPE_FLM_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_FLM_GLPE_FLM_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_FLM_GLPE_FLM_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_FLM_GLPE_FLM_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_FLM_GLPE_FLM_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_FLM_GLPE_FLM_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_FLM_GLPE_FLM_DTM_GROUP_CFG 0x4209008C
#define IG3_FLM_GLPE_FLM_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_FLM_GLPE_FLM_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_FLM_GLPE_FLM_DTM_GROUP_CFG_RSVD1_S)
#define IG3_FLM_GLPE_FLM_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_FLM_GLPE_FLM_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_FLM_GLPE_FLM_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_FLM_GLPE_FLM_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_FLM_GLPE_FLM_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_FLM_GLPE_FLM_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_FLM_GLPE_FLM_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_FLM_GLPE_FLM_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_FLM_GLPE_FLM_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_FLM_GLPE_FLM_DTM_LOG_CFG 0x42090090
#define IG3_FLM_GLPE_FLM_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_FLM_GLPE_FLM_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_FLM_GLPE_FLM_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_FLM_GLPE_FLM_DTM_LOG_CFG_RSVD1_S 2
#define IG3_FLM_GLPE_FLM_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_FLM_GLPE_FLM_DTM_LOG_CFG_RSVD1_S)
#define IG3_FLM_GLPE_FLM_DTM_LOG_CFG_MODE_S 0
#define IG3_FLM_GLPE_FLM_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_DTM_LOG_CFG_MODE_S)
#define IG3_FLM_GLPE_FLM_DTM_LOG_MASK 0x42090098
#define IG3_FLM_GLPE_FLM_DTM_LOG_MASK_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLM_GLPE_FLM_DTM_LOG_MASK_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_LOG_PATTERN 0x42090094
#define IG3_FLM_GLPE_FLM_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLM_GLPE_FLM_DTM_LOG_PATTERN_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_MAIN_CFG 0x42090084
#define IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_RSVD1_S)
#define IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_RSVD2_S)
#define IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_RSVD3_S)
#define IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_FLM_GLPE_FLM_DTM_MAIN_STS 0x42090088
#define IG3_FLM_GLPE_FLM_DTM_MAIN_STS_RSVD1_S 9
#define IG3_FLM_GLPE_FLM_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_FLM_GLPE_FLM_DTM_MAIN_STS_RSVD1_S)
#define IG3_FLM_GLPE_FLM_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_FLM_GLPE_FLM_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_FLM_GLPE_FLM_DTM_MAIN_STS_RSVD2_S 1
#define IG3_FLM_GLPE_FLM_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_FLM_GLPE_FLM_DTM_MAIN_STS_RSVD2_S)
#define IG3_FLM_GLPE_FLM_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_FLM_GLPE_FLM_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_FLM_GLPE_FLM_DTM_TIMESTAMP 0x420900B0
#define IG3_FLM_GLPE_FLM_DTM_TIMESTAMP_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLM_GLPE_FLM_DTM_TIMESTAMP_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_TIMESTAMP_ROLLOVER 0x420900B4
#define IG3_FLM_GLPE_FLM_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLM_GLPE_FLM_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG 0x420900DC
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS 0x420900E0
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_FLM_GLPE_FLM_DTM_TRIG_CFG 0x4209009C
#define IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_RSVD1_S)
#define IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_RSVD2_S)
#define IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_MODE_S 0
#define IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_FLM_GLPE_FLM_DTM_TRIG_CFG_MODE_S)
#define IG3_FLM_GLPE_FLM_DTM_TRIG_COUNT 0x420900A8
#define IG3_FLM_GLPE_FLM_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLM_GLPE_FLM_DTM_TRIG_COUNT_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_TRIG_MASK 0x420900A4
#define IG3_FLM_GLPE_FLM_DTM_TRIG_MASK_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLM_GLPE_FLM_DTM_TRIG_MASK_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_TRIG_PATTERN 0x420900A0
#define IG3_FLM_GLPE_FLM_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLM_GLPE_FLM_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_FLM_GLPE_FLM_DTM_TRIG_TIMESTAMP 0x420900AC
#define IG3_FLM_GLPE_FLM_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_FLM_GLPE_FLM_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLM_GLPE_FLM_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_FLM_GLPE_FLM_ECC_COR_ERR 0x42090054
#define IG3_FLM_GLPE_FLM_ECC_COR_ERR_RSVD_S 12
#define IG3_FLM_GLPE_FLM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_FLM_GLPE_FLM_ECC_COR_ERR_RSVD_S)
#define IG3_FLM_GLPE_FLM_ECC_COR_ERR_CNT_S 0
#define IG3_FLM_GLPE_FLM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_FLM_GLPE_FLM_ECC_COR_ERR_CNT_S)
#define IG3_FLM_GLPE_FLM_ECC_UNCOR_ERR 0x42090050
#define IG3_FLM_GLPE_FLM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_FLM_GLPE_FLM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_FLM_GLPE_FLM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_FLM_GLPE_FLM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_FLM_GLPE_FLM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_FLM_GLPE_FLM_ECC_UNCOR_ERR_CNT_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG 0x42090020
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RSVD3_S 20
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RSVD3_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RM_S 16
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RM_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RSVD2_S 14
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RSVD2_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RME_S 12
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RME_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RSVD1_S 10
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RSVD1_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ERR_CNT_S 9
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ERR_CNT_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_FIX_CNT_S 8
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_FIX_CNT_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RSVD0_S 6
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_RSVD0_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_MASK_INT_S 5
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_MASK_INT_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_LS_BYPASS_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_LS_FORCE_S 3
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_LS_FORCE_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ECC_EN_S 0
#define IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_LFSR_MEM_CFG_ECC_EN_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS 0x42090024
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_RSVD1_S 30
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_RSVD1_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_RSVD0_S 4
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_RSVD0_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_INIT_DONE_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_ECC_FIX_S)
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_LFSR_MEM_STATUS_ECC_ERR_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG 0x42090030
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RSVD3_S 20
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RSVD3_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RM_S 16
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RM_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RSVD2_S 14
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RSVD2_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RME_S 12
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RME_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RSVD1_S 10
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RSVD1_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ERR_CNT_S 9
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ERR_CNT_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_FIX_CNT_S 8
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_FIX_CNT_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RSVD0_S 6
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_RSVD0_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_MASK_INT_S 5
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_MASK_INT_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_LS_BYPASS_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_LS_FORCE_S 3
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_LS_FORCE_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ECC_EN_S 0
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_CFG_ECC_EN_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS 0x42090034
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_RSVD1_S 30
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_RSVD1_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_RSVD0_S 4
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_RSVD0_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_INIT_DONE_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_ECC_FIX_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MAX_MEM_STATUS_ECC_ERR_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG 0x42090028
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RSVD3_S 20
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RSVD3_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RM_S 16
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RM_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RSVD2_S 14
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RSVD2_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RME_S 12
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RME_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RSVD1_S 10
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RSVD1_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ERR_CNT_S 9
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ERR_CNT_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_FIX_CNT_S 8
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_FIX_CNT_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RSVD0_S 6
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_RSVD0_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_MASK_INT_S 5
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_MASK_INT_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_LS_BYPASS_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_LS_FORCE_S 3
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_LS_FORCE_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ECC_EN_S 0
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_CFG_ECC_EN_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS 0x4209002C
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_RSVD1_S 30
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_RSVD1_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_RSVD0_S 4
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_RSVD0_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_INIT_DONE_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_ECC_FIX_S)
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_HEAD_MEM_STATUS_ECC_ERR_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG 0x42090038
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RSVD3_S 20
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RSVD3_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RM_S 16
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RM_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RSVD2_S 14
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RSVD2_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RME_S 12
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RME_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RSVD1_S 10
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RSVD1_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ERR_CNT_S 9
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ERR_CNT_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_FIX_CNT_S 8
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_FIX_CNT_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RSVD0_S 6
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_RSVD0_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_MASK_INT_S 5
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_MASK_INT_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_LS_BYPASS_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_LS_FORCE_S 3
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_LS_FORCE_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ECC_EN_S 0
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_CFG_ECC_EN_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS 0x4209003C
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_RSVD1_S 30
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_RSVD1_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_RSVD0_S 4
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_RSVD0_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_INIT_DONE_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_ECC_FIX_S)
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLM_GLPE_FLM_PTR_TAIL_MEM_STATUS_ECC_ERR_S)
#define IG3_FLM_GLPE_OOISC_ALLOCERR(_i) 0x4208E000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_FLM_GLPE_OOISC_ALLOCERR_MAX_INDEX_I 1031
#define IG3_FLM_GLPE_OOISC_ALLOCERR_RSVD_S 16
#define IG3_FLM_GLPE_OOISC_ALLOCERR_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_FLM_GLPE_OOISC_ALLOCERR_RSVD_S)
#define IG3_FLM_GLPE_OOISC_ALLOCERR_ERROR_COUNT_S 0
#define IG3_FLM_GLPE_OOISC_ALLOCERR_ERROR_COUNT_M RDMA_MASK3(32, 0xFFFF, IG3_FLM_GLPE_OOISC_ALLOCERR_ERROR_COUNT_S)
#define IG3_FLM_GLPE_Q1_ALLOCERR(_i) 0x4208A000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_FLM_GLPE_Q1_ALLOCERR_MAX_INDEX_I 1031
#define IG3_FLM_GLPE_Q1_ALLOCERR_RSVD_S 16
#define IG3_FLM_GLPE_Q1_ALLOCERR_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_FLM_GLPE_Q1_ALLOCERR_RSVD_S)
#define IG3_FLM_GLPE_Q1_ALLOCERR_ERROR_COUNT_S 0
#define IG3_FLM_GLPE_Q1_ALLOCERR_ERROR_COUNT_M RDMA_MASK3(32, 0xFFFF, IG3_FLM_GLPE_Q1_ALLOCERR_ERROR_COUNT_S)
#define IG3_FLM_GLPE_RRSP_ALLOCERR(_i) 0x4208C000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_FLM_GLPE_RRSP_ALLOCERR_MAX_INDEX_I 1031
#define IG3_FLM_GLPE_RRSP_ALLOCERR_RSVD_S 16
#define IG3_FLM_GLPE_RRSP_ALLOCERR_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_FLM_GLPE_RRSP_ALLOCERR_RSVD_S)
#define IG3_FLM_GLPE_RRSP_ALLOCERR_ERROR_COUNT_S 0
#define IG3_FLM_GLPE_RRSP_ALLOCERR_ERROR_COUNT_M RDMA_MASK3(32, 0xFFFF, IG3_FLM_GLPE_RRSP_ALLOCERR_ERROR_COUNT_S)
#define IG3_FLM_GLPE_XMIT_ALLOCERR(_i) 0x42088000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_FLM_GLPE_XMIT_ALLOCERR_MAX_INDEX_I 1031
#define IG3_FLM_GLPE_XMIT_ALLOCERR_RSVD_S 16
#define IG3_FLM_GLPE_XMIT_ALLOCERR_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_FLM_GLPE_XMIT_ALLOCERR_RSVD_S)
#define IG3_FLM_GLPE_XMIT_ALLOCERR_ERROR_COUNT_S 0
#define IG3_FLM_GLPE_XMIT_ALLOCERR_ERROR_COUNT_M RDMA_MASK3(32, 0xFFFF, IG3_FLM_GLPE_XMIT_ALLOCERR_ERROR_COUNT_S)
#define IG3_FLM_GPLE_FLMDEBUG 0x4209001C
#define IG3_FLM_GPLE_FLMDEBUG_RSVD_S 3
#define IG3_FLM_GPLE_FLMDEBUG_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_FLM_GPLE_FLMDEBUG_RSVD_S)
#define IG3_FLM_GPLE_FLMDEBUG_SOFT_RESET_S 2
#define IG3_FLM_GPLE_FLMDEBUG_SOFT_RESET_M RDMA_BIT2(32, IG3_FLM_GPLE_FLMDEBUG_SOFT_RESET_S)
#define IG3_FLM_GPLE_FLMDEBUG_BYPASS_RAM_DISABLE_S 1
#define IG3_FLM_GPLE_FLMDEBUG_BYPASS_RAM_DISABLE_M RDMA_BIT2(32, IG3_FLM_GPLE_FLMDEBUG_BYPASS_RAM_DISABLE_S)
#define IG3_FLM_GPLE_FLMDEBUG_STORE_PTR_RESET_S 0
#define IG3_FLM_GPLE_FLMDEBUG_STORE_PTR_RESET_M RDMA_BIT2(32, IG3_FLM_GPLE_FLMDEBUG_STORE_PTR_RESET_S)
#define IG3_TMR_GLPE_TCPNOWDIV(_i) 0x420A2000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_TMR_GLPE_TCPNOWDIV_MAX_INDEX_I 1031
#define IG3_TMR_GLPE_TCPNOWDIV_RSVD_S 16
#define IG3_TMR_GLPE_TCPNOWDIV_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_TMR_GLPE_TCPNOWDIV_RSVD_S)
#define IG3_TMR_GLPE_TCPNOWDIV_TCPNOWDIV_S 0
#define IG3_TMR_GLPE_TCPNOWDIV_TCPNOWDIV_M RDMA_MASK3(32, 0xFFFF, IG3_TMR_GLPE_TCPNOWDIV_TCPNOWDIV_S)
#define IG3_TMR_GLPE_TCPNOWINIT 0x420A6014
#define IG3_TMR_GLPE_TCPNOWINIT_TCPNOWINIT_S 0
#define IG3_TMR_GLPE_TCPNOWINIT_TCPNOWINIT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMR_GLPE_TCPNOWINIT_TCPNOWINIT_S)
#define IG3_TMR_GLPE_TCPTMRCFG(_i) 0x420A4000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_TMR_GLPE_TCPTMRCFG_MAX_INDEX_I 1031
#define IG3_TMR_GLPE_TCPTMRCFG_PETCPTMREN_S 31
#define IG3_TMR_GLPE_TCPTMRCFG_PETCPTMREN_M RDMA_BIT2(32, IG3_TMR_GLPE_TCPTMRCFG_PETCPTMREN_S)
#define IG3_TMR_GLPE_TCPTMRCFG_PETCPTMRST_S 30
#define IG3_TMR_GLPE_TCPTMRCFG_PETCPTMRST_M RDMA_BIT2(32, IG3_TMR_GLPE_TCPTMRCFG_PETCPTMRST_S)
#define IG3_TMR_GLPE_TCPTMRCFG_RSVD2_S 27
#define IG3_TMR_GLPE_TCPTMRCFG_RSVD2_M RDMA_MASK3(32, 0x7, IG3_TMR_GLPE_TCPTMRCFG_RSVD2_S)
#define IG3_TMR_GLPE_TCPTMRCFG_PETCPTMRNUMQP512BLK_S 16
#define IG3_TMR_GLPE_TCPTMRCFG_PETCPTMRNUMQP512BLK_M RDMA_MASK3(32, 0x7FF, IG3_TMR_GLPE_TCPTMRCFG_PETCPTMRNUMQP512BLK_S)
#define IG3_TMR_GLPE_TCPTMRCFG_PEROCEV2RTOPOLICY_S 15
#define IG3_TMR_GLPE_TCPTMRCFG_PEROCEV2RTOPOLICY_M RDMA_BIT2(32, IG3_TMR_GLPE_TCPTMRCFG_PEROCEV2RTOPOLICY_S)
#define IG3_TMR_GLPE_TCPTMRCFG_RSVD1_S 13
#define IG3_TMR_GLPE_TCPTMRCFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TMR_GLPE_TCPTMRCFG_RSVD1_S)
#define IG3_TMR_GLPE_TCPTMRCFG_PETCPTMRBKTSHIFT_S 8
#define IG3_TMR_GLPE_TCPTMRCFG_PETCPTMRBKTSHIFT_M RDMA_MASK3(32, 0x1F, IG3_TMR_GLPE_TCPTMRCFG_PETCPTMRBKTSHIFT_S)
#define IG3_TMR_GLPE_TCPTMRCFG_RSVD0_S 5
#define IG3_TMR_GLPE_TCPTMRCFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_TMR_GLPE_TCPTMRCFG_RSVD0_S)
#define IG3_TMR_GLPE_TCPTMRCFG_PETCPTMRBKTMSKBITS_S 0
#define IG3_TMR_GLPE_TCPTMRCFG_PETCPTMRBKTMSKBITS_M RDMA_MASK3(32, 0x1F, IG3_TMR_GLPE_TCPTMRCFG_PETCPTMRBKTMSKBITS_S)
#define IG3_TMR_GLPE_TMRCTRL0 0x420A6000
#define IG3_TMR_GLPE_TMRCTRL0_TRIG_S 31
#define IG3_TMR_GLPE_TMRCTRL0_TRIG_M RDMA_BIT2(32, IG3_TMR_GLPE_TMRCTRL0_TRIG_S)
#define IG3_TMR_GLPE_TMRCTRL0_RSVD_S 26
#define IG3_TMR_GLPE_TMRCTRL0_RSVD_M RDMA_MASK3(32, 0x1F, IG3_TMR_GLPE_TMRCTRL0_RSVD_S)
#define IG3_TMR_GLPE_TMRCTRL0_REXMIT_DELTA_S 0
#define IG3_TMR_GLPE_TMRCTRL0_REXMIT_DELTA_M RDMA_MASK3(32, 0x3FFFFFF, IG3_TMR_GLPE_TMRCTRL0_REXMIT_DELTA_S)
#define IG3_TMR_GLPE_TMRCTRL1 0x420A6004
#define IG3_TMR_GLPE_TMRCTRL1_DACK_OP_S 30
#define IG3_TMR_GLPE_TMRCTRL1_DACK_OP_M RDMA_MASK3(32, 0x3, IG3_TMR_GLPE_TMRCTRL1_DACK_OP_S)
#define IG3_TMR_GLPE_TMRCTRL1_REXMIT_OP_S 28
#define IG3_TMR_GLPE_TMRCTRL1_REXMIT_OP_M RDMA_MASK3(32, 0x3, IG3_TMR_GLPE_TMRCTRL1_REXMIT_OP_S)
#define IG3_TMR_GLPE_TMRCTRL1_PERSIST_OP_S 26
#define IG3_TMR_GLPE_TMRCTRL1_PERSIST_OP_M RDMA_MASK3(32, 0x3, IG3_TMR_GLPE_TMRCTRL1_PERSIST_OP_S)
#define IG3_TMR_GLPE_TMRCTRL1_IDLE_OP_S 24
#define IG3_TMR_GLPE_TMRCTRL1_IDLE_OP_M RDMA_MASK3(32, 0x3, IG3_TMR_GLPE_TMRCTRL1_IDLE_OP_S)
#define IG3_TMR_GLPE_TMRCTRL1_GP_OP_S 22
#define IG3_TMR_GLPE_TMRCTRL1_GP_OP_M RDMA_MASK3(32, 0x3, IG3_TMR_GLPE_TMRCTRL1_GP_OP_S)
#define IG3_TMR_GLPE_TMRCTRL1_RSVD_S 19
#define IG3_TMR_GLPE_TMRCTRL1_RSVD_M RDMA_MASK3(32, 0x7, IG3_TMR_GLPE_TMRCTRL1_RSVD_S)
#define IG3_TMR_GLPE_TMRCTRL1_LINEADDR_S 10
#define IG3_TMR_GLPE_TMRCTRL1_LINEADDR_M RDMA_MASK3(32, 0x1FF, IG3_TMR_GLPE_TMRCTRL1_LINEADDR_S)
#define IG3_TMR_GLPE_TMRCTRL1_DACK_DELTA_S 0
#define IG3_TMR_GLPE_TMRCTRL1_DACK_DELTA_M RDMA_MASK3(32, 0x3FF, IG3_TMR_GLPE_TMRCTRL1_DACK_DELTA_S)
#define IG3_TMR_GLPE_TMRCTRL2 0x420A6008
#define IG3_TMR_GLPE_TMRCTRL2_PMF_S 20
#define IG3_TMR_GLPE_TMRCTRL2_PMF_M RDMA_MASK3(32, 0xFFF, IG3_TMR_GLPE_TMRCTRL2_PMF_S)
#define IG3_TMR_GLPE_TMRCTRL2_VDEV_VF_TYPE_S 18
#define IG3_TMR_GLPE_TMRCTRL2_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_TMR_GLPE_TMRCTRL2_VDEV_VF_TYPE_S)
#define IG3_TMR_GLPE_TMRCTRL2_VDEV_VF_NUM_S 6
#define IG3_TMR_GLPE_TMRCTRL2_VDEV_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_TMR_GLPE_TMRCTRL2_VDEV_VF_NUM_S)
#define IG3_TMR_GLPE_TMRCTRL2_PF_NUM_S 0
#define IG3_TMR_GLPE_TMRCTRL2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_TMR_GLPE_TMRCTRL2_PF_NUM_S)
#define IG3_TMR_GLPE_TMRCTRL3 0x420A600C
#define IG3_TMR_GLPE_TMRCTRL3_RSVD_S 30
#define IG3_TMR_GLPE_TMRCTRL3_RSVD_M RDMA_MASK3(32, 0x3, IG3_TMR_GLPE_TMRCTRL3_RSVD_S)
#define IG3_TMR_GLPE_TMRCTRL3_HOST_S 27
#define IG3_TMR_GLPE_TMRCTRL3_HOST_M RDMA_MASK3(32, 0x7, IG3_TMR_GLPE_TMRCTRL3_HOST_S)
#define IG3_TMR_GLPE_TMRCTRL3_TILE_S 24
#define IG3_TMR_GLPE_TMRCTRL3_TILE_M RDMA_MASK3(32, 0x7, IG3_TMR_GLPE_TMRCTRL3_TILE_S)
#define IG3_TMR_GLPE_TMRCTRL3_QP_NUM_S 0
#define IG3_TMR_GLPE_TMRCTRL3_QP_NUM_M RDMA_MASK3(32, 0xFFFFFF, IG3_TMR_GLPE_TMRCTRL3_QP_NUM_S)
#define IG3_TMR_GLPE_TMRSTAT 0x420A6010
#define IG3_TMR_GLPE_TMRSTAT_RSVD_S 2
#define IG3_TMR_GLPE_TMRSTAT_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_TMR_GLPE_TMRSTAT_RSVD_S)
#define IG3_TMR_GLPE_TMRSTAT_SCN_BUSY_S 1
#define IG3_TMR_GLPE_TMRSTAT_SCN_BUSY_M RDMA_BIT2(32, IG3_TMR_GLPE_TMRSTAT_SCN_BUSY_S)
#define IG3_TMR_GLPE_TMRSTAT_CSR_BUSY_S 0
#define IG3_TMR_GLPE_TMRSTAT_CSR_BUSY_M RDMA_BIT2(32, IG3_TMR_GLPE_TMRSTAT_CSR_BUSY_S)
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_COUNT 0x420A60B8
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_TMR_GLPE_TMR_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_TMR_GLPE_TMR_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_CMD 0x420A60CC
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_DATA_H 0x420A60D8
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_DATA_L 0x420A60D4
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_PTR 0x420A60D0
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_TMR_GLPE_TMR_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_CMD 0x420A60BC
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_DATA_H 0x420A60C8
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_DATA_L 0x420A60C4
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_PTR 0x420A60C0
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_TMR_GLPE_TMR_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_CONTROL 0x420A6080
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_RSVD1_S 25
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_TMR_GLPE_TMR_DTM_CONTROL_RSVD1_S)
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_RSVD2_S 17
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_TMR_GLPE_TMR_DTM_CONTROL_RSVD2_S)
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_RSVD3_S 9
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_TMR_GLPE_TMR_DTM_CONTROL_RSVD3_S)
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_BYPASS_S 8
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_CONTROL_BYPASS_S)
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_RSVD4_S 1
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_TMR_GLPE_TMR_DTM_CONTROL_RSVD4_S)
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_TMR_GLPE_TMR_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_CONTROL_LOCAL_EN_S)
#define IG3_TMR_GLPE_TMR_DTM_ECC_COR_ERR 0x420A60E8
#define IG3_TMR_GLPE_TMR_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_TMR_GLPE_TMR_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TMR_GLPE_TMR_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_TMR_GLPE_TMR_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_TMR_GLPE_TMR_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TMR_GLPE_TMR_DTM_ECC_COR_ERR_CNT_S)
#define IG3_TMR_GLPE_TMR_DTM_ECC_UNCOR_ERR 0x420A60E4
#define IG3_TMR_GLPE_TMR_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TMR_GLPE_TMR_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TMR_GLPE_TMR_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TMR_GLPE_TMR_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TMR_GLPE_TMR_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TMR_GLPE_TMR_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_TMR_GLPE_TMR_DTM_GROUP_CFG 0x420A608C
#define IG3_TMR_GLPE_TMR_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_TMR_GLPE_TMR_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_TMR_GLPE_TMR_DTM_GROUP_CFG_RSVD1_S)
#define IG3_TMR_GLPE_TMR_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_TMR_GLPE_TMR_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_TMR_GLPE_TMR_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_TMR_GLPE_TMR_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_TMR_GLPE_TMR_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_TMR_GLPE_TMR_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_TMR_GLPE_TMR_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_TMR_GLPE_TMR_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_TMR_GLPE_TMR_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_TMR_GLPE_TMR_DTM_LOG_CFG 0x420A6090
#define IG3_TMR_GLPE_TMR_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_TMR_GLPE_TMR_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_TMR_GLPE_TMR_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_TMR_GLPE_TMR_DTM_LOG_CFG_RSVD1_S 2
#define IG3_TMR_GLPE_TMR_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_TMR_GLPE_TMR_DTM_LOG_CFG_RSVD1_S)
#define IG3_TMR_GLPE_TMR_DTM_LOG_CFG_MODE_S 0
#define IG3_TMR_GLPE_TMR_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_TMR_GLPE_TMR_DTM_LOG_CFG_MODE_S)
#define IG3_TMR_GLPE_TMR_DTM_LOG_MASK 0x420A6098
#define IG3_TMR_GLPE_TMR_DTM_LOG_MASK_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMR_GLPE_TMR_DTM_LOG_MASK_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_LOG_PATTERN 0x420A6094
#define IG3_TMR_GLPE_TMR_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMR_GLPE_TMR_DTM_LOG_PATTERN_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_MAIN_CFG 0x420A6084
#define IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_RSVD1_S)
#define IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_RSVD2_S)
#define IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_RSVD3_S)
#define IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_TMR_GLPE_TMR_DTM_MAIN_STS 0x420A6088
#define IG3_TMR_GLPE_TMR_DTM_MAIN_STS_RSVD1_S 9
#define IG3_TMR_GLPE_TMR_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_TMR_GLPE_TMR_DTM_MAIN_STS_RSVD1_S)
#define IG3_TMR_GLPE_TMR_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_TMR_GLPE_TMR_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_TMR_GLPE_TMR_DTM_MAIN_STS_RSVD2_S 1
#define IG3_TMR_GLPE_TMR_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_TMR_GLPE_TMR_DTM_MAIN_STS_RSVD2_S)
#define IG3_TMR_GLPE_TMR_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_TMR_GLPE_TMR_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_TMR_GLPE_TMR_DTM_TIMESTAMP 0x420A60B0
#define IG3_TMR_GLPE_TMR_DTM_TIMESTAMP_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMR_GLPE_TMR_DTM_TIMESTAMP_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_TIMESTAMP_ROLLOVER 0x420A60B4
#define IG3_TMR_GLPE_TMR_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMR_GLPE_TMR_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG 0x420A60DC
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS 0x420A60E0
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TMR_GLPE_TMR_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_TMR_GLPE_TMR_DTM_TRIG_CFG 0x420A609C
#define IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_RSVD1_S)
#define IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_RSVD2_S)
#define IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_MODE_S 0
#define IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_TMR_GLPE_TMR_DTM_TRIG_CFG_MODE_S)
#define IG3_TMR_GLPE_TMR_DTM_TRIG_COUNT 0x420A60A8
#define IG3_TMR_GLPE_TMR_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMR_GLPE_TMR_DTM_TRIG_COUNT_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_TRIG_MASK 0x420A60A4
#define IG3_TMR_GLPE_TMR_DTM_TRIG_MASK_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMR_GLPE_TMR_DTM_TRIG_MASK_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_TRIG_PATTERN 0x420A60A0
#define IG3_TMR_GLPE_TMR_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMR_GLPE_TMR_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_TMR_GLPE_TMR_DTM_TRIG_TIMESTAMP 0x420A60AC
#define IG3_TMR_GLPE_TMR_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_TMR_GLPE_TMR_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMR_GLPE_TMR_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_TMR_GLPE_TMR_HF 0x420A6018
#define IG3_TMR_GLPE_TMR_HF_CNT_S 16
#define IG3_TMR_GLPE_TMR_HF_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_TMR_GLPE_TMR_HF_CNT_S)
#define IG3_TMR_GLPE_TMR_HF_VAL_S 0
#define IG3_TMR_GLPE_TMR_HF_VAL_M RDMA_MASK3(32, 0xFFFF, IG3_TMR_GLPE_TMR_HF_VAL_S)
#define IG3_TMR_PMFPE_TCPNOWTIMER(_i) 0x420A0000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_TMR_PMFPE_TCPNOWTIMER_MAX_INDEX_I 1031
#define IG3_TMR_PMFPE_TCPNOWTIMER_TCP_NOW_S 0
#define IG3_TMR_PMFPE_TCPNOWTIMER_TCP_NOW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMR_PMFPE_TCPNOWTIMER_TCP_NOW_S)
#define IG3_PTXI_GLPE_PMFCOUNT_CTRL 0x420C6308
#define IG3_PTXI_GLPE_PMFCOUNT_CTRL_RSVD_S 1
#define IG3_PTXI_GLPE_PMFCOUNT_CTRL_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTXI_GLPE_PMFCOUNT_CTRL_RSVD_S)
#define IG3_PTXI_GLPE_PMFCOUNT_CTRL_STALL_S 0
#define IG3_PTXI_GLPE_PMFCOUNT_CTRL_STALL_M RDMA_BIT2(32, IG3_PTXI_GLPE_PMFCOUNT_CTRL_STALL_S)
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG(_i) 0x420C6338 + ((_i) * 4) /* _i=0...7 */
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_MAX_INDEX_I 7
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_BUSY_S 31
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_BUSY_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_BUSY_S)
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_HOSTID_S 28
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_HOSTID_S)
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_VM_VF_TYPE_S 26
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_VM_VF_TYPE_S)
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_PF_NUM_S 20
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_PF_NUM_S)
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_VM_VF_NUM_S 8
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_VM_VF_NUM_S)
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_PORT_S 5
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_PORT_M RDMA_MASK3(32, 0x7, IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_PORT_S)
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_RSVD0_S 0
#define IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_PTXI_GLPE_PTXCMP_MKR_TRIG_RSVD0_S)
#define IG3_PTXI_GLPE_PTXI_CONFIG 0x420C630C
#define IG3_PTXI_GLPE_PTXI_CONFIG_RSVD_S 2
#define IG3_PTXI_GLPE_PTXI_CONFIG_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_PTXI_GLPE_PTXI_CONFIG_RSVD_S)
#define IG3_PTXI_GLPE_PTXI_CONFIG_STALL_FLR_ON_FULL_S 1
#define IG3_PTXI_GLPE_PTXI_CONFIG_STALL_FLR_ON_FULL_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_CONFIG_STALL_FLR_ON_FULL_S)
#define IG3_PTXI_GLPE_PTXI_CONFIG_STALL_FLUSH_ON_FULL_S 0
#define IG3_PTXI_GLPE_PTXI_CONFIG_STALL_FLUSH_ON_FULL_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_CONFIG_STALL_FLUSH_ON_FULL_S)
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_COUNT 0x420C63B8
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTXI_GLPE_PTXI_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTXI_GLPE_PTXI_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_CMD 0x420C63CC
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_DATA_H 0x420C63D8
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_DATA_L 0x420C63D4
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_PTR 0x420C63D0
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTXI_GLPE_PTXI_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_CMD 0x420C63BC
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_DATA_H 0x420C63C8
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_DATA_L 0x420C63C4
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_PTR 0x420C63C0
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTXI_GLPE_PTXI_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL 0x420C6380
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_RSVD1_S 25
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PTXI_GLPE_PTXI_DTM_CONTROL_RSVD1_S)
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_RSVD2_S 17
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTXI_GLPE_PTXI_DTM_CONTROL_RSVD2_S)
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_RSVD3_S 9
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PTXI_GLPE_PTXI_DTM_CONTROL_RSVD3_S)
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_BYPASS_S 8
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_CONTROL_BYPASS_S)
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_RSVD4_S 1
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PTXI_GLPE_PTXI_DTM_CONTROL_RSVD4_S)
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PTXI_GLPE_PTXI_DTM_ECC_COR_ERR 0x420C63E8
#define IG3_PTXI_GLPE_PTXI_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PTXI_GLPE_PTXI_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PTXI_GLPE_PTXI_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PTXI_GLPE_PTXI_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PTXI_GLPE_PTXI_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PTXI_GLPE_PTXI_DTM_ECC_UNCOR_ERR 0x420C63E4
#define IG3_PTXI_GLPE_PTXI_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PTXI_GLPE_PTXI_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PTXI_GLPE_PTXI_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PTXI_GLPE_PTXI_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PTXI_GLPE_PTXI_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PTXI_GLPE_PTXI_DTM_GROUP_CFG 0x420C638C
#define IG3_PTXI_GLPE_PTXI_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PTXI_GLPE_PTXI_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTXI_GLPE_PTXI_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PTXI_GLPE_PTXI_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PTXI_GLPE_PTXI_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PTXI_GLPE_PTXI_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PTXI_GLPE_PTXI_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PTXI_GLPE_PTXI_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PTXI_GLPE_PTXI_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PTXI_GLPE_PTXI_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PTXI_GLPE_PTXI_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PTXI_GLPE_PTXI_DTM_LOG_CFG 0x420C6390
#define IG3_PTXI_GLPE_PTXI_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PTXI_GLPE_PTXI_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PTXI_GLPE_PTXI_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PTXI_GLPE_PTXI_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PTXI_GLPE_PTXI_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PTXI_GLPE_PTXI_DTM_LOG_CFG_RSVD1_S)
#define IG3_PTXI_GLPE_PTXI_DTM_LOG_CFG_MODE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PTXI_GLPE_PTXI_DTM_LOG_CFG_MODE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_LOG_MASK 0x420C6398
#define IG3_PTXI_GLPE_PTXI_DTM_LOG_MASK_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTXI_GLPE_PTXI_DTM_LOG_MASK_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_LOG_PATTERN 0x420C6394
#define IG3_PTXI_GLPE_PTXI_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTXI_GLPE_PTXI_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG 0x420C6384
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_STS 0x420C6388
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PTXI_GLPE_PTXI_DTM_MAIN_STS_RSVD1_S)
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTXI_GLPE_PTXI_DTM_MAIN_STS_RSVD2_S)
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TIMESTAMP 0x420C63B0
#define IG3_PTXI_GLPE_PTXI_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTXI_GLPE_PTXI_DTM_TIMESTAMP_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TIMESTAMP_ROLLOVER 0x420C63B4
#define IG3_PTXI_GLPE_PTXI_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTXI_GLPE_PTXI_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG 0x420C63DC
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS 0x420C63E0
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PTXI_GLPE_PTXI_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG 0x420C639C
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_MODE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PTXI_GLPE_PTXI_DTM_TRIG_CFG_MODE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_COUNT 0x420C63A8
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTXI_GLPE_PTXI_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_MASK 0x420C63A4
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTXI_GLPE_PTXI_DTM_TRIG_MASK_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_PATTERN 0x420C63A0
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTXI_GLPE_PTXI_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_TIMESTAMP 0x420C63AC
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PTXI_GLPE_PTXI_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTXI_GLPE_PTXI_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PTXI_GLPE_PTX_FLR_MKR_CNT 0x420C6314
#define IG3_PTXI_GLPE_PTX_FLR_MKR_CNT_RSVD_S 8
#define IG3_PTXI_GLPE_PTX_FLR_MKR_CNT_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTXI_GLPE_PTX_FLR_MKR_CNT_RSVD_S)
#define IG3_PTXI_GLPE_PTX_FLR_MKR_CNT_MKR_CNT_S 0
#define IG3_PTXI_GLPE_PTX_FLR_MKR_CNT_MKR_CNT_M RDMA_MASK3(32, 0xFF, IG3_PTXI_GLPE_PTX_FLR_MKR_CNT_MKR_CNT_S)
#define IG3_PTXI_GLPE_PTX_FLUSH_MKR_CNT 0x420C6310
#define IG3_PTXI_GLPE_PTX_FLUSH_MKR_CNT_RSVD_S 16
#define IG3_PTXI_GLPE_PTX_FLUSH_MKR_CNT_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PTXI_GLPE_PTX_FLUSH_MKR_CNT_RSVD_S)
#define IG3_PTXI_GLPE_PTX_FLUSH_MKR_CNT_MKR_CNT_S 0
#define IG3_PTXI_GLPE_PTX_FLUSH_MKR_CNT_MKR_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PTXI_GLPE_PTX_FLUSH_MKR_CNT_MKR_CNT_S)
#define IG3_PTXI_GLPE_XLR_DROP(_i) 0x420C6318 + ((_i) * 4) /* _i=0...7 */
#define IG3_PTXI_GLPE_XLR_DROP_MAX_INDEX_I 7
#define IG3_PTXI_GLPE_XLR_DROP_DROP_S 31
#define IG3_PTXI_GLPE_XLR_DROP_DROP_M RDMA_BIT2(32, IG3_PTXI_GLPE_XLR_DROP_DROP_S)
#define IG3_PTXI_GLPE_XLR_DROP_RSVD_S 20
#define IG3_PTXI_GLPE_XLR_DROP_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_PTXI_GLPE_XLR_DROP_RSVD_S)
#define IG3_PTXI_GLPE_XLR_DROP_FUNC_TYPE_S 18
#define IG3_PTXI_GLPE_XLR_DROP_FUNC_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTXI_GLPE_XLR_DROP_FUNC_TYPE_S)
#define IG3_PTXI_GLPE_XLR_DROP_FUNC_NUM_S 6
#define IG3_PTXI_GLPE_XLR_DROP_FUNC_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTXI_GLPE_XLR_DROP_FUNC_NUM_S)
#define IG3_PTXI_GLPE_XLR_DROP_PHY_FUNC_S 0
#define IG3_PTXI_GLPE_XLR_DROP_PHY_FUNC_M RDMA_MASK3(32, 0x3F, IG3_PTXI_GLPE_XLR_DROP_PHY_FUNC_S)
#define IG3_PTXI_PMFPE_IPCONFIG0(_i) 0x420C0000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PTXI_PMFPE_IPCONFIG0_MAX_INDEX_I 1031
#define IG3_PTXI_PMFPE_IPCONFIG0_RSVD_S 18
#define IG3_PTXI_PMFPE_IPCONFIG0_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_PTXI_PMFPE_IPCONFIG0_RSVD_S)
#define IG3_PTXI_PMFPE_IPCONFIG0_UDP_SRC_PORT_MASK_EN_S 17
#define IG3_PTXI_PMFPE_IPCONFIG0_UDP_SRC_PORT_MASK_EN_M RDMA_BIT2(32, IG3_PTXI_PMFPE_IPCONFIG0_UDP_SRC_PORT_MASK_EN_S)
#define IG3_PTXI_PMFPE_IPCONFIG0_USEENTIREIDRANGE_S 16
#define IG3_PTXI_PMFPE_IPCONFIG0_USEENTIREIDRANGE_M RDMA_BIT2(32, IG3_PTXI_PMFPE_IPCONFIG0_USEENTIREIDRANGE_S)
#define IG3_PTXI_PMFPE_IPCONFIG0_PEIPID_S 0
#define IG3_PTXI_PMFPE_IPCONFIG0_PEIPID_M RDMA_MASK3(32, 0xFFFF, IG3_PTXI_PMFPE_IPCONFIG0_PEIPID_S)
#define IG3_PTXI_PMFPE_PMFCOUNT(_i) 0x420C2000 + ((_i) * 4) /* _i=0...4127 */
#define IG3_PTXI_PMFPE_PMFCOUNT_MAX_INDEX_I 4127
#define IG3_PTXI_PMFPE_PMFCOUNT_FW_TOKEN_S 24
#define IG3_PTXI_PMFPE_PMFCOUNT_FW_TOKEN_M RDMA_MASK3(32, 0xFF, IG3_PTXI_PMFPE_PMFCOUNT_FW_TOKEN_S)
#define IG3_PTXI_PMFPE_PMFCOUNT_RSVD1_S 23
#define IG3_PTXI_PMFPE_PMFCOUNT_RSVD1_M RDMA_BIT2(32, IG3_PTXI_PMFPE_PMFCOUNT_RSVD1_S)
#define IG3_PTXI_PMFPE_PMFCOUNT_HOST_ID_S 20
#define IG3_PTXI_PMFPE_PMFCOUNT_HOST_ID_M RDMA_MASK3(32, 0x7, IG3_PTXI_PMFPE_PMFCOUNT_HOST_ID_S)
#define IG3_PTXI_PMFPE_PMFCOUNT_FLUSH_PENDING_S 19
#define IG3_PTXI_PMFPE_PMFCOUNT_FLUSH_PENDING_M RDMA_BIT2(32, IG3_PTXI_PMFPE_PMFCOUNT_FLUSH_PENDING_S)
#define IG3_PTXI_PMFPE_PMFCOUNT_RSVD0_S 18
#define IG3_PTXI_PMFPE_PMFCOUNT_RSVD0_M RDMA_BIT2(32, IG3_PTXI_PMFPE_PMFCOUNT_RSVD0_S)
#define IG3_PTXI_PMFPE_PMFCOUNT_COUNT_S 0
#define IG3_PTXI_PMFPE_PMFCOUNT_COUNT_M RDMA_MASK3(32, 0x3FFFF, IG3_PTXI_PMFPE_PMFCOUNT_COUNT_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH(_i) 0x420C6200 + ((_i) * 4) /* _i=0...65 */
#define IG3_PTXI_PMFPE_PMF_EPOCH_MAX_INDEX_I 65
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH15_S 30
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH15_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH15_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH14_S 28
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH14_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH14_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH13_S 26
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH13_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH13_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH12_S 24
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH12_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH12_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH11_S 22
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH11_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH11_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH10_S 20
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH10_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH10_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH9_S 18
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH9_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH9_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH8_S 16
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH8_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH8_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH7_S 14
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH7_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH7_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH6_S 12
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH6_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH6_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH5_S 10
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH5_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH5_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH4_S 8
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH4_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH4_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH3_S 6
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH3_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH3_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH2_S 4
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH2_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH2_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH1_S 2
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH1_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH1_S)
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH0_S 0
#define IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH0_M RDMA_MASK3(32, 0x3, IG3_PTXI_PMFPE_PMF_EPOCH_EPOCH0_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_BUS_INDEX 0x420E1110
#define IG3_CORE_GLPE_CORE_BOB0_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL 0x420E1100
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_RESERVED_31_10_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_TRIG_OP_S 8
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_TRIG_OP_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_FREEZE_RESET_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_FREEZE_SET_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_CTRL_FREEZE_SET_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_FREEZE_ON_CNT_VAL 0x420E1120
#define IG3_CORE_GLPE_CORE_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_OBS_BUS 0x420E1140
#define IG3_CORE_GLPE_CORE_BOB0_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CNT0 0x420E1160
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CNT0_CNT0_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CNT0_CNT0_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CNT1_0 0x420E1168
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CNT1_1 0x420E116C
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CTRL 0x420E1158
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_CORE_GLPE_CORE_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_RC_CTRL 0x420E1138
#define IG3_CORE_GLPE_CORE_BOB0_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_CORE_GLPE_CORE_BOB0_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_RC_GAP 0x420E1128
#define IG3_CORE_GLPE_CORE_BOB0_BOB_RC_GAP_RC_GAP_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_RC_GAP_RC_GAP_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_RC_TRNS 0x420E1130
#define IG3_CORE_GLPE_CORE_BOB0_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS 0x420E1108
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_RESERVED_31_8_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_I_FREEZE_S 6
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_I_FREEZE_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_READY_S 5
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_READY_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_VALID_S 4
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_VALID_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB0_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_TRANS_CNT 0x420E1118
#define IG3_CORE_GLPE_CORE_BOB0_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_TRIG_MASK 0x420E1148
#define IG3_CORE_GLPE_CORE_BOB0_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_CORE_GLPE_CORE_BOB0_BOB_TRIG_VALUE 0x420E1150
#define IG3_CORE_GLPE_CORE_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_CORE_GLPE_CORE_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_BUS_INDEX 0x420E1190
#define IG3_CORE_GLPE_CORE_BOB1_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL 0x420E1180
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_RESERVED_31_10_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_TRIG_OP_S 8
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_TRIG_OP_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_FREEZE_RESET_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_FREEZE_SET_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_CTRL_FREEZE_SET_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_FREEZE_ON_CNT_VAL 0x420E11A0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_OBS_BUS 0x420E11C0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CNT0 0x420E11E0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CNT0_CNT0_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CNT0_CNT0_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CNT1_0 0x420E11E8
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CNT1_1 0x420E11EC
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CTRL 0x420E11D8
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_CORE_GLPE_CORE_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_RC_CTRL 0x420E11B8
#define IG3_CORE_GLPE_CORE_BOB1_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_CORE_GLPE_CORE_BOB1_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_RC_GAP 0x420E11A8
#define IG3_CORE_GLPE_CORE_BOB1_BOB_RC_GAP_RC_GAP_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_RC_GAP_RC_GAP_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_RC_TRNS 0x420E11B0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS 0x420E1188
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_RESERVED_31_8_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_I_FREEZE_S 6
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_I_FREEZE_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_READY_S 5
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_READY_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_VALID_S 4
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_VALID_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB1_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_TRANS_CNT 0x420E1198
#define IG3_CORE_GLPE_CORE_BOB1_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_TRIG_MASK 0x420E11C8
#define IG3_CORE_GLPE_CORE_BOB1_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_CORE_GLPE_CORE_BOB1_BOB_TRIG_VALUE 0x420E11D0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_CORE_GLPE_CORE_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_BUS_INDEX 0x420E1210
#define IG3_CORE_GLPE_CORE_BOB2_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL 0x420E1200
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_RESERVED_31_10_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_TRIG_OP_S 8
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_TRIG_OP_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_FREEZE_RESET_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_FREEZE_SET_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_CTRL_FREEZE_SET_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_FREEZE_ON_CNT_VAL 0x420E1220
#define IG3_CORE_GLPE_CORE_BOB2_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_OBS_BUS 0x420E1240
#define IG3_CORE_GLPE_CORE_BOB2_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CNT0 0x420E1260
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CNT0_CNT0_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CNT0_CNT0_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CNT1_0 0x420E1268
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CNT1_1 0x420E126C
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CTRL 0x420E1258
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_CORE_GLPE_CORE_BOB2_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_RC_CTRL 0x420E1238
#define IG3_CORE_GLPE_CORE_BOB2_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_CORE_GLPE_CORE_BOB2_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_RC_GAP 0x420E1228
#define IG3_CORE_GLPE_CORE_BOB2_BOB_RC_GAP_RC_GAP_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_RC_GAP_RC_GAP_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_RC_TRNS 0x420E1230
#define IG3_CORE_GLPE_CORE_BOB2_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS 0x420E1208
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_RESERVED_31_8_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_I_FREEZE_S 6
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_I_FREEZE_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_READY_S 5
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_READY_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_VALID_S 4
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_VALID_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB2_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_TRANS_CNT 0x420E1218
#define IG3_CORE_GLPE_CORE_BOB2_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_TRIG_MASK 0x420E1248
#define IG3_CORE_GLPE_CORE_BOB2_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_CORE_GLPE_CORE_BOB2_BOB_TRIG_VALUE 0x420E1250
#define IG3_CORE_GLPE_CORE_BOB2_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_CORE_GLPE_CORE_BOB2_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB2_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_BUS_INDEX 0x420E1290
#define IG3_CORE_GLPE_CORE_BOB3_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL 0x420E1280
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_RESERVED_31_10_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_TRIG_OP_S 8
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_TRIG_OP_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_FREEZE_RESET_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_FREEZE_SET_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_CTRL_FREEZE_SET_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_FREEZE_ON_CNT_VAL 0x420E12A0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_OBS_BUS 0x420E12C0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CNT0 0x420E12E0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CNT0_CNT0_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CNT0_CNT0_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CNT1_0 0x420E12E8
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CNT1_1 0x420E12EC
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CTRL 0x420E12D8
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_CORE_GLPE_CORE_BOB3_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_RC_CTRL 0x420E12B8
#define IG3_CORE_GLPE_CORE_BOB3_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_CORE_GLPE_CORE_BOB3_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_RC_GAP 0x420E12A8
#define IG3_CORE_GLPE_CORE_BOB3_BOB_RC_GAP_RC_GAP_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_RC_GAP_RC_GAP_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_RC_TRNS 0x420E12B0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS 0x420E1288
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_RESERVED_31_8_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_I_FREEZE_S 6
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_I_FREEZE_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_READY_S 5
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_READY_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_VALID_S 4
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_VALID_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB3_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_TRANS_CNT 0x420E1298
#define IG3_CORE_GLPE_CORE_BOB3_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_TRIG_MASK 0x420E12C8
#define IG3_CORE_GLPE_CORE_BOB3_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_CORE_GLPE_CORE_BOB3_BOB_TRIG_VALUE 0x420E12D0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_CORE_GLPE_CORE_BOB3_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB3_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_BUS_INDEX 0x420E1310
#define IG3_CORE_GLPE_CORE_BOB4_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL 0x420E1300
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_RESERVED_31_10_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_TRIG_OP_S 8
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_TRIG_OP_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_FREEZE_RESET_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_FREEZE_SET_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_CTRL_FREEZE_SET_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_FREEZE_ON_CNT_VAL 0x420E1320
#define IG3_CORE_GLPE_CORE_BOB4_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_OBS_BUS 0x420E1340
#define IG3_CORE_GLPE_CORE_BOB4_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CNT0 0x420E1360
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CNT0_CNT0_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CNT0_CNT0_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CNT1_0 0x420E1368
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CNT1_1 0x420E136C
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CTRL 0x420E1358
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_CORE_GLPE_CORE_BOB4_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_RC_CTRL 0x420E1338
#define IG3_CORE_GLPE_CORE_BOB4_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_CORE_GLPE_CORE_BOB4_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_RC_GAP 0x420E1328
#define IG3_CORE_GLPE_CORE_BOB4_BOB_RC_GAP_RC_GAP_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_RC_GAP_RC_GAP_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_RC_TRNS 0x420E1330
#define IG3_CORE_GLPE_CORE_BOB4_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS 0x420E1308
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_RESERVED_31_8_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_I_FREEZE_S 6
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_I_FREEZE_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_READY_S 5
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_READY_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_VALID_S 4
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_VALID_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB4_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_TRANS_CNT 0x420E1318
#define IG3_CORE_GLPE_CORE_BOB4_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_TRIG_MASK 0x420E1348
#define IG3_CORE_GLPE_CORE_BOB4_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_CORE_GLPE_CORE_BOB4_BOB_TRIG_VALUE 0x420E1350
#define IG3_CORE_GLPE_CORE_BOB4_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_CORE_GLPE_CORE_BOB4_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB4_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_BUS_INDEX 0x420E1390
#define IG3_CORE_GLPE_CORE_BOB5_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL 0x420E1380
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_RESERVED_31_10_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_TRIG_OP_S 8
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_TRIG_OP_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_FREEZE_RESET_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_FREEZE_SET_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_CTRL_FREEZE_SET_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_FREEZE_ON_CNT_VAL 0x420E13A0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_OBS_BUS 0x420E13C0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CNT0 0x420E13E0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CNT0_CNT0_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CNT0_CNT0_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CNT1_0 0x420E13E8
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CNT1_1 0x420E13EC
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CTRL 0x420E13D8
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_CORE_GLPE_CORE_BOB5_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_RC_CTRL 0x420E13B8
#define IG3_CORE_GLPE_CORE_BOB5_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_CORE_GLPE_CORE_BOB5_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_RC_GAP 0x420E13A8
#define IG3_CORE_GLPE_CORE_BOB5_BOB_RC_GAP_RC_GAP_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_RC_GAP_RC_GAP_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_RC_TRNS 0x420E13B0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS 0x420E1388
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_RESERVED_31_8_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_I_FREEZE_S 6
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_I_FREEZE_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_READY_S 5
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_READY_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_VALID_S 4
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_VALID_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_CORE_GLPE_CORE_BOB5_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_TRANS_CNT 0x420E1398
#define IG3_CORE_GLPE_CORE_BOB5_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_TRIG_MASK 0x420E13C8
#define IG3_CORE_GLPE_CORE_BOB5_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_CORE_GLPE_CORE_BOB5_BOB_TRIG_VALUE 0x420E13D0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_CORE_GLPE_CORE_BOB5_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_CORE_BOB5_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC0 0x420E104C
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC0_HOST3_THOLD_S 24
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC0_HOST3_THOLD_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_CPAL_HOST_ALLOC0_HOST3_THOLD_S)
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC0_HOST2_THOLD_S 16
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC0_HOST2_THOLD_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_CPAL_HOST_ALLOC0_HOST2_THOLD_S)
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC0_HOST1_THOLD_S 8
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC0_HOST1_THOLD_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_CPAL_HOST_ALLOC0_HOST1_THOLD_S)
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC0_HOST0_THOLD_S 0
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC0_HOST0_THOLD_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_CPAL_HOST_ALLOC0_HOST0_THOLD_S)
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC1 0x420E1050
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC1_RSVD_S 16
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC1_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_CORE_GLPE_CPAL_HOST_ALLOC1_RSVD_S)
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC1_HOST5_THOLD_S 8
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC1_HOST5_THOLD_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_CPAL_HOST_ALLOC1_HOST5_THOLD_S)
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC1_HOST4_THOLD_S 0
#define IG3_CORE_GLPE_CPAL_HOST_ALLOC1_HOST4_THOLD_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_CPAL_HOST_ALLOC1_HOST4_THOLD_S)
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC0 0x420E1054
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC0_HOST3_THOLD_S 24
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC0_HOST3_THOLD_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_DPAL_HOST_ALLOC0_HOST3_THOLD_S)
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC0_HOST2_THOLD_S 16
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC0_HOST2_THOLD_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_DPAL_HOST_ALLOC0_HOST2_THOLD_S)
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC0_HOST1_THOLD_S 8
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC0_HOST1_THOLD_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_DPAL_HOST_ALLOC0_HOST1_THOLD_S)
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC0_HOST0_THOLD_S 0
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC0_HOST0_THOLD_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_DPAL_HOST_ALLOC0_HOST0_THOLD_S)
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC1 0x420E1058
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC1_RSVD_S 16
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC1_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_CORE_GLPE_DPAL_HOST_ALLOC1_RSVD_S)
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC1_HOST5_THOLD_S 8
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC1_HOST5_THOLD_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_DPAL_HOST_ALLOC1_HOST5_THOLD_S)
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC1_HOST4_THOLD_S 0
#define IG3_CORE_GLPE_DPAL_HOST_ALLOC1_HOST4_THOLD_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_DPAL_HOST_ALLOC1_HOST4_THOLD_S)
#define IG3_CORE_GLPE_DTM_GLOBAL_EN 0x420E105C
#define IG3_CORE_GLPE_DTM_GLOBAL_EN_RSVD_S 1
#define IG3_CORE_GLPE_DTM_GLOBAL_EN_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CORE_GLPE_DTM_GLOBAL_EN_RSVD_S)
#define IG3_CORE_GLPE_DTM_GLOBAL_EN_GLOBAL_EN_S 0
#define IG3_CORE_GLPE_DTM_GLOBAL_EN_GLOBAL_EN_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_GLOBAL_EN_GLOBAL_EN_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_0_31_0 0x420E1060
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_0_31_0_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_0_31_0_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_0_31_0_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_0_63_32 0x420E1064
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_0_63_32_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_0_63_32_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_0_63_32_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_0_75_64 0x420E1068
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_0_75_64_RSVD_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_0_75_64_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_0_75_64_RSVD_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_0_75_64_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_0_75_64_MASK_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_0_75_64_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_1_31_0 0x420E106C
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_1_31_0_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_1_31_0_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_1_31_0_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_1_63_32 0x420E1070
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_1_63_32_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_1_63_32_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_1_63_32_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_1_75_64 0x420E1074
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_1_75_64_RSVD_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_1_75_64_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_1_75_64_RSVD_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_1_75_64_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_1_75_64_MASK_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_1_75_64_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_2_31_0 0x420E1078
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_2_31_0_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_2_31_0_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_2_31_0_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_2_63_32 0x420E107C
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_2_63_32_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_2_63_32_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_2_63_32_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_2_75_64 0x420E1080
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_2_75_64_RSVD_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_2_75_64_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_2_75_64_RSVD_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_2_75_64_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_2_75_64_MASK_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_2_75_64_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_3_31_0 0x420E1084
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_3_31_0_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_3_31_0_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_3_31_0_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_3_63_32 0x420E1088
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_3_63_32_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_3_63_32_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_3_63_32_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_3_75_64 0x420E108C
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_3_75_64_RSVD_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_3_75_64_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_3_75_64_RSVD_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_3_75_64_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_3_75_64_MASK_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_3_75_64_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_4_31_0 0x420E1090
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_4_31_0_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_4_31_0_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_4_31_0_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_4_63_32 0x420E1094
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_4_63_32_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_4_63_32_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_4_63_32_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_4_75_64 0x420E1098
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_4_75_64_RSVD_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_4_75_64_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_4_75_64_RSVD_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_4_75_64_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_4_75_64_MASK_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_4_75_64_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_5_31_0 0x420E109C
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_5_31_0_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_5_31_0_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_5_31_0_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_5_63_32 0x420E10A0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_5_63_32_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_5_63_32_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_5_63_32_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_5_75_64 0x420E10A4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_5_75_64_RSVD_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_5_75_64_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_5_75_64_RSVD_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_5_75_64_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_5_75_64_MASK_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_5_75_64_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_6_31_0 0x420E10A8
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_6_31_0_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_6_31_0_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_6_31_0_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_6_63_32 0x420E10AC
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_6_63_32_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_6_63_32_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_6_63_32_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_6_75_64 0x420E10B0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_6_75_64_RSVD_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_6_75_64_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_6_75_64_RSVD_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_6_75_64_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_6_75_64_MASK_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_6_75_64_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_7_31_0 0x420E10B4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_7_31_0_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_7_31_0_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_7_31_0_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_7_63_32 0x420E10B8
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_7_63_32_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_7_63_32_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_7_63_32_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_7_75_64 0x420E10BC
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_7_75_64_RSVD_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_7_75_64_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_7_75_64_RSVD_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_7_75_64_MASK_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_7_75_64_MASK_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_7_75_64_MASK_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8 0x420E10C4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD7_S 31
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD7_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD7_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_15_S 28
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_15_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_15_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD6_S 27
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD6_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD6_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_14_S 24
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_14_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_14_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD5_S 23
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD5_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD5_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_13_S 20
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_13_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_13_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD4_S 19
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD4_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD4_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_12_S 16
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_12_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_12_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD3_S 15
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD3_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD3_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_11_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_11_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_11_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD2_S 11
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD2_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD2_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_10_S 8
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_10_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_10_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD1_S 7
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD1_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD1_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_9_S 4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_9_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_9_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD0_S 3
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD0_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_RSVD0_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_8_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_8_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_15_8_MASK_SEL_8_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16 0x420E10C8
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD7_S 31
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD7_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD7_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_23_S 28
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_23_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_23_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD6_S 27
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD6_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD6_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_22_S 24
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_22_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_22_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD5_S 23
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD5_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD5_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_21_S 20
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_21_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_21_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD4_S 19
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD4_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD4_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_20_S 16
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_20_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_20_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD3_S 15
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD3_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD3_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_19_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_19_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_19_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD2_S 11
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD2_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD2_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_18_S 8
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_18_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_18_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD1_S 7
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD1_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD1_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_17_S 4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_17_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_17_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD0_S 3
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD0_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_RSVD0_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_16_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_16_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_23_16_MASK_SEL_16_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24 0x420E10CC
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD7_S 31
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD7_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD7_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_31_S 28
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_31_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_31_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD6_S 27
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD6_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD6_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_30_S 24
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_30_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_30_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD5_S 23
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD5_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD5_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_29_S 20
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_29_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_29_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD4_S 19
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD4_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD4_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_28_S 16
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_28_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_28_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD3_S 15
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD3_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD3_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_27_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_27_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_27_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD2_S 11
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD2_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD2_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_26_S 8
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_26_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_26_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD1_S 7
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD1_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD1_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_25_S 4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_25_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_25_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD0_S 3
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD0_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_RSVD0_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_24_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_24_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_31_24_MASK_SEL_24_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32 0x420E10D0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD7_S 31
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD7_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD7_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_39_S 28
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_39_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_39_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD6_S 27
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD6_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD6_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_38_S 24
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_38_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_38_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD5_S 23
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD5_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD5_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_37_S 20
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_37_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_37_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD4_S 19
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD4_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD4_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_36_S 16
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_36_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_36_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD3_S 15
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD3_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD3_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_35_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_35_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_35_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD2_S 11
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD2_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD2_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_34_S 8
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_34_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_34_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD1_S 7
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD1_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD1_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_33_S 4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_33_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_33_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD0_S 3
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD0_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_RSVD0_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_32_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_32_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_39_32_MASK_SEL_32_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40 0x420E10D4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD7_S 31
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD7_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD7_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_47_S 28
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_47_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_47_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD6_S 27
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD6_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD6_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_46_S 24
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_46_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_46_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD5_S 23
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD5_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD5_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_45_S 20
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_45_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_45_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD4_S 19
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD4_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD4_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_44_S 16
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_44_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_44_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD3_S 15
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD3_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD3_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_43_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_43_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_43_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD2_S 11
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD2_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD2_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_42_S 8
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_42_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_42_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD1_S 7
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD1_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD1_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_41_S 4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_41_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_41_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD0_S 3
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD0_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_RSVD0_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_40_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_40_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_47_40_MASK_SEL_40_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48 0x420E10D8
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD7_S 31
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD7_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD7_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_55_S 28
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_55_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_55_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD6_S 27
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD6_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD6_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_54_S 24
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_54_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_54_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD5_S 23
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD5_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD5_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_53_S 20
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_53_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_53_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD4_S 19
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD4_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD4_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_52_S 16
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_52_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_52_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD3_S 15
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD3_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD3_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_51_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_51_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_51_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD2_S 11
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD2_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD2_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_50_S 8
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_50_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_50_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD1_S 7
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD1_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD1_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_49_S 4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_49_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_49_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD0_S 3
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD0_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_RSVD0_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_48_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_48_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_55_48_MASK_SEL_48_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56 0x420E10DC
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD7_S 31
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD7_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD7_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_63_S 28
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_63_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_63_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD6_S 27
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD6_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD6_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_62_S 24
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_62_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_62_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD5_S 23
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD5_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD5_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_61_S 20
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_61_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_61_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD4_S 19
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD4_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD4_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_60_S 16
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_60_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_60_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD3_S 15
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD3_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD3_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_59_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_59_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_59_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD2_S 11
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD2_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD2_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_58_S 8
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_58_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_58_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD1_S 7
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD1_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD1_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_57_S 4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_57_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_57_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD0_S 3
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD0_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_RSVD0_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_56_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_56_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_63_56_MASK_SEL_56_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64 0x420E10E0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD7_S 31
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD7_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD7_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_71_S 28
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_71_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_71_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD6_S 27
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD6_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD6_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_70_S 24
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_70_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_70_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD5_S 23
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD5_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD5_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_69_S 20
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_69_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_69_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD4_S 19
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD4_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD4_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_68_S 16
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_68_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_68_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD3_S 15
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD3_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD3_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_67_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_67_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_67_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD2_S 11
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD2_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD2_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_66_S 8
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_66_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_66_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD1_S 7
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD1_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD1_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_65_S 4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_65_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_65_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD0_S 3
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD0_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_RSVD0_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_64_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_64_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_71_64_MASK_SEL_64_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72 0x420E10E4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_RSVD5_S 15
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_RSVD5_M RDMA_MASK3(32, 0x1FFFF, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_RSVD5_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_MASK_SEL_75_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_MASK_SEL_75_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_MASK_SEL_75_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_RSVD2_S 11
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_RSVD2_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_RSVD2_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_MASK_SEL_74_S 8
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_MASK_SEL_74_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_MASK_SEL_74_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_RSVD1_S 7
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_RSVD1_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_RSVD1_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_MASK_SEL_73_S 4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_MASK_SEL_73_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_MASK_SEL_73_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_RSVD0_S 3
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_RSVD0_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_RSVD0_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_MASK_SEL_72_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_MASK_SEL_72_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_75_72_MASK_SEL_72_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0 0x420E10C0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD7_S 31
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD7_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD7_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_7_S 28
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_7_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_7_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD6_S 27
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD6_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD6_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_6_S 24
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_6_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_6_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD5_S 23
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD5_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD5_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_5_S 20
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_5_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_5_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD4_S 19
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD4_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD4_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_4_S 16
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_4_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_4_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD3_S 15
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD3_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD3_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_3_S 12
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_3_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_3_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD2_S 11
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD2_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD2_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_2_S 8
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_2_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_2_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD1_S 7
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD1_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD1_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_1_S 4
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_1_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_1_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD0_S 3
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD0_M RDMA_BIT2(32, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_RSVD0_S)
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_0_S 0
#define IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_0_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_DTM_MATRIX_MASK_SEL_7_0_MASK_SEL_0_S)
#define IG3_CORE_GLPE_FLM_OBJCTRL(_i) 0x420E0000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_CORE_GLPE_FLM_OBJCTRL_MAX_INDEX_I 1031
#define IG3_CORE_GLPE_FLM_OBJCTRL_FLMEN_S 31
#define IG3_CORE_GLPE_FLM_OBJCTRL_FLMEN_M RDMA_BIT2(32, IG3_CORE_GLPE_FLM_OBJCTRL_FLMEN_S)
#define IG3_CORE_GLPE_FLM_OBJCTRL_FLMST_S 30
#define IG3_CORE_GLPE_FLM_OBJCTRL_FLMST_M RDMA_BIT2(32, IG3_CORE_GLPE_FLM_OBJCTRL_FLMST_S)
#define IG3_CORE_GLPE_FLM_OBJCTRL_RSVD3_S 27
#define IG3_CORE_GLPE_FLM_OBJCTRL_RSVD3_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_FLM_OBJCTRL_RSVD3_S)
#define IG3_CORE_GLPE_FLM_OBJCTRL_OOISC_BLOCKSIZE_S 24
#define IG3_CORE_GLPE_FLM_OBJCTRL_OOISC_BLOCKSIZE_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_FLM_OBJCTRL_OOISC_BLOCKSIZE_S)
#define IG3_CORE_GLPE_FLM_OBJCTRL_RSVD2_S 19
#define IG3_CORE_GLPE_FLM_OBJCTRL_RSVD2_M RDMA_MASK3(32, 0x1F, IG3_CORE_GLPE_FLM_OBJCTRL_RSVD2_S)
#define IG3_CORE_GLPE_FLM_OBJCTRL_RRSP_BLOCKSIZE_S 16
#define IG3_CORE_GLPE_FLM_OBJCTRL_RRSP_BLOCKSIZE_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_FLM_OBJCTRL_RRSP_BLOCKSIZE_S)
#define IG3_CORE_GLPE_FLM_OBJCTRL_RSVD1_S 11
#define IG3_CORE_GLPE_FLM_OBJCTRL_RSVD1_M RDMA_MASK3(32, 0x1F, IG3_CORE_GLPE_FLM_OBJCTRL_RSVD1_S)
#define IG3_CORE_GLPE_FLM_OBJCTRL_Q1_BLOCKSIZE_S 8
#define IG3_CORE_GLPE_FLM_OBJCTRL_Q1_BLOCKSIZE_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_FLM_OBJCTRL_Q1_BLOCKSIZE_S)
#define IG3_CORE_GLPE_FLM_OBJCTRL_RSVD0_S 3
#define IG3_CORE_GLPE_FLM_OBJCTRL_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_CORE_GLPE_FLM_OBJCTRL_RSVD0_S)
#define IG3_CORE_GLPE_FLM_OBJCTRL_XMIT_BLOCKSIZE_S 0
#define IG3_CORE_GLPE_FLM_OBJCTRL_XMIT_BLOCKSIZE_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_FLM_OBJCTRL_XMIT_BLOCKSIZE_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0 0x420E1020
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_BUSY_S 31
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_BUSY_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_BUSY_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_OP_S 28
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_OP_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_PMF_TABLE_CTRL0_OP_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_ISMASKED_C_MASK_S 27
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_ISMASKED_C_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_ISMASKED_C_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_ISMASKED_C_S 26
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_ISMASKED_C_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_ISMASKED_C_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_ISMASKED_W_MASK_S 25
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_ISMASKED_W_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_ISMASKED_W_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_ISMASKED_W_S 24
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_ISMASKED_W_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_ISMASKED_W_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INFLR_C_MASK_S 23
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INFLR_C_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_INFLR_C_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INFLR_C_S 22
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INFLR_C_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_INFLR_C_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INFLR_W_MASK_S 21
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INFLR_W_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_INFLR_W_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INFLR_W_S 20
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INFLR_W_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_INFLR_W_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INTEAM_C_MASK_S 19
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INTEAM_C_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_INTEAM_C_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INTEAM_C_S 18
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INTEAM_C_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_INTEAM_C_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INTEAM_W_MASK_S 17
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INTEAM_W_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_INTEAM_W_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INTEAM_W_S 16
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_INTEAM_W_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_INTEAM_W_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_VALID_C_MASK_S 15
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_VALID_C_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_VALID_C_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_VALID_C_S 14
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_VALID_C_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_VALID_C_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_VALID_W_MASK_S 13
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_VALID_W_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_VALID_W_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_VALID_W_S 12
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_VALID_W_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL0_VALID_W_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_TBL_IDX_S 0
#define IG3_CORE_GLPE_PMF_TABLE_CTRL0_TBL_IDX_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_PMF_TABLE_CTRL0_TBL_IDX_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL1 0x420E1024
#define IG3_CORE_GLPE_PMF_TABLE_CTRL1_PMF_C_MASK_S 31
#define IG3_CORE_GLPE_PMF_TABLE_CTRL1_PMF_C_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL1_PMF_C_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL1_RSVD1_S 28
#define IG3_CORE_GLPE_PMF_TABLE_CTRL1_RSVD1_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_PMF_TABLE_CTRL1_RSVD1_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL1_PMF_C_S 16
#define IG3_CORE_GLPE_PMF_TABLE_CTRL1_PMF_C_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_PMF_TABLE_CTRL1_PMF_C_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL1_PMF_W_MASK_S 15
#define IG3_CORE_GLPE_PMF_TABLE_CTRL1_PMF_W_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL1_PMF_W_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL1_RSVD0_S 12
#define IG3_CORE_GLPE_PMF_TABLE_CTRL1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_PMF_TABLE_CTRL1_RSVD0_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL1_PMF_W_S 0
#define IG3_CORE_GLPE_PMF_TABLE_CTRL1_PMF_W_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_PMF_TABLE_CTRL1_PMF_W_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2 0x420E1028
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_HOSTID_W_MASK_S 31
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_HOSTID_W_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL2_HOSTID_W_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_VDEV_VF_TYPE_W_MASK_S 30
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_VDEV_VF_TYPE_W_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL2_VDEV_VF_TYPE_W_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_VDEV_VF_W_MASK_S 29
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_VDEV_VF_W_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL2_VDEV_VF_W_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_PF_W_MASK_S 28
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_PF_W_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL2_PF_W_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_RSVD_S 23
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_RSVD_M RDMA_MASK3(32, 0x1F, IG3_CORE_GLPE_PMF_TABLE_CTRL2_RSVD_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_HOSTID_W_S 20
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_HOSTID_W_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_PMF_TABLE_CTRL2_HOSTID_W_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_VDEV_VF_TYPE_W_S 18
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_VDEV_VF_TYPE_W_M RDMA_MASK3(32, 0x3, IG3_CORE_GLPE_PMF_TABLE_CTRL2_VDEV_VF_TYPE_W_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_VDEV_VF_W_S 6
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_VDEV_VF_W_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_PMF_TABLE_CTRL2_VDEV_VF_W_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_PF_W_S 0
#define IG3_CORE_GLPE_PMF_TABLE_CTRL2_PF_W_M RDMA_MASK3(32, 0x3F, IG3_CORE_GLPE_PMF_TABLE_CTRL2_PF_W_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3 0x420E102C
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_HOSTID_C_MASK_S 31
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_HOSTID_C_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL3_HOSTID_C_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_VDEV_VF_TYPE_C_MASK_S 30
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_VDEV_VF_TYPE_C_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL3_VDEV_VF_TYPE_C_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_VDEV_VF_C_MASK_S 29
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_VDEV_VF_C_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL3_VDEV_VF_C_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_PF_C_MASK_S 28
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_PF_C_MASK_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_CTRL3_PF_C_MASK_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_RSVD_S 23
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_RSVD_M RDMA_MASK3(32, 0x1F, IG3_CORE_GLPE_PMF_TABLE_CTRL3_RSVD_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_HOSTID_C_S 20
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_HOSTID_C_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_PMF_TABLE_CTRL3_HOSTID_C_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_VDEV_VF_TYPE_C_S 18
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_VDEV_VF_TYPE_C_M RDMA_MASK3(32, 0x3, IG3_CORE_GLPE_PMF_TABLE_CTRL3_VDEV_VF_TYPE_C_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_VDEV_VF_C_S 6
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_VDEV_VF_C_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_PMF_TABLE_CTRL3_VDEV_VF_C_S)
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_PF_C_S 0
#define IG3_CORE_GLPE_PMF_TABLE_CTRL3_PF_C_M RDMA_MASK3(32, 0x3F, IG3_CORE_GLPE_PMF_TABLE_CTRL3_PF_C_S)
#define IG3_CORE_GLPE_PMF_TABLE_DATA0 0x420E1030
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_HIT_S 31
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_HIT_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_DATA0_HIT_S)
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_RSVD_S 28
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_RSVD_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_PMF_TABLE_DATA0_RSVD_S)
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_PMF_S 16
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_PMF_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_PMF_TABLE_DATA0_PMF_S)
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_INTEAM_S 15
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_INTEAM_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_DATA0_INTEAM_S)
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_INFLR_S 14
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_INFLR_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_DATA0_INFLR_S)
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_ISMASKED_S 13
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_ISMASKED_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_DATA0_ISMASKED_S)
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_VALID_S 12
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_VALID_M RDMA_BIT2(32, IG3_CORE_GLPE_PMF_TABLE_DATA0_VALID_S)
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_TBL_IDX_S 0
#define IG3_CORE_GLPE_PMF_TABLE_DATA0_TBL_IDX_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_PMF_TABLE_DATA0_TBL_IDX_S)
#define IG3_CORE_GLPE_PMF_TABLE_DATA1 0x420E1034
#define IG3_CORE_GLPE_PMF_TABLE_DATA1_RSVD_S 23
#define IG3_CORE_GLPE_PMF_TABLE_DATA1_RSVD_M RDMA_MASK3(32, 0x1FF, IG3_CORE_GLPE_PMF_TABLE_DATA1_RSVD_S)
#define IG3_CORE_GLPE_PMF_TABLE_DATA1_HOSTID_S 20
#define IG3_CORE_GLPE_PMF_TABLE_DATA1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_PMF_TABLE_DATA1_HOSTID_S)
#define IG3_CORE_GLPE_PMF_TABLE_DATA1_VDEV_VF_TYPE_S 18
#define IG3_CORE_GLPE_PMF_TABLE_DATA1_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_CORE_GLPE_PMF_TABLE_DATA1_VDEV_VF_TYPE_S)
#define IG3_CORE_GLPE_PMF_TABLE_DATA1_VDEV_VF_S 6
#define IG3_CORE_GLPE_PMF_TABLE_DATA1_VDEV_VF_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_PMF_TABLE_DATA1_VDEV_VF_S)
#define IG3_CORE_GLPE_PMF_TABLE_DATA1_PF_S 0
#define IG3_CORE_GLPE_PMF_TABLE_DATA1_PF_M RDMA_MASK3(32, 0x3F, IG3_CORE_GLPE_PMF_TABLE_DATA1_PF_S)
#define IG3_CORE_GLPE_PRECACHE_TABLE_CTRL 0x420E1038
#define IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_BUSY_S 31
#define IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_BUSY_M RDMA_BIT2(32, IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_BUSY_S)
#define IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_RSVD_S 15
#define IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_RSVD_S)
#define IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_OP_S 14
#define IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_OP_M RDMA_BIT2(32, IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_OP_S)
#define IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_FTYPE_S 12
#define IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_FTYPE_M RDMA_MASK3(32, 0x3, IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_FTYPE_S)
#define IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_TBL_IDX_S 0
#define IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_TBL_IDX_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_PRECACHE_TABLE_CTRL_TBL_IDX_S)
#define IG3_CORE_GLPE_PRECACHE_TABLE_DATA 0x420E103C
#define IG3_CORE_GLPE_PRECACHE_TABLE_DATA_RSVD_S 3
#define IG3_CORE_GLPE_PRECACHE_TABLE_DATA_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_CORE_GLPE_PRECACHE_TABLE_DATA_RSVD_S)
#define IG3_CORE_GLPE_PRECACHE_TABLE_DATA_PROTOCOL_S 0
#define IG3_CORE_GLPE_PRECACHE_TABLE_DATA_PROTOCOL_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_PRECACHE_TABLE_DATA_PROTOCOL_S)
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHHI 0x420E1048
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHHI_RSVD0_S 26
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_CORE_GLPE_SRQ_FWQPFLUSHHI_RSVD0_S)
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHHI_QPID_S 6
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_GLPE_SRQ_FWQPFLUSHHI_QPID_S)
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_CORE_GLPE_SRQ_FWQPFLUSHHI_PF_NUM_S)
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO 0x420E1044
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_BUSY_S 31
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_BUSY_S)
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_RSVD0_S 29
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_RSVD0_S)
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_HOSTID_S 26
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_HOSTID_S)
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_PMF_S 0
#define IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_CORE_GLPE_SRQ_FWQPFLUSHLO_PMF_S)
#define IG3_CORE_GLPE_TMR_COMP 0x420E1040
#define IG3_CORE_GLPE_TMR_COMP_RSVD_S 8
#define IG3_CORE_GLPE_TMR_COMP_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CORE_GLPE_TMR_COMP_RSVD_S)
#define IG3_CORE_GLPE_TMR_COMP_COMP_S 0
#define IG3_CORE_GLPE_TMR_COMP_COMP_M RDMA_MASK3(32, 0xFF, IG3_CORE_GLPE_TMR_COMP_COMP_S)
#define IG3_RLCR_GLPE_RLADDR 0x420E2010
#define IG3_RLCR_GLPE_RLADDR_RSVD_S 13
#define IG3_RLCR_GLPE_RLADDR_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_RLCR_GLPE_RLADDR_RSVD_S)
#define IG3_RLCR_GLPE_RLADDR_RL_ADDR_S 0
#define IG3_RLCR_GLPE_RLADDR_RL_ADDR_M RDMA_MASK3(32, 0x1FFF, IG3_RLCR_GLPE_RLADDR_RL_ADDR_S)
#define IG3_RLCR_GLPE_RLC_DPC_COMP 0x420E2024
#define IG3_RLCR_GLPE_RLC_DPC_COMP_RSVD_S 13
#define IG3_RLCR_GLPE_RLC_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_RLCR_GLPE_RLC_DPC_COMP_RSVD_S)
#define IG3_RLCR_GLPE_RLC_DPC_COMP_COMP_FTYPE_S 11
#define IG3_RLCR_GLPE_RLC_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_RLCR_GLPE_RLC_DPC_COMP_COMP_FTYPE_S)
#define IG3_RLCR_GLPE_RLC_DPC_COMP_COMP_FNUM_S 1
#define IG3_RLCR_GLPE_RLC_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_RLCR_GLPE_RLC_DPC_COMP_COMP_FNUM_S)
#define IG3_RLCR_GLPE_RLC_DPC_COMP_COMP_VALID_S 0
#define IG3_RLCR_GLPE_RLC_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DPC_COMP_COMP_VALID_S)
#define IG3_RLCR_GLPE_RLC_DPC_REQ 0x420E2020
#define IG3_RLCR_GLPE_RLC_DPC_REQ_RSVD_S 12
#define IG3_RLCR_GLPE_RLC_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RLCR_GLPE_RLC_DPC_REQ_RSVD_S)
#define IG3_RLCR_GLPE_RLC_DPC_REQ_REQ_FTYPE_S 10
#define IG3_RLCR_GLPE_RLC_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_RLCR_GLPE_RLC_DPC_REQ_REQ_FTYPE_S)
#define IG3_RLCR_GLPE_RLC_DPC_REQ_REQ_FNUM_S 0
#define IG3_RLCR_GLPE_RLC_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_RLCR_GLPE_RLC_DPC_REQ_REQ_FNUM_S)
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_COUNT 0x420E20B8
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RLCR_GLPE_RLC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RLCR_GLPE_RLC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_CMD 0x420E20CC
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_DATA_H 0x420E20D8
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_DATA_L 0x420E20D4
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_PTR 0x420E20D0
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RLCR_GLPE_RLC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_CMD 0x420E20BC
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_DATA_H 0x420E20C8
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_DATA_L 0x420E20C4
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_PTR 0x420E20C0
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RLCR_GLPE_RLC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL 0x420E2080
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_RSVD1_S 25
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_RLCR_GLPE_RLC_DTM_CONTROL_RSVD1_S)
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_RSVD2_S 17
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RLCR_GLPE_RLC_DTM_CONTROL_RSVD2_S)
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_RSVD3_S 9
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_RLCR_GLPE_RLC_DTM_CONTROL_RSVD3_S)
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_BYPASS_S 8
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_CONTROL_BYPASS_S)
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_RSVD4_S 1
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_RLCR_GLPE_RLC_DTM_CONTROL_RSVD4_S)
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_RLCR_GLPE_RLC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_RLCR_GLPE_RLC_DTM_ECC_COR_ERR 0x420E20E8
#define IG3_RLCR_GLPE_RLC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_RLCR_GLPE_RLC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RLCR_GLPE_RLC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_RLCR_GLPE_RLC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_RLCR_GLPE_RLC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RLCR_GLPE_RLC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_RLCR_GLPE_RLC_DTM_ECC_UNCOR_ERR 0x420E20E4
#define IG3_RLCR_GLPE_RLC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_RLCR_GLPE_RLC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RLCR_GLPE_RLC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_RLCR_GLPE_RLC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_RLCR_GLPE_RLC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RLCR_GLPE_RLC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_RLCR_GLPE_RLC_DTM_GROUP_CFG 0x420E208C
#define IG3_RLCR_GLPE_RLC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_RLCR_GLPE_RLC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_RLCR_GLPE_RLC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_RLCR_GLPE_RLC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_RLCR_GLPE_RLC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_RLCR_GLPE_RLC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_RLCR_GLPE_RLC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_RLCR_GLPE_RLC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_RLCR_GLPE_RLC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_RLCR_GLPE_RLC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_RLCR_GLPE_RLC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_RLCR_GLPE_RLC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_RLCR_GLPE_RLC_DTM_LOG_CFG 0x420E2090
#define IG3_RLCR_GLPE_RLC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_RLCR_GLPE_RLC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_RLCR_GLPE_RLC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_RLCR_GLPE_RLC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_RLCR_GLPE_RLC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_RLCR_GLPE_RLC_DTM_LOG_CFG_RSVD1_S)
#define IG3_RLCR_GLPE_RLC_DTM_LOG_CFG_MODE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_RLCR_GLPE_RLC_DTM_LOG_CFG_MODE_S)
#define IG3_RLCR_GLPE_RLC_DTM_LOG_MASK 0x420E2098
#define IG3_RLCR_GLPE_RLC_DTM_LOG_MASK_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCR_GLPE_RLC_DTM_LOG_MASK_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_LOG_PATTERN 0x420E2094
#define IG3_RLCR_GLPE_RLC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCR_GLPE_RLC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG 0x420E2084
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_STS 0x420E2088
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_RLCR_GLPE_RLC_DTM_MAIN_STS_RSVD1_S)
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RLCR_GLPE_RLC_DTM_MAIN_STS_RSVD2_S)
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_RLCR_GLPE_RLC_DTM_TIMESTAMP 0x420E20B0
#define IG3_RLCR_GLPE_RLC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCR_GLPE_RLC_DTM_TIMESTAMP_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_TIMESTAMP_ROLLOVER 0x420E20B4
#define IG3_RLCR_GLPE_RLC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCR_GLPE_RLC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG 0x420E20DC
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS 0x420E20E0
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG 0x420E209C
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_MODE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_RLCR_GLPE_RLC_DTM_TRIG_CFG_MODE_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_COUNT 0x420E20A8
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCR_GLPE_RLC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_MASK 0x420E20A4
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCR_GLPE_RLC_DTM_TRIG_MASK_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_PATTERN 0x420E20A0
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCR_GLPE_RLC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_TIMESTAMP 0x420E20AC
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_RLCR_GLPE_RLC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCR_GLPE_RLC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_RLCR_GLPE_RLC_ERRDATA 0x420E201C
#define IG3_RLCR_GLPE_RLC_ERRDATA_Q_NUM_S 8
#define IG3_RLCR_GLPE_RLC_ERRDATA_Q_NUM_M RDMA_MASK3(32, 0xFFFFFF, IG3_RLCR_GLPE_RLC_ERRDATA_Q_NUM_S)
#define IG3_RLCR_GLPE_RLC_ERRDATA_RSVD0_S 7
#define IG3_RLCR_GLPE_RLC_ERRDATA_RSVD0_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_ERRDATA_RSVD0_S)
#define IG3_RLCR_GLPE_RLC_ERRDATA_Q_TYPE_S 4
#define IG3_RLCR_GLPE_RLC_ERRDATA_Q_TYPE_M RDMA_MASK3(32, 0x7, IG3_RLCR_GLPE_RLC_ERRDATA_Q_TYPE_S)
#define IG3_RLCR_GLPE_RLC_ERRDATA_ERROR_CODE_S 0
#define IG3_RLCR_GLPE_RLC_ERRDATA_ERROR_CODE_M RDMA_MASK3(32, 0xF, IG3_RLCR_GLPE_RLC_ERRDATA_ERROR_CODE_S)
#define IG3_RLCR_GLPE_RLC_ERRINFO 0x420E2018
#define IG3_RLCR_GLPE_RLC_ERRINFO_RLS_ERROR_CNT_S 24
#define IG3_RLCR_GLPE_RLC_ERRINFO_RLS_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_RLCR_GLPE_RLC_ERRINFO_RLS_ERROR_CNT_S)
#define IG3_RLCR_GLPE_RLC_ERRINFO_RLU_ERROR_CNT_S 16
#define IG3_RLCR_GLPE_RLC_ERRINFO_RLU_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_RLCR_GLPE_RLC_ERRINFO_RLU_ERROR_CNT_S)
#define IG3_RLCR_GLPE_RLC_ERRINFO_DBL_ERROR_CNT_S 8
#define IG3_RLCR_GLPE_RLC_ERRINFO_DBL_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_RLCR_GLPE_RLC_ERRINFO_DBL_ERROR_CNT_S)
#define IG3_RLCR_GLPE_RLC_ERRINFO_RSVD1_S 7
#define IG3_RLCR_GLPE_RLC_ERRINFO_RSVD1_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_ERRINFO_RSVD1_S)
#define IG3_RLCR_GLPE_RLC_ERRINFO_ERROR_INST_S 4
#define IG3_RLCR_GLPE_RLC_ERRINFO_ERROR_INST_M RDMA_MASK3(32, 0x7, IG3_RLCR_GLPE_RLC_ERRINFO_ERROR_INST_S)
#define IG3_RLCR_GLPE_RLC_ERRINFO_RSVD0_S 1
#define IG3_RLCR_GLPE_RLC_ERRINFO_RSVD0_M RDMA_MASK3(32, 0x7, IG3_RLCR_GLPE_RLC_ERRINFO_RSVD0_S)
#define IG3_RLCR_GLPE_RLC_ERRINFO_ERROR_VALID_S 0
#define IG3_RLCR_GLPE_RLC_ERRINFO_ERROR_VALID_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLC_ERRINFO_ERROR_VALID_S)
#define IG3_RLCR_GLPE_RLDATA 0x420E2014
#define IG3_RLCR_GLPE_RLDATA_RL_DATA_S 0
#define IG3_RLCR_GLPE_RLDATA_RL_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCR_GLPE_RLDATA_RL_DATA_S)
#define IG3_RLCR_GLPE_RLQUERY(_i) 0x420E2000 + ((_i) * 4) /* _i=0...1 */
#define IG3_RLCR_GLPE_RLQUERY_MAX_INDEX_I 1
#define IG3_RLCR_GLPE_RLQUERY_RSVD_S 12
#define IG3_RLCR_GLPE_RLQUERY_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RLCR_GLPE_RLQUERY_RSVD_S)
#define IG3_RLCR_GLPE_RLQUERY_RLINDEX_S 0
#define IG3_RLCR_GLPE_RLQUERY_RLINDEX_M RDMA_MASK3(32, 0xFFF, IG3_RLCR_GLPE_RLQUERY_RLINDEX_S)
#define IG3_RLCR_GLPE_RLSTAT(_i) 0x420E2008 + ((_i) * 4) /* _i=0...1 */
#define IG3_RLCR_GLPE_RLSTAT_MAX_INDEX_I 1
#define IG3_RLCR_GLPE_RLSTAT_RSVD_S 2
#define IG3_RLCR_GLPE_RLSTAT_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_RLCR_GLPE_RLSTAT_RSVD_S)
#define IG3_RLCR_GLPE_RLSTAT_RL_EMPTY_S 1
#define IG3_RLCR_GLPE_RLSTAT_RL_EMPTY_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLSTAT_RL_EMPTY_S)
#define IG3_RLCR_GLPE_RLSTAT_QUERY_DONE_S 0
#define IG3_RLCR_GLPE_RLSTAT_QUERY_DONE_M RDMA_BIT2(32, IG3_RLCR_GLPE_RLSTAT_QUERY_DONE_S)
#define IG3_RLCC_GLPE_RLADDR 0x420E2410
#define IG3_RLCC_GLPE_RLADDR_RSVD_S 13
#define IG3_RLCC_GLPE_RLADDR_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_RLCC_GLPE_RLADDR_RSVD_S)
#define IG3_RLCC_GLPE_RLADDR_RL_ADDR_S 0
#define IG3_RLCC_GLPE_RLADDR_RL_ADDR_M RDMA_MASK3(32, 0x1FFF, IG3_RLCC_GLPE_RLADDR_RL_ADDR_S)
#define IG3_RLCC_GLPE_RLC_DPC_COMP 0x420E2424
#define IG3_RLCC_GLPE_RLC_DPC_COMP_RSVD_S 13
#define IG3_RLCC_GLPE_RLC_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_RLCC_GLPE_RLC_DPC_COMP_RSVD_S)
#define IG3_RLCC_GLPE_RLC_DPC_COMP_COMP_FTYPE_S 11
#define IG3_RLCC_GLPE_RLC_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_RLCC_GLPE_RLC_DPC_COMP_COMP_FTYPE_S)
#define IG3_RLCC_GLPE_RLC_DPC_COMP_COMP_FNUM_S 1
#define IG3_RLCC_GLPE_RLC_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_RLCC_GLPE_RLC_DPC_COMP_COMP_FNUM_S)
#define IG3_RLCC_GLPE_RLC_DPC_COMP_COMP_VALID_S 0
#define IG3_RLCC_GLPE_RLC_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DPC_COMP_COMP_VALID_S)
#define IG3_RLCC_GLPE_RLC_DPC_REQ 0x420E2420
#define IG3_RLCC_GLPE_RLC_DPC_REQ_RSVD_S 12
#define IG3_RLCC_GLPE_RLC_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RLCC_GLPE_RLC_DPC_REQ_RSVD_S)
#define IG3_RLCC_GLPE_RLC_DPC_REQ_REQ_FTYPE_S 10
#define IG3_RLCC_GLPE_RLC_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_RLCC_GLPE_RLC_DPC_REQ_REQ_FTYPE_S)
#define IG3_RLCC_GLPE_RLC_DPC_REQ_REQ_FNUM_S 0
#define IG3_RLCC_GLPE_RLC_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_RLCC_GLPE_RLC_DPC_REQ_REQ_FNUM_S)
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_COUNT 0x420E24B8
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RLCC_GLPE_RLC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RLCC_GLPE_RLC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_CMD 0x420E24CC
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_DATA_H 0x420E24D8
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_DATA_L 0x420E24D4
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_PTR 0x420E24D0
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RLCC_GLPE_RLC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_CMD 0x420E24BC
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_DATA_H 0x420E24C8
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_DATA_L 0x420E24C4
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_PTR 0x420E24C0
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RLCC_GLPE_RLC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL 0x420E2480
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_RSVD1_S 25
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_RLCC_GLPE_RLC_DTM_CONTROL_RSVD1_S)
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_RSVD2_S 17
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RLCC_GLPE_RLC_DTM_CONTROL_RSVD2_S)
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_RSVD3_S 9
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_RLCC_GLPE_RLC_DTM_CONTROL_RSVD3_S)
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_BYPASS_S 8
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_CONTROL_BYPASS_S)
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_RSVD4_S 1
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_RLCC_GLPE_RLC_DTM_CONTROL_RSVD4_S)
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_RLCC_GLPE_RLC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_RLCC_GLPE_RLC_DTM_ECC_COR_ERR 0x420E24E8
#define IG3_RLCC_GLPE_RLC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_RLCC_GLPE_RLC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RLCC_GLPE_RLC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_RLCC_GLPE_RLC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_RLCC_GLPE_RLC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RLCC_GLPE_RLC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_RLCC_GLPE_RLC_DTM_ECC_UNCOR_ERR 0x420E24E4
#define IG3_RLCC_GLPE_RLC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_RLCC_GLPE_RLC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RLCC_GLPE_RLC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_RLCC_GLPE_RLC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_RLCC_GLPE_RLC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RLCC_GLPE_RLC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_RLCC_GLPE_RLC_DTM_GROUP_CFG 0x420E248C
#define IG3_RLCC_GLPE_RLC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_RLCC_GLPE_RLC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_RLCC_GLPE_RLC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_RLCC_GLPE_RLC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_RLCC_GLPE_RLC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_RLCC_GLPE_RLC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_RLCC_GLPE_RLC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_RLCC_GLPE_RLC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_RLCC_GLPE_RLC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_RLCC_GLPE_RLC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_RLCC_GLPE_RLC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_RLCC_GLPE_RLC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_RLCC_GLPE_RLC_DTM_LOG_CFG 0x420E2490
#define IG3_RLCC_GLPE_RLC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_RLCC_GLPE_RLC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_RLCC_GLPE_RLC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_RLCC_GLPE_RLC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_RLCC_GLPE_RLC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_RLCC_GLPE_RLC_DTM_LOG_CFG_RSVD1_S)
#define IG3_RLCC_GLPE_RLC_DTM_LOG_CFG_MODE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_RLCC_GLPE_RLC_DTM_LOG_CFG_MODE_S)
#define IG3_RLCC_GLPE_RLC_DTM_LOG_MASK 0x420E2498
#define IG3_RLCC_GLPE_RLC_DTM_LOG_MASK_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCC_GLPE_RLC_DTM_LOG_MASK_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_LOG_PATTERN 0x420E2494
#define IG3_RLCC_GLPE_RLC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCC_GLPE_RLC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG 0x420E2484
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_STS 0x420E2488
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_RLCC_GLPE_RLC_DTM_MAIN_STS_RSVD1_S)
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RLCC_GLPE_RLC_DTM_MAIN_STS_RSVD2_S)
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_RLCC_GLPE_RLC_DTM_TIMESTAMP 0x420E24B0
#define IG3_RLCC_GLPE_RLC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCC_GLPE_RLC_DTM_TIMESTAMP_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_TIMESTAMP_ROLLOVER 0x420E24B4
#define IG3_RLCC_GLPE_RLC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCC_GLPE_RLC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG 0x420E24DC
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS 0x420E24E0
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG 0x420E249C
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_MODE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_RLCC_GLPE_RLC_DTM_TRIG_CFG_MODE_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_COUNT 0x420E24A8
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCC_GLPE_RLC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_MASK 0x420E24A4
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCC_GLPE_RLC_DTM_TRIG_MASK_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_PATTERN 0x420E24A0
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCC_GLPE_RLC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_TIMESTAMP 0x420E24AC
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_RLCC_GLPE_RLC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCC_GLPE_RLC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_RLCC_GLPE_RLC_ERRDATA 0x420E241C
#define IG3_RLCC_GLPE_RLC_ERRDATA_Q_NUM_S 8
#define IG3_RLCC_GLPE_RLC_ERRDATA_Q_NUM_M RDMA_MASK3(32, 0xFFFFFF, IG3_RLCC_GLPE_RLC_ERRDATA_Q_NUM_S)
#define IG3_RLCC_GLPE_RLC_ERRDATA_RSVD0_S 7
#define IG3_RLCC_GLPE_RLC_ERRDATA_RSVD0_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_ERRDATA_RSVD0_S)
#define IG3_RLCC_GLPE_RLC_ERRDATA_Q_TYPE_S 4
#define IG3_RLCC_GLPE_RLC_ERRDATA_Q_TYPE_M RDMA_MASK3(32, 0x7, IG3_RLCC_GLPE_RLC_ERRDATA_Q_TYPE_S)
#define IG3_RLCC_GLPE_RLC_ERRDATA_ERROR_CODE_S 0
#define IG3_RLCC_GLPE_RLC_ERRDATA_ERROR_CODE_M RDMA_MASK3(32, 0xF, IG3_RLCC_GLPE_RLC_ERRDATA_ERROR_CODE_S)
#define IG3_RLCC_GLPE_RLC_ERRINFO 0x420E2418
#define IG3_RLCC_GLPE_RLC_ERRINFO_RLS_ERROR_CNT_S 24
#define IG3_RLCC_GLPE_RLC_ERRINFO_RLS_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_RLCC_GLPE_RLC_ERRINFO_RLS_ERROR_CNT_S)
#define IG3_RLCC_GLPE_RLC_ERRINFO_RLU_ERROR_CNT_S 16
#define IG3_RLCC_GLPE_RLC_ERRINFO_RLU_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_RLCC_GLPE_RLC_ERRINFO_RLU_ERROR_CNT_S)
#define IG3_RLCC_GLPE_RLC_ERRINFO_DBL_ERROR_CNT_S 8
#define IG3_RLCC_GLPE_RLC_ERRINFO_DBL_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_RLCC_GLPE_RLC_ERRINFO_DBL_ERROR_CNT_S)
#define IG3_RLCC_GLPE_RLC_ERRINFO_RSVD1_S 7
#define IG3_RLCC_GLPE_RLC_ERRINFO_RSVD1_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_ERRINFO_RSVD1_S)
#define IG3_RLCC_GLPE_RLC_ERRINFO_ERROR_INST_S 4
#define IG3_RLCC_GLPE_RLC_ERRINFO_ERROR_INST_M RDMA_MASK3(32, 0x7, IG3_RLCC_GLPE_RLC_ERRINFO_ERROR_INST_S)
#define IG3_RLCC_GLPE_RLC_ERRINFO_RSVD0_S 1
#define IG3_RLCC_GLPE_RLC_ERRINFO_RSVD0_M RDMA_MASK3(32, 0x7, IG3_RLCC_GLPE_RLC_ERRINFO_RSVD0_S)
#define IG3_RLCC_GLPE_RLC_ERRINFO_ERROR_VALID_S 0
#define IG3_RLCC_GLPE_RLC_ERRINFO_ERROR_VALID_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLC_ERRINFO_ERROR_VALID_S)
#define IG3_RLCC_GLPE_RLDATA 0x420E2414
#define IG3_RLCC_GLPE_RLDATA_RL_DATA_S 0
#define IG3_RLCC_GLPE_RLDATA_RL_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RLCC_GLPE_RLDATA_RL_DATA_S)
#define IG3_RLCC_GLPE_RLQUERY(_i) 0x420E2400 + ((_i) * 4) /* _i=0...1 */
#define IG3_RLCC_GLPE_RLQUERY_MAX_INDEX_I 1
#define IG3_RLCC_GLPE_RLQUERY_RSVD_S 12
#define IG3_RLCC_GLPE_RLQUERY_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RLCC_GLPE_RLQUERY_RSVD_S)
#define IG3_RLCC_GLPE_RLQUERY_RLINDEX_S 0
#define IG3_RLCC_GLPE_RLQUERY_RLINDEX_M RDMA_MASK3(32, 0xFFF, IG3_RLCC_GLPE_RLQUERY_RLINDEX_S)
#define IG3_RLCC_GLPE_RLSTAT(_i) 0x420E2408 + ((_i) * 4) /* _i=0...1 */
#define IG3_RLCC_GLPE_RLSTAT_MAX_INDEX_I 1
#define IG3_RLCC_GLPE_RLSTAT_RSVD_S 2
#define IG3_RLCC_GLPE_RLSTAT_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_RLCC_GLPE_RLSTAT_RSVD_S)
#define IG3_RLCC_GLPE_RLSTAT_RL_EMPTY_S 1
#define IG3_RLCC_GLPE_RLSTAT_RL_EMPTY_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLSTAT_RL_EMPTY_S)
#define IG3_RLCC_GLPE_RLSTAT_QUERY_DONE_S 0
#define IG3_RLCC_GLPE_RLSTAT_QUERY_DONE_M RDMA_BIT2(32, IG3_RLCC_GLPE_RLSTAT_QUERY_DONE_S)
#define IG3_CEH_GLGEN_PE_STOP_SCREAM_RAS 0x420E2830
#define IG3_CEH_GLGEN_PE_STOP_SCREAM_RAS_RSVD_S 3
#define IG3_CEH_GLGEN_PE_STOP_SCREAM_RAS_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_CEH_GLGEN_PE_STOP_SCREAM_RAS_RSVD_S)
#define IG3_CEH_GLGEN_PE_STOP_SCREAM_RAS_DISABLE_S 2
#define IG3_CEH_GLGEN_PE_STOP_SCREAM_RAS_DISABLE_M RDMA_BIT2(32, IG3_CEH_GLGEN_PE_STOP_SCREAM_RAS_DISABLE_S)
#define IG3_CEH_GLGEN_PE_STOP_SCREAM_RAS_STOP_SCREAM_STAT_S 0
#define IG3_CEH_GLGEN_PE_STOP_SCREAM_RAS_STOP_SCREAM_STAT_M RDMA_MASK3(32, 0x3, IG3_CEH_GLGEN_PE_STOP_SCREAM_RAS_STOP_SCREAM_STAT_S)
#define IG3_CEH_GLPE_CRITERR_MODMASK 0x420E2804
#define IG3_CEH_GLPE_CRITERR_MODMASK_MODULE_MASK0_S 1
#define IG3_CEH_GLPE_CRITERR_MODMASK_MODULE_MASK0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CEH_GLPE_CRITERR_MODMASK_MODULE_MASK0_S)
#define IG3_CEH_GLPE_CRITERR_MODMASK_RSVD_S 0
#define IG3_CEH_GLPE_CRITERR_MODMASK_RSVD_M RDMA_BIT2(32, IG3_CEH_GLPE_CRITERR_MODMASK_RSVD_S)
#define IG3_CEH_GLPE_CRITERR_MODMASK1 0x420E2808
#define IG3_CEH_GLPE_CRITERR_MODMASK1_MODULE_MASK_S 0
#define IG3_CEH_GLPE_CRITERR_MODMASK1_MODULE_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CEH_GLPE_CRITERR_MODMASK1_MODULE_MASK_S)
#define IG3_CEH_GLPE_CRITERR_MODMASK2 0x420E280C
#define IG3_CEH_GLPE_CRITERR_MODMASK2_MODULE_MASK_S 0
#define IG3_CEH_GLPE_CRITERR_MODMASK2_MODULE_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CEH_GLPE_CRITERR_MODMASK2_MODULE_MASK_S)
#define IG3_CEH_GLPE_CRITERR_STATUS 0x420E2800
#define IG3_CEH_GLPE_CRITERR_STATUS_RSVD_S 17
#define IG3_CEH_GLPE_CRITERR_STATUS_RSVD_M RDMA_MASK3(32, 0x7FFF, IG3_CEH_GLPE_CRITERR_STATUS_RSVD_S)
#define IG3_CEH_GLPE_CRITERR_STATUS_ERROR_SET_S 16
#define IG3_CEH_GLPE_CRITERR_STATUS_ERROR_SET_M RDMA_BIT2(32, IG3_CEH_GLPE_CRITERR_STATUS_ERROR_SET_S)
#define IG3_CEH_GLPE_CRITERR_STATUS_ERROR_MODULE_S 8
#define IG3_CEH_GLPE_CRITERR_STATUS_ERROR_MODULE_M RDMA_MASK3(32, 0xFF, IG3_CEH_GLPE_CRITERR_STATUS_ERROR_MODULE_S)
#define IG3_CEH_GLPE_CRITERR_STATUS_ERROR_TYPE_S 6
#define IG3_CEH_GLPE_CRITERR_STATUS_ERROR_TYPE_M RDMA_MASK3(32, 0x3, IG3_CEH_GLPE_CRITERR_STATUS_ERROR_TYPE_S)
#define IG3_CEH_GLPE_CRITERR_STATUS_ERROR_INST_S 0
#define IG3_CEH_GLPE_CRITERR_STATUS_ERROR_INST_M RDMA_MASK3(32, 0x3F, IG3_CEH_GLPE_CRITERR_STATUS_ERROR_INST_S)
#define IG3_CEH_GLPE_CRITERR_TRGTMASK(_i) 0x420E2810 + ((_i) * 4) /* _i=0...7 */
#define IG3_CEH_GLPE_CRITERR_TRGTMASK_MAX_INDEX_I 7
#define IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_1_MODULE_S 24
#define IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_1_MODULE_M RDMA_MASK3(32, 0xFF, IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_1_MODULE_S)
#define IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_1_TYPE_S 22
#define IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_1_TYPE_M RDMA_MASK3(32, 0x3, IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_1_TYPE_S)
#define IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_1_INST_S 16
#define IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_1_INST_M RDMA_MASK3(32, 0x3F, IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_1_INST_S)
#define IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_0_MODULE_S 8
#define IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_0_MODULE_M RDMA_MASK3(32, 0xFF, IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_0_MODULE_S)
#define IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_0_TYPE_S 6
#define IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_0_TYPE_M RDMA_MASK3(32, 0x3, IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_0_TYPE_S)
#define IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_0_INST_S 0
#define IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_0_INST_M RDMA_MASK3(32, 0x3F, IG3_CEH_GLPE_CRITERR_TRGTMASK_TRGT_MATCH_0_INST_S)
#define IG3_TMGR_GLPE_TMGR_CLIENTREQ_HI 0x420E2C44
#define IG3_TMGR_GLPE_TMGR_CLIENTREQ_HI_CLIENTREQ_HI_S 0
#define IG3_TMGR_GLPE_TMGR_CLIENTREQ_HI_CLIENTREQ_HI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_CLIENTREQ_HI_CLIENTREQ_HI_S)
#define IG3_TMGR_GLPE_TMGR_CLIENTREQ_LO 0x420E2C40
#define IG3_TMGR_GLPE_TMGR_CLIENTREQ_LO_CLIENTREQ_LO_S 0
#define IG3_TMGR_GLPE_TMGR_CLIENTREQ_LO_CLIENTREQ_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_CLIENTREQ_LO_CLIENTREQ_LO_S)
#define IG3_TMGR_GLPE_TMGR_CLIENTRESP_HI 0x420E2C4C
#define IG3_TMGR_GLPE_TMGR_CLIENTRESP_HI_CLIENTRESP_HI_S 0
#define IG3_TMGR_GLPE_TMGR_CLIENTRESP_HI_CLIENTRESP_HI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_CLIENTRESP_HI_CLIENTRESP_HI_S)
#define IG3_TMGR_GLPE_TMGR_CLIENTRESP_LO 0x420E2C48
#define IG3_TMGR_GLPE_TMGR_CLIENTRESP_LO_CLIENTRESP_LO_S 0
#define IG3_TMGR_GLPE_TMGR_CLIENTRESP_LO_CLIENTRESP_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_CLIENTRESP_LO_CLIENTRESP_LO_S)
#define IG3_TMGR_GLPE_TMGR_CMSNOOPMISS_HI 0x420E2C64
#define IG3_TMGR_GLPE_TMGR_CMSNOOPMISS_HI_CMSNOOPMISS_HI_S 0
#define IG3_TMGR_GLPE_TMGR_CMSNOOPMISS_HI_CMSNOOPMISS_HI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_CMSNOOPMISS_HI_CMSNOOPMISS_HI_S)
#define IG3_TMGR_GLPE_TMGR_CMSNOOPMISS_LO 0x420E2C60
#define IG3_TMGR_GLPE_TMGR_CMSNOOPMISS_LO_CMSNOOPMISS_LOW_S 0
#define IG3_TMGR_GLPE_TMGR_CMSNOOPMISS_LO_CMSNOOPMISS_LOW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_CMSNOOPMISS_LO_CMSNOOPMISS_LOW_S)
#define IG3_TMGR_GLPE_TMGR_CMSNOOPREQ_HI 0x420E2C54
#define IG3_TMGR_GLPE_TMGR_CMSNOOPREQ_HI_CMSNOOPREQ_HI_S 0
#define IG3_TMGR_GLPE_TMGR_CMSNOOPREQ_HI_CMSNOOPREQ_HI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_CMSNOOPREQ_HI_CMSNOOPREQ_HI_S)
#define IG3_TMGR_GLPE_TMGR_CMSNOOPREQ_LO 0x420E2C50
#define IG3_TMGR_GLPE_TMGR_CMSNOOPREQ_LO_CMSNOOPREQ_LO_S 0
#define IG3_TMGR_GLPE_TMGR_CMSNOOPREQ_LO_CMSNOOPREQ_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_CMSNOOPREQ_LO_CMSNOOPREQ_LO_S)
#define IG3_TMGR_GLPE_TMGR_CMSNOOPRESP_HI 0x420E2C5C
#define IG3_TMGR_GLPE_TMGR_CMSNOOPRESP_HI_CMSNOOPRESP_HI_S 0
#define IG3_TMGR_GLPE_TMGR_CMSNOOPRESP_HI_CMSNOOPRESP_HI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_CMSNOOPRESP_HI_CMSNOOPRESP_HI_S)
#define IG3_TMGR_GLPE_TMGR_CMSNOOPRESP_LO 0x420E2C58
#define IG3_TMGR_GLPE_TMGR_CMSNOOPRESP_LO_CMSNOOPRESP_LO_S 0
#define IG3_TMGR_GLPE_TMGR_CMSNOOPRESP_LO_CMSNOOPRESP_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_CMSNOOPRESP_LO_CMSNOOPRESP_LO_S)
#define IG3_TMGR_GLPE_TMGR_COALESCE_HI 0x420E2C3C
#define IG3_TMGR_GLPE_TMGR_COALESCE_HI_COALESCE_HI_S 0
#define IG3_TMGR_GLPE_TMGR_COALESCE_HI_COALESCE_HI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_COALESCE_HI_COALESCE_HI_S)
#define IG3_TMGR_GLPE_TMGR_COALESCE_LO 0x420E2C38
#define IG3_TMGR_GLPE_TMGR_COALESCE_LO_COALESCE_LO_S 0
#define IG3_TMGR_GLPE_TMGR_COALESCE_LO_COALESCE_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_COALESCE_LO_COALESCE_LO_S)
#define IG3_TMGR_GLPE_TMGR_CONFIG(_i) 0x420E2C04 + ((_i) * 4) /* _i=0...4 */
#define IG3_TMGR_GLPE_TMGR_CONFIG_MAX_INDEX_I 4
#define IG3_TMGR_GLPE_TMGR_CONFIG_RSVD2_S 25
#define IG3_TMGR_GLPE_TMGR_CONFIG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_TMGR_GLPE_TMGR_CONFIG_RSVD2_S)
#define IG3_TMGR_GLPE_TMGR_CONFIG_NUM_AVAIL_OFFSET_S 16
#define IG3_TMGR_GLPE_TMGR_CONFIG_NUM_AVAIL_OFFSET_M RDMA_MASK3(32, 0x1FF, IG3_TMGR_GLPE_TMGR_CONFIG_NUM_AVAIL_OFFSET_S)
#define IG3_TMGR_GLPE_TMGR_CONFIG_RSVD1_S 10
#define IG3_TMGR_GLPE_TMGR_CONFIG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_TMGR_GLPE_TMGR_CONFIG_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_CONFIG_SEL_MODE_S 8
#define IG3_TMGR_GLPE_TMGR_CONFIG_SEL_MODE_M RDMA_MASK3(32, 0x3, IG3_TMGR_GLPE_TMGR_CONFIG_SEL_MODE_S)
#define IG3_TMGR_GLPE_TMGR_CONFIG_RSVD0_S 5
#define IG3_TMGR_GLPE_TMGR_CONFIG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_TMGR_GLPE_TMGR_CONFIG_RSVD0_S)
#define IG3_TMGR_GLPE_TMGR_CONFIG_TILE_ASSIGNMENT_S 0
#define IG3_TMGR_GLPE_TMGR_CONFIG_TILE_ASSIGNMENT_M RDMA_MASK3(32, 0x1F, IG3_TMGR_GLPE_TMGR_CONFIG_TILE_ASSIGNMENT_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL 0x420E2C2C
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_DEBUG_MODE_S 16
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_DEBUG_MODE_M RDMA_MASK3(32, 0xFFFF, IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_DEBUG_MODE_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_DEBUG_VALUE_S 4
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_DEBUG_VALUE_M RDMA_MASK3(32, 0xFFF, IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_DEBUG_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_SW_RESET_S 3
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_SW_RESET_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_SW_RESET_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_ENABLE_STATS_S 2
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_ENABLE_STATS_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_ENABLE_STATS_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_CLEAR_STATS_S 1
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_CLEAR_STATS_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_CLEAR_STATS_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_STOP_CLIENT_IF_S 0
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_STOP_CLIENT_IF_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DEBUG_STATS_CTL_STOP_CLIENT_IF_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1 0x420E2C30
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_RSVD1_S 31
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_RSVD1_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_ORD_FIFO_DOUT_CLIENT_ID_S 27
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_ORD_FIFO_DOUT_CLIENT_ID_M RDMA_MASK3(32, 0xF, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_ORD_FIFO_DOUT_CLIENT_ID_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_PKT_CNT_COMPLETE_WR_ERR_S 26
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_PKT_CNT_COMPLETE_WR_ERR_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_PKT_CNT_COMPLETE_WR_ERR_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_ORD_FIFO_OVERFLOW_S 25
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_ORD_FIFO_OVERFLOW_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_ORD_FIFO_OVERFLOW_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_ORD_FIFO_UNDERFLOW_S 24
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_ORD_FIFO_UNDERFLOW_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_ORD_FIFO_UNDERFLOW_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_ORD_FIFO_FULL_SPACE_S 18
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_ORD_FIFO_FULL_SPACE_M RDMA_MASK3(32, 0x3F, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_ORD_FIFO_FULL_SPACE_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_PKT_CNT_PENDING_WR_ERR_S 17
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_PKT_CNT_PENDING_WR_ERR_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_PKT_CNT_PENDING_WR_ERR_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_REQ_FIFO_OVERFLOW_S 16
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_REQ_FIFO_OVERFLOW_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_REQ_FIFO_OVERFLOW_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_REQ_FIFO_UNDERFLOW_S 15
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_REQ_FIFO_UNDERFLOW_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_REQ_FIFO_UNDERFLOW_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_REQ_FIFO_FULL_SPACE_S 9
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_REQ_FIFO_FULL_SPACE_M RDMA_MASK3(32, 0x3F, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_REQ_FIFO_FULL_SPACE_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_PKT_CNT_OUTSTANDING_WR_ERR_S 8
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_PKT_CNT_OUTSTANDING_WR_ERR_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_PKT_CNT_OUTSTANDING_WR_ERR_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_OUT_FIFO_OVERFLOW_S 7
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_OUT_FIFO_OVERFLOW_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_OUT_FIFO_OVERFLOW_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_OUT_FIFO_UNDERFLOW_S 6
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_OUT_FIFO_UNDERFLOW_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_OUT_FIFO_UNDERFLOW_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_OUT_FIFO_FULL_SPACE_S 0
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_OUT_FIFO_FULL_SPACE_M RDMA_MASK3(32, 0x3F, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS1_CSR_OUT_FIFO_FULL_SPACE_S)
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS2 0x420E2C34
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS2_TMGR_DEBUG_STATUS2_S 0
#define IG3_TMGR_GLPE_TMGR_DEBUG_STATUS2_TMGR_DEBUG_STATUS2_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_DEBUG_STATUS2_TMGR_DEBUG_STATUS2_S)
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_COUNT 0x420E2CB8
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_TMGR_GLPE_TMGR_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_TMGR_GLPE_TMGR_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_CMD 0x420E2CCC
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_DATA_H 0x420E2CD8
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_DATA_L 0x420E2CD4
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_PTR 0x420E2CD0
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_TMGR_GLPE_TMGR_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_CMD 0x420E2CBC
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_DATA_H 0x420E2CC8
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_DATA_L 0x420E2CC4
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_PTR 0x420E2CC0
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_TMGR_GLPE_TMGR_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL 0x420E2C80
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_RSVD1_S 25
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_TMGR_GLPE_TMGR_DTM_CONTROL_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_RSVD2_S 17
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_TMGR_GLPE_TMGR_DTM_CONTROL_RSVD2_S)
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_RSVD3_S 9
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_TMGR_GLPE_TMGR_DTM_CONTROL_RSVD3_S)
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_BYPASS_S 8
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_CONTROL_BYPASS_S)
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_RSVD4_S 1
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_TMGR_GLPE_TMGR_DTM_CONTROL_RSVD4_S)
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_CONTROL_LOCAL_EN_S)
#define IG3_TMGR_GLPE_TMGR_DTM_ECC_COR_ERR 0x420E2CE8
#define IG3_TMGR_GLPE_TMGR_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_TMGR_GLPE_TMGR_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TMGR_GLPE_TMGR_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_TMGR_GLPE_TMGR_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TMGR_GLPE_TMGR_DTM_ECC_COR_ERR_CNT_S)
#define IG3_TMGR_GLPE_TMGR_DTM_ECC_UNCOR_ERR 0x420E2CE4
#define IG3_TMGR_GLPE_TMGR_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TMGR_GLPE_TMGR_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TMGR_GLPE_TMGR_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TMGR_GLPE_TMGR_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TMGR_GLPE_TMGR_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_TMGR_GLPE_TMGR_DTM_GROUP_CFG 0x420E2C8C
#define IG3_TMGR_GLPE_TMGR_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_TMGR_GLPE_TMGR_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_TMGR_GLPE_TMGR_DTM_GROUP_CFG_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_TMGR_GLPE_TMGR_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_TMGR_GLPE_TMGR_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_TMGR_GLPE_TMGR_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_TMGR_GLPE_TMGR_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_TMGR_GLPE_TMGR_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_TMGR_GLPE_TMGR_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_TMGR_GLPE_TMGR_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_TMGR_GLPE_TMGR_DTM_LOG_CFG 0x420E2C90
#define IG3_TMGR_GLPE_TMGR_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_TMGR_GLPE_TMGR_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_TMGR_GLPE_TMGR_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_TMGR_GLPE_TMGR_DTM_LOG_CFG_RSVD1_S 2
#define IG3_TMGR_GLPE_TMGR_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_TMGR_GLPE_TMGR_DTM_LOG_CFG_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_DTM_LOG_CFG_MODE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_TMGR_GLPE_TMGR_DTM_LOG_CFG_MODE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_LOG_MASK 0x420E2C98
#define IG3_TMGR_GLPE_TMGR_DTM_LOG_MASK_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_DTM_LOG_MASK_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_LOG_PATTERN 0x420E2C94
#define IG3_TMGR_GLPE_TMGR_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_DTM_LOG_PATTERN_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG 0x420E2C84
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_RSVD2_S)
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_RSVD3_S)
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_STS 0x420E2C88
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_STS_RSVD1_S 9
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_TMGR_GLPE_TMGR_DTM_MAIN_STS_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_STS_RSVD2_S 1
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_TMGR_GLPE_TMGR_DTM_MAIN_STS_RSVD2_S)
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TIMESTAMP 0x420E2CB0
#define IG3_TMGR_GLPE_TMGR_DTM_TIMESTAMP_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_DTM_TIMESTAMP_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TIMESTAMP_ROLLOVER 0x420E2CB4
#define IG3_TMGR_GLPE_TMGR_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG 0x420E2CDC
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS 0x420E2CE0
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TMGR_GLPE_TMGR_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG 0x420E2C9C
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_RSVD2_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_MODE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_TMGR_GLPE_TMGR_DTM_TRIG_CFG_MODE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_COUNT 0x420E2CA8
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_DTM_TRIG_COUNT_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_MASK 0x420E2CA4
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_MASK_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_DTM_TRIG_MASK_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_PATTERN 0x420E2CA0
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_TIMESTAMP 0x420E2CAC
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_TMGR_GLPE_TMGR_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TMGR_GLPE_TMGR_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_TMGR_GLPE_TMGR_SELECTION 0x420E2C00
#define IG3_TMGR_GLPE_TMGR_SELECTION_RSVD1_S 3
#define IG3_TMGR_GLPE_TMGR_SELECTION_RSVD1_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_TMGR_GLPE_TMGR_SELECTION_RSVD1_S)
#define IG3_TMGR_GLPE_TMGR_SELECTION_TILE_ASSIGNMENT_S 0
#define IG3_TMGR_GLPE_TMGR_SELECTION_TILE_ASSIGNMENT_M RDMA_MASK3(32, 0x7, IG3_TMGR_GLPE_TMGR_SELECTION_TILE_ASSIGNMENT_S)
#define IG3_TMGR_GLPE_TMGR_STATUS(_i) 0x420E2C18 + ((_i) * 4) /* _i=0...4 */
#define IG3_TMGR_GLPE_TMGR_STATUS_MAX_INDEX_I 4
#define IG3_TMGR_GLPE_TMGR_STATUS_RSVD_S 16
#define IG3_TMGR_GLPE_TMGR_STATUS_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_TMGR_GLPE_TMGR_STATUS_RSVD_S)
#define IG3_TMGR_GLPE_TMGR_STATUS_NUM_CACHELINE_S 0
#define IG3_TMGR_GLPE_TMGR_STATUS_NUM_CACHELINE_M RDMA_MASK3(32, 0xFFFF, IG3_TMGR_GLPE_TMGR_STATUS_NUM_CACHELINE_S)
#define IG3_SQCE_GLPE_SQCE_CONFIG 0x420E3070
#define IG3_SQCE_GLPE_SQCE_CONFIG_RSVD_S 3
#define IG3_SQCE_GLPE_SQCE_CONFIG_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SQCE_GLPE_SQCE_CONFIG_RSVD_S)
#define IG3_SQCE_GLPE_SQCE_CONFIG_CRT_XMIT_RAM_EN_S 2
#define IG3_SQCE_GLPE_SQCE_CONFIG_CRT_XMIT_RAM_EN_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_CONFIG_CRT_XMIT_RAM_EN_S)
#define IG3_SQCE_GLPE_SQCE_CONFIG_DBL_DIS_S 1
#define IG3_SQCE_GLPE_SQCE_CONFIG_DBL_DIS_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_CONFIG_DBL_DIS_S)
#define IG3_SQCE_GLPE_SQCE_CONFIG_COALESCE_DIS_S 0
#define IG3_SQCE_GLPE_SQCE_CONFIG_COALESCE_DIS_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_CONFIG_COALESCE_DIS_S)
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_COUNT 0x420E30B8
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQCE_GLPE_SQCE_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQCE_GLPE_SQCE_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_CMD 0x420E30CC
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_DATA_H 0x420E30D8
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_DATA_L 0x420E30D4
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_PTR 0x420E30D0
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQCE_GLPE_SQCE_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_CMD 0x420E30BC
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_DATA_H 0x420E30C8
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_DATA_L 0x420E30C4
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_PTR 0x420E30C0
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQCE_GLPE_SQCE_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL 0x420E3080
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_RSVD1_S 25
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SQCE_GLPE_SQCE_DTM_CONTROL_RSVD1_S)
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_RSVD2_S 17
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQCE_GLPE_SQCE_DTM_CONTROL_RSVD2_S)
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_RSVD3_S 9
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SQCE_GLPE_SQCE_DTM_CONTROL_RSVD3_S)
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_BYPASS_S 8
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_CONTROL_BYPASS_S)
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_RSVD4_S 1
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SQCE_GLPE_SQCE_DTM_CONTROL_RSVD4_S)
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SQCE_GLPE_SQCE_DTM_ECC_COR_ERR 0x420E30E8
#define IG3_SQCE_GLPE_SQCE_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SQCE_GLPE_SQCE_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQCE_GLPE_SQCE_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SQCE_GLPE_SQCE_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQCE_GLPE_SQCE_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SQCE_GLPE_SQCE_DTM_ECC_UNCOR_ERR 0x420E30E4
#define IG3_SQCE_GLPE_SQCE_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SQCE_GLPE_SQCE_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQCE_GLPE_SQCE_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SQCE_GLPE_SQCE_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQCE_GLPE_SQCE_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SQCE_GLPE_SQCE_DTM_GROUP_CFG 0x420E308C
#define IG3_SQCE_GLPE_SQCE_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SQCE_GLPE_SQCE_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SQCE_GLPE_SQCE_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SQCE_GLPE_SQCE_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SQCE_GLPE_SQCE_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SQCE_GLPE_SQCE_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SQCE_GLPE_SQCE_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SQCE_GLPE_SQCE_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SQCE_GLPE_SQCE_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SQCE_GLPE_SQCE_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SQCE_GLPE_SQCE_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SQCE_GLPE_SQCE_DTM_LOG_CFG 0x420E3090
#define IG3_SQCE_GLPE_SQCE_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SQCE_GLPE_SQCE_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SQCE_GLPE_SQCE_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SQCE_GLPE_SQCE_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SQCE_GLPE_SQCE_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SQCE_GLPE_SQCE_DTM_LOG_CFG_RSVD1_S)
#define IG3_SQCE_GLPE_SQCE_DTM_LOG_CFG_MODE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SQCE_GLPE_SQCE_DTM_LOG_CFG_MODE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_LOG_MASK 0x420E3098
#define IG3_SQCE_GLPE_SQCE_DTM_LOG_MASK_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQCE_GLPE_SQCE_DTM_LOG_MASK_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_LOG_PATTERN 0x420E3094
#define IG3_SQCE_GLPE_SQCE_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQCE_GLPE_SQCE_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG 0x420E3084
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_STS 0x420E3088
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SQCE_GLPE_SQCE_DTM_MAIN_STS_RSVD1_S)
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQCE_GLPE_SQCE_DTM_MAIN_STS_RSVD2_S)
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TIMESTAMP 0x420E30B0
#define IG3_SQCE_GLPE_SQCE_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQCE_GLPE_SQCE_DTM_TIMESTAMP_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TIMESTAMP_ROLLOVER 0x420E30B4
#define IG3_SQCE_GLPE_SQCE_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQCE_GLPE_SQCE_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG 0x420E30DC
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS 0x420E30E0
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG 0x420E309C
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_MODE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SQCE_GLPE_SQCE_DTM_TRIG_CFG_MODE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_COUNT 0x420E30A8
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQCE_GLPE_SQCE_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_MASK 0x420E30A4
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQCE_GLPE_SQCE_DTM_TRIG_MASK_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_PATTERN 0x420E30A0
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQCE_GLPE_SQCE_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_TIMESTAMP 0x420E30AC
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SQCE_GLPE_SQCE_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQCE_GLPE_SQCE_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SQCE_GLPE_SQCE_FWFLRDROP(_i) 0x420E3040 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQCE_GLPE_SQCE_FWFLRDROP_MAX_INDEX_I 7
#define IG3_SQCE_GLPE_SQCE_FWFLRDROP_EN_S 31
#define IG3_SQCE_GLPE_SQCE_FWFLRDROP_EN_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_FWFLRDROP_EN_S)
#define IG3_SQCE_GLPE_SQCE_FWFLRDROP_RSVD0_S 12
#define IG3_SQCE_GLPE_SQCE_FWFLRDROP_RSVD0_M RDMA_MASK3(32, 0x7FFFF, IG3_SQCE_GLPE_SQCE_FWFLRDROP_RSVD0_S)
#define IG3_SQCE_GLPE_SQCE_FWFLRDROP_PMF_S 0
#define IG3_SQCE_GLPE_SQCE_FWFLRDROP_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQCE_GLPE_SQCE_FWFLRDROP_PMF_S)
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHHI 0x420E3060
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHHI_RSVD0_S 26
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHHI_RSVD0_S)
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHHI_QPID_S 6
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHHI_QPID_S)
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHHI_PF_NUM_S 0
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHHI_PF_NUM_S)
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO 0x420E3064
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_BUSY_S 31
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_BUSY_S)
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_REQ_TYPE_S 30
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_REQ_TYPE_S)
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_RSVD0_S 29
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_RSVD0_S)
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_HOSTID_S 26
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_HOSTID_S)
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_VM_VF_NUM_S)
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_PMF_S 0
#define IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQCE_GLPE_SQCE_FWFLRQPFLUSHLO_PMF_S)
#define IG3_SQCE_GLPE_SQCE_FWSYNCRESP(_i) 0x420E3068 + ((_i) * 4) /* _i=0...1 */
#define IG3_SQCE_GLPE_SQCE_FWSYNCRESP_MAX_INDEX_I 1
#define IG3_SQCE_GLPE_SQCE_FWSYNCRESP_RSVD_S 18
#define IG3_SQCE_GLPE_SQCE_FWSYNCRESP_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_SQCE_GLPE_SQCE_FWSYNCRESP_RSVD_S)
#define IG3_SQCE_GLPE_SQCE_FWSYNCRESP_COUNT_S 8
#define IG3_SQCE_GLPE_SQCE_FWSYNCRESP_COUNT_M RDMA_MASK3(32, 0x3FF, IG3_SQCE_GLPE_SQCE_FWSYNCRESP_COUNT_S)
#define IG3_SQCE_GLPE_SQCE_FWSYNCRESP_TAG_S 0
#define IG3_SQCE_GLPE_SQCE_FWSYNCRESP_TAG_M RDMA_MASK3(32, 0xFF, IG3_SQCE_GLPE_SQCE_FWSYNCRESP_TAG_S)
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPHI(_i) 0x420E3020 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPHI_MAX_INDEX_I 7
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPHI_RSVD0_S 26
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_SQCE_GPLE_SQCE_FWFLUSHDROPHI_RSVD0_S)
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPHI_QPID_S 6
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_SQCE_GPLE_SQCE_FWFLUSHDROPHI_QPID_S)
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPHI_PF_NUM_S 0
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_SQCE_GPLE_SQCE_FWFLUSHDROPHI_PF_NUM_S)
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO(_i) 0x420E3000 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_MAX_INDEX_I 7
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_EN_S 31
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_EN_M RDMA_BIT2(32, IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_EN_S)
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_RSVD0_S 29
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_RSVD0_S)
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_HOSTID_S 26
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_HOSTID_S)
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_VM_VF_TYPE_S 24
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_VM_VF_TYPE_S)
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_VM_VF_NUM_S 12
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_VM_VF_NUM_S)
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_PMF_S 0
#define IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQCE_GPLE_SQCE_FWFLUSHDROPLO_PMF_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG 0x420E3100
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ECC_INST_NUM_S 25
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ECC_INST_NUM_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RSVD3_S 20
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RSVD3_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RM_S 16
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RM_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RSVD2_S 14
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RSVD2_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_POWER_GATE_EN_S 13
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_POWER_GATE_EN_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RME_S 12
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RME_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RME_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RSVD1_S 10
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RSVD1_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ERR_CNT_S 9
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ERR_CNT_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_FIX_CNT_S 8
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_FIX_CNT_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RSVD0_S 6
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_RSVD0_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_MASK_INT_S 5
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_MASK_INT_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_LS_BYPASS_S 4
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_LS_BYPASS_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_LS_FORCE_S 3
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_LS_FORCE_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ECC_INVERT_2_S 2
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ECC_INVERT_2_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ECC_INVERT_1_S 1
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ECC_INVERT_1_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ECC_EN_S 0
#define IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_PTR_CFG_ECC_EN_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS 0x420E3104
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_RSVD1_S 30
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_RSVD1_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_RSVD0_S 4
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_RSVD0_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_INIT_DONE_S 2
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_INIT_DONE_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_ECC_FIX_S 1
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_ECC_FIX_S)
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_ECC_ERR_S 0
#define IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_PTR_STATUS_ECC_ERR_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG 0x420E3108
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ECC_INST_NUM_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RSVD3_S 20
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RSVD3_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RM_S 16
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RM_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RSVD2_S 14
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RSVD2_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_POWER_GATE_EN_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RME_S 12
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RME_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RME_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RSVD1_S 10
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RSVD1_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ERR_CNT_S 9
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ERR_CNT_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_FIX_CNT_S 8
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_FIX_CNT_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RSVD0_S 6
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_RSVD0_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_MASK_INT_S 5
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_MASK_INT_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_LS_BYPASS_S 4
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_LS_BYPASS_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_LS_FORCE_S 3
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_LS_FORCE_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ECC_INVERT_2_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ECC_INVERT_1_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ECC_EN_S 0
#define IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_RAM_CFG_ECC_EN_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS 0x420E310C
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_RSVD1_S 30
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_RSVD1_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_RSVD0_S 4
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_RSVD0_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_INIT_DONE_S 2
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_INIT_DONE_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_ECC_FIX_S 1
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_ECC_FIX_S)
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_ECC_ERR_S 0
#define IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQCE_SQCE_CRTBUF_RAM_STATUS_ECC_ERR_S)
#define IG3_SQCE_SQCE_ECC_COR_ERR 0x420E311C
#define IG3_SQCE_SQCE_ECC_COR_ERR_RSVD_S 12
#define IG3_SQCE_SQCE_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQCE_SQCE_ECC_COR_ERR_RSVD_S)
#define IG3_SQCE_SQCE_ECC_COR_ERR_CNT_S 0
#define IG3_SQCE_SQCE_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQCE_SQCE_ECC_COR_ERR_CNT_S)
#define IG3_SQCE_SQCE_ECC_UNCOR_ERR 0x420E3118
#define IG3_SQCE_SQCE_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SQCE_SQCE_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQCE_SQCE_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SQCE_SQCE_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SQCE_SQCE_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQCE_SQCE_ECC_UNCOR_ERR_CNT_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG 0x420E3110
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ECC_INST_NUM_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RSVD3_S 20
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RSVD3_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RM_S 16
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RM_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RSVD2_S 14
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RSVD2_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_POWER_GATE_EN_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RME_S 12
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RME_M RDMA_BIT2(32, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RME_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RSVD1_S 10
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RSVD1_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ERR_CNT_S 9
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ERR_CNT_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_FIX_CNT_S 8
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_FIX_CNT_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RSVD0_S 6
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_RSVD0_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_MASK_INT_S 5
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_MASK_INT_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_LS_BYPASS_S 4
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_LS_BYPASS_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_LS_FORCE_S 3
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_LS_FORCE_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ECC_INVERT_2_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ECC_INVERT_1_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ECC_EN_S 0
#define IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQCE_SQCE_SCN_DBL_RAM_CFG_ECC_EN_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS 0x420E3114
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_RSVD1_S 30
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_RSVD1_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_RSVD0_S 4
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_RSVD0_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_INIT_DONE_S 2
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_INIT_DONE_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_ECC_FIX_S 1
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_ECC_FIX_S)
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_ECC_ERR_S 0
#define IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQCE_SQCE_SCN_DBL_RAM_STATUS_ECC_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0 0x420E3404
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RSVD_S 26
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RSVD_M RDMA_MASK3(32, 0x3F, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RSVD_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_CORE_FAT_ERR_S 25
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_CORE_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_CORE_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_STATS_FAT_ERR_S 24
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_STATS_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_STATS_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_CPUW_FAT_ERR_S 23
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_CPUW_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_CPUW_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX4_FAT_ERR_S 22
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX4_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX4_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX3_FAT_ERR_S 21
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX3_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX3_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX2_FAT_ERR_S 20
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX2_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX2_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX1_FAT_ERR_S 19
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX1_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX1_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX0_FAT_ERR_S 18
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX0_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TX0_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX4_FAT_ERR_S 17
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX4_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX4_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX3_FAT_ERR_S 16
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX3_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX3_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX2_FAT_ERR_S 15
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX2_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX2_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX1_FAT_ERR_S 14
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX1_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX1_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX0_FAT_ERR_S 13
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX0_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_RX0_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX4_FAT_ERR_S 12
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX4_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX4_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX3_FAT_ERR_S 11
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX3_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX3_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX2_FAT_ERR_S 10
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX2_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX2_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX1_FAT_ERR_S 9
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX1_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX1_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX0_FAT_ERR_S 8
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX0_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DRX0_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DBL_FAT_ERR_S 7
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DBL_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_DBL_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TOC_FAT_ERR_S 6
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TOC_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_TOC_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_XOC_FAT_ERR_S 5
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_XOC_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_XOC_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_Q1OC_FAT_ERR_S 4
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_Q1OC_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_Q1OC_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_CQOC_FAT_ERR_S 3
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_CQOC_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_CQOC_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_MROC_FAT_ERR_S 2
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_MROC_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_MROC_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_PBLOC1_FAT_ERR_S 1
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_PBLOC1_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_PBLOC1_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_PBLOC0_FAT_ERR_S 0
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR0_PBLOC0_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR0_PBLOC0_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1 0x420E3408
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_RSVD_S 16
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_RSVD_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM4_FAT_ERR_S 15
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM4_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM4_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM3_FAT_ERR_S 14
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM3_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM3_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM2_FAT_ERR_S 13
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM2_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM2_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM1_FAT_ERR_S 12
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM1_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM1_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM0_FAT_ERR_S 11
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM0_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CPM0_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_PMAT_FAT_ERR_S 10
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_PMAT_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_PMAT_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_MSOC_FAT_ERR_S 9
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_MSOC_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_MSOC_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_FLOC_FAT_ERR_S 8
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_FLOC_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_FLOC_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CRX_FAT_ERR_S 7
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CRX_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CRX_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_BRX_FAT_ERR_S 6
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_BRX_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_BRX_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_AMP_FAT_ERR_S 5
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_AMP_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_AMP_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CQM_FAT_ERR_S 4
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CQM_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_CQM_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_TSCD_FAT_ERR_S 3
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_TSCD_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_TSCD_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_RMI1_FAT_ERR_S 2
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_RMI1_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_RMI1_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_RMI0_FAT_ERR_S 1
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_RMI0_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_RMI0_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_RHI_FAT_ERR_S 0
#define IG3_STOP_SCREAM_RDMA_FATAL_ECR1_RHI_FAT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_ECR1_RHI_FAT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0 0x420E340C
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RSVD_S 26
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RSVD_M RDMA_MASK3(32, 0x3F, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RSVD_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_CORE_FAT_MSK_S 25
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_CORE_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_CORE_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_STATS_FAT_MSK_S 24
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_STATS_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_STATS_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_CPUW_FAT_MSK_S 23
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_CPUW_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_CPUW_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX4_FAT_MSK_S 22
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX4_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX4_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX3_FAT_MSK_S 21
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX3_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX3_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX2_FAT_MSK_S 20
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX2_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX2_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX1_FAT_MSK_S 19
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX1_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX1_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX0_FAT_MSK_S 18
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX0_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TX0_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX4_FAT_MSK_S 17
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX4_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX4_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX3_FAT_MSK_S 16
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX3_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX3_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX2_FAT_MSK_S 15
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX2_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX2_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX1_FAT_MSK_S 14
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX1_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX1_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX0_FAT_MSK_S 13
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX0_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_RX0_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX4_FAT_MSK_S 12
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX4_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX4_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX3_FAT_MSK_S 11
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX3_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX3_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX2_FAT_MSK_S 10
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX2_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX2_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX1_FAT_MSK_S 9
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX1_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX1_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX0_FAT_MSK_S 8
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX0_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DRX0_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DBL_FAT_MSK_S 7
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DBL_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_DBL_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TOC_FAT_MSK_S 6
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TOC_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_TOC_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_XOC_FAT_MSK_S 5
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_XOC_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_XOC_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_Q1OC_FAT_MSK_S 4
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_Q1OC_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_Q1OC_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_CQOC_FAT_MSK_S 3
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_CQOC_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_CQOC_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_MROC_FAT_MSK_S 2
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_MROC_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_MROC_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_PBLOC1_FAT_MSK_S 1
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_PBLOC1_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_PBLOC1_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_PBLOC0_FAT_MSK_S 0
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK0_PBLOC0_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK0_PBLOC0_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1 0x420E3410
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_RSVD_S 16
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_RSVD_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM4_FAT_MSK_S 15
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM4_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM4_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM3_FAT_MSK_S 14
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM3_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM3_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM2_FAT_MSK_S 13
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM2_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM2_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM1_FAT_MSK_S 12
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM1_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM1_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM0_FAT_MSK_S 11
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM0_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CPM0_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_PMAT_FAT_MSK_S 10
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_PMAT_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_PMAT_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_MSOC_FAT_MSK_S 9
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_MSOC_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_MSOC_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_FLOC_FAT_MSK_S 8
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_FLOC_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_FLOC_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CRX_FAT_MSK_S 7
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CRX_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CRX_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_BRX_FAT_MSK_S 6
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_BRX_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_BRX_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_AMP_FAT_MSK_S 5
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_AMP_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_AMP_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CQM_FAT_MSK_S 4
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CQM_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_CQM_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_TSCD_FAT_MSK_S 3
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_TSCD_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_TSCD_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_RMI1_FAT_MSK_S 2
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_RMI1_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_RMI1_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_RMI0_FAT_MSK_S 1
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_RMI0_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_RMI0_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_RHI_FAT_MSK_S 0
#define IG3_STOP_SCREAM_RDMA_FATAL_MSK1_RHI_FAT_MSK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_FATAL_MSK1_RHI_FAT_MSK_S)
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR0 0x420E341C
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR0_RSVD_S 17
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR0_RSVD_M RDMA_MASK3(32, 0x7FFF, IG3_STOP_SCREAM_RDMA_INT_ARES_ICR0_RSVD_S)
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR0_PECRIT_ERR_S 16
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR0_PECRIT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_INT_ARES_ICR0_PECRIT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR0_HMC_ERR_S 0
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR0_HMC_ERR_M RDMA_MASK3(32, 0xFFFF, IG3_STOP_SCREAM_RDMA_INT_ARES_ICR0_HMC_ERR_S)
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR1 0x420E3420
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR1_UNCORR_ERR_S 31
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR1_UNCORR_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_INT_ARES_ICR1_UNCORR_ERR_S)
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR1_RSVD_S 16
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR1_RSVD_M RDMA_MASK3(32, 0x7FFF, IG3_STOP_SCREAM_RDMA_INT_ARES_ICR1_RSVD_S)
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR1_CMPE_CRC_ERR_S 0
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR1_CMPE_CRC_ERR_M RDMA_MASK3(32, 0xFFFF, IG3_STOP_SCREAM_RDMA_INT_ARES_ICR1_CMPE_CRC_ERR_S)
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK0 0x420E342C
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK0_RSVD_S 17
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK0_RSVD_M RDMA_MASK3(32, 0x7FFF, IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK0_RSVD_S)
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK0_PECRIT_ERR_MASK_S 16
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK0_PECRIT_ERR_MASK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK0_PECRIT_ERR_MASK_S)
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK0_HMC_ERR_MASK_S 0
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK0_HMC_ERR_MASK_M RDMA_MASK3(32, 0xFFFF, IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK0_HMC_ERR_MASK_S)
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK1 0x420E3430
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK1_UNCORR_ERR_MASK_S 31
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK1_UNCORR_ERR_MASK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK1_UNCORR_ERR_MASK_S)
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK1_RSVD_S 16
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK1_RSVD_M RDMA_MASK3(32, 0x7FFF, IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK1_RSVD_S)
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK1_CMPE_CRC_ERR_MASK_S 0
#define IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK1_CMPE_CRC_ERR_MASK_M RDMA_MASK3(32, 0xFFFF, IG3_STOP_SCREAM_RDMA_INT_ARES_ICR_MSK1_CMPE_CRC_ERR_MASK_S)
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR0 0x420E3414
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR0_RSVD_S 17
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR0_RSVD_M RDMA_MASK3(32, 0x7FFF, IG3_STOP_SCREAM_RDMA_INT_IMC_ICR0_RSVD_S)
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR0_PECRIT_ERR_S 16
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR0_PECRIT_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_INT_IMC_ICR0_PECRIT_ERR_S)
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR0_HMC_ERR_S 0
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR0_HMC_ERR_M RDMA_MASK3(32, 0xFFFF, IG3_STOP_SCREAM_RDMA_INT_IMC_ICR0_HMC_ERR_S)
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR1 0x420E3418
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR1_UNCORR_ERR_S 31
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR1_UNCORR_ERR_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_INT_IMC_ICR1_UNCORR_ERR_S)
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR1_IMC_FW_REQ_S 30
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR1_IMC_FW_REQ_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_INT_IMC_ICR1_IMC_FW_REQ_S)
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR1_RSVD_S 16
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR1_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_STOP_SCREAM_RDMA_INT_IMC_ICR1_RSVD_S)
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR1_CMPE_CRC_ERR_S 0
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR1_CMPE_CRC_ERR_M RDMA_MASK3(32, 0xFFFF, IG3_STOP_SCREAM_RDMA_INT_IMC_ICR1_CMPE_CRC_ERR_S)
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK0 0x420E3424
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK0_RSVD_S 17
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK0_RSVD_M RDMA_MASK3(32, 0x7FFF, IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK0_RSVD_S)
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK0_PECRIT_ERR_MASK_S 16
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK0_PECRIT_ERR_MASK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK0_PECRIT_ERR_MASK_S)
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK0_HMC_ERR_MASK_S 0
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK0_HMC_ERR_MASK_M RDMA_MASK3(32, 0xFFFF, IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK0_HMC_ERR_MASK_S)
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK1 0x420E3428
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK1_UNCORR_ERR_MASK_S 31
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK1_UNCORR_ERR_MASK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK1_UNCORR_ERR_MASK_S)
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK1_IMC_FW_REQ_MASK_S 30
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK1_IMC_FW_REQ_MASK_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK1_IMC_FW_REQ_MASK_S)
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK1_RSVD_S 16
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK1_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK1_RSVD_S)
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK1_CMPE_CRC_ERR_MASK_S 0
#define IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK1_CMPE_CRC_ERR_MASK_M RDMA_MASK3(32, 0xFFFF, IG3_STOP_SCREAM_RDMA_INT_IMC_ICR_MSK1_CMPE_CRC_ERR_MASK_S)
#define IG3_STOP_SCREAM_RDMA_STOP_SCREAM_RAS 0x420E3400
#define IG3_STOP_SCREAM_RDMA_STOP_SCREAM_RAS_RSVD_S 3
#define IG3_STOP_SCREAM_RDMA_STOP_SCREAM_RAS_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_STOP_SCREAM_RDMA_STOP_SCREAM_RAS_RSVD_S)
#define IG3_STOP_SCREAM_RDMA_STOP_SCREAM_RAS_DISABLE_S 2
#define IG3_STOP_SCREAM_RDMA_STOP_SCREAM_RAS_DISABLE_M RDMA_BIT2(32, IG3_STOP_SCREAM_RDMA_STOP_SCREAM_RAS_DISABLE_S)
#define IG3_STOP_SCREAM_RDMA_STOP_SCREAM_RAS_STOP_SCREAM_STAT_S 0
#define IG3_STOP_SCREAM_RDMA_STOP_SCREAM_RAS_STOP_SCREAM_STAT_M RDMA_MASK3(32, 0x3, IG3_STOP_SCREAM_RDMA_STOP_SCREAM_RAS_STOP_SCREAM_STAT_S)
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_COUNT 0x420E4038
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RHA_GLPE_RHA_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RHA_GLPE_RHA_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_CMD 0x420E404C
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_DATA_H 0x420E4058
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_DATA_L 0x420E4054
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_PTR 0x420E4050
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RHA_GLPE_RHA_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_CMD 0x420E403C
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_DATA_H 0x420E4048
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_DATA_L 0x420E4044
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_PTR 0x420E4040
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RHA_GLPE_RHA_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_CONTROL 0x420E4000
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_RSVD1_S 25
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_RHA_GLPE_RHA_DTM_CONTROL_RSVD1_S)
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_RSVD2_S 17
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RHA_GLPE_RHA_DTM_CONTROL_RSVD2_S)
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_RSVD3_S 9
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_RHA_GLPE_RHA_DTM_CONTROL_RSVD3_S)
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_BYPASS_S 8
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_CONTROL_BYPASS_S)
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_RSVD4_S 1
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_RHA_GLPE_RHA_DTM_CONTROL_RSVD4_S)
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_RHA_GLPE_RHA_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_CONTROL_LOCAL_EN_S)
#define IG3_RHA_GLPE_RHA_DTM_ECC_COR_ERR 0x420E4068
#define IG3_RHA_GLPE_RHA_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_RHA_GLPE_RHA_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RHA_GLPE_RHA_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_RHA_GLPE_RHA_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_RHA_GLPE_RHA_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RHA_GLPE_RHA_DTM_ECC_COR_ERR_CNT_S)
#define IG3_RHA_GLPE_RHA_DTM_ECC_UNCOR_ERR 0x420E4064
#define IG3_RHA_GLPE_RHA_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_RHA_GLPE_RHA_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RHA_GLPE_RHA_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_RHA_GLPE_RHA_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_RHA_GLPE_RHA_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RHA_GLPE_RHA_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_RHA_GLPE_RHA_DTM_GROUP_CFG 0x420E400C
#define IG3_RHA_GLPE_RHA_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_RHA_GLPE_RHA_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_RHA_GLPE_RHA_DTM_GROUP_CFG_RSVD1_S)
#define IG3_RHA_GLPE_RHA_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_RHA_GLPE_RHA_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_RHA_GLPE_RHA_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_RHA_GLPE_RHA_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_RHA_GLPE_RHA_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_RHA_GLPE_RHA_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_RHA_GLPE_RHA_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_RHA_GLPE_RHA_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_RHA_GLPE_RHA_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_RHA_GLPE_RHA_DTM_LOG_CFG 0x420E4010
#define IG3_RHA_GLPE_RHA_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_RHA_GLPE_RHA_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_RHA_GLPE_RHA_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_RHA_GLPE_RHA_DTM_LOG_CFG_RSVD1_S 2
#define IG3_RHA_GLPE_RHA_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_RHA_GLPE_RHA_DTM_LOG_CFG_RSVD1_S)
#define IG3_RHA_GLPE_RHA_DTM_LOG_CFG_MODE_S 0
#define IG3_RHA_GLPE_RHA_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_RHA_GLPE_RHA_DTM_LOG_CFG_MODE_S)
#define IG3_RHA_GLPE_RHA_DTM_LOG_MASK 0x420E4018
#define IG3_RHA_GLPE_RHA_DTM_LOG_MASK_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHA_GLPE_RHA_DTM_LOG_MASK_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_LOG_PATTERN 0x420E4014
#define IG3_RHA_GLPE_RHA_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHA_GLPE_RHA_DTM_LOG_PATTERN_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_MAIN_CFG 0x420E4004
#define IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_RSVD1_S)
#define IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_RSVD2_S)
#define IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_RSVD3_S)
#define IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_RHA_GLPE_RHA_DTM_MAIN_STS 0x420E4008
#define IG3_RHA_GLPE_RHA_DTM_MAIN_STS_RSVD1_S 9
#define IG3_RHA_GLPE_RHA_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_RHA_GLPE_RHA_DTM_MAIN_STS_RSVD1_S)
#define IG3_RHA_GLPE_RHA_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_RHA_GLPE_RHA_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_RHA_GLPE_RHA_DTM_MAIN_STS_RSVD2_S 1
#define IG3_RHA_GLPE_RHA_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RHA_GLPE_RHA_DTM_MAIN_STS_RSVD2_S)
#define IG3_RHA_GLPE_RHA_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_RHA_GLPE_RHA_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_RHA_GLPE_RHA_DTM_TIMESTAMP 0x420E4030
#define IG3_RHA_GLPE_RHA_DTM_TIMESTAMP_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHA_GLPE_RHA_DTM_TIMESTAMP_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_TIMESTAMP_ROLLOVER 0x420E4034
#define IG3_RHA_GLPE_RHA_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHA_GLPE_RHA_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG 0x420E405C
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS 0x420E4060
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RHA_GLPE_RHA_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_RHA_GLPE_RHA_DTM_TRIG_CFG 0x420E401C
#define IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_RSVD1_S)
#define IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_RSVD2_S)
#define IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_MODE_S 0
#define IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_RHA_GLPE_RHA_DTM_TRIG_CFG_MODE_S)
#define IG3_RHA_GLPE_RHA_DTM_TRIG_COUNT 0x420E4028
#define IG3_RHA_GLPE_RHA_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHA_GLPE_RHA_DTM_TRIG_COUNT_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_TRIG_MASK 0x420E4024
#define IG3_RHA_GLPE_RHA_DTM_TRIG_MASK_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHA_GLPE_RHA_DTM_TRIG_MASK_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_TRIG_PATTERN 0x420E4020
#define IG3_RHA_GLPE_RHA_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHA_GLPE_RHA_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_RHA_GLPE_RHA_DTM_TRIG_TIMESTAMP 0x420E402C
#define IG3_RHA_GLPE_RHA_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_RHA_GLPE_RHA_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHA_GLPE_RHA_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG 0x420E4400
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS 0x420E4404
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_ENTRY_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG 0x420E4408
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS 0x420E440C
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_LEAFOBJ_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG 0x420E4410
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS 0x420E4414
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_CPAL_PADDROBJ_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG 0x420E4418
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS 0x420E441C
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_ENTRY_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG 0x420E4420
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS 0x420E4424
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_LEAFOBJ_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG 0x420E4428
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS 0x420E442C
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_DPAL_PADDROBJ_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_PAL_ECC_COR_ERR 0x420E4434
#define IG3_CORE_SHCTL_GLPE_PAL_ECC_COR_ERR_RSVD_S 12
#define IG3_CORE_SHCTL_GLPE_PAL_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_SHCTL_GLPE_PAL_ECC_COR_ERR_RSVD_S)
#define IG3_CORE_SHCTL_GLPE_PAL_ECC_COR_ERR_CNT_S 0
#define IG3_CORE_SHCTL_GLPE_PAL_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CORE_SHCTL_GLPE_PAL_ECC_COR_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_PAL_ECC_UNCOR_ERR 0x420E4430
#define IG3_CORE_SHCTL_GLPE_PAL_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CORE_SHCTL_GLPE_PAL_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_SHCTL_GLPE_PAL_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CORE_SHCTL_GLPE_PAL_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CORE_SHCTL_GLPE_PAL_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CORE_SHCTL_GLPE_PAL_ECC_UNCOR_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG 0x420E4518
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS 0x420E451C
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PMF_CNTR_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_PTXI_ECC_COR_ERR 0x420E4524
#define IG3_CORE_SHCTL_GLPE_PTXI_ECC_COR_ERR_RSVD_S 12
#define IG3_CORE_SHCTL_GLPE_PTXI_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_SHCTL_GLPE_PTXI_ECC_COR_ERR_RSVD_S)
#define IG3_CORE_SHCTL_GLPE_PTXI_ECC_COR_ERR_CNT_S 0
#define IG3_CORE_SHCTL_GLPE_PTXI_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CORE_SHCTL_GLPE_PTXI_ECC_COR_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_PTXI_ECC_UNCOR_ERR 0x420E4520
#define IG3_CORE_SHCTL_GLPE_PTXI_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CORE_SHCTL_GLPE_PTXI_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_SHCTL_GLPE_PTXI_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CORE_SHCTL_GLPE_PTXI_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CORE_SHCTL_GLPE_PTXI_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CORE_SHCTL_GLPE_PTXI_ECC_UNCOR_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG 0x420E4510
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS 0x420E4514
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_PTX_CSR_RAM_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_RLC_ECC_COR_ERR 0x420E450C
#define IG3_CORE_SHCTL_GLPE_RLC_ECC_COR_ERR_RSVD_S 12
#define IG3_CORE_SHCTL_GLPE_RLC_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_SHCTL_GLPE_RLC_ECC_COR_ERR_RSVD_S)
#define IG3_CORE_SHCTL_GLPE_RLC_ECC_COR_ERR_CNT_S 0
#define IG3_CORE_SHCTL_GLPE_RLC_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CORE_SHCTL_GLPE_RLC_ECC_COR_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_ECC_UNCOR_ERR 0x420E4508
#define IG3_CORE_SHCTL_GLPE_RLC_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CORE_SHCTL_GLPE_RLC_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_SHCTL_GLPE_RLC_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CORE_SHCTL_GLPE_RLC_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CORE_SHCTL_GLPE_RLC_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CORE_SHCTL_GLPE_RLC_ECC_UNCOR_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG 0x420E44D8
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS 0x420E44DC
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG 0x420E44E0
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS 0x420E44E4
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST0_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG 0x420E44F0
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS 0x420E44F4
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG 0x420E44F8
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS 0x420E44FC
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_RDYLIST1_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG 0x420E44E8
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS 0x420E44EC
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET0_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG 0x420E4500
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS 0x420E4504
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_RLC_TRIPLET1_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG 0x420E44B0
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS 0x420E44B4
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG 0x420E44B8
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS 0x420E44BC
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG 0x420E44C0
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS 0x420E44C4
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_2_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG 0x420E44C8
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS 0x420E44CC
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CFG_3_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG 0x420E4450
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS 0x420E4454
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG 0x420E4458
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS 0x420E445C
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG 0x420E4460
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS 0x420E4464
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_2_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG 0x420E4468
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS 0x420E446C
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_CNT_3_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG 0x420E4470
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS 0x420E4474
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG 0x420E4478
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS 0x420E447C
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG 0x420E4480
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS 0x420E4484
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_2_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG 0x420E4488
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS 0x420E448C
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_DIV_3_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_ECC_COR_ERR 0x420E44D4
#define IG3_CORE_SHCTL_GLPE_TMR_ECC_COR_ERR_RSVD_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_SHCTL_GLPE_TMR_ECC_COR_ERR_RSVD_S)
#define IG3_CORE_SHCTL_GLPE_TMR_ECC_COR_ERR_CNT_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CORE_SHCTL_GLPE_TMR_ECC_COR_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_ECC_UNCOR_ERR 0x420E44D0
#define IG3_CORE_SHCTL_GLPE_TMR_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CORE_SHCTL_GLPE_TMR_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CORE_SHCTL_GLPE_TMR_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CORE_SHCTL_GLPE_TMR_ECC_UNCOR_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG 0x420E4490
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS 0x420E4494
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG 0x420E4498
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS 0x420E449C
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG 0x420E44A0
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS 0x420E44A4
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_2_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG 0x420E44A8
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS 0x420E44AC
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_NOW_3_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG 0x420E4448
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS 0x420E444C
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_BUCKET_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG 0x420E4438
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS 0x420E443C
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_SCN_MEM_STATUS_ECC_ERR_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG 0x420E4440
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RSVD3_S 20
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RSVD3_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RM_S 16
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RM_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RSVD2_S 14
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RSVD2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RME_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RME_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RSVD1_S 10
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ERR_CNT_S 9
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ERR_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_FIX_CNT_S 8
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_FIX_CNT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RSVD0_S 6
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_MASK_INT_S 5
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_MASK_INT_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_LS_BYPASS_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_LS_BYPASS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_LS_FORCE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_LS_FORCE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ECC_EN_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_CFG_ECC_EN_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS 0x420E4444
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_RSVD1_S 30
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_RSVD1_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_RSVD0_S 4
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_RSVD0_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_INIT_DONE_S 2
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_INIT_DONE_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_ECC_FIX_S 1
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_ECC_FIX_S)
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_ECC_ERR_S 0
#define IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CORE_SHCTL_GLPE_TMR_UCB_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_APM_THRESHOLDS(_i) 0x42400028 + ((_i) * 4) /* _i=0...4 */
#define IG3_AMP_GLPE_AMP_APM_THRESHOLDS_MAX_INDEX_I 4
#define IG3_AMP_GLPE_AMP_APM_THRESHOLDS_RSVD_S 24
#define IG3_AMP_GLPE_AMP_APM_THRESHOLDS_RSVD_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_APM_THRESHOLDS_RSVD_S)
#define IG3_AMP_GLPE_AMP_APM_THRESHOLDS_PMAT_REQ_THRESHOLD_S 16
#define IG3_AMP_GLPE_AMP_APM_THRESHOLDS_PMAT_REQ_THRESHOLD_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_APM_THRESHOLDS_PMAT_REQ_THRESHOLD_S)
#define IG3_AMP_GLPE_AMP_APM_THRESHOLDS_PBLOC_REQ_THRESHOLD_S 8
#define IG3_AMP_GLPE_AMP_APM_THRESHOLDS_PBLOC_REQ_THRESHOLD_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_APM_THRESHOLDS_PBLOC_REQ_THRESHOLD_S)
#define IG3_AMP_GLPE_AMP_APM_THRESHOLDS_MROC_REQ_THRESHOLD_S 0
#define IG3_AMP_GLPE_AMP_APM_THRESHOLDS_MROC_REQ_THRESHOLD_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_APM_THRESHOLDS_MROC_REQ_THRESHOLD_S)
#define IG3_AMP_GLPE_AMP_CFG 0x42400004
#define IG3_AMP_GLPE_AMP_CFG_RSVD_S 1
#define IG3_AMP_GLPE_AMP_CFG_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_AMP_GLPE_AMP_CFG_RSVD_S)
#define IG3_AMP_GLPE_AMP_CFG_EN_TYPE_2B_MW_S 0
#define IG3_AMP_GLPE_AMP_CFG_EN_TYPE_2B_MW_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_CFG_EN_TYPE_2B_MW_S)
#define IG3_AMP_GLPE_AMP_CONSUMED_RESOURCES(_i) 0x4240003C + ((_i) * 4) /* _i=0...4 */
#define IG3_AMP_GLPE_AMP_CONSUMED_RESOURCES_MAX_INDEX_I 4
#define IG3_AMP_GLPE_AMP_CONSUMED_RESOURCES_RSVD_S 24
#define IG3_AMP_GLPE_AMP_CONSUMED_RESOURCES_RSVD_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_CONSUMED_RESOURCES_RSVD_S)
#define IG3_AMP_GLPE_AMP_CONSUMED_RESOURCES_PMAT_CNT_S 16
#define IG3_AMP_GLPE_AMP_CONSUMED_RESOURCES_PMAT_CNT_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_CONSUMED_RESOURCES_PMAT_CNT_S)
#define IG3_AMP_GLPE_AMP_CONSUMED_RESOURCES_PBLOC_CNT_S 8
#define IG3_AMP_GLPE_AMP_CONSUMED_RESOURCES_PBLOC_CNT_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_CONSUMED_RESOURCES_PBLOC_CNT_S)
#define IG3_AMP_GLPE_AMP_CONSUMED_RESOURCES_MROC_CNT_S 0
#define IG3_AMP_GLPE_AMP_CONSUMED_RESOURCES_MROC_CNT_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_CONSUMED_RESOURCES_MROC_CNT_S)
#define IG3_AMP_GLPE_AMP_DBG_CFG(_i) 0x42400008 + ((_i) * 4) /* _i=0...4 */
#define IG3_AMP_GLPE_AMP_DBG_CFG_MAX_INDEX_I 4
#define IG3_AMP_GLPE_AMP_DBG_CFG_RSVD2_S 23
#define IG3_AMP_GLPE_AMP_DBG_CFG_RSVD2_M RDMA_MASK3(32, 0x1FF, IG3_AMP_GLPE_AMP_DBG_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_DBG_CFG_DBG_CAM1_IDX_S 16
#define IG3_AMP_GLPE_AMP_DBG_CFG_DBG_CAM1_IDX_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_DBG_CFG_DBG_CAM1_IDX_S)
#define IG3_AMP_GLPE_AMP_DBG_CFG_RSVD1_S 15
#define IG3_AMP_GLPE_AMP_DBG_CFG_RSVD1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DBG_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_DBG_CFG_DBG_CAM0_IDX_S 8
#define IG3_AMP_GLPE_AMP_DBG_CFG_DBG_CAM0_IDX_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_DBG_CFG_DBG_CAM0_IDX_S)
#define IG3_AMP_GLPE_AMP_DBG_CFG_RSVD0_S 7
#define IG3_AMP_GLPE_AMP_DBG_CFG_RSVD0_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DBG_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_DBG_CFG_DBG_REQTAG_S 0
#define IG3_AMP_GLPE_AMP_DBG_CFG_DBG_REQTAG_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_DBG_CFG_DBG_REQTAG_S)
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_COUNT 0x42400138
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_AMP_GLPE_AMP_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_AMP_GLPE_AMP_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_CMD 0x4240014C
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_DATA_H 0x42400158
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_DATA_L 0x42400154
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_PTR 0x42400150
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_AMP_GLPE_AMP_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_CMD 0x4240013C
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_DATA_H 0x42400148
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_DATA_L 0x42400144
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_PTR 0x42400140
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_AMP_GLPE_AMP_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_CFG 0x4240001C
#define IG3_AMP_GLPE_AMP_DTM_CFG_RSVD_S 3
#define IG3_AMP_GLPE_AMP_DTM_CFG_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_AMP_GLPE_AMP_DTM_CFG_RSVD_S)
#define IG3_AMP_GLPE_AMP_DTM_CFG_AMP_ENG_SEL_S 0
#define IG3_AMP_GLPE_AMP_DTM_CFG_AMP_ENG_SEL_M RDMA_MASK3(32, 0x7, IG3_AMP_GLPE_AMP_DTM_CFG_AMP_ENG_SEL_S)
#define IG3_AMP_GLPE_AMP_DTM_CONTROL 0x42400100
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_RSVD1_S 25
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_DTM_CONTROL_RSVD1_S)
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_RSVD2_S 17
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_DTM_CONTROL_RSVD2_S)
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_RSVD3_S 9
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_DTM_CONTROL_RSVD3_S)
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_BYPASS_S 8
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_CONTROL_BYPASS_S)
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_RSVD4_S 1
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_DTM_CONTROL_RSVD4_S)
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_AMP_GLPE_AMP_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_CONTROL_LOCAL_EN_S)
#define IG3_AMP_GLPE_AMP_DTM_ECC_COR_ERR 0x42400168
#define IG3_AMP_GLPE_AMP_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_AMP_GLPE_AMP_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_AMP_GLPE_AMP_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_AMP_GLPE_AMP_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_AMP_GLPE_AMP_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_AMP_GLPE_AMP_DTM_ECC_COR_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_DTM_ECC_UNCOR_ERR 0x42400164
#define IG3_AMP_GLPE_AMP_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_AMP_GLPE_AMP_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_AMP_GLPE_AMP_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_AMP_GLPE_AMP_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_AMP_GLPE_AMP_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_AMP_GLPE_AMP_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_DTM_GROUP_CFG 0x4240010C
#define IG3_AMP_GLPE_AMP_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_AMP_GLPE_AMP_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_DTM_GROUP_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_AMP_GLPE_AMP_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_AMP_GLPE_AMP_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_AMP_GLPE_AMP_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_AMP_GLPE_AMP_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_AMP_GLPE_AMP_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_AMP_GLPE_AMP_DTM_LOG_CFG 0x42400110
#define IG3_AMP_GLPE_AMP_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_AMP_GLPE_AMP_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_AMP_GLPE_AMP_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_AMP_GLPE_AMP_DTM_LOG_CFG_RSVD1_S 2
#define IG3_AMP_GLPE_AMP_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_AMP_GLPE_AMP_DTM_LOG_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_DTM_LOG_CFG_MODE_S 0
#define IG3_AMP_GLPE_AMP_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_DTM_LOG_CFG_MODE_S)
#define IG3_AMP_GLPE_AMP_DTM_LOG_MASK 0x42400118
#define IG3_AMP_GLPE_AMP_DTM_LOG_MASK_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_AMP_GLPE_AMP_DTM_LOG_MASK_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_LOG_PATTERN 0x42400114
#define IG3_AMP_GLPE_AMP_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_AMP_GLPE_AMP_DTM_LOG_PATTERN_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_MAIN_CFG 0x42400104
#define IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_AMP_GLPE_AMP_DTM_MAIN_STS 0x42400108
#define IG3_AMP_GLPE_AMP_DTM_MAIN_STS_RSVD1_S 9
#define IG3_AMP_GLPE_AMP_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_AMP_GLPE_AMP_DTM_MAIN_STS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_AMP_GLPE_AMP_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_AMP_GLPE_AMP_DTM_MAIN_STS_RSVD2_S 1
#define IG3_AMP_GLPE_AMP_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_DTM_MAIN_STS_RSVD2_S)
#define IG3_AMP_GLPE_AMP_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_AMP_GLPE_AMP_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_AMP_GLPE_AMP_DTM_TIMESTAMP 0x42400130
#define IG3_AMP_GLPE_AMP_DTM_TIMESTAMP_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_AMP_GLPE_AMP_DTM_TIMESTAMP_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_TIMESTAMP_ROLLOVER 0x42400134
#define IG3_AMP_GLPE_AMP_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_AMP_GLPE_AMP_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG 0x4240015C
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS 0x42400160
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_DTM_TRIG_CFG 0x4240011C
#define IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_MODE_S 0
#define IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_DTM_TRIG_CFG_MODE_S)
#define IG3_AMP_GLPE_AMP_DTM_TRIG_COUNT 0x42400128
#define IG3_AMP_GLPE_AMP_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_AMP_GLPE_AMP_DTM_TRIG_COUNT_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_TRIG_MASK 0x42400124
#define IG3_AMP_GLPE_AMP_DTM_TRIG_MASK_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_AMP_GLPE_AMP_DTM_TRIG_MASK_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_TRIG_PATTERN 0x42400120
#define IG3_AMP_GLPE_AMP_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_AMP_GLPE_AMP_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_AMP_GLPE_AMP_DTM_TRIG_TIMESTAMP 0x4240012C
#define IG3_AMP_GLPE_AMP_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_AMP_GLPE_AMP_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_AMP_GLPE_AMP_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_AMP_GLPE_AMP_ECC_COR_ERR 0x424000D4
#define IG3_AMP_GLPE_AMP_ECC_COR_ERR_RSVD_S 12
#define IG3_AMP_GLPE_AMP_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_AMP_GLPE_AMP_ECC_COR_ERR_RSVD_S)
#define IG3_AMP_GLPE_AMP_ECC_COR_ERR_CNT_S 0
#define IG3_AMP_GLPE_AMP_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_AMP_GLPE_AMP_ECC_COR_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_ECC_UNCOR_ERR 0x424000D0
#define IG3_AMP_GLPE_AMP_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_AMP_GLPE_AMP_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_AMP_GLPE_AMP_ECC_UNCOR_ERR_RSVD_S)
#define IG3_AMP_GLPE_AMP_ECC_UNCOR_ERR_CNT_S 0
#define IG3_AMP_GLPE_AMP_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_AMP_GLPE_AMP_ECC_UNCOR_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG 0x42400050
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS 0x42400054
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_0_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG 0x42400068
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS 0x4240006C
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_1_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG 0x42400080
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS 0x42400084
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_2_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG 0x42400098
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS 0x4240009C
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_3_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG 0x424000B0
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS 0x424000B4
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_LOOP_FIFO_4_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG 0x424000C8
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS 0x424000CC
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MIM_TBL_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG 0x42400058
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_0_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS 0x4240005C
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_0_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG 0x42400070
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_1_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS 0x42400074
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_1_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG 0x42400088
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_2_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS 0x4240008C
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_2_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG 0x424000A0
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_3_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS 0x424000A4
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_3_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG 0x424000B8
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_4_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS 0x424000BC
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_MRTE_4_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG 0x42400060
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_0_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS 0x42400064
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_0_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG 0x42400078
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_1_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS 0x4240007C
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_1_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG 0x42400090
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_2_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS 0x42400094
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_2_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG 0x424000A8
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_3_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS 0x424000AC
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_3_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG 0x424000C0
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ECC_INST_NUM_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RSVD3_S 20
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RSVD3_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RM_S 16
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RM_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RSVD2_S 14
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RSVD2_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_POWER_GATE_EN_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RME_S 12
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RME_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RME_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RSVD1_S 10
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RSVD1_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ERR_CNT_S 9
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ERR_CNT_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_FIX_CNT_S 8
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_FIX_CNT_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RSVD0_S 6
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_RSVD0_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_MASK_INT_S 5
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_MASK_INT_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_LS_BYPASS_S 4
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_LS_BYPASS_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_LS_FORCE_S 3
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_LS_FORCE_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ECC_INVERT_2_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ECC_INVERT_1_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ECC_EN_S 0
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_4_MEM_CFG_ECC_EN_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS 0x424000C4
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_RSVD1_S 30
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_RSVD1_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_RSVD0_S 4
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_RSVD0_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_INIT_DONE_S 2
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_INIT_DONE_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_ECC_FIX_S 1
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_ECC_FIX_S)
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_ECC_ERR_S 0
#define IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_AMP_GLPE_AMP_TAG_4_MEM_STATUS_ECC_ERR_S)
#define IG3_AMP_GLPE_ATM_CONFIG 0x42400000
#define IG3_AMP_GLPE_ATM_CONFIG_RSVD0_S 2
#define IG3_AMP_GLPE_ATM_CONFIG_RSVD0_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_AMP_GLPE_ATM_CONFIG_RSVD0_S)
#define IG3_AMP_GLPE_ATM_CONFIG_SEL_MODE_S 0
#define IG3_AMP_GLPE_ATM_CONFIG_SEL_MODE_M RDMA_MASK3(32, 0x3, IG3_AMP_GLPE_ATM_CONFIG_SEL_MODE_S)
#define IG3_AMP_GLPE_FWMRTEIDXMASKTBL_CMD 0x42400020
#define IG3_AMP_GLPE_FWMRTEIDXMASKTBL_CMD_TBLWR_S 31
#define IG3_AMP_GLPE_FWMRTEIDXMASKTBL_CMD_TBLWR_M RDMA_BIT2(32, IG3_AMP_GLPE_FWMRTEIDXMASKTBL_CMD_TBLWR_S)
#define IG3_AMP_GLPE_FWMRTEIDXMASKTBL_CMD_RSVD_S 12
#define IG3_AMP_GLPE_FWMRTEIDXMASKTBL_CMD_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_AMP_GLPE_FWMRTEIDXMASKTBL_CMD_RSVD_S)
#define IG3_AMP_GLPE_FWMRTEIDXMASKTBL_CMD_PMFIDX_S 0
#define IG3_AMP_GLPE_FWMRTEIDXMASKTBL_CMD_PMFIDX_M RDMA_MASK3(32, 0xFFF, IG3_AMP_GLPE_FWMRTEIDXMASKTBL_CMD_PMFIDX_S)
#define IG3_AMP_GLPE_FWMRTEIDXMASKTBL_DATA 0x42400024
#define IG3_AMP_GLPE_FWMRTEIDXMASKTBL_DATA_RSVD_S 5
#define IG3_AMP_GLPE_FWMRTEIDXMASKTBL_DATA_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_AMP_GLPE_FWMRTEIDXMASKTBL_DATA_RSVD_S)
#define IG3_AMP_GLPE_FWMRTEIDXMASKTBL_DATA_MRTEIDXMASKBITS_S 0
#define IG3_AMP_GLPE_FWMRTEIDXMASKTBL_DATA_MRTEIDXMASKBITS_M RDMA_MASK3(32, 0x1F, IG3_AMP_GLPE_FWMRTEIDXMASKTBL_DATA_MRTEIDXMASKBITS_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG 0x42400410
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ECC_INST_NUM_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RSVD3_S 20
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RSVD3_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RM_S 16
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RM_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RSVD2_S 14
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RSVD2_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_POWER_GATE_EN_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RME_S 12
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RME_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RME_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RSVD1_S 10
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RSVD1_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ERR_CNT_S 9
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ERR_CNT_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_FIX_CNT_S 8
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_FIX_CNT_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RSVD0_S 6
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_RSVD0_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_MASK_INT_S 5
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_MASK_INT_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_LS_BYPASS_S 4
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_LS_BYPASS_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_LS_FORCE_S 3
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_LS_FORCE_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ECC_INVERT_2_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ECC_INVERT_1_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ECC_EN_S 0
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CHUNK_RAM_CFG_ECC_EN_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS 0x42400414
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_RSVD1_S 30
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_RSVD1_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_RSVD0_S 4
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_RSVD0_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_INIT_DONE_S 2
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_INIT_DONE_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_ECC_FIX_S 1
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_ECC_FIX_S)
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_ECC_ERR_S 0
#define IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CHUNK_RAM_STATUS_ECC_ERR_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG 0x42400418
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ECC_INST_NUM_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RSVD3_S 20
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RSVD3_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RM_S 16
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RM_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RSVD2_S 14
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RSVD2_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_POWER_GATE_EN_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RME_S 12
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RME_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RME_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RSVD1_S 10
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RSVD1_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ERR_CNT_S 9
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ERR_CNT_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_FIX_CNT_S 8
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_FIX_CNT_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RSVD0_S 6
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_RSVD0_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_MASK_INT_S 5
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_MASK_INT_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_LS_BYPASS_S 4
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_LS_BYPASS_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_LS_FORCE_S 3
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_LS_FORCE_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ECC_INVERT_2_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ECC_INVERT_1_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ECC_EN_S 0
#define IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CLID_RAM_CFG_ECC_EN_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS 0x4240041C
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_RSVD1_S 30
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_RSVD1_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_RSVD0_S 4
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_RSVD0_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_INIT_DONE_S 2
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_INIT_DONE_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_ECC_FIX_S 1
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_ECC_FIX_S)
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_ECC_ERR_S 0
#define IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_CLID_RAM_STATUS_ECC_ERR_S)
#define IG3_BRX_GLPE_BRX_CONFIG 0x42400400
#define IG3_BRX_GLPE_BRX_CONFIG_RSVD1_S 3
#define IG3_BRX_GLPE_BRX_CONFIG_RSVD1_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_BRX_GLPE_BRX_CONFIG_RSVD1_S)
#define IG3_BRX_GLPE_BRX_CONFIG_CRC_MASK_S 0
#define IG3_BRX_GLPE_BRX_CONFIG_CRC_MASK_M RDMA_MASK3(32, 0x7, IG3_BRX_GLPE_BRX_CONFIG_CRC_MASK_S)
#define IG3_BRX_GLPE_BRX_DEBUG 0x42400404
#define IG3_BRX_GLPE_BRX_DEBUG_RSVD0_S 11
#define IG3_BRX_GLPE_BRX_DEBUG_RSVD0_M RDMA_MASK3(32, 0x1FFFFF, IG3_BRX_GLPE_BRX_DEBUG_RSVD0_S)
#define IG3_BRX_GLPE_BRX_DEBUG_USED_RX_CHUNKS_S 0
#define IG3_BRX_GLPE_BRX_DEBUG_USED_RX_CHUNKS_M RDMA_MASK3(32, 0x7FF, IG3_BRX_GLPE_BRX_DEBUG_USED_RX_CHUNKS_S)
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_COUNT 0x424004B8
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_BRX_GLPE_BRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_BRX_GLPE_BRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_CMD 0x424004CC
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_DATA_H 0x424004D8
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_DATA_L 0x424004D4
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_PTR 0x424004D0
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_BRX_GLPE_BRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_CMD 0x424004BC
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_DATA_H 0x424004C8
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_DATA_L 0x424004C4
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_PTR 0x424004C0
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_BRX_GLPE_BRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_CONTROL 0x42400480
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_RSVD1_S 25
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_BRX_GLPE_BRX_DTM_CONTROL_RSVD1_S)
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_RSVD2_S 17
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_BRX_GLPE_BRX_DTM_CONTROL_RSVD2_S)
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_RSVD3_S 9
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_BRX_GLPE_BRX_DTM_CONTROL_RSVD3_S)
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_BYPASS_S 8
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_CONTROL_BYPASS_S)
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_RSVD4_S 1
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_BRX_GLPE_BRX_DTM_CONTROL_RSVD4_S)
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_BRX_GLPE_BRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_BRX_GLPE_BRX_DTM_ECC_COR_ERR 0x424004E8
#define IG3_BRX_GLPE_BRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_BRX_GLPE_BRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_BRX_GLPE_BRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_BRX_GLPE_BRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_BRX_GLPE_BRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_BRX_GLPE_BRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_BRX_GLPE_BRX_DTM_ECC_UNCOR_ERR 0x424004E4
#define IG3_BRX_GLPE_BRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_BRX_GLPE_BRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_BRX_GLPE_BRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_BRX_GLPE_BRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_BRX_GLPE_BRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_BRX_GLPE_BRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_BRX_GLPE_BRX_DTM_GROUP_CFG 0x4240048C
#define IG3_BRX_GLPE_BRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_BRX_GLPE_BRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_BRX_GLPE_BRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_BRX_GLPE_BRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_BRX_GLPE_BRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_BRX_GLPE_BRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_BRX_GLPE_BRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_BRX_GLPE_BRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_BRX_GLPE_BRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_BRX_GLPE_BRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_BRX_GLPE_BRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_BRX_GLPE_BRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_BRX_GLPE_BRX_DTM_LOG_CFG 0x42400490
#define IG3_BRX_GLPE_BRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_BRX_GLPE_BRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_BRX_GLPE_BRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_BRX_GLPE_BRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_BRX_GLPE_BRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_BRX_GLPE_BRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_BRX_GLPE_BRX_DTM_LOG_CFG_MODE_S 0
#define IG3_BRX_GLPE_BRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_DTM_LOG_CFG_MODE_S)
#define IG3_BRX_GLPE_BRX_DTM_LOG_MASK 0x42400498
#define IG3_BRX_GLPE_BRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_BRX_GLPE_BRX_DTM_LOG_MASK_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_LOG_PATTERN 0x42400494
#define IG3_BRX_GLPE_BRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_BRX_GLPE_BRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_MAIN_CFG 0x42400484
#define IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_BRX_GLPE_BRX_DTM_MAIN_STS 0x42400488
#define IG3_BRX_GLPE_BRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_BRX_GLPE_BRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_BRX_GLPE_BRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_BRX_GLPE_BRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_BRX_GLPE_BRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_BRX_GLPE_BRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_BRX_GLPE_BRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_BRX_GLPE_BRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_BRX_GLPE_BRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_BRX_GLPE_BRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_BRX_GLPE_BRX_DTM_TIMESTAMP 0x424004B0
#define IG3_BRX_GLPE_BRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_BRX_GLPE_BRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_TIMESTAMP_ROLLOVER 0x424004B4
#define IG3_BRX_GLPE_BRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_BRX_GLPE_BRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG 0x424004DC
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS 0x424004E0
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_BRX_GLPE_BRX_DTM_TRIG_CFG 0x4240049C
#define IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_BRX_GLPE_BRX_DTM_TRIG_CFG_MODE_S)
#define IG3_BRX_GLPE_BRX_DTM_TRIG_COUNT 0x424004A8
#define IG3_BRX_GLPE_BRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_BRX_GLPE_BRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_TRIG_MASK 0x424004A4
#define IG3_BRX_GLPE_BRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_BRX_GLPE_BRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_TRIG_PATTERN 0x424004A0
#define IG3_BRX_GLPE_BRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_BRX_GLPE_BRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_BRX_GLPE_BRX_DTM_TRIG_TIMESTAMP 0x424004AC
#define IG3_BRX_GLPE_BRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_BRX_GLPE_BRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_BRX_GLPE_BRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_BRX_GLPE_BRX_ECC_COR_ERR 0x4240040C
#define IG3_BRX_GLPE_BRX_ECC_COR_ERR_RSVD_S 12
#define IG3_BRX_GLPE_BRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_BRX_GLPE_BRX_ECC_COR_ERR_RSVD_S)
#define IG3_BRX_GLPE_BRX_ECC_COR_ERR_CNT_S 0
#define IG3_BRX_GLPE_BRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_BRX_GLPE_BRX_ECC_COR_ERR_CNT_S)
#define IG3_BRX_GLPE_BRX_ECC_UNCOR_ERR 0x42400408
#define IG3_BRX_GLPE_BRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_BRX_GLPE_BRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_BRX_GLPE_BRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_BRX_GLPE_BRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_BRX_GLPE_BRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_BRX_GLPE_BRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG 0x42400420
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ECC_INST_NUM_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RSVD3_S 20
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RSVD3_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RM_S 16
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RM_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RSVD2_S 14
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RSVD2_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_POWER_GATE_EN_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RME_S 12
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RME_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RME_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RSVD1_S 10
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RSVD1_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ERR_CNT_S 9
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ERR_CNT_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_FIX_CNT_S 8
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_FIX_CNT_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RSVD0_S 6
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_RSVD0_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_MASK_INT_S 5
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_MASK_INT_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_LS_BYPASS_S 4
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_LS_BYPASS_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_LS_FORCE_S 3
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_LS_FORCE_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ECC_INVERT_2_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ECC_INVERT_1_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ECC_EN_S 0
#define IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_FREE_RAM_CFG_ECC_EN_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS 0x42400424
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_RSVD1_S 30
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_RSVD1_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_RSVD0_S 4
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_RSVD0_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_INIT_DONE_S 2
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_INIT_DONE_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_ECC_FIX_S 1
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_ECC_FIX_S)
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_ECC_ERR_S 0
#define IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_BRX_GLPE_BRX_FREE_RAM_STATUS_ECC_ERR_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_BUS_INDEX 0x42400A10
#define IG3_CRX_GLPE_CRX_BOB0_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL 0x42400A00
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_RESERVED_31_10_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_TRIG_OP_S 8
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_TRIG_OP_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_FREEZE_RESET_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_FREEZE_SET_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_CTRL_FREEZE_SET_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_FREEZE_ON_CNT_VAL 0x42400A20
#define IG3_CRX_GLPE_CRX_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_OBS_BUS 0x42400A40
#define IG3_CRX_GLPE_CRX_BOB0_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CNT0 0x42400A60
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CNT0_CNT0_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CNT0_CNT0_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CNT1_0 0x42400A68
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CNT1_1 0x42400A6C
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CTRL 0x42400A58
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_CRX_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_RC_CTRL 0x42400A38
#define IG3_CRX_GLPE_CRX_BOB0_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_CRX_GLPE_CRX_BOB0_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_RC_GAP 0x42400A28
#define IG3_CRX_GLPE_CRX_BOB0_BOB_RC_GAP_RC_GAP_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_RC_GAP_RC_GAP_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_RC_TRNS 0x42400A30
#define IG3_CRX_GLPE_CRX_BOB0_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS 0x42400A08
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_RESERVED_31_8_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_I_FREEZE_S 6
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_I_FREEZE_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_READY_S 5
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_READY_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_VALID_S 4
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_VALID_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB0_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_TRANS_CNT 0x42400A18
#define IG3_CRX_GLPE_CRX_BOB0_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_TRIG_MASK 0x42400A48
#define IG3_CRX_GLPE_CRX_BOB0_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_CRX_GLPE_CRX_BOB0_BOB_TRIG_VALUE 0x42400A50
#define IG3_CRX_GLPE_CRX_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_CRX_GLPE_CRX_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_BUS_INDEX 0x42400A90
#define IG3_CRX_GLPE_CRX_BOB1_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL 0x42400A80
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_RESERVED_31_10_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_TRIG_OP_S 8
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_TRIG_OP_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_FREEZE_RESET_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_FREEZE_SET_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_CTRL_FREEZE_SET_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_FREEZE_ON_CNT_VAL 0x42400AA0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_OBS_BUS 0x42400AC0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CNT0 0x42400AE0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CNT0_CNT0_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CNT0_CNT0_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CNT1_0 0x42400AE8
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CNT1_1 0x42400AEC
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CTRL 0x42400AD8
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_CRX_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_RC_CTRL 0x42400AB8
#define IG3_CRX_GLPE_CRX_BOB1_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_CRX_GLPE_CRX_BOB1_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_RC_GAP 0x42400AA8
#define IG3_CRX_GLPE_CRX_BOB1_BOB_RC_GAP_RC_GAP_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_RC_GAP_RC_GAP_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_RC_TRNS 0x42400AB0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS 0x42400A88
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_RESERVED_31_8_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_I_FREEZE_S 6
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_I_FREEZE_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_READY_S 5
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_READY_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_VALID_S 4
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_VALID_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB1_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_TRANS_CNT 0x42400A98
#define IG3_CRX_GLPE_CRX_BOB1_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_TRIG_MASK 0x42400AC8
#define IG3_CRX_GLPE_CRX_BOB1_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_CRX_GLPE_CRX_BOB1_BOB_TRIG_VALUE 0x42400AD0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_CRX_GLPE_CRX_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_BUS_INDEX 0x42400B10
#define IG3_CRX_GLPE_CRX_BOB2_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL 0x42400B00
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_RESERVED_31_10_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_TRIG_OP_S 8
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_TRIG_OP_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_FREEZE_RESET_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_FREEZE_SET_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_CTRL_FREEZE_SET_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_FREEZE_ON_CNT_VAL 0x42400B20
#define IG3_CRX_GLPE_CRX_BOB2_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_OBS_BUS 0x42400B40
#define IG3_CRX_GLPE_CRX_BOB2_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CNT0 0x42400B60
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CNT0_CNT0_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CNT0_CNT0_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CNT1_0 0x42400B68
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CNT1_1 0x42400B6C
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CTRL 0x42400B58
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_CRX_BOB2_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_RC_CTRL 0x42400B38
#define IG3_CRX_GLPE_CRX_BOB2_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_CRX_GLPE_CRX_BOB2_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_RC_GAP 0x42400B28
#define IG3_CRX_GLPE_CRX_BOB2_BOB_RC_GAP_RC_GAP_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_RC_GAP_RC_GAP_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_RC_TRNS 0x42400B30
#define IG3_CRX_GLPE_CRX_BOB2_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS 0x42400B08
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_RESERVED_31_8_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_I_FREEZE_S 6
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_I_FREEZE_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_READY_S 5
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_READY_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_VALID_S 4
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_VALID_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB2_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_TRANS_CNT 0x42400B18
#define IG3_CRX_GLPE_CRX_BOB2_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_TRIG_MASK 0x42400B48
#define IG3_CRX_GLPE_CRX_BOB2_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_CRX_GLPE_CRX_BOB2_BOB_TRIG_VALUE 0x42400B50
#define IG3_CRX_GLPE_CRX_BOB2_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_CRX_GLPE_CRX_BOB2_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB2_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_BUS_INDEX 0x42400B90
#define IG3_CRX_GLPE_CRX_BOB3_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL 0x42400B80
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_RESERVED_31_10_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_TRIG_OP_S 8
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_TRIG_OP_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_FREEZE_RESET_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_FREEZE_SET_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_CTRL_FREEZE_SET_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_FREEZE_ON_CNT_VAL 0x42400BA0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_OBS_BUS 0x42400BC0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CNT0 0x42400BE0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CNT0_CNT0_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CNT0_CNT0_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CNT1_0 0x42400BE8
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CNT1_1 0x42400BEC
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CTRL 0x42400BD8
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_CRX_BOB3_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_RC_CTRL 0x42400BB8
#define IG3_CRX_GLPE_CRX_BOB3_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_CRX_GLPE_CRX_BOB3_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_RC_GAP 0x42400BA8
#define IG3_CRX_GLPE_CRX_BOB3_BOB_RC_GAP_RC_GAP_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_RC_GAP_RC_GAP_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_RC_TRNS 0x42400BB0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS 0x42400B88
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_RESERVED_31_8_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_I_FREEZE_S 6
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_I_FREEZE_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_READY_S 5
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_READY_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_VALID_S 4
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_VALID_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_BOB3_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_TRANS_CNT 0x42400B98
#define IG3_CRX_GLPE_CRX_BOB3_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_TRIG_MASK 0x42400BC8
#define IG3_CRX_GLPE_CRX_BOB3_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_CRX_GLPE_CRX_BOB3_BOB_TRIG_VALUE 0x42400BD0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_CRX_GLPE_CRX_BOB3_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_BOB3_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_CRX_GLPE_CRX_CONFIG 0x42400800
#define IG3_CRX_GLPE_CRX_CONFIG_RSVD1_S 3
#define IG3_CRX_GLPE_CRX_CONFIG_RSVD1_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_CRX_GLPE_CRX_CONFIG_RSVD1_S)
#define IG3_CRX_GLPE_CRX_CONFIG_CRC_MASK_S 0
#define IG3_CRX_GLPE_CRX_CONFIG_CRC_MASK_M RDMA_MASK3(32, 0x7, IG3_CRX_GLPE_CRX_CONFIG_CRC_MASK_S)
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_COUNT 0x424009B8
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CRX_GLPE_CRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CRX_GLPE_CRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_CMD 0x424009CC
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_DATA_H 0x424009D8
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_DATA_L 0x424009D4
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_PTR 0x424009D0
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CRX_GLPE_CRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_CMD 0x424009BC
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_DATA_H 0x424009C8
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_DATA_L 0x424009C4
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_PTR 0x424009C0
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CRX_GLPE_CRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_CONTROL 0x42400980
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_RSVD1_S 25
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_CRX_GLPE_CRX_DTM_CONTROL_RSVD1_S)
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_RSVD2_S 17
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CRX_GLPE_CRX_DTM_CONTROL_RSVD2_S)
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_RSVD3_S 9
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_CRX_GLPE_CRX_DTM_CONTROL_RSVD3_S)
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_BYPASS_S 8
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_CONTROL_BYPASS_S)
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_RSVD4_S 1
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_CRX_GLPE_CRX_DTM_CONTROL_RSVD4_S)
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_CRX_GLPE_CRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_CRX_GLPE_CRX_DTM_ECC_COR_ERR 0x424009E8
#define IG3_CRX_GLPE_CRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_CRX_GLPE_CRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CRX_GLPE_CRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_CRX_GLPE_CRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_CRX_GLPE_CRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CRX_GLPE_CRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_CRX_GLPE_CRX_DTM_ECC_UNCOR_ERR 0x424009E4
#define IG3_CRX_GLPE_CRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CRX_GLPE_CRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CRX_GLPE_CRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CRX_GLPE_CRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CRX_GLPE_CRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CRX_GLPE_CRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_CRX_GLPE_CRX_DTM_GROUP_CFG 0x4240098C
#define IG3_CRX_GLPE_CRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_CRX_GLPE_CRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_CRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_CRX_GLPE_CRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_CRX_GLPE_CRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_CRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_CRX_GLPE_CRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_CRX_GLPE_CRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_CRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_CRX_GLPE_CRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_CRX_GLPE_CRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_CRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_CRX_GLPE_CRX_DTM_LOG_CFG 0x42400990
#define IG3_CRX_GLPE_CRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_CRX_GLPE_CRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_CRX_GLPE_CRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_CRX_GLPE_CRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_CRX_GLPE_CRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CRX_GLPE_CRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_CRX_GLPE_CRX_DTM_LOG_CFG_MODE_S 0
#define IG3_CRX_GLPE_CRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_CRX_DTM_LOG_CFG_MODE_S)
#define IG3_CRX_GLPE_CRX_DTM_LOG_MASK 0x42400998
#define IG3_CRX_GLPE_CRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_DTM_LOG_MASK_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_LOG_PATTERN 0x42400994
#define IG3_CRX_GLPE_CRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_MAIN_CFG 0x42400984
#define IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_CRX_GLPE_CRX_DTM_MAIN_STS 0x42400988
#define IG3_CRX_GLPE_CRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_CRX_GLPE_CRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_CRX_GLPE_CRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_CRX_GLPE_CRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_CRX_GLPE_CRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_CRX_GLPE_CRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_CRX_GLPE_CRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CRX_GLPE_CRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_CRX_GLPE_CRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_CRX_GLPE_CRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_CRX_GLPE_CRX_DTM_TIMESTAMP 0x424009B0
#define IG3_CRX_GLPE_CRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_TIMESTAMP_ROLLOVER 0x424009B4
#define IG3_CRX_GLPE_CRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG 0x424009DC
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS 0x424009E0
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CRX_GLPE_CRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_CRX_GLPE_CRX_DTM_TRIG_CFG 0x4240099C
#define IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_CRX_DTM_TRIG_CFG_MODE_S)
#define IG3_CRX_GLPE_CRX_DTM_TRIG_COUNT 0x424009A8
#define IG3_CRX_GLPE_CRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_TRIG_MASK 0x424009A4
#define IG3_CRX_GLPE_CRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_TRIG_PATTERN 0x424009A0
#define IG3_CRX_GLPE_CRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_CRX_GLPE_CRX_DTM_TRIG_TIMESTAMP 0x424009AC
#define IG3_CRX_GLPE_CRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_CRX_GLPE_CRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CRX_GLPE_CRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_CRX_GLPE_CRX_ECC_COR_ERR 0x424008E0
#define IG3_CRX_GLPE_CRX_ECC_COR_ERR_RSVD_S 12
#define IG3_CRX_GLPE_CRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CRX_GLPE_CRX_ECC_COR_ERR_RSVD_S)
#define IG3_CRX_GLPE_CRX_ECC_COR_ERR_CNT_S 0
#define IG3_CRX_GLPE_CRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CRX_GLPE_CRX_ECC_COR_ERR_CNT_S)
#define IG3_CRX_GLPE_CRX_ECC_UNCOR_ERR 0x424008DC
#define IG3_CRX_GLPE_CRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CRX_GLPE_CRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CRX_GLPE_CRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CRX_GLPE_CRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CRX_GLPE_CRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CRX_GLPE_CRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG 0x424008E4
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_ECC_INST_NUM_S 25
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CRX_GLPE_MC_OC_BUF_CFG_ECC_INST_NUM_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_RSVD3_S 20
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CRX_GLPE_MC_OC_BUF_CFG_RSVD3_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_RM_S 16
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_MC_OC_BUF_CFG_RM_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_RSVD2_S 14
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_MC_OC_BUF_CFG_RSVD2_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_POWER_GATE_EN_S 13
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MC_OC_BUF_CFG_POWER_GATE_EN_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_RME_S 12
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_RME_M RDMA_BIT2(32, IG3_CRX_GLPE_MC_OC_BUF_CFG_RME_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_RSVD1_S 10
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_MC_OC_BUF_CFG_RSVD1_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_ERR_CNT_S 9
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_MC_OC_BUF_CFG_ERR_CNT_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_FIX_CNT_S 8
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_MC_OC_BUF_CFG_FIX_CNT_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_RSVD0_S 6
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_MC_OC_BUF_CFG_RSVD0_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_MASK_INT_S 5
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CRX_GLPE_MC_OC_BUF_CFG_MASK_INT_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_LS_BYPASS_S 4
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CRX_GLPE_MC_OC_BUF_CFG_LS_BYPASS_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_LS_FORCE_S 3
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CRX_GLPE_MC_OC_BUF_CFG_LS_FORCE_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_ECC_INVERT_2_S 2
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CRX_GLPE_MC_OC_BUF_CFG_ECC_INVERT_2_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_ECC_INVERT_1_S 1
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CRX_GLPE_MC_OC_BUF_CFG_ECC_INVERT_1_S)
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_ECC_EN_S 0
#define IG3_CRX_GLPE_MC_OC_BUF_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MC_OC_BUF_CFG_ECC_EN_S)
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS 0x424008E8
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS_RSVD1_S 30
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_MC_OC_BUF_STATUS_RSVD1_S)
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CRX_GLPE_MC_OC_BUF_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS_RSVD0_S 4
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_MC_OC_BUF_STATUS_RSVD0_S)
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CRX_GLPE_MC_OC_BUF_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS_INIT_DONE_S 2
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CRX_GLPE_MC_OC_BUF_STATUS_INIT_DONE_S)
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS_ECC_FIX_S 1
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CRX_GLPE_MC_OC_BUF_STATUS_ECC_FIX_S)
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS_ECC_ERR_S 0
#define IG3_CRX_GLPE_MC_OC_BUF_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CRX_GLPE_MC_OC_BUF_STATUS_ECC_ERR_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD 0x424008AC
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_RSVD_S 8
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_RSVD_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST7_CREDIT_EN_S 7
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST7_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST7_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST6_CREDIT_EN_S 6
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST6_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST6_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST5_CREDIT_EN_S 5
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST5_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST5_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST4_CREDIT_EN_S 4
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST4_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST4_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST3_CREDIT_EN_S 3
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST3_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST3_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST2_CREDIT_EN_S 2
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST2_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST2_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST1_CREDIT_EN_S 1
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST1_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST1_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST0_CREDIT_EN_S 0
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST0_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PD_HOST0_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD 0x424008C4
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_RSVD_S 8
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_RSVD_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST7_CREDIT_EN_S 7
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST7_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST7_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST6_CREDIT_EN_S 6
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST6_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST6_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST5_CREDIT_EN_S 5
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST5_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST5_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST4_CREDIT_EN_S 4
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST4_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST4_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST3_CREDIT_EN_S 3
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST3_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST3_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST2_CREDIT_EN_S 2
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST2_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST2_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST1_CREDIT_EN_S 1
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST1_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST1_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST0_CREDIT_EN_S 0
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST0_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_CRT_PMD_HOST0_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD 0x4240087C
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_RSVD_S 8
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_RSVD_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST7_CREDIT_EN_S 7
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST7_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST7_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST6_CREDIT_EN_S 6
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST6_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST6_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST5_CREDIT_EN_S 5
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST5_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST5_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST4_CREDIT_EN_S 4
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST4_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST4_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST3_CREDIT_EN_S 3
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST3_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST3_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST2_CREDIT_EN_S 2
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST2_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST2_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST1_CREDIT_EN_S 1
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST1_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST1_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST0_CREDIT_EN_S 0
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST0_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PD_HOST0_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD 0x42400894
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_RSVD_S 8
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_RSVD_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST7_CREDIT_EN_S 7
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST7_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST7_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST6_CREDIT_EN_S 6
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST6_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST6_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST5_CREDIT_EN_S 5
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST5_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST5_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST4_CREDIT_EN_S 4
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST4_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST4_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST3_CREDIT_EN_S 3
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST3_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST3_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST2_CREDIT_EN_S 2
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST2_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST2_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST1_CREDIT_EN_S 1
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST1_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST1_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST0_CREDIT_EN_S 0
#define IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST0_CREDIT_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_MIF_HOST_CREDIT_ENABLE_PR_PMD_HOST0_CREDIT_EN_S)
#define IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_CRT_PD(_i) 0x424008B0 + ((_i) * 4) /* _i=0...4 */
#define IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_CRT_PD_MAX_INDEX_I 4
#define IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_CRT_PD_RSVD_S 12
#define IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_CRT_PD_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_CRT_PD_RSVD_S)
#define IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_CRT_PD_INIT_VALUE_S 0
#define IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_CRT_PD_INIT_VALUE_M RDMA_MASK3(32, 0xFFF, IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_CRT_PD_INIT_VALUE_S)
#define IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_PR_PD(_i) 0x42400880 + ((_i) * 4) /* _i=0...4 */
#define IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_PR_PD_MAX_INDEX_I 4
#define IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_PR_PD_RSVD_S 12
#define IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_PR_PD_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_PR_PD_RSVD_S)
#define IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_PR_PD_INIT_VALUE_S 0
#define IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_PR_PD_INIT_VALUE_M RDMA_MASK3(32, 0xFFF, IG3_CRX_GLPE_MIF_PD_INITIAL_CREDIT_VALUE_PR_PD_INIT_VALUE_S)
#define IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_CRT_PMD(_i) 0x424008C8 + ((_i) * 4) /* _i=0...4 */
#define IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_CRT_PMD_MAX_INDEX_I 4
#define IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_CRT_PMD_RSVD_S 12
#define IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_CRT_PMD_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_CRT_PMD_RSVD_S)
#define IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_CRT_PMD_INIT_VALUE_S 0
#define IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_CRT_PMD_INIT_VALUE_M RDMA_MASK3(32, 0xFFF, IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_CRT_PMD_INIT_VALUE_S)
#define IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_PR_PMD(_i) 0x42400898 + ((_i) * 4) /* _i=0...4 */
#define IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_PR_PMD_MAX_INDEX_I 4
#define IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_PR_PMD_RSVD_S 12
#define IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_PR_PMD_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_PR_PMD_RSVD_S)
#define IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_PR_PMD_INIT_VALUE_S 0
#define IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_PR_PMD_INIT_VALUE_M RDMA_MASK3(32, 0xFFF, IG3_CRX_GLPE_MIF_PMD_INITIAL_CREDIT_VALUE_PR_PMD_INIT_VALUE_S)
#define IG3_CRX_GLPE_PARSEPTR_CRT_DEF 0x42400844
#define IG3_CRX_GLPE_PARSEPTR_CRT_DEF_RSVD_S 8
#define IG3_CRX_GLPE_PARSEPTR_CRT_DEF_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_PARSEPTR_CRT_DEF_RSVD_S)
#define IG3_CRX_GLPE_PARSEPTR_CRT_DEF_PARSEPTRID_S 0
#define IG3_CRX_GLPE_PARSEPTR_CRT_DEF_PARSEPTRID_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_PARSEPTR_CRT_DEF_PARSEPTRID_S)
#define IG3_CRX_GLPE_PARSEPTR_IPV4_DEF(_i) 0x42400810 + ((_i) * 4) /* _i=0...2 */
#define IG3_CRX_GLPE_PARSEPTR_IPV4_DEF_MAX_INDEX_I 2
#define IG3_CRX_GLPE_PARSEPTR_IPV4_DEF_RSVD_S 8
#define IG3_CRX_GLPE_PARSEPTR_IPV4_DEF_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_PARSEPTR_IPV4_DEF_RSVD_S)
#define IG3_CRX_GLPE_PARSEPTR_IPV4_DEF_PARSEPTRID_S 0
#define IG3_CRX_GLPE_PARSEPTR_IPV4_DEF_PARSEPTRID_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_PARSEPTR_IPV4_DEF_PARSEPTRID_S)
#define IG3_CRX_GLPE_PARSEPTR_IPV6_DEF(_i) 0x4240081C + ((_i) * 4) /* _i=0...2 */
#define IG3_CRX_GLPE_PARSEPTR_IPV6_DEF_MAX_INDEX_I 2
#define IG3_CRX_GLPE_PARSEPTR_IPV6_DEF_RSVD_S 8
#define IG3_CRX_GLPE_PARSEPTR_IPV6_DEF_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_PARSEPTR_IPV6_DEF_RSVD_S)
#define IG3_CRX_GLPE_PARSEPTR_IPV6_DEF_PARSEPTRID_S 0
#define IG3_CRX_GLPE_PARSEPTR_IPV6_DEF_PARSEPTRID_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_PARSEPTR_IPV6_DEF_PARSEPTRID_S)
#define IG3_CRX_GLPE_PARSEPTR_MAC_DEF(_i) 0x42400804 + ((_i) * 4) /* _i=0...2 */
#define IG3_CRX_GLPE_PARSEPTR_MAC_DEF_MAX_INDEX_I 2
#define IG3_CRX_GLPE_PARSEPTR_MAC_DEF_RSVD_S 8
#define IG3_CRX_GLPE_PARSEPTR_MAC_DEF_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_PARSEPTR_MAC_DEF_RSVD_S)
#define IG3_CRX_GLPE_PARSEPTR_MAC_DEF_PARSEPTRID_S 0
#define IG3_CRX_GLPE_PARSEPTR_MAC_DEF_PARSEPTRID_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_PARSEPTR_MAC_DEF_PARSEPTRID_S)
#define IG3_CRX_GLPE_PARSEPTR_PAY_DEF 0x42400848
#define IG3_CRX_GLPE_PARSEPTR_PAY_DEF_RSVD_S 8
#define IG3_CRX_GLPE_PARSEPTR_PAY_DEF_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_PARSEPTR_PAY_DEF_RSVD_S)
#define IG3_CRX_GLPE_PARSEPTR_PAY_DEF_PARSEPTRID_S 0
#define IG3_CRX_GLPE_PARSEPTR_PAY_DEF_PARSEPTRID_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_PARSEPTR_PAY_DEF_PARSEPTRID_S)
#define IG3_CRX_GLPE_PARSEPTR_ROCEV2_DEF 0x42400840
#define IG3_CRX_GLPE_PARSEPTR_ROCEV2_DEF_RSVD_S 8
#define IG3_CRX_GLPE_PARSEPTR_ROCEV2_DEF_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_PARSEPTR_ROCEV2_DEF_RSVD_S)
#define IG3_CRX_GLPE_PARSEPTR_ROCEV2_DEF_PARSEPTRID_S 0
#define IG3_CRX_GLPE_PARSEPTR_ROCEV2_DEF_PARSEPTRID_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_PARSEPTR_ROCEV2_DEF_PARSEPTRID_S)
#define IG3_CRX_GLPE_PARSEPTR_TCP_DEF 0x4240083C
#define IG3_CRX_GLPE_PARSEPTR_TCP_DEF_RSVD_S 8
#define IG3_CRX_GLPE_PARSEPTR_TCP_DEF_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_PARSEPTR_TCP_DEF_RSVD_S)
#define IG3_CRX_GLPE_PARSEPTR_TCP_DEF_PARSEPTRID_S 0
#define IG3_CRX_GLPE_PARSEPTR_TCP_DEF_PARSEPTRID_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_PARSEPTR_TCP_DEF_PARSEPTRID_S)
#define IG3_CRX_GLPE_PARSEPTR_UDP_DEF 0x42400838
#define IG3_CRX_GLPE_PARSEPTR_UDP_DEF_RSVD_S 8
#define IG3_CRX_GLPE_PARSEPTR_UDP_DEF_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_PARSEPTR_UDP_DEF_RSVD_S)
#define IG3_CRX_GLPE_PARSEPTR_UDP_DEF_PARSEPTRID_S 0
#define IG3_CRX_GLPE_PARSEPTR_UDP_DEF_PARSEPTRID_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_PARSEPTR_UDP_DEF_PARSEPTRID_S)
#define IG3_CRX_GLPE_PARSEPTR_VLAN_EXTERNAL_DEF(_i) 0x42400830 + ((_i) * 4) /* _i=0...1 */
#define IG3_CRX_GLPE_PARSEPTR_VLAN_EXTERNAL_DEF_MAX_INDEX_I 1
#define IG3_CRX_GLPE_PARSEPTR_VLAN_EXTERNAL_DEF_RSVD_S 8
#define IG3_CRX_GLPE_PARSEPTR_VLAN_EXTERNAL_DEF_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_PARSEPTR_VLAN_EXTERNAL_DEF_RSVD_S)
#define IG3_CRX_GLPE_PARSEPTR_VLAN_EXTERNAL_DEF_PARSEPTRID_S 0
#define IG3_CRX_GLPE_PARSEPTR_VLAN_EXTERNAL_DEF_PARSEPTRID_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_PARSEPTR_VLAN_EXTERNAL_DEF_PARSEPTRID_S)
#define IG3_CRX_GLPE_PARSEPTR_VLAN_INTERNAL_DEF(_i) 0x42400828 + ((_i) * 4) /* _i=0...1 */
#define IG3_CRX_GLPE_PARSEPTR_VLAN_INTERNAL_DEF_MAX_INDEX_I 1
#define IG3_CRX_GLPE_PARSEPTR_VLAN_INTERNAL_DEF_RSVD_S 8
#define IG3_CRX_GLPE_PARSEPTR_VLAN_INTERNAL_DEF_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CRX_GLPE_PARSEPTR_VLAN_INTERNAL_DEF_RSVD_S)
#define IG3_CRX_GLPE_PARSEPTR_VLAN_INTERNAL_DEF_PARSEPTRID_S 0
#define IG3_CRX_GLPE_PARSEPTR_VLAN_INTERNAL_DEF_PARSEPTRID_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_PARSEPTR_VLAN_INTERNAL_DEF_PARSEPTRID_S)
#define IG3_CRX_GLPE_RB_CREDIT_LIMIT(_i) 0x4240084C + ((_i) * 4) /* _i=0...4 */
#define IG3_CRX_GLPE_RB_CREDIT_LIMIT_MAX_INDEX_I 4
#define IG3_CRX_GLPE_RB_CREDIT_LIMIT_RSVD_S 22
#define IG3_CRX_GLPE_RB_CREDIT_LIMIT_RSVD_M RDMA_MASK3(32, 0x3FF, IG3_CRX_GLPE_RB_CREDIT_LIMIT_RSVD_S)
#define IG3_CRX_GLPE_RB_CREDIT_LIMIT_SHARED_S 11
#define IG3_CRX_GLPE_RB_CREDIT_LIMIT_SHARED_M RDMA_MASK3(32, 0x7FF, IG3_CRX_GLPE_RB_CREDIT_LIMIT_SHARED_S)
#define IG3_CRX_GLPE_RB_CREDIT_LIMIT_DEDICATED_S 0
#define IG3_CRX_GLPE_RB_CREDIT_LIMIT_DEDICATED_M RDMA_MASK3(32, 0x7FF, IG3_CRX_GLPE_RB_CREDIT_LIMIT_DEDICATED_S)
#define IG3_CRX_GLPE_RB_CREDIT_USED(_i) 0x42400864 + ((_i) * 4) /* _i=0...4 */
#define IG3_CRX_GLPE_RB_CREDIT_USED_MAX_INDEX_I 4
#define IG3_CRX_GLPE_RB_CREDIT_USED_RSVD_S 22
#define IG3_CRX_GLPE_RB_CREDIT_USED_RSVD_M RDMA_MASK3(32, 0x3FF, IG3_CRX_GLPE_RB_CREDIT_USED_RSVD_S)
#define IG3_CRX_GLPE_RB_CREDIT_USED_SHARED_S 11
#define IG3_CRX_GLPE_RB_CREDIT_USED_SHARED_M RDMA_MASK3(32, 0x7FF, IG3_CRX_GLPE_RB_CREDIT_USED_SHARED_S)
#define IG3_CRX_GLPE_RB_CREDIT_USED_DEDICATED_S 0
#define IG3_CRX_GLPE_RB_CREDIT_USED_DEDICATED_M RDMA_MASK3(32, 0x7FF, IG3_CRX_GLPE_RB_CREDIT_USED_DEDICATED_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG 0x424008EC
#define IG3_CRX_GLPE_RB_DATA_0_CFG_ECC_INST_NUM_S 25
#define IG3_CRX_GLPE_RB_DATA_0_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CRX_GLPE_RB_DATA_0_CFG_ECC_INST_NUM_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_RSVD3_S 20
#define IG3_CRX_GLPE_RB_DATA_0_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CRX_GLPE_RB_DATA_0_CFG_RSVD3_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_RM_S 16
#define IG3_CRX_GLPE_RB_DATA_0_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_RB_DATA_0_CFG_RM_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_RSVD2_S 14
#define IG3_CRX_GLPE_RB_DATA_0_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_DATA_0_CFG_RSVD2_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_POWER_GATE_EN_S 13
#define IG3_CRX_GLPE_RB_DATA_0_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_0_CFG_POWER_GATE_EN_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_RME_S 12
#define IG3_CRX_GLPE_RB_DATA_0_CFG_RME_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_0_CFG_RME_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_RSVD1_S 10
#define IG3_CRX_GLPE_RB_DATA_0_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_DATA_0_CFG_RSVD1_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_ERR_CNT_S 9
#define IG3_CRX_GLPE_RB_DATA_0_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_0_CFG_ERR_CNT_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_FIX_CNT_S 8
#define IG3_CRX_GLPE_RB_DATA_0_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_0_CFG_FIX_CNT_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_RSVD0_S 6
#define IG3_CRX_GLPE_RB_DATA_0_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_DATA_0_CFG_RSVD0_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_MASK_INT_S 5
#define IG3_CRX_GLPE_RB_DATA_0_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_0_CFG_MASK_INT_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_LS_BYPASS_S 4
#define IG3_CRX_GLPE_RB_DATA_0_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_0_CFG_LS_BYPASS_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_LS_FORCE_S 3
#define IG3_CRX_GLPE_RB_DATA_0_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_0_CFG_LS_FORCE_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_ECC_INVERT_2_S 2
#define IG3_CRX_GLPE_RB_DATA_0_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_0_CFG_ECC_INVERT_2_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_ECC_INVERT_1_S 1
#define IG3_CRX_GLPE_RB_DATA_0_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_0_CFG_ECC_INVERT_1_S)
#define IG3_CRX_GLPE_RB_DATA_0_CFG_ECC_EN_S 0
#define IG3_CRX_GLPE_RB_DATA_0_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_0_CFG_ECC_EN_S)
#define IG3_CRX_GLPE_RB_DATA_0_STATUS 0x424008F0
#define IG3_CRX_GLPE_RB_DATA_0_STATUS_RSVD1_S 30
#define IG3_CRX_GLPE_RB_DATA_0_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_DATA_0_STATUS_RSVD1_S)
#define IG3_CRX_GLPE_RB_DATA_0_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CRX_GLPE_RB_DATA_0_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CRX_GLPE_RB_DATA_0_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CRX_GLPE_RB_DATA_0_STATUS_RSVD0_S 4
#define IG3_CRX_GLPE_RB_DATA_0_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_RB_DATA_0_STATUS_RSVD0_S)
#define IG3_CRX_GLPE_RB_DATA_0_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CRX_GLPE_RB_DATA_0_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_0_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CRX_GLPE_RB_DATA_0_STATUS_INIT_DONE_S 2
#define IG3_CRX_GLPE_RB_DATA_0_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_0_STATUS_INIT_DONE_S)
#define IG3_CRX_GLPE_RB_DATA_0_STATUS_ECC_FIX_S 1
#define IG3_CRX_GLPE_RB_DATA_0_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_0_STATUS_ECC_FIX_S)
#define IG3_CRX_GLPE_RB_DATA_0_STATUS_ECC_ERR_S 0
#define IG3_CRX_GLPE_RB_DATA_0_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_0_STATUS_ECC_ERR_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG 0x424008F4
#define IG3_CRX_GLPE_RB_DATA_1_CFG_ECC_INST_NUM_S 25
#define IG3_CRX_GLPE_RB_DATA_1_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CRX_GLPE_RB_DATA_1_CFG_ECC_INST_NUM_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_RSVD3_S 20
#define IG3_CRX_GLPE_RB_DATA_1_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CRX_GLPE_RB_DATA_1_CFG_RSVD3_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_RM_S 16
#define IG3_CRX_GLPE_RB_DATA_1_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_RB_DATA_1_CFG_RM_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_RSVD2_S 14
#define IG3_CRX_GLPE_RB_DATA_1_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_DATA_1_CFG_RSVD2_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_POWER_GATE_EN_S 13
#define IG3_CRX_GLPE_RB_DATA_1_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_1_CFG_POWER_GATE_EN_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_RME_S 12
#define IG3_CRX_GLPE_RB_DATA_1_CFG_RME_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_1_CFG_RME_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_RSVD1_S 10
#define IG3_CRX_GLPE_RB_DATA_1_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_DATA_1_CFG_RSVD1_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_ERR_CNT_S 9
#define IG3_CRX_GLPE_RB_DATA_1_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_1_CFG_ERR_CNT_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_FIX_CNT_S 8
#define IG3_CRX_GLPE_RB_DATA_1_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_1_CFG_FIX_CNT_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_RSVD0_S 6
#define IG3_CRX_GLPE_RB_DATA_1_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_DATA_1_CFG_RSVD0_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_MASK_INT_S 5
#define IG3_CRX_GLPE_RB_DATA_1_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_1_CFG_MASK_INT_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_LS_BYPASS_S 4
#define IG3_CRX_GLPE_RB_DATA_1_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_1_CFG_LS_BYPASS_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_LS_FORCE_S 3
#define IG3_CRX_GLPE_RB_DATA_1_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_1_CFG_LS_FORCE_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_ECC_INVERT_2_S 2
#define IG3_CRX_GLPE_RB_DATA_1_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_1_CFG_ECC_INVERT_2_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_ECC_INVERT_1_S 1
#define IG3_CRX_GLPE_RB_DATA_1_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_1_CFG_ECC_INVERT_1_S)
#define IG3_CRX_GLPE_RB_DATA_1_CFG_ECC_EN_S 0
#define IG3_CRX_GLPE_RB_DATA_1_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_1_CFG_ECC_EN_S)
#define IG3_CRX_GLPE_RB_DATA_1_STATUS 0x424008F8
#define IG3_CRX_GLPE_RB_DATA_1_STATUS_RSVD1_S 30
#define IG3_CRX_GLPE_RB_DATA_1_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_DATA_1_STATUS_RSVD1_S)
#define IG3_CRX_GLPE_RB_DATA_1_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CRX_GLPE_RB_DATA_1_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CRX_GLPE_RB_DATA_1_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CRX_GLPE_RB_DATA_1_STATUS_RSVD0_S 4
#define IG3_CRX_GLPE_RB_DATA_1_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_RB_DATA_1_STATUS_RSVD0_S)
#define IG3_CRX_GLPE_RB_DATA_1_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CRX_GLPE_RB_DATA_1_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_1_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CRX_GLPE_RB_DATA_1_STATUS_INIT_DONE_S 2
#define IG3_CRX_GLPE_RB_DATA_1_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_1_STATUS_INIT_DONE_S)
#define IG3_CRX_GLPE_RB_DATA_1_STATUS_ECC_FIX_S 1
#define IG3_CRX_GLPE_RB_DATA_1_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_1_STATUS_ECC_FIX_S)
#define IG3_CRX_GLPE_RB_DATA_1_STATUS_ECC_ERR_S 0
#define IG3_CRX_GLPE_RB_DATA_1_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_DATA_1_STATUS_ECC_ERR_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG 0x424008FC
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_ECC_INST_NUM_S 25
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CRX_GLPE_RB_METADATA_0_CFG_ECC_INST_NUM_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_RSVD3_S 20
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CRX_GLPE_RB_METADATA_0_CFG_RSVD3_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_RM_S 16
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_RB_METADATA_0_CFG_RM_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_RSVD2_S 14
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_METADATA_0_CFG_RSVD2_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_POWER_GATE_EN_S 13
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_0_CFG_POWER_GATE_EN_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_RME_S 12
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_RME_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_0_CFG_RME_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_RSVD1_S 10
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_METADATA_0_CFG_RSVD1_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_ERR_CNT_S 9
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_0_CFG_ERR_CNT_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_FIX_CNT_S 8
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_0_CFG_FIX_CNT_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_RSVD0_S 6
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_METADATA_0_CFG_RSVD0_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_MASK_INT_S 5
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_0_CFG_MASK_INT_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_LS_BYPASS_S 4
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_0_CFG_LS_BYPASS_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_LS_FORCE_S 3
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_0_CFG_LS_FORCE_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_ECC_INVERT_2_S 2
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_0_CFG_ECC_INVERT_2_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_ECC_INVERT_1_S 1
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_0_CFG_ECC_INVERT_1_S)
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_ECC_EN_S 0
#define IG3_CRX_GLPE_RB_METADATA_0_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_0_CFG_ECC_EN_S)
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS 0x42400900
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS_RSVD1_S 30
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_METADATA_0_STATUS_RSVD1_S)
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CRX_GLPE_RB_METADATA_0_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS_RSVD0_S 4
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_RB_METADATA_0_STATUS_RSVD0_S)
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_0_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS_INIT_DONE_S 2
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_0_STATUS_INIT_DONE_S)
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS_ECC_FIX_S 1
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_0_STATUS_ECC_FIX_S)
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS_ECC_ERR_S 0
#define IG3_CRX_GLPE_RB_METADATA_0_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_0_STATUS_ECC_ERR_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG 0x42400904
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_ECC_INST_NUM_S 25
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CRX_GLPE_RB_METADATA_1_CFG_ECC_INST_NUM_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_RSVD3_S 20
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CRX_GLPE_RB_METADATA_1_CFG_RSVD3_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_RM_S 16
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CRX_GLPE_RB_METADATA_1_CFG_RM_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_RSVD2_S 14
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_METADATA_1_CFG_RSVD2_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_POWER_GATE_EN_S 13
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_1_CFG_POWER_GATE_EN_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_RME_S 12
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_RME_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_1_CFG_RME_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_RSVD1_S 10
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_METADATA_1_CFG_RSVD1_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_ERR_CNT_S 9
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_1_CFG_ERR_CNT_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_FIX_CNT_S 8
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_1_CFG_FIX_CNT_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_RSVD0_S 6
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_METADATA_1_CFG_RSVD0_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_MASK_INT_S 5
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_1_CFG_MASK_INT_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_LS_BYPASS_S 4
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_1_CFG_LS_BYPASS_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_LS_FORCE_S 3
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_1_CFG_LS_FORCE_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_ECC_INVERT_2_S 2
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_1_CFG_ECC_INVERT_2_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_ECC_INVERT_1_S 1
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_1_CFG_ECC_INVERT_1_S)
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_ECC_EN_S 0
#define IG3_CRX_GLPE_RB_METADATA_1_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_1_CFG_ECC_EN_S)
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS 0x42400908
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS_RSVD1_S 30
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CRX_GLPE_RB_METADATA_1_STATUS_RSVD1_S)
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CRX_GLPE_RB_METADATA_1_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS_RSVD0_S 4
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CRX_GLPE_RB_METADATA_1_STATUS_RSVD0_S)
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_1_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS_INIT_DONE_S 2
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_1_STATUS_INIT_DONE_S)
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS_ECC_FIX_S 1
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_1_STATUS_ECC_FIX_S)
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS_ECC_ERR_S 0
#define IG3_CRX_GLPE_RB_METADATA_1_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CRX_GLPE_RB_METADATA_1_STATUS_ECC_ERR_S)
#define IG3_CRX_GLPE_RB_TOTAL_CREDIT_LIMIT 0x42400860
#define IG3_CRX_GLPE_RB_TOTAL_CREDIT_LIMIT_RSVD_S 22
#define IG3_CRX_GLPE_RB_TOTAL_CREDIT_LIMIT_RSVD_M RDMA_MASK3(32, 0x3FF, IG3_CRX_GLPE_RB_TOTAL_CREDIT_LIMIT_RSVD_S)
#define IG3_CRX_GLPE_RB_TOTAL_CREDIT_LIMIT_TOTAL_SHARED_S 11
#define IG3_CRX_GLPE_RB_TOTAL_CREDIT_LIMIT_TOTAL_SHARED_M RDMA_MASK3(32, 0x7FF, IG3_CRX_GLPE_RB_TOTAL_CREDIT_LIMIT_TOTAL_SHARED_S)
#define IG3_CRX_GLPE_RB_TOTAL_CREDIT_LIMIT_TOTAL_CREDIT_S 0
#define IG3_CRX_GLPE_RB_TOTAL_CREDIT_LIMIT_TOTAL_CREDIT_M RDMA_MASK3(32, 0x7FF, IG3_CRX_GLPE_RB_TOTAL_CREDIT_LIMIT_TOTAL_CREDIT_S)
#define IG3_CRX_GLPE_RB_TOTAL_CREDIT_USED 0x42400878
#define IG3_CRX_GLPE_RB_TOTAL_CREDIT_USED_RSVD_S 22
#define IG3_CRX_GLPE_RB_TOTAL_CREDIT_USED_RSVD_M RDMA_MASK3(32, 0x3FF, IG3_CRX_GLPE_RB_TOTAL_CREDIT_USED_RSVD_S)
#define IG3_CRX_GLPE_RB_TOTAL_CREDIT_USED_TOTAL_SHARED_S 11
#define IG3_CRX_GLPE_RB_TOTAL_CREDIT_USED_TOTAL_SHARED_M RDMA_MASK3(32, 0x7FF, IG3_CRX_GLPE_RB_TOTAL_CREDIT_USED_TOTAL_SHARED_S)
#define IG3_CRX_GLPE_RB_TOTAL_CREDIT_USED_TOTAL_DEDICATED_S 0
#define IG3_CRX_GLPE_RB_TOTAL_CREDIT_USED_TOTAL_DEDICATED_M RDMA_MASK3(32, 0x7FF, IG3_CRX_GLPE_RB_TOTAL_CREDIT_USED_TOTAL_DEDICATED_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_CRED(_i) 0x424837C0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_CRED_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_CRED_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_CRED_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_CRED_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_CRED_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_CRED_COUNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_CRED_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_HW(_i) 0x42483880 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_HW_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_HW_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_HW_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_HW_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_HW_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_HW_THRESH_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_HW_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_LW(_i) 0x42483940 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_LW_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_LW_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_LW_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_LW_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_LW_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_LW_THRESH_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_BUF_LW_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_CRED(_i) 0x424837A0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_CRED_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_CRED_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_CRED_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_CRED_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_CRED_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_CRED_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_CRED_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_HW(_i) 0x42483860 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_HW_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_HW_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_HW_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_HW_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_HW_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_HW_THRESH_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_HW_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_LW(_i) 0x42483920 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_LW_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_LW_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_LW_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_LW_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_LW_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_LW_THRESH_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_RX_PKT_LW_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_CRED(_i) 0x42483780 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_CRED_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_CRED_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_CRED_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_CRED_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_CRED_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_CRED_COUNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_CRED_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_HW(_i) 0x42483840 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_HW_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_HW_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_HW_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_HW_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_HW_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_HW_THRESH_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_HW_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_LW(_i) 0x42483900 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_LW_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_LW_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_LW_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_LW_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_LW_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_LW_THRESH_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_BUF_LW_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_CRED(_i) 0x42483760 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_CRED_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_CRED_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_CRED_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_CRED_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_CRED_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_CRED_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_CRED_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_HW(_i) 0x42483820 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_HW_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_HW_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_HW_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_HW_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_HW_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_HW_THRESH_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_HW_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_LW(_i) 0x424838E0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_LW_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_LW_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_LW_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_LW_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_LW_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_LW_THRESH_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_REQ_TX_PKT_LW_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_CRED(_i) 0x42483740 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_CRED_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_CRED_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_CRED_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_CRED_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_CRED_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_CRED_COUNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_CRED_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_HW(_i) 0x42483800 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_HW_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_HW_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_HW_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_HW_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_HW_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_HW_THRESH_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_HW_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_LW(_i) 0x424838C0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_LW_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_LW_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_LW_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_LW_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_LW_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_LW_THRESH_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_BUF_LW_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_CRED(_i) 0x42483720 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_CRED_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_CRED_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_CRED_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_CRED_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_CRED_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_CRED_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_CRED_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_HW(_i) 0x424837E0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_HW_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_HW_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_HW_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_HW_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_HW_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_HW_THRESH_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_HW_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_LW(_i) 0x424838A0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_LW_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_LW_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_LW_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_LW_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_LW_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_LW_THRESH_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_HOST_RSP_TX_PKT_LW_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC 0x4248B0C4
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_REQ_BUF_CREDIT_RX_S 21
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_REQ_BUF_CREDIT_RX_M RDMA_MASK3(32, 0x7FF, IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_REQ_BUF_CREDIT_RX_S)
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_RSVD3_S 19
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_RSVD3_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_RSVD3_S)
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_REQ_PKT_CREDIT_RX_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_REQ_PKT_CREDIT_RX_M RDMA_MASK3(32, 0x7, IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_REQ_PKT_CREDIT_RX_S)
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_RSVD2_S 13
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_RSVD2_M RDMA_MASK3(32, 0x7, IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_RSVD2_S)
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_REQ_BUF_CREDIT_TX_S 8
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_REQ_BUF_CREDIT_TX_M RDMA_MASK3(32, 0x1F, IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_REQ_BUF_CREDIT_TX_S)
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_RSVD1_S 3
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_RSVD1_M RDMA_MASK3(32, 0x1F, IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_REQ_PKT_CREDIT_TX_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_REQ_PKT_CREDIT_TX_M RDMA_MASK3(32, 0x7, IG3_PEPM_GLPE_PEPM_CRT_PUSH_REQ_ALLOC_REQ_PKT_CREDIT_TX_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_HW_PROFILE(_i) 0x4248B050 + ((_i) * 4) /* _i=0...3 */
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_HW_PROFILE_MAX_INDEX_I 3
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_HW_PROFILE_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_HW_PROFILE_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_HW_PROFILE_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_HW_PROFILE_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_HW_PROFILE_THRESH_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_HW_PROFILE_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_LW_PROFILE(_i) 0x4248B0B0 + ((_i) * 4) /* _i=0...3 */
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_LW_PROFILE_MAX_INDEX_I 3
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_LW_PROFILE_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_LW_PROFILE_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_LW_PROFILE_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_LW_PROFILE_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_LW_PROFILE_THRESH_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_BUF_LW_PROFILE_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_HW_PROFILE(_i) 0x4248B040 + ((_i) * 4) /* _i=0...3 */
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_HW_PROFILE_MAX_INDEX_I 3
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_HW_PROFILE_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_HW_PROFILE_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_HW_PROFILE_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_HW_PROFILE_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_HW_PROFILE_THRESH_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_HW_PROFILE_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_LW_PROFILE(_i) 0x4248B0A0 + ((_i) * 4) /* _i=0...3 */
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_LW_PROFILE_MAX_INDEX_I 3
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_LW_PROFILE_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_LW_PROFILE_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_LW_PROFILE_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_LW_PROFILE_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_LW_PROFILE_THRESH_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_RX_PKT_LW_PROFILE_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_HW_PROFILE(_i) 0x4248B030 + ((_i) * 4) /* _i=0...3 */
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_HW_PROFILE_MAX_INDEX_I 3
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_HW_PROFILE_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_HW_PROFILE_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_HW_PROFILE_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_HW_PROFILE_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_HW_PROFILE_THRESH_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_HW_PROFILE_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_LW_PROFILE(_i) 0x4248B090 + ((_i) * 4) /* _i=0...3 */
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_LW_PROFILE_MAX_INDEX_I 3
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_LW_PROFILE_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_LW_PROFILE_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_LW_PROFILE_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_LW_PROFILE_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_LW_PROFILE_THRESH_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_BUF_LW_PROFILE_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_HW_PROFILE(_i) 0x4248B020 + ((_i) * 4) /* _i=0...3 */
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_HW_PROFILE_MAX_INDEX_I 3
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_HW_PROFILE_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_HW_PROFILE_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_HW_PROFILE_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_HW_PROFILE_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_HW_PROFILE_THRESH_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_HW_PROFILE_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_LW_PROFILE(_i) 0x4248B080 + ((_i) * 4) /* _i=0...3 */
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_LW_PROFILE_MAX_INDEX_I 3
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_LW_PROFILE_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_LW_PROFILE_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_LW_PROFILE_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_LW_PROFILE_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_LW_PROFILE_THRESH_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_REQ_TX_PKT_LW_PROFILE_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_HW_PROFILE(_i) 0x4248B010 + ((_i) * 4) /* _i=0...3 */
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_HW_PROFILE_MAX_INDEX_I 3
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_HW_PROFILE_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_HW_PROFILE_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_HW_PROFILE_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_HW_PROFILE_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_HW_PROFILE_THRESH_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_HW_PROFILE_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_LW_PROFILE(_i) 0x4248B070 + ((_i) * 4) /* _i=0...3 */
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_LW_PROFILE_MAX_INDEX_I 3
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_LW_PROFILE_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_LW_PROFILE_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_LW_PROFILE_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_LW_PROFILE_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_LW_PROFILE_THRESH_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_BUF_LW_PROFILE_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_HW_PROFILE(_i) 0x4248B000 + ((_i) * 4) /* _i=0...3 */
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_HW_PROFILE_MAX_INDEX_I 3
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_HW_PROFILE_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_HW_PROFILE_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_HW_PROFILE_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_HW_PROFILE_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_HW_PROFILE_THRESH_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_HW_PROFILE_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_LW_PROFILE(_i) 0x4248B060 + ((_i) * 4) /* _i=0...3 */
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_LW_PROFILE_MAX_INDEX_I 3
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_LW_PROFILE_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_LW_PROFILE_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_LW_PROFILE_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_LW_PROFILE_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_LW_PROFILE_THRESH_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_RSP_TX_PKT_LW_PROFILE_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC 0x4248B0C0
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_REQ_BUF_CREDIT_RX_S 21
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_REQ_BUF_CREDIT_RX_M RDMA_MASK3(32, 0x7FF, IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_REQ_BUF_CREDIT_RX_S)
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_RSVD3_S 20
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_RSVD3_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_RSVD3_S)
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_REQ_PKT_CREDIT_RX_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_REQ_PKT_CREDIT_RX_M RDMA_MASK3(32, 0xF, IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_REQ_PKT_CREDIT_RX_S)
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_RSVD2_S 13
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_RSVD2_M RDMA_MASK3(32, 0x7, IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_RSVD2_S)
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_REQ_BUF_CREDIT_TX_S 8
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_REQ_BUF_CREDIT_TX_M RDMA_MASK3(32, 0x1F, IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_REQ_BUF_CREDIT_TX_S)
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_RSVD1_S 4
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_REQ_PKT_CREDIT_TX_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_REQ_PKT_CREDIT_TX_M RDMA_MASK3(32, 0xF, IG3_PEPM_GLPE_PEPM_CRT_TSCD_REQ_ALLOC_REQ_PKT_CREDIT_TX_S)
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_RSP_ALLOC 0x4248B0C8
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_RSP_ALLOC_RSVD2_S 13
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_RSP_ALLOC_RSVD2_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_CRT_TSCD_RSP_ALLOC_RSVD2_S)
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_RSP_ALLOC_RSP_BUF_CREDIT_TX_S 8
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_RSP_ALLOC_RSP_BUF_CREDIT_TX_M RDMA_MASK3(32, 0x1F, IG3_PEPM_GLPE_PEPM_CRT_TSCD_RSP_ALLOC_RSP_BUF_CREDIT_TX_S)
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_RSP_ALLOC_RSVD1_S 4
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_RSP_ALLOC_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PEPM_GLPE_PEPM_CRT_TSCD_RSP_ALLOC_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_RSP_ALLOC_RSP_PKT_CREDIT_TX_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_TSCD_RSP_ALLOC_RSP_PKT_CREDIT_TX_M RDMA_MASK3(32, 0xF, IG3_PEPM_GLPE_PEPM_CRT_TSCD_RSP_ALLOC_RSP_PKT_CREDIT_TX_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG 0x4248B200
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RSVD3_S 20
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RSVD3_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RM_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RM_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RSVD2_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RSVD2_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RME_S 12
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RME_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RSVD1_S 10
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ERR_CNT_S 9
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ERR_CNT_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_FIX_CNT_S 8
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_FIX_CNT_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RSVD0_S 6
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_RSVD0_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_MASK_INT_S 5
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_MASK_INT_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_LS_BYPASS_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_LS_FORCE_S 3
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_LS_FORCE_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ECC_EN_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_CFG_ECC_EN_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS 0x4248B204
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_RSVD1_S 30
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_RSVD0_S 4
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_RSVD0_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_INIT_DONE_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_ECC_FIX_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CRT_VF_MEM_STATUS_ECC_ERR_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_PROFILE(_i) 0x4248A000 + ((_i) * 4) /* _i=0...1023 */
#define IG3_PEPM_GLPE_PEPM_CRT_VF_PROFILE_MAX_INDEX_I 1023
#define IG3_PEPM_GLPE_PEPM_CRT_VF_PROFILE_RSVD_S 2
#define IG3_PEPM_GLPE_PEPM_CRT_VF_PROFILE_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_PEPM_GLPE_PEPM_CRT_VF_PROFILE_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_PROFILE_PROFILE_ID_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_VF_PROFILE_PROFILE_ID_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_CRT_VF_PROFILE_PROFILE_ID_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_BUF_CRED(_i) 0x42489000 + ((_i) * 4) /* _i=0...1023 */
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_BUF_CRED_MAX_INDEX_I 1023
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_BUF_CRED_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_BUF_CRED_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_BUF_CRED_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_BUF_CRED_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_BUF_CRED_COUNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_BUF_CRED_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_PKT_CRED(_i) 0x42488000 + ((_i) * 4) /* _i=0...1023 */
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_PKT_CRED_MAX_INDEX_I 1023
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_PKT_CRED_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_PKT_CRED_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_PKT_CRED_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_PKT_CRED_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_PKT_CRED_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_RX_PKT_CRED_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_BUF_CRED(_i) 0x42487000 + ((_i) * 4) /* _i=0...1023 */
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_BUF_CRED_MAX_INDEX_I 1023
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_BUF_CRED_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_BUF_CRED_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_BUF_CRED_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_BUF_CRED_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_BUF_CRED_COUNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_BUF_CRED_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_PKT_CRED(_i) 0x42486000 + ((_i) * 4) /* _i=0...1023 */
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_PKT_CRED_MAX_INDEX_I 1023
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_PKT_CRED_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_PKT_CRED_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_PKT_CRED_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_PKT_CRED_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_PKT_CRED_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_VF_REQ_TX_PKT_CRED_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_BUF_CRED(_i) 0x42485000 + ((_i) * 4) /* _i=0...1023 */
#define IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_BUF_CRED_MAX_INDEX_I 1023
#define IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_BUF_CRED_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_BUF_CRED_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_BUF_CRED_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_BUF_CRED_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_BUF_CRED_COUNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_BUF_CRED_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_PKT_CRED(_i) 0x42484000 + ((_i) * 4) /* _i=0...1023 */
#define IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_PKT_CRED_MAX_INDEX_I 1023
#define IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_PKT_CRED_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_PKT_CRED_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_PKT_CRED_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_PKT_CRED_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_PKT_CRED_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_CRT_VF_RSP_TX_PKT_CRED_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_CSR_CNT_HI 0x4248B160
#define IG3_PEPM_GLPE_PEPM_CSR_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_CSR_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CSR_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_CSR_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_CSR_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_CSR_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_CSR_CNT_LO 0x4248B164
#define IG3_PEPM_GLPE_PEPM_CSR_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_CSR_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_CSR_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_CTRL 0x42480000
#define IG3_PEPM_GLPE_PEPM_CTRL_PEPM_IDLE_S 31
#define IG3_PEPM_GLPE_PEPM_CTRL_PEPM_IDLE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CTRL_PEPM_IDLE_S)
#define IG3_PEPM_GLPE_PEPM_CTRL_RSVD2_S 24
#define IG3_PEPM_GLPE_PEPM_CTRL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEPM_GLPE_PEPM_CTRL_RSVD2_S)
#define IG3_PEPM_GLPE_PEPM_CTRL_PEPM_PUSH_MARGIN_S 16
#define IG3_PEPM_GLPE_PEPM_CTRL_PEPM_PUSH_MARGIN_M RDMA_MASK3(32, 0xFF, IG3_PEPM_GLPE_PEPM_CTRL_PEPM_PUSH_MARGIN_S)
#define IG3_PEPM_GLPE_PEPM_CTRL_RSVD1_S 9
#define IG3_PEPM_GLPE_PEPM_CTRL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PEPM_GLPE_PEPM_CTRL_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_CTRL_PEPM_HALT_S 8
#define IG3_PEPM_GLPE_PEPM_CTRL_PEPM_HALT_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CTRL_PEPM_HALT_S)
#define IG3_PEPM_GLPE_PEPM_CTRL_RSVD0_S 4
#define IG3_PEPM_GLPE_PEPM_CTRL_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PEPM_GLPE_PEPM_CTRL_RSVD0_S)
#define IG3_PEPM_GLPE_PEPM_CTRL_PEPM_TS_UPDATE_S 3
#define IG3_PEPM_GLPE_PEPM_CTRL_PEPM_TS_UPDATE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CTRL_PEPM_TS_UPDATE_S)
#define IG3_PEPM_GLPE_PEPM_CTRL_PEPM_MODE_S 1
#define IG3_PEPM_GLPE_PEPM_CTRL_PEPM_MODE_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_CTRL_PEPM_MODE_S)
#define IG3_PEPM_GLPE_PEPM_CTRL_PEPM_ENABLE_S 0
#define IG3_PEPM_GLPE_PEPM_CTRL_PEPM_ENABLE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_CTRL_PEPM_ENABLE_S)
#define IG3_PEPM_GLPE_PEPM_DEALLOC_CNT_HI 0x4248B148
#define IG3_PEPM_GLPE_PEPM_DEALLOC_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_DEALLOC_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_DEALLOC_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_DEALLOC_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_DEALLOC_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_DEALLOC_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_DEALLOC_CNT_LO 0x4248B14C
#define IG3_PEPM_GLPE_PEPM_DEALLOC_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_DEALLOC_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_DEALLOC_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_COUNT 0x4248B1B8
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_CMD 0x4248B1CC
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_DATA_H 0x4248B1D8
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_DATA_L 0x4248B1D4
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_PTR 0x4248B1D0
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_CMD 0x4248B1BC
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_DATA_H 0x4248B1C8
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_DATA_L 0x4248B1C4
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_PTR 0x4248B1C0
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL 0x4248B180
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_RSVD1_S 25
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PEPM_GLPE_PEPM_DTM_CONTROL_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_RSVD2_S 17
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEPM_GLPE_PEPM_DTM_CONTROL_RSVD2_S)
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_RSVD3_S 9
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PEPM_GLPE_PEPM_DTM_CONTROL_RSVD3_S)
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_BYPASS_S 8
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_CONTROL_BYPASS_S)
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_RSVD4_S 1
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PEPM_GLPE_PEPM_DTM_CONTROL_RSVD4_S)
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PEPM_GLPE_PEPM_DTM_ECC_COR_ERR 0x4248B1E8
#define IG3_PEPM_GLPE_PEPM_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PEPM_GLPE_PEPM_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PEPM_GLPE_PEPM_DTM_ECC_UNCOR_ERR 0x4248B1E4
#define IG3_PEPM_GLPE_PEPM_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PEPM_GLPE_PEPM_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PEPM_GLPE_PEPM_DTM_GROUP_CFG 0x4248B18C
#define IG3_PEPM_GLPE_PEPM_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PEPM_GLPE_PEPM_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PEPM_GLPE_PEPM_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PEPM_GLPE_PEPM_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PEPM_GLPE_PEPM_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PEPM_GLPE_PEPM_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PEPM_GLPE_PEPM_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PEPM_GLPE_PEPM_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PEPM_GLPE_PEPM_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PEPM_GLPE_PEPM_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PEPM_GLPE_PEPM_DTM_LOG_CFG 0x4248B190
#define IG3_PEPM_GLPE_PEPM_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PEPM_GLPE_PEPM_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PEPM_GLPE_PEPM_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PEPM_GLPE_PEPM_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_DTM_LOG_CFG_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_DTM_LOG_CFG_MODE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_DTM_LOG_CFG_MODE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_LOG_MASK 0x4248B198
#define IG3_PEPM_GLPE_PEPM_DTM_LOG_MASK_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_DTM_LOG_MASK_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_LOG_PATTERN 0x4248B194
#define IG3_PEPM_GLPE_PEPM_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG 0x4248B184
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_STS 0x4248B188
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PEPM_GLPE_PEPM_DTM_MAIN_STS_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEPM_GLPE_PEPM_DTM_MAIN_STS_RSVD2_S)
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TIMESTAMP 0x4248B1B0
#define IG3_PEPM_GLPE_PEPM_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_DTM_TIMESTAMP_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TIMESTAMP_ROLLOVER 0x4248B1B4
#define IG3_PEPM_GLPE_PEPM_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG 0x4248B1DC
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS 0x4248B1E0
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG 0x4248B19C
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_MODE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PEPM_GLPE_PEPM_DTM_TRIG_CFG_MODE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_COUNT 0x4248B1A8
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_MASK 0x4248B1A4
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_DTM_TRIG_MASK_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_PATTERN 0x4248B1A0
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_TIMESTAMP 0x4248B1AC
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PEPM_GLPE_PEPM_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PEPM_GLPE_PEPM_ECC_COR_ERR 0x4248B214
#define IG3_PEPM_GLPE_PEPM_ECC_COR_ERR_RSVD_S 12
#define IG3_PEPM_GLPE_PEPM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_ECC_COR_ERR_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_ECC_COR_ERR_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_ECC_COR_ERR_CNT_S)
#define IG3_PEPM_GLPE_PEPM_ECC_UNCOR_ERR 0x4248B210
#define IG3_PEPM_GLPE_PEPM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PEPM_GLPE_PEPM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PEPM_GLPE_PEPM_ERLID_CNT_HI 0x4248B108
#define IG3_PEPM_GLPE_PEPM_ERLID_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_ERLID_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_ERLID_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_ERLID_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_ERLID_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_ERLID_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_ERLID_CNT_LO 0x4248B10C
#define IG3_PEPM_GLPE_PEPM_ERLID_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_ERLID_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_ERLID_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_ALLOC 0x4248B0CC
#define IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_ALLOC_RSVD2_S 30
#define IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_ALLOC_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_ALLOC_RSVD2_S)
#define IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_ALLOC_RSP_ERLID_ALLOC_SIZE_S 16
#define IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_ALLOC_RSP_ERLID_ALLOC_SIZE_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_ALLOC_RSP_ERLID_ALLOC_SIZE_S)
#define IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_ALLOC_RSVD1_S 14
#define IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_ALLOC_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_ALLOC_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_ALLOC_REQ_ERLID_ALLOC_SIZE_S 0
#define IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_ALLOC_REQ_ERLID_ALLOC_SIZE_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_ALLOC_REQ_ERLID_ALLOC_SIZE_S)
#define IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_PUSH 0x4248B0D0
#define IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_PUSH_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_PUSH_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_PUSH_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_PUSH_PUSH_ERLID_ALLOC_SIZE_S 0
#define IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_PUSH_PUSH_ERLID_ALLOC_SIZE_M RDMA_MASK3(32, 0x3FFF, IG3_PEPM_GLPE_PEPM_ERLID_QUANTA_TX_PUSH_PUSH_ERLID_ALLOC_SIZE_S)
#define IG3_PEPM_GLPE_PEPM_ERR_MSK 0x4248B174
#define IG3_PEPM_GLPE_PEPM_ERR_MSK_MASK_S 0
#define IG3_PEPM_GLPE_PEPM_ERR_MSK_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_ERR_MSK_MASK_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC 0x4248B178
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_RSVD_S 30
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_RSVD_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_ERR_SRC_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_BUF_CNTR_FTZ_S 29
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_BUF_CNTR_FTZ_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_BUF_CNTR_FTZ_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_PKT_CNTR_FTZ_S 28
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_PKT_CNTR_FTZ_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_PKT_CNTR_FTZ_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_VMIF_FIFO_OVF_S 27
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_VMIF_FIFO_OVF_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_VMIF_FIFO_OVF_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_VMIF_FIFO_UDF_S 26
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_VMIF_FIFO_UDF_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_VMIF_FIFO_UDF_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_TS_UPDATE_FIFO_OVF_S 25
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_TS_UPDATE_FIFO_OVF_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_TS_UPDATE_FIFO_OVF_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_TS_UPDATE_FIFO_UDF_S 24
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_TS_UPDATE_FIFO_UDF_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_TS_UPDATE_FIFO_UDF_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_DEALLOC_FIFO_OVF_S 23
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_DEALLOC_FIFO_OVF_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_DEALLOC_FIFO_OVF_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_DEALLOC_FIFO_UDF_S 22
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_DEALLOC_FIFO_UDF_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_DEALLOC_FIFO_UDF_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_TSIF_RSP_FIFO_UDF_S 21
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_TSIF_RSP_FIFO_UDF_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_TSIF_RSP_FIFO_UDF_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_TSIF_REQ_FIFO_UDF_S 20
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_TSIF_REQ_FIFO_UDF_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_TSIF_REQ_FIFO_UDF_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_TSIF_RSP_FIFO_OVF_S 19
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_TSIF_RSP_FIFO_OVF_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_TSIF_RSP_FIFO_OVF_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_TSIF_REQ_FIFO_OVF_S 18
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_TSIF_REQ_FIFO_OVF_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_TSIF_REQ_FIFO_OVF_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_VMRL_DRP_TXBW_ERR_S 17
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_VMRL_DRP_TXBW_ERR_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_VMRL_DRP_TXBW_ERR_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_VMRL_DRP_TRANS_ERR_S 16
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_VMRL_DRP_TRANS_ERR_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_VMRL_DRP_TRANS_ERR_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_ERL_CAM_VMISS_S 15
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_ERL_CAM_VMISS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_ERL_CAM_VMISS_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_ERL_CAM_MISS_S 14
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_ERL_CAM_MISS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_ERL_CAM_MISS_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_ERL_CAM_ALIGN_ERR_S 13
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_ERL_CAM_ALIGN_ERR_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_ERL_CAM_ALIGN_ERR_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_VF_CAM_VMISS_S 12
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_VF_CAM_VMISS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_VF_CAM_VMISS_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_VF_CAM_MISS_S 11
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_VF_CAM_MISS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_VF_CAM_MISS_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_VF_CAM_ALIGN_ERR_S 10
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_VF_CAM_ALIGN_ERR_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_VF_CAM_ALIGN_ERR_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_HOST_CAM_VMISS_S 9
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_HOST_CAM_VMISS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_HOST_CAM_VMISS_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_HOST_CAM_MISS_S 8
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_HOST_CAM_MISS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_HOST_CAM_MISS_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_HOST_CAM_ALIGN_ERR_S 7
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_HOST_CAM_ALIGN_ERR_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_HOST_CAM_ALIGN_ERR_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_UNEXPECTED_ARB_TRAN_S 6
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_UNEXPECTED_ARB_TRAN_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_UNEXPECTED_ARB_TRAN_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_DISABLED_W_ACT_REQS_S 5
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_DISABLED_W_ACT_REQS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_DISABLED_W_ACT_REQS_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_UNEXPECTED_PROTOCOL_S 4
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_UNEXPECTED_PROTOCOL_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_UNEXPECTED_PROTOCOL_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_POP_NO_PROTO_VLD_S 3
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_POP_NO_PROTO_VLD_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_POP_NO_PROTO_VLD_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_POP_NO_READ_VLD_S 2
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_POP_NO_READ_VLD_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_POP_NO_READ_VLD_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_PROTO_VLD_NO_POP_S 1
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_PROTO_VLD_NO_POP_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_PROTO_VLD_NO_POP_S)
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_READ_VLD_NO_POP_S 0
#define IG3_PEPM_GLPE_PEPM_ERR_SRC_READ_VLD_NO_POP_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_ERR_SRC_READ_VLD_NO_POP_S)
#define IG3_PEPM_GLPE_PEPM_ERR_STS 0x4248B170
#define IG3_PEPM_GLPE_PEPM_ERR_STS_ERR_S 0
#define IG3_PEPM_GLPE_PEPM_ERR_STS_ERR_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_ERR_STS_ERR_S)
#define IG3_PEPM_GLPE_PEPM_FCG_MAP(_i) 0x42480800 + ((_i) * 4) /* _i=0...2175 */
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_MAX_INDEX_I 2175
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_VALID_S 31
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_VALID_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_FCG_MAP_VALID_S)
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_RSVD1_S 30
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_RSVD1_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_FCG_MAP_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_LLTC_S 29
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_LLTC_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_FCG_MAP_LLTC_S)
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_CGD_S 23
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_CGD_M RDMA_MASK3(32, 0x3F, IG3_PEPM_GLPE_PEPM_FCG_MAP_CGD_S)
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_VF_S 13
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_VF_M RDMA_MASK3(32, 0x3FF, IG3_PEPM_GLPE_PEPM_FCG_MAP_VF_S)
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_HOST_S 10
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_HOST_M RDMA_MASK3(32, 0x7, IG3_PEPM_GLPE_PEPM_FCG_MAP_HOST_S)
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_ERLID_S 0
#define IG3_PEPM_GLPE_PEPM_FCG_MAP_ERLID_M RDMA_MASK3(32, 0x3FF, IG3_PEPM_GLPE_PEPM_FCG_MAP_ERLID_S)
#define IG3_PEPM_GLPE_PEPM_FREE_CNT_HI 0x4248B168
#define IG3_PEPM_GLPE_PEPM_FREE_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_FREE_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_FREE_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_FREE_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_FREE_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_FREE_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_FREE_CNT_LO 0x4248B16C
#define IG3_PEPM_GLPE_PEPM_FREE_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_FREE_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_FREE_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_FUNC_CNT_HI 0x4248B0E8
#define IG3_PEPM_GLPE_PEPM_FUNC_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_FUNC_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_FUNC_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_FUNC_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_FUNC_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_FUNC_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_FUNC_CNT_LO 0x4248B0EC
#define IG3_PEPM_GLPE_PEPM_FUNC_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_FUNC_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_FUNC_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_GLOBAL_CNT_HI 0x4248B120
#define IG3_PEPM_GLPE_PEPM_GLOBAL_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_GLOBAL_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_GLOBAL_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_GLOBAL_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_GLOBAL_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_GLOBAL_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_GLOBAL_CNT_LO 0x4248B124
#define IG3_PEPM_GLPE_PEPM_GLOBAL_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_GLOBAL_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_GLOBAL_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_HOST_CNT_HI 0x4248B0E0
#define IG3_PEPM_GLPE_PEPM_HOST_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_HOST_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_HOST_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_HOST_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_HOST_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_HOST_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_HOST_CNT_LO 0x4248B0E4
#define IG3_PEPM_GLPE_PEPM_HOST_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_HOST_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_HOST_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_INFLT_CNT_HI 0x4248B0F0
#define IG3_PEPM_GLPE_PEPM_INFLT_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_INFLT_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_INFLT_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_INFLT_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_INFLT_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_INFLT_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_INFLT_CNT_LO 0x4248B0F4
#define IG3_PEPM_GLPE_PEPM_INFLT_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_INFLT_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_INFLT_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_LLTC_CNT_HI 0x4248B0F8
#define IG3_PEPM_GLPE_PEPM_LLTC_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_LLTC_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_LLTC_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_LLTC_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_LLTC_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_LLTC_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_LLTC_CNT_LO 0x4248B0FC
#define IG3_PEPM_GLPE_PEPM_LLTC_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_LLTC_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_LLTC_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_PFC_CNT_HI 0x4248B158
#define IG3_PEPM_GLPE_PEPM_PFC_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_PFC_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_PFC_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_PFC_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_PFC_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_PFC_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_PFC_CNT_LO 0x4248B15C
#define IG3_PEPM_GLPE_PEPM_PFC_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_PFC_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_PFC_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_PFC_FC_CNT_HI 0x4248B118
#define IG3_PEPM_GLPE_PEPM_PFC_FC_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_PFC_FC_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_PFC_FC_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_PFC_FC_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_PFC_FC_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_PFC_FC_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_PFC_FC_CNT_LO 0x4248B11C
#define IG3_PEPM_GLPE_PEPM_PFC_FC_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_PFC_FC_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_PFC_FC_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1 0x4248B0D4
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_RSVD2_S 30
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_PMON_CTRL1_RSVD2_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_ERLID_SEL_S 20
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_ERLID_SEL_M RDMA_MASK3(32, 0x3FF, IG3_PEPM_GLPE_PEPM_PMON_CTRL1_ERLID_SEL_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_VF_SEL_S 8
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_VF_SEL_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_PMON_CTRL1_VF_SEL_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_RSVD1_S 7
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_RSVD1_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_PMON_CTRL1_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_HOST_SEL_S 4
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_HOST_SEL_M RDMA_MASK3(32, 0x7, IG3_PEPM_GLPE_PEPM_PMON_CTRL1_HOST_SEL_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_GLOBAL_SEL_S 2
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_GLOBAL_SEL_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_PMON_CTRL1_GLOBAL_SEL_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_START_CNTS_S 1
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_START_CNTS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_PMON_CTRL1_START_CNTS_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_CLEAR_CNTS_S 0
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL1_CLEAR_CNTS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_PMON_CTRL1_CLEAR_CNTS_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2 0x4248B0D8
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_RSVD1_S 30
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_PMON_CTRL2_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_ICQ_PORT_S 28
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_ICQ_PORT_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_PMON_CTRL2_ICQ_PORT_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_ICQ_TC_S 25
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_ICQ_TC_M RDMA_MASK3(32, 0x7, IG3_PEPM_GLPE_PEPM_PMON_CTRL2_ICQ_TC_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_TC_SEL_S 22
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_TC_SEL_M RDMA_MASK3(32, 0x7, IG3_PEPM_GLPE_PEPM_PMON_CTRL2_TC_SEL_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_LLTC_SEL_S 19
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_LLTC_SEL_M RDMA_MASK3(32, 0x7, IG3_PEPM_GLPE_PEPM_PMON_CTRL2_LLTC_SEL_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_INFLT_SEL_S 16
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_INFLT_SEL_M RDMA_MASK3(32, 0x7, IG3_PEPM_GLPE_PEPM_PMON_CTRL2_INFLT_SEL_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_RSVD_S 14
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_RSVD_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_PMON_CTRL2_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_QSET_GRP_S 12
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_QSET_GRP_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_PMON_CTRL2_QSET_GRP_S)
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_QSET_SEL_S 0
#define IG3_PEPM_GLPE_PEPM_PMON_CTRL2_QSET_SEL_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_PMON_CTRL2_QSET_SEL_S)
#define IG3_PEPM_GLPE_PEPM_PMON_SMPL 0x4248B0DC
#define IG3_PEPM_GLPE_PEPM_PMON_SMPL_SAMPLE_CLKS_S 0
#define IG3_PEPM_GLPE_PEPM_PMON_SMPL_SAMPLE_CLKS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_PMON_SMPL_SAMPLE_CLKS_S)
#define IG3_PEPM_GLPE_PEPM_PUSH_CNT_HI 0x4248B140
#define IG3_PEPM_GLPE_PEPM_PUSH_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_PUSH_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_PUSH_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_PUSH_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_PUSH_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_PUSH_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_PUSH_CNT_LO 0x4248B144
#define IG3_PEPM_GLPE_PEPM_PUSH_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_PUSH_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_PUSH_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_PUSH_NAK_CNT_HI 0x4248B130
#define IG3_PEPM_GLPE_PEPM_PUSH_NAK_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_PUSH_NAK_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_PUSH_NAK_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_PUSH_NAK_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_PUSH_NAK_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_PUSH_NAK_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_PUSH_NAK_CNT_LO 0x4248B134
#define IG3_PEPM_GLPE_PEPM_PUSH_NAK_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_PUSH_NAK_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_PUSH_NAK_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_QSET_CNT_HI 0x4248B110
#define IG3_PEPM_GLPE_PEPM_QSET_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_QSET_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_QSET_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_QSET_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_QSET_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_QSET_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_QSET_CNT_LO 0x4248B114
#define IG3_PEPM_GLPE_PEPM_QSET_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_QSET_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_QSET_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_TC_CNT_HI 0x4248B100
#define IG3_PEPM_GLPE_PEPM_TC_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_TC_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_TC_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TC_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_TC_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_TC_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_TC_CNT_LO 0x4248B104
#define IG3_PEPM_GLPE_PEPM_TC_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_TC_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_TC_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_TSCD_CNT_HI 0x4248B138
#define IG3_PEPM_GLPE_PEPM_TSCD_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_TSCD_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_TSCD_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TSCD_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_TSCD_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_TSCD_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_TSCD_CNT_LO 0x4248B13C
#define IG3_PEPM_GLPE_PEPM_TSCD_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_TSCD_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_TSCD_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_TSCD_NAK_CNT_HI 0x4248B128
#define IG3_PEPM_GLPE_PEPM_TSCD_NAK_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_TSCD_NAK_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_TSCD_NAK_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TSCD_NAK_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_TSCD_NAK_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_TSCD_NAK_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_TSCD_NAK_CNT_LO 0x4248B12C
#define IG3_PEPM_GLPE_PEPM_TSCD_NAK_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_TSCD_NAK_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_TSCD_NAK_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_TSUPD_CNT_HI 0x4248B150
#define IG3_PEPM_GLPE_PEPM_TSUPD_CNT_HI_RSVD_S 16
#define IG3_PEPM_GLPE_PEPM_TSUPD_CNT_HI_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_TSUPD_CNT_HI_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TSUPD_CNT_HI_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_TSUPD_CNT_HI_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_PEPM_GLPE_PEPM_TSUPD_CNT_HI_CNT_S)
#define IG3_PEPM_GLPE_PEPM_TSUPD_CNT_LO 0x4248B154
#define IG3_PEPM_GLPE_PEPM_TSUPD_CNT_LO_CNT_S 0
#define IG3_PEPM_GLPE_PEPM_TSUPD_CNT_LO_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEPM_GLPE_PEPM_TSUPD_CNT_LO_CNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_AGG_BYTES(_i) 0x424833C0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_AGG_BYTES_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_AGG_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_AGG_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_AGG_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_AGG_BYTES_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_AGG_BYTES_COUNT_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_AGG_BYTES_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HBUF(_i) 0x424833A0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HBUF_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_AGG_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HBUF_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HBUF_COUNT_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_AGG_HBUF_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HW_BYTES(_i) 0x42483400 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HW_BYTES_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HW_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HW_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_AGG_HW_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HW_BYTES_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HW_BYTES_THRESH_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_AGG_HW_BYTES_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HW_HBUF(_i) 0x424833E0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HW_HBUF_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HW_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HW_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_AGG_HW_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HW_HBUF_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_AGG_HW_HBUF_THRESH_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_AGG_HW_HBUF_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_AGG_LW_BYTES(_i) 0x42483440 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_AGG_LW_BYTES_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_AGG_LW_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_AGG_LW_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_AGG_LW_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_AGG_LW_BYTES_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_AGG_LW_BYTES_THRESH_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_AGG_LW_BYTES_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_AGG_LW_HBUF(_i) 0x42483420 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_AGG_LW_HBUF_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_AGG_LW_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_AGG_LW_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_AGG_LW_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_AGG_LW_HBUF_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_AGG_LW_HBUF_THRESH_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_AGG_LW_HBUF_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_ALLOC_BYTES 0x42483704
#define IG3_PEPM_GLPE_PEPM_TS_ALLOC_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_ALLOC_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_ALLOC_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_ALLOC_BYTES_BYTES_S 0
#define IG3_PEPM_GLPE_PEPM_TS_ALLOC_BYTES_BYTES_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_ALLOC_BYTES_BYTES_S)
#define IG3_PEPM_GLPE_PEPM_TS_ALLOC_HBUF 0x42483700
#define IG3_PEPM_GLPE_PEPM_TS_ALLOC_HBUF_RSVD_S 4
#define IG3_PEPM_GLPE_PEPM_TS_ALLOC_HBUF_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PEPM_GLPE_PEPM_TS_ALLOC_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_ALLOC_HBUF_CREDIT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_ALLOC_HBUF_CREDIT_M RDMA_MASK3(32, 0xF, IG3_PEPM_GLPE_PEPM_TS_ALLOC_HBUF_CREDIT_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG 0x4248B208
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RSVD3_S 20
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RSVD3_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RM_S 16
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RM_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RSVD2_S 14
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RSVD2_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RME_S 12
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RME_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RSVD1_S 10
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ERR_CNT_S 9
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ERR_CNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_FIX_CNT_S 8
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_FIX_CNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RSVD0_S 6
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_RSVD0_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_MASK_INT_S 5
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_MASK_INT_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_LS_BYPASS_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_LS_FORCE_S 3
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_LS_FORCE_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ECC_EN_S 0
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_CFG_ECC_EN_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS 0x4248B20C
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_RSVD1_S 30
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_RSVD1_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_RSVD0_S 4
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_RSVD0_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_INIT_DONE_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_ECC_FIX_S)
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEPM_GLPE_PEPM_TS_CGD_MEM_STATUS_ECC_ERR_S)
#define IG3_PEPM_GLPE_PEPM_TS_HW_BYTES(_i) 0x42483100 + ((_i) * 4) /* _i=0...39 */
#define IG3_PEPM_GLPE_PEPM_TS_HW_BYTES_MAX_INDEX_I 39
#define IG3_PEPM_GLPE_PEPM_TS_HW_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_HW_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_HW_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_HW_BYTES_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_HW_BYTES_THRESH_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_HW_BYTES_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_HW_HBUF(_i) 0x42483000 + ((_i) * 4) /* _i=0...39 */
#define IG3_PEPM_GLPE_PEPM_TS_HW_HBUF_MAX_INDEX_I 39
#define IG3_PEPM_GLPE_PEPM_TS_HW_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_HW_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_HW_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_HW_HBUF_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_HW_HBUF_THRESH_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_HW_HBUF_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_IB_BYTES(_i) 0x42482B00 + ((_i) * 4) /* _i=0...39 */
#define IG3_PEPM_GLPE_PEPM_TS_IB_BYTES_MAX_INDEX_I 39
#define IG3_PEPM_GLPE_PEPM_TS_IB_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_IB_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_IB_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_IB_BYTES_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_IB_BYTES_COUNT_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_IB_BYTES_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_IB_HBUF(_i) 0x42482A00 + ((_i) * 4) /* _i=0...39 */
#define IG3_PEPM_GLPE_PEPM_TS_IB_HBUF_MAX_INDEX_I 39
#define IG3_PEPM_GLPE_PEPM_TS_IB_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_IB_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_IB_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_IB_HBUF_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_IB_HBUF_COUNT_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_IB_HBUF_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_BYTES(_i) 0x424835C0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_BYTES_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_BYTES_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_BYTES_COUNT_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_BYTES_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_HBUF(_i) 0x424835A0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_HBUF_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_HBUF_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_HBUF_COUNT_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_IB_HBUF_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_BYTES(_i) 0x42483600 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_BYTES_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_BYTES_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_BYTES_COUNT_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_BYTES_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_HBUF(_i) 0x424835E0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_HBUF_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_HBUF_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_HBUF_COUNT_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_RB_HBUF_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_BYTES(_i) 0x42483640 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_BYTES_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_BYTES_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_BYTES_COUNT_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_BYTES_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_HBUF(_i) 0x42483620 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_HBUF_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_HBUF_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_HBUF_COUNT_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_AGG_WB_HBUF_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_BYTES(_i) 0x42483680 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_BYTES_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_BYTES_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_BYTES_THRESH_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_BYTES_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_HBUF(_i) 0x42483660 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_HBUF_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_HBUF_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_HBUF_THRESH_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_HW_HBUF_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_BYTES(_i) 0x424836C0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_BYTES_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_BYTES_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_BYTES_THRESH_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_BYTES_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_HBUF(_i) 0x424836A0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_HBUF_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_HBUF_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_HBUF_THRESH_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_LW_HBUF_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_MAP(_i) 0x424836E0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_MAP_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_MAP_RSVD_S 8
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_MAP_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_MAP_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_MAP_TCMAP_S 0
#define IG3_PEPM_GLPE_PEPM_TS_LLTC_MAP_TCMAP_M RDMA_MASK3(32, 0xFF, IG3_PEPM_GLPE_PEPM_TS_LLTC_MAP_TCMAP_S)
#define IG3_PEPM_GLPE_PEPM_TS_LW_BYTES(_i) 0x42483300 + ((_i) * 4) /* _i=0...39 */
#define IG3_PEPM_GLPE_PEPM_TS_LW_BYTES_MAX_INDEX_I 39
#define IG3_PEPM_GLPE_PEPM_TS_LW_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_LW_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_LW_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_LW_BYTES_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_LW_BYTES_THRESH_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_LW_BYTES_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_LW_HBUF(_i) 0x42483200 + ((_i) * 4) /* _i=0...39 */
#define IG3_PEPM_GLPE_PEPM_TS_LW_HBUF_MAX_INDEX_I 39
#define IG3_PEPM_GLPE_PEPM_TS_LW_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_LW_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_LW_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_LW_HBUF_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_LW_HBUF_THRESH_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_LW_HBUF_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_RB_BYTES(_i) 0x42482D00 + ((_i) * 4) /* _i=0...39 */
#define IG3_PEPM_GLPE_PEPM_TS_RB_BYTES_MAX_INDEX_I 39
#define IG3_PEPM_GLPE_PEPM_TS_RB_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_RB_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_RB_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_RB_BYTES_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_RB_BYTES_COUNT_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_RB_BYTES_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_RB_HBUF(_i) 0x42482C00 + ((_i) * 4) /* _i=0...39 */
#define IG3_PEPM_GLPE_PEPM_TS_RB_HBUF_MAX_INDEX_I 39
#define IG3_PEPM_GLPE_PEPM_TS_RB_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_RB_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_RB_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_RB_HBUF_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_RB_HBUF_COUNT_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_RB_HBUF_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_BYTES(_i) 0x42483480 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_BYTES_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_BYTES_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_BYTES_COUNT_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_BYTES_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_HBUF(_i) 0x42483460 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_HBUF_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_HBUF_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_HBUF_COUNT_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_TC_AGG_IB_HBUF_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_BYTES(_i) 0x424834C0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_BYTES_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_BYTES_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_BYTES_COUNT_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_BYTES_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_HBUF(_i) 0x424834A0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_HBUF_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_HBUF_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_HBUF_COUNT_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_TC_AGG_RB_HBUF_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_BYTES(_i) 0x42483500 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_BYTES_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_BYTES_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_BYTES_COUNT_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_BYTES_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_HBUF(_i) 0x424834E0 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_HBUF_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_HBUF_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_HBUF_COUNT_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_TC_AGG_WB_HBUF_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_HW_BYTES(_i) 0x42483540 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_TC_HW_BYTES_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_TC_HW_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_TC_HW_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_TC_HW_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_HW_BYTES_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_TC_HW_BYTES_THRESH_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_TC_HW_BYTES_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_HW_HBUF(_i) 0x42483520 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_TC_HW_HBUF_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_TC_HW_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_TC_HW_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_TC_HW_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_HW_HBUF_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_TC_HW_HBUF_THRESH_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_TC_HW_HBUF_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_LW_BYTES(_i) 0x42483580 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_TC_LW_BYTES_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_TC_LW_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_TC_LW_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_TC_LW_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_LW_BYTES_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_TC_LW_BYTES_THRESH_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_TC_LW_BYTES_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_LW_HBUF(_i) 0x42483560 + ((_i) * 4) /* _i=0...4 */
#define IG3_PEPM_GLPE_PEPM_TS_TC_LW_HBUF_MAX_INDEX_I 4
#define IG3_PEPM_GLPE_PEPM_TS_TC_LW_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_TC_LW_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_TC_LW_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_TC_LW_HBUF_THRESH_S 0
#define IG3_PEPM_GLPE_PEPM_TS_TC_LW_HBUF_THRESH_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_TC_LW_HBUF_THRESH_S)
#define IG3_PEPM_GLPE_PEPM_TS_WB_BYTES(_i) 0x42482F00 + ((_i) * 4) /* _i=0...39 */
#define IG3_PEPM_GLPE_PEPM_TS_WB_BYTES_MAX_INDEX_I 39
#define IG3_PEPM_GLPE_PEPM_TS_WB_BYTES_RSVD_S 20
#define IG3_PEPM_GLPE_PEPM_TS_WB_BYTES_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_PEPM_GLPE_PEPM_TS_WB_BYTES_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_WB_BYTES_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_WB_BYTES_COUNT_M RDMA_MASK3(32, 0xFFFFF, IG3_PEPM_GLPE_PEPM_TS_WB_BYTES_COUNT_S)
#define IG3_PEPM_GLPE_PEPM_TS_WB_HBUF(_i) 0x42482E00 + ((_i) * 4) /* _i=0...39 */
#define IG3_PEPM_GLPE_PEPM_TS_WB_HBUF_MAX_INDEX_I 39
#define IG3_PEPM_GLPE_PEPM_TS_WB_HBUF_RSVD_S 13
#define IG3_PEPM_GLPE_PEPM_TS_WB_HBUF_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEPM_GLPE_PEPM_TS_WB_HBUF_RSVD_S)
#define IG3_PEPM_GLPE_PEPM_TS_WB_HBUF_COUNT_S 0
#define IG3_PEPM_GLPE_PEPM_TS_WB_HBUF_COUNT_M RDMA_MASK3(32, 0x1FFF, IG3_PEPM_GLPE_PEPM_TS_WB_HBUF_COUNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_BUS_INDEX 0x424C0290
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL 0x424C0280
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_RESERVED_31_10_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_TRIG_OP_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_TRIG_OP_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_FREEZE_RESET_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_FREEZE_SET_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_CTRL_FREEZE_SET_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_FREEZE_ON_CNT_VAL 0x424C02A0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_OBS_BUS 0x424C02C0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CNT0 0x424C02E0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CNT0_CNT0_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CNT0_CNT0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CNT1_0 0x424C02E8
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CNT1_1 0x424C02EC
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CTRL 0x424C02D8
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_CTRL 0x424C02B8
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_GAP 0x424C02A8
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_GAP_RC_GAP_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_GAP_RC_GAP_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_TRNS 0x424C02B0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS 0x424C0288
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_RESERVED_31_8_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_I_FREEZE_S 6
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_I_FREEZE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_READY_S 5
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_READY_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_VALID_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_VALID_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_TRANS_CNT 0x424C0298
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_TRIG_MASK 0x424C02C8
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_TRIG_VALUE 0x424C02D0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_BOB_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL 0x424C024C
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_DONE_S 31
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_RD_EN_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_RD_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_RSVD_S 26
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_DW_SEL_S 18
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_DW_SEL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_ADR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_CTL_ADR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_DATA 0x424C0250
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_DATA_RD_DW_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_DBG_DATA_RD_DW_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG 0x424C0244
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RSVD3_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RSVD3_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RM_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RSVD2_S 14
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RSVD2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RME_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RME_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RSVD1_S 10
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ERR_CNT_S 9
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ERR_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_FIX_CNT_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_FIX_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RSVD0_S 6
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_MASK_INT_S 5
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_MASK_INT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_LS_BYPASS_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_LS_BYPASS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_LS_FORCE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_LS_FORCE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ECC_EN_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_CFG_ECC_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS 0x424C0248
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_RSVD1_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_RSVD0_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_INIT_DONE_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_ECC_FIX_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_ECC_FIX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_ECC_ERR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_BRANCH_TABLE_MEM_STATUS_ECC_ERR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_COUNT 0x424C0338
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_CMD 0x424C034C
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_DATA_H 0x424C0358
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_DATA_L 0x424C0354
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_PTR 0x424C0350
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_CMD 0x424C033C
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_DATA_H 0x424C0348
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_DATA_L 0x424C0344
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_PTR 0x424C0340
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL 0x424C0300
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_RSVD1_S 25
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_RSVD2_S 17
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_RSVD2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_RSVD3_S 9
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_RSVD3_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_BYPASS_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_BYPASS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_RSVD4_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_RSVD4_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_CONTROL_LOCAL_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_ECC_COR_ERR 0x424C0368
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_ECC_COR_ERR_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_ECC_UNCOR_ERR 0x424C0364
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_GROUP_CFG 0x424C030C
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_GROUP_CFG_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_CFG 0x424C0310
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_CFG_RSVD1_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_CFG_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_CFG_MODE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_CFG_MODE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_MASK 0x424C0318
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_MASK_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_MASK_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_PATTERN 0x424C0314
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_LOG_PATTERN_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG 0x424C0304
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_RSVD2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_RSVD3_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_STS 0x424C0308
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_STS_RSVD1_S 9
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_STS_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_STS_RSVD2_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_STS_RSVD2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TIMESTAMP 0x424C0330
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TIMESTAMP_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_TIMESTAMP_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TIMESTAMP_ROLLOVER 0x424C0334
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG 0x424C035C
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS 0x424C0360
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG 0x424C031C
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_RSVD2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_MODE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_CFG_MODE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_COUNT 0x424C0328
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_COUNT_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_MASK 0x424C0324
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_MASK_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_MASK_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_PATTERN 0x424C0320
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_TIMESTAMP 0x424C032C
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_ECC_COR_ERR 0x424C01F0
#define IG3_MEV_TSCD_GLPE_TSCD_ECC_COR_ERR_RSVD_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_MEV_TSCD_GLPE_TSCD_ECC_COR_ERR_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_ECC_COR_ERR_CNT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_MEV_TSCD_GLPE_TSCD_ECC_COR_ERR_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_ECC_UNCOR_ERR 0x424C01EC
#define IG3_MEV_TSCD_GLPE_TSCD_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_MEV_TSCD_GLPE_TSCD_ECC_UNCOR_ERR_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_ECC_UNCOR_ERR_CNT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_MEV_TSCD_GLPE_TSCD_ECC_UNCOR_ERR_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_ERRSTATREG 0x424C015C
#define IG3_MEV_TSCD_GLPE_TSCD_ERRSTATREG_RSVD_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_ERRSTATREG_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_ERRSTATREG_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_ERRSTATREG_BRANCH_LOOP_DETECTED_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_ERRSTATREG_BRANCH_LOOP_DETECTED_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_ERRSTATREG_BRANCH_LOOP_DETECTED_S)
#define IG3_MEV_TSCD_GLPE_TSCD_ERRSTATREG_FWERR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_ERRSTATREG_FWERR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_ERRSTATREG_FWERR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FIFO_OVF_CAPTURE 0x424C01E4
#define IG3_MEV_TSCD_GLPE_TSCD_FIFO_OVF_CAPTURE_FIFO_OVF_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_FIFO_OVF_CAPTURE_FIFO_OVF_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_FIFO_OVF_CAPTURE_FIFO_OVF_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FIFO_UDF_CAPTURE 0x424C01E8
#define IG3_MEV_TSCD_GLPE_TSCD_FIFO_UDF_CAPTURE_FIFO_UDF_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_FIFO_UDF_CAPTURE_FIFO_UDF_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_FIFO_UDF_CAPTURE_FIFO_UDF_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FLR(_i) 0x424C016C + ((_i) * 4) /* _i=0...7 */
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_MAX_INDEX_I 7
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_BUSY_S 31
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_BUSY_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_FLR_BUSY_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_HOSTID_S 28
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_HOSTID_M RDMA_MASK3(32, 0x7, IG3_MEV_TSCD_GLPE_TSCD_FLR_HOSTID_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_VM_VF_TYPE_S 26
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_FLR_VM_VF_TYPE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_PF_NUM_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_MEV_TSCD_GLPE_TSCD_FLR_PF_NUM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_VM_VF_NUM_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_MEV_TSCD_GLPE_TSCD_FLR_VM_VF_NUM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_PORT_S 5
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_PORT_M RDMA_MASK3(32, 0x7, IG3_MEV_TSCD_GLPE_TSCD_FLR_PORT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_RSVD0_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_FLR_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_MEV_TSCD_GLPE_TSCD_FLR_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQHI 0x424C0168
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQHI_PMF_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQHI_PMF_M RDMA_MASK3(32, 0xFFF, IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQHI_PMF_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQHI_RSVD_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQHI_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQHI_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO 0x424C0164
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_BUSY_S 31
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_BUSY_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_BUSY_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_HOSTID_S 28
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_HOSTID_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_VM_VF_TYPE_S 26
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_VM_VF_TYPE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_PF_NUM_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_PF_NUM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_VM_VF_NUM_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_VM_VF_NUM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_TAG_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_TAG_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_FWSYNCREQLO_TAG_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDH 0x424C009C
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDH_RSVD_S 31
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDH_RSVD_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFBCMDH_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDH_VALUE_ENTRYIDX_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDH_VALUE_ENTRYIDX_M RDMA_MASK3(32, 0x7FFFF, IG3_MEV_TSCD_GLPE_TSCD_IFBCMDH_VALUE_ENTRYIDX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDH_FLDSZ_S 7
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDH_FLDSZ_M RDMA_MASK3(32, 0x1F, IG3_MEV_TSCD_GLPE_TSCD_IFBCMDH_FLDSZ_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDH_FLDOFFS_NUMENTS_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDH_FLDOFFS_NUMENTS_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_IFBCMDH_FLDOFFS_NUMENTS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL 0x424C0098
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_NTROOTNODE_S 29
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_NTROOTNODE_M RDMA_MASK3(32, 0x7, IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_NTROOTNODE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_RSVD_S 28
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_RSVD_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_NTLEVEL_S 25
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_NTLEVEL_M RDMA_MASK3(32, 0x7, IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_NTLEVEL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_CTRLTYPE_S 22
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_CTRLTYPE_M RDMA_MASK3(32, 0x7, IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_CTRLTYPE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_TBLENTRYIDX_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_TBLENTRYIDX_M RDMA_MASK3(32, 0x3FFF, IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_TBLENTRYIDX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_TBLTYPE_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_TBLTYPE_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_TBLTYPE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_OPCODE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_OPCODE_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_IFBCMDL_OPCODE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL 0x424C00A4
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_PATHMASKCLRCNT_S 24
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_PATHMASKCLRCNT_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_PATHMASKCLRCNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_NWATIMER_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_NWATIMER_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_NWATIMER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_RSVD_S 9
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_RSVD_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_IOQDEPTH1_EN_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_IOQDEPTH1_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_IOQDEPTH1_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_NODE_SCAN_EN_S 7
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_NODE_SCAN_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_NODE_SCAN_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_ISSUE_FILTER_EN_S 6
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_ISSUE_FILTER_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_ISSUE_FILTER_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_NODE_HIERARCHY_EN_S 5
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_NODE_HIERARCHY_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_NODE_HIERARCHY_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_QSET_DIRECT_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_QSET_DIRECT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_QSET_DIRECT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_SCH_ENA_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_SCH_ENA_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_SCH_ENA_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_BCMDCLRERR_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_BCMDCLRERR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_BCMDCLRERR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_ICMDCLRERR_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_ICMDCLRERR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_ICMDCLRERR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_BCMDDB_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_BCMDDB_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFCTRL_BCMDDB_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFDATA(_i) 0x424C0080 + ((_i) * 4) /* _i=0...3 */
#define IG3_MEV_TSCD_GLPE_TSCD_IFDATA_MAX_INDEX_I 3
#define IG3_MEV_TSCD_GLPE_TSCD_IFDATA_TSCDIFDATA_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_IFDATA_TSCDIFDATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_IFDATA_TSCDIFDATA_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFDATA_INFO 0x424C0000
#define IG3_MEV_TSCD_GLPE_TSCD_IFDATA_INFO_RSVD_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_IFDATA_INFO_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_IFDATA_INFO_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFDATA_INFO_NUM_IFDATA_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_IFDATA_INFO_NUM_IFDATA_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_IFDATA_INFO_NUM_IFDATA_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDH 0x424C0094
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDH_RSVD_S 31
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDH_RSVD_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFICMDH_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDH_VALUE_ENTRYIDX_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDH_VALUE_ENTRYIDX_M RDMA_MASK3(32, 0x7FFFF, IG3_MEV_TSCD_GLPE_TSCD_IFICMDH_VALUE_ENTRYIDX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDH_FLDSZ_S 7
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDH_FLDSZ_M RDMA_MASK3(32, 0x1F, IG3_MEV_TSCD_GLPE_TSCD_IFICMDH_FLDSZ_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDH_FLDOFFS_NUMENTS_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDH_FLDOFFS_NUMENTS_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_IFICMDH_FLDOFFS_NUMENTS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL 0x424C0090
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_NTROOTNODE_S 29
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_NTROOTNODE_M RDMA_MASK3(32, 0x7, IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_NTROOTNODE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_RSVD_S 28
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_RSVD_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_NTLEVEL_S 25
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_NTLEVEL_M RDMA_MASK3(32, 0x7, IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_NTLEVEL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_CTRLTYPE_S 22
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_CTRLTYPE_M RDMA_MASK3(32, 0x7, IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_CTRLTYPE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_TBLENTRYIDX_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_TBLENTRYIDX_M RDMA_MASK3(32, 0x3FFF, IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_TBLENTRYIDX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_TBLTYPE_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_TBLTYPE_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_TBLTYPE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_OPCODE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_OPCODE_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_IFICMDL_OPCODE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS 0x424C00A0
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_RSVD_S 11
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_RSVD_M RDMA_MASK3(32, 0x1FFFFF, IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_SCH_IDLE_S 10
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_SCH_IDLE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_SCH_IDLE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_SCH_ENA_S 9
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_SCH_ENA_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_SCH_ENA_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_BCMDERR_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_BCMDERR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_BCMDERR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_ICMDERR_S 7
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_ICMDERR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_ICMDERR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_ICMDBZ_S 6
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_ICMDBZ_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_ICMDBZ_S)
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_ENTRAVAIL_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_ENTRAVAIL_M RDMA_MASK3(32, 0x3F, IG3_MEV_TSCD_GLPE_TSCD_IFSTATUS_ENTRAVAIL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_INCSCHEDCFGCOUNT 0x424C0158
#define IG3_MEV_TSCD_GLPE_TSCD_INCSCHEDCFGCOUNT_INCSCHEDCFGCOUNT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_INCSCHEDCFGCOUNT_INCSCHEDCFGCOUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_INCSCHEDCFGCOUNT_INCSCHEDCFGCOUNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL 0x424C01FC
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_DONE_S 31
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_RD_EN_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_RD_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_RSVD_S 26
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_DW_SEL_S 18
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_DW_SEL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_ADR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_CTL_ADR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_DATA 0x424C0200
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_DATA_RD_DW_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_DBG_DATA_RD_DW_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG 0x424C01F4
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RSVD3_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RSVD3_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RM_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RSVD2_S 14
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RSVD2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RME_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RME_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RSVD1_S 10
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ERR_CNT_S 9
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ERR_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_FIX_CNT_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_FIX_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RSVD0_S 6
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_MASK_INT_S 5
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_MASK_INT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_LS_BYPASS_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_LS_BYPASS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_LS_FORCE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_LS_FORCE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ECC_EN_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_CFG_ECC_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS 0x424C01F8
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_RSVD1_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_RSVD0_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_INIT_DONE_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_ECC_FIX_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_ECC_FIX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_ECC_ERR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L3_NODE_TABLE_MEM_STATUS_ECC_ERR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL 0x424C020C
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_DONE_S 31
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_RD_EN_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_RD_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_RSVD_S 26
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_DW_SEL_S 18
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_DW_SEL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_ADR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_CTL_ADR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_DATA 0x424C0210
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_DATA_RD_DW_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_DBG_DATA_RD_DW_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG 0x424C0204
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RSVD3_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RSVD3_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RM_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RSVD2_S 14
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RSVD2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RME_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RME_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RSVD1_S 10
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ERR_CNT_S 9
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ERR_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_FIX_CNT_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_FIX_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RSVD0_S 6
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_MASK_INT_S 5
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_MASK_INT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_LS_BYPASS_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_LS_BYPASS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_LS_FORCE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_LS_FORCE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ECC_EN_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_CFG_ECC_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS 0x424C0208
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_RSVD1_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_RSVD0_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_INIT_DONE_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_ECC_FIX_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_ECC_FIX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_ECC_ERR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L4_NODE_TABLE_MEM_STATUS_ECC_ERR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL 0x424C021C
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_DONE_S 31
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_RD_EN_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_RD_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_RSVD_S 26
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_DW_SEL_S 18
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_DW_SEL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_ADR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_CTL_ADR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_DATA 0x424C0220
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_DATA_RD_DW_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_DBG_DATA_RD_DW_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG 0x424C0214
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RSVD3_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RSVD3_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RM_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RSVD2_S 14
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RSVD2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RME_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RME_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RSVD1_S 10
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ERR_CNT_S 9
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ERR_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_FIX_CNT_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_FIX_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RSVD0_S 6
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_MASK_INT_S 5
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_MASK_INT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_LS_BYPASS_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_LS_BYPASS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_LS_FORCE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_LS_FORCE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ECC_EN_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_CFG_ECC_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS 0x424C0218
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_RSVD1_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_RSVD0_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_INIT_DONE_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_ECC_FIX_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_ECC_FIX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_ECC_ERR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L5_NODE_TABLE_MEM_STATUS_ECC_ERR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL 0x424C022C
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_DONE_S 31
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_RD_EN_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_RD_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_RSVD_S 26
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_DW_SEL_S 18
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_DW_SEL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_ADR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_CTL_ADR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_DATA 0x424C0230
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_DATA_RD_DW_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_DBG_DATA_RD_DW_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG 0x424C0224
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RSVD3_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RSVD3_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RM_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RSVD2_S 14
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RSVD2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RME_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RME_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RSVD1_S 10
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ERR_CNT_S 9
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ERR_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_FIX_CNT_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_FIX_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RSVD0_S 6
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_MASK_INT_S 5
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_MASK_INT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_LS_BYPASS_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_LS_BYPASS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_LS_FORCE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_LS_FORCE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ECC_EN_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_CFG_ECC_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS 0x424C0228
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_RSVD1_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_RSVD0_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_INIT_DONE_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_ECC_FIX_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_ECC_FIX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_ECC_ERR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L6_NODE_TABLE_MEM_STATUS_ECC_ERR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL 0x424C023C
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_DONE_S 31
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_RD_EN_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_RD_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_RSVD_S 26
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_DW_SEL_S 18
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_DW_SEL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_ADR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_CTL_ADR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_DATA 0x424C0240
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_DATA_RD_DW_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_DBG_DATA_RD_DW_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG 0x424C0234
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RSVD3_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RSVD3_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RM_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RSVD2_S 14
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RSVD2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RME_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RME_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RSVD1_S 10
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ERR_CNT_S 9
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ERR_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_FIX_CNT_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_FIX_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RSVD0_S 6
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_MASK_INT_S 5
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_MASK_INT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_LS_BYPASS_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_LS_BYPASS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_LS_FORCE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_LS_FORCE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ECC_EN_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_CFG_ECC_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS 0x424C0238
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_RSVD1_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_RSVD0_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_INIT_DONE_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_ECC_FIX_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_ECC_FIX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_ECC_ERR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_L7_NODE_TABLE_MEM_STATUS_ECC_ERR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_NT_INFO 0x424C0008
#define IG3_MEV_TSCD_GLPE_TSCD_NT_INFO_MAX_RN_S 24
#define IG3_MEV_TSCD_GLPE_TSCD_NT_INFO_MAX_RN_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_NT_INFO_MAX_RN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_NT_INFO_MIN_RN_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_NT_INFO_MIN_RN_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_NT_INFO_MIN_RN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_NT_INFO_MAX_LVL_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_NT_INFO_MAX_LVL_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_NT_INFO_MAX_LVL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_NT_INFO_MIN_LVL_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_NT_INFO_MIN_LVL_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_NT_INFO_MIN_LVL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL(_i) 0x424C002C + ((_i) * 16) /* _i=0...0 */
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_MAX_INDEX_I 0
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_RESERVED3_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_RESERVED3_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_RESERVED3_S)
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO0 0x424C0010
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO0_MAX_TOTAL_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO0_MAX_TOTAL_M RDMA_MASK3(32, 0xFFFF, IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO0_MAX_TOTAL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO0_MAX_PER_ROOT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO0_MAX_PER_ROOT_M RDMA_MASK3(32, 0xFFFF, IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO0_MAX_PER_ROOT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO1 0x424C0014
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO1_RESERVED1_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO1_RESERVED1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO1_RESERVED1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO2 0x424C0018
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO2_MAX_CHILDREN_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO2_MAX_CHILDREN_M RDMA_MASK3(32, 0xFFFF, IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO2_MAX_CHILDREN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO2_CHILD_NALLOC_SIZE_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO2_CHILD_NALLOC_SIZE_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO2_CHILD_NALLOC_SIZE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO2_CHILD_ALIGNMENT_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO2_CHILD_ALIGNMENT_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO2_CHILD_ALIGNMENT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO2_MIN_CHILDREN_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO2_MIN_CHILDREN_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO2_MIN_CHILDREN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO3 0x424C001C
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO3_RESERVED3_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO3_RESERVED3_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_NT_LVL_L1_INFO3_RESERVED3_S)
#define IG3_MEV_TSCD_GLPE_TSCD_PEPM 0x424C0160
#define IG3_MEV_TSCD_GLPE_TSCD_PEPM_RSVD_S 14
#define IG3_MEV_TSCD_GLPE_TSCD_PEPM_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_PEPM_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_PEPM_QUANTA_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_PEPM_QUANTA_M RDMA_MASK3(32, 0x3FFF, IG3_MEV_TSCD_GLPE_TSCD_PEPM_QUANTA_S)
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL(_i) 0x424C0118 + ((_i) * 4) /* _i=0...15 */
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_MAX_INDEX_I 15
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_RSVD1_S 26
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_QSINDEX_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_QSINDEX_M RDMA_MASK3(32, 0x3FF, IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_QSINDEX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_RSVD0_S 13
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_RSVD0_M RDMA_MASK3(32, 0x7, IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_TCINDEX_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_TCINDEX_M RDMA_MASK3(32, 0x1F, IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_TCINDEX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_PORTINDEX_S 5
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_PORTINDEX_M RDMA_MASK3(32, 0x7, IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_PORTINDEX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_RESOURCESELECT_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_RESOURCESELECT_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_RESOURCESELECT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_COUNTERTYPE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_COUNTERTYPE_M RDMA_MASK3(32, 0x7, IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCONTROL_COUNTERTYPE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCOUNT(_i) 0x424C00D8 + ((_i) * 4) /* _i=0...15 */
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCOUNT_MAX_INDEX_I 15
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCOUNT_PRGPERFCOUNT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCOUNT_PRGPERFCOUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_PRGPERFCOUNT_PRGPERFCOUNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QST_INFO 0x424C0004
#define IG3_MEV_TSCD_GLPE_TSCD_QST_INFO_MAX_QS_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_QST_INFO_MAX_QS_M RDMA_MASK3(32, 0xFFFF, IG3_MEV_TSCD_GLPE_TSCD_QST_INFO_MAX_QS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QST_INFO_MIN_QS_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_QST_INFO_MIN_QS_M RDMA_MASK3(32, 0xFFFF, IG3_MEV_TSCD_GLPE_TSCD_QST_INFO_MIN_QS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL 0x424C025C
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_DONE_S 31
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_RD_EN_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_RD_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_RSVD_S 26
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_DW_SEL_S 18
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_DW_SEL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_ADR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_CTL_ADR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_DATA 0x424C0260
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_DATA_RD_DW_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_DBG_DATA_RD_DW_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG 0x424C0254
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RSVD3_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RSVD3_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RM_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RM_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RSVD2_S 14
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RSVD2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RME_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RME_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RSVD1_S 10
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ERR_CNT_S 9
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ERR_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_FIX_CNT_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_FIX_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RSVD0_S 6
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_MASK_INT_S 5
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_MASK_INT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_LS_BYPASS_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_LS_BYPASS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_LS_FORCE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_LS_FORCE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ECC_EN_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_CFG_ECC_EN_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS 0x424C0258
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_RSVD1_S 30
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_RSVD0_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_INIT_DONE_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_INIT_DONE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_ECC_FIX_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_ECC_FIX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_ECC_ERR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_QUEUE_SET_TABLE_MEM_STATUS_ECC_ERR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2CMD 0x424C00AC
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2CMD_RSVD_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2CMD_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2CMD_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2CMD_RLMTBLIDX_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2CMD_RLMTBLIDX_M RDMA_MASK3(32, 0xFFF, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2CMD_RLMTBLIDX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATAHI 0x424C00D4
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATAHI_DATA_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATAHI_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATAHI_DATA_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATALO 0x424C00C8
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATALO_DATA_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATALO_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATALO_DATA_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATAMIDHI 0x424C00D0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATAMIDHI_DATA_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATAMIDHI_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATAMIDHI_DATA_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATAMIDLO 0x424C00CC
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATAMIDLO_DATA_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATAMIDLO_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2DATAMIDLO_DATA_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2STATUS 0x424C00B4
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2STATUS_RSVD_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2STATUS_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2STATUS_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2STATUS_VALID_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2STATUS_VALID_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRD2STATUS_VALID_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDCMD 0x424C00A8
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDCMD_RSVD_S 12
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDCMD_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDCMD_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDCMD_RLMTBLIDX_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDCMD_RLMTBLIDX_M RDMA_MASK3(32, 0xFFF, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDCMD_RLMTBLIDX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATAHI 0x424C00C4
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATAHI_DATA_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATAHI_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATAHI_DATA_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATALO 0x424C00B8
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATALO_DATA_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATALO_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATALO_DATA_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATAMIDHI 0x424C00C0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATAMIDHI_DATA_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATAMIDHI_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATAMIDHI_DATA_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATAMIDLO 0x424C00BC
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATAMIDLO_DATA_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATAMIDLO_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDDATAMIDLO_DATA_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDSTATUS 0x424C00B0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDSTATUS_RSVD_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDSTATUS_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDSTATUS_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDSTATUS_VALID_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDSTATUS_VALID_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_RLMTBLRDSTATUS_VALID_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_CTL 0x424C018C
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_CTL_RSVD_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_CTL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_CTL_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_CTL_FREERUN_TOGGLE_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_CTL_FREERUN_TOGGLE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_CTL_FREERUN_TOGGLE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_CTL_ONESHOT_TOGGLE_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_CTL_ONESHOT_TOGGLE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_CTL_ONESHOT_TOGGLE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_ENTRY_OP_CNT(_i) 0x424C01CC + ((_i) * 4) /* _i=0...1 */
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_ENTRY_OP_CNT_MAX_INDEX_I 1
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_ENTRY_OP_CNT_ENTRY_OP_CNT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_ENTRY_OP_CNT_ENTRY_OP_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_ENTRY_OP_CNT_ENTRY_OP_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_EXIT_DISPOSITION_CNT(_i) 0x424C01C4 + ((_i) * 4) /* _i=0...1 */
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_EXIT_DISPOSITION_CNT_MAX_INDEX_I 1
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_EXIT_DISPOSITION_CNT_EXIT_DISPOSITION_CNT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_EXIT_DISPOSITION_CNT_EXIT_DISPOSITION_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_EXIT_DISPOSITION_CNT_EXIT_DISPOSITION_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_EXIT_LATENCY_HISTO_BINCNT(_i) 0x424C01A4 + ((_i) * 4) /* _i=0...7 */
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_EXIT_LATENCY_HISTO_BINCNT_MAX_INDEX_I 7
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_EXIT_LATENCY_HISTO_BINCNT_EXITLATENCY_HISTO_BINCNT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_EXIT_LATENCY_HISTO_BINCNT_EXITLATENCY_HISTO_BINCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_EXIT_LATENCY_HISTO_BINCNT_EXITLATENCY_HISTO_BINCNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_NWA_DONE_CNT 0x424C01D8
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_NWA_DONE_CNT_NWA_DONE_CNT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_NWA_DONE_CNT_NWA_DONE_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_NWA_DONE_CNT_NWA_DONE_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_PREFETCH_LOAD_CNT 0x424C01D4
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_PREFETCH_LOAD_CNT_PREFETCH_LOAD_CNT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_PREFETCH_LOAD_CNT_PREFETCH_LOAD_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_PREFETCH_LOAD_CNT_PREFETCH_LOAD_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_QSETS_ISSUED_CTL 0x424C01DC
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_QSETS_ISSUED_CTL_RSVD_S 7
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_QSETS_ISSUED_CTL_RSVD_M RDMA_MASK3(32, 0x1FFFFFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_QSETS_ISSUED_CTL_RSVD_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_QSETS_ISSUED_CTL_QSETS_ISSUED_INDEX_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_QSETS_ISSUED_CTL_QSETS_ISSUED_INDEX_M RDMA_MASK3(32, 0x7F, IG3_MEV_TSCD_GLPE_TSCD_STATS_QSETS_ISSUED_CTL_QSETS_ISSUED_INDEX_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_QSETS_ISSUED_DATA 0x424C01E0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_QSETS_ISSUED_DATA_QSETS_ISSUED_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_QSETS_ISSUED_DATA_QSETS_ISSUED_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_QSETS_ISSUED_DATA_QSETS_ISSUED_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS 0x424C0194
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_FREERUN_ROLLOVER_CNT_S 24
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_FREERUN_ROLLOVER_CNT_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_FREERUN_ROLLOVER_CNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_RSVD2_S 23
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_RSVD2_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_RSVD2_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_WAMON_EDGE_ROLLOVER_S 22
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_WAMON_EDGE_ROLLOVER_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_WAMON_EDGE_ROLLOVER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_WAMON_LVL_ROLLOVER_S 21
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_WAMON_LVL_ROLLOVER_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_WAMON_LVL_ROLLOVER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_PREFETCH_ROLLOVER_S 20
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_PREFETCH_ROLLOVER_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_PREFETCH_ROLLOVER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_EXIT_DISCARD_ROLLOVER_S 19
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_EXIT_DISCARD_ROLLOVER_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_EXIT_DISCARD_ROLLOVER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_EXIT_ISSUE_ROLLOVER_S 18
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_EXIT_ISSUE_ROLLOVER_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_EXIT_ISSUE_ROLLOVER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_ENTRY_NWA_ROLLOVER_S 17
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_ENTRY_NWA_ROLLOVER_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_ENTRY_NWA_ROLLOVER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_ENTRY_WA_ROLLOVER_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_ENTRY_WA_ROLLOVER_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_ENTRY_WA_ROLLOVER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_RSVD1_S 8
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN7_ROLLOVER_S 7
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN7_ROLLOVER_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN7_ROLLOVER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN6_ROLLOVER_S 6
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN6_ROLLOVER_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN6_ROLLOVER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN5_ROLLOVER_S 5
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN5_ROLLOVER_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN5_ROLLOVER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN4_ROLLOVER_S 4
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN4_ROLLOVER_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN4_ROLLOVER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN3_ROLLOVER_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN3_ROLLOVER_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN3_ROLLOVER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN2_ROLLOVER_S 2
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN2_ROLLOVER_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN2_ROLLOVER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_RSVD0_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_RSVD0_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN0_ROLLOVER_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN0_ROLLOVER_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_STATUS_HISTO_BIN0_ROLLOVER_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_TMR 0x424C0190
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_TMR_STATSTMR_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_TMR_STATSTMR_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_TMR_STATSTMR_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL 0x424C0198
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_RSVD1_S 18
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_RSVD1_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_FINAL_WA_EDGE_S 17
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_FINAL_WA_EDGE_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_FINAL_WA_EDGE_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_WA_EDGE_VALID_S 16
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_WA_EDGE_VALID_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_WA_EDGE_VALID_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_RSVD0_S 15
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_RSVD0_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_RSVD0_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_WA_QSET_S 3
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_WA_QSET_M RDMA_MASK3(32, 0xFFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_WA_QSET_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_WA_SEL_S 1
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_WA_SEL_M RDMA_MASK3(32, 0x3, IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_WA_SEL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_WA_LVL_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_WA_LVL_M RDMA_BIT2(32, IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_CTL_WA_LVL_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_EDGECNT 0x424C01A0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_EDGECNT_WA_EDGECNT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_EDGECNT_WA_EDGECNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_EDGECNT_WA_EDGECNT_S)
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_LVLCNT 0x424C019C
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_LVLCNT_WA_LVLCNT_S 0
#define IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_LVLCNT_WA_LVLCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MEV_TSCD_GLPE_TSCD_STATS_WAMON_LVLCNT_WA_LVLCNT_S)
#define IG3_STATS_GLPES_CNPPROCESSEDHI 0x4266E8A4
#define IG3_STATS_GLPES_CNPPROCESSEDHI_CNPPROCESSEDLO_S 0
#define IG3_STATS_GLPES_CNPPROCESSEDHI_CNPPROCESSEDLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_CNPPROCESSEDHI_CNPPROCESSEDLO_S)
#define IG3_STATS_GLPES_CNPPROCESSEDLO 0x4266E8A0
#define IG3_STATS_GLPES_CNPPROCESSEDLO_CNPPROCESSEDLO_S 0
#define IG3_STATS_GLPES_CNPPROCESSEDLO_CNPPROCESSEDLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_CNPPROCESSEDLO_CNPPROCESSEDLO_S)
#define IG3_STATS_GLPES_DUPRREQRCVDHI 0x4266E8F4
#define IG3_STATS_GLPES_DUPRREQRCVDHI_DUPRREQRCVDHI_S 0
#define IG3_STATS_GLPES_DUPRREQRCVDHI_DUPRREQRCVDHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_DUPRREQRCVDHI_DUPRREQRCVDHI_S)
#define IG3_STATS_GLPES_DUPRREQRCVDLO 0x4266E8F0
#define IG3_STATS_GLPES_DUPRREQRCVDLO_DUPRREQRCVDLO_S 0
#define IG3_STATS_GLPES_DUPRREQRCVDLO_DUPRREQRCVDLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_DUPRREQRCVDLO_DUPRREQRCVDLO_S)
#define IG3_STATS_GLPES_HMCERRCNTHI 0x4266E8FC
#define IG3_STATS_GLPES_HMCERRCNTHI_HMCERRCNTHI_S 0
#define IG3_STATS_GLPES_HMCERRCNTHI_HMCERRCNTHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_HMCERRCNTHI_HMCERRCNTHI_S)
#define IG3_STATS_GLPES_HMCERRCNTLO 0x4266E8F8
#define IG3_STATS_GLPES_HMCERRCNTLO_HMCERRCNTLO_S 0
#define IG3_STATS_GLPES_HMCERRCNTLO_HMCERRCNTLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_HMCERRCNTLO_HMCERRCNTLO_S)
#define IG3_STATS_GLPES_OOPCNTGP0HI 0x4266E884
#define IG3_STATS_GLPES_OOPCNTGP0HI_OOPGP0_S 0
#define IG3_STATS_GLPES_OOPCNTGP0HI_OOPGP0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_OOPCNTGP0HI_OOPGP0_S)
#define IG3_STATS_GLPES_OOPCNTGP0LO 0x4266E880
#define IG3_STATS_GLPES_OOPCNTGP0LO_OOPGP0_S 0
#define IG3_STATS_GLPES_OOPCNTGP0LO_OOPGP0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_OOPCNTGP0LO_OOPGP0_S)
#define IG3_STATS_GLPES_OOPCNTGP1HI 0x4266E88C
#define IG3_STATS_GLPES_OOPCNTGP1HI_OOPGP1_S 0
#define IG3_STATS_GLPES_OOPCNTGP1HI_OOPGP1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_OOPCNTGP1HI_OOPGP1_S)
#define IG3_STATS_GLPES_OOPCNTGP1LO 0x4266E888
#define IG3_STATS_GLPES_OOPCNTGP1LO_OOPGP1_S 0
#define IG3_STATS_GLPES_OOPCNTGP1LO_OOPGP1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_OOPCNTGP1LO_OOPGP1_S)
#define IG3_STATS_GLPES_OOPCNTGP2HI 0x4266E894
#define IG3_STATS_GLPES_OOPCNTGP2HI_OOPGP2_S 0
#define IG3_STATS_GLPES_OOPCNTGP2HI_OOPGP2_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_OOPCNTGP2HI_OOPGP2_S)
#define IG3_STATS_GLPES_OOPCNTGP2LO 0x4266E890
#define IG3_STATS_GLPES_OOPCNTGP2LO_OOPGP2_S 0
#define IG3_STATS_GLPES_OOPCNTGP2LO_OOPGP2_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_OOPCNTGP2LO_OOPGP2_S)
#define IG3_STATS_GLPES_OOPCNTGP3HI 0x4266E89C
#define IG3_STATS_GLPES_OOPCNTGP3HI_OOPGP3_S 0
#define IG3_STATS_GLPES_OOPCNTGP3HI_OOPGP3_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_OOPCNTGP3HI_OOPGP3_S)
#define IG3_STATS_GLPES_OOPCNTGP3LO 0x4266E898
#define IG3_STATS_GLPES_OOPCNTGP3LO_OOPGP3_S 0
#define IG3_STATS_GLPES_OOPCNTGP3LO_OOPGP3_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_OOPCNTGP3LO_OOPGP3_S)
#define IG3_STATS_GLPES_PERNRRCVDHI(_i) 0x42669300 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PERNRRCVDHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PERNRRCVDHI_PERNRRCVDHI_S 0
#define IG3_STATS_GLPES_PERNRRCVDHI_PERNRRCVDHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PERNRRCVDHI_PERNRRCVDHI_S)
#define IG3_STATS_GLPES_PERNRRCVDLO(_i) 0x42668200 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PERNRRCVDLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PERNRRCVDLO_PERNRRCVDLO_S 0
#define IG3_STATS_GLPES_PERNRRCVDLO_PERNRRCVDLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PERNRRCVDLO_PERNRRCVDLO_S)
#define IG3_STATS_GLPES_PERNRSENTHI(_i) 0x4263A700 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PERNRSENTHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PERNRSENTHI_PERNRSENTHI_S 0
#define IG3_STATS_GLPES_PERNRSENTHI_PERNRSENTHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PERNRSENTHI_PERNRSENTHI_S)
#define IG3_STATS_GLPES_PERNRSENTLO(_i) 0x42639600 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PERNRSENTLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PERNRSENTLO_PERNRSENTLO_S 0
#define IG3_STATS_GLPES_PERNRSENTLO_PERNRSENTLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PERNRSENTLO_PERNRSENTLO_S)
#define IG3_STATS_GLPES_PFIP4RXDISCARDHI(_i) 0x42614300 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4RXDISCARDHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4RXDISCARDHI_IP4RXDISCARD_S 0
#define IG3_STATS_GLPES_PFIP4RXDISCARDHI_IP4RXDISCARD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4RXDISCARDHI_IP4RXDISCARD_S)
#define IG3_STATS_GLPES_PFIP4RXDISCARDLO(_i) 0x42613200 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4RXDISCARDLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4RXDISCARDLO_IP4RXDISCARD_S 0
#define IG3_STATS_GLPES_PFIP4RXDISCARDLO_IP4RXDISCARD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4RXDISCARDLO_IP4RXDISCARD_S)
#define IG3_STATS_GLPES_PFIP4RXFRAGSHI(_i) 0x42616500 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4RXFRAGSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4RXFRAGSHI_IP4RXFRAGSHI_S 0
#define IG3_STATS_GLPES_PFIP4RXFRAGSHI_IP4RXFRAGSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4RXFRAGSHI_IP4RXFRAGSHI_S)
#define IG3_STATS_GLPES_PFIP4RXFRAGSLO(_i) 0x42615400 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4RXFRAGSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4RXFRAGSLO_IP4RXFRAGSLO_S 0
#define IG3_STATS_GLPES_PFIP4RXFRAGSLO_IP4RXFRAGSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4RXFRAGSLO_IP4RXFRAGSLO_S)
#define IG3_STATS_GLPES_PFIP4RXMCOCTSHI(_i) 0x42605500 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4RXMCOCTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4RXMCOCTSHI_IP4RXMCOCTSHI_S 0
#define IG3_STATS_GLPES_PFIP4RXMCOCTSHI_IP4RXMCOCTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4RXMCOCTSHI_IP4RXMCOCTSHI_S)
#define IG3_STATS_GLPES_PFIP4RXMCOCTSLO(_i) 0x42604400 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4RXMCOCTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4RXMCOCTSLO_IP4RXMCOCTSLO_S 0
#define IG3_STATS_GLPES_PFIP4RXMCOCTSLO_IP4RXMCOCTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4RXMCOCTSLO_IP4RXMCOCTSLO_S)
#define IG3_STATS_GLPES_PFIP4RXMCPKTSHI(_i) 0x42607700 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4RXMCPKTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4RXMCPKTSHI_IP4RXMCPKTSHI_S 0
#define IG3_STATS_GLPES_PFIP4RXMCPKTSHI_IP4RXMCPKTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4RXMCPKTSHI_IP4RXMCPKTSHI_S)
#define IG3_STATS_GLPES_PFIP4RXMCPKTSLO(_i) 0x42606600 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4RXMCPKTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4RXMCPKTSLO_IP4RXMCPKTSLO_S 0
#define IG3_STATS_GLPES_PFIP4RXMCPKTSLO_IP4RXMCPKTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4RXMCPKTSLO_IP4RXMCPKTSLO_S)
#define IG3_STATS_GLPES_PFIP4RXOCTSHI(_i) 0x42601100 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4RXOCTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4RXOCTSHI_IP4RXOCTSHI_S 0
#define IG3_STATS_GLPES_PFIP4RXOCTSHI_IP4RXOCTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4RXOCTSHI_IP4RXOCTSHI_S)
#define IG3_STATS_GLPES_PFIP4RXOCTSLO(_i) 0x42600000 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4RXOCTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4RXOCTSLO_IP4RXOCTSLO_S 0
#define IG3_STATS_GLPES_PFIP4RXOCTSLO_IP4RXOCTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4RXOCTSLO_IP4RXOCTSLO_S)
#define IG3_STATS_GLPES_PFIP4RXPKTSHI(_i) 0x42603300 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4RXPKTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4RXPKTSHI_IP4RXPKTSHI_S 0
#define IG3_STATS_GLPES_PFIP4RXPKTSHI_IP4RXPKTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4RXPKTSHI_IP4RXPKTSHI_S)
#define IG3_STATS_GLPES_PFIP4RXPKTSLO(_i) 0x42602200 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4RXPKTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4RXPKTSLO_IP4RXPKTSLO_S 0
#define IG3_STATS_GLPES_PFIP4RXPKTSLO_IP4RXPKTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4RXPKTSLO_IP4RXPKTSLO_S)
#define IG3_STATS_GLPES_PFIP4RXTRUNCHI(_i) 0x42618700 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4RXTRUNCHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4RXTRUNCHI_IP4RXTRUNC_S 0
#define IG3_STATS_GLPES_PFIP4RXTRUNCHI_IP4RXTRUNC_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4RXTRUNCHI_IP4RXTRUNC_S)
#define IG3_STATS_GLPES_PFIP4RXTRUNCLO(_i) 0x42617600 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4RXTRUNCLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4RXTRUNCLO_IP4RXTRUNC_S 0
#define IG3_STATS_GLPES_PFIP4RXTRUNCLO_IP4RXTRUNC_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4RXTRUNCLO_IP4RXTRUNC_S)
#define IG3_STATS_GLPES_PFIP4TXFRAGSHI(_i) 0x42653F00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4TXFRAGSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4TXFRAGSHI_IP4TXFRAGSHI_S 0
#define IG3_STATS_GLPES_PFIP4TXFRAGSHI_IP4TXFRAGSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4TXFRAGSHI_IP4TXFRAGSHI_S)
#define IG3_STATS_GLPES_PFIP4TXFRAGSLO(_i) 0x42652E00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4TXFRAGSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4TXFRAGSLO_IP4TXFRAGSLO_S 0
#define IG3_STATS_GLPES_PFIP4TXFRAGSLO_IP4TXFRAGSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4TXFRAGSLO_IP4TXFRAGSLO_S)
#define IG3_STATS_GLPES_PFIP4TXMCOCTSHI(_i) 0x42645100 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4TXMCOCTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4TXMCOCTSHI_IP4TXMCOCTSHI_S 0
#define IG3_STATS_GLPES_PFIP4TXMCOCTSHI_IP4TXMCOCTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4TXMCOCTSHI_IP4TXMCOCTSHI_S)
#define IG3_STATS_GLPES_PFIP4TXMCOCTSLO(_i) 0x42644000 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4TXMCOCTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4TXMCOCTSLO_IP4TXMCOCTSLO_S 0
#define IG3_STATS_GLPES_PFIP4TXMCOCTSLO_IP4TXMCOCTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4TXMCOCTSLO_IP4TXMCOCTSLO_S)
#define IG3_STATS_GLPES_PFIP4TXMCPKTSHI(_i) 0x42647300 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4TXMCPKTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4TXMCPKTSHI_IP4TXMCPKTSHI_S 0
#define IG3_STATS_GLPES_PFIP4TXMCPKTSHI_IP4TXMCPKTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4TXMCPKTSHI_IP4TXMCPKTSHI_S)
#define IG3_STATS_GLPES_PFIP4TXMCPKTSLO(_i) 0x42646200 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4TXMCPKTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4TXMCPKTSLO_IP4TXMCPKTSLO_S 0
#define IG3_STATS_GLPES_PFIP4TXMCPKTSLO_IP4TXMCPKTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4TXMCPKTSLO_IP4TXMCPKTSLO_S)
#define IG3_STATS_GLPES_PFIP4TXNOROUTEHI(_i) 0x42651D00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4TXNOROUTEHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4TXNOROUTEHI_IP4TXNOROUTE_S 0
#define IG3_STATS_GLPES_PFIP4TXNOROUTEHI_IP4TXNOROUTE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4TXNOROUTEHI_IP4TXNOROUTE_S)
#define IG3_STATS_GLPES_PFIP4TXNOROUTELO(_i) 0x42650C00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4TXNOROUTELO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4TXNOROUTELO_IP4TXNOROUTE_S 0
#define IG3_STATS_GLPES_PFIP4TXNOROUTELO_IP4TXNOROUTE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4TXNOROUTELO_IP4TXNOROUTE_S)
#define IG3_STATS_GLPES_PFIP4TXOCTSHI(_i) 0x42640D00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4TXOCTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4TXOCTSHI_IP4TXOCTSHI_S 0
#define IG3_STATS_GLPES_PFIP4TXOCTSHI_IP4TXOCTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4TXOCTSHI_IP4TXOCTSHI_S)
#define IG3_STATS_GLPES_PFIP4TXOCTSLO(_i) 0x4263FC00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4TXOCTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4TXOCTSLO_IP4TXOCTSLO_S 0
#define IG3_STATS_GLPES_PFIP4TXOCTSLO_IP4TXOCTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4TXOCTSLO_IP4TXOCTSLO_S)
#define IG3_STATS_GLPES_PFIP4TXPKTSHI(_i) 0x42642F00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4TXPKTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4TXPKTSHI_IP4TXPKTSHI_S 0
#define IG3_STATS_GLPES_PFIP4TXPKTSHI_IP4TXPKTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4TXPKTSHI_IP4TXPKTSHI_S)
#define IG3_STATS_GLPES_PFIP4TXPKTSLO(_i) 0x42641E00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP4TXPKTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP4TXPKTSLO_IP4TXPKTSLO_S 0
#define IG3_STATS_GLPES_PFIP4TXPKTSLO_IP4TXPKTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP4TXPKTSLO_IP4TXPKTSLO_S)
#define IG3_STATS_GLPES_PFIP6RXDISCARDHI(_i) 0x4261CB00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6RXDISCARDHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6RXDISCARDHI_IP6RXDISCARD_S 0
#define IG3_STATS_GLPES_PFIP6RXDISCARDHI_IP6RXDISCARD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6RXDISCARDHI_IP6RXDISCARD_S)
#define IG3_STATS_GLPES_PFIP6RXDISCARDLO(_i) 0x4261BA00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6RXDISCARDLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6RXDISCARDLO_IP6RXDISCARD_S 0
#define IG3_STATS_GLPES_PFIP6RXDISCARDLO_IP6RXDISCARD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6RXDISCARDLO_IP6RXDISCARD_S)
#define IG3_STATS_GLPES_PFIP6RXFRAGSHI(_i) 0x4261ED00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6RXFRAGSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6RXFRAGSHI_IP6RXFRAGSHI_S 0
#define IG3_STATS_GLPES_PFIP6RXFRAGSHI_IP6RXFRAGSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6RXFRAGSHI_IP6RXFRAGSHI_S)
#define IG3_STATS_GLPES_PFIP6RXFRAGSLO(_i) 0x4261DC00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6RXFRAGSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6RXFRAGSLO_IP6RXFRAGSLO_S 0
#define IG3_STATS_GLPES_PFIP6RXFRAGSLO_IP6RXFRAGSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6RXFRAGSLO_IP6RXFRAGSLO_S)
#define IG3_STATS_GLPES_PFIP6RXMCOCTSHI(_i) 0x4260DD00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6RXMCOCTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6RXMCOCTSHI_IP6RXMCOCTSHI_S 0
#define IG3_STATS_GLPES_PFIP6RXMCOCTSHI_IP6RXMCOCTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6RXMCOCTSHI_IP6RXMCOCTSHI_S)
#define IG3_STATS_GLPES_PFIP6RXMCOCTSLO(_i) 0x4260CC00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6RXMCOCTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6RXMCOCTSLO_IP6RXMCOCTSLO_S 0
#define IG3_STATS_GLPES_PFIP6RXMCOCTSLO_IP6RXMCOCTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6RXMCOCTSLO_IP6RXMCOCTSLO_S)
#define IG3_STATS_GLPES_PFIP6RXMCPKTSHI(_i) 0x4260FF00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6RXMCPKTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6RXMCPKTSHI_IP6RXMCPKTSHI_S 0
#define IG3_STATS_GLPES_PFIP6RXMCPKTSHI_IP6RXMCPKTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6RXMCPKTSHI_IP6RXMCPKTSHI_S)
#define IG3_STATS_GLPES_PFIP6RXMCPKTSLO(_i) 0x4260EE00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6RXMCPKTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6RXMCPKTSLO_IP6RXMCPKTSLO_S 0
#define IG3_STATS_GLPES_PFIP6RXMCPKTSLO_IP6RXMCPKTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6RXMCPKTSLO_IP6RXMCPKTSLO_S)
#define IG3_STATS_GLPES_PFIP6RXOCTSHI(_i) 0x42609900 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6RXOCTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6RXOCTSHI_IP6RXOCTSHI_S 0
#define IG3_STATS_GLPES_PFIP6RXOCTSHI_IP6RXOCTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6RXOCTSHI_IP6RXOCTSHI_S)
#define IG3_STATS_GLPES_PFIP6RXOCTSLO(_i) 0x42608800 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6RXOCTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6RXOCTSLO_IP6RXOCTSLO_S 0
#define IG3_STATS_GLPES_PFIP6RXOCTSLO_IP6RXOCTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6RXOCTSLO_IP6RXOCTSLO_S)
#define IG3_STATS_GLPES_PFIP6RXPKTSHI(_i) 0x4260BB00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6RXPKTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6RXPKTSHI_IP6RXPKTSHI_S 0
#define IG3_STATS_GLPES_PFIP6RXPKTSHI_IP6RXPKTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6RXPKTSHI_IP6RXPKTSHI_S)
#define IG3_STATS_GLPES_PFIP6RXPKTSLO(_i) 0x4260AA00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6RXPKTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6RXPKTSLO_IP6RXPKTSLO_S 0
#define IG3_STATS_GLPES_PFIP6RXPKTSLO_IP6RXPKTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6RXPKTSLO_IP6RXPKTSLO_S)
#define IG3_STATS_GLPES_PFIP6RXTRUNCHI(_i) 0x42623100 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6RXTRUNCHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6RXTRUNCHI_IP6RXTRUNC_S 0
#define IG3_STATS_GLPES_PFIP6RXTRUNCHI_IP6RXTRUNC_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6RXTRUNCHI_IP6RXTRUNC_S)
#define IG3_STATS_GLPES_PFIP6RXTRUNCLO(_i) 0x42622000 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6RXTRUNCLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6RXTRUNCLO_IP6RXTRUNC_S 0
#define IG3_STATS_GLPES_PFIP6RXTRUNCLO_IP6RXTRUNC_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6RXTRUNCLO_IP6RXTRUNC_S)
#define IG3_STATS_GLPES_PFIP6TXFRAGSHI(_i) 0x42658300 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6TXFRAGSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6TXFRAGSHI_IP6TXFRAGSHI_S 0
#define IG3_STATS_GLPES_PFIP6TXFRAGSHI_IP6TXFRAGSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6TXFRAGSHI_IP6TXFRAGSHI_S)
#define IG3_STATS_GLPES_PFIP6TXFRAGSLO(_i) 0x42657200 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6TXFRAGSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6TXFRAGSLO_IP6TXFRAGSLO_S 0
#define IG3_STATS_GLPES_PFIP6TXFRAGSLO_IP6TXFRAGSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6TXFRAGSLO_IP6TXFRAGSLO_S)
#define IG3_STATS_GLPES_PFIP6TXMCOCTSHI(_i) 0x4264D900 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6TXMCOCTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6TXMCOCTSHI_IP6TXMCOCTSHI_S 0
#define IG3_STATS_GLPES_PFIP6TXMCOCTSHI_IP6TXMCOCTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6TXMCOCTSHI_IP6TXMCOCTSHI_S)
#define IG3_STATS_GLPES_PFIP6TXMCOCTSLO(_i) 0x4264C800 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6TXMCOCTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6TXMCOCTSLO_IP6TXMCOCTSLO_S 0
#define IG3_STATS_GLPES_PFIP6TXMCOCTSLO_IP6TXMCOCTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6TXMCOCTSLO_IP6TXMCOCTSLO_S)
#define IG3_STATS_GLPES_PFIP6TXMCPKTSHI(_i) 0x4264FB00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6TXMCPKTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6TXMCPKTSHI_IP6TXMCPKTSHI_S 0
#define IG3_STATS_GLPES_PFIP6TXMCPKTSHI_IP6TXMCPKTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6TXMCPKTSHI_IP6TXMCPKTSHI_S)
#define IG3_STATS_GLPES_PFIP6TXMCPKTSLO(_i) 0x4264EA00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6TXMCPKTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6TXMCPKTSLO_IP6TXMCPKTSLO_S 0
#define IG3_STATS_GLPES_PFIP6TXMCPKTSLO_IP6TXMCPKTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6TXMCPKTSLO_IP6TXMCPKTSLO_S)
#define IG3_STATS_GLPES_PFIP6TXNOROUTEHI(_i) 0x42656100 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6TXNOROUTEHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6TXNOROUTEHI_IP6TXNOROUTE_S 0
#define IG3_STATS_GLPES_PFIP6TXNOROUTEHI_IP6TXNOROUTE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6TXNOROUTEHI_IP6TXNOROUTE_S)
#define IG3_STATS_GLPES_PFIP6TXNOROUTELO(_i) 0x42655000 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6TXNOROUTELO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6TXNOROUTELO_IP6TXNOROUTE_S 0
#define IG3_STATS_GLPES_PFIP6TXNOROUTELO_IP6TXNOROUTE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6TXNOROUTELO_IP6TXNOROUTE_S)
#define IG3_STATS_GLPES_PFIP6TXOCTSHI(_i) 0x42649500 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6TXOCTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6TXOCTSHI_IP6TXOCTSHI_S 0
#define IG3_STATS_GLPES_PFIP6TXOCTSHI_IP6TXOCTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6TXOCTSHI_IP6TXOCTSHI_S)
#define IG3_STATS_GLPES_PFIP6TXOCTSLO(_i) 0x42648400 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6TXOCTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6TXOCTSLO_IP6TXOCTSLO_S 0
#define IG3_STATS_GLPES_PFIP6TXOCTSLO_IP6TXOCTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6TXOCTSLO_IP6TXOCTSLO_S)
#define IG3_STATS_GLPES_PFIP6TXPKTSHI(_i) 0x4264B700 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6TXPKTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6TXPKTSHI_IP6TXPKTSHI_S 0
#define IG3_STATS_GLPES_PFIP6TXPKTSHI_IP6TXPKTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6TXPKTSHI_IP6TXPKTSHI_S)
#define IG3_STATS_GLPES_PFIP6TXPKTSLO(_i) 0x4264A600 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFIP6TXPKTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFIP6TXPKTSLO_IP6TXPKTSLO_S 0
#define IG3_STATS_GLPES_PFIP6TXPKTSLO_IP6TXPKTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFIP6TXPKTSLO_IP6TXPKTSLO_S)
#define IG3_STATS_GLPES_PFRDMARXATSHI(_i) 0x4262B900 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMARXATSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMARXATSHI_RDMARXATSHI_S 0
#define IG3_STATS_GLPES_PFRDMARXATSHI_RDMARXATSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMARXATSHI_RDMARXATSHI_S)
#define IG3_STATS_GLPES_PFRDMARXATSLO(_i) 0x4262A800 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMARXATSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMARXATSLO_RDMARXATSLO_S 0
#define IG3_STATS_GLPES_PFRDMARXATSLO_RDMARXATSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMARXATSLO_RDMARXATSLO_S)
#define IG3_STATS_GLPES_PFRDMARXRDSHI(_i) 0x4262FD00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMARXRDSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMARXRDSHI_RDMARXRDSHI_S 0
#define IG3_STATS_GLPES_PFRDMARXRDSHI_RDMARXRDSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMARXRDSHI_RDMARXRDSHI_S)
#define IG3_STATS_GLPES_PFRDMARXRDSLO(_i) 0x4262EC00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMARXRDSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMARXRDSLO_RDMARXRDSLO_S 0
#define IG3_STATS_GLPES_PFRDMARXRDSLO_RDMARXRDSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMARXRDSLO_RDMARXRDSLO_S)
#define IG3_STATS_GLPES_PFRDMARXSNDSHI(_i) 0x42631F00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMARXSNDSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMARXSNDSHI_RDMARXSNDSHI_S 0
#define IG3_STATS_GLPES_PFRDMARXSNDSHI_RDMARXSNDSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMARXSNDSHI_RDMARXSNDSHI_S)
#define IG3_STATS_GLPES_PFRDMARXSNDSLO(_i) 0x42630E00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMARXSNDSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMARXSNDSLO_RDMARXSNDSLO_S 0
#define IG3_STATS_GLPES_PFRDMARXSNDSLO_RDMARXSNDSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMARXSNDSLO_RDMARXSNDSLO_S)
#define IG3_STATS_GLPES_PFRDMARXWRSHI(_i) 0x4262DB00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMARXWRSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMARXWRSHI_RDMARXWRSHI_S 0
#define IG3_STATS_GLPES_PFRDMARXWRSHI_RDMARXWRSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMARXWRSHI_RDMARXWRSHI_S)
#define IG3_STATS_GLPES_PFRDMARXWRSLO(_i) 0x4262CA00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMARXWRSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMARXWRSLO_RDMARXWRSLO_S 0
#define IG3_STATS_GLPES_PFRDMARXWRSLO_RDMARXWRSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMARXWRSLO_RDMARXWRSLO_S)
#define IG3_STATS_GLPES_PFRDMATXATSHI(_i) 0x4265E900 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMATXATSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMATXATSHI_RDMARXATSHI_S 0
#define IG3_STATS_GLPES_PFRDMATXATSHI_RDMARXATSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMATXATSHI_RDMARXATSHI_S)
#define IG3_STATS_GLPES_PFRDMATXATSLO(_i) 0x4265D800 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMATXATSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMATXATSLO_RDMARXATSLO_S 0
#define IG3_STATS_GLPES_PFRDMATXATSLO_RDMARXATSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMATXATSLO_RDMARXATSLO_S)
#define IG3_STATS_GLPES_PFRDMATXRDSHI(_i) 0x42662D00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMATXRDSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMATXRDSHI_RDMARXRDSHI_S 0
#define IG3_STATS_GLPES_PFRDMATXRDSHI_RDMARXRDSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMATXRDSHI_RDMARXRDSHI_S)
#define IG3_STATS_GLPES_PFRDMATXRDSLO(_i) 0x42661C00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMATXRDSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMATXRDSLO_RDMARXRDSLO_S 0
#define IG3_STATS_GLPES_PFRDMATXRDSLO_RDMARXRDSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMATXRDSLO_RDMARXRDSLO_S)
#define IG3_STATS_GLPES_PFRDMATXSNDSHI(_i) 0x42664F00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMATXSNDSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMATXSNDSHI_RDMARXSNDSHI_S 0
#define IG3_STATS_GLPES_PFRDMATXSNDSHI_RDMARXSNDSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMATXSNDSHI_RDMARXSNDSHI_S)
#define IG3_STATS_GLPES_PFRDMATXSNDSLO(_i) 0x42663E00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMATXSNDSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMATXSNDSLO_RDMARXSNDSLO_S 0
#define IG3_STATS_GLPES_PFRDMATXSNDSLO_RDMARXSNDSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMATXSNDSLO_RDMARXSNDSLO_S)
#define IG3_STATS_GLPES_PFRDMATXWRSHI(_i) 0x42660B00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMATXWRSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMATXWRSHI_RDMARXWRSHI_S 0
#define IG3_STATS_GLPES_PFRDMATXWRSHI_RDMARXWRSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMATXWRSHI_RDMARXWRSHI_S)
#define IG3_STATS_GLPES_PFRDMATXWRSLO(_i) 0x4265FA00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMATXWRSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMATXWRSLO_RDMARXWRSLO_S 0
#define IG3_STATS_GLPES_PFRDMATXWRSLO_RDMARXWRSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMATXWRSLO_RDMARXWRSLO_S)
#define IG3_STATS_GLPES_PFRDMAVBNDHI(_i) 0x42634100 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMAVBNDHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMAVBNDHI_RDMAVBNDHI_S 0
#define IG3_STATS_GLPES_PFRDMAVBNDHI_RDMAVBNDHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMAVBNDHI_RDMAVBNDHI_S)
#define IG3_STATS_GLPES_PFRDMAVBNDLO(_i) 0x42633000 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMAVBNDLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMAVBNDLO_RDMAVBNDLO_S 0
#define IG3_STATS_GLPES_PFRDMAVBNDLO_RDMAVBNDLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMAVBNDLO_RDMAVBNDLO_S)
#define IG3_STATS_GLPES_PFRDMAVINVHI(_i) 0x42636300 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMAVINVHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMAVINVHI_RDMAVINVHI_S 0
#define IG3_STATS_GLPES_PFRDMAVINVHI_RDMAVINVHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMAVINVHI_RDMAVINVHI_S)
#define IG3_STATS_GLPES_PFRDMAVINVLO(_i) 0x42635200 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRDMAVINVLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRDMAVINVLO_RDMAVINVLO_S 0
#define IG3_STATS_GLPES_PFRDMAVINVLO_RDMAVINVLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRDMAVINVLO_RDMAVINVLO_S)
#define IG3_STATS_GLPES_PFRXNPECNMARKEDPKTSHI(_i) 0x42638500 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRXNPECNMARKEDPKTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRXNPECNMARKEDPKTSHI_FRXNPECNMARKEDPKTSHI_S 0
#define IG3_STATS_GLPES_PFRXNPECNMARKEDPKTSHI_FRXNPECNMARKEDPKTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRXNPECNMARKEDPKTSHI_FRXNPECNMARKEDPKTSHI_S)
#define IG3_STATS_GLPES_PFRXNPECNMARKEDPKTSLO(_i) 0x42637400 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRXNPECNMARKEDPKTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRXNPECNMARKEDPKTSLO_RXNPECNMARKEDPKTSLO_S 0
#define IG3_STATS_GLPES_PFRXNPECNMARKEDPKTSLO_RXNPECNMARKEDPKTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRXNPECNMARKEDPKTSLO_RXNPECNMARKEDPKTSLO_S)
#define IG3_STATS_GLPES_PFRXRPCNPHANDLEDHI(_i) 0x42629700 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRXRPCNPHANDLEDHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRXRPCNPHANDLEDHI_RXRPCNPHANDLED_S 0
#define IG3_STATS_GLPES_PFRXRPCNPHANDLEDHI_RXRPCNPHANDLED_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRXRPCNPHANDLEDHI_RXRPCNPHANDLED_S)
#define IG3_STATS_GLPES_PFRXRPCNPHANDLEDLO(_i) 0x42628600 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRXRPCNPHANDLEDLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRXRPCNPHANDLEDLO_RXRPCNPHANDLED_S 0
#define IG3_STATS_GLPES_PFRXRPCNPHANDLEDLO_RXRPCNPHANDLED_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRXRPCNPHANDLEDLO_RXRPCNPHANDLED_S)
#define IG3_STATS_GLPES_PFRXRPCNPIGNOREDHI(_i) 0x4261A900 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRXRPCNPIGNOREDHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRXRPCNPIGNOREDHI_RPCNPIGNORED_S 0
#define IG3_STATS_GLPES_PFRXRPCNPIGNOREDHI_RPCNPIGNORED_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRXRPCNPIGNOREDHI_RPCNPIGNORED_S)
#define IG3_STATS_GLPES_PFRXRPCNPIGNOREDLO(_i) 0x42619800 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRXRPCNPIGNOREDLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRXRPCNPIGNOREDLO_RPCNPIGNORED_S 0
#define IG3_STATS_GLPES_PFRXRPCNPIGNOREDLO_RPCNPIGNORED_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRXRPCNPIGNOREDLO_RPCNPIGNORED_S)
#define IG3_STATS_GLPES_PFRXVLANERRHI(_i) 0x42612100 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRXVLANERRHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRXVLANERRHI_RXVLANERR_S 0
#define IG3_STATS_GLPES_PFRXVLANERRHI_RXVLANERR_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRXVLANERRHI_RXVLANERR_S)
#define IG3_STATS_GLPES_PFRXVLANERRLO(_i) 0x42611000 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFRXVLANERRLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFRXVLANERRLO_RXVLANERR_S 0
#define IG3_STATS_GLPES_PFRXVLANERRLO_RXVLANERR_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFRXVLANERRLO_RXVLANERR_S)
#define IG3_STATS_GLPES_PFTCPRTXSEGHI(_i) 0x4265C700 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFTCPRTXSEGHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFTCPRTXSEGHI_TCPRTXSEG_S 0
#define IG3_STATS_GLPES_PFTCPRTXSEGHI_TCPRTXSEG_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFTCPRTXSEGHI_TCPRTXSEG_S)
#define IG3_STATS_GLPES_PFTCPRTXSEGLO(_i) 0x4265B600 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFTCPRTXSEGLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFTCPRTXSEGLO_TCPRTXSEG_S 0
#define IG3_STATS_GLPES_PFTCPRTXSEGLO_TCPRTXSEG_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFTCPRTXSEGLO_TCPRTXSEG_S)
#define IG3_STATS_GLPES_PFTCPRXOPTERRHI(_i) 0x42627500 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFTCPRXOPTERRHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFTCPRXOPTERRHI_TCPRXOPTERR_S 0
#define IG3_STATS_GLPES_PFTCPRXOPTERRHI_TCPRXOPTERR_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFTCPRXOPTERRHI_TCPRXOPTERR_S)
#define IG3_STATS_GLPES_PFTCPRXOPTERRLO(_i) 0x42626400 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFTCPRXOPTERRLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFTCPRXOPTERRLO_TCPRXOPTERR_S 0
#define IG3_STATS_GLPES_PFTCPRXOPTERRLO_TCPRXOPTERR_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFTCPRXOPTERRLO_TCPRXOPTERR_S)
#define IG3_STATS_GLPES_PFTCPRXPROTOERRHI(_i) 0x42620F00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFTCPRXPROTOERRHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFTCPRXPROTOERRHI_TCPRXPROTOERR_S 0
#define IG3_STATS_GLPES_PFTCPRXPROTOERRHI_TCPRXPROTOERR_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFTCPRXPROTOERRHI_TCPRXPROTOERR_S)
#define IG3_STATS_GLPES_PFTCPRXPROTOERRLO(_i) 0x4261FE00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFTCPRXPROTOERRLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFTCPRXPROTOERRLO_TCPRXPROTOERR_S 0
#define IG3_STATS_GLPES_PFTCPRXPROTOERRLO_TCPRXPROTOERR_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFTCPRXPROTOERRLO_TCPRXPROTOERR_S)
#define IG3_STATS_GLPES_PFTCPRXSEGSHI(_i) 0x4263C900 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFTCPRXSEGSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFTCPRXSEGSHI_TCPRXSEGSHI_S 0
#define IG3_STATS_GLPES_PFTCPRXSEGSHI_TCPRXSEGSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFTCPRXSEGSHI_TCPRXSEGSHI_S)
#define IG3_STATS_GLPES_PFTCPRXSEGSLO(_i) 0x4263B800 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFTCPRXSEGSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFTCPRXSEGSLO_TCPRXSEGSLO_S 0
#define IG3_STATS_GLPES_PFTCPRXSEGSLO_TCPRXSEGSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFTCPRXSEGSLO_TCPRXSEGSLO_S)
#define IG3_STATS_GLPES_PFTCPTXSEGSHI(_i) 0x4266B500 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFTCPTXSEGSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFTCPTXSEGSHI_TCPTXSEGHI_S 0
#define IG3_STATS_GLPES_PFTCPTXSEGSHI_TCPTXSEGHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFTCPTXSEGSHI_TCPTXSEGHI_S)
#define IG3_STATS_GLPES_PFTCPTXSEGSLO(_i) 0x4266A400 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFTCPTXSEGSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFTCPTXSEGSLO_TCPTXSEGLO_S 0
#define IG3_STATS_GLPES_PFTCPTXSEGSLO_TCPTXSEGLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFTCPTXSEGSLO_TCPTXSEGLO_S)
#define IG3_STATS_GLPES_PFTXNPCNPSENTHI(_i) 0x42667100 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFTXNPCNPSENTHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFTXNPCNPSENTHI_PFTXNPCNPSENT_S 0
#define IG3_STATS_GLPES_PFTXNPCNPSENTHI_PFTXNPCNPSENT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFTXNPCNPSENTHI_PFTXNPCNPSENT_S)
#define IG3_STATS_GLPES_PFTXNPCNPSENTLO(_i) 0x42666000 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFTXNPCNPSENTLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFTXNPCNPSENTLO_PFTXNPCNPSENT_S 0
#define IG3_STATS_GLPES_PFTXNPCNPSENTLO_PFTXNPCNPSENT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFTXNPCNPSENTLO_PFTXNPCNPSENT_S)
#define IG3_STATS_GLPES_PFUDPRXPKTSHI(_i) 0x4263EB00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFUDPRXPKTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFUDPRXPKTSHI_UDPRXPKTSHI_S 0
#define IG3_STATS_GLPES_PFUDPRXPKTSHI_UDPRXPKTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFUDPRXPKTSHI_UDPRXPKTSHI_S)
#define IG3_STATS_GLPES_PFUDPRXPKTSLO(_i) 0x4263DA00 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFUDPRXPKTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFUDPRXPKTSLO_UDPRXPKTSLO_S 0
#define IG3_STATS_GLPES_PFUDPRXPKTSLO_UDPRXPKTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFUDPRXPKTSLO_UDPRXPKTSLO_S)
#define IG3_STATS_GLPES_PFUDPTXPKTSHI(_i) 0x4266D700 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFUDPTXPKTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFUDPTXPKTSHI_UDPTXPKTSHI_S 0
#define IG3_STATS_GLPES_PFUDPTXPKTSHI_UDPTXPKTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFUDPTXPKTSHI_UDPTXPKTSHI_S)
#define IG3_STATS_GLPES_PFUDPTXPKTSLO(_i) 0x4266C600 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_PFUDPTXPKTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_PFUDPTXPKTSLO_UDPTXPKTSLO_S 0
#define IG3_STATS_GLPES_PFUDPTXPKTSLO_UDPTXPKTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PFUDPTXPKTSLO_UDPTXPKTSLO_S)
#define IG3_STATS_GLPES_PSHGCTRKTBLCNTHI 0x4266EEAC
#define IG3_STATS_GLPES_PSHGCTRKTBLCNTHI_PSHGCTRKTBLCNT_S 0
#define IG3_STATS_GLPES_PSHGCTRKTBLCNTHI_PSHGCTRKTBLCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHGCTRKTBLCNTHI_PSHGCTRKTBLCNT_S)
#define IG3_STATS_GLPES_PSHGCTRKTBLCNTLO 0x4266EEA8
#define IG3_STATS_GLPES_PSHGCTRKTBLCNTLO_PSHGCTRKTBLCNT_S 0
#define IG3_STATS_GLPES_PSHGCTRKTBLCNTLO_PSHGCTRKTBLCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHGCTRKTBLCNTLO_PSHGCTRKTBLCNT_S)
#define IG3_STATS_GLPES_PSHINCWQECNTHI 0x4266EE94
#define IG3_STATS_GLPES_PSHINCWQECNTHI_PSHINCWQECNT_S 0
#define IG3_STATS_GLPES_PSHINCWQECNTHI_PSHINCWQECNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHINCWQECNTHI_PSHINCWQECNT_S)
#define IG3_STATS_GLPES_PSHINCWQECNTLO 0x4266EE90
#define IG3_STATS_GLPES_PSHINCWQECNTLO_PSHINCWQECNT_S 0
#define IG3_STATS_GLPES_PSHINCWQECNTLO_PSHINCWQECNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHINCWQECNTLO_PSHINCWQECNT_S)
#define IG3_STATS_GLPES_PSHINVACCESSCNTHI 0x4266EE9C
#define IG3_STATS_GLPES_PSHINVACCESSCNTHI_PSHINVACCESSCNT_S 0
#define IG3_STATS_GLPES_PSHINVACCESSCNTHI_PSHINVACCESSCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHINVACCESSCNTHI_PSHINVACCESSCNT_S)
#define IG3_STATS_GLPES_PSHINVACCESSCNTLO 0x4266EE98
#define IG3_STATS_GLPES_PSHINVACCESSCNTLO_PSHINVACCESSCNT_S 0
#define IG3_STATS_GLPES_PSHINVACCESSCNTLO_PSHINVACCESSCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHINVACCESSCNTLO_PSHINVACCESSCNT_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T0(_i) 0x4266EEC8 + ((_i) * 4) /* _i=0...7 */
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T0_MAX_INDEX_I 7
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T0_VALID_S 31
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T0_VALID_M RDMA_BIT2(32, IG3_STATS_GLPES_PSHINVACCESSTRC_T0_VALID_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T0_RSVD_S 30
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T0_RSVD_M RDMA_BIT2(32, IG3_STATS_GLPES_PSHINVACCESSTRC_T0_RSVD_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T0_PAGE_OFST_S 24
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T0_PAGE_OFST_M RDMA_MASK3(32, 0x3F, IG3_STATS_GLPES_PSHINVACCESSTRC_T0_PAGE_OFST_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T0_PAGE_IDX_S 14
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T0_PAGE_IDX_M RDMA_MASK3(32, 0x3FF, IG3_STATS_GLPES_PSHINVACCESSTRC_T0_PAGE_IDX_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T0_VF_IDX_S 2
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T0_VF_IDX_M RDMA_MASK3(32, 0xFFF, IG3_STATS_GLPES_PSHINVACCESSTRC_T0_VF_IDX_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T0_VM_VF_TYPE_S 0
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T0_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPES_PSHINVACCESSTRC_T0_VM_VF_TYPE_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T1(_i) 0x4266EEE8 + ((_i) * 4) /* _i=0...7 */
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T1_MAX_INDEX_I 7
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T1_VALID_S 31
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T1_VALID_M RDMA_BIT2(32, IG3_STATS_GLPES_PSHINVACCESSTRC_T1_VALID_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T1_RSVD_S 30
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T1_RSVD_M RDMA_BIT2(32, IG3_STATS_GLPES_PSHINVACCESSTRC_T1_RSVD_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T1_PAGE_OFST_S 24
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T1_PAGE_OFST_M RDMA_MASK3(32, 0x3F, IG3_STATS_GLPES_PSHINVACCESSTRC_T1_PAGE_OFST_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T1_PAGE_IDX_S 14
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T1_PAGE_IDX_M RDMA_MASK3(32, 0x3FF, IG3_STATS_GLPES_PSHINVACCESSTRC_T1_PAGE_IDX_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T1_VF_IDX_S 2
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T1_VF_IDX_M RDMA_MASK3(32, 0xFFF, IG3_STATS_GLPES_PSHINVACCESSTRC_T1_VF_IDX_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T1_VM_VF_TYPE_S 0
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPES_PSHINVACCESSTRC_T1_VM_VF_TYPE_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T2(_i) 0x4266EF08 + ((_i) * 4) /* _i=0...7 */
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T2_MAX_INDEX_I 7
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T2_VALID_S 31
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T2_VALID_M RDMA_BIT2(32, IG3_STATS_GLPES_PSHINVACCESSTRC_T2_VALID_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T2_RSVD_S 30
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T2_RSVD_M RDMA_BIT2(32, IG3_STATS_GLPES_PSHINVACCESSTRC_T2_RSVD_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T2_PAGE_OFST_S 24
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T2_PAGE_OFST_M RDMA_MASK3(32, 0x3F, IG3_STATS_GLPES_PSHINVACCESSTRC_T2_PAGE_OFST_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T2_PAGE_IDX_S 14
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T2_PAGE_IDX_M RDMA_MASK3(32, 0x3FF, IG3_STATS_GLPES_PSHINVACCESSTRC_T2_PAGE_IDX_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T2_VF_IDX_S 2
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T2_VF_IDX_M RDMA_MASK3(32, 0xFFF, IG3_STATS_GLPES_PSHINVACCESSTRC_T2_VF_IDX_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T2_VM_VF_TYPE_S 0
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T2_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPES_PSHINVACCESSTRC_T2_VM_VF_TYPE_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T3(_i) 0x4266EF28 + ((_i) * 4) /* _i=0...7 */
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T3_MAX_INDEX_I 7
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T3_VALID_S 31
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T3_VALID_M RDMA_BIT2(32, IG3_STATS_GLPES_PSHINVACCESSTRC_T3_VALID_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T3_RSVD_S 30
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T3_RSVD_M RDMA_BIT2(32, IG3_STATS_GLPES_PSHINVACCESSTRC_T3_RSVD_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T3_PAGE_OFST_S 24
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T3_PAGE_OFST_M RDMA_MASK3(32, 0x3F, IG3_STATS_GLPES_PSHINVACCESSTRC_T3_PAGE_OFST_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T3_PAGE_IDX_S 14
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T3_PAGE_IDX_M RDMA_MASK3(32, 0x3FF, IG3_STATS_GLPES_PSHINVACCESSTRC_T3_PAGE_IDX_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T3_VF_IDX_S 2
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T3_VF_IDX_M RDMA_MASK3(32, 0xFFF, IG3_STATS_GLPES_PSHINVACCESSTRC_T3_VF_IDX_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T3_VM_VF_TYPE_S 0
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T3_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPES_PSHINVACCESSTRC_T3_VM_VF_TYPE_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T4(_i) 0x4266EF48 + ((_i) * 4) /* _i=0...7 */
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T4_MAX_INDEX_I 7
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T4_VALID_S 31
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T4_VALID_M RDMA_BIT2(32, IG3_STATS_GLPES_PSHINVACCESSTRC_T4_VALID_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T4_RSVD_S 30
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T4_RSVD_M RDMA_BIT2(32, IG3_STATS_GLPES_PSHINVACCESSTRC_T4_RSVD_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T4_PAGE_OFST_S 24
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T4_PAGE_OFST_M RDMA_MASK3(32, 0x3F, IG3_STATS_GLPES_PSHINVACCESSTRC_T4_PAGE_OFST_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T4_PAGE_IDX_S 14
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T4_PAGE_IDX_M RDMA_MASK3(32, 0x3FF, IG3_STATS_GLPES_PSHINVACCESSTRC_T4_PAGE_IDX_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T4_VF_IDX_S 2
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T4_VF_IDX_M RDMA_MASK3(32, 0xFFF, IG3_STATS_GLPES_PSHINVACCESSTRC_T4_VF_IDX_S)
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T4_VM_VF_TYPE_S 0
#define IG3_STATS_GLPES_PSHINVACCESSTRC_T4_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPES_PSHINVACCESSTRC_T4_VM_VF_TYPE_S)
#define IG3_STATS_GLPES_PSHINVSQHDCNTHI 0x4266EEB4
#define IG3_STATS_GLPES_PSHINVSQHDCNTHI_PSHINVSQHDCNT_S 0
#define IG3_STATS_GLPES_PSHINVSQHDCNTHI_PSHINVSQHDCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHINVSQHDCNTHI_PSHINVSQHDCNT_S)
#define IG3_STATS_GLPES_PSHINVSQHDCNTLO 0x4266EEB0
#define IG3_STATS_GLPES_PSHINVSQHDCNTLO_PSHINVSQHDCNT_S 0
#define IG3_STATS_GLPES_PSHINVSQHDCNTLO_PSHINVSQHDCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHINVSQHDCNTLO_PSHINVSQHDCNT_S)
#define IG3_STATS_GLPES_PSHNOCREDCNTHI 0x4266EE84
#define IG3_STATS_GLPES_PSHNOCREDCNTHI_PSHNOCREDCNT_S 0
#define IG3_STATS_GLPES_PSHNOCREDCNTHI_PSHNOCREDCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHNOCREDCNTHI_PSHNOCREDCNT_S)
#define IG3_STATS_GLPES_PSHNOCREDCNTLO 0x4266EE80
#define IG3_STATS_GLPES_PSHNOCREDCNTLO_PSHNOCREDCNT_S 0
#define IG3_STATS_GLPES_PSHNOCREDCNTLO_PSHNOCREDCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHNOCREDCNTLO_PSHNOCREDCNT_S)
#define IG3_STATS_GLPES_PSHNOTRKTBLDBCNTHI 0x4266EE8C
#define IG3_STATS_GLPES_PSHNOTRKTBLDBCNTHI_PSHNOTRKTBLDBCNT_S 0
#define IG3_STATS_GLPES_PSHNOTRKTBLDBCNTHI_PSHNOTRKTBLDBCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHNOTRKTBLDBCNTHI_PSHNOTRKTBLDBCNT_S)
#define IG3_STATS_GLPES_PSHNOTRKTBLDBCNTLO 0x4266EE88
#define IG3_STATS_GLPES_PSHNOTRKTBLDBCNTLO_PSHNOTRKTBLDBCNT_S 0
#define IG3_STATS_GLPES_PSHNOTRKTBLDBCNTLO_PSHNOTRKTBLDBCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHNOTRKTBLDBCNTLO_PSHNOTRKTBLDBCNT_S)
#define IG3_STATS_GLPES_PSHNOTRKTBLTRNCNTHI 0x4266EEC4
#define IG3_STATS_GLPES_PSHNOTRKTBLTRNCNTHI_PSHNOTRKTBLCNT_S 0
#define IG3_STATS_GLPES_PSHNOTRKTBLTRNCNTHI_PSHNOTRKTBLCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHNOTRKTBLTRNCNTHI_PSHNOTRKTBLCNT_S)
#define IG3_STATS_GLPES_PSHNOTRKTBLTRNCNTLO 0x4266EEC0
#define IG3_STATS_GLPES_PSHNOTRKTBLTRNCNTLO_PSHNOTRKTBLCNT_S 0
#define IG3_STATS_GLPES_PSHNOTRKTBLTRNCNTLO_PSHNOTRKTBLCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHNOTRKTBLTRNCNTLO_PSHNOTRKTBLCNT_S)
#define IG3_STATS_GLPES_PSHPFCDROPCNTHI 0x4266EEBC
#define IG3_STATS_GLPES_PSHPFCDROPCNTHI_PSHPFCDROPCNT_S 0
#define IG3_STATS_GLPES_PSHPFCDROPCNTHI_PSHPFCDROPCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHPFCDROPCNTHI_PSHPFCDROPCNT_S)
#define IG3_STATS_GLPES_PSHPFCDROPCNTLO 0x4266EEB8
#define IG3_STATS_GLPES_PSHPFCDROPCNTLO_PSHPFCDROPCNT_S 0
#define IG3_STATS_GLPES_PSHPFCDROPCNTLO_PSHPFCDROPCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHPFCDROPCNTLO_PSHPFCDROPCNT_S)
#define IG3_STATS_GLPES_PSHSQXMITCNTHI 0x4266EEA4
#define IG3_STATS_GLPES_PSHSQXMITCNTHI_PSHSQXMITCNT_S 0
#define IG3_STATS_GLPES_PSHSQXMITCNTHI_PSHSQXMITCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHSQXMITCNTHI_PSHSQXMITCNT_S)
#define IG3_STATS_GLPES_PSHSQXMITCNTLO 0x4266EEA0
#define IG3_STATS_GLPES_PSHSQXMITCNTLO_PSHSQXMITCNT_S 0
#define IG3_STATS_GLPES_PSHSQXMITCNTLO_PSHSQXMITCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_PSHSQXMITCNTLO_PSHSQXMITCNT_S)
#define IG3_STATS_GLPES_RDMAIRDLMTCNTSHI(_i) 0x42625300 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_RDMAIRDLMTCNTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_RDMAIRDLMTCNTSHI_RDMAIRDLMTCNTLCNTSHI_S 0
#define IG3_STATS_GLPES_RDMAIRDLMTCNTSHI_RDMAIRDLMTCNTLCNTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RDMAIRDLMTCNTSHI_RDMAIRDLMTCNTLCNTSHI_S)
#define IG3_STATS_GLPES_RDMAIRDLMTCNTSLO(_i) 0x42624200 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_RDMAIRDLMTCNTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_RDMAIRDLMTCNTSLO_RDMAIRDLMTCNTLCNTSLO_S 0
#define IG3_STATS_GLPES_RDMAIRDLMTCNTSLO_RDMAIRDLMTCNTLCNTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RDMAIRDLMTCNTSLO_RDMAIRDLMTCNTLCNTSLO_S)
#define IG3_STATS_GLPES_RDMAORDLMTCNTSHI(_i) 0x4265A500 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_RDMAORDLMTCNTSHI_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_RDMAORDLMTCNTSHI_RDMAORDLMTCNTLCNTSHI_S 0
#define IG3_STATS_GLPES_RDMAORDLMTCNTSHI_RDMAORDLMTCNTLCNTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RDMAORDLMTCNTSHI_RDMAORDLMTCNTLCNTSHI_S)
#define IG3_STATS_GLPES_RDMAORDLMTCNTSLO(_i) 0x42659400 + ((_i) * 4) /* _i=0...1087 */
#define IG3_STATS_GLPES_RDMAORDLMTCNTSLO_MAX_INDEX_I 1087
#define IG3_STATS_GLPES_RDMAORDLMTCNTSLO_RDMAORDLMTCNTLCNTSLO_S 0
#define IG3_STATS_GLPES_RDMAORDLMTCNTSLO_RDMAORDLMTCNTLCNTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RDMAORDLMTCNTSLO_RDMAORDLMTCNTLCNTSLO_S)
#define IG3_STATS_GLPES_RDMARXMULTFPDUSHI 0x4266E81C
#define IG3_STATS_GLPES_RDMARXMULTFPDUSHI_RDMARXMULTFPDUSHI_S 0
#define IG3_STATS_GLPES_RDMARXMULTFPDUSHI_RDMARXMULTFPDUSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RDMARXMULTFPDUSHI_RDMARXMULTFPDUSHI_S)
#define IG3_STATS_GLPES_RDMARXMULTFPDUSLO 0x4266E818
#define IG3_STATS_GLPES_RDMARXMULTFPDUSLO_RDMARXMULTFPDUSLO_S 0
#define IG3_STATS_GLPES_RDMARXMULTFPDUSLO_RDMARXMULTFPDUSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RDMARXMULTFPDUSLO_RDMARXMULTFPDUSLO_S)
#define IG3_STATS_GLPES_RDMARXOOODDPHI 0x4266E824
#define IG3_STATS_GLPES_RDMARXOOODDPHI_RDMARXOOODDPHI_S 0
#define IG3_STATS_GLPES_RDMARXOOODDPHI_RDMARXOOODDPHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RDMARXOOODDPHI_RDMARXOOODDPHI_S)
#define IG3_STATS_GLPES_RDMARXOOODDPLO 0x4266E820
#define IG3_STATS_GLPES_RDMARXOOODDPLO_RDMARXOOODDPLO_S 0
#define IG3_STATS_GLPES_RDMARXOOODDPLO_RDMARXOOODDPLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RDMARXOOODDPLO_RDMARXOOODDPLO_S)
#define IG3_STATS_GLPES_RDMARXOOONOMARKHI 0x4266E814
#define IG3_STATS_GLPES_RDMARXOOONOMARKHI_RDMAOOONOMARK_S 0
#define IG3_STATS_GLPES_RDMARXOOONOMARKHI_RDMAOOONOMARK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RDMARXOOONOMARKHI_RDMAOOONOMARK_S)
#define IG3_STATS_GLPES_RDMARXOOONOMARKLO 0x4266E810
#define IG3_STATS_GLPES_RDMARXOOONOMARKLO_RDMAOOONOMARK_S 0
#define IG3_STATS_GLPES_RDMARXOOONOMARKLO_RDMAOOONOMARK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RDMARXOOONOMARKLO_RDMAOOONOMARK_S)
#define IG3_STATS_GLPES_RDMARXUNALIGNHI 0x4266E804
#define IG3_STATS_GLPES_RDMARXUNALIGNHI_RDMRXAUNALIGN_S 0
#define IG3_STATS_GLPES_RDMARXUNALIGNHI_RDMRXAUNALIGN_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RDMARXUNALIGNHI_RDMRXAUNALIGN_S)
#define IG3_STATS_GLPES_RDMARXUNALIGNLO 0x4266E800
#define IG3_STATS_GLPES_RDMARXUNALIGNLO_RDMRXAUNALIGN_S 0
#define IG3_STATS_GLPES_RDMARXUNALIGNLO_RDMRXAUNALIGN_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RDMARXUNALIGNLO_RDMRXAUNALIGN_S)
#define IG3_STATS_GLPES_RNRNAKREQHI 0x4266E8EC
#define IG3_STATS_GLPES_RNRNAKREQHI_RNRNAKREQHI_S 0
#define IG3_STATS_GLPES_RNRNAKREQHI_RNRNAKREQHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RNRNAKREQHI_RNRNAKREQHI_S)
#define IG3_STATS_GLPES_RNRNAKREQLO 0x4266E8E8
#define IG3_STATS_GLPES_RNRNAKREQLO_RNRNAKREQLO_S 0
#define IG3_STATS_GLPES_RNRNAKREQLO_RNRNAKREQLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RNRNAKREQLO_RNRNAKREQLO_S)
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID11HI 0x4266E80C
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID11HI_RXRAM2RSVDCNTRID11HI_S 0
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID11HI_RXRAM2RSVDCNTRID11HI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RXRAM2RSVDCNTRID11HI_RXRAM2RSVDCNTRID11HI_S)
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID11LO 0x4266E808
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID11LO_RXRAM2RSVDCNTRID11LO_S 0
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID11LO_RXRAM2RSVDCNTRID11LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RXRAM2RSVDCNTRID11LO_RXRAM2RSVDCNTRID11LO_S)
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1AHI 0x4266E854
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1AHI_RXRAM2RSVDCNTRID1AHI_S 0
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1AHI_RXRAM2RSVDCNTRID1AHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RXRAM2RSVDCNTRID1AHI_RXRAM2RSVDCNTRID1AHI_S)
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1ALO 0x4266E850
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1ALO_RXRAM2RSVDCNTRID1ALO_S 0
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1ALO_RXRAM2RSVDCNTRID1ALO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RXRAM2RSVDCNTRID1ALO_RXRAM2RSVDCNTRID1ALO_S)
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1BHI 0x4266E85C
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1BHI_RXRAM2RSVDCNTRID1BHI_S 0
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1BHI_RXRAM2RSVDCNTRID1BHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RXRAM2RSVDCNTRID1BHI_RXRAM2RSVDCNTRID1BHI_S)
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1BLO 0x4266E858
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1BLO_RXRAM2RSVDCNTRID1BLO_S 0
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1BLO_RXRAM2RSVDCNTRID1BLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RXRAM2RSVDCNTRID1BLO_RXRAM2RSVDCNTRID1BLO_S)
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1CHI 0x4266E864
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1CHI_RXRAM2RSVDCNTRID1CHI_S 0
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1CHI_RXRAM2RSVDCNTRID1CHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RXRAM2RSVDCNTRID1CHI_RXRAM2RSVDCNTRID1CHI_S)
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1CLO 0x4266E860
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1CLO_RXRAM2RSVDCNTRID1CLO_S 0
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1CLO_RXRAM2RSVDCNTRID1CLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RXRAM2RSVDCNTRID1CLO_RXRAM2RSVDCNTRID1CLO_S)
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1DHI 0x4266E86C
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1DHI_RXRAM2RSVDCNTRID1DHI_S 0
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1DHI_RXRAM2RSVDCNTRID1DHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RXRAM2RSVDCNTRID1DHI_RXRAM2RSVDCNTRID1DHI_S)
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1DLO 0x4266E868
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1DLO_RXRAM2RSVDCNTRID1DLO_S 0
#define IG3_STATS_GLPES_RXRAM2RSVDCNTRID1DLO_RXRAM2RSVDCNTRID1DLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RXRAM2RSVDCNTRID1DLO_RXRAM2RSVDCNTRID1DLO_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_MAX_VAL(_i) 0x4266EE40 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_MAX_VAL_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_MAX_VAL_THRESHOLD_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_MAX_VAL_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_MAX_VAL_THRESHOLD_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H0(_i) 0x4266E940 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H0_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H0_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H0_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H0_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H1(_i) 0x4266E980 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H1_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H1_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H1_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H1_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H2(_i) 0x4266E9C0 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H2_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H2_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H2_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H2_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H3(_i) 0x4266EA00 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H3_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H3_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H3_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H3_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H4(_i) 0x4266EA40 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H4_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H4_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P0_H4_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H0(_i) 0x4266EA80 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H0_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H0_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H0_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H0_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H1(_i) 0x4266EAC0 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H1_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H1_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H1_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H1_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H2(_i) 0x4266EB00 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H2_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H2_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H2_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H2_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H3(_i) 0x4266EB40 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H3_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H3_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H3_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H3_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H4(_i) 0x4266EB80 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H4_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H4_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P1_H4_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H0(_i) 0x4266EBC0 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H0_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H0_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H0_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H0_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H1(_i) 0x4266EC00 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H1_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H1_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H1_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H1_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H2(_i) 0x4266EC40 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H2_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H2_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H2_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H2_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H3(_i) 0x4266EC80 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H3_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H3_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H3_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H3_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H4(_i) 0x4266ECC0 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H4_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H4_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P2_H4_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H0(_i) 0x4266ED00 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H0_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H0_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H0_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H0_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H1(_i) 0x4266ED40 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H1_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H1_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H1_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H1_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H2(_i) 0x4266ED80 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H2_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H2_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H2_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H2_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H3(_i) 0x4266EDC0 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H3_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H3_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H3_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H3_COUNT_S)
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H4(_i) 0x4266EE00 + ((_i) * 4) /* _i=0...15 */
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H4_MAX_INDEX_I 15
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H4_COUNT_S 0
#define IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_RX_LATENCY_HIS_P3_H4_COUNT_S)
#define IG3_STATS_GLPES_TCPRXFOURHOLEHI 0x4266E84C
#define IG3_STATS_GLPES_TCPRXFOURHOLEHI_TCPRXFOURHOLEHI_S 0
#define IG3_STATS_GLPES_TCPRXFOURHOLEHI_TCPRXFOURHOLEHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPRXFOURHOLEHI_TCPRXFOURHOLEHI_S)
#define IG3_STATS_GLPES_TCPRXFOURHOLELO 0x4266E848
#define IG3_STATS_GLPES_TCPRXFOURHOLELO_TCPRXFOURHOLELO_S 0
#define IG3_STATS_GLPES_TCPRXFOURHOLELO_TCPRXFOURHOLELO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPRXFOURHOLELO_TCPRXFOURHOLELO_S)
#define IG3_STATS_GLPES_TCPRXONEHOLEHI 0x4266E834
#define IG3_STATS_GLPES_TCPRXONEHOLEHI_TCPRXONEHOLEHI_S 0
#define IG3_STATS_GLPES_TCPRXONEHOLEHI_TCPRXONEHOLEHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPRXONEHOLEHI_TCPRXONEHOLEHI_S)
#define IG3_STATS_GLPES_TCPRXONEHOLELO 0x4266E830
#define IG3_STATS_GLPES_TCPRXONEHOLELO_TCPRXONEHOLELO_S 0
#define IG3_STATS_GLPES_TCPRXONEHOLELO_TCPRXONEHOLELO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPRXONEHOLELO_TCPRXONEHOLELO_S)
#define IG3_STATS_GLPES_TCPRXPUREACKSHI 0x4266E82C
#define IG3_STATS_GLPES_TCPRXPUREACKSHI_TCPRXPUREACKSHI_S 0
#define IG3_STATS_GLPES_TCPRXPUREACKSHI_TCPRXPUREACKSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPRXPUREACKSHI_TCPRXPUREACKSHI_S)
#define IG3_STATS_GLPES_TCPRXPUREACKSLO 0x4266E828
#define IG3_STATS_GLPES_TCPRXPUREACKSLO_TCPRXPUREACKLO_S 0
#define IG3_STATS_GLPES_TCPRXPUREACKSLO_TCPRXPUREACKLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPRXPUREACKSLO_TCPRXPUREACKLO_S)
#define IG3_STATS_GLPES_TCPRXTHREEHOLEHI 0x4266E844
#define IG3_STATS_GLPES_TCPRXTHREEHOLEHI_TCPRXTHREEHOLEHI_S 0
#define IG3_STATS_GLPES_TCPRXTHREEHOLEHI_TCPRXTHREEHOLEHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPRXTHREEHOLEHI_TCPRXTHREEHOLEHI_S)
#define IG3_STATS_GLPES_TCPRXTHREEHOLELO 0x4266E840
#define IG3_STATS_GLPES_TCPRXTHREEHOLELO_TCPRXTHREEHOLELO_S 0
#define IG3_STATS_GLPES_TCPRXTHREEHOLELO_TCPRXTHREEHOLELO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPRXTHREEHOLELO_TCPRXTHREEHOLELO_S)
#define IG3_STATS_GLPES_TCPRXTWOHOLEHI 0x4266E83C
#define IG3_STATS_GLPES_TCPRXTWOHOLEHI_TCPRXTWOHOLEHI_S 0
#define IG3_STATS_GLPES_TCPRXTWOHOLEHI_TCPRXTWOHOLEHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPRXTWOHOLEHI_TCPRXTWOHOLEHI_S)
#define IG3_STATS_GLPES_TCPRXTWOHOLELO 0x4266E838
#define IG3_STATS_GLPES_TCPRXTWOHOLELO_TCPRXTWOHOLELO_S 0
#define IG3_STATS_GLPES_TCPRXTWOHOLELO_TCPRXTWOHOLELO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPRXTWOHOLELO_TCPRXTWOHOLELO_S)
#define IG3_STATS_GLPES_TCPTXRETRANSFASTHI 0x4266E8AC
#define IG3_STATS_GLPES_TCPTXRETRANSFASTHI_TCPTXRETRANSFASTHI_S 0
#define IG3_STATS_GLPES_TCPTXRETRANSFASTHI_TCPTXRETRANSFASTHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPTXRETRANSFASTHI_TCPTXRETRANSFASTHI_S)
#define IG3_STATS_GLPES_TCPTXRETRANSFASTLO 0x4266E8A8
#define IG3_STATS_GLPES_TCPTXRETRANSFASTLO_TCPTXRETRANSFASTLO_S 0
#define IG3_STATS_GLPES_TCPTXRETRANSFASTLO_TCPTXRETRANSFASTLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPTXRETRANSFASTLO_TCPTXRETRANSFASTLO_S)
#define IG3_STATS_GLPES_TCPTXTOUTSFASTHI 0x4266E8B4
#define IG3_STATS_GLPES_TCPTXTOUTSFASTHI_TCPTXTOUTSFASTHI_S 0
#define IG3_STATS_GLPES_TCPTXTOUTSFASTHI_TCPTXTOUTSFASTHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPTXTOUTSFASTHI_TCPTXTOUTSFASTHI_S)
#define IG3_STATS_GLPES_TCPTXTOUTSFASTLO 0x4266E8B0
#define IG3_STATS_GLPES_TCPTXTOUTSFASTLO_TCPTXTOUTSFASTLO_S 0
#define IG3_STATS_GLPES_TCPTXTOUTSFASTLO_TCPTXTOUTSFASTLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPTXTOUTSFASTLO_TCPTXTOUTSFASTLO_S)
#define IG3_STATS_GLPES_TCPTXTOUTSHI 0x4266E8BC
#define IG3_STATS_GLPES_TCPTXTOUTSHI_TCPTXTOUTSHI_S 0
#define IG3_STATS_GLPES_TCPTXTOUTSHI_TCPTXTOUTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPTXTOUTSHI_TCPTXTOUTSHI_S)
#define IG3_STATS_GLPES_TCPTXTOUTSLO 0x4266E8B8
#define IG3_STATS_GLPES_TCPTXTOUTSLO_TCPTXTOUTSLO_S 0
#define IG3_STATS_GLPES_TCPTXTOUTSLO_TCPTXTOUTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TCPTXTOUTSLO_TCPTXTOUTSLO_S)
#define IG3_STATS_GLPES_TEPCNTGP0HI 0x4266E8C4
#define IG3_STATS_GLPES_TEPCNTGP0HI_TEPGP0_S 0
#define IG3_STATS_GLPES_TEPCNTGP0HI_TEPGP0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TEPCNTGP0HI_TEPGP0_S)
#define IG3_STATS_GLPES_TEPCNTGP0LO 0x4266E8C0
#define IG3_STATS_GLPES_TEPCNTGP0LO_TEPGP0_S 0
#define IG3_STATS_GLPES_TEPCNTGP0LO_TEPGP0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TEPCNTGP0LO_TEPGP0_S)
#define IG3_STATS_GLPES_TEPCNTGP1HI 0x4266E8CC
#define IG3_STATS_GLPES_TEPCNTGP1HI_TEPGP1_S 0
#define IG3_STATS_GLPES_TEPCNTGP1HI_TEPGP1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TEPCNTGP1HI_TEPGP1_S)
#define IG3_STATS_GLPES_TEPCNTGP1LO 0x4266E8C8
#define IG3_STATS_GLPES_TEPCNTGP1LO_TEPGP1_S 0
#define IG3_STATS_GLPES_TEPCNTGP1LO_TEPGP1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TEPCNTGP1LO_TEPGP1_S)
#define IG3_STATS_GLPES_TEPCNTGP2HI 0x4266E8D4
#define IG3_STATS_GLPES_TEPCNTGP2HI_TEPGP2_S 0
#define IG3_STATS_GLPES_TEPCNTGP2HI_TEPGP2_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TEPCNTGP2HI_TEPGP2_S)
#define IG3_STATS_GLPES_TEPCNTGP2LO 0x4266E8D0
#define IG3_STATS_GLPES_TEPCNTGP2LO_TEPGP2_S 0
#define IG3_STATS_GLPES_TEPCNTGP2LO_TEPGP2_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TEPCNTGP2LO_TEPGP2_S)
#define IG3_STATS_GLPES_TEPCNTGP3HI 0x4266E8DC
#define IG3_STATS_GLPES_TEPCNTGP3HI_TEPGP3_S 0
#define IG3_STATS_GLPES_TEPCNTGP3HI_TEPGP3_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TEPCNTGP3HI_TEPGP3_S)
#define IG3_STATS_GLPES_TEPCNTGP3LO 0x4266E8D8
#define IG3_STATS_GLPES_TEPCNTGP3LO_TEPGP3_S 0
#define IG3_STATS_GLPES_TEPCNTGP3LO_TEPGP3_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TEPCNTGP3LO_TEPGP3_S)
#define IG3_STATS_GLPES_TXABORTSHI 0x4266E8E4
#define IG3_STATS_GLPES_TXABORTSHI_TXABORTSHI_S 0
#define IG3_STATS_GLPES_TXABORTSHI_TXABORTSHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TXABORTSHI_TXABORTSHI_S)
#define IG3_STATS_GLPES_TXABORTSLO 0x4266E8E0
#define IG3_STATS_GLPES_TXABORTSLO_TXABORTSLO_S 0
#define IG3_STATS_GLPES_TXABORTSLO_TXABORTSLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_TXABORTSLO_TXABORTSLO_S)
#define IG3_STATS_GLPES_UDPMCDPIGNREPLCNTHI 0x4266E87C
#define IG3_STATS_GLPES_UDPMCDPIGNREPLCNTHI_GLPE_UDAMCDPIGNREPLCNT_S 0
#define IG3_STATS_GLPES_UDPMCDPIGNREPLCNTHI_GLPE_UDAMCDPIGNREPLCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_UDPMCDPIGNREPLCNTHI_GLPE_UDAMCDPIGNREPLCNT_S)
#define IG3_STATS_GLPES_UDPMCDPIGNREPLCNTLO 0x4266E878
#define IG3_STATS_GLPES_UDPMCDPIGNREPLCNTLO_GLPE_UDAMCDPIGNREPLCNT_S 0
#define IG3_STATS_GLPES_UDPMCDPIGNREPLCNTLO_GLPE_UDAMCDPIGNREPLCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_UDPMCDPIGNREPLCNTLO_GLPE_UDAMCDPIGNREPLCNT_S)
#define IG3_STATS_GLPES_UDPMCREPLCNTHI 0x4266E874
#define IG3_STATS_GLPES_UDPMCREPLCNTHI_UDAMCREPLCNT_S 0
#define IG3_STATS_GLPES_UDPMCREPLCNTHI_UDAMCREPLCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_UDPMCREPLCNTHI_UDAMCREPLCNT_S)
#define IG3_STATS_GLPES_UDPMCREPLCNTLO 0x4266E870
#define IG3_STATS_GLPES_UDPMCREPLCNTLO_UDAMCREPLCNT_S 0
#define IG3_STATS_GLPES_UDPMCREPLCNTLO_UDAMCREPLCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_UDPMCREPLCNTLO_UDAMCREPLCNT_S)
#define IG3_STATS_GLPES_XLRCOUNTHI 0x4266E904
#define IG3_STATS_GLPES_XLRCOUNTHI_XLRCOUNTHI_S 0
#define IG3_STATS_GLPES_XLRCOUNTHI_XLRCOUNTHI_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_XLRCOUNTHI_XLRCOUNTHI_S)
#define IG3_STATS_GLPES_XLRCOUNTLO 0x4266E900
#define IG3_STATS_GLPES_XLRCOUNTLO_XLRCOUNTLO_S 0
#define IG3_STATS_GLPES_XLRCOUNTLO_XLRCOUNTLO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_STATS_GLPES_XLRCOUNTLO_XLRCOUNTLO_S)
#define IG3_STATS_GLPE_STATS_ECC_COR_ERR 0x4266EFA4
#define IG3_STATS_GLPE_STATS_ECC_COR_ERR_RSVD_S 12
#define IG3_STATS_GLPE_STATS_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_STATS_GLPE_STATS_ECC_COR_ERR_RSVD_S)
#define IG3_STATS_GLPE_STATS_ECC_COR_ERR_CNT_S 0
#define IG3_STATS_GLPE_STATS_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_STATS_GLPE_STATS_ECC_COR_ERR_CNT_S)
#define IG3_STATS_GLPE_STATS_ECC_UNCOR_ERR 0x4266EFA0
#define IG3_STATS_GLPE_STATS_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_STATS_GLPE_STATS_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_STATS_GLPE_STATS_ECC_UNCOR_ERR_RSVD_S)
#define IG3_STATS_GLPE_STATS_ECC_UNCOR_ERR_CNT_S 0
#define IG3_STATS_GLPE_STATS_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_STATS_GLPE_STATS_ECC_UNCOR_ERR_CNT_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG 0x4266EF98
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ECC_INST_NUM_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RSVD3_S 20
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RSVD3_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RM_S 16
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RM_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RSVD2_S 14
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RSVD2_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_POWER_GATE_EN_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RME_S 12
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RME_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RME_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RSVD1_S 10
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RSVD1_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ERR_CNT_S 9
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ERR_CNT_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_FIX_CNT_S 8
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_FIX_CNT_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RSVD0_S 6
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_RSVD0_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_MASK_INT_S 5
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_MASK_INT_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_LS_BYPASS_S 4
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_LS_BYPASS_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_LS_FORCE_S 3
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_LS_FORCE_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ECC_INVERT_2_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ECC_INVERT_1_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ECC_EN_S 0
#define IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_FOUR_MEM_CFG_ECC_EN_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS 0x4266EF9C
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_RSVD1_S 30
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_RSVD1_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_RSVD0_S 4
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_RSVD0_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_INIT_DONE_S 2
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_INIT_DONE_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_ECC_FIX_S 1
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_ECC_FIX_S)
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_ECC_ERR_S 0
#define IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_FOUR_MEM_STATUS_ECC_ERR_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG 0x4266EF68
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RSVD3_S 20
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RSVD3_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RM_S 16
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RM_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RSVD2_S 14
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RSVD2_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RME_S 12
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RME_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RSVD1_S 10
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RSVD1_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ERR_CNT_S 9
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ERR_CNT_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_FIX_CNT_S 8
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_FIX_CNT_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RSVD0_S 6
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_RSVD0_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_MASK_INT_S 5
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_MASK_INT_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_LS_BYPASS_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_LS_FORCE_S 3
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_LS_FORCE_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ECC_EN_S 0
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_0_MEM_CFG_ECC_EN_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS 0x4266EF6C
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_RSVD1_S 30
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_RSVD1_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_RSVD0_S 4
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_RSVD0_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_INIT_DONE_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_ECC_FIX_S)
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_0_MEM_STATUS_ECC_ERR_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG 0x4266EF70
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RSVD3_S 20
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RSVD3_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RM_S 16
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RM_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RSVD2_S 14
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RSVD2_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RME_S 12
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RME_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RSVD1_S 10
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RSVD1_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ERR_CNT_S 9
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ERR_CNT_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_FIX_CNT_S 8
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_FIX_CNT_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RSVD0_S 6
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_RSVD0_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_MASK_INT_S 5
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_MASK_INT_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_LS_BYPASS_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_LS_FORCE_S 3
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_LS_FORCE_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ECC_EN_S 0
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_1_MEM_CFG_ECC_EN_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS 0x4266EF74
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_RSVD1_S 30
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_RSVD1_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_RSVD0_S 4
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_RSVD0_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_INIT_DONE_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_ECC_FIX_S)
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_ONE_1_MEM_STATUS_ECC_ERR_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG 0x4266EF88
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RSVD3_S 20
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RSVD3_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RM_S 16
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RM_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RSVD2_S 14
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RSVD2_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RME_S 12
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RME_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RSVD1_S 10
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RSVD1_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ERR_CNT_S 9
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ERR_CNT_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_FIX_CNT_S 8
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_FIX_CNT_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RSVD0_S 6
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_RSVD0_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_MASK_INT_S 5
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_MASK_INT_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_LS_BYPASS_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_LS_FORCE_S 3
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_LS_FORCE_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ECC_EN_S 0
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_0_MEM_CFG_ECC_EN_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS 0x4266EF8C
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_RSVD1_S 30
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_RSVD1_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_RSVD0_S 4
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_RSVD0_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_INIT_DONE_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_ECC_FIX_S)
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_0_MEM_STATUS_ECC_ERR_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG 0x4266EF90
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RSVD3_S 20
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RSVD3_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RM_S 16
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RM_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RSVD2_S 14
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RSVD2_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RME_S 12
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RME_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RSVD1_S 10
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RSVD1_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ERR_CNT_S 9
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ERR_CNT_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_FIX_CNT_S 8
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_FIX_CNT_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RSVD0_S 6
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_RSVD0_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_MASK_INT_S 5
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_MASK_INT_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_LS_BYPASS_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_LS_FORCE_S 3
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_LS_FORCE_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ECC_EN_S 0
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_1_MEM_CFG_ECC_EN_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS 0x4266EF94
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_RSVD1_S 30
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_RSVD1_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_RSVD0_S 4
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_RSVD0_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_INIT_DONE_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_ECC_FIX_S)
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_THREE_1_MEM_STATUS_ECC_ERR_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG 0x4266EF78
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RSVD3_S 20
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RSVD3_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RM_S 16
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RM_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RSVD2_S 14
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RSVD2_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RME_S 12
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RME_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RSVD1_S 10
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RSVD1_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ERR_CNT_S 9
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ERR_CNT_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_FIX_CNT_S 8
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_FIX_CNT_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RSVD0_S 6
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_RSVD0_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_MASK_INT_S 5
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_MASK_INT_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_LS_BYPASS_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_LS_FORCE_S 3
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_LS_FORCE_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ECC_EN_S 0
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_0_MEM_CFG_ECC_EN_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS 0x4266EF7C
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_RSVD1_S 30
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_RSVD1_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_RSVD0_S 4
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_RSVD0_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_INIT_DONE_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_ECC_FIX_S)
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_0_MEM_STATUS_ECC_ERR_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG 0x4266EF80
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RSVD3_S 20
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RSVD3_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RM_S 16
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RM_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RSVD2_S 14
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RSVD2_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RME_S 12
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RME_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RSVD1_S 10
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RSVD1_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ERR_CNT_S 9
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ERR_CNT_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_FIX_CNT_S 8
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_FIX_CNT_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RSVD0_S 6
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_RSVD0_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_MASK_INT_S 5
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_MASK_INT_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_LS_BYPASS_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_LS_FORCE_S 3
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_LS_FORCE_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ECC_EN_S 0
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_1_MEM_CFG_ECC_EN_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS 0x4266EF84
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_RSVD1_S 30
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_RSVD1_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_RSVD0_S 4
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_RSVD0_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_INIT_DONE_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_ECC_FIX_S)
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_STATS_GLPE_STATS_TWO_1_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_GLHMC_CEQMAX 0x42807214
#define IG3_PMAT_GLHMC_CEQMAX_RSVD_S 12
#define IG3_PMAT_GLHMC_CEQMAX_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PMAT_GLHMC_CEQMAX_RSVD_S)
#define IG3_PMAT_GLHMC_CEQMAX_GLHMC_CEQMAX_S 0
#define IG3_PMAT_GLHMC_CEQMAX_GLHMC_CEQMAX_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_GLHMC_CEQMAX_GLHMC_CEQMAX_S)
#define IG3_PMAT_GLHMC_DBCQMAX 0x42807210
#define IG3_PMAT_GLHMC_DBCQMAX_RSVD_S 22
#define IG3_PMAT_GLHMC_DBCQMAX_RSVD_M RDMA_MASK3(32, 0x3FF, IG3_PMAT_GLHMC_DBCQMAX_RSVD_S)
#define IG3_PMAT_GLHMC_DBCQMAX_GLHMC_DBCQMAX_S 0
#define IG3_PMAT_GLHMC_DBCQMAX_GLHMC_DBCQMAX_M RDMA_MASK3(32, 0x3FFFFF, IG3_PMAT_GLHMC_DBCQMAX_GLHMC_DBCQMAX_S)
#define IG3_PMAT_GLHMC_DBQPMAX 0x4280720C
#define IG3_PMAT_GLHMC_DBQPMAX_RSVD_S 21
#define IG3_PMAT_GLHMC_DBQPMAX_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_PMAT_GLHMC_DBQPMAX_RSVD_S)
#define IG3_PMAT_GLHMC_DBQPMAX_GLHMC_DBQPMAX_S 0
#define IG3_PMAT_GLHMC_DBQPMAX_GLHMC_DBQPMAX_M RDMA_MASK3(32, 0x1FFFFF, IG3_PMAT_GLHMC_DBQPMAX_GLHMC_DBQPMAX_S)
#define IG3_PMAT_GLHMC_DEBUG 0x428071C4
#define IG3_PMAT_GLHMC_DEBUG_RSVD_S 4
#define IG3_PMAT_GLHMC_DEBUG_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_DEBUG_RSVD_S)
#define IG3_PMAT_GLHMC_DEBUG_NAK_DIS_S 3
#define IG3_PMAT_GLHMC_DEBUG_NAK_DIS_M RDMA_BIT2(32, IG3_PMAT_GLHMC_DEBUG_NAK_DIS_S)
#define IG3_PMAT_GLHMC_DEBUG_PD_DIS_S 2
#define IG3_PMAT_GLHMC_DEBUG_PD_DIS_M RDMA_BIT2(32, IG3_PMAT_GLHMC_DEBUG_PD_DIS_S)
#define IG3_PMAT_GLHMC_DEBUG_MEM_DIS_S 1
#define IG3_PMAT_GLHMC_DEBUG_MEM_DIS_M RDMA_BIT2(32, IG3_PMAT_GLHMC_DEBUG_MEM_DIS_S)
#define IG3_PMAT_GLHMC_DEBUG_SOFT_RESET_S 0
#define IG3_PMAT_GLHMC_DEBUG_SOFT_RESET_M RDMA_BIT2(32, IG3_PMAT_GLHMC_DEBUG_SOFT_RESET_S)
#define IG3_PMAT_GLHMC_DOMAIN_ID 0x4280721C
#define IG3_PMAT_GLHMC_DOMAIN_ID_RSVD_S 3
#define IG3_PMAT_GLHMC_DOMAIN_ID_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_DOMAIN_ID_RSVD_S)
#define IG3_PMAT_GLHMC_DOMAIN_ID_ATOMIC_DOMAIN_ID_S 0
#define IG3_PMAT_GLHMC_DOMAIN_ID_ATOMIC_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_DOMAIN_ID_ATOMIC_DOMAIN_ID_S)
#define IG3_PMAT_GLHMC_FSIAVBASE(_i) 0x42830000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_FSIAVBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_FSIAVBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_FSIAVBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_FSIAVBASE_RSVD_S)
#define IG3_PMAT_GLHMC_FSIAVBASE_FPMFSIAVBASE_S 0
#define IG3_PMAT_GLHMC_FSIAVBASE_FPMFSIAVBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_FSIAVBASE_FPMFSIAVBASE_S)
#define IG3_PMAT_GLHMC_FSIAVCNT(_i) 0x42832000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_FSIAVCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_FSIAVCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_FSIAVCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_FSIAVCNT_RSVD_S)
#define IG3_PMAT_GLHMC_FSIAVCNT_FPMFSIAVCNT_S 0
#define IG3_PMAT_GLHMC_FSIAVCNT_FPMFSIAVCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_FSIAVCNT_FPMFSIAVCNT_S)
#define IG3_PMAT_GLHMC_FSIAVMAX 0x428071A0
#define IG3_PMAT_GLHMC_FSIAVMAX_RSVD_S 22
#define IG3_PMAT_GLHMC_FSIAVMAX_RSVD_M RDMA_MASK3(32, 0x3FF, IG3_PMAT_GLHMC_FSIAVMAX_RSVD_S)
#define IG3_PMAT_GLHMC_FSIAVMAX_PMFSIAVMAX_S 0
#define IG3_PMAT_GLHMC_FSIAVMAX_PMFSIAVMAX_M RDMA_MASK3(32, 0x3FFFFF, IG3_PMAT_GLHMC_FSIAVMAX_PMFSIAVMAX_S)
#define IG3_PMAT_GLHMC_FSIAVOBJSZ 0x4280719C
#define IG3_PMAT_GLHMC_FSIAVOBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_FSIAVOBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_FSIAVOBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_FSIAVOBJSZ_PMFSIAVOBJSZ_S 0
#define IG3_PMAT_GLHMC_FSIAVOBJSZ_PMFSIAVOBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_FSIAVOBJSZ_PMFSIAVOBJSZ_S)
#define IG3_PMAT_GLHMC_FSIMCBASE(_i) 0x42844000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_FSIMCBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_FSIMCBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_FSIMCBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_FSIMCBASE_RSVD_S)
#define IG3_PMAT_GLHMC_FSIMCBASE_FPMFSIMCBASE_S 0
#define IG3_PMAT_GLHMC_FSIMCBASE_FPMFSIMCBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_FSIMCBASE_FPMFSIMCBASE_S)
#define IG3_PMAT_GLHMC_FSIMCCNT(_i) 0x42846000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_FSIMCCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_FSIMCCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_FSIMCCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_FSIMCCNT_RSVD_S)
#define IG3_PMAT_GLHMC_FSIMCCNT_FPMFSIMCSZ_S 0
#define IG3_PMAT_GLHMC_FSIMCCNT_FPMFSIMCSZ_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_FSIMCCNT_FPMFSIMCSZ_S)
#define IG3_PMAT_GLHMC_FSIMCMAX 0x42807198
#define IG3_PMAT_GLHMC_FSIMCMAX_RSVD_S 14
#define IG3_PMAT_GLHMC_FSIMCMAX_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_GLHMC_FSIMCMAX_RSVD_S)
#define IG3_PMAT_GLHMC_FSIMCMAX_PMFSIMCMAX_S 0
#define IG3_PMAT_GLHMC_FSIMCMAX_PMFSIMCMAX_M RDMA_MASK3(32, 0x3FFF, IG3_PMAT_GLHMC_FSIMCMAX_PMFSIMCMAX_S)
#define IG3_PMAT_GLHMC_FSIMCOBJSZ 0x42807194
#define IG3_PMAT_GLHMC_FSIMCOBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_FSIMCOBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_FSIMCOBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_FSIMCOBJSZ_PMFSIMCOBJSZ_S 0
#define IG3_PMAT_GLHMC_FSIMCOBJSZ_PMFSIMCOBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_FSIMCOBJSZ_PMFSIMCOBJSZ_S)
#define IG3_PMAT_GLHMC_FWPDINV 0x428071B8
#define IG3_PMAT_GLHMC_FWPDINV_RSVD1_S 25
#define IG3_PMAT_GLHMC_FWPDINV_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PMAT_GLHMC_FWPDINV_RSVD1_S)
#define IG3_PMAT_GLHMC_FWPDINV_PMPDIDX_S 16
#define IG3_PMAT_GLHMC_FWPDINV_PMPDIDX_M RDMA_MASK3(32, 0x1FF, IG3_PMAT_GLHMC_FWPDINV_PMPDIDX_S)
#define IG3_PMAT_GLHMC_FWPDINV_RSVD_S 15
#define IG3_PMAT_GLHMC_FWPDINV_RSVD_M RDMA_BIT2(32, IG3_PMAT_GLHMC_FWPDINV_RSVD_S)
#define IG3_PMAT_GLHMC_FWPDINV_PMSDIDX_S 0
#define IG3_PMAT_GLHMC_FWPDINV_PMSDIDX_M RDMA_MASK3(32, 0x7FFF, IG3_PMAT_GLHMC_FWPDINV_PMSDIDX_S)
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0 0x428071F8
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_CMD_DONE_S 31
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_CMD_DONE_M RDMA_BIT2(32, IG3_PMAT_GLHMC_IMCOBJCACHECTL0_CMD_DONE_S)
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_CMD_FAILED_S 30
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_CMD_FAILED_M RDMA_BIT2(32, IG3_PMAT_GLHMC_IMCOBJCACHECTL0_CMD_FAILED_S)
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_RSVD2_S 29
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_RSVD2_M RDMA_BIT2(32, IG3_PMAT_GLHMC_IMCOBJCACHECTL0_RSVD2_S)
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_OBJ_VDEV_VF_TYPE_S 27
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_OBJ_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PMAT_GLHMC_IMCOBJCACHECTL0_OBJ_VDEV_VF_TYPE_S)
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_RSVD1_S 26
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_RSVD1_M RDMA_BIT2(32, IG3_PMAT_GLHMC_IMCOBJCACHECTL0_RSVD1_S)
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_OBJ_VDEV_VF_NUM_S 16
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_OBJ_VDEV_VF_NUM_M RDMA_MASK3(32, 0x3FF, IG3_PMAT_GLHMC_IMCOBJCACHECTL0_OBJ_VDEV_VF_NUM_S)
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_CMD_S 13
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_CMD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_IMCOBJCACHECTL0_CMD_S)
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_OBJ_TYPE_S 8
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_OBJ_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_IMCOBJCACHECTL0_OBJ_TYPE_S)
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_RSVD0_S 6
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_GLHMC_IMCOBJCACHECTL0_RSVD0_S)
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_OBJ_PF_NUM_S 0
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL0_OBJ_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PMAT_GLHMC_IMCOBJCACHECTL0_OBJ_PF_NUM_S)
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL1 0x428071FC
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL1_RSVD_S 28
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL1_RSVD_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_IMCOBJCACHECTL1_RSVD_S)
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL1_OBJ_INDEX_S 0
#define IG3_PMAT_GLHMC_IMCOBJCACHECTL1_OBJ_INDEX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_IMCOBJCACHECTL1_OBJ_INDEX_S)
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0(_i) 0x42807000 + ((_i) * 4) /* _i=0...15 */
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_MAX_INDEX_I 15
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_CMD_DONE_S 31
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_CMD_DONE_M RDMA_BIT2(32, IG3_PMAT_GLHMC_OBJECTCACHECTL0_CMD_DONE_S)
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_CMD_FAILED_S 30
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_CMD_FAILED_M RDMA_BIT2(32, IG3_PMAT_GLHMC_OBJECTCACHECTL0_CMD_FAILED_S)
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_RSVD2_S 29
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_RSVD2_M RDMA_BIT2(32, IG3_PMAT_GLHMC_OBJECTCACHECTL0_RSVD2_S)
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_OBJ_VDEV_VF_TYPE_S 27
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_OBJ_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PMAT_GLHMC_OBJECTCACHECTL0_OBJ_VDEV_VF_TYPE_S)
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_RSVD1_S 26
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_RSVD1_M RDMA_BIT2(32, IG3_PMAT_GLHMC_OBJECTCACHECTL0_RSVD1_S)
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_OBJ_VDEV_VF_NUM_S 16
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_OBJ_VDEV_VF_NUM_M RDMA_MASK3(32, 0x3FF, IG3_PMAT_GLHMC_OBJECTCACHECTL0_OBJ_VDEV_VF_NUM_S)
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_CMD_S 13
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_CMD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_OBJECTCACHECTL0_CMD_S)
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_OBJ_TYPE_S 8
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_OBJ_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_OBJECTCACHECTL0_OBJ_TYPE_S)
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_RSVD0_S 6
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_GLHMC_OBJECTCACHECTL0_RSVD0_S)
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_OBJ_PF_NUM_S 0
#define IG3_PMAT_GLHMC_OBJECTCACHECTL0_OBJ_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PMAT_GLHMC_OBJECTCACHECTL0_OBJ_PF_NUM_S)
#define IG3_PMAT_GLHMC_OBJECTCACHECTL1(_i) 0x42807100 + ((_i) * 4) /* _i=0...15 */
#define IG3_PMAT_GLHMC_OBJECTCACHECTL1_MAX_INDEX_I 15
#define IG3_PMAT_GLHMC_OBJECTCACHECTL1_RSVD_S 28
#define IG3_PMAT_GLHMC_OBJECTCACHECTL1_RSVD_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_OBJECTCACHECTL1_RSVD_S)
#define IG3_PMAT_GLHMC_OBJECTCACHECTL1_OBJ_INDEX_S 0
#define IG3_PMAT_GLHMC_OBJECTCACHECTL1_OBJ_INDEX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_OBJECTCACHECTL1_OBJ_INDEX_S)
#define IG3_PMAT_GLHMC_PASID(_i) 0x42802000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PASID_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PASID_RSVD_S 21
#define IG3_PMAT_GLHMC_PASID_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_PMAT_GLHMC_PASID_RSVD_S)
#define IG3_PMAT_GLHMC_PASID_PASID_VALID_S 20
#define IG3_PMAT_GLHMC_PASID_PASID_VALID_M RDMA_BIT2(32, IG3_PMAT_GLHMC_PASID_PASID_VALID_S)
#define IG3_PMAT_GLHMC_PASID_PASID_S 0
#define IG3_PMAT_GLHMC_PASID_PASID_M RDMA_MASK3(32, 0xFFFFF, IG3_PMAT_GLHMC_PASID_PASID_S)
#define IG3_PMAT_GLHMC_PE32BRSVDBASE(_i) 0x4283C000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PE32BRSVDBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PE32BRSVDBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PE32BRSVDBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PE32BRSVDBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PE32BRSVDBASE_FPMPE32BRSVDBASE_S 0
#define IG3_PMAT_GLHMC_PE32BRSVDBASE_FPMPE32BRSVDBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PE32BRSVDBASE_FPMPE32BRSVDBASE_S)
#define IG3_PMAT_GLHMC_PE32BRSVDCNT(_i) 0x4283E000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PE32BRSVDCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PE32BRSVDCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PE32BRSVDCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PE32BRSVDCNT_RSVD_S)
#define IG3_PMAT_GLHMC_PE32BRSVDCNT_FPMPE32BRSVDCNT_S 0
#define IG3_PMAT_GLHMC_PE32BRSVDCNT_FPMPE32BRSVDCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PE32BRSVDCNT_FPMPE32BRSVDCNT_S)
#define IG3_PMAT_GLHMC_PE32BRSVDMAX 0x428071D4
#define IG3_PMAT_GLHMC_PE32BRSVDMAX_RSVD_S 29
#define IG3_PMAT_GLHMC_PE32BRSVDMAX_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PE32BRSVDMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PE32BRSVDMAX_PMPE32BRSVDMAX_S 0
#define IG3_PMAT_GLHMC_PE32BRSVDMAX_PMPE32BRSVDMAX_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PE32BRSVDMAX_PMPE32BRSVDMAX_S)
#define IG3_PMAT_GLHMC_PE32BRSVDOBJSZ 0x428071D0
#define IG3_PMAT_GLHMC_PE32BRSVDOBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_PE32BRSVDOBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PE32BRSVDOBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_PE32BRSVDOBJSZ_PMPE32BRSVDOBJSZ_S 0
#define IG3_PMAT_GLHMC_PE32BRSVDOBJSZ_PMPE32BRSVDOBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PE32BRSVDOBJSZ_PMPE32BRSVDOBJSZ_S)
#define IG3_PMAT_GLHMC_PE64BRSVDBASE(_i) 0x42840000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PE64BRSVDBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PE64BRSVDBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PE64BRSVDBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PE64BRSVDBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PE64BRSVDBASE_FPMPE64BRSVDBASE_S 0
#define IG3_PMAT_GLHMC_PE64BRSVDBASE_FPMPE64BRSVDBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PE64BRSVDBASE_FPMPE64BRSVDBASE_S)
#define IG3_PMAT_GLHMC_PE64BRSVDCNT(_i) 0x42842000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PE64BRSVDCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PE64BRSVDCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PE64BRSVDCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PE64BRSVDCNT_RSVD_S)
#define IG3_PMAT_GLHMC_PE64BRSVDCNT_FPMPE64BRSVDCNT_S 0
#define IG3_PMAT_GLHMC_PE64BRSVDCNT_FPMPE64BRSVDCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PE64BRSVDCNT_FPMPE64BRSVDCNT_S)
#define IG3_PMAT_GLHMC_PE64BRSVDMAX 0x428071DC
#define IG3_PMAT_GLHMC_PE64BRSVDMAX_RSVD_S 29
#define IG3_PMAT_GLHMC_PE64BRSVDMAX_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PE64BRSVDMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PE64BRSVDMAX_PMPE64BRSVDMAX_S 0
#define IG3_PMAT_GLHMC_PE64BRSVDMAX_PMPE64BRSVDMAX_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PE64BRSVDMAX_PMPE64BRSVDMAX_S)
#define IG3_PMAT_GLHMC_PE64BRSVDOBJSZ 0x428071D8
#define IG3_PMAT_GLHMC_PE64BRSVDOBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_PE64BRSVDOBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PE64BRSVDOBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_PE64BRSVDOBJSZ_PMPE64BRSVDOBJSZ_S 0
#define IG3_PMAT_GLHMC_PE64BRSVDOBJSZ_PMPE64BRSVDOBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PE64BRSVDOBJSZ_PMPE64BRSVDOBJSZ_S)
#define IG3_PMAT_GLHMC_PEARPBASE(_i) 0x42818000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEARPBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEARPBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PEARPBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PEARPBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PEARPBASE_FPMPEARPBASE_S 0
#define IG3_PMAT_GLHMC_PEARPBASE_FPMPEARPBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PEARPBASE_FPMPEARPBASE_S)
#define IG3_PMAT_GLHMC_PEARPCNT(_i) 0x4281A000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEARPCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEARPCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PEARPCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEARPCNT_RSVD_S)
#define IG3_PMAT_GLHMC_PEARPCNT_FPMPEARPCNT_S 0
#define IG3_PMAT_GLHMC_PEARPCNT_FPMPEARPCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PEARPCNT_FPMPEARPCNT_S)
#define IG3_PMAT_GLHMC_PEARPMAX 0x42807170
#define IG3_PMAT_GLHMC_PEARPMAX_RSVD_S 17
#define IG3_PMAT_GLHMC_PEARPMAX_RSVD_M RDMA_MASK3(32, 0x7FFF, IG3_PMAT_GLHMC_PEARPMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PEARPMAX_PMPEARPMAX_S 0
#define IG3_PMAT_GLHMC_PEARPMAX_PMPEARPMAX_M RDMA_MASK3(32, 0x1FFFF, IG3_PMAT_GLHMC_PEARPMAX_PMPEARPMAX_S)
#define IG3_PMAT_GLHMC_PEARPOBJSZ 0x4280716C
#define IG3_PMAT_GLHMC_PEARPOBJSZ_RSVD_S 3
#define IG3_PMAT_GLHMC_PEARPOBJSZ_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PEARPOBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_PEARPOBJSZ_PMPEARPOBJSZ_S 0
#define IG3_PMAT_GLHMC_PEARPOBJSZ_PMPEARPOBJSZ_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEARPOBJSZ_PMPEARPOBJSZ_S)
#define IG3_PMAT_GLHMC_PECQBASE(_i) 0x4280C000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PECQBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PECQBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PECQBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PECQBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PECQBASE_FPMPECQBASE_S 0
#define IG3_PMAT_GLHMC_PECQBASE_FPMPECQBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PECQBASE_FPMPECQBASE_S)
#define IG3_PMAT_GLHMC_PECQCNT(_i) 0x4280E000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PECQCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PECQCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PECQCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PECQCNT_RSVD_S)
#define IG3_PMAT_GLHMC_PECQCNT_FPMPECQCNT_S 0
#define IG3_PMAT_GLHMC_PECQCNT_FPMPECQCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PECQCNT_FPMPECQCNT_S)
#define IG3_PMAT_GLHMC_PECQOBJSZ 0x42807158
#define IG3_PMAT_GLHMC_PECQOBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_PECQOBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PECQOBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_PECQOBJSZ_PMPECQOBJSZ_S 0
#define IG3_PMAT_GLHMC_PECQOBJSZ_PMPECQOBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PECQOBJSZ_PMPECQOBJSZ_S)
#define IG3_PMAT_GLHMC_PEHDRBASE(_i) 0x42848000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEHDRBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEHDRBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PEHDRBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PEHDRBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PEHDRBASE_GLHMC_PEHDRBASE_S 0
#define IG3_PMAT_GLHMC_PEHDRBASE_GLHMC_PEHDRBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PEHDRBASE_GLHMC_PEHDRBASE_S)
#define IG3_PMAT_GLHMC_PEHDRCNT(_i) 0x4284A000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEHDRCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEHDRCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PEHDRCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEHDRCNT_RSVD_S)
#define IG3_PMAT_GLHMC_PEHDRCNT_GLHMC_PEHDRCNT_S 0
#define IG3_PMAT_GLHMC_PEHDRCNT_GLHMC_PEHDRCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PEHDRCNT_GLHMC_PEHDRCNT_S)
#define IG3_PMAT_GLHMC_PEHDRMAX 0x42807148
#define IG3_PMAT_GLHMC_PEHDRMAX_RSVD_S 21
#define IG3_PMAT_GLHMC_PEHDRMAX_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_PMAT_GLHMC_PEHDRMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PEHDRMAX_PMPEHDRMAX_S 0
#define IG3_PMAT_GLHMC_PEHDRMAX_PMPEHDRMAX_M RDMA_MASK3(32, 0x1FFFFF, IG3_PMAT_GLHMC_PEHDRMAX_PMPEHDRMAX_S)
#define IG3_PMAT_GLHMC_PEHDROBJSZ 0x42807144
#define IG3_PMAT_GLHMC_PEHDROBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_PEHDROBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PEHDROBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_PEHDROBJSZ_PMPEHDROBJSZ_S 0
#define IG3_PMAT_GLHMC_PEHDROBJSZ_PMPEHDROBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PEHDROBJSZ_PMPEHDROBJSZ_S)
#define IG3_PMAT_GLHMC_PEHTCNT(_i) 0x42816000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEHTCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEHTCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PEHTCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEHTCNT_RSVD_S)
#define IG3_PMAT_GLHMC_PEHTCNT_FPMPEHTCNT_S 0
#define IG3_PMAT_GLHMC_PEHTCNT_FPMPEHTCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PEHTCNT_FPMPEHTCNT_S)
#define IG3_PMAT_GLHMC_PEHTEBASE(_i) 0x42814000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEHTEBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEHTEBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PEHTEBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PEHTEBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PEHTEBASE_FPMPEHTEBASE_S 0
#define IG3_PMAT_GLHMC_PEHTEBASE_FPMPEHTEBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PEHTEBASE_FPMPEHTEBASE_S)
#define IG3_PMAT_GLHMC_PEHTEOBJSZ 0x42807164
#define IG3_PMAT_GLHMC_PEHTEOBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_PEHTEOBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PEHTEOBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_PEHTEOBJSZ_PMPEHTEOBJSZ_S 0
#define IG3_PMAT_GLHMC_PEHTEOBJSZ_PMPEHTEOBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PEHTEOBJSZ_PMPEHTEOBJSZ_S)
#define IG3_PMAT_GLHMC_PEHTMAX 0x42807168
#define IG3_PMAT_GLHMC_PEHTMAX_RSVD_S 21
#define IG3_PMAT_GLHMC_PEHTMAX_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_PMAT_GLHMC_PEHTMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PEHTMAX_PMPEHTMAX_S 0
#define IG3_PMAT_GLHMC_PEHTMAX_PMPEHTMAX_M RDMA_MASK3(32, 0x1FFFFF, IG3_PMAT_GLHMC_PEHTMAX_PMPEHTMAX_S)
#define IG3_PMAT_GLHMC_PEMRBASE(_i) 0x4281C000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEMRBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEMRBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PEMRBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PEMRBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PEMRBASE_FPMPEMRBASE_S 0
#define IG3_PMAT_GLHMC_PEMRBASE_FPMPEMRBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PEMRBASE_FPMPEMRBASE_S)
#define IG3_PMAT_GLHMC_PEMRCNT(_i) 0x4281E000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEMRCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEMRCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PEMRCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEMRCNT_RSVD_S)
#define IG3_PMAT_GLHMC_PEMRCNT_FPMPEMRSZ_S 0
#define IG3_PMAT_GLHMC_PEMRCNT_FPMPEMRSZ_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PEMRCNT_FPMPEMRSZ_S)
#define IG3_PMAT_GLHMC_PEMRMAX 0x42807178
#define IG3_PMAT_GLHMC_PEMRMAX_RSVD_S 23
#define IG3_PMAT_GLHMC_PEMRMAX_RSVD_M RDMA_MASK3(32, 0x1FF, IG3_PMAT_GLHMC_PEMRMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PEMRMAX_PMPEMRMAX_S 0
#define IG3_PMAT_GLHMC_PEMRMAX_PMPEMRMAX_M RDMA_MASK3(32, 0x7FFFFF, IG3_PMAT_GLHMC_PEMRMAX_PMPEMRMAX_S)
#define IG3_PMAT_GLHMC_PEMROBJSZ 0x42807174
#define IG3_PMAT_GLHMC_PEMROBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_PEMROBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PEMROBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_PEMROBJSZ_PMPEMROBJSZ_S 0
#define IG3_PMAT_GLHMC_PEMROBJSZ_PMPEMROBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PEMROBJSZ_PMPEMROBJSZ_S)
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0 0x428071F0
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_CMD_DONE_S 31
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_CMD_DONE_M RDMA_BIT2(32, IG3_PMAT_GLHMC_PEOBJCACHECTL0_CMD_DONE_S)
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_CMD_FAILED_S 30
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_CMD_FAILED_M RDMA_BIT2(32, IG3_PMAT_GLHMC_PEOBJCACHECTL0_CMD_FAILED_S)
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_RSVD2_S 29
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_RSVD2_M RDMA_BIT2(32, IG3_PMAT_GLHMC_PEOBJCACHECTL0_RSVD2_S)
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_OBJ_VDEV_VF_TYPE_S 27
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_OBJ_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PMAT_GLHMC_PEOBJCACHECTL0_OBJ_VDEV_VF_TYPE_S)
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_RSVD1_S 26
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_RSVD1_M RDMA_BIT2(32, IG3_PMAT_GLHMC_PEOBJCACHECTL0_RSVD1_S)
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_OBJ_VDEV_VF_NUM_S 16
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_OBJ_VDEV_VF_NUM_M RDMA_MASK3(32, 0x3FF, IG3_PMAT_GLHMC_PEOBJCACHECTL0_OBJ_VDEV_VF_NUM_S)
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_CMD_S 13
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_CMD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEOBJCACHECTL0_CMD_S)
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_OBJ_TYPE_S 8
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_OBJ_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PEOBJCACHECTL0_OBJ_TYPE_S)
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_RSVD0_S 6
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_GLHMC_PEOBJCACHECTL0_RSVD0_S)
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_OBJ_PF_NUM_S 0
#define IG3_PMAT_GLHMC_PEOBJCACHECTL0_OBJ_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PMAT_GLHMC_PEOBJCACHECTL0_OBJ_PF_NUM_S)
#define IG3_PMAT_GLHMC_PEOBJCACHECTL1 0x428071F4
#define IG3_PMAT_GLHMC_PEOBJCACHECTL1_RSVD_S 28
#define IG3_PMAT_GLHMC_PEOBJCACHECTL1_RSVD_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PEOBJCACHECTL1_RSVD_S)
#define IG3_PMAT_GLHMC_PEOBJCACHECTL1_OBJ_INDEX_S 0
#define IG3_PMAT_GLHMC_PEOBJCACHECTL1_OBJ_INDEX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PEOBJCACHECTL1_OBJ_INDEX_S)
#define IG3_PMAT_GLHMC_PEOOISCBASE(_i) 0x4284C000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEOOISCBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEOOISCBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PEOOISCBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PEOOISCBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PEOOISCBASE_GLHMC_PEOOISCBASE_S 0
#define IG3_PMAT_GLHMC_PEOOISCBASE_GLHMC_PEOOISCBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PEOOISCBASE_GLHMC_PEOOISCBASE_S)
#define IG3_PMAT_GLHMC_PEOOISCCNT(_i) 0x4284E000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEOOISCCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEOOISCCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PEOOISCCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEOOISCCNT_RSVD_S)
#define IG3_PMAT_GLHMC_PEOOISCCNT_GLHMC_PEOOISCCNT_S 0
#define IG3_PMAT_GLHMC_PEOOISCCNT_GLHMC_PEOOISCCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PEOOISCCNT_GLHMC_PEOOISCCNT_S)
#define IG3_PMAT_GLHMC_PEOOISCFFLBASE(_i) 0x42858000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEOOISCFFLBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEOOISCFFLBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PEOOISCFFLBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PEOOISCFFLBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PEOOISCFFLBASE_GLHMC_PEOOISCFFLBASE_S 0
#define IG3_PMAT_GLHMC_PEOOISCFFLBASE_GLHMC_PEOOISCFFLBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PEOOISCFFLBASE_GLHMC_PEOOISCFFLBASE_S)
#define IG3_PMAT_GLHMC_PEOOISCFFLCNT_PMAT(_i) 0x4285A000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEOOISCFFLCNT_PMAT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEOOISCFFLCNT_PMAT_RSVD_S 29
#define IG3_PMAT_GLHMC_PEOOISCFFLCNT_PMAT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEOOISCFFLCNT_PMAT_RSVD_S)
#define IG3_PMAT_GLHMC_PEOOISCFFLCNT_PMAT_FPMPEOOISCFFLCNT_S 0
#define IG3_PMAT_GLHMC_PEOOISCFFLCNT_PMAT_FPMPEOOISCFFLCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PEOOISCFFLCNT_PMAT_FPMPEOOISCFFLCNT_S)
#define IG3_PMAT_GLHMC_PEOOISCFFLMAX 0x428071EC
#define IG3_PMAT_GLHMC_PEOOISCFFLMAX_RSVD_S 21
#define IG3_PMAT_GLHMC_PEOOISCFFLMAX_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_PMAT_GLHMC_PEOOISCFFLMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PEOOISCFFLMAX_PMPEOOISCFFLMAX_S 0
#define IG3_PMAT_GLHMC_PEOOISCFFLMAX_PMPEOOISCFFLMAX_M RDMA_MASK3(32, 0x1FFFFF, IG3_PMAT_GLHMC_PEOOISCFFLMAX_PMPEOOISCFFLMAX_S)
#define IG3_PMAT_GLHMC_PEOOISCMAX 0x42807150
#define IG3_PMAT_GLHMC_PEOOISCMAX_RSVD_S 21
#define IG3_PMAT_GLHMC_PEOOISCMAX_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_PMAT_GLHMC_PEOOISCMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PEOOISCMAX_PMPEOOISCMAX_S 0
#define IG3_PMAT_GLHMC_PEOOISCMAX_PMPEOOISCMAX_M RDMA_MASK3(32, 0x1FFFFF, IG3_PMAT_GLHMC_PEOOISCMAX_PMPEOOISCMAX_S)
#define IG3_PMAT_GLHMC_PEOOISCOBJSZ 0x4280714C
#define IG3_PMAT_GLHMC_PEOOISCOBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_PEOOISCOBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PEOOISCOBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_PEOOISCOBJSZ_PMPEOOISCOBJSZ_S 0
#define IG3_PMAT_GLHMC_PEOOISCOBJSZ_PMPEOOISCOBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PEOOISCOBJSZ_PMPEOOISCOBJSZ_S)
#define IG3_PMAT_GLHMC_PEPBLBASE(_i) 0x42834000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEPBLBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEPBLBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PEPBLBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PEPBLBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PEPBLBASE_FPMPEPBLBASE_S 0
#define IG3_PMAT_GLHMC_PEPBLBASE_FPMPEPBLBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PEPBLBASE_FPMPEPBLBASE_S)
#define IG3_PMAT_GLHMC_PEPBLCNT(_i) 0x42836000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEPBLCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEPBLCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PEPBLCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEPBLCNT_RSVD_S)
#define IG3_PMAT_GLHMC_PEPBLCNT_FPMPEPBLCNT_S 0
#define IG3_PMAT_GLHMC_PEPBLCNT_FPMPEPBLCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PEPBLCNT_FPMPEPBLCNT_S)
#define IG3_PMAT_GLHMC_PEPBLMAX 0x428071A4
#define IG3_PMAT_GLHMC_PEPBLMAX_RSVD_S 29
#define IG3_PMAT_GLHMC_PEPBLMAX_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEPBLMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PEPBLMAX_PMPEPBLMAX_S 0
#define IG3_PMAT_GLHMC_PEPBLMAX_PMPEPBLMAX_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PEPBLMAX_PMPEPBLMAX_S)
#define IG3_PMAT_GLHMC_PEQ1BASE(_i) 0x42828000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEQ1BASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEQ1BASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PEQ1BASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PEQ1BASE_RSVD_S)
#define IG3_PMAT_GLHMC_PEQ1BASE_FPMPEQ1BASE_S 0
#define IG3_PMAT_GLHMC_PEQ1BASE_FPMPEQ1BASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PEQ1BASE_FPMPEQ1BASE_S)
#define IG3_PMAT_GLHMC_PEQ1CNT(_i) 0x4282A000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEQ1CNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEQ1CNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PEQ1CNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEQ1CNT_RSVD_S)
#define IG3_PMAT_GLHMC_PEQ1CNT_FPMPEQ1CNT_S 0
#define IG3_PMAT_GLHMC_PEQ1CNT_FPMPEQ1CNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PEQ1CNT_FPMPEQ1CNT_S)
#define IG3_PMAT_GLHMC_PEQ1FLBASE(_i) 0x4282C000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEQ1FLBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEQ1FLBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PEQ1FLBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PEQ1FLBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PEQ1FLBASE_FPMPEQ1FLBASE_S 0
#define IG3_PMAT_GLHMC_PEQ1FLBASE_FPMPEQ1FLBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PEQ1FLBASE_FPMPEQ1FLBASE_S)
#define IG3_PMAT_GLHMC_PEQ1FLCNT_PMAT(_i) 0x4282E000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEQ1FLCNT_PMAT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEQ1FLCNT_PMAT_RSVD_S 29
#define IG3_PMAT_GLHMC_PEQ1FLCNT_PMAT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEQ1FLCNT_PMAT_RSVD_S)
#define IG3_PMAT_GLHMC_PEQ1FLCNT_PMAT_FPMPEQ1FLCNT_S 0
#define IG3_PMAT_GLHMC_PEQ1FLCNT_PMAT_FPMPEQ1FLCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PEQ1FLCNT_PMAT_FPMPEQ1FLCNT_S)
#define IG3_PMAT_GLHMC_PEQ1FLMAX 0x42807190
#define IG3_PMAT_GLHMC_PEQ1FLMAX_RSVD_S 28
#define IG3_PMAT_GLHMC_PEQ1FLMAX_RSVD_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PEQ1FLMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PEQ1FLMAX_PMPEQ1FLMAX_S 0
#define IG3_PMAT_GLHMC_PEQ1FLMAX_PMPEQ1FLMAX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PEQ1FLMAX_PMPEQ1FLMAX_S)
#define IG3_PMAT_GLHMC_PEQ1MAX 0x4280718C
#define IG3_PMAT_GLHMC_PEQ1MAX_RSVD_S 28
#define IG3_PMAT_GLHMC_PEQ1MAX_RSVD_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PEQ1MAX_RSVD_S)
#define IG3_PMAT_GLHMC_PEQ1MAX_PMPEQ1MAX_S 0
#define IG3_PMAT_GLHMC_PEQ1MAX_PMPEQ1MAX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PEQ1MAX_PMPEQ1MAX_S)
#define IG3_PMAT_GLHMC_PEQ1OBJSZ 0x42807188
#define IG3_PMAT_GLHMC_PEQ1OBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_PEQ1OBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PEQ1OBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_PEQ1OBJSZ_PMPEQ1OBJSZ_S 0
#define IG3_PMAT_GLHMC_PEQ1OBJSZ_PMPEQ1OBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PEQ1OBJSZ_PMPEQ1OBJSZ_S)
#define IG3_PMAT_GLHMC_PEQPBASE(_i) 0x42808000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEQPBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEQPBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PEQPBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PEQPBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PEQPBASE_FPMPEQPBASE_S 0
#define IG3_PMAT_GLHMC_PEQPBASE_FPMPEQPBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PEQPBASE_FPMPEQPBASE_S)
#define IG3_PMAT_GLHMC_PEQPCNT(_i) 0x4280A000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEQPCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEQPCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PEQPCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEQPCNT_RSVD_S)
#define IG3_PMAT_GLHMC_PEQPCNT_FPMPEQPCNT_S 0
#define IG3_PMAT_GLHMC_PEQPCNT_FPMPEQPCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PEQPCNT_FPMPEQPCNT_S)
#define IG3_PMAT_GLHMC_PEQPOBJSZ 0x42807154
#define IG3_PMAT_GLHMC_PEQPOBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_PEQPOBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PEQPOBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_PEQPOBJSZ_PMPEQPOBJSZ_S 0
#define IG3_PMAT_GLHMC_PEQPOBJSZ_PMPEQPOBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PEQPOBJSZ_PMPEQPOBJSZ_S)
#define IG3_PMAT_GLHMC_PERRFBASE(_i) 0x42850000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PERRFBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PERRFBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PERRFBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PERRFBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PERRFBASE_GLHMC_PERRFBASE_S 0
#define IG3_PMAT_GLHMC_PERRFBASE_GLHMC_PERRFBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PERRFBASE_GLHMC_PERRFBASE_S)
#define IG3_PMAT_GLHMC_PERRFCNT(_i) 0x42852000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PERRFCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PERRFCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PERRFCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PERRFCNT_RSVD_S)
#define IG3_PMAT_GLHMC_PERRFCNT_GLHMC_PERRFCNT_S 0
#define IG3_PMAT_GLHMC_PERRFCNT_GLHMC_PERRFCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PERRFCNT_GLHMC_PERRFCNT_S)
#define IG3_PMAT_GLHMC_PERRFFLBASE(_i) 0x42854000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PERRFFLBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PERRFFLBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PERRFFLBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PERRFFLBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PERRFFLBASE_GLHMC_PERRFFLBASE_S 0
#define IG3_PMAT_GLHMC_PERRFFLBASE_GLHMC_PERRFFLBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PERRFFLBASE_GLHMC_PERRFFLBASE_S)
#define IG3_PMAT_GLHMC_PERRFFLCNT_PMAT(_i) 0x42856000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PERRFFLCNT_PMAT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PERRFFLCNT_PMAT_RSVD_S 29
#define IG3_PMAT_GLHMC_PERRFFLCNT_PMAT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PERRFFLCNT_PMAT_RSVD_S)
#define IG3_PMAT_GLHMC_PERRFFLCNT_PMAT_FPMPERRFFLCNT_S 0
#define IG3_PMAT_GLHMC_PERRFFLCNT_PMAT_FPMPERRFFLCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PERRFFLCNT_PMAT_FPMPERRFFLCNT_S)
#define IG3_PMAT_GLHMC_PERRFFLMAX 0x428071E8
#define IG3_PMAT_GLHMC_PERRFFLMAX_RSVD_S 27
#define IG3_PMAT_GLHMC_PERRFFLMAX_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PERRFFLMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PERRFFLMAX_PMPERRFFLMAX_S 0
#define IG3_PMAT_GLHMC_PERRFFLMAX_PMPERRFFLMAX_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PERRFFLMAX_PMPERRFFLMAX_S)
#define IG3_PMAT_GLHMC_PERRFMAX 0x428071E4
#define IG3_PMAT_GLHMC_PERRFMAX_RSVD_S 28
#define IG3_PMAT_GLHMC_PERRFMAX_RSVD_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PERRFMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PERRFMAX_PMPERRFMAX_S 0
#define IG3_PMAT_GLHMC_PERRFMAX_PMPERRFMAX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PERRFMAX_PMPERRFMAX_S)
#define IG3_PMAT_GLHMC_PERRFOBJSZ 0x428071E0
#define IG3_PMAT_GLHMC_PERRFOBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_PERRFOBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PERRFOBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_PERRFOBJSZ_PMPERRFOBJSZ_S 0
#define IG3_PMAT_GLHMC_PERRFOBJSZ_PMPERRFOBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PERRFOBJSZ_PMPERRFOBJSZ_S)
#define IG3_PMAT_GLHMC_PESRQBASE(_i) 0x42810000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PESRQBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PESRQBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PESRQBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PESRQBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PESRQBASE_FPMPESRQBASE_S 0
#define IG3_PMAT_GLHMC_PESRQBASE_FPMPESRQBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PESRQBASE_FPMPESRQBASE_S)
#define IG3_PMAT_GLHMC_PESRQCNT(_i) 0x42812000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PESRQCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PESRQCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PESRQCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PESRQCNT_RSVD_S)
#define IG3_PMAT_GLHMC_PESRQCNT_FPMPESRQCNT_S 0
#define IG3_PMAT_GLHMC_PESRQCNT_FPMPESRQCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PESRQCNT_FPMPESRQCNT_S)
#define IG3_PMAT_GLHMC_PESRQMAX 0x42807160
#define IG3_PMAT_GLHMC_PESRQMAX_RSVD_S 17
#define IG3_PMAT_GLHMC_PESRQMAX_RSVD_M RDMA_MASK3(32, 0x7FFF, IG3_PMAT_GLHMC_PESRQMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PESRQMAX_PMPESRQMAX_S 0
#define IG3_PMAT_GLHMC_PESRQMAX_PMPESRQMAX_M RDMA_MASK3(32, 0x1FFFF, IG3_PMAT_GLHMC_PESRQMAX_PMPESRQMAX_S)
#define IG3_PMAT_GLHMC_PESRQOBJSZ 0x4280715C
#define IG3_PMAT_GLHMC_PESRQOBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_PESRQOBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PESRQOBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_PESRQOBJSZ_PMPESRQOBJSZ_S 0
#define IG3_PMAT_GLHMC_PESRQOBJSZ_PMPESRQOBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PESRQOBJSZ_PMPESRQOBJSZ_S)
#define IG3_PMAT_GLHMC_PETIMERBASE(_i) 0x42838000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PETIMERBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PETIMERBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PETIMERBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PETIMERBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PETIMERBASE_FPMPETIMERBASE_S 0
#define IG3_PMAT_GLHMC_PETIMERBASE_FPMPETIMERBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PETIMERBASE_FPMPETIMERBASE_S)
#define IG3_PMAT_GLHMC_PETIMERCNT(_i) 0x4283A000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PETIMERCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PETIMERCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PETIMERCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PETIMERCNT_RSVD_S)
#define IG3_PMAT_GLHMC_PETIMERCNT_FPMPETIMERCNT_S 0
#define IG3_PMAT_GLHMC_PETIMERCNT_FPMPETIMERCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PETIMERCNT_FPMPETIMERCNT_S)
#define IG3_PMAT_GLHMC_PETIMERMAX 0x428071CC
#define IG3_PMAT_GLHMC_PETIMERMAX_RSVD_S 29
#define IG3_PMAT_GLHMC_PETIMERMAX_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PETIMERMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PETIMERMAX_PMPETIMERMAX_S 0
#define IG3_PMAT_GLHMC_PETIMERMAX_PMPETIMERMAX_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PETIMERMAX_PMPETIMERMAX_S)
#define IG3_PMAT_GLHMC_PETIMEROBJSZ 0x428071C8
#define IG3_PMAT_GLHMC_PETIMEROBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_PETIMEROBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PETIMEROBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_PETIMEROBJSZ_PMPETIMEROBJSZ_S 0
#define IG3_PMAT_GLHMC_PETIMEROBJSZ_PMPETIMEROBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PETIMEROBJSZ_PMPETIMEROBJSZ_S)
#define IG3_PMAT_GLHMC_PEXFBASE(_i) 0x42820000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEXFBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEXFBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PEXFBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PEXFBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PEXFBASE_FPMPEXFBASE_S 0
#define IG3_PMAT_GLHMC_PEXFBASE_FPMPEXFBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PEXFBASE_FPMPEXFBASE_S)
#define IG3_PMAT_GLHMC_PEXFCNT(_i) 0x42822000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEXFCNT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEXFCNT_RSVD_S 29
#define IG3_PMAT_GLHMC_PEXFCNT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEXFCNT_RSVD_S)
#define IG3_PMAT_GLHMC_PEXFCNT_FPMPEXFCNT_S 0
#define IG3_PMAT_GLHMC_PEXFCNT_FPMPEXFCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PEXFCNT_FPMPEXFCNT_S)
#define IG3_PMAT_GLHMC_PEXFFLBASE(_i) 0x42824000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEXFFLBASE_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEXFFLBASE_RSVD_S 27
#define IG3_PMAT_GLHMC_PEXFFLBASE_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PEXFFLBASE_RSVD_S)
#define IG3_PMAT_GLHMC_PEXFFLBASE_FPMPEXFFLBASE_S 0
#define IG3_PMAT_GLHMC_PEXFFLBASE_FPMPEXFFLBASE_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PEXFFLBASE_FPMPEXFFLBASE_S)
#define IG3_PMAT_GLHMC_PEXFFLCNT_PMAT(_i) 0x42826000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PMAT_GLHMC_PEXFFLCNT_PMAT_MAX_INDEX_I 1031
#define IG3_PMAT_GLHMC_PEXFFLCNT_PMAT_RSVD_S 29
#define IG3_PMAT_GLHMC_PEXFFLCNT_PMAT_RSVD_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_PEXFFLCNT_PMAT_RSVD_S)
#define IG3_PMAT_GLHMC_PEXFFLCNT_PMAT_FPMPEXFFLCNT_S 0
#define IG3_PMAT_GLHMC_PEXFFLCNT_PMAT_FPMPEXFFLCNT_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_PMAT_GLHMC_PEXFFLCNT_PMAT_FPMPEXFFLCNT_S)
#define IG3_PMAT_GLHMC_PEXFFLMAX 0x42807184
#define IG3_PMAT_GLHMC_PEXFFLMAX_RSVD_S 27
#define IG3_PMAT_GLHMC_PEXFFLMAX_RSVD_M RDMA_MASK3(32, 0x1F, IG3_PMAT_GLHMC_PEXFFLMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PEXFFLMAX_PMPEXFFLMAX_S 0
#define IG3_PMAT_GLHMC_PEXFFLMAX_PMPEXFFLMAX_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PMAT_GLHMC_PEXFFLMAX_PMPEXFFLMAX_S)
#define IG3_PMAT_GLHMC_PEXFMAX 0x42807180
#define IG3_PMAT_GLHMC_PEXFMAX_RSVD_S 28
#define IG3_PMAT_GLHMC_PEXFMAX_RSVD_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PEXFMAX_RSVD_S)
#define IG3_PMAT_GLHMC_PEXFMAX_PMPEXFMAX_S 0
#define IG3_PMAT_GLHMC_PEXFMAX_PMPEXFMAX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PEXFMAX_PMPEXFMAX_S)
#define IG3_PMAT_GLHMC_PEXFOBJSZ 0x4280717C
#define IG3_PMAT_GLHMC_PEXFOBJSZ_RSVD_S 4
#define IG3_PMAT_GLHMC_PEXFOBJSZ_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PMAT_GLHMC_PEXFOBJSZ_RSVD_S)
#define IG3_PMAT_GLHMC_PEXFOBJSZ_PMPEXFOBJSZ_S 0
#define IG3_PMAT_GLHMC_PEXFOBJSZ_PMPEXFOBJSZ_M RDMA_MASK3(32, 0xF, IG3_PMAT_GLHMC_PEXFOBJSZ_PMPEXFOBJSZ_S)
#define IG3_PMAT_GLHMC_PMATCFG 0x42807140
#define IG3_PMAT_GLHMC_PMATCFG_RSVD_S 1
#define IG3_PMAT_GLHMC_PMATCFG_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PMAT_GLHMC_PMATCFG_RSVD_S)
#define IG3_PMAT_GLHMC_PMATCFG_DISABLE_PCIE_CLK_GATING_S 0
#define IG3_PMAT_GLHMC_PMATCFG_DISABLE_PCIE_CLK_GATING_M RDMA_BIT2(32, IG3_PMAT_GLHMC_PMATCFG_DISABLE_PCIE_CLK_GATING_S)
#define IG3_PMAT_GLHMC_SDCMD 0x428071A8
#define IG3_PMAT_GLHMC_SDCMD_PMSDWR_S 31
#define IG3_PMAT_GLHMC_SDCMD_PMSDWR_M RDMA_BIT2(32, IG3_PMAT_GLHMC_SDCMD_PMSDWR_S)
#define IG3_PMAT_GLHMC_SDCMD_RSVD_S 15
#define IG3_PMAT_GLHMC_SDCMD_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PMAT_GLHMC_SDCMD_RSVD_S)
#define IG3_PMAT_GLHMC_SDCMD_PMSDIDX_S 0
#define IG3_PMAT_GLHMC_SDCMD_PMSDIDX_M RDMA_MASK3(32, 0x7FFF, IG3_PMAT_GLHMC_SDCMD_PMSDIDX_S)
#define IG3_PMAT_GLHMC_SDDATA0 0x428071AC
#define IG3_PMAT_GLHMC_SDDATA0_PMSDDATALOW_S 12
#define IG3_PMAT_GLHMC_SDDATA0_PMSDDATALOW_M RDMA_MASK3(32, 0xFFFFF, IG3_PMAT_GLHMC_SDDATA0_PMSDDATALOW_S)
#define IG3_PMAT_GLHMC_SDDATA0_PMSDBPCOUNT_S 2
#define IG3_PMAT_GLHMC_SDDATA0_PMSDBPCOUNT_M RDMA_MASK3(32, 0x3FF, IG3_PMAT_GLHMC_SDDATA0_PMSDBPCOUNT_S)
#define IG3_PMAT_GLHMC_SDDATA0_PMSDTYPE_S 1
#define IG3_PMAT_GLHMC_SDDATA0_PMSDTYPE_M RDMA_BIT2(32, IG3_PMAT_GLHMC_SDDATA0_PMSDTYPE_S)
#define IG3_PMAT_GLHMC_SDDATA0_PMSDVALID_S 0
#define IG3_PMAT_GLHMC_SDDATA0_PMSDVALID_M RDMA_BIT2(32, IG3_PMAT_GLHMC_SDDATA0_PMSDVALID_S)
#define IG3_PMAT_GLHMC_SDDATA1 0x428071B0
#define IG3_PMAT_GLHMC_SDDATA1_PMSDDATAHIGH_S 0
#define IG3_PMAT_GLHMC_SDDATA1_PMSDDATAHIGH_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PMAT_GLHMC_SDDATA1_PMSDDATAHIGH_S)
#define IG3_PMAT_GLHMC_SDDATA2 0x428071B4
#define IG3_PMAT_GLHMC_SDDATA2_RSVD0_S 25
#define IG3_PMAT_GLHMC_SDDATA2_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_PMAT_GLHMC_SDDATA2_RSVD0_S)
#define IG3_PMAT_GLHMC_SDDATA2_PMSDHOSTID_S 22
#define IG3_PMAT_GLHMC_SDDATA2_PMSDHOSTID_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_SDDATA2_PMSDHOSTID_S)
#define IG3_PMAT_GLHMC_SDDATA2_PMF_TYPE_S 20
#define IG3_PMAT_GLHMC_SDDATA2_PMF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PMAT_GLHMC_SDDATA2_PMF_TYPE_S)
#define IG3_PMAT_GLHMC_SDDATA2_VF_S 10
#define IG3_PMAT_GLHMC_SDDATA2_VF_M RDMA_MASK3(32, 0x3FF, IG3_PMAT_GLHMC_SDDATA2_VF_S)
#define IG3_PMAT_GLHMC_SDDATA2_PF_S 4
#define IG3_PMAT_GLHMC_SDDATA2_PF_M RDMA_MASK3(32, 0x3F, IG3_PMAT_GLHMC_SDDATA2_PF_S)
#define IG3_PMAT_GLHMC_SDDATA2_PMCHAN_S 3
#define IG3_PMAT_GLHMC_SDDATA2_PMCHAN_M RDMA_BIT2(32, IG3_PMAT_GLHMC_SDDATA2_PMCHAN_S)
#define IG3_PMAT_GLHMC_SDDATA2_PMSDMEM_S 0
#define IG3_PMAT_GLHMC_SDDATA2_PMSDMEM_M RDMA_MASK3(32, 0x7, IG3_PMAT_GLHMC_SDDATA2_PMSDMEM_S)
#define IG3_PMAT_GLHMC_SDMAX 0x42807218
#define IG3_PMAT_GLHMC_SDMAX_RSVD_S 16
#define IG3_PMAT_GLHMC_SDMAX_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PMAT_GLHMC_SDMAX_RSVD_S)
#define IG3_PMAT_GLHMC_SDMAX_GLHMC_SDMAX_S 0
#define IG3_PMAT_GLHMC_SDMAX_GLHMC_SDMAX_M RDMA_MASK3(32, 0xFFFF, IG3_PMAT_GLHMC_SDMAX_GLHMC_SDMAX_S)
#define IG3_PMAT_GLHMC_SDPARTTABLE(_i) 0x42804000 + ((_i) * 4) /* _i=0...3071 */
#define IG3_PMAT_GLHMC_SDPARTTABLE_MAX_INDEX_I 3071
#define IG3_PMAT_GLHMC_SDPARTTABLE_SDPTVALID_S 31
#define IG3_PMAT_GLHMC_SDPARTTABLE_SDPTVALID_M RDMA_BIT2(32, IG3_PMAT_GLHMC_SDPARTTABLE_SDPTVALID_S)
#define IG3_PMAT_GLHMC_SDPARTTABLE_RSVD_S 30
#define IG3_PMAT_GLHMC_SDPARTTABLE_RSVD_M RDMA_BIT2(32, IG3_PMAT_GLHMC_SDPARTTABLE_RSVD_S)
#define IG3_PMAT_GLHMC_SDPARTTABLE_SDPTPF_S 24
#define IG3_PMAT_GLHMC_SDPARTTABLE_SDPTPF_M RDMA_MASK3(32, 0x3F, IG3_PMAT_GLHMC_SDPARTTABLE_SDPTPF_S)
#define IG3_PMAT_GLHMC_SDPARTTABLE_SDPTPMF_S 12
#define IG3_PMAT_GLHMC_SDPARTTABLE_SDPTPMF_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_GLHMC_SDPARTTABLE_SDPTPMF_S)
#define IG3_PMAT_GLHMC_SDPARTTABLE_SDPTBASE_S 0
#define IG3_PMAT_GLHMC_SDPARTTABLE_SDPTBASE_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_GLHMC_SDPARTTABLE_SDPTBASE_S)
#define IG3_PMAT_GLHMC_SPDT_LKUP_CMD 0x428071BC
#define IG3_PMAT_GLHMC_SPDT_LKUP_CMD_SDPTLKVLD_S 31
#define IG3_PMAT_GLHMC_SPDT_LKUP_CMD_SDPTLKVLD_M RDMA_BIT2(32, IG3_PMAT_GLHMC_SPDT_LKUP_CMD_SDPTLKVLD_S)
#define IG3_PMAT_GLHMC_SPDT_LKUP_CMD_RSVD1_S 30
#define IG3_PMAT_GLHMC_SPDT_LKUP_CMD_RSVD1_M RDMA_BIT2(32, IG3_PMAT_GLHMC_SPDT_LKUP_CMD_RSVD1_S)
#define IG3_PMAT_GLHMC_SPDT_LKUP_CMD_SDPTLKPF_S 24
#define IG3_PMAT_GLHMC_SPDT_LKUP_CMD_SDPTLKPF_M RDMA_MASK3(32, 0x3F, IG3_PMAT_GLHMC_SPDT_LKUP_CMD_SDPTLKPF_S)
#define IG3_PMAT_GLHMC_SPDT_LKUP_CMD_SDPTLKPMF_S 12
#define IG3_PMAT_GLHMC_SPDT_LKUP_CMD_SDPTLKPMF_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_GLHMC_SPDT_LKUP_CMD_SDPTLKPMF_S)
#define IG3_PMAT_GLHMC_SPDT_LKUP_CMD_SDPTLKBASE_S 0
#define IG3_PMAT_GLHMC_SPDT_LKUP_CMD_SDPTLKBASE_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_GLHMC_SPDT_LKUP_CMD_SDPTLKBASE_S)
#define IG3_PMAT_GLHMC_SPDT_LKUP_STATUS 0x428071C0
#define IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_RSVD1_S 16
#define IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_RSVD1_M RDMA_MASK3(32, 0xFFFF, IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_RSVD1_S)
#define IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_SDPTINDEX_S 4
#define IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_SDPTINDEX_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_SDPTINDEX_S)
#define IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_RSVD0_S 2
#define IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_RSVD0_S)
#define IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_HIT_S 1
#define IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_HIT_M RDMA_BIT2(32, IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_HIT_S)
#define IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_VLD_S 0
#define IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_VLD_M RDMA_BIT2(32, IG3_PMAT_GLHMC_SPDT_LKUP_STATUS_VLD_S)
#define IG3_PMAT_GLPE_PMAT_XLR_ZERO 0x42807204
#define IG3_PMAT_GLPE_PMAT_XLR_ZERO_RSVD0_S 12
#define IG3_PMAT_GLPE_PMAT_XLR_ZERO_RSVD0_M RDMA_MASK3(32, 0xFFFFF, IG3_PMAT_GLPE_PMAT_XLR_ZERO_RSVD0_S)
#define IG3_PMAT_GLPE_PMAT_XLR_ZERO_PMF_S 0
#define IG3_PMAT_GLPE_PMAT_XLR_ZERO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_GLPE_PMAT_XLR_ZERO_PMF_S)
#define IG3_PMAT_GLPE_PMAT_XLR_ZERO_STATUS 0x42807208
#define IG3_PMAT_GLPE_PMAT_XLR_ZERO_STATUS_DONE_S 31
#define IG3_PMAT_GLPE_PMAT_XLR_ZERO_STATUS_DONE_M RDMA_BIT2(32, IG3_PMAT_GLPE_PMAT_XLR_ZERO_STATUS_DONE_S)
#define IG3_PMAT_GLPE_PMAT_XLR_ZERO_STATUS_RSVD0_S 12
#define IG3_PMAT_GLPE_PMAT_XLR_ZERO_STATUS_RSVD0_M RDMA_MASK3(32, 0x7FFFF, IG3_PMAT_GLPE_PMAT_XLR_ZERO_STATUS_RSVD0_S)
#define IG3_PMAT_GLPE_PMAT_XLR_ZERO_STATUS_PMF_S 0
#define IG3_PMAT_GLPE_PMAT_XLR_ZERO_STATUS_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_GLPE_PMAT_XLR_ZERO_STATUS_PMF_S)
#define IG3_PMAT_PFHMC_ERRORDATA(_i) 0x42800100 + ((_i) * 4) /* _i=0...15 */
#define IG3_PMAT_PFHMC_ERRORDATA_MAX_INDEX_I 15
#define IG3_PMAT_PFHMC_ERRORDATA_RSVD_S 30
#define IG3_PMAT_PFHMC_ERRORDATA_RSVD_M RDMA_MASK3(32, 0x3, IG3_PMAT_PFHMC_ERRORDATA_RSVD_S)
#define IG3_PMAT_PFHMC_ERRORDATA_HMC_ERROR_DATA_S 0
#define IG3_PMAT_PFHMC_ERRORDATA_HMC_ERROR_DATA_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_PMAT_PFHMC_ERRORDATA_HMC_ERROR_DATA_S)
#define IG3_PMAT_PFHMC_ERRORINFO(_i) 0x42800000 + ((_i) * 4) /* _i=0...15 */
#define IG3_PMAT_PFHMC_ERRORINFO_MAX_INDEX_I 15
#define IG3_PMAT_PFHMC_ERRORINFO_ERROR_DETECTED_S 31
#define IG3_PMAT_PFHMC_ERRORINFO_ERROR_DETECTED_M RDMA_BIT2(32, IG3_PMAT_PFHMC_ERRORINFO_ERROR_DETECTED_S)
#define IG3_PMAT_PFHMC_ERRORINFO_RSVD2_S 25
#define IG3_PMAT_PFHMC_ERRORINFO_RSVD2_M RDMA_MASK3(32, 0x3F, IG3_PMAT_PFHMC_ERRORINFO_RSVD2_S)
#define IG3_PMAT_PFHMC_ERRORINFO_HMC_OBJECT_TYPE_S 20
#define IG3_PMAT_PFHMC_ERRORINFO_HMC_OBJECT_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PFHMC_ERRORINFO_HMC_OBJECT_TYPE_S)
#define IG3_PMAT_PFHMC_ERRORINFO_HMC_ERROR_TYPE_S 16
#define IG3_PMAT_PFHMC_ERRORINFO_HMC_ERROR_TYPE_M RDMA_MASK3(32, 0xF, IG3_PMAT_PFHMC_ERRORINFO_HMC_ERROR_TYPE_S)
#define IG3_PMAT_PFHMC_ERRORINFO_RSVD1_S 13
#define IG3_PMAT_PFHMC_ERRORINFO_RSVD1_M RDMA_MASK3(32, 0x7, IG3_PMAT_PFHMC_ERRORINFO_RSVD1_S)
#define IG3_PMAT_PFHMC_ERRORINFO_PMF_ISVF_S 12
#define IG3_PMAT_PFHMC_ERRORINFO_PMF_ISVF_M RDMA_BIT2(32, IG3_PMAT_PFHMC_ERRORINFO_PMF_ISVF_S)
#define IG3_PMAT_PFHMC_ERRORINFO_PMF_INDEX_S 0
#define IG3_PMAT_PFHMC_ERRORINFO_PMF_INDEX_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_PFHMC_ERRORINFO_PMF_INDEX_S)
#define IG3_PMAT_PMAT_ECC_COR_ERR 0x4285B09C
#define IG3_PMAT_PMAT_ECC_COR_ERR_RSVD_S 12
#define IG3_PMAT_PMAT_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PMAT_PMAT_ECC_COR_ERR_RSVD_S)
#define IG3_PMAT_PMAT_ECC_COR_ERR_CNT_S 0
#define IG3_PMAT_PMAT_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_PMAT_ECC_COR_ERR_CNT_S)
#define IG3_PMAT_PMAT_ECC_UNCOR_ERR 0x4285B098
#define IG3_PMAT_PMAT_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PMAT_PMAT_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PMAT_PMAT_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PMAT_PMAT_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PMAT_PMAT_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_PMAT_ECC_UNCOR_ERR_CNT_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG 0x4285B068
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RSVD1_S 10
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RSVD1_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS 0x4285B06C
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CMPL_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG 0x4285B070
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RSVD1_S 10
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RSVD1_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CQ_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS 0x4285B074
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA0_CQ_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG 0x4285B078
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RSVD1_S 10
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RSVD1_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS 0x4285B07C
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CMPL_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG 0x4285B080
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RSVD1_S 10
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RSVD1_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CQ_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS 0x4285B084
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_LOCA1_CQ_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG 0x4285B028
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RSVD1_S 10
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RSVD1_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BASE_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS 0x4285B02C
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BASE_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG 0x4285B030
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RSVD1_S 10
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RSVD1_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BNDS_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS 0x4285B034
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BNDS_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG 0x4285B040
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RSVD1_S 10
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RSVD1_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS 0x4285B044
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_LNK_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG 0x4285B038
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RSVD1_S 10
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RSVD1_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS 0x4285B03C
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_OBJ_BP_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG 0x4285B088
#define IG3_PMAT_PMAT_PASID_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_PASID_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_PASID_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_PASID_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_PASID_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_PASID_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_PASID_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_PASID_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PASID_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_PASID_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_PASID_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_PASID_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_PASID_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_RSVD1_S 10
#define IG3_PMAT_PMAT_PASID_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PASID_MEM_CFG_RSVD1_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_PASID_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PASID_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_PASID_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PASID_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_PASID_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PASID_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_PASID_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PASID_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_PASID_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_PASID_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_PASID_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PASID_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_PASID_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_PASID_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_PASID_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_PASID_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_PASID_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_PASID_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_PASID_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_PASID_MEM_STATUS 0x4285B08C
#define IG3_PMAT_PMAT_PASID_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_PASID_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PASID_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_PASID_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_PASID_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_PASID_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_PASID_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_PASID_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_PASID_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_PASID_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_PASID_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PASID_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_PASID_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_PASID_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PASID_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_PASID_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_PASID_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_PASID_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_PASID_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_PASID_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_PASID_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG 0x4285B058
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RSVD1_S 10
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RSVD1_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CMPL_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS 0x4285B05C
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CMPL_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_PMAT_PCIE_CMP_NRDY_CNT 0x42807200
#define IG3_PMAT_PMAT_PCIE_CMP_NRDY_CNT_PCIECMPNRDYCNT_S 0
#define IG3_PMAT_PMAT_PCIE_CMP_NRDY_CNT_PCIECMPNRDYCNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PMAT_PMAT_PCIE_CMP_NRDY_CNT_PCIECMPNRDYCNT_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG 0x4285B060
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RSVD1_S 10
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RSVD1_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CQ_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS 0x4285B064
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_CQ_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG 0x4285B048
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RSVD1_S 10
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RSVD1_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS 0x4285B04C
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_DAT_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG 0x4285B050
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RSVD1_S 10
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RSVD1_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS 0x4285B054
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_PCIE_NAK_HDR_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG 0x4285B020
#define IG3_PMAT_PMAT_ST_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_ST_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_ST_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_ST_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_ST_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_ST_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_ST_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_ST_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_ST_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_ST_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_ST_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_ST_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_ST_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_RSVD1_S 10
#define IG3_PMAT_PMAT_ST_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_ST_MEM_CFG_RSVD1_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_ST_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_ST_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_ST_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_ST_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_ST_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_ST_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_ST_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_ST_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_ST_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_ST_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_ST_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_ST_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_ST_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_ST_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_ST_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_ST_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_ST_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_ST_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_ST_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_ST_MEM_STATUS 0x4285B024
#define IG3_PMAT_PMAT_ST_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_ST_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_ST_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_ST_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_ST_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_ST_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_ST_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_ST_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_ST_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_ST_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_ST_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_ST_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_ST_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_ST_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_ST_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_ST_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_ST_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_ST_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_ST_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_ST_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_ST_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG 0x4285B090
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_PMAT_TCAM_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_RSVD3_S 20
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_PMAT_TCAM_MEM_CFG_RSVD3_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_RM_S 16
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_PMAT_TCAM_MEM_CFG_RM_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_RSVD2_S 14
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_TCAM_MEM_CFG_RSVD2_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_RME_S 12
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_CFG_RME_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_UPDATE_DISABLE_S 11
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_UPDATE_DISABLE_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_CFG_UPDATE_DISABLE_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_CHECK_ERR_DISABLE_S 10
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_CHECK_ERR_DISABLE_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_CFG_CHECK_ERR_DISABLE_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_ERR_CNT_S 9
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_CFG_ERR_CNT_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_FIX_CNT_S 8
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_CFG_FIX_CNT_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_RSVD0_S 6
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_TCAM_MEM_CFG_RSVD0_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_MASK_INT_S 5
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_CFG_MASK_INT_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_LS_BYPASS_S 4
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_CFG_LS_BYPASS_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_LS_FORCE_S 3
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_CFG_LS_FORCE_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_ECC_EN_S 0
#define IG3_PMAT_PMAT_TCAM_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_CFG_ECC_EN_S)
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS 0x4285B094
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS_RSVD1_S 30
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_PMAT_TCAM_MEM_STATUS_RSVD1_S)
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_PMAT_TCAM_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS_RSVD0_S 4
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_PMAT_TCAM_MEM_STATUS_RSVD0_S)
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS_INIT_DONE_S 2
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_STATUS_INIT_DONE_S)
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS_ECC_FIX_S 1
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_STATUS_ECC_FIX_S)
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS_ECC_ERR_S 0
#define IG3_PMAT_PMAT_TCAM_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_PMAT_TCAM_MEM_STATUS_ECC_ERR_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_COUNT 0x42880038
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_CMD 0x4288004C
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_DATA_H 0x42880058
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_DATA_L 0x42880054
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_PTR 0x42880050
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_CMD 0x4288003C
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_DATA_H 0x42880048
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_DATA_L 0x42880044
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_PTR 0x42880040
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL 0x42880000
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_RSVD1_S 25
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_RSVD1_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_RSVD2_S 17
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_RSVD2_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_RSVD3_S 9
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_RSVD3_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_BYPASS_S 8
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_BYPASS_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_RSVD4_S 1
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_RSVD4_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_ECC_COR_ERR 0x42880068
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_ECC_UNCOR_ERR 0x42880064
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_GROUP_CFG 0x4288000C
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_CFG 0x42880010
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_CFG_RSVD1_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_CFG_MODE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_CFG_MODE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_MASK 0x42880018
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_MASK_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_MASK_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_PATTERN 0x42880014
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG 0x42880004
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_STS 0x42880008
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_STS_RSVD1_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_STS_RSVD2_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TIMESTAMP 0x42880030
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_TIMESTAMP_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TIMESTAMP_ROLLOVER 0x42880034
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG 0x4288005C
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS 0x42880060
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG 0x4288001C
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_MODE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_CFG_MODE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_COUNT 0x42880028
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_MASK 0x42880024
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_MASK_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_PATTERN 0x42880020
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_TIMESTAMP 0x4288002C
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PMAT_DTM_GLPE_PMAT_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PDOC_GLPDOC_CACHESIZE 0x42880480
#define IG3_PDOC_GLPDOC_CACHESIZE_RSVD_S 24
#define IG3_PDOC_GLPDOC_CACHESIZE_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHESIZE_RSVD_S)
#define IG3_PDOC_GLPDOC_CACHESIZE_WAYS_S 20
#define IG3_PDOC_GLPDOC_CACHESIZE_WAYS_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHESIZE_WAYS_S)
#define IG3_PDOC_GLPDOC_CACHESIZE_SETS_S 8
#define IG3_PDOC_GLPDOC_CACHESIZE_SETS_M RDMA_MASK3(32, 0xFFF, IG3_PDOC_GLPDOC_CACHESIZE_SETS_S)
#define IG3_PDOC_GLPDOC_CACHESIZE_WORD_SIZE_S 0
#define IG3_PDOC_GLPDOC_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHESIZE_WORD_SIZE_S)
#define IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL 0x4288050C
#define IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_DONE_S 31
#define IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_RD_EN_S 30
#define IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_RD_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_RSVD_S 26
#define IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_RSVD_S)
#define IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_DW_SEL_S 18
#define IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_DW_SEL_S)
#define IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_ADR_S 0
#define IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_0_DBG_CTL_ADR_S)
#define IG3_PDOC_GLPDOC_CACHE_0_DBG_DATA 0x42880510
#define IG3_PDOC_GLPDOC_CACHE_0_DBG_DATA_RD_DW_S 0
#define IG3_PDOC_GLPDOC_CACHE_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_CACHE_0_DBG_DATA_RD_DW_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG 0x428804C4
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RSVD3_S 20
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RM_S 16
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RM_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RSVD2_S 14
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RME_S 12
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RME_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RSVD1_S 10
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ERR_CNT_S 9
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_FIX_CNT_S 8
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_FIX_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RSVD0_S 6
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_MASK_INT_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_LS_BYPASS_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_LS_FORCE_S 3
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_LS_FORCE_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_MEM_CFG_ECC_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS 0x428804C8
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_RSVD1_S 30
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_RSVD0_S 4
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_ECC_FIX_S)
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_0_MEM_STATUS_ECC_ERR_S)
#define IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL 0x42880514
#define IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_DONE_S 31
#define IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_RD_EN_S 30
#define IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_RD_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_RSVD_S 26
#define IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_RSVD_S)
#define IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_DW_SEL_S 18
#define IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_DW_SEL_S)
#define IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_ADR_S 0
#define IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_1_DBG_CTL_ADR_S)
#define IG3_PDOC_GLPDOC_CACHE_1_DBG_DATA 0x42880518
#define IG3_PDOC_GLPDOC_CACHE_1_DBG_DATA_RD_DW_S 0
#define IG3_PDOC_GLPDOC_CACHE_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_CACHE_1_DBG_DATA_RD_DW_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG 0x428804CC
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RSVD3_S 20
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RM_S 16
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RM_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RSVD2_S 14
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RME_S 12
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RME_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RSVD1_S 10
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ERR_CNT_S 9
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_FIX_CNT_S 8
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_FIX_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RSVD0_S 6
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_MASK_INT_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_LS_BYPASS_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_LS_FORCE_S 3
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_LS_FORCE_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_MEM_CFG_ECC_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS 0x428804D0
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_RSVD1_S 30
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_RSVD0_S 4
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_ECC_FIX_S)
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_1_MEM_STATUS_ECC_ERR_S)
#define IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL 0x4288051C
#define IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_DONE_S 31
#define IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_RD_EN_S 30
#define IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_RD_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_RSVD_S 26
#define IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_RSVD_S)
#define IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_DW_SEL_S 18
#define IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_DW_SEL_S)
#define IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_ADR_S 0
#define IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_2_DBG_CTL_ADR_S)
#define IG3_PDOC_GLPDOC_CACHE_2_DBG_DATA 0x42880520
#define IG3_PDOC_GLPDOC_CACHE_2_DBG_DATA_RD_DW_S 0
#define IG3_PDOC_GLPDOC_CACHE_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_CACHE_2_DBG_DATA_RD_DW_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG 0x428804D4
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RSVD3_S 20
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RM_S 16
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RM_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RSVD2_S 14
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RME_S 12
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RME_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RSVD1_S 10
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ERR_CNT_S 9
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_FIX_CNT_S 8
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_FIX_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RSVD0_S 6
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_MASK_INT_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_LS_BYPASS_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_LS_FORCE_S 3
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_LS_FORCE_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_MEM_CFG_ECC_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS 0x428804D8
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_RSVD1_S 30
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_RSVD0_S 4
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_ECC_FIX_S)
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_2_MEM_STATUS_ECC_ERR_S)
#define IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL 0x42880524
#define IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_DONE_S 31
#define IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_RD_EN_S 30
#define IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_RD_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_RSVD_S 26
#define IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_RSVD_S)
#define IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_DW_SEL_S 18
#define IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_DW_SEL_S)
#define IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_ADR_S 0
#define IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_3_DBG_CTL_ADR_S)
#define IG3_PDOC_GLPDOC_CACHE_3_DBG_DATA 0x42880528
#define IG3_PDOC_GLPDOC_CACHE_3_DBG_DATA_RD_DW_S 0
#define IG3_PDOC_GLPDOC_CACHE_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_CACHE_3_DBG_DATA_RD_DW_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG 0x428804DC
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RSVD3_S 20
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RM_S 16
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RM_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RSVD2_S 14
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RME_S 12
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RME_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RSVD1_S 10
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ERR_CNT_S 9
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_FIX_CNT_S 8
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_FIX_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RSVD0_S 6
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_MASK_INT_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_LS_BYPASS_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_LS_FORCE_S 3
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_LS_FORCE_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_MEM_CFG_ECC_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS 0x428804E0
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_RSVD1_S 30
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_RSVD0_S 4
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_ECC_FIX_S)
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_3_MEM_STATUS_ECC_ERR_S)
#define IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL 0x4288052C
#define IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_DONE_S 31
#define IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_RD_EN_S 30
#define IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_RD_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_RSVD_S 26
#define IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_RSVD_S)
#define IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_DW_SEL_S 18
#define IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_DW_SEL_S)
#define IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_ADR_S 0
#define IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_4_DBG_CTL_ADR_S)
#define IG3_PDOC_GLPDOC_CACHE_4_DBG_DATA 0x42880530
#define IG3_PDOC_GLPDOC_CACHE_4_DBG_DATA_RD_DW_S 0
#define IG3_PDOC_GLPDOC_CACHE_4_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_CACHE_4_DBG_DATA_RD_DW_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG 0x428804E4
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RSVD3_S 20
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RM_S 16
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RM_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RSVD2_S 14
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RME_S 12
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RME_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RSVD1_S 10
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ERR_CNT_S 9
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_FIX_CNT_S 8
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_FIX_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RSVD0_S 6
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_MASK_INT_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_LS_BYPASS_S 4
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_LS_BYPASS_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_LS_FORCE_S 3
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_LS_FORCE_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_MEM_CFG_ECC_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS 0x428804E8
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_RSVD1_S 30
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_RSVD0_S 4
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_INIT_DONE_S 2
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_ECC_FIX_S 1
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_ECC_FIX_S)
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_ECC_ERR_S 0
#define IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_4_MEM_STATUS_ECC_ERR_S)
#define IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL 0x42880534
#define IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_DONE_S 31
#define IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_RD_EN_S 30
#define IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_RD_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_RSVD_S 26
#define IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_RSVD_S)
#define IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_DW_SEL_S 18
#define IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_DW_SEL_S)
#define IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_ADR_S 0
#define IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_5_DBG_CTL_ADR_S)
#define IG3_PDOC_GLPDOC_CACHE_5_DBG_DATA 0x42880538
#define IG3_PDOC_GLPDOC_CACHE_5_DBG_DATA_RD_DW_S 0
#define IG3_PDOC_GLPDOC_CACHE_5_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_CACHE_5_DBG_DATA_RD_DW_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG 0x428804EC
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RSVD3_S 20
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RM_S 16
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RM_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RSVD2_S 14
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RME_S 12
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RME_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RSVD1_S 10
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ERR_CNT_S 9
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_FIX_CNT_S 8
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_FIX_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RSVD0_S 6
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_MASK_INT_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_LS_BYPASS_S 4
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_LS_BYPASS_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_LS_FORCE_S 3
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_LS_FORCE_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_MEM_CFG_ECC_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS 0x428804F0
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_RSVD1_S 30
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_RSVD0_S 4
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_INIT_DONE_S 2
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_ECC_FIX_S 1
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_ECC_FIX_S)
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_ECC_ERR_S 0
#define IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_5_MEM_STATUS_ECC_ERR_S)
#define IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL 0x4288053C
#define IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_DONE_S 31
#define IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_RD_EN_S 30
#define IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_RD_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_RSVD_S 26
#define IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_RSVD_S)
#define IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_DW_SEL_S 18
#define IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_DW_SEL_S)
#define IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_ADR_S 0
#define IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_6_DBG_CTL_ADR_S)
#define IG3_PDOC_GLPDOC_CACHE_6_DBG_DATA 0x42880540
#define IG3_PDOC_GLPDOC_CACHE_6_DBG_DATA_RD_DW_S 0
#define IG3_PDOC_GLPDOC_CACHE_6_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_CACHE_6_DBG_DATA_RD_DW_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG 0x428804F4
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RSVD3_S 20
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RM_S 16
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RM_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RSVD2_S 14
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RME_S 12
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RME_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RSVD1_S 10
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ERR_CNT_S 9
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_FIX_CNT_S 8
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_FIX_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RSVD0_S 6
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_MASK_INT_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_LS_BYPASS_S 4
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_LS_BYPASS_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_LS_FORCE_S 3
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_LS_FORCE_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_MEM_CFG_ECC_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS 0x428804F8
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_RSVD1_S 30
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_RSVD0_S 4
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_INIT_DONE_S 2
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_ECC_FIX_S 1
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_ECC_FIX_S)
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_ECC_ERR_S 0
#define IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_6_MEM_STATUS_ECC_ERR_S)
#define IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL 0x42880544
#define IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_DONE_S 31
#define IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_RD_EN_S 30
#define IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_RD_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_RSVD_S 26
#define IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_RSVD_S)
#define IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_DW_SEL_S 18
#define IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_DW_SEL_S)
#define IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_ADR_S 0
#define IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_7_DBG_CTL_ADR_S)
#define IG3_PDOC_GLPDOC_CACHE_7_DBG_DATA 0x42880548
#define IG3_PDOC_GLPDOC_CACHE_7_DBG_DATA_RD_DW_S 0
#define IG3_PDOC_GLPDOC_CACHE_7_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_CACHE_7_DBG_DATA_RD_DW_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG 0x428804FC
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RSVD3_S 20
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RM_S 16
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RM_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RSVD2_S 14
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RME_S 12
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RME_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RSVD1_S 10
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ERR_CNT_S 9
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_FIX_CNT_S 8
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_FIX_CNT_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RSVD0_S 6
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_MASK_INT_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_LS_BYPASS_S 4
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_LS_BYPASS_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_LS_FORCE_S 3
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_LS_FORCE_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_MEM_CFG_ECC_EN_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS 0x42880500
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_RSVD1_S 30
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_RSVD1_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_RSVD0_S 4
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_RSVD0_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_INIT_DONE_S 2
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_ECC_FIX_S 1
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_ECC_FIX_S)
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_ECC_ERR_S 0
#define IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CACHE_7_MEM_STATUS_ECC_ERR_S)
#define IG3_PDOC_GLPDOC_CACHE_CTRL 0x42880400
#define IG3_PDOC_GLPDOC_CACHE_CTRL_RSVD_S 2
#define IG3_PDOC_GLPDOC_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_PDOC_GLPDOC_CACHE_CTRL_RSVD_S)
#define IG3_PDOC_GLPDOC_CACHE_CTRL_SCALE_FACTOR_S 0
#define IG3_PDOC_GLPDOC_CACHE_CTRL_SCALE_FACTOR_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_CACHE_CTRL_SCALE_FACTOR_S)
#define IG3_PDOC_GLPDOC_CECC_ERR 0x42880470
#define IG3_PDOC_GLPDOC_CECC_ERR_RSVD1_S 28
#define IG3_PDOC_GLPDOC_CECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CECC_ERR_RSVD1_S)
#define IG3_PDOC_GLPDOC_CECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PDOC_GLPDOC_CECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PDOC_GLPDOC_CECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_CECC_ERR_RSVD0_S 12
#define IG3_PDOC_GLPDOC_CECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_CECC_ERR_RSVD0_S)
#define IG3_PDOC_GLPDOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PDOC_GLPDOC_CECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PDOC_GLPDOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_CSTATELKUP_CFG 0x42880478
#define IG3_PDOC_GLPDOC_CSTATELKUP_CFG_RSVD1_S 9
#define IG3_PDOC_GLPDOC_CSTATELKUP_CFG_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PDOC_GLPDOC_CSTATELKUP_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S 8
#define IG3_PDOC_GLPDOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S)
#define IG3_PDOC_GLPDOC_CSTATELKUP_CFG_RSVD0_S 3
#define IG3_PDOC_GLPDOC_CSTATELKUP_CFG_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_CSTATELKUP_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S 0
#define IG3_PDOC_GLPDOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_M RDMA_MASK3(32, 0x7, IG3_PDOC_GLPDOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S)
#define IG3_PDOC_GLPDOC_DPC_COMP 0x42880488
#define IG3_PDOC_GLPDOC_DPC_COMP_RSVD_S 13
#define IG3_PDOC_GLPDOC_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PDOC_GLPDOC_DPC_COMP_RSVD_S)
#define IG3_PDOC_GLPDOC_DPC_COMP_COMP_FTYPE_S 11
#define IG3_PDOC_GLPDOC_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_DPC_COMP_COMP_FTYPE_S)
#define IG3_PDOC_GLPDOC_DPC_COMP_COMP_FNUM_S 1
#define IG3_PDOC_GLPDOC_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PDOC_GLPDOC_DPC_COMP_COMP_FNUM_S)
#define IG3_PDOC_GLPDOC_DPC_COMP_COMP_VALID_S 0
#define IG3_PDOC_GLPDOC_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DPC_COMP_COMP_VALID_S)
#define IG3_PDOC_GLPDOC_DPC_REQ 0x42880484
#define IG3_PDOC_GLPDOC_DPC_REQ_RSVD_S 12
#define IG3_PDOC_GLPDOC_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PDOC_GLPDOC_DPC_REQ_RSVD_S)
#define IG3_PDOC_GLPDOC_DPC_REQ_REQ_FTYPE_S 10
#define IG3_PDOC_GLPDOC_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_DPC_REQ_REQ_FTYPE_S)
#define IG3_PDOC_GLPDOC_DPC_REQ_REQ_FNUM_S 0
#define IG3_PDOC_GLPDOC_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PDOC_GLPDOC_DPC_REQ_REQ_FNUM_S)
#define IG3_PDOC_GLPDOC_DTM_BUFFER_COUNT 0x428805B8
#define IG3_PDOC_GLPDOC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PDOC_GLPDOC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PDOC_GLPDOC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PDOC_GLPDOC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PDOC_GLPDOC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_CMD 0x428805CC
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PDOC_GLPDOC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_DATA_H 0x428805D8
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_DATA_L 0x428805D4
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_PTR 0x428805D0
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PDOC_GLPDOC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PDOC_GLPDOC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_CMD 0x428805BC
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PDOC_GLPDOC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_DATA_H 0x428805C8
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_DATA_L 0x428805C4
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_PTR 0x428805C0
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PDOC_GLPDOC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PDOC_GLPDOC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_CONTROL 0x42880580
#define IG3_PDOC_GLPDOC_DTM_CONTROL_RSVD1_S 25
#define IG3_PDOC_GLPDOC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_DTM_CONTROL_RSVD1_S)
#define IG3_PDOC_GLPDOC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PDOC_GLPDOC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PDOC_GLPDOC_DTM_CONTROL_RSVD2_S 17
#define IG3_PDOC_GLPDOC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_DTM_CONTROL_RSVD2_S)
#define IG3_PDOC_GLPDOC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PDOC_GLPDOC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PDOC_GLPDOC_DTM_CONTROL_RSVD3_S 9
#define IG3_PDOC_GLPDOC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_DTM_CONTROL_RSVD3_S)
#define IG3_PDOC_GLPDOC_DTM_CONTROL_BYPASS_S 8
#define IG3_PDOC_GLPDOC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_CONTROL_BYPASS_S)
#define IG3_PDOC_GLPDOC_DTM_CONTROL_RSVD4_S 1
#define IG3_PDOC_GLPDOC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_DTM_CONTROL_RSVD4_S)
#define IG3_PDOC_GLPDOC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PDOC_GLPDOC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PDOC_GLPDOC_DTM_ECC_COR_ERR 0x428805E8
#define IG3_PDOC_GLPDOC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PDOC_GLPDOC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PDOC_GLPDOC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PDOC_GLPDOC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PDOC_GLPDOC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PDOC_GLPDOC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_DTM_ECC_UNCOR_ERR 0x428805E4
#define IG3_PDOC_GLPDOC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PDOC_GLPDOC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PDOC_GLPDOC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PDOC_GLPDOC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PDOC_GLPDOC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PDOC_GLPDOC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_DTM_GROUP_CFG 0x4288058C
#define IG3_PDOC_GLPDOC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PDOC_GLPDOC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PDOC_GLPDOC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PDOC_GLPDOC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PDOC_GLPDOC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PDOC_GLPDOC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PDOC_GLPDOC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PDOC_GLPDOC_DTM_LOG_CFG 0x42880590
#define IG3_PDOC_GLPDOC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PDOC_GLPDOC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PDOC_GLPDOC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PDOC_GLPDOC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PDOC_GLPDOC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PDOC_GLPDOC_DTM_LOG_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_DTM_LOG_CFG_MODE_S 0
#define IG3_PDOC_GLPDOC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_DTM_LOG_CFG_MODE_S)
#define IG3_PDOC_GLPDOC_DTM_LOG_MASK 0x42880598
#define IG3_PDOC_GLPDOC_DTM_LOG_MASK_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_DTM_LOG_MASK_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_LOG_PATTERN 0x42880594
#define IG3_PDOC_GLPDOC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_MAIN_CFG 0x42880584
#define IG3_PDOC_GLPDOC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PDOC_GLPDOC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PDOC_GLPDOC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PDOC_GLPDOC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PDOC_GLPDOC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PDOC_GLPDOC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PDOC_GLPDOC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PDOC_GLPDOC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PDOC_GLPDOC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PDOC_GLPDOC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PDOC_GLPDOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PDOC_GLPDOC_DTM_MAIN_STS 0x42880588
#define IG3_PDOC_GLPDOC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PDOC_GLPDOC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PDOC_GLPDOC_DTM_MAIN_STS_RSVD1_S)
#define IG3_PDOC_GLPDOC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PDOC_GLPDOC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PDOC_GLPDOC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PDOC_GLPDOC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_DTM_MAIN_STS_RSVD2_S)
#define IG3_PDOC_GLPDOC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PDOC_GLPDOC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PDOC_GLPDOC_DTM_TIMESTAMP 0x428805B0
#define IG3_PDOC_GLPDOC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_DTM_TIMESTAMP_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_TIMESTAMP_ROLLOVER 0x428805B4
#define IG3_PDOC_GLPDOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG 0x428805DC
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS 0x428805E0
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PDOC_GLPDOC_DTM_TRIG_CFG 0x4288059C
#define IG3_PDOC_GLPDOC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PDOC_GLPDOC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PDOC_GLPDOC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PDOC_GLPDOC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PDOC_GLPDOC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PDOC_GLPDOC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PDOC_GLPDOC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_DTM_TRIG_CFG_MODE_S 0
#define IG3_PDOC_GLPDOC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_DTM_TRIG_CFG_MODE_S)
#define IG3_PDOC_GLPDOC_DTM_TRIG_COUNT 0x428805A8
#define IG3_PDOC_GLPDOC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_TRIG_MASK 0x428805A4
#define IG3_PDOC_GLPDOC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_DTM_TRIG_MASK_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_TRIG_PATTERN 0x428805A0
#define IG3_PDOC_GLPDOC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PDOC_GLPDOC_DTM_TRIG_TIMESTAMP 0x428805AC
#define IG3_PDOC_GLPDOC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PDOC_GLPDOC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PDOC_GLPDOC_ECC_CTL 0x4288046C
#define IG3_PDOC_GLPDOC_ECC_CTL_RSVD_S 8
#define IG3_PDOC_GLPDOC_ECC_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PDOC_GLPDOC_ECC_CTL_RSVD_S)
#define IG3_PDOC_GLPDOC_ECC_CTL_CLIENT_ECC_INVERT2_S 7
#define IG3_PDOC_GLPDOC_ECC_CTL_CLIENT_ECC_INVERT2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_ECC_CTL_CLIENT_ECC_INVERT2_S)
#define IG3_PDOC_GLPDOC_ECC_CTL_CLIENT_ECC_INVERT1_S 6
#define IG3_PDOC_GLPDOC_ECC_CTL_CLIENT_ECC_INVERT1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_ECC_CTL_CLIENT_ECC_INVERT1_S)
#define IG3_PDOC_GLPDOC_ECC_CTL_CLIENT_ECC_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_ECC_CTL_CLIENT_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_ECC_CTL_CLIENT_ECC_MASK_INT_S)
#define IG3_PDOC_GLPDOC_ECC_CTL_CLIENT_ECC_EN_S 4
#define IG3_PDOC_GLPDOC_ECC_CTL_CLIENT_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_ECC_CTL_CLIENT_ECC_EN_S)
#define IG3_PDOC_GLPDOC_ECC_CTL_HOST_ECC_INVERT2_S 3
#define IG3_PDOC_GLPDOC_ECC_CTL_HOST_ECC_INVERT2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_ECC_CTL_HOST_ECC_INVERT2_S)
#define IG3_PDOC_GLPDOC_ECC_CTL_HOST_ECC_INVERT1_S 2
#define IG3_PDOC_GLPDOC_ECC_CTL_HOST_ECC_INVERT1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_ECC_CTL_HOST_ECC_INVERT1_S)
#define IG3_PDOC_GLPDOC_ECC_CTL_HOST_ECC_MASK_INT_S 1
#define IG3_PDOC_GLPDOC_ECC_CTL_HOST_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_ECC_CTL_HOST_ECC_MASK_INT_S)
#define IG3_PDOC_GLPDOC_ECC_CTL_HOST_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_ECC_CTL_HOST_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_ECC_CTL_HOST_ECC_EN_S)
#define IG3_PDOC_GLPDOC_ERRDATA0 0x4288045C
#define IG3_PDOC_GLPDOC_ERRDATA0_RSVD1_S 31
#define IG3_PDOC_GLPDOC_ERRDATA0_RSVD1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_ERRDATA0_RSVD1_S)
#define IG3_PDOC_GLPDOC_ERRDATA0_PF_NUM_S 25
#define IG3_PDOC_GLPDOC_ERRDATA0_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PDOC_GLPDOC_ERRDATA0_PF_NUM_S)
#define IG3_PDOC_GLPDOC_ERRDATA0_VDEV_VF_NUM_S 15
#define IG3_PDOC_GLPDOC_ERRDATA0_VDEV_VF_NUM_M RDMA_MASK3(32, 0x3FF, IG3_PDOC_GLPDOC_ERRDATA0_VDEV_VF_NUM_S)
#define IG3_PDOC_GLPDOC_ERRDATA0_VDEV_VF_TYPE_S 13
#define IG3_PDOC_GLPDOC_ERRDATA0_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_ERRDATA0_VDEV_VF_TYPE_S)
#define IG3_PDOC_GLPDOC_ERRDATA0_OBJ_TYPE_S 8
#define IG3_PDOC_GLPDOC_ERRDATA0_OBJ_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_ERRDATA0_OBJ_TYPE_S)
#define IG3_PDOC_GLPDOC_ERRDATA0_RSVD0_S 6
#define IG3_PDOC_GLPDOC_ERRDATA0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_ERRDATA0_RSVD0_S)
#define IG3_PDOC_GLPDOC_ERRDATA0_ERROR_CODE_S 0
#define IG3_PDOC_GLPDOC_ERRDATA0_ERROR_CODE_M RDMA_MASK3(32, 0x3F, IG3_PDOC_GLPDOC_ERRDATA0_ERROR_CODE_S)
#define IG3_PDOC_GLPDOC_ERRDATA1 0x42880460
#define IG3_PDOC_GLPDOC_ERRDATA1_RSVD_S 28
#define IG3_PDOC_GLPDOC_ERRDATA1_RSVD_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_ERRDATA1_RSVD_S)
#define IG3_PDOC_GLPDOC_ERRDATA1_OBJ_INDEX_S 0
#define IG3_PDOC_GLPDOC_ERRDATA1_OBJ_INDEX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PDOC_GLPDOC_ERRDATA1_OBJ_INDEX_S)
#define IG3_PDOC_GLPDOC_ERRDATA2 0x42880464
#define IG3_PDOC_GLPDOC_ERRDATA2_RSVD_S 23
#define IG3_PDOC_GLPDOC_ERRDATA2_RSVD_M RDMA_MASK3(32, 0x1FF, IG3_PDOC_GLPDOC_ERRDATA2_RSVD_S)
#define IG3_PDOC_GLPDOC_ERRDATA2_OPTYPE_S 20
#define IG3_PDOC_GLPDOC_ERRDATA2_OPTYPE_M RDMA_MASK3(32, 0x7, IG3_PDOC_GLPDOC_ERRDATA2_OPTYPE_S)
#define IG3_PDOC_GLPDOC_ERRDATA2_OFFSET_S 7
#define IG3_PDOC_GLPDOC_ERRDATA2_OFFSET_M RDMA_MASK3(32, 0x1FFF, IG3_PDOC_GLPDOC_ERRDATA2_OFFSET_S)
#define IG3_PDOC_GLPDOC_ERRDATA2_LENGTH_S 0
#define IG3_PDOC_GLPDOC_ERRDATA2_LENGTH_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_ERRDATA2_LENGTH_S)
#define IG3_PDOC_GLPDOC_ERRDATA3 0x42880468
#define IG3_PDOC_GLPDOC_ERRDATA3_RSVD_S 15
#define IG3_PDOC_GLPDOC_ERRDATA3_RSVD_M RDMA_MASK3(32, 0x1FFFF, IG3_PDOC_GLPDOC_ERRDATA3_RSVD_S)
#define IG3_PDOC_GLPDOC_ERRDATA3_TAG_S 0
#define IG3_PDOC_GLPDOC_ERRDATA3_TAG_M RDMA_MASK3(32, 0x7FFF, IG3_PDOC_GLPDOC_ERRDATA3_TAG_S)
#define IG3_PDOC_GLPDOC_ERRINFO 0x42880458
#define IG3_PDOC_GLPDOC_ERRINFO_RSVD1_S 16
#define IG3_PDOC_GLPDOC_ERRINFO_RSVD1_M RDMA_MASK3(32, 0xFFFF, IG3_PDOC_GLPDOC_ERRINFO_RSVD1_S)
#define IG3_PDOC_GLPDOC_ERRINFO_ERROR_CNT_S 8
#define IG3_PDOC_GLPDOC_ERRINFO_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_ERRINFO_ERROR_CNT_S)
#define IG3_PDOC_GLPDOC_ERRINFO_RSVD0_S 1
#define IG3_PDOC_GLPDOC_ERRINFO_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_ERRINFO_RSVD0_S)
#define IG3_PDOC_GLPDOC_ERRINFO_ERROR_VALID_S 0
#define IG3_PDOC_GLPDOC_ERRINFO_ERROR_VALID_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_ERRINFO_ERROR_VALID_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG 0x428804BC
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RSVD3_S 20
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RM_S 16
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RM_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RSVD2_S 14
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RME_S 12
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RME_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RSVD1_S 10
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ERR_CNT_S 9
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_FIX_CNT_S 8
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_FIX_CNT_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RSVD0_S 6
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_MASK_INT_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_LS_BYPASS_S 4
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_LS_BYPASS_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_LS_FORCE_S 3
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_LS_FORCE_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_EVICT_MEM_CFG_ECC_EN_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS 0x428804C0
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_RSVD1_S 30
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_RSVD1_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_RSVD0_S 4
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_RSVD0_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_INIT_DONE_S 2
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_ECC_FIX_S 1
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_ECC_FIX_S)
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_ECC_ERR_S 0
#define IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_EVICT_MEM_STATUS_ECC_ERR_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG 0x428804B4
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_FILL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_RSVD3_S 20
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_FILL_MEM_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_RM_S 16
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_FILL_MEM_CFG_RM_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_RSVD2_S 14
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_FILL_MEM_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_FILL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_RME_S 12
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_FILL_MEM_CFG_RME_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_RSVD1_S 10
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_FILL_MEM_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_ERR_CNT_S 9
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_FILL_MEM_CFG_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_FIX_CNT_S 8
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_FILL_MEM_CFG_FIX_CNT_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_RSVD0_S 6
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_FILL_MEM_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_FILL_MEM_CFG_MASK_INT_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_LS_BYPASS_S 4
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_FILL_MEM_CFG_LS_BYPASS_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_LS_FORCE_S 3
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_FILL_MEM_CFG_LS_FORCE_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_FILL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_FILL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_FILL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_FILL_MEM_CFG_ECC_EN_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS 0x428804B8
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS_RSVD1_S 30
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_FILL_MEM_STATUS_RSVD1_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS_RSVD0_S 4
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_FILL_MEM_STATUS_RSVD0_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS_INIT_DONE_S 2
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_FILL_MEM_STATUS_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS_ECC_FIX_S 1
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_FILL_MEM_STATUS_ECC_FIX_S)
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS_ECC_ERR_S 0
#define IG3_PDOC_GLPDOC_FILL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_FILL_MEM_STATUS_ECC_ERR_S)
#define IG3_PDOC_GLPDOC_MAXOSR 0x42880474
#define IG3_PDOC_GLPDOC_MAXOSR_RSVD1_S 11
#define IG3_PDOC_GLPDOC_MAXOSR_RSVD1_M RDMA_MASK3(32, 0x1FFFFF, IG3_PDOC_GLPDOC_MAXOSR_RSVD1_S)
#define IG3_PDOC_GLPDOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S 10
#define IG3_PDOC_GLPDOC_MAXOSR_MAX_OSR_CLNT_WRPULL_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S)
#define IG3_PDOC_GLPDOC_MAXOSR_RSVD0_S 8
#define IG3_PDOC_GLPDOC_MAXOSR_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_MAXOSR_RSVD0_S)
#define IG3_PDOC_GLPDOC_MAXOSR_MAX_OSR_PMAT_FETCH_S 0
#define IG3_PDOC_GLPDOC_MAXOSR_MAX_OSR_PMAT_FETCH_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_MAXOSR_MAX_OSR_PMAT_FETCH_S)
#define IG3_PDOC_GLPDOC_MEM_ECC_COR_ERR 0x42880558
#define IG3_PDOC_GLPDOC_MEM_ECC_COR_ERR_RSVD_S 12
#define IG3_PDOC_GLPDOC_MEM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PDOC_GLPDOC_MEM_ECC_COR_ERR_RSVD_S)
#define IG3_PDOC_GLPDOC_MEM_ECC_COR_ERR_CNT_S 0
#define IG3_PDOC_GLPDOC_MEM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PDOC_GLPDOC_MEM_ECC_COR_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_MEM_ECC_UNCOR_ERR 0x42880554
#define IG3_PDOC_GLPDOC_MEM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PDOC_GLPDOC_MEM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PDOC_GLPDOC_MEM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PDOC_GLPDOC_MEM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PDOC_GLPDOC_MEM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PDOC_GLPDOC_MEM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_PLIST_DBG_CTL 0x4288054C
#define IG3_PDOC_GLPDOC_PLIST_DBG_CTL_DONE_S 31
#define IG3_PDOC_GLPDOC_PLIST_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_DBG_CTL_DONE_S)
#define IG3_PDOC_GLPDOC_PLIST_DBG_CTL_RD_EN_S 30
#define IG3_PDOC_GLPDOC_PLIST_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_DBG_CTL_RD_EN_S)
#define IG3_PDOC_GLPDOC_PLIST_DBG_CTL_RSVD_S 26
#define IG3_PDOC_GLPDOC_PLIST_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_PLIST_DBG_CTL_RSVD_S)
#define IG3_PDOC_GLPDOC_PLIST_DBG_CTL_DW_SEL_S 18
#define IG3_PDOC_GLPDOC_PLIST_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_PLIST_DBG_CTL_DW_SEL_S)
#define IG3_PDOC_GLPDOC_PLIST_DBG_CTL_ADR_S 0
#define IG3_PDOC_GLPDOC_PLIST_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_PLIST_DBG_CTL_ADR_S)
#define IG3_PDOC_GLPDOC_PLIST_DBG_DATA 0x42880550
#define IG3_PDOC_GLPDOC_PLIST_DBG_DATA_RD_DW_S 0
#define IG3_PDOC_GLPDOC_PLIST_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_PLIST_DBG_DATA_RD_DW_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG 0x428804AC
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RSVD3_S 20
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RM_S 16
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RM_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RSVD2_S 14
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RME_S 12
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RME_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RSVD1_S 10
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ERR_CNT_S 9
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_FIX_CNT_S 8
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_FIX_CNT_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RSVD0_S 6
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_MASK_INT_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_LS_BYPASS_S 4
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_LS_BYPASS_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_LS_FORCE_S 3
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_LS_FORCE_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_MEM_CFG_ECC_EN_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS 0x428804B0
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_RSVD1_S 30
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_RSVD1_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_RSVD0_S 4
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_RSVD0_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_INIT_DONE_S 2
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_ECC_FIX_S 1
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_ECC_FIX_S)
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_ECC_ERR_S 0
#define IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PLIST_MEM_STATUS_ECC_ERR_S)
#define IG3_PDOC_GLPDOC_PMATINV_CFG 0x4288047C
#define IG3_PDOC_GLPDOC_PMATINV_CFG_RSVD_S 6
#define IG3_PDOC_GLPDOC_PMATINV_CFG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_PDOC_GLPDOC_PMATINV_CFG_RSVD_S)
#define IG3_PDOC_GLPDOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S 5
#define IG3_PDOC_GLPDOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S)
#define IG3_PDOC_GLPDOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S 4
#define IG3_PDOC_GLPDOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PDOC_GLPDOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S 3
#define IG3_PDOC_GLPDOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S)
#define IG3_PDOC_GLPDOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S 2
#define IG3_PDOC_GLPDOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S)
#define IG3_PDOC_GLPDOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S 1
#define IG3_PDOC_GLPDOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PDOC_GLPDOC_PMATINV_CFG_INVBYFN_FENCE_EN_S 0
#define IG3_PDOC_GLPDOC_PMATINV_CFG_INVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_PMATINV_CFG_INVBYFN_FENCE_EN_S)
#define IG3_PDOC_GLPDOC_STAT_CTL 0x42880404
#define IG3_PDOC_GLPDOC_STAT_CTL_RSVD_S 5
#define IG3_PDOC_GLPDOC_STAT_CTL_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PDOC_GLPDOC_STAT_CTL_RSVD_S)
#define IG3_PDOC_GLPDOC_STAT_CTL_OBJECT_TYPE_S 0
#define IG3_PDOC_GLPDOC_STAT_CTL_OBJECT_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_STAT_CTL_OBJECT_TYPE_S)
#define IG3_PDOC_GLPDOC_STAT_FENCING_TIME_HI 0x4288044C
#define IG3_PDOC_GLPDOC_STAT_FENCING_TIME_HI_RSVD_S 24
#define IG3_PDOC_GLPDOC_STAT_FENCING_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_STAT_FENCING_TIME_HI_RSVD_S)
#define IG3_PDOC_GLPDOC_STAT_FENCING_TIME_HI_CNT_HI_S 0
#define IG3_PDOC_GLPDOC_STAT_FENCING_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PDOC_GLPDOC_STAT_FENCING_TIME_HI_CNT_HI_S)
#define IG3_PDOC_GLPDOC_STAT_FENCING_TIME_LO 0x42880448
#define IG3_PDOC_GLPDOC_STAT_FENCING_TIME_LO_CNT_LO_S 0
#define IG3_PDOC_GLPDOC_STAT_FENCING_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_STAT_FENCING_TIME_LO_CNT_LO_S)
#define IG3_PDOC_GLPDOC_STAT_MAX_PENDING_ENTRIES 0x4288042C
#define IG3_PDOC_GLPDOC_STAT_MAX_PENDING_ENTRIES_RSVD_S 8
#define IG3_PDOC_GLPDOC_STAT_MAX_PENDING_ENTRIES_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PDOC_GLPDOC_STAT_MAX_PENDING_ENTRIES_RSVD_S)
#define IG3_PDOC_GLPDOC_STAT_MAX_PENDING_ENTRIES_CNT_S 0
#define IG3_PDOC_GLPDOC_STAT_MAX_PENDING_ENTRIES_CNT_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_STAT_MAX_PENDING_ENTRIES_CNT_S)
#define IG3_PDOC_GLPDOC_STAT_MAX_PENDING_LIST_DEPTH 0x42880434
#define IG3_PDOC_GLPDOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S 8
#define IG3_PDOC_GLPDOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PDOC_GLPDOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S)
#define IG3_PDOC_GLPDOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S 0
#define IG3_PDOC_GLPDOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S)
#define IG3_PDOC_GLPDOC_STAT_MAX_VIRT_PENDING_LISTS 0x42880430
#define IG3_PDOC_GLPDOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S 8
#define IG3_PDOC_GLPDOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PDOC_GLPDOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S)
#define IG3_PDOC_GLPDOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S 0
#define IG3_PDOC_GLPDOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S)
#define IG3_PDOC_GLPDOC_STAT_OBJ_CNT 0x42880408
#define IG3_PDOC_GLPDOC_STAT_OBJ_CNT_RSVD_S 14
#define IG3_PDOC_GLPDOC_STAT_OBJ_CNT_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_STAT_OBJ_CNT_RSVD_S)
#define IG3_PDOC_GLPDOC_STAT_OBJ_CNT_OBJECT_COUNT_S 0
#define IG3_PDOC_GLPDOC_STAT_OBJ_CNT_OBJECT_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PDOC_GLPDOC_STAT_OBJ_CNT_OBJECT_COUNT_S)
#define IG3_PDOC_GLPDOC_STAT_PENDLING_LIST_FULL_HI 0x42880444
#define IG3_PDOC_GLPDOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S 24
#define IG3_PDOC_GLPDOC_STAT_PENDLING_LIST_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S)
#define IG3_PDOC_GLPDOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S 0
#define IG3_PDOC_GLPDOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PDOC_GLPDOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S)
#define IG3_PDOC_GLPDOC_STAT_PENDLING_LIST_FULL_LO 0x42880440
#define IG3_PDOC_GLPDOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S 0
#define IG3_PDOC_GLPDOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S)
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_IDLE_HI 0x42880420
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_IDLE_HI_RSVD_S 24
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_STAT_RD_DATA_IDLE_HI_RSVD_S)
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PDOC_GLPDOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_IDLE_LO 0x4288041C
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_XFER_HI 0x42880428
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_XFER_HI_RSVD_S 24
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_STAT_RD_DATA_XFER_HI_RSVD_S)
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PDOC_GLPDOC_STAT_RD_DATA_XFER_HI_CNT_HI_S)
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_XFER_LO 0x42880424
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PDOC_GLPDOC_STAT_RD_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_STAT_RD_DATA_XFER_LO_CNT_LO_S)
#define IG3_PDOC_GLPDOC_STAT_RD_HIT_HI 0x42880410
#define IG3_PDOC_GLPDOC_STAT_RD_HIT_HI_RSVD_S 24
#define IG3_PDOC_GLPDOC_STAT_RD_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_STAT_RD_HIT_HI_RSVD_S)
#define IG3_PDOC_GLPDOC_STAT_RD_HIT_HI_CNT_HI_S 0
#define IG3_PDOC_GLPDOC_STAT_RD_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PDOC_GLPDOC_STAT_RD_HIT_HI_CNT_HI_S)
#define IG3_PDOC_GLPDOC_STAT_RD_HIT_LO 0x4288040C
#define IG3_PDOC_GLPDOC_STAT_RD_HIT_LO_CNT_LO_S 0
#define IG3_PDOC_GLPDOC_STAT_RD_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_STAT_RD_HIT_LO_CNT_LO_S)
#define IG3_PDOC_GLPDOC_STAT_RD_MISS_HI 0x42880418
#define IG3_PDOC_GLPDOC_STAT_RD_MISS_HI_RSVD_S 24
#define IG3_PDOC_GLPDOC_STAT_RD_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_STAT_RD_MISS_HI_RSVD_S)
#define IG3_PDOC_GLPDOC_STAT_RD_MISS_HI_CNT_HI_S 0
#define IG3_PDOC_GLPDOC_STAT_RD_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PDOC_GLPDOC_STAT_RD_MISS_HI_CNT_HI_S)
#define IG3_PDOC_GLPDOC_STAT_RD_MISS_LO 0x42880414
#define IG3_PDOC_GLPDOC_STAT_RD_MISS_LO_CNT_LO_S 0
#define IG3_PDOC_GLPDOC_STAT_RD_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_STAT_RD_MISS_LO_CNT_LO_S)
#define IG3_PDOC_GLPDOC_STAT_REPLAY_TIME_HI 0x42880454
#define IG3_PDOC_GLPDOC_STAT_REPLAY_TIME_HI_RSVD_S 24
#define IG3_PDOC_GLPDOC_STAT_REPLAY_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_STAT_REPLAY_TIME_HI_RSVD_S)
#define IG3_PDOC_GLPDOC_STAT_REPLAY_TIME_HI_CNT_HI_S 0
#define IG3_PDOC_GLPDOC_STAT_REPLAY_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PDOC_GLPDOC_STAT_REPLAY_TIME_HI_CNT_HI_S)
#define IG3_PDOC_GLPDOC_STAT_REPLAY_TIME_LO 0x42880450
#define IG3_PDOC_GLPDOC_STAT_REPLAY_TIME_LO_CNT_LO_S 0
#define IG3_PDOC_GLPDOC_STAT_REPLAY_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_STAT_REPLAY_TIME_LO_CNT_LO_S)
#define IG3_PDOC_GLPDOC_STAT_WR_BUFF_FULL_HI 0x4288043C
#define IG3_PDOC_GLPDOC_STAT_WR_BUFF_FULL_HI_RSVD_S 24
#define IG3_PDOC_GLPDOC_STAT_WR_BUFF_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_STAT_WR_BUFF_FULL_HI_RSVD_S)
#define IG3_PDOC_GLPDOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S 0
#define IG3_PDOC_GLPDOC_STAT_WR_BUFF_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PDOC_GLPDOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S)
#define IG3_PDOC_GLPDOC_STAT_WR_BUFF_FULL_LO 0x42880438
#define IG3_PDOC_GLPDOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S 0
#define IG3_PDOC_GLPDOC_STAT_WR_BUFF_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S)
#define IG3_PDOC_GLPDOC_TAG_DBG_CTL 0x42880504
#define IG3_PDOC_GLPDOC_TAG_DBG_CTL_DONE_S 31
#define IG3_PDOC_GLPDOC_TAG_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_DBG_CTL_DONE_S)
#define IG3_PDOC_GLPDOC_TAG_DBG_CTL_RD_EN_S 30
#define IG3_PDOC_GLPDOC_TAG_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_DBG_CTL_RD_EN_S)
#define IG3_PDOC_GLPDOC_TAG_DBG_CTL_RSVD_S 26
#define IG3_PDOC_GLPDOC_TAG_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_TAG_DBG_CTL_RSVD_S)
#define IG3_PDOC_GLPDOC_TAG_DBG_CTL_DW_SEL_S 18
#define IG3_PDOC_GLPDOC_TAG_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_TAG_DBG_CTL_DW_SEL_S)
#define IG3_PDOC_GLPDOC_TAG_DBG_CTL_ADR_S 0
#define IG3_PDOC_GLPDOC_TAG_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_TAG_DBG_CTL_ADR_S)
#define IG3_PDOC_GLPDOC_TAG_DBG_DATA 0x42880508
#define IG3_PDOC_GLPDOC_TAG_DBG_DATA_RD_DW_S 0
#define IG3_PDOC_GLPDOC_TAG_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_TAG_DBG_DATA_RD_DW_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG 0x4288049C
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_RSVD3_S 20
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_TAG_MEM_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_RM_S 16
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_TAG_MEM_CFG_RM_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_RSVD2_S 14
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_TAG_MEM_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_RME_S 12
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_MEM_CFG_RME_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_RSVD1_S 10
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_TAG_MEM_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_RSVD0_S 6
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_TAG_MEM_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_MEM_CFG_MASK_INT_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_MEM_CFG_ECC_EN_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS 0x428804A0
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_TAG_MEM_STATUS_RSVD1_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_TAG_MEM_STATUS_RSVD0_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_PDOC_GLPDOC_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_PDOC_GLPDOC_TOTAL_TAG_HI 0x42880490
#define IG3_PDOC_GLPDOC_TOTAL_TAG_HI_RSVD_S 24
#define IG3_PDOC_GLPDOC_TOTAL_TAG_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_TOTAL_TAG_HI_RSVD_S)
#define IG3_PDOC_GLPDOC_TOTAL_TAG_HI_CNT_HI_S 0
#define IG3_PDOC_GLPDOC_TOTAL_TAG_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PDOC_GLPDOC_TOTAL_TAG_HI_CNT_HI_S)
#define IG3_PDOC_GLPDOC_TOTAL_TAG_HIT_HI 0x42880498
#define IG3_PDOC_GLPDOC_TOTAL_TAG_HIT_HI_RSVD_S 24
#define IG3_PDOC_GLPDOC_TOTAL_TAG_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_TOTAL_TAG_HIT_HI_RSVD_S)
#define IG3_PDOC_GLPDOC_TOTAL_TAG_HIT_HI_CNT_HI_S 0
#define IG3_PDOC_GLPDOC_TOTAL_TAG_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PDOC_GLPDOC_TOTAL_TAG_HIT_HI_CNT_HI_S)
#define IG3_PDOC_GLPDOC_TOTAL_TAG_HIT_LO 0x42880494
#define IG3_PDOC_GLPDOC_TOTAL_TAG_HIT_LO_CNT_LO_S 0
#define IG3_PDOC_GLPDOC_TOTAL_TAG_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_TOTAL_TAG_HIT_LO_CNT_LO_S)
#define IG3_PDOC_GLPDOC_TOTAL_TAG_LO 0x4288048C
#define IG3_PDOC_GLPDOC_TOTAL_TAG_LO_CNT_LO_S 0
#define IG3_PDOC_GLPDOC_TOTAL_TAG_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PDOC_GLPDOC_TOTAL_TAG_LO_CNT_LO_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG 0x428804A4
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RSVD3_S 20
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RSVD3_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RM_S 16
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RM_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RSVD2_S 14
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RSVD2_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RME_S 12
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RME_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RSVD1_S 10
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RSVD1_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ERR_CNT_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_FIX_CNT_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RSVD0_S 6
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_RSVD0_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_MASK_INT_S 5
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_MASK_INT_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_LS_FORCE_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ECC_EN_S 0
#define IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_WRBUF_MEM_CFG_ECC_EN_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS 0x428804A8
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_RSVD1_S 30
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_RSVD1_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_RSVD0_S 4
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_RSVD0_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PDOC_GLPDOC_WRBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC0_GLPBLOC_ARPTBLE_OBJOFST 0x4290007C
#define IG3_PBLOC0_GLPBLOC_ARPTBLE_OBJOFST_RSVD_S 10
#define IG3_PBLOC0_GLPBLOC_ARPTBLE_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PBLOC0_GLPBLOC_ARPTBLE_OBJOFST_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PBLOC0_GLPBLOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PBLOC0_GLPBLOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PBLOC0_GLPBLOC_CACHESIZE 0x429000AC
#define IG3_PBLOC0_GLPBLOC_CACHESIZE_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_CACHESIZE_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHESIZE_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_CACHESIZE_WAYS_S 20
#define IG3_PBLOC0_GLPBLOC_CACHESIZE_WAYS_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHESIZE_WAYS_S)
#define IG3_PBLOC0_GLPBLOC_CACHESIZE_SETS_S 8
#define IG3_PBLOC0_GLPBLOC_CACHESIZE_SETS_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC0_GLPBLOC_CACHESIZE_SETS_S)
#define IG3_PBLOC0_GLPBLOC_CACHESIZE_WORD_SIZE_S 0
#define IG3_PBLOC0_GLPBLOC_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHESIZE_WORD_SIZE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL 0x42900138
#define IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_DONE_S 31
#define IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_RD_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_RSVD_S 26
#define IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_ADR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_CTL_ADR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_DATA 0x4290013C
#define IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_CACHE_0_DBG_DATA_RD_DW_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG 0x429000F0
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RM_S 16
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RME_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RME_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS 0x429000F4
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_0_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL 0x42900140
#define IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_DONE_S 31
#define IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_RD_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_RSVD_S 26
#define IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_ADR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_CTL_ADR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_DATA 0x42900144
#define IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_CACHE_1_DBG_DATA_RD_DW_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG 0x429000F8
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RM_S 16
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RME_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RME_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS 0x429000FC
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_1_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL 0x42900148
#define IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_DONE_S 31
#define IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_RD_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_RSVD_S 26
#define IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_ADR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_CTL_ADR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_DATA 0x4290014C
#define IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_CACHE_2_DBG_DATA_RD_DW_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG 0x42900100
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RM_S 16
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RME_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RME_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS 0x42900104
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_2_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL 0x42900150
#define IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_DONE_S 31
#define IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_RD_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_RSVD_S 26
#define IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_ADR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_CTL_ADR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_DATA 0x42900154
#define IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_CACHE_3_DBG_DATA_RD_DW_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG 0x42900108
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RM_S 16
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RME_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RME_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS 0x4290010C
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_3_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL 0x42900158
#define IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_DONE_S 31
#define IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_RD_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_RSVD_S 26
#define IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_ADR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_CTL_ADR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_DATA 0x4290015C
#define IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_CACHE_4_DBG_DATA_RD_DW_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG 0x42900110
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RM_S 16
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RME_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RME_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS 0x42900114
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_4_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL 0x42900160
#define IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_DONE_S 31
#define IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_RD_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_RSVD_S 26
#define IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_ADR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_CTL_ADR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_DATA 0x42900164
#define IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_CACHE_5_DBG_DATA_RD_DW_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG 0x42900118
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RM_S 16
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RME_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RME_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS 0x4290011C
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_5_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL 0x42900168
#define IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_DONE_S 31
#define IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_RD_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_RSVD_S 26
#define IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_ADR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_CTL_ADR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_DATA 0x4290016C
#define IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_CACHE_6_DBG_DATA_RD_DW_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG 0x42900120
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RM_S 16
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RME_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RME_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS 0x42900124
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_6_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL 0x42900170
#define IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_DONE_S 31
#define IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_RD_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_RSVD_S 26
#define IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_ADR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_CTL_ADR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_DATA 0x42900174
#define IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_CACHE_7_DBG_DATA_RD_DW_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG 0x42900128
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RM_S 16
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RM_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RME_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RME_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS 0x4290012C
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CACHE_7_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_CTRL 0x42900000
#define IG3_PBLOC0_GLPBLOC_CACHE_CTRL_RSVD_S 2
#define IG3_PBLOC0_GLPBLOC_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_PBLOC0_GLPBLOC_CACHE_CTRL_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_CACHE_CTRL_SCALE_FACTOR_S 0
#define IG3_PBLOC0_GLPBLOC_CACHE_CTRL_SCALE_FACTOR_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_CACHE_CTRL_SCALE_FACTOR_S)
#define IG3_PBLOC0_GLPBLOC_CECC_ERR 0x4290009C
#define IG3_PBLOC0_GLPBLOC_CECC_ERR_RSVD1_S 28
#define IG3_PBLOC0_GLPBLOC_CECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CECC_ERR_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PBLOC0_GLPBLOC_CECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC0_GLPBLOC_CECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CECC_ERR_RSVD0_S 12
#define IG3_PBLOC0_GLPBLOC_CECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_CECC_ERR_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PBLOC0_GLPBLOC_CECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC0_GLPBLOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_CSTATELKUP_CFG 0x429000A4
#define IG3_PBLOC0_GLPBLOC_CSTATELKUP_CFG_RSVD1_S 9
#define IG3_PBLOC0_GLPBLOC_CSTATELKUP_CFG_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PBLOC0_GLPBLOC_CSTATELKUP_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S 8
#define IG3_PBLOC0_GLPBLOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S)
#define IG3_PBLOC0_GLPBLOC_CSTATELKUP_CFG_RSVD0_S 3
#define IG3_PBLOC0_GLPBLOC_CSTATELKUP_CFG_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_CSTATELKUP_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S 0
#define IG3_PBLOC0_GLPBLOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_M RDMA_MASK3(32, 0x7, IG3_PBLOC0_GLPBLOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S)
#define IG3_PBLOC0_GLPBLOC_DPC_COMP 0x429000B4
#define IG3_PBLOC0_GLPBLOC_DPC_COMP_RSVD_S 13
#define IG3_PBLOC0_GLPBLOC_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PBLOC0_GLPBLOC_DPC_COMP_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_DPC_COMP_COMP_FTYPE_S 11
#define IG3_PBLOC0_GLPBLOC_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_DPC_COMP_COMP_FTYPE_S)
#define IG3_PBLOC0_GLPBLOC_DPC_COMP_COMP_FNUM_S 1
#define IG3_PBLOC0_GLPBLOC_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PBLOC0_GLPBLOC_DPC_COMP_COMP_FNUM_S)
#define IG3_PBLOC0_GLPBLOC_DPC_COMP_COMP_VALID_S 0
#define IG3_PBLOC0_GLPBLOC_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DPC_COMP_COMP_VALID_S)
#define IG3_PBLOC0_GLPBLOC_DPC_REQ 0x429000B0
#define IG3_PBLOC0_GLPBLOC_DPC_REQ_RSVD_S 12
#define IG3_PBLOC0_GLPBLOC_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC0_GLPBLOC_DPC_REQ_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_DPC_REQ_REQ_FTYPE_S 10
#define IG3_PBLOC0_GLPBLOC_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_DPC_REQ_REQ_FTYPE_S)
#define IG3_PBLOC0_GLPBLOC_DPC_REQ_REQ_FNUM_S 0
#define IG3_PBLOC0_GLPBLOC_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PBLOC0_GLPBLOC_DPC_REQ_REQ_FNUM_S)
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_COUNT 0x42900238
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC0_GLPBLOC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC0_GLPBLOC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_CMD 0x4290024C
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_DATA_H 0x42900258
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_DATA_L 0x42900254
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_PTR 0x42900250
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC0_GLPBLOC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_CMD 0x4290023C
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_DATA_H 0x42900248
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_DATA_L 0x42900244
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_PTR 0x42900240
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC0_GLPBLOC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL 0x42900200
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_RSVD1_S 25
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_DTM_CONTROL_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_RSVD2_S 17
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_DTM_CONTROL_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_RSVD3_S 9
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_DTM_CONTROL_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_BYPASS_S 8
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_CONTROL_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_RSVD4_S 1
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_DTM_CONTROL_RSVD4_S)
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PBLOC0_GLPBLOC_DTM_ECC_COR_ERR 0x42900268
#define IG3_PBLOC0_GLPBLOC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PBLOC0_GLPBLOC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC0_GLPBLOC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC0_GLPBLOC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_DTM_ECC_UNCOR_ERR 0x42900264
#define IG3_PBLOC0_GLPBLOC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PBLOC0_GLPBLOC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC0_GLPBLOC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC0_GLPBLOC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_DTM_GROUP_CFG 0x4290020C
#define IG3_PBLOC0_GLPBLOC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PBLOC0_GLPBLOC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PBLOC0_GLPBLOC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PBLOC0_GLPBLOC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PBLOC0_GLPBLOC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PBLOC0_GLPBLOC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PBLOC0_GLPBLOC_DTM_LOG_CFG 0x42900210
#define IG3_PBLOC0_GLPBLOC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PBLOC0_GLPBLOC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PBLOC0_GLPBLOC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PBLOC0_GLPBLOC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PBLOC0_GLPBLOC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PBLOC0_GLPBLOC_DTM_LOG_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_DTM_LOG_CFG_MODE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_DTM_LOG_CFG_MODE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_LOG_MASK 0x42900218
#define IG3_PBLOC0_GLPBLOC_DTM_LOG_MASK_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_DTM_LOG_MASK_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_LOG_PATTERN 0x42900214
#define IG3_PBLOC0_GLPBLOC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG 0x42900204
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_STS 0x42900208
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PBLOC0_GLPBLOC_DTM_MAIN_STS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_DTM_MAIN_STS_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TIMESTAMP 0x42900230
#define IG3_PBLOC0_GLPBLOC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_DTM_TIMESTAMP_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TIMESTAMP_ROLLOVER 0x42900234
#define IG3_PBLOC0_GLPBLOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG 0x4290025C
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS 0x42900260
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG 0x4290021C
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_MODE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_DTM_TRIG_CFG_MODE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_COUNT 0x42900228
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_MASK 0x42900224
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_DTM_TRIG_MASK_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_PATTERN 0x42900220
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_TIMESTAMP 0x4290022C
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PBLOC0_GLPBLOC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PBLOC0_GLPBLOC_ECC_CTL 0x42900094
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_RSVD_S 8
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_ECC_CTL_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_CLIENT_ECC_INVERT2_S 7
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_CLIENT_ECC_INVERT2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_ECC_CTL_CLIENT_ECC_INVERT2_S)
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_CLIENT_ECC_INVERT1_S 6
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_CLIENT_ECC_INVERT1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_ECC_CTL_CLIENT_ECC_INVERT1_S)
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_CLIENT_ECC_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_CLIENT_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_ECC_CTL_CLIENT_ECC_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_CLIENT_ECC_EN_S 4
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_CLIENT_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_ECC_CTL_CLIENT_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_HOST_ECC_INVERT2_S 3
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_HOST_ECC_INVERT2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_ECC_CTL_HOST_ECC_INVERT2_S)
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_HOST_ECC_INVERT1_S 2
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_HOST_ECC_INVERT1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_ECC_CTL_HOST_ECC_INVERT1_S)
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_HOST_ECC_MASK_INT_S 1
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_HOST_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_ECC_CTL_HOST_ECC_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_HOST_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_ECC_CTL_HOST_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_ECC_CTL_HOST_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA0 0x42900084
#define IG3_PBLOC0_GLPBLOC_ERRDATA0_RSVD1_S 31
#define IG3_PBLOC0_GLPBLOC_ERRDATA0_RSVD1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_ERRDATA0_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA0_PF_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_ERRDATA0_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PBLOC0_GLPBLOC_ERRDATA0_PF_NUM_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA0_VDEV_VF_NUM_S 15
#define IG3_PBLOC0_GLPBLOC_ERRDATA0_VDEV_VF_NUM_M RDMA_MASK3(32, 0x3FF, IG3_PBLOC0_GLPBLOC_ERRDATA0_VDEV_VF_NUM_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA0_VDEV_VF_TYPE_S 13
#define IG3_PBLOC0_GLPBLOC_ERRDATA0_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_ERRDATA0_VDEV_VF_TYPE_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA0_OBJ_TYPE_S 8
#define IG3_PBLOC0_GLPBLOC_ERRDATA0_OBJ_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_ERRDATA0_OBJ_TYPE_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA0_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_ERRDATA0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_ERRDATA0_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA0_ERROR_CODE_S 0
#define IG3_PBLOC0_GLPBLOC_ERRDATA0_ERROR_CODE_M RDMA_MASK3(32, 0x3F, IG3_PBLOC0_GLPBLOC_ERRDATA0_ERROR_CODE_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA1 0x42900088
#define IG3_PBLOC0_GLPBLOC_ERRDATA1_RSVD_S 28
#define IG3_PBLOC0_GLPBLOC_ERRDATA1_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_ERRDATA1_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA1_OBJ_INDEX_S 0
#define IG3_PBLOC0_GLPBLOC_ERRDATA1_OBJ_INDEX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PBLOC0_GLPBLOC_ERRDATA1_OBJ_INDEX_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA2 0x4290008C
#define IG3_PBLOC0_GLPBLOC_ERRDATA2_RSVD_S 23
#define IG3_PBLOC0_GLPBLOC_ERRDATA2_RSVD_M RDMA_MASK3(32, 0x1FF, IG3_PBLOC0_GLPBLOC_ERRDATA2_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA2_OPTYPE_S 20
#define IG3_PBLOC0_GLPBLOC_ERRDATA2_OPTYPE_M RDMA_MASK3(32, 0x7, IG3_PBLOC0_GLPBLOC_ERRDATA2_OPTYPE_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA2_OFFSET_S 7
#define IG3_PBLOC0_GLPBLOC_ERRDATA2_OFFSET_M RDMA_MASK3(32, 0x1FFF, IG3_PBLOC0_GLPBLOC_ERRDATA2_OFFSET_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA2_LENGTH_S 0
#define IG3_PBLOC0_GLPBLOC_ERRDATA2_LENGTH_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_ERRDATA2_LENGTH_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA3 0x42900090
#define IG3_PBLOC0_GLPBLOC_ERRDATA3_RSVD_S 15
#define IG3_PBLOC0_GLPBLOC_ERRDATA3_RSVD_M RDMA_MASK3(32, 0x1FFFF, IG3_PBLOC0_GLPBLOC_ERRDATA3_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_ERRDATA3_TAG_S 0
#define IG3_PBLOC0_GLPBLOC_ERRDATA3_TAG_M RDMA_MASK3(32, 0x7FFF, IG3_PBLOC0_GLPBLOC_ERRDATA3_TAG_S)
#define IG3_PBLOC0_GLPBLOC_ERRINFO 0x42900080
#define IG3_PBLOC0_GLPBLOC_ERRINFO_RSVD1_S 16
#define IG3_PBLOC0_GLPBLOC_ERRINFO_RSVD1_M RDMA_MASK3(32, 0xFFFF, IG3_PBLOC0_GLPBLOC_ERRINFO_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_ERRINFO_ERROR_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_ERRINFO_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_ERRINFO_ERROR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_ERRINFO_RSVD0_S 1
#define IG3_PBLOC0_GLPBLOC_ERRINFO_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_ERRINFO_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_ERRINFO_ERROR_VALID_S 0
#define IG3_PBLOC0_GLPBLOC_ERRINFO_ERROR_VALID_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_ERRINFO_ERROR_VALID_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG 0x429000E8
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RM_S 16
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RM_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RME_S 12
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RME_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_EVICT_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS 0x429000EC
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_EVICT_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG 0x429000E0
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RM_S 16
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RM_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RME_S 12
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RME_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_FILL_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS 0x429000E4
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_FILL_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC0_GLPBLOC_HECC_ERR 0x42900098
#define IG3_PBLOC0_GLPBLOC_HECC_ERR_RSVD1_S 28
#define IG3_PBLOC0_GLPBLOC_HECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_HECC_ERR_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_HECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PBLOC0_GLPBLOC_HECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC0_GLPBLOC_HECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_HECC_ERR_RSVD0_S 12
#define IG3_PBLOC0_GLPBLOC_HECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_HECC_ERR_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PBLOC0_GLPBLOC_HECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC0_GLPBLOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_MAXOSR 0x429000A0
#define IG3_PBLOC0_GLPBLOC_MAXOSR_RSVD1_S 11
#define IG3_PBLOC0_GLPBLOC_MAXOSR_RSVD1_M RDMA_MASK3(32, 0x1FFFFF, IG3_PBLOC0_GLPBLOC_MAXOSR_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S 10
#define IG3_PBLOC0_GLPBLOC_MAXOSR_MAX_OSR_CLNT_WRPULL_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S)
#define IG3_PBLOC0_GLPBLOC_MAXOSR_RSVD0_S 8
#define IG3_PBLOC0_GLPBLOC_MAXOSR_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_MAXOSR_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_MAXOSR_MAX_OSR_PMAT_FETCH_S 0
#define IG3_PBLOC0_GLPBLOC_MAXOSR_MAX_OSR_PMAT_FETCH_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_MAXOSR_MAX_OSR_PMAT_FETCH_S)
#define IG3_PBLOC0_GLPBLOC_MEM_ECC_COR_ERR 0x42900184
#define IG3_PBLOC0_GLPBLOC_MEM_ECC_COR_ERR_RSVD_S 12
#define IG3_PBLOC0_GLPBLOC_MEM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC0_GLPBLOC_MEM_ECC_COR_ERR_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_MEM_ECC_COR_ERR_CNT_S 0
#define IG3_PBLOC0_GLPBLOC_MEM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC0_GLPBLOC_MEM_ECC_COR_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_MEM_ECC_UNCOR_ERR 0x42900180
#define IG3_PBLOC0_GLPBLOC_MEM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PBLOC0_GLPBLOC_MEM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC0_GLPBLOC_MEM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_MEM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PBLOC0_GLPBLOC_MEM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC0_GLPBLOC_MEM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_PBLE_OBJOFST 0x42900078
#define IG3_PBLOC0_GLPBLOC_PBLE_OBJOFST_RSVD_S 10
#define IG3_PBLOC0_GLPBLOC_PBLE_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PBLOC0_GLPBLOC_PBLE_OBJOFST_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_PBLE_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PBLOC0_GLPBLOC_PBLE_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PBLOC0_GLPBLOC_PBLE_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL 0x42900178
#define IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_DONE_S 31
#define IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_DONE_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_RD_EN_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_RSVD_S 26
#define IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_ADR_S 0
#define IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_PLIST_DBG_CTL_ADR_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_DBG_DATA 0x4290017C
#define IG3_PBLOC0_GLPBLOC_PLIST_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC0_GLPBLOC_PLIST_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_PLIST_DBG_DATA_RD_DW_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG 0x429000D8
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RM_S 16
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RM_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RME_S 12
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RME_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS 0x429000DC
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PLIST_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG 0x429000A8
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG_RSVD_S 6
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_PBLOC0_GLPBLOC_PMATINV_CFG_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S 5
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S)
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S 4
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S 3
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S)
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S 2
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S)
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S 1
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG_INVBYFN_FENCE_EN_S 0
#define IG3_PBLOC0_GLPBLOC_PMATINV_CFG_INVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_PMATINV_CFG_INVBYFN_FENCE_EN_S)
#define IG3_PBLOC0_GLPBLOC_STAT_CTL 0x42900004
#define IG3_PBLOC0_GLPBLOC_STAT_CTL_RSVD_S 5
#define IG3_PBLOC0_GLPBLOC_STAT_CTL_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PBLOC0_GLPBLOC_STAT_CTL_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_CTL_OBJECT_TYPE_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_CTL_OBJECT_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_STAT_CTL_OBJECT_TYPE_S)
#define IG3_PBLOC0_GLPBLOC_STAT_FENCING_TIME_HI 0x4290006C
#define IG3_PBLOC0_GLPBLOC_STAT_FENCING_TIME_HI_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_STAT_FENCING_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_FENCING_TIME_HI_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_FENCING_TIME_HI_CNT_HI_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_FENCING_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_FENCING_TIME_HI_CNT_HI_S)
#define IG3_PBLOC0_GLPBLOC_STAT_FENCING_TIME_LO 0x42900068
#define IG3_PBLOC0_GLPBLOC_STAT_FENCING_TIME_LO_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_FENCING_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_FENCING_TIME_LO_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_PENDING_ENTRIES 0x4290004C
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_PENDING_ENTRIES_RSVD_S 8
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_PENDING_ENTRIES_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_MAX_PENDING_ENTRIES_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_PENDING_ENTRIES_CNT_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_PENDING_ENTRIES_CNT_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_MAX_PENDING_ENTRIES_CNT_S)
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_PENDING_LIST_DEPTH 0x42900054
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S 8
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_VIRT_PENDING_LISTS 0x42900050
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S 8
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_STAT_OBJ_CNT 0x42900008
#define IG3_PBLOC0_GLPBLOC_STAT_OBJ_CNT_RSVD_S 14
#define IG3_PBLOC0_GLPBLOC_STAT_OBJ_CNT_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_STAT_OBJ_CNT_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_OBJ_CNT_OBJECT_COUNT_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_OBJ_CNT_OBJECT_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PBLOC0_GLPBLOC_STAT_OBJ_CNT_OBJECT_COUNT_S)
#define IG3_PBLOC0_GLPBLOC_STAT_PENDLING_LIST_FULL_HI 0x42900064
#define IG3_PBLOC0_GLPBLOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_STAT_PENDLING_LIST_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S)
#define IG3_PBLOC0_GLPBLOC_STAT_PENDLING_LIST_FULL_LO 0x42900060
#define IG3_PBLOC0_GLPBLOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_IDLE_HI 0x42900030
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_IDLE_HI_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_IDLE_HI_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_IDLE_LO 0x4290002C
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_XFER_HI 0x42900038
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_XFER_HI_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_XFER_HI_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_XFER_HI_CNT_HI_S)
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_XFER_LO 0x42900034
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_RD_DATA_XFER_LO_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_STAT_RD_HIT_HI 0x42900010
#define IG3_PBLOC0_GLPBLOC_STAT_RD_HIT_HI_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_STAT_RD_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_RD_HIT_HI_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_RD_HIT_HI_CNT_HI_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_RD_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_RD_HIT_HI_CNT_HI_S)
#define IG3_PBLOC0_GLPBLOC_STAT_RD_HIT_LO 0x4290000C
#define IG3_PBLOC0_GLPBLOC_STAT_RD_HIT_LO_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_RD_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_RD_HIT_LO_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_STAT_RD_MISS_HI 0x42900018
#define IG3_PBLOC0_GLPBLOC_STAT_RD_MISS_HI_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_STAT_RD_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_RD_MISS_HI_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_RD_MISS_HI_CNT_HI_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_RD_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_RD_MISS_HI_CNT_HI_S)
#define IG3_PBLOC0_GLPBLOC_STAT_RD_MISS_LO 0x42900014
#define IG3_PBLOC0_GLPBLOC_STAT_RD_MISS_LO_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_RD_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_RD_MISS_LO_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_STAT_REPLAY_TIME_HI 0x42900074
#define IG3_PBLOC0_GLPBLOC_STAT_REPLAY_TIME_HI_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_STAT_REPLAY_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_REPLAY_TIME_HI_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_REPLAY_TIME_HI_CNT_HI_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_REPLAY_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_REPLAY_TIME_HI_CNT_HI_S)
#define IG3_PBLOC0_GLPBLOC_STAT_REPLAY_TIME_LO 0x42900070
#define IG3_PBLOC0_GLPBLOC_STAT_REPLAY_TIME_LO_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_REPLAY_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_REPLAY_TIME_LO_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_BUFF_FULL_HI 0x4290005C
#define IG3_PBLOC0_GLPBLOC_STAT_WR_BUFF_FULL_HI_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_STAT_WR_BUFF_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_WR_BUFF_FULL_HI_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_WR_BUFF_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_BUFF_FULL_LO 0x42900058
#define IG3_PBLOC0_GLPBLOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_WR_BUFF_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_IDLE_HI 0x42900040
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_IDLE_HI_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_IDLE_HI_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_IDLE_LO 0x4290003C
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_XFER_HI 0x42900048
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_XFER_HI_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_XFER_HI_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_XFER_HI_CNT_HI_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_XFER_LO 0x42900044
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_WR_DATA_XFER_LO_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_HIT_HI 0x42900020
#define IG3_PBLOC0_GLPBLOC_STAT_WR_HIT_HI_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_STAT_WR_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_WR_HIT_HI_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_HIT_HI_CNT_HI_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_WR_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_WR_HIT_HI_CNT_HI_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_HIT_LO 0x4290001C
#define IG3_PBLOC0_GLPBLOC_STAT_WR_HIT_LO_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_WR_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_WR_HIT_LO_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_MISS_HI 0x42900028
#define IG3_PBLOC0_GLPBLOC_STAT_WR_MISS_HI_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_STAT_WR_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_STAT_WR_MISS_HI_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_MISS_HI_CNT_HI_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_WR_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_WR_MISS_HI_CNT_HI_S)
#define IG3_PBLOC0_GLPBLOC_STAT_WR_MISS_LO 0x42900024
#define IG3_PBLOC0_GLPBLOC_STAT_WR_MISS_LO_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_STAT_WR_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_STAT_WR_MISS_LO_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL 0x42900130
#define IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_DONE_S 31
#define IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_DONE_S)
#define IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_RD_EN_S)
#define IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_RSVD_S 26
#define IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_ADR_S 0
#define IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_TAG_DBG_CTL_ADR_S)
#define IG3_PBLOC0_GLPBLOC_TAG_DBG_DATA 0x42900134
#define IG3_PBLOC0_GLPBLOC_TAG_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC0_GLPBLOC_TAG_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_TAG_DBG_DATA_RD_DW_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG 0x429000C8
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RM_S 16
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RM_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RME_S 12
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RME_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS 0x429000CC
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HI 0x429000BC
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HI_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HI_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HI_CNT_HI_S 0
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HI_CNT_HI_S)
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HIT_HI 0x429000C4
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HIT_HI_RSVD_S 24
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HIT_HI_RSVD_S)
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HIT_HI_CNT_HI_S 0
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HIT_HI_CNT_HI_S)
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HIT_LO 0x429000C0
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HIT_LO_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_TOTAL_TAG_HIT_LO_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_LO 0x429000B8
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_LO_CNT_LO_S 0
#define IG3_PBLOC0_GLPBLOC_TOTAL_TAG_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC0_GLPBLOC_TOTAL_TAG_LO_CNT_LO_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG 0x429000D0
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RSVD3_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RM_S 16
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RM_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RSVD2_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RME_S 12
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RME_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS 0x429000D4
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC0_GLPBLOC_WRBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC1_GLPBLOC_ARPTBLE_OBJOFST 0x4290047C
#define IG3_PBLOC1_GLPBLOC_ARPTBLE_OBJOFST_RSVD_S 10
#define IG3_PBLOC1_GLPBLOC_ARPTBLE_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PBLOC1_GLPBLOC_ARPTBLE_OBJOFST_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PBLOC1_GLPBLOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PBLOC1_GLPBLOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PBLOC1_GLPBLOC_CACHESIZE 0x429004AC
#define IG3_PBLOC1_GLPBLOC_CACHESIZE_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_CACHESIZE_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHESIZE_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_CACHESIZE_WAYS_S 20
#define IG3_PBLOC1_GLPBLOC_CACHESIZE_WAYS_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHESIZE_WAYS_S)
#define IG3_PBLOC1_GLPBLOC_CACHESIZE_SETS_S 8
#define IG3_PBLOC1_GLPBLOC_CACHESIZE_SETS_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC1_GLPBLOC_CACHESIZE_SETS_S)
#define IG3_PBLOC1_GLPBLOC_CACHESIZE_WORD_SIZE_S 0
#define IG3_PBLOC1_GLPBLOC_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHESIZE_WORD_SIZE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL 0x42900538
#define IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_DONE_S 31
#define IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_RD_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_RSVD_S 26
#define IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_ADR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_CTL_ADR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_DATA 0x4290053C
#define IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_CACHE_0_DBG_DATA_RD_DW_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG 0x429004F0
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RM_S 16
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RME_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RME_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS 0x429004F4
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_0_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL 0x42900540
#define IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_DONE_S 31
#define IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_RD_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_RSVD_S 26
#define IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_ADR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_CTL_ADR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_DATA 0x42900544
#define IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_CACHE_1_DBG_DATA_RD_DW_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG 0x429004F8
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RM_S 16
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RME_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RME_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS 0x429004FC
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_1_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL 0x42900548
#define IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_DONE_S 31
#define IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_RD_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_RSVD_S 26
#define IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_ADR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_CTL_ADR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_DATA 0x4290054C
#define IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_CACHE_2_DBG_DATA_RD_DW_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG 0x42900500
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RM_S 16
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RME_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RME_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS 0x42900504
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_2_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL 0x42900550
#define IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_DONE_S 31
#define IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_RD_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_RSVD_S 26
#define IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_ADR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_CTL_ADR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_DATA 0x42900554
#define IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_CACHE_3_DBG_DATA_RD_DW_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG 0x42900508
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RM_S 16
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RME_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RME_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS 0x4290050C
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_3_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL 0x42900558
#define IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_DONE_S 31
#define IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_RD_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_RSVD_S 26
#define IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_ADR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_CTL_ADR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_DATA 0x4290055C
#define IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_CACHE_4_DBG_DATA_RD_DW_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG 0x42900510
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RM_S 16
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RME_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RME_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS 0x42900514
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_4_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL 0x42900560
#define IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_DONE_S 31
#define IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_RD_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_RSVD_S 26
#define IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_ADR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_CTL_ADR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_DATA 0x42900564
#define IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_CACHE_5_DBG_DATA_RD_DW_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG 0x42900518
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RM_S 16
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RME_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RME_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS 0x4290051C
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_5_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL 0x42900568
#define IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_DONE_S 31
#define IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_RD_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_RSVD_S 26
#define IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_ADR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_CTL_ADR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_DATA 0x4290056C
#define IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_CACHE_6_DBG_DATA_RD_DW_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG 0x42900520
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RM_S 16
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RME_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RME_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS 0x42900524
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_6_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL 0x42900570
#define IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_DONE_S 31
#define IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_RD_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_RSVD_S 26
#define IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_ADR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_CTL_ADR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_DATA 0x42900574
#define IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_CACHE_7_DBG_DATA_RD_DW_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG 0x42900528
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RM_S 16
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RM_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RME_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RME_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS 0x4290052C
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CACHE_7_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_CTRL 0x42900400
#define IG3_PBLOC1_GLPBLOC_CACHE_CTRL_RSVD_S 2
#define IG3_PBLOC1_GLPBLOC_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_PBLOC1_GLPBLOC_CACHE_CTRL_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_CACHE_CTRL_SCALE_FACTOR_S 0
#define IG3_PBLOC1_GLPBLOC_CACHE_CTRL_SCALE_FACTOR_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_CACHE_CTRL_SCALE_FACTOR_S)
#define IG3_PBLOC1_GLPBLOC_CECC_ERR 0x4290049C
#define IG3_PBLOC1_GLPBLOC_CECC_ERR_RSVD1_S 28
#define IG3_PBLOC1_GLPBLOC_CECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CECC_ERR_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PBLOC1_GLPBLOC_CECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC1_GLPBLOC_CECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CECC_ERR_RSVD0_S 12
#define IG3_PBLOC1_GLPBLOC_CECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_CECC_ERR_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PBLOC1_GLPBLOC_CECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC1_GLPBLOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_CSTATELKUP_CFG 0x429004A4
#define IG3_PBLOC1_GLPBLOC_CSTATELKUP_CFG_RSVD1_S 9
#define IG3_PBLOC1_GLPBLOC_CSTATELKUP_CFG_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PBLOC1_GLPBLOC_CSTATELKUP_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S 8
#define IG3_PBLOC1_GLPBLOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S)
#define IG3_PBLOC1_GLPBLOC_CSTATELKUP_CFG_RSVD0_S 3
#define IG3_PBLOC1_GLPBLOC_CSTATELKUP_CFG_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_CSTATELKUP_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S 0
#define IG3_PBLOC1_GLPBLOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_M RDMA_MASK3(32, 0x7, IG3_PBLOC1_GLPBLOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S)
#define IG3_PBLOC1_GLPBLOC_DPC_COMP 0x429004B4
#define IG3_PBLOC1_GLPBLOC_DPC_COMP_RSVD_S 13
#define IG3_PBLOC1_GLPBLOC_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PBLOC1_GLPBLOC_DPC_COMP_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_DPC_COMP_COMP_FTYPE_S 11
#define IG3_PBLOC1_GLPBLOC_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_DPC_COMP_COMP_FTYPE_S)
#define IG3_PBLOC1_GLPBLOC_DPC_COMP_COMP_FNUM_S 1
#define IG3_PBLOC1_GLPBLOC_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PBLOC1_GLPBLOC_DPC_COMP_COMP_FNUM_S)
#define IG3_PBLOC1_GLPBLOC_DPC_COMP_COMP_VALID_S 0
#define IG3_PBLOC1_GLPBLOC_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DPC_COMP_COMP_VALID_S)
#define IG3_PBLOC1_GLPBLOC_DPC_REQ 0x429004B0
#define IG3_PBLOC1_GLPBLOC_DPC_REQ_RSVD_S 12
#define IG3_PBLOC1_GLPBLOC_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC1_GLPBLOC_DPC_REQ_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_DPC_REQ_REQ_FTYPE_S 10
#define IG3_PBLOC1_GLPBLOC_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_DPC_REQ_REQ_FTYPE_S)
#define IG3_PBLOC1_GLPBLOC_DPC_REQ_REQ_FNUM_S 0
#define IG3_PBLOC1_GLPBLOC_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PBLOC1_GLPBLOC_DPC_REQ_REQ_FNUM_S)
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_COUNT 0x42900638
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC1_GLPBLOC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC1_GLPBLOC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_CMD 0x4290064C
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_DATA_H 0x42900658
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_DATA_L 0x42900654
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_PTR 0x42900650
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC1_GLPBLOC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_CMD 0x4290063C
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_DATA_H 0x42900648
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_DATA_L 0x42900644
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_PTR 0x42900640
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC1_GLPBLOC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL 0x42900600
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_RSVD1_S 25
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_DTM_CONTROL_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_RSVD2_S 17
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_DTM_CONTROL_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_RSVD3_S 9
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_DTM_CONTROL_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_BYPASS_S 8
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_CONTROL_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_RSVD4_S 1
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_DTM_CONTROL_RSVD4_S)
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PBLOC1_GLPBLOC_DTM_ECC_COR_ERR 0x42900668
#define IG3_PBLOC1_GLPBLOC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PBLOC1_GLPBLOC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC1_GLPBLOC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC1_GLPBLOC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_DTM_ECC_UNCOR_ERR 0x42900664
#define IG3_PBLOC1_GLPBLOC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PBLOC1_GLPBLOC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC1_GLPBLOC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC1_GLPBLOC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_DTM_GROUP_CFG 0x4290060C
#define IG3_PBLOC1_GLPBLOC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PBLOC1_GLPBLOC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PBLOC1_GLPBLOC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PBLOC1_GLPBLOC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PBLOC1_GLPBLOC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PBLOC1_GLPBLOC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PBLOC1_GLPBLOC_DTM_LOG_CFG 0x42900610
#define IG3_PBLOC1_GLPBLOC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PBLOC1_GLPBLOC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PBLOC1_GLPBLOC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PBLOC1_GLPBLOC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PBLOC1_GLPBLOC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PBLOC1_GLPBLOC_DTM_LOG_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_DTM_LOG_CFG_MODE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_DTM_LOG_CFG_MODE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_LOG_MASK 0x42900618
#define IG3_PBLOC1_GLPBLOC_DTM_LOG_MASK_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_DTM_LOG_MASK_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_LOG_PATTERN 0x42900614
#define IG3_PBLOC1_GLPBLOC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG 0x42900604
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_STS 0x42900608
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PBLOC1_GLPBLOC_DTM_MAIN_STS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_DTM_MAIN_STS_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TIMESTAMP 0x42900630
#define IG3_PBLOC1_GLPBLOC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_DTM_TIMESTAMP_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TIMESTAMP_ROLLOVER 0x42900634
#define IG3_PBLOC1_GLPBLOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG 0x4290065C
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS 0x42900660
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG 0x4290061C
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_MODE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_DTM_TRIG_CFG_MODE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_COUNT 0x42900628
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_MASK 0x42900624
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_DTM_TRIG_MASK_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_PATTERN 0x42900620
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_TIMESTAMP 0x4290062C
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PBLOC1_GLPBLOC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PBLOC1_GLPBLOC_ECC_CTL 0x42900494
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_RSVD_S 8
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_ECC_CTL_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_CLIENT_ECC_INVERT2_S 7
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_CLIENT_ECC_INVERT2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_ECC_CTL_CLIENT_ECC_INVERT2_S)
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_CLIENT_ECC_INVERT1_S 6
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_CLIENT_ECC_INVERT1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_ECC_CTL_CLIENT_ECC_INVERT1_S)
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_CLIENT_ECC_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_CLIENT_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_ECC_CTL_CLIENT_ECC_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_CLIENT_ECC_EN_S 4
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_CLIENT_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_ECC_CTL_CLIENT_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_HOST_ECC_INVERT2_S 3
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_HOST_ECC_INVERT2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_ECC_CTL_HOST_ECC_INVERT2_S)
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_HOST_ECC_INVERT1_S 2
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_HOST_ECC_INVERT1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_ECC_CTL_HOST_ECC_INVERT1_S)
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_HOST_ECC_MASK_INT_S 1
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_HOST_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_ECC_CTL_HOST_ECC_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_HOST_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_ECC_CTL_HOST_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_ECC_CTL_HOST_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA0 0x42900484
#define IG3_PBLOC1_GLPBLOC_ERRDATA0_RSVD1_S 31
#define IG3_PBLOC1_GLPBLOC_ERRDATA0_RSVD1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_ERRDATA0_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA0_PF_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_ERRDATA0_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PBLOC1_GLPBLOC_ERRDATA0_PF_NUM_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA0_VDEV_VF_NUM_S 15
#define IG3_PBLOC1_GLPBLOC_ERRDATA0_VDEV_VF_NUM_M RDMA_MASK3(32, 0x3FF, IG3_PBLOC1_GLPBLOC_ERRDATA0_VDEV_VF_NUM_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA0_VDEV_VF_TYPE_S 13
#define IG3_PBLOC1_GLPBLOC_ERRDATA0_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_ERRDATA0_VDEV_VF_TYPE_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA0_OBJ_TYPE_S 8
#define IG3_PBLOC1_GLPBLOC_ERRDATA0_OBJ_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_ERRDATA0_OBJ_TYPE_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA0_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_ERRDATA0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_ERRDATA0_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA0_ERROR_CODE_S 0
#define IG3_PBLOC1_GLPBLOC_ERRDATA0_ERROR_CODE_M RDMA_MASK3(32, 0x3F, IG3_PBLOC1_GLPBLOC_ERRDATA0_ERROR_CODE_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA1 0x42900488
#define IG3_PBLOC1_GLPBLOC_ERRDATA1_RSVD_S 28
#define IG3_PBLOC1_GLPBLOC_ERRDATA1_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_ERRDATA1_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA1_OBJ_INDEX_S 0
#define IG3_PBLOC1_GLPBLOC_ERRDATA1_OBJ_INDEX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PBLOC1_GLPBLOC_ERRDATA1_OBJ_INDEX_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA2 0x4290048C
#define IG3_PBLOC1_GLPBLOC_ERRDATA2_RSVD_S 23
#define IG3_PBLOC1_GLPBLOC_ERRDATA2_RSVD_M RDMA_MASK3(32, 0x1FF, IG3_PBLOC1_GLPBLOC_ERRDATA2_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA2_OPTYPE_S 20
#define IG3_PBLOC1_GLPBLOC_ERRDATA2_OPTYPE_M RDMA_MASK3(32, 0x7, IG3_PBLOC1_GLPBLOC_ERRDATA2_OPTYPE_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA2_OFFSET_S 7
#define IG3_PBLOC1_GLPBLOC_ERRDATA2_OFFSET_M RDMA_MASK3(32, 0x1FFF, IG3_PBLOC1_GLPBLOC_ERRDATA2_OFFSET_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA2_LENGTH_S 0
#define IG3_PBLOC1_GLPBLOC_ERRDATA2_LENGTH_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_ERRDATA2_LENGTH_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA3 0x42900490
#define IG3_PBLOC1_GLPBLOC_ERRDATA3_RSVD_S 15
#define IG3_PBLOC1_GLPBLOC_ERRDATA3_RSVD_M RDMA_MASK3(32, 0x1FFFF, IG3_PBLOC1_GLPBLOC_ERRDATA3_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_ERRDATA3_TAG_S 0
#define IG3_PBLOC1_GLPBLOC_ERRDATA3_TAG_M RDMA_MASK3(32, 0x7FFF, IG3_PBLOC1_GLPBLOC_ERRDATA3_TAG_S)
#define IG3_PBLOC1_GLPBLOC_ERRINFO 0x42900480
#define IG3_PBLOC1_GLPBLOC_ERRINFO_RSVD1_S 16
#define IG3_PBLOC1_GLPBLOC_ERRINFO_RSVD1_M RDMA_MASK3(32, 0xFFFF, IG3_PBLOC1_GLPBLOC_ERRINFO_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_ERRINFO_ERROR_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_ERRINFO_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_ERRINFO_ERROR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_ERRINFO_RSVD0_S 1
#define IG3_PBLOC1_GLPBLOC_ERRINFO_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_ERRINFO_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_ERRINFO_ERROR_VALID_S 0
#define IG3_PBLOC1_GLPBLOC_ERRINFO_ERROR_VALID_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_ERRINFO_ERROR_VALID_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG 0x429004E8
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RM_S 16
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RM_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RME_S 12
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RME_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_EVICT_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS 0x429004EC
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_EVICT_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG 0x429004E0
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RM_S 16
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RM_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RME_S 12
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RME_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_FILL_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS 0x429004E4
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_FILL_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC1_GLPBLOC_HECC_ERR 0x42900498
#define IG3_PBLOC1_GLPBLOC_HECC_ERR_RSVD1_S 28
#define IG3_PBLOC1_GLPBLOC_HECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_HECC_ERR_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_HECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PBLOC1_GLPBLOC_HECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC1_GLPBLOC_HECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_HECC_ERR_RSVD0_S 12
#define IG3_PBLOC1_GLPBLOC_HECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_HECC_ERR_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PBLOC1_GLPBLOC_HECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC1_GLPBLOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_MAXOSR 0x429004A0
#define IG3_PBLOC1_GLPBLOC_MAXOSR_RSVD1_S 11
#define IG3_PBLOC1_GLPBLOC_MAXOSR_RSVD1_M RDMA_MASK3(32, 0x1FFFFF, IG3_PBLOC1_GLPBLOC_MAXOSR_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S 10
#define IG3_PBLOC1_GLPBLOC_MAXOSR_MAX_OSR_CLNT_WRPULL_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S)
#define IG3_PBLOC1_GLPBLOC_MAXOSR_RSVD0_S 8
#define IG3_PBLOC1_GLPBLOC_MAXOSR_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_MAXOSR_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_MAXOSR_MAX_OSR_PMAT_FETCH_S 0
#define IG3_PBLOC1_GLPBLOC_MAXOSR_MAX_OSR_PMAT_FETCH_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_MAXOSR_MAX_OSR_PMAT_FETCH_S)
#define IG3_PBLOC1_GLPBLOC_MEM_ECC_COR_ERR 0x42900584
#define IG3_PBLOC1_GLPBLOC_MEM_ECC_COR_ERR_RSVD_S 12
#define IG3_PBLOC1_GLPBLOC_MEM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC1_GLPBLOC_MEM_ECC_COR_ERR_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_MEM_ECC_COR_ERR_CNT_S 0
#define IG3_PBLOC1_GLPBLOC_MEM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC1_GLPBLOC_MEM_ECC_COR_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_MEM_ECC_UNCOR_ERR 0x42900580
#define IG3_PBLOC1_GLPBLOC_MEM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PBLOC1_GLPBLOC_MEM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PBLOC1_GLPBLOC_MEM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_MEM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PBLOC1_GLPBLOC_MEM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PBLOC1_GLPBLOC_MEM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_PBLE_OBJOFST 0x42900478
#define IG3_PBLOC1_GLPBLOC_PBLE_OBJOFST_RSVD_S 10
#define IG3_PBLOC1_GLPBLOC_PBLE_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PBLOC1_GLPBLOC_PBLE_OBJOFST_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_PBLE_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PBLOC1_GLPBLOC_PBLE_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PBLOC1_GLPBLOC_PBLE_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL 0x42900578
#define IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_DONE_S 31
#define IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_DONE_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_RD_EN_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_RSVD_S 26
#define IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_ADR_S 0
#define IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_PLIST_DBG_CTL_ADR_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_DBG_DATA 0x4290057C
#define IG3_PBLOC1_GLPBLOC_PLIST_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC1_GLPBLOC_PLIST_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_PLIST_DBG_DATA_RD_DW_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG 0x429004D8
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RM_S 16
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RM_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RME_S 12
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RME_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS 0x429004DC
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PLIST_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG 0x429004A8
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG_RSVD_S 6
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_PBLOC1_GLPBLOC_PMATINV_CFG_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S 5
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S)
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S 4
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S 3
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S)
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S 2
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S)
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S 1
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG_INVBYFN_FENCE_EN_S 0
#define IG3_PBLOC1_GLPBLOC_PMATINV_CFG_INVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_PMATINV_CFG_INVBYFN_FENCE_EN_S)
#define IG3_PBLOC1_GLPBLOC_STAT_CTL 0x42900404
#define IG3_PBLOC1_GLPBLOC_STAT_CTL_RSVD_S 5
#define IG3_PBLOC1_GLPBLOC_STAT_CTL_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PBLOC1_GLPBLOC_STAT_CTL_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_CTL_OBJECT_TYPE_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_CTL_OBJECT_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_STAT_CTL_OBJECT_TYPE_S)
#define IG3_PBLOC1_GLPBLOC_STAT_FENCING_TIME_HI 0x4290046C
#define IG3_PBLOC1_GLPBLOC_STAT_FENCING_TIME_HI_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_STAT_FENCING_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_FENCING_TIME_HI_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_FENCING_TIME_HI_CNT_HI_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_FENCING_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_FENCING_TIME_HI_CNT_HI_S)
#define IG3_PBLOC1_GLPBLOC_STAT_FENCING_TIME_LO 0x42900468
#define IG3_PBLOC1_GLPBLOC_STAT_FENCING_TIME_LO_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_FENCING_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_FENCING_TIME_LO_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_PENDING_ENTRIES 0x4290044C
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_PENDING_ENTRIES_RSVD_S 8
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_PENDING_ENTRIES_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_MAX_PENDING_ENTRIES_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_PENDING_ENTRIES_CNT_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_PENDING_ENTRIES_CNT_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_MAX_PENDING_ENTRIES_CNT_S)
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_PENDING_LIST_DEPTH 0x42900454
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S 8
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_VIRT_PENDING_LISTS 0x42900450
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S 8
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_STAT_OBJ_CNT 0x42900408
#define IG3_PBLOC1_GLPBLOC_STAT_OBJ_CNT_RSVD_S 14
#define IG3_PBLOC1_GLPBLOC_STAT_OBJ_CNT_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_STAT_OBJ_CNT_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_OBJ_CNT_OBJECT_COUNT_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_OBJ_CNT_OBJECT_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PBLOC1_GLPBLOC_STAT_OBJ_CNT_OBJECT_COUNT_S)
#define IG3_PBLOC1_GLPBLOC_STAT_PENDLING_LIST_FULL_HI 0x42900464
#define IG3_PBLOC1_GLPBLOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_STAT_PENDLING_LIST_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S)
#define IG3_PBLOC1_GLPBLOC_STAT_PENDLING_LIST_FULL_LO 0x42900460
#define IG3_PBLOC1_GLPBLOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_IDLE_HI 0x42900430
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_IDLE_HI_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_IDLE_HI_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_IDLE_LO 0x4290042C
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_XFER_HI 0x42900438
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_XFER_HI_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_XFER_HI_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_XFER_HI_CNT_HI_S)
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_XFER_LO 0x42900434
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_RD_DATA_XFER_LO_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_STAT_RD_HIT_HI 0x42900410
#define IG3_PBLOC1_GLPBLOC_STAT_RD_HIT_HI_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_STAT_RD_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_RD_HIT_HI_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_RD_HIT_HI_CNT_HI_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_RD_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_RD_HIT_HI_CNT_HI_S)
#define IG3_PBLOC1_GLPBLOC_STAT_RD_HIT_LO 0x4290040C
#define IG3_PBLOC1_GLPBLOC_STAT_RD_HIT_LO_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_RD_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_RD_HIT_LO_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_STAT_RD_MISS_HI 0x42900418
#define IG3_PBLOC1_GLPBLOC_STAT_RD_MISS_HI_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_STAT_RD_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_RD_MISS_HI_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_RD_MISS_HI_CNT_HI_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_RD_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_RD_MISS_HI_CNT_HI_S)
#define IG3_PBLOC1_GLPBLOC_STAT_RD_MISS_LO 0x42900414
#define IG3_PBLOC1_GLPBLOC_STAT_RD_MISS_LO_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_RD_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_RD_MISS_LO_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_STAT_REPLAY_TIME_HI 0x42900474
#define IG3_PBLOC1_GLPBLOC_STAT_REPLAY_TIME_HI_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_STAT_REPLAY_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_REPLAY_TIME_HI_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_REPLAY_TIME_HI_CNT_HI_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_REPLAY_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_REPLAY_TIME_HI_CNT_HI_S)
#define IG3_PBLOC1_GLPBLOC_STAT_REPLAY_TIME_LO 0x42900470
#define IG3_PBLOC1_GLPBLOC_STAT_REPLAY_TIME_LO_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_REPLAY_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_REPLAY_TIME_LO_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_BUFF_FULL_HI 0x4290045C
#define IG3_PBLOC1_GLPBLOC_STAT_WR_BUFF_FULL_HI_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_STAT_WR_BUFF_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_WR_BUFF_FULL_HI_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_WR_BUFF_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_BUFF_FULL_LO 0x42900458
#define IG3_PBLOC1_GLPBLOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_WR_BUFF_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_IDLE_HI 0x42900440
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_IDLE_HI_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_IDLE_HI_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_IDLE_LO 0x4290043C
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_XFER_HI 0x42900448
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_XFER_HI_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_XFER_HI_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_XFER_HI_CNT_HI_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_XFER_LO 0x42900444
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_WR_DATA_XFER_LO_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_HIT_HI 0x42900420
#define IG3_PBLOC1_GLPBLOC_STAT_WR_HIT_HI_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_STAT_WR_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_WR_HIT_HI_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_HIT_HI_CNT_HI_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_WR_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_WR_HIT_HI_CNT_HI_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_HIT_LO 0x4290041C
#define IG3_PBLOC1_GLPBLOC_STAT_WR_HIT_LO_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_WR_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_WR_HIT_LO_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_MISS_HI 0x42900428
#define IG3_PBLOC1_GLPBLOC_STAT_WR_MISS_HI_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_STAT_WR_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_STAT_WR_MISS_HI_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_MISS_HI_CNT_HI_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_WR_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_WR_MISS_HI_CNT_HI_S)
#define IG3_PBLOC1_GLPBLOC_STAT_WR_MISS_LO 0x42900424
#define IG3_PBLOC1_GLPBLOC_STAT_WR_MISS_LO_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_STAT_WR_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_STAT_WR_MISS_LO_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL 0x42900530
#define IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_DONE_S 31
#define IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_DONE_S)
#define IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_RD_EN_S 30
#define IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_RD_EN_S)
#define IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_RSVD_S 26
#define IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_DW_SEL_S 18
#define IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_DW_SEL_S)
#define IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_ADR_S 0
#define IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_TAG_DBG_CTL_ADR_S)
#define IG3_PBLOC1_GLPBLOC_TAG_DBG_DATA 0x42900534
#define IG3_PBLOC1_GLPBLOC_TAG_DBG_DATA_RD_DW_S 0
#define IG3_PBLOC1_GLPBLOC_TAG_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_TAG_DBG_DATA_RD_DW_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG 0x429004C8
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RM_S 16
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RM_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RME_S 12
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RME_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS 0x429004CC
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HI 0x429004BC
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HI_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HI_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HI_CNT_HI_S 0
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HI_CNT_HI_S)
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HIT_HI 0x429004C4
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HIT_HI_RSVD_S 24
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HIT_HI_RSVD_S)
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HIT_HI_CNT_HI_S 0
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HIT_HI_CNT_HI_S)
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HIT_LO 0x429004C0
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HIT_LO_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_TOTAL_TAG_HIT_LO_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_LO 0x429004B8
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_LO_CNT_LO_S 0
#define IG3_PBLOC1_GLPBLOC_TOTAL_TAG_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PBLOC1_GLPBLOC_TOTAL_TAG_LO_CNT_LO_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG 0x429004D0
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RSVD3_S 20
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RSVD3_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RM_S 16
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RM_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RSVD2_S 14
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RSVD2_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RME_S 12
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RME_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RSVD1_S 10
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ERR_CNT_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_FIX_CNT_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RSVD0_S 6
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_MASK_INT_S 5
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_MASK_INT_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_LS_FORCE_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ECC_EN_S 0
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_CFG_ECC_EN_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS 0x429004D4
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_RSVD1_S 30
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_RSVD1_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_RSVD0_S 4
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_RSVD0_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PBLOC1_GLPBLOC_WRBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLMSOC_ARPTBLE_OBJOFST 0x42900878
#define IG3_MSOC_GLMSOC_ARPTBLE_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_ARPTBLE_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_ARPTBLE_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLMSOC_CACHESIZE 0x429008E0
#define IG3_MSOC_GLMSOC_CACHESIZE_RSVD_S 24
#define IG3_MSOC_GLMSOC_CACHESIZE_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHESIZE_RSVD_S)
#define IG3_MSOC_GLMSOC_CACHESIZE_WAYS_S 20
#define IG3_MSOC_GLMSOC_CACHESIZE_WAYS_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHESIZE_WAYS_S)
#define IG3_MSOC_GLMSOC_CACHESIZE_SETS_S 8
#define IG3_MSOC_GLMSOC_CACHESIZE_SETS_M RDMA_MASK3(32, 0xFFF, IG3_MSOC_GLMSOC_CACHESIZE_SETS_S)
#define IG3_MSOC_GLMSOC_CACHESIZE_WORD_SIZE_S 0
#define IG3_MSOC_GLMSOC_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHESIZE_WORD_SIZE_S)
#define IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL 0x4290096C
#define IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_DONE_S 31
#define IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_RD_EN_S 30
#define IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_RD_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_RSVD_S 26
#define IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_RSVD_S)
#define IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_DW_SEL_S 18
#define IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_DW_SEL_S)
#define IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_ADR_S 0
#define IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_0_DBG_CTL_ADR_S)
#define IG3_MSOC_GLMSOC_CACHE_0_DBG_DATA 0x42900970
#define IG3_MSOC_GLMSOC_CACHE_0_DBG_DATA_RD_DW_S 0
#define IG3_MSOC_GLMSOC_CACHE_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_CACHE_0_DBG_DATA_RD_DW_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG 0x42900924
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RSVD3_S 20
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RSVD3_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RM_S 16
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RM_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RSVD2_S 14
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RSVD2_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RME_S 12
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RME_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RSVD1_S 10
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ERR_CNT_S 9
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_FIX_CNT_S 8
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_FIX_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RSVD0_S 6
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_MASK_INT_S 5
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_MASK_INT_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_LS_BYPASS_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_LS_FORCE_S 3
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_LS_FORCE_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ECC_EN_S 0
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_MEM_CFG_ECC_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS 0x42900928
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_RSVD1_S 30
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_RSVD0_S 4
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_ECC_FIX_S)
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_0_MEM_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL 0x42900974
#define IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_DONE_S 31
#define IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_RD_EN_S 30
#define IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_RD_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_RSVD_S 26
#define IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_RSVD_S)
#define IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_DW_SEL_S 18
#define IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_DW_SEL_S)
#define IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_ADR_S 0
#define IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_1_DBG_CTL_ADR_S)
#define IG3_MSOC_GLMSOC_CACHE_1_DBG_DATA 0x42900978
#define IG3_MSOC_GLMSOC_CACHE_1_DBG_DATA_RD_DW_S 0
#define IG3_MSOC_GLMSOC_CACHE_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_CACHE_1_DBG_DATA_RD_DW_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG 0x4290092C
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RSVD3_S 20
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RSVD3_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RM_S 16
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RM_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RSVD2_S 14
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RSVD2_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RME_S 12
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RME_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RSVD1_S 10
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ERR_CNT_S 9
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_FIX_CNT_S 8
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_FIX_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RSVD0_S 6
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_MASK_INT_S 5
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_MASK_INT_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_LS_BYPASS_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_LS_FORCE_S 3
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_LS_FORCE_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ECC_EN_S 0
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_MEM_CFG_ECC_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS 0x42900930
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_RSVD1_S 30
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_RSVD0_S 4
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_ECC_FIX_S)
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_1_MEM_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL 0x4290097C
#define IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_DONE_S 31
#define IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_RD_EN_S 30
#define IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_RD_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_RSVD_S 26
#define IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_RSVD_S)
#define IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_DW_SEL_S 18
#define IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_DW_SEL_S)
#define IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_ADR_S 0
#define IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_2_DBG_CTL_ADR_S)
#define IG3_MSOC_GLMSOC_CACHE_2_DBG_DATA 0x42900980
#define IG3_MSOC_GLMSOC_CACHE_2_DBG_DATA_RD_DW_S 0
#define IG3_MSOC_GLMSOC_CACHE_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_CACHE_2_DBG_DATA_RD_DW_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG 0x42900934
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RSVD3_S 20
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RSVD3_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RM_S 16
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RM_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RSVD2_S 14
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RSVD2_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RME_S 12
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RME_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RSVD1_S 10
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ERR_CNT_S 9
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_FIX_CNT_S 8
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_FIX_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RSVD0_S 6
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_MASK_INT_S 5
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_MASK_INT_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_LS_BYPASS_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_LS_FORCE_S 3
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_LS_FORCE_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ECC_EN_S 0
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_MEM_CFG_ECC_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS 0x42900938
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_RSVD1_S 30
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_RSVD0_S 4
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_ECC_FIX_S)
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_2_MEM_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL 0x42900984
#define IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_DONE_S 31
#define IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_RD_EN_S 30
#define IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_RD_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_RSVD_S 26
#define IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_RSVD_S)
#define IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_DW_SEL_S 18
#define IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_DW_SEL_S)
#define IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_ADR_S 0
#define IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_3_DBG_CTL_ADR_S)
#define IG3_MSOC_GLMSOC_CACHE_3_DBG_DATA 0x42900988
#define IG3_MSOC_GLMSOC_CACHE_3_DBG_DATA_RD_DW_S 0
#define IG3_MSOC_GLMSOC_CACHE_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_CACHE_3_DBG_DATA_RD_DW_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG 0x4290093C
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RSVD3_S 20
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RSVD3_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RM_S 16
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RM_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RSVD2_S 14
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RSVD2_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RME_S 12
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RME_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RSVD1_S 10
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ERR_CNT_S 9
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_FIX_CNT_S 8
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_FIX_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RSVD0_S 6
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_MASK_INT_S 5
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_MASK_INT_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_LS_BYPASS_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_LS_FORCE_S 3
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_LS_FORCE_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ECC_EN_S 0
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_MEM_CFG_ECC_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS 0x42900940
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_RSVD1_S 30
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_RSVD0_S 4
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_ECC_FIX_S)
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_3_MEM_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL 0x4290098C
#define IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_DONE_S 31
#define IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_RD_EN_S 30
#define IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_RD_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_RSVD_S 26
#define IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_RSVD_S)
#define IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_DW_SEL_S 18
#define IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_DW_SEL_S)
#define IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_ADR_S 0
#define IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_4_DBG_CTL_ADR_S)
#define IG3_MSOC_GLMSOC_CACHE_4_DBG_DATA 0x42900990
#define IG3_MSOC_GLMSOC_CACHE_4_DBG_DATA_RD_DW_S 0
#define IG3_MSOC_GLMSOC_CACHE_4_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_CACHE_4_DBG_DATA_RD_DW_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG 0x42900944
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RSVD3_S 20
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RSVD3_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RM_S 16
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RM_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RSVD2_S 14
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RSVD2_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RME_S 12
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RME_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RSVD1_S 10
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ERR_CNT_S 9
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_FIX_CNT_S 8
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_FIX_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RSVD0_S 6
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_MASK_INT_S 5
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_MASK_INT_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_LS_BYPASS_S 4
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_LS_BYPASS_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_LS_FORCE_S 3
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_LS_FORCE_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ECC_EN_S 0
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_MEM_CFG_ECC_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS 0x42900948
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_RSVD1_S 30
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_RSVD0_S 4
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_INIT_DONE_S 2
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_ECC_FIX_S 1
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_ECC_FIX_S)
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_ECC_ERR_S 0
#define IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_4_MEM_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL 0x42900994
#define IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_DONE_S 31
#define IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_RD_EN_S 30
#define IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_RD_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_RSVD_S 26
#define IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_RSVD_S)
#define IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_DW_SEL_S 18
#define IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_DW_SEL_S)
#define IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_ADR_S 0
#define IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_5_DBG_CTL_ADR_S)
#define IG3_MSOC_GLMSOC_CACHE_5_DBG_DATA 0x42900998
#define IG3_MSOC_GLMSOC_CACHE_5_DBG_DATA_RD_DW_S 0
#define IG3_MSOC_GLMSOC_CACHE_5_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_CACHE_5_DBG_DATA_RD_DW_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG 0x4290094C
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RSVD3_S 20
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RSVD3_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RM_S 16
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RM_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RSVD2_S 14
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RSVD2_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RME_S 12
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RME_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RSVD1_S 10
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ERR_CNT_S 9
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_FIX_CNT_S 8
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_FIX_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RSVD0_S 6
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_MASK_INT_S 5
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_MASK_INT_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_LS_BYPASS_S 4
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_LS_BYPASS_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_LS_FORCE_S 3
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_LS_FORCE_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ECC_EN_S 0
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_MEM_CFG_ECC_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS 0x42900950
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_RSVD1_S 30
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_RSVD0_S 4
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_INIT_DONE_S 2
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_ECC_FIX_S 1
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_ECC_FIX_S)
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_ECC_ERR_S 0
#define IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_5_MEM_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL 0x4290099C
#define IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_DONE_S 31
#define IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_RD_EN_S 30
#define IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_RD_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_RSVD_S 26
#define IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_RSVD_S)
#define IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_DW_SEL_S 18
#define IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_DW_SEL_S)
#define IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_ADR_S 0
#define IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_6_DBG_CTL_ADR_S)
#define IG3_MSOC_GLMSOC_CACHE_6_DBG_DATA 0x429009A0
#define IG3_MSOC_GLMSOC_CACHE_6_DBG_DATA_RD_DW_S 0
#define IG3_MSOC_GLMSOC_CACHE_6_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_CACHE_6_DBG_DATA_RD_DW_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG 0x42900954
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RSVD3_S 20
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RSVD3_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RM_S 16
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RM_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RSVD2_S 14
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RSVD2_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RME_S 12
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RME_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RSVD1_S 10
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ERR_CNT_S 9
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_FIX_CNT_S 8
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_FIX_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RSVD0_S 6
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_MASK_INT_S 5
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_MASK_INT_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_LS_BYPASS_S 4
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_LS_BYPASS_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_LS_FORCE_S 3
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_LS_FORCE_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ECC_EN_S 0
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_MEM_CFG_ECC_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS 0x42900958
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_RSVD1_S 30
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_RSVD0_S 4
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_INIT_DONE_S 2
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_ECC_FIX_S 1
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_ECC_FIX_S)
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_ECC_ERR_S 0
#define IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_6_MEM_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL 0x429009A4
#define IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_DONE_S 31
#define IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_RD_EN_S 30
#define IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_RD_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_RSVD_S 26
#define IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_RSVD_S)
#define IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_DW_SEL_S 18
#define IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_DW_SEL_S)
#define IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_ADR_S 0
#define IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_7_DBG_CTL_ADR_S)
#define IG3_MSOC_GLMSOC_CACHE_7_DBG_DATA 0x429009A8
#define IG3_MSOC_GLMSOC_CACHE_7_DBG_DATA_RD_DW_S 0
#define IG3_MSOC_GLMSOC_CACHE_7_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_CACHE_7_DBG_DATA_RD_DW_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG 0x4290095C
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RSVD3_S 20
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RSVD3_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RM_S 16
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RM_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RSVD2_S 14
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RSVD2_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RME_S 12
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RME_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RSVD1_S 10
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ERR_CNT_S 9
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_FIX_CNT_S 8
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_FIX_CNT_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RSVD0_S 6
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_MASK_INT_S 5
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_MASK_INT_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_LS_BYPASS_S 4
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_LS_BYPASS_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_LS_FORCE_S 3
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_LS_FORCE_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ECC_EN_S 0
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_MEM_CFG_ECC_EN_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS 0x42900960
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_RSVD1_S 30
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_RSVD1_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_RSVD0_S 4
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_RSVD0_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_INIT_DONE_S 2
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_ECC_FIX_S 1
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_ECC_FIX_S)
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_ECC_ERR_S 0
#define IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CACHE_7_MEM_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLMSOC_CACHE_CTRL 0x42900800
#define IG3_MSOC_GLMSOC_CACHE_CTRL_RSVD_S 2
#define IG3_MSOC_GLMSOC_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_MSOC_GLMSOC_CACHE_CTRL_RSVD_S)
#define IG3_MSOC_GLMSOC_CACHE_CTRL_SCALE_FACTOR_S 0
#define IG3_MSOC_GLMSOC_CACHE_CTRL_SCALE_FACTOR_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_CACHE_CTRL_SCALE_FACTOR_S)
#define IG3_MSOC_GLMSOC_CECC_ERR 0x429008D0
#define IG3_MSOC_GLMSOC_CECC_ERR_RSVD1_S 28
#define IG3_MSOC_GLMSOC_CECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CECC_ERR_RSVD1_S)
#define IG3_MSOC_GLMSOC_CECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_MSOC_GLMSOC_CECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_MSOC_GLMSOC_CECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_CECC_ERR_RSVD0_S 12
#define IG3_MSOC_GLMSOC_CECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_CECC_ERR_RSVD0_S)
#define IG3_MSOC_GLMSOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_MSOC_GLMSOC_CECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_MSOC_GLMSOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_CQCTX_OBJOFST 0x42900884
#define IG3_MSOC_GLMSOC_CQCTX_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_CQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_CQCTX_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLMSOC_CSTATELKUP_CFG 0x429008D8
#define IG3_MSOC_GLMSOC_CSTATELKUP_CFG_RSVD1_S 9
#define IG3_MSOC_GLMSOC_CSTATELKUP_CFG_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_MSOC_GLMSOC_CSTATELKUP_CFG_RSVD1_S)
#define IG3_MSOC_GLMSOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S 8
#define IG3_MSOC_GLMSOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S)
#define IG3_MSOC_GLMSOC_CSTATELKUP_CFG_RSVD0_S 3
#define IG3_MSOC_GLMSOC_CSTATELKUP_CFG_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_CSTATELKUP_CFG_RSVD0_S)
#define IG3_MSOC_GLMSOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S 0
#define IG3_MSOC_GLMSOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_M RDMA_MASK3(32, 0x7, IG3_MSOC_GLMSOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S)
#define IG3_MSOC_GLMSOC_DPC_COMP 0x429008E8
#define IG3_MSOC_GLMSOC_DPC_COMP_RSVD_S 13
#define IG3_MSOC_GLMSOC_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_MSOC_GLMSOC_DPC_COMP_RSVD_S)
#define IG3_MSOC_GLMSOC_DPC_COMP_COMP_FTYPE_S 11
#define IG3_MSOC_GLMSOC_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_DPC_COMP_COMP_FTYPE_S)
#define IG3_MSOC_GLMSOC_DPC_COMP_COMP_FNUM_S 1
#define IG3_MSOC_GLMSOC_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_DPC_COMP_COMP_FNUM_S)
#define IG3_MSOC_GLMSOC_DPC_COMP_COMP_VALID_S 0
#define IG3_MSOC_GLMSOC_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_DPC_COMP_COMP_VALID_S)
#define IG3_MSOC_GLMSOC_DPC_REQ 0x429008E4
#define IG3_MSOC_GLMSOC_DPC_REQ_RSVD_S 12
#define IG3_MSOC_GLMSOC_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_MSOC_GLMSOC_DPC_REQ_RSVD_S)
#define IG3_MSOC_GLMSOC_DPC_REQ_REQ_FTYPE_S 10
#define IG3_MSOC_GLMSOC_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_DPC_REQ_REQ_FTYPE_S)
#define IG3_MSOC_GLMSOC_DPC_REQ_REQ_FNUM_S 0
#define IG3_MSOC_GLMSOC_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_DPC_REQ_REQ_FNUM_S)
#define IG3_MSOC_GLMSOC_ECC_CTL 0x429008C8
#define IG3_MSOC_GLMSOC_ECC_CTL_RSVD_S 8
#define IG3_MSOC_GLMSOC_ECC_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_ECC_CTL_RSVD_S)
#define IG3_MSOC_GLMSOC_ECC_CTL_CLIENT_ECC_INVERT2_S 7
#define IG3_MSOC_GLMSOC_ECC_CTL_CLIENT_ECC_INVERT2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_ECC_CTL_CLIENT_ECC_INVERT2_S)
#define IG3_MSOC_GLMSOC_ECC_CTL_CLIENT_ECC_INVERT1_S 6
#define IG3_MSOC_GLMSOC_ECC_CTL_CLIENT_ECC_INVERT1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_ECC_CTL_CLIENT_ECC_INVERT1_S)
#define IG3_MSOC_GLMSOC_ECC_CTL_CLIENT_ECC_MASK_INT_S 5
#define IG3_MSOC_GLMSOC_ECC_CTL_CLIENT_ECC_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_ECC_CTL_CLIENT_ECC_MASK_INT_S)
#define IG3_MSOC_GLMSOC_ECC_CTL_CLIENT_ECC_EN_S 4
#define IG3_MSOC_GLMSOC_ECC_CTL_CLIENT_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_ECC_CTL_CLIENT_ECC_EN_S)
#define IG3_MSOC_GLMSOC_ECC_CTL_HOST_ECC_INVERT2_S 3
#define IG3_MSOC_GLMSOC_ECC_CTL_HOST_ECC_INVERT2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_ECC_CTL_HOST_ECC_INVERT2_S)
#define IG3_MSOC_GLMSOC_ECC_CTL_HOST_ECC_INVERT1_S 2
#define IG3_MSOC_GLMSOC_ECC_CTL_HOST_ECC_INVERT1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_ECC_CTL_HOST_ECC_INVERT1_S)
#define IG3_MSOC_GLMSOC_ECC_CTL_HOST_ECC_MASK_INT_S 1
#define IG3_MSOC_GLMSOC_ECC_CTL_HOST_ECC_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_ECC_CTL_HOST_ECC_MASK_INT_S)
#define IG3_MSOC_GLMSOC_ECC_CTL_HOST_ECC_EN_S 0
#define IG3_MSOC_GLMSOC_ECC_CTL_HOST_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_ECC_CTL_HOST_ECC_EN_S)
#define IG3_MSOC_GLMSOC_ERRDATA0 0x429008B8
#define IG3_MSOC_GLMSOC_ERRDATA0_RSVD1_S 31
#define IG3_MSOC_GLMSOC_ERRDATA0_RSVD1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_ERRDATA0_RSVD1_S)
#define IG3_MSOC_GLMSOC_ERRDATA0_PF_NUM_S 25
#define IG3_MSOC_GLMSOC_ERRDATA0_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_MSOC_GLMSOC_ERRDATA0_PF_NUM_S)
#define IG3_MSOC_GLMSOC_ERRDATA0_VDEV_VF_NUM_S 15
#define IG3_MSOC_GLMSOC_ERRDATA0_VDEV_VF_NUM_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_ERRDATA0_VDEV_VF_NUM_S)
#define IG3_MSOC_GLMSOC_ERRDATA0_VDEV_VF_TYPE_S 13
#define IG3_MSOC_GLMSOC_ERRDATA0_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_ERRDATA0_VDEV_VF_TYPE_S)
#define IG3_MSOC_GLMSOC_ERRDATA0_OBJ_TYPE_S 8
#define IG3_MSOC_GLMSOC_ERRDATA0_OBJ_TYPE_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_ERRDATA0_OBJ_TYPE_S)
#define IG3_MSOC_GLMSOC_ERRDATA0_RSVD0_S 6
#define IG3_MSOC_GLMSOC_ERRDATA0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_ERRDATA0_RSVD0_S)
#define IG3_MSOC_GLMSOC_ERRDATA0_ERROR_CODE_S 0
#define IG3_MSOC_GLMSOC_ERRDATA0_ERROR_CODE_M RDMA_MASK3(32, 0x3F, IG3_MSOC_GLMSOC_ERRDATA0_ERROR_CODE_S)
#define IG3_MSOC_GLMSOC_ERRDATA1 0x429008BC
#define IG3_MSOC_GLMSOC_ERRDATA1_RSVD_S 28
#define IG3_MSOC_GLMSOC_ERRDATA1_RSVD_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_ERRDATA1_RSVD_S)
#define IG3_MSOC_GLMSOC_ERRDATA1_OBJ_INDEX_S 0
#define IG3_MSOC_GLMSOC_ERRDATA1_OBJ_INDEX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_MSOC_GLMSOC_ERRDATA1_OBJ_INDEX_S)
#define IG3_MSOC_GLMSOC_ERRDATA2 0x429008C0
#define IG3_MSOC_GLMSOC_ERRDATA2_RSVD_S 23
#define IG3_MSOC_GLMSOC_ERRDATA2_RSVD_M RDMA_MASK3(32, 0x1FF, IG3_MSOC_GLMSOC_ERRDATA2_RSVD_S)
#define IG3_MSOC_GLMSOC_ERRDATA2_OPTYPE_S 20
#define IG3_MSOC_GLMSOC_ERRDATA2_OPTYPE_M RDMA_MASK3(32, 0x7, IG3_MSOC_GLMSOC_ERRDATA2_OPTYPE_S)
#define IG3_MSOC_GLMSOC_ERRDATA2_OFFSET_S 7
#define IG3_MSOC_GLMSOC_ERRDATA2_OFFSET_M RDMA_MASK3(32, 0x1FFF, IG3_MSOC_GLMSOC_ERRDATA2_OFFSET_S)
#define IG3_MSOC_GLMSOC_ERRDATA2_LENGTH_S 0
#define IG3_MSOC_GLMSOC_ERRDATA2_LENGTH_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_ERRDATA2_LENGTH_S)
#define IG3_MSOC_GLMSOC_ERRDATA3 0x429008C4
#define IG3_MSOC_GLMSOC_ERRDATA3_RSVD_S 15
#define IG3_MSOC_GLMSOC_ERRDATA3_RSVD_M RDMA_MASK3(32, 0x1FFFF, IG3_MSOC_GLMSOC_ERRDATA3_RSVD_S)
#define IG3_MSOC_GLMSOC_ERRDATA3_TAG_S 0
#define IG3_MSOC_GLMSOC_ERRDATA3_TAG_M RDMA_MASK3(32, 0x7FFF, IG3_MSOC_GLMSOC_ERRDATA3_TAG_S)
#define IG3_MSOC_GLMSOC_ERRINFO 0x429008B4
#define IG3_MSOC_GLMSOC_ERRINFO_RSVD1_S 16
#define IG3_MSOC_GLMSOC_ERRINFO_RSVD1_M RDMA_MASK3(32, 0xFFFF, IG3_MSOC_GLMSOC_ERRINFO_RSVD1_S)
#define IG3_MSOC_GLMSOC_ERRINFO_ERROR_CNT_S 8
#define IG3_MSOC_GLMSOC_ERRINFO_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_ERRINFO_ERROR_CNT_S)
#define IG3_MSOC_GLMSOC_ERRINFO_RSVD0_S 1
#define IG3_MSOC_GLMSOC_ERRINFO_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_ERRINFO_RSVD0_S)
#define IG3_MSOC_GLMSOC_ERRINFO_ERROR_VALID_S 0
#define IG3_MSOC_GLMSOC_ERRINFO_ERROR_VALID_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_ERRINFO_ERROR_VALID_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG 0x4290091C
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RSVD3_S 20
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RSVD3_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RM_S 16
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RM_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RSVD2_S 14
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RSVD2_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RME_S 12
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RME_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RSVD1_S 10
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RSVD1_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ERR_CNT_S 9
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_FIX_CNT_S 8
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_FIX_CNT_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RSVD0_S 6
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_RSVD0_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_MASK_INT_S 5
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_MASK_INT_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_LS_BYPASS_S 4
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_LS_BYPASS_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_LS_FORCE_S 3
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_LS_FORCE_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ECC_EN_S 0
#define IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_EVICT_MEM_CFG_ECC_EN_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS 0x42900920
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_RSVD1_S 30
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_RSVD1_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_RSVD0_S 4
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_RSVD0_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_INIT_DONE_S 2
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_ECC_FIX_S 1
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_ECC_FIX_S)
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_ECC_ERR_S 0
#define IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_EVICT_MEM_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG 0x42900914
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_FILL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_RSVD3_S 20
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_FILL_MEM_CFG_RSVD3_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_RM_S 16
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_FILL_MEM_CFG_RM_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_RSVD2_S 14
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_FILL_MEM_CFG_RSVD2_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_FILL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_RME_S 12
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_FILL_MEM_CFG_RME_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_RSVD1_S 10
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_FILL_MEM_CFG_RSVD1_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_ERR_CNT_S 9
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_FILL_MEM_CFG_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_FIX_CNT_S 8
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_FILL_MEM_CFG_FIX_CNT_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_RSVD0_S 6
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_FILL_MEM_CFG_RSVD0_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_MASK_INT_S 5
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_FILL_MEM_CFG_MASK_INT_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_LS_BYPASS_S 4
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_FILL_MEM_CFG_LS_BYPASS_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_LS_FORCE_S 3
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_FILL_MEM_CFG_LS_FORCE_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_FILL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_FILL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_ECC_EN_S 0
#define IG3_MSOC_GLMSOC_FILL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_FILL_MEM_CFG_ECC_EN_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS 0x42900918
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS_RSVD1_S 30
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_FILL_MEM_STATUS_RSVD1_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS_RSVD0_S 4
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_FILL_MEM_STATUS_RSVD0_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS_INIT_DONE_S 2
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_FILL_MEM_STATUS_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS_ECC_FIX_S 1
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_FILL_MEM_STATUS_ECC_FIX_S)
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS_ECC_ERR_S 0
#define IG3_MSOC_GLMSOC_FILL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_FILL_MEM_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLMSOC_FSIADR_OBJOFST 0x4290088C
#define IG3_MSOC_GLMSOC_FSIADR_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_FSIADR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_FSIADR_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLMSOC_FSIMCAST_OBJOFST 0x42900890
#define IG3_MSOC_GLMSOC_FSIMCAST_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_FSIMCAST_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_FSIMCAST_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLMSOC_HDR_OBJOFST 0x429008A0
#define IG3_MSOC_GLMSOC_HDR_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_HDR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_HDR_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLMSOC_HECC_ERR 0x429008CC
#define IG3_MSOC_GLMSOC_HECC_ERR_RSVD1_S 28
#define IG3_MSOC_GLMSOC_HECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_HECC_ERR_RSVD1_S)
#define IG3_MSOC_GLMSOC_HECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_MSOC_GLMSOC_HECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_MSOC_GLMSOC_HECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_HECC_ERR_RSVD0_S 12
#define IG3_MSOC_GLMSOC_HECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_HECC_ERR_RSVD0_S)
#define IG3_MSOC_GLMSOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_MSOC_GLMSOC_HECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_MSOC_GLMSOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_IRRQ_OBJOFST 0x42900880
#define IG3_MSOC_GLMSOC_IRRQ_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_IRRQ_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_IRRQ_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLMSOC_MAXOSR 0x429008D4
#define IG3_MSOC_GLMSOC_MAXOSR_RSVD1_S 15
#define IG3_MSOC_GLMSOC_MAXOSR_RSVD1_M RDMA_MASK3(32, 0x1FFFF, IG3_MSOC_GLMSOC_MAXOSR_RSVD1_S)
#define IG3_MSOC_GLMSOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S 10
#define IG3_MSOC_GLMSOC_MAXOSR_MAX_OSR_CLNT_WRPULL_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S)
#define IG3_MSOC_GLMSOC_MAXOSR_RSVD0_S 8
#define IG3_MSOC_GLMSOC_MAXOSR_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_MAXOSR_RSVD0_S)
#define IG3_MSOC_GLMSOC_MAXOSR_MAX_OSR_PMAT_FETCH_S 0
#define IG3_MSOC_GLMSOC_MAXOSR_MAX_OSR_PMAT_FETCH_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_MAXOSR_MAX_OSR_PMAT_FETCH_S)
#define IG3_MSOC_GLMSOC_MEM_ECC_COR_ERR 0x429009B8
#define IG3_MSOC_GLMSOC_MEM_ECC_COR_ERR_RSVD_S 12
#define IG3_MSOC_GLMSOC_MEM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_MSOC_GLMSOC_MEM_ECC_COR_ERR_RSVD_S)
#define IG3_MSOC_GLMSOC_MEM_ECC_COR_ERR_CNT_S 0
#define IG3_MSOC_GLMSOC_MEM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_MSOC_GLMSOC_MEM_ECC_COR_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_MEM_ECC_UNCOR_ERR 0x429009B4
#define IG3_MSOC_GLMSOC_MEM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_MSOC_GLMSOC_MEM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_MSOC_GLMSOC_MEM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_MSOC_GLMSOC_MEM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_MSOC_GLMSOC_MEM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_MSOC_GLMSOC_MEM_ECC_UNCOR_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_OOISCFL_OBJOFST 0x429008B0
#define IG3_MSOC_GLMSOC_OOISCFL_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_OOISCFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_OOISCFL_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLMSOC_OOISC_OBJOFST 0x429008AC
#define IG3_MSOC_GLMSOC_OOISC_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_OOISC_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_OOISC_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLMSOC_PLIST_DBG_CTL 0x429009AC
#define IG3_MSOC_GLMSOC_PLIST_DBG_CTL_DONE_S 31
#define IG3_MSOC_GLMSOC_PLIST_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_DBG_CTL_DONE_S)
#define IG3_MSOC_GLMSOC_PLIST_DBG_CTL_RD_EN_S 30
#define IG3_MSOC_GLMSOC_PLIST_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_DBG_CTL_RD_EN_S)
#define IG3_MSOC_GLMSOC_PLIST_DBG_CTL_RSVD_S 26
#define IG3_MSOC_GLMSOC_PLIST_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_PLIST_DBG_CTL_RSVD_S)
#define IG3_MSOC_GLMSOC_PLIST_DBG_CTL_DW_SEL_S 18
#define IG3_MSOC_GLMSOC_PLIST_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_PLIST_DBG_CTL_DW_SEL_S)
#define IG3_MSOC_GLMSOC_PLIST_DBG_CTL_ADR_S 0
#define IG3_MSOC_GLMSOC_PLIST_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_PLIST_DBG_CTL_ADR_S)
#define IG3_MSOC_GLMSOC_PLIST_DBG_DATA 0x429009B0
#define IG3_MSOC_GLMSOC_PLIST_DBG_DATA_RD_DW_S 0
#define IG3_MSOC_GLMSOC_PLIST_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_PLIST_DBG_DATA_RD_DW_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG 0x4290090C
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RSVD3_S 20
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RSVD3_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RM_S 16
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RM_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RSVD2_S 14
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RSVD2_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RME_S 12
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RME_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RSVD1_S 10
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RSVD1_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ERR_CNT_S 9
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_FIX_CNT_S 8
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_FIX_CNT_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RSVD0_S 6
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_RSVD0_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_MASK_INT_S 5
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_MASK_INT_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_LS_BYPASS_S 4
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_LS_BYPASS_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_LS_FORCE_S 3
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_LS_FORCE_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ECC_EN_S 0
#define IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_MEM_CFG_ECC_EN_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS 0x42900910
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_RSVD1_S 30
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_RSVD1_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_RSVD0_S 4
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_RSVD0_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_INIT_DONE_S 2
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_ECC_FIX_S 1
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_ECC_FIX_S)
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_ECC_ERR_S 0
#define IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PLIST_MEM_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLMSOC_PMATINV_CFG 0x429008DC
#define IG3_MSOC_GLMSOC_PMATINV_CFG_RSVD_S 6
#define IG3_MSOC_GLMSOC_PMATINV_CFG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_MSOC_GLMSOC_PMATINV_CFG_RSVD_S)
#define IG3_MSOC_GLMSOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S 5
#define IG3_MSOC_GLMSOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S)
#define IG3_MSOC_GLMSOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S 4
#define IG3_MSOC_GLMSOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S)
#define IG3_MSOC_GLMSOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S 3
#define IG3_MSOC_GLMSOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S)
#define IG3_MSOC_GLMSOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S 2
#define IG3_MSOC_GLMSOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S)
#define IG3_MSOC_GLMSOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S 1
#define IG3_MSOC_GLMSOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S)
#define IG3_MSOC_GLMSOC_PMATINV_CFG_INVBYFN_FENCE_EN_S 0
#define IG3_MSOC_GLMSOC_PMATINV_CFG_INVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_PMATINV_CFG_INVBYFN_FENCE_EN_S)
#define IG3_MSOC_GLMSOC_Q1FL_OBJOFST 0x42900898
#define IG3_MSOC_GLMSOC_Q1FL_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_Q1FL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_Q1FL_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLMSOC_RRFL_OBJOFST 0x429008A8
#define IG3_MSOC_GLMSOC_RRFL_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_RRFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_RRFL_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLMSOC_RRF_OBJOFST 0x429008A4
#define IG3_MSOC_GLMSOC_RRF_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_RRF_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_RRF_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLMSOC_SRQCTX_OBJOFST 0x42900888
#define IG3_MSOC_GLMSOC_SRQCTX_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_SRQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_SRQCTX_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLMSOC_STAT_CTL 0x42900804
#define IG3_MSOC_GLMSOC_STAT_CTL_RSVD_S 5
#define IG3_MSOC_GLMSOC_STAT_CTL_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_MSOC_GLMSOC_STAT_CTL_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_CTL_OBJECT_TYPE_S 0
#define IG3_MSOC_GLMSOC_STAT_CTL_OBJECT_TYPE_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_STAT_CTL_OBJECT_TYPE_S)
#define IG3_MSOC_GLMSOC_STAT_FENCING_TIME_HI 0x4290086C
#define IG3_MSOC_GLMSOC_STAT_FENCING_TIME_HI_RSVD_S 24
#define IG3_MSOC_GLMSOC_STAT_FENCING_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_FENCING_TIME_HI_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_FENCING_TIME_HI_CNT_HI_S 0
#define IG3_MSOC_GLMSOC_STAT_FENCING_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_FENCING_TIME_HI_CNT_HI_S)
#define IG3_MSOC_GLMSOC_STAT_FENCING_TIME_LO 0x42900868
#define IG3_MSOC_GLMSOC_STAT_FENCING_TIME_LO_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_STAT_FENCING_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_STAT_FENCING_TIME_LO_CNT_LO_S)
#define IG3_MSOC_GLMSOC_STAT_MAX_PENDING_ENTRIES 0x4290084C
#define IG3_MSOC_GLMSOC_STAT_MAX_PENDING_ENTRIES_RSVD_S 8
#define IG3_MSOC_GLMSOC_STAT_MAX_PENDING_ENTRIES_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_MAX_PENDING_ENTRIES_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_MAX_PENDING_ENTRIES_CNT_S 0
#define IG3_MSOC_GLMSOC_STAT_MAX_PENDING_ENTRIES_CNT_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_MAX_PENDING_ENTRIES_CNT_S)
#define IG3_MSOC_GLMSOC_STAT_MAX_PENDING_LIST_DEPTH 0x42900854
#define IG3_MSOC_GLMSOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S 8
#define IG3_MSOC_GLMSOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S)
#define IG3_MSOC_GLMSOC_STAT_MAX_VIRT_PENDING_LISTS 0x42900850
#define IG3_MSOC_GLMSOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S 8
#define IG3_MSOC_GLMSOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S)
#define IG3_MSOC_GLMSOC_STAT_OBJ_CNT 0x42900808
#define IG3_MSOC_GLMSOC_STAT_OBJ_CNT_RSVD_S 14
#define IG3_MSOC_GLMSOC_STAT_OBJ_CNT_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_STAT_OBJ_CNT_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_OBJ_CNT_OBJECT_COUNT_S 0
#define IG3_MSOC_GLMSOC_STAT_OBJ_CNT_OBJECT_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_MSOC_GLMSOC_STAT_OBJ_CNT_OBJECT_COUNT_S)
#define IG3_MSOC_GLMSOC_STAT_PENDLING_LIST_FULL_HI 0x42900864
#define IG3_MSOC_GLMSOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S 24
#define IG3_MSOC_GLMSOC_STAT_PENDLING_LIST_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S 0
#define IG3_MSOC_GLMSOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S)
#define IG3_MSOC_GLMSOC_STAT_PENDLING_LIST_FULL_LO 0x42900860
#define IG3_MSOC_GLMSOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S)
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_IDLE_HI 0x42900830
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_IDLE_HI_RSVD_S 24
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_RD_DATA_IDLE_HI_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S)
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_IDLE_LO 0x4290082C
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S)
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_XFER_HI 0x42900838
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_XFER_HI_RSVD_S 24
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_RD_DATA_XFER_HI_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_XFER_HI_CNT_HI_S 0
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_RD_DATA_XFER_HI_CNT_HI_S)
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_XFER_LO 0x42900834
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_XFER_LO_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_STAT_RD_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_STAT_RD_DATA_XFER_LO_CNT_LO_S)
#define IG3_MSOC_GLMSOC_STAT_RD_HIT_HI 0x42900810
#define IG3_MSOC_GLMSOC_STAT_RD_HIT_HI_RSVD_S 24
#define IG3_MSOC_GLMSOC_STAT_RD_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_RD_HIT_HI_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_RD_HIT_HI_CNT_HI_S 0
#define IG3_MSOC_GLMSOC_STAT_RD_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_RD_HIT_HI_CNT_HI_S)
#define IG3_MSOC_GLMSOC_STAT_RD_HIT_LO 0x4290080C
#define IG3_MSOC_GLMSOC_STAT_RD_HIT_LO_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_STAT_RD_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_STAT_RD_HIT_LO_CNT_LO_S)
#define IG3_MSOC_GLMSOC_STAT_RD_MISS_HI 0x42900818
#define IG3_MSOC_GLMSOC_STAT_RD_MISS_HI_RSVD_S 24
#define IG3_MSOC_GLMSOC_STAT_RD_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_RD_MISS_HI_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_RD_MISS_HI_CNT_HI_S 0
#define IG3_MSOC_GLMSOC_STAT_RD_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_RD_MISS_HI_CNT_HI_S)
#define IG3_MSOC_GLMSOC_STAT_RD_MISS_LO 0x42900814
#define IG3_MSOC_GLMSOC_STAT_RD_MISS_LO_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_STAT_RD_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_STAT_RD_MISS_LO_CNT_LO_S)
#define IG3_MSOC_GLMSOC_STAT_REPLAY_TIME_HI 0x42900874
#define IG3_MSOC_GLMSOC_STAT_REPLAY_TIME_HI_RSVD_S 24
#define IG3_MSOC_GLMSOC_STAT_REPLAY_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_REPLAY_TIME_HI_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_REPLAY_TIME_HI_CNT_HI_S 0
#define IG3_MSOC_GLMSOC_STAT_REPLAY_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_REPLAY_TIME_HI_CNT_HI_S)
#define IG3_MSOC_GLMSOC_STAT_REPLAY_TIME_LO 0x42900870
#define IG3_MSOC_GLMSOC_STAT_REPLAY_TIME_LO_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_STAT_REPLAY_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_STAT_REPLAY_TIME_LO_CNT_LO_S)
#define IG3_MSOC_GLMSOC_STAT_WR_BUFF_FULL_HI 0x4290085C
#define IG3_MSOC_GLMSOC_STAT_WR_BUFF_FULL_HI_RSVD_S 24
#define IG3_MSOC_GLMSOC_STAT_WR_BUFF_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_WR_BUFF_FULL_HI_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S 0
#define IG3_MSOC_GLMSOC_STAT_WR_BUFF_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S)
#define IG3_MSOC_GLMSOC_STAT_WR_BUFF_FULL_LO 0x42900858
#define IG3_MSOC_GLMSOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_STAT_WR_BUFF_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S)
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_IDLE_HI 0x42900840
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_IDLE_HI_RSVD_S 24
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_WR_DATA_IDLE_HI_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S)
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_IDLE_LO 0x4290083C
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S)
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_XFER_HI 0x42900848
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_XFER_HI_RSVD_S 24
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_WR_DATA_XFER_HI_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_XFER_HI_CNT_HI_S 0
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_WR_DATA_XFER_HI_CNT_HI_S)
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_XFER_LO 0x42900844
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_XFER_LO_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_STAT_WR_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_STAT_WR_DATA_XFER_LO_CNT_LO_S)
#define IG3_MSOC_GLMSOC_STAT_WR_HIT_HI 0x42900820
#define IG3_MSOC_GLMSOC_STAT_WR_HIT_HI_RSVD_S 24
#define IG3_MSOC_GLMSOC_STAT_WR_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_WR_HIT_HI_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_WR_HIT_HI_CNT_HI_S 0
#define IG3_MSOC_GLMSOC_STAT_WR_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_WR_HIT_HI_CNT_HI_S)
#define IG3_MSOC_GLMSOC_STAT_WR_HIT_LO 0x4290081C
#define IG3_MSOC_GLMSOC_STAT_WR_HIT_LO_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_STAT_WR_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_STAT_WR_HIT_LO_CNT_LO_S)
#define IG3_MSOC_GLMSOC_STAT_WR_MISS_HI 0x42900828
#define IG3_MSOC_GLMSOC_STAT_WR_MISS_HI_RSVD_S 24
#define IG3_MSOC_GLMSOC_STAT_WR_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_STAT_WR_MISS_HI_RSVD_S)
#define IG3_MSOC_GLMSOC_STAT_WR_MISS_HI_CNT_HI_S 0
#define IG3_MSOC_GLMSOC_STAT_WR_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_STAT_WR_MISS_HI_CNT_HI_S)
#define IG3_MSOC_GLMSOC_STAT_WR_MISS_LO 0x42900824
#define IG3_MSOC_GLMSOC_STAT_WR_MISS_LO_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_STAT_WR_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_STAT_WR_MISS_LO_CNT_LO_S)
#define IG3_MSOC_GLMSOC_TAG_DBG_CTL 0x42900964
#define IG3_MSOC_GLMSOC_TAG_DBG_CTL_DONE_S 31
#define IG3_MSOC_GLMSOC_TAG_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_DBG_CTL_DONE_S)
#define IG3_MSOC_GLMSOC_TAG_DBG_CTL_RD_EN_S 30
#define IG3_MSOC_GLMSOC_TAG_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_DBG_CTL_RD_EN_S)
#define IG3_MSOC_GLMSOC_TAG_DBG_CTL_RSVD_S 26
#define IG3_MSOC_GLMSOC_TAG_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_TAG_DBG_CTL_RSVD_S)
#define IG3_MSOC_GLMSOC_TAG_DBG_CTL_DW_SEL_S 18
#define IG3_MSOC_GLMSOC_TAG_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_TAG_DBG_CTL_DW_SEL_S)
#define IG3_MSOC_GLMSOC_TAG_DBG_CTL_ADR_S 0
#define IG3_MSOC_GLMSOC_TAG_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_TAG_DBG_CTL_ADR_S)
#define IG3_MSOC_GLMSOC_TAG_DBG_DATA 0x42900968
#define IG3_MSOC_GLMSOC_TAG_DBG_DATA_RD_DW_S 0
#define IG3_MSOC_GLMSOC_TAG_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_TAG_DBG_DATA_RD_DW_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG 0x429008FC
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_RSVD3_S 20
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_TAG_MEM_CFG_RSVD3_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_RM_S 16
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_TAG_MEM_CFG_RM_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_RSVD2_S 14
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_TAG_MEM_CFG_RSVD2_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_RME_S 12
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_MEM_CFG_RME_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_RSVD1_S 10
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_TAG_MEM_CFG_RSVD1_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_RSVD0_S 6
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_TAG_MEM_CFG_RSVD0_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_MEM_CFG_MASK_INT_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_MSOC_GLMSOC_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_MEM_CFG_ECC_EN_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS 0x42900900
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_TAG_MEM_STATUS_RSVD1_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_TAG_MEM_STATUS_RSVD0_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_MSOC_GLMSOC_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLMSOC_TIMER_OBJOFST 0x4290089C
#define IG3_MSOC_GLMSOC_TIMER_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_TIMER_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_TIMER_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLMSOC_TOTAL_TAG_HI 0x429008F0
#define IG3_MSOC_GLMSOC_TOTAL_TAG_HI_RSVD_S 24
#define IG3_MSOC_GLMSOC_TOTAL_TAG_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_TOTAL_TAG_HI_RSVD_S)
#define IG3_MSOC_GLMSOC_TOTAL_TAG_HI_CNT_HI_S 0
#define IG3_MSOC_GLMSOC_TOTAL_TAG_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_TOTAL_TAG_HI_CNT_HI_S)
#define IG3_MSOC_GLMSOC_TOTAL_TAG_HIT_HI 0x429008F8
#define IG3_MSOC_GLMSOC_TOTAL_TAG_HIT_HI_RSVD_S 24
#define IG3_MSOC_GLMSOC_TOTAL_TAG_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_TOTAL_TAG_HIT_HI_RSVD_S)
#define IG3_MSOC_GLMSOC_TOTAL_TAG_HIT_HI_CNT_HI_S 0
#define IG3_MSOC_GLMSOC_TOTAL_TAG_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_MSOC_GLMSOC_TOTAL_TAG_HIT_HI_CNT_HI_S)
#define IG3_MSOC_GLMSOC_TOTAL_TAG_HIT_LO 0x429008F4
#define IG3_MSOC_GLMSOC_TOTAL_TAG_HIT_LO_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_TOTAL_TAG_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_TOTAL_TAG_HIT_LO_CNT_LO_S)
#define IG3_MSOC_GLMSOC_TOTAL_TAG_LO 0x429008EC
#define IG3_MSOC_GLMSOC_TOTAL_TAG_LO_CNT_LO_S 0
#define IG3_MSOC_GLMSOC_TOTAL_TAG_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLMSOC_TOTAL_TAG_LO_CNT_LO_S)
#define IG3_MSOC_GLMSOC_TXFIFO_OBJOFST 0x4290087C
#define IG3_MSOC_GLMSOC_TXFIFO_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_TXFIFO_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_TXFIFO_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG 0x42900904
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RSVD3_S 20
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RSVD3_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RM_S 16
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RM_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RSVD2_S 14
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RSVD2_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RME_S 12
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RME_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RSVD1_S 10
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RSVD1_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ERR_CNT_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_FIX_CNT_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RSVD0_S 6
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_RSVD0_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_MASK_INT_S 5
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_MASK_INT_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_LS_FORCE_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ECC_EN_S 0
#define IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_WRBUF_MEM_CFG_ECC_EN_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS 0x42900908
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_RSVD1_S 30
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_RSVD1_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_RSVD0_S 4
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_RSVD0_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MSOC_GLMSOC_WRBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLMSOC_XFFL_OBJOFST 0x42900894
#define IG3_MSOC_GLMSOC_XFFL_OBJOFST_RSVD_S 10
#define IG3_MSOC_GLMSOC_XFFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_MSOC_GLMSOC_XFFL_OBJOFST_RSVD_S)
#define IG3_MSOC_GLMSOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_MSOC_GLMSOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_MSOC_GLMSOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_COUNT 0x42900A38
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_MSOC_GLPE_MSOC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_MSOC_GLPE_MSOC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_CMD 0x42900A4C
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_DATA_H 0x42900A58
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_DATA_L 0x42900A54
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_PTR 0x42900A50
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_MSOC_GLPE_MSOC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_CMD 0x42900A3C
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_DATA_H 0x42900A48
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_DATA_L 0x42900A44
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_PTR 0x42900A40
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_MSOC_GLPE_MSOC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL 0x42900A00
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_RSVD1_S 25
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLPE_MSOC_DTM_CONTROL_RSVD1_S)
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_RSVD2_S 17
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLPE_MSOC_DTM_CONTROL_RSVD2_S)
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_RSVD3_S 9
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLPE_MSOC_DTM_CONTROL_RSVD3_S)
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_BYPASS_S 8
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_CONTROL_BYPASS_S)
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_RSVD4_S 1
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLPE_MSOC_DTM_CONTROL_RSVD4_S)
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_MSOC_GLPE_MSOC_DTM_ECC_COR_ERR 0x42900A68
#define IG3_MSOC_GLPE_MSOC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_MSOC_GLPE_MSOC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_MSOC_GLPE_MSOC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_MSOC_GLPE_MSOC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_MSOC_GLPE_MSOC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_MSOC_GLPE_MSOC_DTM_ECC_UNCOR_ERR 0x42900A64
#define IG3_MSOC_GLPE_MSOC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_MSOC_GLPE_MSOC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_MSOC_GLPE_MSOC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_MSOC_GLPE_MSOC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_MSOC_GLPE_MSOC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_MSOC_GLPE_MSOC_DTM_GROUP_CFG 0x42900A0C
#define IG3_MSOC_GLPE_MSOC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_MSOC_GLPE_MSOC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLPE_MSOC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_MSOC_GLPE_MSOC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_MSOC_GLPE_MSOC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLPE_MSOC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_MSOC_GLPE_MSOC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_MSOC_GLPE_MSOC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLPE_MSOC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_MSOC_GLPE_MSOC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLPE_MSOC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_MSOC_GLPE_MSOC_DTM_LOG_CFG 0x42900A10
#define IG3_MSOC_GLPE_MSOC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_MSOC_GLPE_MSOC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_MSOC_GLPE_MSOC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_MSOC_GLPE_MSOC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_MSOC_GLPE_MSOC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_MSOC_GLPE_MSOC_DTM_LOG_CFG_RSVD1_S)
#define IG3_MSOC_GLPE_MSOC_DTM_LOG_CFG_MODE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLPE_MSOC_DTM_LOG_CFG_MODE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_LOG_MASK 0x42900A18
#define IG3_MSOC_GLPE_MSOC_DTM_LOG_MASK_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLPE_MSOC_DTM_LOG_MASK_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_LOG_PATTERN 0x42900A14
#define IG3_MSOC_GLPE_MSOC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLPE_MSOC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG 0x42900A04
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_STS 0x42900A08
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_MSOC_GLPE_MSOC_DTM_MAIN_STS_RSVD1_S)
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLPE_MSOC_DTM_MAIN_STS_RSVD2_S)
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TIMESTAMP 0x42900A30
#define IG3_MSOC_GLPE_MSOC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLPE_MSOC_DTM_TIMESTAMP_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TIMESTAMP_ROLLOVER 0x42900A34
#define IG3_MSOC_GLPE_MSOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLPE_MSOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG 0x42900A5C
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS 0x42900A60
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_MSOC_GLPE_MSOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG 0x42900A1C
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_MODE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_MSOC_GLPE_MSOC_DTM_TRIG_CFG_MODE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_COUNT 0x42900A28
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLPE_MSOC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_MASK 0x42900A24
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLPE_MSOC_DTM_TRIG_MASK_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_PATTERN 0x42900A20
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLPE_MSOC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_TIMESTAMP 0x42900A2C
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_MSOC_GLPE_MSOC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_MSOC_GLPE_MSOC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PEOC1_GLPEOC_ARPTBLE_OBJOFST 0x42900C78
#define IG3_PEOC1_GLPEOC_ARPTBLE_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_ARPTBLE_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_ARPTBLE_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC1_GLPEOC_CACHESIZE 0x42900CE0
#define IG3_PEOC1_GLPEOC_CACHESIZE_RSVD_S 24
#define IG3_PEOC1_GLPEOC_CACHESIZE_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHESIZE_RSVD_S)
#define IG3_PEOC1_GLPEOC_CACHESIZE_WAYS_S 20
#define IG3_PEOC1_GLPEOC_CACHESIZE_WAYS_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHESIZE_WAYS_S)
#define IG3_PEOC1_GLPEOC_CACHESIZE_SETS_S 8
#define IG3_PEOC1_GLPEOC_CACHESIZE_SETS_M RDMA_MASK3(32, 0xFFF, IG3_PEOC1_GLPEOC_CACHESIZE_SETS_S)
#define IG3_PEOC1_GLPEOC_CACHESIZE_WORD_SIZE_S 0
#define IG3_PEOC1_GLPEOC_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHESIZE_WORD_SIZE_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL 0x42900D6C
#define IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_DONE_S 31
#define IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_RD_EN_S 30
#define IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_RD_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_RSVD_S 26
#define IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_RSVD_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_ADR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_0_DBG_CTL_ADR_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_DBG_DATA 0x42900D70
#define IG3_PEOC1_GLPEOC_CACHE_0_DBG_DATA_RD_DW_S 0
#define IG3_PEOC1_GLPEOC_CACHE_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_CACHE_0_DBG_DATA_RD_DW_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG 0x42900D24
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RSVD3_S 20
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RM_S 16
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RM_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RSVD2_S 14
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RME_S 12
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RME_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RSVD1_S 10
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS 0x42900D28
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL 0x42900D74
#define IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_DONE_S 31
#define IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_RD_EN_S 30
#define IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_RD_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_RSVD_S 26
#define IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_RSVD_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_ADR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_1_DBG_CTL_ADR_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_DBG_DATA 0x42900D78
#define IG3_PEOC1_GLPEOC_CACHE_1_DBG_DATA_RD_DW_S 0
#define IG3_PEOC1_GLPEOC_CACHE_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_CACHE_1_DBG_DATA_RD_DW_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG 0x42900D2C
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RSVD3_S 20
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RM_S 16
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RM_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RSVD2_S 14
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RME_S 12
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RME_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RSVD1_S 10
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS 0x42900D30
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL 0x42900D7C
#define IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_DONE_S 31
#define IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_RD_EN_S 30
#define IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_RD_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_RSVD_S 26
#define IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_RSVD_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_ADR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_2_DBG_CTL_ADR_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_DBG_DATA 0x42900D80
#define IG3_PEOC1_GLPEOC_CACHE_2_DBG_DATA_RD_DW_S 0
#define IG3_PEOC1_GLPEOC_CACHE_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_CACHE_2_DBG_DATA_RD_DW_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG 0x42900D34
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RSVD3_S 20
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RM_S 16
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RM_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RSVD2_S 14
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RME_S 12
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RME_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RSVD1_S 10
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS 0x42900D38
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL 0x42900D84
#define IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_DONE_S 31
#define IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_RD_EN_S 30
#define IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_RD_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_RSVD_S 26
#define IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_RSVD_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_ADR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_3_DBG_CTL_ADR_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_DBG_DATA 0x42900D88
#define IG3_PEOC1_GLPEOC_CACHE_3_DBG_DATA_RD_DW_S 0
#define IG3_PEOC1_GLPEOC_CACHE_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_CACHE_3_DBG_DATA_RD_DW_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG 0x42900D3C
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RSVD3_S 20
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RM_S 16
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RM_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RSVD2_S 14
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RME_S 12
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RME_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RSVD1_S 10
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS 0x42900D40
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL 0x42900D8C
#define IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_DONE_S 31
#define IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_RD_EN_S 30
#define IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_RD_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_RSVD_S 26
#define IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_RSVD_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_ADR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_4_DBG_CTL_ADR_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_DBG_DATA 0x42900D90
#define IG3_PEOC1_GLPEOC_CACHE_4_DBG_DATA_RD_DW_S 0
#define IG3_PEOC1_GLPEOC_CACHE_4_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_CACHE_4_DBG_DATA_RD_DW_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG 0x42900D44
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RSVD3_S 20
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RM_S 16
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RM_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RSVD2_S 14
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RME_S 12
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RME_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RSVD1_S 10
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS 0x42900D48
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL 0x42900D94
#define IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_DONE_S 31
#define IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_RD_EN_S 30
#define IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_RD_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_RSVD_S 26
#define IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_RSVD_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_ADR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_5_DBG_CTL_ADR_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_DBG_DATA 0x42900D98
#define IG3_PEOC1_GLPEOC_CACHE_5_DBG_DATA_RD_DW_S 0
#define IG3_PEOC1_GLPEOC_CACHE_5_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_CACHE_5_DBG_DATA_RD_DW_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG 0x42900D4C
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RSVD3_S 20
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RM_S 16
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RM_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RSVD2_S 14
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RME_S 12
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RME_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RSVD1_S 10
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS 0x42900D50
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL 0x42900D9C
#define IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_DONE_S 31
#define IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_RD_EN_S 30
#define IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_RD_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_RSVD_S 26
#define IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_RSVD_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_ADR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_6_DBG_CTL_ADR_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_DBG_DATA 0x42900DA0
#define IG3_PEOC1_GLPEOC_CACHE_6_DBG_DATA_RD_DW_S 0
#define IG3_PEOC1_GLPEOC_CACHE_6_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_CACHE_6_DBG_DATA_RD_DW_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG 0x42900D54
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RSVD3_S 20
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RM_S 16
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RM_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RSVD2_S 14
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RME_S 12
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RME_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RSVD1_S 10
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS 0x42900D58
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL 0x42900DA4
#define IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_DONE_S 31
#define IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_RD_EN_S 30
#define IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_RD_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_RSVD_S 26
#define IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_RSVD_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_ADR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_7_DBG_CTL_ADR_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_DBG_DATA 0x42900DA8
#define IG3_PEOC1_GLPEOC_CACHE_7_DBG_DATA_RD_DW_S 0
#define IG3_PEOC1_GLPEOC_CACHE_7_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_CACHE_7_DBG_DATA_RD_DW_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG 0x42900D5C
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RSVD3_S 20
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RM_S 16
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RM_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RSVD2_S 14
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RME_S 12
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RME_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RSVD1_S 10
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS 0x42900D60
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC1_GLPEOC_CACHE_CTRL 0x42900C00
#define IG3_PEOC1_GLPEOC_CACHE_CTRL_RSVD_S 2
#define IG3_PEOC1_GLPEOC_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_PEOC1_GLPEOC_CACHE_CTRL_RSVD_S)
#define IG3_PEOC1_GLPEOC_CACHE_CTRL_SCALE_FACTOR_S 0
#define IG3_PEOC1_GLPEOC_CACHE_CTRL_SCALE_FACTOR_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_CACHE_CTRL_SCALE_FACTOR_S)
#define IG3_PEOC1_GLPEOC_CECC_ERR 0x42900CD0
#define IG3_PEOC1_GLPEOC_CECC_ERR_RSVD1_S 28
#define IG3_PEOC1_GLPEOC_CECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CECC_ERR_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PEOC1_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC1_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_CECC_ERR_RSVD0_S 12
#define IG3_PEOC1_GLPEOC_CECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_CECC_ERR_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PEOC1_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC1_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_CQCTX_OBJOFST 0x42900C84
#define IG3_PEOC1_GLPEOC_CQCTX_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_CQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_CQCTX_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC1_GLPEOC_CSTATELKUP_CFG 0x42900CD8
#define IG3_PEOC1_GLPEOC_CSTATELKUP_CFG_RSVD1_S 9
#define IG3_PEOC1_GLPEOC_CSTATELKUP_CFG_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PEOC1_GLPEOC_CSTATELKUP_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S 8
#define IG3_PEOC1_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S)
#define IG3_PEOC1_GLPEOC_CSTATELKUP_CFG_RSVD0_S 3
#define IG3_PEOC1_GLPEOC_CSTATELKUP_CFG_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_CSTATELKUP_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S 0
#define IG3_PEOC1_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_M RDMA_MASK3(32, 0x7, IG3_PEOC1_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S)
#define IG3_PEOC1_GLPEOC_DPC_COMP 0x42900CE8
#define IG3_PEOC1_GLPEOC_DPC_COMP_RSVD_S 13
#define IG3_PEOC1_GLPEOC_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEOC1_GLPEOC_DPC_COMP_RSVD_S)
#define IG3_PEOC1_GLPEOC_DPC_COMP_COMP_FTYPE_S 11
#define IG3_PEOC1_GLPEOC_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_DPC_COMP_COMP_FTYPE_S)
#define IG3_PEOC1_GLPEOC_DPC_COMP_COMP_FNUM_S 1
#define IG3_PEOC1_GLPEOC_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_DPC_COMP_COMP_FNUM_S)
#define IG3_PEOC1_GLPEOC_DPC_COMP_COMP_VALID_S 0
#define IG3_PEOC1_GLPEOC_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DPC_COMP_COMP_VALID_S)
#define IG3_PEOC1_GLPEOC_DPC_REQ 0x42900CE4
#define IG3_PEOC1_GLPEOC_DPC_REQ_RSVD_S 12
#define IG3_PEOC1_GLPEOC_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC1_GLPEOC_DPC_REQ_RSVD_S)
#define IG3_PEOC1_GLPEOC_DPC_REQ_REQ_FTYPE_S 10
#define IG3_PEOC1_GLPEOC_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_DPC_REQ_REQ_FTYPE_S)
#define IG3_PEOC1_GLPEOC_DPC_REQ_REQ_FNUM_S 0
#define IG3_PEOC1_GLPEOC_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_DPC_REQ_REQ_FNUM_S)
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_COUNT 0x42900E38
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC1_GLPEOC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC1_GLPEOC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_CMD 0x42900E4C
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_DATA_H 0x42900E58
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_DATA_L 0x42900E54
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_PTR 0x42900E50
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC1_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_CMD 0x42900E3C
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_DATA_H 0x42900E48
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_DATA_L 0x42900E44
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_PTR 0x42900E40
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC1_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_CONTROL 0x42900E00
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_RSVD1_S 25
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_DTM_CONTROL_RSVD1_S)
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_RSVD2_S 17
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_DTM_CONTROL_RSVD2_S)
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_RSVD3_S 9
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_DTM_CONTROL_RSVD3_S)
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_BYPASS_S 8
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_CONTROL_BYPASS_S)
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_RSVD4_S 1
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_DTM_CONTROL_RSVD4_S)
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PEOC1_GLPEOC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PEOC1_GLPEOC_DTM_ECC_COR_ERR 0x42900E68
#define IG3_PEOC1_GLPEOC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PEOC1_GLPEOC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC1_GLPEOC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PEOC1_GLPEOC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PEOC1_GLPEOC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC1_GLPEOC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_DTM_ECC_UNCOR_ERR 0x42900E64
#define IG3_PEOC1_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PEOC1_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC1_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PEOC1_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PEOC1_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC1_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_DTM_GROUP_CFG 0x42900E0C
#define IG3_PEOC1_GLPEOC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PEOC1_GLPEOC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PEOC1_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PEOC1_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PEOC1_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PEOC1_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PEOC1_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PEOC1_GLPEOC_DTM_LOG_CFG 0x42900E10
#define IG3_PEOC1_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PEOC1_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PEOC1_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PEOC1_GLPEOC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PEOC1_GLPEOC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PEOC1_GLPEOC_DTM_LOG_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_DTM_LOG_CFG_MODE_S 0
#define IG3_PEOC1_GLPEOC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_DTM_LOG_CFG_MODE_S)
#define IG3_PEOC1_GLPEOC_DTM_LOG_MASK 0x42900E18
#define IG3_PEOC1_GLPEOC_DTM_LOG_MASK_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_DTM_LOG_MASK_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_LOG_PATTERN 0x42900E14
#define IG3_PEOC1_GLPEOC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_MAIN_CFG 0x42900E04
#define IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PEOC1_GLPEOC_DTM_MAIN_STS 0x42900E08
#define IG3_PEOC1_GLPEOC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PEOC1_GLPEOC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PEOC1_GLPEOC_DTM_MAIN_STS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PEOC1_GLPEOC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PEOC1_GLPEOC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PEOC1_GLPEOC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_DTM_MAIN_STS_RSVD2_S)
#define IG3_PEOC1_GLPEOC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PEOC1_GLPEOC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PEOC1_GLPEOC_DTM_TIMESTAMP 0x42900E30
#define IG3_PEOC1_GLPEOC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_DTM_TIMESTAMP_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_TIMESTAMP_ROLLOVER 0x42900E34
#define IG3_PEOC1_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG 0x42900E5C
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS 0x42900E60
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PEOC1_GLPEOC_DTM_TRIG_CFG 0x42900E1C
#define IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_MODE_S 0
#define IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_DTM_TRIG_CFG_MODE_S)
#define IG3_PEOC1_GLPEOC_DTM_TRIG_COUNT 0x42900E28
#define IG3_PEOC1_GLPEOC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_TRIG_MASK 0x42900E24
#define IG3_PEOC1_GLPEOC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_DTM_TRIG_MASK_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_TRIG_PATTERN 0x42900E20
#define IG3_PEOC1_GLPEOC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PEOC1_GLPEOC_DTM_TRIG_TIMESTAMP 0x42900E2C
#define IG3_PEOC1_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PEOC1_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PEOC1_GLPEOC_ECC_CTL 0x42900CC8
#define IG3_PEOC1_GLPEOC_ECC_CTL_RSVD_S 8
#define IG3_PEOC1_GLPEOC_ECC_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_ECC_CTL_RSVD_S)
#define IG3_PEOC1_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_S 7
#define IG3_PEOC1_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_S)
#define IG3_PEOC1_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_S 6
#define IG3_PEOC1_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_S)
#define IG3_PEOC1_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_ECC_CTL_CLIENT_ECC_EN_S 4
#define IG3_PEOC1_GLPEOC_ECC_CTL_CLIENT_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_ECC_CTL_CLIENT_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_S 3
#define IG3_PEOC1_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_S)
#define IG3_PEOC1_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_S 2
#define IG3_PEOC1_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_S)
#define IG3_PEOC1_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_S 1
#define IG3_PEOC1_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_ECC_CTL_HOST_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_ECC_CTL_HOST_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_ECC_CTL_HOST_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_ERRDATA0 0x42900CB8
#define IG3_PEOC1_GLPEOC_ERRDATA0_RSVD1_S 31
#define IG3_PEOC1_GLPEOC_ERRDATA0_RSVD1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_ERRDATA0_RSVD1_S)
#define IG3_PEOC1_GLPEOC_ERRDATA0_PF_NUM_S 25
#define IG3_PEOC1_GLPEOC_ERRDATA0_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PEOC1_GLPEOC_ERRDATA0_PF_NUM_S)
#define IG3_PEOC1_GLPEOC_ERRDATA0_VDEV_VF_NUM_S 15
#define IG3_PEOC1_GLPEOC_ERRDATA0_VDEV_VF_NUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_ERRDATA0_VDEV_VF_NUM_S)
#define IG3_PEOC1_GLPEOC_ERRDATA0_VDEV_VF_TYPE_S 13
#define IG3_PEOC1_GLPEOC_ERRDATA0_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_ERRDATA0_VDEV_VF_TYPE_S)
#define IG3_PEOC1_GLPEOC_ERRDATA0_OBJ_TYPE_S 8
#define IG3_PEOC1_GLPEOC_ERRDATA0_OBJ_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_ERRDATA0_OBJ_TYPE_S)
#define IG3_PEOC1_GLPEOC_ERRDATA0_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_ERRDATA0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_ERRDATA0_RSVD0_S)
#define IG3_PEOC1_GLPEOC_ERRDATA0_ERROR_CODE_S 0
#define IG3_PEOC1_GLPEOC_ERRDATA0_ERROR_CODE_M RDMA_MASK3(32, 0x3F, IG3_PEOC1_GLPEOC_ERRDATA0_ERROR_CODE_S)
#define IG3_PEOC1_GLPEOC_ERRDATA1 0x42900CBC
#define IG3_PEOC1_GLPEOC_ERRDATA1_RSVD_S 28
#define IG3_PEOC1_GLPEOC_ERRDATA1_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_ERRDATA1_RSVD_S)
#define IG3_PEOC1_GLPEOC_ERRDATA1_OBJ_INDEX_S 0
#define IG3_PEOC1_GLPEOC_ERRDATA1_OBJ_INDEX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PEOC1_GLPEOC_ERRDATA1_OBJ_INDEX_S)
#define IG3_PEOC1_GLPEOC_ERRDATA2 0x42900CC0
#define IG3_PEOC1_GLPEOC_ERRDATA2_RSVD_S 23
#define IG3_PEOC1_GLPEOC_ERRDATA2_RSVD_M RDMA_MASK3(32, 0x1FF, IG3_PEOC1_GLPEOC_ERRDATA2_RSVD_S)
#define IG3_PEOC1_GLPEOC_ERRDATA2_OPTYPE_S 20
#define IG3_PEOC1_GLPEOC_ERRDATA2_OPTYPE_M RDMA_MASK3(32, 0x7, IG3_PEOC1_GLPEOC_ERRDATA2_OPTYPE_S)
#define IG3_PEOC1_GLPEOC_ERRDATA2_OFFSET_S 7
#define IG3_PEOC1_GLPEOC_ERRDATA2_OFFSET_M RDMA_MASK3(32, 0x1FFF, IG3_PEOC1_GLPEOC_ERRDATA2_OFFSET_S)
#define IG3_PEOC1_GLPEOC_ERRDATA2_LENGTH_S 0
#define IG3_PEOC1_GLPEOC_ERRDATA2_LENGTH_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_ERRDATA2_LENGTH_S)
#define IG3_PEOC1_GLPEOC_ERRDATA3 0x42900CC4
#define IG3_PEOC1_GLPEOC_ERRDATA3_RSVD_S 15
#define IG3_PEOC1_GLPEOC_ERRDATA3_RSVD_M RDMA_MASK3(32, 0x1FFFF, IG3_PEOC1_GLPEOC_ERRDATA3_RSVD_S)
#define IG3_PEOC1_GLPEOC_ERRDATA3_TAG_S 0
#define IG3_PEOC1_GLPEOC_ERRDATA3_TAG_M RDMA_MASK3(32, 0x7FFF, IG3_PEOC1_GLPEOC_ERRDATA3_TAG_S)
#define IG3_PEOC1_GLPEOC_ERRINFO 0x42900CB4
#define IG3_PEOC1_GLPEOC_ERRINFO_RSVD1_S 16
#define IG3_PEOC1_GLPEOC_ERRINFO_RSVD1_M RDMA_MASK3(32, 0xFFFF, IG3_PEOC1_GLPEOC_ERRINFO_RSVD1_S)
#define IG3_PEOC1_GLPEOC_ERRINFO_ERROR_CNT_S 8
#define IG3_PEOC1_GLPEOC_ERRINFO_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_ERRINFO_ERROR_CNT_S)
#define IG3_PEOC1_GLPEOC_ERRINFO_RSVD0_S 1
#define IG3_PEOC1_GLPEOC_ERRINFO_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_ERRINFO_RSVD0_S)
#define IG3_PEOC1_GLPEOC_ERRINFO_ERROR_VALID_S 0
#define IG3_PEOC1_GLPEOC_ERRINFO_ERROR_VALID_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_ERRINFO_ERROR_VALID_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG 0x42900D1C
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RSVD3_S 20
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RM_S 16
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RM_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RSVD2_S 14
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RME_S 12
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RME_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RSVD1_S 10
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_EVICT_MEM_CFG_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS 0x42900D20
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_RSVD0_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG 0x42900D14
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RSVD3_S 20
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RM_S 16
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RM_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RSVD2_S 14
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RME_S 12
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RME_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RSVD1_S 10
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_FILL_MEM_CFG_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS 0x42900D18
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_RSVD0_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_FILL_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC1_GLPEOC_FSIADR_OBJOFST 0x42900C8C
#define IG3_PEOC1_GLPEOC_FSIADR_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_FSIADR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_FSIADR_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC1_GLPEOC_FSIMCAST_OBJOFST 0x42900C90
#define IG3_PEOC1_GLPEOC_FSIMCAST_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_FSIMCAST_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_FSIMCAST_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC1_GLPEOC_HDR_OBJOFST 0x42900CA0
#define IG3_PEOC1_GLPEOC_HDR_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_HDR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_HDR_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC1_GLPEOC_HECC_ERR 0x42900CCC
#define IG3_PEOC1_GLPEOC_HECC_ERR_RSVD1_S 28
#define IG3_PEOC1_GLPEOC_HECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_HECC_ERR_RSVD1_S)
#define IG3_PEOC1_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PEOC1_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC1_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_HECC_ERR_RSVD0_S 12
#define IG3_PEOC1_GLPEOC_HECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_HECC_ERR_RSVD0_S)
#define IG3_PEOC1_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PEOC1_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC1_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_IRRQ_OBJOFST 0x42900C80
#define IG3_PEOC1_GLPEOC_IRRQ_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_IRRQ_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_IRRQ_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC1_GLPEOC_MAXOSR 0x42900CD4
#define IG3_PEOC1_GLPEOC_MAXOSR_RSVD1_S 12
#define IG3_PEOC1_GLPEOC_MAXOSR_RSVD1_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC1_GLPEOC_MAXOSR_RSVD1_S)
#define IG3_PEOC1_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S 8
#define IG3_PEOC1_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S)
#define IG3_PEOC1_GLPEOC_MAXOSR_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_MAXOSR_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_MAXOSR_RSVD0_S)
#define IG3_PEOC1_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_S 0
#define IG3_PEOC1_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_M RDMA_MASK3(32, 0x3F, IG3_PEOC1_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_S)
#define IG3_PEOC1_GLPEOC_MEM_ECC_COR_ERR 0x42900DB8
#define IG3_PEOC1_GLPEOC_MEM_ECC_COR_ERR_RSVD_S 12
#define IG3_PEOC1_GLPEOC_MEM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC1_GLPEOC_MEM_ECC_COR_ERR_RSVD_S)
#define IG3_PEOC1_GLPEOC_MEM_ECC_COR_ERR_CNT_S 0
#define IG3_PEOC1_GLPEOC_MEM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC1_GLPEOC_MEM_ECC_COR_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_MEM_ECC_UNCOR_ERR 0x42900DB4
#define IG3_PEOC1_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PEOC1_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC1_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PEOC1_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PEOC1_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC1_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_OOISCFL_OBJOFST 0x42900CB0
#define IG3_PEOC1_GLPEOC_OOISCFL_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_OOISCFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_OOISCFL_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC1_GLPEOC_OOISC_OBJOFST 0x42900CAC
#define IG3_PEOC1_GLPEOC_OOISC_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_OOISC_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_OOISC_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC1_GLPEOC_PLIST_DBG_CTL 0x42900DAC
#define IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_DONE_S 31
#define IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_DONE_S)
#define IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_RD_EN_S 30
#define IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_RD_EN_S)
#define IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_RSVD_S 26
#define IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_RSVD_S)
#define IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_DW_SEL_S)
#define IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_ADR_S 0
#define IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_PLIST_DBG_CTL_ADR_S)
#define IG3_PEOC1_GLPEOC_PLIST_DBG_DATA 0x42900DB0
#define IG3_PEOC1_GLPEOC_PLIST_DBG_DATA_RD_DW_S 0
#define IG3_PEOC1_GLPEOC_PLIST_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_PLIST_DBG_DATA_RD_DW_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG 0x42900D0C
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RSVD3_S 20
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RM_S 16
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RM_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RSVD2_S 14
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RME_S 12
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RME_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RSVD1_S 10
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_MEM_CFG_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS 0x42900D10
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_RSVD0_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC1_GLPEOC_PMATINV_CFG 0x42900CDC
#define IG3_PEOC1_GLPEOC_PMATINV_CFG_RSVD_S 6
#define IG3_PEOC1_GLPEOC_PMATINV_CFG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_PEOC1_GLPEOC_PMATINV_CFG_RSVD_S)
#define IG3_PEOC1_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S 5
#define IG3_PEOC1_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S)
#define IG3_PEOC1_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S 4
#define IG3_PEOC1_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PEOC1_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S 3
#define IG3_PEOC1_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S)
#define IG3_PEOC1_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S 2
#define IG3_PEOC1_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S)
#define IG3_PEOC1_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S 1
#define IG3_PEOC1_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PEOC1_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_S 0
#define IG3_PEOC1_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_S)
#define IG3_PEOC1_GLPEOC_Q1FL_OBJOFST 0x42900C98
#define IG3_PEOC1_GLPEOC_Q1FL_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_Q1FL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_Q1FL_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC1_GLPEOC_RRFL_OBJOFST 0x42900CA8
#define IG3_PEOC1_GLPEOC_RRFL_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_RRFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_RRFL_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC1_GLPEOC_RRF_OBJOFST 0x42900CA4
#define IG3_PEOC1_GLPEOC_RRF_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_RRF_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_RRF_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC1_GLPEOC_SRQCTX_OBJOFST 0x42900C88
#define IG3_PEOC1_GLPEOC_SRQCTX_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_SRQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_SRQCTX_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC1_GLPEOC_STAT_CTL 0x42900C04
#define IG3_PEOC1_GLPEOC_STAT_CTL_RSVD_S 5
#define IG3_PEOC1_GLPEOC_STAT_CTL_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PEOC1_GLPEOC_STAT_CTL_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_CTL_OBJECT_TYPE_S 0
#define IG3_PEOC1_GLPEOC_STAT_CTL_OBJECT_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_STAT_CTL_OBJECT_TYPE_S)
#define IG3_PEOC1_GLPEOC_STAT_FENCING_TIME_HI 0x42900C6C
#define IG3_PEOC1_GLPEOC_STAT_FENCING_TIME_HI_RSVD_S 24
#define IG3_PEOC1_GLPEOC_STAT_FENCING_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_FENCING_TIME_HI_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_S 0
#define IG3_PEOC1_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_S)
#define IG3_PEOC1_GLPEOC_STAT_FENCING_TIME_LO 0x42900C68
#define IG3_PEOC1_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_STAT_MAX_PENDING_ENTRIES 0x42900C4C
#define IG3_PEOC1_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_S 8
#define IG3_PEOC1_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_S 0
#define IG3_PEOC1_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_S)
#define IG3_PEOC1_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH 0x42900C54
#define IG3_PEOC1_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S 8
#define IG3_PEOC1_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS 0x42900C50
#define IG3_PEOC1_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S 8
#define IG3_PEOC1_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_STAT_OBJ_CNT 0x42900C08
#define IG3_PEOC1_GLPEOC_STAT_OBJ_CNT_RSVD_S 14
#define IG3_PEOC1_GLPEOC_STAT_OBJ_CNT_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_STAT_OBJ_CNT_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_S 0
#define IG3_PEOC1_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PEOC1_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_S)
#define IG3_PEOC1_GLPEOC_STAT_PENDLING_LIST_FULL_HI 0x42900C64
#define IG3_PEOC1_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S 24
#define IG3_PEOC1_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S 0
#define IG3_PEOC1_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S)
#define IG3_PEOC1_GLPEOC_STAT_PENDLING_LIST_FULL_LO 0x42900C60
#define IG3_PEOC1_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_IDLE_HI 0x42900C30
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_S 24
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_IDLE_LO 0x42900C2C
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_XFER_HI 0x42900C38
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_S 24
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_S)
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_XFER_LO 0x42900C34
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_STAT_RD_HIT_HI 0x42900C10
#define IG3_PEOC1_GLPEOC_STAT_RD_HIT_HI_RSVD_S 24
#define IG3_PEOC1_GLPEOC_STAT_RD_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_RD_HIT_HI_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_RD_HIT_HI_CNT_HI_S 0
#define IG3_PEOC1_GLPEOC_STAT_RD_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_RD_HIT_HI_CNT_HI_S)
#define IG3_PEOC1_GLPEOC_STAT_RD_HIT_LO 0x42900C0C
#define IG3_PEOC1_GLPEOC_STAT_RD_HIT_LO_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_STAT_RD_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_STAT_RD_HIT_LO_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_STAT_RD_MISS_HI 0x42900C18
#define IG3_PEOC1_GLPEOC_STAT_RD_MISS_HI_RSVD_S 24
#define IG3_PEOC1_GLPEOC_STAT_RD_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_RD_MISS_HI_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_RD_MISS_HI_CNT_HI_S 0
#define IG3_PEOC1_GLPEOC_STAT_RD_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_RD_MISS_HI_CNT_HI_S)
#define IG3_PEOC1_GLPEOC_STAT_RD_MISS_LO 0x42900C14
#define IG3_PEOC1_GLPEOC_STAT_RD_MISS_LO_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_STAT_RD_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_STAT_RD_MISS_LO_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_STAT_REPLAY_TIME_HI 0x42900C74
#define IG3_PEOC1_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_S 24
#define IG3_PEOC1_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_S 0
#define IG3_PEOC1_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_S)
#define IG3_PEOC1_GLPEOC_STAT_REPLAY_TIME_LO 0x42900C70
#define IG3_PEOC1_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_BUFF_FULL_HI 0x42900C5C
#define IG3_PEOC1_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_S 24
#define IG3_PEOC1_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S 0
#define IG3_PEOC1_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_BUFF_FULL_LO 0x42900C58
#define IG3_PEOC1_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_IDLE_HI 0x42900C40
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_S 24
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_IDLE_LO 0x42900C3C
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_XFER_HI 0x42900C48
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_S 24
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_XFER_LO 0x42900C44
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_HIT_HI 0x42900C20
#define IG3_PEOC1_GLPEOC_STAT_WR_HIT_HI_RSVD_S 24
#define IG3_PEOC1_GLPEOC_STAT_WR_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_WR_HIT_HI_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_HIT_HI_CNT_HI_S 0
#define IG3_PEOC1_GLPEOC_STAT_WR_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_WR_HIT_HI_CNT_HI_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_HIT_LO 0x42900C1C
#define IG3_PEOC1_GLPEOC_STAT_WR_HIT_LO_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_STAT_WR_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_STAT_WR_HIT_LO_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_MISS_HI 0x42900C28
#define IG3_PEOC1_GLPEOC_STAT_WR_MISS_HI_RSVD_S 24
#define IG3_PEOC1_GLPEOC_STAT_WR_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_STAT_WR_MISS_HI_RSVD_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_MISS_HI_CNT_HI_S 0
#define IG3_PEOC1_GLPEOC_STAT_WR_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_STAT_WR_MISS_HI_CNT_HI_S)
#define IG3_PEOC1_GLPEOC_STAT_WR_MISS_LO 0x42900C24
#define IG3_PEOC1_GLPEOC_STAT_WR_MISS_LO_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_STAT_WR_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_STAT_WR_MISS_LO_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_TAG_DBG_CTL 0x42900D64
#define IG3_PEOC1_GLPEOC_TAG_DBG_CTL_DONE_S 31
#define IG3_PEOC1_GLPEOC_TAG_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_DBG_CTL_DONE_S)
#define IG3_PEOC1_GLPEOC_TAG_DBG_CTL_RD_EN_S 30
#define IG3_PEOC1_GLPEOC_TAG_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_DBG_CTL_RD_EN_S)
#define IG3_PEOC1_GLPEOC_TAG_DBG_CTL_RSVD_S 26
#define IG3_PEOC1_GLPEOC_TAG_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_TAG_DBG_CTL_RSVD_S)
#define IG3_PEOC1_GLPEOC_TAG_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC1_GLPEOC_TAG_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_TAG_DBG_CTL_DW_SEL_S)
#define IG3_PEOC1_GLPEOC_TAG_DBG_CTL_ADR_S 0
#define IG3_PEOC1_GLPEOC_TAG_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_TAG_DBG_CTL_ADR_S)
#define IG3_PEOC1_GLPEOC_TAG_DBG_DATA 0x42900D68
#define IG3_PEOC1_GLPEOC_TAG_DBG_DATA_RD_DW_S 0
#define IG3_PEOC1_GLPEOC_TAG_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_TAG_DBG_DATA_RD_DW_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG 0x42900CFC
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RSVD3_S 20
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RM_S 16
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RM_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RSVD2_S 14
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RME_S 12
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RME_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RSVD1_S 10
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_MEM_CFG_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS 0x42900D00
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_RSVD0_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC1_GLPEOC_TIMER_OBJOFST 0x42900C9C
#define IG3_PEOC1_GLPEOC_TIMER_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_TIMER_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_TIMER_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_HI 0x42900CF0
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_HI_RSVD_S 24
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_TOTAL_TAG_HI_RSVD_S)
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_HI_CNT_HI_S 0
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_TOTAL_TAG_HI_CNT_HI_S)
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_HIT_HI 0x42900CF8
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_S 24
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_S)
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_S 0
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC1_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_S)
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_HIT_LO 0x42900CF4
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_LO 0x42900CEC
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_LO_CNT_LO_S 0
#define IG3_PEOC1_GLPEOC_TOTAL_TAG_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC1_GLPEOC_TOTAL_TAG_LO_CNT_LO_S)
#define IG3_PEOC1_GLPEOC_TXFIFO_OBJOFST 0x42900C7C
#define IG3_PEOC1_GLPEOC_TXFIFO_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_TXFIFO_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_TXFIFO_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG 0x42900D04
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RSVD3_S 20
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RSVD3_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RM_S 16
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RM_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RSVD2_S 14
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RSVD2_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RME_S 12
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RME_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RSVD1_S 10
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RSVD1_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RSVD0_S 6
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_RSVD0_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_MASK_INT_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_WRBUF_MEM_CFG_ECC_EN_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS 0x42900D08
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_RSVD1_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_RSVD0_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC1_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC1_GLPEOC_XFFL_OBJOFST 0x42900C94
#define IG3_PEOC1_GLPEOC_XFFL_OBJOFST_RSVD_S 10
#define IG3_PEOC1_GLPEOC_XFFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC1_GLPEOC_XFFL_OBJOFST_RSVD_S)
#define IG3_PEOC1_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC1_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC1_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_ARPTBLE_OBJOFST 0x42901078
#define IG3_FLOC_GLFLOC_ARPTBLE_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_ARPTBLE_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_ARPTBLE_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_CACHESIZE 0x429010E0
#define IG3_FLOC_GLFLOC_CACHESIZE_RSVD_S 24
#define IG3_FLOC_GLFLOC_CACHESIZE_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHESIZE_RSVD_S)
#define IG3_FLOC_GLFLOC_CACHESIZE_WAYS_S 20
#define IG3_FLOC_GLFLOC_CACHESIZE_WAYS_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHESIZE_WAYS_S)
#define IG3_FLOC_GLFLOC_CACHESIZE_SETS_S 8
#define IG3_FLOC_GLFLOC_CACHESIZE_SETS_M RDMA_MASK3(32, 0xFFF, IG3_FLOC_GLFLOC_CACHESIZE_SETS_S)
#define IG3_FLOC_GLFLOC_CACHESIZE_WORD_SIZE_S 0
#define IG3_FLOC_GLFLOC_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHESIZE_WORD_SIZE_S)
#define IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL 0x4290116C
#define IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_DONE_S 31
#define IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_RD_EN_S 30
#define IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_RD_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_RSVD_S 26
#define IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_RSVD_S)
#define IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_DW_SEL_S 18
#define IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_DW_SEL_S)
#define IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_ADR_S 0
#define IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_0_DBG_CTL_ADR_S)
#define IG3_FLOC_GLFLOC_CACHE_0_DBG_DATA 0x42901170
#define IG3_FLOC_GLFLOC_CACHE_0_DBG_DATA_RD_DW_S 0
#define IG3_FLOC_GLFLOC_CACHE_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_CACHE_0_DBG_DATA_RD_DW_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG 0x42901124
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RSVD3_S 20
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RSVD3_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RM_S 16
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RM_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RSVD2_S 14
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RSVD2_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RME_S 12
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RME_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RSVD1_S 10
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ERR_CNT_S 9
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_FIX_CNT_S 8
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_FIX_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RSVD0_S 6
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_MASK_INT_S 5
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_MASK_INT_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_LS_BYPASS_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_LS_FORCE_S 3
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_LS_FORCE_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ECC_EN_S 0
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_MEM_CFG_ECC_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS 0x42901128
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_RSVD1_S 30
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_RSVD0_S 4
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_ECC_FIX_S)
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_0_MEM_STATUS_ECC_ERR_S)
#define IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL 0x42901174
#define IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_DONE_S 31
#define IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_RD_EN_S 30
#define IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_RD_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_RSVD_S 26
#define IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_RSVD_S)
#define IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_DW_SEL_S 18
#define IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_DW_SEL_S)
#define IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_ADR_S 0
#define IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_1_DBG_CTL_ADR_S)
#define IG3_FLOC_GLFLOC_CACHE_1_DBG_DATA 0x42901178
#define IG3_FLOC_GLFLOC_CACHE_1_DBG_DATA_RD_DW_S 0
#define IG3_FLOC_GLFLOC_CACHE_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_CACHE_1_DBG_DATA_RD_DW_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG 0x4290112C
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RSVD3_S 20
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RSVD3_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RM_S 16
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RM_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RSVD2_S 14
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RSVD2_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RME_S 12
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RME_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RSVD1_S 10
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ERR_CNT_S 9
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_FIX_CNT_S 8
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_FIX_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RSVD0_S 6
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_MASK_INT_S 5
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_MASK_INT_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_LS_BYPASS_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_LS_FORCE_S 3
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_LS_FORCE_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ECC_EN_S 0
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_MEM_CFG_ECC_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS 0x42901130
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_RSVD1_S 30
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_RSVD0_S 4
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_ECC_FIX_S)
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_1_MEM_STATUS_ECC_ERR_S)
#define IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL 0x4290117C
#define IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_DONE_S 31
#define IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_RD_EN_S 30
#define IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_RD_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_RSVD_S 26
#define IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_RSVD_S)
#define IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_DW_SEL_S 18
#define IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_DW_SEL_S)
#define IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_ADR_S 0
#define IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_2_DBG_CTL_ADR_S)
#define IG3_FLOC_GLFLOC_CACHE_2_DBG_DATA 0x42901180
#define IG3_FLOC_GLFLOC_CACHE_2_DBG_DATA_RD_DW_S 0
#define IG3_FLOC_GLFLOC_CACHE_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_CACHE_2_DBG_DATA_RD_DW_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG 0x42901134
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RSVD3_S 20
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RSVD3_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RM_S 16
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RM_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RSVD2_S 14
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RSVD2_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RME_S 12
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RME_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RSVD1_S 10
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ERR_CNT_S 9
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_FIX_CNT_S 8
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_FIX_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RSVD0_S 6
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_MASK_INT_S 5
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_MASK_INT_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_LS_BYPASS_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_LS_FORCE_S 3
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_LS_FORCE_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ECC_EN_S 0
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_MEM_CFG_ECC_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS 0x42901138
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_RSVD1_S 30
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_RSVD0_S 4
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_ECC_FIX_S)
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_2_MEM_STATUS_ECC_ERR_S)
#define IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL 0x42901184
#define IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_DONE_S 31
#define IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_RD_EN_S 30
#define IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_RD_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_RSVD_S 26
#define IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_RSVD_S)
#define IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_DW_SEL_S 18
#define IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_DW_SEL_S)
#define IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_ADR_S 0
#define IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_3_DBG_CTL_ADR_S)
#define IG3_FLOC_GLFLOC_CACHE_3_DBG_DATA 0x42901188
#define IG3_FLOC_GLFLOC_CACHE_3_DBG_DATA_RD_DW_S 0
#define IG3_FLOC_GLFLOC_CACHE_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_CACHE_3_DBG_DATA_RD_DW_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG 0x4290113C
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RSVD3_S 20
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RSVD3_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RM_S 16
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RM_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RSVD2_S 14
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RSVD2_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RME_S 12
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RME_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RSVD1_S 10
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ERR_CNT_S 9
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_FIX_CNT_S 8
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_FIX_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RSVD0_S 6
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_MASK_INT_S 5
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_MASK_INT_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_LS_BYPASS_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_LS_FORCE_S 3
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_LS_FORCE_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ECC_EN_S 0
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_MEM_CFG_ECC_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS 0x42901140
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_RSVD1_S 30
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_RSVD0_S 4
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_ECC_FIX_S)
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_3_MEM_STATUS_ECC_ERR_S)
#define IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL 0x4290118C
#define IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_DONE_S 31
#define IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_RD_EN_S 30
#define IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_RD_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_RSVD_S 26
#define IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_RSVD_S)
#define IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_DW_SEL_S 18
#define IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_DW_SEL_S)
#define IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_ADR_S 0
#define IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_4_DBG_CTL_ADR_S)
#define IG3_FLOC_GLFLOC_CACHE_4_DBG_DATA 0x42901190
#define IG3_FLOC_GLFLOC_CACHE_4_DBG_DATA_RD_DW_S 0
#define IG3_FLOC_GLFLOC_CACHE_4_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_CACHE_4_DBG_DATA_RD_DW_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG 0x42901144
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RSVD3_S 20
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RSVD3_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RM_S 16
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RM_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RSVD2_S 14
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RSVD2_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RME_S 12
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RME_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RSVD1_S 10
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ERR_CNT_S 9
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_FIX_CNT_S 8
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_FIX_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RSVD0_S 6
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_MASK_INT_S 5
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_MASK_INT_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_LS_BYPASS_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_LS_FORCE_S 3
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_LS_FORCE_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ECC_EN_S 0
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_MEM_CFG_ECC_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS 0x42901148
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_RSVD1_S 30
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_RSVD0_S 4
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_ECC_FIX_S)
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_4_MEM_STATUS_ECC_ERR_S)
#define IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL 0x42901194
#define IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_DONE_S 31
#define IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_RD_EN_S 30
#define IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_RD_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_RSVD_S 26
#define IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_RSVD_S)
#define IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_DW_SEL_S 18
#define IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_DW_SEL_S)
#define IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_ADR_S 0
#define IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_5_DBG_CTL_ADR_S)
#define IG3_FLOC_GLFLOC_CACHE_5_DBG_DATA 0x42901198
#define IG3_FLOC_GLFLOC_CACHE_5_DBG_DATA_RD_DW_S 0
#define IG3_FLOC_GLFLOC_CACHE_5_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_CACHE_5_DBG_DATA_RD_DW_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG 0x4290114C
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RSVD3_S 20
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RSVD3_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RM_S 16
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RM_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RSVD2_S 14
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RSVD2_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RME_S 12
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RME_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RSVD1_S 10
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ERR_CNT_S 9
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_FIX_CNT_S 8
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_FIX_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RSVD0_S 6
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_MASK_INT_S 5
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_MASK_INT_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_LS_BYPASS_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_LS_FORCE_S 3
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_LS_FORCE_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ECC_EN_S 0
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_MEM_CFG_ECC_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS 0x42901150
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_RSVD1_S 30
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_RSVD0_S 4
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_ECC_FIX_S)
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_5_MEM_STATUS_ECC_ERR_S)
#define IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL 0x4290119C
#define IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_DONE_S 31
#define IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_RD_EN_S 30
#define IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_RD_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_RSVD_S 26
#define IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_RSVD_S)
#define IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_DW_SEL_S 18
#define IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_DW_SEL_S)
#define IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_ADR_S 0
#define IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_6_DBG_CTL_ADR_S)
#define IG3_FLOC_GLFLOC_CACHE_6_DBG_DATA 0x429011A0
#define IG3_FLOC_GLFLOC_CACHE_6_DBG_DATA_RD_DW_S 0
#define IG3_FLOC_GLFLOC_CACHE_6_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_CACHE_6_DBG_DATA_RD_DW_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG 0x42901154
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RSVD3_S 20
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RSVD3_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RM_S 16
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RM_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RSVD2_S 14
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RSVD2_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RME_S 12
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RME_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RSVD1_S 10
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ERR_CNT_S 9
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_FIX_CNT_S 8
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_FIX_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RSVD0_S 6
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_MASK_INT_S 5
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_MASK_INT_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_LS_BYPASS_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_LS_FORCE_S 3
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_LS_FORCE_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ECC_EN_S 0
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_MEM_CFG_ECC_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS 0x42901158
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_RSVD1_S 30
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_RSVD0_S 4
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_ECC_FIX_S)
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_6_MEM_STATUS_ECC_ERR_S)
#define IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL 0x429011A4
#define IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_DONE_S 31
#define IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_RD_EN_S 30
#define IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_RD_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_RSVD_S 26
#define IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_RSVD_S)
#define IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_DW_SEL_S 18
#define IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_DW_SEL_S)
#define IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_ADR_S 0
#define IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_7_DBG_CTL_ADR_S)
#define IG3_FLOC_GLFLOC_CACHE_7_DBG_DATA 0x429011A8
#define IG3_FLOC_GLFLOC_CACHE_7_DBG_DATA_RD_DW_S 0
#define IG3_FLOC_GLFLOC_CACHE_7_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_CACHE_7_DBG_DATA_RD_DW_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG 0x4290115C
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RSVD3_S 20
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RSVD3_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RM_S 16
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RM_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RSVD2_S 14
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RSVD2_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RME_S 12
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RME_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RSVD1_S 10
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ERR_CNT_S 9
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_FIX_CNT_S 8
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_FIX_CNT_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RSVD0_S 6
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_MASK_INT_S 5
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_MASK_INT_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_LS_BYPASS_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_LS_FORCE_S 3
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_LS_FORCE_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ECC_EN_S 0
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_MEM_CFG_ECC_EN_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS 0x42901160
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_RSVD1_S 30
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_RSVD1_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_RSVD0_S 4
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_RSVD0_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_ECC_FIX_S)
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CACHE_7_MEM_STATUS_ECC_ERR_S)
#define IG3_FLOC_GLFLOC_CACHE_CTRL 0x42901000
#define IG3_FLOC_GLFLOC_CACHE_CTRL_RSVD_S 2
#define IG3_FLOC_GLFLOC_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_FLOC_GLFLOC_CACHE_CTRL_RSVD_S)
#define IG3_FLOC_GLFLOC_CACHE_CTRL_SCALE_FACTOR_S 0
#define IG3_FLOC_GLFLOC_CACHE_CTRL_SCALE_FACTOR_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_CACHE_CTRL_SCALE_FACTOR_S)
#define IG3_FLOC_GLFLOC_CECC_ERR 0x429010D0
#define IG3_FLOC_GLFLOC_CECC_ERR_RSVD1_S 28
#define IG3_FLOC_GLFLOC_CECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CECC_ERR_RSVD1_S)
#define IG3_FLOC_GLFLOC_CECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_FLOC_GLFLOC_CECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_FLOC_GLFLOC_CECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_CECC_ERR_RSVD0_S 12
#define IG3_FLOC_GLFLOC_CECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_CECC_ERR_RSVD0_S)
#define IG3_FLOC_GLFLOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_FLOC_GLFLOC_CECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_FLOC_GLFLOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_CQCTX_OBJOFST 0x42901084
#define IG3_FLOC_GLFLOC_CQCTX_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_CQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_CQCTX_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_CSTATELKUP_CFG 0x429010D8
#define IG3_FLOC_GLFLOC_CSTATELKUP_CFG_RSVD1_S 9
#define IG3_FLOC_GLFLOC_CSTATELKUP_CFG_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_FLOC_GLFLOC_CSTATELKUP_CFG_RSVD1_S)
#define IG3_FLOC_GLFLOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S 8
#define IG3_FLOC_GLFLOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S)
#define IG3_FLOC_GLFLOC_CSTATELKUP_CFG_RSVD0_S 3
#define IG3_FLOC_GLFLOC_CSTATELKUP_CFG_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_CSTATELKUP_CFG_RSVD0_S)
#define IG3_FLOC_GLFLOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S 0
#define IG3_FLOC_GLFLOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_M RDMA_MASK3(32, 0x7, IG3_FLOC_GLFLOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S)
#define IG3_FLOC_GLFLOC_DPC_COMP 0x429010E8
#define IG3_FLOC_GLFLOC_DPC_COMP_RSVD_S 13
#define IG3_FLOC_GLFLOC_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_FLOC_GLFLOC_DPC_COMP_RSVD_S)
#define IG3_FLOC_GLFLOC_DPC_COMP_COMP_FTYPE_S 11
#define IG3_FLOC_GLFLOC_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_DPC_COMP_COMP_FTYPE_S)
#define IG3_FLOC_GLFLOC_DPC_COMP_COMP_FNUM_S 1
#define IG3_FLOC_GLFLOC_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_DPC_COMP_COMP_FNUM_S)
#define IG3_FLOC_GLFLOC_DPC_COMP_COMP_VALID_S 0
#define IG3_FLOC_GLFLOC_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_DPC_COMP_COMP_VALID_S)
#define IG3_FLOC_GLFLOC_DPC_REQ 0x429010E4
#define IG3_FLOC_GLFLOC_DPC_REQ_RSVD_S 12
#define IG3_FLOC_GLFLOC_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_FLOC_GLFLOC_DPC_REQ_RSVD_S)
#define IG3_FLOC_GLFLOC_DPC_REQ_REQ_FTYPE_S 10
#define IG3_FLOC_GLFLOC_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_DPC_REQ_REQ_FTYPE_S)
#define IG3_FLOC_GLFLOC_DPC_REQ_REQ_FNUM_S 0
#define IG3_FLOC_GLFLOC_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_DPC_REQ_REQ_FNUM_S)
#define IG3_FLOC_GLFLOC_ECC_CTL 0x429010C8
#define IG3_FLOC_GLFLOC_ECC_CTL_RSVD_S 8
#define IG3_FLOC_GLFLOC_ECC_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_ECC_CTL_RSVD_S)
#define IG3_FLOC_GLFLOC_ECC_CTL_CLIENT_ECC_INVERT2_S 7
#define IG3_FLOC_GLFLOC_ECC_CTL_CLIENT_ECC_INVERT2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_ECC_CTL_CLIENT_ECC_INVERT2_S)
#define IG3_FLOC_GLFLOC_ECC_CTL_CLIENT_ECC_INVERT1_S 6
#define IG3_FLOC_GLFLOC_ECC_CTL_CLIENT_ECC_INVERT1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_ECC_CTL_CLIENT_ECC_INVERT1_S)
#define IG3_FLOC_GLFLOC_ECC_CTL_CLIENT_ECC_MASK_INT_S 5
#define IG3_FLOC_GLFLOC_ECC_CTL_CLIENT_ECC_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_ECC_CTL_CLIENT_ECC_MASK_INT_S)
#define IG3_FLOC_GLFLOC_ECC_CTL_CLIENT_ECC_EN_S 4
#define IG3_FLOC_GLFLOC_ECC_CTL_CLIENT_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_ECC_CTL_CLIENT_ECC_EN_S)
#define IG3_FLOC_GLFLOC_ECC_CTL_HOST_ECC_INVERT2_S 3
#define IG3_FLOC_GLFLOC_ECC_CTL_HOST_ECC_INVERT2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_ECC_CTL_HOST_ECC_INVERT2_S)
#define IG3_FLOC_GLFLOC_ECC_CTL_HOST_ECC_INVERT1_S 2
#define IG3_FLOC_GLFLOC_ECC_CTL_HOST_ECC_INVERT1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_ECC_CTL_HOST_ECC_INVERT1_S)
#define IG3_FLOC_GLFLOC_ECC_CTL_HOST_ECC_MASK_INT_S 1
#define IG3_FLOC_GLFLOC_ECC_CTL_HOST_ECC_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_ECC_CTL_HOST_ECC_MASK_INT_S)
#define IG3_FLOC_GLFLOC_ECC_CTL_HOST_ECC_EN_S 0
#define IG3_FLOC_GLFLOC_ECC_CTL_HOST_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_ECC_CTL_HOST_ECC_EN_S)
#define IG3_FLOC_GLFLOC_ERRDATA0 0x429010B8
#define IG3_FLOC_GLFLOC_ERRDATA0_RSVD1_S 31
#define IG3_FLOC_GLFLOC_ERRDATA0_RSVD1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_ERRDATA0_RSVD1_S)
#define IG3_FLOC_GLFLOC_ERRDATA0_PF_NUM_S 25
#define IG3_FLOC_GLFLOC_ERRDATA0_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_FLOC_GLFLOC_ERRDATA0_PF_NUM_S)
#define IG3_FLOC_GLFLOC_ERRDATA0_VDEV_VF_NUM_S 15
#define IG3_FLOC_GLFLOC_ERRDATA0_VDEV_VF_NUM_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_ERRDATA0_VDEV_VF_NUM_S)
#define IG3_FLOC_GLFLOC_ERRDATA0_VDEV_VF_TYPE_S 13
#define IG3_FLOC_GLFLOC_ERRDATA0_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_ERRDATA0_VDEV_VF_TYPE_S)
#define IG3_FLOC_GLFLOC_ERRDATA0_OBJ_TYPE_S 8
#define IG3_FLOC_GLFLOC_ERRDATA0_OBJ_TYPE_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_ERRDATA0_OBJ_TYPE_S)
#define IG3_FLOC_GLFLOC_ERRDATA0_RSVD0_S 6
#define IG3_FLOC_GLFLOC_ERRDATA0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_ERRDATA0_RSVD0_S)
#define IG3_FLOC_GLFLOC_ERRDATA0_ERROR_CODE_S 0
#define IG3_FLOC_GLFLOC_ERRDATA0_ERROR_CODE_M RDMA_MASK3(32, 0x3F, IG3_FLOC_GLFLOC_ERRDATA0_ERROR_CODE_S)
#define IG3_FLOC_GLFLOC_ERRDATA1 0x429010BC
#define IG3_FLOC_GLFLOC_ERRDATA1_RSVD_S 28
#define IG3_FLOC_GLFLOC_ERRDATA1_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_ERRDATA1_RSVD_S)
#define IG3_FLOC_GLFLOC_ERRDATA1_OBJ_INDEX_S 0
#define IG3_FLOC_GLFLOC_ERRDATA1_OBJ_INDEX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_FLOC_GLFLOC_ERRDATA1_OBJ_INDEX_S)
#define IG3_FLOC_GLFLOC_ERRDATA2 0x429010C0
#define IG3_FLOC_GLFLOC_ERRDATA2_RSVD_S 23
#define IG3_FLOC_GLFLOC_ERRDATA2_RSVD_M RDMA_MASK3(32, 0x1FF, IG3_FLOC_GLFLOC_ERRDATA2_RSVD_S)
#define IG3_FLOC_GLFLOC_ERRDATA2_OPTYPE_S 20
#define IG3_FLOC_GLFLOC_ERRDATA2_OPTYPE_M RDMA_MASK3(32, 0x7, IG3_FLOC_GLFLOC_ERRDATA2_OPTYPE_S)
#define IG3_FLOC_GLFLOC_ERRDATA2_OFFSET_S 7
#define IG3_FLOC_GLFLOC_ERRDATA2_OFFSET_M RDMA_MASK3(32, 0x1FFF, IG3_FLOC_GLFLOC_ERRDATA2_OFFSET_S)
#define IG3_FLOC_GLFLOC_ERRDATA2_LENGTH_S 0
#define IG3_FLOC_GLFLOC_ERRDATA2_LENGTH_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_ERRDATA2_LENGTH_S)
#define IG3_FLOC_GLFLOC_ERRDATA3 0x429010C4
#define IG3_FLOC_GLFLOC_ERRDATA3_RSVD_S 15
#define IG3_FLOC_GLFLOC_ERRDATA3_RSVD_M RDMA_MASK3(32, 0x1FFFF, IG3_FLOC_GLFLOC_ERRDATA3_RSVD_S)
#define IG3_FLOC_GLFLOC_ERRDATA3_TAG_S 0
#define IG3_FLOC_GLFLOC_ERRDATA3_TAG_M RDMA_MASK3(32, 0x7FFF, IG3_FLOC_GLFLOC_ERRDATA3_TAG_S)
#define IG3_FLOC_GLFLOC_ERRINFO 0x429010B4
#define IG3_FLOC_GLFLOC_ERRINFO_RSVD1_S 16
#define IG3_FLOC_GLFLOC_ERRINFO_RSVD1_M RDMA_MASK3(32, 0xFFFF, IG3_FLOC_GLFLOC_ERRINFO_RSVD1_S)
#define IG3_FLOC_GLFLOC_ERRINFO_ERROR_CNT_S 8
#define IG3_FLOC_GLFLOC_ERRINFO_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_ERRINFO_ERROR_CNT_S)
#define IG3_FLOC_GLFLOC_ERRINFO_RSVD0_S 1
#define IG3_FLOC_GLFLOC_ERRINFO_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_ERRINFO_RSVD0_S)
#define IG3_FLOC_GLFLOC_ERRINFO_ERROR_VALID_S 0
#define IG3_FLOC_GLFLOC_ERRINFO_ERROR_VALID_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_ERRINFO_ERROR_VALID_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG 0x4290111C
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RSVD3_S 20
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RSVD3_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RM_S 16
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RM_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RSVD2_S 14
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RSVD2_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RME_S 12
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RME_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RSVD1_S 10
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RSVD1_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ERR_CNT_S 9
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_FIX_CNT_S 8
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_FIX_CNT_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RSVD0_S 6
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_RSVD0_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_MASK_INT_S 5
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_MASK_INT_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_LS_BYPASS_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_LS_FORCE_S 3
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_LS_FORCE_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ECC_EN_S 0
#define IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_EVICT_MEM_CFG_ECC_EN_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS 0x42901120
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_RSVD1_S 30
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_RSVD1_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_RSVD0_S 4
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_RSVD0_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_ECC_FIX_S)
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_EVICT_MEM_STATUS_ECC_ERR_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG 0x42901114
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_FILL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_RSVD3_S 20
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_FILL_MEM_CFG_RSVD3_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_RM_S 16
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_FILL_MEM_CFG_RM_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_RSVD2_S 14
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_FILL_MEM_CFG_RSVD2_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_FILL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_RME_S 12
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_FILL_MEM_CFG_RME_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_RSVD1_S 10
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_FILL_MEM_CFG_RSVD1_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_ERR_CNT_S 9
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_FILL_MEM_CFG_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_FIX_CNT_S 8
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_FILL_MEM_CFG_FIX_CNT_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_RSVD0_S 6
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_FILL_MEM_CFG_RSVD0_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_MASK_INT_S 5
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_FILL_MEM_CFG_MASK_INT_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_FILL_MEM_CFG_LS_BYPASS_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_LS_FORCE_S 3
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_FILL_MEM_CFG_LS_FORCE_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_FILL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_FILL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_ECC_EN_S 0
#define IG3_FLOC_GLFLOC_FILL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_FILL_MEM_CFG_ECC_EN_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS 0x42901118
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS_RSVD1_S 30
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_FILL_MEM_STATUS_RSVD1_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS_RSVD0_S 4
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_FILL_MEM_STATUS_RSVD0_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_FILL_MEM_STATUS_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_FILL_MEM_STATUS_ECC_FIX_S)
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLOC_GLFLOC_FILL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_FILL_MEM_STATUS_ECC_ERR_S)
#define IG3_FLOC_GLFLOC_FSIADR_OBJOFST 0x4290108C
#define IG3_FLOC_GLFLOC_FSIADR_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_FSIADR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_FSIADR_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_FSIMCAST_OBJOFST 0x42901090
#define IG3_FLOC_GLFLOC_FSIMCAST_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_FSIMCAST_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_FSIMCAST_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_HDR_OBJOFST 0x429010A0
#define IG3_FLOC_GLFLOC_HDR_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_HDR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_HDR_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_HECC_ERR 0x429010CC
#define IG3_FLOC_GLFLOC_HECC_ERR_RSVD1_S 28
#define IG3_FLOC_GLFLOC_HECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_HECC_ERR_RSVD1_S)
#define IG3_FLOC_GLFLOC_HECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_FLOC_GLFLOC_HECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_FLOC_GLFLOC_HECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_HECC_ERR_RSVD0_S 12
#define IG3_FLOC_GLFLOC_HECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_HECC_ERR_RSVD0_S)
#define IG3_FLOC_GLFLOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_FLOC_GLFLOC_HECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_FLOC_GLFLOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_IRRQ_OBJOFST 0x42901080
#define IG3_FLOC_GLFLOC_IRRQ_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_IRRQ_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_IRRQ_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_MAXOSR 0x429010D4
#define IG3_FLOC_GLFLOC_MAXOSR_RSVD1_S 14
#define IG3_FLOC_GLFLOC_MAXOSR_RSVD1_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_MAXOSR_RSVD1_S)
#define IG3_FLOC_GLFLOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S 10
#define IG3_FLOC_GLFLOC_MAXOSR_MAX_OSR_CLNT_WRPULL_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S)
#define IG3_FLOC_GLFLOC_MAXOSR_RSVD0_S 6
#define IG3_FLOC_GLFLOC_MAXOSR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_MAXOSR_RSVD0_S)
#define IG3_FLOC_GLFLOC_MAXOSR_MAX_OSR_PMAT_FETCH_S 0
#define IG3_FLOC_GLFLOC_MAXOSR_MAX_OSR_PMAT_FETCH_M RDMA_MASK3(32, 0x3F, IG3_FLOC_GLFLOC_MAXOSR_MAX_OSR_PMAT_FETCH_S)
#define IG3_FLOC_GLFLOC_MEM_ECC_COR_ERR 0x429011B8
#define IG3_FLOC_GLFLOC_MEM_ECC_COR_ERR_RSVD_S 12
#define IG3_FLOC_GLFLOC_MEM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_FLOC_GLFLOC_MEM_ECC_COR_ERR_RSVD_S)
#define IG3_FLOC_GLFLOC_MEM_ECC_COR_ERR_CNT_S 0
#define IG3_FLOC_GLFLOC_MEM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_FLOC_GLFLOC_MEM_ECC_COR_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_MEM_ECC_UNCOR_ERR 0x429011B4
#define IG3_FLOC_GLFLOC_MEM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_FLOC_GLFLOC_MEM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_FLOC_GLFLOC_MEM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_FLOC_GLFLOC_MEM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_FLOC_GLFLOC_MEM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_FLOC_GLFLOC_MEM_ECC_UNCOR_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_OOISCFL_OBJOFST 0x429010B0
#define IG3_FLOC_GLFLOC_OOISCFL_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_OOISCFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_OOISCFL_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_OOISC_OBJOFST 0x429010AC
#define IG3_FLOC_GLFLOC_OOISC_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_OOISC_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_OOISC_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_PLIST_DBG_CTL 0x429011AC
#define IG3_FLOC_GLFLOC_PLIST_DBG_CTL_DONE_S 31
#define IG3_FLOC_GLFLOC_PLIST_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_DBG_CTL_DONE_S)
#define IG3_FLOC_GLFLOC_PLIST_DBG_CTL_RD_EN_S 30
#define IG3_FLOC_GLFLOC_PLIST_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_DBG_CTL_RD_EN_S)
#define IG3_FLOC_GLFLOC_PLIST_DBG_CTL_RSVD_S 26
#define IG3_FLOC_GLFLOC_PLIST_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_PLIST_DBG_CTL_RSVD_S)
#define IG3_FLOC_GLFLOC_PLIST_DBG_CTL_DW_SEL_S 18
#define IG3_FLOC_GLFLOC_PLIST_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_PLIST_DBG_CTL_DW_SEL_S)
#define IG3_FLOC_GLFLOC_PLIST_DBG_CTL_ADR_S 0
#define IG3_FLOC_GLFLOC_PLIST_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_PLIST_DBG_CTL_ADR_S)
#define IG3_FLOC_GLFLOC_PLIST_DBG_DATA 0x429011B0
#define IG3_FLOC_GLFLOC_PLIST_DBG_DATA_RD_DW_S 0
#define IG3_FLOC_GLFLOC_PLIST_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_PLIST_DBG_DATA_RD_DW_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG 0x4290110C
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RSVD3_S 20
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RSVD3_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RM_S 16
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RM_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RSVD2_S 14
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RSVD2_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RME_S 12
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RME_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RSVD1_S 10
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RSVD1_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ERR_CNT_S 9
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_FIX_CNT_S 8
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_FIX_CNT_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RSVD0_S 6
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_RSVD0_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_MASK_INT_S 5
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_MASK_INT_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_LS_BYPASS_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_LS_FORCE_S 3
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_LS_FORCE_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ECC_EN_S 0
#define IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_MEM_CFG_ECC_EN_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS 0x42901110
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_RSVD1_S 30
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_RSVD1_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_RSVD0_S 4
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_RSVD0_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_ECC_FIX_S)
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PLIST_MEM_STATUS_ECC_ERR_S)
#define IG3_FLOC_GLFLOC_PMATINV_CFG 0x429010DC
#define IG3_FLOC_GLFLOC_PMATINV_CFG_RSVD_S 6
#define IG3_FLOC_GLFLOC_PMATINV_CFG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_FLOC_GLFLOC_PMATINV_CFG_RSVD_S)
#define IG3_FLOC_GLFLOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S 5
#define IG3_FLOC_GLFLOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S)
#define IG3_FLOC_GLFLOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S 4
#define IG3_FLOC_GLFLOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S)
#define IG3_FLOC_GLFLOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S 3
#define IG3_FLOC_GLFLOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S)
#define IG3_FLOC_GLFLOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S 2
#define IG3_FLOC_GLFLOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S)
#define IG3_FLOC_GLFLOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S 1
#define IG3_FLOC_GLFLOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S)
#define IG3_FLOC_GLFLOC_PMATINV_CFG_INVBYFN_FENCE_EN_S 0
#define IG3_FLOC_GLFLOC_PMATINV_CFG_INVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_PMATINV_CFG_INVBYFN_FENCE_EN_S)
#define IG3_FLOC_GLFLOC_Q1FL_OBJOFST 0x42901098
#define IG3_FLOC_GLFLOC_Q1FL_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_Q1FL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_Q1FL_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_RRFL_OBJOFST 0x429010A8
#define IG3_FLOC_GLFLOC_RRFL_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_RRFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_RRFL_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_RRF_OBJOFST 0x429010A4
#define IG3_FLOC_GLFLOC_RRF_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_RRF_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_RRF_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_SRQCTX_OBJOFST 0x42901088
#define IG3_FLOC_GLFLOC_SRQCTX_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_SRQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_SRQCTX_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_STAT_CTL 0x42901004
#define IG3_FLOC_GLFLOC_STAT_CTL_RSVD_S 5
#define IG3_FLOC_GLFLOC_STAT_CTL_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_FLOC_GLFLOC_STAT_CTL_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_CTL_OBJECT_TYPE_S 0
#define IG3_FLOC_GLFLOC_STAT_CTL_OBJECT_TYPE_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_STAT_CTL_OBJECT_TYPE_S)
#define IG3_FLOC_GLFLOC_STAT_FENCING_TIME_HI 0x4290106C
#define IG3_FLOC_GLFLOC_STAT_FENCING_TIME_HI_RSVD_S 24
#define IG3_FLOC_GLFLOC_STAT_FENCING_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_FENCING_TIME_HI_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_FENCING_TIME_HI_CNT_HI_S 0
#define IG3_FLOC_GLFLOC_STAT_FENCING_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_FENCING_TIME_HI_CNT_HI_S)
#define IG3_FLOC_GLFLOC_STAT_FENCING_TIME_LO 0x42901068
#define IG3_FLOC_GLFLOC_STAT_FENCING_TIME_LO_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_STAT_FENCING_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_STAT_FENCING_TIME_LO_CNT_LO_S)
#define IG3_FLOC_GLFLOC_STAT_MAX_PENDING_ENTRIES 0x4290104C
#define IG3_FLOC_GLFLOC_STAT_MAX_PENDING_ENTRIES_RSVD_S 8
#define IG3_FLOC_GLFLOC_STAT_MAX_PENDING_ENTRIES_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_MAX_PENDING_ENTRIES_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_MAX_PENDING_ENTRIES_CNT_S 0
#define IG3_FLOC_GLFLOC_STAT_MAX_PENDING_ENTRIES_CNT_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_MAX_PENDING_ENTRIES_CNT_S)
#define IG3_FLOC_GLFLOC_STAT_MAX_PENDING_LIST_DEPTH 0x42901054
#define IG3_FLOC_GLFLOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S 8
#define IG3_FLOC_GLFLOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S)
#define IG3_FLOC_GLFLOC_STAT_MAX_VIRT_PENDING_LISTS 0x42901050
#define IG3_FLOC_GLFLOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S 8
#define IG3_FLOC_GLFLOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S)
#define IG3_FLOC_GLFLOC_STAT_OBJ_CNT 0x42901008
#define IG3_FLOC_GLFLOC_STAT_OBJ_CNT_RSVD_S 14
#define IG3_FLOC_GLFLOC_STAT_OBJ_CNT_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_STAT_OBJ_CNT_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_OBJ_CNT_OBJECT_COUNT_S 0
#define IG3_FLOC_GLFLOC_STAT_OBJ_CNT_OBJECT_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_FLOC_GLFLOC_STAT_OBJ_CNT_OBJECT_COUNT_S)
#define IG3_FLOC_GLFLOC_STAT_PENDLING_LIST_FULL_HI 0x42901064
#define IG3_FLOC_GLFLOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S 24
#define IG3_FLOC_GLFLOC_STAT_PENDLING_LIST_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S 0
#define IG3_FLOC_GLFLOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S)
#define IG3_FLOC_GLFLOC_STAT_PENDLING_LIST_FULL_LO 0x42901060
#define IG3_FLOC_GLFLOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S)
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_IDLE_HI 0x42901030
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_IDLE_HI_RSVD_S 24
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_RD_DATA_IDLE_HI_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S)
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_IDLE_LO 0x4290102C
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S)
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_XFER_HI 0x42901038
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_XFER_HI_RSVD_S 24
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_RD_DATA_XFER_HI_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_XFER_HI_CNT_HI_S 0
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_RD_DATA_XFER_HI_CNT_HI_S)
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_XFER_LO 0x42901034
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_XFER_LO_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_STAT_RD_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_STAT_RD_DATA_XFER_LO_CNT_LO_S)
#define IG3_FLOC_GLFLOC_STAT_RD_HIT_HI 0x42901010
#define IG3_FLOC_GLFLOC_STAT_RD_HIT_HI_RSVD_S 24
#define IG3_FLOC_GLFLOC_STAT_RD_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_RD_HIT_HI_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_RD_HIT_HI_CNT_HI_S 0
#define IG3_FLOC_GLFLOC_STAT_RD_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_RD_HIT_HI_CNT_HI_S)
#define IG3_FLOC_GLFLOC_STAT_RD_HIT_LO 0x4290100C
#define IG3_FLOC_GLFLOC_STAT_RD_HIT_LO_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_STAT_RD_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_STAT_RD_HIT_LO_CNT_LO_S)
#define IG3_FLOC_GLFLOC_STAT_RD_MISS_HI 0x42901018
#define IG3_FLOC_GLFLOC_STAT_RD_MISS_HI_RSVD_S 24
#define IG3_FLOC_GLFLOC_STAT_RD_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_RD_MISS_HI_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_RD_MISS_HI_CNT_HI_S 0
#define IG3_FLOC_GLFLOC_STAT_RD_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_RD_MISS_HI_CNT_HI_S)
#define IG3_FLOC_GLFLOC_STAT_RD_MISS_LO 0x42901014
#define IG3_FLOC_GLFLOC_STAT_RD_MISS_LO_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_STAT_RD_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_STAT_RD_MISS_LO_CNT_LO_S)
#define IG3_FLOC_GLFLOC_STAT_REPLAY_TIME_HI 0x42901074
#define IG3_FLOC_GLFLOC_STAT_REPLAY_TIME_HI_RSVD_S 24
#define IG3_FLOC_GLFLOC_STAT_REPLAY_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_REPLAY_TIME_HI_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_REPLAY_TIME_HI_CNT_HI_S 0
#define IG3_FLOC_GLFLOC_STAT_REPLAY_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_REPLAY_TIME_HI_CNT_HI_S)
#define IG3_FLOC_GLFLOC_STAT_REPLAY_TIME_LO 0x42901070
#define IG3_FLOC_GLFLOC_STAT_REPLAY_TIME_LO_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_STAT_REPLAY_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_STAT_REPLAY_TIME_LO_CNT_LO_S)
#define IG3_FLOC_GLFLOC_STAT_WR_BUFF_FULL_HI 0x4290105C
#define IG3_FLOC_GLFLOC_STAT_WR_BUFF_FULL_HI_RSVD_S 24
#define IG3_FLOC_GLFLOC_STAT_WR_BUFF_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_WR_BUFF_FULL_HI_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S 0
#define IG3_FLOC_GLFLOC_STAT_WR_BUFF_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S)
#define IG3_FLOC_GLFLOC_STAT_WR_BUFF_FULL_LO 0x42901058
#define IG3_FLOC_GLFLOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_STAT_WR_BUFF_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S)
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_IDLE_HI 0x42901040
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_IDLE_HI_RSVD_S 24
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_WR_DATA_IDLE_HI_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S)
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_IDLE_LO 0x4290103C
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S)
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_XFER_HI 0x42901048
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_XFER_HI_RSVD_S 24
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_WR_DATA_XFER_HI_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_XFER_HI_CNT_HI_S 0
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_WR_DATA_XFER_HI_CNT_HI_S)
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_XFER_LO 0x42901044
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_XFER_LO_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_STAT_WR_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_STAT_WR_DATA_XFER_LO_CNT_LO_S)
#define IG3_FLOC_GLFLOC_STAT_WR_HIT_HI 0x42901020
#define IG3_FLOC_GLFLOC_STAT_WR_HIT_HI_RSVD_S 24
#define IG3_FLOC_GLFLOC_STAT_WR_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_WR_HIT_HI_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_WR_HIT_HI_CNT_HI_S 0
#define IG3_FLOC_GLFLOC_STAT_WR_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_WR_HIT_HI_CNT_HI_S)
#define IG3_FLOC_GLFLOC_STAT_WR_HIT_LO 0x4290101C
#define IG3_FLOC_GLFLOC_STAT_WR_HIT_LO_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_STAT_WR_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_STAT_WR_HIT_LO_CNT_LO_S)
#define IG3_FLOC_GLFLOC_STAT_WR_MISS_HI 0x42901028
#define IG3_FLOC_GLFLOC_STAT_WR_MISS_HI_RSVD_S 24
#define IG3_FLOC_GLFLOC_STAT_WR_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_STAT_WR_MISS_HI_RSVD_S)
#define IG3_FLOC_GLFLOC_STAT_WR_MISS_HI_CNT_HI_S 0
#define IG3_FLOC_GLFLOC_STAT_WR_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_STAT_WR_MISS_HI_CNT_HI_S)
#define IG3_FLOC_GLFLOC_STAT_WR_MISS_LO 0x42901024
#define IG3_FLOC_GLFLOC_STAT_WR_MISS_LO_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_STAT_WR_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_STAT_WR_MISS_LO_CNT_LO_S)
#define IG3_FLOC_GLFLOC_TAG_DBG_CTL 0x42901164
#define IG3_FLOC_GLFLOC_TAG_DBG_CTL_DONE_S 31
#define IG3_FLOC_GLFLOC_TAG_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_DBG_CTL_DONE_S)
#define IG3_FLOC_GLFLOC_TAG_DBG_CTL_RD_EN_S 30
#define IG3_FLOC_GLFLOC_TAG_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_DBG_CTL_RD_EN_S)
#define IG3_FLOC_GLFLOC_TAG_DBG_CTL_RSVD_S 26
#define IG3_FLOC_GLFLOC_TAG_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_TAG_DBG_CTL_RSVD_S)
#define IG3_FLOC_GLFLOC_TAG_DBG_CTL_DW_SEL_S 18
#define IG3_FLOC_GLFLOC_TAG_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_TAG_DBG_CTL_DW_SEL_S)
#define IG3_FLOC_GLFLOC_TAG_DBG_CTL_ADR_S 0
#define IG3_FLOC_GLFLOC_TAG_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_TAG_DBG_CTL_ADR_S)
#define IG3_FLOC_GLFLOC_TAG_DBG_DATA 0x42901168
#define IG3_FLOC_GLFLOC_TAG_DBG_DATA_RD_DW_S 0
#define IG3_FLOC_GLFLOC_TAG_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_TAG_DBG_DATA_RD_DW_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG 0x429010FC
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_RSVD3_S 20
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_TAG_MEM_CFG_RSVD3_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_RM_S 16
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_TAG_MEM_CFG_RM_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_RSVD2_S 14
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_TAG_MEM_CFG_RSVD2_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_RME_S 12
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_MEM_CFG_RME_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_RSVD1_S 10
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_TAG_MEM_CFG_RSVD1_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_RSVD0_S 6
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_TAG_MEM_CFG_RSVD0_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_MEM_CFG_MASK_INT_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_FLOC_GLFLOC_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_MEM_CFG_ECC_EN_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS 0x42901100
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_TAG_MEM_STATUS_RSVD1_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_TAG_MEM_STATUS_RSVD0_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLOC_GLFLOC_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_FLOC_GLFLOC_TIMER_OBJOFST 0x4290109C
#define IG3_FLOC_GLFLOC_TIMER_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_TIMER_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_TIMER_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_TOTAL_TAG_HI 0x429010F0
#define IG3_FLOC_GLFLOC_TOTAL_TAG_HI_RSVD_S 24
#define IG3_FLOC_GLFLOC_TOTAL_TAG_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_TOTAL_TAG_HI_RSVD_S)
#define IG3_FLOC_GLFLOC_TOTAL_TAG_HI_CNT_HI_S 0
#define IG3_FLOC_GLFLOC_TOTAL_TAG_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_TOTAL_TAG_HI_CNT_HI_S)
#define IG3_FLOC_GLFLOC_TOTAL_TAG_HIT_HI 0x429010F8
#define IG3_FLOC_GLFLOC_TOTAL_TAG_HIT_HI_RSVD_S 24
#define IG3_FLOC_GLFLOC_TOTAL_TAG_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_TOTAL_TAG_HIT_HI_RSVD_S)
#define IG3_FLOC_GLFLOC_TOTAL_TAG_HIT_HI_CNT_HI_S 0
#define IG3_FLOC_GLFLOC_TOTAL_TAG_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_FLOC_GLFLOC_TOTAL_TAG_HIT_HI_CNT_HI_S)
#define IG3_FLOC_GLFLOC_TOTAL_TAG_HIT_LO 0x429010F4
#define IG3_FLOC_GLFLOC_TOTAL_TAG_HIT_LO_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_TOTAL_TAG_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_TOTAL_TAG_HIT_LO_CNT_LO_S)
#define IG3_FLOC_GLFLOC_TOTAL_TAG_LO 0x429010EC
#define IG3_FLOC_GLFLOC_TOTAL_TAG_LO_CNT_LO_S 0
#define IG3_FLOC_GLFLOC_TOTAL_TAG_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLFLOC_TOTAL_TAG_LO_CNT_LO_S)
#define IG3_FLOC_GLFLOC_TXFIFO_OBJOFST 0x4290107C
#define IG3_FLOC_GLFLOC_TXFIFO_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_TXFIFO_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_TXFIFO_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG 0x42901104
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RSVD3_S 20
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RSVD3_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RM_S 16
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RM_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RSVD2_S 14
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RSVD2_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RME_S 12
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RME_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RSVD1_S 10
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RSVD1_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ERR_CNT_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_FIX_CNT_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RSVD0_S 6
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_RSVD0_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_MASK_INT_S 5
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_MASK_INT_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_LS_FORCE_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ECC_EN_S 0
#define IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_WRBUF_MEM_CFG_ECC_EN_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS 0x42901108
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_RSVD1_S 30
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_RSVD1_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_RSVD0_S 4
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_RSVD0_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLOC_GLFLOC_WRBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_FLOC_GLFLOC_XFFL_OBJOFST 0x42901094
#define IG3_FLOC_GLFLOC_XFFL_OBJOFST_RSVD_S 10
#define IG3_FLOC_GLFLOC_XFFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_FLOC_GLFLOC_XFFL_OBJOFST_RSVD_S)
#define IG3_FLOC_GLFLOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_FLOC_GLFLOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_FLOC_GLFLOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_COUNT 0x42901238
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_FLOC_GLPE_FLOC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_FLOC_GLPE_FLOC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_CMD 0x4290124C
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_DATA_H 0x42901258
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_DATA_L 0x42901254
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_PTR 0x42901250
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_FLOC_GLPE_FLOC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_CMD 0x4290123C
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_DATA_H 0x42901248
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_DATA_L 0x42901244
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_PTR 0x42901240
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_FLOC_GLPE_FLOC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL 0x42901200
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_RSVD1_S 25
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLPE_FLOC_DTM_CONTROL_RSVD1_S)
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_RSVD2_S 17
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLPE_FLOC_DTM_CONTROL_RSVD2_S)
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_RSVD3_S 9
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLPE_FLOC_DTM_CONTROL_RSVD3_S)
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_BYPASS_S 8
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_CONTROL_BYPASS_S)
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_RSVD4_S 1
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLPE_FLOC_DTM_CONTROL_RSVD4_S)
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_FLOC_GLPE_FLOC_DTM_ECC_COR_ERR 0x42901268
#define IG3_FLOC_GLPE_FLOC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_FLOC_GLPE_FLOC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_FLOC_GLPE_FLOC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_FLOC_GLPE_FLOC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_FLOC_GLPE_FLOC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_FLOC_GLPE_FLOC_DTM_ECC_UNCOR_ERR 0x42901264
#define IG3_FLOC_GLPE_FLOC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_FLOC_GLPE_FLOC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_FLOC_GLPE_FLOC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_FLOC_GLPE_FLOC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_FLOC_GLPE_FLOC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_FLOC_GLPE_FLOC_DTM_GROUP_CFG 0x4290120C
#define IG3_FLOC_GLPE_FLOC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_FLOC_GLPE_FLOC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLPE_FLOC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_FLOC_GLPE_FLOC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_FLOC_GLPE_FLOC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLPE_FLOC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_FLOC_GLPE_FLOC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_FLOC_GLPE_FLOC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLPE_FLOC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_FLOC_GLPE_FLOC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLPE_FLOC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_FLOC_GLPE_FLOC_DTM_LOG_CFG 0x42901210
#define IG3_FLOC_GLPE_FLOC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_FLOC_GLPE_FLOC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_FLOC_GLPE_FLOC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_FLOC_GLPE_FLOC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_FLOC_GLPE_FLOC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_FLOC_GLPE_FLOC_DTM_LOG_CFG_RSVD1_S)
#define IG3_FLOC_GLPE_FLOC_DTM_LOG_CFG_MODE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLPE_FLOC_DTM_LOG_CFG_MODE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_LOG_MASK 0x42901218
#define IG3_FLOC_GLPE_FLOC_DTM_LOG_MASK_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLPE_FLOC_DTM_LOG_MASK_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_LOG_PATTERN 0x42901214
#define IG3_FLOC_GLPE_FLOC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLPE_FLOC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG 0x42901204
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_STS 0x42901208
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_FLOC_GLPE_FLOC_DTM_MAIN_STS_RSVD1_S)
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLPE_FLOC_DTM_MAIN_STS_RSVD2_S)
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TIMESTAMP 0x42901230
#define IG3_FLOC_GLPE_FLOC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLPE_FLOC_DTM_TIMESTAMP_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TIMESTAMP_ROLLOVER 0x42901234
#define IG3_FLOC_GLPE_FLOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLPE_FLOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG 0x4290125C
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS 0x42901260
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_FLOC_GLPE_FLOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG 0x4290121C
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_MODE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_FLOC_GLPE_FLOC_DTM_TRIG_CFG_MODE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_COUNT 0x42901228
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLPE_FLOC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_MASK 0x42901224
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLPE_FLOC_DTM_TRIG_MASK_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_PATTERN 0x42901220
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLPE_FLOC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_TIMESTAMP 0x4290122C
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_FLOC_GLPE_FLOC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_FLOC_GLPE_FLOC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PEOC4_GLPEOC_ARPTBLE_OBJOFST 0x42901478
#define IG3_PEOC4_GLPEOC_ARPTBLE_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_ARPTBLE_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_ARPTBLE_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC4_GLPEOC_CACHESIZE 0x429014E0
#define IG3_PEOC4_GLPEOC_CACHESIZE_RSVD_S 24
#define IG3_PEOC4_GLPEOC_CACHESIZE_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHESIZE_RSVD_S)
#define IG3_PEOC4_GLPEOC_CACHESIZE_WAYS_S 20
#define IG3_PEOC4_GLPEOC_CACHESIZE_WAYS_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHESIZE_WAYS_S)
#define IG3_PEOC4_GLPEOC_CACHESIZE_SETS_S 8
#define IG3_PEOC4_GLPEOC_CACHESIZE_SETS_M RDMA_MASK3(32, 0xFFF, IG3_PEOC4_GLPEOC_CACHESIZE_SETS_S)
#define IG3_PEOC4_GLPEOC_CACHESIZE_WORD_SIZE_S 0
#define IG3_PEOC4_GLPEOC_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHESIZE_WORD_SIZE_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL 0x4290156C
#define IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_DONE_S 31
#define IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_RD_EN_S 30
#define IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_RD_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_RSVD_S 26
#define IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_RSVD_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_ADR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_0_DBG_CTL_ADR_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_DBG_DATA 0x42901570
#define IG3_PEOC4_GLPEOC_CACHE_0_DBG_DATA_RD_DW_S 0
#define IG3_PEOC4_GLPEOC_CACHE_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_CACHE_0_DBG_DATA_RD_DW_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG 0x42901524
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RSVD3_S 20
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RM_S 16
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RM_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RSVD2_S 14
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RME_S 12
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RME_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RSVD1_S 10
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS 0x42901528
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL 0x42901574
#define IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_DONE_S 31
#define IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_RD_EN_S 30
#define IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_RD_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_RSVD_S 26
#define IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_RSVD_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_ADR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_1_DBG_CTL_ADR_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_DBG_DATA 0x42901578
#define IG3_PEOC4_GLPEOC_CACHE_1_DBG_DATA_RD_DW_S 0
#define IG3_PEOC4_GLPEOC_CACHE_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_CACHE_1_DBG_DATA_RD_DW_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG 0x4290152C
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RSVD3_S 20
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RM_S 16
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RM_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RSVD2_S 14
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RME_S 12
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RME_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RSVD1_S 10
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS 0x42901530
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL 0x4290157C
#define IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_DONE_S 31
#define IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_RD_EN_S 30
#define IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_RD_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_RSVD_S 26
#define IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_RSVD_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_ADR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_2_DBG_CTL_ADR_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_DBG_DATA 0x42901580
#define IG3_PEOC4_GLPEOC_CACHE_2_DBG_DATA_RD_DW_S 0
#define IG3_PEOC4_GLPEOC_CACHE_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_CACHE_2_DBG_DATA_RD_DW_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG 0x42901534
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RSVD3_S 20
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RM_S 16
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RM_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RSVD2_S 14
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RME_S 12
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RME_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RSVD1_S 10
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS 0x42901538
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL 0x42901584
#define IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_DONE_S 31
#define IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_RD_EN_S 30
#define IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_RD_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_RSVD_S 26
#define IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_RSVD_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_ADR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_3_DBG_CTL_ADR_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_DBG_DATA 0x42901588
#define IG3_PEOC4_GLPEOC_CACHE_3_DBG_DATA_RD_DW_S 0
#define IG3_PEOC4_GLPEOC_CACHE_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_CACHE_3_DBG_DATA_RD_DW_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG 0x4290153C
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RSVD3_S 20
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RM_S 16
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RM_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RSVD2_S 14
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RME_S 12
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RME_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RSVD1_S 10
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS 0x42901540
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL 0x4290158C
#define IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_DONE_S 31
#define IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_RD_EN_S 30
#define IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_RD_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_RSVD_S 26
#define IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_RSVD_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_ADR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_4_DBG_CTL_ADR_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_DBG_DATA 0x42901590
#define IG3_PEOC4_GLPEOC_CACHE_4_DBG_DATA_RD_DW_S 0
#define IG3_PEOC4_GLPEOC_CACHE_4_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_CACHE_4_DBG_DATA_RD_DW_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG 0x42901544
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RSVD3_S 20
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RM_S 16
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RM_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RSVD2_S 14
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RME_S 12
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RME_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RSVD1_S 10
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS 0x42901548
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL 0x42901594
#define IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_DONE_S 31
#define IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_RD_EN_S 30
#define IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_RD_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_RSVD_S 26
#define IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_RSVD_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_ADR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_5_DBG_CTL_ADR_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_DBG_DATA 0x42901598
#define IG3_PEOC4_GLPEOC_CACHE_5_DBG_DATA_RD_DW_S 0
#define IG3_PEOC4_GLPEOC_CACHE_5_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_CACHE_5_DBG_DATA_RD_DW_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG 0x4290154C
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RSVD3_S 20
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RM_S 16
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RM_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RSVD2_S 14
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RME_S 12
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RME_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RSVD1_S 10
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS 0x42901550
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL 0x4290159C
#define IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_DONE_S 31
#define IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_RD_EN_S 30
#define IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_RD_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_RSVD_S 26
#define IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_RSVD_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_ADR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_6_DBG_CTL_ADR_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_DBG_DATA 0x429015A0
#define IG3_PEOC4_GLPEOC_CACHE_6_DBG_DATA_RD_DW_S 0
#define IG3_PEOC4_GLPEOC_CACHE_6_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_CACHE_6_DBG_DATA_RD_DW_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG 0x42901554
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RSVD3_S 20
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RM_S 16
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RM_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RSVD2_S 14
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RME_S 12
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RME_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RSVD1_S 10
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS 0x42901558
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL 0x429015A4
#define IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_DONE_S 31
#define IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_RD_EN_S 30
#define IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_RD_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_RSVD_S 26
#define IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_RSVD_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_ADR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_7_DBG_CTL_ADR_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_DBG_DATA 0x429015A8
#define IG3_PEOC4_GLPEOC_CACHE_7_DBG_DATA_RD_DW_S 0
#define IG3_PEOC4_GLPEOC_CACHE_7_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_CACHE_7_DBG_DATA_RD_DW_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG 0x4290155C
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RSVD3_S 20
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RM_S 16
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RM_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RSVD2_S 14
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RME_S 12
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RME_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RSVD1_S 10
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS 0x42901560
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC4_GLPEOC_CACHE_CTRL 0x42901400
#define IG3_PEOC4_GLPEOC_CACHE_CTRL_RSVD_S 2
#define IG3_PEOC4_GLPEOC_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_PEOC4_GLPEOC_CACHE_CTRL_RSVD_S)
#define IG3_PEOC4_GLPEOC_CACHE_CTRL_SCALE_FACTOR_S 0
#define IG3_PEOC4_GLPEOC_CACHE_CTRL_SCALE_FACTOR_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_CACHE_CTRL_SCALE_FACTOR_S)
#define IG3_PEOC4_GLPEOC_CECC_ERR 0x429014D0
#define IG3_PEOC4_GLPEOC_CECC_ERR_RSVD1_S 28
#define IG3_PEOC4_GLPEOC_CECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CECC_ERR_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PEOC4_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC4_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_CECC_ERR_RSVD0_S 12
#define IG3_PEOC4_GLPEOC_CECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_CECC_ERR_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PEOC4_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC4_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_CQCTX_OBJOFST 0x42901484
#define IG3_PEOC4_GLPEOC_CQCTX_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_CQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_CQCTX_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC4_GLPEOC_CSTATELKUP_CFG 0x429014D8
#define IG3_PEOC4_GLPEOC_CSTATELKUP_CFG_RSVD1_S 9
#define IG3_PEOC4_GLPEOC_CSTATELKUP_CFG_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PEOC4_GLPEOC_CSTATELKUP_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S 8
#define IG3_PEOC4_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S)
#define IG3_PEOC4_GLPEOC_CSTATELKUP_CFG_RSVD0_S 3
#define IG3_PEOC4_GLPEOC_CSTATELKUP_CFG_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_CSTATELKUP_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S 0
#define IG3_PEOC4_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_M RDMA_MASK3(32, 0x7, IG3_PEOC4_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S)
#define IG3_PEOC4_GLPEOC_DPC_COMP 0x429014E8
#define IG3_PEOC4_GLPEOC_DPC_COMP_RSVD_S 13
#define IG3_PEOC4_GLPEOC_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEOC4_GLPEOC_DPC_COMP_RSVD_S)
#define IG3_PEOC4_GLPEOC_DPC_COMP_COMP_FTYPE_S 11
#define IG3_PEOC4_GLPEOC_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_DPC_COMP_COMP_FTYPE_S)
#define IG3_PEOC4_GLPEOC_DPC_COMP_COMP_FNUM_S 1
#define IG3_PEOC4_GLPEOC_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_DPC_COMP_COMP_FNUM_S)
#define IG3_PEOC4_GLPEOC_DPC_COMP_COMP_VALID_S 0
#define IG3_PEOC4_GLPEOC_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DPC_COMP_COMP_VALID_S)
#define IG3_PEOC4_GLPEOC_DPC_REQ 0x429014E4
#define IG3_PEOC4_GLPEOC_DPC_REQ_RSVD_S 12
#define IG3_PEOC4_GLPEOC_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC4_GLPEOC_DPC_REQ_RSVD_S)
#define IG3_PEOC4_GLPEOC_DPC_REQ_REQ_FTYPE_S 10
#define IG3_PEOC4_GLPEOC_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_DPC_REQ_REQ_FTYPE_S)
#define IG3_PEOC4_GLPEOC_DPC_REQ_REQ_FNUM_S 0
#define IG3_PEOC4_GLPEOC_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_DPC_REQ_REQ_FNUM_S)
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_COUNT 0x42901638
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC4_GLPEOC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC4_GLPEOC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_CMD 0x4290164C
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_DATA_H 0x42901658
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_DATA_L 0x42901654
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_PTR 0x42901650
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC4_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_CMD 0x4290163C
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_DATA_H 0x42901648
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_DATA_L 0x42901644
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_PTR 0x42901640
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC4_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_CONTROL 0x42901600
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_RSVD1_S 25
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_DTM_CONTROL_RSVD1_S)
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_RSVD2_S 17
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_DTM_CONTROL_RSVD2_S)
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_RSVD3_S 9
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_DTM_CONTROL_RSVD3_S)
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_BYPASS_S 8
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_CONTROL_BYPASS_S)
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_RSVD4_S 1
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_DTM_CONTROL_RSVD4_S)
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PEOC4_GLPEOC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PEOC4_GLPEOC_DTM_ECC_COR_ERR 0x42901668
#define IG3_PEOC4_GLPEOC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PEOC4_GLPEOC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC4_GLPEOC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PEOC4_GLPEOC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PEOC4_GLPEOC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC4_GLPEOC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_DTM_ECC_UNCOR_ERR 0x42901664
#define IG3_PEOC4_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PEOC4_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC4_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PEOC4_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PEOC4_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC4_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_DTM_GROUP_CFG 0x4290160C
#define IG3_PEOC4_GLPEOC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PEOC4_GLPEOC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PEOC4_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PEOC4_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PEOC4_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PEOC4_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PEOC4_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PEOC4_GLPEOC_DTM_LOG_CFG 0x42901610
#define IG3_PEOC4_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PEOC4_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PEOC4_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PEOC4_GLPEOC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PEOC4_GLPEOC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PEOC4_GLPEOC_DTM_LOG_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_DTM_LOG_CFG_MODE_S 0
#define IG3_PEOC4_GLPEOC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_DTM_LOG_CFG_MODE_S)
#define IG3_PEOC4_GLPEOC_DTM_LOG_MASK 0x42901618
#define IG3_PEOC4_GLPEOC_DTM_LOG_MASK_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_DTM_LOG_MASK_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_LOG_PATTERN 0x42901614
#define IG3_PEOC4_GLPEOC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_MAIN_CFG 0x42901604
#define IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PEOC4_GLPEOC_DTM_MAIN_STS 0x42901608
#define IG3_PEOC4_GLPEOC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PEOC4_GLPEOC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PEOC4_GLPEOC_DTM_MAIN_STS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PEOC4_GLPEOC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PEOC4_GLPEOC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PEOC4_GLPEOC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_DTM_MAIN_STS_RSVD2_S)
#define IG3_PEOC4_GLPEOC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PEOC4_GLPEOC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PEOC4_GLPEOC_DTM_TIMESTAMP 0x42901630
#define IG3_PEOC4_GLPEOC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_DTM_TIMESTAMP_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_TIMESTAMP_ROLLOVER 0x42901634
#define IG3_PEOC4_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG 0x4290165C
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS 0x42901660
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PEOC4_GLPEOC_DTM_TRIG_CFG 0x4290161C
#define IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_MODE_S 0
#define IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_DTM_TRIG_CFG_MODE_S)
#define IG3_PEOC4_GLPEOC_DTM_TRIG_COUNT 0x42901628
#define IG3_PEOC4_GLPEOC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_TRIG_MASK 0x42901624
#define IG3_PEOC4_GLPEOC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_DTM_TRIG_MASK_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_TRIG_PATTERN 0x42901620
#define IG3_PEOC4_GLPEOC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PEOC4_GLPEOC_DTM_TRIG_TIMESTAMP 0x4290162C
#define IG3_PEOC4_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PEOC4_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PEOC4_GLPEOC_ECC_CTL 0x429014C8
#define IG3_PEOC4_GLPEOC_ECC_CTL_RSVD_S 8
#define IG3_PEOC4_GLPEOC_ECC_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_ECC_CTL_RSVD_S)
#define IG3_PEOC4_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_S 7
#define IG3_PEOC4_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_S)
#define IG3_PEOC4_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_S 6
#define IG3_PEOC4_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_S)
#define IG3_PEOC4_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_ECC_CTL_CLIENT_ECC_EN_S 4
#define IG3_PEOC4_GLPEOC_ECC_CTL_CLIENT_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_ECC_CTL_CLIENT_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_S 3
#define IG3_PEOC4_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_S)
#define IG3_PEOC4_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_S 2
#define IG3_PEOC4_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_S)
#define IG3_PEOC4_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_S 1
#define IG3_PEOC4_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_ECC_CTL_HOST_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_ECC_CTL_HOST_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_ECC_CTL_HOST_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_ERRDATA0 0x429014B8
#define IG3_PEOC4_GLPEOC_ERRDATA0_RSVD1_S 31
#define IG3_PEOC4_GLPEOC_ERRDATA0_RSVD1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_ERRDATA0_RSVD1_S)
#define IG3_PEOC4_GLPEOC_ERRDATA0_PF_NUM_S 25
#define IG3_PEOC4_GLPEOC_ERRDATA0_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PEOC4_GLPEOC_ERRDATA0_PF_NUM_S)
#define IG3_PEOC4_GLPEOC_ERRDATA0_VDEV_VF_NUM_S 15
#define IG3_PEOC4_GLPEOC_ERRDATA0_VDEV_VF_NUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_ERRDATA0_VDEV_VF_NUM_S)
#define IG3_PEOC4_GLPEOC_ERRDATA0_VDEV_VF_TYPE_S 13
#define IG3_PEOC4_GLPEOC_ERRDATA0_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_ERRDATA0_VDEV_VF_TYPE_S)
#define IG3_PEOC4_GLPEOC_ERRDATA0_OBJ_TYPE_S 8
#define IG3_PEOC4_GLPEOC_ERRDATA0_OBJ_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_ERRDATA0_OBJ_TYPE_S)
#define IG3_PEOC4_GLPEOC_ERRDATA0_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_ERRDATA0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_ERRDATA0_RSVD0_S)
#define IG3_PEOC4_GLPEOC_ERRDATA0_ERROR_CODE_S 0
#define IG3_PEOC4_GLPEOC_ERRDATA0_ERROR_CODE_M RDMA_MASK3(32, 0x3F, IG3_PEOC4_GLPEOC_ERRDATA0_ERROR_CODE_S)
#define IG3_PEOC4_GLPEOC_ERRDATA1 0x429014BC
#define IG3_PEOC4_GLPEOC_ERRDATA1_RSVD_S 28
#define IG3_PEOC4_GLPEOC_ERRDATA1_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_ERRDATA1_RSVD_S)
#define IG3_PEOC4_GLPEOC_ERRDATA1_OBJ_INDEX_S 0
#define IG3_PEOC4_GLPEOC_ERRDATA1_OBJ_INDEX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PEOC4_GLPEOC_ERRDATA1_OBJ_INDEX_S)
#define IG3_PEOC4_GLPEOC_ERRDATA2 0x429014C0
#define IG3_PEOC4_GLPEOC_ERRDATA2_RSVD_S 23
#define IG3_PEOC4_GLPEOC_ERRDATA2_RSVD_M RDMA_MASK3(32, 0x1FF, IG3_PEOC4_GLPEOC_ERRDATA2_RSVD_S)
#define IG3_PEOC4_GLPEOC_ERRDATA2_OPTYPE_S 20
#define IG3_PEOC4_GLPEOC_ERRDATA2_OPTYPE_M RDMA_MASK3(32, 0x7, IG3_PEOC4_GLPEOC_ERRDATA2_OPTYPE_S)
#define IG3_PEOC4_GLPEOC_ERRDATA2_OFFSET_S 7
#define IG3_PEOC4_GLPEOC_ERRDATA2_OFFSET_M RDMA_MASK3(32, 0x1FFF, IG3_PEOC4_GLPEOC_ERRDATA2_OFFSET_S)
#define IG3_PEOC4_GLPEOC_ERRDATA2_LENGTH_S 0
#define IG3_PEOC4_GLPEOC_ERRDATA2_LENGTH_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_ERRDATA2_LENGTH_S)
#define IG3_PEOC4_GLPEOC_ERRDATA3 0x429014C4
#define IG3_PEOC4_GLPEOC_ERRDATA3_RSVD_S 15
#define IG3_PEOC4_GLPEOC_ERRDATA3_RSVD_M RDMA_MASK3(32, 0x1FFFF, IG3_PEOC4_GLPEOC_ERRDATA3_RSVD_S)
#define IG3_PEOC4_GLPEOC_ERRDATA3_TAG_S 0
#define IG3_PEOC4_GLPEOC_ERRDATA3_TAG_M RDMA_MASK3(32, 0x7FFF, IG3_PEOC4_GLPEOC_ERRDATA3_TAG_S)
#define IG3_PEOC4_GLPEOC_ERRINFO 0x429014B4
#define IG3_PEOC4_GLPEOC_ERRINFO_RSVD1_S 16
#define IG3_PEOC4_GLPEOC_ERRINFO_RSVD1_M RDMA_MASK3(32, 0xFFFF, IG3_PEOC4_GLPEOC_ERRINFO_RSVD1_S)
#define IG3_PEOC4_GLPEOC_ERRINFO_ERROR_CNT_S 8
#define IG3_PEOC4_GLPEOC_ERRINFO_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_ERRINFO_ERROR_CNT_S)
#define IG3_PEOC4_GLPEOC_ERRINFO_RSVD0_S 1
#define IG3_PEOC4_GLPEOC_ERRINFO_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_ERRINFO_RSVD0_S)
#define IG3_PEOC4_GLPEOC_ERRINFO_ERROR_VALID_S 0
#define IG3_PEOC4_GLPEOC_ERRINFO_ERROR_VALID_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_ERRINFO_ERROR_VALID_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG 0x4290151C
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RSVD3_S 20
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RM_S 16
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RM_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RSVD2_S 14
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RME_S 12
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RME_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RSVD1_S 10
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_EVICT_MEM_CFG_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS 0x42901520
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_RSVD0_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG 0x42901514
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RSVD3_S 20
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RM_S 16
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RM_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RSVD2_S 14
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RME_S 12
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RME_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RSVD1_S 10
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_FILL_MEM_CFG_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS 0x42901518
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_RSVD0_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_FILL_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC4_GLPEOC_FSIADR_OBJOFST 0x4290148C
#define IG3_PEOC4_GLPEOC_FSIADR_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_FSIADR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_FSIADR_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC4_GLPEOC_FSIMCAST_OBJOFST 0x42901490
#define IG3_PEOC4_GLPEOC_FSIMCAST_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_FSIMCAST_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_FSIMCAST_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC4_GLPEOC_HDR_OBJOFST 0x429014A0
#define IG3_PEOC4_GLPEOC_HDR_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_HDR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_HDR_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC4_GLPEOC_HECC_ERR 0x429014CC
#define IG3_PEOC4_GLPEOC_HECC_ERR_RSVD1_S 28
#define IG3_PEOC4_GLPEOC_HECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_HECC_ERR_RSVD1_S)
#define IG3_PEOC4_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PEOC4_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC4_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_HECC_ERR_RSVD0_S 12
#define IG3_PEOC4_GLPEOC_HECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_HECC_ERR_RSVD0_S)
#define IG3_PEOC4_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PEOC4_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC4_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_IRRQ_OBJOFST 0x42901480
#define IG3_PEOC4_GLPEOC_IRRQ_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_IRRQ_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_IRRQ_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC4_GLPEOC_MAXOSR 0x429014D4
#define IG3_PEOC4_GLPEOC_MAXOSR_RSVD1_S 15
#define IG3_PEOC4_GLPEOC_MAXOSR_RSVD1_M RDMA_MASK3(32, 0x1FFFF, IG3_PEOC4_GLPEOC_MAXOSR_RSVD1_S)
#define IG3_PEOC4_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S 10
#define IG3_PEOC4_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S)
#define IG3_PEOC4_GLPEOC_MAXOSR_RSVD0_S 8
#define IG3_PEOC4_GLPEOC_MAXOSR_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_MAXOSR_RSVD0_S)
#define IG3_PEOC4_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_S 0
#define IG3_PEOC4_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_S)
#define IG3_PEOC4_GLPEOC_MEM_ECC_COR_ERR 0x429015B8
#define IG3_PEOC4_GLPEOC_MEM_ECC_COR_ERR_RSVD_S 12
#define IG3_PEOC4_GLPEOC_MEM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC4_GLPEOC_MEM_ECC_COR_ERR_RSVD_S)
#define IG3_PEOC4_GLPEOC_MEM_ECC_COR_ERR_CNT_S 0
#define IG3_PEOC4_GLPEOC_MEM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC4_GLPEOC_MEM_ECC_COR_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_MEM_ECC_UNCOR_ERR 0x429015B4
#define IG3_PEOC4_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PEOC4_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC4_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PEOC4_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PEOC4_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC4_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_OOISCFL_OBJOFST 0x429014B0
#define IG3_PEOC4_GLPEOC_OOISCFL_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_OOISCFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_OOISCFL_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC4_GLPEOC_OOISC_OBJOFST 0x429014AC
#define IG3_PEOC4_GLPEOC_OOISC_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_OOISC_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_OOISC_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC4_GLPEOC_PLIST_DBG_CTL 0x429015AC
#define IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_DONE_S 31
#define IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_DONE_S)
#define IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_RD_EN_S 30
#define IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_RD_EN_S)
#define IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_RSVD_S 26
#define IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_RSVD_S)
#define IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_DW_SEL_S)
#define IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_ADR_S 0
#define IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_PLIST_DBG_CTL_ADR_S)
#define IG3_PEOC4_GLPEOC_PLIST_DBG_DATA 0x429015B0
#define IG3_PEOC4_GLPEOC_PLIST_DBG_DATA_RD_DW_S 0
#define IG3_PEOC4_GLPEOC_PLIST_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_PLIST_DBG_DATA_RD_DW_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG 0x4290150C
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RSVD3_S 20
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RM_S 16
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RM_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RSVD2_S 14
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RME_S 12
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RME_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RSVD1_S 10
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_MEM_CFG_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS 0x42901510
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_RSVD0_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC4_GLPEOC_PMATINV_CFG 0x429014DC
#define IG3_PEOC4_GLPEOC_PMATINV_CFG_RSVD_S 6
#define IG3_PEOC4_GLPEOC_PMATINV_CFG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_PEOC4_GLPEOC_PMATINV_CFG_RSVD_S)
#define IG3_PEOC4_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S 5
#define IG3_PEOC4_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S)
#define IG3_PEOC4_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S 4
#define IG3_PEOC4_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PEOC4_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S 3
#define IG3_PEOC4_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S)
#define IG3_PEOC4_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S 2
#define IG3_PEOC4_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S)
#define IG3_PEOC4_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S 1
#define IG3_PEOC4_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PEOC4_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_S 0
#define IG3_PEOC4_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_S)
#define IG3_PEOC4_GLPEOC_Q1FL_OBJOFST 0x42901498
#define IG3_PEOC4_GLPEOC_Q1FL_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_Q1FL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_Q1FL_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC4_GLPEOC_RRFL_OBJOFST 0x429014A8
#define IG3_PEOC4_GLPEOC_RRFL_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_RRFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_RRFL_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC4_GLPEOC_RRF_OBJOFST 0x429014A4
#define IG3_PEOC4_GLPEOC_RRF_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_RRF_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_RRF_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC4_GLPEOC_SRQCTX_OBJOFST 0x42901488
#define IG3_PEOC4_GLPEOC_SRQCTX_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_SRQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_SRQCTX_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC4_GLPEOC_STAT_CTL 0x42901404
#define IG3_PEOC4_GLPEOC_STAT_CTL_RSVD_S 5
#define IG3_PEOC4_GLPEOC_STAT_CTL_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PEOC4_GLPEOC_STAT_CTL_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_CTL_OBJECT_TYPE_S 0
#define IG3_PEOC4_GLPEOC_STAT_CTL_OBJECT_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_STAT_CTL_OBJECT_TYPE_S)
#define IG3_PEOC4_GLPEOC_STAT_FENCING_TIME_HI 0x4290146C
#define IG3_PEOC4_GLPEOC_STAT_FENCING_TIME_HI_RSVD_S 24
#define IG3_PEOC4_GLPEOC_STAT_FENCING_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_FENCING_TIME_HI_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_S 0
#define IG3_PEOC4_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_S)
#define IG3_PEOC4_GLPEOC_STAT_FENCING_TIME_LO 0x42901468
#define IG3_PEOC4_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_STAT_MAX_PENDING_ENTRIES 0x4290144C
#define IG3_PEOC4_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_S 8
#define IG3_PEOC4_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_S 0
#define IG3_PEOC4_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_S)
#define IG3_PEOC4_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH 0x42901454
#define IG3_PEOC4_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S 8
#define IG3_PEOC4_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS 0x42901450
#define IG3_PEOC4_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S 8
#define IG3_PEOC4_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_STAT_OBJ_CNT 0x42901408
#define IG3_PEOC4_GLPEOC_STAT_OBJ_CNT_RSVD_S 14
#define IG3_PEOC4_GLPEOC_STAT_OBJ_CNT_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_STAT_OBJ_CNT_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_S 0
#define IG3_PEOC4_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PEOC4_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_S)
#define IG3_PEOC4_GLPEOC_STAT_PENDLING_LIST_FULL_HI 0x42901464
#define IG3_PEOC4_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S 24
#define IG3_PEOC4_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S 0
#define IG3_PEOC4_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S)
#define IG3_PEOC4_GLPEOC_STAT_PENDLING_LIST_FULL_LO 0x42901460
#define IG3_PEOC4_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_IDLE_HI 0x42901430
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_S 24
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_IDLE_LO 0x4290142C
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_XFER_HI 0x42901438
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_S 24
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_S)
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_XFER_LO 0x42901434
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_STAT_RD_HIT_HI 0x42901410
#define IG3_PEOC4_GLPEOC_STAT_RD_HIT_HI_RSVD_S 24
#define IG3_PEOC4_GLPEOC_STAT_RD_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_RD_HIT_HI_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_RD_HIT_HI_CNT_HI_S 0
#define IG3_PEOC4_GLPEOC_STAT_RD_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_RD_HIT_HI_CNT_HI_S)
#define IG3_PEOC4_GLPEOC_STAT_RD_HIT_LO 0x4290140C
#define IG3_PEOC4_GLPEOC_STAT_RD_HIT_LO_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_STAT_RD_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_STAT_RD_HIT_LO_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_STAT_RD_MISS_HI 0x42901418
#define IG3_PEOC4_GLPEOC_STAT_RD_MISS_HI_RSVD_S 24
#define IG3_PEOC4_GLPEOC_STAT_RD_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_RD_MISS_HI_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_RD_MISS_HI_CNT_HI_S 0
#define IG3_PEOC4_GLPEOC_STAT_RD_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_RD_MISS_HI_CNT_HI_S)
#define IG3_PEOC4_GLPEOC_STAT_RD_MISS_LO 0x42901414
#define IG3_PEOC4_GLPEOC_STAT_RD_MISS_LO_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_STAT_RD_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_STAT_RD_MISS_LO_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_STAT_REPLAY_TIME_HI 0x42901474
#define IG3_PEOC4_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_S 24
#define IG3_PEOC4_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_S 0
#define IG3_PEOC4_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_S)
#define IG3_PEOC4_GLPEOC_STAT_REPLAY_TIME_LO 0x42901470
#define IG3_PEOC4_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_BUFF_FULL_HI 0x4290145C
#define IG3_PEOC4_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_S 24
#define IG3_PEOC4_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S 0
#define IG3_PEOC4_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_BUFF_FULL_LO 0x42901458
#define IG3_PEOC4_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_IDLE_HI 0x42901440
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_S 24
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_IDLE_LO 0x4290143C
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_XFER_HI 0x42901448
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_S 24
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_XFER_LO 0x42901444
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_HIT_HI 0x42901420
#define IG3_PEOC4_GLPEOC_STAT_WR_HIT_HI_RSVD_S 24
#define IG3_PEOC4_GLPEOC_STAT_WR_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_WR_HIT_HI_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_HIT_HI_CNT_HI_S 0
#define IG3_PEOC4_GLPEOC_STAT_WR_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_WR_HIT_HI_CNT_HI_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_HIT_LO 0x4290141C
#define IG3_PEOC4_GLPEOC_STAT_WR_HIT_LO_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_STAT_WR_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_STAT_WR_HIT_LO_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_MISS_HI 0x42901428
#define IG3_PEOC4_GLPEOC_STAT_WR_MISS_HI_RSVD_S 24
#define IG3_PEOC4_GLPEOC_STAT_WR_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_STAT_WR_MISS_HI_RSVD_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_MISS_HI_CNT_HI_S 0
#define IG3_PEOC4_GLPEOC_STAT_WR_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_STAT_WR_MISS_HI_CNT_HI_S)
#define IG3_PEOC4_GLPEOC_STAT_WR_MISS_LO 0x42901424
#define IG3_PEOC4_GLPEOC_STAT_WR_MISS_LO_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_STAT_WR_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_STAT_WR_MISS_LO_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_TAG_DBG_CTL 0x42901564
#define IG3_PEOC4_GLPEOC_TAG_DBG_CTL_DONE_S 31
#define IG3_PEOC4_GLPEOC_TAG_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_DBG_CTL_DONE_S)
#define IG3_PEOC4_GLPEOC_TAG_DBG_CTL_RD_EN_S 30
#define IG3_PEOC4_GLPEOC_TAG_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_DBG_CTL_RD_EN_S)
#define IG3_PEOC4_GLPEOC_TAG_DBG_CTL_RSVD_S 26
#define IG3_PEOC4_GLPEOC_TAG_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_TAG_DBG_CTL_RSVD_S)
#define IG3_PEOC4_GLPEOC_TAG_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC4_GLPEOC_TAG_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_TAG_DBG_CTL_DW_SEL_S)
#define IG3_PEOC4_GLPEOC_TAG_DBG_CTL_ADR_S 0
#define IG3_PEOC4_GLPEOC_TAG_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_TAG_DBG_CTL_ADR_S)
#define IG3_PEOC4_GLPEOC_TAG_DBG_DATA 0x42901568
#define IG3_PEOC4_GLPEOC_TAG_DBG_DATA_RD_DW_S 0
#define IG3_PEOC4_GLPEOC_TAG_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_TAG_DBG_DATA_RD_DW_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG 0x429014FC
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RSVD3_S 20
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RM_S 16
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RM_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RSVD2_S 14
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RME_S 12
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RME_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RSVD1_S 10
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_MEM_CFG_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS 0x42901500
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_RSVD0_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC4_GLPEOC_TIMER_OBJOFST 0x4290149C
#define IG3_PEOC4_GLPEOC_TIMER_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_TIMER_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_TIMER_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_HI 0x429014F0
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_HI_RSVD_S 24
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_TOTAL_TAG_HI_RSVD_S)
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_HI_CNT_HI_S 0
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_TOTAL_TAG_HI_CNT_HI_S)
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_HIT_HI 0x429014F8
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_S 24
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_S)
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_S 0
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC4_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_S)
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_HIT_LO 0x429014F4
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_LO 0x429014EC
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_LO_CNT_LO_S 0
#define IG3_PEOC4_GLPEOC_TOTAL_TAG_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC4_GLPEOC_TOTAL_TAG_LO_CNT_LO_S)
#define IG3_PEOC4_GLPEOC_TXFIFO_OBJOFST 0x4290147C
#define IG3_PEOC4_GLPEOC_TXFIFO_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_TXFIFO_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_TXFIFO_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG 0x42901504
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RSVD3_S 20
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RSVD3_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RM_S 16
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RM_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RSVD2_S 14
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RSVD2_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RME_S 12
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RME_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RSVD1_S 10
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RSVD1_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RSVD0_S 6
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_RSVD0_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_MASK_INT_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_WRBUF_MEM_CFG_ECC_EN_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS 0x42901508
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_RSVD1_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_RSVD0_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC4_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC4_GLPEOC_XFFL_OBJOFST 0x42901494
#define IG3_PEOC4_GLPEOC_XFFL_OBJOFST_RSVD_S 10
#define IG3_PEOC4_GLPEOC_XFFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC4_GLPEOC_XFFL_OBJOFST_RSVD_S)
#define IG3_PEOC4_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC4_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC4_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_ARPTBLE_OBJOFST 0x42901878
#define IG3_PEOC6_GLPEOC_ARPTBLE_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_ARPTBLE_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_ARPTBLE_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_CACHESIZE 0x429018E0
#define IG3_PEOC6_GLPEOC_CACHESIZE_RSVD_S 24
#define IG3_PEOC6_GLPEOC_CACHESIZE_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHESIZE_RSVD_S)
#define IG3_PEOC6_GLPEOC_CACHESIZE_WAYS_S 20
#define IG3_PEOC6_GLPEOC_CACHESIZE_WAYS_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHESIZE_WAYS_S)
#define IG3_PEOC6_GLPEOC_CACHESIZE_SETS_S 8
#define IG3_PEOC6_GLPEOC_CACHESIZE_SETS_M RDMA_MASK3(32, 0xFFF, IG3_PEOC6_GLPEOC_CACHESIZE_SETS_S)
#define IG3_PEOC6_GLPEOC_CACHESIZE_WORD_SIZE_S 0
#define IG3_PEOC6_GLPEOC_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHESIZE_WORD_SIZE_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL 0x4290196C
#define IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_DONE_S 31
#define IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_RD_EN_S 30
#define IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_RD_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_RSVD_S 26
#define IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_RSVD_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_ADR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_0_DBG_CTL_ADR_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_DBG_DATA 0x42901970
#define IG3_PEOC6_GLPEOC_CACHE_0_DBG_DATA_RD_DW_S 0
#define IG3_PEOC6_GLPEOC_CACHE_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_CACHE_0_DBG_DATA_RD_DW_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG 0x42901924
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RSVD3_S 20
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RM_S 16
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RM_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RSVD2_S 14
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RME_S 12
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RME_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RSVD1_S 10
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS 0x42901928
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL 0x42901974
#define IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_DONE_S 31
#define IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_RD_EN_S 30
#define IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_RD_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_RSVD_S 26
#define IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_RSVD_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_ADR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_1_DBG_CTL_ADR_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_DBG_DATA 0x42901978
#define IG3_PEOC6_GLPEOC_CACHE_1_DBG_DATA_RD_DW_S 0
#define IG3_PEOC6_GLPEOC_CACHE_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_CACHE_1_DBG_DATA_RD_DW_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG 0x4290192C
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RSVD3_S 20
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RM_S 16
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RM_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RSVD2_S 14
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RME_S 12
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RME_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RSVD1_S 10
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS 0x42901930
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL 0x4290197C
#define IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_DONE_S 31
#define IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_RD_EN_S 30
#define IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_RD_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_RSVD_S 26
#define IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_RSVD_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_ADR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_2_DBG_CTL_ADR_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_DBG_DATA 0x42901980
#define IG3_PEOC6_GLPEOC_CACHE_2_DBG_DATA_RD_DW_S 0
#define IG3_PEOC6_GLPEOC_CACHE_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_CACHE_2_DBG_DATA_RD_DW_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG 0x42901934
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RSVD3_S 20
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RM_S 16
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RM_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RSVD2_S 14
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RME_S 12
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RME_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RSVD1_S 10
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS 0x42901938
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL 0x42901984
#define IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_DONE_S 31
#define IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_RD_EN_S 30
#define IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_RD_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_RSVD_S 26
#define IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_RSVD_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_ADR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_3_DBG_CTL_ADR_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_DBG_DATA 0x42901988
#define IG3_PEOC6_GLPEOC_CACHE_3_DBG_DATA_RD_DW_S 0
#define IG3_PEOC6_GLPEOC_CACHE_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_CACHE_3_DBG_DATA_RD_DW_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG 0x4290193C
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RSVD3_S 20
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RM_S 16
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RM_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RSVD2_S 14
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RME_S 12
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RME_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RSVD1_S 10
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS 0x42901940
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL 0x4290198C
#define IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_DONE_S 31
#define IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_RD_EN_S 30
#define IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_RD_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_RSVD_S 26
#define IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_RSVD_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_ADR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_4_DBG_CTL_ADR_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_DBG_DATA 0x42901990
#define IG3_PEOC6_GLPEOC_CACHE_4_DBG_DATA_RD_DW_S 0
#define IG3_PEOC6_GLPEOC_CACHE_4_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_CACHE_4_DBG_DATA_RD_DW_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG 0x42901944
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RSVD3_S 20
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RM_S 16
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RM_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RSVD2_S 14
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RME_S 12
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RME_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RSVD1_S 10
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS 0x42901948
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL 0x42901994
#define IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_DONE_S 31
#define IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_RD_EN_S 30
#define IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_RD_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_RSVD_S 26
#define IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_RSVD_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_ADR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_5_DBG_CTL_ADR_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_DBG_DATA 0x42901998
#define IG3_PEOC6_GLPEOC_CACHE_5_DBG_DATA_RD_DW_S 0
#define IG3_PEOC6_GLPEOC_CACHE_5_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_CACHE_5_DBG_DATA_RD_DW_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG 0x4290194C
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RSVD3_S 20
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RM_S 16
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RM_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RSVD2_S 14
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RME_S 12
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RME_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RSVD1_S 10
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS 0x42901950
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL 0x4290199C
#define IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_DONE_S 31
#define IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_RD_EN_S 30
#define IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_RD_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_RSVD_S 26
#define IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_RSVD_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_ADR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_6_DBG_CTL_ADR_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_DBG_DATA 0x429019A0
#define IG3_PEOC6_GLPEOC_CACHE_6_DBG_DATA_RD_DW_S 0
#define IG3_PEOC6_GLPEOC_CACHE_6_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_CACHE_6_DBG_DATA_RD_DW_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG 0x42901954
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RSVD3_S 20
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RM_S 16
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RM_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RSVD2_S 14
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RME_S 12
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RME_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RSVD1_S 10
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS 0x42901958
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL 0x429019A4
#define IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_DONE_S 31
#define IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_RD_EN_S 30
#define IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_RD_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_RSVD_S 26
#define IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_RSVD_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_ADR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_7_DBG_CTL_ADR_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_DBG_DATA 0x429019A8
#define IG3_PEOC6_GLPEOC_CACHE_7_DBG_DATA_RD_DW_S 0
#define IG3_PEOC6_GLPEOC_CACHE_7_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_CACHE_7_DBG_DATA_RD_DW_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG 0x4290195C
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RSVD3_S 20
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RM_S 16
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RM_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RSVD2_S 14
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RME_S 12
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RME_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RSVD1_S 10
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS 0x42901960
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC6_GLPEOC_CACHE_CTRL 0x42901800
#define IG3_PEOC6_GLPEOC_CACHE_CTRL_RSVD_S 2
#define IG3_PEOC6_GLPEOC_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_PEOC6_GLPEOC_CACHE_CTRL_RSVD_S)
#define IG3_PEOC6_GLPEOC_CACHE_CTRL_SCALE_FACTOR_S 0
#define IG3_PEOC6_GLPEOC_CACHE_CTRL_SCALE_FACTOR_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_CACHE_CTRL_SCALE_FACTOR_S)
#define IG3_PEOC6_GLPEOC_CECC_ERR 0x429018D0
#define IG3_PEOC6_GLPEOC_CECC_ERR_RSVD1_S 28
#define IG3_PEOC6_GLPEOC_CECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CECC_ERR_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PEOC6_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC6_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_CECC_ERR_RSVD0_S 12
#define IG3_PEOC6_GLPEOC_CECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_CECC_ERR_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PEOC6_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC6_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_CQCTX_OBJOFST 0x42901884
#define IG3_PEOC6_GLPEOC_CQCTX_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_CQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_CQCTX_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_CSTATELKUP_CFG 0x429018D8
#define IG3_PEOC6_GLPEOC_CSTATELKUP_CFG_RSVD1_S 9
#define IG3_PEOC6_GLPEOC_CSTATELKUP_CFG_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PEOC6_GLPEOC_CSTATELKUP_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S 8
#define IG3_PEOC6_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S)
#define IG3_PEOC6_GLPEOC_CSTATELKUP_CFG_RSVD0_S 3
#define IG3_PEOC6_GLPEOC_CSTATELKUP_CFG_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_CSTATELKUP_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S 0
#define IG3_PEOC6_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_M RDMA_MASK3(32, 0x7, IG3_PEOC6_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S)
#define IG3_PEOC6_GLPEOC_DPC_COMP 0x429018E8
#define IG3_PEOC6_GLPEOC_DPC_COMP_RSVD_S 13
#define IG3_PEOC6_GLPEOC_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEOC6_GLPEOC_DPC_COMP_RSVD_S)
#define IG3_PEOC6_GLPEOC_DPC_COMP_COMP_FTYPE_S 11
#define IG3_PEOC6_GLPEOC_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_DPC_COMP_COMP_FTYPE_S)
#define IG3_PEOC6_GLPEOC_DPC_COMP_COMP_FNUM_S 1
#define IG3_PEOC6_GLPEOC_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_DPC_COMP_COMP_FNUM_S)
#define IG3_PEOC6_GLPEOC_DPC_COMP_COMP_VALID_S 0
#define IG3_PEOC6_GLPEOC_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DPC_COMP_COMP_VALID_S)
#define IG3_PEOC6_GLPEOC_DPC_REQ 0x429018E4
#define IG3_PEOC6_GLPEOC_DPC_REQ_RSVD_S 12
#define IG3_PEOC6_GLPEOC_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC6_GLPEOC_DPC_REQ_RSVD_S)
#define IG3_PEOC6_GLPEOC_DPC_REQ_REQ_FTYPE_S 10
#define IG3_PEOC6_GLPEOC_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_DPC_REQ_REQ_FTYPE_S)
#define IG3_PEOC6_GLPEOC_DPC_REQ_REQ_FNUM_S 0
#define IG3_PEOC6_GLPEOC_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_DPC_REQ_REQ_FNUM_S)
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_COUNT 0x42901A38
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC6_GLPEOC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC6_GLPEOC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_CMD 0x42901A4C
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_DATA_H 0x42901A58
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_DATA_L 0x42901A54
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_PTR 0x42901A50
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC6_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_CMD 0x42901A3C
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_DATA_H 0x42901A48
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_DATA_L 0x42901A44
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_PTR 0x42901A40
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC6_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_CONTROL 0x42901A00
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_RSVD1_S 25
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_DTM_CONTROL_RSVD1_S)
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_RSVD2_S 17
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_DTM_CONTROL_RSVD2_S)
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_RSVD3_S 9
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_DTM_CONTROL_RSVD3_S)
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_BYPASS_S 8
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_CONTROL_BYPASS_S)
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_RSVD4_S 1
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_DTM_CONTROL_RSVD4_S)
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PEOC6_GLPEOC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PEOC6_GLPEOC_DTM_ECC_COR_ERR 0x42901A68
#define IG3_PEOC6_GLPEOC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PEOC6_GLPEOC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC6_GLPEOC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PEOC6_GLPEOC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PEOC6_GLPEOC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC6_GLPEOC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_DTM_ECC_UNCOR_ERR 0x42901A64
#define IG3_PEOC6_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PEOC6_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC6_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PEOC6_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PEOC6_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC6_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_DTM_GROUP_CFG 0x42901A0C
#define IG3_PEOC6_GLPEOC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PEOC6_GLPEOC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PEOC6_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PEOC6_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PEOC6_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PEOC6_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PEOC6_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PEOC6_GLPEOC_DTM_LOG_CFG 0x42901A10
#define IG3_PEOC6_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PEOC6_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PEOC6_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PEOC6_GLPEOC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PEOC6_GLPEOC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PEOC6_GLPEOC_DTM_LOG_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_DTM_LOG_CFG_MODE_S 0
#define IG3_PEOC6_GLPEOC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_DTM_LOG_CFG_MODE_S)
#define IG3_PEOC6_GLPEOC_DTM_LOG_MASK 0x42901A18
#define IG3_PEOC6_GLPEOC_DTM_LOG_MASK_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_DTM_LOG_MASK_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_LOG_PATTERN 0x42901A14
#define IG3_PEOC6_GLPEOC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_MAIN_CFG 0x42901A04
#define IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PEOC6_GLPEOC_DTM_MAIN_STS 0x42901A08
#define IG3_PEOC6_GLPEOC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PEOC6_GLPEOC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PEOC6_GLPEOC_DTM_MAIN_STS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PEOC6_GLPEOC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PEOC6_GLPEOC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PEOC6_GLPEOC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_DTM_MAIN_STS_RSVD2_S)
#define IG3_PEOC6_GLPEOC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PEOC6_GLPEOC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PEOC6_GLPEOC_DTM_TIMESTAMP 0x42901A30
#define IG3_PEOC6_GLPEOC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_DTM_TIMESTAMP_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_TIMESTAMP_ROLLOVER 0x42901A34
#define IG3_PEOC6_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG 0x42901A5C
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS 0x42901A60
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PEOC6_GLPEOC_DTM_TRIG_CFG 0x42901A1C
#define IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_MODE_S 0
#define IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_DTM_TRIG_CFG_MODE_S)
#define IG3_PEOC6_GLPEOC_DTM_TRIG_COUNT 0x42901A28
#define IG3_PEOC6_GLPEOC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_TRIG_MASK 0x42901A24
#define IG3_PEOC6_GLPEOC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_DTM_TRIG_MASK_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_TRIG_PATTERN 0x42901A20
#define IG3_PEOC6_GLPEOC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PEOC6_GLPEOC_DTM_TRIG_TIMESTAMP 0x42901A2C
#define IG3_PEOC6_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PEOC6_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PEOC6_GLPEOC_ECC_CTL 0x429018C8
#define IG3_PEOC6_GLPEOC_ECC_CTL_RSVD_S 8
#define IG3_PEOC6_GLPEOC_ECC_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_ECC_CTL_RSVD_S)
#define IG3_PEOC6_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_S 7
#define IG3_PEOC6_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_S)
#define IG3_PEOC6_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_S 6
#define IG3_PEOC6_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_S)
#define IG3_PEOC6_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_ECC_CTL_CLIENT_ECC_EN_S 4
#define IG3_PEOC6_GLPEOC_ECC_CTL_CLIENT_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_ECC_CTL_CLIENT_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_S 3
#define IG3_PEOC6_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_S)
#define IG3_PEOC6_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_S 2
#define IG3_PEOC6_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_S)
#define IG3_PEOC6_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_S 1
#define IG3_PEOC6_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_ECC_CTL_HOST_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_ECC_CTL_HOST_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_ECC_CTL_HOST_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_ERRDATA0 0x429018B8
#define IG3_PEOC6_GLPEOC_ERRDATA0_RSVD1_S 31
#define IG3_PEOC6_GLPEOC_ERRDATA0_RSVD1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_ERRDATA0_RSVD1_S)
#define IG3_PEOC6_GLPEOC_ERRDATA0_PF_NUM_S 25
#define IG3_PEOC6_GLPEOC_ERRDATA0_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PEOC6_GLPEOC_ERRDATA0_PF_NUM_S)
#define IG3_PEOC6_GLPEOC_ERRDATA0_VDEV_VF_NUM_S 15
#define IG3_PEOC6_GLPEOC_ERRDATA0_VDEV_VF_NUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_ERRDATA0_VDEV_VF_NUM_S)
#define IG3_PEOC6_GLPEOC_ERRDATA0_VDEV_VF_TYPE_S 13
#define IG3_PEOC6_GLPEOC_ERRDATA0_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_ERRDATA0_VDEV_VF_TYPE_S)
#define IG3_PEOC6_GLPEOC_ERRDATA0_OBJ_TYPE_S 8
#define IG3_PEOC6_GLPEOC_ERRDATA0_OBJ_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_ERRDATA0_OBJ_TYPE_S)
#define IG3_PEOC6_GLPEOC_ERRDATA0_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_ERRDATA0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_ERRDATA0_RSVD0_S)
#define IG3_PEOC6_GLPEOC_ERRDATA0_ERROR_CODE_S 0
#define IG3_PEOC6_GLPEOC_ERRDATA0_ERROR_CODE_M RDMA_MASK3(32, 0x3F, IG3_PEOC6_GLPEOC_ERRDATA0_ERROR_CODE_S)
#define IG3_PEOC6_GLPEOC_ERRDATA1 0x429018BC
#define IG3_PEOC6_GLPEOC_ERRDATA1_RSVD_S 28
#define IG3_PEOC6_GLPEOC_ERRDATA1_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_ERRDATA1_RSVD_S)
#define IG3_PEOC6_GLPEOC_ERRDATA1_OBJ_INDEX_S 0
#define IG3_PEOC6_GLPEOC_ERRDATA1_OBJ_INDEX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PEOC6_GLPEOC_ERRDATA1_OBJ_INDEX_S)
#define IG3_PEOC6_GLPEOC_ERRDATA2 0x429018C0
#define IG3_PEOC6_GLPEOC_ERRDATA2_RSVD_S 23
#define IG3_PEOC6_GLPEOC_ERRDATA2_RSVD_M RDMA_MASK3(32, 0x1FF, IG3_PEOC6_GLPEOC_ERRDATA2_RSVD_S)
#define IG3_PEOC6_GLPEOC_ERRDATA2_OPTYPE_S 20
#define IG3_PEOC6_GLPEOC_ERRDATA2_OPTYPE_M RDMA_MASK3(32, 0x7, IG3_PEOC6_GLPEOC_ERRDATA2_OPTYPE_S)
#define IG3_PEOC6_GLPEOC_ERRDATA2_OFFSET_S 7
#define IG3_PEOC6_GLPEOC_ERRDATA2_OFFSET_M RDMA_MASK3(32, 0x1FFF, IG3_PEOC6_GLPEOC_ERRDATA2_OFFSET_S)
#define IG3_PEOC6_GLPEOC_ERRDATA2_LENGTH_S 0
#define IG3_PEOC6_GLPEOC_ERRDATA2_LENGTH_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_ERRDATA2_LENGTH_S)
#define IG3_PEOC6_GLPEOC_ERRDATA3 0x429018C4
#define IG3_PEOC6_GLPEOC_ERRDATA3_RSVD_S 15
#define IG3_PEOC6_GLPEOC_ERRDATA3_RSVD_M RDMA_MASK3(32, 0x1FFFF, IG3_PEOC6_GLPEOC_ERRDATA3_RSVD_S)
#define IG3_PEOC6_GLPEOC_ERRDATA3_TAG_S 0
#define IG3_PEOC6_GLPEOC_ERRDATA3_TAG_M RDMA_MASK3(32, 0x7FFF, IG3_PEOC6_GLPEOC_ERRDATA3_TAG_S)
#define IG3_PEOC6_GLPEOC_ERRINFO 0x429018B4
#define IG3_PEOC6_GLPEOC_ERRINFO_RSVD1_S 16
#define IG3_PEOC6_GLPEOC_ERRINFO_RSVD1_M RDMA_MASK3(32, 0xFFFF, IG3_PEOC6_GLPEOC_ERRINFO_RSVD1_S)
#define IG3_PEOC6_GLPEOC_ERRINFO_ERROR_CNT_S 8
#define IG3_PEOC6_GLPEOC_ERRINFO_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_ERRINFO_ERROR_CNT_S)
#define IG3_PEOC6_GLPEOC_ERRINFO_RSVD0_S 1
#define IG3_PEOC6_GLPEOC_ERRINFO_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_ERRINFO_RSVD0_S)
#define IG3_PEOC6_GLPEOC_ERRINFO_ERROR_VALID_S 0
#define IG3_PEOC6_GLPEOC_ERRINFO_ERROR_VALID_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_ERRINFO_ERROR_VALID_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG 0x4290191C
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RSVD3_S 20
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RM_S 16
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RM_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RSVD2_S 14
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RME_S 12
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RME_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RSVD1_S 10
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_EVICT_MEM_CFG_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS 0x42901920
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_RSVD0_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG 0x42901914
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RSVD3_S 20
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RM_S 16
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RM_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RSVD2_S 14
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RME_S 12
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RME_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RSVD1_S 10
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_FILL_MEM_CFG_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS 0x42901918
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_RSVD0_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_FILL_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC6_GLPEOC_FSIADR_OBJOFST 0x4290188C
#define IG3_PEOC6_GLPEOC_FSIADR_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_FSIADR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_FSIADR_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_FSIMCAST_OBJOFST 0x42901890
#define IG3_PEOC6_GLPEOC_FSIMCAST_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_FSIMCAST_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_FSIMCAST_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_HDR_OBJOFST 0x429018A0
#define IG3_PEOC6_GLPEOC_HDR_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_HDR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_HDR_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_HECC_ERR 0x429018CC
#define IG3_PEOC6_GLPEOC_HECC_ERR_RSVD1_S 28
#define IG3_PEOC6_GLPEOC_HECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_HECC_ERR_RSVD1_S)
#define IG3_PEOC6_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PEOC6_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC6_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_HECC_ERR_RSVD0_S 12
#define IG3_PEOC6_GLPEOC_HECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_HECC_ERR_RSVD0_S)
#define IG3_PEOC6_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PEOC6_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC6_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_IRRQ_OBJOFST 0x42901880
#define IG3_PEOC6_GLPEOC_IRRQ_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_IRRQ_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_IRRQ_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_MAXOSR 0x429018D4
#define IG3_PEOC6_GLPEOC_MAXOSR_RSVD1_S 15
#define IG3_PEOC6_GLPEOC_MAXOSR_RSVD1_M RDMA_MASK3(32, 0x1FFFF, IG3_PEOC6_GLPEOC_MAXOSR_RSVD1_S)
#define IG3_PEOC6_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S 10
#define IG3_PEOC6_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S)
#define IG3_PEOC6_GLPEOC_MAXOSR_RSVD0_S 8
#define IG3_PEOC6_GLPEOC_MAXOSR_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_MAXOSR_RSVD0_S)
#define IG3_PEOC6_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_S 0
#define IG3_PEOC6_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_S)
#define IG3_PEOC6_GLPEOC_MEM_ECC_COR_ERR 0x429019B8
#define IG3_PEOC6_GLPEOC_MEM_ECC_COR_ERR_RSVD_S 12
#define IG3_PEOC6_GLPEOC_MEM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC6_GLPEOC_MEM_ECC_COR_ERR_RSVD_S)
#define IG3_PEOC6_GLPEOC_MEM_ECC_COR_ERR_CNT_S 0
#define IG3_PEOC6_GLPEOC_MEM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC6_GLPEOC_MEM_ECC_COR_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_MEM_ECC_UNCOR_ERR 0x429019B4
#define IG3_PEOC6_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PEOC6_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC6_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PEOC6_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PEOC6_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC6_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_OOISCFL_OBJOFST 0x429018B0
#define IG3_PEOC6_GLPEOC_OOISCFL_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_OOISCFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_OOISCFL_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_OOISC_OBJOFST 0x429018AC
#define IG3_PEOC6_GLPEOC_OOISC_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_OOISC_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_OOISC_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_PLIST_DBG_CTL 0x429019AC
#define IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_DONE_S 31
#define IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_DONE_S)
#define IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_RD_EN_S 30
#define IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_RD_EN_S)
#define IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_RSVD_S 26
#define IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_RSVD_S)
#define IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_DW_SEL_S)
#define IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_ADR_S 0
#define IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_PLIST_DBG_CTL_ADR_S)
#define IG3_PEOC6_GLPEOC_PLIST_DBG_DATA 0x429019B0
#define IG3_PEOC6_GLPEOC_PLIST_DBG_DATA_RD_DW_S 0
#define IG3_PEOC6_GLPEOC_PLIST_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_PLIST_DBG_DATA_RD_DW_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG 0x4290190C
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RSVD3_S 20
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RM_S 16
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RM_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RSVD2_S 14
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RME_S 12
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RME_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RSVD1_S 10
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_MEM_CFG_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS 0x42901910
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_RSVD0_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC6_GLPEOC_PMATINV_CFG 0x429018DC
#define IG3_PEOC6_GLPEOC_PMATINV_CFG_RSVD_S 6
#define IG3_PEOC6_GLPEOC_PMATINV_CFG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_PEOC6_GLPEOC_PMATINV_CFG_RSVD_S)
#define IG3_PEOC6_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S 5
#define IG3_PEOC6_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S)
#define IG3_PEOC6_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S 4
#define IG3_PEOC6_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PEOC6_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S 3
#define IG3_PEOC6_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S)
#define IG3_PEOC6_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S 2
#define IG3_PEOC6_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S)
#define IG3_PEOC6_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S 1
#define IG3_PEOC6_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PEOC6_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_S 0
#define IG3_PEOC6_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_S)
#define IG3_PEOC6_GLPEOC_Q1FL_OBJOFST 0x42901898
#define IG3_PEOC6_GLPEOC_Q1FL_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_Q1FL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_Q1FL_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_RRFL_OBJOFST 0x429018A8
#define IG3_PEOC6_GLPEOC_RRFL_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_RRFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_RRFL_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_RRF_OBJOFST 0x429018A4
#define IG3_PEOC6_GLPEOC_RRF_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_RRF_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_RRF_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_SRQCTX_OBJOFST 0x42901888
#define IG3_PEOC6_GLPEOC_SRQCTX_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_SRQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_SRQCTX_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_STAT_CTL 0x42901804
#define IG3_PEOC6_GLPEOC_STAT_CTL_RSVD_S 5
#define IG3_PEOC6_GLPEOC_STAT_CTL_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PEOC6_GLPEOC_STAT_CTL_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_CTL_OBJECT_TYPE_S 0
#define IG3_PEOC6_GLPEOC_STAT_CTL_OBJECT_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_STAT_CTL_OBJECT_TYPE_S)
#define IG3_PEOC6_GLPEOC_STAT_FENCING_TIME_HI 0x4290186C
#define IG3_PEOC6_GLPEOC_STAT_FENCING_TIME_HI_RSVD_S 24
#define IG3_PEOC6_GLPEOC_STAT_FENCING_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_FENCING_TIME_HI_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_S 0
#define IG3_PEOC6_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_S)
#define IG3_PEOC6_GLPEOC_STAT_FENCING_TIME_LO 0x42901868
#define IG3_PEOC6_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_STAT_MAX_PENDING_ENTRIES 0x4290184C
#define IG3_PEOC6_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_S 8
#define IG3_PEOC6_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_S 0
#define IG3_PEOC6_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_S)
#define IG3_PEOC6_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH 0x42901854
#define IG3_PEOC6_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S 8
#define IG3_PEOC6_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS 0x42901850
#define IG3_PEOC6_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S 8
#define IG3_PEOC6_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_STAT_OBJ_CNT 0x42901808
#define IG3_PEOC6_GLPEOC_STAT_OBJ_CNT_RSVD_S 14
#define IG3_PEOC6_GLPEOC_STAT_OBJ_CNT_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_STAT_OBJ_CNT_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_S 0
#define IG3_PEOC6_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PEOC6_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_S)
#define IG3_PEOC6_GLPEOC_STAT_PENDLING_LIST_FULL_HI 0x42901864
#define IG3_PEOC6_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S 24
#define IG3_PEOC6_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S 0
#define IG3_PEOC6_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S)
#define IG3_PEOC6_GLPEOC_STAT_PENDLING_LIST_FULL_LO 0x42901860
#define IG3_PEOC6_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_IDLE_HI 0x42901830
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_S 24
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_IDLE_LO 0x4290182C
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_XFER_HI 0x42901838
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_S 24
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_S)
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_XFER_LO 0x42901834
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_STAT_RD_HIT_HI 0x42901810
#define IG3_PEOC6_GLPEOC_STAT_RD_HIT_HI_RSVD_S 24
#define IG3_PEOC6_GLPEOC_STAT_RD_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_RD_HIT_HI_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_RD_HIT_HI_CNT_HI_S 0
#define IG3_PEOC6_GLPEOC_STAT_RD_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_RD_HIT_HI_CNT_HI_S)
#define IG3_PEOC6_GLPEOC_STAT_RD_HIT_LO 0x4290180C
#define IG3_PEOC6_GLPEOC_STAT_RD_HIT_LO_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_STAT_RD_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_STAT_RD_HIT_LO_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_STAT_RD_MISS_HI 0x42901818
#define IG3_PEOC6_GLPEOC_STAT_RD_MISS_HI_RSVD_S 24
#define IG3_PEOC6_GLPEOC_STAT_RD_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_RD_MISS_HI_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_RD_MISS_HI_CNT_HI_S 0
#define IG3_PEOC6_GLPEOC_STAT_RD_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_RD_MISS_HI_CNT_HI_S)
#define IG3_PEOC6_GLPEOC_STAT_RD_MISS_LO 0x42901814
#define IG3_PEOC6_GLPEOC_STAT_RD_MISS_LO_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_STAT_RD_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_STAT_RD_MISS_LO_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_STAT_REPLAY_TIME_HI 0x42901874
#define IG3_PEOC6_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_S 24
#define IG3_PEOC6_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_S 0
#define IG3_PEOC6_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_S)
#define IG3_PEOC6_GLPEOC_STAT_REPLAY_TIME_LO 0x42901870
#define IG3_PEOC6_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_BUFF_FULL_HI 0x4290185C
#define IG3_PEOC6_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_S 24
#define IG3_PEOC6_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S 0
#define IG3_PEOC6_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_BUFF_FULL_LO 0x42901858
#define IG3_PEOC6_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_IDLE_HI 0x42901840
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_S 24
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_IDLE_LO 0x4290183C
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_XFER_HI 0x42901848
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_S 24
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_XFER_LO 0x42901844
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_HIT_HI 0x42901820
#define IG3_PEOC6_GLPEOC_STAT_WR_HIT_HI_RSVD_S 24
#define IG3_PEOC6_GLPEOC_STAT_WR_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_WR_HIT_HI_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_HIT_HI_CNT_HI_S 0
#define IG3_PEOC6_GLPEOC_STAT_WR_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_WR_HIT_HI_CNT_HI_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_HIT_LO 0x4290181C
#define IG3_PEOC6_GLPEOC_STAT_WR_HIT_LO_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_STAT_WR_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_STAT_WR_HIT_LO_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_MISS_HI 0x42901828
#define IG3_PEOC6_GLPEOC_STAT_WR_MISS_HI_RSVD_S 24
#define IG3_PEOC6_GLPEOC_STAT_WR_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_STAT_WR_MISS_HI_RSVD_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_MISS_HI_CNT_HI_S 0
#define IG3_PEOC6_GLPEOC_STAT_WR_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_STAT_WR_MISS_HI_CNT_HI_S)
#define IG3_PEOC6_GLPEOC_STAT_WR_MISS_LO 0x42901824
#define IG3_PEOC6_GLPEOC_STAT_WR_MISS_LO_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_STAT_WR_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_STAT_WR_MISS_LO_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_TAG_DBG_CTL 0x42901964
#define IG3_PEOC6_GLPEOC_TAG_DBG_CTL_DONE_S 31
#define IG3_PEOC6_GLPEOC_TAG_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_DBG_CTL_DONE_S)
#define IG3_PEOC6_GLPEOC_TAG_DBG_CTL_RD_EN_S 30
#define IG3_PEOC6_GLPEOC_TAG_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_DBG_CTL_RD_EN_S)
#define IG3_PEOC6_GLPEOC_TAG_DBG_CTL_RSVD_S 26
#define IG3_PEOC6_GLPEOC_TAG_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_TAG_DBG_CTL_RSVD_S)
#define IG3_PEOC6_GLPEOC_TAG_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC6_GLPEOC_TAG_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_TAG_DBG_CTL_DW_SEL_S)
#define IG3_PEOC6_GLPEOC_TAG_DBG_CTL_ADR_S 0
#define IG3_PEOC6_GLPEOC_TAG_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_TAG_DBG_CTL_ADR_S)
#define IG3_PEOC6_GLPEOC_TAG_DBG_DATA 0x42901968
#define IG3_PEOC6_GLPEOC_TAG_DBG_DATA_RD_DW_S 0
#define IG3_PEOC6_GLPEOC_TAG_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_TAG_DBG_DATA_RD_DW_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG 0x429018FC
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RSVD3_S 20
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RM_S 16
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RM_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RSVD2_S 14
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RME_S 12
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RME_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RSVD1_S 10
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_MEM_CFG_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS 0x42901900
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_RSVD0_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC6_GLPEOC_TIMER_OBJOFST 0x4290189C
#define IG3_PEOC6_GLPEOC_TIMER_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_TIMER_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_TIMER_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_HI 0x429018F0
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_HI_RSVD_S 24
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_TOTAL_TAG_HI_RSVD_S)
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_HI_CNT_HI_S 0
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_TOTAL_TAG_HI_CNT_HI_S)
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_HIT_HI 0x429018F8
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_S 24
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_S)
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_S 0
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC6_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_S)
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_HIT_LO 0x429018F4
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_LO 0x429018EC
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_LO_CNT_LO_S 0
#define IG3_PEOC6_GLPEOC_TOTAL_TAG_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC6_GLPEOC_TOTAL_TAG_LO_CNT_LO_S)
#define IG3_PEOC6_GLPEOC_TXFIFO_OBJOFST 0x4290187C
#define IG3_PEOC6_GLPEOC_TXFIFO_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_TXFIFO_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_TXFIFO_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG 0x42901904
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RSVD3_S 20
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RSVD3_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RM_S 16
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RM_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RSVD2_S 14
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RSVD2_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RME_S 12
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RME_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RSVD1_S 10
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RSVD1_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RSVD0_S 6
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_RSVD0_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_MASK_INT_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_WRBUF_MEM_CFG_ECC_EN_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS 0x42901908
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_RSVD1_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_RSVD0_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC6_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC6_GLPEOC_XFFL_OBJOFST 0x42901894
#define IG3_PEOC6_GLPEOC_XFFL_OBJOFST_RSVD_S 10
#define IG3_PEOC6_GLPEOC_XFFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC6_GLPEOC_XFFL_OBJOFST_RSVD_S)
#define IG3_PEOC6_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC6_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC6_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_ARPTBLE_OBJOFST 0x42901C78
#define IG3_PEOC7_GLPEOC_ARPTBLE_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_ARPTBLE_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_ARPTBLE_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_CACHESIZE 0x42901CE0
#define IG3_PEOC7_GLPEOC_CACHESIZE_RSVD_S 24
#define IG3_PEOC7_GLPEOC_CACHESIZE_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHESIZE_RSVD_S)
#define IG3_PEOC7_GLPEOC_CACHESIZE_WAYS_S 20
#define IG3_PEOC7_GLPEOC_CACHESIZE_WAYS_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHESIZE_WAYS_S)
#define IG3_PEOC7_GLPEOC_CACHESIZE_SETS_S 8
#define IG3_PEOC7_GLPEOC_CACHESIZE_SETS_M RDMA_MASK3(32, 0xFFF, IG3_PEOC7_GLPEOC_CACHESIZE_SETS_S)
#define IG3_PEOC7_GLPEOC_CACHESIZE_WORD_SIZE_S 0
#define IG3_PEOC7_GLPEOC_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHESIZE_WORD_SIZE_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL 0x42901D6C
#define IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_DONE_S 31
#define IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_RD_EN_S 30
#define IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_RD_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_RSVD_S 26
#define IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_RSVD_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_ADR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_0_DBG_CTL_ADR_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_DBG_DATA 0x42901D70
#define IG3_PEOC7_GLPEOC_CACHE_0_DBG_DATA_RD_DW_S 0
#define IG3_PEOC7_GLPEOC_CACHE_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_CACHE_0_DBG_DATA_RD_DW_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG 0x42901D24
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RSVD3_S 20
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RM_S 16
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RM_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RSVD2_S 14
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RME_S 12
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RME_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RSVD1_S 10
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS 0x42901D28
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL 0x42901D74
#define IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_DONE_S 31
#define IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_RD_EN_S 30
#define IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_RD_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_RSVD_S 26
#define IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_RSVD_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_ADR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_1_DBG_CTL_ADR_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_DBG_DATA 0x42901D78
#define IG3_PEOC7_GLPEOC_CACHE_1_DBG_DATA_RD_DW_S 0
#define IG3_PEOC7_GLPEOC_CACHE_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_CACHE_1_DBG_DATA_RD_DW_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG 0x42901D2C
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RSVD3_S 20
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RM_S 16
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RM_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RSVD2_S 14
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RME_S 12
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RME_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RSVD1_S 10
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS 0x42901D30
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL 0x42901D7C
#define IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_DONE_S 31
#define IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_RD_EN_S 30
#define IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_RD_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_RSVD_S 26
#define IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_RSVD_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_ADR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_2_DBG_CTL_ADR_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_DBG_DATA 0x42901D80
#define IG3_PEOC7_GLPEOC_CACHE_2_DBG_DATA_RD_DW_S 0
#define IG3_PEOC7_GLPEOC_CACHE_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_CACHE_2_DBG_DATA_RD_DW_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG 0x42901D34
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RSVD3_S 20
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RM_S 16
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RM_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RSVD2_S 14
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RME_S 12
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RME_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RSVD1_S 10
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS 0x42901D38
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL 0x42901D84
#define IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_DONE_S 31
#define IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_RD_EN_S 30
#define IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_RD_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_RSVD_S 26
#define IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_RSVD_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_ADR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_3_DBG_CTL_ADR_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_DBG_DATA 0x42901D88
#define IG3_PEOC7_GLPEOC_CACHE_3_DBG_DATA_RD_DW_S 0
#define IG3_PEOC7_GLPEOC_CACHE_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_CACHE_3_DBG_DATA_RD_DW_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG 0x42901D3C
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RSVD3_S 20
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RM_S 16
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RM_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RSVD2_S 14
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RME_S 12
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RME_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RSVD1_S 10
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS 0x42901D40
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL 0x42901D8C
#define IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_DONE_S 31
#define IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_RD_EN_S 30
#define IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_RD_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_RSVD_S 26
#define IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_RSVD_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_ADR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_4_DBG_CTL_ADR_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_DBG_DATA 0x42901D90
#define IG3_PEOC7_GLPEOC_CACHE_4_DBG_DATA_RD_DW_S 0
#define IG3_PEOC7_GLPEOC_CACHE_4_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_CACHE_4_DBG_DATA_RD_DW_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG 0x42901D44
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RSVD3_S 20
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RM_S 16
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RM_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RSVD2_S 14
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RME_S 12
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RME_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RSVD1_S 10
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS 0x42901D48
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL 0x42901D94
#define IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_DONE_S 31
#define IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_RD_EN_S 30
#define IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_RD_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_RSVD_S 26
#define IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_RSVD_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_ADR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_5_DBG_CTL_ADR_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_DBG_DATA 0x42901D98
#define IG3_PEOC7_GLPEOC_CACHE_5_DBG_DATA_RD_DW_S 0
#define IG3_PEOC7_GLPEOC_CACHE_5_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_CACHE_5_DBG_DATA_RD_DW_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG 0x42901D4C
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RSVD3_S 20
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RM_S 16
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RM_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RSVD2_S 14
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RME_S 12
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RME_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RSVD1_S 10
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS 0x42901D50
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL 0x42901D9C
#define IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_DONE_S 31
#define IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_RD_EN_S 30
#define IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_RD_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_RSVD_S 26
#define IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_RSVD_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_ADR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_6_DBG_CTL_ADR_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_DBG_DATA 0x42901DA0
#define IG3_PEOC7_GLPEOC_CACHE_6_DBG_DATA_RD_DW_S 0
#define IG3_PEOC7_GLPEOC_CACHE_6_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_CACHE_6_DBG_DATA_RD_DW_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG 0x42901D54
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RSVD3_S 20
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RM_S 16
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RM_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RSVD2_S 14
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RME_S 12
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RME_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RSVD1_S 10
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS 0x42901D58
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL 0x42901DA4
#define IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_DONE_S 31
#define IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_RD_EN_S 30
#define IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_RD_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_RSVD_S 26
#define IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_RSVD_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_ADR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_7_DBG_CTL_ADR_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_DBG_DATA 0x42901DA8
#define IG3_PEOC7_GLPEOC_CACHE_7_DBG_DATA_RD_DW_S 0
#define IG3_PEOC7_GLPEOC_CACHE_7_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_CACHE_7_DBG_DATA_RD_DW_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG 0x42901D5C
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RSVD3_S 20
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RM_S 16
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RM_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RSVD2_S 14
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RME_S 12
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RME_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RSVD1_S 10
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS 0x42901D60
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC7_GLPEOC_CACHE_CTRL 0x42901C00
#define IG3_PEOC7_GLPEOC_CACHE_CTRL_RSVD_S 2
#define IG3_PEOC7_GLPEOC_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_PEOC7_GLPEOC_CACHE_CTRL_RSVD_S)
#define IG3_PEOC7_GLPEOC_CACHE_CTRL_SCALE_FACTOR_S 0
#define IG3_PEOC7_GLPEOC_CACHE_CTRL_SCALE_FACTOR_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_CACHE_CTRL_SCALE_FACTOR_S)
#define IG3_PEOC7_GLPEOC_CECC_ERR 0x42901CD0
#define IG3_PEOC7_GLPEOC_CECC_ERR_RSVD1_S 28
#define IG3_PEOC7_GLPEOC_CECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CECC_ERR_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PEOC7_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC7_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_CECC_ERR_RSVD0_S 12
#define IG3_PEOC7_GLPEOC_CECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_CECC_ERR_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PEOC7_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC7_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_CQCTX_OBJOFST 0x42901C84
#define IG3_PEOC7_GLPEOC_CQCTX_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_CQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_CQCTX_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_CSTATELKUP_CFG 0x42901CD8
#define IG3_PEOC7_GLPEOC_CSTATELKUP_CFG_RSVD1_S 9
#define IG3_PEOC7_GLPEOC_CSTATELKUP_CFG_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PEOC7_GLPEOC_CSTATELKUP_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S 8
#define IG3_PEOC7_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S)
#define IG3_PEOC7_GLPEOC_CSTATELKUP_CFG_RSVD0_S 3
#define IG3_PEOC7_GLPEOC_CSTATELKUP_CFG_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_CSTATELKUP_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S 0
#define IG3_PEOC7_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_M RDMA_MASK3(32, 0x7, IG3_PEOC7_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S)
#define IG3_PEOC7_GLPEOC_DPC_COMP 0x42901CE8
#define IG3_PEOC7_GLPEOC_DPC_COMP_RSVD_S 13
#define IG3_PEOC7_GLPEOC_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEOC7_GLPEOC_DPC_COMP_RSVD_S)
#define IG3_PEOC7_GLPEOC_DPC_COMP_COMP_FTYPE_S 11
#define IG3_PEOC7_GLPEOC_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_DPC_COMP_COMP_FTYPE_S)
#define IG3_PEOC7_GLPEOC_DPC_COMP_COMP_FNUM_S 1
#define IG3_PEOC7_GLPEOC_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_DPC_COMP_COMP_FNUM_S)
#define IG3_PEOC7_GLPEOC_DPC_COMP_COMP_VALID_S 0
#define IG3_PEOC7_GLPEOC_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DPC_COMP_COMP_VALID_S)
#define IG3_PEOC7_GLPEOC_DPC_REQ 0x42901CE4
#define IG3_PEOC7_GLPEOC_DPC_REQ_RSVD_S 12
#define IG3_PEOC7_GLPEOC_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC7_GLPEOC_DPC_REQ_RSVD_S)
#define IG3_PEOC7_GLPEOC_DPC_REQ_REQ_FTYPE_S 10
#define IG3_PEOC7_GLPEOC_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_DPC_REQ_REQ_FTYPE_S)
#define IG3_PEOC7_GLPEOC_DPC_REQ_REQ_FNUM_S 0
#define IG3_PEOC7_GLPEOC_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_DPC_REQ_REQ_FNUM_S)
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_COUNT 0x42901E38
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC7_GLPEOC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC7_GLPEOC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_CMD 0x42901E4C
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_DATA_H 0x42901E58
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_DATA_L 0x42901E54
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_PTR 0x42901E50
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC7_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_CMD 0x42901E3C
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_DATA_H 0x42901E48
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_DATA_L 0x42901E44
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_PTR 0x42901E40
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC7_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_CONTROL 0x42901E00
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_RSVD1_S 25
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_DTM_CONTROL_RSVD1_S)
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_RSVD2_S 17
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_DTM_CONTROL_RSVD2_S)
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_RSVD3_S 9
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_DTM_CONTROL_RSVD3_S)
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_BYPASS_S 8
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_CONTROL_BYPASS_S)
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_RSVD4_S 1
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_DTM_CONTROL_RSVD4_S)
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PEOC7_GLPEOC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PEOC7_GLPEOC_DTM_ECC_COR_ERR 0x42901E68
#define IG3_PEOC7_GLPEOC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PEOC7_GLPEOC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC7_GLPEOC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PEOC7_GLPEOC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PEOC7_GLPEOC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC7_GLPEOC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_DTM_ECC_UNCOR_ERR 0x42901E64
#define IG3_PEOC7_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PEOC7_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC7_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PEOC7_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PEOC7_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC7_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_DTM_GROUP_CFG 0x42901E0C
#define IG3_PEOC7_GLPEOC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PEOC7_GLPEOC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PEOC7_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PEOC7_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PEOC7_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PEOC7_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PEOC7_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PEOC7_GLPEOC_DTM_LOG_CFG 0x42901E10
#define IG3_PEOC7_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PEOC7_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PEOC7_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PEOC7_GLPEOC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PEOC7_GLPEOC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PEOC7_GLPEOC_DTM_LOG_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_DTM_LOG_CFG_MODE_S 0
#define IG3_PEOC7_GLPEOC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_DTM_LOG_CFG_MODE_S)
#define IG3_PEOC7_GLPEOC_DTM_LOG_MASK 0x42901E18
#define IG3_PEOC7_GLPEOC_DTM_LOG_MASK_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_DTM_LOG_MASK_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_LOG_PATTERN 0x42901E14
#define IG3_PEOC7_GLPEOC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_MAIN_CFG 0x42901E04
#define IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PEOC7_GLPEOC_DTM_MAIN_STS 0x42901E08
#define IG3_PEOC7_GLPEOC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PEOC7_GLPEOC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PEOC7_GLPEOC_DTM_MAIN_STS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PEOC7_GLPEOC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PEOC7_GLPEOC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PEOC7_GLPEOC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_DTM_MAIN_STS_RSVD2_S)
#define IG3_PEOC7_GLPEOC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PEOC7_GLPEOC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PEOC7_GLPEOC_DTM_TIMESTAMP 0x42901E30
#define IG3_PEOC7_GLPEOC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_DTM_TIMESTAMP_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_TIMESTAMP_ROLLOVER 0x42901E34
#define IG3_PEOC7_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG 0x42901E5C
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS 0x42901E60
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PEOC7_GLPEOC_DTM_TRIG_CFG 0x42901E1C
#define IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_MODE_S 0
#define IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_DTM_TRIG_CFG_MODE_S)
#define IG3_PEOC7_GLPEOC_DTM_TRIG_COUNT 0x42901E28
#define IG3_PEOC7_GLPEOC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_TRIG_MASK 0x42901E24
#define IG3_PEOC7_GLPEOC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_DTM_TRIG_MASK_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_TRIG_PATTERN 0x42901E20
#define IG3_PEOC7_GLPEOC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PEOC7_GLPEOC_DTM_TRIG_TIMESTAMP 0x42901E2C
#define IG3_PEOC7_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PEOC7_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PEOC7_GLPEOC_ECC_CTL 0x42901CC8
#define IG3_PEOC7_GLPEOC_ECC_CTL_RSVD_S 8
#define IG3_PEOC7_GLPEOC_ECC_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_ECC_CTL_RSVD_S)
#define IG3_PEOC7_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_S 7
#define IG3_PEOC7_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_S)
#define IG3_PEOC7_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_S 6
#define IG3_PEOC7_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_S)
#define IG3_PEOC7_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_ECC_CTL_CLIENT_ECC_EN_S 4
#define IG3_PEOC7_GLPEOC_ECC_CTL_CLIENT_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_ECC_CTL_CLIENT_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_S 3
#define IG3_PEOC7_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_S)
#define IG3_PEOC7_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_S 2
#define IG3_PEOC7_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_S)
#define IG3_PEOC7_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_S 1
#define IG3_PEOC7_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_ECC_CTL_HOST_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_ECC_CTL_HOST_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_ECC_CTL_HOST_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_ERRDATA0 0x42901CB8
#define IG3_PEOC7_GLPEOC_ERRDATA0_RSVD1_S 31
#define IG3_PEOC7_GLPEOC_ERRDATA0_RSVD1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_ERRDATA0_RSVD1_S)
#define IG3_PEOC7_GLPEOC_ERRDATA0_PF_NUM_S 25
#define IG3_PEOC7_GLPEOC_ERRDATA0_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PEOC7_GLPEOC_ERRDATA0_PF_NUM_S)
#define IG3_PEOC7_GLPEOC_ERRDATA0_VDEV_VF_NUM_S 15
#define IG3_PEOC7_GLPEOC_ERRDATA0_VDEV_VF_NUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_ERRDATA0_VDEV_VF_NUM_S)
#define IG3_PEOC7_GLPEOC_ERRDATA0_VDEV_VF_TYPE_S 13
#define IG3_PEOC7_GLPEOC_ERRDATA0_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_ERRDATA0_VDEV_VF_TYPE_S)
#define IG3_PEOC7_GLPEOC_ERRDATA0_OBJ_TYPE_S 8
#define IG3_PEOC7_GLPEOC_ERRDATA0_OBJ_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_ERRDATA0_OBJ_TYPE_S)
#define IG3_PEOC7_GLPEOC_ERRDATA0_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_ERRDATA0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_ERRDATA0_RSVD0_S)
#define IG3_PEOC7_GLPEOC_ERRDATA0_ERROR_CODE_S 0
#define IG3_PEOC7_GLPEOC_ERRDATA0_ERROR_CODE_M RDMA_MASK3(32, 0x3F, IG3_PEOC7_GLPEOC_ERRDATA0_ERROR_CODE_S)
#define IG3_PEOC7_GLPEOC_ERRDATA1 0x42901CBC
#define IG3_PEOC7_GLPEOC_ERRDATA1_RSVD_S 28
#define IG3_PEOC7_GLPEOC_ERRDATA1_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_ERRDATA1_RSVD_S)
#define IG3_PEOC7_GLPEOC_ERRDATA1_OBJ_INDEX_S 0
#define IG3_PEOC7_GLPEOC_ERRDATA1_OBJ_INDEX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PEOC7_GLPEOC_ERRDATA1_OBJ_INDEX_S)
#define IG3_PEOC7_GLPEOC_ERRDATA2 0x42901CC0
#define IG3_PEOC7_GLPEOC_ERRDATA2_RSVD_S 23
#define IG3_PEOC7_GLPEOC_ERRDATA2_RSVD_M RDMA_MASK3(32, 0x1FF, IG3_PEOC7_GLPEOC_ERRDATA2_RSVD_S)
#define IG3_PEOC7_GLPEOC_ERRDATA2_OPTYPE_S 20
#define IG3_PEOC7_GLPEOC_ERRDATA2_OPTYPE_M RDMA_MASK3(32, 0x7, IG3_PEOC7_GLPEOC_ERRDATA2_OPTYPE_S)
#define IG3_PEOC7_GLPEOC_ERRDATA2_OFFSET_S 7
#define IG3_PEOC7_GLPEOC_ERRDATA2_OFFSET_M RDMA_MASK3(32, 0x1FFF, IG3_PEOC7_GLPEOC_ERRDATA2_OFFSET_S)
#define IG3_PEOC7_GLPEOC_ERRDATA2_LENGTH_S 0
#define IG3_PEOC7_GLPEOC_ERRDATA2_LENGTH_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_ERRDATA2_LENGTH_S)
#define IG3_PEOC7_GLPEOC_ERRDATA3 0x42901CC4
#define IG3_PEOC7_GLPEOC_ERRDATA3_RSVD_S 15
#define IG3_PEOC7_GLPEOC_ERRDATA3_RSVD_M RDMA_MASK3(32, 0x1FFFF, IG3_PEOC7_GLPEOC_ERRDATA3_RSVD_S)
#define IG3_PEOC7_GLPEOC_ERRDATA3_TAG_S 0
#define IG3_PEOC7_GLPEOC_ERRDATA3_TAG_M RDMA_MASK3(32, 0x7FFF, IG3_PEOC7_GLPEOC_ERRDATA3_TAG_S)
#define IG3_PEOC7_GLPEOC_ERRINFO 0x42901CB4
#define IG3_PEOC7_GLPEOC_ERRINFO_RSVD1_S 16
#define IG3_PEOC7_GLPEOC_ERRINFO_RSVD1_M RDMA_MASK3(32, 0xFFFF, IG3_PEOC7_GLPEOC_ERRINFO_RSVD1_S)
#define IG3_PEOC7_GLPEOC_ERRINFO_ERROR_CNT_S 8
#define IG3_PEOC7_GLPEOC_ERRINFO_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_ERRINFO_ERROR_CNT_S)
#define IG3_PEOC7_GLPEOC_ERRINFO_RSVD0_S 1
#define IG3_PEOC7_GLPEOC_ERRINFO_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_ERRINFO_RSVD0_S)
#define IG3_PEOC7_GLPEOC_ERRINFO_ERROR_VALID_S 0
#define IG3_PEOC7_GLPEOC_ERRINFO_ERROR_VALID_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_ERRINFO_ERROR_VALID_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG 0x42901D1C
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RSVD3_S 20
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RM_S 16
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RM_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RSVD2_S 14
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RME_S 12
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RME_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RSVD1_S 10
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_EVICT_MEM_CFG_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS 0x42901D20
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_RSVD0_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG 0x42901D14
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RSVD3_S 20
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RM_S 16
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RM_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RSVD2_S 14
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RME_S 12
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RME_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RSVD1_S 10
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_FILL_MEM_CFG_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS 0x42901D18
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_RSVD0_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_FILL_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC7_GLPEOC_FSIADR_OBJOFST 0x42901C8C
#define IG3_PEOC7_GLPEOC_FSIADR_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_FSIADR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_FSIADR_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_FSIMCAST_OBJOFST 0x42901C90
#define IG3_PEOC7_GLPEOC_FSIMCAST_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_FSIMCAST_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_FSIMCAST_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_HDR_OBJOFST 0x42901CA0
#define IG3_PEOC7_GLPEOC_HDR_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_HDR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_HDR_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_HECC_ERR 0x42901CCC
#define IG3_PEOC7_GLPEOC_HECC_ERR_RSVD1_S 28
#define IG3_PEOC7_GLPEOC_HECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_HECC_ERR_RSVD1_S)
#define IG3_PEOC7_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PEOC7_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC7_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_HECC_ERR_RSVD0_S 12
#define IG3_PEOC7_GLPEOC_HECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_HECC_ERR_RSVD0_S)
#define IG3_PEOC7_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PEOC7_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC7_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_IRRQ_OBJOFST 0x42901C80
#define IG3_PEOC7_GLPEOC_IRRQ_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_IRRQ_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_IRRQ_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_MAXOSR 0x42901CD4
#define IG3_PEOC7_GLPEOC_MAXOSR_RSVD1_S 15
#define IG3_PEOC7_GLPEOC_MAXOSR_RSVD1_M RDMA_MASK3(32, 0x1FFFF, IG3_PEOC7_GLPEOC_MAXOSR_RSVD1_S)
#define IG3_PEOC7_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S 10
#define IG3_PEOC7_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S)
#define IG3_PEOC7_GLPEOC_MAXOSR_RSVD0_S 8
#define IG3_PEOC7_GLPEOC_MAXOSR_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_MAXOSR_RSVD0_S)
#define IG3_PEOC7_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_S 0
#define IG3_PEOC7_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_S)
#define IG3_PEOC7_GLPEOC_MEM_ECC_COR_ERR 0x42901DB8
#define IG3_PEOC7_GLPEOC_MEM_ECC_COR_ERR_RSVD_S 12
#define IG3_PEOC7_GLPEOC_MEM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC7_GLPEOC_MEM_ECC_COR_ERR_RSVD_S)
#define IG3_PEOC7_GLPEOC_MEM_ECC_COR_ERR_CNT_S 0
#define IG3_PEOC7_GLPEOC_MEM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC7_GLPEOC_MEM_ECC_COR_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_MEM_ECC_UNCOR_ERR 0x42901DB4
#define IG3_PEOC7_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PEOC7_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC7_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PEOC7_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PEOC7_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC7_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_OOISCFL_OBJOFST 0x42901CB0
#define IG3_PEOC7_GLPEOC_OOISCFL_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_OOISCFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_OOISCFL_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_OOISC_OBJOFST 0x42901CAC
#define IG3_PEOC7_GLPEOC_OOISC_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_OOISC_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_OOISC_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_PLIST_DBG_CTL 0x42901DAC
#define IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_DONE_S 31
#define IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_DONE_S)
#define IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_RD_EN_S 30
#define IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_RD_EN_S)
#define IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_RSVD_S 26
#define IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_RSVD_S)
#define IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_DW_SEL_S)
#define IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_ADR_S 0
#define IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_PLIST_DBG_CTL_ADR_S)
#define IG3_PEOC7_GLPEOC_PLIST_DBG_DATA 0x42901DB0
#define IG3_PEOC7_GLPEOC_PLIST_DBG_DATA_RD_DW_S 0
#define IG3_PEOC7_GLPEOC_PLIST_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_PLIST_DBG_DATA_RD_DW_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG 0x42901D0C
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RSVD3_S 20
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RM_S 16
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RM_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RSVD2_S 14
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RME_S 12
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RME_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RSVD1_S 10
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_MEM_CFG_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS 0x42901D10
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_RSVD0_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC7_GLPEOC_PMATINV_CFG 0x42901CDC
#define IG3_PEOC7_GLPEOC_PMATINV_CFG_RSVD_S 6
#define IG3_PEOC7_GLPEOC_PMATINV_CFG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_PEOC7_GLPEOC_PMATINV_CFG_RSVD_S)
#define IG3_PEOC7_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S 5
#define IG3_PEOC7_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S)
#define IG3_PEOC7_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S 4
#define IG3_PEOC7_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PEOC7_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S 3
#define IG3_PEOC7_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S)
#define IG3_PEOC7_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S 2
#define IG3_PEOC7_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S)
#define IG3_PEOC7_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S 1
#define IG3_PEOC7_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PEOC7_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_S 0
#define IG3_PEOC7_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_S)
#define IG3_PEOC7_GLPEOC_Q1FL_OBJOFST 0x42901C98
#define IG3_PEOC7_GLPEOC_Q1FL_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_Q1FL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_Q1FL_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_RRFL_OBJOFST 0x42901CA8
#define IG3_PEOC7_GLPEOC_RRFL_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_RRFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_RRFL_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_RRF_OBJOFST 0x42901CA4
#define IG3_PEOC7_GLPEOC_RRF_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_RRF_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_RRF_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_SRQCTX_OBJOFST 0x42901C88
#define IG3_PEOC7_GLPEOC_SRQCTX_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_SRQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_SRQCTX_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_STAT_CTL 0x42901C04
#define IG3_PEOC7_GLPEOC_STAT_CTL_RSVD_S 5
#define IG3_PEOC7_GLPEOC_STAT_CTL_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PEOC7_GLPEOC_STAT_CTL_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_CTL_OBJECT_TYPE_S 0
#define IG3_PEOC7_GLPEOC_STAT_CTL_OBJECT_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_STAT_CTL_OBJECT_TYPE_S)
#define IG3_PEOC7_GLPEOC_STAT_FENCING_TIME_HI 0x42901C6C
#define IG3_PEOC7_GLPEOC_STAT_FENCING_TIME_HI_RSVD_S 24
#define IG3_PEOC7_GLPEOC_STAT_FENCING_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_FENCING_TIME_HI_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_S 0
#define IG3_PEOC7_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_S)
#define IG3_PEOC7_GLPEOC_STAT_FENCING_TIME_LO 0x42901C68
#define IG3_PEOC7_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_STAT_MAX_PENDING_ENTRIES 0x42901C4C
#define IG3_PEOC7_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_S 8
#define IG3_PEOC7_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_S 0
#define IG3_PEOC7_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_S)
#define IG3_PEOC7_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH 0x42901C54
#define IG3_PEOC7_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S 8
#define IG3_PEOC7_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS 0x42901C50
#define IG3_PEOC7_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S 8
#define IG3_PEOC7_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_STAT_OBJ_CNT 0x42901C08
#define IG3_PEOC7_GLPEOC_STAT_OBJ_CNT_RSVD_S 14
#define IG3_PEOC7_GLPEOC_STAT_OBJ_CNT_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_STAT_OBJ_CNT_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_S 0
#define IG3_PEOC7_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PEOC7_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_S)
#define IG3_PEOC7_GLPEOC_STAT_PENDLING_LIST_FULL_HI 0x42901C64
#define IG3_PEOC7_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S 24
#define IG3_PEOC7_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S 0
#define IG3_PEOC7_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S)
#define IG3_PEOC7_GLPEOC_STAT_PENDLING_LIST_FULL_LO 0x42901C60
#define IG3_PEOC7_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_IDLE_HI 0x42901C30
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_S 24
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_IDLE_LO 0x42901C2C
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_XFER_HI 0x42901C38
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_S 24
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_S)
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_XFER_LO 0x42901C34
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_STAT_RD_HIT_HI 0x42901C10
#define IG3_PEOC7_GLPEOC_STAT_RD_HIT_HI_RSVD_S 24
#define IG3_PEOC7_GLPEOC_STAT_RD_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_RD_HIT_HI_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_RD_HIT_HI_CNT_HI_S 0
#define IG3_PEOC7_GLPEOC_STAT_RD_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_RD_HIT_HI_CNT_HI_S)
#define IG3_PEOC7_GLPEOC_STAT_RD_HIT_LO 0x42901C0C
#define IG3_PEOC7_GLPEOC_STAT_RD_HIT_LO_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_STAT_RD_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_STAT_RD_HIT_LO_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_STAT_RD_MISS_HI 0x42901C18
#define IG3_PEOC7_GLPEOC_STAT_RD_MISS_HI_RSVD_S 24
#define IG3_PEOC7_GLPEOC_STAT_RD_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_RD_MISS_HI_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_RD_MISS_HI_CNT_HI_S 0
#define IG3_PEOC7_GLPEOC_STAT_RD_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_RD_MISS_HI_CNT_HI_S)
#define IG3_PEOC7_GLPEOC_STAT_RD_MISS_LO 0x42901C14
#define IG3_PEOC7_GLPEOC_STAT_RD_MISS_LO_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_STAT_RD_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_STAT_RD_MISS_LO_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_STAT_REPLAY_TIME_HI 0x42901C74
#define IG3_PEOC7_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_S 24
#define IG3_PEOC7_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_S 0
#define IG3_PEOC7_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_S)
#define IG3_PEOC7_GLPEOC_STAT_REPLAY_TIME_LO 0x42901C70
#define IG3_PEOC7_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_BUFF_FULL_HI 0x42901C5C
#define IG3_PEOC7_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_S 24
#define IG3_PEOC7_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S 0
#define IG3_PEOC7_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_BUFF_FULL_LO 0x42901C58
#define IG3_PEOC7_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_IDLE_HI 0x42901C40
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_S 24
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_IDLE_LO 0x42901C3C
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_XFER_HI 0x42901C48
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_S 24
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_XFER_LO 0x42901C44
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_HIT_HI 0x42901C20
#define IG3_PEOC7_GLPEOC_STAT_WR_HIT_HI_RSVD_S 24
#define IG3_PEOC7_GLPEOC_STAT_WR_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_WR_HIT_HI_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_HIT_HI_CNT_HI_S 0
#define IG3_PEOC7_GLPEOC_STAT_WR_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_WR_HIT_HI_CNT_HI_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_HIT_LO 0x42901C1C
#define IG3_PEOC7_GLPEOC_STAT_WR_HIT_LO_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_STAT_WR_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_STAT_WR_HIT_LO_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_MISS_HI 0x42901C28
#define IG3_PEOC7_GLPEOC_STAT_WR_MISS_HI_RSVD_S 24
#define IG3_PEOC7_GLPEOC_STAT_WR_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_STAT_WR_MISS_HI_RSVD_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_MISS_HI_CNT_HI_S 0
#define IG3_PEOC7_GLPEOC_STAT_WR_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_STAT_WR_MISS_HI_CNT_HI_S)
#define IG3_PEOC7_GLPEOC_STAT_WR_MISS_LO 0x42901C24
#define IG3_PEOC7_GLPEOC_STAT_WR_MISS_LO_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_STAT_WR_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_STAT_WR_MISS_LO_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_TAG_DBG_CTL 0x42901D64
#define IG3_PEOC7_GLPEOC_TAG_DBG_CTL_DONE_S 31
#define IG3_PEOC7_GLPEOC_TAG_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_DBG_CTL_DONE_S)
#define IG3_PEOC7_GLPEOC_TAG_DBG_CTL_RD_EN_S 30
#define IG3_PEOC7_GLPEOC_TAG_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_DBG_CTL_RD_EN_S)
#define IG3_PEOC7_GLPEOC_TAG_DBG_CTL_RSVD_S 26
#define IG3_PEOC7_GLPEOC_TAG_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_TAG_DBG_CTL_RSVD_S)
#define IG3_PEOC7_GLPEOC_TAG_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC7_GLPEOC_TAG_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_TAG_DBG_CTL_DW_SEL_S)
#define IG3_PEOC7_GLPEOC_TAG_DBG_CTL_ADR_S 0
#define IG3_PEOC7_GLPEOC_TAG_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_TAG_DBG_CTL_ADR_S)
#define IG3_PEOC7_GLPEOC_TAG_DBG_DATA 0x42901D68
#define IG3_PEOC7_GLPEOC_TAG_DBG_DATA_RD_DW_S 0
#define IG3_PEOC7_GLPEOC_TAG_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_TAG_DBG_DATA_RD_DW_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG 0x42901CFC
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RSVD3_S 20
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RM_S 16
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RM_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RSVD2_S 14
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RME_S 12
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RME_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RSVD1_S 10
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_MEM_CFG_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS 0x42901D00
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_RSVD0_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC7_GLPEOC_TIMER_OBJOFST 0x42901C9C
#define IG3_PEOC7_GLPEOC_TIMER_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_TIMER_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_TIMER_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_HI 0x42901CF0
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_HI_RSVD_S 24
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_TOTAL_TAG_HI_RSVD_S)
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_HI_CNT_HI_S 0
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_TOTAL_TAG_HI_CNT_HI_S)
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_HIT_HI 0x42901CF8
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_S 24
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_S)
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_S 0
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC7_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_S)
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_HIT_LO 0x42901CF4
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_LO 0x42901CEC
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_LO_CNT_LO_S 0
#define IG3_PEOC7_GLPEOC_TOTAL_TAG_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC7_GLPEOC_TOTAL_TAG_LO_CNT_LO_S)
#define IG3_PEOC7_GLPEOC_TXFIFO_OBJOFST 0x42901C7C
#define IG3_PEOC7_GLPEOC_TXFIFO_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_TXFIFO_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_TXFIFO_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG 0x42901D04
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RSVD3_S 20
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RSVD3_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RM_S 16
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RM_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RSVD2_S 14
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RSVD2_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RME_S 12
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RME_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RSVD1_S 10
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RSVD1_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RSVD0_S 6
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_RSVD0_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_MASK_INT_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_WRBUF_MEM_CFG_ECC_EN_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS 0x42901D08
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_RSVD1_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_RSVD0_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC7_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC7_GLPEOC_XFFL_OBJOFST 0x42901C94
#define IG3_PEOC7_GLPEOC_XFFL_OBJOFST_RSVD_S 10
#define IG3_PEOC7_GLPEOC_XFFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC7_GLPEOC_XFFL_OBJOFST_RSVD_S)
#define IG3_PEOC7_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC7_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC7_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_ARPTBLE_OBJOFST 0x42902078
#define IG3_PEOC8_GLPEOC_ARPTBLE_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_ARPTBLE_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_ARPTBLE_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_CACHESIZE 0x429020E0
#define IG3_PEOC8_GLPEOC_CACHESIZE_RSVD_S 24
#define IG3_PEOC8_GLPEOC_CACHESIZE_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHESIZE_RSVD_S)
#define IG3_PEOC8_GLPEOC_CACHESIZE_WAYS_S 20
#define IG3_PEOC8_GLPEOC_CACHESIZE_WAYS_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHESIZE_WAYS_S)
#define IG3_PEOC8_GLPEOC_CACHESIZE_SETS_S 8
#define IG3_PEOC8_GLPEOC_CACHESIZE_SETS_M RDMA_MASK3(32, 0xFFF, IG3_PEOC8_GLPEOC_CACHESIZE_SETS_S)
#define IG3_PEOC8_GLPEOC_CACHESIZE_WORD_SIZE_S 0
#define IG3_PEOC8_GLPEOC_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHESIZE_WORD_SIZE_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL 0x4290216C
#define IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_DONE_S 31
#define IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_RD_EN_S 30
#define IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_RD_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_RSVD_S 26
#define IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_RSVD_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_ADR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_0_DBG_CTL_ADR_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_DBG_DATA 0x42902170
#define IG3_PEOC8_GLPEOC_CACHE_0_DBG_DATA_RD_DW_S 0
#define IG3_PEOC8_GLPEOC_CACHE_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_CACHE_0_DBG_DATA_RD_DW_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG 0x42902124
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RSVD3_S 20
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RM_S 16
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RM_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RSVD2_S 14
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RME_S 12
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RME_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RSVD1_S 10
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS 0x42902128
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL 0x42902174
#define IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_DONE_S 31
#define IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_RD_EN_S 30
#define IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_RD_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_RSVD_S 26
#define IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_RSVD_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_ADR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_1_DBG_CTL_ADR_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_DBG_DATA 0x42902178
#define IG3_PEOC8_GLPEOC_CACHE_1_DBG_DATA_RD_DW_S 0
#define IG3_PEOC8_GLPEOC_CACHE_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_CACHE_1_DBG_DATA_RD_DW_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG 0x4290212C
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RSVD3_S 20
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RM_S 16
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RM_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RSVD2_S 14
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RME_S 12
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RME_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RSVD1_S 10
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS 0x42902130
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL 0x4290217C
#define IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_DONE_S 31
#define IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_RD_EN_S 30
#define IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_RD_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_RSVD_S 26
#define IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_RSVD_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_ADR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_2_DBG_CTL_ADR_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_DBG_DATA 0x42902180
#define IG3_PEOC8_GLPEOC_CACHE_2_DBG_DATA_RD_DW_S 0
#define IG3_PEOC8_GLPEOC_CACHE_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_CACHE_2_DBG_DATA_RD_DW_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG 0x42902134
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RSVD3_S 20
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RM_S 16
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RM_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RSVD2_S 14
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RME_S 12
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RME_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RSVD1_S 10
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS 0x42902138
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL 0x42902184
#define IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_DONE_S 31
#define IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_RD_EN_S 30
#define IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_RD_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_RSVD_S 26
#define IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_RSVD_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_ADR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_3_DBG_CTL_ADR_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_DBG_DATA 0x42902188
#define IG3_PEOC8_GLPEOC_CACHE_3_DBG_DATA_RD_DW_S 0
#define IG3_PEOC8_GLPEOC_CACHE_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_CACHE_3_DBG_DATA_RD_DW_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG 0x4290213C
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RSVD3_S 20
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RM_S 16
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RM_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RSVD2_S 14
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RME_S 12
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RME_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RSVD1_S 10
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS 0x42902140
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL 0x4290218C
#define IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_DONE_S 31
#define IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_RD_EN_S 30
#define IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_RD_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_RSVD_S 26
#define IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_RSVD_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_ADR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_4_DBG_CTL_ADR_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_DBG_DATA 0x42902190
#define IG3_PEOC8_GLPEOC_CACHE_4_DBG_DATA_RD_DW_S 0
#define IG3_PEOC8_GLPEOC_CACHE_4_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_CACHE_4_DBG_DATA_RD_DW_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG 0x42902144
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RSVD3_S 20
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RM_S 16
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RM_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RSVD2_S 14
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RME_S 12
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RME_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RSVD1_S 10
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS 0x42902148
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL 0x42902194
#define IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_DONE_S 31
#define IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_RD_EN_S 30
#define IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_RD_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_RSVD_S 26
#define IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_RSVD_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_ADR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_5_DBG_CTL_ADR_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_DBG_DATA 0x42902198
#define IG3_PEOC8_GLPEOC_CACHE_5_DBG_DATA_RD_DW_S 0
#define IG3_PEOC8_GLPEOC_CACHE_5_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_CACHE_5_DBG_DATA_RD_DW_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG 0x4290214C
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RSVD3_S 20
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RM_S 16
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RM_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RSVD2_S 14
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RME_S 12
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RME_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RSVD1_S 10
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS 0x42902150
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL 0x4290219C
#define IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_DONE_S 31
#define IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_RD_EN_S 30
#define IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_RD_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_RSVD_S 26
#define IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_RSVD_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_ADR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_6_DBG_CTL_ADR_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_DBG_DATA 0x429021A0
#define IG3_PEOC8_GLPEOC_CACHE_6_DBG_DATA_RD_DW_S 0
#define IG3_PEOC8_GLPEOC_CACHE_6_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_CACHE_6_DBG_DATA_RD_DW_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG 0x42902154
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RSVD3_S 20
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RM_S 16
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RM_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RSVD2_S 14
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RME_S 12
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RME_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RSVD1_S 10
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS 0x42902158
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL 0x429021A4
#define IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_DONE_S 31
#define IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_RD_EN_S 30
#define IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_RD_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_RSVD_S 26
#define IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_RSVD_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_ADR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_7_DBG_CTL_ADR_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_DBG_DATA 0x429021A8
#define IG3_PEOC8_GLPEOC_CACHE_7_DBG_DATA_RD_DW_S 0
#define IG3_PEOC8_GLPEOC_CACHE_7_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_CACHE_7_DBG_DATA_RD_DW_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG 0x4290215C
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RSVD3_S 20
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RM_S 16
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RM_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RSVD2_S 14
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RME_S 12
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RME_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RSVD1_S 10
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS 0x42902160
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC8_GLPEOC_CACHE_CTRL 0x42902000
#define IG3_PEOC8_GLPEOC_CACHE_CTRL_RSVD_S 2
#define IG3_PEOC8_GLPEOC_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_PEOC8_GLPEOC_CACHE_CTRL_RSVD_S)
#define IG3_PEOC8_GLPEOC_CACHE_CTRL_SCALE_FACTOR_S 0
#define IG3_PEOC8_GLPEOC_CACHE_CTRL_SCALE_FACTOR_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_CACHE_CTRL_SCALE_FACTOR_S)
#define IG3_PEOC8_GLPEOC_CECC_ERR 0x429020D0
#define IG3_PEOC8_GLPEOC_CECC_ERR_RSVD1_S 28
#define IG3_PEOC8_GLPEOC_CECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CECC_ERR_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PEOC8_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC8_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_CECC_ERR_RSVD0_S 12
#define IG3_PEOC8_GLPEOC_CECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_CECC_ERR_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PEOC8_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC8_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_CQCTX_OBJOFST 0x42902084
#define IG3_PEOC8_GLPEOC_CQCTX_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_CQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_CQCTX_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_CSTATELKUP_CFG 0x429020D8
#define IG3_PEOC8_GLPEOC_CSTATELKUP_CFG_RSVD1_S 9
#define IG3_PEOC8_GLPEOC_CSTATELKUP_CFG_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PEOC8_GLPEOC_CSTATELKUP_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S 8
#define IG3_PEOC8_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S)
#define IG3_PEOC8_GLPEOC_CSTATELKUP_CFG_RSVD0_S 3
#define IG3_PEOC8_GLPEOC_CSTATELKUP_CFG_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_CSTATELKUP_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S 0
#define IG3_PEOC8_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_M RDMA_MASK3(32, 0x7, IG3_PEOC8_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S)
#define IG3_PEOC8_GLPEOC_DPC_COMP 0x429020E8
#define IG3_PEOC8_GLPEOC_DPC_COMP_RSVD_S 13
#define IG3_PEOC8_GLPEOC_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEOC8_GLPEOC_DPC_COMP_RSVD_S)
#define IG3_PEOC8_GLPEOC_DPC_COMP_COMP_FTYPE_S 11
#define IG3_PEOC8_GLPEOC_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_DPC_COMP_COMP_FTYPE_S)
#define IG3_PEOC8_GLPEOC_DPC_COMP_COMP_FNUM_S 1
#define IG3_PEOC8_GLPEOC_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_DPC_COMP_COMP_FNUM_S)
#define IG3_PEOC8_GLPEOC_DPC_COMP_COMP_VALID_S 0
#define IG3_PEOC8_GLPEOC_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DPC_COMP_COMP_VALID_S)
#define IG3_PEOC8_GLPEOC_DPC_REQ 0x429020E4
#define IG3_PEOC8_GLPEOC_DPC_REQ_RSVD_S 12
#define IG3_PEOC8_GLPEOC_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC8_GLPEOC_DPC_REQ_RSVD_S)
#define IG3_PEOC8_GLPEOC_DPC_REQ_REQ_FTYPE_S 10
#define IG3_PEOC8_GLPEOC_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_DPC_REQ_REQ_FTYPE_S)
#define IG3_PEOC8_GLPEOC_DPC_REQ_REQ_FNUM_S 0
#define IG3_PEOC8_GLPEOC_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_DPC_REQ_REQ_FNUM_S)
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_COUNT 0x42902238
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC8_GLPEOC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC8_GLPEOC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_CMD 0x4290224C
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_DATA_H 0x42902258
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_DATA_L 0x42902254
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_PTR 0x42902250
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC8_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_CMD 0x4290223C
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_DATA_H 0x42902248
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_DATA_L 0x42902244
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_PTR 0x42902240
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC8_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_CONTROL 0x42902200
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_RSVD1_S 25
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_DTM_CONTROL_RSVD1_S)
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_RSVD2_S 17
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_DTM_CONTROL_RSVD2_S)
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_RSVD3_S 9
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_DTM_CONTROL_RSVD3_S)
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_BYPASS_S 8
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_CONTROL_BYPASS_S)
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_RSVD4_S 1
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_DTM_CONTROL_RSVD4_S)
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PEOC8_GLPEOC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PEOC8_GLPEOC_DTM_ECC_COR_ERR 0x42902268
#define IG3_PEOC8_GLPEOC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PEOC8_GLPEOC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC8_GLPEOC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PEOC8_GLPEOC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PEOC8_GLPEOC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC8_GLPEOC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_DTM_ECC_UNCOR_ERR 0x42902264
#define IG3_PEOC8_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PEOC8_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC8_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PEOC8_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PEOC8_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC8_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_DTM_GROUP_CFG 0x4290220C
#define IG3_PEOC8_GLPEOC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PEOC8_GLPEOC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PEOC8_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PEOC8_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PEOC8_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PEOC8_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PEOC8_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PEOC8_GLPEOC_DTM_LOG_CFG 0x42902210
#define IG3_PEOC8_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PEOC8_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PEOC8_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PEOC8_GLPEOC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PEOC8_GLPEOC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PEOC8_GLPEOC_DTM_LOG_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_DTM_LOG_CFG_MODE_S 0
#define IG3_PEOC8_GLPEOC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_DTM_LOG_CFG_MODE_S)
#define IG3_PEOC8_GLPEOC_DTM_LOG_MASK 0x42902218
#define IG3_PEOC8_GLPEOC_DTM_LOG_MASK_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_DTM_LOG_MASK_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_LOG_PATTERN 0x42902214
#define IG3_PEOC8_GLPEOC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_MAIN_CFG 0x42902204
#define IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PEOC8_GLPEOC_DTM_MAIN_STS 0x42902208
#define IG3_PEOC8_GLPEOC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PEOC8_GLPEOC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PEOC8_GLPEOC_DTM_MAIN_STS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PEOC8_GLPEOC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PEOC8_GLPEOC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PEOC8_GLPEOC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_DTM_MAIN_STS_RSVD2_S)
#define IG3_PEOC8_GLPEOC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PEOC8_GLPEOC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PEOC8_GLPEOC_DTM_TIMESTAMP 0x42902230
#define IG3_PEOC8_GLPEOC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_DTM_TIMESTAMP_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_TIMESTAMP_ROLLOVER 0x42902234
#define IG3_PEOC8_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG 0x4290225C
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS 0x42902260
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PEOC8_GLPEOC_DTM_TRIG_CFG 0x4290221C
#define IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_MODE_S 0
#define IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_DTM_TRIG_CFG_MODE_S)
#define IG3_PEOC8_GLPEOC_DTM_TRIG_COUNT 0x42902228
#define IG3_PEOC8_GLPEOC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_TRIG_MASK 0x42902224
#define IG3_PEOC8_GLPEOC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_DTM_TRIG_MASK_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_TRIG_PATTERN 0x42902220
#define IG3_PEOC8_GLPEOC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PEOC8_GLPEOC_DTM_TRIG_TIMESTAMP 0x4290222C
#define IG3_PEOC8_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PEOC8_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PEOC8_GLPEOC_ECC_CTL 0x429020C8
#define IG3_PEOC8_GLPEOC_ECC_CTL_RSVD_S 8
#define IG3_PEOC8_GLPEOC_ECC_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_ECC_CTL_RSVD_S)
#define IG3_PEOC8_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_S 7
#define IG3_PEOC8_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_S)
#define IG3_PEOC8_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_S 6
#define IG3_PEOC8_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_S)
#define IG3_PEOC8_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_ECC_CTL_CLIENT_ECC_EN_S 4
#define IG3_PEOC8_GLPEOC_ECC_CTL_CLIENT_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_ECC_CTL_CLIENT_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_S 3
#define IG3_PEOC8_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_S)
#define IG3_PEOC8_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_S 2
#define IG3_PEOC8_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_S)
#define IG3_PEOC8_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_S 1
#define IG3_PEOC8_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_ECC_CTL_HOST_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_ECC_CTL_HOST_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_ECC_CTL_HOST_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_ERRDATA0 0x429020B8
#define IG3_PEOC8_GLPEOC_ERRDATA0_RSVD1_S 31
#define IG3_PEOC8_GLPEOC_ERRDATA0_RSVD1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_ERRDATA0_RSVD1_S)
#define IG3_PEOC8_GLPEOC_ERRDATA0_PF_NUM_S 25
#define IG3_PEOC8_GLPEOC_ERRDATA0_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PEOC8_GLPEOC_ERRDATA0_PF_NUM_S)
#define IG3_PEOC8_GLPEOC_ERRDATA0_VDEV_VF_NUM_S 15
#define IG3_PEOC8_GLPEOC_ERRDATA0_VDEV_VF_NUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_ERRDATA0_VDEV_VF_NUM_S)
#define IG3_PEOC8_GLPEOC_ERRDATA0_VDEV_VF_TYPE_S 13
#define IG3_PEOC8_GLPEOC_ERRDATA0_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_ERRDATA0_VDEV_VF_TYPE_S)
#define IG3_PEOC8_GLPEOC_ERRDATA0_OBJ_TYPE_S 8
#define IG3_PEOC8_GLPEOC_ERRDATA0_OBJ_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_ERRDATA0_OBJ_TYPE_S)
#define IG3_PEOC8_GLPEOC_ERRDATA0_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_ERRDATA0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_ERRDATA0_RSVD0_S)
#define IG3_PEOC8_GLPEOC_ERRDATA0_ERROR_CODE_S 0
#define IG3_PEOC8_GLPEOC_ERRDATA0_ERROR_CODE_M RDMA_MASK3(32, 0x3F, IG3_PEOC8_GLPEOC_ERRDATA0_ERROR_CODE_S)
#define IG3_PEOC8_GLPEOC_ERRDATA1 0x429020BC
#define IG3_PEOC8_GLPEOC_ERRDATA1_RSVD_S 28
#define IG3_PEOC8_GLPEOC_ERRDATA1_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_ERRDATA1_RSVD_S)
#define IG3_PEOC8_GLPEOC_ERRDATA1_OBJ_INDEX_S 0
#define IG3_PEOC8_GLPEOC_ERRDATA1_OBJ_INDEX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PEOC8_GLPEOC_ERRDATA1_OBJ_INDEX_S)
#define IG3_PEOC8_GLPEOC_ERRDATA2 0x429020C0
#define IG3_PEOC8_GLPEOC_ERRDATA2_RSVD_S 23
#define IG3_PEOC8_GLPEOC_ERRDATA2_RSVD_M RDMA_MASK3(32, 0x1FF, IG3_PEOC8_GLPEOC_ERRDATA2_RSVD_S)
#define IG3_PEOC8_GLPEOC_ERRDATA2_OPTYPE_S 20
#define IG3_PEOC8_GLPEOC_ERRDATA2_OPTYPE_M RDMA_MASK3(32, 0x7, IG3_PEOC8_GLPEOC_ERRDATA2_OPTYPE_S)
#define IG3_PEOC8_GLPEOC_ERRDATA2_OFFSET_S 7
#define IG3_PEOC8_GLPEOC_ERRDATA2_OFFSET_M RDMA_MASK3(32, 0x1FFF, IG3_PEOC8_GLPEOC_ERRDATA2_OFFSET_S)
#define IG3_PEOC8_GLPEOC_ERRDATA2_LENGTH_S 0
#define IG3_PEOC8_GLPEOC_ERRDATA2_LENGTH_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_ERRDATA2_LENGTH_S)
#define IG3_PEOC8_GLPEOC_ERRDATA3 0x429020C4
#define IG3_PEOC8_GLPEOC_ERRDATA3_RSVD_S 15
#define IG3_PEOC8_GLPEOC_ERRDATA3_RSVD_M RDMA_MASK3(32, 0x1FFFF, IG3_PEOC8_GLPEOC_ERRDATA3_RSVD_S)
#define IG3_PEOC8_GLPEOC_ERRDATA3_TAG_S 0
#define IG3_PEOC8_GLPEOC_ERRDATA3_TAG_M RDMA_MASK3(32, 0x7FFF, IG3_PEOC8_GLPEOC_ERRDATA3_TAG_S)
#define IG3_PEOC8_GLPEOC_ERRINFO 0x429020B4
#define IG3_PEOC8_GLPEOC_ERRINFO_RSVD1_S 16
#define IG3_PEOC8_GLPEOC_ERRINFO_RSVD1_M RDMA_MASK3(32, 0xFFFF, IG3_PEOC8_GLPEOC_ERRINFO_RSVD1_S)
#define IG3_PEOC8_GLPEOC_ERRINFO_ERROR_CNT_S 8
#define IG3_PEOC8_GLPEOC_ERRINFO_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_ERRINFO_ERROR_CNT_S)
#define IG3_PEOC8_GLPEOC_ERRINFO_RSVD0_S 1
#define IG3_PEOC8_GLPEOC_ERRINFO_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_ERRINFO_RSVD0_S)
#define IG3_PEOC8_GLPEOC_ERRINFO_ERROR_VALID_S 0
#define IG3_PEOC8_GLPEOC_ERRINFO_ERROR_VALID_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_ERRINFO_ERROR_VALID_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG 0x4290211C
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RSVD3_S 20
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RM_S 16
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RM_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RSVD2_S 14
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RME_S 12
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RME_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RSVD1_S 10
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_EVICT_MEM_CFG_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS 0x42902120
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_RSVD0_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG 0x42902114
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RSVD3_S 20
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RM_S 16
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RM_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RSVD2_S 14
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RME_S 12
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RME_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RSVD1_S 10
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_FILL_MEM_CFG_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS 0x42902118
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_RSVD0_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_FILL_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC8_GLPEOC_FSIADR_OBJOFST 0x4290208C
#define IG3_PEOC8_GLPEOC_FSIADR_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_FSIADR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_FSIADR_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_FSIMCAST_OBJOFST 0x42902090
#define IG3_PEOC8_GLPEOC_FSIMCAST_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_FSIMCAST_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_FSIMCAST_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_HDR_OBJOFST 0x429020A0
#define IG3_PEOC8_GLPEOC_HDR_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_HDR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_HDR_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_HECC_ERR 0x429020CC
#define IG3_PEOC8_GLPEOC_HECC_ERR_RSVD1_S 28
#define IG3_PEOC8_GLPEOC_HECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_HECC_ERR_RSVD1_S)
#define IG3_PEOC8_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PEOC8_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC8_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_HECC_ERR_RSVD0_S 12
#define IG3_PEOC8_GLPEOC_HECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_HECC_ERR_RSVD0_S)
#define IG3_PEOC8_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PEOC8_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC8_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_IRRQ_OBJOFST 0x42902080
#define IG3_PEOC8_GLPEOC_IRRQ_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_IRRQ_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_IRRQ_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_MAXOSR 0x429020D4
#define IG3_PEOC8_GLPEOC_MAXOSR_RSVD1_S 12
#define IG3_PEOC8_GLPEOC_MAXOSR_RSVD1_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC8_GLPEOC_MAXOSR_RSVD1_S)
#define IG3_PEOC8_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S 8
#define IG3_PEOC8_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S)
#define IG3_PEOC8_GLPEOC_MAXOSR_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_MAXOSR_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_MAXOSR_RSVD0_S)
#define IG3_PEOC8_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_S 0
#define IG3_PEOC8_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_M RDMA_MASK3(32, 0x3F, IG3_PEOC8_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_S)
#define IG3_PEOC8_GLPEOC_MEM_ECC_COR_ERR 0x429021B8
#define IG3_PEOC8_GLPEOC_MEM_ECC_COR_ERR_RSVD_S 12
#define IG3_PEOC8_GLPEOC_MEM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC8_GLPEOC_MEM_ECC_COR_ERR_RSVD_S)
#define IG3_PEOC8_GLPEOC_MEM_ECC_COR_ERR_CNT_S 0
#define IG3_PEOC8_GLPEOC_MEM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC8_GLPEOC_MEM_ECC_COR_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_MEM_ECC_UNCOR_ERR 0x429021B4
#define IG3_PEOC8_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PEOC8_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC8_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PEOC8_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PEOC8_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC8_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_OOISCFL_OBJOFST 0x429020B0
#define IG3_PEOC8_GLPEOC_OOISCFL_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_OOISCFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_OOISCFL_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_OOISC_OBJOFST 0x429020AC
#define IG3_PEOC8_GLPEOC_OOISC_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_OOISC_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_OOISC_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_PLIST_DBG_CTL 0x429021AC
#define IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_DONE_S 31
#define IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_DONE_S)
#define IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_RD_EN_S 30
#define IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_RD_EN_S)
#define IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_RSVD_S 26
#define IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_RSVD_S)
#define IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_DW_SEL_S)
#define IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_ADR_S 0
#define IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_PLIST_DBG_CTL_ADR_S)
#define IG3_PEOC8_GLPEOC_PLIST_DBG_DATA 0x429021B0
#define IG3_PEOC8_GLPEOC_PLIST_DBG_DATA_RD_DW_S 0
#define IG3_PEOC8_GLPEOC_PLIST_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_PLIST_DBG_DATA_RD_DW_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG 0x4290210C
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RSVD3_S 20
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RM_S 16
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RM_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RSVD2_S 14
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RME_S 12
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RME_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RSVD1_S 10
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_MEM_CFG_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS 0x42902110
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_RSVD0_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC8_GLPEOC_PMATINV_CFG 0x429020DC
#define IG3_PEOC8_GLPEOC_PMATINV_CFG_RSVD_S 6
#define IG3_PEOC8_GLPEOC_PMATINV_CFG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_PEOC8_GLPEOC_PMATINV_CFG_RSVD_S)
#define IG3_PEOC8_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S 5
#define IG3_PEOC8_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S)
#define IG3_PEOC8_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S 4
#define IG3_PEOC8_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PEOC8_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S 3
#define IG3_PEOC8_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S)
#define IG3_PEOC8_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S 2
#define IG3_PEOC8_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S)
#define IG3_PEOC8_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S 1
#define IG3_PEOC8_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PEOC8_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_S 0
#define IG3_PEOC8_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_S)
#define IG3_PEOC8_GLPEOC_Q1FL_OBJOFST 0x42902098
#define IG3_PEOC8_GLPEOC_Q1FL_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_Q1FL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_Q1FL_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_RRFL_OBJOFST 0x429020A8
#define IG3_PEOC8_GLPEOC_RRFL_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_RRFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_RRFL_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_RRF_OBJOFST 0x429020A4
#define IG3_PEOC8_GLPEOC_RRF_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_RRF_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_RRF_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_SRQCTX_OBJOFST 0x42902088
#define IG3_PEOC8_GLPEOC_SRQCTX_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_SRQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_SRQCTX_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_STAT_CTL 0x42902004
#define IG3_PEOC8_GLPEOC_STAT_CTL_RSVD_S 5
#define IG3_PEOC8_GLPEOC_STAT_CTL_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PEOC8_GLPEOC_STAT_CTL_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_CTL_OBJECT_TYPE_S 0
#define IG3_PEOC8_GLPEOC_STAT_CTL_OBJECT_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_STAT_CTL_OBJECT_TYPE_S)
#define IG3_PEOC8_GLPEOC_STAT_FENCING_TIME_HI 0x4290206C
#define IG3_PEOC8_GLPEOC_STAT_FENCING_TIME_HI_RSVD_S 24
#define IG3_PEOC8_GLPEOC_STAT_FENCING_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_FENCING_TIME_HI_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_S 0
#define IG3_PEOC8_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_S)
#define IG3_PEOC8_GLPEOC_STAT_FENCING_TIME_LO 0x42902068
#define IG3_PEOC8_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_STAT_MAX_PENDING_ENTRIES 0x4290204C
#define IG3_PEOC8_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_S 8
#define IG3_PEOC8_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_S 0
#define IG3_PEOC8_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_S)
#define IG3_PEOC8_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH 0x42902054
#define IG3_PEOC8_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S 8
#define IG3_PEOC8_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS 0x42902050
#define IG3_PEOC8_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S 8
#define IG3_PEOC8_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_STAT_OBJ_CNT 0x42902008
#define IG3_PEOC8_GLPEOC_STAT_OBJ_CNT_RSVD_S 14
#define IG3_PEOC8_GLPEOC_STAT_OBJ_CNT_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_STAT_OBJ_CNT_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_S 0
#define IG3_PEOC8_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PEOC8_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_S)
#define IG3_PEOC8_GLPEOC_STAT_PENDLING_LIST_FULL_HI 0x42902064
#define IG3_PEOC8_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S 24
#define IG3_PEOC8_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S 0
#define IG3_PEOC8_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S)
#define IG3_PEOC8_GLPEOC_STAT_PENDLING_LIST_FULL_LO 0x42902060
#define IG3_PEOC8_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_IDLE_HI 0x42902030
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_S 24
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_IDLE_LO 0x4290202C
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_XFER_HI 0x42902038
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_S 24
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_S)
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_XFER_LO 0x42902034
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_STAT_RD_HIT_HI 0x42902010
#define IG3_PEOC8_GLPEOC_STAT_RD_HIT_HI_RSVD_S 24
#define IG3_PEOC8_GLPEOC_STAT_RD_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_RD_HIT_HI_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_RD_HIT_HI_CNT_HI_S 0
#define IG3_PEOC8_GLPEOC_STAT_RD_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_RD_HIT_HI_CNT_HI_S)
#define IG3_PEOC8_GLPEOC_STAT_RD_HIT_LO 0x4290200C
#define IG3_PEOC8_GLPEOC_STAT_RD_HIT_LO_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_STAT_RD_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_STAT_RD_HIT_LO_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_STAT_RD_MISS_HI 0x42902018
#define IG3_PEOC8_GLPEOC_STAT_RD_MISS_HI_RSVD_S 24
#define IG3_PEOC8_GLPEOC_STAT_RD_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_RD_MISS_HI_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_RD_MISS_HI_CNT_HI_S 0
#define IG3_PEOC8_GLPEOC_STAT_RD_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_RD_MISS_HI_CNT_HI_S)
#define IG3_PEOC8_GLPEOC_STAT_RD_MISS_LO 0x42902014
#define IG3_PEOC8_GLPEOC_STAT_RD_MISS_LO_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_STAT_RD_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_STAT_RD_MISS_LO_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_STAT_REPLAY_TIME_HI 0x42902074
#define IG3_PEOC8_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_S 24
#define IG3_PEOC8_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_S 0
#define IG3_PEOC8_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_S)
#define IG3_PEOC8_GLPEOC_STAT_REPLAY_TIME_LO 0x42902070
#define IG3_PEOC8_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_BUFF_FULL_HI 0x4290205C
#define IG3_PEOC8_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_S 24
#define IG3_PEOC8_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S 0
#define IG3_PEOC8_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_BUFF_FULL_LO 0x42902058
#define IG3_PEOC8_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_IDLE_HI 0x42902040
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_S 24
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_IDLE_LO 0x4290203C
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_XFER_HI 0x42902048
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_S 24
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_XFER_LO 0x42902044
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_HIT_HI 0x42902020
#define IG3_PEOC8_GLPEOC_STAT_WR_HIT_HI_RSVD_S 24
#define IG3_PEOC8_GLPEOC_STAT_WR_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_WR_HIT_HI_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_HIT_HI_CNT_HI_S 0
#define IG3_PEOC8_GLPEOC_STAT_WR_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_WR_HIT_HI_CNT_HI_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_HIT_LO 0x4290201C
#define IG3_PEOC8_GLPEOC_STAT_WR_HIT_LO_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_STAT_WR_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_STAT_WR_HIT_LO_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_MISS_HI 0x42902028
#define IG3_PEOC8_GLPEOC_STAT_WR_MISS_HI_RSVD_S 24
#define IG3_PEOC8_GLPEOC_STAT_WR_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_STAT_WR_MISS_HI_RSVD_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_MISS_HI_CNT_HI_S 0
#define IG3_PEOC8_GLPEOC_STAT_WR_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_STAT_WR_MISS_HI_CNT_HI_S)
#define IG3_PEOC8_GLPEOC_STAT_WR_MISS_LO 0x42902024
#define IG3_PEOC8_GLPEOC_STAT_WR_MISS_LO_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_STAT_WR_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_STAT_WR_MISS_LO_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_TAG_DBG_CTL 0x42902164
#define IG3_PEOC8_GLPEOC_TAG_DBG_CTL_DONE_S 31
#define IG3_PEOC8_GLPEOC_TAG_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_DBG_CTL_DONE_S)
#define IG3_PEOC8_GLPEOC_TAG_DBG_CTL_RD_EN_S 30
#define IG3_PEOC8_GLPEOC_TAG_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_DBG_CTL_RD_EN_S)
#define IG3_PEOC8_GLPEOC_TAG_DBG_CTL_RSVD_S 26
#define IG3_PEOC8_GLPEOC_TAG_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_TAG_DBG_CTL_RSVD_S)
#define IG3_PEOC8_GLPEOC_TAG_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC8_GLPEOC_TAG_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_TAG_DBG_CTL_DW_SEL_S)
#define IG3_PEOC8_GLPEOC_TAG_DBG_CTL_ADR_S 0
#define IG3_PEOC8_GLPEOC_TAG_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_TAG_DBG_CTL_ADR_S)
#define IG3_PEOC8_GLPEOC_TAG_DBG_DATA 0x42902168
#define IG3_PEOC8_GLPEOC_TAG_DBG_DATA_RD_DW_S 0
#define IG3_PEOC8_GLPEOC_TAG_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_TAG_DBG_DATA_RD_DW_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG 0x429020FC
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RSVD3_S 20
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RM_S 16
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RM_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RSVD2_S 14
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RME_S 12
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RME_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RSVD1_S 10
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_MEM_CFG_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS 0x42902100
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_RSVD0_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC8_GLPEOC_TIMER_OBJOFST 0x4290209C
#define IG3_PEOC8_GLPEOC_TIMER_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_TIMER_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_TIMER_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_HI 0x429020F0
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_HI_RSVD_S 24
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_TOTAL_TAG_HI_RSVD_S)
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_HI_CNT_HI_S 0
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_TOTAL_TAG_HI_CNT_HI_S)
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_HIT_HI 0x429020F8
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_S 24
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_S)
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_S 0
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC8_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_S)
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_HIT_LO 0x429020F4
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_LO 0x429020EC
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_LO_CNT_LO_S 0
#define IG3_PEOC8_GLPEOC_TOTAL_TAG_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC8_GLPEOC_TOTAL_TAG_LO_CNT_LO_S)
#define IG3_PEOC8_GLPEOC_TXFIFO_OBJOFST 0x4290207C
#define IG3_PEOC8_GLPEOC_TXFIFO_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_TXFIFO_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_TXFIFO_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG 0x42902104
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RSVD3_S 20
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RSVD3_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RM_S 16
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RM_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RSVD2_S 14
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RSVD2_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RME_S 12
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RME_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RSVD1_S 10
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RSVD1_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RSVD0_S 6
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_RSVD0_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_MASK_INT_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_WRBUF_MEM_CFG_ECC_EN_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS 0x42902108
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_RSVD1_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_RSVD0_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC8_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC8_GLPEOC_XFFL_OBJOFST 0x42902094
#define IG3_PEOC8_GLPEOC_XFFL_OBJOFST_RSVD_S 10
#define IG3_PEOC8_GLPEOC_XFFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC8_GLPEOC_XFFL_OBJOFST_RSVD_S)
#define IG3_PEOC8_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC8_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC8_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_ARPTBLE_OBJOFST 0x42902478
#define IG3_PEOC9_GLPEOC_ARPTBLE_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_ARPTBLE_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_ARPTBLE_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_ARPTBLE_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_CACHESIZE 0x429024E0
#define IG3_PEOC9_GLPEOC_CACHESIZE_RSVD_S 24
#define IG3_PEOC9_GLPEOC_CACHESIZE_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHESIZE_RSVD_S)
#define IG3_PEOC9_GLPEOC_CACHESIZE_WAYS_S 20
#define IG3_PEOC9_GLPEOC_CACHESIZE_WAYS_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHESIZE_WAYS_S)
#define IG3_PEOC9_GLPEOC_CACHESIZE_SETS_S 8
#define IG3_PEOC9_GLPEOC_CACHESIZE_SETS_M RDMA_MASK3(32, 0xFFF, IG3_PEOC9_GLPEOC_CACHESIZE_SETS_S)
#define IG3_PEOC9_GLPEOC_CACHESIZE_WORD_SIZE_S 0
#define IG3_PEOC9_GLPEOC_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHESIZE_WORD_SIZE_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL 0x4290256C
#define IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_DONE_S 31
#define IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_RD_EN_S 30
#define IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_RD_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_RSVD_S 26
#define IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_RSVD_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_DW_SEL_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_ADR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_0_DBG_CTL_ADR_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_DBG_DATA 0x42902570
#define IG3_PEOC9_GLPEOC_CACHE_0_DBG_DATA_RD_DW_S 0
#define IG3_PEOC9_GLPEOC_CACHE_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_CACHE_0_DBG_DATA_RD_DW_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG 0x42902524
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RSVD3_S 20
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RM_S 16
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RM_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RSVD2_S 14
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RME_S 12
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RME_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RSVD1_S 10
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_MEM_CFG_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS 0x42902528
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_0_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL 0x42902574
#define IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_DONE_S 31
#define IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_RD_EN_S 30
#define IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_RD_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_RSVD_S 26
#define IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_RSVD_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_DW_SEL_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_ADR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_1_DBG_CTL_ADR_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_DBG_DATA 0x42902578
#define IG3_PEOC9_GLPEOC_CACHE_1_DBG_DATA_RD_DW_S 0
#define IG3_PEOC9_GLPEOC_CACHE_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_CACHE_1_DBG_DATA_RD_DW_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG 0x4290252C
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RSVD3_S 20
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RM_S 16
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RM_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RSVD2_S 14
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RME_S 12
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RME_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RSVD1_S 10
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_MEM_CFG_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS 0x42902530
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_1_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL 0x4290257C
#define IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_DONE_S 31
#define IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_RD_EN_S 30
#define IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_RD_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_RSVD_S 26
#define IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_RSVD_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_DW_SEL_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_ADR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_2_DBG_CTL_ADR_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_DBG_DATA 0x42902580
#define IG3_PEOC9_GLPEOC_CACHE_2_DBG_DATA_RD_DW_S 0
#define IG3_PEOC9_GLPEOC_CACHE_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_CACHE_2_DBG_DATA_RD_DW_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG 0x42902534
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RSVD3_S 20
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RM_S 16
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RM_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RSVD2_S 14
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RME_S 12
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RME_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RSVD1_S 10
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_MEM_CFG_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS 0x42902538
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_2_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL 0x42902584
#define IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_DONE_S 31
#define IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_RD_EN_S 30
#define IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_RD_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_RSVD_S 26
#define IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_RSVD_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_DW_SEL_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_ADR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_3_DBG_CTL_ADR_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_DBG_DATA 0x42902588
#define IG3_PEOC9_GLPEOC_CACHE_3_DBG_DATA_RD_DW_S 0
#define IG3_PEOC9_GLPEOC_CACHE_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_CACHE_3_DBG_DATA_RD_DW_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG 0x4290253C
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RSVD3_S 20
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RM_S 16
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RM_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RSVD2_S 14
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RME_S 12
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RME_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RSVD1_S 10
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_MEM_CFG_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS 0x42902540
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_3_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL 0x4290258C
#define IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_DONE_S 31
#define IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_RD_EN_S 30
#define IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_RD_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_RSVD_S 26
#define IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_RSVD_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_DW_SEL_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_ADR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_4_DBG_CTL_ADR_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_DBG_DATA 0x42902590
#define IG3_PEOC9_GLPEOC_CACHE_4_DBG_DATA_RD_DW_S 0
#define IG3_PEOC9_GLPEOC_CACHE_4_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_CACHE_4_DBG_DATA_RD_DW_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG 0x42902544
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RSVD3_S 20
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RM_S 16
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RM_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RSVD2_S 14
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RME_S 12
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RME_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RSVD1_S 10
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_MEM_CFG_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS 0x42902548
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_4_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL 0x42902594
#define IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_DONE_S 31
#define IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_RD_EN_S 30
#define IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_RD_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_RSVD_S 26
#define IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_RSVD_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_DW_SEL_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_ADR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_5_DBG_CTL_ADR_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_DBG_DATA 0x42902598
#define IG3_PEOC9_GLPEOC_CACHE_5_DBG_DATA_RD_DW_S 0
#define IG3_PEOC9_GLPEOC_CACHE_5_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_CACHE_5_DBG_DATA_RD_DW_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG 0x4290254C
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RSVD3_S 20
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RM_S 16
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RM_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RSVD2_S 14
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RME_S 12
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RME_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RSVD1_S 10
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_MEM_CFG_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS 0x42902550
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_5_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL 0x4290259C
#define IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_DONE_S 31
#define IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_RD_EN_S 30
#define IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_RD_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_RSVD_S 26
#define IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_RSVD_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_DW_SEL_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_ADR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_6_DBG_CTL_ADR_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_DBG_DATA 0x429025A0
#define IG3_PEOC9_GLPEOC_CACHE_6_DBG_DATA_RD_DW_S 0
#define IG3_PEOC9_GLPEOC_CACHE_6_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_CACHE_6_DBG_DATA_RD_DW_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG 0x42902554
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RSVD3_S 20
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RM_S 16
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RM_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RSVD2_S 14
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RME_S 12
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RME_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RSVD1_S 10
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_MEM_CFG_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS 0x42902558
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_6_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL 0x429025A4
#define IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_DONE_S 31
#define IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_RD_EN_S 30
#define IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_RD_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_RSVD_S 26
#define IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_RSVD_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_DW_SEL_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_ADR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_7_DBG_CTL_ADR_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_DBG_DATA 0x429025A8
#define IG3_PEOC9_GLPEOC_CACHE_7_DBG_DATA_RD_DW_S 0
#define IG3_PEOC9_GLPEOC_CACHE_7_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_CACHE_7_DBG_DATA_RD_DW_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG 0x4290255C
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RSVD3_S 20
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RM_S 16
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RM_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RSVD2_S 14
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RME_S 12
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RME_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RSVD1_S 10
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_MEM_CFG_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS 0x42902560
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CACHE_7_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC9_GLPEOC_CACHE_CTRL 0x42902400
#define IG3_PEOC9_GLPEOC_CACHE_CTRL_RSVD_S 2
#define IG3_PEOC9_GLPEOC_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_PEOC9_GLPEOC_CACHE_CTRL_RSVD_S)
#define IG3_PEOC9_GLPEOC_CACHE_CTRL_SCALE_FACTOR_S 0
#define IG3_PEOC9_GLPEOC_CACHE_CTRL_SCALE_FACTOR_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_CACHE_CTRL_SCALE_FACTOR_S)
#define IG3_PEOC9_GLPEOC_CECC_ERR 0x429024D0
#define IG3_PEOC9_GLPEOC_CECC_ERR_RSVD1_S 28
#define IG3_PEOC9_GLPEOC_CECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CECC_ERR_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PEOC9_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC9_GLPEOC_CECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_CECC_ERR_RSVD0_S 12
#define IG3_PEOC9_GLPEOC_CECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_CECC_ERR_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PEOC9_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC9_GLPEOC_CECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_CQCTX_OBJOFST 0x42902484
#define IG3_PEOC9_GLPEOC_CQCTX_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_CQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_CQCTX_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_CQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_CSTATELKUP_CFG 0x429024D8
#define IG3_PEOC9_GLPEOC_CSTATELKUP_CFG_RSVD1_S 9
#define IG3_PEOC9_GLPEOC_CSTATELKUP_CFG_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PEOC9_GLPEOC_CSTATELKUP_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S 8
#define IG3_PEOC9_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_CSTATELKUP_CFG_LKUP_REPLAY_ON_PEND_CLR_S)
#define IG3_PEOC9_GLPEOC_CSTATELKUP_CFG_RSVD0_S 3
#define IG3_PEOC9_GLPEOC_CSTATELKUP_CFG_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_CSTATELKUP_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S 0
#define IG3_PEOC9_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_M RDMA_MASK3(32, 0x7, IG3_PEOC9_GLPEOC_CSTATELKUP_CFG_LKUP_RATE_LIMIT_WTCYCLES_S)
#define IG3_PEOC9_GLPEOC_DPC_COMP 0x429024E8
#define IG3_PEOC9_GLPEOC_DPC_COMP_RSVD_S 13
#define IG3_PEOC9_GLPEOC_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_PEOC9_GLPEOC_DPC_COMP_RSVD_S)
#define IG3_PEOC9_GLPEOC_DPC_COMP_COMP_FTYPE_S 11
#define IG3_PEOC9_GLPEOC_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_DPC_COMP_COMP_FTYPE_S)
#define IG3_PEOC9_GLPEOC_DPC_COMP_COMP_FNUM_S 1
#define IG3_PEOC9_GLPEOC_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_DPC_COMP_COMP_FNUM_S)
#define IG3_PEOC9_GLPEOC_DPC_COMP_COMP_VALID_S 0
#define IG3_PEOC9_GLPEOC_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DPC_COMP_COMP_VALID_S)
#define IG3_PEOC9_GLPEOC_DPC_REQ 0x429024E4
#define IG3_PEOC9_GLPEOC_DPC_REQ_RSVD_S 12
#define IG3_PEOC9_GLPEOC_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC9_GLPEOC_DPC_REQ_RSVD_S)
#define IG3_PEOC9_GLPEOC_DPC_REQ_REQ_FTYPE_S 10
#define IG3_PEOC9_GLPEOC_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_DPC_REQ_REQ_FTYPE_S)
#define IG3_PEOC9_GLPEOC_DPC_REQ_REQ_FNUM_S 0
#define IG3_PEOC9_GLPEOC_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_DPC_REQ_REQ_FNUM_S)
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_COUNT 0x42902638
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC9_GLPEOC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC9_GLPEOC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_CMD 0x4290264C
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_DATA_H 0x42902658
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_DATA_L 0x42902654
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_PTR 0x42902650
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC9_GLPEOC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_CMD 0x4290263C
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_DATA_H 0x42902648
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_DATA_L 0x42902644
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_PTR 0x42902640
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC9_GLPEOC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_CONTROL 0x42902600
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_RSVD1_S 25
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_DTM_CONTROL_RSVD1_S)
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_RSVD2_S 17
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_DTM_CONTROL_RSVD2_S)
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_RSVD3_S 9
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_DTM_CONTROL_RSVD3_S)
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_BYPASS_S 8
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_CONTROL_BYPASS_S)
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_RSVD4_S 1
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_DTM_CONTROL_RSVD4_S)
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PEOC9_GLPEOC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PEOC9_GLPEOC_DTM_ECC_COR_ERR 0x42902668
#define IG3_PEOC9_GLPEOC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PEOC9_GLPEOC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC9_GLPEOC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PEOC9_GLPEOC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PEOC9_GLPEOC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC9_GLPEOC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_DTM_ECC_UNCOR_ERR 0x42902664
#define IG3_PEOC9_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PEOC9_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC9_GLPEOC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PEOC9_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PEOC9_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC9_GLPEOC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_DTM_GROUP_CFG 0x4290260C
#define IG3_PEOC9_GLPEOC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PEOC9_GLPEOC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PEOC9_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PEOC9_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PEOC9_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PEOC9_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PEOC9_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PEOC9_GLPEOC_DTM_LOG_CFG 0x42902610
#define IG3_PEOC9_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PEOC9_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PEOC9_GLPEOC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PEOC9_GLPEOC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PEOC9_GLPEOC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PEOC9_GLPEOC_DTM_LOG_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_DTM_LOG_CFG_MODE_S 0
#define IG3_PEOC9_GLPEOC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_DTM_LOG_CFG_MODE_S)
#define IG3_PEOC9_GLPEOC_DTM_LOG_MASK 0x42902618
#define IG3_PEOC9_GLPEOC_DTM_LOG_MASK_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_DTM_LOG_MASK_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_LOG_PATTERN 0x42902614
#define IG3_PEOC9_GLPEOC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_MAIN_CFG 0x42902604
#define IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PEOC9_GLPEOC_DTM_MAIN_STS 0x42902608
#define IG3_PEOC9_GLPEOC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PEOC9_GLPEOC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PEOC9_GLPEOC_DTM_MAIN_STS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PEOC9_GLPEOC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PEOC9_GLPEOC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PEOC9_GLPEOC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_DTM_MAIN_STS_RSVD2_S)
#define IG3_PEOC9_GLPEOC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PEOC9_GLPEOC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PEOC9_GLPEOC_DTM_TIMESTAMP 0x42902630
#define IG3_PEOC9_GLPEOC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_DTM_TIMESTAMP_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_TIMESTAMP_ROLLOVER 0x42902634
#define IG3_PEOC9_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG 0x4290265C
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS 0x42902660
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PEOC9_GLPEOC_DTM_TRIG_CFG 0x4290261C
#define IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_MODE_S 0
#define IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_DTM_TRIG_CFG_MODE_S)
#define IG3_PEOC9_GLPEOC_DTM_TRIG_COUNT 0x42902628
#define IG3_PEOC9_GLPEOC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_TRIG_MASK 0x42902624
#define IG3_PEOC9_GLPEOC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_DTM_TRIG_MASK_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_TRIG_PATTERN 0x42902620
#define IG3_PEOC9_GLPEOC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PEOC9_GLPEOC_DTM_TRIG_TIMESTAMP 0x4290262C
#define IG3_PEOC9_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PEOC9_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PEOC9_GLPEOC_ECC_CTL 0x429024C8
#define IG3_PEOC9_GLPEOC_ECC_CTL_RSVD_S 8
#define IG3_PEOC9_GLPEOC_ECC_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_ECC_CTL_RSVD_S)
#define IG3_PEOC9_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_S 7
#define IG3_PEOC9_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT2_S)
#define IG3_PEOC9_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_S 6
#define IG3_PEOC9_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_ECC_CTL_CLIENT_ECC_INVERT1_S)
#define IG3_PEOC9_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_ECC_CTL_CLIENT_ECC_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_ECC_CTL_CLIENT_ECC_EN_S 4
#define IG3_PEOC9_GLPEOC_ECC_CTL_CLIENT_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_ECC_CTL_CLIENT_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_S 3
#define IG3_PEOC9_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_ECC_CTL_HOST_ECC_INVERT2_S)
#define IG3_PEOC9_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_S 2
#define IG3_PEOC9_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_ECC_CTL_HOST_ECC_INVERT1_S)
#define IG3_PEOC9_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_S 1
#define IG3_PEOC9_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_ECC_CTL_HOST_ECC_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_ECC_CTL_HOST_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_ECC_CTL_HOST_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_ECC_CTL_HOST_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_ERRDATA0 0x429024B8
#define IG3_PEOC9_GLPEOC_ERRDATA0_RSVD1_S 31
#define IG3_PEOC9_GLPEOC_ERRDATA0_RSVD1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_ERRDATA0_RSVD1_S)
#define IG3_PEOC9_GLPEOC_ERRDATA0_PF_NUM_S 25
#define IG3_PEOC9_GLPEOC_ERRDATA0_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PEOC9_GLPEOC_ERRDATA0_PF_NUM_S)
#define IG3_PEOC9_GLPEOC_ERRDATA0_VDEV_VF_NUM_S 15
#define IG3_PEOC9_GLPEOC_ERRDATA0_VDEV_VF_NUM_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_ERRDATA0_VDEV_VF_NUM_S)
#define IG3_PEOC9_GLPEOC_ERRDATA0_VDEV_VF_TYPE_S 13
#define IG3_PEOC9_GLPEOC_ERRDATA0_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_ERRDATA0_VDEV_VF_TYPE_S)
#define IG3_PEOC9_GLPEOC_ERRDATA0_OBJ_TYPE_S 8
#define IG3_PEOC9_GLPEOC_ERRDATA0_OBJ_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_ERRDATA0_OBJ_TYPE_S)
#define IG3_PEOC9_GLPEOC_ERRDATA0_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_ERRDATA0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_ERRDATA0_RSVD0_S)
#define IG3_PEOC9_GLPEOC_ERRDATA0_ERROR_CODE_S 0
#define IG3_PEOC9_GLPEOC_ERRDATA0_ERROR_CODE_M RDMA_MASK3(32, 0x3F, IG3_PEOC9_GLPEOC_ERRDATA0_ERROR_CODE_S)
#define IG3_PEOC9_GLPEOC_ERRDATA1 0x429024BC
#define IG3_PEOC9_GLPEOC_ERRDATA1_RSVD_S 28
#define IG3_PEOC9_GLPEOC_ERRDATA1_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_ERRDATA1_RSVD_S)
#define IG3_PEOC9_GLPEOC_ERRDATA1_OBJ_INDEX_S 0
#define IG3_PEOC9_GLPEOC_ERRDATA1_OBJ_INDEX_M RDMA_MASK3(32, 0xFFFFFFF, IG3_PEOC9_GLPEOC_ERRDATA1_OBJ_INDEX_S)
#define IG3_PEOC9_GLPEOC_ERRDATA2 0x429024C0
#define IG3_PEOC9_GLPEOC_ERRDATA2_RSVD_S 23
#define IG3_PEOC9_GLPEOC_ERRDATA2_RSVD_M RDMA_MASK3(32, 0x1FF, IG3_PEOC9_GLPEOC_ERRDATA2_RSVD_S)
#define IG3_PEOC9_GLPEOC_ERRDATA2_OPTYPE_S 20
#define IG3_PEOC9_GLPEOC_ERRDATA2_OPTYPE_M RDMA_MASK3(32, 0x7, IG3_PEOC9_GLPEOC_ERRDATA2_OPTYPE_S)
#define IG3_PEOC9_GLPEOC_ERRDATA2_OFFSET_S 7
#define IG3_PEOC9_GLPEOC_ERRDATA2_OFFSET_M RDMA_MASK3(32, 0x1FFF, IG3_PEOC9_GLPEOC_ERRDATA2_OFFSET_S)
#define IG3_PEOC9_GLPEOC_ERRDATA2_LENGTH_S 0
#define IG3_PEOC9_GLPEOC_ERRDATA2_LENGTH_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_ERRDATA2_LENGTH_S)
#define IG3_PEOC9_GLPEOC_ERRDATA3 0x429024C4
#define IG3_PEOC9_GLPEOC_ERRDATA3_RSVD_S 15
#define IG3_PEOC9_GLPEOC_ERRDATA3_RSVD_M RDMA_MASK3(32, 0x1FFFF, IG3_PEOC9_GLPEOC_ERRDATA3_RSVD_S)
#define IG3_PEOC9_GLPEOC_ERRDATA3_TAG_S 0
#define IG3_PEOC9_GLPEOC_ERRDATA3_TAG_M RDMA_MASK3(32, 0x7FFF, IG3_PEOC9_GLPEOC_ERRDATA3_TAG_S)
#define IG3_PEOC9_GLPEOC_ERRINFO 0x429024B4
#define IG3_PEOC9_GLPEOC_ERRINFO_RSVD1_S 16
#define IG3_PEOC9_GLPEOC_ERRINFO_RSVD1_M RDMA_MASK3(32, 0xFFFF, IG3_PEOC9_GLPEOC_ERRINFO_RSVD1_S)
#define IG3_PEOC9_GLPEOC_ERRINFO_ERROR_CNT_S 8
#define IG3_PEOC9_GLPEOC_ERRINFO_ERROR_CNT_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_ERRINFO_ERROR_CNT_S)
#define IG3_PEOC9_GLPEOC_ERRINFO_RSVD0_S 1
#define IG3_PEOC9_GLPEOC_ERRINFO_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_ERRINFO_RSVD0_S)
#define IG3_PEOC9_GLPEOC_ERRINFO_ERROR_VALID_S 0
#define IG3_PEOC9_GLPEOC_ERRINFO_ERROR_VALID_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_ERRINFO_ERROR_VALID_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG 0x4290251C
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RSVD3_S 20
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RM_S 16
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RM_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RSVD2_S 14
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RME_S 12
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RME_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RSVD1_S 10
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_EVICT_MEM_CFG_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS 0x42902520
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_RSVD0_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_EVICT_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG 0x42902514
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RSVD3_S 20
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RM_S 16
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RM_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RSVD2_S 14
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RME_S 12
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RME_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RSVD1_S 10
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_FILL_MEM_CFG_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS 0x42902518
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_RSVD0_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_FILL_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC9_GLPEOC_FSIADR_OBJOFST 0x4290248C
#define IG3_PEOC9_GLPEOC_FSIADR_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_FSIADR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_FSIADR_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_FSIADR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_FSIMCAST_OBJOFST 0x42902490
#define IG3_PEOC9_GLPEOC_FSIMCAST_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_FSIMCAST_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_FSIMCAST_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_FSIMCAST_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_HDR_OBJOFST 0x429024A0
#define IG3_PEOC9_GLPEOC_HDR_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_HDR_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_HDR_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_HDR_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_HECC_ERR 0x429024CC
#define IG3_PEOC9_GLPEOC_HECC_ERR_RSVD1_S 28
#define IG3_PEOC9_GLPEOC_HECC_ERR_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_HECC_ERR_RSVD1_S)
#define IG3_PEOC9_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_S 16
#define IG3_PEOC9_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC9_GLPEOC_HECC_ERR_COR_ECC_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_HECC_ERR_RSVD0_S 12
#define IG3_PEOC9_GLPEOC_HECC_ERR_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_HECC_ERR_RSVD0_S)
#define IG3_PEOC9_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S 0
#define IG3_PEOC9_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC9_GLPEOC_HECC_ERR_UNCOR_ECC_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_IRRQ_OBJOFST 0x42902480
#define IG3_PEOC9_GLPEOC_IRRQ_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_IRRQ_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_IRRQ_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_IRRQ_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_MAXOSR 0x429024D4
#define IG3_PEOC9_GLPEOC_MAXOSR_RSVD1_S 15
#define IG3_PEOC9_GLPEOC_MAXOSR_RSVD1_M RDMA_MASK3(32, 0x1FFFF, IG3_PEOC9_GLPEOC_MAXOSR_RSVD1_S)
#define IG3_PEOC9_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S 10
#define IG3_PEOC9_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_MAXOSR_MAX_OSR_CLNT_WRPULL_S)
#define IG3_PEOC9_GLPEOC_MAXOSR_RSVD0_S 8
#define IG3_PEOC9_GLPEOC_MAXOSR_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_MAXOSR_RSVD0_S)
#define IG3_PEOC9_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_S 0
#define IG3_PEOC9_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_MAXOSR_MAX_OSR_PMAT_FETCH_S)
#define IG3_PEOC9_GLPEOC_MEM_ECC_COR_ERR 0x429025B8
#define IG3_PEOC9_GLPEOC_MEM_ECC_COR_ERR_RSVD_S 12
#define IG3_PEOC9_GLPEOC_MEM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC9_GLPEOC_MEM_ECC_COR_ERR_RSVD_S)
#define IG3_PEOC9_GLPEOC_MEM_ECC_COR_ERR_CNT_S 0
#define IG3_PEOC9_GLPEOC_MEM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC9_GLPEOC_MEM_ECC_COR_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_MEM_ECC_UNCOR_ERR 0x429025B4
#define IG3_PEOC9_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PEOC9_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PEOC9_GLPEOC_MEM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PEOC9_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PEOC9_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PEOC9_GLPEOC_MEM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_OOISCFL_OBJOFST 0x429024B0
#define IG3_PEOC9_GLPEOC_OOISCFL_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_OOISCFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_OOISCFL_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_OOISCFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_OOISC_OBJOFST 0x429024AC
#define IG3_PEOC9_GLPEOC_OOISC_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_OOISC_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_OOISC_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_OOISC_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_PLIST_DBG_CTL 0x429025AC
#define IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_DONE_S 31
#define IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_DONE_S)
#define IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_RD_EN_S 30
#define IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_RD_EN_S)
#define IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_RSVD_S 26
#define IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_RSVD_S)
#define IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_DW_SEL_S)
#define IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_ADR_S 0
#define IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_PLIST_DBG_CTL_ADR_S)
#define IG3_PEOC9_GLPEOC_PLIST_DBG_DATA 0x429025B0
#define IG3_PEOC9_GLPEOC_PLIST_DBG_DATA_RD_DW_S 0
#define IG3_PEOC9_GLPEOC_PLIST_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_PLIST_DBG_DATA_RD_DW_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG 0x4290250C
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RSVD3_S 20
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RM_S 16
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RM_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RSVD2_S 14
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RME_S 12
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RME_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RSVD1_S 10
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_MEM_CFG_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS 0x42902510
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_RSVD0_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PLIST_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC9_GLPEOC_PMATINV_CFG 0x429024DC
#define IG3_PEOC9_GLPEOC_PMATINV_CFG_RSVD_S 6
#define IG3_PEOC9_GLPEOC_PMATINV_CFG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_PEOC9_GLPEOC_PMATINV_CFG_RSVD_S)
#define IG3_PEOC9_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S 5
#define IG3_PEOC9_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PMATINV_CFG_WBINVBYPRNTANDFN_FENCE_EN_S)
#define IG3_PEOC9_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S 4
#define IG3_PEOC9_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PMATINV_CFG_WBINVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PEOC9_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S 3
#define IG3_PEOC9_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PMATINV_CFG_WBINVBYFN_FENCE_EN_S)
#define IG3_PEOC9_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S 2
#define IG3_PEOC9_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PMATINV_CFG_WBINVBYOBJ_FENCE_EN_S)
#define IG3_PEOC9_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S 1
#define IG3_PEOC9_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PMATINV_CFG_INVBYTYPEANDFN_FENCE_EN_S)
#define IG3_PEOC9_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_S 0
#define IG3_PEOC9_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_PMATINV_CFG_INVBYFN_FENCE_EN_S)
#define IG3_PEOC9_GLPEOC_Q1FL_OBJOFST 0x42902498
#define IG3_PEOC9_GLPEOC_Q1FL_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_Q1FL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_Q1FL_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_Q1FL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_RRFL_OBJOFST 0x429024A8
#define IG3_PEOC9_GLPEOC_RRFL_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_RRFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_RRFL_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_RRFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_RRF_OBJOFST 0x429024A4
#define IG3_PEOC9_GLPEOC_RRF_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_RRF_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_RRF_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_RRF_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_SRQCTX_OBJOFST 0x42902488
#define IG3_PEOC9_GLPEOC_SRQCTX_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_SRQCTX_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_SRQCTX_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_SRQCTX_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_STAT_CTL 0x42902404
#define IG3_PEOC9_GLPEOC_STAT_CTL_RSVD_S 5
#define IG3_PEOC9_GLPEOC_STAT_CTL_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_PEOC9_GLPEOC_STAT_CTL_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_CTL_OBJECT_TYPE_S 0
#define IG3_PEOC9_GLPEOC_STAT_CTL_OBJECT_TYPE_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_STAT_CTL_OBJECT_TYPE_S)
#define IG3_PEOC9_GLPEOC_STAT_FENCING_TIME_HI 0x4290246C
#define IG3_PEOC9_GLPEOC_STAT_FENCING_TIME_HI_RSVD_S 24
#define IG3_PEOC9_GLPEOC_STAT_FENCING_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_FENCING_TIME_HI_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_S 0
#define IG3_PEOC9_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_FENCING_TIME_HI_CNT_HI_S)
#define IG3_PEOC9_GLPEOC_STAT_FENCING_TIME_LO 0x42902468
#define IG3_PEOC9_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_STAT_FENCING_TIME_LO_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_STAT_MAX_PENDING_ENTRIES 0x4290244C
#define IG3_PEOC9_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_S 8
#define IG3_PEOC9_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_MAX_PENDING_ENTRIES_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_S 0
#define IG3_PEOC9_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_MAX_PENDING_ENTRIES_CNT_S)
#define IG3_PEOC9_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH 0x42902454
#define IG3_PEOC9_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S 8
#define IG3_PEOC9_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_MAX_PENDING_LIST_DEPTH_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS 0x42902450
#define IG3_PEOC9_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S 8
#define IG3_PEOC9_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_MAX_VIRT_PENDING_LISTS_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_STAT_OBJ_CNT 0x42902408
#define IG3_PEOC9_GLPEOC_STAT_OBJ_CNT_RSVD_S 14
#define IG3_PEOC9_GLPEOC_STAT_OBJ_CNT_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_STAT_OBJ_CNT_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_S 0
#define IG3_PEOC9_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_M RDMA_MASK3(32, 0x3FFF, IG3_PEOC9_GLPEOC_STAT_OBJ_CNT_OBJECT_COUNT_S)
#define IG3_PEOC9_GLPEOC_STAT_PENDLING_LIST_FULL_HI 0x42902464
#define IG3_PEOC9_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S 24
#define IG3_PEOC9_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_PENDLING_LIST_FULL_HI_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S 0
#define IG3_PEOC9_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_PENDLING_LIST_FULL_HI_CNT_HI_S)
#define IG3_PEOC9_GLPEOC_STAT_PENDLING_LIST_FULL_LO 0x42902460
#define IG3_PEOC9_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_STAT_PENDLING_LIST_FULL_LO_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_IDLE_HI 0x42902430
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_S 24
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_RD_DATA_IDLE_HI_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_RD_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_IDLE_LO 0x4290242C
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_STAT_RD_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_XFER_HI 0x42902438
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_S 24
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_RD_DATA_XFER_HI_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_RD_DATA_XFER_HI_CNT_HI_S)
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_XFER_LO 0x42902434
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_STAT_RD_DATA_XFER_LO_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_STAT_RD_HIT_HI 0x42902410
#define IG3_PEOC9_GLPEOC_STAT_RD_HIT_HI_RSVD_S 24
#define IG3_PEOC9_GLPEOC_STAT_RD_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_RD_HIT_HI_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_RD_HIT_HI_CNT_HI_S 0
#define IG3_PEOC9_GLPEOC_STAT_RD_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_RD_HIT_HI_CNT_HI_S)
#define IG3_PEOC9_GLPEOC_STAT_RD_HIT_LO 0x4290240C
#define IG3_PEOC9_GLPEOC_STAT_RD_HIT_LO_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_STAT_RD_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_STAT_RD_HIT_LO_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_STAT_RD_MISS_HI 0x42902418
#define IG3_PEOC9_GLPEOC_STAT_RD_MISS_HI_RSVD_S 24
#define IG3_PEOC9_GLPEOC_STAT_RD_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_RD_MISS_HI_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_RD_MISS_HI_CNT_HI_S 0
#define IG3_PEOC9_GLPEOC_STAT_RD_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_RD_MISS_HI_CNT_HI_S)
#define IG3_PEOC9_GLPEOC_STAT_RD_MISS_LO 0x42902414
#define IG3_PEOC9_GLPEOC_STAT_RD_MISS_LO_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_STAT_RD_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_STAT_RD_MISS_LO_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_STAT_REPLAY_TIME_HI 0x42902474
#define IG3_PEOC9_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_S 24
#define IG3_PEOC9_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_REPLAY_TIME_HI_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_S 0
#define IG3_PEOC9_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_REPLAY_TIME_HI_CNT_HI_S)
#define IG3_PEOC9_GLPEOC_STAT_REPLAY_TIME_LO 0x42902470
#define IG3_PEOC9_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_STAT_REPLAY_TIME_LO_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_BUFF_FULL_HI 0x4290245C
#define IG3_PEOC9_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_S 24
#define IG3_PEOC9_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_WR_BUFF_FULL_HI_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S 0
#define IG3_PEOC9_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_WR_BUFF_FULL_HI_CNT_HI_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_BUFF_FULL_LO 0x42902458
#define IG3_PEOC9_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_STAT_WR_BUFF_FULL_LO_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_IDLE_HI 0x42902440
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_S 24
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_WR_DATA_IDLE_HI_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S 0
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_WR_DATA_IDLE_HI_CNT_HI_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_IDLE_LO 0x4290243C
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_STAT_WR_DATA_IDLE_LO_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_XFER_HI 0x42902448
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_S 24
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_WR_DATA_XFER_HI_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_S 0
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_WR_DATA_XFER_HI_CNT_HI_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_XFER_LO 0x42902444
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_STAT_WR_DATA_XFER_LO_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_HIT_HI 0x42902420
#define IG3_PEOC9_GLPEOC_STAT_WR_HIT_HI_RSVD_S 24
#define IG3_PEOC9_GLPEOC_STAT_WR_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_WR_HIT_HI_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_HIT_HI_CNT_HI_S 0
#define IG3_PEOC9_GLPEOC_STAT_WR_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_WR_HIT_HI_CNT_HI_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_HIT_LO 0x4290241C
#define IG3_PEOC9_GLPEOC_STAT_WR_HIT_LO_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_STAT_WR_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_STAT_WR_HIT_LO_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_MISS_HI 0x42902428
#define IG3_PEOC9_GLPEOC_STAT_WR_MISS_HI_RSVD_S 24
#define IG3_PEOC9_GLPEOC_STAT_WR_MISS_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_STAT_WR_MISS_HI_RSVD_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_MISS_HI_CNT_HI_S 0
#define IG3_PEOC9_GLPEOC_STAT_WR_MISS_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_STAT_WR_MISS_HI_CNT_HI_S)
#define IG3_PEOC9_GLPEOC_STAT_WR_MISS_LO 0x42902424
#define IG3_PEOC9_GLPEOC_STAT_WR_MISS_LO_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_STAT_WR_MISS_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_STAT_WR_MISS_LO_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_TAG_DBG_CTL 0x42902564
#define IG3_PEOC9_GLPEOC_TAG_DBG_CTL_DONE_S 31
#define IG3_PEOC9_GLPEOC_TAG_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_DBG_CTL_DONE_S)
#define IG3_PEOC9_GLPEOC_TAG_DBG_CTL_RD_EN_S 30
#define IG3_PEOC9_GLPEOC_TAG_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_DBG_CTL_RD_EN_S)
#define IG3_PEOC9_GLPEOC_TAG_DBG_CTL_RSVD_S 26
#define IG3_PEOC9_GLPEOC_TAG_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_TAG_DBG_CTL_RSVD_S)
#define IG3_PEOC9_GLPEOC_TAG_DBG_CTL_DW_SEL_S 18
#define IG3_PEOC9_GLPEOC_TAG_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_TAG_DBG_CTL_DW_SEL_S)
#define IG3_PEOC9_GLPEOC_TAG_DBG_CTL_ADR_S 0
#define IG3_PEOC9_GLPEOC_TAG_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_TAG_DBG_CTL_ADR_S)
#define IG3_PEOC9_GLPEOC_TAG_DBG_DATA 0x42902568
#define IG3_PEOC9_GLPEOC_TAG_DBG_DATA_RD_DW_S 0
#define IG3_PEOC9_GLPEOC_TAG_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_TAG_DBG_DATA_RD_DW_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG 0x429024FC
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RSVD3_S 20
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RM_S 16
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RM_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RSVD2_S 14
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RME_S 12
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RME_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RSVD1_S 10
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_MEM_CFG_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS 0x42902500
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_RSVD0_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC9_GLPEOC_TIMER_OBJOFST 0x4290249C
#define IG3_PEOC9_GLPEOC_TIMER_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_TIMER_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_TIMER_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_TIMER_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_HI 0x429024F0
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_HI_RSVD_S 24
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_TOTAL_TAG_HI_RSVD_S)
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_HI_CNT_HI_S 0
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_TOTAL_TAG_HI_CNT_HI_S)
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_HIT_HI 0x429024F8
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_S 24
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_TOTAL_TAG_HIT_HI_RSVD_S)
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_S 0
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_M RDMA_MASK3(32, 0xFFFFFF, IG3_PEOC9_GLPEOC_TOTAL_TAG_HIT_HI_CNT_HI_S)
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_HIT_LO 0x429024F4
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_TOTAL_TAG_HIT_LO_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_LO 0x429024EC
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_LO_CNT_LO_S 0
#define IG3_PEOC9_GLPEOC_TOTAL_TAG_LO_CNT_LO_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PEOC9_GLPEOC_TOTAL_TAG_LO_CNT_LO_S)
#define IG3_PEOC9_GLPEOC_TXFIFO_OBJOFST 0x4290247C
#define IG3_PEOC9_GLPEOC_TXFIFO_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_TXFIFO_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_TXFIFO_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_TXFIFO_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG 0x42902504
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RSVD3_S 20
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RSVD3_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RM_S 16
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RM_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RSVD2_S 14
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RSVD2_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RME_S 12
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RME_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RSVD1_S 10
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RSVD1_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ERR_CNT_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_FIX_CNT_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RSVD0_S 6
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_RSVD0_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_MASK_INT_S 5
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_MASK_INT_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_LS_FORCE_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ECC_EN_S 0
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_WRBUF_MEM_CFG_ECC_EN_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS 0x42902508
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_RSVD1_S 30
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_RSVD1_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_RSVD0_S 4
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_RSVD0_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PEOC9_GLPEOC_WRBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_PEOC9_GLPEOC_XFFL_OBJOFST 0x42902494
#define IG3_PEOC9_GLPEOC_XFFL_OBJOFST_RSVD_S 10
#define IG3_PEOC9_GLPEOC_XFFL_OBJOFST_RSVD_M RDMA_MASK3(32, 0x3FFFFF, IG3_PEOC9_GLPEOC_XFFL_OBJOFST_RSVD_S)
#define IG3_PEOC9_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S 0
#define IG3_PEOC9_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_M RDMA_MASK3(32, 0x3FF, IG3_PEOC9_GLPEOC_XFFL_OBJOFST_OBJ_TYPE_OFFSET_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG 0x42C1327C
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RSVD3_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RM_S 16
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RM_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RSVD2_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RME_S 12
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RME_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RSVD1_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_RSVD0_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQCTL_REG_RAM_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS 0x42C132C8
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQCTL_REG_RAM_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_AEQEDROPCNT(_i) 0x42C0A000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_CQM_GLPE_AEQEDROPCNT_MAX_INDEX_I 1031
#define IG3_CQM_GLPE_AEQEDROPCNT_RSVD_S 16
#define IG3_CQM_GLPE_AEQEDROPCNT_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_AEQEDROPCNT_RSVD_S)
#define IG3_CQM_GLPE_AEQEDROPCNT_AEQEDROPCNT_S 0
#define IG3_CQM_GLPE_AEQEDROPCNT_AEQEDROPCNT_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_AEQEDROPCNT_AEQEDROPCNT_S)
#define IG3_CQM_GLPE_AEQITRMASK(_i) 0x42C0E000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_CQM_GLPE_AEQITRMASK_MAX_INDEX_I 1031
#define IG3_CQM_GLPE_AEQITRMASK_AEQ_ITR_MASK_S 31
#define IG3_CQM_GLPE_AEQITRMASK_AEQ_ITR_MASK_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQITRMASK_AEQ_ITR_MASK_S)
#define IG3_CQM_GLPE_AEQITRMASK_RSVD_S 0
#define IG3_CQM_GLPE_AEQITRMASK_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CQM_GLPE_AEQITRMASK_RSVD_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG 0x42C13278
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RSVD3_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RM_S 16
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RM_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RSVD2_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RME_S 12
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RME_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RSVD1_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_RSVD0_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQ_CTXT_RAM_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS 0x42C132C4
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_AEQ_CTXT_RAM_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_CEQCTL(_i) 0x42C00000 + ((_i) * 4) /* _i=0...3167 */
#define IG3_CQM_GLPE_CEQCTL_MAX_INDEX_I 3167
#define IG3_CQM_GLPE_CEQCTL_RSVD1_S 31
#define IG3_CQM_GLPE_CEQCTL_RSVD1_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_RSVD1_S)
#define IG3_CQM_GLPE_CEQCTL_CAUSE_ENA_S 30
#define IG3_CQM_GLPE_CEQCTL_CAUSE_ENA_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_CAUSE_ENA_S)
#define IG3_CQM_GLPE_CEQCTL_RSVD0_S 15
#define IG3_CQM_GLPE_CEQCTL_RSVD0_M RDMA_MASK3(32, 0x7FFF, IG3_CQM_GLPE_CEQCTL_RSVD0_S)
#define IG3_CQM_GLPE_CEQCTL_ITR_INDX_S 13
#define IG3_CQM_GLPE_CEQCTL_ITR_INDX_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQCTL_ITR_INDX_S)
#define IG3_CQM_GLPE_CEQCTL_MSIX_INDX_S 0
#define IG3_CQM_GLPE_CEQCTL_MSIX_INDX_M RDMA_MASK3(32, 0x1FFF, IG3_CQM_GLPE_CEQCTL_MSIX_INDX_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG 0x42C13284
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RSVD3_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RM_S 16
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RM_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RSVD2_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RME_S 12
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RME_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_RSVD0_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_REG_RAM_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS 0x42C132D0
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQCTL_REG_RAM_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_CEQEDROPCNT(_i) 0x42C08000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_CQM_GLPE_CEQEDROPCNT_MAX_INDEX_I 1031
#define IG3_CQM_GLPE_CEQEDROPCNT_RSVD_S 16
#define IG3_CQM_GLPE_CEQEDROPCNT_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_CEQEDROPCNT_RSVD_S)
#define IG3_CQM_GLPE_CEQEDROPCNT_CEQEDROPCNT_S 0
#define IG3_CQM_GLPE_CEQEDROPCNT_CEQEDROPCNT_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_CEQEDROPCNT_CEQEDROPCNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG 0x42C13288
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CEQE_RAM_0_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_CEQE_RAM_0_CFG_RSVD3_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_RM_S 16
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CEQE_RAM_0_CFG_RM_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_0_CFG_RSVD2_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_0_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_RME_S 12
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_0_CFG_RME_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_0_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_0_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_0_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_0_CFG_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_0_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_0_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_0_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_0_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_0_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_CEQE_RAM_0_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_0_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS 0x42C132D4
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_0_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_CEQE_RAM_0_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CEQE_RAM_0_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_0_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_0_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_0_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_CEQE_RAM_0_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_0_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG 0x42C1328C
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CEQE_RAM_1_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_CEQE_RAM_1_CFG_RSVD3_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_RM_S 16
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CEQE_RAM_1_CFG_RM_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_1_CFG_RSVD2_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_1_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_RME_S 12
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_1_CFG_RME_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_1_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_1_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_1_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_1_CFG_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_1_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_1_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_1_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_1_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_1_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_CEQE_RAM_1_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_1_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS 0x42C132D8
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_1_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_CEQE_RAM_1_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CEQE_RAM_1_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_1_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_1_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_1_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_CEQE_RAM_1_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_1_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG 0x42C13290
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CEQE_RAM_2_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_CEQE_RAM_2_CFG_RSVD3_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_RM_S 16
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CEQE_RAM_2_CFG_RM_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_2_CFG_RSVD2_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_2_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_RME_S 12
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_2_CFG_RME_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_2_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_2_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_2_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_2_CFG_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_2_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_2_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_2_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_2_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_2_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_CEQE_RAM_2_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_2_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS 0x42C132DC
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_2_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_CEQE_RAM_2_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CEQE_RAM_2_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_2_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_2_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_2_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_CEQE_RAM_2_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_2_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG 0x42C13294
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CEQE_RAM_3_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_CEQE_RAM_3_CFG_RSVD3_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_RM_S 16
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CEQE_RAM_3_CFG_RM_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_3_CFG_RSVD2_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_3_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_RME_S 12
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_3_CFG_RME_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_3_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_3_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_3_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_3_CFG_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_3_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_3_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_3_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_3_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_3_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_CEQE_RAM_3_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_3_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS 0x42C132E0
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_3_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_CEQE_RAM_3_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CEQE_RAM_3_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_3_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_3_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_3_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_CEQE_RAM_3_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_3_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG 0x42C13298
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CEQE_RAM_4_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_CEQE_RAM_4_CFG_RSVD3_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_RM_S 16
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CEQE_RAM_4_CFG_RM_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_4_CFG_RSVD2_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_4_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_RME_S 12
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_4_CFG_RME_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_4_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_4_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_4_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_4_CFG_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_4_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_4_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_4_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_4_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_4_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_CEQE_RAM_4_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_4_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS 0x42C132E4
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_4_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_CEQE_RAM_4_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CEQE_RAM_4_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_4_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_4_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_4_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_CEQE_RAM_4_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_4_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG 0x42C1329C
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CEQE_RAM_5_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_CEQE_RAM_5_CFG_RSVD3_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_RM_S 16
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CEQE_RAM_5_CFG_RM_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_5_CFG_RSVD2_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_5_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_RME_S 12
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_5_CFG_RME_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_5_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_5_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_5_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_5_CFG_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_5_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_5_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_5_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_5_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_5_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_CEQE_RAM_5_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_5_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS 0x42C132E8
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_5_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_CEQE_RAM_5_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CEQE_RAM_5_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_5_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_5_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_5_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_CEQE_RAM_5_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_5_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG 0x42C132A0
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CEQE_RAM_6_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_CEQE_RAM_6_CFG_RSVD3_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_RM_S 16
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CEQE_RAM_6_CFG_RM_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_6_CFG_RSVD2_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_6_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_RME_S 12
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_6_CFG_RME_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_6_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_6_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_6_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_6_CFG_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_6_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_6_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_6_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_6_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_6_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_CEQE_RAM_6_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_6_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS 0x42C132EC
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_6_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_CEQE_RAM_6_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CEQE_RAM_6_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_6_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_6_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_6_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_CEQE_RAM_6_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_6_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG 0x42C132A4
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CEQE_RAM_7_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_CEQE_RAM_7_CFG_RSVD3_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_RM_S 16
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CEQE_RAM_7_CFG_RM_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_7_CFG_RSVD2_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_7_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_RME_S 12
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_7_CFG_RME_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_7_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_7_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_7_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_7_CFG_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_7_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_7_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_7_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_7_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_7_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_CEQE_RAM_7_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_7_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS 0x42C132F0
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQE_RAM_7_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_CEQE_RAM_7_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CEQE_RAM_7_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_7_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_7_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_7_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_CEQE_RAM_7_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQE_RAM_7_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_CEQITRMASK(_i) 0x42C10000 + ((_i) * 4) /* _i=0...3167 */
#define IG3_CQM_GLPE_CEQITRMASK_MAX_INDEX_I 3167
#define IG3_CQM_GLPE_CEQITRMASK_CEQ_ITR_MASK_S 31
#define IG3_CQM_GLPE_CEQITRMASK_CEQ_ITR_MASK_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQITRMASK_CEQ_ITR_MASK_S)
#define IG3_CQM_GLPE_CEQITRMASK_RSVD_S 0
#define IG3_CQM_GLPE_CEQITRMASK_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CQM_GLPE_CEQITRMASK_RSVD_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG 0x42C13280
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RSVD3_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RM_S 16
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RM_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RSVD2_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RME_S 12
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RME_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_RSVD0_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQ_CTXT_RAM_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS 0x42C132CC
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_CEQ_CTXT_RAM_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_CQEDROPCNT(_i) 0x42C06000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_CQM_GLPE_CQEDROPCNT_MAX_INDEX_I 1031
#define IG3_CQM_GLPE_CQEDROPCNT_RSVD_S 16
#define IG3_CQM_GLPE_CQEDROPCNT_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_CQEDROPCNT_RSVD_S)
#define IG3_CQM_GLPE_CQEDROPCNT_CQEDROPCNT_S 0
#define IG3_CQM_GLPE_CQEDROPCNT_CQEDROPCNT_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_CQEDROPCNT_CQEDROPCNT_S)
#define IG3_CQM_GLPE_CQE_TSCTL(_i) 0x42C0C000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_CQM_GLPE_CQE_TSCTL_MAX_INDEX_I 1031
#define IG3_CQM_GLPE_CQE_TSCTL_ENABLE_S 31
#define IG3_CQM_GLPE_CQE_TSCTL_ENABLE_M RDMA_BIT2(32, IG3_CQM_GLPE_CQE_TSCTL_ENABLE_S)
#define IG3_CQM_GLPE_CQE_TSCTL_RSVD0_S 5
#define IG3_CQM_GLPE_CQE_TSCTL_RSVD0_M RDMA_MASK3(32, 0x3FFFFFF, IG3_CQM_GLPE_CQE_TSCTL_RSVD0_S)
#define IG3_CQM_GLPE_CQE_TSCTL_SHIFT_CNT_S 0
#define IG3_CQM_GLPE_CQE_TSCTL_SHIFT_CNT_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_CQE_TSCTL_SHIFT_CNT_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_BUS_INDEX 0x42C13390
#define IG3_CQM_GLPE_CQM_BOB_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL 0x42C13380
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_RESERVED_31_10_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_TRIG_OP_S 8
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_TRIG_OP_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_FREEZE_RESET_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_FREEZE_SET_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_CTRL_FREEZE_SET_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_FREEZE_ON_CNT_VAL 0x42C133A0
#define IG3_CQM_GLPE_CQM_BOB_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_OBS_BUS 0x42C133C0
#define IG3_CQM_GLPE_CQM_BOB_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CNT0 0x42C133E0
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CNT0_CNT0_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CNT0_CNT0_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CNT1_0 0x42C133E8
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CNT1_1 0x42C133EC
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CTRL 0x42C133D8
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CQM_BOB_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_RC_CTRL 0x42C133B8
#define IG3_CQM_GLPE_CQM_BOB_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_CQM_GLPE_CQM_BOB_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_RC_GAP 0x42C133A8
#define IG3_CQM_GLPE_CQM_BOB_BOB_RC_GAP_RC_GAP_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_RC_GAP_RC_GAP_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_RC_TRNS 0x42C133B0
#define IG3_CQM_GLPE_CQM_BOB_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS 0x42C13388
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_RESERVED_31_8_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_I_FREEZE_S 6
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_I_FREEZE_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_READY_S 5
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_READY_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_VALID_S 4
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_VALID_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_BOB_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_TRANS_CNT 0x42C13398
#define IG3_CQM_GLPE_CQM_BOB_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_TRIG_MASK 0x42C133C8
#define IG3_CQM_GLPE_CQM_BOB_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_CQM_GLPE_CQM_BOB_BOB_TRIG_VALUE 0x42C133D0
#define IG3_CQM_GLPE_CQM_BOB_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_CQM_GLPE_CQM_BOB_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_BOB_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_COUNT 0x42C13438
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CQM_GLPE_CQM_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CQM_GLPE_CQM_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_CMD 0x42C1344C
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_DATA_H 0x42C13458
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_DATA_L 0x42C13454
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_PTR 0x42C13450
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CQM_GLPE_CQM_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_CMD 0x42C1343C
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_DATA_H 0x42C13448
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_DATA_L 0x42C13444
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_PTR 0x42C13440
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CQM_GLPE_CQM_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_CONTROL 0x42C13400
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_RSVD1_S 25
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CQM_DTM_CONTROL_RSVD1_S)
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_RSVD2_S 17
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CQM_DTM_CONTROL_RSVD2_S)
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_RSVD3_S 9
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CQM_DTM_CONTROL_RSVD3_S)
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_BYPASS_S 8
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_CONTROL_BYPASS_S)
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_RSVD4_S 1
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CQM_DTM_CONTROL_RSVD4_S)
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_CQM_GLPE_CQM_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_CONTROL_LOCAL_EN_S)
#define IG3_CQM_GLPE_CQM_DTM_ECC_COR_ERR 0x42C13468
#define IG3_CQM_GLPE_CQM_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_CQM_GLPE_CQM_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CQM_GLPE_CQM_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_CQM_GLPE_CQM_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_CQM_GLPE_CQM_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CQM_GLPE_CQM_DTM_ECC_COR_ERR_CNT_S)
#define IG3_CQM_GLPE_CQM_DTM_ECC_UNCOR_ERR 0x42C13464
#define IG3_CQM_GLPE_CQM_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CQM_GLPE_CQM_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CQM_GLPE_CQM_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CQM_GLPE_CQM_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CQM_GLPE_CQM_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CQM_GLPE_CQM_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_CQM_GLPE_CQM_DTM_GROUP_CFG 0x42C1340C
#define IG3_CQM_GLPE_CQM_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_CQM_GLPE_CQM_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CQM_DTM_GROUP_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CQM_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_CQM_GLPE_CQM_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CQM_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_CQM_GLPE_CQM_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_CQM_GLPE_CQM_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CQM_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_CQM_GLPE_CQM_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_CQM_GLPE_CQM_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CQM_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_CQM_GLPE_CQM_DTM_LOG_CFG 0x42C13410
#define IG3_CQM_GLPE_CQM_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_CQM_GLPE_CQM_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_CQM_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_CQM_GLPE_CQM_DTM_LOG_CFG_RSVD1_S 2
#define IG3_CQM_GLPE_CQM_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CQM_GLPE_CQM_DTM_LOG_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CQM_DTM_LOG_CFG_MODE_S 0
#define IG3_CQM_GLPE_CQM_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CQM_DTM_LOG_CFG_MODE_S)
#define IG3_CQM_GLPE_CQM_DTM_LOG_MASK 0x42C13418
#define IG3_CQM_GLPE_CQM_DTM_LOG_MASK_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_DTM_LOG_MASK_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_LOG_PATTERN 0x42C13414
#define IG3_CQM_GLPE_CQM_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_DTM_LOG_PATTERN_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_MAIN_CFG 0x42C13404
#define IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_RSVD2_S)
#define IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_RSVD3_S)
#define IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_CQM_GLPE_CQM_DTM_MAIN_STS 0x42C13408
#define IG3_CQM_GLPE_CQM_DTM_MAIN_STS_RSVD1_S 9
#define IG3_CQM_GLPE_CQM_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_CQM_GLPE_CQM_DTM_MAIN_STS_RSVD1_S)
#define IG3_CQM_GLPE_CQM_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_CQM_GLPE_CQM_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_CQM_GLPE_CQM_DTM_MAIN_STS_RSVD2_S 1
#define IG3_CQM_GLPE_CQM_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CQM_DTM_MAIN_STS_RSVD2_S)
#define IG3_CQM_GLPE_CQM_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_CQM_GLPE_CQM_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_CQM_GLPE_CQM_DTM_TIMESTAMP 0x42C13430
#define IG3_CQM_GLPE_CQM_DTM_TIMESTAMP_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_DTM_TIMESTAMP_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_TIMESTAMP_ROLLOVER 0x42C13434
#define IG3_CQM_GLPE_CQM_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG 0x42C1345C
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS 0x42C13460
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_CQM_DTM_TRIG_CFG 0x42C1341C
#define IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_RSVD2_S)
#define IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_MODE_S 0
#define IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CQM_DTM_TRIG_CFG_MODE_S)
#define IG3_CQM_GLPE_CQM_DTM_TRIG_COUNT 0x42C13428
#define IG3_CQM_GLPE_CQM_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_DTM_TRIG_COUNT_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_TRIG_MASK 0x42C13424
#define IG3_CQM_GLPE_CQM_DTM_TRIG_MASK_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_DTM_TRIG_MASK_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_TRIG_PATTERN 0x42C13420
#define IG3_CQM_GLPE_CQM_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_CQM_GLPE_CQM_DTM_TRIG_TIMESTAMP 0x42C1342C
#define IG3_CQM_GLPE_CQM_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_CQM_GLPE_CQM_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CQM_GLPE_CQM_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_CQM_GLPE_CQM_ECC_COR_ERR 0x42C13314
#define IG3_CQM_GLPE_CQM_ECC_COR_ERR_RSVD_S 12
#define IG3_CQM_GLPE_CQM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CQM_GLPE_CQM_ECC_COR_ERR_RSVD_S)
#define IG3_CQM_GLPE_CQM_ECC_COR_ERR_CNT_S 0
#define IG3_CQM_GLPE_CQM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CQM_GLPE_CQM_ECC_COR_ERR_CNT_S)
#define IG3_CQM_GLPE_CQM_ECC_UNCOR_ERR 0x42C13310
#define IG3_CQM_GLPE_CQM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CQM_GLPE_CQM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CQM_GLPE_CQM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CQM_GLPE_CQM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CQM_GLPE_CQM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CQM_GLPE_CQM_ECC_UNCOR_ERR_CNT_S)
#define IG3_CQM_GLPE_CQM_FLR_RX_MKR_CNT 0x42C13230
#define IG3_CQM_GLPE_CQM_FLR_RX_MKR_CNT_RSVD_S 8
#define IG3_CQM_GLPE_CQM_FLR_RX_MKR_CNT_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CQM_GLPE_CQM_FLR_RX_MKR_CNT_RSVD_S)
#define IG3_CQM_GLPE_CQM_FLR_RX_MKR_CNT_COUNT_S 0
#define IG3_CQM_GLPE_CQM_FLR_RX_MKR_CNT_COUNT_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CQM_FLR_RX_MKR_CNT_COUNT_S)
#define IG3_CQM_GLPE_CQM_FLR_TXCMP_MKR_CNT 0x42C1322C
#define IG3_CQM_GLPE_CQM_FLR_TXCMP_MKR_CNT_RSVD_S 8
#define IG3_CQM_GLPE_CQM_FLR_TXCMP_MKR_CNT_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_CQM_GLPE_CQM_FLR_TXCMP_MKR_CNT_RSVD_S)
#define IG3_CQM_GLPE_CQM_FLR_TXCMP_MKR_CNT_COUNT_S 0
#define IG3_CQM_GLPE_CQM_FLR_TXCMP_MKR_CNT_COUNT_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_CQM_FLR_TXCMP_MKR_CNT_COUNT_S)
#define IG3_CQM_GLPE_CQM_FLUSH_MKR_CNT 0x42C13228
#define IG3_CQM_GLPE_CQM_FLUSH_MKR_CNT_RSVD_S 16
#define IG3_CQM_GLPE_CQM_FLUSH_MKR_CNT_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_CQM_FLUSH_MKR_CNT_RSVD_S)
#define IG3_CQM_GLPE_CQM_FLUSH_MKR_CNT_MKR_CNT_S 0
#define IG3_CQM_GLPE_CQM_FLUSH_MKR_CNT_MKR_CNT_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_CQM_FLUSH_MKR_CNT_MKR_CNT_S)
#define IG3_CQM_GLPE_CQM_FUNC_INVALIDATE 0x42C13200
#define IG3_CQM_GLPE_CQM_FUNC_INVALIDATE_ENABLE_S 31
#define IG3_CQM_GLPE_CQM_FUNC_INVALIDATE_ENABLE_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_FUNC_INVALIDATE_ENABLE_S)
#define IG3_CQM_GLPE_CQM_FUNC_INVALIDATE_RSVD_S 20
#define IG3_CQM_GLPE_CQM_FUNC_INVALIDATE_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_CQM_GLPE_CQM_FUNC_INVALIDATE_RSVD_S)
#define IG3_CQM_GLPE_CQM_FUNC_INVALIDATE_FUNC_TRIPLET_S 0
#define IG3_CQM_GLPE_CQM_FUNC_INVALIDATE_FUNC_TRIPLET_M RDMA_MASK3(32, 0xFFFFF, IG3_CQM_GLPE_CQM_FUNC_INVALIDATE_FUNC_TRIPLET_S)
#define IG3_CQM_GLPE_CQM_ORDERING_DOMAIN 0x42C13274
#define IG3_CQM_GLPE_CQM_ORDERING_DOMAIN_RSVD0_S 3
#define IG3_CQM_GLPE_CQM_ORDERING_DOMAIN_RSVD0_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_CQM_GLPE_CQM_ORDERING_DOMAIN_RSVD0_S)
#define IG3_CQM_GLPE_CQM_ORDERING_DOMAIN_ORDERING_DOMAIN_S 0
#define IG3_CQM_GLPE_CQM_ORDERING_DOMAIN_ORDERING_DOMAIN_M RDMA_MASK3(32, 0x7, IG3_CQM_GLPE_CQM_ORDERING_DOMAIN_ORDERING_DOMAIN_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG 0x42C132B4
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RSVD3_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RM_S 16
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RM_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RSVD2_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RME_S 12
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RME_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RSVD1_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_RSVD0_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_TRANS_RAM_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_CQM_XLR_DROP_HI(_i) 0x42C13254 + ((_i) * 4) /* _i=0...7 */
#define IG3_CQM_GLPE_CQM_XLR_DROP_HI_MAX_INDEX_I 7
#define IG3_CQM_GLPE_CQM_XLR_DROP_HI_EN_S 31
#define IG3_CQM_GLPE_CQM_XLR_DROP_HI_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CQM_XLR_DROP_HI_EN_S)
#define IG3_CQM_GLPE_CQM_XLR_DROP_HI_RSVD0_S 12
#define IG3_CQM_GLPE_CQM_XLR_DROP_HI_RSVD0_M RDMA_MASK3(32, 0x7FFFF, IG3_CQM_GLPE_CQM_XLR_DROP_HI_RSVD0_S)
#define IG3_CQM_GLPE_CQM_XLR_DROP_HI_PMF_S 0
#define IG3_CQM_GLPE_CQM_XLR_DROP_HI_PMF_M RDMA_MASK3(32, 0xFFF, IG3_CQM_GLPE_CQM_XLR_DROP_HI_PMF_S)
#define IG3_CQM_GLPE_CQM_XLR_DROP_LO(_i) 0x42C13234 + ((_i) * 4) /* _i=0...7 */
#define IG3_CQM_GLPE_CQM_XLR_DROP_LO_MAX_INDEX_I 7
#define IG3_CQM_GLPE_CQM_XLR_DROP_LO_RSVD_S 20
#define IG3_CQM_GLPE_CQM_XLR_DROP_LO_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CQM_GLPE_CQM_XLR_DROP_LO_RSVD_S)
#define IG3_CQM_GLPE_CQM_XLR_DROP_LO_VDEFVFTYPE_S 18
#define IG3_CQM_GLPE_CQM_XLR_DROP_LO_VDEFVFTYPE_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CQM_XLR_DROP_LO_VDEFVFTYPE_S)
#define IG3_CQM_GLPE_CQM_XLR_DROP_LO_VF_S 6
#define IG3_CQM_GLPE_CQM_XLR_DROP_LO_VF_M RDMA_MASK3(32, 0xFFF, IG3_CQM_GLPE_CQM_XLR_DROP_LO_VF_S)
#define IG3_CQM_GLPE_CQM_XLR_DROP_LO_PF_S 0
#define IG3_CQM_GLPE_CQM_XLR_DROP_LO_PF_M RDMA_MASK3(32, 0x3F, IG3_CQM_GLPE_CQM_XLR_DROP_LO_PF_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER 0x42C13208
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_LOCK_EN_S 31
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_LOCK_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_LOCK_EN_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_LOCK_ACTIVE_S 30
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_LOCK_ACTIVE_M RDMA_BIT2(32, IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_LOCK_ACTIVE_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_RSVD_S 20
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_RSVD_M RDMA_MASK3(32, 0x3FF, IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_RSVD_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_VDEFVFTYPE_S 18
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_VDEFVFTYPE_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_VDEFVFTYPE_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_VF_S 6
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_VF_M RDMA_MASK3(32, 0xFFF, IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_VF_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_PF_S 0
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_PF_M RDMA_MASK3(32, 0x3F, IG3_CQM_GLPE_CQP_CQ_LOCK0_LOWER_PF_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_UPPER 0x42C13204
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_UPPER_RSVD_S 20
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_UPPER_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CQM_GLPE_CQP_CQ_LOCK0_UPPER_RSVD_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_UPPER_CQID_S 0
#define IG3_CQM_GLPE_CQP_CQ_LOCK0_UPPER_CQID_M RDMA_MASK3(32, 0xFFFFF, IG3_CQM_GLPE_CQP_CQ_LOCK0_UPPER_CQID_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER 0x42C13210
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_LOCK_EN_S 31
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_LOCK_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_LOCK_EN_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_LOCK_ACTIVE_S 30
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_LOCK_ACTIVE_M RDMA_BIT2(32, IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_LOCK_ACTIVE_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_RSVD_S 20
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_RSVD_M RDMA_MASK3(32, 0x3FF, IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_RSVD_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_VDEFVFTYPE_S 18
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_VDEFVFTYPE_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_VDEFVFTYPE_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_VF_S 6
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_VF_M RDMA_MASK3(32, 0xFFF, IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_VF_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_PF_S 0
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_PF_M RDMA_MASK3(32, 0x3F, IG3_CQM_GLPE_CQP_CQ_LOCK1_LOWER_PF_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_UPPER 0x42C1320C
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_UPPER_RSVD_S 20
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_UPPER_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CQM_GLPE_CQP_CQ_LOCK1_UPPER_RSVD_S)
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_UPPER_CQID_S 0
#define IG3_CQM_GLPE_CQP_CQ_LOCK1_UPPER_CQID_M RDMA_MASK3(32, 0xFFFFF, IG3_CQM_GLPE_CQP_CQ_LOCK1_UPPER_CQID_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG 0x42C132B8
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RSVD3_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RM_S 16
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RM_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RSVD2_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RME_S 12
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RME_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RSVD1_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_RSVD0_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_0_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS 0x42C13304
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_0_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG 0x42C132BC
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RSVD3_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RM_S 16
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RM_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RSVD2_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RME_S 12
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RME_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RSVD1_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_RSVD0_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_1_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS 0x42C13308
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_1_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG 0x42C132C0
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RSVD3_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RM_S 16
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RM_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RSVD2_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RME_S 12
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RME_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RSVD1_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_RSVD0_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_2_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS 0x42C1330C
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_DROP_REG_RAM_2_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_HOME0_PARTITION 0x42C13214
#define IG3_CQM_GLPE_HOME0_PARTITION_RSVD_S 16
#define IG3_CQM_GLPE_HOME0_PARTITION_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_HOME0_PARTITION_RSVD_S)
#define IG3_CQM_GLPE_HOME0_PARTITION_MAXPERDBHOME_S 8
#define IG3_CQM_GLPE_HOME0_PARTITION_MAXPERDBHOME_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_HOME0_PARTITION_MAXPERDBHOME_S)
#define IG3_CQM_GLPE_HOME0_PARTITION_MAXPERCQHOME_S 0
#define IG3_CQM_GLPE_HOME0_PARTITION_MAXPERCQHOME_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_HOME0_PARTITION_MAXPERCQHOME_S)
#define IG3_CQM_GLPE_HOME1_PARTITION 0x42C13218
#define IG3_CQM_GLPE_HOME1_PARTITION_RSVD_S 16
#define IG3_CQM_GLPE_HOME1_PARTITION_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_HOME1_PARTITION_RSVD_S)
#define IG3_CQM_GLPE_HOME1_PARTITION_MAXPERDBHOME_S 8
#define IG3_CQM_GLPE_HOME1_PARTITION_MAXPERDBHOME_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_HOME1_PARTITION_MAXPERDBHOME_S)
#define IG3_CQM_GLPE_HOME1_PARTITION_MAXPERCQHOME_S 0
#define IG3_CQM_GLPE_HOME1_PARTITION_MAXPERCQHOME_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_HOME1_PARTITION_MAXPERCQHOME_S)
#define IG3_CQM_GLPE_HOME2_PARTITION 0x42C1321C
#define IG3_CQM_GLPE_HOME2_PARTITION_RSVD_S 16
#define IG3_CQM_GLPE_HOME2_PARTITION_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_HOME2_PARTITION_RSVD_S)
#define IG3_CQM_GLPE_HOME2_PARTITION_MAXPERDBHOME_S 8
#define IG3_CQM_GLPE_HOME2_PARTITION_MAXPERDBHOME_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_HOME2_PARTITION_MAXPERDBHOME_S)
#define IG3_CQM_GLPE_HOME2_PARTITION_MAXPERCQHOME_S 0
#define IG3_CQM_GLPE_HOME2_PARTITION_MAXPERCQHOME_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_HOME2_PARTITION_MAXPERCQHOME_S)
#define IG3_CQM_GLPE_HOME3_PARTITION 0x42C13220
#define IG3_CQM_GLPE_HOME3_PARTITION_RSVD_S 16
#define IG3_CQM_GLPE_HOME3_PARTITION_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_HOME3_PARTITION_RSVD_S)
#define IG3_CQM_GLPE_HOME3_PARTITION_MAXPERDBHOME_S 8
#define IG3_CQM_GLPE_HOME3_PARTITION_MAXPERDBHOME_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_HOME3_PARTITION_MAXPERDBHOME_S)
#define IG3_CQM_GLPE_HOME3_PARTITION_MAXPERCQHOME_S 0
#define IG3_CQM_GLPE_HOME3_PARTITION_MAXPERCQHOME_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_HOME3_PARTITION_MAXPERCQHOME_S)
#define IG3_CQM_GLPE_HOME4_PARTITION 0x42C13224
#define IG3_CQM_GLPE_HOME4_PARTITION_RSVD_S 16
#define IG3_CQM_GLPE_HOME4_PARTITION_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_CQM_GLPE_HOME4_PARTITION_RSVD_S)
#define IG3_CQM_GLPE_HOME4_PARTITION_MAXPERDBHOME_S 8
#define IG3_CQM_GLPE_HOME4_PARTITION_MAXPERDBHOME_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_HOME4_PARTITION_MAXPERDBHOME_S)
#define IG3_CQM_GLPE_HOME4_PARTITION_MAXPERCQHOME_S 0
#define IG3_CQM_GLPE_HOME4_PARTITION_MAXPERCQHOME_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_HOME4_PARTITION_MAXPERCQHOME_S)
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS 0x42C13300
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CQM_TRANS_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG 0x42C132A8
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RSVD3_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RM_S 16
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RM_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RSVD2_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RME_S 12
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RME_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RSVD1_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_RSVD0_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CTXT_RAM_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS 0x42C132F4
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_CTXT_RAM_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG 0x42C132AC
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RSVD3_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RM_S 16
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RM_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RSVD2_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RME_S 12
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RME_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RSVD1_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_RSVD0_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_HSM_RAM_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS 0x42C132F8
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_HSM_RAM_STATUS_ECC_ERR_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG 0x42C132B0
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ECC_INST_NUM_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RSVD3_S 20
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RSVD3_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RM_S 16
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RM_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RSVD2_S 14
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RSVD2_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_POWER_GATE_EN_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RME_S 12
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RME_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RME_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RSVD1_S 10
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RSVD1_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ERR_CNT_S 9
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ERR_CNT_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_FIX_CNT_S 8
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_FIX_CNT_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RSVD0_S 6
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_RSVD0_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_MASK_INT_S 5
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_MASK_INT_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_LS_BYPASS_S 4
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_LS_BYPASS_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_LS_FORCE_S 3
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_LS_FORCE_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ECC_INVERT_2_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ECC_INVERT_1_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ECC_EN_S 0
#define IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_PAL_RAM_CFG_ECC_EN_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS 0x42C132FC
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_RSVD1_S 30
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_RSVD1_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_RSVD0_S 4
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_RSVD0_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_INIT_DONE_S 2
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_INIT_DONE_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_ECC_FIX_S 1
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_ECC_FIX_S)
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_ECC_ERR_S 0
#define IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CQM_GLPE_SPAD_PAL_RAM_STATUS_ECC_ERR_S)
#define IG3_CQM_PMFPE_AEQCTL(_i) 0x42C04000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_CQM_PMFPE_AEQCTL_MAX_INDEX_I 1031
#define IG3_CQM_PMFPE_AEQCTL_RSVD1_S 31
#define IG3_CQM_PMFPE_AEQCTL_RSVD1_M RDMA_BIT2(32, IG3_CQM_PMFPE_AEQCTL_RSVD1_S)
#define IG3_CQM_PMFPE_AEQCTL_CAUSE_ENA_S 30
#define IG3_CQM_PMFPE_AEQCTL_CAUSE_ENA_M RDMA_BIT2(32, IG3_CQM_PMFPE_AEQCTL_CAUSE_ENA_S)
#define IG3_CQM_PMFPE_AEQCTL_RSVD0_S 15
#define IG3_CQM_PMFPE_AEQCTL_RSVD0_M RDMA_MASK3(32, 0x7FFF, IG3_CQM_PMFPE_AEQCTL_RSVD0_S)
#define IG3_CQM_PMFPE_AEQCTL_ITR_INDX_S 13
#define IG3_CQM_PMFPE_AEQCTL_ITR_INDX_M RDMA_MASK3(32, 0x3, IG3_CQM_PMFPE_AEQCTL_ITR_INDX_S)
#define IG3_CQM_PMFPE_AEQCTL_MSIX_INDX_S 0
#define IG3_CQM_PMFPE_AEQCTL_MSIX_INDX_M RDMA_MASK3(32, 0x1FFF, IG3_CQM_PMFPE_AEQCTL_MSIX_INDX_S)
#define IG3_DBL_GLPE_CEQPART_CTRL0 0x42C2004C
#define IG3_DBL_GLPE_CEQPART_CTRL0_BUSY_S 31
#define IG3_DBL_GLPE_CEQPART_CTRL0_BUSY_M RDMA_BIT2(32, IG3_DBL_GLPE_CEQPART_CTRL0_BUSY_S)
#define IG3_DBL_GLPE_CEQPART_CTRL0_RSVD1_S 19
#define IG3_DBL_GLPE_CEQPART_CTRL0_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_CEQPART_CTRL0_RSVD1_S)
#define IG3_DBL_GLPE_CEQPART_CTRL0_ADDR_S 8
#define IG3_DBL_GLPE_CEQPART_CTRL0_ADDR_M RDMA_MASK3(32, 0x7FF, IG3_DBL_GLPE_CEQPART_CTRL0_ADDR_S)
#define IG3_DBL_GLPE_CEQPART_CTRL0_RSVD0_S 3
#define IG3_DBL_GLPE_CEQPART_CTRL0_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_DBL_GLPE_CEQPART_CTRL0_RSVD0_S)
#define IG3_DBL_GLPE_CEQPART_CTRL0_OP_S 0
#define IG3_DBL_GLPE_CEQPART_CTRL0_OP_M RDMA_MASK3(32, 0x7, IG3_DBL_GLPE_CEQPART_CTRL0_OP_S)
#define IG3_DBL_GLPE_CEQPART_CTRL1 0x42C20050
#define IG3_DBL_GLPE_CEQPART_CTRL1_VALID_MASK_S 31
#define IG3_DBL_GLPE_CEQPART_CTRL1_VALID_MASK_M RDMA_BIT2(32, IG3_DBL_GLPE_CEQPART_CTRL1_VALID_MASK_S)
#define IG3_DBL_GLPE_CEQPART_CTRL1_VALID_S 30
#define IG3_DBL_GLPE_CEQPART_CTRL1_VALID_M RDMA_BIT2(32, IG3_DBL_GLPE_CEQPART_CTRL1_VALID_S)
#define IG3_DBL_GLPE_CEQPART_CTRL1_PMF_MASK_S 29
#define IG3_DBL_GLPE_CEQPART_CTRL1_PMF_MASK_M RDMA_BIT2(32, IG3_DBL_GLPE_CEQPART_CTRL1_PMF_MASK_S)
#define IG3_DBL_GLPE_CEQPART_CTRL1_RSVD1_S 27
#define IG3_DBL_GLPE_CEQPART_CTRL1_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_CEQPART_CTRL1_RSVD1_S)
#define IG3_DBL_GLPE_CEQPART_CTRL1_PMF_S 16
#define IG3_DBL_GLPE_CEQPART_CTRL1_PMF_M RDMA_MASK3(32, 0x7FF, IG3_DBL_GLPE_CEQPART_CTRL1_PMF_S)
#define IG3_DBL_GLPE_CEQPART_CTRL1_UNIT_MASK_S 15
#define IG3_DBL_GLPE_CEQPART_CTRL1_UNIT_MASK_M RDMA_BIT2(32, IG3_DBL_GLPE_CEQPART_CTRL1_UNIT_MASK_S)
#define IG3_DBL_GLPE_CEQPART_CTRL1_RSVD0_S 7
#define IG3_DBL_GLPE_CEQPART_CTRL1_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_CEQPART_CTRL1_RSVD0_S)
#define IG3_DBL_GLPE_CEQPART_CTRL1_UNIT_S 0
#define IG3_DBL_GLPE_CEQPART_CTRL1_UNIT_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_CEQPART_CTRL1_UNIT_S)
#define IG3_DBL_GLPE_CEQPART_DATA0 0x42C20054
#define IG3_DBL_GLPE_CEQPART_DATA0_RSVD1_S 30
#define IG3_DBL_GLPE_CEQPART_DATA0_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_CEQPART_DATA0_RSVD1_S)
#define IG3_DBL_GLPE_CEQPART_DATA0_HITCNT_S 19
#define IG3_DBL_GLPE_CEQPART_DATA0_HITCNT_M RDMA_MASK3(32, 0x7FF, IG3_DBL_GLPE_CEQPART_DATA0_HITCNT_S)
#define IG3_DBL_GLPE_CEQPART_DATA0_ADDR_S 8
#define IG3_DBL_GLPE_CEQPART_DATA0_ADDR_M RDMA_MASK3(32, 0x7FF, IG3_DBL_GLPE_CEQPART_DATA0_ADDR_S)
#define IG3_DBL_GLPE_CEQPART_DATA0_RSVD0_S 0
#define IG3_DBL_GLPE_CEQPART_DATA0_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_CEQPART_DATA0_RSVD0_S)
#define IG3_DBL_GLPE_CEQPART_DATA1 0x42C20058
#define IG3_DBL_GLPE_CEQPART_DATA1_RSVD1_S 31
#define IG3_DBL_GLPE_CEQPART_DATA1_RSVD1_M RDMA_BIT2(32, IG3_DBL_GLPE_CEQPART_DATA1_RSVD1_S)
#define IG3_DBL_GLPE_CEQPART_DATA1_VALID_S 30
#define IG3_DBL_GLPE_CEQPART_DATA1_VALID_M RDMA_BIT2(32, IG3_DBL_GLPE_CEQPART_DATA1_VALID_S)
#define IG3_DBL_GLPE_CEQPART_DATA1_ERROR_S 29
#define IG3_DBL_GLPE_CEQPART_DATA1_ERROR_M RDMA_BIT2(32, IG3_DBL_GLPE_CEQPART_DATA1_ERROR_S)
#define IG3_DBL_GLPE_CEQPART_DATA1_HIT_S 28
#define IG3_DBL_GLPE_CEQPART_DATA1_HIT_M RDMA_BIT2(32, IG3_DBL_GLPE_CEQPART_DATA1_HIT_S)
#define IG3_DBL_GLPE_CEQPART_DATA1_PMF_S 16
#define IG3_DBL_GLPE_CEQPART_DATA1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_CEQPART_DATA1_PMF_S)
#define IG3_DBL_GLPE_CEQPART_DATA1_RSVD0_S 7
#define IG3_DBL_GLPE_CEQPART_DATA1_RSVD0_M RDMA_MASK3(32, 0x1FF, IG3_DBL_GLPE_CEQPART_DATA1_RSVD0_S)
#define IG3_DBL_GLPE_CEQPART_DATA1_UNIT_S 0
#define IG3_DBL_GLPE_CEQPART_DATA1_UNIT_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_CEQPART_DATA1_UNIT_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG 0x42C200A8
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ECC_INST_NUM_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RSVD3_S 20
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RSVD3_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RM_S 16
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RM_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RSVD2_S 14
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RSVD2_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_POWER_GATE_EN_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RME_S 12
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RME_M RDMA_BIT2(32, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RME_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RSVD1_S 10
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RSVD1_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ERR_CNT_S 9
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ERR_CNT_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_FIX_CNT_S 8
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_FIX_CNT_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RSVD0_S 6
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_RSVD0_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_MASK_INT_S 5
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_MASK_INT_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_LS_BYPASS_S 4
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_LS_BYPASS_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_LS_FORCE_S 3
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_LS_FORCE_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ECC_INVERT_2_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ECC_INVERT_1_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ECC_EN_S 0
#define IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_CQ_DBA_MEM_CFG_ECC_EN_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS 0x42C200AC
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_RSVD1_S 30
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_RSVD1_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_RSVD0_S 4
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_RSVD0_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_INIT_DONE_S 2
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_INIT_DONE_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_ECC_FIX_S 1
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_ECC_FIX_S)
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_ECC_ERR_S 0
#define IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DBL_GLPE_CQ_DBA_MEM_STATUS_ECC_ERR_S)
#define IG3_DBL_GLPE_DBA_CTRL0 0x42C20014
#define IG3_DBL_GLPE_DBA_CTRL0_DONE_S 31
#define IG3_DBL_GLPE_DBA_CTRL0_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_DBA_CTRL0_DONE_S)
#define IG3_DBL_GLPE_DBA_CTRL0_WR_S 30
#define IG3_DBL_GLPE_DBA_CTRL0_WR_M RDMA_BIT2(32, IG3_DBL_GLPE_DBA_CTRL0_WR_S)
#define IG3_DBL_GLPE_DBA_CTRL0_SEL_S 29
#define IG3_DBL_GLPE_DBA_CTRL0_SEL_M RDMA_BIT2(32, IG3_DBL_GLPE_DBA_CTRL0_SEL_S)
#define IG3_DBL_GLPE_DBA_CTRL0_RSVD2_S 28
#define IG3_DBL_GLPE_DBA_CTRL0_RSVD2_M RDMA_BIT2(32, IG3_DBL_GLPE_DBA_CTRL0_RSVD2_S)
#define IG3_DBL_GLPE_DBA_CTRL0_WRDATA_EN_S 26
#define IG3_DBL_GLPE_DBA_CTRL0_WRDATA_EN_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_DBA_CTRL0_WRDATA_EN_S)
#define IG3_DBL_GLPE_DBA_CTRL0_WRDATA_S 24
#define IG3_DBL_GLPE_DBA_CTRL0_WRDATA_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_DBA_CTRL0_WRDATA_S)
#define IG3_DBL_GLPE_DBA_CTRL0_RSVD1_S 18
#define IG3_DBL_GLPE_DBA_CTRL0_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_DBL_GLPE_DBA_CTRL0_RSVD1_S)
#define IG3_DBL_GLPE_DBA_CTRL0_RDDATA_S 16
#define IG3_DBL_GLPE_DBA_CTRL0_RDDATA_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_DBA_CTRL0_RDDATA_S)
#define IG3_DBL_GLPE_DBA_CTRL0_RSVD0_S 15
#define IG3_DBL_GLPE_DBA_CTRL0_RSVD0_M RDMA_BIT2(32, IG3_DBL_GLPE_DBA_CTRL0_RSVD0_S)
#define IG3_DBL_GLPE_DBA_CTRL0_HOSTID_S 12
#define IG3_DBL_GLPE_DBA_CTRL0_HOSTID_M RDMA_MASK3(32, 0x7, IG3_DBL_GLPE_DBA_CTRL0_HOSTID_S)
#define IG3_DBL_GLPE_DBA_CTRL0_PMF_S 0
#define IG3_DBL_GLPE_DBA_CTRL0_PMF_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_DBA_CTRL0_PMF_S)
#define IG3_DBL_GLPE_DBA_CTRL1 0x42C20018
#define IG3_DBL_GLPE_DBA_CTRL1_RSVD_S 25
#define IG3_DBL_GLPE_DBA_CTRL1_RSVD_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_DBA_CTRL1_RSVD_S)
#define IG3_DBL_GLPE_DBA_CTRL1_QID_S 0
#define IG3_DBL_GLPE_DBA_CTRL1_QID_M RDMA_MASK3(32, 0x1FFFFFF, IG3_DBL_GLPE_DBA_CTRL1_QID_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_BUS_INDEX 0x42C20190
#define IG3_DBL_GLPE_DBL_BOB0_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL 0x42C20180
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_RESERVED_31_10_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_TRIG_OP_S 8
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_TRIG_OP_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_FREEZE_RESET_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_FREEZE_SET_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_CTRL_FREEZE_SET_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_FREEZE_ON_CNT_VAL 0x42C201A0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_OBS_BUS 0x42C201C0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CNT0 0x42C201E0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CNT0_CNT0_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CNT0_CNT0_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CNT1_0 0x42C201E8
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CNT1_1 0x42C201EC
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CTRL 0x42C201D8
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_DBL_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_RC_CTRL 0x42C201B8
#define IG3_DBL_GLPE_DBL_BOB0_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_DBL_GLPE_DBL_BOB0_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_RC_GAP 0x42C201A8
#define IG3_DBL_GLPE_DBL_BOB0_BOB_RC_GAP_RC_GAP_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_RC_GAP_RC_GAP_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_RC_TRNS 0x42C201B0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS 0x42C20188
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_RESERVED_31_8_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_I_FREEZE_S 6
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_I_FREEZE_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_READY_S 5
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_READY_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_VALID_S 4
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_VALID_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB0_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_TRANS_CNT 0x42C20198
#define IG3_DBL_GLPE_DBL_BOB0_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_TRIG_MASK 0x42C201C8
#define IG3_DBL_GLPE_DBL_BOB0_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_DBL_GLPE_DBL_BOB0_BOB_TRIG_VALUE 0x42C201D0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_DBL_GLPE_DBL_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_BUS_INDEX 0x42C20210
#define IG3_DBL_GLPE_DBL_BOB1_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL 0x42C20200
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_RESERVED_31_10_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_TRIG_OP_S 8
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_TRIG_OP_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_FREEZE_RESET_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_FREEZE_SET_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_CTRL_FREEZE_SET_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_FREEZE_ON_CNT_VAL 0x42C20220
#define IG3_DBL_GLPE_DBL_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_OBS_BUS 0x42C20240
#define IG3_DBL_GLPE_DBL_BOB1_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CNT0 0x42C20260
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CNT0_CNT0_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CNT0_CNT0_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CNT1_0 0x42C20268
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CNT1_1 0x42C2026C
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CTRL 0x42C20258
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_DBL_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_RC_CTRL 0x42C20238
#define IG3_DBL_GLPE_DBL_BOB1_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_DBL_GLPE_DBL_BOB1_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_RC_GAP 0x42C20228
#define IG3_DBL_GLPE_DBL_BOB1_BOB_RC_GAP_RC_GAP_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_RC_GAP_RC_GAP_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_RC_TRNS 0x42C20230
#define IG3_DBL_GLPE_DBL_BOB1_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS 0x42C20208
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_RESERVED_31_8_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_I_FREEZE_S 6
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_I_FREEZE_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_READY_S 5
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_READY_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_VALID_S 4
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_VALID_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_BOB1_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_TRANS_CNT 0x42C20218
#define IG3_DBL_GLPE_DBL_BOB1_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_TRIG_MASK 0x42C20248
#define IG3_DBL_GLPE_DBL_BOB1_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_DBL_GLPE_DBL_BOB1_BOB_TRIG_VALUE 0x42C20250
#define IG3_DBL_GLPE_DBL_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_DBL_GLPE_DBL_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_DBL_GLPE_DBL_CONFIG 0x42C20000
#define IG3_DBL_GLPE_DBL_CONFIG_RSVD_S 2
#define IG3_DBL_GLPE_DBL_CONFIG_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_DBL_GLPE_DBL_CONFIG_RSVD_S)
#define IG3_DBL_GLPE_DBL_CONFIG_DP_CONFIG_S 0
#define IG3_DBL_GLPE_DBL_CONFIG_DP_CONFIG_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_DBL_CONFIG_DP_CONFIG_S)
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_COUNT 0x42C20138
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_DBL_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DBL_GLPE_DBL_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_CMD 0x42C2014C
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_DATA_H 0x42C20158
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_DATA_L 0x42C20154
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_PTR 0x42C20150
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DBL_GLPE_DBL_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_CMD 0x42C2013C
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_DATA_H 0x42C20148
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_DATA_L 0x42C20144
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_PTR 0x42C20140
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DBL_GLPE_DBL_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_CONTROL 0x42C20100
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_RSVD1_S 25
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_DBL_DTM_CONTROL_RSVD1_S)
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_RSVD2_S 17
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_DBL_DTM_CONTROL_RSVD2_S)
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_RSVD3_S 9
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_DBL_DTM_CONTROL_RSVD3_S)
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_BYPASS_S 8
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_CONTROL_BYPASS_S)
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_RSVD4_S 1
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_DBL_DTM_CONTROL_RSVD4_S)
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_DBL_GLPE_DBL_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_CONTROL_LOCAL_EN_S)
#define IG3_DBL_GLPE_DBL_DTM_ECC_COR_ERR 0x42C20168
#define IG3_DBL_GLPE_DBL_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_DBL_GLPE_DBL_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DBL_GLPE_DBL_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_DBL_GLPE_DBL_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_DBL_GLPE_DBL_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_DBL_DTM_ECC_COR_ERR_CNT_S)
#define IG3_DBL_GLPE_DBL_DTM_ECC_UNCOR_ERR 0x42C20164
#define IG3_DBL_GLPE_DBL_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_DBL_GLPE_DBL_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DBL_GLPE_DBL_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_DBL_GLPE_DBL_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_DBL_GLPE_DBL_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_DBL_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_DBL_GLPE_DBL_DTM_GROUP_CFG 0x42C2010C
#define IG3_DBL_GLPE_DBL_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_DBL_GLPE_DBL_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_DBL_DTM_GROUP_CFG_RSVD1_S)
#define IG3_DBL_GLPE_DBL_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_DBL_GLPE_DBL_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_DBL_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_DBL_GLPE_DBL_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_DBL_GLPE_DBL_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_DBL_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_DBL_GLPE_DBL_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_DBL_GLPE_DBL_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_DBL_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_DBL_GLPE_DBL_DTM_LOG_CFG 0x42C20110
#define IG3_DBL_GLPE_DBL_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_DBL_GLPE_DBL_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_DBL_GLPE_DBL_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_DBL_GLPE_DBL_DTM_LOG_CFG_RSVD1_S 2
#define IG3_DBL_GLPE_DBL_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_DBL_GLPE_DBL_DTM_LOG_CFG_RSVD1_S)
#define IG3_DBL_GLPE_DBL_DTM_LOG_CFG_MODE_S 0
#define IG3_DBL_GLPE_DBL_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_DBL_DTM_LOG_CFG_MODE_S)
#define IG3_DBL_GLPE_DBL_DTM_LOG_MASK 0x42C20118
#define IG3_DBL_GLPE_DBL_DTM_LOG_MASK_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_DTM_LOG_MASK_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_LOG_PATTERN 0x42C20114
#define IG3_DBL_GLPE_DBL_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_DTM_LOG_PATTERN_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_MAIN_CFG 0x42C20104
#define IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_RSVD1_S)
#define IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_RSVD2_S)
#define IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_RSVD3_S)
#define IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_DBL_GLPE_DBL_DTM_MAIN_STS 0x42C20108
#define IG3_DBL_GLPE_DBL_DTM_MAIN_STS_RSVD1_S 9
#define IG3_DBL_GLPE_DBL_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_DBL_GLPE_DBL_DTM_MAIN_STS_RSVD1_S)
#define IG3_DBL_GLPE_DBL_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_DBL_GLPE_DBL_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_DBL_GLPE_DBL_DTM_MAIN_STS_RSVD2_S 1
#define IG3_DBL_GLPE_DBL_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_DBL_DTM_MAIN_STS_RSVD2_S)
#define IG3_DBL_GLPE_DBL_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_DBL_GLPE_DBL_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_DBL_GLPE_DBL_DTM_TIMESTAMP 0x42C20130
#define IG3_DBL_GLPE_DBL_DTM_TIMESTAMP_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_DTM_TIMESTAMP_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_TIMESTAMP_ROLLOVER 0x42C20134
#define IG3_DBL_GLPE_DBL_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG 0x42C2015C
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS 0x42C20160
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DBL_GLPE_DBL_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_DBL_GLPE_DBL_DTM_TRIG_CFG 0x42C2011C
#define IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_RSVD1_S)
#define IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_RSVD2_S)
#define IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_MODE_S 0
#define IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_DBL_DTM_TRIG_CFG_MODE_S)
#define IG3_DBL_GLPE_DBL_DTM_TRIG_COUNT 0x42C20128
#define IG3_DBL_GLPE_DBL_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_DTM_TRIG_COUNT_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_TRIG_MASK 0x42C20124
#define IG3_DBL_GLPE_DBL_DTM_TRIG_MASK_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_DTM_TRIG_MASK_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_TRIG_PATTERN 0x42C20120
#define IG3_DBL_GLPE_DBL_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_DBL_GLPE_DBL_DTM_TRIG_TIMESTAMP 0x42C2012C
#define IG3_DBL_GLPE_DBL_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_DBL_GLPE_DBL_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DBL_GLPE_DBL_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_DBL_GLPE_DBL_ECC_COR_ERR 0x42C200BC
#define IG3_DBL_GLPE_DBL_ECC_COR_ERR_RSVD_S 12
#define IG3_DBL_GLPE_DBL_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DBL_GLPE_DBL_ECC_COR_ERR_RSVD_S)
#define IG3_DBL_GLPE_DBL_ECC_COR_ERR_CNT_S 0
#define IG3_DBL_GLPE_DBL_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_DBL_ECC_COR_ERR_CNT_S)
#define IG3_DBL_GLPE_DBL_ECC_UNCOR_ERR 0x42C200B8
#define IG3_DBL_GLPE_DBL_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_DBL_GLPE_DBL_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DBL_GLPE_DBL_ECC_UNCOR_ERR_RSVD_S)
#define IG3_DBL_GLPE_DBL_ECC_UNCOR_ERR_CNT_S 0
#define IG3_DBL_GLPE_DBL_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_DBL_ECC_UNCOR_ERR_CNT_S)
#define IG3_DBL_GLPE_DBPT_CTRL 0x42C20020
#define IG3_DBL_GLPE_DBPT_CTRL_BUSY_S 31
#define IG3_DBL_GLPE_DBPT_CTRL_BUSY_M RDMA_BIT2(32, IG3_DBL_GLPE_DBPT_CTRL_BUSY_S)
#define IG3_DBL_GLPE_DBPT_CTRL_RSVD1_S 27
#define IG3_DBL_GLPE_DBPT_CTRL_RSVD1_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_DBPT_CTRL_RSVD1_S)
#define IG3_DBL_GLPE_DBPT_CTRL_DBPTIDX_S 16
#define IG3_DBL_GLPE_DBPT_CTRL_DBPTIDX_M RDMA_MASK3(32, 0x7FF, IG3_DBL_GLPE_DBPT_CTRL_DBPTIDX_S)
#define IG3_DBL_GLPE_DBPT_CTRL_RSVD0_S 1
#define IG3_DBL_GLPE_DBPT_CTRL_RSVD0_M RDMA_MASK3(32, 0x7FFF, IG3_DBL_GLPE_DBPT_CTRL_RSVD0_S)
#define IG3_DBL_GLPE_DBPT_CTRL_WR_S 0
#define IG3_DBL_GLPE_DBPT_CTRL_WR_M RDMA_BIT2(32, IG3_DBL_GLPE_DBPT_CTRL_WR_S)
#define IG3_DBL_GLPE_DBPT_DATA0 0x42C20024
#define IG3_DBL_GLPE_DBPT_DATA0_PAGE_TYPE_S 28
#define IG3_DBL_GLPE_DBPT_DATA0_PAGE_TYPE_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_DBPT_DATA0_PAGE_TYPE_S)
#define IG3_DBL_GLPE_DBPT_DATA0_VSI_S 16
#define IG3_DBL_GLPE_DBPT_DATA0_VSI_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_DBPT_DATA0_VSI_S)
#define IG3_DBL_GLPE_DBPT_DATA0_TC_S 11
#define IG3_DBL_GLPE_DBPT_DATA0_TC_M RDMA_MASK3(32, 0x1F, IG3_DBL_GLPE_DBPT_DATA0_TC_S)
#define IG3_DBL_GLPE_DBPT_DATA0_PHY_PORT_S 8
#define IG3_DBL_GLPE_DBPT_DATA0_PHY_PORT_M RDMA_MASK3(32, 0x7, IG3_DBL_GLPE_DBPT_DATA0_PHY_PORT_S)
#define IG3_DBL_GLPE_DBPT_DATA0_RSVD0_S 7
#define IG3_DBL_GLPE_DBPT_DATA0_RSVD0_M RDMA_BIT2(32, IG3_DBL_GLPE_DBPT_DATA0_RSVD0_S)
#define IG3_DBL_GLPE_DBPT_DATA0_CREDIT_INDEX_S 0
#define IG3_DBL_GLPE_DBPT_DATA0_CREDIT_INDEX_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_DBPT_DATA0_CREDIT_INDEX_S)
#define IG3_DBL_GLPE_DBPT_DATA1 0x42C20028
#define IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_S 31
#define IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_M RDMA_BIT2(32, IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_S)
#define IG3_DBL_GLPE_DBPT_DATA1_RSVD_S 23
#define IG3_DBL_GLPE_DBPT_DATA1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_DBPT_DATA1_RSVD_S)
#define IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_HOSTID_S 20
#define IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_HOSTID_M RDMA_MASK3(32, 0x7, IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_HOSTID_S)
#define IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_VDEV_VF_TYPE_S 18
#define IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_VDEV_VF_TYPE_S)
#define IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_VDEV_VF_S 6
#define IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_VDEV_VF_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_VDEV_VF_S)
#define IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_PF_S 0
#define IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_PF_M RDMA_MASK3(32, 0x3F, IG3_DBL_GLPE_DBPT_DATA1_VALIDATE_PF_S)
#define IG3_DBL_GLPE_DBPT_DATA2 0x42C2002C
#define IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_S 31
#define IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_M RDMA_BIT2(32, IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_S)
#define IG3_DBL_GLPE_DBPT_DATA2_RSVD_S 23
#define IG3_DBL_GLPE_DBPT_DATA2_RSVD_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_DBPT_DATA2_RSVD_S)
#define IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_HOSTID_S 20
#define IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_HOSTID_M RDMA_MASK3(32, 0x7, IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_HOSTID_S)
#define IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_VDEV_VF_TYPE_S 18
#define IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_VDEV_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_VDEV_VF_TYPE_S)
#define IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_VDEV_VF_S 6
#define IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_VDEV_VF_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_VDEV_VF_S)
#define IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_PF_S 0
#define IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_PF_M RDMA_MASK3(32, 0x3F, IG3_DBL_GLPE_DBPT_DATA2_OVERRIDE_PF_S)
#define IG3_DBL_GLPE_DESTROY_QP_HIGH(_i) 0x42C2000C + ((_i) * 4) /* _i=0...1 */
#define IG3_DBL_GLPE_DESTROY_QP_HIGH_MAX_INDEX_I 1
#define IG3_DBL_GLPE_DESTROY_QP_HIGH_VALID_S 31
#define IG3_DBL_GLPE_DESTROY_QP_HIGH_VALID_M RDMA_BIT2(32, IG3_DBL_GLPE_DESTROY_QP_HIGH_VALID_S)
#define IG3_DBL_GLPE_DESTROY_QP_HIGH_RSVD_S 12
#define IG3_DBL_GLPE_DESTROY_QP_HIGH_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_DBL_GLPE_DESTROY_QP_HIGH_RSVD_S)
#define IG3_DBL_GLPE_DESTROY_QP_HIGH_PMF_S 0
#define IG3_DBL_GLPE_DESTROY_QP_HIGH_PMF_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_DESTROY_QP_HIGH_PMF_S)
#define IG3_DBL_GLPE_DESTROY_QP_LOW(_i) 0x42C20004 + ((_i) * 4) /* _i=0...1 */
#define IG3_DBL_GLPE_DESTROY_QP_LOW_MAX_INDEX_I 1
#define IG3_DBL_GLPE_DESTROY_QP_LOW_RSVD_S 24
#define IG3_DBL_GLPE_DESTROY_QP_LOW_RSVD_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_DESTROY_QP_LOW_RSVD_S)
#define IG3_DBL_GLPE_DESTROY_QP_LOW_Q_NUM_S 0
#define IG3_DBL_GLPE_DESTROY_QP_LOW_Q_NUM_M RDMA_MASK3(32, 0xFFFFFF, IG3_DBL_GLPE_DESTROY_QP_LOW_Q_NUM_S)
#define IG3_DBL_GLPE_PRLCT_CTRL 0x42C20030
#define IG3_DBL_GLPE_PRLCT_CTRL_BUSY_S 31
#define IG3_DBL_GLPE_PRLCT_CTRL_BUSY_M RDMA_BIT2(32, IG3_DBL_GLPE_PRLCT_CTRL_BUSY_S)
#define IG3_DBL_GLPE_PRLCT_CTRL_RSVD2_S 28
#define IG3_DBL_GLPE_PRLCT_CTRL_RSVD2_M RDMA_MASK3(32, 0x7, IG3_DBL_GLPE_PRLCT_CTRL_RSVD2_S)
#define IG3_DBL_GLPE_PRLCT_CTRL_RL_S 16
#define IG3_DBL_GLPE_PRLCT_CTRL_RL_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_PRLCT_CTRL_RL_S)
#define IG3_DBL_GLPE_PRLCT_CTRL_RSVD1_S 15
#define IG3_DBL_GLPE_PRLCT_CTRL_RSVD1_M RDMA_BIT2(32, IG3_DBL_GLPE_PRLCT_CTRL_RSVD1_S)
#define IG3_DBL_GLPE_PRLCT_CTRL_TABLE_INDEX_S 8
#define IG3_DBL_GLPE_PRLCT_CTRL_TABLE_INDEX_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_PRLCT_CTRL_TABLE_INDEX_S)
#define IG3_DBL_GLPE_PRLCT_CTRL_RSVD0_S 1
#define IG3_DBL_GLPE_PRLCT_CTRL_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_PRLCT_CTRL_RSVD0_S)
#define IG3_DBL_GLPE_PRLCT_CTRL_WR_S 0
#define IG3_DBL_GLPE_PRLCT_CTRL_WR_M RDMA_BIT2(32, IG3_DBL_GLPE_PRLCT_CTRL_WR_S)
#define IG3_DBL_GLPE_PRLCT_DATA 0x42C20034
#define IG3_DBL_GLPE_PRLCT_DATA_VALID_S 31
#define IG3_DBL_GLPE_PRLCT_DATA_VALID_M RDMA_BIT2(32, IG3_DBL_GLPE_PRLCT_DATA_VALID_S)
#define IG3_DBL_GLPE_PRLCT_DATA_RSVD2_S 23
#define IG3_DBL_GLPE_PRLCT_DATA_RSVD2_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_PRLCT_DATA_RSVD2_S)
#define IG3_DBL_GLPE_PRLCT_DATA_QUANTA_CREDITS_S 16
#define IG3_DBL_GLPE_PRLCT_DATA_QUANTA_CREDITS_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_PRLCT_DATA_QUANTA_CREDITS_S)
#define IG3_DBL_GLPE_PRLCT_DATA_RSVD1_S 15
#define IG3_DBL_GLPE_PRLCT_DATA_RSVD1_M RDMA_BIT2(32, IG3_DBL_GLPE_PRLCT_DATA_RSVD1_S)
#define IG3_DBL_GLPE_PRLCT_DATA_CREDIT_WATERMARK2_S 8
#define IG3_DBL_GLPE_PRLCT_DATA_CREDIT_WATERMARK2_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_PRLCT_DATA_CREDIT_WATERMARK2_S)
#define IG3_DBL_GLPE_PRLCT_DATA_RSVD0_S 7
#define IG3_DBL_GLPE_PRLCT_DATA_RSVD0_M RDMA_BIT2(32, IG3_DBL_GLPE_PRLCT_DATA_RSVD0_S)
#define IG3_DBL_GLPE_PRLCT_DATA_CREDIT_WATERMARK1_S 0
#define IG3_DBL_GLPE_PRLCT_DATA_CREDIT_WATERMARK1_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_PRLCT_DATA_CREDIT_WATERMARK1_S)
#define IG3_DBL_GLPE_PRLCT_DATA1 0x42C20038
#define IG3_DBL_GLPE_PRLCT_DATA1_RSVD_S 16
#define IG3_DBL_GLPE_PRLCT_DATA1_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_DBL_GLPE_PRLCT_DATA1_RSVD_S)
#define IG3_DBL_GLPE_PRLCT_DATA1_ERLID_S 0
#define IG3_DBL_GLPE_PRLCT_DATA1_ERLID_M RDMA_MASK3(32, 0xFFFF, IG3_DBL_GLPE_PRLCT_DATA1_ERLID_S)
#define IG3_DBL_GLPE_PSHINVACCESSTRC(_i) 0x42C20068 + ((_i) * 4) /* _i=0...7 */
#define IG3_DBL_GLPE_PSHINVACCESSTRC_MAX_INDEX_I 7
#define IG3_DBL_GLPE_PSHINVACCESSTRC_VALID_S 31
#define IG3_DBL_GLPE_PSHINVACCESSTRC_VALID_M RDMA_BIT2(32, IG3_DBL_GLPE_PSHINVACCESSTRC_VALID_S)
#define IG3_DBL_GLPE_PSHINVACCESSTRC_RSVD_S 29
#define IG3_DBL_GLPE_PSHINVACCESSTRC_RSVD_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_PSHINVACCESSTRC_RSVD_S)
#define IG3_DBL_GLPE_PSHINVACCESSTRC_PAGEIDX_S 16
#define IG3_DBL_GLPE_PSHINVACCESSTRC_PAGEIDX_M RDMA_MASK3(32, 0x1FFF, IG3_DBL_GLPE_PSHINVACCESSTRC_PAGEIDX_S)
#define IG3_DBL_GLPE_PSHINVACCESSTRC_OFFSETIDX_S 10
#define IG3_DBL_GLPE_PSHINVACCESSTRC_OFFSETIDX_M RDMA_MASK3(32, 0x3F, IG3_DBL_GLPE_PSHINVACCESSTRC_OFFSETIDX_S)
#define IG3_DBL_GLPE_PSHINVACCESSTRC_PFVFFLAG_S 8
#define IG3_DBL_GLPE_PSHINVACCESSTRC_PFVFFLAG_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_PSHINVACCESSTRC_PFVFFLAG_S)
#define IG3_DBL_GLPE_PSHINVACCESSTRC_VFIDX_S 0
#define IG3_DBL_GLPE_PSHINVACCESSTRC_VFIDX_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_PSHINVACCESSTRC_VFIDX_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG 0x42C20088
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RSVD3_S 20
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RSVD3_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RM_S 16
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RM_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RSVD2_S 14
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RSVD2_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RME_S 12
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RME_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RSVD1_S 10
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RSVD1_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ERR_CNT_S 9
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ERR_CNT_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_FIX_CNT_S 8
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_FIX_CNT_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RSVD0_S 6
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_RSVD0_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_MASK_INT_S 5
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_MASK_INT_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_LS_BYPASS_S 4
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_LS_BYPASS_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_LS_FORCE_S 3
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_LS_FORCE_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ECC_EN_S 0
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_CFG_ECC_EN_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS 0x42C2008C
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_RSVD1_S 30
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_RSVD1_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_RSVD0_S 4
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_RSVD0_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_INIT_DONE_S 2
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_INIT_DONE_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_ECC_FIX_S 1
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_ECC_FIX_S)
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_ECC_ERR_S 0
#define IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER0_MEM_STATUS_ECC_ERR_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG 0x42C20090
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RSVD3_S 20
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RSVD3_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RM_S 16
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RM_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RSVD2_S 14
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RSVD2_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RME_S 12
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RME_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RSVD1_S 10
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RSVD1_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ERR_CNT_S 9
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ERR_CNT_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_FIX_CNT_S 8
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_FIX_CNT_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RSVD0_S 6
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_RSVD0_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_MASK_INT_S 5
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_MASK_INT_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_LS_BYPASS_S 4
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_LS_BYPASS_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_LS_FORCE_S 3
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_LS_FORCE_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ECC_EN_S 0
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_CFG_ECC_EN_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS 0x42C20094
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_RSVD1_S 30
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_RSVD1_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_RSVD0_S 4
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_RSVD0_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_INIT_DONE_S 2
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_INIT_DONE_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_ECC_FIX_S 1
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_ECC_FIX_S)
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_ECC_ERR_S 0
#define IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_BUFFER1_MEM_STATUS_ECC_ERR_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG 0x42C20098
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RSVD3_S 20
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RSVD3_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RM_S 16
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RM_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RSVD2_S 14
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RSVD2_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RME_S 12
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RME_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RSVD1_S 10
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RSVD1_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ERR_CNT_S 9
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ERR_CNT_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_FIX_CNT_S 8
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_FIX_CNT_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RSVD0_S 6
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_RSVD0_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_MASK_INT_S 5
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_MASK_INT_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_LS_BYPASS_S 4
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_LS_BYPASS_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_LS_FORCE_S 3
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_LS_FORCE_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ECC_EN_S 0
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_DBPT_MEM_CFG_ECC_EN_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS 0x42C2009C
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_RSVD1_S 30
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_RSVD1_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_RSVD0_S 4
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_RSVD0_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_INIT_DONE_S 2
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_INIT_DONE_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_ECC_FIX_S 1
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_ECC_FIX_S)
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_ECC_ERR_S 0
#define IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DBL_GLPE_PUSH_DBPT_MEM_STATUS_ECC_ERR_S)
#define IG3_DBL_GLPE_PUSH_GCPERIOD 0x42C2001C
#define IG3_DBL_GLPE_PUSH_GCPERIOD_PERIOD_S 10
#define IG3_DBL_GLPE_PUSH_GCPERIOD_PERIOD_M RDMA_MASK3(32, 0x3FFFFF, IG3_DBL_GLPE_PUSH_GCPERIOD_PERIOD_S)
#define IG3_DBL_GLPE_PUSH_GCPERIOD_LOBITS_S 0
#define IG3_DBL_GLPE_PUSH_GCPERIOD_LOBITS_M RDMA_MASK3(32, 0x3FF, IG3_DBL_GLPE_PUSH_GCPERIOD_LOBITS_S)
#define IG3_DBL_GLPE_PUSH_SCHED_CONFIG 0x42C2005C
#define IG3_DBL_GLPE_PUSH_SCHED_CONFIG_RSVD_S 14
#define IG3_DBL_GLPE_PUSH_SCHED_CONFIG_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_DBL_GLPE_PUSH_SCHED_CONFIG_RSVD_S)
#define IG3_DBL_GLPE_PUSH_SCHED_CONFIG_QUANTA_S 0
#define IG3_DBL_GLPE_PUSH_SCHED_CONFIG_QUANTA_M RDMA_MASK3(32, 0x3FFF, IG3_DBL_GLPE_PUSH_SCHED_CONFIG_QUANTA_S)
#define IG3_DBL_GLPE_QPART_CTRL0 0x42C2003C
#define IG3_DBL_GLPE_QPART_CTRL0_BUSY_S 31
#define IG3_DBL_GLPE_QPART_CTRL0_BUSY_M RDMA_BIT2(32, IG3_DBL_GLPE_QPART_CTRL0_BUSY_S)
#define IG3_DBL_GLPE_QPART_CTRL0_RSVD1_S 19
#define IG3_DBL_GLPE_QPART_CTRL0_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_QPART_CTRL0_RSVD1_S)
#define IG3_DBL_GLPE_QPART_CTRL0_ADDR_S 8
#define IG3_DBL_GLPE_QPART_CTRL0_ADDR_M RDMA_MASK3(32, 0x7FF, IG3_DBL_GLPE_QPART_CTRL0_ADDR_S)
#define IG3_DBL_GLPE_QPART_CTRL0_RSVD0_S 3
#define IG3_DBL_GLPE_QPART_CTRL0_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_DBL_GLPE_QPART_CTRL0_RSVD0_S)
#define IG3_DBL_GLPE_QPART_CTRL0_OP_S 0
#define IG3_DBL_GLPE_QPART_CTRL0_OP_M RDMA_MASK3(32, 0x7, IG3_DBL_GLPE_QPART_CTRL0_OP_S)
#define IG3_DBL_GLPE_QPART_CTRL1 0x42C20040
#define IG3_DBL_GLPE_QPART_CTRL1_VALID_MASK_S 31
#define IG3_DBL_GLPE_QPART_CTRL1_VALID_MASK_M RDMA_BIT2(32, IG3_DBL_GLPE_QPART_CTRL1_VALID_MASK_S)
#define IG3_DBL_GLPE_QPART_CTRL1_VALID_S 30
#define IG3_DBL_GLPE_QPART_CTRL1_VALID_M RDMA_BIT2(32, IG3_DBL_GLPE_QPART_CTRL1_VALID_S)
#define IG3_DBL_GLPE_QPART_CTRL1_PMF_MASK_S 29
#define IG3_DBL_GLPE_QPART_CTRL1_PMF_MASK_M RDMA_BIT2(32, IG3_DBL_GLPE_QPART_CTRL1_PMF_MASK_S)
#define IG3_DBL_GLPE_QPART_CTRL1_RSVD1_S 27
#define IG3_DBL_GLPE_QPART_CTRL1_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_QPART_CTRL1_RSVD1_S)
#define IG3_DBL_GLPE_QPART_CTRL1_PMF_S 16
#define IG3_DBL_GLPE_QPART_CTRL1_PMF_M RDMA_MASK3(32, 0x7FF, IG3_DBL_GLPE_QPART_CTRL1_PMF_S)
#define IG3_DBL_GLPE_QPART_CTRL1_QUEUE_MASK_S 15
#define IG3_DBL_GLPE_QPART_CTRL1_QUEUE_MASK_M RDMA_BIT2(32, IG3_DBL_GLPE_QPART_CTRL1_QUEUE_MASK_S)
#define IG3_DBL_GLPE_QPART_CTRL1_RSVD0_S 11
#define IG3_DBL_GLPE_QPART_CTRL1_RSVD0_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_QPART_CTRL1_RSVD0_S)
#define IG3_DBL_GLPE_QPART_CTRL1_QUEUE_S 0
#define IG3_DBL_GLPE_QPART_CTRL1_QUEUE_M RDMA_MASK3(32, 0x7FF, IG3_DBL_GLPE_QPART_CTRL1_QUEUE_S)
#define IG3_DBL_GLPE_QPART_DATA0 0x42C20044
#define IG3_DBL_GLPE_QPART_DATA0_RSVD1_S 31
#define IG3_DBL_GLPE_QPART_DATA0_RSVD1_M RDMA_BIT2(32, IG3_DBL_GLPE_QPART_DATA0_RSVD1_S)
#define IG3_DBL_GLPE_QPART_DATA0_HITCNT_S 19
#define IG3_DBL_GLPE_QPART_DATA0_HITCNT_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_QPART_DATA0_HITCNT_S)
#define IG3_DBL_GLPE_QPART_DATA0_ADDR_S 8
#define IG3_DBL_GLPE_QPART_DATA0_ADDR_M RDMA_MASK3(32, 0x7FF, IG3_DBL_GLPE_QPART_DATA0_ADDR_S)
#define IG3_DBL_GLPE_QPART_DATA0_RSVD0_S 0
#define IG3_DBL_GLPE_QPART_DATA0_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_QPART_DATA0_RSVD0_S)
#define IG3_DBL_GLPE_QPART_DATA1 0x42C20048
#define IG3_DBL_GLPE_QPART_DATA1_RSVD1_S 31
#define IG3_DBL_GLPE_QPART_DATA1_RSVD1_M RDMA_BIT2(32, IG3_DBL_GLPE_QPART_DATA1_RSVD1_S)
#define IG3_DBL_GLPE_QPART_DATA1_VALID_S 30
#define IG3_DBL_GLPE_QPART_DATA1_VALID_M RDMA_BIT2(32, IG3_DBL_GLPE_QPART_DATA1_VALID_S)
#define IG3_DBL_GLPE_QPART_DATA1_ERROR_S 29
#define IG3_DBL_GLPE_QPART_DATA1_ERROR_M RDMA_BIT2(32, IG3_DBL_GLPE_QPART_DATA1_ERROR_S)
#define IG3_DBL_GLPE_QPART_DATA1_HIT_S 28
#define IG3_DBL_GLPE_QPART_DATA1_HIT_M RDMA_BIT2(32, IG3_DBL_GLPE_QPART_DATA1_HIT_S)
#define IG3_DBL_GLPE_QPART_DATA1_PMF_S 16
#define IG3_DBL_GLPE_QPART_DATA1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_QPART_DATA1_PMF_S)
#define IG3_DBL_GLPE_QPART_DATA1_RSVD0_S 11
#define IG3_DBL_GLPE_QPART_DATA1_RSVD0_M RDMA_MASK3(32, 0x1F, IG3_DBL_GLPE_QPART_DATA1_RSVD0_S)
#define IG3_DBL_GLPE_QPART_DATA1_QUEUE_S 0
#define IG3_DBL_GLPE_QPART_DATA1_QUEUE_M RDMA_MASK3(32, 0x7FF, IG3_DBL_GLPE_QPART_DATA1_QUEUE_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG 0x42C200A0
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_QP_DBA_MEM_CFG_ECC_INST_NUM_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_RSVD3_S 20
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DBL_GLPE_QP_DBA_MEM_CFG_RSVD3_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_RM_S 16
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_QP_DBA_MEM_CFG_RM_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_RSVD2_S 14
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_QP_DBA_MEM_CFG_RSVD2_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_QP_DBA_MEM_CFG_POWER_GATE_EN_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_RME_S 12
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_RME_M RDMA_BIT2(32, IG3_DBL_GLPE_QP_DBA_MEM_CFG_RME_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_RSVD1_S 10
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_QP_DBA_MEM_CFG_RSVD1_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_ERR_CNT_S 9
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_QP_DBA_MEM_CFG_ERR_CNT_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_FIX_CNT_S 8
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_QP_DBA_MEM_CFG_FIX_CNT_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_RSVD0_S 6
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_QP_DBA_MEM_CFG_RSVD0_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_MASK_INT_S 5
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DBL_GLPE_QP_DBA_MEM_CFG_MASK_INT_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_LS_BYPASS_S 4
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DBL_GLPE_QP_DBA_MEM_CFG_LS_BYPASS_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_LS_FORCE_S 3
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DBL_GLPE_QP_DBA_MEM_CFG_LS_FORCE_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DBL_GLPE_QP_DBA_MEM_CFG_ECC_INVERT_2_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DBL_GLPE_QP_DBA_MEM_CFG_ECC_INVERT_1_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_ECC_EN_S 0
#define IG3_DBL_GLPE_QP_DBA_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_QP_DBA_MEM_CFG_ECC_EN_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS 0x42C200A4
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS_RSVD1_S 30
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_QP_DBA_MEM_STATUS_RSVD1_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DBL_GLPE_QP_DBA_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS_RSVD0_S 4
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_QP_DBA_MEM_STATUS_RSVD0_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_QP_DBA_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS_INIT_DONE_S 2
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_QP_DBA_MEM_STATUS_INIT_DONE_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS_ECC_FIX_S 1
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DBL_GLPE_QP_DBA_MEM_STATUS_ECC_FIX_S)
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS_ECC_ERR_S 0
#define IG3_DBL_GLPE_QP_DBA_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DBL_GLPE_QP_DBA_MEM_STATUS_ECC_ERR_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL 0x42C20060
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_BUSY_S 31
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_BUSY_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_BUSY_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_RSVD1_S 26
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_RSVD1_M RDMA_MASK3(32, 0x1F, IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_RSVD1_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_MAPIDX_S 16
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_MAPIDX_M RDMA_MASK3(32, 0x3FF, IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_MAPIDX_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_RSVD0_S 1
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_RSVD0_M RDMA_MASK3(32, 0x7FFF, IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_RSVD0_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_WR_S 0
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_WR_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_CTRL_WR_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_DATA 0x42C20064
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_DATA_RSVD1_S 29
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_DATA_RSVD1_M RDMA_MASK3(32, 0x7, IG3_DBL_GLPE_VF_DBPAGE_MAP_DATA_RSVD1_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_DATA_BASE_S 16
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_DATA_BASE_M RDMA_MASK3(32, 0x1FFF, IG3_DBL_GLPE_VF_DBPAGE_MAP_DATA_BASE_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_DATA_RSVD0_S 4
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_DATA_RSVD0_M RDMA_MASK3(32, 0xFFF, IG3_DBL_GLPE_VF_DBPAGE_MAP_DATA_RSVD0_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_DATA_SIZE_S 0
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_DATA_SIZE_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_VF_DBPAGE_MAP_DATA_SIZE_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG 0x42C200B0
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ECC_INST_NUM_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RSVD3_S 20
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RSVD3_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RM_S 16
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RM_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RSVD2_S 14
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RSVD2_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_POWER_GATE_EN_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RME_S 12
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RME_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RME_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RSVD1_S 10
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RSVD1_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ERR_CNT_S 9
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ERR_CNT_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_FIX_CNT_S 8
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_FIX_CNT_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RSVD0_S 6
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_RSVD0_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_MASK_INT_S 5
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_MASK_INT_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_LS_BYPASS_S 4
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_LS_BYPASS_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_LS_FORCE_S 3
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_LS_FORCE_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ECC_INVERT_2_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ECC_INVERT_1_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ECC_EN_S 0
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_CFG_ECC_EN_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS 0x42C200B4
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_RSVD1_S 30
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_RSVD1_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_RSVD0_S 4
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_RSVD0_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_INIT_DONE_S 2
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_INIT_DONE_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_ECC_FIX_S 1
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_ECC_FIX_S)
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_ECC_ERR_S 0
#define IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DBL_GLPE_VF_DBPAGE_MAP_MEM_STATUS_ECC_ERR_S)
#define IG3_RHI_CQM_CLIENT_CRED_HOST(_i) 0x42C30014 + ((_i) * 4) /* _i=0...4 */
#define IG3_RHI_CQM_CLIENT_CRED_HOST_MAX_INDEX_I 4
#define IG3_RHI_CQM_CLIENT_CRED_HOST_RSVD_S 16
#define IG3_RHI_CQM_CLIENT_CRED_HOST_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_RHI_CQM_CLIENT_CRED_HOST_RSVD_S)
#define IG3_RHI_CQM_CLIENT_CRED_HOST_DATA_CRED_S 8
#define IG3_RHI_CQM_CLIENT_CRED_HOST_DATA_CRED_M RDMA_MASK3(32, 0xFF, IG3_RHI_CQM_CLIENT_CRED_HOST_DATA_CRED_S)
#define IG3_RHI_CQM_CLIENT_CRED_HOST_CMD_CRED_S 0
#define IG3_RHI_CQM_CLIENT_CRED_HOST_CMD_CRED_M RDMA_MASK3(32, 0xFF, IG3_RHI_CQM_CLIENT_CRED_HOST_CMD_CRED_S)
#define IG3_RHI_CQM_CMD_MEM_CFG 0x42C300F0
#define IG3_RHI_CQM_CMD_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_RHI_CQM_CMD_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RHI_CQM_CMD_MEM_CFG_ECC_INST_NUM_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_RSVD3_S 20
#define IG3_RHI_CQM_CMD_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RHI_CQM_CMD_MEM_CFG_RSVD3_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_RM_S 16
#define IG3_RHI_CQM_CMD_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RHI_CQM_CMD_MEM_CFG_RM_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_RSVD2_S 14
#define IG3_RHI_CQM_CMD_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RHI_CQM_CMD_MEM_CFG_RSVD2_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_RHI_CQM_CMD_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RHI_CQM_CMD_MEM_CFG_POWER_GATE_EN_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_RME_S 12
#define IG3_RHI_CQM_CMD_MEM_CFG_RME_M RDMA_BIT2(32, IG3_RHI_CQM_CMD_MEM_CFG_RME_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_RSVD1_S 10
#define IG3_RHI_CQM_CMD_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHI_CQM_CMD_MEM_CFG_RSVD1_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_ERR_CNT_S 9
#define IG3_RHI_CQM_CMD_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RHI_CQM_CMD_MEM_CFG_ERR_CNT_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_FIX_CNT_S 8
#define IG3_RHI_CQM_CMD_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RHI_CQM_CMD_MEM_CFG_FIX_CNT_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_RSVD0_S 6
#define IG3_RHI_CQM_CMD_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RHI_CQM_CMD_MEM_CFG_RSVD0_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_MASK_INT_S 5
#define IG3_RHI_CQM_CMD_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RHI_CQM_CMD_MEM_CFG_MASK_INT_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_LS_BYPASS_S 4
#define IG3_RHI_CQM_CMD_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RHI_CQM_CMD_MEM_CFG_LS_BYPASS_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_LS_FORCE_S 3
#define IG3_RHI_CQM_CMD_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RHI_CQM_CMD_MEM_CFG_LS_FORCE_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_RHI_CQM_CMD_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RHI_CQM_CMD_MEM_CFG_ECC_INVERT_2_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_RHI_CQM_CMD_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RHI_CQM_CMD_MEM_CFG_ECC_INVERT_1_S)
#define IG3_RHI_CQM_CMD_MEM_CFG_ECC_EN_S 0
#define IG3_RHI_CQM_CMD_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RHI_CQM_CMD_MEM_CFG_ECC_EN_S)
#define IG3_RHI_CQM_CMD_MEM_STATUS 0x42C300EC
#define IG3_RHI_CQM_CMD_MEM_STATUS_RSVD1_S 30
#define IG3_RHI_CQM_CMD_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHI_CQM_CMD_MEM_STATUS_RSVD1_S)
#define IG3_RHI_CQM_CMD_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RHI_CQM_CMD_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RHI_CQM_CMD_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RHI_CQM_CMD_MEM_STATUS_RSVD0_S 4
#define IG3_RHI_CQM_CMD_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RHI_CQM_CMD_MEM_STATUS_RSVD0_S)
#define IG3_RHI_CQM_CMD_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RHI_CQM_CMD_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RHI_CQM_CMD_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RHI_CQM_CMD_MEM_STATUS_INIT_DONE_S 2
#define IG3_RHI_CQM_CMD_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RHI_CQM_CMD_MEM_STATUS_INIT_DONE_S)
#define IG3_RHI_CQM_CMD_MEM_STATUS_ECC_FIX_S 1
#define IG3_RHI_CQM_CMD_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RHI_CQM_CMD_MEM_STATUS_ECC_FIX_S)
#define IG3_RHI_CQM_CMD_MEM_STATUS_ECC_ERR_S 0
#define IG3_RHI_CQM_CMD_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RHI_CQM_CMD_MEM_STATUS_ECC_ERR_S)
#define IG3_RHI_CQM_DATA_MEM_CFG 0x42C300F8
#define IG3_RHI_CQM_DATA_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_RHI_CQM_DATA_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RHI_CQM_DATA_MEM_CFG_ECC_INST_NUM_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_RSVD3_S 20
#define IG3_RHI_CQM_DATA_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RHI_CQM_DATA_MEM_CFG_RSVD3_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_RM_S 16
#define IG3_RHI_CQM_DATA_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RHI_CQM_DATA_MEM_CFG_RM_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_RSVD2_S 14
#define IG3_RHI_CQM_DATA_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RHI_CQM_DATA_MEM_CFG_RSVD2_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_RHI_CQM_DATA_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RHI_CQM_DATA_MEM_CFG_POWER_GATE_EN_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_RME_S 12
#define IG3_RHI_CQM_DATA_MEM_CFG_RME_M RDMA_BIT2(32, IG3_RHI_CQM_DATA_MEM_CFG_RME_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_RSVD1_S 10
#define IG3_RHI_CQM_DATA_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHI_CQM_DATA_MEM_CFG_RSVD1_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_ERR_CNT_S 9
#define IG3_RHI_CQM_DATA_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RHI_CQM_DATA_MEM_CFG_ERR_CNT_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_FIX_CNT_S 8
#define IG3_RHI_CQM_DATA_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RHI_CQM_DATA_MEM_CFG_FIX_CNT_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_RSVD0_S 6
#define IG3_RHI_CQM_DATA_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RHI_CQM_DATA_MEM_CFG_RSVD0_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_MASK_INT_S 5
#define IG3_RHI_CQM_DATA_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RHI_CQM_DATA_MEM_CFG_MASK_INT_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_LS_BYPASS_S 4
#define IG3_RHI_CQM_DATA_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RHI_CQM_DATA_MEM_CFG_LS_BYPASS_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_LS_FORCE_S 3
#define IG3_RHI_CQM_DATA_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RHI_CQM_DATA_MEM_CFG_LS_FORCE_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_RHI_CQM_DATA_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RHI_CQM_DATA_MEM_CFG_ECC_INVERT_2_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_RHI_CQM_DATA_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RHI_CQM_DATA_MEM_CFG_ECC_INVERT_1_S)
#define IG3_RHI_CQM_DATA_MEM_CFG_ECC_EN_S 0
#define IG3_RHI_CQM_DATA_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RHI_CQM_DATA_MEM_CFG_ECC_EN_S)
#define IG3_RHI_CQM_DATA_MEM_STATUS 0x42C300F4
#define IG3_RHI_CQM_DATA_MEM_STATUS_RSVD1_S 30
#define IG3_RHI_CQM_DATA_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHI_CQM_DATA_MEM_STATUS_RSVD1_S)
#define IG3_RHI_CQM_DATA_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RHI_CQM_DATA_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RHI_CQM_DATA_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RHI_CQM_DATA_MEM_STATUS_RSVD0_S 4
#define IG3_RHI_CQM_DATA_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RHI_CQM_DATA_MEM_STATUS_RSVD0_S)
#define IG3_RHI_CQM_DATA_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RHI_CQM_DATA_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RHI_CQM_DATA_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RHI_CQM_DATA_MEM_STATUS_INIT_DONE_S 2
#define IG3_RHI_CQM_DATA_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RHI_CQM_DATA_MEM_STATUS_INIT_DONE_S)
#define IG3_RHI_CQM_DATA_MEM_STATUS_ECC_FIX_S 1
#define IG3_RHI_CQM_DATA_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RHI_CQM_DATA_MEM_STATUS_ECC_FIX_S)
#define IG3_RHI_CQM_DATA_MEM_STATUS_ECC_ERR_S 0
#define IG3_RHI_CQM_DATA_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RHI_CQM_DATA_MEM_STATUS_ECC_ERR_S)
#define IG3_RHI_DEST_ARB_EN_MODE 0x42C3003C
#define IG3_RHI_DEST_ARB_EN_MODE_RSVD_S 2
#define IG3_RHI_DEST_ARB_EN_MODE_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_RHI_DEST_ARB_EN_MODE_RSVD_S)
#define IG3_RHI_DEST_ARB_EN_MODE_ARB_MODE_S 0
#define IG3_RHI_DEST_ARB_EN_MODE_ARB_MODE_M RDMA_MASK3(32, 0x3, IG3_RHI_DEST_ARB_EN_MODE_ARB_MODE_S)
#define IG3_RHI_DEST_SPRR_ARB(_i) 0x42C30040 + ((_i) * 4) /* _i=0...2 */
#define IG3_RHI_DEST_SPRR_ARB_MAX_INDEX_I 2
#define IG3_RHI_DEST_SPRR_ARB_RSVD_S 4
#define IG3_RHI_DEST_SPRR_ARB_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_RHI_DEST_SPRR_ARB_RSVD_S)
#define IG3_RHI_DEST_SPRR_ARB_SPRR_WEIGHT_S 0
#define IG3_RHI_DEST_SPRR_ARB_SPRR_WEIGHT_M RDMA_MASK3(32, 0xF, IG3_RHI_DEST_SPRR_ARB_SPRR_WEIGHT_S)
#define IG3_RHI_DEST_WRR_ARB(_i) 0x42C3004C + ((_i) * 4) /* _i=0...2 */
#define IG3_RHI_DEST_WRR_ARB_MAX_INDEX_I 2
#define IG3_RHI_DEST_WRR_ARB_RSVD_S 14
#define IG3_RHI_DEST_WRR_ARB_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_RHI_DEST_WRR_ARB_RSVD_S)
#define IG3_RHI_DEST_WRR_ARB_WRR_WEIGHT_CRED_S 4
#define IG3_RHI_DEST_WRR_ARB_WRR_WEIGHT_CRED_M RDMA_MASK3(32, 0x3FF, IG3_RHI_DEST_WRR_ARB_WRR_WEIGHT_CRED_S)
#define IG3_RHI_DEST_WRR_ARB_WRR_WEIGHT_S 0
#define IG3_RHI_DEST_WRR_ARB_WRR_WEIGHT_M RDMA_MASK3(32, 0xF, IG3_RHI_DEST_WRR_ARB_WRR_WEIGHT_S)
#define IG3_RHI_GKT_ARB_EN_MODE 0x42C30058
#define IG3_RHI_GKT_ARB_EN_MODE_RSVD_S 2
#define IG3_RHI_GKT_ARB_EN_MODE_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_RHI_GKT_ARB_EN_MODE_RSVD_S)
#define IG3_RHI_GKT_ARB_EN_MODE_ARB_MODE_S 0
#define IG3_RHI_GKT_ARB_EN_MODE_ARB_MODE_M RDMA_MASK3(32, 0x3, IG3_RHI_GKT_ARB_EN_MODE_ARB_MODE_S)
#define IG3_RHI_GKT_MASK_CRED 0x42C300D4
#define IG3_RHI_GKT_MASK_CRED_RSVD_S 9
#define IG3_RHI_GKT_MASK_CRED_RSVD_M RDMA_MASK3(32, 0x7FFFFF, IG3_RHI_GKT_MASK_CRED_RSVD_S)
#define IG3_RHI_GKT_MASK_CRED_MASK_DATA_CRED_S 1
#define IG3_RHI_GKT_MASK_CRED_MASK_DATA_CRED_M RDMA_MASK3(32, 0xFF, IG3_RHI_GKT_MASK_CRED_MASK_DATA_CRED_S)
#define IG3_RHI_GKT_MASK_CRED_MASK_EN_S 0
#define IG3_RHI_GKT_MASK_CRED_MASK_EN_M RDMA_BIT2(32, IG3_RHI_GKT_MASK_CRED_MASK_EN_S)
#define IG3_RHI_GKT_SPRR_ARB(_i) 0x42C3005C + ((_i) * 4) /* _i=0...14 */
#define IG3_RHI_GKT_SPRR_ARB_MAX_INDEX_I 14
#define IG3_RHI_GKT_SPRR_ARB_RSVD_S 4
#define IG3_RHI_GKT_SPRR_ARB_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_RHI_GKT_SPRR_ARB_RSVD_S)
#define IG3_RHI_GKT_SPRR_ARB_SPRR_WEIGHT_S 0
#define IG3_RHI_GKT_SPRR_ARB_SPRR_WEIGHT_M RDMA_MASK3(32, 0xF, IG3_RHI_GKT_SPRR_ARB_SPRR_WEIGHT_S)
#define IG3_RHI_GKT_WRR_ARB(_i) 0x42C30098 + ((_i) * 4) /* _i=0...14 */
#define IG3_RHI_GKT_WRR_ARB_MAX_INDEX_I 14
#define IG3_RHI_GKT_WRR_ARB_RSVD_S 14
#define IG3_RHI_GKT_WRR_ARB_RSVD_M RDMA_MASK3(32, 0x3FFFF, IG3_RHI_GKT_WRR_ARB_RSVD_S)
#define IG3_RHI_GKT_WRR_ARB_WRR_WEIGHT_CRED_S 4
#define IG3_RHI_GKT_WRR_ARB_WRR_WEIGHT_CRED_M RDMA_MASK3(32, 0x3FF, IG3_RHI_GKT_WRR_ARB_WRR_WEIGHT_CRED_S)
#define IG3_RHI_GKT_WRR_ARB_WRR_WEIGHT_S 0
#define IG3_RHI_GKT_WRR_ARB_WRR_WEIGHT_M RDMA_MASK3(32, 0xF, IG3_RHI_GKT_WRR_ARB_WRR_WEIGHT_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_BUS_INDEX 0x42C30210
#define IG3_RHI_GLPE_RHI_BOB_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL 0x42C30200
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_RESERVED_31_10_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_TRIG_OP_S 8
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_TRIG_OP_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_FREEZE_RESET_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_FREEZE_SET_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_CTRL_FREEZE_SET_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_FREEZE_ON_CNT_VAL 0x42C30220
#define IG3_RHI_GLPE_RHI_BOB_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_OBS_BUS 0x42C30240
#define IG3_RHI_GLPE_RHI_BOB_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CNT0 0x42C30260
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CNT0_CNT0_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CNT0_CNT0_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CNT1_0 0x42C30268
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CNT1_1 0x42C3026C
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CTRL 0x42C30258
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_RHI_GLPE_RHI_BOB_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_RC_CTRL 0x42C30238
#define IG3_RHI_GLPE_RHI_BOB_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_RHI_GLPE_RHI_BOB_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_RC_GAP 0x42C30228
#define IG3_RHI_GLPE_RHI_BOB_BOB_RC_GAP_RC_GAP_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_RC_GAP_RC_GAP_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_RC_TRNS 0x42C30230
#define IG3_RHI_GLPE_RHI_BOB_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS 0x42C30208
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_RESERVED_31_8_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_I_FREEZE_S 6
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_I_FREEZE_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_READY_S 5
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_READY_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_VALID_S 4
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_VALID_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_BOB_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_TRANS_CNT 0x42C30218
#define IG3_RHI_GLPE_RHI_BOB_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_TRIG_MASK 0x42C30248
#define IG3_RHI_GLPE_RHI_BOB_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_RHI_GLPE_RHI_BOB_BOB_TRIG_VALUE 0x42C30250
#define IG3_RHI_GLPE_RHI_BOB_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_RHI_GLPE_RHI_BOB_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_BOB_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_COUNT 0x42C301B8
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RHI_GLPE_RHI_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RHI_GLPE_RHI_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_CMD 0x42C301CC
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_DATA_H 0x42C301D8
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_DATA_L 0x42C301D4
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_PTR 0x42C301D0
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RHI_GLPE_RHI_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_CMD 0x42C301BC
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_DATA_H 0x42C301C8
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_DATA_L 0x42C301C4
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_PTR 0x42C301C0
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RHI_GLPE_RHI_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_CONTROL 0x42C30180
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_RSVD1_S 25
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_RHI_GLPE_RHI_DTM_CONTROL_RSVD1_S)
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_RSVD2_S 17
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RHI_GLPE_RHI_DTM_CONTROL_RSVD2_S)
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_RSVD3_S 9
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_RHI_GLPE_RHI_DTM_CONTROL_RSVD3_S)
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_BYPASS_S 8
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_CONTROL_BYPASS_S)
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_RSVD4_S 1
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_RHI_GLPE_RHI_DTM_CONTROL_RSVD4_S)
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_RHI_GLPE_RHI_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_CONTROL_LOCAL_EN_S)
#define IG3_RHI_GLPE_RHI_DTM_ECC_COR_ERR 0x42C301E8
#define IG3_RHI_GLPE_RHI_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_RHI_GLPE_RHI_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RHI_GLPE_RHI_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_RHI_GLPE_RHI_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_RHI_GLPE_RHI_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RHI_GLPE_RHI_DTM_ECC_COR_ERR_CNT_S)
#define IG3_RHI_GLPE_RHI_DTM_ECC_UNCOR_ERR 0x42C301E4
#define IG3_RHI_GLPE_RHI_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_RHI_GLPE_RHI_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RHI_GLPE_RHI_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_RHI_GLPE_RHI_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_RHI_GLPE_RHI_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RHI_GLPE_RHI_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_RHI_GLPE_RHI_DTM_GROUP_CFG 0x42C3018C
#define IG3_RHI_GLPE_RHI_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_RHI_GLPE_RHI_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_RHI_GLPE_RHI_DTM_GROUP_CFG_RSVD1_S)
#define IG3_RHI_GLPE_RHI_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_RHI_GLPE_RHI_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_RHI_GLPE_RHI_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_RHI_GLPE_RHI_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_RHI_GLPE_RHI_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_RHI_GLPE_RHI_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_RHI_GLPE_RHI_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_RHI_GLPE_RHI_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_RHI_GLPE_RHI_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_RHI_GLPE_RHI_DTM_LOG_CFG 0x42C30190
#define IG3_RHI_GLPE_RHI_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_RHI_GLPE_RHI_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_RHI_GLPE_RHI_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_RHI_GLPE_RHI_DTM_LOG_CFG_RSVD1_S 2
#define IG3_RHI_GLPE_RHI_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_RHI_GLPE_RHI_DTM_LOG_CFG_RSVD1_S)
#define IG3_RHI_GLPE_RHI_DTM_LOG_CFG_MODE_S 0
#define IG3_RHI_GLPE_RHI_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_RHI_GLPE_RHI_DTM_LOG_CFG_MODE_S)
#define IG3_RHI_GLPE_RHI_DTM_LOG_MASK 0x42C30198
#define IG3_RHI_GLPE_RHI_DTM_LOG_MASK_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_DTM_LOG_MASK_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_LOG_PATTERN 0x42C30194
#define IG3_RHI_GLPE_RHI_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_DTM_LOG_PATTERN_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_MAIN_CFG 0x42C30184
#define IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_RSVD1_S)
#define IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_RSVD2_S)
#define IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_RSVD3_S)
#define IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_RHI_GLPE_RHI_DTM_MAIN_STS 0x42C30188
#define IG3_RHI_GLPE_RHI_DTM_MAIN_STS_RSVD1_S 9
#define IG3_RHI_GLPE_RHI_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_RHI_GLPE_RHI_DTM_MAIN_STS_RSVD1_S)
#define IG3_RHI_GLPE_RHI_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_RHI_GLPE_RHI_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_RHI_GLPE_RHI_DTM_MAIN_STS_RSVD2_S 1
#define IG3_RHI_GLPE_RHI_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RHI_GLPE_RHI_DTM_MAIN_STS_RSVD2_S)
#define IG3_RHI_GLPE_RHI_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_RHI_GLPE_RHI_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_RHI_GLPE_RHI_DTM_TIMESTAMP 0x42C301B0
#define IG3_RHI_GLPE_RHI_DTM_TIMESTAMP_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_DTM_TIMESTAMP_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_TIMESTAMP_ROLLOVER 0x42C301B4
#define IG3_RHI_GLPE_RHI_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG 0x42C301DC
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS 0x42C301E0
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RHI_GLPE_RHI_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_RHI_GLPE_RHI_DTM_TRIG_CFG 0x42C3019C
#define IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_RSVD1_S)
#define IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_RSVD2_S)
#define IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_MODE_S 0
#define IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_RHI_GLPE_RHI_DTM_TRIG_CFG_MODE_S)
#define IG3_RHI_GLPE_RHI_DTM_TRIG_COUNT 0x42C301A8
#define IG3_RHI_GLPE_RHI_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_DTM_TRIG_COUNT_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_TRIG_MASK 0x42C301A4
#define IG3_RHI_GLPE_RHI_DTM_TRIG_MASK_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_DTM_TRIG_MASK_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_TRIG_PATTERN 0x42C301A0
#define IG3_RHI_GLPE_RHI_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_RHI_GLPE_RHI_DTM_TRIG_TIMESTAMP 0x42C301AC
#define IG3_RHI_GLPE_RHI_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_RHI_GLPE_RHI_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RHI_GLPE_RHI_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_RHI_PMAT_CLIENT_CRED_HOST(_i) 0x42C30028 + ((_i) * 4) /* _i=0...4 */
#define IG3_RHI_PMAT_CLIENT_CRED_HOST_MAX_INDEX_I 4
#define IG3_RHI_PMAT_CLIENT_CRED_HOST_RSVD_S 16
#define IG3_RHI_PMAT_CLIENT_CRED_HOST_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_RHI_PMAT_CLIENT_CRED_HOST_RSVD_S)
#define IG3_RHI_PMAT_CLIENT_CRED_HOST_DATA_CRED_S 8
#define IG3_RHI_PMAT_CLIENT_CRED_HOST_DATA_CRED_M RDMA_MASK3(32, 0xFF, IG3_RHI_PMAT_CLIENT_CRED_HOST_DATA_CRED_S)
#define IG3_RHI_PMAT_CLIENT_CRED_HOST_CMD_CRED_S 0
#define IG3_RHI_PMAT_CLIENT_CRED_HOST_CMD_CRED_M RDMA_MASK3(32, 0xFF, IG3_RHI_PMAT_CLIENT_CRED_HOST_CMD_CRED_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG 0x42C30100
#define IG3_RHI_PMAT_CMD_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_RHI_PMAT_CMD_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RHI_PMAT_CMD_MEM_CFG_ECC_INST_NUM_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_RSVD3_S 20
#define IG3_RHI_PMAT_CMD_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RHI_PMAT_CMD_MEM_CFG_RSVD3_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_RM_S 16
#define IG3_RHI_PMAT_CMD_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RHI_PMAT_CMD_MEM_CFG_RM_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_RSVD2_S 14
#define IG3_RHI_PMAT_CMD_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RHI_PMAT_CMD_MEM_CFG_RSVD2_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_RHI_PMAT_CMD_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RHI_PMAT_CMD_MEM_CFG_POWER_GATE_EN_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_RME_S 12
#define IG3_RHI_PMAT_CMD_MEM_CFG_RME_M RDMA_BIT2(32, IG3_RHI_PMAT_CMD_MEM_CFG_RME_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_RSVD1_S 10
#define IG3_RHI_PMAT_CMD_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHI_PMAT_CMD_MEM_CFG_RSVD1_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_ERR_CNT_S 9
#define IG3_RHI_PMAT_CMD_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RHI_PMAT_CMD_MEM_CFG_ERR_CNT_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_FIX_CNT_S 8
#define IG3_RHI_PMAT_CMD_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RHI_PMAT_CMD_MEM_CFG_FIX_CNT_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_RSVD0_S 6
#define IG3_RHI_PMAT_CMD_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RHI_PMAT_CMD_MEM_CFG_RSVD0_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_MASK_INT_S 5
#define IG3_RHI_PMAT_CMD_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RHI_PMAT_CMD_MEM_CFG_MASK_INT_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_LS_BYPASS_S 4
#define IG3_RHI_PMAT_CMD_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RHI_PMAT_CMD_MEM_CFG_LS_BYPASS_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_LS_FORCE_S 3
#define IG3_RHI_PMAT_CMD_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RHI_PMAT_CMD_MEM_CFG_LS_FORCE_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_RHI_PMAT_CMD_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RHI_PMAT_CMD_MEM_CFG_ECC_INVERT_2_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_RHI_PMAT_CMD_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RHI_PMAT_CMD_MEM_CFG_ECC_INVERT_1_S)
#define IG3_RHI_PMAT_CMD_MEM_CFG_ECC_EN_S 0
#define IG3_RHI_PMAT_CMD_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RHI_PMAT_CMD_MEM_CFG_ECC_EN_S)
#define IG3_RHI_PMAT_CMD_MEM_STATUS 0x42C300FC
#define IG3_RHI_PMAT_CMD_MEM_STATUS_RSVD1_S 30
#define IG3_RHI_PMAT_CMD_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHI_PMAT_CMD_MEM_STATUS_RSVD1_S)
#define IG3_RHI_PMAT_CMD_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RHI_PMAT_CMD_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RHI_PMAT_CMD_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RHI_PMAT_CMD_MEM_STATUS_RSVD0_S 4
#define IG3_RHI_PMAT_CMD_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RHI_PMAT_CMD_MEM_STATUS_RSVD0_S)
#define IG3_RHI_PMAT_CMD_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RHI_PMAT_CMD_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RHI_PMAT_CMD_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RHI_PMAT_CMD_MEM_STATUS_INIT_DONE_S 2
#define IG3_RHI_PMAT_CMD_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RHI_PMAT_CMD_MEM_STATUS_INIT_DONE_S)
#define IG3_RHI_PMAT_CMD_MEM_STATUS_ECC_FIX_S 1
#define IG3_RHI_PMAT_CMD_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RHI_PMAT_CMD_MEM_STATUS_ECC_FIX_S)
#define IG3_RHI_PMAT_CMD_MEM_STATUS_ECC_ERR_S 0
#define IG3_RHI_PMAT_CMD_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RHI_PMAT_CMD_MEM_STATUS_ECC_ERR_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG 0x42C30108
#define IG3_RHI_PMAT_DATA_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_RHI_PMAT_DATA_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RHI_PMAT_DATA_MEM_CFG_ECC_INST_NUM_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_RSVD3_S 20
#define IG3_RHI_PMAT_DATA_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RHI_PMAT_DATA_MEM_CFG_RSVD3_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_RM_S 16
#define IG3_RHI_PMAT_DATA_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RHI_PMAT_DATA_MEM_CFG_RM_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_RSVD2_S 14
#define IG3_RHI_PMAT_DATA_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RHI_PMAT_DATA_MEM_CFG_RSVD2_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_RHI_PMAT_DATA_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RHI_PMAT_DATA_MEM_CFG_POWER_GATE_EN_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_RME_S 12
#define IG3_RHI_PMAT_DATA_MEM_CFG_RME_M RDMA_BIT2(32, IG3_RHI_PMAT_DATA_MEM_CFG_RME_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_RSVD1_S 10
#define IG3_RHI_PMAT_DATA_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHI_PMAT_DATA_MEM_CFG_RSVD1_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_ERR_CNT_S 9
#define IG3_RHI_PMAT_DATA_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RHI_PMAT_DATA_MEM_CFG_ERR_CNT_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_FIX_CNT_S 8
#define IG3_RHI_PMAT_DATA_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RHI_PMAT_DATA_MEM_CFG_FIX_CNT_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_RSVD0_S 6
#define IG3_RHI_PMAT_DATA_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RHI_PMAT_DATA_MEM_CFG_RSVD0_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_MASK_INT_S 5
#define IG3_RHI_PMAT_DATA_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RHI_PMAT_DATA_MEM_CFG_MASK_INT_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_LS_BYPASS_S 4
#define IG3_RHI_PMAT_DATA_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RHI_PMAT_DATA_MEM_CFG_LS_BYPASS_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_LS_FORCE_S 3
#define IG3_RHI_PMAT_DATA_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RHI_PMAT_DATA_MEM_CFG_LS_FORCE_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_RHI_PMAT_DATA_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RHI_PMAT_DATA_MEM_CFG_ECC_INVERT_2_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_RHI_PMAT_DATA_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RHI_PMAT_DATA_MEM_CFG_ECC_INVERT_1_S)
#define IG3_RHI_PMAT_DATA_MEM_CFG_ECC_EN_S 0
#define IG3_RHI_PMAT_DATA_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RHI_PMAT_DATA_MEM_CFG_ECC_EN_S)
#define IG3_RHI_PMAT_DATA_MEM_STATUS 0x42C30104
#define IG3_RHI_PMAT_DATA_MEM_STATUS_RSVD1_S 30
#define IG3_RHI_PMAT_DATA_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHI_PMAT_DATA_MEM_STATUS_RSVD1_S)
#define IG3_RHI_PMAT_DATA_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RHI_PMAT_DATA_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RHI_PMAT_DATA_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RHI_PMAT_DATA_MEM_STATUS_RSVD0_S 4
#define IG3_RHI_PMAT_DATA_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RHI_PMAT_DATA_MEM_STATUS_RSVD0_S)
#define IG3_RHI_PMAT_DATA_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RHI_PMAT_DATA_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RHI_PMAT_DATA_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RHI_PMAT_DATA_MEM_STATUS_INIT_DONE_S 2
#define IG3_RHI_PMAT_DATA_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RHI_PMAT_DATA_MEM_STATUS_INIT_DONE_S)
#define IG3_RHI_PMAT_DATA_MEM_STATUS_ECC_FIX_S 1
#define IG3_RHI_PMAT_DATA_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RHI_PMAT_DATA_MEM_STATUS_ECC_FIX_S)
#define IG3_RHI_PMAT_DATA_MEM_STATUS_ECC_ERR_S 0
#define IG3_RHI_PMAT_DATA_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RHI_PMAT_DATA_MEM_STATUS_ECC_ERR_S)
#define IG3_RHI_RHA_CLIENT_CRED_HOST(_i) 0x42C30000 + ((_i) * 4) /* _i=0...4 */
#define IG3_RHI_RHA_CLIENT_CRED_HOST_MAX_INDEX_I 4
#define IG3_RHI_RHA_CLIENT_CRED_HOST_RSVD_S 16
#define IG3_RHI_RHA_CLIENT_CRED_HOST_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_RHI_RHA_CLIENT_CRED_HOST_RSVD_S)
#define IG3_RHI_RHA_CLIENT_CRED_HOST_DATA_CRED_S 8
#define IG3_RHI_RHA_CLIENT_CRED_HOST_DATA_CRED_M RDMA_MASK3(32, 0xFF, IG3_RHI_RHA_CLIENT_CRED_HOST_DATA_CRED_S)
#define IG3_RHI_RHA_CLIENT_CRED_HOST_CMD_CRED_S 0
#define IG3_RHI_RHA_CLIENT_CRED_HOST_CMD_CRED_M RDMA_MASK3(32, 0xFF, IG3_RHI_RHA_CLIENT_CRED_HOST_CMD_CRED_S)
#define IG3_RHI_RHA_CMD_MEM_CFG 0x42C300E0
#define IG3_RHI_RHA_CMD_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_RHI_RHA_CMD_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RHI_RHA_CMD_MEM_CFG_ECC_INST_NUM_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_RSVD3_S 20
#define IG3_RHI_RHA_CMD_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RHI_RHA_CMD_MEM_CFG_RSVD3_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_RM_S 16
#define IG3_RHI_RHA_CMD_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RHI_RHA_CMD_MEM_CFG_RM_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_RSVD2_S 14
#define IG3_RHI_RHA_CMD_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RHI_RHA_CMD_MEM_CFG_RSVD2_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_RHI_RHA_CMD_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RHI_RHA_CMD_MEM_CFG_POWER_GATE_EN_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_RME_S 12
#define IG3_RHI_RHA_CMD_MEM_CFG_RME_M RDMA_BIT2(32, IG3_RHI_RHA_CMD_MEM_CFG_RME_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_RSVD1_S 10
#define IG3_RHI_RHA_CMD_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHI_RHA_CMD_MEM_CFG_RSVD1_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_ERR_CNT_S 9
#define IG3_RHI_RHA_CMD_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RHI_RHA_CMD_MEM_CFG_ERR_CNT_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_FIX_CNT_S 8
#define IG3_RHI_RHA_CMD_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RHI_RHA_CMD_MEM_CFG_FIX_CNT_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_RSVD0_S 6
#define IG3_RHI_RHA_CMD_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RHI_RHA_CMD_MEM_CFG_RSVD0_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_MASK_INT_S 5
#define IG3_RHI_RHA_CMD_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RHI_RHA_CMD_MEM_CFG_MASK_INT_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_LS_BYPASS_S 4
#define IG3_RHI_RHA_CMD_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RHI_RHA_CMD_MEM_CFG_LS_BYPASS_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_LS_FORCE_S 3
#define IG3_RHI_RHA_CMD_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RHI_RHA_CMD_MEM_CFG_LS_FORCE_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_RHI_RHA_CMD_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RHI_RHA_CMD_MEM_CFG_ECC_INVERT_2_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_RHI_RHA_CMD_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RHI_RHA_CMD_MEM_CFG_ECC_INVERT_1_S)
#define IG3_RHI_RHA_CMD_MEM_CFG_ECC_EN_S 0
#define IG3_RHI_RHA_CMD_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RHI_RHA_CMD_MEM_CFG_ECC_EN_S)
#define IG3_RHI_RHA_CMD_MEM_STATUS 0x42C300DC
#define IG3_RHI_RHA_CMD_MEM_STATUS_RSVD1_S 30
#define IG3_RHI_RHA_CMD_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHI_RHA_CMD_MEM_STATUS_RSVD1_S)
#define IG3_RHI_RHA_CMD_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RHI_RHA_CMD_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RHI_RHA_CMD_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RHI_RHA_CMD_MEM_STATUS_RSVD0_S 4
#define IG3_RHI_RHA_CMD_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RHI_RHA_CMD_MEM_STATUS_RSVD0_S)
#define IG3_RHI_RHA_CMD_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RHI_RHA_CMD_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RHI_RHA_CMD_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RHI_RHA_CMD_MEM_STATUS_INIT_DONE_S 2
#define IG3_RHI_RHA_CMD_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RHI_RHA_CMD_MEM_STATUS_INIT_DONE_S)
#define IG3_RHI_RHA_CMD_MEM_STATUS_ECC_FIX_S 1
#define IG3_RHI_RHA_CMD_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RHI_RHA_CMD_MEM_STATUS_ECC_FIX_S)
#define IG3_RHI_RHA_CMD_MEM_STATUS_ECC_ERR_S 0
#define IG3_RHI_RHA_CMD_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RHI_RHA_CMD_MEM_STATUS_ECC_ERR_S)
#define IG3_RHI_RHA_DATA_MEM_CFG 0x42C300E8
#define IG3_RHI_RHA_DATA_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_RHI_RHA_DATA_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RHI_RHA_DATA_MEM_CFG_ECC_INST_NUM_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_RSVD3_S 20
#define IG3_RHI_RHA_DATA_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RHI_RHA_DATA_MEM_CFG_RSVD3_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_RM_S 16
#define IG3_RHI_RHA_DATA_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RHI_RHA_DATA_MEM_CFG_RM_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_RSVD2_S 14
#define IG3_RHI_RHA_DATA_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RHI_RHA_DATA_MEM_CFG_RSVD2_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_RHI_RHA_DATA_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RHI_RHA_DATA_MEM_CFG_POWER_GATE_EN_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_RME_S 12
#define IG3_RHI_RHA_DATA_MEM_CFG_RME_M RDMA_BIT2(32, IG3_RHI_RHA_DATA_MEM_CFG_RME_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_RSVD1_S 10
#define IG3_RHI_RHA_DATA_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHI_RHA_DATA_MEM_CFG_RSVD1_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_ERR_CNT_S 9
#define IG3_RHI_RHA_DATA_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RHI_RHA_DATA_MEM_CFG_ERR_CNT_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_FIX_CNT_S 8
#define IG3_RHI_RHA_DATA_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RHI_RHA_DATA_MEM_CFG_FIX_CNT_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_RSVD0_S 6
#define IG3_RHI_RHA_DATA_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RHI_RHA_DATA_MEM_CFG_RSVD0_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_MASK_INT_S 5
#define IG3_RHI_RHA_DATA_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RHI_RHA_DATA_MEM_CFG_MASK_INT_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_LS_BYPASS_S 4
#define IG3_RHI_RHA_DATA_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RHI_RHA_DATA_MEM_CFG_LS_BYPASS_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_LS_FORCE_S 3
#define IG3_RHI_RHA_DATA_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RHI_RHA_DATA_MEM_CFG_LS_FORCE_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_RHI_RHA_DATA_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RHI_RHA_DATA_MEM_CFG_ECC_INVERT_2_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_RHI_RHA_DATA_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RHI_RHA_DATA_MEM_CFG_ECC_INVERT_1_S)
#define IG3_RHI_RHA_DATA_MEM_CFG_ECC_EN_S 0
#define IG3_RHI_RHA_DATA_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RHI_RHA_DATA_MEM_CFG_ECC_EN_S)
#define IG3_RHI_RHA_DATA_MEM_STATUS 0x42C300E4
#define IG3_RHI_RHA_DATA_MEM_STATUS_RSVD1_S 30
#define IG3_RHI_RHA_DATA_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RHI_RHA_DATA_MEM_STATUS_RSVD1_S)
#define IG3_RHI_RHA_DATA_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RHI_RHA_DATA_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RHI_RHA_DATA_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RHI_RHA_DATA_MEM_STATUS_RSVD0_S 4
#define IG3_RHI_RHA_DATA_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RHI_RHA_DATA_MEM_STATUS_RSVD0_S)
#define IG3_RHI_RHA_DATA_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RHI_RHA_DATA_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RHI_RHA_DATA_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RHI_RHA_DATA_MEM_STATUS_INIT_DONE_S 2
#define IG3_RHI_RHA_DATA_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RHI_RHA_DATA_MEM_STATUS_INIT_DONE_S)
#define IG3_RHI_RHA_DATA_MEM_STATUS_ECC_FIX_S 1
#define IG3_RHI_RHA_DATA_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RHI_RHA_DATA_MEM_STATUS_ECC_FIX_S)
#define IG3_RHI_RHA_DATA_MEM_STATUS_ECC_ERR_S 0
#define IG3_RHI_RHA_DATA_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RHI_RHA_DATA_MEM_STATUS_ECC_ERR_S)
#define IG3_RHI_RHI_AUTOLOAD_DONE 0x42C300D8
#define IG3_RHI_RHI_AUTOLOAD_DONE_RSVD_S 4
#define IG3_RHI_RHI_AUTOLOAD_DONE_RSVD_M RDMA_MASK3(32, 0xFFFFFFF, IG3_RHI_RHI_AUTOLOAD_DONE_RSVD_S)
#define IG3_RHI_RHI_AUTOLOAD_DONE_AUTOLOAD_DONE_MASK_S 3
#define IG3_RHI_RHI_AUTOLOAD_DONE_AUTOLOAD_DONE_MASK_M RDMA_BIT2(32, IG3_RHI_RHI_AUTOLOAD_DONE_AUTOLOAD_DONE_MASK_S)
#define IG3_RHI_RHI_AUTOLOAD_DONE_AUTOLOAD_DONE_GKT_ARB_S 2
#define IG3_RHI_RHI_AUTOLOAD_DONE_AUTOLOAD_DONE_GKT_ARB_M RDMA_BIT2(32, IG3_RHI_RHI_AUTOLOAD_DONE_AUTOLOAD_DONE_GKT_ARB_S)
#define IG3_RHI_RHI_AUTOLOAD_DONE_AUTOLOAD_DONE_DEST_ARB_S 1
#define IG3_RHI_RHI_AUTOLOAD_DONE_AUTOLOAD_DONE_DEST_ARB_M RDMA_BIT2(32, IG3_RHI_RHI_AUTOLOAD_DONE_AUTOLOAD_DONE_DEST_ARB_S)
#define IG3_RHI_RHI_AUTOLOAD_DONE_AUTOLOAD_DONE_CRED_S 0
#define IG3_RHI_RHI_AUTOLOAD_DONE_AUTOLOAD_DONE_CRED_M RDMA_BIT2(32, IG3_RHI_RHI_AUTOLOAD_DONE_AUTOLOAD_DONE_CRED_S)
#define IG3_RHI_RHI_ECC_COR_ERR 0x42C30110
#define IG3_RHI_RHI_ECC_COR_ERR_RSVD_S 12
#define IG3_RHI_RHI_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RHI_RHI_ECC_COR_ERR_RSVD_S)
#define IG3_RHI_RHI_ECC_COR_ERR_CNT_S 0
#define IG3_RHI_RHI_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RHI_RHI_ECC_COR_ERR_CNT_S)
#define IG3_RHI_RHI_ECC_UNCOR_ERR 0x42C3010C
#define IG3_RHI_RHI_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_RHI_RHI_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RHI_RHI_ECC_UNCOR_ERR_RSVD_S)
#define IG3_RHI_RHI_ECC_UNCOR_ERR_CNT_S 0
#define IG3_RHI_RHI_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RHI_RHI_ECC_UNCOR_ERR_CNT_S)
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST 0x42C40008
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_RSV3_S 24
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_RSV3_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_AXI_RD_CONST_RSV3_S)
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_RSV2_S 16
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_RSV2_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_AXI_RD_CONST_RSV2_S)
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARMMUSECSID_S 15
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARMMUSECSID_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARMMUSECSID_S)
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARTRACE_S 14
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARTRACE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARTRACE_S)
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARDOMAIN_S 12
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARDOMAIN_M RDMA_MASK3(32, 0x3, IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARDOMAIN_S)
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARSNOOP_S 8
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARSNOOP_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARSNOOP_S)
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARQOS_S 4
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARQOS_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARQOS_S)
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARCACHE_S 0
#define IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARCACHE_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_AXI_RD_CONST_ARCACHE_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0 0x42C40000
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSTASHLPIDEN_S 31
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSTASHLPIDEN_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSTASHLPIDEN_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSTASHLPID_S 26
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSTASHLPID_M RDMA_MASK3(32, 0x1F, IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSTASHLPID_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSTASHNIDEN_S 25
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSTASHNIDEN_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSTASHNIDEN_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSTASHNID_S 14
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSTASHNID_M RDMA_MASK3(32, 0x7FF, IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSTASHNID_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWDOMAIN_S 12
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWDOMAIN_M RDMA_MASK3(32, 0x3, IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWDOMAIN_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSNOOP_S 8
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSNOOP_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWSNOOP_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWQOS_S 4
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWQOS_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWQOS_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWCACHE_S 0
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWCACHE_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_AXI_WR_CONST0_AWCACHE_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1 0x42C40004
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_RSV3_S 24
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_RSV3_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_RSV3_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_RSV2_S 16
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_RSV2_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_RSV2_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_RSV1_S 8
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_RSV1_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_RSV1_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_RSV0_S 4
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_RSV0_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_RSV0_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_WUSER_S 3
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_WUSER_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_WUSER_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_WTRACE_S 2
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_WTRACE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_WTRACE_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_AWMMUSECSID_S 1
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_AWMMUSECSID_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_AWMMUSECSID_S)
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_AWTRACE_S 0
#define IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_AWTRACE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_AXI_WR_CONST1_AWTRACE_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_BUS_INDEX 0x42C40110
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL 0x42C40100
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_RESERVED_31_10_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_TRIG_OP_S 8
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_TRIG_OP_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_FREEZE_RESET_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_FREEZE_SET_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_CTRL_FREEZE_SET_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_FREEZE_ON_CNT_VAL 0x42C40120
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_OBS_BUS 0x42C40140
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CNT0 0x42C40160
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CNT0_CNT0_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CNT0_CNT0_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CNT1_0 0x42C40168
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CNT1_1 0x42C4016C
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CTRL 0x42C40158
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_CTRL 0x42C40138
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_GAP 0x42C40128
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_GAP_RC_GAP_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_GAP_RC_GAP_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_TRNS 0x42C40130
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS 0x42C40108
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_RESERVED_31_8_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_I_FREEZE_S 6
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_I_FREEZE_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_READY_S 5
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_READY_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_VALID_S 4
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_VALID_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_TRANS_CNT 0x42C40118
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_TRIG_MASK 0x42C40148
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_TRIG_VALUE 0x42C40150
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_BUS_INDEX 0x42C40190
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL 0x42C40180
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_RESERVED_31_10_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_TRIG_OP_S 8
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_TRIG_OP_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_FREEZE_RESET_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_FREEZE_SET_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_CTRL_FREEZE_SET_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_FREEZE_ON_CNT_VAL 0x42C401A0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_OBS_BUS 0x42C401C0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CNT0 0x42C401E0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CNT0_CNT0_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CNT0_CNT0_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CNT1_0 0x42C401E8
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CNT1_1 0x42C401EC
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CTRL 0x42C401D8
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_CTRL 0x42C401B8
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_GAP 0x42C401A8
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_GAP_RC_GAP_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_GAP_RC_GAP_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_TRNS 0x42C401B0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS 0x42C40188
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_RESERVED_31_8_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_I_FREEZE_S 6
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_I_FREEZE_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_READY_S 5
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_READY_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_VALID_S 4
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_VALID_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_TRANS_CNT 0x42C40198
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_TRIG_MASK 0x42C401C8
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_TRIG_VALUE 0x42C401D0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_BUS_INDEX 0x42C40210
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL 0x42C40200
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_RESERVED_31_10_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_TRIG_OP_S 8
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_TRIG_OP_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_FREEZE_RESET_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_FREEZE_SET_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_CTRL_FREEZE_SET_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_FREEZE_ON_CNT_VAL 0x42C40220
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_OBS_BUS 0x42C40240
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CNT0 0x42C40260
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CNT0_CNT0_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CNT0_CNT0_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CNT1_0 0x42C40268
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CNT1_1 0x42C4026C
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CTRL 0x42C40258
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_CTRL 0x42C40238
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_GAP 0x42C40228
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_GAP_RC_GAP_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_GAP_RC_GAP_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_TRNS 0x42C40230
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS 0x42C40208
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_RESERVED_31_8_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_I_FREEZE_S 6
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_I_FREEZE_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_READY_S 5
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_READY_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_VALID_S 4
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_VALID_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_TRANS_CNT 0x42C40218
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_TRIG_MASK 0x42C40248
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_TRIG_VALUE 0x42C40250
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_BOB2_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB2_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_BUS_INDEX 0x42C40290
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL 0x42C40280
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_RESERVED_31_10_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_TRIG_OP_S 8
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_TRIG_OP_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_FREEZE_RESET_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_FREEZE_SET_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_CTRL_FREEZE_SET_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_FREEZE_ON_CNT_VAL 0x42C402A0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_OBS_BUS 0x42C402C0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CNT0 0x42C402E0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CNT0_CNT0_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CNT0_CNT0_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CNT1_0 0x42C402E8
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CNT1_1 0x42C402EC
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CTRL 0x42C402D8
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_CTRL 0x42C402B8
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_GAP 0x42C402A8
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_GAP_RC_GAP_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_GAP_RC_GAP_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_TRNS 0x42C402B0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS 0x42C40288
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_RESERVED_31_8_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_I_FREEZE_S 6
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_I_FREEZE_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_READY_S 5
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_READY_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_VALID_S 4
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_VALID_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_TRANS_CNT 0x42C40298
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_TRIG_MASK 0x42C402C8
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_TRIG_VALUE 0x42C402D0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_BOB3_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB3_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_BUS_INDEX 0x42C40310
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL 0x42C40300
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_RESERVED_31_10_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_TRIG_OP_S 8
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_TRIG_OP_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_FREEZE_RESET_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_FREEZE_SET_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_CTRL_FREEZE_SET_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_FREEZE_ON_CNT_VAL 0x42C40320
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_OBS_BUS 0x42C40340
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CNT0 0x42C40360
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CNT0_CNT0_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CNT0_CNT0_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CNT1_0 0x42C40368
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CNT1_1 0x42C4036C
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CTRL 0x42C40358
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_CTRL 0x42C40338
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_GAP 0x42C40328
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_GAP_RC_GAP_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_GAP_RC_GAP_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_TRNS 0x42C40330
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS 0x42C40308
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_RESERVED_31_8_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_I_FREEZE_S 6
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_I_FREEZE_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_READY_S 5
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_READY_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_VALID_S 4
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_VALID_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_TRANS_CNT 0x42C40318
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_TRIG_MASK 0x42C40348
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_TRIG_VALUE 0x42C40350
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_BOB4_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_BOB4_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_COUNT 0x42C400B8
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RMI0_GLPE_RMI_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RMI0_GLPE_RMI_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_CMD 0x42C400CC
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_DATA_H 0x42C400D8
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_DATA_L 0x42C400D4
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_PTR 0x42C400D0
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RMI0_GLPE_RMI_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_CMD 0x42C400BC
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_DATA_H 0x42C400C8
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_DATA_L 0x42C400C4
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_PTR 0x42C400C0
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RMI0_GLPE_RMI_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL 0x42C40080
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_RSVD1_S 25
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_RMI0_GLPE_RMI_DTM_CONTROL_RSVD1_S)
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_RSVD2_S 17
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RMI0_GLPE_RMI_DTM_CONTROL_RSVD2_S)
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_RSVD3_S 9
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_RMI0_GLPE_RMI_DTM_CONTROL_RSVD3_S)
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_BYPASS_S 8
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_CONTROL_BYPASS_S)
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_RSVD4_S 1
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_RMI0_GLPE_RMI_DTM_CONTROL_RSVD4_S)
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_RMI0_GLPE_RMI_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_CONTROL_LOCAL_EN_S)
#define IG3_RMI0_GLPE_RMI_DTM_ECC_COR_ERR 0x42C400E8
#define IG3_RMI0_GLPE_RMI_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_RMI0_GLPE_RMI_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RMI0_GLPE_RMI_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_RMI0_GLPE_RMI_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_RMI0_GLPE_RMI_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RMI0_GLPE_RMI_DTM_ECC_COR_ERR_CNT_S)
#define IG3_RMI0_GLPE_RMI_DTM_ECC_UNCOR_ERR 0x42C400E4
#define IG3_RMI0_GLPE_RMI_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_RMI0_GLPE_RMI_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RMI0_GLPE_RMI_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_RMI0_GLPE_RMI_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_RMI0_GLPE_RMI_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RMI0_GLPE_RMI_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_RMI0_GLPE_RMI_DTM_GROUP_CFG 0x42C4008C
#define IG3_RMI0_GLPE_RMI_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_RMI0_GLPE_RMI_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_DTM_GROUP_CFG_RSVD1_S)
#define IG3_RMI0_GLPE_RMI_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_RMI0_GLPE_RMI_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_RMI0_GLPE_RMI_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_RMI0_GLPE_RMI_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_RMI0_GLPE_RMI_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_RMI0_GLPE_RMI_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_RMI0_GLPE_RMI_DTM_LOG_CFG 0x42C40090
#define IG3_RMI0_GLPE_RMI_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_RMI0_GLPE_RMI_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_RMI0_GLPE_RMI_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_RMI0_GLPE_RMI_DTM_LOG_CFG_RSVD1_S 2
#define IG3_RMI0_GLPE_RMI_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_RMI0_GLPE_RMI_DTM_LOG_CFG_RSVD1_S)
#define IG3_RMI0_GLPE_RMI_DTM_LOG_CFG_MODE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_RMI0_GLPE_RMI_DTM_LOG_CFG_MODE_S)
#define IG3_RMI0_GLPE_RMI_DTM_LOG_MASK 0x42C40098
#define IG3_RMI0_GLPE_RMI_DTM_LOG_MASK_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_DTM_LOG_MASK_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_LOG_PATTERN 0x42C40094
#define IG3_RMI0_GLPE_RMI_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_DTM_LOG_PATTERN_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG 0x42C40084
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_RSVD1_S)
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_RSVD2_S)
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_RSVD3_S)
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_STS 0x42C40088
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_STS_RSVD1_S 9
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_RMI0_GLPE_RMI_DTM_MAIN_STS_RSVD1_S)
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_STS_RSVD2_S 1
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RMI0_GLPE_RMI_DTM_MAIN_STS_RSVD2_S)
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_RMI0_GLPE_RMI_DTM_TIMESTAMP 0x42C400B0
#define IG3_RMI0_GLPE_RMI_DTM_TIMESTAMP_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_DTM_TIMESTAMP_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_TIMESTAMP_ROLLOVER 0x42C400B4
#define IG3_RMI0_GLPE_RMI_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG 0x42C400DC
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS 0x42C400E0
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RMI0_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG 0x42C4009C
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_RSVD1_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_RSVD2_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_MODE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_RMI0_GLPE_RMI_DTM_TRIG_CFG_MODE_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_COUNT 0x42C400A8
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_DTM_TRIG_COUNT_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_MASK 0x42C400A4
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_MASK_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_DTM_TRIG_MASK_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_PATTERN 0x42C400A0
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_TIMESTAMP 0x42C400AC
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_RMI0_GLPE_RMI_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI0_GLPE_RMI_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_RMI0_RHI_ECC_COR_ERR 0x42C40030
#define IG3_RMI0_RHI_ECC_COR_ERR_RSVD_S 12
#define IG3_RMI0_RHI_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RMI0_RHI_ECC_COR_ERR_RSVD_S)
#define IG3_RMI0_RHI_ECC_COR_ERR_CNT_S 0
#define IG3_RMI0_RHI_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RMI0_RHI_ECC_COR_ERR_CNT_S)
#define IG3_RMI0_RHI_ECC_UNCOR_ERR 0x42C4002C
#define IG3_RMI0_RHI_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_RMI0_RHI_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RMI0_RHI_ECC_UNCOR_ERR_RSVD_S)
#define IG3_RMI0_RHI_ECC_UNCOR_ERR_CNT_S 0
#define IG3_RMI0_RHI_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RMI0_RHI_ECC_UNCOR_ERR_CNT_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG 0x42C40020
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_ECC_INST_NUM_S 25
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RMI0_RMI_CMD_CREDITS_CFG_ECC_INST_NUM_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_RSVD3_S 20
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RMI0_RMI_CMD_CREDITS_CFG_RSVD3_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_RM_S 16
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RMI0_RMI_CMD_CREDITS_CFG_RM_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_RSVD2_S 14
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_CMD_CREDITS_CFG_RSVD2_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_POWER_GATE_EN_S 13
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RMI0_RMI_CMD_CREDITS_CFG_POWER_GATE_EN_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_RME_S 12
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_RME_M RDMA_BIT2(32, IG3_RMI0_RMI_CMD_CREDITS_CFG_RME_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_RSVD1_S 10
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_CMD_CREDITS_CFG_RSVD1_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_ERR_CNT_S 9
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RMI0_RMI_CMD_CREDITS_CFG_ERR_CNT_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_FIX_CNT_S 8
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RMI0_RMI_CMD_CREDITS_CFG_FIX_CNT_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_RSVD0_S 6
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_CMD_CREDITS_CFG_RSVD0_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_MASK_INT_S 5
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RMI0_RMI_CMD_CREDITS_CFG_MASK_INT_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_LS_BYPASS_S 4
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RMI0_RMI_CMD_CREDITS_CFG_LS_BYPASS_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_LS_FORCE_S 3
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RMI0_RMI_CMD_CREDITS_CFG_LS_FORCE_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_ECC_INVERT_2_S 2
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RMI0_RMI_CMD_CREDITS_CFG_ECC_INVERT_2_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_ECC_INVERT_1_S 1
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RMI0_RMI_CMD_CREDITS_CFG_ECC_INVERT_1_S)
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_ECC_EN_S 0
#define IG3_RMI0_RMI_CMD_CREDITS_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RMI0_RMI_CMD_CREDITS_CFG_ECC_EN_S)
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS 0x42C4001C
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS_RSVD1_S 30
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_CMD_CREDITS_STATUS_RSVD1_S)
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RMI0_RMI_CMD_CREDITS_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS_RSVD0_S 4
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RMI0_RMI_CMD_CREDITS_STATUS_RSVD0_S)
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RMI0_RMI_CMD_CREDITS_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS_INIT_DONE_S 2
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RMI0_RMI_CMD_CREDITS_STATUS_INIT_DONE_S)
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS_ECC_FIX_S 1
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RMI0_RMI_CMD_CREDITS_STATUS_ECC_FIX_S)
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS_ECC_ERR_S 0
#define IG3_RMI0_RMI_CMD_CREDITS_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RMI0_RMI_CMD_CREDITS_STATUS_ECC_ERR_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG 0x42C40028
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_ECC_INST_NUM_S 25
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RMI0_RMI_DATA_CREDITS_CFG_ECC_INST_NUM_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_RSVD3_S 20
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RMI0_RMI_DATA_CREDITS_CFG_RSVD3_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_RM_S 16
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RMI0_RMI_DATA_CREDITS_CFG_RM_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_RSVD2_S 14
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_DATA_CREDITS_CFG_RSVD2_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_POWER_GATE_EN_S 13
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RMI0_RMI_DATA_CREDITS_CFG_POWER_GATE_EN_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_RME_S 12
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_RME_M RDMA_BIT2(32, IG3_RMI0_RMI_DATA_CREDITS_CFG_RME_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_RSVD1_S 10
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_DATA_CREDITS_CFG_RSVD1_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_ERR_CNT_S 9
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RMI0_RMI_DATA_CREDITS_CFG_ERR_CNT_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_FIX_CNT_S 8
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RMI0_RMI_DATA_CREDITS_CFG_FIX_CNT_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_RSVD0_S 6
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_DATA_CREDITS_CFG_RSVD0_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_MASK_INT_S 5
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RMI0_RMI_DATA_CREDITS_CFG_MASK_INT_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_LS_BYPASS_S 4
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RMI0_RMI_DATA_CREDITS_CFG_LS_BYPASS_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_LS_FORCE_S 3
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RMI0_RMI_DATA_CREDITS_CFG_LS_FORCE_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_ECC_INVERT_2_S 2
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RMI0_RMI_DATA_CREDITS_CFG_ECC_INVERT_2_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_ECC_INVERT_1_S 1
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RMI0_RMI_DATA_CREDITS_CFG_ECC_INVERT_1_S)
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_ECC_EN_S 0
#define IG3_RMI0_RMI_DATA_CREDITS_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RMI0_RMI_DATA_CREDITS_CFG_ECC_EN_S)
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS 0x42C40024
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS_RSVD1_S 30
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_DATA_CREDITS_STATUS_RSVD1_S)
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RMI0_RMI_DATA_CREDITS_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS_RSVD0_S 4
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RMI0_RMI_DATA_CREDITS_STATUS_RSVD0_S)
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RMI0_RMI_DATA_CREDITS_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS_INIT_DONE_S 2
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RMI0_RMI_DATA_CREDITS_STATUS_INIT_DONE_S)
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS_ECC_FIX_S 1
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RMI0_RMI_DATA_CREDITS_STATUS_ECC_FIX_S)
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS_ECC_ERR_S 0
#define IG3_RMI0_RMI_DATA_CREDITS_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RMI0_RMI_DATA_CREDITS_STATUS_ECC_ERR_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG 0x42C40010
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ECC_INST_NUM_S 25
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ECC_INST_NUM_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RSVD3_S 20
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RSVD3_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RM_S 16
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RM_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RSVD2_S 14
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RSVD2_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_POWER_GATE_EN_S 13
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_POWER_GATE_EN_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RME_S 12
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RME_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RME_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RSVD1_S 10
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RSVD1_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ERR_CNT_S 9
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ERR_CNT_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_FIX_CNT_S 8
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_FIX_CNT_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RSVD0_S 6
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_RSVD0_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_MASK_INT_S 5
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_MASK_INT_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_LS_BYPASS_S 4
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_LS_BYPASS_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_LS_FORCE_S 3
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_LS_FORCE_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ECC_INVERT_2_S 2
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ECC_INVERT_2_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ECC_INVERT_1_S 1
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ECC_INVERT_1_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ECC_EN_S 0
#define IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_LEFT_DATA_CFG_ECC_EN_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS 0x42C4000C
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_RSVD1_S 30
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_RSVD1_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_RSVD0_S 4
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_RSVD0_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_INIT_DONE_S 2
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_INIT_DONE_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_ECC_FIX_S 1
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_ECC_FIX_S)
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_ECC_ERR_S 0
#define IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_LEFT_DATA_STATUS_ECC_ERR_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG 0x42C40018
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ECC_INST_NUM_S 25
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ECC_INST_NUM_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RSVD3_S 20
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RSVD3_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RM_S 16
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RM_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RSVD2_S 14
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RSVD2_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_POWER_GATE_EN_S 13
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_POWER_GATE_EN_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RME_S 12
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RME_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RME_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RSVD1_S 10
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RSVD1_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ERR_CNT_S 9
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ERR_CNT_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_FIX_CNT_S 8
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_FIX_CNT_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RSVD0_S 6
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_RSVD0_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_MASK_INT_S 5
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_MASK_INT_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_LS_BYPASS_S 4
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_LS_BYPASS_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_LS_FORCE_S 3
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_LS_FORCE_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ECC_INVERT_2_S 2
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ECC_INVERT_2_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ECC_INVERT_1_S 1
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ECC_INVERT_1_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ECC_EN_S 0
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_RIGHT_DATA_CFG_ECC_EN_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS 0x42C40014
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_RSVD1_S 30
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_RSVD1_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_RSVD0_S 4
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_RSVD0_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_INIT_DONE_S 2
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_INIT_DONE_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_ECC_FIX_S 1
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_ECC_FIX_S)
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_ECC_ERR_S 0
#define IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RMI0_RMI_RESP_RIGHT_DATA_STATUS_ECC_ERR_S)
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST 0x42C50008
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_RSV3_S 24
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_RSV3_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_AXI_RD_CONST_RSV3_S)
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_RSV2_S 16
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_RSV2_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_AXI_RD_CONST_RSV2_S)
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARMMUSECSID_S 15
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARMMUSECSID_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARMMUSECSID_S)
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARTRACE_S 14
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARTRACE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARTRACE_S)
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARDOMAIN_S 12
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARDOMAIN_M RDMA_MASK3(32, 0x3, IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARDOMAIN_S)
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARSNOOP_S 8
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARSNOOP_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARSNOOP_S)
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARQOS_S 4
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARQOS_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARQOS_S)
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARCACHE_S 0
#define IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARCACHE_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_AXI_RD_CONST_ARCACHE_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0 0x42C50000
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSTASHLPIDEN_S 31
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSTASHLPIDEN_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSTASHLPIDEN_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSTASHLPID_S 26
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSTASHLPID_M RDMA_MASK3(32, 0x1F, IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSTASHLPID_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSTASHNIDEN_S 25
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSTASHNIDEN_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSTASHNIDEN_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSTASHNID_S 14
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSTASHNID_M RDMA_MASK3(32, 0x7FF, IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSTASHNID_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWDOMAIN_S 12
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWDOMAIN_M RDMA_MASK3(32, 0x3, IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWDOMAIN_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSNOOP_S 8
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSNOOP_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWSNOOP_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWQOS_S 4
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWQOS_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWQOS_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWCACHE_S 0
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWCACHE_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_AXI_WR_CONST0_AWCACHE_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1 0x42C50004
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_RSV3_S 24
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_RSV3_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_RSV3_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_RSV2_S 16
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_RSV2_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_RSV2_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_RSV1_S 8
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_RSV1_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_RSV1_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_RSV0_S 4
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_RSV0_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_RSV0_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_WUSER_S 3
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_WUSER_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_WUSER_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_WTRACE_S 2
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_WTRACE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_WTRACE_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_AWMMUSECSID_S 1
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_AWMMUSECSID_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_AWMMUSECSID_S)
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_AWTRACE_S 0
#define IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_AWTRACE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_AXI_WR_CONST1_AWTRACE_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_BUS_INDEX 0x42C50110
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL 0x42C50100
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_RESERVED_31_10_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_TRIG_OP_S 8
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_TRIG_OP_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_FREEZE_RESET_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_FREEZE_SET_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_CTRL_FREEZE_SET_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_FREEZE_ON_CNT_VAL 0x42C50120
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_OBS_BUS 0x42C50140
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CNT0 0x42C50160
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CNT0_CNT0_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CNT0_CNT0_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CNT1_0 0x42C50168
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CNT1_1 0x42C5016C
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CTRL 0x42C50158
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_BOB0_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_CTRL 0x42C50138
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_GAP 0x42C50128
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_GAP_RC_GAP_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_GAP_RC_GAP_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_TRNS 0x42C50130
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS 0x42C50108
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_RESERVED_31_8_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_I_FREEZE_S 6
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_I_FREEZE_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_READY_S 5
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_READY_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_VALID_S 4
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_VALID_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB0_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_TRANS_CNT 0x42C50118
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_TRIG_MASK 0x42C50148
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_TRIG_VALUE 0x42C50150
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB0_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_BUS_INDEX 0x42C50190
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL 0x42C50180
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_RESERVED_31_10_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_TRIG_OP_S 8
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_TRIG_OP_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_FREEZE_RESET_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_FREEZE_SET_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_CTRL_FREEZE_SET_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_FREEZE_ON_CNT_VAL 0x42C501A0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_OBS_BUS 0x42C501C0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CNT0 0x42C501E0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CNT0_CNT0_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CNT0_CNT0_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CNT1_0 0x42C501E8
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CNT1_1 0x42C501EC
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CTRL 0x42C501D8
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_BOB1_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_CTRL 0x42C501B8
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_GAP 0x42C501A8
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_GAP_RC_GAP_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_GAP_RC_GAP_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_TRNS 0x42C501B0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS 0x42C50188
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_RESERVED_31_8_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_I_FREEZE_S 6
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_I_FREEZE_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_READY_S 5
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_READY_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_VALID_S 4
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_VALID_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB1_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_TRANS_CNT 0x42C50198
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_TRIG_MASK 0x42C501C8
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_TRIG_VALUE 0x42C501D0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB1_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_BUS_INDEX 0x42C50210
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL 0x42C50200
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_RESERVED_31_10_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_TRIG_OP_S 8
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_TRIG_OP_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_FREEZE_RESET_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_FREEZE_SET_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_CTRL_FREEZE_SET_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_FREEZE_ON_CNT_VAL 0x42C50220
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_OBS_BUS 0x42C50240
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CNT0 0x42C50260
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CNT0_CNT0_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CNT0_CNT0_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CNT1_0 0x42C50268
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CNT1_1 0x42C5026C
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CTRL 0x42C50258
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_BOB2_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_CTRL 0x42C50238
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_GAP 0x42C50228
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_GAP_RC_GAP_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_GAP_RC_GAP_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_TRNS 0x42C50230
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS 0x42C50208
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_RESERVED_31_8_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_I_FREEZE_S 6
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_I_FREEZE_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_READY_S 5
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_READY_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_VALID_S 4
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_VALID_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB2_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_TRANS_CNT 0x42C50218
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_TRIG_MASK 0x42C50248
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_TRIG_VALUE 0x42C50250
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_BOB2_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB2_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_BUS_INDEX 0x42C50290
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL 0x42C50280
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_RESERVED_31_10_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_TRIG_OP_S 8
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_TRIG_OP_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_FREEZE_RESET_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_FREEZE_SET_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_CTRL_FREEZE_SET_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_FREEZE_ON_CNT_VAL 0x42C502A0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_OBS_BUS 0x42C502C0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CNT0 0x42C502E0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CNT0_CNT0_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CNT0_CNT0_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CNT1_0 0x42C502E8
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CNT1_1 0x42C502EC
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CTRL 0x42C502D8
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_BOB3_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_CTRL 0x42C502B8
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_GAP 0x42C502A8
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_GAP_RC_GAP_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_GAP_RC_GAP_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_TRNS 0x42C502B0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS 0x42C50288
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_RESERVED_31_8_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_I_FREEZE_S 6
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_I_FREEZE_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_READY_S 5
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_READY_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_VALID_S 4
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_VALID_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB3_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_TRANS_CNT 0x42C50298
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_TRIG_MASK 0x42C502C8
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_TRIG_VALUE 0x42C502D0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_BOB3_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB3_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_BUS_INDEX 0x42C50310
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_BUS_INDEX_BUS_INDEX_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_BUS_INDEX_BUS_INDEX_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_BUS_INDEX_BUS_INDEX_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL 0x42C50300
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_RESERVED_31_10_S 10
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_RESERVED_31_10_M RDMA_MASK3(32, 0x3FFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_RESERVED_31_10_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_TRIG_OP_S 8
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_TRIG_OP_M RDMA_MASK3(32, 0x3, IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_TRIG_OP_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_VLD_RDY_FRZ_EN_S 7
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_VLD_RDY_FRZ_EN_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_VLD_RDY_FRZ_EN_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_EN_I_FREEZE_S 6
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_EN_I_FREEZE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_EN_I_FREEZE_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_COUNT_ONLY_TRIG_S 5
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_COUNT_ONLY_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_COUNT_ONLY_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_READ_INPUT_BUS_S 4
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_READ_INPUT_BUS_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_READ_INPUT_BUS_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_EN_FRZ_ON_CNT_S 3
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_EN_FRZ_ON_CNT_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_EN_FRZ_ON_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_EN_FRZ_ON_TRIG_S 2
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_EN_FRZ_ON_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_EN_FRZ_ON_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_FREEZE_RESET_S 1
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_FREEZE_RESET_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_FREEZE_RESET_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_FREEZE_SET_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_FREEZE_SET_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_CTRL_FREEZE_SET_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_FREEZE_ON_CNT_VAL 0x42C50320
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_FREEZE_ON_CNT_VAL_FREEZE_ON_CNT_VAL_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_OBS_BUS 0x42C50340
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_OBS_BUS_OBS_BUS_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_OBS_BUS_OBS_BUS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_OBS_BUS_OBS_BUS_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CNT0 0x42C50360
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CNT0_CNT0_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CNT0_CNT0_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CNT0_CNT0_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CNT1_0 0x42C50368
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CNT1_0_CNT1_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CNT1_0_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CNT1_0_CNT1_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CNT1_1 0x42C5036C
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CNT1_1_CNT1_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CNT1_1_CNT1_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CNT1_1_CNT1_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CTRL 0x42C50358
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CTRL_RESERVED_31_16_S 16
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CTRL_RESERVED_31_16_M RDMA_MASK3(32, 0xFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CTRL_RESERVED_31_16_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_WIN_S 8
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_WIN_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_WIN_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_CNT1_CFG_S 4
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_CNT1_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_CNT1_CFG_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_CNT0_CFG_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_CNT0_CFG_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_BOB4_BOB_PERF_CTRL_PERF_CNT0_CFG_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_CTRL 0x42C50338
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_CTRL_RESERVED_31_1_S 1
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_CTRL_RESERVED_31_1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_CTRL_RESERVED_31_1_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_CTRL_RC_TRIG_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_CTRL_RC_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_CTRL_RC_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_GAP 0x42C50328
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_GAP_RC_GAP_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_GAP_RC_GAP_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_GAP_RC_GAP_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_TRNS 0x42C50330
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_TRNS_RC_TRNS_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_TRNS_RC_TRNS_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_RC_TRNS_RC_TRNS_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS 0x42C50308
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_RESERVED_31_8_S 8
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_RESERVED_31_8_M RDMA_MASK3(32, 0xFFFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_RESERVED_31_8_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_IFRZ_S 7
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_IFRZ_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_IFRZ_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_I_FREEZE_S 6
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_I_FREEZE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_I_FREEZE_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_READY_S 5
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_READY_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_READY_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_VALID_S 4
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_VALID_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_VALID_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_CNT_S 3
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_CNT_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_TRIG_S 2
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_UPON_TRIG_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S 1
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_SET_BY_SW_FLAG_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_STATUS_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_STATUS_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_BOB4_BOB_STATUS_FREEZE_STATUS_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_TRANS_CNT 0x42C50318
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_TRANS_CNT_TRANS_CNT_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_TRANS_CNT_TRANS_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_TRANS_CNT_TRANS_CNT_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_TRIG_MASK 0x42C50348
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_TRIG_MASK_TRIG_MASK_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_TRIG_MASK_TRIG_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_TRIG_MASK_TRIG_MASK_S)
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_TRIG_VALUE 0x42C50350
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_TRIG_VALUE_TRIG_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_BOB4_BOB_TRIG_VALUE_TRIG_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_BOB4_BOB_TRIG_VALUE_TRIG_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_COUNT 0x42C500B8
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RMI1_GLPE_RMI_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RMI1_GLPE_RMI_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_CMD 0x42C500CC
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_DATA_H 0x42C500D8
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_DATA_L 0x42C500D4
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_PTR 0x42C500D0
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RMI1_GLPE_RMI_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_CMD 0x42C500BC
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_DATA_H 0x42C500C8
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_DATA_L 0x42C500C4
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_PTR 0x42C500C0
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_RMI1_GLPE_RMI_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL 0x42C50080
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_RSVD1_S 25
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_RMI1_GLPE_RMI_DTM_CONTROL_RSVD1_S)
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_RSVD2_S 17
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RMI1_GLPE_RMI_DTM_CONTROL_RSVD2_S)
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_RSVD3_S 9
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_RMI1_GLPE_RMI_DTM_CONTROL_RSVD3_S)
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_BYPASS_S 8
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_CONTROL_BYPASS_S)
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_RSVD4_S 1
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_RMI1_GLPE_RMI_DTM_CONTROL_RSVD4_S)
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_RMI1_GLPE_RMI_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_CONTROL_LOCAL_EN_S)
#define IG3_RMI1_GLPE_RMI_DTM_ECC_COR_ERR 0x42C500E8
#define IG3_RMI1_GLPE_RMI_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_RMI1_GLPE_RMI_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RMI1_GLPE_RMI_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_RMI1_GLPE_RMI_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_RMI1_GLPE_RMI_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RMI1_GLPE_RMI_DTM_ECC_COR_ERR_CNT_S)
#define IG3_RMI1_GLPE_RMI_DTM_ECC_UNCOR_ERR 0x42C500E4
#define IG3_RMI1_GLPE_RMI_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_RMI1_GLPE_RMI_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RMI1_GLPE_RMI_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_RMI1_GLPE_RMI_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_RMI1_GLPE_RMI_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RMI1_GLPE_RMI_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_RMI1_GLPE_RMI_DTM_GROUP_CFG 0x42C5008C
#define IG3_RMI1_GLPE_RMI_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_RMI1_GLPE_RMI_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_DTM_GROUP_CFG_RSVD1_S)
#define IG3_RMI1_GLPE_RMI_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_RMI1_GLPE_RMI_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_RMI1_GLPE_RMI_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_RMI1_GLPE_RMI_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_RMI1_GLPE_RMI_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_RMI1_GLPE_RMI_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_RMI1_GLPE_RMI_DTM_LOG_CFG 0x42C50090
#define IG3_RMI1_GLPE_RMI_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_RMI1_GLPE_RMI_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_RMI1_GLPE_RMI_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_RMI1_GLPE_RMI_DTM_LOG_CFG_RSVD1_S 2
#define IG3_RMI1_GLPE_RMI_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_RMI1_GLPE_RMI_DTM_LOG_CFG_RSVD1_S)
#define IG3_RMI1_GLPE_RMI_DTM_LOG_CFG_MODE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_RMI1_GLPE_RMI_DTM_LOG_CFG_MODE_S)
#define IG3_RMI1_GLPE_RMI_DTM_LOG_MASK 0x42C50098
#define IG3_RMI1_GLPE_RMI_DTM_LOG_MASK_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_DTM_LOG_MASK_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_LOG_PATTERN 0x42C50094
#define IG3_RMI1_GLPE_RMI_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_DTM_LOG_PATTERN_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG 0x42C50084
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_RSVD1_S)
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_RSVD2_S)
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_RSVD3_S)
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_STS 0x42C50088
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_STS_RSVD1_S 9
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_RMI1_GLPE_RMI_DTM_MAIN_STS_RSVD1_S)
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_STS_RSVD2_S 1
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_RMI1_GLPE_RMI_DTM_MAIN_STS_RSVD2_S)
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_RMI1_GLPE_RMI_DTM_TIMESTAMP 0x42C500B0
#define IG3_RMI1_GLPE_RMI_DTM_TIMESTAMP_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_DTM_TIMESTAMP_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_TIMESTAMP_ROLLOVER 0x42C500B4
#define IG3_RMI1_GLPE_RMI_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG 0x42C500DC
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS 0x42C500E0
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RMI1_GLPE_RMI_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG 0x42C5009C
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_RSVD1_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_RSVD2_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_MODE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_RMI1_GLPE_RMI_DTM_TRIG_CFG_MODE_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_COUNT 0x42C500A8
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_DTM_TRIG_COUNT_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_MASK 0x42C500A4
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_MASK_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_DTM_TRIG_MASK_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_PATTERN 0x42C500A0
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_TIMESTAMP 0x42C500AC
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_RMI1_GLPE_RMI_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_RMI1_GLPE_RMI_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_RMI1_RHI_ECC_COR_ERR 0x42C50030
#define IG3_RMI1_RHI_ECC_COR_ERR_RSVD_S 12
#define IG3_RMI1_RHI_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RMI1_RHI_ECC_COR_ERR_RSVD_S)
#define IG3_RMI1_RHI_ECC_COR_ERR_CNT_S 0
#define IG3_RMI1_RHI_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RMI1_RHI_ECC_COR_ERR_CNT_S)
#define IG3_RMI1_RHI_ECC_UNCOR_ERR 0x42C5002C
#define IG3_RMI1_RHI_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_RMI1_RHI_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_RMI1_RHI_ECC_UNCOR_ERR_RSVD_S)
#define IG3_RMI1_RHI_ECC_UNCOR_ERR_CNT_S 0
#define IG3_RMI1_RHI_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_RMI1_RHI_ECC_UNCOR_ERR_CNT_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG 0x42C50020
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_ECC_INST_NUM_S 25
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RMI1_RMI_CMD_CREDITS_CFG_ECC_INST_NUM_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_RSVD3_S 20
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RMI1_RMI_CMD_CREDITS_CFG_RSVD3_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_RM_S 16
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RMI1_RMI_CMD_CREDITS_CFG_RM_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_RSVD2_S 14
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_CMD_CREDITS_CFG_RSVD2_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_POWER_GATE_EN_S 13
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RMI1_RMI_CMD_CREDITS_CFG_POWER_GATE_EN_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_RME_S 12
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_RME_M RDMA_BIT2(32, IG3_RMI1_RMI_CMD_CREDITS_CFG_RME_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_RSVD1_S 10
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_CMD_CREDITS_CFG_RSVD1_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_ERR_CNT_S 9
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RMI1_RMI_CMD_CREDITS_CFG_ERR_CNT_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_FIX_CNT_S 8
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RMI1_RMI_CMD_CREDITS_CFG_FIX_CNT_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_RSVD0_S 6
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_CMD_CREDITS_CFG_RSVD0_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_MASK_INT_S 5
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RMI1_RMI_CMD_CREDITS_CFG_MASK_INT_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_LS_BYPASS_S 4
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RMI1_RMI_CMD_CREDITS_CFG_LS_BYPASS_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_LS_FORCE_S 3
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RMI1_RMI_CMD_CREDITS_CFG_LS_FORCE_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_ECC_INVERT_2_S 2
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RMI1_RMI_CMD_CREDITS_CFG_ECC_INVERT_2_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_ECC_INVERT_1_S 1
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RMI1_RMI_CMD_CREDITS_CFG_ECC_INVERT_1_S)
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_ECC_EN_S 0
#define IG3_RMI1_RMI_CMD_CREDITS_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RMI1_RMI_CMD_CREDITS_CFG_ECC_EN_S)
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS 0x42C5001C
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS_RSVD1_S 30
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_CMD_CREDITS_STATUS_RSVD1_S)
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RMI1_RMI_CMD_CREDITS_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS_RSVD0_S 4
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RMI1_RMI_CMD_CREDITS_STATUS_RSVD0_S)
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RMI1_RMI_CMD_CREDITS_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS_INIT_DONE_S 2
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RMI1_RMI_CMD_CREDITS_STATUS_INIT_DONE_S)
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS_ECC_FIX_S 1
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RMI1_RMI_CMD_CREDITS_STATUS_ECC_FIX_S)
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS_ECC_ERR_S 0
#define IG3_RMI1_RMI_CMD_CREDITS_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RMI1_RMI_CMD_CREDITS_STATUS_ECC_ERR_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG 0x42C50028
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_ECC_INST_NUM_S 25
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RMI1_RMI_DATA_CREDITS_CFG_ECC_INST_NUM_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_RSVD3_S 20
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RMI1_RMI_DATA_CREDITS_CFG_RSVD3_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_RM_S 16
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RMI1_RMI_DATA_CREDITS_CFG_RM_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_RSVD2_S 14
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_DATA_CREDITS_CFG_RSVD2_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_POWER_GATE_EN_S 13
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RMI1_RMI_DATA_CREDITS_CFG_POWER_GATE_EN_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_RME_S 12
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_RME_M RDMA_BIT2(32, IG3_RMI1_RMI_DATA_CREDITS_CFG_RME_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_RSVD1_S 10
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_DATA_CREDITS_CFG_RSVD1_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_ERR_CNT_S 9
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RMI1_RMI_DATA_CREDITS_CFG_ERR_CNT_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_FIX_CNT_S 8
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RMI1_RMI_DATA_CREDITS_CFG_FIX_CNT_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_RSVD0_S 6
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_DATA_CREDITS_CFG_RSVD0_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_MASK_INT_S 5
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RMI1_RMI_DATA_CREDITS_CFG_MASK_INT_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_LS_BYPASS_S 4
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RMI1_RMI_DATA_CREDITS_CFG_LS_BYPASS_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_LS_FORCE_S 3
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RMI1_RMI_DATA_CREDITS_CFG_LS_FORCE_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_ECC_INVERT_2_S 2
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RMI1_RMI_DATA_CREDITS_CFG_ECC_INVERT_2_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_ECC_INVERT_1_S 1
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RMI1_RMI_DATA_CREDITS_CFG_ECC_INVERT_1_S)
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_ECC_EN_S 0
#define IG3_RMI1_RMI_DATA_CREDITS_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RMI1_RMI_DATA_CREDITS_CFG_ECC_EN_S)
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS 0x42C50024
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS_RSVD1_S 30
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_DATA_CREDITS_STATUS_RSVD1_S)
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RMI1_RMI_DATA_CREDITS_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS_RSVD0_S 4
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RMI1_RMI_DATA_CREDITS_STATUS_RSVD0_S)
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RMI1_RMI_DATA_CREDITS_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS_INIT_DONE_S 2
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RMI1_RMI_DATA_CREDITS_STATUS_INIT_DONE_S)
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS_ECC_FIX_S 1
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RMI1_RMI_DATA_CREDITS_STATUS_ECC_FIX_S)
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS_ECC_ERR_S 0
#define IG3_RMI1_RMI_DATA_CREDITS_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RMI1_RMI_DATA_CREDITS_STATUS_ECC_ERR_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG 0x42C50010
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ECC_INST_NUM_S 25
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ECC_INST_NUM_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RSVD3_S 20
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RSVD3_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RM_S 16
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RM_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RSVD2_S 14
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RSVD2_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_POWER_GATE_EN_S 13
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_POWER_GATE_EN_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RME_S 12
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RME_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RME_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RSVD1_S 10
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RSVD1_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ERR_CNT_S 9
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ERR_CNT_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_FIX_CNT_S 8
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_FIX_CNT_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RSVD0_S 6
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_RSVD0_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_MASK_INT_S 5
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_MASK_INT_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_LS_BYPASS_S 4
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_LS_BYPASS_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_LS_FORCE_S 3
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_LS_FORCE_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ECC_INVERT_2_S 2
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ECC_INVERT_2_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ECC_INVERT_1_S 1
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ECC_INVERT_1_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ECC_EN_S 0
#define IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_LEFT_DATA_CFG_ECC_EN_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS 0x42C5000C
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_RSVD1_S 30
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_RSVD1_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_RSVD0_S 4
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_RSVD0_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_INIT_DONE_S 2
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_INIT_DONE_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_ECC_FIX_S 1
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_ECC_FIX_S)
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_ECC_ERR_S 0
#define IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_LEFT_DATA_STATUS_ECC_ERR_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG 0x42C50018
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ECC_INST_NUM_S 25
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ECC_INST_NUM_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RSVD3_S 20
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RSVD3_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RM_S 16
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RM_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RSVD2_S 14
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RSVD2_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_POWER_GATE_EN_S 13
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_POWER_GATE_EN_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RME_S 12
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RME_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RME_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RSVD1_S 10
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RSVD1_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ERR_CNT_S 9
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ERR_CNT_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_FIX_CNT_S 8
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_FIX_CNT_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RSVD0_S 6
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_RSVD0_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_MASK_INT_S 5
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_MASK_INT_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_MASK_INT_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_LS_BYPASS_S 4
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_LS_BYPASS_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_LS_FORCE_S 3
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_LS_FORCE_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ECC_INVERT_2_S 2
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ECC_INVERT_2_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ECC_INVERT_1_S 1
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ECC_INVERT_1_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ECC_EN_S 0
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ECC_EN_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_RIGHT_DATA_CFG_ECC_EN_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS 0x42C50014
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_RSVD1_S 30
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_RSVD1_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_RSVD0_S 4
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_RSVD0_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_INIT_DONE_S 2
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_INIT_DONE_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_ECC_FIX_S 1
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_ECC_FIX_S)
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_ECC_ERR_S 0
#define IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_RMI1_RMI_RESP_RIGHT_DATA_STATUS_ECC_ERR_S)
#define IG3_PRX0_GLPE_CC_DCQCN1_CFG(_i) 0x43002000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX0_GLPE_CC_DCQCN1_CFG_MAX_INDEX_I 1031
#define IG3_PRX0_GLPE_CC_DCQCN1_CFG_RSVD2_S 31
#define IG3_PRX0_GLPE_CC_DCQCN1_CFG_RSVD2_M RDMA_BIT2(32, IG3_PRX0_GLPE_CC_DCQCN1_CFG_RSVD2_S)
#define IG3_PRX0_GLPE_CC_DCQCN1_CFG_DCQCN_F_S 28
#define IG3_PRX0_GLPE_CC_DCQCN1_CFG_DCQCN_F_M RDMA_MASK3(32, 0x7, IG3_PRX0_GLPE_CC_DCQCN1_CFG_DCQCN_F_S)
#define IG3_PRX0_GLPE_CC_DCQCN1_CFG_RSVD1_S 25
#define IG3_PRX0_GLPE_CC_DCQCN1_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_PRX0_GLPE_CC_DCQCN1_CFG_RSVD1_S)
#define IG3_PRX0_GLPE_CC_DCQCN1_CFG_DCQCN_B_S 0
#define IG3_PRX0_GLPE_CC_DCQCN1_CFG_DCQCN_B_M RDMA_MASK3(32, 0x1FFFFFF, IG3_PRX0_GLPE_CC_DCQCN1_CFG_DCQCN_B_S)
#define IG3_PRX0_GLPE_CC_DCQCN2_CFG(_i) 0x43004000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX0_GLPE_CC_DCQCN2_CFG_MAX_INDEX_I 1031
#define IG3_PRX0_GLPE_CC_DCQCN2_CFG_RSVD_S 16
#define IG3_PRX0_GLPE_CC_DCQCN2_CFG_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PRX0_GLPE_CC_DCQCN2_CFG_RSVD_S)
#define IG3_PRX0_GLPE_CC_DCQCN2_CFG_DCQCN_T_S 0
#define IG3_PRX0_GLPE_CC_DCQCN2_CFG_DCQCN_T_M RDMA_MASK3(32, 0xFFFF, IG3_PRX0_GLPE_CC_DCQCN2_CFG_DCQCN_T_S)
#define IG3_PRX0_GLPE_CC_TIMELY_CFG(_i) 0x43000000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX0_GLPE_CC_TIMELY_CFG_MAX_INDEX_I 1031
#define IG3_PRX0_GLPE_CC_TIMELY_CFG_RAI_FACTOR_S 16
#define IG3_PRX0_GLPE_CC_TIMELY_CFG_RAI_FACTOR_M RDMA_MASK3(32, 0xFFFF, IG3_PRX0_GLPE_CC_TIMELY_CFG_RAI_FACTOR_S)
#define IG3_PRX0_GLPE_CC_TIMELY_CFG_HAI_FACTOR_S 0
#define IG3_PRX0_GLPE_CC_TIMELY_CFG_HAI_FACTOR_M RDMA_MASK3(32, 0xFFFF, IG3_PRX0_GLPE_CC_TIMELY_CFG_HAI_FACTOR_S)
#define IG3_PRX0_GLPE_PRX_CONFIG 0x43005020
#define IG3_PRX0_GLPE_PRX_CONFIG_REORDER_CNT_MAX_S 24
#define IG3_PRX0_GLPE_PRX_CONFIG_REORDER_CNT_MAX_M RDMA_MASK3(32, 0xFF, IG3_PRX0_GLPE_PRX_CONFIG_REORDER_CNT_MAX_S)
#define IG3_PRX0_GLPE_PRX_CONFIG_REORDER_CNT_MIN_S 16
#define IG3_PRX0_GLPE_PRX_CONFIG_REORDER_CNT_MIN_M RDMA_MASK3(32, 0xFF, IG3_PRX0_GLPE_PRX_CONFIG_REORDER_CNT_MIN_S)
#define IG3_PRX0_GLPE_PRX_CONFIG_RSVD1_S 12
#define IG3_PRX0_GLPE_PRX_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PRX0_GLPE_PRX_CONFIG_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_S 8
#define IG3_PRX0_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_M RDMA_MASK3(32, 0xF, IG3_PRX0_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_S)
#define IG3_PRX0_GLPE_PRX_CONFIG_RSVD0_S 5
#define IG3_PRX0_GLPE_PRX_CONFIG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PRX0_GLPE_PRX_CONFIG_RSVD0_S)
#define IG3_PRX0_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_S 4
#define IG3_PRX0_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_S)
#define IG3_PRX0_GLPE_PRX_CONFIG_ONE_HP_TILE_S 3
#define IG3_PRX0_GLPE_PRX_CONFIG_ONE_HP_TILE_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_CONFIG_ONE_HP_TILE_S)
#define IG3_PRX0_GLPE_PRX_CONFIG_DIS_RREC_S 2
#define IG3_PRX0_GLPE_PRX_CONFIG_DIS_RREC_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_CONFIG_DIS_RREC_S)
#define IG3_PRX0_GLPE_PRX_CONFIG_DIS_QR_STALL_S 1
#define IG3_PRX0_GLPE_PRX_CONFIG_DIS_QR_STALL_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_CONFIG_DIS_QR_STALL_S)
#define IG3_PRX0_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_S 0
#define IG3_PRX0_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_S)
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_COUNT 0x430050B8
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX0_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX0_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_CMD 0x430050CC
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_DATA_H 0x430050D8
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_DATA_L 0x430050D4
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_PTR 0x430050D0
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX0_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_CMD 0x430050BC
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_DATA_H 0x430050C8
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_DATA_L 0x430050C4
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_PTR 0x430050C0
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX0_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL 0x43005080
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_RSVD1_S 25
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PRX0_GLPE_PRX_DTM_CONTROL_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_RSVD2_S 17
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX0_GLPE_PRX_DTM_CONTROL_RSVD2_S)
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_RSVD3_S 9
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PRX0_GLPE_PRX_DTM_CONTROL_RSVD3_S)
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_BYPASS_S 8
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_CONTROL_BYPASS_S)
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_RSVD4_S 1
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PRX0_GLPE_PRX_DTM_CONTROL_RSVD4_S)
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PRX0_GLPE_PRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PRX0_GLPE_PRX_DTM_ECC_COR_ERR 0x430050E8
#define IG3_PRX0_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PRX0_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX0_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PRX0_GLPE_PRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PRX0_GLPE_PRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PRX0_GLPE_PRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PRX0_GLPE_PRX_DTM_ECC_UNCOR_ERR 0x430050E4
#define IG3_PRX0_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PRX0_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX0_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PRX0_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PRX0_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PRX0_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PRX0_GLPE_PRX_DTM_GROUP_CFG 0x4300508C
#define IG3_PRX0_GLPE_PRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PRX0_GLPE_PRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PRX0_GLPE_PRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PRX0_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX0_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PRX0_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PRX0_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX0_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PRX0_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PRX0_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX0_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PRX0_GLPE_PRX_DTM_LOG_CFG 0x43005090
#define IG3_PRX0_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PRX0_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PRX0_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PRX0_GLPE_PRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PRX0_GLPE_PRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PRX0_GLPE_PRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_DTM_LOG_CFG_MODE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PRX0_GLPE_PRX_DTM_LOG_CFG_MODE_S)
#define IG3_PRX0_GLPE_PRX_DTM_LOG_MASK 0x43005098
#define IG3_PRX0_GLPE_PRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX0_GLPE_PRX_DTM_LOG_MASK_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_LOG_PATTERN 0x43005094
#define IG3_PRX0_GLPE_PRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX0_GLPE_PRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG 0x43005084
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_STS 0x43005088
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PRX0_GLPE_PRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX0_GLPE_PRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PRX0_GLPE_PRX_DTM_TIMESTAMP 0x430050B0
#define IG3_PRX0_GLPE_PRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX0_GLPE_PRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER 0x430050B4
#define IG3_PRX0_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX0_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG 0x430050DC
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS 0x430050E0
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG 0x4300509C
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PRX0_GLPE_PRX_DTM_TRIG_CFG_MODE_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_COUNT 0x430050A8
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX0_GLPE_PRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_MASK 0x430050A4
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX0_GLPE_PRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_PATTERN 0x430050A0
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX0_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_TIMESTAMP 0x430050AC
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PRX0_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX0_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_CTL 0x43005024
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_S 12
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_S)
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_S 0
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_S)
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA 0x43005028
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_S 31
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_S)
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_S 30
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_M RDMA_BIT2(32, IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_S)
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_S 24
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_S)
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_S 20
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_S)
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_S 0
#define IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX0_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_S)
#define IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL 0x43008018
#define IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_S 21
#define IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_M RDMA_MASK3(32, 0x7FF, IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_S)
#define IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_S 16
#define IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_S)
#define IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_S 13
#define IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_S 8
#define IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_S)
#define IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_S 5
#define IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_S)
#define IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_S 0
#define IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX0_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_S)
#define IG3_WRX0_GLPE_WRX_CONFIG 0x43008000
#define IG3_WRX0_GLPE_WRX_CONFIG_RSVD_S 8
#define IG3_WRX0_GLPE_WRX_CONFIG_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WRX0_GLPE_WRX_CONFIG_RSVD_S)
#define IG3_WRX0_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_S 5
#define IG3_WRX0_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_M RDMA_MASK3(32, 0x7, IG3_WRX0_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_S)
#define IG3_WRX0_GLPE_WRX_CONFIG_DIS_WQE_CACHE_S 4
#define IG3_WRX0_GLPE_WRX_CONFIG_DIS_WQE_CACHE_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_CONFIG_DIS_WQE_CACHE_S)
#define IG3_WRX0_GLPE_WRX_CONFIG_DROP_OOO_IMMED_S 3
#define IG3_WRX0_GLPE_WRX_CONFIG_DROP_OOO_IMMED_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_CONFIG_DROP_OOO_IMMED_S)
#define IG3_WRX0_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_S 2
#define IG3_WRX0_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_S)
#define IG3_WRX0_GLPE_WRX_CONFIG_DIS_Q1_AE_S 1
#define IG3_WRX0_GLPE_WRX_CONFIG_DIS_Q1_AE_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_CONFIG_DIS_Q1_AE_S)
#define IG3_WRX0_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_S 0
#define IG3_WRX0_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_S)
#define IG3_WRX0_GLPE_WRX_DOMAIN_IDS 0x43008014
#define IG3_WRX0_GLPE_WRX_DOMAIN_IDS_RSVD2_S 11
#define IG3_WRX0_GLPE_WRX_DOMAIN_IDS_RSVD2_M RDMA_MASK3(32, 0x1FFFFF, IG3_WRX0_GLPE_WRX_DOMAIN_IDS_RSVD2_S)
#define IG3_WRX0_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_S 8
#define IG3_WRX0_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX0_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_S)
#define IG3_WRX0_GLPE_WRX_DOMAIN_IDS_RSVD1_S 7
#define IG3_WRX0_GLPE_WRX_DOMAIN_IDS_RSVD1_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DOMAIN_IDS_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_S 4
#define IG3_WRX0_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX0_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_S)
#define IG3_WRX0_GLPE_WRX_DOMAIN_IDS_RSVD0_S 3
#define IG3_WRX0_GLPE_WRX_DOMAIN_IDS_RSVD0_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DOMAIN_IDS_RSVD0_S)
#define IG3_WRX0_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_S 0
#define IG3_WRX0_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX0_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_S)
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_COUNT 0x430080B8
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX0_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX0_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_CMD 0x430080CC
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_DATA_H 0x430080D8
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_DATA_L 0x430080D4
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_PTR 0x430080D0
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX0_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_CMD 0x430080BC
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_DATA_H 0x430080C8
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_DATA_L 0x430080C4
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_PTR 0x430080C0
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX0_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL 0x43008080
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_RSVD1_S 25
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_WRX0_GLPE_WRX_DTM_CONTROL_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_RSVD2_S 17
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX0_GLPE_WRX_DTM_CONTROL_RSVD2_S)
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_RSVD3_S 9
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_WRX0_GLPE_WRX_DTM_CONTROL_RSVD3_S)
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_BYPASS_S 8
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_CONTROL_BYPASS_S)
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_RSVD4_S 1
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_WRX0_GLPE_WRX_DTM_CONTROL_RSVD4_S)
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_WRX0_GLPE_WRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_WRX0_GLPE_WRX_DTM_ECC_COR_ERR 0x430080E8
#define IG3_WRX0_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_WRX0_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX0_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_WRX0_GLPE_WRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_WRX0_GLPE_WRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WRX0_GLPE_WRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_WRX0_GLPE_WRX_DTM_ECC_UNCOR_ERR 0x430080E4
#define IG3_WRX0_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_WRX0_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX0_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_WRX0_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_WRX0_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WRX0_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_WRX0_GLPE_WRX_DTM_GROUP_CFG 0x4300808C
#define IG3_WRX0_GLPE_WRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_WRX0_GLPE_WRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WRX0_GLPE_WRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_WRX0_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX0_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_WRX0_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_WRX0_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX0_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_WRX0_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_WRX0_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX0_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_WRX0_GLPE_WRX_DTM_LOG_CFG 0x43008090
#define IG3_WRX0_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_WRX0_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_WRX0_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_WRX0_GLPE_WRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_WRX0_GLPE_WRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_WRX0_GLPE_WRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_DTM_LOG_CFG_MODE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_WRX0_GLPE_WRX_DTM_LOG_CFG_MODE_S)
#define IG3_WRX0_GLPE_WRX_DTM_LOG_MASK 0x43008098
#define IG3_WRX0_GLPE_WRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_DTM_LOG_MASK_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_LOG_PATTERN 0x43008094
#define IG3_WRX0_GLPE_WRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG 0x43008084
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_STS 0x43008088
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_WRX0_GLPE_WRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX0_GLPE_WRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_WRX0_GLPE_WRX_DTM_TIMESTAMP 0x430080B0
#define IG3_WRX0_GLPE_WRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER 0x430080B4
#define IG3_WRX0_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG 0x430080DC
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS 0x430080E0
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG 0x4300809C
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_WRX0_GLPE_WRX_DTM_TRIG_CFG_MODE_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_COUNT 0x430080A8
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_MASK 0x430080A4
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_PATTERN 0x430080A0
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_TIMESTAMP 0x430080AC
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_WRX0_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHHI 0x43008020
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WRX0_GLPE_WRX_FWQPFLUSHHI_RSVD0_S)
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHHI_QPID_S 6
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX0_GLPE_WRX_FWQPFLUSHHI_QPID_S)
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WRX0_GLPE_WRX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO 0x4300801C
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_BUSY_S 31
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_BUSY_S)
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_RSVD0_S)
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_HOSTID_S)
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_PMF_S 0
#define IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WRX0_GLPE_WRX_FWQPFLUSHLO_PMF_S)
#define IG3_WRX0_GLPE_WRX_RQ_CACHE_CTRL 0x43008004
#define IG3_WRX0_GLPE_WRX_RQ_CACHE_CTRL_RSVD_S 7
#define IG3_WRX0_GLPE_WRX_RQ_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x1FFFFFF, IG3_WRX0_GLPE_WRX_RQ_CACHE_CTRL_RSVD_S)
#define IG3_WRX0_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_S 0
#define IG3_WRX0_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_M RDMA_MASK3(32, 0x7F, IG3_WRX0_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_S)
#define IG3_WRX0_GLPE_WRX_RQ_CACHE_DATA0 0x43008008
#define IG3_WRX0_GLPE_WRX_RQ_CACHE_DATA0_DATA_S 0
#define IG3_WRX0_GLPE_WRX_RQ_CACHE_DATA0_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_RQ_CACHE_DATA0_DATA_S)
#define IG3_WRX0_GLPE_WRX_RQ_CACHE_DATA1 0x4300800C
#define IG3_WRX0_GLPE_WRX_RQ_CACHE_DATA1_DATA_S 0
#define IG3_WRX0_GLPE_WRX_RQ_CACHE_DATA1_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_RQ_CACHE_DATA1_DATA_S)
#define IG3_WRX0_GLPE_WRX_RQ_CACHE_DATA2 0x43008010
#define IG3_WRX0_GLPE_WRX_RQ_CACHE_DATA2_DATA_S 0
#define IG3_WRX0_GLPE_WRX_RQ_CACHE_DATA2_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX0_GLPE_WRX_RQ_CACHE_DATA2_DATA_S)
#define IG3_SQC0_GLPE_SQC_CONFIG 0x43008470
#define IG3_SQC0_GLPE_SQC_CONFIG_RSVD_S 6
#define IG3_SQC0_GLPE_SQC_CONFIG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_SQC0_GLPE_SQC_CONFIG_RSVD_S)
#define IG3_SQC0_GLPE_SQC_CONFIG_DBL_INDV_DIS_S 3
#define IG3_SQC0_GLPE_SQC_CONFIG_DBL_INDV_DIS_M RDMA_MASK3(32, 0x7, IG3_SQC0_GLPE_SQC_CONFIG_DBL_INDV_DIS_S)
#define IG3_SQC0_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_S 2
#define IG3_SQC0_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_S)
#define IG3_SQC0_GLPE_SQC_CONFIG_DBL_DIS_S 1
#define IG3_SQC0_GLPE_SQC_CONFIG_DBL_DIS_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_CONFIG_DBL_DIS_S)
#define IG3_SQC0_GLPE_SQC_CONFIG_COALESCE_DIS_S 0
#define IG3_SQC0_GLPE_SQC_CONFIG_COALESCE_DIS_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_CONFIG_COALESCE_DIS_S)
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_COUNT 0x430084B8
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC0_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC0_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_CMD 0x430084CC
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_DATA_H 0x430084D8
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_DATA_L 0x430084D4
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_PTR 0x430084D0
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC0_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_CMD 0x430084BC
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_DATA_H 0x430084C8
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_DATA_L 0x430084C4
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_PTR 0x430084C0
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC0_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL 0x43008480
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_RSVD1_S 25
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SQC0_GLPE_SQC_DTM_CONTROL_RSVD1_S)
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_RSVD2_S 17
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC0_GLPE_SQC_DTM_CONTROL_RSVD2_S)
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_RSVD3_S 9
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SQC0_GLPE_SQC_DTM_CONTROL_RSVD3_S)
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_BYPASS_S 8
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_CONTROL_BYPASS_S)
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_RSVD4_S 1
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SQC0_GLPE_SQC_DTM_CONTROL_RSVD4_S)
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SQC0_GLPE_SQC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SQC0_GLPE_SQC_DTM_ECC_COR_ERR 0x430084E8
#define IG3_SQC0_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SQC0_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC0_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SQC0_GLPE_SQC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SQC0_GLPE_SQC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC0_GLPE_SQC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SQC0_GLPE_SQC_DTM_ECC_UNCOR_ERR 0x430084E4
#define IG3_SQC0_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SQC0_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC0_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SQC0_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SQC0_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC0_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SQC0_GLPE_SQC_DTM_GROUP_CFG 0x4300848C
#define IG3_SQC0_GLPE_SQC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SQC0_GLPE_SQC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SQC0_GLPE_SQC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SQC0_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SQC0_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC0_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SQC0_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SQC0_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC0_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SQC0_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SQC0_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC0_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SQC0_GLPE_SQC_DTM_LOG_CFG 0x43008490
#define IG3_SQC0_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SQC0_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SQC0_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SQC0_GLPE_SQC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SQC0_GLPE_SQC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SQC0_GLPE_SQC_DTM_LOG_CFG_RSVD1_S)
#define IG3_SQC0_GLPE_SQC_DTM_LOG_CFG_MODE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SQC0_GLPE_SQC_DTM_LOG_CFG_MODE_S)
#define IG3_SQC0_GLPE_SQC_DTM_LOG_MASK 0x43008498
#define IG3_SQC0_GLPE_SQC_DTM_LOG_MASK_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC0_GLPE_SQC_DTM_LOG_MASK_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_LOG_PATTERN 0x43008494
#define IG3_SQC0_GLPE_SQC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC0_GLPE_SQC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG 0x43008484
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_STS 0x43008488
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SQC0_GLPE_SQC_DTM_MAIN_STS_RSVD1_S)
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC0_GLPE_SQC_DTM_MAIN_STS_RSVD2_S)
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SQC0_GLPE_SQC_DTM_TIMESTAMP 0x430084B0
#define IG3_SQC0_GLPE_SQC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC0_GLPE_SQC_DTM_TIMESTAMP_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER 0x430084B4
#define IG3_SQC0_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC0_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG 0x430084DC
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS 0x430084E0
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG 0x4300849C
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_MODE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SQC0_GLPE_SQC_DTM_TRIG_CFG_MODE_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_COUNT 0x430084A8
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC0_GLPE_SQC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_MASK 0x430084A4
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC0_GLPE_SQC_DTM_TRIG_MASK_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_PATTERN 0x430084A0
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC0_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_TIMESTAMP 0x430084AC
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SQC0_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC0_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHHI 0x43008460
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_S 26
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_S)
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHHI_QPID_S 6
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHHI_QPID_S)
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_S 0
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_S)
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO 0x43008464
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_S 31
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_S)
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_S 30
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_S)
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_S 29
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_S)
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_S 26
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_S)
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_S)
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_PMF_S 0
#define IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC0_GLPE_SQC_FWFLRQPFLUSHLO_PMF_S)
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPHI(_i) 0x43008420 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPHI_MAX_INDEX_I 7
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPHI_RSVD0_S 26
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_SQC0_GLPE_SQC_FWFLUSHDROPHI_RSVD0_S)
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPHI_QPID_S 6
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC0_GLPE_SQC_FWFLUSHDROPHI_QPID_S)
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_S 0
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_SQC0_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_S)
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO(_i) 0x43008400 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_MAX_INDEX_I 7
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_EN_S 31
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_EN_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_EN_S)
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_RSVD0_S 29
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_RSVD0_S)
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_HOSTID_S 26
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_HOSTID_S)
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_S 24
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_S)
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_S 12
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_S)
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_PMF_S 0
#define IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC0_GLPE_SQC_FWFLUSHDROPLO_PMF_S)
#define IG3_SQC0_GLPE_SQC_FWSYNCRESP(_i) 0x43008468 + ((_i) * 4) /* _i=0...1 */
#define IG3_SQC0_GLPE_SQC_FWSYNCRESP_MAX_INDEX_I 1
#define IG3_SQC0_GLPE_SQC_FWSYNCRESP_RSVD_S 18
#define IG3_SQC0_GLPE_SQC_FWSYNCRESP_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_SQC0_GLPE_SQC_FWSYNCRESP_RSVD_S)
#define IG3_SQC0_GLPE_SQC_FWSYNCRESP_COUNT_S 8
#define IG3_SQC0_GLPE_SQC_FWSYNCRESP_COUNT_M RDMA_MASK3(32, 0x3FF, IG3_SQC0_GLPE_SQC_FWSYNCRESP_COUNT_S)
#define IG3_SQC0_GLPE_SQC_FWSYNCRESP_TAG_S 0
#define IG3_SQC0_GLPE_SQC_FWSYNCRESP_TAG_M RDMA_MASK3(32, 0xFF, IG3_SQC0_GLPE_SQC_FWSYNCRESP_TAG_S)
#define IG3_SQC0_GLPE_SQC_XLR_DROP(_i) 0x43008440 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC0_GLPE_SQC_XLR_DROP_MAX_INDEX_I 7
#define IG3_SQC0_GLPE_SQC_XLR_DROP_EN_S 31
#define IG3_SQC0_GLPE_SQC_XLR_DROP_EN_M RDMA_BIT2(32, IG3_SQC0_GLPE_SQC_XLR_DROP_EN_S)
#define IG3_SQC0_GLPE_SQC_XLR_DROP_RSVD0_S 12
#define IG3_SQC0_GLPE_SQC_XLR_DROP_RSVD0_M RDMA_MASK3(32, 0x7FFFF, IG3_SQC0_GLPE_SQC_XLR_DROP_RSVD0_S)
#define IG3_SQC0_GLPE_SQC_XLR_DROP_PMF_S 0
#define IG3_SQC0_GLPE_SQC_XLR_DROP_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC0_GLPE_SQC_XLR_DROP_PMF_S)
#define IG3_SQC0_SQC_ECC_COR_ERR 0x43008514
#define IG3_SQC0_SQC_ECC_COR_ERR_RSVD_S 12
#define IG3_SQC0_SQC_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC0_SQC_ECC_COR_ERR_RSVD_S)
#define IG3_SQC0_SQC_ECC_COR_ERR_CNT_S 0
#define IG3_SQC0_SQC_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC0_SQC_ECC_COR_ERR_CNT_S)
#define IG3_SQC0_SQC_ECC_UNCOR_ERR 0x43008510
#define IG3_SQC0_SQC_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SQC0_SQC_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC0_SQC_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SQC0_SQC_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SQC0_SQC_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC0_SQC_ECC_UNCOR_ERR_CNT_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG 0x43008500
#define IG3_SQC0_SQC_WRK_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_SQC0_SQC_WRK_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC0_SQC_WRK_RAM_CFG_ECC_INST_NUM_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_RSVD3_S 20
#define IG3_SQC0_SQC_WRK_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC0_SQC_WRK_RAM_CFG_RSVD3_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_RM_S 16
#define IG3_SQC0_SQC_WRK_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC0_SQC_WRK_RAM_CFG_RM_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_RSVD2_S 14
#define IG3_SQC0_SQC_WRK_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC0_SQC_WRK_RAM_CFG_RSVD2_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_SQC0_SQC_WRK_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC0_SQC_WRK_RAM_CFG_POWER_GATE_EN_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_RME_S 12
#define IG3_SQC0_SQC_WRK_RAM_CFG_RME_M RDMA_BIT2(32, IG3_SQC0_SQC_WRK_RAM_CFG_RME_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_RSVD1_S 10
#define IG3_SQC0_SQC_WRK_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC0_SQC_WRK_RAM_CFG_RSVD1_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_ERR_CNT_S 9
#define IG3_SQC0_SQC_WRK_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC0_SQC_WRK_RAM_CFG_ERR_CNT_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_FIX_CNT_S 8
#define IG3_SQC0_SQC_WRK_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC0_SQC_WRK_RAM_CFG_FIX_CNT_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_RSVD0_S 6
#define IG3_SQC0_SQC_WRK_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC0_SQC_WRK_RAM_CFG_RSVD0_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_MASK_INT_S 5
#define IG3_SQC0_SQC_WRK_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC0_SQC_WRK_RAM_CFG_MASK_INT_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_LS_BYPASS_S 4
#define IG3_SQC0_SQC_WRK_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC0_SQC_WRK_RAM_CFG_LS_BYPASS_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_LS_FORCE_S 3
#define IG3_SQC0_SQC_WRK_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC0_SQC_WRK_RAM_CFG_LS_FORCE_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_SQC0_SQC_WRK_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC0_SQC_WRK_RAM_CFG_ECC_INVERT_2_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_SQC0_SQC_WRK_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC0_SQC_WRK_RAM_CFG_ECC_INVERT_1_S)
#define IG3_SQC0_SQC_WRK_RAM_CFG_ECC_EN_S 0
#define IG3_SQC0_SQC_WRK_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC0_SQC_WRK_RAM_CFG_ECC_EN_S)
#define IG3_SQC0_SQC_WRK_RAM_STATUS 0x43008504
#define IG3_SQC0_SQC_WRK_RAM_STATUS_RSVD1_S 30
#define IG3_SQC0_SQC_WRK_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC0_SQC_WRK_RAM_STATUS_RSVD1_S)
#define IG3_SQC0_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC0_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC0_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC0_SQC_WRK_RAM_STATUS_RSVD0_S 4
#define IG3_SQC0_SQC_WRK_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC0_SQC_WRK_RAM_STATUS_RSVD0_S)
#define IG3_SQC0_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC0_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC0_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC0_SQC_WRK_RAM_STATUS_INIT_DONE_S 2
#define IG3_SQC0_SQC_WRK_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC0_SQC_WRK_RAM_STATUS_INIT_DONE_S)
#define IG3_SQC0_SQC_WRK_RAM_STATUS_ECC_FIX_S 1
#define IG3_SQC0_SQC_WRK_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC0_SQC_WRK_RAM_STATUS_ECC_FIX_S)
#define IG3_SQC0_SQC_WRK_RAM_STATUS_ECC_ERR_S 0
#define IG3_SQC0_SQC_WRK_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC0_SQC_WRK_RAM_STATUS_ECC_ERR_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG 0x43008508
#define IG3_SQC0_SQC_XBUF_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_SQC0_SQC_XBUF_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC0_SQC_XBUF_RAM_CFG_ECC_INST_NUM_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_RSVD3_S 20
#define IG3_SQC0_SQC_XBUF_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC0_SQC_XBUF_RAM_CFG_RSVD3_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_RM_S 16
#define IG3_SQC0_SQC_XBUF_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC0_SQC_XBUF_RAM_CFG_RM_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_RSVD2_S 14
#define IG3_SQC0_SQC_XBUF_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC0_SQC_XBUF_RAM_CFG_RSVD2_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_SQC0_SQC_XBUF_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC0_SQC_XBUF_RAM_CFG_POWER_GATE_EN_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_RME_S 12
#define IG3_SQC0_SQC_XBUF_RAM_CFG_RME_M RDMA_BIT2(32, IG3_SQC0_SQC_XBUF_RAM_CFG_RME_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_RSVD1_S 10
#define IG3_SQC0_SQC_XBUF_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC0_SQC_XBUF_RAM_CFG_RSVD1_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_ERR_CNT_S 9
#define IG3_SQC0_SQC_XBUF_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC0_SQC_XBUF_RAM_CFG_ERR_CNT_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_FIX_CNT_S 8
#define IG3_SQC0_SQC_XBUF_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC0_SQC_XBUF_RAM_CFG_FIX_CNT_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_RSVD0_S 6
#define IG3_SQC0_SQC_XBUF_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC0_SQC_XBUF_RAM_CFG_RSVD0_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_MASK_INT_S 5
#define IG3_SQC0_SQC_XBUF_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC0_SQC_XBUF_RAM_CFG_MASK_INT_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_LS_BYPASS_S 4
#define IG3_SQC0_SQC_XBUF_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC0_SQC_XBUF_RAM_CFG_LS_BYPASS_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_LS_FORCE_S 3
#define IG3_SQC0_SQC_XBUF_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC0_SQC_XBUF_RAM_CFG_LS_FORCE_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_SQC0_SQC_XBUF_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC0_SQC_XBUF_RAM_CFG_ECC_INVERT_2_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_SQC0_SQC_XBUF_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC0_SQC_XBUF_RAM_CFG_ECC_INVERT_1_S)
#define IG3_SQC0_SQC_XBUF_RAM_CFG_ECC_EN_S 0
#define IG3_SQC0_SQC_XBUF_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC0_SQC_XBUF_RAM_CFG_ECC_EN_S)
#define IG3_SQC0_SQC_XBUF_RAM_STATUS 0x4300850C
#define IG3_SQC0_SQC_XBUF_RAM_STATUS_RSVD1_S 30
#define IG3_SQC0_SQC_XBUF_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC0_SQC_XBUF_RAM_STATUS_RSVD1_S)
#define IG3_SQC0_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC0_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC0_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC0_SQC_XBUF_RAM_STATUS_RSVD0_S 4
#define IG3_SQC0_SQC_XBUF_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC0_SQC_XBUF_RAM_STATUS_RSVD0_S)
#define IG3_SQC0_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC0_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC0_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC0_SQC_XBUF_RAM_STATUS_INIT_DONE_S 2
#define IG3_SQC0_SQC_XBUF_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC0_SQC_XBUF_RAM_STATUS_INIT_DONE_S)
#define IG3_SQC0_SQC_XBUF_RAM_STATUS_ECC_FIX_S 1
#define IG3_SQC0_SQC_XBUF_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC0_SQC_XBUF_RAM_STATUS_ECC_FIX_S)
#define IG3_SQC0_SQC_XBUF_RAM_STATUS_ECC_ERR_S 0
#define IG3_SQC0_SQC_XBUF_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC0_SQC_XBUF_RAM_STATUS_ECC_ERR_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DOMAIN_ID 0x43008804
#define IG3_SFPRX0_GLPE_SFP_RX_DOMAIN_ID_RSVD_S 3
#define IG3_SFPRX0_GLPE_SFP_RX_DOMAIN_ID_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DOMAIN_ID_RSVD_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_SFPRX0_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_COUNT 0x430088B8
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_CMD 0x430088CC
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H 0x430088D8
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L 0x430088D4
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_PTR 0x430088D0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_CMD 0x430088BC
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H 0x430088C8
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L 0x430088C4
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_PTR 0x430088C0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL 0x43008880
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_RSVD1_S 25
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_RSVD1_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_RSVD2_S 17
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_RSVD2_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_RSVD3_S 9
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_RSVD3_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_BYPASS_S 8
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_BYPASS_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_RSVD4_S 1
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_RSVD4_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_ECC_COR_ERR 0x430088E8
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR 0x430088E4
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_GROUP_CFG 0x4300888C
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_CFG 0x43008890
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_CFG_MODE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_CFG_MODE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_MASK 0x43008898
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_PATTERN 0x43008894
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG 0x43008884
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_STS 0x43008888
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TIMESTAMP 0x430088B0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER 0x430088B4
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG 0x430088DC
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS 0x430088E0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG 0x4300889C
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_COUNT 0x430088A8
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_MASK 0x430088A4
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_PATTERN 0x430088A0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP 0x430088AC
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SFPRX0_GLPE_SFP_RX_ERR_TBL_CLR 0x43008800
#define IG3_SFPRX0_GLPE_SFP_RX_ERR_TBL_CLR_REQ_S 31
#define IG3_SFPRX0_GLPE_SFP_RX_ERR_TBL_CLR_REQ_M RDMA_BIT2(32, IG3_SFPRX0_GLPE_SFP_RX_ERR_TBL_CLR_REQ_S)
#define IG3_SFPRX0_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_S 12
#define IG3_SFPRX0_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_SFPRX0_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_S)
#define IG3_SFPRX0_GLPE_SFP_RX_ERR_TBL_CLR_PMF_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_ERR_TBL_CLR_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX0_GLPE_SFP_RX_ERR_TBL_CLR_PMF_S)
#define IG3_SFPRX0_GLPE_SFP_RX_PER_MEM 0x43008808
#define IG3_SFPRX0_GLPE_SFP_RX_PER_MEM_RSVD_S 3
#define IG3_SFPRX0_GLPE_SFP_RX_PER_MEM_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPRX0_GLPE_SFP_RX_PER_MEM_RSVD_S)
#define IG3_SFPRX0_GLPE_SFP_RX_PER_MEM_PER_TYPE_S 0
#define IG3_SFPRX0_GLPE_SFP_RX_PER_MEM_PER_TYPE_M RDMA_MASK3(32, 0x7, IG3_SFPRX0_GLPE_SFP_RX_PER_MEM_PER_TYPE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG 0x43008C08
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS 0x43008C0C
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ECC_COR_ERR 0x43008C34
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR 0x43008C30
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG 0x43008C18
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS 0x43008C1C
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG 0x43008C20
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS 0x43008C24
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG 0x43008C00
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS 0x43008C04
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG 0x43008C28
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS 0x43008C2C
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG 0x43008C10
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS 0x43008C14
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG 0x43008C48
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS 0x43008C4C
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG 0x43008C40
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS 0x43008C44
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG 0x43008C78
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS 0x43008C7C
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG 0x43008C50
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS 0x43008C54
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG 0x43008C58
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS 0x43008C5C
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR 0x43008C84
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR 0x43008C80
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG 0x43008C70
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS 0x43008C74
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG 0x43008C60
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS 0x43008C64
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG 0x43008C68
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS 0x43008C6C
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG 0x43008C38
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS 0x43008C3C
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_ECC_COR_ERR 0x43008CCC
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR 0x43008CC8
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG 0x43008CD8
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS 0x43008CDC
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL 0x43008C90
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_S 31
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_S 26
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_S 18
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA 0x43008C94
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG 0x43008C88
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS 0x43008C8C
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL 0x43008CA0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_S 31
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_S 26
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA 0x43008CA4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG 0x43008C98
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS 0x43008C9C
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL 0x43008CB0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_S 31
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_S 26
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_S 18
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA 0x43008CB4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG 0x43008CA8
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS 0x43008CAC
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL 0x43008CC0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_S 31
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_S 26
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_S 18
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA 0x43008CC4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG 0x43008CB8
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS 0x43008CBC
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG 0x43008CD0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS 0x43008CD4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_WTX0_GLPE_WTX_1USCOUNT 0x43010010
#define IG3_WTX0_GLPE_WTX_1USCOUNT_CNT_S 0
#define IG3_WTX0_GLPE_WTX_1USCOUNT_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_1USCOUNT_CNT_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0 0x43010120
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_TAG_S 16
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_TAG_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_MODE_S 11
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_MODE_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1 0x43010124
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_PMF_S 0
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG1_PMF_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG2 0x43010128
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG2_QPID_S 6
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG2_QPID_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG3 0x4301012C
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG4 0x43010130
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_S 0
#define IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_S)
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG 0x43010020
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG_RSVD3_S 24
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG_RSVD3_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_ARB_CONFIG_RSVD3_S)
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG_RSVD2_S 20
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WTX0_GLPE_WTX_ARB_CONFIG_RSVD2_S)
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_S 16
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX0_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_S)
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG_RSVD1_S 12
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_WTX0_GLPE_WTX_ARB_CONFIG_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_S 8
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX0_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_S)
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG_RSVD0_S 4
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG_RSVD0_M RDMA_MASK3(32, 0xF, IG3_WTX0_GLPE_WTX_ARB_CONFIG_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_S 0
#define IG3_WTX0_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX0_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0 0x430100F8
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_TAG_S 16
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_TAG_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_MODE_S 11
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_MODE_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1 0x430100FC
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_PMF_S 0
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG1_PMF_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG2 0x43010100
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG2_QPID_S 6
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG2_QPID_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG3 0x43010104
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG4 0x43010108
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG4_COUNT_S 0
#define IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_CMP_DTM_TRIG4_COUNT_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG 0x4301017C
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_S 31
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_S 27
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_S 26
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX 0x43010180
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_CNPCOUNT 0x43010014
#define IG3_WTX0_GLPE_WTX_CNPCOUNT_CNT_S 0
#define IG3_WTX0_GLPE_WTX_CNPCOUNT_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_CNPCOUNT_CNT_S)
#define IG3_WTX0_GLPE_WTX_CONFIG 0x4301000C
#define IG3_WTX0_GLPE_WTX_CONFIG_RSVD1_S 28
#define IG3_WTX0_GLPE_WTX_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_WTX0_GLPE_WTX_CONFIG_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_CONFIG_SQ_HSM_ORD_S 25
#define IG3_WTX0_GLPE_WTX_CONFIG_SQ_HSM_ORD_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_CONFIG_SQ_HSM_ORD_S)
#define IG3_WTX0_GLPE_WTX_CONFIG_SQ_WQE_ORD_S 22
#define IG3_WTX0_GLPE_WTX_CONFIG_SQ_WQE_ORD_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_CONFIG_SQ_WQE_ORD_S)
#define IG3_WTX0_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_S 21
#define IG3_WTX0_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_S)
#define IG3_WTX0_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_S 20
#define IG3_WTX0_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_S)
#define IG3_WTX0_GLPE_WTX_CONFIG_RSVD0_S 4
#define IG3_WTX0_GLPE_WTX_CONFIG_RSVD0_M RDMA_MASK3(32, 0xFFFF, IG3_WTX0_GLPE_WTX_CONFIG_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_S 3
#define IG3_WTX0_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_S)
#define IG3_WTX0_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_S 2
#define IG3_WTX0_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_S)
#define IG3_WTX0_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_S 1
#define IG3_WTX0_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_S)
#define IG3_WTX0_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_S 0
#define IG3_WTX0_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG0 0x4301003C
#define IG3_WTX0_GLPE_WTX_CTCONFIG0_RSVD_S 21
#define IG3_WTX0_GLPE_WTX_CTCONFIG0_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_WTX0_GLPE_WTX_CTCONFIG0_RSVD_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG0_SCHED_S 0
#define IG3_WTX0_GLPE_WTX_CTCONFIG0_SCHED_M RDMA_MASK3(32, 0x1FFFFF, IG3_WTX0_GLPE_WTX_CTCONFIG0_SCHED_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG1 0x43010040
#define IG3_WTX0_GLPE_WTX_CTCONFIG1_RSVD_S 21
#define IG3_WTX0_GLPE_WTX_CTCONFIG1_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_WTX0_GLPE_WTX_CTCONFIG1_RSVD_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG1_VMRL_S 0
#define IG3_WTX0_GLPE_WTX_CTCONFIG1_VMRL_M RDMA_MASK3(32, 0x1FFFFF, IG3_WTX0_GLPE_WTX_CTCONFIG1_VMRL_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG2 0x43010044
#define IG3_WTX0_GLPE_WTX_CTCONFIG2_RSVD_S 30
#define IG3_WTX0_GLPE_WTX_CTCONFIG2_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_CTCONFIG2_RSVD_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_S 16
#define IG3_WTX0_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_S 0
#define IG3_WTX0_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX0_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG3 0x43010048
#define IG3_WTX0_GLPE_WTX_CTCONFIG3_RSVD_S 30
#define IG3_WTX0_GLPE_WTX_CTCONFIG3_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_CTCONFIG3_RSVD_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_S 16
#define IG3_WTX0_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_S 0
#define IG3_WTX0_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX0_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG4 0x4301004C
#define IG3_WTX0_GLPE_WTX_CTCONFIG4_RSVD_S 30
#define IG3_WTX0_GLPE_WTX_CTCONFIG4_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_CTCONFIG4_RSVD_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_S 16
#define IG3_WTX0_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_S 0
#define IG3_WTX0_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX0_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG5 0x43010050
#define IG3_WTX0_GLPE_WTX_CTCONFIG5_RSVD_S 20
#define IG3_WTX0_GLPE_WTX_CTCONFIG5_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_CTCONFIG5_RSVD_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG5_BMPKT_S 0
#define IG3_WTX0_GLPE_WTX_CTCONFIG5_BMPKT_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX0_GLPE_WTX_CTCONFIG5_BMPKT_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG6 0x43010054
#define IG3_WTX0_GLPE_WTX_CTCONFIG6_RSVD_S 13
#define IG3_WTX0_GLPE_WTX_CTCONFIG6_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_WTX0_GLPE_WTX_CTCONFIG6_RSVD_S)
#define IG3_WTX0_GLPE_WTX_CTCONFIG6_BMHDR_S 0
#define IG3_WTX0_GLPE_WTX_CTCONFIG6_BMHDR_M RDMA_MASK3(32, 0x1FFF, IG3_WTX0_GLPE_WTX_CTCONFIG6_BMHDR_S)
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_COUNT 0x43010238
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX0_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_CMD 0x4301024C
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_DATA_H 0x43010258
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_DATA_L 0x43010254
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_PTR 0x43010250
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX0_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_CMD 0x4301023C
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_DATA_H 0x43010248
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_DATA_L 0x43010244
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_PTR 0x43010240
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX0_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL 0x43010200
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_RSVD1_S 25
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_WTX0_GLPE_WTX_DTM_CONTROL_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_RSVD2_S 17
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX0_GLPE_WTX_DTM_CONTROL_RSVD2_S)
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_RSVD3_S 9
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_WTX0_GLPE_WTX_DTM_CONTROL_RSVD3_S)
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_BYPASS_S 8
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_CONTROL_BYPASS_S)
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_RSVD4_S 1
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_WTX0_GLPE_WTX_DTM_CONTROL_RSVD4_S)
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_WTX0_GLPE_WTX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_WTX0_GLPE_WTX_DTM_ECC_COR_ERR 0x43010268
#define IG3_WTX0_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX0_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_WTX0_GLPE_WTX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_WTX0_GLPE_WTX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_WTX0_GLPE_WTX_DTM_ECC_UNCOR_ERR 0x43010264
#define IG3_WTX0_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX0_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_WTX0_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_WTX0_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_WTX0_GLPE_WTX_DTM_GROUP_CFG 0x4301020C
#define IG3_WTX0_GLPE_WTX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_WTX0_GLPE_WTX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_WTX0_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_WTX0_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_WTX0_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_WTX0_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_WTX0_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_WTX0_GLPE_WTX_DTM_LOG_CFG 0x43010210
#define IG3_WTX0_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_WTX0_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_WTX0_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_WTX0_GLPE_WTX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_WTX0_GLPE_WTX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_DTM_LOG_CFG_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_DTM_LOG_CFG_MODE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_DTM_LOG_CFG_MODE_S)
#define IG3_WTX0_GLPE_WTX_DTM_LOG_MASK 0x43010218
#define IG3_WTX0_GLPE_WTX_DTM_LOG_MASK_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_DTM_LOG_MASK_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_LOG_PATTERN 0x43010214
#define IG3_WTX0_GLPE_WTX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG 0x43010204
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_STS 0x43010208
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_WTX0_GLPE_WTX_DTM_MAIN_STS_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX0_GLPE_WTX_DTM_MAIN_STS_RSVD2_S)
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_WTX0_GLPE_WTX_DTM_TIMESTAMP 0x43010230
#define IG3_WTX0_GLPE_WTX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_DTM_TIMESTAMP_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER 0x43010234
#define IG3_WTX0_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG 0x4301025C
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS 0x43010260
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG 0x4301021C
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_MODE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_WTX0_GLPE_WTX_DTM_TRIG_CFG_MODE_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_COUNT 0x43010228
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_MASK 0x43010224
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_DTM_TRIG_MASK_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_PATTERN 0x43010220
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_TIMESTAMP 0x4301022C
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_WTX0_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG 0x4301014C
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_S 29
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_S 13
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_S 0
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG 0x43010150
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_S 31
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_S 27
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_S 26
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX 0x43010154
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHHI 0x4301005C
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WTX0_GLPE_WTX_FWQPFLUSHHI_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHHI_QPID_S 6
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX0_GLPE_WTX_FWQPFLUSHHI_QPID_S)
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX0_GLPE_WTX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO 0x43010058
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_BUSY_S 31
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_BUSY_S)
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_HOSTID_S)
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_PMF_S 0
#define IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_FWQPFLUSHLO_PMF_S)
#define IG3_WTX0_GLPE_WTX_HOST_READ_CONFIG 0x43010038
#define IG3_WTX0_GLPE_WTX_HOST_READ_CONFIG_RSVD_S 8
#define IG3_WTX0_GLPE_WTX_HOST_READ_CONFIG_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX0_GLPE_WTX_HOST_READ_CONFIG_RSVD_S)
#define IG3_WTX0_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_S 0
#define IG3_WTX0_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0 0x4301010C
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_S 16
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_S 11
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1 0x43010110
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_S 0
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG2 0x43010114
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_S 6
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG3 0x43010118
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG4 0x4301011C
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_S 0
#define IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG 0x4301018C
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_S 31
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_S 27
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_S 26
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX 0x43010190
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG 0x43010194
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_S 31
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_S 27
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_S 26
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX 0x43010198
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG 0x43010184
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_S 31
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_S 27
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_S 26
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX 0x43010188
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0 0x43010090
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1 0x43010094
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG2 0x43010098
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG3 0x4301009C
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG4 0x430100A0
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0 0x43010060
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1 0x43010064
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG2 0x43010068
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG3 0x4301006C
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG4 0x43010070
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG5 0x43010074
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0 0x43010078
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1 0x4301007C
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG2 0x43010080
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG3 0x43010084
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG4 0x43010088
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG5 0x4301008C
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG 0x43010134
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_S 29
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_S 13
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_S 0
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG 0x43010138
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_S 31
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_S 27
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_S 26
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX 0x4301013C
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG 0x43010140
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_S 29
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_S 13
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_S 0
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG 0x43010144
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_S 31
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_S 27
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_S 26
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX 0x43010148
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG 0x43010164
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_S 29
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_S 13
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_S 0
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG 0x43010168
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_S 31
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_S 27
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_S 26
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX 0x4301016C
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG 0x43010158
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_S 29
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_S 13
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_S 0
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG 0x4301015C
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_S 31
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_S 27
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_S 26
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX 0x43010160
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0 0x430100E4
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_S 16
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_S 11
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1 0x430100E8
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_S 0
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG2 0x430100EC
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_S 6
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG3 0x430100F0
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG4 0x430100F4
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_S 0
#define IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0 0x430100D0
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_S 16
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_S 11
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1 0x430100D4
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_S 0
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG2 0x430100D8
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_S 6
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG3 0x430100DC
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG4 0x430100E0
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_S 0
#define IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_S)
#define IG3_WTX0_GLPE_WTX_SPADS_ASSIGNED(_i) 0x43010000 + ((_i) * 4) /* _i=0...2 */
#define IG3_WTX0_GLPE_WTX_SPADS_ASSIGNED_MAX_INDEX_I 2
#define IG3_WTX0_GLPE_WTX_SPADS_ASSIGNED_SPAD3_S 24
#define IG3_WTX0_GLPE_WTX_SPADS_ASSIGNED_SPAD3_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPADS_ASSIGNED_SPAD3_S)
#define IG3_WTX0_GLPE_WTX_SPADS_ASSIGNED_SPAD2_S 16
#define IG3_WTX0_GLPE_WTX_SPADS_ASSIGNED_SPAD2_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPADS_ASSIGNED_SPAD2_S)
#define IG3_WTX0_GLPE_WTX_SPADS_ASSIGNED_SPAD1_S 8
#define IG3_WTX0_GLPE_WTX_SPADS_ASSIGNED_SPAD1_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPADS_ASSIGNED_SPAD1_S)
#define IG3_WTX0_GLPE_WTX_SPADS_ASSIGNED_SPAD0_S 0
#define IG3_WTX0_GLPE_WTX_SPADS_ASSIGNED_SPAD0_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPADS_ASSIGNED_SPAD0_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0 0x430100A4
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_S 16
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_S 11
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1 0x430100A8
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG2 0x430100AC
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_S 6
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG3 0x430100B0
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG4 0x430100B4
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG5 0x430100B8
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX0_GLPE_WTX_SPAD_CONFIG0 0x43010024
#define IG3_WTX0_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_S 24
#define IG3_WTX0_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_S)
#define IG3_WTX0_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_S 16
#define IG3_WTX0_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_S)
#define IG3_WTX0_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_S 8
#define IG3_WTX0_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_S)
#define IG3_WTX0_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_S)
#define IG3_WTX0_GLPE_WTX_SPAD_CONFIG1 0x43010028
#define IG3_WTX0_GLPE_WTX_SPAD_CONFIG1_RSVD_S 8
#define IG3_WTX0_GLPE_WTX_SPAD_CONFIG1_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX0_GLPE_WTX_SPAD_CONFIG1_RSVD_S)
#define IG3_WTX0_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_S)
#define IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS0 0x4301002C
#define IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_S 24
#define IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_S)
#define IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_S 16
#define IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_S)
#define IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_S 8
#define IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_S)
#define IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_S)
#define IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS1 0x43010030
#define IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_S 8
#define IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_S)
#define IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0 0x430100BC
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_S 16
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_S 11
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1 0x430100C0
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG2 0x430100C4
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_S 6
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG3 0x430100C8
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG4 0x430100CC
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_S)
#define IG3_WTX0_GLPE_WTX_SPAD_QUEUE_PTR_CTL 0x43010034
#define IG3_WTX0_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_S 16
#define IG3_WTX0_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_WTX0_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_S)
#define IG3_WTX0_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_S 8
#define IG3_WTX0_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_S)
#define IG3_WTX0_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_S)
#define IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL 0x43010018
#define IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_RSVD1_S 20
#define IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_S 16
#define IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_M RDMA_MASK3(32, 0xF, IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_S)
#define IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_RSVD0_S 10
#define IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_S 8
#define IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_M RDMA_MASK3(32, 0x3, IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_S)
#define IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_M RDMA_MASK3(32, 0xFF, IG3_WTX0_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_S)
#define IG3_WTX0_GLPE_WTX_SPAD_STAT_DATA 0x4301001C
#define IG3_WTX0_GLPE_WTX_SPAD_STAT_DATA_DATA_S 0
#define IG3_WTX0_GLPE_WTX_SPAD_STAT_DATA_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX0_GLPE_WTX_SPAD_STAT_DATA_DATA_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG 0x43010170
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_S 29
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_S 13
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_S 0
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG 0x43010174
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_S 31
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_S 27
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_S 26
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX 0x43010178
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX0_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_PTX0_GLPE_ARPCONTROL 0x4301400C
#define IG3_PTX0_GLPE_ARPCONTROL_ARP_LOCK_ACK_S 31
#define IG3_PTX0_GLPE_ARPCONTROL_ARP_LOCK_ACK_M RDMA_BIT2(32, IG3_PTX0_GLPE_ARPCONTROL_ARP_LOCK_ACK_S)
#define IG3_PTX0_GLPE_ARPCONTROL_ARP_LOCK_REQ_S 30
#define IG3_PTX0_GLPE_ARPCONTROL_ARP_LOCK_REQ_M RDMA_BIT2(32, IG3_PTX0_GLPE_ARPCONTROL_ARP_LOCK_REQ_S)
#define IG3_PTX0_GLPE_ARPCONTROL_RSVD_S 16
#define IG3_PTX0_GLPE_ARPCONTROL_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_PTX0_GLPE_ARPCONTROL_RSVD_S)
#define IG3_PTX0_GLPE_ARPCONTROL_ARP_LOCK_INDEX_S 0
#define IG3_PTX0_GLPE_ARPCONTROL_ARP_LOCK_INDEX_M RDMA_MASK3(32, 0xFFFF, IG3_PTX0_GLPE_ARPCONTROL_ARP_LOCK_INDEX_S)
#define IG3_PTX0_GLPE_CRT_CONFIG0 0x43014010
#define IG3_PTX0_GLPE_CRT_CONFIG0_RSVD_S 25
#define IG3_PTX0_GLPE_CRT_CONFIG0_RSVD_M RDMA_MASK3(32, 0x7F, IG3_PTX0_GLPE_CRT_CONFIG0_RSVD_S)
#define IG3_PTX0_GLPE_CRT_CONFIG0_QP_FC_EN_S 24
#define IG3_PTX0_GLPE_CRT_CONFIG0_QP_FC_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_CRT_CONFIG0_QP_FC_EN_S)
#define IG3_PTX0_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_S 16
#define IG3_PTX0_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_S)
#define IG3_PTX0_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_S 8
#define IG3_PTX0_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_S)
#define IG3_PTX0_GLPE_CRT_CONFIG0_TX_BUF_SIZE_S 0
#define IG3_PTX0_GLPE_CRT_CONFIG0_TX_BUF_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_CRT_CONFIG0_TX_BUF_SIZE_S)
#define IG3_PTX0_GLPE_CRT_CONFIG1 0x43014014
#define IG3_PTX0_GLPE_CRT_CONFIG1_RSVD_S 19
#define IG3_PTX0_GLPE_CRT_CONFIG1_RSVD_M RDMA_MASK3(32, 0x1FFF, IG3_PTX0_GLPE_CRT_CONFIG1_RSVD_S)
#define IG3_PTX0_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_S 16
#define IG3_PTX0_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_M RDMA_MASK3(32, 0x7, IG3_PTX0_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_S)
#define IG3_PTX0_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_S 8
#define IG3_PTX0_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_S)
#define IG3_PTX0_GLPE_CRT_CONFIG1_RX_BUF_SIZE_S 0
#define IG3_PTX0_GLPE_CRT_CONFIG1_RX_BUF_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_CRT_CONFIG1_RX_BUF_SIZE_S)
#define IG3_PTX0_GLPE_MAX_INLINE_DATA 0x43014000
#define IG3_PTX0_GLPE_MAX_INLINE_DATA_RSVD_S 8
#define IG3_PTX0_GLPE_MAX_INLINE_DATA_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX0_GLPE_MAX_INLINE_DATA_RSVD_S)
#define IG3_PTX0_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_S 0
#define IG3_PTX0_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_S)
#define IG3_PTX0_GLPE_MAX_TCP_ACKS 0x43014004
#define IG3_PTX0_GLPE_MAX_TCP_ACKS_RSVD_S 8
#define IG3_PTX0_GLPE_MAX_TCP_ACKS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX0_GLPE_MAX_TCP_ACKS_RSVD_S)
#define IG3_PTX0_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_S 0
#define IG3_PTX0_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0 0x43014018
#define IG3_PTX0_GLPE_PTX_CONFIG0_RSVD_31_S 31
#define IG3_PTX0_GLPE_PTX_CONFIG0_RSVD_31_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_RSVD_31_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_S 30
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_S 29
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_S 28
#define IG3_PTX0_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_S 27
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_S 26
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_S 22
#define IG3_PTX0_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_M RDMA_MASK3(32, 0xF, IG3_PTX0_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_S 21
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_S 20
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_RSVD_19_S 19
#define IG3_PTX0_GLPE_PTX_CONFIG0_RSVD_19_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_RSVD_19_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_S 18
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_S 17
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_S 16
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_S 15
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_S 14
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_RSVD_13_7_S 7
#define IG3_PTX0_GLPE_PTX_CONFIG0_RSVD_13_7_M RDMA_MASK3(32, 0x7F, IG3_PTX0_GLPE_PTX_CONFIG0_RSVD_13_7_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_UDP_CS_EN_S 6
#define IG3_PTX0_GLPE_PTX_CONFIG0_UDP_CS_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_UDP_CS_EN_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_Q1_PACING_S 5
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_Q1_PACING_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_DIS_Q1_PACING_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_S 4
#define IG3_PTX0_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_S 3
#define IG3_PTX0_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_S 1
#define IG3_PTX0_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_S)
#define IG3_PTX0_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_S 0
#define IG3_PTX0_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_S)
#define IG3_PTX0_GLPE_PTX_CONFIG1 0x4301401C
#define IG3_PTX0_GLPE_PTX_CONFIG1_RSVD_S 24
#define IG3_PTX0_GLPE_PTX_CONFIG1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_CONFIG1_RSVD_S)
#define IG3_PTX0_GLPE_PTX_CONFIG1_ACKREQ_PACING_S 21
#define IG3_PTX0_GLPE_PTX_CONFIG1_ACKREQ_PACING_M RDMA_MASK3(32, 0x7, IG3_PTX0_GLPE_PTX_CONFIG1_ACKREQ_PACING_S)
#define IG3_PTX0_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_S 16
#define IG3_PTX0_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_M RDMA_MASK3(32, 0x1F, IG3_PTX0_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_S)
#define IG3_PTX0_GLPE_PTX_CONFIG1_Q1_PACING_MULT_S 0
#define IG3_PTX0_GLPE_PTX_CONFIG1_Q1_PACING_MULT_M RDMA_MASK3(32, 0xFFFF, IG3_PTX0_GLPE_PTX_CONFIG1_Q1_PACING_MULT_S)
#define IG3_PTX0_GLPE_PTX_CONFIG2 0x43014020
#define IG3_PTX0_GLPE_PTX_CONFIG2_SEND2CPU_S 0
#define IG3_PTX0_GLPE_PTX_CONFIG2_SEND2CPU_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_CONFIG2_SEND2CPU_S)
#define IG3_PTX0_GLPE_PTX_CRT_XMIT_PTR 0x4301402C
#define IG3_PTX0_GLPE_PTX_CRT_XMIT_PTR_RSVD_S 8
#define IG3_PTX0_GLPE_PTX_CRT_XMIT_PTR_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX0_GLPE_PTX_CRT_XMIT_PTR_RSVD_S)
#define IG3_PTX0_GLPE_PTX_CRT_XMIT_PTR_COUNT_S 0
#define IG3_PTX0_GLPE_PTX_CRT_XMIT_PTR_COUNT_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_CRT_XMIT_PTR_COUNT_S)
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_COUNT 0x43014138
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX0_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX0_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_CMD 0x4301414C
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_DATA_H 0x43014158
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_DATA_L 0x43014154
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_PTR 0x43014150
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX0_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_CMD 0x4301413C
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_DATA_H 0x43014148
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_DATA_L 0x43014144
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_PTR 0x43014140
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX0_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL 0x43014100
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_RSVD1_S 25
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PTX0_GLPE_PTX_DTM_CONTROL_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_RSVD2_S 17
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX0_GLPE_PTX_DTM_CONTROL_RSVD2_S)
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_RSVD3_S 9
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PTX0_GLPE_PTX_DTM_CONTROL_RSVD3_S)
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_BYPASS_S 8
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_CONTROL_BYPASS_S)
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_RSVD4_S 1
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PTX0_GLPE_PTX_DTM_CONTROL_RSVD4_S)
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PTX0_GLPE_PTX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PTX0_GLPE_PTX_DTM_ECC_COR_ERR 0x43014168
#define IG3_PTX0_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PTX0_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX0_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PTX0_GLPE_PTX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PTX0_GLPE_PTX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PTX0_GLPE_PTX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PTX0_GLPE_PTX_DTM_ECC_UNCOR_ERR 0x43014164
#define IG3_PTX0_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PTX0_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX0_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PTX0_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PTX0_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PTX0_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PTX0_GLPE_PTX_DTM_GROUP_CFG 0x4301410C
#define IG3_PTX0_GLPE_PTX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PTX0_GLPE_PTX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PTX0_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PTX0_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PTX0_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PTX0_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PTX0_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PTX0_GLPE_PTX_DTM_LOG_CFG 0x43014110
#define IG3_PTX0_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PTX0_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PTX0_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PTX0_GLPE_PTX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PTX0_GLPE_PTX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PTX0_GLPE_PTX_DTM_LOG_CFG_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_DTM_LOG_CFG_MODE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_DTM_LOG_CFG_MODE_S)
#define IG3_PTX0_GLPE_PTX_DTM_LOG_MASK 0x43014118
#define IG3_PTX0_GLPE_PTX_DTM_LOG_MASK_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_DTM_LOG_MASK_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_LOG_PATTERN 0x43014114
#define IG3_PTX0_GLPE_PTX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG 0x43014104
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_STS 0x43014108
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PTX0_GLPE_PTX_DTM_MAIN_STS_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX0_GLPE_PTX_DTM_MAIN_STS_RSVD2_S)
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PTX0_GLPE_PTX_DTM_TIMESTAMP 0x43014130
#define IG3_PTX0_GLPE_PTX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_DTM_TIMESTAMP_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER 0x43014134
#define IG3_PTX0_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG 0x4301415C
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS 0x43014160
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG 0x4301411C
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_MODE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PTX0_GLPE_PTX_DTM_TRIG_CFG_MODE_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_COUNT 0x43014128
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_MASK 0x43014124
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_DTM_TRIG_MASK_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_PATTERN 0x43014120
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_TIMESTAMP 0x4301412C
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PTX0_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHHI 0x43014028
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_PTX0_GLPE_PTX_FWQPFLUSHHI_RSVD0_S)
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHHI_QPID_S 6
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX0_GLPE_PTX_FWQPFLUSHHI_QPID_S)
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX0_GLPE_PTX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO 0x43014024
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_BUSY_S 31
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_BUSY_S)
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_RSVD0_S)
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_HOSTID_S)
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_PMF_S 0
#define IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX0_GLPE_PTX_FWQPFLUSHLO_PMF_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0 0x43014044
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_TAG_S 16
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_TAG_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_MODE_S 11
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_MODE_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1 0x43014048
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_PMF_S 0
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG1_PMF_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG2 0x4301404C
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG2_QPID_S 6
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG2_QPID_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG3 0x43014050
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG4 0x43014054
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG4_COUNT_S 0
#define IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_ST0_DTM_TRIG4_COUNT_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0 0x43014058
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_TAG_S 16
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_TAG_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_MODE_S 11
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_MODE_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1 0x4301405C
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_PMF_S 0
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG1_PMF_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG2 0x43014060
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG2_QPID_S 6
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG2_QPID_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG3 0x43014064
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG4 0x43014068
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG4_COUNT_S 0
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG4_COUNT_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT0 0x43014078
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_S 1
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_S 0
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT1 0x4301407C
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_S 0
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT2 0x43014080
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_S 0
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE0 0x4301406C
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_S 1
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_S 0
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE1 0x43014070
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_S 24
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_S 0
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE2 0x43014074
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_S 24
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_S)
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_S 0
#define IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX0_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0 0x43014030
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_S 16
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_S 11
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1 0x43014034
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_S 0
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG2 0x43014038
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_S 6
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG3 0x4301403C
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG4 0x43014040
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_S 0
#define IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX0_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_S)
#define IG3_PTX0_GLPE_TIMELY_STALL_THRESHOLD 0x43014008
#define IG3_PTX0_GLPE_TIMELY_STALL_THRESHOLD_RSVD_S 25
#define IG3_PTX0_GLPE_TIMELY_STALL_THRESHOLD_RSVD_M RDMA_MASK3(32, 0x7F, IG3_PTX0_GLPE_TIMELY_STALL_THRESHOLD_RSVD_S)
#define IG3_PTX0_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_S 24
#define IG3_PTX0_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_M RDMA_BIT2(32, IG3_PTX0_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_S)
#define IG3_PTX0_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_S 0
#define IG3_PTX0_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX0_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_COUNT 0x430144B8
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_CMD 0x430144CC
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_DATA_H 0x430144D8
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_DATA_L 0x430144D4
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_PTR 0x430144D0
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_CMD 0x430144BC
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_DATA_H 0x430144C8
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_DATA_L 0x430144C4
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_PTR 0x430144C0
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL 0x43014480
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_RSVD1_S 25
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_RSVD1_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_RSVD2_S 17
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_RSVD2_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_RSVD3_S 9
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_RSVD3_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_BYPASS_S 8
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_BYPASS_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_RSVD4_S 1
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_RSVD4_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_ECC_COR_ERR 0x430144E8
#define IG3_SFPTX0_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SFPTX0_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX0_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_ECC_UNCOR_ERR 0x430144E4
#define IG3_SFPTX0_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SFPTX0_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX0_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_GROUP_CFG 0x4301448C
#define IG3_SFPTX0_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SFPTX0_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPTX0_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SFPTX0_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX0_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SFPTX0_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX0_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX0_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_LOG_CFG 0x43014490
#define IG3_SFPTX0_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SFPTX0_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SFPTX0_GLPE_SFPT_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SFPTX0_GLPE_SFPT_DTM_LOG_CFG_RSVD1_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_LOG_CFG_MODE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SFPTX0_GLPE_SFPT_DTM_LOG_CFG_MODE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_LOG_MASK 0x43014498
#define IG3_SFPTX0_GLPE_SFPT_DTM_LOG_MASK_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_LOG_MASK_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_LOG_PATTERN 0x43014494
#define IG3_SFPTX0_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG 0x43014484
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_STS 0x43014488
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_STS_RSVD1_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_STS_RSVD2_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TIMESTAMP 0x430144B0
#define IG3_SFPTX0_GLPE_SFPT_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_TIMESTAMP_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER 0x430144B4
#define IG3_SFPTX0_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG 0x430144DC
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS 0x430144E0
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SFPTX0_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG 0x4301449C
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_MODE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_CFG_MODE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_COUNT 0x430144A8
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_MASK 0x430144A4
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_MASK_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_PATTERN 0x430144A0
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_TIMESTAMP 0x430144AC
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX0_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SFPTX0_GLPE_SFP_TX_DOMAIN_ID 0x43014400
#define IG3_SFPTX0_GLPE_SFP_TX_DOMAIN_ID_RSVD_S 3
#define IG3_SFPTX0_GLPE_SFP_TX_DOMAIN_ID_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPTX0_GLPE_SFP_TX_DOMAIN_ID_RSVD_S)
#define IG3_SFPTX0_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_S 0
#define IG3_SFPTX0_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_SFPTX0_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_S)
#define IG3_SFPTX0_GLPE_SFP_TX_PER_MEM 0x43014404
#define IG3_SFPTX0_GLPE_SFP_TX_PER_MEM_RSVD_S 3
#define IG3_SFPTX0_GLPE_SFP_TX_PER_MEM_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPTX0_GLPE_SFP_TX_PER_MEM_RSVD_S)
#define IG3_SFPTX0_GLPE_SFP_TX_PER_MEM_PER_TYPE_S 0
#define IG3_SFPTX0_GLPE_SFP_TX_PER_MEM_PER_TYPE_M RDMA_MASK3(32, 0x7, IG3_SFPTX0_GLPE_SFP_TX_PER_MEM_PER_TYPE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG 0x43014800
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS 0x43014804
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG 0x43014810
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS 0x43014814
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ECC_COR_ERR 0x43014834
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR 0x43014830
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG 0x43014818
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS 0x4301481C
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG 0x43014808
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS 0x4301480C
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG 0x43014828
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS 0x4301482C
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG 0x43014820
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS 0x43014824
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG 0x43014840
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS 0x43014844
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG 0x43014848
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS 0x4301484C
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG 0x43014850
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS 0x43014854
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG 0x43014858
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS 0x4301485C
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR 0x4301487C
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR 0x43014878
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG 0x43014860
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS 0x43014864
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG 0x43014868
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS 0x4301486C
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG 0x43014870
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS 0x43014874
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG 0x43014838
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS 0x4301483C
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL 0x430148C8
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_S 31
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_S 26
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_S 18
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_DATA 0x430148CC
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG 0x430148C0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS 0x430148C4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_ECC_COR_ERR 0x430148E4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR 0x430148E0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL 0x430148D8
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_S 31
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_S 26
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA 0x430148DC
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG 0x430148D0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS 0x430148D4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL 0x43014888
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_S 31
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_S 26
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_S 18
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA 0x4301488C
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG 0x43014880
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS 0x43014884
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL 0x43014898
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_S 31
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_S 26
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA 0x4301489C
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG 0x43014890
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS 0x43014894
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL 0x430148A8
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_S 31
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_S 26
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_S 18
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA 0x430148AC
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG 0x430148A0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS 0x430148A4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL 0x430148B8
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_S 31
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_S 26
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_S 18
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA 0x430148BC
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG 0x430148B0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_S 20
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_S 16
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_S 14
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_S 10
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_S 6
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_S 5
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS 0x430148B4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_S 30
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_S 4
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE0_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_S)
#define IG3_DRX0_GLPE_DRX_CONFIG 0x43020800
#define IG3_DRX0_GLPE_DRX_CONFIG_RSVD1_S 3
#define IG3_DRX0_GLPE_DRX_CONFIG_RSVD1_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_DRX0_GLPE_DRX_CONFIG_RSVD1_S)
#define IG3_DRX0_GLPE_DRX_CONFIG_CRC_MASK_S 0
#define IG3_DRX0_GLPE_DRX_CONFIG_CRC_MASK_M RDMA_MASK3(32, 0x7, IG3_DRX0_GLPE_DRX_CONFIG_CRC_MASK_S)
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_COUNT 0x430208B8
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX0_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX0_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_CMD 0x430208CC
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_DATA_H 0x430208D8
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_DATA_L 0x430208D4
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_PTR 0x430208D0
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX0_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_CMD 0x430208BC
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_DATA_H 0x430208C8
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_DATA_L 0x430208C4
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_PTR 0x430208C0
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX0_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL 0x43020880
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_RSVD1_S 25
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_DRX0_GLPE_DRX_DTM_CONTROL_RSVD1_S)
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_RSVD2_S 17
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX0_GLPE_DRX_DTM_CONTROL_RSVD2_S)
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_RSVD3_S 9
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_DRX0_GLPE_DRX_DTM_CONTROL_RSVD3_S)
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_BYPASS_S 8
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_CONTROL_BYPASS_S)
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_RSVD4_S 1
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_DRX0_GLPE_DRX_DTM_CONTROL_RSVD4_S)
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_DRX0_GLPE_DRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_DRX0_GLPE_DRX_DTM_ECC_COR_ERR 0x430208E8
#define IG3_DRX0_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_DRX0_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX0_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_DRX0_GLPE_DRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_DRX0_GLPE_DRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX0_GLPE_DRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_DRX0_GLPE_DRX_DTM_ECC_UNCOR_ERR 0x430208E4
#define IG3_DRX0_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_DRX0_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX0_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_DRX0_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_DRX0_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX0_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_DRX0_GLPE_DRX_DTM_GROUP_CFG 0x4302088C
#define IG3_DRX0_GLPE_DRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_DRX0_GLPE_DRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_DRX0_GLPE_DRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_DRX0_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_DRX0_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX0_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_DRX0_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_DRX0_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX0_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_DRX0_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_DRX0_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX0_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_DRX0_GLPE_DRX_DTM_LOG_CFG 0x43020890
#define IG3_DRX0_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_DRX0_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_DRX0_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_DRX0_GLPE_DRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_DRX0_GLPE_DRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_DRX0_GLPE_DRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_DRX0_GLPE_DRX_DTM_LOG_CFG_MODE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_DRX0_GLPE_DRX_DTM_LOG_CFG_MODE_S)
#define IG3_DRX0_GLPE_DRX_DTM_LOG_MASK 0x43020898
#define IG3_DRX0_GLPE_DRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX0_GLPE_DRX_DTM_LOG_MASK_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_LOG_PATTERN 0x43020894
#define IG3_DRX0_GLPE_DRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX0_GLPE_DRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG 0x43020884
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_STS 0x43020888
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_DRX0_GLPE_DRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX0_GLPE_DRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_DRX0_GLPE_DRX_DTM_TIMESTAMP 0x430208B0
#define IG3_DRX0_GLPE_DRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX0_GLPE_DRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER 0x430208B4
#define IG3_DRX0_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX0_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG 0x430208DC
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS 0x430208E0
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DRX0_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG 0x4302089C
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_DRX0_GLPE_DRX_DTM_TRIG_CFG_MODE_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_COUNT 0x430208A8
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX0_GLPE_DRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_MASK 0x430208A4
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX0_GLPE_DRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_PATTERN 0x430208A0
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX0_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_TIMESTAMP 0x430208AC
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_DRX0_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX0_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_DRX0_GLPE_DRX_ECC_COR_ERR 0x43020804
#define IG3_DRX0_GLPE_DRX_ECC_COR_ERR_RSVD_S 12
#define IG3_DRX0_GLPE_DRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX0_GLPE_DRX_ECC_COR_ERR_RSVD_S)
#define IG3_DRX0_GLPE_DRX_ECC_COR_ERR_CNT_S 0
#define IG3_DRX0_GLPE_DRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX0_GLPE_DRX_ECC_COR_ERR_CNT_S)
#define IG3_DRX0_GLPE_DRX_ECC_UNCOR_ERR 0x43020808
#define IG3_DRX0_GLPE_DRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_DRX0_GLPE_DRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX0_GLPE_DRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_DRX0_GLPE_DRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_DRX0_GLPE_DRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX0_GLPE_DRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_DRX0_GLPE_PBUF_CFG 0x4302080C
#define IG3_DRX0_GLPE_PBUF_CFG_ECC_INST_NUM_S 25
#define IG3_DRX0_GLPE_PBUF_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DRX0_GLPE_PBUF_CFG_ECC_INST_NUM_S)
#define IG3_DRX0_GLPE_PBUF_CFG_RSVD3_S 20
#define IG3_DRX0_GLPE_PBUF_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DRX0_GLPE_PBUF_CFG_RSVD3_S)
#define IG3_DRX0_GLPE_PBUF_CFG_RM_S 16
#define IG3_DRX0_GLPE_PBUF_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DRX0_GLPE_PBUF_CFG_RM_S)
#define IG3_DRX0_GLPE_PBUF_CFG_RSVD2_S 14
#define IG3_DRX0_GLPE_PBUF_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DRX0_GLPE_PBUF_CFG_RSVD2_S)
#define IG3_DRX0_GLPE_PBUF_CFG_POWER_GATE_EN_S 13
#define IG3_DRX0_GLPE_PBUF_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DRX0_GLPE_PBUF_CFG_POWER_GATE_EN_S)
#define IG3_DRX0_GLPE_PBUF_CFG_RME_S 12
#define IG3_DRX0_GLPE_PBUF_CFG_RME_M RDMA_BIT2(32, IG3_DRX0_GLPE_PBUF_CFG_RME_S)
#define IG3_DRX0_GLPE_PBUF_CFG_RSVD1_S 10
#define IG3_DRX0_GLPE_PBUF_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX0_GLPE_PBUF_CFG_RSVD1_S)
#define IG3_DRX0_GLPE_PBUF_CFG_ERR_CNT_S 9
#define IG3_DRX0_GLPE_PBUF_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DRX0_GLPE_PBUF_CFG_ERR_CNT_S)
#define IG3_DRX0_GLPE_PBUF_CFG_FIX_CNT_S 8
#define IG3_DRX0_GLPE_PBUF_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DRX0_GLPE_PBUF_CFG_FIX_CNT_S)
#define IG3_DRX0_GLPE_PBUF_CFG_RSVD0_S 6
#define IG3_DRX0_GLPE_PBUF_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DRX0_GLPE_PBUF_CFG_RSVD0_S)
#define IG3_DRX0_GLPE_PBUF_CFG_MASK_INT_S 5
#define IG3_DRX0_GLPE_PBUF_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DRX0_GLPE_PBUF_CFG_MASK_INT_S)
#define IG3_DRX0_GLPE_PBUF_CFG_LS_BYPASS_S 4
#define IG3_DRX0_GLPE_PBUF_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DRX0_GLPE_PBUF_CFG_LS_BYPASS_S)
#define IG3_DRX0_GLPE_PBUF_CFG_LS_FORCE_S 3
#define IG3_DRX0_GLPE_PBUF_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DRX0_GLPE_PBUF_CFG_LS_FORCE_S)
#define IG3_DRX0_GLPE_PBUF_CFG_ECC_INVERT_2_S 2
#define IG3_DRX0_GLPE_PBUF_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DRX0_GLPE_PBUF_CFG_ECC_INVERT_2_S)
#define IG3_DRX0_GLPE_PBUF_CFG_ECC_INVERT_1_S 1
#define IG3_DRX0_GLPE_PBUF_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DRX0_GLPE_PBUF_CFG_ECC_INVERT_1_S)
#define IG3_DRX0_GLPE_PBUF_CFG_ECC_EN_S 0
#define IG3_DRX0_GLPE_PBUF_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DRX0_GLPE_PBUF_CFG_ECC_EN_S)
#define IG3_DRX0_GLPE_PBUF_STATUS 0x43020810
#define IG3_DRX0_GLPE_PBUF_STATUS_RSVD1_S 30
#define IG3_DRX0_GLPE_PBUF_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX0_GLPE_PBUF_STATUS_RSVD1_S)
#define IG3_DRX0_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DRX0_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DRX0_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DRX0_GLPE_PBUF_STATUS_RSVD0_S 4
#define IG3_DRX0_GLPE_PBUF_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DRX0_GLPE_PBUF_STATUS_RSVD0_S)
#define IG3_DRX0_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DRX0_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DRX0_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DRX0_GLPE_PBUF_STATUS_INIT_DONE_S 2
#define IG3_DRX0_GLPE_PBUF_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DRX0_GLPE_PBUF_STATUS_INIT_DONE_S)
#define IG3_DRX0_GLPE_PBUF_STATUS_ECC_FIX_S 1
#define IG3_DRX0_GLPE_PBUF_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DRX0_GLPE_PBUF_STATUS_ECC_FIX_S)
#define IG3_DRX0_GLPE_PBUF_STATUS_ECC_ERR_S 0
#define IG3_DRX0_GLPE_PBUF_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DRX0_GLPE_PBUF_STATUS_ECC_ERR_S)
#define IG3_CMPE0_CMPE_ECC_COR_ERR 0x43020D3C
#define IG3_CMPE0_CMPE_ECC_COR_ERR_RSVD_S 12
#define IG3_CMPE0_CMPE_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE0_CMPE_ECC_COR_ERR_RSVD_S)
#define IG3_CMPE0_CMPE_ECC_COR_ERR_CNT_S 0
#define IG3_CMPE0_CMPE_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE0_CMPE_ECC_COR_ERR_CNT_S)
#define IG3_CMPE0_CMPE_ECC_UNCOR_ERR 0x43020D38
#define IG3_CMPE0_CMPE_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CMPE0_CMPE_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE0_CMPE_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CMPE0_CMPE_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CMPE0_CMPE_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE0_CMPE_ECC_UNCOR_ERR_CNT_S)
#define IG3_CMPE0_GLCM_PECLSADDR 0x43020C84
#define IG3_CMPE0_GLCM_PECLSADDR_RSVD_S 9
#define IG3_CMPE0_GLCM_PECLSADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE0_GLCM_PECLSADDR_RSVD_S)
#define IG3_CMPE0_GLCM_PECLSADDR_CLS_ADDR_S 0
#define IG3_CMPE0_GLCM_PECLSADDR_CLS_ADDR_M RDMA_MASK3(32, 0x1FF, IG3_CMPE0_GLCM_PECLSADDR_CLS_ADDR_S)
#define IG3_CMPE0_GLCM_PECLSDATA0 0x43020C88
#define IG3_CMPE0_GLCM_PECLSDATA0_CLS_DATA_S 0
#define IG3_CMPE0_GLCM_PECLSDATA0_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLCM_PECLSDATA0_CLS_DATA_S)
#define IG3_CMPE0_GLCM_PECLSDATA1 0x43020C8C
#define IG3_CMPE0_GLCM_PECLSDATA1_CLS_DATA_S 0
#define IG3_CMPE0_GLCM_PECLSDATA1_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLCM_PECLSDATA1_CLS_DATA_S)
#define IG3_CMPE0_GLCM_PECLSDATA2 0x43020C90
#define IG3_CMPE0_GLCM_PECLSDATA2_CLS_DATA_S 0
#define IG3_CMPE0_GLCM_PECLSDATA2_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLCM_PECLSDATA2_CLS_DATA_S)
#define IG3_CMPE0_GLCM_PECONFIG 0x43020C80
#define IG3_CMPE0_GLCM_PECONFIG_DBGMUX_EN_S 31
#define IG3_CMPE0_GLCM_PECONFIG_DBGMUX_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECONFIG_DBGMUX_EN_S)
#define IG3_CMPE0_GLCM_PECONFIG_RSVD13_S 30
#define IG3_CMPE0_GLCM_PECONFIG_RSVD13_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECONFIG_RSVD13_S)
#define IG3_CMPE0_GLCM_PECONFIG_DBGMUX_SEL_HI_S 25
#define IG3_CMPE0_GLCM_PECONFIG_DBGMUX_SEL_HI_M RDMA_MASK3(32, 0x1F, IG3_CMPE0_GLCM_PECONFIG_DBGMUX_SEL_HI_S)
#define IG3_CMPE0_GLCM_PECONFIG_DBGMUX_SEL_LO_S 20
#define IG3_CMPE0_GLCM_PECONFIG_DBGMUX_SEL_LO_M RDMA_MASK3(32, 0x1F, IG3_CMPE0_GLCM_PECONFIG_DBGMUX_SEL_LO_S)
#define IG3_CMPE0_GLCM_PECONFIG_RSVD10_S 17
#define IG3_CMPE0_GLCM_PECONFIG_RSVD10_M RDMA_MASK3(32, 0x7, IG3_CMPE0_GLCM_PECONFIG_RSVD10_S)
#define IG3_CMPE0_GLCM_PECONFIG_DBG_WRSEL_S 16
#define IG3_CMPE0_GLCM_PECONFIG_DBG_WRSEL_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECONFIG_DBG_WRSEL_S)
#define IG3_CMPE0_GLCM_PECONFIG_DBG_DWSEL_S 14
#define IG3_CMPE0_GLCM_PECONFIG_DBG_DWSEL_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PECONFIG_DBG_DWSEL_S)
#define IG3_CMPE0_GLCM_PECONFIG_DBG_DPSEL_S 12
#define IG3_CMPE0_GLCM_PECONFIG_DBG_DPSEL_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PECONFIG_DBG_DPSEL_S)
#define IG3_CMPE0_GLCM_PECONFIG_RSVD6_S 7
#define IG3_CMPE0_GLCM_PECONFIG_RSVD6_M RDMA_MASK3(32, 0x1F, IG3_CMPE0_GLCM_PECONFIG_RSVD6_S)
#define IG3_CMPE0_GLCM_PECONFIG_DISABLE_CTXT_PACKING_S 6
#define IG3_CMPE0_GLCM_PECONFIG_DISABLE_CTXT_PACKING_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECONFIG_DISABLE_CTXT_PACKING_S)
#define IG3_CMPE0_GLCM_PECONFIG_DISABLE_LSA_S 5
#define IG3_CMPE0_GLCM_PECONFIG_DISABLE_LSA_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECONFIG_DISABLE_LSA_S)
#define IG3_CMPE0_GLCM_PECONFIG_ENABLE_CRC_S 4
#define IG3_CMPE0_GLCM_PECONFIG_ENABLE_CRC_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECONFIG_ENABLE_CRC_S)
#define IG3_CMPE0_GLCM_PECONFIG_DISABLE_RESCHEDULE_S 3
#define IG3_CMPE0_GLCM_PECONFIG_DISABLE_RESCHEDULE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECONFIG_DISABLE_RESCHEDULE_S)
#define IG3_CMPE0_GLCM_PECONFIG_DISABLE_PACKET_COUNT_S 2
#define IG3_CMPE0_GLCM_PECONFIG_DISABLE_PACKET_COUNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECONFIG_DISABLE_PACKET_COUNT_S)
#define IG3_CMPE0_GLCM_PECONFIG_GLOBAL_LOCK_MODE_S 1
#define IG3_CMPE0_GLCM_PECONFIG_GLOBAL_LOCK_MODE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECONFIG_GLOBAL_LOCK_MODE_S)
#define IG3_CMPE0_GLCM_PECONFIG_RSVD1_S 0
#define IG3_CMPE0_GLCM_PECONFIG_RSVD1_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECONFIG_RSVD1_S)
#define IG3_CMPE0_GLCM_PECTXDGCTL 0x43020CC8
#define IG3_CMPE0_GLCM_PECTXDGCTL_RSVD_S 12
#define IG3_CMPE0_GLCM_PECTXDGCTL_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE0_GLCM_PECTXDGCTL_RSVD_S)
#define IG3_CMPE0_GLCM_PECTXDGCTL_PKTCNT_S 10
#define IG3_CMPE0_GLCM_PECTXDGCTL_PKTCNT_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PECTXDGCTL_PKTCNT_S)
#define IG3_CMPE0_GLCM_PECTXDGCTL_OP_CODE_S 8
#define IG3_CMPE0_GLCM_PECTXDGCTL_OP_CODE_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PECTXDGCTL_OP_CODE_S)
#define IG3_CMPE0_GLCM_PECTXDGCTL_ALLOCATE_S 7
#define IG3_CMPE0_GLCM_PECTXDGCTL_ALLOCATE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECTXDGCTL_ALLOCATE_S)
#define IG3_CMPE0_GLCM_PECTXDGCTL_WRITEBACK_S 6
#define IG3_CMPE0_GLCM_PECTXDGCTL_WRITEBACK_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECTXDGCTL_WRITEBACK_S)
#define IG3_CMPE0_GLCM_PECTXDGCTL_INVALIDATE_S 5
#define IG3_CMPE0_GLCM_PECTXDGCTL_INVALIDATE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECTXDGCTL_INVALIDATE_S)
#define IG3_CMPE0_GLCM_PECTXDGCTL_SUB_LINE_S 0
#define IG3_CMPE0_GLCM_PECTXDGCTL_SUB_LINE_M RDMA_MASK3(32, 0x1F, IG3_CMPE0_GLCM_PECTXDGCTL_SUB_LINE_S)
#define IG3_CMPE0_GLCM_PECTXDGDATA(_i) 0x43020CCC + ((_i) * 4) /* _i=0...3 */
#define IG3_CMPE0_GLCM_PECTXDGDATA_MAX_INDEX_I 3
#define IG3_CMPE0_GLCM_PECTXDGDATA_DATA_S 0
#define IG3_CMPE0_GLCM_PECTXDGDATA_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLCM_PECTXDGDATA_DATA_S)
#define IG3_CMPE0_GLCM_PECTXDGFN 0x43020CC0
#define IG3_CMPE0_GLCM_PECTXDGFN_RSVD_S 20
#define IG3_CMPE0_GLCM_PECTXDGFN_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE0_GLCM_PECTXDGFN_RSVD_S)
#define IG3_CMPE0_GLCM_PECTXDGFN_FUNC_TRIPLET_S 0
#define IG3_CMPE0_GLCM_PECTXDGFN_FUNC_TRIPLET_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE0_GLCM_PECTXDGFN_FUNC_TRIPLET_S)
#define IG3_CMPE0_GLCM_PECTXDGQP 0x43020CC4
#define IG3_CMPE0_GLCM_PECTXDGQP_RSVD_S 24
#define IG3_CMPE0_GLCM_PECTXDGQP_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLCM_PECTXDGQP_RSVD_S)
#define IG3_CMPE0_GLCM_PECTXDGQP_QUEUE_NUM_S 0
#define IG3_CMPE0_GLCM_PECTXDGQP_QUEUE_NUM_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE0_GLCM_PECTXDGQP_QUEUE_NUM_S)
#define IG3_CMPE0_GLCM_PECTXDGSTAT 0x43020CDC
#define IG3_CMPE0_GLCM_PECTXDGSTAT_RSVD_S 2
#define IG3_CMPE0_GLCM_PECTXDGSTAT_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_CMPE0_GLCM_PECTXDGSTAT_RSVD_S)
#define IG3_CMPE0_GLCM_PECTXDGSTAT_CTX_MISS_S 1
#define IG3_CMPE0_GLCM_PECTXDGSTAT_CTX_MISS_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECTXDGSTAT_CTX_MISS_S)
#define IG3_CMPE0_GLCM_PECTXDGSTAT_CTX_DONE_S 0
#define IG3_CMPE0_GLCM_PECTXDGSTAT_CTX_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PECTXDGSTAT_CTX_DONE_S)
#define IG3_CMPE0_GLCM_PEDATAREQHI 0x43020CB4
#define IG3_CMPE0_GLCM_PEDATAREQHI_RSVD_S 24
#define IG3_CMPE0_GLCM_PEDATAREQHI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLCM_PEDATAREQHI_RSVD_S)
#define IG3_CMPE0_GLCM_PEDATAREQHI_DATAREQHI_S 0
#define IG3_CMPE0_GLCM_PEDATAREQHI_DATAREQHI_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE0_GLCM_PEDATAREQHI_DATAREQHI_S)
#define IG3_CMPE0_GLCM_PEDATAREQLO 0x43020CB0
#define IG3_CMPE0_GLCM_PEDATAREQLO_DATAREQLOW_S 0
#define IG3_CMPE0_GLCM_PEDATAREQLO_DATAREQLOW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLCM_PEDATAREQLO_DATAREQLOW_S)
#define IG3_CMPE0_GLCM_PEDATASTALLHI 0x43020CBC
#define IG3_CMPE0_GLCM_PEDATASTALLHI_RSVD_S 24
#define IG3_CMPE0_GLCM_PEDATASTALLHI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLCM_PEDATASTALLHI_RSVD_S)
#define IG3_CMPE0_GLCM_PEDATASTALLHI_DATASTALLHI_S 0
#define IG3_CMPE0_GLCM_PEDATASTALLHI_DATASTALLHI_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE0_GLCM_PEDATASTALLHI_DATASTALLHI_S)
#define IG3_CMPE0_GLCM_PEDATASTALLLO 0x43020CB8
#define IG3_CMPE0_GLCM_PEDATASTALLLO_DATASTALLLOW_S 0
#define IG3_CMPE0_GLCM_PEDATASTALLLO_DATASTALLLOW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLCM_PEDATASTALLLO_DATASTALLLOW_S)
#define IG3_CMPE0_GLCM_PELOCKTBLADDR 0x43020C9C
#define IG3_CMPE0_GLCM_PELOCKTBLADDR_RSVD_S 5
#define IG3_CMPE0_GLCM_PELOCKTBLADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_CMPE0_GLCM_PELOCKTBLADDR_RSVD_S)
#define IG3_CMPE0_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_S 0
#define IG3_CMPE0_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_M RDMA_MASK3(32, 0x1F, IG3_CMPE0_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_S)
#define IG3_CMPE0_GLCM_PELOCKTBLDATA0 0x43020CA0
#define IG3_CMPE0_GLCM_PELOCKTBLDATA0_GPLOCKSEL_S 31
#define IG3_CMPE0_GLCM_PELOCKTBLDATA0_GPLOCKSEL_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PELOCKTBLDATA0_GPLOCKSEL_S)
#define IG3_CMPE0_GLCM_PELOCKTBLDATA0_RSVD_S 24
#define IG3_CMPE0_GLCM_PELOCKTBLDATA0_RSVD_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLCM_PELOCKTBLDATA0_RSVD_S)
#define IG3_CMPE0_GLCM_PELOCKTBLDATA0_QPID_S 0
#define IG3_CMPE0_GLCM_PELOCKTBLDATA0_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE0_GLCM_PELOCKTBLDATA0_QPID_S)
#define IG3_CMPE0_GLCM_PELOCKTBLDATA1 0x43020CA4
#define IG3_CMPE0_GLCM_PELOCKTBLDATA1_RSVD_S 20
#define IG3_CMPE0_GLCM_PELOCKTBLDATA1_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE0_GLCM_PELOCKTBLDATA1_RSVD_S)
#define IG3_CMPE0_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_S 0
#define IG3_CMPE0_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE0_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_S)
#define IG3_CMPE0_GLCM_PELOCKTBLDATA2 0x43020CA8
#define IG3_CMPE0_GLCM_PELOCKTBLDATA2_LOCKSEL_S 0
#define IG3_CMPE0_GLCM_PELOCKTBLDATA2_LOCKSEL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLCM_PELOCKTBLDATA2_LOCKSEL_S)
#define IG3_CMPE0_GLCM_PEPKTCNTADDR 0x43020C94
#define IG3_CMPE0_GLCM_PEPKTCNTADDR_RSVD_S 9
#define IG3_CMPE0_GLCM_PEPKTCNTADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE0_GLCM_PEPKTCNTADDR_RSVD_S)
#define IG3_CMPE0_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_S 0
#define IG3_CMPE0_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_M RDMA_MASK3(32, 0x1FF, IG3_CMPE0_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_S)
#define IG3_CMPE0_GLCM_PEPKTCNTDATA 0x43020C98
#define IG3_CMPE0_GLCM_PEPKTCNTDATA_RSVD1_S 18
#define IG3_CMPE0_GLCM_PEPKTCNTDATA_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE0_GLCM_PEPKTCNTDATA_RSVD1_S)
#define IG3_CMPE0_GLCM_PEPKTCNTDATA_RLRSP_STATE_S 16
#define IG3_CMPE0_GLCM_PEPKTCNTDATA_RLRSP_STATE_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PEPKTCNTDATA_RLRSP_STATE_S)
#define IG3_CMPE0_GLCM_PEPKTCNTDATA_RSVD0_S 14
#define IG3_CMPE0_GLCM_PEPKTCNTDATA_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PEPKTCNTDATA_RSVD0_S)
#define IG3_CMPE0_GLCM_PEPKTCNTDATA_RLREQ_STATE_S 12
#define IG3_CMPE0_GLCM_PEPKTCNTDATA_RLREQ_STATE_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PEPKTCNTDATA_RLREQ_STATE_S)
#define IG3_CMPE0_GLCM_PEPKTCNTDATA_PKTCNT_S 1
#define IG3_CMPE0_GLCM_PEPKTCNTDATA_PKTCNT_M RDMA_MASK3(32, 0x7FF, IG3_CMPE0_GLCM_PEPKTCNTDATA_PKTCNT_S)
#define IG3_CMPE0_GLCM_PEPKTCNTDATA_DONE_S 0
#define IG3_CMPE0_GLCM_PEPKTCNTDATA_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PEPKTCNTDATA_DONE_S)
#define IG3_CMPE0_GLCM_PESTATSCTL 0x43020CAC
#define IG3_CMPE0_GLCM_PESTATSCTL_RSVD_S 2
#define IG3_CMPE0_GLCM_PESTATSCTL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_CMPE0_GLCM_PESTATSCTL_RSVD_S)
#define IG3_CMPE0_GLCM_PESTATSCTL_ENABLE_S 1
#define IG3_CMPE0_GLCM_PESTATSCTL_ENABLE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PESTATSCTL_ENABLE_S)
#define IG3_CMPE0_GLCM_PESTATSCTL_CLEAR_S 0
#define IG3_CMPE0_GLCM_PESTATSCTL_CLEAR_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PESTATSCTL_CLEAR_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG 0x43020D00
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_S 20
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RM_S 16
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RM_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_S 14
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RME_S 12
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RME_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_S 10
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_S 6
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS 0x43020D04
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG 0x43020D08
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_S 20
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RM_S 16
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RM_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_S 14
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RME_S 12
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RME_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_S 10
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_S 6
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS 0x43020D0C
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG 0x43020D10
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_S 20
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RM_S 16
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RM_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_S 14
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RME_S 12
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RME_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_S 10
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_S 6
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS 0x43020D14
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG 0x43020D18
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_S 20
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RM_S 16
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RM_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_S 14
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RME_S 12
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RME_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_S 10
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_S 6
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS 0x43020D1C
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG 0x43020D20
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RSVD3_S 20
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RSVD3_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RM_S 16
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RM_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RSVD2_S 14
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RSVD2_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RME_S 12
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RME_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RSVD1_S 10
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RSVD0_S 6
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS 0x43020D24
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE0_GLCM_PE_CACHESIZE 0x43020CE4
#define IG3_CMPE0_GLCM_PE_CACHESIZE_RSVD_S 26
#define IG3_CMPE0_GLCM_PE_CACHESIZE_RSVD_M RDMA_MASK3(32, 0x3F, IG3_CMPE0_GLCM_PE_CACHESIZE_RSVD_S)
#define IG3_CMPE0_GLCM_PE_CACHESIZE_WAYS_S 16
#define IG3_CMPE0_GLCM_PE_CACHESIZE_WAYS_M RDMA_MASK3(32, 0x3FF, IG3_CMPE0_GLCM_PE_CACHESIZE_WAYS_S)
#define IG3_CMPE0_GLCM_PE_CACHESIZE_SETS_S 12
#define IG3_CMPE0_GLCM_PE_CACHESIZE_SETS_M RDMA_MASK3(32, 0xF, IG3_CMPE0_GLCM_PE_CACHESIZE_SETS_S)
#define IG3_CMPE0_GLCM_PE_CACHESIZE_WORD_SIZE_S 0
#define IG3_CMPE0_GLCM_PE_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFFF, IG3_CMPE0_GLCM_PE_CACHESIZE_WORD_SIZE_S)
#define IG3_CMPE0_GLCM_PE_DPC_COMP 0x43020CF4
#define IG3_CMPE0_GLCM_PE_DPC_COMP_RSVD_S 13
#define IG3_CMPE0_GLCM_PE_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_CMPE0_GLCM_PE_DPC_COMP_RSVD_S)
#define IG3_CMPE0_GLCM_PE_DPC_COMP_COMP_FTYPE_S 11
#define IG3_CMPE0_GLCM_PE_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_DPC_COMP_COMP_FTYPE_S)
#define IG3_CMPE0_GLCM_PE_DPC_COMP_COMP_FNUM_S 1
#define IG3_CMPE0_GLCM_PE_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_CMPE0_GLCM_PE_DPC_COMP_COMP_FNUM_S)
#define IG3_CMPE0_GLCM_PE_DPC_COMP_COMP_VALID_S 0
#define IG3_CMPE0_GLCM_PE_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_DPC_COMP_COMP_VALID_S)
#define IG3_CMPE0_GLCM_PE_DPC_REQ 0x43020CF0
#define IG3_CMPE0_GLCM_PE_DPC_REQ_RSVD_S 12
#define IG3_CMPE0_GLCM_PE_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE0_GLCM_PE_DPC_REQ_RSVD_S)
#define IG3_CMPE0_GLCM_PE_DPC_REQ_REQ_FTYPE_S 10
#define IG3_CMPE0_GLCM_PE_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_DPC_REQ_REQ_FTYPE_S)
#define IG3_CMPE0_GLCM_PE_DPC_REQ_REQ_FNUM_S 0
#define IG3_CMPE0_GLCM_PE_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_CMPE0_GLCM_PE_DPC_REQ_REQ_FNUM_S)
#define IG3_CMPE0_GLCM_PE_E2E_FC 0x43020CF8
#define IG3_CMPE0_GLCM_PE_E2E_FC_RSVD1_S 22
#define IG3_CMPE0_GLCM_PE_E2E_FC_RSVD1_M RDMA_MASK3(32, 0x3FF, IG3_CMPE0_GLCM_PE_E2E_FC_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_S 16
#define IG3_CMPE0_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_M RDMA_MASK3(32, 0x3F, IG3_CMPE0_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_S)
#define IG3_CMPE0_GLCM_PE_E2E_FC_RSVD0_S 9
#define IG3_CMPE0_GLCM_PE_E2E_FC_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLCM_PE_E2E_FC_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_S 0
#define IG3_CMPE0_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_M RDMA_MASK3(32, 0x1FF, IG3_CMPE0_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG 0x43020D28
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_S 20
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RM_S 16
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RM_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_S 14
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RME_S 12
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RME_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_S 10
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_S 6
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS 0x43020D2C
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG 0x43020D30
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_S 20
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RM_S 16
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RM_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_S 14
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RME_S 12
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RME_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_S 10
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_S 6
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS 0x43020D34
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE0_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE0_GLCM_PE_IF_FC 0x43020CFC
#define IG3_CMPE0_GLCM_PE_IF_FC_RSVD1_S 22
#define IG3_CMPE0_GLCM_PE_IF_FC_RSVD1_M RDMA_MASK3(32, 0x3FF, IG3_CMPE0_GLCM_PE_IF_FC_RSVD1_S)
#define IG3_CMPE0_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_S 16
#define IG3_CMPE0_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_M RDMA_MASK3(32, 0x3F, IG3_CMPE0_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_S)
#define IG3_CMPE0_GLCM_PE_IF_FC_RSVD0_S 9
#define IG3_CMPE0_GLCM_PE_IF_FC_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLCM_PE_IF_FC_RSVD0_S)
#define IG3_CMPE0_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_S 0
#define IG3_CMPE0_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_M RDMA_MASK3(32, 0x1FF, IG3_CMPE0_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_S)
#define IG3_CMPE0_GLCM_PE_MAXOSR 0x43020CE0
#define IG3_CMPE0_GLCM_PE_MAXOSR_RSVD_S 6
#define IG3_CMPE0_GLCM_PE_MAXOSR_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_CMPE0_GLCM_PE_MAXOSR_RSVD_S)
#define IG3_CMPE0_GLCM_PE_MAXOSR_MAXOSR_S 0
#define IG3_CMPE0_GLCM_PE_MAXOSR_MAXOSR_M RDMA_MASK3(32, 0x3F, IG3_CMPE0_GLCM_PE_MAXOSR_MAXOSR_S)
#define IG3_CMPE0_GLCM_PE_RLDDBGCTL0 0x43020CE8
#define IG3_CMPE0_GLCM_PE_RLDDBGCTL0_RSVD_S 24
#define IG3_CMPE0_GLCM_PE_RLDDBGCTL0_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLCM_PE_RLDDBGCTL0_RSVD_S)
#define IG3_CMPE0_GLCM_PE_RLDDBGCTL0_QPID_S 0
#define IG3_CMPE0_GLCM_PE_RLDDBGCTL0_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE0_GLCM_PE_RLDDBGCTL0_QPID_S)
#define IG3_CMPE0_GLCM_PE_RLDDBGCTL1 0x43020CEC
#define IG3_CMPE0_GLCM_PE_RLDDBGCTL1_RSVD_S 20
#define IG3_CMPE0_GLCM_PE_RLDDBGCTL1_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE0_GLCM_PE_RLDDBGCTL1_RSVD_S)
#define IG3_CMPE0_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_S 18
#define IG3_CMPE0_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_S)
#define IG3_CMPE0_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_S 6
#define IG3_CMPE0_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CMPE0_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_S)
#define IG3_CMPE0_GLCM_PE_RLDDBGCTL1_PF_NUM_S 0
#define IG3_CMPE0_GLCM_PE_RLDDBGCTL1_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_CMPE0_GLCM_PE_RLDDBGCTL1_PF_NUM_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_COUNT 0x43020DB8
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_CMD 0x43020DCC
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_DATA_H 0x43020DD8
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_DATA_L 0x43020DD4
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_PTR 0x43020DD0
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_CMD 0x43020DBC
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_DATA_H 0x43020DC8
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_DATA_L 0x43020DC4
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_PTR 0x43020DC0
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL 0x43020D80
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_RSVD1_S 25
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_RSVD1_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_RSVD2_S 17
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_RSVD2_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_RSVD3_S 9
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_RSVD3_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_BYPASS_S 8
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_BYPASS_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_RSVD4_S 1
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_RSVD4_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_ECC_COR_ERR 0x43020DE8
#define IG3_CMPE0_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_CMPE0_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE0_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_ECC_UNCOR_ERR 0x43020DE4
#define IG3_CMPE0_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CMPE0_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE0_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_GROUP_CFG 0x43020D8C
#define IG3_CMPE0_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_CMPE0_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_CMPE0_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_CMPE0_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_LOG_CFG 0x43020D90
#define IG3_CMPE0_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_CMPE0_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_CMPE0_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_LOG_CFG_RSVD1_S 2
#define IG3_CMPE0_GLPE_CMPE_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE0_GLPE_CMPE_DTM_LOG_CFG_RSVD1_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_LOG_CFG_MODE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLPE_CMPE_DTM_LOG_CFG_MODE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_LOG_MASK 0x43020D98
#define IG3_CMPE0_GLPE_CMPE_DTM_LOG_MASK_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_LOG_MASK_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_LOG_PATTERN 0x43020D94
#define IG3_CMPE0_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG 0x43020D84
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_STS 0x43020D88
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_STS_RSVD1_S 9
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE0_GLPE_CMPE_DTM_MAIN_STS_RSVD1_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_STS_RSVD2_S 1
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLPE_CMPE_DTM_MAIN_STS_RSVD2_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TIMESTAMP 0x43020DB0
#define IG3_CMPE0_GLPE_CMPE_DTM_TIMESTAMP_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_TIMESTAMP_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER 0x43020DB4
#define IG3_CMPE0_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG 0x43020DDC
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS 0x43020DE0
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE0_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG 0x43020D9C
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_MODE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_CMPE0_GLPE_CMPE_DTM_TRIG_CFG_MODE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_COUNT 0x43020DA8
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_MASK 0x43020DA4
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_MASK_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_TRIG_MASK_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_PATTERN 0x43020DA0
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_TIMESTAMP 0x43020DAC
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_CMPE0_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE0_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_CMPE0_PFCM_PE_CRCERRINFO0(_i) 0x43020C00 + ((_i) * 4) /* _i=0...15 */
#define IG3_CMPE0_PFCM_PE_CRCERRINFO0_MAX_INDEX_I 15
#define IG3_CMPE0_PFCM_PE_CRCERRINFO0_RSVD1_S 18
#define IG3_CMPE0_PFCM_PE_CRCERRINFO0_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE0_PFCM_PE_CRCERRINFO0_RSVD1_S)
#define IG3_CMPE0_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_S 16
#define IG3_CMPE0_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE0_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_S)
#define IG3_CMPE0_PFCM_PE_CRCERRINFO0_VM_VF_NUM_S 4
#define IG3_CMPE0_PFCM_PE_CRCERRINFO0_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CMPE0_PFCM_PE_CRCERRINFO0_VM_VF_NUM_S)
#define IG3_CMPE0_PFCM_PE_CRCERRINFO0_RSVD0_S 1
#define IG3_CMPE0_PFCM_PE_CRCERRINFO0_RSVD0_M RDMA_MASK3(32, 0x7, IG3_CMPE0_PFCM_PE_CRCERRINFO0_RSVD0_S)
#define IG3_CMPE0_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_S 0
#define IG3_CMPE0_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_M RDMA_BIT2(32, IG3_CMPE0_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_S)
#define IG3_CMPE0_PFCM_PE_CRCERRINFO1(_i) 0x43020C40 + ((_i) * 4) /* _i=0...15 */
#define IG3_CMPE0_PFCM_PE_CRCERRINFO1_MAX_INDEX_I 15
#define IG3_CMPE0_PFCM_PE_CRCERRINFO1_RSVD_S 24
#define IG3_CMPE0_PFCM_PE_CRCERRINFO1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE0_PFCM_PE_CRCERRINFO1_RSVD_S)
#define IG3_CMPE0_PFCM_PE_CRCERRINFO1_Q_NUM_S 0
#define IG3_CMPE0_PFCM_PE_CRCERRINFO1_Q_NUM_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE0_PFCM_PE_CRCERRINFO1_Q_NUM_S)
#define IG3_PRX1_GLPE_CC_DCQCN1_CFG(_i) 0x43402000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX1_GLPE_CC_DCQCN1_CFG_MAX_INDEX_I 1031
#define IG3_PRX1_GLPE_CC_DCQCN1_CFG_RSVD2_S 31
#define IG3_PRX1_GLPE_CC_DCQCN1_CFG_RSVD2_M RDMA_BIT2(32, IG3_PRX1_GLPE_CC_DCQCN1_CFG_RSVD2_S)
#define IG3_PRX1_GLPE_CC_DCQCN1_CFG_DCQCN_F_S 28
#define IG3_PRX1_GLPE_CC_DCQCN1_CFG_DCQCN_F_M RDMA_MASK3(32, 0x7, IG3_PRX1_GLPE_CC_DCQCN1_CFG_DCQCN_F_S)
#define IG3_PRX1_GLPE_CC_DCQCN1_CFG_RSVD1_S 25
#define IG3_PRX1_GLPE_CC_DCQCN1_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_PRX1_GLPE_CC_DCQCN1_CFG_RSVD1_S)
#define IG3_PRX1_GLPE_CC_DCQCN1_CFG_DCQCN_B_S 0
#define IG3_PRX1_GLPE_CC_DCQCN1_CFG_DCQCN_B_M RDMA_MASK3(32, 0x1FFFFFF, IG3_PRX1_GLPE_CC_DCQCN1_CFG_DCQCN_B_S)
#define IG3_PRX1_GLPE_CC_DCQCN2_CFG(_i) 0x43404000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX1_GLPE_CC_DCQCN2_CFG_MAX_INDEX_I 1031
#define IG3_PRX1_GLPE_CC_DCQCN2_CFG_RSVD_S 16
#define IG3_PRX1_GLPE_CC_DCQCN2_CFG_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PRX1_GLPE_CC_DCQCN2_CFG_RSVD_S)
#define IG3_PRX1_GLPE_CC_DCQCN2_CFG_DCQCN_T_S 0
#define IG3_PRX1_GLPE_CC_DCQCN2_CFG_DCQCN_T_M RDMA_MASK3(32, 0xFFFF, IG3_PRX1_GLPE_CC_DCQCN2_CFG_DCQCN_T_S)
#define IG3_PRX1_GLPE_CC_TIMELY_CFG(_i) 0x43400000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX1_GLPE_CC_TIMELY_CFG_MAX_INDEX_I 1031
#define IG3_PRX1_GLPE_CC_TIMELY_CFG_RAI_FACTOR_S 16
#define IG3_PRX1_GLPE_CC_TIMELY_CFG_RAI_FACTOR_M RDMA_MASK3(32, 0xFFFF, IG3_PRX1_GLPE_CC_TIMELY_CFG_RAI_FACTOR_S)
#define IG3_PRX1_GLPE_CC_TIMELY_CFG_HAI_FACTOR_S 0
#define IG3_PRX1_GLPE_CC_TIMELY_CFG_HAI_FACTOR_M RDMA_MASK3(32, 0xFFFF, IG3_PRX1_GLPE_CC_TIMELY_CFG_HAI_FACTOR_S)
#define IG3_PRX1_GLPE_PRX_CONFIG 0x43405020
#define IG3_PRX1_GLPE_PRX_CONFIG_REORDER_CNT_MAX_S 24
#define IG3_PRX1_GLPE_PRX_CONFIG_REORDER_CNT_MAX_M RDMA_MASK3(32, 0xFF, IG3_PRX1_GLPE_PRX_CONFIG_REORDER_CNT_MAX_S)
#define IG3_PRX1_GLPE_PRX_CONFIG_REORDER_CNT_MIN_S 16
#define IG3_PRX1_GLPE_PRX_CONFIG_REORDER_CNT_MIN_M RDMA_MASK3(32, 0xFF, IG3_PRX1_GLPE_PRX_CONFIG_REORDER_CNT_MIN_S)
#define IG3_PRX1_GLPE_PRX_CONFIG_RSVD1_S 12
#define IG3_PRX1_GLPE_PRX_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PRX1_GLPE_PRX_CONFIG_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_S 8
#define IG3_PRX1_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_M RDMA_MASK3(32, 0xF, IG3_PRX1_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_S)
#define IG3_PRX1_GLPE_PRX_CONFIG_RSVD0_S 5
#define IG3_PRX1_GLPE_PRX_CONFIG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PRX1_GLPE_PRX_CONFIG_RSVD0_S)
#define IG3_PRX1_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_S 4
#define IG3_PRX1_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_S)
#define IG3_PRX1_GLPE_PRX_CONFIG_ONE_HP_TILE_S 3
#define IG3_PRX1_GLPE_PRX_CONFIG_ONE_HP_TILE_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_CONFIG_ONE_HP_TILE_S)
#define IG3_PRX1_GLPE_PRX_CONFIG_DIS_RREC_S 2
#define IG3_PRX1_GLPE_PRX_CONFIG_DIS_RREC_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_CONFIG_DIS_RREC_S)
#define IG3_PRX1_GLPE_PRX_CONFIG_DIS_QR_STALL_S 1
#define IG3_PRX1_GLPE_PRX_CONFIG_DIS_QR_STALL_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_CONFIG_DIS_QR_STALL_S)
#define IG3_PRX1_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_S 0
#define IG3_PRX1_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_S)
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_COUNT 0x434050B8
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX1_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX1_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_CMD 0x434050CC
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_DATA_H 0x434050D8
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_DATA_L 0x434050D4
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_PTR 0x434050D0
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX1_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_CMD 0x434050BC
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_DATA_H 0x434050C8
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_DATA_L 0x434050C4
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_PTR 0x434050C0
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX1_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL 0x43405080
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_RSVD1_S 25
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PRX1_GLPE_PRX_DTM_CONTROL_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_RSVD2_S 17
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX1_GLPE_PRX_DTM_CONTROL_RSVD2_S)
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_RSVD3_S 9
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PRX1_GLPE_PRX_DTM_CONTROL_RSVD3_S)
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_BYPASS_S 8
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_CONTROL_BYPASS_S)
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_RSVD4_S 1
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PRX1_GLPE_PRX_DTM_CONTROL_RSVD4_S)
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PRX1_GLPE_PRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PRX1_GLPE_PRX_DTM_ECC_COR_ERR 0x434050E8
#define IG3_PRX1_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PRX1_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX1_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PRX1_GLPE_PRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PRX1_GLPE_PRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PRX1_GLPE_PRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PRX1_GLPE_PRX_DTM_ECC_UNCOR_ERR 0x434050E4
#define IG3_PRX1_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PRX1_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX1_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PRX1_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PRX1_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PRX1_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PRX1_GLPE_PRX_DTM_GROUP_CFG 0x4340508C
#define IG3_PRX1_GLPE_PRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PRX1_GLPE_PRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PRX1_GLPE_PRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PRX1_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX1_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PRX1_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PRX1_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX1_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PRX1_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PRX1_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX1_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PRX1_GLPE_PRX_DTM_LOG_CFG 0x43405090
#define IG3_PRX1_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PRX1_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PRX1_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PRX1_GLPE_PRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PRX1_GLPE_PRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PRX1_GLPE_PRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_DTM_LOG_CFG_MODE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PRX1_GLPE_PRX_DTM_LOG_CFG_MODE_S)
#define IG3_PRX1_GLPE_PRX_DTM_LOG_MASK 0x43405098
#define IG3_PRX1_GLPE_PRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX1_GLPE_PRX_DTM_LOG_MASK_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_LOG_PATTERN 0x43405094
#define IG3_PRX1_GLPE_PRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX1_GLPE_PRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG 0x43405084
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_STS 0x43405088
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PRX1_GLPE_PRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX1_GLPE_PRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PRX1_GLPE_PRX_DTM_TIMESTAMP 0x434050B0
#define IG3_PRX1_GLPE_PRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX1_GLPE_PRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER 0x434050B4
#define IG3_PRX1_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX1_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG 0x434050DC
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS 0x434050E0
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG 0x4340509C
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PRX1_GLPE_PRX_DTM_TRIG_CFG_MODE_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_COUNT 0x434050A8
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX1_GLPE_PRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_MASK 0x434050A4
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX1_GLPE_PRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_PATTERN 0x434050A0
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX1_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_TIMESTAMP 0x434050AC
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PRX1_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX1_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_CTL 0x43405024
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_S 12
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_S)
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_S 0
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_S)
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA 0x43405028
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_S 31
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_S)
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_S 30
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_M RDMA_BIT2(32, IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_S)
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_S 24
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_S)
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_S 20
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_S)
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_S 0
#define IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX1_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_S)
#define IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL 0x43408018
#define IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_S 21
#define IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_M RDMA_MASK3(32, 0x7FF, IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_S)
#define IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_S 16
#define IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_S)
#define IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_S 13
#define IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_S 8
#define IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_S)
#define IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_S 5
#define IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_S)
#define IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_S 0
#define IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX1_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_S)
#define IG3_WRX1_GLPE_WRX_CONFIG 0x43408000
#define IG3_WRX1_GLPE_WRX_CONFIG_RSVD_S 8
#define IG3_WRX1_GLPE_WRX_CONFIG_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WRX1_GLPE_WRX_CONFIG_RSVD_S)
#define IG3_WRX1_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_S 5
#define IG3_WRX1_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_M RDMA_MASK3(32, 0x7, IG3_WRX1_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_S)
#define IG3_WRX1_GLPE_WRX_CONFIG_DIS_WQE_CACHE_S 4
#define IG3_WRX1_GLPE_WRX_CONFIG_DIS_WQE_CACHE_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_CONFIG_DIS_WQE_CACHE_S)
#define IG3_WRX1_GLPE_WRX_CONFIG_DROP_OOO_IMMED_S 3
#define IG3_WRX1_GLPE_WRX_CONFIG_DROP_OOO_IMMED_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_CONFIG_DROP_OOO_IMMED_S)
#define IG3_WRX1_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_S 2
#define IG3_WRX1_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_S)
#define IG3_WRX1_GLPE_WRX_CONFIG_DIS_Q1_AE_S 1
#define IG3_WRX1_GLPE_WRX_CONFIG_DIS_Q1_AE_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_CONFIG_DIS_Q1_AE_S)
#define IG3_WRX1_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_S 0
#define IG3_WRX1_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_S)
#define IG3_WRX1_GLPE_WRX_DOMAIN_IDS 0x43408014
#define IG3_WRX1_GLPE_WRX_DOMAIN_IDS_RSVD2_S 11
#define IG3_WRX1_GLPE_WRX_DOMAIN_IDS_RSVD2_M RDMA_MASK3(32, 0x1FFFFF, IG3_WRX1_GLPE_WRX_DOMAIN_IDS_RSVD2_S)
#define IG3_WRX1_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_S 8
#define IG3_WRX1_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX1_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_S)
#define IG3_WRX1_GLPE_WRX_DOMAIN_IDS_RSVD1_S 7
#define IG3_WRX1_GLPE_WRX_DOMAIN_IDS_RSVD1_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DOMAIN_IDS_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_S 4
#define IG3_WRX1_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX1_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_S)
#define IG3_WRX1_GLPE_WRX_DOMAIN_IDS_RSVD0_S 3
#define IG3_WRX1_GLPE_WRX_DOMAIN_IDS_RSVD0_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DOMAIN_IDS_RSVD0_S)
#define IG3_WRX1_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_S 0
#define IG3_WRX1_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX1_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_S)
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_COUNT 0x434080B8
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX1_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX1_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_CMD 0x434080CC
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_DATA_H 0x434080D8
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_DATA_L 0x434080D4
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_PTR 0x434080D0
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX1_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_CMD 0x434080BC
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_DATA_H 0x434080C8
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_DATA_L 0x434080C4
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_PTR 0x434080C0
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX1_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL 0x43408080
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_RSVD1_S 25
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_WRX1_GLPE_WRX_DTM_CONTROL_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_RSVD2_S 17
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX1_GLPE_WRX_DTM_CONTROL_RSVD2_S)
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_RSVD3_S 9
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_WRX1_GLPE_WRX_DTM_CONTROL_RSVD3_S)
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_BYPASS_S 8
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_CONTROL_BYPASS_S)
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_RSVD4_S 1
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_WRX1_GLPE_WRX_DTM_CONTROL_RSVD4_S)
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_WRX1_GLPE_WRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_WRX1_GLPE_WRX_DTM_ECC_COR_ERR 0x434080E8
#define IG3_WRX1_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_WRX1_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX1_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_WRX1_GLPE_WRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_WRX1_GLPE_WRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WRX1_GLPE_WRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_WRX1_GLPE_WRX_DTM_ECC_UNCOR_ERR 0x434080E4
#define IG3_WRX1_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_WRX1_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX1_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_WRX1_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_WRX1_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WRX1_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_WRX1_GLPE_WRX_DTM_GROUP_CFG 0x4340808C
#define IG3_WRX1_GLPE_WRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_WRX1_GLPE_WRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WRX1_GLPE_WRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_WRX1_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX1_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_WRX1_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_WRX1_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX1_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_WRX1_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_WRX1_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX1_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_WRX1_GLPE_WRX_DTM_LOG_CFG 0x43408090
#define IG3_WRX1_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_WRX1_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_WRX1_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_WRX1_GLPE_WRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_WRX1_GLPE_WRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_WRX1_GLPE_WRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_DTM_LOG_CFG_MODE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_WRX1_GLPE_WRX_DTM_LOG_CFG_MODE_S)
#define IG3_WRX1_GLPE_WRX_DTM_LOG_MASK 0x43408098
#define IG3_WRX1_GLPE_WRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_DTM_LOG_MASK_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_LOG_PATTERN 0x43408094
#define IG3_WRX1_GLPE_WRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG 0x43408084
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_STS 0x43408088
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_WRX1_GLPE_WRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX1_GLPE_WRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_WRX1_GLPE_WRX_DTM_TIMESTAMP 0x434080B0
#define IG3_WRX1_GLPE_WRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER 0x434080B4
#define IG3_WRX1_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG 0x434080DC
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS 0x434080E0
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG 0x4340809C
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_WRX1_GLPE_WRX_DTM_TRIG_CFG_MODE_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_COUNT 0x434080A8
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_MASK 0x434080A4
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_PATTERN 0x434080A0
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_TIMESTAMP 0x434080AC
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_WRX1_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHHI 0x43408020
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WRX1_GLPE_WRX_FWQPFLUSHHI_RSVD0_S)
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHHI_QPID_S 6
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX1_GLPE_WRX_FWQPFLUSHHI_QPID_S)
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WRX1_GLPE_WRX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO 0x4340801C
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_BUSY_S 31
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_BUSY_S)
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_RSVD0_S)
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_HOSTID_S)
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_PMF_S 0
#define IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WRX1_GLPE_WRX_FWQPFLUSHLO_PMF_S)
#define IG3_WRX1_GLPE_WRX_RQ_CACHE_CTRL 0x43408004
#define IG3_WRX1_GLPE_WRX_RQ_CACHE_CTRL_RSVD_S 7
#define IG3_WRX1_GLPE_WRX_RQ_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x1FFFFFF, IG3_WRX1_GLPE_WRX_RQ_CACHE_CTRL_RSVD_S)
#define IG3_WRX1_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_S 0
#define IG3_WRX1_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_M RDMA_MASK3(32, 0x7F, IG3_WRX1_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_S)
#define IG3_WRX1_GLPE_WRX_RQ_CACHE_DATA0 0x43408008
#define IG3_WRX1_GLPE_WRX_RQ_CACHE_DATA0_DATA_S 0
#define IG3_WRX1_GLPE_WRX_RQ_CACHE_DATA0_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_RQ_CACHE_DATA0_DATA_S)
#define IG3_WRX1_GLPE_WRX_RQ_CACHE_DATA1 0x4340800C
#define IG3_WRX1_GLPE_WRX_RQ_CACHE_DATA1_DATA_S 0
#define IG3_WRX1_GLPE_WRX_RQ_CACHE_DATA1_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_RQ_CACHE_DATA1_DATA_S)
#define IG3_WRX1_GLPE_WRX_RQ_CACHE_DATA2 0x43408010
#define IG3_WRX1_GLPE_WRX_RQ_CACHE_DATA2_DATA_S 0
#define IG3_WRX1_GLPE_WRX_RQ_CACHE_DATA2_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX1_GLPE_WRX_RQ_CACHE_DATA2_DATA_S)
#define IG3_SQC1_GLPE_SQC_CONFIG 0x43408470
#define IG3_SQC1_GLPE_SQC_CONFIG_RSVD_S 6
#define IG3_SQC1_GLPE_SQC_CONFIG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_SQC1_GLPE_SQC_CONFIG_RSVD_S)
#define IG3_SQC1_GLPE_SQC_CONFIG_DBL_INDV_DIS_S 3
#define IG3_SQC1_GLPE_SQC_CONFIG_DBL_INDV_DIS_M RDMA_MASK3(32, 0x7, IG3_SQC1_GLPE_SQC_CONFIG_DBL_INDV_DIS_S)
#define IG3_SQC1_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_S 2
#define IG3_SQC1_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_S)
#define IG3_SQC1_GLPE_SQC_CONFIG_DBL_DIS_S 1
#define IG3_SQC1_GLPE_SQC_CONFIG_DBL_DIS_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_CONFIG_DBL_DIS_S)
#define IG3_SQC1_GLPE_SQC_CONFIG_COALESCE_DIS_S 0
#define IG3_SQC1_GLPE_SQC_CONFIG_COALESCE_DIS_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_CONFIG_COALESCE_DIS_S)
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_COUNT 0x434084B8
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC1_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC1_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_CMD 0x434084CC
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_DATA_H 0x434084D8
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_DATA_L 0x434084D4
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_PTR 0x434084D0
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC1_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_CMD 0x434084BC
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_DATA_H 0x434084C8
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_DATA_L 0x434084C4
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_PTR 0x434084C0
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC1_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL 0x43408480
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_RSVD1_S 25
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SQC1_GLPE_SQC_DTM_CONTROL_RSVD1_S)
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_RSVD2_S 17
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC1_GLPE_SQC_DTM_CONTROL_RSVD2_S)
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_RSVD3_S 9
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SQC1_GLPE_SQC_DTM_CONTROL_RSVD3_S)
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_BYPASS_S 8
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_CONTROL_BYPASS_S)
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_RSVD4_S 1
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SQC1_GLPE_SQC_DTM_CONTROL_RSVD4_S)
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SQC1_GLPE_SQC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SQC1_GLPE_SQC_DTM_ECC_COR_ERR 0x434084E8
#define IG3_SQC1_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SQC1_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC1_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SQC1_GLPE_SQC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SQC1_GLPE_SQC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC1_GLPE_SQC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SQC1_GLPE_SQC_DTM_ECC_UNCOR_ERR 0x434084E4
#define IG3_SQC1_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SQC1_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC1_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SQC1_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SQC1_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC1_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SQC1_GLPE_SQC_DTM_GROUP_CFG 0x4340848C
#define IG3_SQC1_GLPE_SQC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SQC1_GLPE_SQC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SQC1_GLPE_SQC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SQC1_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SQC1_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC1_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SQC1_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SQC1_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC1_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SQC1_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SQC1_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC1_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SQC1_GLPE_SQC_DTM_LOG_CFG 0x43408490
#define IG3_SQC1_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SQC1_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SQC1_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SQC1_GLPE_SQC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SQC1_GLPE_SQC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SQC1_GLPE_SQC_DTM_LOG_CFG_RSVD1_S)
#define IG3_SQC1_GLPE_SQC_DTM_LOG_CFG_MODE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SQC1_GLPE_SQC_DTM_LOG_CFG_MODE_S)
#define IG3_SQC1_GLPE_SQC_DTM_LOG_MASK 0x43408498
#define IG3_SQC1_GLPE_SQC_DTM_LOG_MASK_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC1_GLPE_SQC_DTM_LOG_MASK_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_LOG_PATTERN 0x43408494
#define IG3_SQC1_GLPE_SQC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC1_GLPE_SQC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG 0x43408484
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_STS 0x43408488
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SQC1_GLPE_SQC_DTM_MAIN_STS_RSVD1_S)
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC1_GLPE_SQC_DTM_MAIN_STS_RSVD2_S)
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SQC1_GLPE_SQC_DTM_TIMESTAMP 0x434084B0
#define IG3_SQC1_GLPE_SQC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC1_GLPE_SQC_DTM_TIMESTAMP_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER 0x434084B4
#define IG3_SQC1_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC1_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG 0x434084DC
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS 0x434084E0
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG 0x4340849C
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_MODE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SQC1_GLPE_SQC_DTM_TRIG_CFG_MODE_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_COUNT 0x434084A8
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC1_GLPE_SQC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_MASK 0x434084A4
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC1_GLPE_SQC_DTM_TRIG_MASK_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_PATTERN 0x434084A0
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC1_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_TIMESTAMP 0x434084AC
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SQC1_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC1_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHHI 0x43408460
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_S 26
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_S)
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHHI_QPID_S 6
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHHI_QPID_S)
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_S 0
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_S)
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO 0x43408464
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_S 31
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_S)
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_S 30
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_S)
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_S 29
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_S)
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_S 26
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_S)
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_S)
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_PMF_S 0
#define IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC1_GLPE_SQC_FWFLRQPFLUSHLO_PMF_S)
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPHI(_i) 0x43408420 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPHI_MAX_INDEX_I 7
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPHI_RSVD0_S 26
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_SQC1_GLPE_SQC_FWFLUSHDROPHI_RSVD0_S)
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPHI_QPID_S 6
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC1_GLPE_SQC_FWFLUSHDROPHI_QPID_S)
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_S 0
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_SQC1_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_S)
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO(_i) 0x43408400 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_MAX_INDEX_I 7
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_EN_S 31
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_EN_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_EN_S)
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_RSVD0_S 29
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_RSVD0_S)
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_HOSTID_S 26
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_HOSTID_S)
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_S 24
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_S)
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_S 12
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_S)
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_PMF_S 0
#define IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC1_GLPE_SQC_FWFLUSHDROPLO_PMF_S)
#define IG3_SQC1_GLPE_SQC_FWSYNCRESP(_i) 0x43408468 + ((_i) * 4) /* _i=0...1 */
#define IG3_SQC1_GLPE_SQC_FWSYNCRESP_MAX_INDEX_I 1
#define IG3_SQC1_GLPE_SQC_FWSYNCRESP_RSVD_S 18
#define IG3_SQC1_GLPE_SQC_FWSYNCRESP_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_SQC1_GLPE_SQC_FWSYNCRESP_RSVD_S)
#define IG3_SQC1_GLPE_SQC_FWSYNCRESP_COUNT_S 8
#define IG3_SQC1_GLPE_SQC_FWSYNCRESP_COUNT_M RDMA_MASK3(32, 0x3FF, IG3_SQC1_GLPE_SQC_FWSYNCRESP_COUNT_S)
#define IG3_SQC1_GLPE_SQC_FWSYNCRESP_TAG_S 0
#define IG3_SQC1_GLPE_SQC_FWSYNCRESP_TAG_M RDMA_MASK3(32, 0xFF, IG3_SQC1_GLPE_SQC_FWSYNCRESP_TAG_S)
#define IG3_SQC1_GLPE_SQC_XLR_DROP(_i) 0x43408440 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC1_GLPE_SQC_XLR_DROP_MAX_INDEX_I 7
#define IG3_SQC1_GLPE_SQC_XLR_DROP_EN_S 31
#define IG3_SQC1_GLPE_SQC_XLR_DROP_EN_M RDMA_BIT2(32, IG3_SQC1_GLPE_SQC_XLR_DROP_EN_S)
#define IG3_SQC1_GLPE_SQC_XLR_DROP_RSVD0_S 12
#define IG3_SQC1_GLPE_SQC_XLR_DROP_RSVD0_M RDMA_MASK3(32, 0x7FFFF, IG3_SQC1_GLPE_SQC_XLR_DROP_RSVD0_S)
#define IG3_SQC1_GLPE_SQC_XLR_DROP_PMF_S 0
#define IG3_SQC1_GLPE_SQC_XLR_DROP_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC1_GLPE_SQC_XLR_DROP_PMF_S)
#define IG3_SQC1_SQC_ECC_COR_ERR 0x43408514
#define IG3_SQC1_SQC_ECC_COR_ERR_RSVD_S 12
#define IG3_SQC1_SQC_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC1_SQC_ECC_COR_ERR_RSVD_S)
#define IG3_SQC1_SQC_ECC_COR_ERR_CNT_S 0
#define IG3_SQC1_SQC_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC1_SQC_ECC_COR_ERR_CNT_S)
#define IG3_SQC1_SQC_ECC_UNCOR_ERR 0x43408510
#define IG3_SQC1_SQC_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SQC1_SQC_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC1_SQC_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SQC1_SQC_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SQC1_SQC_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC1_SQC_ECC_UNCOR_ERR_CNT_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG 0x43408500
#define IG3_SQC1_SQC_WRK_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_SQC1_SQC_WRK_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC1_SQC_WRK_RAM_CFG_ECC_INST_NUM_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_RSVD3_S 20
#define IG3_SQC1_SQC_WRK_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC1_SQC_WRK_RAM_CFG_RSVD3_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_RM_S 16
#define IG3_SQC1_SQC_WRK_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC1_SQC_WRK_RAM_CFG_RM_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_RSVD2_S 14
#define IG3_SQC1_SQC_WRK_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC1_SQC_WRK_RAM_CFG_RSVD2_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_SQC1_SQC_WRK_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC1_SQC_WRK_RAM_CFG_POWER_GATE_EN_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_RME_S 12
#define IG3_SQC1_SQC_WRK_RAM_CFG_RME_M RDMA_BIT2(32, IG3_SQC1_SQC_WRK_RAM_CFG_RME_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_RSVD1_S 10
#define IG3_SQC1_SQC_WRK_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC1_SQC_WRK_RAM_CFG_RSVD1_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_ERR_CNT_S 9
#define IG3_SQC1_SQC_WRK_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC1_SQC_WRK_RAM_CFG_ERR_CNT_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_FIX_CNT_S 8
#define IG3_SQC1_SQC_WRK_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC1_SQC_WRK_RAM_CFG_FIX_CNT_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_RSVD0_S 6
#define IG3_SQC1_SQC_WRK_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC1_SQC_WRK_RAM_CFG_RSVD0_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_MASK_INT_S 5
#define IG3_SQC1_SQC_WRK_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC1_SQC_WRK_RAM_CFG_MASK_INT_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_LS_BYPASS_S 4
#define IG3_SQC1_SQC_WRK_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC1_SQC_WRK_RAM_CFG_LS_BYPASS_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_LS_FORCE_S 3
#define IG3_SQC1_SQC_WRK_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC1_SQC_WRK_RAM_CFG_LS_FORCE_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_SQC1_SQC_WRK_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC1_SQC_WRK_RAM_CFG_ECC_INVERT_2_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_SQC1_SQC_WRK_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC1_SQC_WRK_RAM_CFG_ECC_INVERT_1_S)
#define IG3_SQC1_SQC_WRK_RAM_CFG_ECC_EN_S 0
#define IG3_SQC1_SQC_WRK_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC1_SQC_WRK_RAM_CFG_ECC_EN_S)
#define IG3_SQC1_SQC_WRK_RAM_STATUS 0x43408504
#define IG3_SQC1_SQC_WRK_RAM_STATUS_RSVD1_S 30
#define IG3_SQC1_SQC_WRK_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC1_SQC_WRK_RAM_STATUS_RSVD1_S)
#define IG3_SQC1_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC1_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC1_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC1_SQC_WRK_RAM_STATUS_RSVD0_S 4
#define IG3_SQC1_SQC_WRK_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC1_SQC_WRK_RAM_STATUS_RSVD0_S)
#define IG3_SQC1_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC1_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC1_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC1_SQC_WRK_RAM_STATUS_INIT_DONE_S 2
#define IG3_SQC1_SQC_WRK_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC1_SQC_WRK_RAM_STATUS_INIT_DONE_S)
#define IG3_SQC1_SQC_WRK_RAM_STATUS_ECC_FIX_S 1
#define IG3_SQC1_SQC_WRK_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC1_SQC_WRK_RAM_STATUS_ECC_FIX_S)
#define IG3_SQC1_SQC_WRK_RAM_STATUS_ECC_ERR_S 0
#define IG3_SQC1_SQC_WRK_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC1_SQC_WRK_RAM_STATUS_ECC_ERR_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG 0x43408508
#define IG3_SQC1_SQC_XBUF_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_SQC1_SQC_XBUF_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC1_SQC_XBUF_RAM_CFG_ECC_INST_NUM_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_RSVD3_S 20
#define IG3_SQC1_SQC_XBUF_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC1_SQC_XBUF_RAM_CFG_RSVD3_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_RM_S 16
#define IG3_SQC1_SQC_XBUF_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC1_SQC_XBUF_RAM_CFG_RM_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_RSVD2_S 14
#define IG3_SQC1_SQC_XBUF_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC1_SQC_XBUF_RAM_CFG_RSVD2_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_SQC1_SQC_XBUF_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC1_SQC_XBUF_RAM_CFG_POWER_GATE_EN_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_RME_S 12
#define IG3_SQC1_SQC_XBUF_RAM_CFG_RME_M RDMA_BIT2(32, IG3_SQC1_SQC_XBUF_RAM_CFG_RME_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_RSVD1_S 10
#define IG3_SQC1_SQC_XBUF_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC1_SQC_XBUF_RAM_CFG_RSVD1_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_ERR_CNT_S 9
#define IG3_SQC1_SQC_XBUF_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC1_SQC_XBUF_RAM_CFG_ERR_CNT_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_FIX_CNT_S 8
#define IG3_SQC1_SQC_XBUF_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC1_SQC_XBUF_RAM_CFG_FIX_CNT_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_RSVD0_S 6
#define IG3_SQC1_SQC_XBUF_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC1_SQC_XBUF_RAM_CFG_RSVD0_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_MASK_INT_S 5
#define IG3_SQC1_SQC_XBUF_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC1_SQC_XBUF_RAM_CFG_MASK_INT_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_LS_BYPASS_S 4
#define IG3_SQC1_SQC_XBUF_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC1_SQC_XBUF_RAM_CFG_LS_BYPASS_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_LS_FORCE_S 3
#define IG3_SQC1_SQC_XBUF_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC1_SQC_XBUF_RAM_CFG_LS_FORCE_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_SQC1_SQC_XBUF_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC1_SQC_XBUF_RAM_CFG_ECC_INVERT_2_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_SQC1_SQC_XBUF_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC1_SQC_XBUF_RAM_CFG_ECC_INVERT_1_S)
#define IG3_SQC1_SQC_XBUF_RAM_CFG_ECC_EN_S 0
#define IG3_SQC1_SQC_XBUF_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC1_SQC_XBUF_RAM_CFG_ECC_EN_S)
#define IG3_SQC1_SQC_XBUF_RAM_STATUS 0x4340850C
#define IG3_SQC1_SQC_XBUF_RAM_STATUS_RSVD1_S 30
#define IG3_SQC1_SQC_XBUF_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC1_SQC_XBUF_RAM_STATUS_RSVD1_S)
#define IG3_SQC1_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC1_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC1_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC1_SQC_XBUF_RAM_STATUS_RSVD0_S 4
#define IG3_SQC1_SQC_XBUF_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC1_SQC_XBUF_RAM_STATUS_RSVD0_S)
#define IG3_SQC1_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC1_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC1_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC1_SQC_XBUF_RAM_STATUS_INIT_DONE_S 2
#define IG3_SQC1_SQC_XBUF_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC1_SQC_XBUF_RAM_STATUS_INIT_DONE_S)
#define IG3_SQC1_SQC_XBUF_RAM_STATUS_ECC_FIX_S 1
#define IG3_SQC1_SQC_XBUF_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC1_SQC_XBUF_RAM_STATUS_ECC_FIX_S)
#define IG3_SQC1_SQC_XBUF_RAM_STATUS_ECC_ERR_S 0
#define IG3_SQC1_SQC_XBUF_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC1_SQC_XBUF_RAM_STATUS_ECC_ERR_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DOMAIN_ID 0x43408804
#define IG3_SFPRX1_GLPE_SFP_RX_DOMAIN_ID_RSVD_S 3
#define IG3_SFPRX1_GLPE_SFP_RX_DOMAIN_ID_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DOMAIN_ID_RSVD_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_SFPRX1_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_COUNT 0x434088B8
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_CMD 0x434088CC
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H 0x434088D8
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L 0x434088D4
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_PTR 0x434088D0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_CMD 0x434088BC
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H 0x434088C8
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L 0x434088C4
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_PTR 0x434088C0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL 0x43408880
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_RSVD1_S 25
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_RSVD1_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_RSVD2_S 17
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_RSVD2_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_RSVD3_S 9
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_RSVD3_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_BYPASS_S 8
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_BYPASS_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_RSVD4_S 1
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_RSVD4_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_ECC_COR_ERR 0x434088E8
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR 0x434088E4
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_GROUP_CFG 0x4340888C
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_CFG 0x43408890
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_CFG_MODE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_CFG_MODE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_MASK 0x43408898
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_PATTERN 0x43408894
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG 0x43408884
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_STS 0x43408888
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TIMESTAMP 0x434088B0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER 0x434088B4
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG 0x434088DC
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS 0x434088E0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG 0x4340889C
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_COUNT 0x434088A8
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_MASK 0x434088A4
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_PATTERN 0x434088A0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP 0x434088AC
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SFPRX1_GLPE_SFP_RX_ERR_TBL_CLR 0x43408800
#define IG3_SFPRX1_GLPE_SFP_RX_ERR_TBL_CLR_REQ_S 31
#define IG3_SFPRX1_GLPE_SFP_RX_ERR_TBL_CLR_REQ_M RDMA_BIT2(32, IG3_SFPRX1_GLPE_SFP_RX_ERR_TBL_CLR_REQ_S)
#define IG3_SFPRX1_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_S 12
#define IG3_SFPRX1_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_SFPRX1_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_S)
#define IG3_SFPRX1_GLPE_SFP_RX_ERR_TBL_CLR_PMF_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_ERR_TBL_CLR_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX1_GLPE_SFP_RX_ERR_TBL_CLR_PMF_S)
#define IG3_SFPRX1_GLPE_SFP_RX_PER_MEM 0x43408808
#define IG3_SFPRX1_GLPE_SFP_RX_PER_MEM_RSVD_S 3
#define IG3_SFPRX1_GLPE_SFP_RX_PER_MEM_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPRX1_GLPE_SFP_RX_PER_MEM_RSVD_S)
#define IG3_SFPRX1_GLPE_SFP_RX_PER_MEM_PER_TYPE_S 0
#define IG3_SFPRX1_GLPE_SFP_RX_PER_MEM_PER_TYPE_M RDMA_MASK3(32, 0x7, IG3_SFPRX1_GLPE_SFP_RX_PER_MEM_PER_TYPE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG 0x43408C08
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS 0x43408C0C
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ECC_COR_ERR 0x43408C34
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR 0x43408C30
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG 0x43408C18
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS 0x43408C1C
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG 0x43408C20
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS 0x43408C24
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG 0x43408C00
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS 0x43408C04
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG 0x43408C28
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS 0x43408C2C
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG 0x43408C10
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS 0x43408C14
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG 0x43408C48
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS 0x43408C4C
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG 0x43408C40
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS 0x43408C44
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG 0x43408C78
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS 0x43408C7C
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG 0x43408C50
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS 0x43408C54
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG 0x43408C58
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS 0x43408C5C
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR 0x43408C84
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR 0x43408C80
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG 0x43408C70
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS 0x43408C74
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG 0x43408C60
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS 0x43408C64
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG 0x43408C68
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS 0x43408C6C
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG 0x43408C38
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS 0x43408C3C
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_ECC_COR_ERR 0x43408CCC
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR 0x43408CC8
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG 0x43408CD8
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS 0x43408CDC
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL 0x43408C90
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_S 31
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_S 26
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_S 18
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA 0x43408C94
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG 0x43408C88
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS 0x43408C8C
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL 0x43408CA0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_S 31
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_S 26
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA 0x43408CA4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG 0x43408C98
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS 0x43408C9C
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL 0x43408CB0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_S 31
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_S 26
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_S 18
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA 0x43408CB4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG 0x43408CA8
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS 0x43408CAC
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL 0x43408CC0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_S 31
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_S 26
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_S 18
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA 0x43408CC4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG 0x43408CB8
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS 0x43408CBC
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG 0x43408CD0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS 0x43408CD4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_WTX1_GLPE_WTX_1USCOUNT 0x43410010
#define IG3_WTX1_GLPE_WTX_1USCOUNT_CNT_S 0
#define IG3_WTX1_GLPE_WTX_1USCOUNT_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_1USCOUNT_CNT_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0 0x43410120
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_TAG_S 16
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_TAG_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_MODE_S 11
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_MODE_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1 0x43410124
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_PMF_S 0
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG1_PMF_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG2 0x43410128
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG2_QPID_S 6
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG2_QPID_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG3 0x4341012C
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG4 0x43410130
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_S 0
#define IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_S)
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG 0x43410020
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG_RSVD3_S 24
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG_RSVD3_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_ARB_CONFIG_RSVD3_S)
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG_RSVD2_S 20
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WTX1_GLPE_WTX_ARB_CONFIG_RSVD2_S)
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_S 16
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX1_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_S)
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG_RSVD1_S 12
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_WTX1_GLPE_WTX_ARB_CONFIG_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_S 8
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX1_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_S)
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG_RSVD0_S 4
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG_RSVD0_M RDMA_MASK3(32, 0xF, IG3_WTX1_GLPE_WTX_ARB_CONFIG_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_S 0
#define IG3_WTX1_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX1_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0 0x434100F8
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_TAG_S 16
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_TAG_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_MODE_S 11
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_MODE_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1 0x434100FC
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_PMF_S 0
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG1_PMF_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG2 0x43410100
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG2_QPID_S 6
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG2_QPID_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG3 0x43410104
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG4 0x43410108
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG4_COUNT_S 0
#define IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_CMP_DTM_TRIG4_COUNT_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG 0x4341017C
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_S 31
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_S 27
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_S 26
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX 0x43410180
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_CNPCOUNT 0x43410014
#define IG3_WTX1_GLPE_WTX_CNPCOUNT_CNT_S 0
#define IG3_WTX1_GLPE_WTX_CNPCOUNT_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_CNPCOUNT_CNT_S)
#define IG3_WTX1_GLPE_WTX_CONFIG 0x4341000C
#define IG3_WTX1_GLPE_WTX_CONFIG_RSVD1_S 28
#define IG3_WTX1_GLPE_WTX_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_WTX1_GLPE_WTX_CONFIG_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_CONFIG_SQ_HSM_ORD_S 25
#define IG3_WTX1_GLPE_WTX_CONFIG_SQ_HSM_ORD_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_CONFIG_SQ_HSM_ORD_S)
#define IG3_WTX1_GLPE_WTX_CONFIG_SQ_WQE_ORD_S 22
#define IG3_WTX1_GLPE_WTX_CONFIG_SQ_WQE_ORD_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_CONFIG_SQ_WQE_ORD_S)
#define IG3_WTX1_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_S 21
#define IG3_WTX1_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_S)
#define IG3_WTX1_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_S 20
#define IG3_WTX1_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_S)
#define IG3_WTX1_GLPE_WTX_CONFIG_RSVD0_S 4
#define IG3_WTX1_GLPE_WTX_CONFIG_RSVD0_M RDMA_MASK3(32, 0xFFFF, IG3_WTX1_GLPE_WTX_CONFIG_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_S 3
#define IG3_WTX1_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_S)
#define IG3_WTX1_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_S 2
#define IG3_WTX1_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_S)
#define IG3_WTX1_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_S 1
#define IG3_WTX1_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_S)
#define IG3_WTX1_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_S 0
#define IG3_WTX1_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG0 0x4341003C
#define IG3_WTX1_GLPE_WTX_CTCONFIG0_RSVD_S 21
#define IG3_WTX1_GLPE_WTX_CTCONFIG0_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_WTX1_GLPE_WTX_CTCONFIG0_RSVD_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG0_SCHED_S 0
#define IG3_WTX1_GLPE_WTX_CTCONFIG0_SCHED_M RDMA_MASK3(32, 0x1FFFFF, IG3_WTX1_GLPE_WTX_CTCONFIG0_SCHED_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG1 0x43410040
#define IG3_WTX1_GLPE_WTX_CTCONFIG1_RSVD_S 21
#define IG3_WTX1_GLPE_WTX_CTCONFIG1_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_WTX1_GLPE_WTX_CTCONFIG1_RSVD_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG1_VMRL_S 0
#define IG3_WTX1_GLPE_WTX_CTCONFIG1_VMRL_M RDMA_MASK3(32, 0x1FFFFF, IG3_WTX1_GLPE_WTX_CTCONFIG1_VMRL_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG2 0x43410044
#define IG3_WTX1_GLPE_WTX_CTCONFIG2_RSVD_S 30
#define IG3_WTX1_GLPE_WTX_CTCONFIG2_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_CTCONFIG2_RSVD_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_S 16
#define IG3_WTX1_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_S 0
#define IG3_WTX1_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX1_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG3 0x43410048
#define IG3_WTX1_GLPE_WTX_CTCONFIG3_RSVD_S 30
#define IG3_WTX1_GLPE_WTX_CTCONFIG3_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_CTCONFIG3_RSVD_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_S 16
#define IG3_WTX1_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_S 0
#define IG3_WTX1_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX1_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG4 0x4341004C
#define IG3_WTX1_GLPE_WTX_CTCONFIG4_RSVD_S 30
#define IG3_WTX1_GLPE_WTX_CTCONFIG4_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_CTCONFIG4_RSVD_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_S 16
#define IG3_WTX1_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_S 0
#define IG3_WTX1_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX1_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG5 0x43410050
#define IG3_WTX1_GLPE_WTX_CTCONFIG5_RSVD_S 20
#define IG3_WTX1_GLPE_WTX_CTCONFIG5_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_CTCONFIG5_RSVD_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG5_BMPKT_S 0
#define IG3_WTX1_GLPE_WTX_CTCONFIG5_BMPKT_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX1_GLPE_WTX_CTCONFIG5_BMPKT_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG6 0x43410054
#define IG3_WTX1_GLPE_WTX_CTCONFIG6_RSVD_S 13
#define IG3_WTX1_GLPE_WTX_CTCONFIG6_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_WTX1_GLPE_WTX_CTCONFIG6_RSVD_S)
#define IG3_WTX1_GLPE_WTX_CTCONFIG6_BMHDR_S 0
#define IG3_WTX1_GLPE_WTX_CTCONFIG6_BMHDR_M RDMA_MASK3(32, 0x1FFF, IG3_WTX1_GLPE_WTX_CTCONFIG6_BMHDR_S)
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_COUNT 0x43410238
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX1_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_CMD 0x4341024C
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_DATA_H 0x43410258
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_DATA_L 0x43410254
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_PTR 0x43410250
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX1_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_CMD 0x4341023C
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_DATA_H 0x43410248
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_DATA_L 0x43410244
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_PTR 0x43410240
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX1_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL 0x43410200
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_RSVD1_S 25
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_WTX1_GLPE_WTX_DTM_CONTROL_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_RSVD2_S 17
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX1_GLPE_WTX_DTM_CONTROL_RSVD2_S)
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_RSVD3_S 9
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_WTX1_GLPE_WTX_DTM_CONTROL_RSVD3_S)
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_BYPASS_S 8
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_CONTROL_BYPASS_S)
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_RSVD4_S 1
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_WTX1_GLPE_WTX_DTM_CONTROL_RSVD4_S)
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_WTX1_GLPE_WTX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_WTX1_GLPE_WTX_DTM_ECC_COR_ERR 0x43410268
#define IG3_WTX1_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX1_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_WTX1_GLPE_WTX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_WTX1_GLPE_WTX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_WTX1_GLPE_WTX_DTM_ECC_UNCOR_ERR 0x43410264
#define IG3_WTX1_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX1_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_WTX1_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_WTX1_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_WTX1_GLPE_WTX_DTM_GROUP_CFG 0x4341020C
#define IG3_WTX1_GLPE_WTX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_WTX1_GLPE_WTX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_WTX1_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_WTX1_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_WTX1_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_WTX1_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_WTX1_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_WTX1_GLPE_WTX_DTM_LOG_CFG 0x43410210
#define IG3_WTX1_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_WTX1_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_WTX1_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_WTX1_GLPE_WTX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_WTX1_GLPE_WTX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_DTM_LOG_CFG_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_DTM_LOG_CFG_MODE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_DTM_LOG_CFG_MODE_S)
#define IG3_WTX1_GLPE_WTX_DTM_LOG_MASK 0x43410218
#define IG3_WTX1_GLPE_WTX_DTM_LOG_MASK_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_DTM_LOG_MASK_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_LOG_PATTERN 0x43410214
#define IG3_WTX1_GLPE_WTX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG 0x43410204
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_STS 0x43410208
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_WTX1_GLPE_WTX_DTM_MAIN_STS_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX1_GLPE_WTX_DTM_MAIN_STS_RSVD2_S)
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_WTX1_GLPE_WTX_DTM_TIMESTAMP 0x43410230
#define IG3_WTX1_GLPE_WTX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_DTM_TIMESTAMP_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER 0x43410234
#define IG3_WTX1_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG 0x4341025C
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS 0x43410260
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG 0x4341021C
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_MODE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_WTX1_GLPE_WTX_DTM_TRIG_CFG_MODE_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_COUNT 0x43410228
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_MASK 0x43410224
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_DTM_TRIG_MASK_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_PATTERN 0x43410220
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_TIMESTAMP 0x4341022C
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_WTX1_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG 0x4341014C
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_S 29
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_S 13
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_S 0
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG 0x43410150
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_S 31
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_S 27
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_S 26
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX 0x43410154
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHHI 0x4341005C
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WTX1_GLPE_WTX_FWQPFLUSHHI_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHHI_QPID_S 6
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX1_GLPE_WTX_FWQPFLUSHHI_QPID_S)
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX1_GLPE_WTX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO 0x43410058
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_BUSY_S 31
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_BUSY_S)
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_HOSTID_S)
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_PMF_S 0
#define IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_FWQPFLUSHLO_PMF_S)
#define IG3_WTX1_GLPE_WTX_HOST_READ_CONFIG 0x43410038
#define IG3_WTX1_GLPE_WTX_HOST_READ_CONFIG_RSVD_S 8
#define IG3_WTX1_GLPE_WTX_HOST_READ_CONFIG_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX1_GLPE_WTX_HOST_READ_CONFIG_RSVD_S)
#define IG3_WTX1_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_S 0
#define IG3_WTX1_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0 0x4341010C
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_S 16
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_S 11
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1 0x43410110
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_S 0
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG2 0x43410114
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_S 6
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG3 0x43410118
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG4 0x4341011C
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_S 0
#define IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG 0x4341018C
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_S 31
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_S 27
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_S 26
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX 0x43410190
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG 0x43410194
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_S 31
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_S 27
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_S 26
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX 0x43410198
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG 0x43410184
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_S 31
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_S 27
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_S 26
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX 0x43410188
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0 0x43410090
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1 0x43410094
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG2 0x43410098
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG3 0x4341009C
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG4 0x434100A0
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0 0x43410060
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1 0x43410064
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG2 0x43410068
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG3 0x4341006C
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG4 0x43410070
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG5 0x43410074
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0 0x43410078
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1 0x4341007C
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG2 0x43410080
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG3 0x43410084
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG4 0x43410088
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG5 0x4341008C
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG 0x43410134
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_S 29
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_S 13
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_S 0
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG 0x43410138
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_S 31
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_S 27
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_S 26
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX 0x4341013C
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG 0x43410140
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_S 29
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_S 13
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_S 0
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG 0x43410144
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_S 31
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_S 27
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_S 26
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX 0x43410148
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG 0x43410164
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_S 29
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_S 13
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_S 0
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG 0x43410168
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_S 31
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_S 27
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_S 26
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX 0x4341016C
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG 0x43410158
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_S 29
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_S 13
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_S 0
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG 0x4341015C
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_S 31
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_S 27
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_S 26
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX 0x43410160
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0 0x434100E4
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_S 16
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_S 11
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1 0x434100E8
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_S 0
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG2 0x434100EC
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_S 6
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG3 0x434100F0
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG4 0x434100F4
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_S 0
#define IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0 0x434100D0
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_S 16
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_S 11
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1 0x434100D4
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_S 0
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG2 0x434100D8
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_S 6
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG3 0x434100DC
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG4 0x434100E0
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_S 0
#define IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_S)
#define IG3_WTX1_GLPE_WTX_SPADS_ASSIGNED(_i) 0x43410000 + ((_i) * 4) /* _i=0...2 */
#define IG3_WTX1_GLPE_WTX_SPADS_ASSIGNED_MAX_INDEX_I 2
#define IG3_WTX1_GLPE_WTX_SPADS_ASSIGNED_SPAD3_S 24
#define IG3_WTX1_GLPE_WTX_SPADS_ASSIGNED_SPAD3_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPADS_ASSIGNED_SPAD3_S)
#define IG3_WTX1_GLPE_WTX_SPADS_ASSIGNED_SPAD2_S 16
#define IG3_WTX1_GLPE_WTX_SPADS_ASSIGNED_SPAD2_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPADS_ASSIGNED_SPAD2_S)
#define IG3_WTX1_GLPE_WTX_SPADS_ASSIGNED_SPAD1_S 8
#define IG3_WTX1_GLPE_WTX_SPADS_ASSIGNED_SPAD1_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPADS_ASSIGNED_SPAD1_S)
#define IG3_WTX1_GLPE_WTX_SPADS_ASSIGNED_SPAD0_S 0
#define IG3_WTX1_GLPE_WTX_SPADS_ASSIGNED_SPAD0_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPADS_ASSIGNED_SPAD0_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0 0x434100A4
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_S 16
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_S 11
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1 0x434100A8
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG2 0x434100AC
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_S 6
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG3 0x434100B0
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG4 0x434100B4
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG5 0x434100B8
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX1_GLPE_WTX_SPAD_CONFIG0 0x43410024
#define IG3_WTX1_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_S 24
#define IG3_WTX1_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_S)
#define IG3_WTX1_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_S 16
#define IG3_WTX1_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_S)
#define IG3_WTX1_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_S 8
#define IG3_WTX1_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_S)
#define IG3_WTX1_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_S)
#define IG3_WTX1_GLPE_WTX_SPAD_CONFIG1 0x43410028
#define IG3_WTX1_GLPE_WTX_SPAD_CONFIG1_RSVD_S 8
#define IG3_WTX1_GLPE_WTX_SPAD_CONFIG1_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX1_GLPE_WTX_SPAD_CONFIG1_RSVD_S)
#define IG3_WTX1_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_S)
#define IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS0 0x4341002C
#define IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_S 24
#define IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_S)
#define IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_S 16
#define IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_S)
#define IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_S 8
#define IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_S)
#define IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_S)
#define IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS1 0x43410030
#define IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_S 8
#define IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_S)
#define IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0 0x434100BC
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_S 16
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_S 11
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1 0x434100C0
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG2 0x434100C4
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_S 6
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG3 0x434100C8
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG4 0x434100CC
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_S)
#define IG3_WTX1_GLPE_WTX_SPAD_QUEUE_PTR_CTL 0x43410034
#define IG3_WTX1_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_S 16
#define IG3_WTX1_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_WTX1_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_S)
#define IG3_WTX1_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_S 8
#define IG3_WTX1_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_S)
#define IG3_WTX1_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_S)
#define IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL 0x43410018
#define IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_RSVD1_S 20
#define IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_S 16
#define IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_M RDMA_MASK3(32, 0xF, IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_S)
#define IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_RSVD0_S 10
#define IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_S 8
#define IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_M RDMA_MASK3(32, 0x3, IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_S)
#define IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_M RDMA_MASK3(32, 0xFF, IG3_WTX1_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_S)
#define IG3_WTX1_GLPE_WTX_SPAD_STAT_DATA 0x4341001C
#define IG3_WTX1_GLPE_WTX_SPAD_STAT_DATA_DATA_S 0
#define IG3_WTX1_GLPE_WTX_SPAD_STAT_DATA_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX1_GLPE_WTX_SPAD_STAT_DATA_DATA_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG 0x43410170
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_S 29
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_S 13
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_S 0
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG 0x43410174
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_S 31
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_S 27
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_S 26
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX 0x43410178
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX1_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_PTX1_GLPE_ARPCONTROL 0x4341400C
#define IG3_PTX1_GLPE_ARPCONTROL_ARP_LOCK_ACK_S 31
#define IG3_PTX1_GLPE_ARPCONTROL_ARP_LOCK_ACK_M RDMA_BIT2(32, IG3_PTX1_GLPE_ARPCONTROL_ARP_LOCK_ACK_S)
#define IG3_PTX1_GLPE_ARPCONTROL_ARP_LOCK_REQ_S 30
#define IG3_PTX1_GLPE_ARPCONTROL_ARP_LOCK_REQ_M RDMA_BIT2(32, IG3_PTX1_GLPE_ARPCONTROL_ARP_LOCK_REQ_S)
#define IG3_PTX1_GLPE_ARPCONTROL_RSVD_S 16
#define IG3_PTX1_GLPE_ARPCONTROL_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_PTX1_GLPE_ARPCONTROL_RSVD_S)
#define IG3_PTX1_GLPE_ARPCONTROL_ARP_LOCK_INDEX_S 0
#define IG3_PTX1_GLPE_ARPCONTROL_ARP_LOCK_INDEX_M RDMA_MASK3(32, 0xFFFF, IG3_PTX1_GLPE_ARPCONTROL_ARP_LOCK_INDEX_S)
#define IG3_PTX1_GLPE_CRT_CONFIG0 0x43414010
#define IG3_PTX1_GLPE_CRT_CONFIG0_RSVD_S 25
#define IG3_PTX1_GLPE_CRT_CONFIG0_RSVD_M RDMA_MASK3(32, 0x7F, IG3_PTX1_GLPE_CRT_CONFIG0_RSVD_S)
#define IG3_PTX1_GLPE_CRT_CONFIG0_QP_FC_EN_S 24
#define IG3_PTX1_GLPE_CRT_CONFIG0_QP_FC_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_CRT_CONFIG0_QP_FC_EN_S)
#define IG3_PTX1_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_S 16
#define IG3_PTX1_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_S)
#define IG3_PTX1_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_S 8
#define IG3_PTX1_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_S)
#define IG3_PTX1_GLPE_CRT_CONFIG0_TX_BUF_SIZE_S 0
#define IG3_PTX1_GLPE_CRT_CONFIG0_TX_BUF_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_CRT_CONFIG0_TX_BUF_SIZE_S)
#define IG3_PTX1_GLPE_CRT_CONFIG1 0x43414014
#define IG3_PTX1_GLPE_CRT_CONFIG1_RSVD_S 19
#define IG3_PTX1_GLPE_CRT_CONFIG1_RSVD_M RDMA_MASK3(32, 0x1FFF, IG3_PTX1_GLPE_CRT_CONFIG1_RSVD_S)
#define IG3_PTX1_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_S 16
#define IG3_PTX1_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_M RDMA_MASK3(32, 0x7, IG3_PTX1_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_S)
#define IG3_PTX1_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_S 8
#define IG3_PTX1_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_S)
#define IG3_PTX1_GLPE_CRT_CONFIG1_RX_BUF_SIZE_S 0
#define IG3_PTX1_GLPE_CRT_CONFIG1_RX_BUF_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_CRT_CONFIG1_RX_BUF_SIZE_S)
#define IG3_PTX1_GLPE_MAX_INLINE_DATA 0x43414000
#define IG3_PTX1_GLPE_MAX_INLINE_DATA_RSVD_S 8
#define IG3_PTX1_GLPE_MAX_INLINE_DATA_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX1_GLPE_MAX_INLINE_DATA_RSVD_S)
#define IG3_PTX1_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_S 0
#define IG3_PTX1_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_S)
#define IG3_PTX1_GLPE_MAX_TCP_ACKS 0x43414004
#define IG3_PTX1_GLPE_MAX_TCP_ACKS_RSVD_S 8
#define IG3_PTX1_GLPE_MAX_TCP_ACKS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX1_GLPE_MAX_TCP_ACKS_RSVD_S)
#define IG3_PTX1_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_S 0
#define IG3_PTX1_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0 0x43414018
#define IG3_PTX1_GLPE_PTX_CONFIG0_RSVD_31_S 31
#define IG3_PTX1_GLPE_PTX_CONFIG0_RSVD_31_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_RSVD_31_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_S 30
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_S 29
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_S 28
#define IG3_PTX1_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_S 27
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_S 26
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_S 22
#define IG3_PTX1_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_M RDMA_MASK3(32, 0xF, IG3_PTX1_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_S 21
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_S 20
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_RSVD_19_S 19
#define IG3_PTX1_GLPE_PTX_CONFIG0_RSVD_19_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_RSVD_19_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_S 18
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_S 17
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_S 16
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_S 15
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_S 14
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_RSVD_13_7_S 7
#define IG3_PTX1_GLPE_PTX_CONFIG0_RSVD_13_7_M RDMA_MASK3(32, 0x7F, IG3_PTX1_GLPE_PTX_CONFIG0_RSVD_13_7_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_UDP_CS_EN_S 6
#define IG3_PTX1_GLPE_PTX_CONFIG0_UDP_CS_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_UDP_CS_EN_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_Q1_PACING_S 5
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_Q1_PACING_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_DIS_Q1_PACING_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_S 4
#define IG3_PTX1_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_S 3
#define IG3_PTX1_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_S 1
#define IG3_PTX1_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_S)
#define IG3_PTX1_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_S 0
#define IG3_PTX1_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_S)
#define IG3_PTX1_GLPE_PTX_CONFIG1 0x4341401C
#define IG3_PTX1_GLPE_PTX_CONFIG1_RSVD_S 24
#define IG3_PTX1_GLPE_PTX_CONFIG1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_CONFIG1_RSVD_S)
#define IG3_PTX1_GLPE_PTX_CONFIG1_ACKREQ_PACING_S 21
#define IG3_PTX1_GLPE_PTX_CONFIG1_ACKREQ_PACING_M RDMA_MASK3(32, 0x7, IG3_PTX1_GLPE_PTX_CONFIG1_ACKREQ_PACING_S)
#define IG3_PTX1_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_S 16
#define IG3_PTX1_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_M RDMA_MASK3(32, 0x1F, IG3_PTX1_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_S)
#define IG3_PTX1_GLPE_PTX_CONFIG1_Q1_PACING_MULT_S 0
#define IG3_PTX1_GLPE_PTX_CONFIG1_Q1_PACING_MULT_M RDMA_MASK3(32, 0xFFFF, IG3_PTX1_GLPE_PTX_CONFIG1_Q1_PACING_MULT_S)
#define IG3_PTX1_GLPE_PTX_CONFIG2 0x43414020
#define IG3_PTX1_GLPE_PTX_CONFIG2_SEND2CPU_S 0
#define IG3_PTX1_GLPE_PTX_CONFIG2_SEND2CPU_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_CONFIG2_SEND2CPU_S)
#define IG3_PTX1_GLPE_PTX_CRT_XMIT_PTR 0x4341402C
#define IG3_PTX1_GLPE_PTX_CRT_XMIT_PTR_RSVD_S 8
#define IG3_PTX1_GLPE_PTX_CRT_XMIT_PTR_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX1_GLPE_PTX_CRT_XMIT_PTR_RSVD_S)
#define IG3_PTX1_GLPE_PTX_CRT_XMIT_PTR_COUNT_S 0
#define IG3_PTX1_GLPE_PTX_CRT_XMIT_PTR_COUNT_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_CRT_XMIT_PTR_COUNT_S)
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_COUNT 0x43414138
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX1_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX1_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_CMD 0x4341414C
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_DATA_H 0x43414158
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_DATA_L 0x43414154
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_PTR 0x43414150
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX1_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_CMD 0x4341413C
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_DATA_H 0x43414148
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_DATA_L 0x43414144
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_PTR 0x43414140
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX1_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL 0x43414100
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_RSVD1_S 25
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PTX1_GLPE_PTX_DTM_CONTROL_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_RSVD2_S 17
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX1_GLPE_PTX_DTM_CONTROL_RSVD2_S)
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_RSVD3_S 9
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PTX1_GLPE_PTX_DTM_CONTROL_RSVD3_S)
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_BYPASS_S 8
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_CONTROL_BYPASS_S)
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_RSVD4_S 1
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PTX1_GLPE_PTX_DTM_CONTROL_RSVD4_S)
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PTX1_GLPE_PTX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PTX1_GLPE_PTX_DTM_ECC_COR_ERR 0x43414168
#define IG3_PTX1_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PTX1_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX1_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PTX1_GLPE_PTX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PTX1_GLPE_PTX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PTX1_GLPE_PTX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PTX1_GLPE_PTX_DTM_ECC_UNCOR_ERR 0x43414164
#define IG3_PTX1_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PTX1_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX1_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PTX1_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PTX1_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PTX1_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PTX1_GLPE_PTX_DTM_GROUP_CFG 0x4341410C
#define IG3_PTX1_GLPE_PTX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PTX1_GLPE_PTX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PTX1_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PTX1_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PTX1_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PTX1_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PTX1_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PTX1_GLPE_PTX_DTM_LOG_CFG 0x43414110
#define IG3_PTX1_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PTX1_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PTX1_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PTX1_GLPE_PTX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PTX1_GLPE_PTX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PTX1_GLPE_PTX_DTM_LOG_CFG_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_DTM_LOG_CFG_MODE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_DTM_LOG_CFG_MODE_S)
#define IG3_PTX1_GLPE_PTX_DTM_LOG_MASK 0x43414118
#define IG3_PTX1_GLPE_PTX_DTM_LOG_MASK_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_DTM_LOG_MASK_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_LOG_PATTERN 0x43414114
#define IG3_PTX1_GLPE_PTX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG 0x43414104
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_STS 0x43414108
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PTX1_GLPE_PTX_DTM_MAIN_STS_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX1_GLPE_PTX_DTM_MAIN_STS_RSVD2_S)
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PTX1_GLPE_PTX_DTM_TIMESTAMP 0x43414130
#define IG3_PTX1_GLPE_PTX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_DTM_TIMESTAMP_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER 0x43414134
#define IG3_PTX1_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG 0x4341415C
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS 0x43414160
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG 0x4341411C
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_MODE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PTX1_GLPE_PTX_DTM_TRIG_CFG_MODE_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_COUNT 0x43414128
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_MASK 0x43414124
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_DTM_TRIG_MASK_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_PATTERN 0x43414120
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_TIMESTAMP 0x4341412C
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PTX1_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHHI 0x43414028
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_PTX1_GLPE_PTX_FWQPFLUSHHI_RSVD0_S)
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHHI_QPID_S 6
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX1_GLPE_PTX_FWQPFLUSHHI_QPID_S)
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX1_GLPE_PTX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO 0x43414024
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_BUSY_S 31
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_BUSY_S)
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_RSVD0_S)
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_HOSTID_S)
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_PMF_S 0
#define IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX1_GLPE_PTX_FWQPFLUSHLO_PMF_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0 0x43414044
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_TAG_S 16
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_TAG_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_MODE_S 11
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_MODE_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1 0x43414048
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_PMF_S 0
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG1_PMF_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG2 0x4341404C
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG2_QPID_S 6
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG2_QPID_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG3 0x43414050
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG4 0x43414054
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG4_COUNT_S 0
#define IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_ST0_DTM_TRIG4_COUNT_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0 0x43414058
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_TAG_S 16
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_TAG_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_MODE_S 11
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_MODE_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1 0x4341405C
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_PMF_S 0
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG1_PMF_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG2 0x43414060
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG2_QPID_S 6
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG2_QPID_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG3 0x43414064
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG4 0x43414068
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG4_COUNT_S 0
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG4_COUNT_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT0 0x43414078
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_S 1
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_S 0
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT1 0x4341407C
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_S 0
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT2 0x43414080
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_S 0
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE0 0x4341406C
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_S 1
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_S 0
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE1 0x43414070
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_S 24
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_S 0
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE2 0x43414074
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_S 24
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_S)
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_S 0
#define IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX1_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0 0x43414030
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_S 16
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_S 11
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1 0x43414034
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_S 0
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG2 0x43414038
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_S 6
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG3 0x4341403C
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG4 0x43414040
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_S 0
#define IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX1_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_S)
#define IG3_PTX1_GLPE_TIMELY_STALL_THRESHOLD 0x43414008
#define IG3_PTX1_GLPE_TIMELY_STALL_THRESHOLD_RSVD_S 25
#define IG3_PTX1_GLPE_TIMELY_STALL_THRESHOLD_RSVD_M RDMA_MASK3(32, 0x7F, IG3_PTX1_GLPE_TIMELY_STALL_THRESHOLD_RSVD_S)
#define IG3_PTX1_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_S 24
#define IG3_PTX1_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_M RDMA_BIT2(32, IG3_PTX1_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_S)
#define IG3_PTX1_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_S 0
#define IG3_PTX1_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX1_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_COUNT 0x434144B8
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_CMD 0x434144CC
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_DATA_H 0x434144D8
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_DATA_L 0x434144D4
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_PTR 0x434144D0
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_CMD 0x434144BC
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_DATA_H 0x434144C8
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_DATA_L 0x434144C4
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_PTR 0x434144C0
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL 0x43414480
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_RSVD1_S 25
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_RSVD1_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_RSVD2_S 17
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_RSVD2_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_RSVD3_S 9
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_RSVD3_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_BYPASS_S 8
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_BYPASS_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_RSVD4_S 1
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_RSVD4_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_ECC_COR_ERR 0x434144E8
#define IG3_SFPTX1_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SFPTX1_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX1_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_ECC_UNCOR_ERR 0x434144E4
#define IG3_SFPTX1_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SFPTX1_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX1_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_GROUP_CFG 0x4341448C
#define IG3_SFPTX1_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SFPTX1_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPTX1_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SFPTX1_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX1_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SFPTX1_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX1_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX1_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_LOG_CFG 0x43414490
#define IG3_SFPTX1_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SFPTX1_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SFPTX1_GLPE_SFPT_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SFPTX1_GLPE_SFPT_DTM_LOG_CFG_RSVD1_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_LOG_CFG_MODE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SFPTX1_GLPE_SFPT_DTM_LOG_CFG_MODE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_LOG_MASK 0x43414498
#define IG3_SFPTX1_GLPE_SFPT_DTM_LOG_MASK_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_LOG_MASK_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_LOG_PATTERN 0x43414494
#define IG3_SFPTX1_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG 0x43414484
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_STS 0x43414488
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_STS_RSVD1_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_STS_RSVD2_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TIMESTAMP 0x434144B0
#define IG3_SFPTX1_GLPE_SFPT_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_TIMESTAMP_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER 0x434144B4
#define IG3_SFPTX1_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG 0x434144DC
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS 0x434144E0
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SFPTX1_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG 0x4341449C
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_MODE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_CFG_MODE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_COUNT 0x434144A8
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_MASK 0x434144A4
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_MASK_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_PATTERN 0x434144A0
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_TIMESTAMP 0x434144AC
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX1_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SFPTX1_GLPE_SFP_TX_DOMAIN_ID 0x43414400
#define IG3_SFPTX1_GLPE_SFP_TX_DOMAIN_ID_RSVD_S 3
#define IG3_SFPTX1_GLPE_SFP_TX_DOMAIN_ID_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPTX1_GLPE_SFP_TX_DOMAIN_ID_RSVD_S)
#define IG3_SFPTX1_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_S 0
#define IG3_SFPTX1_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_SFPTX1_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_S)
#define IG3_SFPTX1_GLPE_SFP_TX_PER_MEM 0x43414404
#define IG3_SFPTX1_GLPE_SFP_TX_PER_MEM_RSVD_S 3
#define IG3_SFPTX1_GLPE_SFP_TX_PER_MEM_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPTX1_GLPE_SFP_TX_PER_MEM_RSVD_S)
#define IG3_SFPTX1_GLPE_SFP_TX_PER_MEM_PER_TYPE_S 0
#define IG3_SFPTX1_GLPE_SFP_TX_PER_MEM_PER_TYPE_M RDMA_MASK3(32, 0x7, IG3_SFPTX1_GLPE_SFP_TX_PER_MEM_PER_TYPE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG 0x43414800
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS 0x43414804
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG 0x43414810
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS 0x43414814
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ECC_COR_ERR 0x43414834
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR 0x43414830
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG 0x43414818
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS 0x4341481C
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG 0x43414808
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS 0x4341480C
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG 0x43414828
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS 0x4341482C
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG 0x43414820
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS 0x43414824
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG 0x43414840
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS 0x43414844
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG 0x43414848
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS 0x4341484C
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG 0x43414850
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS 0x43414854
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG 0x43414858
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS 0x4341485C
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR 0x4341487C
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR 0x43414878
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG 0x43414860
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS 0x43414864
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG 0x43414868
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS 0x4341486C
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG 0x43414870
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS 0x43414874
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG 0x43414838
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS 0x4341483C
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL 0x434148C8
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_S 31
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_S 26
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_S 18
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_DATA 0x434148CC
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG 0x434148C0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS 0x434148C4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_ECC_COR_ERR 0x434148E4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR 0x434148E0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL 0x434148D8
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_S 31
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_S 26
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA 0x434148DC
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG 0x434148D0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS 0x434148D4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL 0x43414888
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_S 31
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_S 26
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_S 18
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA 0x4341488C
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG 0x43414880
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS 0x43414884
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL 0x43414898
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_S 31
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_S 26
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA 0x4341489C
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG 0x43414890
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS 0x43414894
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL 0x434148A8
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_S 31
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_S 26
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_S 18
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA 0x434148AC
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG 0x434148A0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS 0x434148A4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL 0x434148B8
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_S 31
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_S 26
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_S 18
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA 0x434148BC
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG 0x434148B0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_S 20
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_S 16
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_S 14
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_S 10
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_S 6
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_S 5
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS 0x434148B4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_S 30
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_S 4
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE1_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_S)
#define IG3_DRX1_GLPE_DRX_CONFIG 0x43420000
#define IG3_DRX1_GLPE_DRX_CONFIG_RSVD1_S 3
#define IG3_DRX1_GLPE_DRX_CONFIG_RSVD1_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_DRX1_GLPE_DRX_CONFIG_RSVD1_S)
#define IG3_DRX1_GLPE_DRX_CONFIG_CRC_MASK_S 0
#define IG3_DRX1_GLPE_DRX_CONFIG_CRC_MASK_M RDMA_MASK3(32, 0x7, IG3_DRX1_GLPE_DRX_CONFIG_CRC_MASK_S)
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_COUNT 0x434200B8
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX1_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX1_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_CMD 0x434200CC
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_DATA_H 0x434200D8
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_DATA_L 0x434200D4
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_PTR 0x434200D0
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX1_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_CMD 0x434200BC
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_DATA_H 0x434200C8
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_DATA_L 0x434200C4
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_PTR 0x434200C0
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX1_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL 0x43420080
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_RSVD1_S 25
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_DRX1_GLPE_DRX_DTM_CONTROL_RSVD1_S)
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_RSVD2_S 17
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX1_GLPE_DRX_DTM_CONTROL_RSVD2_S)
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_RSVD3_S 9
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_DRX1_GLPE_DRX_DTM_CONTROL_RSVD3_S)
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_BYPASS_S 8
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_CONTROL_BYPASS_S)
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_RSVD4_S 1
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_DRX1_GLPE_DRX_DTM_CONTROL_RSVD4_S)
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_DRX1_GLPE_DRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_DRX1_GLPE_DRX_DTM_ECC_COR_ERR 0x434200E8
#define IG3_DRX1_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_DRX1_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX1_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_DRX1_GLPE_DRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_DRX1_GLPE_DRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX1_GLPE_DRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_DRX1_GLPE_DRX_DTM_ECC_UNCOR_ERR 0x434200E4
#define IG3_DRX1_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_DRX1_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX1_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_DRX1_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_DRX1_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX1_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_DRX1_GLPE_DRX_DTM_GROUP_CFG 0x4342008C
#define IG3_DRX1_GLPE_DRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_DRX1_GLPE_DRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_DRX1_GLPE_DRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_DRX1_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_DRX1_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX1_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_DRX1_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_DRX1_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX1_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_DRX1_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_DRX1_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX1_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_DRX1_GLPE_DRX_DTM_LOG_CFG 0x43420090
#define IG3_DRX1_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_DRX1_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_DRX1_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_DRX1_GLPE_DRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_DRX1_GLPE_DRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_DRX1_GLPE_DRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_DRX1_GLPE_DRX_DTM_LOG_CFG_MODE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_DRX1_GLPE_DRX_DTM_LOG_CFG_MODE_S)
#define IG3_DRX1_GLPE_DRX_DTM_LOG_MASK 0x43420098
#define IG3_DRX1_GLPE_DRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX1_GLPE_DRX_DTM_LOG_MASK_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_LOG_PATTERN 0x43420094
#define IG3_DRX1_GLPE_DRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX1_GLPE_DRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG 0x43420084
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_STS 0x43420088
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_DRX1_GLPE_DRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX1_GLPE_DRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_DRX1_GLPE_DRX_DTM_TIMESTAMP 0x434200B0
#define IG3_DRX1_GLPE_DRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX1_GLPE_DRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER 0x434200B4
#define IG3_DRX1_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX1_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG 0x434200DC
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS 0x434200E0
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DRX1_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG 0x4342009C
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_DRX1_GLPE_DRX_DTM_TRIG_CFG_MODE_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_COUNT 0x434200A8
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX1_GLPE_DRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_MASK 0x434200A4
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX1_GLPE_DRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_PATTERN 0x434200A0
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX1_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_TIMESTAMP 0x434200AC
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_DRX1_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX1_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_DRX1_GLPE_DRX_ECC_COR_ERR 0x43420004
#define IG3_DRX1_GLPE_DRX_ECC_COR_ERR_RSVD_S 12
#define IG3_DRX1_GLPE_DRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX1_GLPE_DRX_ECC_COR_ERR_RSVD_S)
#define IG3_DRX1_GLPE_DRX_ECC_COR_ERR_CNT_S 0
#define IG3_DRX1_GLPE_DRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX1_GLPE_DRX_ECC_COR_ERR_CNT_S)
#define IG3_DRX1_GLPE_DRX_ECC_UNCOR_ERR 0x43420008
#define IG3_DRX1_GLPE_DRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_DRX1_GLPE_DRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX1_GLPE_DRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_DRX1_GLPE_DRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_DRX1_GLPE_DRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX1_GLPE_DRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_DRX1_GLPE_PBUF_CFG 0x4342000C
#define IG3_DRX1_GLPE_PBUF_CFG_ECC_INST_NUM_S 25
#define IG3_DRX1_GLPE_PBUF_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DRX1_GLPE_PBUF_CFG_ECC_INST_NUM_S)
#define IG3_DRX1_GLPE_PBUF_CFG_RSVD3_S 20
#define IG3_DRX1_GLPE_PBUF_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DRX1_GLPE_PBUF_CFG_RSVD3_S)
#define IG3_DRX1_GLPE_PBUF_CFG_RM_S 16
#define IG3_DRX1_GLPE_PBUF_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DRX1_GLPE_PBUF_CFG_RM_S)
#define IG3_DRX1_GLPE_PBUF_CFG_RSVD2_S 14
#define IG3_DRX1_GLPE_PBUF_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DRX1_GLPE_PBUF_CFG_RSVD2_S)
#define IG3_DRX1_GLPE_PBUF_CFG_POWER_GATE_EN_S 13
#define IG3_DRX1_GLPE_PBUF_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DRX1_GLPE_PBUF_CFG_POWER_GATE_EN_S)
#define IG3_DRX1_GLPE_PBUF_CFG_RME_S 12
#define IG3_DRX1_GLPE_PBUF_CFG_RME_M RDMA_BIT2(32, IG3_DRX1_GLPE_PBUF_CFG_RME_S)
#define IG3_DRX1_GLPE_PBUF_CFG_RSVD1_S 10
#define IG3_DRX1_GLPE_PBUF_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX1_GLPE_PBUF_CFG_RSVD1_S)
#define IG3_DRX1_GLPE_PBUF_CFG_ERR_CNT_S 9
#define IG3_DRX1_GLPE_PBUF_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DRX1_GLPE_PBUF_CFG_ERR_CNT_S)
#define IG3_DRX1_GLPE_PBUF_CFG_FIX_CNT_S 8
#define IG3_DRX1_GLPE_PBUF_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DRX1_GLPE_PBUF_CFG_FIX_CNT_S)
#define IG3_DRX1_GLPE_PBUF_CFG_RSVD0_S 6
#define IG3_DRX1_GLPE_PBUF_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DRX1_GLPE_PBUF_CFG_RSVD0_S)
#define IG3_DRX1_GLPE_PBUF_CFG_MASK_INT_S 5
#define IG3_DRX1_GLPE_PBUF_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DRX1_GLPE_PBUF_CFG_MASK_INT_S)
#define IG3_DRX1_GLPE_PBUF_CFG_LS_BYPASS_S 4
#define IG3_DRX1_GLPE_PBUF_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DRX1_GLPE_PBUF_CFG_LS_BYPASS_S)
#define IG3_DRX1_GLPE_PBUF_CFG_LS_FORCE_S 3
#define IG3_DRX1_GLPE_PBUF_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DRX1_GLPE_PBUF_CFG_LS_FORCE_S)
#define IG3_DRX1_GLPE_PBUF_CFG_ECC_INVERT_2_S 2
#define IG3_DRX1_GLPE_PBUF_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DRX1_GLPE_PBUF_CFG_ECC_INVERT_2_S)
#define IG3_DRX1_GLPE_PBUF_CFG_ECC_INVERT_1_S 1
#define IG3_DRX1_GLPE_PBUF_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DRX1_GLPE_PBUF_CFG_ECC_INVERT_1_S)
#define IG3_DRX1_GLPE_PBUF_CFG_ECC_EN_S 0
#define IG3_DRX1_GLPE_PBUF_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DRX1_GLPE_PBUF_CFG_ECC_EN_S)
#define IG3_DRX1_GLPE_PBUF_STATUS 0x43420010
#define IG3_DRX1_GLPE_PBUF_STATUS_RSVD1_S 30
#define IG3_DRX1_GLPE_PBUF_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX1_GLPE_PBUF_STATUS_RSVD1_S)
#define IG3_DRX1_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DRX1_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DRX1_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DRX1_GLPE_PBUF_STATUS_RSVD0_S 4
#define IG3_DRX1_GLPE_PBUF_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DRX1_GLPE_PBUF_STATUS_RSVD0_S)
#define IG3_DRX1_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DRX1_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DRX1_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DRX1_GLPE_PBUF_STATUS_INIT_DONE_S 2
#define IG3_DRX1_GLPE_PBUF_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DRX1_GLPE_PBUF_STATUS_INIT_DONE_S)
#define IG3_DRX1_GLPE_PBUF_STATUS_ECC_FIX_S 1
#define IG3_DRX1_GLPE_PBUF_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DRX1_GLPE_PBUF_STATUS_ECC_FIX_S)
#define IG3_DRX1_GLPE_PBUF_STATUS_ECC_ERR_S 0
#define IG3_DRX1_GLPE_PBUF_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DRX1_GLPE_PBUF_STATUS_ECC_ERR_S)
#define IG3_CMPE1_CMPE_ECC_COR_ERR 0x4342053C
#define IG3_CMPE1_CMPE_ECC_COR_ERR_RSVD_S 12
#define IG3_CMPE1_CMPE_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE1_CMPE_ECC_COR_ERR_RSVD_S)
#define IG3_CMPE1_CMPE_ECC_COR_ERR_CNT_S 0
#define IG3_CMPE1_CMPE_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE1_CMPE_ECC_COR_ERR_CNT_S)
#define IG3_CMPE1_CMPE_ECC_UNCOR_ERR 0x43420538
#define IG3_CMPE1_CMPE_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CMPE1_CMPE_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE1_CMPE_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CMPE1_CMPE_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CMPE1_CMPE_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE1_CMPE_ECC_UNCOR_ERR_CNT_S)
#define IG3_CMPE1_GLCM_PECLSADDR 0x43420484
#define IG3_CMPE1_GLCM_PECLSADDR_RSVD_S 9
#define IG3_CMPE1_GLCM_PECLSADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE1_GLCM_PECLSADDR_RSVD_S)
#define IG3_CMPE1_GLCM_PECLSADDR_CLS_ADDR_S 0
#define IG3_CMPE1_GLCM_PECLSADDR_CLS_ADDR_M RDMA_MASK3(32, 0x1FF, IG3_CMPE1_GLCM_PECLSADDR_CLS_ADDR_S)
#define IG3_CMPE1_GLCM_PECLSDATA0 0x43420488
#define IG3_CMPE1_GLCM_PECLSDATA0_CLS_DATA_S 0
#define IG3_CMPE1_GLCM_PECLSDATA0_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLCM_PECLSDATA0_CLS_DATA_S)
#define IG3_CMPE1_GLCM_PECLSDATA1 0x4342048C
#define IG3_CMPE1_GLCM_PECLSDATA1_CLS_DATA_S 0
#define IG3_CMPE1_GLCM_PECLSDATA1_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLCM_PECLSDATA1_CLS_DATA_S)
#define IG3_CMPE1_GLCM_PECLSDATA2 0x43420490
#define IG3_CMPE1_GLCM_PECLSDATA2_CLS_DATA_S 0
#define IG3_CMPE1_GLCM_PECLSDATA2_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLCM_PECLSDATA2_CLS_DATA_S)
#define IG3_CMPE1_GLCM_PECONFIG 0x43420480
#define IG3_CMPE1_GLCM_PECONFIG_DBGMUX_EN_S 31
#define IG3_CMPE1_GLCM_PECONFIG_DBGMUX_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECONFIG_DBGMUX_EN_S)
#define IG3_CMPE1_GLCM_PECONFIG_RSVD13_S 30
#define IG3_CMPE1_GLCM_PECONFIG_RSVD13_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECONFIG_RSVD13_S)
#define IG3_CMPE1_GLCM_PECONFIG_DBGMUX_SEL_HI_S 25
#define IG3_CMPE1_GLCM_PECONFIG_DBGMUX_SEL_HI_M RDMA_MASK3(32, 0x1F, IG3_CMPE1_GLCM_PECONFIG_DBGMUX_SEL_HI_S)
#define IG3_CMPE1_GLCM_PECONFIG_DBGMUX_SEL_LO_S 20
#define IG3_CMPE1_GLCM_PECONFIG_DBGMUX_SEL_LO_M RDMA_MASK3(32, 0x1F, IG3_CMPE1_GLCM_PECONFIG_DBGMUX_SEL_LO_S)
#define IG3_CMPE1_GLCM_PECONFIG_RSVD10_S 17
#define IG3_CMPE1_GLCM_PECONFIG_RSVD10_M RDMA_MASK3(32, 0x7, IG3_CMPE1_GLCM_PECONFIG_RSVD10_S)
#define IG3_CMPE1_GLCM_PECONFIG_DBG_WRSEL_S 16
#define IG3_CMPE1_GLCM_PECONFIG_DBG_WRSEL_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECONFIG_DBG_WRSEL_S)
#define IG3_CMPE1_GLCM_PECONFIG_DBG_DWSEL_S 14
#define IG3_CMPE1_GLCM_PECONFIG_DBG_DWSEL_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PECONFIG_DBG_DWSEL_S)
#define IG3_CMPE1_GLCM_PECONFIG_DBG_DPSEL_S 12
#define IG3_CMPE1_GLCM_PECONFIG_DBG_DPSEL_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PECONFIG_DBG_DPSEL_S)
#define IG3_CMPE1_GLCM_PECONFIG_RSVD6_S 7
#define IG3_CMPE1_GLCM_PECONFIG_RSVD6_M RDMA_MASK3(32, 0x1F, IG3_CMPE1_GLCM_PECONFIG_RSVD6_S)
#define IG3_CMPE1_GLCM_PECONFIG_DISABLE_CTXT_PACKING_S 6
#define IG3_CMPE1_GLCM_PECONFIG_DISABLE_CTXT_PACKING_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECONFIG_DISABLE_CTXT_PACKING_S)
#define IG3_CMPE1_GLCM_PECONFIG_DISABLE_LSA_S 5
#define IG3_CMPE1_GLCM_PECONFIG_DISABLE_LSA_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECONFIG_DISABLE_LSA_S)
#define IG3_CMPE1_GLCM_PECONFIG_ENABLE_CRC_S 4
#define IG3_CMPE1_GLCM_PECONFIG_ENABLE_CRC_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECONFIG_ENABLE_CRC_S)
#define IG3_CMPE1_GLCM_PECONFIG_DISABLE_RESCHEDULE_S 3
#define IG3_CMPE1_GLCM_PECONFIG_DISABLE_RESCHEDULE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECONFIG_DISABLE_RESCHEDULE_S)
#define IG3_CMPE1_GLCM_PECONFIG_DISABLE_PACKET_COUNT_S 2
#define IG3_CMPE1_GLCM_PECONFIG_DISABLE_PACKET_COUNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECONFIG_DISABLE_PACKET_COUNT_S)
#define IG3_CMPE1_GLCM_PECONFIG_GLOBAL_LOCK_MODE_S 1
#define IG3_CMPE1_GLCM_PECONFIG_GLOBAL_LOCK_MODE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECONFIG_GLOBAL_LOCK_MODE_S)
#define IG3_CMPE1_GLCM_PECONFIG_RSVD1_S 0
#define IG3_CMPE1_GLCM_PECONFIG_RSVD1_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECONFIG_RSVD1_S)
#define IG3_CMPE1_GLCM_PECTXDGCTL 0x434204C8
#define IG3_CMPE1_GLCM_PECTXDGCTL_RSVD_S 12
#define IG3_CMPE1_GLCM_PECTXDGCTL_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE1_GLCM_PECTXDGCTL_RSVD_S)
#define IG3_CMPE1_GLCM_PECTXDGCTL_PKTCNT_S 10
#define IG3_CMPE1_GLCM_PECTXDGCTL_PKTCNT_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PECTXDGCTL_PKTCNT_S)
#define IG3_CMPE1_GLCM_PECTXDGCTL_OP_CODE_S 8
#define IG3_CMPE1_GLCM_PECTXDGCTL_OP_CODE_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PECTXDGCTL_OP_CODE_S)
#define IG3_CMPE1_GLCM_PECTXDGCTL_ALLOCATE_S 7
#define IG3_CMPE1_GLCM_PECTXDGCTL_ALLOCATE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECTXDGCTL_ALLOCATE_S)
#define IG3_CMPE1_GLCM_PECTXDGCTL_WRITEBACK_S 6
#define IG3_CMPE1_GLCM_PECTXDGCTL_WRITEBACK_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECTXDGCTL_WRITEBACK_S)
#define IG3_CMPE1_GLCM_PECTXDGCTL_INVALIDATE_S 5
#define IG3_CMPE1_GLCM_PECTXDGCTL_INVALIDATE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECTXDGCTL_INVALIDATE_S)
#define IG3_CMPE1_GLCM_PECTXDGCTL_SUB_LINE_S 0
#define IG3_CMPE1_GLCM_PECTXDGCTL_SUB_LINE_M RDMA_MASK3(32, 0x1F, IG3_CMPE1_GLCM_PECTXDGCTL_SUB_LINE_S)
#define IG3_CMPE1_GLCM_PECTXDGDATA(_i) 0x434204CC + ((_i) * 4) /* _i=0...3 */
#define IG3_CMPE1_GLCM_PECTXDGDATA_MAX_INDEX_I 3
#define IG3_CMPE1_GLCM_PECTXDGDATA_DATA_S 0
#define IG3_CMPE1_GLCM_PECTXDGDATA_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLCM_PECTXDGDATA_DATA_S)
#define IG3_CMPE1_GLCM_PECTXDGFN 0x434204C0
#define IG3_CMPE1_GLCM_PECTXDGFN_RSVD_S 20
#define IG3_CMPE1_GLCM_PECTXDGFN_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE1_GLCM_PECTXDGFN_RSVD_S)
#define IG3_CMPE1_GLCM_PECTXDGFN_FUNC_TRIPLET_S 0
#define IG3_CMPE1_GLCM_PECTXDGFN_FUNC_TRIPLET_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE1_GLCM_PECTXDGFN_FUNC_TRIPLET_S)
#define IG3_CMPE1_GLCM_PECTXDGQP 0x434204C4
#define IG3_CMPE1_GLCM_PECTXDGQP_RSVD_S 24
#define IG3_CMPE1_GLCM_PECTXDGQP_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLCM_PECTXDGQP_RSVD_S)
#define IG3_CMPE1_GLCM_PECTXDGQP_QUEUE_NUM_S 0
#define IG3_CMPE1_GLCM_PECTXDGQP_QUEUE_NUM_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE1_GLCM_PECTXDGQP_QUEUE_NUM_S)
#define IG3_CMPE1_GLCM_PECTXDGSTAT 0x434204DC
#define IG3_CMPE1_GLCM_PECTXDGSTAT_RSVD_S 2
#define IG3_CMPE1_GLCM_PECTXDGSTAT_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_CMPE1_GLCM_PECTXDGSTAT_RSVD_S)
#define IG3_CMPE1_GLCM_PECTXDGSTAT_CTX_MISS_S 1
#define IG3_CMPE1_GLCM_PECTXDGSTAT_CTX_MISS_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECTXDGSTAT_CTX_MISS_S)
#define IG3_CMPE1_GLCM_PECTXDGSTAT_CTX_DONE_S 0
#define IG3_CMPE1_GLCM_PECTXDGSTAT_CTX_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PECTXDGSTAT_CTX_DONE_S)
#define IG3_CMPE1_GLCM_PEDATAREQHI 0x434204B4
#define IG3_CMPE1_GLCM_PEDATAREQHI_RSVD_S 24
#define IG3_CMPE1_GLCM_PEDATAREQHI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLCM_PEDATAREQHI_RSVD_S)
#define IG3_CMPE1_GLCM_PEDATAREQHI_DATAREQHI_S 0
#define IG3_CMPE1_GLCM_PEDATAREQHI_DATAREQHI_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE1_GLCM_PEDATAREQHI_DATAREQHI_S)
#define IG3_CMPE1_GLCM_PEDATAREQLO 0x434204B0
#define IG3_CMPE1_GLCM_PEDATAREQLO_DATAREQLOW_S 0
#define IG3_CMPE1_GLCM_PEDATAREQLO_DATAREQLOW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLCM_PEDATAREQLO_DATAREQLOW_S)
#define IG3_CMPE1_GLCM_PEDATASTALLHI 0x434204BC
#define IG3_CMPE1_GLCM_PEDATASTALLHI_RSVD_S 24
#define IG3_CMPE1_GLCM_PEDATASTALLHI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLCM_PEDATASTALLHI_RSVD_S)
#define IG3_CMPE1_GLCM_PEDATASTALLHI_DATASTALLHI_S 0
#define IG3_CMPE1_GLCM_PEDATASTALLHI_DATASTALLHI_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE1_GLCM_PEDATASTALLHI_DATASTALLHI_S)
#define IG3_CMPE1_GLCM_PEDATASTALLLO 0x434204B8
#define IG3_CMPE1_GLCM_PEDATASTALLLO_DATASTALLLOW_S 0
#define IG3_CMPE1_GLCM_PEDATASTALLLO_DATASTALLLOW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLCM_PEDATASTALLLO_DATASTALLLOW_S)
#define IG3_CMPE1_GLCM_PELOCKTBLADDR 0x4342049C
#define IG3_CMPE1_GLCM_PELOCKTBLADDR_RSVD_S 5
#define IG3_CMPE1_GLCM_PELOCKTBLADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_CMPE1_GLCM_PELOCKTBLADDR_RSVD_S)
#define IG3_CMPE1_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_S 0
#define IG3_CMPE1_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_M RDMA_MASK3(32, 0x1F, IG3_CMPE1_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_S)
#define IG3_CMPE1_GLCM_PELOCKTBLDATA0 0x434204A0
#define IG3_CMPE1_GLCM_PELOCKTBLDATA0_GPLOCKSEL_S 31
#define IG3_CMPE1_GLCM_PELOCKTBLDATA0_GPLOCKSEL_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PELOCKTBLDATA0_GPLOCKSEL_S)
#define IG3_CMPE1_GLCM_PELOCKTBLDATA0_RSVD_S 24
#define IG3_CMPE1_GLCM_PELOCKTBLDATA0_RSVD_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLCM_PELOCKTBLDATA0_RSVD_S)
#define IG3_CMPE1_GLCM_PELOCKTBLDATA0_QPID_S 0
#define IG3_CMPE1_GLCM_PELOCKTBLDATA0_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE1_GLCM_PELOCKTBLDATA0_QPID_S)
#define IG3_CMPE1_GLCM_PELOCKTBLDATA1 0x434204A4
#define IG3_CMPE1_GLCM_PELOCKTBLDATA1_RSVD_S 20
#define IG3_CMPE1_GLCM_PELOCKTBLDATA1_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE1_GLCM_PELOCKTBLDATA1_RSVD_S)
#define IG3_CMPE1_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_S 0
#define IG3_CMPE1_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE1_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_S)
#define IG3_CMPE1_GLCM_PELOCKTBLDATA2 0x434204A8
#define IG3_CMPE1_GLCM_PELOCKTBLDATA2_LOCKSEL_S 0
#define IG3_CMPE1_GLCM_PELOCKTBLDATA2_LOCKSEL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLCM_PELOCKTBLDATA2_LOCKSEL_S)
#define IG3_CMPE1_GLCM_PEPKTCNTADDR 0x43420494
#define IG3_CMPE1_GLCM_PEPKTCNTADDR_RSVD_S 9
#define IG3_CMPE1_GLCM_PEPKTCNTADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE1_GLCM_PEPKTCNTADDR_RSVD_S)
#define IG3_CMPE1_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_S 0
#define IG3_CMPE1_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_M RDMA_MASK3(32, 0x1FF, IG3_CMPE1_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_S)
#define IG3_CMPE1_GLCM_PEPKTCNTDATA 0x43420498
#define IG3_CMPE1_GLCM_PEPKTCNTDATA_RSVD1_S 18
#define IG3_CMPE1_GLCM_PEPKTCNTDATA_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE1_GLCM_PEPKTCNTDATA_RSVD1_S)
#define IG3_CMPE1_GLCM_PEPKTCNTDATA_RLRSP_STATE_S 16
#define IG3_CMPE1_GLCM_PEPKTCNTDATA_RLRSP_STATE_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PEPKTCNTDATA_RLRSP_STATE_S)
#define IG3_CMPE1_GLCM_PEPKTCNTDATA_RSVD0_S 14
#define IG3_CMPE1_GLCM_PEPKTCNTDATA_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PEPKTCNTDATA_RSVD0_S)
#define IG3_CMPE1_GLCM_PEPKTCNTDATA_RLREQ_STATE_S 12
#define IG3_CMPE1_GLCM_PEPKTCNTDATA_RLREQ_STATE_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PEPKTCNTDATA_RLREQ_STATE_S)
#define IG3_CMPE1_GLCM_PEPKTCNTDATA_PKTCNT_S 1
#define IG3_CMPE1_GLCM_PEPKTCNTDATA_PKTCNT_M RDMA_MASK3(32, 0x7FF, IG3_CMPE1_GLCM_PEPKTCNTDATA_PKTCNT_S)
#define IG3_CMPE1_GLCM_PEPKTCNTDATA_DONE_S 0
#define IG3_CMPE1_GLCM_PEPKTCNTDATA_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PEPKTCNTDATA_DONE_S)
#define IG3_CMPE1_GLCM_PESTATSCTL 0x434204AC
#define IG3_CMPE1_GLCM_PESTATSCTL_RSVD_S 2
#define IG3_CMPE1_GLCM_PESTATSCTL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_CMPE1_GLCM_PESTATSCTL_RSVD_S)
#define IG3_CMPE1_GLCM_PESTATSCTL_ENABLE_S 1
#define IG3_CMPE1_GLCM_PESTATSCTL_ENABLE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PESTATSCTL_ENABLE_S)
#define IG3_CMPE1_GLCM_PESTATSCTL_CLEAR_S 0
#define IG3_CMPE1_GLCM_PESTATSCTL_CLEAR_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PESTATSCTL_CLEAR_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG 0x43420500
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_S 20
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RM_S 16
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RM_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_S 14
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RME_S 12
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RME_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_S 10
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_S 6
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS 0x43420504
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG 0x43420508
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_S 20
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RM_S 16
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RM_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_S 14
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RME_S 12
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RME_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_S 10
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_S 6
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS 0x4342050C
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG 0x43420510
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_S 20
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RM_S 16
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RM_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_S 14
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RME_S 12
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RME_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_S 10
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_S 6
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS 0x43420514
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG 0x43420518
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_S 20
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RM_S 16
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RM_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_S 14
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RME_S 12
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RME_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_S 10
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_S 6
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS 0x4342051C
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG 0x43420520
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RSVD3_S 20
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RSVD3_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RM_S 16
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RM_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RSVD2_S 14
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RSVD2_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RME_S 12
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RME_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RSVD1_S 10
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RSVD0_S 6
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS 0x43420524
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE1_GLCM_PE_CACHESIZE 0x434204E4
#define IG3_CMPE1_GLCM_PE_CACHESIZE_RSVD_S 26
#define IG3_CMPE1_GLCM_PE_CACHESIZE_RSVD_M RDMA_MASK3(32, 0x3F, IG3_CMPE1_GLCM_PE_CACHESIZE_RSVD_S)
#define IG3_CMPE1_GLCM_PE_CACHESIZE_WAYS_S 16
#define IG3_CMPE1_GLCM_PE_CACHESIZE_WAYS_M RDMA_MASK3(32, 0x3FF, IG3_CMPE1_GLCM_PE_CACHESIZE_WAYS_S)
#define IG3_CMPE1_GLCM_PE_CACHESIZE_SETS_S 12
#define IG3_CMPE1_GLCM_PE_CACHESIZE_SETS_M RDMA_MASK3(32, 0xF, IG3_CMPE1_GLCM_PE_CACHESIZE_SETS_S)
#define IG3_CMPE1_GLCM_PE_CACHESIZE_WORD_SIZE_S 0
#define IG3_CMPE1_GLCM_PE_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFFF, IG3_CMPE1_GLCM_PE_CACHESIZE_WORD_SIZE_S)
#define IG3_CMPE1_GLCM_PE_DPC_COMP 0x434204F4
#define IG3_CMPE1_GLCM_PE_DPC_COMP_RSVD_S 13
#define IG3_CMPE1_GLCM_PE_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_CMPE1_GLCM_PE_DPC_COMP_RSVD_S)
#define IG3_CMPE1_GLCM_PE_DPC_COMP_COMP_FTYPE_S 11
#define IG3_CMPE1_GLCM_PE_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_DPC_COMP_COMP_FTYPE_S)
#define IG3_CMPE1_GLCM_PE_DPC_COMP_COMP_FNUM_S 1
#define IG3_CMPE1_GLCM_PE_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_CMPE1_GLCM_PE_DPC_COMP_COMP_FNUM_S)
#define IG3_CMPE1_GLCM_PE_DPC_COMP_COMP_VALID_S 0
#define IG3_CMPE1_GLCM_PE_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_DPC_COMP_COMP_VALID_S)
#define IG3_CMPE1_GLCM_PE_DPC_REQ 0x434204F0
#define IG3_CMPE1_GLCM_PE_DPC_REQ_RSVD_S 12
#define IG3_CMPE1_GLCM_PE_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE1_GLCM_PE_DPC_REQ_RSVD_S)
#define IG3_CMPE1_GLCM_PE_DPC_REQ_REQ_FTYPE_S 10
#define IG3_CMPE1_GLCM_PE_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_DPC_REQ_REQ_FTYPE_S)
#define IG3_CMPE1_GLCM_PE_DPC_REQ_REQ_FNUM_S 0
#define IG3_CMPE1_GLCM_PE_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_CMPE1_GLCM_PE_DPC_REQ_REQ_FNUM_S)
#define IG3_CMPE1_GLCM_PE_E2E_FC 0x434204F8
#define IG3_CMPE1_GLCM_PE_E2E_FC_RSVD1_S 22
#define IG3_CMPE1_GLCM_PE_E2E_FC_RSVD1_M RDMA_MASK3(32, 0x3FF, IG3_CMPE1_GLCM_PE_E2E_FC_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_S 16
#define IG3_CMPE1_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_M RDMA_MASK3(32, 0x3F, IG3_CMPE1_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_S)
#define IG3_CMPE1_GLCM_PE_E2E_FC_RSVD0_S 9
#define IG3_CMPE1_GLCM_PE_E2E_FC_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLCM_PE_E2E_FC_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_S 0
#define IG3_CMPE1_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_M RDMA_MASK3(32, 0x1FF, IG3_CMPE1_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG 0x43420528
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_S 20
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RM_S 16
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RM_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_S 14
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RME_S 12
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RME_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_S 10
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_S 6
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS 0x4342052C
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG 0x43420530
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_S 20
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RM_S 16
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RM_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_S 14
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RME_S 12
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RME_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_S 10
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_S 6
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS 0x43420534
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE1_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE1_GLCM_PE_IF_FC 0x434204FC
#define IG3_CMPE1_GLCM_PE_IF_FC_RSVD1_S 22
#define IG3_CMPE1_GLCM_PE_IF_FC_RSVD1_M RDMA_MASK3(32, 0x3FF, IG3_CMPE1_GLCM_PE_IF_FC_RSVD1_S)
#define IG3_CMPE1_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_S 16
#define IG3_CMPE1_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_M RDMA_MASK3(32, 0x3F, IG3_CMPE1_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_S)
#define IG3_CMPE1_GLCM_PE_IF_FC_RSVD0_S 9
#define IG3_CMPE1_GLCM_PE_IF_FC_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLCM_PE_IF_FC_RSVD0_S)
#define IG3_CMPE1_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_S 0
#define IG3_CMPE1_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_M RDMA_MASK3(32, 0x1FF, IG3_CMPE1_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_S)
#define IG3_CMPE1_GLCM_PE_MAXOSR 0x434204E0
#define IG3_CMPE1_GLCM_PE_MAXOSR_RSVD_S 6
#define IG3_CMPE1_GLCM_PE_MAXOSR_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_CMPE1_GLCM_PE_MAXOSR_RSVD_S)
#define IG3_CMPE1_GLCM_PE_MAXOSR_MAXOSR_S 0
#define IG3_CMPE1_GLCM_PE_MAXOSR_MAXOSR_M RDMA_MASK3(32, 0x3F, IG3_CMPE1_GLCM_PE_MAXOSR_MAXOSR_S)
#define IG3_CMPE1_GLCM_PE_RLDDBGCTL0 0x434204E8
#define IG3_CMPE1_GLCM_PE_RLDDBGCTL0_RSVD_S 24
#define IG3_CMPE1_GLCM_PE_RLDDBGCTL0_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLCM_PE_RLDDBGCTL0_RSVD_S)
#define IG3_CMPE1_GLCM_PE_RLDDBGCTL0_QPID_S 0
#define IG3_CMPE1_GLCM_PE_RLDDBGCTL0_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE1_GLCM_PE_RLDDBGCTL0_QPID_S)
#define IG3_CMPE1_GLCM_PE_RLDDBGCTL1 0x434204EC
#define IG3_CMPE1_GLCM_PE_RLDDBGCTL1_RSVD_S 20
#define IG3_CMPE1_GLCM_PE_RLDDBGCTL1_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE1_GLCM_PE_RLDDBGCTL1_RSVD_S)
#define IG3_CMPE1_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_S 18
#define IG3_CMPE1_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_S)
#define IG3_CMPE1_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_S 6
#define IG3_CMPE1_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CMPE1_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_S)
#define IG3_CMPE1_GLCM_PE_RLDDBGCTL1_PF_NUM_S 0
#define IG3_CMPE1_GLCM_PE_RLDDBGCTL1_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_CMPE1_GLCM_PE_RLDDBGCTL1_PF_NUM_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_COUNT 0x434205B8
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_CMD 0x434205CC
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_DATA_H 0x434205D8
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_DATA_L 0x434205D4
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_PTR 0x434205D0
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_CMD 0x434205BC
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_DATA_H 0x434205C8
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_DATA_L 0x434205C4
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_PTR 0x434205C0
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL 0x43420580
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_RSVD1_S 25
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_RSVD1_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_RSVD2_S 17
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_RSVD2_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_RSVD3_S 9
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_RSVD3_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_BYPASS_S 8
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_BYPASS_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_RSVD4_S 1
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_RSVD4_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_ECC_COR_ERR 0x434205E8
#define IG3_CMPE1_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_CMPE1_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE1_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_ECC_UNCOR_ERR 0x434205E4
#define IG3_CMPE1_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CMPE1_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE1_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_GROUP_CFG 0x4342058C
#define IG3_CMPE1_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_CMPE1_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_CMPE1_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_CMPE1_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_LOG_CFG 0x43420590
#define IG3_CMPE1_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_CMPE1_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_CMPE1_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_LOG_CFG_RSVD1_S 2
#define IG3_CMPE1_GLPE_CMPE_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE1_GLPE_CMPE_DTM_LOG_CFG_RSVD1_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_LOG_CFG_MODE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLPE_CMPE_DTM_LOG_CFG_MODE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_LOG_MASK 0x43420598
#define IG3_CMPE1_GLPE_CMPE_DTM_LOG_MASK_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_LOG_MASK_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_LOG_PATTERN 0x43420594
#define IG3_CMPE1_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG 0x43420584
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_STS 0x43420588
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_STS_RSVD1_S 9
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE1_GLPE_CMPE_DTM_MAIN_STS_RSVD1_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_STS_RSVD2_S 1
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLPE_CMPE_DTM_MAIN_STS_RSVD2_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TIMESTAMP 0x434205B0
#define IG3_CMPE1_GLPE_CMPE_DTM_TIMESTAMP_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_TIMESTAMP_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER 0x434205B4
#define IG3_CMPE1_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG 0x434205DC
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS 0x434205E0
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE1_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG 0x4342059C
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_MODE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_CMPE1_GLPE_CMPE_DTM_TRIG_CFG_MODE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_COUNT 0x434205A8
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_MASK 0x434205A4
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_MASK_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_TRIG_MASK_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_PATTERN 0x434205A0
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_TIMESTAMP 0x434205AC
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_CMPE1_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE1_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_CMPE1_PFCM_PE_CRCERRINFO0(_i) 0x43420400 + ((_i) * 4) /* _i=0...15 */
#define IG3_CMPE1_PFCM_PE_CRCERRINFO0_MAX_INDEX_I 15
#define IG3_CMPE1_PFCM_PE_CRCERRINFO0_RSVD1_S 18
#define IG3_CMPE1_PFCM_PE_CRCERRINFO0_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE1_PFCM_PE_CRCERRINFO0_RSVD1_S)
#define IG3_CMPE1_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_S 16
#define IG3_CMPE1_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE1_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_S)
#define IG3_CMPE1_PFCM_PE_CRCERRINFO0_VM_VF_NUM_S 4
#define IG3_CMPE1_PFCM_PE_CRCERRINFO0_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CMPE1_PFCM_PE_CRCERRINFO0_VM_VF_NUM_S)
#define IG3_CMPE1_PFCM_PE_CRCERRINFO0_RSVD0_S 1
#define IG3_CMPE1_PFCM_PE_CRCERRINFO0_RSVD0_M RDMA_MASK3(32, 0x7, IG3_CMPE1_PFCM_PE_CRCERRINFO0_RSVD0_S)
#define IG3_CMPE1_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_S 0
#define IG3_CMPE1_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_M RDMA_BIT2(32, IG3_CMPE1_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_S)
#define IG3_CMPE1_PFCM_PE_CRCERRINFO1(_i) 0x43420440 + ((_i) * 4) /* _i=0...15 */
#define IG3_CMPE1_PFCM_PE_CRCERRINFO1_MAX_INDEX_I 15
#define IG3_CMPE1_PFCM_PE_CRCERRINFO1_RSVD_S 24
#define IG3_CMPE1_PFCM_PE_CRCERRINFO1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE1_PFCM_PE_CRCERRINFO1_RSVD_S)
#define IG3_CMPE1_PFCM_PE_CRCERRINFO1_Q_NUM_S 0
#define IG3_CMPE1_PFCM_PE_CRCERRINFO1_Q_NUM_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE1_PFCM_PE_CRCERRINFO1_Q_NUM_S)
#define IG3_PRX2_GLPE_CC_DCQCN1_CFG(_i) 0x43802000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX2_GLPE_CC_DCQCN1_CFG_MAX_INDEX_I 1031
#define IG3_PRX2_GLPE_CC_DCQCN1_CFG_RSVD2_S 31
#define IG3_PRX2_GLPE_CC_DCQCN1_CFG_RSVD2_M RDMA_BIT2(32, IG3_PRX2_GLPE_CC_DCQCN1_CFG_RSVD2_S)
#define IG3_PRX2_GLPE_CC_DCQCN1_CFG_DCQCN_F_S 28
#define IG3_PRX2_GLPE_CC_DCQCN1_CFG_DCQCN_F_M RDMA_MASK3(32, 0x7, IG3_PRX2_GLPE_CC_DCQCN1_CFG_DCQCN_F_S)
#define IG3_PRX2_GLPE_CC_DCQCN1_CFG_RSVD1_S 25
#define IG3_PRX2_GLPE_CC_DCQCN1_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_PRX2_GLPE_CC_DCQCN1_CFG_RSVD1_S)
#define IG3_PRX2_GLPE_CC_DCQCN1_CFG_DCQCN_B_S 0
#define IG3_PRX2_GLPE_CC_DCQCN1_CFG_DCQCN_B_M RDMA_MASK3(32, 0x1FFFFFF, IG3_PRX2_GLPE_CC_DCQCN1_CFG_DCQCN_B_S)
#define IG3_PRX2_GLPE_CC_DCQCN2_CFG(_i) 0x43804000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX2_GLPE_CC_DCQCN2_CFG_MAX_INDEX_I 1031
#define IG3_PRX2_GLPE_CC_DCQCN2_CFG_RSVD_S 16
#define IG3_PRX2_GLPE_CC_DCQCN2_CFG_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PRX2_GLPE_CC_DCQCN2_CFG_RSVD_S)
#define IG3_PRX2_GLPE_CC_DCQCN2_CFG_DCQCN_T_S 0
#define IG3_PRX2_GLPE_CC_DCQCN2_CFG_DCQCN_T_M RDMA_MASK3(32, 0xFFFF, IG3_PRX2_GLPE_CC_DCQCN2_CFG_DCQCN_T_S)
#define IG3_PRX2_GLPE_CC_TIMELY_CFG(_i) 0x43800000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX2_GLPE_CC_TIMELY_CFG_MAX_INDEX_I 1031
#define IG3_PRX2_GLPE_CC_TIMELY_CFG_RAI_FACTOR_S 16
#define IG3_PRX2_GLPE_CC_TIMELY_CFG_RAI_FACTOR_M RDMA_MASK3(32, 0xFFFF, IG3_PRX2_GLPE_CC_TIMELY_CFG_RAI_FACTOR_S)
#define IG3_PRX2_GLPE_CC_TIMELY_CFG_HAI_FACTOR_S 0
#define IG3_PRX2_GLPE_CC_TIMELY_CFG_HAI_FACTOR_M RDMA_MASK3(32, 0xFFFF, IG3_PRX2_GLPE_CC_TIMELY_CFG_HAI_FACTOR_S)
#define IG3_PRX2_GLPE_PRX_CONFIG 0x43805020
#define IG3_PRX2_GLPE_PRX_CONFIG_REORDER_CNT_MAX_S 24
#define IG3_PRX2_GLPE_PRX_CONFIG_REORDER_CNT_MAX_M RDMA_MASK3(32, 0xFF, IG3_PRX2_GLPE_PRX_CONFIG_REORDER_CNT_MAX_S)
#define IG3_PRX2_GLPE_PRX_CONFIG_REORDER_CNT_MIN_S 16
#define IG3_PRX2_GLPE_PRX_CONFIG_REORDER_CNT_MIN_M RDMA_MASK3(32, 0xFF, IG3_PRX2_GLPE_PRX_CONFIG_REORDER_CNT_MIN_S)
#define IG3_PRX2_GLPE_PRX_CONFIG_RSVD1_S 12
#define IG3_PRX2_GLPE_PRX_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PRX2_GLPE_PRX_CONFIG_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_S 8
#define IG3_PRX2_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_M RDMA_MASK3(32, 0xF, IG3_PRX2_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_S)
#define IG3_PRX2_GLPE_PRX_CONFIG_RSVD0_S 5
#define IG3_PRX2_GLPE_PRX_CONFIG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PRX2_GLPE_PRX_CONFIG_RSVD0_S)
#define IG3_PRX2_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_S 4
#define IG3_PRX2_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_S)
#define IG3_PRX2_GLPE_PRX_CONFIG_ONE_HP_TILE_S 3
#define IG3_PRX2_GLPE_PRX_CONFIG_ONE_HP_TILE_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_CONFIG_ONE_HP_TILE_S)
#define IG3_PRX2_GLPE_PRX_CONFIG_DIS_RREC_S 2
#define IG3_PRX2_GLPE_PRX_CONFIG_DIS_RREC_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_CONFIG_DIS_RREC_S)
#define IG3_PRX2_GLPE_PRX_CONFIG_DIS_QR_STALL_S 1
#define IG3_PRX2_GLPE_PRX_CONFIG_DIS_QR_STALL_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_CONFIG_DIS_QR_STALL_S)
#define IG3_PRX2_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_S 0
#define IG3_PRX2_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_S)
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_COUNT 0x438050B8
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX2_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX2_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_CMD 0x438050CC
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_DATA_H 0x438050D8
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_DATA_L 0x438050D4
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_PTR 0x438050D0
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX2_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_CMD 0x438050BC
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_DATA_H 0x438050C8
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_DATA_L 0x438050C4
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_PTR 0x438050C0
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX2_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL 0x43805080
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_RSVD1_S 25
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PRX2_GLPE_PRX_DTM_CONTROL_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_RSVD2_S 17
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX2_GLPE_PRX_DTM_CONTROL_RSVD2_S)
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_RSVD3_S 9
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PRX2_GLPE_PRX_DTM_CONTROL_RSVD3_S)
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_BYPASS_S 8
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_CONTROL_BYPASS_S)
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_RSVD4_S 1
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PRX2_GLPE_PRX_DTM_CONTROL_RSVD4_S)
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PRX2_GLPE_PRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PRX2_GLPE_PRX_DTM_ECC_COR_ERR 0x438050E8
#define IG3_PRX2_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PRX2_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX2_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PRX2_GLPE_PRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PRX2_GLPE_PRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PRX2_GLPE_PRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PRX2_GLPE_PRX_DTM_ECC_UNCOR_ERR 0x438050E4
#define IG3_PRX2_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PRX2_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX2_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PRX2_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PRX2_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PRX2_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PRX2_GLPE_PRX_DTM_GROUP_CFG 0x4380508C
#define IG3_PRX2_GLPE_PRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PRX2_GLPE_PRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PRX2_GLPE_PRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PRX2_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX2_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PRX2_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PRX2_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX2_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PRX2_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PRX2_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX2_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PRX2_GLPE_PRX_DTM_LOG_CFG 0x43805090
#define IG3_PRX2_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PRX2_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PRX2_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PRX2_GLPE_PRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PRX2_GLPE_PRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PRX2_GLPE_PRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_DTM_LOG_CFG_MODE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PRX2_GLPE_PRX_DTM_LOG_CFG_MODE_S)
#define IG3_PRX2_GLPE_PRX_DTM_LOG_MASK 0x43805098
#define IG3_PRX2_GLPE_PRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX2_GLPE_PRX_DTM_LOG_MASK_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_LOG_PATTERN 0x43805094
#define IG3_PRX2_GLPE_PRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX2_GLPE_PRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG 0x43805084
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_STS 0x43805088
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PRX2_GLPE_PRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX2_GLPE_PRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PRX2_GLPE_PRX_DTM_TIMESTAMP 0x438050B0
#define IG3_PRX2_GLPE_PRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX2_GLPE_PRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER 0x438050B4
#define IG3_PRX2_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX2_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG 0x438050DC
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS 0x438050E0
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG 0x4380509C
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PRX2_GLPE_PRX_DTM_TRIG_CFG_MODE_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_COUNT 0x438050A8
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX2_GLPE_PRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_MASK 0x438050A4
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX2_GLPE_PRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_PATTERN 0x438050A0
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX2_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_TIMESTAMP 0x438050AC
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PRX2_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX2_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_CTL 0x43805024
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_S 12
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_S)
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_S 0
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_S)
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA 0x43805028
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_S 31
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_S)
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_S 30
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_M RDMA_BIT2(32, IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_S)
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_S 24
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_S)
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_S 20
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_S)
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_S 0
#define IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX2_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_S)
#define IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL 0x43808018
#define IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_S 21
#define IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_M RDMA_MASK3(32, 0x7FF, IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_S)
#define IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_S 16
#define IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_S)
#define IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_S 13
#define IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_S 8
#define IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_S)
#define IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_S 5
#define IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_S)
#define IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_S 0
#define IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX2_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_S)
#define IG3_WRX2_GLPE_WRX_CONFIG 0x43808000
#define IG3_WRX2_GLPE_WRX_CONFIG_RSVD_S 8
#define IG3_WRX2_GLPE_WRX_CONFIG_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WRX2_GLPE_WRX_CONFIG_RSVD_S)
#define IG3_WRX2_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_S 5
#define IG3_WRX2_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_M RDMA_MASK3(32, 0x7, IG3_WRX2_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_S)
#define IG3_WRX2_GLPE_WRX_CONFIG_DIS_WQE_CACHE_S 4
#define IG3_WRX2_GLPE_WRX_CONFIG_DIS_WQE_CACHE_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_CONFIG_DIS_WQE_CACHE_S)
#define IG3_WRX2_GLPE_WRX_CONFIG_DROP_OOO_IMMED_S 3
#define IG3_WRX2_GLPE_WRX_CONFIG_DROP_OOO_IMMED_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_CONFIG_DROP_OOO_IMMED_S)
#define IG3_WRX2_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_S 2
#define IG3_WRX2_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_S)
#define IG3_WRX2_GLPE_WRX_CONFIG_DIS_Q1_AE_S 1
#define IG3_WRX2_GLPE_WRX_CONFIG_DIS_Q1_AE_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_CONFIG_DIS_Q1_AE_S)
#define IG3_WRX2_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_S 0
#define IG3_WRX2_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_S)
#define IG3_WRX2_GLPE_WRX_DOMAIN_IDS 0x43808014
#define IG3_WRX2_GLPE_WRX_DOMAIN_IDS_RSVD2_S 11
#define IG3_WRX2_GLPE_WRX_DOMAIN_IDS_RSVD2_M RDMA_MASK3(32, 0x1FFFFF, IG3_WRX2_GLPE_WRX_DOMAIN_IDS_RSVD2_S)
#define IG3_WRX2_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_S 8
#define IG3_WRX2_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX2_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_S)
#define IG3_WRX2_GLPE_WRX_DOMAIN_IDS_RSVD1_S 7
#define IG3_WRX2_GLPE_WRX_DOMAIN_IDS_RSVD1_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DOMAIN_IDS_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_S 4
#define IG3_WRX2_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX2_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_S)
#define IG3_WRX2_GLPE_WRX_DOMAIN_IDS_RSVD0_S 3
#define IG3_WRX2_GLPE_WRX_DOMAIN_IDS_RSVD0_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DOMAIN_IDS_RSVD0_S)
#define IG3_WRX2_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_S 0
#define IG3_WRX2_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX2_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_S)
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_COUNT 0x438080B8
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX2_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX2_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_CMD 0x438080CC
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_DATA_H 0x438080D8
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_DATA_L 0x438080D4
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_PTR 0x438080D0
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX2_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_CMD 0x438080BC
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_DATA_H 0x438080C8
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_DATA_L 0x438080C4
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_PTR 0x438080C0
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX2_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL 0x43808080
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_RSVD1_S 25
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_WRX2_GLPE_WRX_DTM_CONTROL_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_RSVD2_S 17
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX2_GLPE_WRX_DTM_CONTROL_RSVD2_S)
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_RSVD3_S 9
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_WRX2_GLPE_WRX_DTM_CONTROL_RSVD3_S)
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_BYPASS_S 8
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_CONTROL_BYPASS_S)
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_RSVD4_S 1
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_WRX2_GLPE_WRX_DTM_CONTROL_RSVD4_S)
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_WRX2_GLPE_WRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_WRX2_GLPE_WRX_DTM_ECC_COR_ERR 0x438080E8
#define IG3_WRX2_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_WRX2_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX2_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_WRX2_GLPE_WRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_WRX2_GLPE_WRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WRX2_GLPE_WRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_WRX2_GLPE_WRX_DTM_ECC_UNCOR_ERR 0x438080E4
#define IG3_WRX2_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_WRX2_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX2_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_WRX2_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_WRX2_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WRX2_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_WRX2_GLPE_WRX_DTM_GROUP_CFG 0x4380808C
#define IG3_WRX2_GLPE_WRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_WRX2_GLPE_WRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WRX2_GLPE_WRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_WRX2_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX2_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_WRX2_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_WRX2_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX2_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_WRX2_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_WRX2_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX2_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_WRX2_GLPE_WRX_DTM_LOG_CFG 0x43808090
#define IG3_WRX2_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_WRX2_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_WRX2_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_WRX2_GLPE_WRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_WRX2_GLPE_WRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_WRX2_GLPE_WRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_DTM_LOG_CFG_MODE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_WRX2_GLPE_WRX_DTM_LOG_CFG_MODE_S)
#define IG3_WRX2_GLPE_WRX_DTM_LOG_MASK 0x43808098
#define IG3_WRX2_GLPE_WRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_DTM_LOG_MASK_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_LOG_PATTERN 0x43808094
#define IG3_WRX2_GLPE_WRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG 0x43808084
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_STS 0x43808088
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_WRX2_GLPE_WRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX2_GLPE_WRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_WRX2_GLPE_WRX_DTM_TIMESTAMP 0x438080B0
#define IG3_WRX2_GLPE_WRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER 0x438080B4
#define IG3_WRX2_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG 0x438080DC
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS 0x438080E0
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG 0x4380809C
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_WRX2_GLPE_WRX_DTM_TRIG_CFG_MODE_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_COUNT 0x438080A8
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_MASK 0x438080A4
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_PATTERN 0x438080A0
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_TIMESTAMP 0x438080AC
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_WRX2_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHHI 0x43808020
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WRX2_GLPE_WRX_FWQPFLUSHHI_RSVD0_S)
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHHI_QPID_S 6
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX2_GLPE_WRX_FWQPFLUSHHI_QPID_S)
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WRX2_GLPE_WRX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO 0x4380801C
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_BUSY_S 31
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_BUSY_S)
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_RSVD0_S)
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_HOSTID_S)
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_PMF_S 0
#define IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WRX2_GLPE_WRX_FWQPFLUSHLO_PMF_S)
#define IG3_WRX2_GLPE_WRX_RQ_CACHE_CTRL 0x43808004
#define IG3_WRX2_GLPE_WRX_RQ_CACHE_CTRL_RSVD_S 7
#define IG3_WRX2_GLPE_WRX_RQ_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x1FFFFFF, IG3_WRX2_GLPE_WRX_RQ_CACHE_CTRL_RSVD_S)
#define IG3_WRX2_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_S 0
#define IG3_WRX2_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_M RDMA_MASK3(32, 0x7F, IG3_WRX2_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_S)
#define IG3_WRX2_GLPE_WRX_RQ_CACHE_DATA0 0x43808008
#define IG3_WRX2_GLPE_WRX_RQ_CACHE_DATA0_DATA_S 0
#define IG3_WRX2_GLPE_WRX_RQ_CACHE_DATA0_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_RQ_CACHE_DATA0_DATA_S)
#define IG3_WRX2_GLPE_WRX_RQ_CACHE_DATA1 0x4380800C
#define IG3_WRX2_GLPE_WRX_RQ_CACHE_DATA1_DATA_S 0
#define IG3_WRX2_GLPE_WRX_RQ_CACHE_DATA1_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_RQ_CACHE_DATA1_DATA_S)
#define IG3_WRX2_GLPE_WRX_RQ_CACHE_DATA2 0x43808010
#define IG3_WRX2_GLPE_WRX_RQ_CACHE_DATA2_DATA_S 0
#define IG3_WRX2_GLPE_WRX_RQ_CACHE_DATA2_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX2_GLPE_WRX_RQ_CACHE_DATA2_DATA_S)
#define IG3_SQC2_GLPE_SQC_CONFIG 0x43808470
#define IG3_SQC2_GLPE_SQC_CONFIG_RSVD_S 6
#define IG3_SQC2_GLPE_SQC_CONFIG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_SQC2_GLPE_SQC_CONFIG_RSVD_S)
#define IG3_SQC2_GLPE_SQC_CONFIG_DBL_INDV_DIS_S 3
#define IG3_SQC2_GLPE_SQC_CONFIG_DBL_INDV_DIS_M RDMA_MASK3(32, 0x7, IG3_SQC2_GLPE_SQC_CONFIG_DBL_INDV_DIS_S)
#define IG3_SQC2_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_S 2
#define IG3_SQC2_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_S)
#define IG3_SQC2_GLPE_SQC_CONFIG_DBL_DIS_S 1
#define IG3_SQC2_GLPE_SQC_CONFIG_DBL_DIS_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_CONFIG_DBL_DIS_S)
#define IG3_SQC2_GLPE_SQC_CONFIG_COALESCE_DIS_S 0
#define IG3_SQC2_GLPE_SQC_CONFIG_COALESCE_DIS_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_CONFIG_COALESCE_DIS_S)
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_COUNT 0x438084B8
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC2_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC2_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_CMD 0x438084CC
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_DATA_H 0x438084D8
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_DATA_L 0x438084D4
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_PTR 0x438084D0
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC2_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_CMD 0x438084BC
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_DATA_H 0x438084C8
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_DATA_L 0x438084C4
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_PTR 0x438084C0
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC2_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL 0x43808480
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_RSVD1_S 25
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SQC2_GLPE_SQC_DTM_CONTROL_RSVD1_S)
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_RSVD2_S 17
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC2_GLPE_SQC_DTM_CONTROL_RSVD2_S)
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_RSVD3_S 9
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SQC2_GLPE_SQC_DTM_CONTROL_RSVD3_S)
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_BYPASS_S 8
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_CONTROL_BYPASS_S)
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_RSVD4_S 1
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SQC2_GLPE_SQC_DTM_CONTROL_RSVD4_S)
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SQC2_GLPE_SQC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SQC2_GLPE_SQC_DTM_ECC_COR_ERR 0x438084E8
#define IG3_SQC2_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SQC2_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC2_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SQC2_GLPE_SQC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SQC2_GLPE_SQC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC2_GLPE_SQC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SQC2_GLPE_SQC_DTM_ECC_UNCOR_ERR 0x438084E4
#define IG3_SQC2_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SQC2_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC2_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SQC2_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SQC2_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC2_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SQC2_GLPE_SQC_DTM_GROUP_CFG 0x4380848C
#define IG3_SQC2_GLPE_SQC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SQC2_GLPE_SQC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SQC2_GLPE_SQC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SQC2_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SQC2_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC2_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SQC2_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SQC2_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC2_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SQC2_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SQC2_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC2_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SQC2_GLPE_SQC_DTM_LOG_CFG 0x43808490
#define IG3_SQC2_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SQC2_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SQC2_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SQC2_GLPE_SQC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SQC2_GLPE_SQC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SQC2_GLPE_SQC_DTM_LOG_CFG_RSVD1_S)
#define IG3_SQC2_GLPE_SQC_DTM_LOG_CFG_MODE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SQC2_GLPE_SQC_DTM_LOG_CFG_MODE_S)
#define IG3_SQC2_GLPE_SQC_DTM_LOG_MASK 0x43808498
#define IG3_SQC2_GLPE_SQC_DTM_LOG_MASK_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC2_GLPE_SQC_DTM_LOG_MASK_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_LOG_PATTERN 0x43808494
#define IG3_SQC2_GLPE_SQC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC2_GLPE_SQC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG 0x43808484
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_STS 0x43808488
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SQC2_GLPE_SQC_DTM_MAIN_STS_RSVD1_S)
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC2_GLPE_SQC_DTM_MAIN_STS_RSVD2_S)
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SQC2_GLPE_SQC_DTM_TIMESTAMP 0x438084B0
#define IG3_SQC2_GLPE_SQC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC2_GLPE_SQC_DTM_TIMESTAMP_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER 0x438084B4
#define IG3_SQC2_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC2_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG 0x438084DC
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS 0x438084E0
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG 0x4380849C
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_MODE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SQC2_GLPE_SQC_DTM_TRIG_CFG_MODE_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_COUNT 0x438084A8
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC2_GLPE_SQC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_MASK 0x438084A4
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC2_GLPE_SQC_DTM_TRIG_MASK_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_PATTERN 0x438084A0
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC2_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_TIMESTAMP 0x438084AC
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SQC2_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC2_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHHI 0x43808460
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_S 26
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_S)
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHHI_QPID_S 6
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHHI_QPID_S)
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_S 0
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_S)
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO 0x43808464
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_S 31
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_S)
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_S 30
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_S)
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_S 29
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_S)
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_S 26
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_S)
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_S)
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_PMF_S 0
#define IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC2_GLPE_SQC_FWFLRQPFLUSHLO_PMF_S)
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPHI(_i) 0x43808420 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPHI_MAX_INDEX_I 7
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPHI_RSVD0_S 26
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_SQC2_GLPE_SQC_FWFLUSHDROPHI_RSVD0_S)
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPHI_QPID_S 6
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC2_GLPE_SQC_FWFLUSHDROPHI_QPID_S)
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_S 0
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_SQC2_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_S)
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO(_i) 0x43808400 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_MAX_INDEX_I 7
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_EN_S 31
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_EN_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_EN_S)
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_RSVD0_S 29
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_RSVD0_S)
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_HOSTID_S 26
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_HOSTID_S)
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_S 24
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_S)
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_S 12
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_S)
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_PMF_S 0
#define IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC2_GLPE_SQC_FWFLUSHDROPLO_PMF_S)
#define IG3_SQC2_GLPE_SQC_FWSYNCRESP(_i) 0x43808468 + ((_i) * 4) /* _i=0...1 */
#define IG3_SQC2_GLPE_SQC_FWSYNCRESP_MAX_INDEX_I 1
#define IG3_SQC2_GLPE_SQC_FWSYNCRESP_RSVD_S 18
#define IG3_SQC2_GLPE_SQC_FWSYNCRESP_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_SQC2_GLPE_SQC_FWSYNCRESP_RSVD_S)
#define IG3_SQC2_GLPE_SQC_FWSYNCRESP_COUNT_S 8
#define IG3_SQC2_GLPE_SQC_FWSYNCRESP_COUNT_M RDMA_MASK3(32, 0x3FF, IG3_SQC2_GLPE_SQC_FWSYNCRESP_COUNT_S)
#define IG3_SQC2_GLPE_SQC_FWSYNCRESP_TAG_S 0
#define IG3_SQC2_GLPE_SQC_FWSYNCRESP_TAG_M RDMA_MASK3(32, 0xFF, IG3_SQC2_GLPE_SQC_FWSYNCRESP_TAG_S)
#define IG3_SQC2_GLPE_SQC_XLR_DROP(_i) 0x43808440 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC2_GLPE_SQC_XLR_DROP_MAX_INDEX_I 7
#define IG3_SQC2_GLPE_SQC_XLR_DROP_EN_S 31
#define IG3_SQC2_GLPE_SQC_XLR_DROP_EN_M RDMA_BIT2(32, IG3_SQC2_GLPE_SQC_XLR_DROP_EN_S)
#define IG3_SQC2_GLPE_SQC_XLR_DROP_RSVD0_S 12
#define IG3_SQC2_GLPE_SQC_XLR_DROP_RSVD0_M RDMA_MASK3(32, 0x7FFFF, IG3_SQC2_GLPE_SQC_XLR_DROP_RSVD0_S)
#define IG3_SQC2_GLPE_SQC_XLR_DROP_PMF_S 0
#define IG3_SQC2_GLPE_SQC_XLR_DROP_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC2_GLPE_SQC_XLR_DROP_PMF_S)
#define IG3_SQC2_SQC_ECC_COR_ERR 0x43808514
#define IG3_SQC2_SQC_ECC_COR_ERR_RSVD_S 12
#define IG3_SQC2_SQC_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC2_SQC_ECC_COR_ERR_RSVD_S)
#define IG3_SQC2_SQC_ECC_COR_ERR_CNT_S 0
#define IG3_SQC2_SQC_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC2_SQC_ECC_COR_ERR_CNT_S)
#define IG3_SQC2_SQC_ECC_UNCOR_ERR 0x43808510
#define IG3_SQC2_SQC_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SQC2_SQC_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC2_SQC_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SQC2_SQC_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SQC2_SQC_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC2_SQC_ECC_UNCOR_ERR_CNT_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG 0x43808500
#define IG3_SQC2_SQC_WRK_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_SQC2_SQC_WRK_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC2_SQC_WRK_RAM_CFG_ECC_INST_NUM_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_RSVD3_S 20
#define IG3_SQC2_SQC_WRK_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC2_SQC_WRK_RAM_CFG_RSVD3_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_RM_S 16
#define IG3_SQC2_SQC_WRK_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC2_SQC_WRK_RAM_CFG_RM_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_RSVD2_S 14
#define IG3_SQC2_SQC_WRK_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC2_SQC_WRK_RAM_CFG_RSVD2_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_SQC2_SQC_WRK_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC2_SQC_WRK_RAM_CFG_POWER_GATE_EN_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_RME_S 12
#define IG3_SQC2_SQC_WRK_RAM_CFG_RME_M RDMA_BIT2(32, IG3_SQC2_SQC_WRK_RAM_CFG_RME_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_RSVD1_S 10
#define IG3_SQC2_SQC_WRK_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC2_SQC_WRK_RAM_CFG_RSVD1_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_ERR_CNT_S 9
#define IG3_SQC2_SQC_WRK_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC2_SQC_WRK_RAM_CFG_ERR_CNT_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_FIX_CNT_S 8
#define IG3_SQC2_SQC_WRK_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC2_SQC_WRK_RAM_CFG_FIX_CNT_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_RSVD0_S 6
#define IG3_SQC2_SQC_WRK_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC2_SQC_WRK_RAM_CFG_RSVD0_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_MASK_INT_S 5
#define IG3_SQC2_SQC_WRK_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC2_SQC_WRK_RAM_CFG_MASK_INT_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_LS_BYPASS_S 4
#define IG3_SQC2_SQC_WRK_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC2_SQC_WRK_RAM_CFG_LS_BYPASS_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_LS_FORCE_S 3
#define IG3_SQC2_SQC_WRK_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC2_SQC_WRK_RAM_CFG_LS_FORCE_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_SQC2_SQC_WRK_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC2_SQC_WRK_RAM_CFG_ECC_INVERT_2_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_SQC2_SQC_WRK_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC2_SQC_WRK_RAM_CFG_ECC_INVERT_1_S)
#define IG3_SQC2_SQC_WRK_RAM_CFG_ECC_EN_S 0
#define IG3_SQC2_SQC_WRK_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC2_SQC_WRK_RAM_CFG_ECC_EN_S)
#define IG3_SQC2_SQC_WRK_RAM_STATUS 0x43808504
#define IG3_SQC2_SQC_WRK_RAM_STATUS_RSVD1_S 30
#define IG3_SQC2_SQC_WRK_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC2_SQC_WRK_RAM_STATUS_RSVD1_S)
#define IG3_SQC2_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC2_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC2_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC2_SQC_WRK_RAM_STATUS_RSVD0_S 4
#define IG3_SQC2_SQC_WRK_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC2_SQC_WRK_RAM_STATUS_RSVD0_S)
#define IG3_SQC2_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC2_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC2_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC2_SQC_WRK_RAM_STATUS_INIT_DONE_S 2
#define IG3_SQC2_SQC_WRK_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC2_SQC_WRK_RAM_STATUS_INIT_DONE_S)
#define IG3_SQC2_SQC_WRK_RAM_STATUS_ECC_FIX_S 1
#define IG3_SQC2_SQC_WRK_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC2_SQC_WRK_RAM_STATUS_ECC_FIX_S)
#define IG3_SQC2_SQC_WRK_RAM_STATUS_ECC_ERR_S 0
#define IG3_SQC2_SQC_WRK_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC2_SQC_WRK_RAM_STATUS_ECC_ERR_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG 0x43808508
#define IG3_SQC2_SQC_XBUF_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_SQC2_SQC_XBUF_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC2_SQC_XBUF_RAM_CFG_ECC_INST_NUM_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_RSVD3_S 20
#define IG3_SQC2_SQC_XBUF_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC2_SQC_XBUF_RAM_CFG_RSVD3_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_RM_S 16
#define IG3_SQC2_SQC_XBUF_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC2_SQC_XBUF_RAM_CFG_RM_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_RSVD2_S 14
#define IG3_SQC2_SQC_XBUF_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC2_SQC_XBUF_RAM_CFG_RSVD2_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_SQC2_SQC_XBUF_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC2_SQC_XBUF_RAM_CFG_POWER_GATE_EN_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_RME_S 12
#define IG3_SQC2_SQC_XBUF_RAM_CFG_RME_M RDMA_BIT2(32, IG3_SQC2_SQC_XBUF_RAM_CFG_RME_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_RSVD1_S 10
#define IG3_SQC2_SQC_XBUF_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC2_SQC_XBUF_RAM_CFG_RSVD1_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_ERR_CNT_S 9
#define IG3_SQC2_SQC_XBUF_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC2_SQC_XBUF_RAM_CFG_ERR_CNT_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_FIX_CNT_S 8
#define IG3_SQC2_SQC_XBUF_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC2_SQC_XBUF_RAM_CFG_FIX_CNT_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_RSVD0_S 6
#define IG3_SQC2_SQC_XBUF_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC2_SQC_XBUF_RAM_CFG_RSVD0_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_MASK_INT_S 5
#define IG3_SQC2_SQC_XBUF_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC2_SQC_XBUF_RAM_CFG_MASK_INT_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_LS_BYPASS_S 4
#define IG3_SQC2_SQC_XBUF_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC2_SQC_XBUF_RAM_CFG_LS_BYPASS_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_LS_FORCE_S 3
#define IG3_SQC2_SQC_XBUF_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC2_SQC_XBUF_RAM_CFG_LS_FORCE_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_SQC2_SQC_XBUF_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC2_SQC_XBUF_RAM_CFG_ECC_INVERT_2_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_SQC2_SQC_XBUF_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC2_SQC_XBUF_RAM_CFG_ECC_INVERT_1_S)
#define IG3_SQC2_SQC_XBUF_RAM_CFG_ECC_EN_S 0
#define IG3_SQC2_SQC_XBUF_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC2_SQC_XBUF_RAM_CFG_ECC_EN_S)
#define IG3_SQC2_SQC_XBUF_RAM_STATUS 0x4380850C
#define IG3_SQC2_SQC_XBUF_RAM_STATUS_RSVD1_S 30
#define IG3_SQC2_SQC_XBUF_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC2_SQC_XBUF_RAM_STATUS_RSVD1_S)
#define IG3_SQC2_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC2_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC2_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC2_SQC_XBUF_RAM_STATUS_RSVD0_S 4
#define IG3_SQC2_SQC_XBUF_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC2_SQC_XBUF_RAM_STATUS_RSVD0_S)
#define IG3_SQC2_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC2_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC2_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC2_SQC_XBUF_RAM_STATUS_INIT_DONE_S 2
#define IG3_SQC2_SQC_XBUF_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC2_SQC_XBUF_RAM_STATUS_INIT_DONE_S)
#define IG3_SQC2_SQC_XBUF_RAM_STATUS_ECC_FIX_S 1
#define IG3_SQC2_SQC_XBUF_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC2_SQC_XBUF_RAM_STATUS_ECC_FIX_S)
#define IG3_SQC2_SQC_XBUF_RAM_STATUS_ECC_ERR_S 0
#define IG3_SQC2_SQC_XBUF_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC2_SQC_XBUF_RAM_STATUS_ECC_ERR_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DOMAIN_ID 0x43808804
#define IG3_SFPRX2_GLPE_SFP_RX_DOMAIN_ID_RSVD_S 3
#define IG3_SFPRX2_GLPE_SFP_RX_DOMAIN_ID_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DOMAIN_ID_RSVD_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_SFPRX2_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_COUNT 0x438088B8
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_CMD 0x438088CC
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H 0x438088D8
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L 0x438088D4
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_PTR 0x438088D0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_CMD 0x438088BC
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H 0x438088C8
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L 0x438088C4
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_PTR 0x438088C0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL 0x43808880
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_RSVD1_S 25
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_RSVD1_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_RSVD2_S 17
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_RSVD2_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_RSVD3_S 9
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_RSVD3_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_BYPASS_S 8
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_BYPASS_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_RSVD4_S 1
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_RSVD4_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_ECC_COR_ERR 0x438088E8
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR 0x438088E4
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_GROUP_CFG 0x4380888C
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_CFG 0x43808890
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_CFG_MODE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_CFG_MODE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_MASK 0x43808898
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_PATTERN 0x43808894
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG 0x43808884
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_STS 0x43808888
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TIMESTAMP 0x438088B0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER 0x438088B4
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG 0x438088DC
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS 0x438088E0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG 0x4380889C
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_COUNT 0x438088A8
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_MASK 0x438088A4
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_PATTERN 0x438088A0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP 0x438088AC
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SFPRX2_GLPE_SFP_RX_ERR_TBL_CLR 0x43808800
#define IG3_SFPRX2_GLPE_SFP_RX_ERR_TBL_CLR_REQ_S 31
#define IG3_SFPRX2_GLPE_SFP_RX_ERR_TBL_CLR_REQ_M RDMA_BIT2(32, IG3_SFPRX2_GLPE_SFP_RX_ERR_TBL_CLR_REQ_S)
#define IG3_SFPRX2_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_S 12
#define IG3_SFPRX2_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_SFPRX2_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_S)
#define IG3_SFPRX2_GLPE_SFP_RX_ERR_TBL_CLR_PMF_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_ERR_TBL_CLR_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX2_GLPE_SFP_RX_ERR_TBL_CLR_PMF_S)
#define IG3_SFPRX2_GLPE_SFP_RX_PER_MEM 0x43808808
#define IG3_SFPRX2_GLPE_SFP_RX_PER_MEM_RSVD_S 3
#define IG3_SFPRX2_GLPE_SFP_RX_PER_MEM_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPRX2_GLPE_SFP_RX_PER_MEM_RSVD_S)
#define IG3_SFPRX2_GLPE_SFP_RX_PER_MEM_PER_TYPE_S 0
#define IG3_SFPRX2_GLPE_SFP_RX_PER_MEM_PER_TYPE_M RDMA_MASK3(32, 0x7, IG3_SFPRX2_GLPE_SFP_RX_PER_MEM_PER_TYPE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG 0x43808C08
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS 0x43808C0C
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ECC_COR_ERR 0x43808C34
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR 0x43808C30
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG 0x43808C18
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS 0x43808C1C
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG 0x43808C20
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS 0x43808C24
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG 0x43808C00
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS 0x43808C04
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG 0x43808C28
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS 0x43808C2C
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG 0x43808C10
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS 0x43808C14
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG 0x43808C48
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS 0x43808C4C
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG 0x43808C40
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS 0x43808C44
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG 0x43808C78
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS 0x43808C7C
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG 0x43808C50
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS 0x43808C54
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG 0x43808C58
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS 0x43808C5C
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR 0x43808C84
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR 0x43808C80
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG 0x43808C70
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS 0x43808C74
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG 0x43808C60
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS 0x43808C64
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG 0x43808C68
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS 0x43808C6C
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG 0x43808C38
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS 0x43808C3C
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_ECC_COR_ERR 0x43808CCC
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR 0x43808CC8
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG 0x43808CD8
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS 0x43808CDC
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL 0x43808C90
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_S 31
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_S 26
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_S 18
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA 0x43808C94
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG 0x43808C88
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS 0x43808C8C
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL 0x43808CA0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_S 31
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_S 26
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA 0x43808CA4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG 0x43808C98
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS 0x43808C9C
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL 0x43808CB0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_S 31
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_S 26
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_S 18
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA 0x43808CB4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG 0x43808CA8
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS 0x43808CAC
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL 0x43808CC0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_S 31
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_S 26
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_S 18
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA 0x43808CC4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG 0x43808CB8
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS 0x43808CBC
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG 0x43808CD0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS 0x43808CD4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_WTX2_GLPE_WTX_1USCOUNT 0x43810010
#define IG3_WTX2_GLPE_WTX_1USCOUNT_CNT_S 0
#define IG3_WTX2_GLPE_WTX_1USCOUNT_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_1USCOUNT_CNT_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0 0x43810120
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_TAG_S 16
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_TAG_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_MODE_S 11
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_MODE_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1 0x43810124
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_PMF_S 0
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG1_PMF_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG2 0x43810128
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG2_QPID_S 6
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG2_QPID_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG3 0x4381012C
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG4 0x43810130
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_S 0
#define IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_S)
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG 0x43810020
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG_RSVD3_S 24
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG_RSVD3_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_ARB_CONFIG_RSVD3_S)
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG_RSVD2_S 20
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WTX2_GLPE_WTX_ARB_CONFIG_RSVD2_S)
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_S 16
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX2_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_S)
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG_RSVD1_S 12
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_WTX2_GLPE_WTX_ARB_CONFIG_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_S 8
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX2_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_S)
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG_RSVD0_S 4
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG_RSVD0_M RDMA_MASK3(32, 0xF, IG3_WTX2_GLPE_WTX_ARB_CONFIG_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_S 0
#define IG3_WTX2_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX2_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0 0x438100F8
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_TAG_S 16
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_TAG_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_MODE_S 11
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_MODE_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1 0x438100FC
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_PMF_S 0
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG1_PMF_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG2 0x43810100
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG2_QPID_S 6
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG2_QPID_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG3 0x43810104
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG4 0x43810108
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG4_COUNT_S 0
#define IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_CMP_DTM_TRIG4_COUNT_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG 0x4381017C
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_S 31
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_S 27
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_S 26
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX 0x43810180
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_CNPCOUNT 0x43810014
#define IG3_WTX2_GLPE_WTX_CNPCOUNT_CNT_S 0
#define IG3_WTX2_GLPE_WTX_CNPCOUNT_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_CNPCOUNT_CNT_S)
#define IG3_WTX2_GLPE_WTX_CONFIG 0x4381000C
#define IG3_WTX2_GLPE_WTX_CONFIG_RSVD1_S 28
#define IG3_WTX2_GLPE_WTX_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_WTX2_GLPE_WTX_CONFIG_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_CONFIG_SQ_HSM_ORD_S 25
#define IG3_WTX2_GLPE_WTX_CONFIG_SQ_HSM_ORD_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_CONFIG_SQ_HSM_ORD_S)
#define IG3_WTX2_GLPE_WTX_CONFIG_SQ_WQE_ORD_S 22
#define IG3_WTX2_GLPE_WTX_CONFIG_SQ_WQE_ORD_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_CONFIG_SQ_WQE_ORD_S)
#define IG3_WTX2_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_S 21
#define IG3_WTX2_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_S)
#define IG3_WTX2_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_S 20
#define IG3_WTX2_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_S)
#define IG3_WTX2_GLPE_WTX_CONFIG_RSVD0_S 4
#define IG3_WTX2_GLPE_WTX_CONFIG_RSVD0_M RDMA_MASK3(32, 0xFFFF, IG3_WTX2_GLPE_WTX_CONFIG_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_S 3
#define IG3_WTX2_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_S)
#define IG3_WTX2_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_S 2
#define IG3_WTX2_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_S)
#define IG3_WTX2_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_S 1
#define IG3_WTX2_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_S)
#define IG3_WTX2_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_S 0
#define IG3_WTX2_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG0 0x4381003C
#define IG3_WTX2_GLPE_WTX_CTCONFIG0_RSVD_S 21
#define IG3_WTX2_GLPE_WTX_CTCONFIG0_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_WTX2_GLPE_WTX_CTCONFIG0_RSVD_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG0_SCHED_S 0
#define IG3_WTX2_GLPE_WTX_CTCONFIG0_SCHED_M RDMA_MASK3(32, 0x1FFFFF, IG3_WTX2_GLPE_WTX_CTCONFIG0_SCHED_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG1 0x43810040
#define IG3_WTX2_GLPE_WTX_CTCONFIG1_RSVD_S 21
#define IG3_WTX2_GLPE_WTX_CTCONFIG1_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_WTX2_GLPE_WTX_CTCONFIG1_RSVD_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG1_VMRL_S 0
#define IG3_WTX2_GLPE_WTX_CTCONFIG1_VMRL_M RDMA_MASK3(32, 0x1FFFFF, IG3_WTX2_GLPE_WTX_CTCONFIG1_VMRL_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG2 0x43810044
#define IG3_WTX2_GLPE_WTX_CTCONFIG2_RSVD_S 30
#define IG3_WTX2_GLPE_WTX_CTCONFIG2_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_CTCONFIG2_RSVD_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_S 16
#define IG3_WTX2_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_S 0
#define IG3_WTX2_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX2_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG3 0x43810048
#define IG3_WTX2_GLPE_WTX_CTCONFIG3_RSVD_S 30
#define IG3_WTX2_GLPE_WTX_CTCONFIG3_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_CTCONFIG3_RSVD_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_S 16
#define IG3_WTX2_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_S 0
#define IG3_WTX2_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX2_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG4 0x4381004C
#define IG3_WTX2_GLPE_WTX_CTCONFIG4_RSVD_S 30
#define IG3_WTX2_GLPE_WTX_CTCONFIG4_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_CTCONFIG4_RSVD_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_S 16
#define IG3_WTX2_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_S 0
#define IG3_WTX2_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX2_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG5 0x43810050
#define IG3_WTX2_GLPE_WTX_CTCONFIG5_RSVD_S 20
#define IG3_WTX2_GLPE_WTX_CTCONFIG5_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_CTCONFIG5_RSVD_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG5_BMPKT_S 0
#define IG3_WTX2_GLPE_WTX_CTCONFIG5_BMPKT_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX2_GLPE_WTX_CTCONFIG5_BMPKT_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG6 0x43810054
#define IG3_WTX2_GLPE_WTX_CTCONFIG6_RSVD_S 13
#define IG3_WTX2_GLPE_WTX_CTCONFIG6_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_WTX2_GLPE_WTX_CTCONFIG6_RSVD_S)
#define IG3_WTX2_GLPE_WTX_CTCONFIG6_BMHDR_S 0
#define IG3_WTX2_GLPE_WTX_CTCONFIG6_BMHDR_M RDMA_MASK3(32, 0x1FFF, IG3_WTX2_GLPE_WTX_CTCONFIG6_BMHDR_S)
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_COUNT 0x43810238
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX2_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_CMD 0x4381024C
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_DATA_H 0x43810258
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_DATA_L 0x43810254
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_PTR 0x43810250
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX2_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_CMD 0x4381023C
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_DATA_H 0x43810248
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_DATA_L 0x43810244
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_PTR 0x43810240
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX2_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL 0x43810200
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_RSVD1_S 25
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_WTX2_GLPE_WTX_DTM_CONTROL_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_RSVD2_S 17
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX2_GLPE_WTX_DTM_CONTROL_RSVD2_S)
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_RSVD3_S 9
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_WTX2_GLPE_WTX_DTM_CONTROL_RSVD3_S)
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_BYPASS_S 8
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_CONTROL_BYPASS_S)
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_RSVD4_S 1
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_WTX2_GLPE_WTX_DTM_CONTROL_RSVD4_S)
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_WTX2_GLPE_WTX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_WTX2_GLPE_WTX_DTM_ECC_COR_ERR 0x43810268
#define IG3_WTX2_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX2_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_WTX2_GLPE_WTX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_WTX2_GLPE_WTX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_WTX2_GLPE_WTX_DTM_ECC_UNCOR_ERR 0x43810264
#define IG3_WTX2_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX2_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_WTX2_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_WTX2_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_WTX2_GLPE_WTX_DTM_GROUP_CFG 0x4381020C
#define IG3_WTX2_GLPE_WTX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_WTX2_GLPE_WTX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_WTX2_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_WTX2_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_WTX2_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_WTX2_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_WTX2_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_WTX2_GLPE_WTX_DTM_LOG_CFG 0x43810210
#define IG3_WTX2_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_WTX2_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_WTX2_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_WTX2_GLPE_WTX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_WTX2_GLPE_WTX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_DTM_LOG_CFG_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_DTM_LOG_CFG_MODE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_DTM_LOG_CFG_MODE_S)
#define IG3_WTX2_GLPE_WTX_DTM_LOG_MASK 0x43810218
#define IG3_WTX2_GLPE_WTX_DTM_LOG_MASK_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_DTM_LOG_MASK_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_LOG_PATTERN 0x43810214
#define IG3_WTX2_GLPE_WTX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG 0x43810204
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_STS 0x43810208
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_WTX2_GLPE_WTX_DTM_MAIN_STS_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX2_GLPE_WTX_DTM_MAIN_STS_RSVD2_S)
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_WTX2_GLPE_WTX_DTM_TIMESTAMP 0x43810230
#define IG3_WTX2_GLPE_WTX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_DTM_TIMESTAMP_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER 0x43810234
#define IG3_WTX2_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG 0x4381025C
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS 0x43810260
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG 0x4381021C
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_MODE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_WTX2_GLPE_WTX_DTM_TRIG_CFG_MODE_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_COUNT 0x43810228
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_MASK 0x43810224
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_DTM_TRIG_MASK_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_PATTERN 0x43810220
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_TIMESTAMP 0x4381022C
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_WTX2_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG 0x4381014C
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_S 29
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_S 13
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_S 0
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG 0x43810150
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_S 31
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_S 27
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_S 26
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX 0x43810154
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHHI 0x4381005C
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WTX2_GLPE_WTX_FWQPFLUSHHI_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHHI_QPID_S 6
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX2_GLPE_WTX_FWQPFLUSHHI_QPID_S)
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX2_GLPE_WTX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO 0x43810058
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_BUSY_S 31
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_BUSY_S)
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_HOSTID_S)
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_PMF_S 0
#define IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_FWQPFLUSHLO_PMF_S)
#define IG3_WTX2_GLPE_WTX_HOST_READ_CONFIG 0x43810038
#define IG3_WTX2_GLPE_WTX_HOST_READ_CONFIG_RSVD_S 8
#define IG3_WTX2_GLPE_WTX_HOST_READ_CONFIG_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX2_GLPE_WTX_HOST_READ_CONFIG_RSVD_S)
#define IG3_WTX2_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_S 0
#define IG3_WTX2_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0 0x4381010C
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_S 16
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_S 11
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1 0x43810110
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_S 0
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG2 0x43810114
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_S 6
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG3 0x43810118
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG4 0x4381011C
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_S 0
#define IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG 0x4381018C
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_S 31
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_S 27
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_S 26
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX 0x43810190
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG 0x43810194
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_S 31
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_S 27
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_S 26
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX 0x43810198
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG 0x43810184
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_S 31
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_S 27
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_S 26
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX 0x43810188
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0 0x43810090
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1 0x43810094
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG2 0x43810098
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG3 0x4381009C
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG4 0x438100A0
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0 0x43810060
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1 0x43810064
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG2 0x43810068
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG3 0x4381006C
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG4 0x43810070
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG5 0x43810074
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0 0x43810078
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1 0x4381007C
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG2 0x43810080
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG3 0x43810084
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG4 0x43810088
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG5 0x4381008C
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG 0x43810134
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_S 29
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_S 13
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_S 0
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG 0x43810138
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_S 31
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_S 27
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_S 26
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX 0x4381013C
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG 0x43810140
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_S 29
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_S 13
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_S 0
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG 0x43810144
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_S 31
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_S 27
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_S 26
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX 0x43810148
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG 0x43810164
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_S 29
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_S 13
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_S 0
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG 0x43810168
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_S 31
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_S 27
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_S 26
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX 0x4381016C
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG 0x43810158
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_S 29
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_S 13
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_S 0
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG 0x4381015C
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_S 31
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_S 27
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_S 26
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX 0x43810160
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0 0x438100E4
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_S 16
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_S 11
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1 0x438100E8
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_S 0
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG2 0x438100EC
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_S 6
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG3 0x438100F0
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG4 0x438100F4
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_S 0
#define IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0 0x438100D0
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_S 16
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_S 11
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1 0x438100D4
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_S 0
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG2 0x438100D8
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_S 6
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG3 0x438100DC
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG4 0x438100E0
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_S 0
#define IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_S)
#define IG3_WTX2_GLPE_WTX_SPADS_ASSIGNED(_i) 0x43810000 + ((_i) * 4) /* _i=0...2 */
#define IG3_WTX2_GLPE_WTX_SPADS_ASSIGNED_MAX_INDEX_I 2
#define IG3_WTX2_GLPE_WTX_SPADS_ASSIGNED_SPAD3_S 24
#define IG3_WTX2_GLPE_WTX_SPADS_ASSIGNED_SPAD3_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPADS_ASSIGNED_SPAD3_S)
#define IG3_WTX2_GLPE_WTX_SPADS_ASSIGNED_SPAD2_S 16
#define IG3_WTX2_GLPE_WTX_SPADS_ASSIGNED_SPAD2_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPADS_ASSIGNED_SPAD2_S)
#define IG3_WTX2_GLPE_WTX_SPADS_ASSIGNED_SPAD1_S 8
#define IG3_WTX2_GLPE_WTX_SPADS_ASSIGNED_SPAD1_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPADS_ASSIGNED_SPAD1_S)
#define IG3_WTX2_GLPE_WTX_SPADS_ASSIGNED_SPAD0_S 0
#define IG3_WTX2_GLPE_WTX_SPADS_ASSIGNED_SPAD0_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPADS_ASSIGNED_SPAD0_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0 0x438100A4
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_S 16
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_S 11
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1 0x438100A8
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG2 0x438100AC
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_S 6
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG3 0x438100B0
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG4 0x438100B4
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG5 0x438100B8
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX2_GLPE_WTX_SPAD_CONFIG0 0x43810024
#define IG3_WTX2_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_S 24
#define IG3_WTX2_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_S)
#define IG3_WTX2_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_S 16
#define IG3_WTX2_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_S)
#define IG3_WTX2_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_S 8
#define IG3_WTX2_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_S)
#define IG3_WTX2_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_S)
#define IG3_WTX2_GLPE_WTX_SPAD_CONFIG1 0x43810028
#define IG3_WTX2_GLPE_WTX_SPAD_CONFIG1_RSVD_S 8
#define IG3_WTX2_GLPE_WTX_SPAD_CONFIG1_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX2_GLPE_WTX_SPAD_CONFIG1_RSVD_S)
#define IG3_WTX2_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_S)
#define IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS0 0x4381002C
#define IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_S 24
#define IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_S)
#define IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_S 16
#define IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_S)
#define IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_S 8
#define IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_S)
#define IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_S)
#define IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS1 0x43810030
#define IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_S 8
#define IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_S)
#define IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0 0x438100BC
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_S 16
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_S 11
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1 0x438100C0
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG2 0x438100C4
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_S 6
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG3 0x438100C8
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG4 0x438100CC
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_S)
#define IG3_WTX2_GLPE_WTX_SPAD_QUEUE_PTR_CTL 0x43810034
#define IG3_WTX2_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_S 16
#define IG3_WTX2_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_WTX2_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_S)
#define IG3_WTX2_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_S 8
#define IG3_WTX2_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_S)
#define IG3_WTX2_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_S)
#define IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL 0x43810018
#define IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_RSVD1_S 20
#define IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_S 16
#define IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_M RDMA_MASK3(32, 0xF, IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_S)
#define IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_RSVD0_S 10
#define IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_S 8
#define IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_M RDMA_MASK3(32, 0x3, IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_S)
#define IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_M RDMA_MASK3(32, 0xFF, IG3_WTX2_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_S)
#define IG3_WTX2_GLPE_WTX_SPAD_STAT_DATA 0x4381001C
#define IG3_WTX2_GLPE_WTX_SPAD_STAT_DATA_DATA_S 0
#define IG3_WTX2_GLPE_WTX_SPAD_STAT_DATA_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX2_GLPE_WTX_SPAD_STAT_DATA_DATA_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG 0x43810170
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_S 29
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_S 13
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_S 0
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG 0x43810174
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_S 31
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_S 27
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_S 26
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX 0x43810178
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX2_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_PTX2_GLPE_ARPCONTROL 0x4381400C
#define IG3_PTX2_GLPE_ARPCONTROL_ARP_LOCK_ACK_S 31
#define IG3_PTX2_GLPE_ARPCONTROL_ARP_LOCK_ACK_M RDMA_BIT2(32, IG3_PTX2_GLPE_ARPCONTROL_ARP_LOCK_ACK_S)
#define IG3_PTX2_GLPE_ARPCONTROL_ARP_LOCK_REQ_S 30
#define IG3_PTX2_GLPE_ARPCONTROL_ARP_LOCK_REQ_M RDMA_BIT2(32, IG3_PTX2_GLPE_ARPCONTROL_ARP_LOCK_REQ_S)
#define IG3_PTX2_GLPE_ARPCONTROL_RSVD_S 16
#define IG3_PTX2_GLPE_ARPCONTROL_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_PTX2_GLPE_ARPCONTROL_RSVD_S)
#define IG3_PTX2_GLPE_ARPCONTROL_ARP_LOCK_INDEX_S 0
#define IG3_PTX2_GLPE_ARPCONTROL_ARP_LOCK_INDEX_M RDMA_MASK3(32, 0xFFFF, IG3_PTX2_GLPE_ARPCONTROL_ARP_LOCK_INDEX_S)
#define IG3_PTX2_GLPE_CRT_CONFIG0 0x43814010
#define IG3_PTX2_GLPE_CRT_CONFIG0_RSVD_S 25
#define IG3_PTX2_GLPE_CRT_CONFIG0_RSVD_M RDMA_MASK3(32, 0x7F, IG3_PTX2_GLPE_CRT_CONFIG0_RSVD_S)
#define IG3_PTX2_GLPE_CRT_CONFIG0_QP_FC_EN_S 24
#define IG3_PTX2_GLPE_CRT_CONFIG0_QP_FC_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_CRT_CONFIG0_QP_FC_EN_S)
#define IG3_PTX2_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_S 16
#define IG3_PTX2_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_S)
#define IG3_PTX2_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_S 8
#define IG3_PTX2_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_S)
#define IG3_PTX2_GLPE_CRT_CONFIG0_TX_BUF_SIZE_S 0
#define IG3_PTX2_GLPE_CRT_CONFIG0_TX_BUF_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_CRT_CONFIG0_TX_BUF_SIZE_S)
#define IG3_PTX2_GLPE_CRT_CONFIG1 0x43814014
#define IG3_PTX2_GLPE_CRT_CONFIG1_RSVD_S 19
#define IG3_PTX2_GLPE_CRT_CONFIG1_RSVD_M RDMA_MASK3(32, 0x1FFF, IG3_PTX2_GLPE_CRT_CONFIG1_RSVD_S)
#define IG3_PTX2_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_S 16
#define IG3_PTX2_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_M RDMA_MASK3(32, 0x7, IG3_PTX2_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_S)
#define IG3_PTX2_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_S 8
#define IG3_PTX2_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_S)
#define IG3_PTX2_GLPE_CRT_CONFIG1_RX_BUF_SIZE_S 0
#define IG3_PTX2_GLPE_CRT_CONFIG1_RX_BUF_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_CRT_CONFIG1_RX_BUF_SIZE_S)
#define IG3_PTX2_GLPE_MAX_INLINE_DATA 0x43814000
#define IG3_PTX2_GLPE_MAX_INLINE_DATA_RSVD_S 8
#define IG3_PTX2_GLPE_MAX_INLINE_DATA_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX2_GLPE_MAX_INLINE_DATA_RSVD_S)
#define IG3_PTX2_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_S 0
#define IG3_PTX2_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_S)
#define IG3_PTX2_GLPE_MAX_TCP_ACKS 0x43814004
#define IG3_PTX2_GLPE_MAX_TCP_ACKS_RSVD_S 8
#define IG3_PTX2_GLPE_MAX_TCP_ACKS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX2_GLPE_MAX_TCP_ACKS_RSVD_S)
#define IG3_PTX2_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_S 0
#define IG3_PTX2_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0 0x43814018
#define IG3_PTX2_GLPE_PTX_CONFIG0_RSVD_31_S 31
#define IG3_PTX2_GLPE_PTX_CONFIG0_RSVD_31_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_RSVD_31_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_S 30
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_S 29
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_S 28
#define IG3_PTX2_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_S 27
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_S 26
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_S 22
#define IG3_PTX2_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_M RDMA_MASK3(32, 0xF, IG3_PTX2_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_S 21
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_S 20
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_RSVD_19_S 19
#define IG3_PTX2_GLPE_PTX_CONFIG0_RSVD_19_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_RSVD_19_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_S 18
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_S 17
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_S 16
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_S 15
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_S 14
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_RSVD_13_7_S 7
#define IG3_PTX2_GLPE_PTX_CONFIG0_RSVD_13_7_M RDMA_MASK3(32, 0x7F, IG3_PTX2_GLPE_PTX_CONFIG0_RSVD_13_7_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_UDP_CS_EN_S 6
#define IG3_PTX2_GLPE_PTX_CONFIG0_UDP_CS_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_UDP_CS_EN_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_Q1_PACING_S 5
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_Q1_PACING_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_DIS_Q1_PACING_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_S 4
#define IG3_PTX2_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_S 3
#define IG3_PTX2_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_S 1
#define IG3_PTX2_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_S)
#define IG3_PTX2_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_S 0
#define IG3_PTX2_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_S)
#define IG3_PTX2_GLPE_PTX_CONFIG1 0x4381401C
#define IG3_PTX2_GLPE_PTX_CONFIG1_RSVD_S 24
#define IG3_PTX2_GLPE_PTX_CONFIG1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_CONFIG1_RSVD_S)
#define IG3_PTX2_GLPE_PTX_CONFIG1_ACKREQ_PACING_S 21
#define IG3_PTX2_GLPE_PTX_CONFIG1_ACKREQ_PACING_M RDMA_MASK3(32, 0x7, IG3_PTX2_GLPE_PTX_CONFIG1_ACKREQ_PACING_S)
#define IG3_PTX2_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_S 16
#define IG3_PTX2_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_M RDMA_MASK3(32, 0x1F, IG3_PTX2_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_S)
#define IG3_PTX2_GLPE_PTX_CONFIG1_Q1_PACING_MULT_S 0
#define IG3_PTX2_GLPE_PTX_CONFIG1_Q1_PACING_MULT_M RDMA_MASK3(32, 0xFFFF, IG3_PTX2_GLPE_PTX_CONFIG1_Q1_PACING_MULT_S)
#define IG3_PTX2_GLPE_PTX_CONFIG2 0x43814020
#define IG3_PTX2_GLPE_PTX_CONFIG2_SEND2CPU_S 0
#define IG3_PTX2_GLPE_PTX_CONFIG2_SEND2CPU_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_CONFIG2_SEND2CPU_S)
#define IG3_PTX2_GLPE_PTX_CRT_XMIT_PTR 0x4381402C
#define IG3_PTX2_GLPE_PTX_CRT_XMIT_PTR_RSVD_S 8
#define IG3_PTX2_GLPE_PTX_CRT_XMIT_PTR_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX2_GLPE_PTX_CRT_XMIT_PTR_RSVD_S)
#define IG3_PTX2_GLPE_PTX_CRT_XMIT_PTR_COUNT_S 0
#define IG3_PTX2_GLPE_PTX_CRT_XMIT_PTR_COUNT_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_CRT_XMIT_PTR_COUNT_S)
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_COUNT 0x43814138
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX2_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX2_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_CMD 0x4381414C
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_DATA_H 0x43814158
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_DATA_L 0x43814154
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_PTR 0x43814150
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX2_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_CMD 0x4381413C
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_DATA_H 0x43814148
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_DATA_L 0x43814144
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_PTR 0x43814140
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX2_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL 0x43814100
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_RSVD1_S 25
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PTX2_GLPE_PTX_DTM_CONTROL_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_RSVD2_S 17
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX2_GLPE_PTX_DTM_CONTROL_RSVD2_S)
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_RSVD3_S 9
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PTX2_GLPE_PTX_DTM_CONTROL_RSVD3_S)
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_BYPASS_S 8
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_CONTROL_BYPASS_S)
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_RSVD4_S 1
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PTX2_GLPE_PTX_DTM_CONTROL_RSVD4_S)
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PTX2_GLPE_PTX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PTX2_GLPE_PTX_DTM_ECC_COR_ERR 0x43814168
#define IG3_PTX2_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PTX2_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX2_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PTX2_GLPE_PTX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PTX2_GLPE_PTX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PTX2_GLPE_PTX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PTX2_GLPE_PTX_DTM_ECC_UNCOR_ERR 0x43814164
#define IG3_PTX2_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PTX2_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX2_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PTX2_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PTX2_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PTX2_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PTX2_GLPE_PTX_DTM_GROUP_CFG 0x4381410C
#define IG3_PTX2_GLPE_PTX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PTX2_GLPE_PTX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PTX2_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PTX2_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PTX2_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PTX2_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PTX2_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PTX2_GLPE_PTX_DTM_LOG_CFG 0x43814110
#define IG3_PTX2_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PTX2_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PTX2_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PTX2_GLPE_PTX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PTX2_GLPE_PTX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PTX2_GLPE_PTX_DTM_LOG_CFG_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_DTM_LOG_CFG_MODE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_DTM_LOG_CFG_MODE_S)
#define IG3_PTX2_GLPE_PTX_DTM_LOG_MASK 0x43814118
#define IG3_PTX2_GLPE_PTX_DTM_LOG_MASK_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_DTM_LOG_MASK_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_LOG_PATTERN 0x43814114
#define IG3_PTX2_GLPE_PTX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG 0x43814104
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_STS 0x43814108
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PTX2_GLPE_PTX_DTM_MAIN_STS_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX2_GLPE_PTX_DTM_MAIN_STS_RSVD2_S)
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PTX2_GLPE_PTX_DTM_TIMESTAMP 0x43814130
#define IG3_PTX2_GLPE_PTX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_DTM_TIMESTAMP_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER 0x43814134
#define IG3_PTX2_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG 0x4381415C
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS 0x43814160
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG 0x4381411C
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_MODE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PTX2_GLPE_PTX_DTM_TRIG_CFG_MODE_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_COUNT 0x43814128
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_MASK 0x43814124
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_DTM_TRIG_MASK_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_PATTERN 0x43814120
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_TIMESTAMP 0x4381412C
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PTX2_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHHI 0x43814028
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_PTX2_GLPE_PTX_FWQPFLUSHHI_RSVD0_S)
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHHI_QPID_S 6
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX2_GLPE_PTX_FWQPFLUSHHI_QPID_S)
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX2_GLPE_PTX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO 0x43814024
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_BUSY_S 31
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_BUSY_S)
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_RSVD0_S)
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_HOSTID_S)
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_PMF_S 0
#define IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX2_GLPE_PTX_FWQPFLUSHLO_PMF_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0 0x43814044
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_TAG_S 16
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_TAG_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_MODE_S 11
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_MODE_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1 0x43814048
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_PMF_S 0
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG1_PMF_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG2 0x4381404C
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG2_QPID_S 6
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG2_QPID_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG3 0x43814050
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG4 0x43814054
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG4_COUNT_S 0
#define IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_ST0_DTM_TRIG4_COUNT_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0 0x43814058
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_TAG_S 16
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_TAG_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_MODE_S 11
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_MODE_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1 0x4381405C
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_PMF_S 0
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG1_PMF_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG2 0x43814060
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG2_QPID_S 6
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG2_QPID_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG3 0x43814064
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG4 0x43814068
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG4_COUNT_S 0
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG4_COUNT_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT0 0x43814078
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_S 1
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_S 0
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT1 0x4381407C
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_S 0
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT2 0x43814080
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_S 0
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE0 0x4381406C
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_S 1
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_S 0
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE1 0x43814070
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_S 24
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_S 0
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE2 0x43814074
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_S 24
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_S)
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_S 0
#define IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX2_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0 0x43814030
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_S 16
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_S 11
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1 0x43814034
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_S 0
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG2 0x43814038
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_S 6
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG3 0x4381403C
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG4 0x43814040
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_S 0
#define IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX2_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_S)
#define IG3_PTX2_GLPE_TIMELY_STALL_THRESHOLD 0x43814008
#define IG3_PTX2_GLPE_TIMELY_STALL_THRESHOLD_RSVD_S 25
#define IG3_PTX2_GLPE_TIMELY_STALL_THRESHOLD_RSVD_M RDMA_MASK3(32, 0x7F, IG3_PTX2_GLPE_TIMELY_STALL_THRESHOLD_RSVD_S)
#define IG3_PTX2_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_S 24
#define IG3_PTX2_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_M RDMA_BIT2(32, IG3_PTX2_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_S)
#define IG3_PTX2_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_S 0
#define IG3_PTX2_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX2_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_COUNT 0x438144B8
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_CMD 0x438144CC
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_DATA_H 0x438144D8
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_DATA_L 0x438144D4
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_PTR 0x438144D0
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_CMD 0x438144BC
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_DATA_H 0x438144C8
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_DATA_L 0x438144C4
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_PTR 0x438144C0
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL 0x43814480
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_RSVD1_S 25
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_RSVD1_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_RSVD2_S 17
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_RSVD2_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_RSVD3_S 9
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_RSVD3_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_BYPASS_S 8
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_BYPASS_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_RSVD4_S 1
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_RSVD4_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_ECC_COR_ERR 0x438144E8
#define IG3_SFPTX2_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SFPTX2_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX2_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_ECC_UNCOR_ERR 0x438144E4
#define IG3_SFPTX2_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SFPTX2_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX2_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_GROUP_CFG 0x4381448C
#define IG3_SFPTX2_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SFPTX2_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPTX2_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SFPTX2_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX2_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SFPTX2_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX2_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX2_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_LOG_CFG 0x43814490
#define IG3_SFPTX2_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SFPTX2_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SFPTX2_GLPE_SFPT_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SFPTX2_GLPE_SFPT_DTM_LOG_CFG_RSVD1_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_LOG_CFG_MODE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SFPTX2_GLPE_SFPT_DTM_LOG_CFG_MODE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_LOG_MASK 0x43814498
#define IG3_SFPTX2_GLPE_SFPT_DTM_LOG_MASK_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_LOG_MASK_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_LOG_PATTERN 0x43814494
#define IG3_SFPTX2_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG 0x43814484
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_STS 0x43814488
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_STS_RSVD1_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_STS_RSVD2_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TIMESTAMP 0x438144B0
#define IG3_SFPTX2_GLPE_SFPT_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_TIMESTAMP_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER 0x438144B4
#define IG3_SFPTX2_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG 0x438144DC
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS 0x438144E0
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SFPTX2_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG 0x4381449C
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_MODE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_CFG_MODE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_COUNT 0x438144A8
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_MASK 0x438144A4
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_MASK_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_PATTERN 0x438144A0
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_TIMESTAMP 0x438144AC
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX2_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SFPTX2_GLPE_SFP_TX_DOMAIN_ID 0x43814400
#define IG3_SFPTX2_GLPE_SFP_TX_DOMAIN_ID_RSVD_S 3
#define IG3_SFPTX2_GLPE_SFP_TX_DOMAIN_ID_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPTX2_GLPE_SFP_TX_DOMAIN_ID_RSVD_S)
#define IG3_SFPTX2_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_S 0
#define IG3_SFPTX2_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_SFPTX2_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_S)
#define IG3_SFPTX2_GLPE_SFP_TX_PER_MEM 0x43814404
#define IG3_SFPTX2_GLPE_SFP_TX_PER_MEM_RSVD_S 3
#define IG3_SFPTX2_GLPE_SFP_TX_PER_MEM_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPTX2_GLPE_SFP_TX_PER_MEM_RSVD_S)
#define IG3_SFPTX2_GLPE_SFP_TX_PER_MEM_PER_TYPE_S 0
#define IG3_SFPTX2_GLPE_SFP_TX_PER_MEM_PER_TYPE_M RDMA_MASK3(32, 0x7, IG3_SFPTX2_GLPE_SFP_TX_PER_MEM_PER_TYPE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG 0x43814800
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS 0x43814804
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG 0x43814810
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS 0x43814814
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ECC_COR_ERR 0x43814834
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR 0x43814830
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG 0x43814818
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS 0x4381481C
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG 0x43814808
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS 0x4381480C
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG 0x43814828
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS 0x4381482C
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG 0x43814820
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS 0x43814824
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG 0x43814840
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS 0x43814844
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG 0x43814848
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS 0x4381484C
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG 0x43814850
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS 0x43814854
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG 0x43814858
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS 0x4381485C
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR 0x4381487C
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR 0x43814878
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG 0x43814860
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS 0x43814864
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG 0x43814868
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS 0x4381486C
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG 0x43814870
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS 0x43814874
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG 0x43814838
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS 0x4381483C
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL 0x438148C8
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_S 31
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_S 26
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_S 18
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_DATA 0x438148CC
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG 0x438148C0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS 0x438148C4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_ECC_COR_ERR 0x438148E4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR 0x438148E0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL 0x438148D8
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_S 31
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_S 26
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA 0x438148DC
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG 0x438148D0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS 0x438148D4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL 0x43814888
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_S 31
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_S 26
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_S 18
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA 0x4381488C
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG 0x43814880
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS 0x43814884
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL 0x43814898
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_S 31
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_S 26
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA 0x4381489C
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG 0x43814890
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS 0x43814894
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL 0x438148A8
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_S 31
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_S 26
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_S 18
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA 0x438148AC
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG 0x438148A0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS 0x438148A4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL 0x438148B8
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_S 31
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_S 26
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_S 18
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA 0x438148BC
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG 0x438148B0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_S 20
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_S 16
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_S 14
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_S 10
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_S 6
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_S 5
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS 0x438148B4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_S 30
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_S 4
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE2_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_S)
#define IG3_DRX2_GLPE_DRX_CONFIG 0x43820000
#define IG3_DRX2_GLPE_DRX_CONFIG_RSVD1_S 3
#define IG3_DRX2_GLPE_DRX_CONFIG_RSVD1_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_DRX2_GLPE_DRX_CONFIG_RSVD1_S)
#define IG3_DRX2_GLPE_DRX_CONFIG_CRC_MASK_S 0
#define IG3_DRX2_GLPE_DRX_CONFIG_CRC_MASK_M RDMA_MASK3(32, 0x7, IG3_DRX2_GLPE_DRX_CONFIG_CRC_MASK_S)
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_COUNT 0x438200B8
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX2_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX2_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_CMD 0x438200CC
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_DATA_H 0x438200D8
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_DATA_L 0x438200D4
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_PTR 0x438200D0
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX2_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_CMD 0x438200BC
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_DATA_H 0x438200C8
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_DATA_L 0x438200C4
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_PTR 0x438200C0
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX2_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL 0x43820080
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_RSVD1_S 25
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_DRX2_GLPE_DRX_DTM_CONTROL_RSVD1_S)
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_RSVD2_S 17
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX2_GLPE_DRX_DTM_CONTROL_RSVD2_S)
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_RSVD3_S 9
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_DRX2_GLPE_DRX_DTM_CONTROL_RSVD3_S)
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_BYPASS_S 8
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_CONTROL_BYPASS_S)
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_RSVD4_S 1
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_DRX2_GLPE_DRX_DTM_CONTROL_RSVD4_S)
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_DRX2_GLPE_DRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_DRX2_GLPE_DRX_DTM_ECC_COR_ERR 0x438200E8
#define IG3_DRX2_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_DRX2_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX2_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_DRX2_GLPE_DRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_DRX2_GLPE_DRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX2_GLPE_DRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_DRX2_GLPE_DRX_DTM_ECC_UNCOR_ERR 0x438200E4
#define IG3_DRX2_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_DRX2_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX2_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_DRX2_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_DRX2_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX2_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_DRX2_GLPE_DRX_DTM_GROUP_CFG 0x4382008C
#define IG3_DRX2_GLPE_DRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_DRX2_GLPE_DRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_DRX2_GLPE_DRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_DRX2_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_DRX2_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX2_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_DRX2_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_DRX2_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX2_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_DRX2_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_DRX2_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX2_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_DRX2_GLPE_DRX_DTM_LOG_CFG 0x43820090
#define IG3_DRX2_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_DRX2_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_DRX2_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_DRX2_GLPE_DRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_DRX2_GLPE_DRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_DRX2_GLPE_DRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_DRX2_GLPE_DRX_DTM_LOG_CFG_MODE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_DRX2_GLPE_DRX_DTM_LOG_CFG_MODE_S)
#define IG3_DRX2_GLPE_DRX_DTM_LOG_MASK 0x43820098
#define IG3_DRX2_GLPE_DRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX2_GLPE_DRX_DTM_LOG_MASK_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_LOG_PATTERN 0x43820094
#define IG3_DRX2_GLPE_DRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX2_GLPE_DRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG 0x43820084
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_STS 0x43820088
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_DRX2_GLPE_DRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX2_GLPE_DRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_DRX2_GLPE_DRX_DTM_TIMESTAMP 0x438200B0
#define IG3_DRX2_GLPE_DRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX2_GLPE_DRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER 0x438200B4
#define IG3_DRX2_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX2_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG 0x438200DC
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS 0x438200E0
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DRX2_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG 0x4382009C
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_DRX2_GLPE_DRX_DTM_TRIG_CFG_MODE_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_COUNT 0x438200A8
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX2_GLPE_DRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_MASK 0x438200A4
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX2_GLPE_DRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_PATTERN 0x438200A0
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX2_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_TIMESTAMP 0x438200AC
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_DRX2_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX2_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_DRX2_GLPE_DRX_ECC_COR_ERR 0x43820004
#define IG3_DRX2_GLPE_DRX_ECC_COR_ERR_RSVD_S 12
#define IG3_DRX2_GLPE_DRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX2_GLPE_DRX_ECC_COR_ERR_RSVD_S)
#define IG3_DRX2_GLPE_DRX_ECC_COR_ERR_CNT_S 0
#define IG3_DRX2_GLPE_DRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX2_GLPE_DRX_ECC_COR_ERR_CNT_S)
#define IG3_DRX2_GLPE_DRX_ECC_UNCOR_ERR 0x43820008
#define IG3_DRX2_GLPE_DRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_DRX2_GLPE_DRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX2_GLPE_DRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_DRX2_GLPE_DRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_DRX2_GLPE_DRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX2_GLPE_DRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_DRX2_GLPE_PBUF_CFG 0x4382000C
#define IG3_DRX2_GLPE_PBUF_CFG_ECC_INST_NUM_S 25
#define IG3_DRX2_GLPE_PBUF_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DRX2_GLPE_PBUF_CFG_ECC_INST_NUM_S)
#define IG3_DRX2_GLPE_PBUF_CFG_RSVD3_S 20
#define IG3_DRX2_GLPE_PBUF_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DRX2_GLPE_PBUF_CFG_RSVD3_S)
#define IG3_DRX2_GLPE_PBUF_CFG_RM_S 16
#define IG3_DRX2_GLPE_PBUF_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DRX2_GLPE_PBUF_CFG_RM_S)
#define IG3_DRX2_GLPE_PBUF_CFG_RSVD2_S 14
#define IG3_DRX2_GLPE_PBUF_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DRX2_GLPE_PBUF_CFG_RSVD2_S)
#define IG3_DRX2_GLPE_PBUF_CFG_POWER_GATE_EN_S 13
#define IG3_DRX2_GLPE_PBUF_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DRX2_GLPE_PBUF_CFG_POWER_GATE_EN_S)
#define IG3_DRX2_GLPE_PBUF_CFG_RME_S 12
#define IG3_DRX2_GLPE_PBUF_CFG_RME_M RDMA_BIT2(32, IG3_DRX2_GLPE_PBUF_CFG_RME_S)
#define IG3_DRX2_GLPE_PBUF_CFG_RSVD1_S 10
#define IG3_DRX2_GLPE_PBUF_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX2_GLPE_PBUF_CFG_RSVD1_S)
#define IG3_DRX2_GLPE_PBUF_CFG_ERR_CNT_S 9
#define IG3_DRX2_GLPE_PBUF_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DRX2_GLPE_PBUF_CFG_ERR_CNT_S)
#define IG3_DRX2_GLPE_PBUF_CFG_FIX_CNT_S 8
#define IG3_DRX2_GLPE_PBUF_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DRX2_GLPE_PBUF_CFG_FIX_CNT_S)
#define IG3_DRX2_GLPE_PBUF_CFG_RSVD0_S 6
#define IG3_DRX2_GLPE_PBUF_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DRX2_GLPE_PBUF_CFG_RSVD0_S)
#define IG3_DRX2_GLPE_PBUF_CFG_MASK_INT_S 5
#define IG3_DRX2_GLPE_PBUF_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DRX2_GLPE_PBUF_CFG_MASK_INT_S)
#define IG3_DRX2_GLPE_PBUF_CFG_LS_BYPASS_S 4
#define IG3_DRX2_GLPE_PBUF_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DRX2_GLPE_PBUF_CFG_LS_BYPASS_S)
#define IG3_DRX2_GLPE_PBUF_CFG_LS_FORCE_S 3
#define IG3_DRX2_GLPE_PBUF_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DRX2_GLPE_PBUF_CFG_LS_FORCE_S)
#define IG3_DRX2_GLPE_PBUF_CFG_ECC_INVERT_2_S 2
#define IG3_DRX2_GLPE_PBUF_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DRX2_GLPE_PBUF_CFG_ECC_INVERT_2_S)
#define IG3_DRX2_GLPE_PBUF_CFG_ECC_INVERT_1_S 1
#define IG3_DRX2_GLPE_PBUF_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DRX2_GLPE_PBUF_CFG_ECC_INVERT_1_S)
#define IG3_DRX2_GLPE_PBUF_CFG_ECC_EN_S 0
#define IG3_DRX2_GLPE_PBUF_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DRX2_GLPE_PBUF_CFG_ECC_EN_S)
#define IG3_DRX2_GLPE_PBUF_STATUS 0x43820010
#define IG3_DRX2_GLPE_PBUF_STATUS_RSVD1_S 30
#define IG3_DRX2_GLPE_PBUF_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX2_GLPE_PBUF_STATUS_RSVD1_S)
#define IG3_DRX2_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DRX2_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DRX2_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DRX2_GLPE_PBUF_STATUS_RSVD0_S 4
#define IG3_DRX2_GLPE_PBUF_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DRX2_GLPE_PBUF_STATUS_RSVD0_S)
#define IG3_DRX2_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DRX2_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DRX2_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DRX2_GLPE_PBUF_STATUS_INIT_DONE_S 2
#define IG3_DRX2_GLPE_PBUF_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DRX2_GLPE_PBUF_STATUS_INIT_DONE_S)
#define IG3_DRX2_GLPE_PBUF_STATUS_ECC_FIX_S 1
#define IG3_DRX2_GLPE_PBUF_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DRX2_GLPE_PBUF_STATUS_ECC_FIX_S)
#define IG3_DRX2_GLPE_PBUF_STATUS_ECC_ERR_S 0
#define IG3_DRX2_GLPE_PBUF_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DRX2_GLPE_PBUF_STATUS_ECC_ERR_S)
#define IG3_CMPE2_CMPE_ECC_COR_ERR 0x4382053C
#define IG3_CMPE2_CMPE_ECC_COR_ERR_RSVD_S 12
#define IG3_CMPE2_CMPE_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE2_CMPE_ECC_COR_ERR_RSVD_S)
#define IG3_CMPE2_CMPE_ECC_COR_ERR_CNT_S 0
#define IG3_CMPE2_CMPE_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE2_CMPE_ECC_COR_ERR_CNT_S)
#define IG3_CMPE2_CMPE_ECC_UNCOR_ERR 0x43820538
#define IG3_CMPE2_CMPE_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CMPE2_CMPE_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE2_CMPE_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CMPE2_CMPE_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CMPE2_CMPE_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE2_CMPE_ECC_UNCOR_ERR_CNT_S)
#define IG3_CMPE2_GLCM_PECLSADDR 0x43820484
#define IG3_CMPE2_GLCM_PECLSADDR_RSVD_S 9
#define IG3_CMPE2_GLCM_PECLSADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE2_GLCM_PECLSADDR_RSVD_S)
#define IG3_CMPE2_GLCM_PECLSADDR_CLS_ADDR_S 0
#define IG3_CMPE2_GLCM_PECLSADDR_CLS_ADDR_M RDMA_MASK3(32, 0x1FF, IG3_CMPE2_GLCM_PECLSADDR_CLS_ADDR_S)
#define IG3_CMPE2_GLCM_PECLSDATA0 0x43820488
#define IG3_CMPE2_GLCM_PECLSDATA0_CLS_DATA_S 0
#define IG3_CMPE2_GLCM_PECLSDATA0_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLCM_PECLSDATA0_CLS_DATA_S)
#define IG3_CMPE2_GLCM_PECLSDATA1 0x4382048C
#define IG3_CMPE2_GLCM_PECLSDATA1_CLS_DATA_S 0
#define IG3_CMPE2_GLCM_PECLSDATA1_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLCM_PECLSDATA1_CLS_DATA_S)
#define IG3_CMPE2_GLCM_PECLSDATA2 0x43820490
#define IG3_CMPE2_GLCM_PECLSDATA2_CLS_DATA_S 0
#define IG3_CMPE2_GLCM_PECLSDATA2_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLCM_PECLSDATA2_CLS_DATA_S)
#define IG3_CMPE2_GLCM_PECONFIG 0x43820480
#define IG3_CMPE2_GLCM_PECONFIG_DBGMUX_EN_S 31
#define IG3_CMPE2_GLCM_PECONFIG_DBGMUX_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECONFIG_DBGMUX_EN_S)
#define IG3_CMPE2_GLCM_PECONFIG_RSVD13_S 30
#define IG3_CMPE2_GLCM_PECONFIG_RSVD13_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECONFIG_RSVD13_S)
#define IG3_CMPE2_GLCM_PECONFIG_DBGMUX_SEL_HI_S 25
#define IG3_CMPE2_GLCM_PECONFIG_DBGMUX_SEL_HI_M RDMA_MASK3(32, 0x1F, IG3_CMPE2_GLCM_PECONFIG_DBGMUX_SEL_HI_S)
#define IG3_CMPE2_GLCM_PECONFIG_DBGMUX_SEL_LO_S 20
#define IG3_CMPE2_GLCM_PECONFIG_DBGMUX_SEL_LO_M RDMA_MASK3(32, 0x1F, IG3_CMPE2_GLCM_PECONFIG_DBGMUX_SEL_LO_S)
#define IG3_CMPE2_GLCM_PECONFIG_RSVD10_S 17
#define IG3_CMPE2_GLCM_PECONFIG_RSVD10_M RDMA_MASK3(32, 0x7, IG3_CMPE2_GLCM_PECONFIG_RSVD10_S)
#define IG3_CMPE2_GLCM_PECONFIG_DBG_WRSEL_S 16
#define IG3_CMPE2_GLCM_PECONFIG_DBG_WRSEL_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECONFIG_DBG_WRSEL_S)
#define IG3_CMPE2_GLCM_PECONFIG_DBG_DWSEL_S 14
#define IG3_CMPE2_GLCM_PECONFIG_DBG_DWSEL_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PECONFIG_DBG_DWSEL_S)
#define IG3_CMPE2_GLCM_PECONFIG_DBG_DPSEL_S 12
#define IG3_CMPE2_GLCM_PECONFIG_DBG_DPSEL_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PECONFIG_DBG_DPSEL_S)
#define IG3_CMPE2_GLCM_PECONFIG_RSVD6_S 7
#define IG3_CMPE2_GLCM_PECONFIG_RSVD6_M RDMA_MASK3(32, 0x1F, IG3_CMPE2_GLCM_PECONFIG_RSVD6_S)
#define IG3_CMPE2_GLCM_PECONFIG_DISABLE_CTXT_PACKING_S 6
#define IG3_CMPE2_GLCM_PECONFIG_DISABLE_CTXT_PACKING_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECONFIG_DISABLE_CTXT_PACKING_S)
#define IG3_CMPE2_GLCM_PECONFIG_DISABLE_LSA_S 5
#define IG3_CMPE2_GLCM_PECONFIG_DISABLE_LSA_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECONFIG_DISABLE_LSA_S)
#define IG3_CMPE2_GLCM_PECONFIG_ENABLE_CRC_S 4
#define IG3_CMPE2_GLCM_PECONFIG_ENABLE_CRC_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECONFIG_ENABLE_CRC_S)
#define IG3_CMPE2_GLCM_PECONFIG_DISABLE_RESCHEDULE_S 3
#define IG3_CMPE2_GLCM_PECONFIG_DISABLE_RESCHEDULE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECONFIG_DISABLE_RESCHEDULE_S)
#define IG3_CMPE2_GLCM_PECONFIG_DISABLE_PACKET_COUNT_S 2
#define IG3_CMPE2_GLCM_PECONFIG_DISABLE_PACKET_COUNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECONFIG_DISABLE_PACKET_COUNT_S)
#define IG3_CMPE2_GLCM_PECONFIG_GLOBAL_LOCK_MODE_S 1
#define IG3_CMPE2_GLCM_PECONFIG_GLOBAL_LOCK_MODE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECONFIG_GLOBAL_LOCK_MODE_S)
#define IG3_CMPE2_GLCM_PECONFIG_RSVD1_S 0
#define IG3_CMPE2_GLCM_PECONFIG_RSVD1_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECONFIG_RSVD1_S)
#define IG3_CMPE2_GLCM_PECTXDGCTL 0x438204C8
#define IG3_CMPE2_GLCM_PECTXDGCTL_RSVD_S 12
#define IG3_CMPE2_GLCM_PECTXDGCTL_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE2_GLCM_PECTXDGCTL_RSVD_S)
#define IG3_CMPE2_GLCM_PECTXDGCTL_PKTCNT_S 10
#define IG3_CMPE2_GLCM_PECTXDGCTL_PKTCNT_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PECTXDGCTL_PKTCNT_S)
#define IG3_CMPE2_GLCM_PECTXDGCTL_OP_CODE_S 8
#define IG3_CMPE2_GLCM_PECTXDGCTL_OP_CODE_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PECTXDGCTL_OP_CODE_S)
#define IG3_CMPE2_GLCM_PECTXDGCTL_ALLOCATE_S 7
#define IG3_CMPE2_GLCM_PECTXDGCTL_ALLOCATE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECTXDGCTL_ALLOCATE_S)
#define IG3_CMPE2_GLCM_PECTXDGCTL_WRITEBACK_S 6
#define IG3_CMPE2_GLCM_PECTXDGCTL_WRITEBACK_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECTXDGCTL_WRITEBACK_S)
#define IG3_CMPE2_GLCM_PECTXDGCTL_INVALIDATE_S 5
#define IG3_CMPE2_GLCM_PECTXDGCTL_INVALIDATE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECTXDGCTL_INVALIDATE_S)
#define IG3_CMPE2_GLCM_PECTXDGCTL_SUB_LINE_S 0
#define IG3_CMPE2_GLCM_PECTXDGCTL_SUB_LINE_M RDMA_MASK3(32, 0x1F, IG3_CMPE2_GLCM_PECTXDGCTL_SUB_LINE_S)
#define IG3_CMPE2_GLCM_PECTXDGDATA(_i) 0x438204CC + ((_i) * 4) /* _i=0...3 */
#define IG3_CMPE2_GLCM_PECTXDGDATA_MAX_INDEX_I 3
#define IG3_CMPE2_GLCM_PECTXDGDATA_DATA_S 0
#define IG3_CMPE2_GLCM_PECTXDGDATA_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLCM_PECTXDGDATA_DATA_S)
#define IG3_CMPE2_GLCM_PECTXDGFN 0x438204C0
#define IG3_CMPE2_GLCM_PECTXDGFN_RSVD_S 20
#define IG3_CMPE2_GLCM_PECTXDGFN_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE2_GLCM_PECTXDGFN_RSVD_S)
#define IG3_CMPE2_GLCM_PECTXDGFN_FUNC_TRIPLET_S 0
#define IG3_CMPE2_GLCM_PECTXDGFN_FUNC_TRIPLET_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE2_GLCM_PECTXDGFN_FUNC_TRIPLET_S)
#define IG3_CMPE2_GLCM_PECTXDGQP 0x438204C4
#define IG3_CMPE2_GLCM_PECTXDGQP_RSVD_S 24
#define IG3_CMPE2_GLCM_PECTXDGQP_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLCM_PECTXDGQP_RSVD_S)
#define IG3_CMPE2_GLCM_PECTXDGQP_QUEUE_NUM_S 0
#define IG3_CMPE2_GLCM_PECTXDGQP_QUEUE_NUM_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE2_GLCM_PECTXDGQP_QUEUE_NUM_S)
#define IG3_CMPE2_GLCM_PECTXDGSTAT 0x438204DC
#define IG3_CMPE2_GLCM_PECTXDGSTAT_RSVD_S 2
#define IG3_CMPE2_GLCM_PECTXDGSTAT_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_CMPE2_GLCM_PECTXDGSTAT_RSVD_S)
#define IG3_CMPE2_GLCM_PECTXDGSTAT_CTX_MISS_S 1
#define IG3_CMPE2_GLCM_PECTXDGSTAT_CTX_MISS_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECTXDGSTAT_CTX_MISS_S)
#define IG3_CMPE2_GLCM_PECTXDGSTAT_CTX_DONE_S 0
#define IG3_CMPE2_GLCM_PECTXDGSTAT_CTX_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PECTXDGSTAT_CTX_DONE_S)
#define IG3_CMPE2_GLCM_PEDATAREQHI 0x438204B4
#define IG3_CMPE2_GLCM_PEDATAREQHI_RSVD_S 24
#define IG3_CMPE2_GLCM_PEDATAREQHI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLCM_PEDATAREQHI_RSVD_S)
#define IG3_CMPE2_GLCM_PEDATAREQHI_DATAREQHI_S 0
#define IG3_CMPE2_GLCM_PEDATAREQHI_DATAREQHI_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE2_GLCM_PEDATAREQHI_DATAREQHI_S)
#define IG3_CMPE2_GLCM_PEDATAREQLO 0x438204B0
#define IG3_CMPE2_GLCM_PEDATAREQLO_DATAREQLOW_S 0
#define IG3_CMPE2_GLCM_PEDATAREQLO_DATAREQLOW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLCM_PEDATAREQLO_DATAREQLOW_S)
#define IG3_CMPE2_GLCM_PEDATASTALLHI 0x438204BC
#define IG3_CMPE2_GLCM_PEDATASTALLHI_RSVD_S 24
#define IG3_CMPE2_GLCM_PEDATASTALLHI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLCM_PEDATASTALLHI_RSVD_S)
#define IG3_CMPE2_GLCM_PEDATASTALLHI_DATASTALLHI_S 0
#define IG3_CMPE2_GLCM_PEDATASTALLHI_DATASTALLHI_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE2_GLCM_PEDATASTALLHI_DATASTALLHI_S)
#define IG3_CMPE2_GLCM_PEDATASTALLLO 0x438204B8
#define IG3_CMPE2_GLCM_PEDATASTALLLO_DATASTALLLOW_S 0
#define IG3_CMPE2_GLCM_PEDATASTALLLO_DATASTALLLOW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLCM_PEDATASTALLLO_DATASTALLLOW_S)
#define IG3_CMPE2_GLCM_PELOCKTBLADDR 0x4382049C
#define IG3_CMPE2_GLCM_PELOCKTBLADDR_RSVD_S 5
#define IG3_CMPE2_GLCM_PELOCKTBLADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_CMPE2_GLCM_PELOCKTBLADDR_RSVD_S)
#define IG3_CMPE2_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_S 0
#define IG3_CMPE2_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_M RDMA_MASK3(32, 0x1F, IG3_CMPE2_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_S)
#define IG3_CMPE2_GLCM_PELOCKTBLDATA0 0x438204A0
#define IG3_CMPE2_GLCM_PELOCKTBLDATA0_GPLOCKSEL_S 31
#define IG3_CMPE2_GLCM_PELOCKTBLDATA0_GPLOCKSEL_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PELOCKTBLDATA0_GPLOCKSEL_S)
#define IG3_CMPE2_GLCM_PELOCKTBLDATA0_RSVD_S 24
#define IG3_CMPE2_GLCM_PELOCKTBLDATA0_RSVD_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLCM_PELOCKTBLDATA0_RSVD_S)
#define IG3_CMPE2_GLCM_PELOCKTBLDATA0_QPID_S 0
#define IG3_CMPE2_GLCM_PELOCKTBLDATA0_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE2_GLCM_PELOCKTBLDATA0_QPID_S)
#define IG3_CMPE2_GLCM_PELOCKTBLDATA1 0x438204A4
#define IG3_CMPE2_GLCM_PELOCKTBLDATA1_RSVD_S 20
#define IG3_CMPE2_GLCM_PELOCKTBLDATA1_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE2_GLCM_PELOCKTBLDATA1_RSVD_S)
#define IG3_CMPE2_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_S 0
#define IG3_CMPE2_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE2_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_S)
#define IG3_CMPE2_GLCM_PELOCKTBLDATA2 0x438204A8
#define IG3_CMPE2_GLCM_PELOCKTBLDATA2_LOCKSEL_S 0
#define IG3_CMPE2_GLCM_PELOCKTBLDATA2_LOCKSEL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLCM_PELOCKTBLDATA2_LOCKSEL_S)
#define IG3_CMPE2_GLCM_PEPKTCNTADDR 0x43820494
#define IG3_CMPE2_GLCM_PEPKTCNTADDR_RSVD_S 9
#define IG3_CMPE2_GLCM_PEPKTCNTADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE2_GLCM_PEPKTCNTADDR_RSVD_S)
#define IG3_CMPE2_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_S 0
#define IG3_CMPE2_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_M RDMA_MASK3(32, 0x1FF, IG3_CMPE2_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_S)
#define IG3_CMPE2_GLCM_PEPKTCNTDATA 0x43820498
#define IG3_CMPE2_GLCM_PEPKTCNTDATA_RSVD1_S 18
#define IG3_CMPE2_GLCM_PEPKTCNTDATA_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE2_GLCM_PEPKTCNTDATA_RSVD1_S)
#define IG3_CMPE2_GLCM_PEPKTCNTDATA_RLRSP_STATE_S 16
#define IG3_CMPE2_GLCM_PEPKTCNTDATA_RLRSP_STATE_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PEPKTCNTDATA_RLRSP_STATE_S)
#define IG3_CMPE2_GLCM_PEPKTCNTDATA_RSVD0_S 14
#define IG3_CMPE2_GLCM_PEPKTCNTDATA_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PEPKTCNTDATA_RSVD0_S)
#define IG3_CMPE2_GLCM_PEPKTCNTDATA_RLREQ_STATE_S 12
#define IG3_CMPE2_GLCM_PEPKTCNTDATA_RLREQ_STATE_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PEPKTCNTDATA_RLREQ_STATE_S)
#define IG3_CMPE2_GLCM_PEPKTCNTDATA_PKTCNT_S 1
#define IG3_CMPE2_GLCM_PEPKTCNTDATA_PKTCNT_M RDMA_MASK3(32, 0x7FF, IG3_CMPE2_GLCM_PEPKTCNTDATA_PKTCNT_S)
#define IG3_CMPE2_GLCM_PEPKTCNTDATA_DONE_S 0
#define IG3_CMPE2_GLCM_PEPKTCNTDATA_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PEPKTCNTDATA_DONE_S)
#define IG3_CMPE2_GLCM_PESTATSCTL 0x438204AC
#define IG3_CMPE2_GLCM_PESTATSCTL_RSVD_S 2
#define IG3_CMPE2_GLCM_PESTATSCTL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_CMPE2_GLCM_PESTATSCTL_RSVD_S)
#define IG3_CMPE2_GLCM_PESTATSCTL_ENABLE_S 1
#define IG3_CMPE2_GLCM_PESTATSCTL_ENABLE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PESTATSCTL_ENABLE_S)
#define IG3_CMPE2_GLCM_PESTATSCTL_CLEAR_S 0
#define IG3_CMPE2_GLCM_PESTATSCTL_CLEAR_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PESTATSCTL_CLEAR_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG 0x43820500
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_S 20
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RM_S 16
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RM_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_S 14
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RME_S 12
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RME_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_S 10
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_S 6
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS 0x43820504
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG 0x43820508
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_S 20
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RM_S 16
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RM_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_S 14
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RME_S 12
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RME_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_S 10
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_S 6
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS 0x4382050C
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG 0x43820510
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_S 20
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RM_S 16
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RM_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_S 14
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RME_S 12
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RME_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_S 10
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_S 6
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS 0x43820514
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG 0x43820518
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_S 20
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RM_S 16
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RM_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_S 14
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RME_S 12
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RME_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_S 10
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_S 6
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS 0x4382051C
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG 0x43820520
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RSVD3_S 20
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RSVD3_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RM_S 16
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RM_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RSVD2_S 14
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RSVD2_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RME_S 12
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RME_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RSVD1_S 10
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RSVD0_S 6
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS 0x43820524
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE2_GLCM_PE_CACHESIZE 0x438204E4
#define IG3_CMPE2_GLCM_PE_CACHESIZE_RSVD_S 26
#define IG3_CMPE2_GLCM_PE_CACHESIZE_RSVD_M RDMA_MASK3(32, 0x3F, IG3_CMPE2_GLCM_PE_CACHESIZE_RSVD_S)
#define IG3_CMPE2_GLCM_PE_CACHESIZE_WAYS_S 16
#define IG3_CMPE2_GLCM_PE_CACHESIZE_WAYS_M RDMA_MASK3(32, 0x3FF, IG3_CMPE2_GLCM_PE_CACHESIZE_WAYS_S)
#define IG3_CMPE2_GLCM_PE_CACHESIZE_SETS_S 12
#define IG3_CMPE2_GLCM_PE_CACHESIZE_SETS_M RDMA_MASK3(32, 0xF, IG3_CMPE2_GLCM_PE_CACHESIZE_SETS_S)
#define IG3_CMPE2_GLCM_PE_CACHESIZE_WORD_SIZE_S 0
#define IG3_CMPE2_GLCM_PE_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFFF, IG3_CMPE2_GLCM_PE_CACHESIZE_WORD_SIZE_S)
#define IG3_CMPE2_GLCM_PE_DPC_COMP 0x438204F4
#define IG3_CMPE2_GLCM_PE_DPC_COMP_RSVD_S 13
#define IG3_CMPE2_GLCM_PE_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_CMPE2_GLCM_PE_DPC_COMP_RSVD_S)
#define IG3_CMPE2_GLCM_PE_DPC_COMP_COMP_FTYPE_S 11
#define IG3_CMPE2_GLCM_PE_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_DPC_COMP_COMP_FTYPE_S)
#define IG3_CMPE2_GLCM_PE_DPC_COMP_COMP_FNUM_S 1
#define IG3_CMPE2_GLCM_PE_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_CMPE2_GLCM_PE_DPC_COMP_COMP_FNUM_S)
#define IG3_CMPE2_GLCM_PE_DPC_COMP_COMP_VALID_S 0
#define IG3_CMPE2_GLCM_PE_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_DPC_COMP_COMP_VALID_S)
#define IG3_CMPE2_GLCM_PE_DPC_REQ 0x438204F0
#define IG3_CMPE2_GLCM_PE_DPC_REQ_RSVD_S 12
#define IG3_CMPE2_GLCM_PE_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE2_GLCM_PE_DPC_REQ_RSVD_S)
#define IG3_CMPE2_GLCM_PE_DPC_REQ_REQ_FTYPE_S 10
#define IG3_CMPE2_GLCM_PE_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_DPC_REQ_REQ_FTYPE_S)
#define IG3_CMPE2_GLCM_PE_DPC_REQ_REQ_FNUM_S 0
#define IG3_CMPE2_GLCM_PE_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_CMPE2_GLCM_PE_DPC_REQ_REQ_FNUM_S)
#define IG3_CMPE2_GLCM_PE_E2E_FC 0x438204F8
#define IG3_CMPE2_GLCM_PE_E2E_FC_RSVD1_S 22
#define IG3_CMPE2_GLCM_PE_E2E_FC_RSVD1_M RDMA_MASK3(32, 0x3FF, IG3_CMPE2_GLCM_PE_E2E_FC_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_S 16
#define IG3_CMPE2_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_M RDMA_MASK3(32, 0x3F, IG3_CMPE2_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_S)
#define IG3_CMPE2_GLCM_PE_E2E_FC_RSVD0_S 9
#define IG3_CMPE2_GLCM_PE_E2E_FC_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLCM_PE_E2E_FC_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_S 0
#define IG3_CMPE2_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_M RDMA_MASK3(32, 0x1FF, IG3_CMPE2_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG 0x43820528
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_S 20
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RM_S 16
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RM_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_S 14
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RME_S 12
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RME_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_S 10
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_S 6
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS 0x4382052C
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG 0x43820530
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_S 20
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RM_S 16
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RM_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_S 14
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RME_S 12
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RME_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_S 10
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_S 6
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS 0x43820534
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE2_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE2_GLCM_PE_IF_FC 0x438204FC
#define IG3_CMPE2_GLCM_PE_IF_FC_RSVD1_S 22
#define IG3_CMPE2_GLCM_PE_IF_FC_RSVD1_M RDMA_MASK3(32, 0x3FF, IG3_CMPE2_GLCM_PE_IF_FC_RSVD1_S)
#define IG3_CMPE2_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_S 16
#define IG3_CMPE2_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_M RDMA_MASK3(32, 0x3F, IG3_CMPE2_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_S)
#define IG3_CMPE2_GLCM_PE_IF_FC_RSVD0_S 9
#define IG3_CMPE2_GLCM_PE_IF_FC_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLCM_PE_IF_FC_RSVD0_S)
#define IG3_CMPE2_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_S 0
#define IG3_CMPE2_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_M RDMA_MASK3(32, 0x1FF, IG3_CMPE2_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_S)
#define IG3_CMPE2_GLCM_PE_MAXOSR 0x438204E0
#define IG3_CMPE2_GLCM_PE_MAXOSR_RSVD_S 6
#define IG3_CMPE2_GLCM_PE_MAXOSR_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_CMPE2_GLCM_PE_MAXOSR_RSVD_S)
#define IG3_CMPE2_GLCM_PE_MAXOSR_MAXOSR_S 0
#define IG3_CMPE2_GLCM_PE_MAXOSR_MAXOSR_M RDMA_MASK3(32, 0x3F, IG3_CMPE2_GLCM_PE_MAXOSR_MAXOSR_S)
#define IG3_CMPE2_GLCM_PE_RLDDBGCTL0 0x438204E8
#define IG3_CMPE2_GLCM_PE_RLDDBGCTL0_RSVD_S 24
#define IG3_CMPE2_GLCM_PE_RLDDBGCTL0_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLCM_PE_RLDDBGCTL0_RSVD_S)
#define IG3_CMPE2_GLCM_PE_RLDDBGCTL0_QPID_S 0
#define IG3_CMPE2_GLCM_PE_RLDDBGCTL0_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE2_GLCM_PE_RLDDBGCTL0_QPID_S)
#define IG3_CMPE2_GLCM_PE_RLDDBGCTL1 0x438204EC
#define IG3_CMPE2_GLCM_PE_RLDDBGCTL1_RSVD_S 20
#define IG3_CMPE2_GLCM_PE_RLDDBGCTL1_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE2_GLCM_PE_RLDDBGCTL1_RSVD_S)
#define IG3_CMPE2_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_S 18
#define IG3_CMPE2_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_S)
#define IG3_CMPE2_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_S 6
#define IG3_CMPE2_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CMPE2_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_S)
#define IG3_CMPE2_GLCM_PE_RLDDBGCTL1_PF_NUM_S 0
#define IG3_CMPE2_GLCM_PE_RLDDBGCTL1_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_CMPE2_GLCM_PE_RLDDBGCTL1_PF_NUM_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_COUNT 0x438205B8
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_CMD 0x438205CC
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_DATA_H 0x438205D8
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_DATA_L 0x438205D4
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_PTR 0x438205D0
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_CMD 0x438205BC
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_DATA_H 0x438205C8
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_DATA_L 0x438205C4
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_PTR 0x438205C0
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL 0x43820580
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_RSVD1_S 25
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_RSVD1_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_RSVD2_S 17
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_RSVD2_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_RSVD3_S 9
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_RSVD3_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_BYPASS_S 8
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_BYPASS_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_RSVD4_S 1
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_RSVD4_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_ECC_COR_ERR 0x438205E8
#define IG3_CMPE2_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_CMPE2_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE2_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_ECC_UNCOR_ERR 0x438205E4
#define IG3_CMPE2_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CMPE2_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE2_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_GROUP_CFG 0x4382058C
#define IG3_CMPE2_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_CMPE2_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_CMPE2_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_CMPE2_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_LOG_CFG 0x43820590
#define IG3_CMPE2_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_CMPE2_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_CMPE2_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_LOG_CFG_RSVD1_S 2
#define IG3_CMPE2_GLPE_CMPE_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE2_GLPE_CMPE_DTM_LOG_CFG_RSVD1_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_LOG_CFG_MODE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLPE_CMPE_DTM_LOG_CFG_MODE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_LOG_MASK 0x43820598
#define IG3_CMPE2_GLPE_CMPE_DTM_LOG_MASK_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_LOG_MASK_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_LOG_PATTERN 0x43820594
#define IG3_CMPE2_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG 0x43820584
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_STS 0x43820588
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_STS_RSVD1_S 9
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE2_GLPE_CMPE_DTM_MAIN_STS_RSVD1_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_STS_RSVD2_S 1
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLPE_CMPE_DTM_MAIN_STS_RSVD2_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TIMESTAMP 0x438205B0
#define IG3_CMPE2_GLPE_CMPE_DTM_TIMESTAMP_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_TIMESTAMP_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER 0x438205B4
#define IG3_CMPE2_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG 0x438205DC
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS 0x438205E0
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE2_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG 0x4382059C
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_MODE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_CMPE2_GLPE_CMPE_DTM_TRIG_CFG_MODE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_COUNT 0x438205A8
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_MASK 0x438205A4
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_MASK_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_TRIG_MASK_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_PATTERN 0x438205A0
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_TIMESTAMP 0x438205AC
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_CMPE2_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE2_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_CMPE2_PFCM_PE_CRCERRINFO0(_i) 0x43820400 + ((_i) * 4) /* _i=0...15 */
#define IG3_CMPE2_PFCM_PE_CRCERRINFO0_MAX_INDEX_I 15
#define IG3_CMPE2_PFCM_PE_CRCERRINFO0_RSVD1_S 18
#define IG3_CMPE2_PFCM_PE_CRCERRINFO0_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE2_PFCM_PE_CRCERRINFO0_RSVD1_S)
#define IG3_CMPE2_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_S 16
#define IG3_CMPE2_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE2_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_S)
#define IG3_CMPE2_PFCM_PE_CRCERRINFO0_VM_VF_NUM_S 4
#define IG3_CMPE2_PFCM_PE_CRCERRINFO0_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CMPE2_PFCM_PE_CRCERRINFO0_VM_VF_NUM_S)
#define IG3_CMPE2_PFCM_PE_CRCERRINFO0_RSVD0_S 1
#define IG3_CMPE2_PFCM_PE_CRCERRINFO0_RSVD0_M RDMA_MASK3(32, 0x7, IG3_CMPE2_PFCM_PE_CRCERRINFO0_RSVD0_S)
#define IG3_CMPE2_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_S 0
#define IG3_CMPE2_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_M RDMA_BIT2(32, IG3_CMPE2_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_S)
#define IG3_CMPE2_PFCM_PE_CRCERRINFO1(_i) 0x43820440 + ((_i) * 4) /* _i=0...15 */
#define IG3_CMPE2_PFCM_PE_CRCERRINFO1_MAX_INDEX_I 15
#define IG3_CMPE2_PFCM_PE_CRCERRINFO1_RSVD_S 24
#define IG3_CMPE2_PFCM_PE_CRCERRINFO1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE2_PFCM_PE_CRCERRINFO1_RSVD_S)
#define IG3_CMPE2_PFCM_PE_CRCERRINFO1_Q_NUM_S 0
#define IG3_CMPE2_PFCM_PE_CRCERRINFO1_Q_NUM_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE2_PFCM_PE_CRCERRINFO1_Q_NUM_S)
#define IG3_PRX3_GLPE_CC_DCQCN1_CFG(_i) 0x43C02000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX3_GLPE_CC_DCQCN1_CFG_MAX_INDEX_I 1031
#define IG3_PRX3_GLPE_CC_DCQCN1_CFG_RSVD2_S 31
#define IG3_PRX3_GLPE_CC_DCQCN1_CFG_RSVD2_M RDMA_BIT2(32, IG3_PRX3_GLPE_CC_DCQCN1_CFG_RSVD2_S)
#define IG3_PRX3_GLPE_CC_DCQCN1_CFG_DCQCN_F_S 28
#define IG3_PRX3_GLPE_CC_DCQCN1_CFG_DCQCN_F_M RDMA_MASK3(32, 0x7, IG3_PRX3_GLPE_CC_DCQCN1_CFG_DCQCN_F_S)
#define IG3_PRX3_GLPE_CC_DCQCN1_CFG_RSVD1_S 25
#define IG3_PRX3_GLPE_CC_DCQCN1_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_PRX3_GLPE_CC_DCQCN1_CFG_RSVD1_S)
#define IG3_PRX3_GLPE_CC_DCQCN1_CFG_DCQCN_B_S 0
#define IG3_PRX3_GLPE_CC_DCQCN1_CFG_DCQCN_B_M RDMA_MASK3(32, 0x1FFFFFF, IG3_PRX3_GLPE_CC_DCQCN1_CFG_DCQCN_B_S)
#define IG3_PRX3_GLPE_CC_DCQCN2_CFG(_i) 0x43C04000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX3_GLPE_CC_DCQCN2_CFG_MAX_INDEX_I 1031
#define IG3_PRX3_GLPE_CC_DCQCN2_CFG_RSVD_S 16
#define IG3_PRX3_GLPE_CC_DCQCN2_CFG_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PRX3_GLPE_CC_DCQCN2_CFG_RSVD_S)
#define IG3_PRX3_GLPE_CC_DCQCN2_CFG_DCQCN_T_S 0
#define IG3_PRX3_GLPE_CC_DCQCN2_CFG_DCQCN_T_M RDMA_MASK3(32, 0xFFFF, IG3_PRX3_GLPE_CC_DCQCN2_CFG_DCQCN_T_S)
#define IG3_PRX3_GLPE_CC_TIMELY_CFG(_i) 0x43C00000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX3_GLPE_CC_TIMELY_CFG_MAX_INDEX_I 1031
#define IG3_PRX3_GLPE_CC_TIMELY_CFG_RAI_FACTOR_S 16
#define IG3_PRX3_GLPE_CC_TIMELY_CFG_RAI_FACTOR_M RDMA_MASK3(32, 0xFFFF, IG3_PRX3_GLPE_CC_TIMELY_CFG_RAI_FACTOR_S)
#define IG3_PRX3_GLPE_CC_TIMELY_CFG_HAI_FACTOR_S 0
#define IG3_PRX3_GLPE_CC_TIMELY_CFG_HAI_FACTOR_M RDMA_MASK3(32, 0xFFFF, IG3_PRX3_GLPE_CC_TIMELY_CFG_HAI_FACTOR_S)
#define IG3_PRX3_GLPE_PRX_CONFIG 0x43C05020
#define IG3_PRX3_GLPE_PRX_CONFIG_REORDER_CNT_MAX_S 24
#define IG3_PRX3_GLPE_PRX_CONFIG_REORDER_CNT_MAX_M RDMA_MASK3(32, 0xFF, IG3_PRX3_GLPE_PRX_CONFIG_REORDER_CNT_MAX_S)
#define IG3_PRX3_GLPE_PRX_CONFIG_REORDER_CNT_MIN_S 16
#define IG3_PRX3_GLPE_PRX_CONFIG_REORDER_CNT_MIN_M RDMA_MASK3(32, 0xFF, IG3_PRX3_GLPE_PRX_CONFIG_REORDER_CNT_MIN_S)
#define IG3_PRX3_GLPE_PRX_CONFIG_RSVD1_S 12
#define IG3_PRX3_GLPE_PRX_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PRX3_GLPE_PRX_CONFIG_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_S 8
#define IG3_PRX3_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_M RDMA_MASK3(32, 0xF, IG3_PRX3_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_S)
#define IG3_PRX3_GLPE_PRX_CONFIG_RSVD0_S 5
#define IG3_PRX3_GLPE_PRX_CONFIG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PRX3_GLPE_PRX_CONFIG_RSVD0_S)
#define IG3_PRX3_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_S 4
#define IG3_PRX3_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_S)
#define IG3_PRX3_GLPE_PRX_CONFIG_ONE_HP_TILE_S 3
#define IG3_PRX3_GLPE_PRX_CONFIG_ONE_HP_TILE_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_CONFIG_ONE_HP_TILE_S)
#define IG3_PRX3_GLPE_PRX_CONFIG_DIS_RREC_S 2
#define IG3_PRX3_GLPE_PRX_CONFIG_DIS_RREC_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_CONFIG_DIS_RREC_S)
#define IG3_PRX3_GLPE_PRX_CONFIG_DIS_QR_STALL_S 1
#define IG3_PRX3_GLPE_PRX_CONFIG_DIS_QR_STALL_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_CONFIG_DIS_QR_STALL_S)
#define IG3_PRX3_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_S 0
#define IG3_PRX3_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_S)
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_COUNT 0x43C050B8
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX3_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX3_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_CMD 0x43C050CC
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_DATA_H 0x43C050D8
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_DATA_L 0x43C050D4
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_PTR 0x43C050D0
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX3_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_CMD 0x43C050BC
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_DATA_H 0x43C050C8
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_DATA_L 0x43C050C4
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_PTR 0x43C050C0
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX3_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL 0x43C05080
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_RSVD1_S 25
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PRX3_GLPE_PRX_DTM_CONTROL_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_RSVD2_S 17
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX3_GLPE_PRX_DTM_CONTROL_RSVD2_S)
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_RSVD3_S 9
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PRX3_GLPE_PRX_DTM_CONTROL_RSVD3_S)
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_BYPASS_S 8
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_CONTROL_BYPASS_S)
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_RSVD4_S 1
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PRX3_GLPE_PRX_DTM_CONTROL_RSVD4_S)
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PRX3_GLPE_PRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PRX3_GLPE_PRX_DTM_ECC_COR_ERR 0x43C050E8
#define IG3_PRX3_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PRX3_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX3_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PRX3_GLPE_PRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PRX3_GLPE_PRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PRX3_GLPE_PRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PRX3_GLPE_PRX_DTM_ECC_UNCOR_ERR 0x43C050E4
#define IG3_PRX3_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PRX3_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX3_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PRX3_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PRX3_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PRX3_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PRX3_GLPE_PRX_DTM_GROUP_CFG 0x43C0508C
#define IG3_PRX3_GLPE_PRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PRX3_GLPE_PRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PRX3_GLPE_PRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PRX3_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX3_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PRX3_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PRX3_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX3_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PRX3_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PRX3_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX3_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PRX3_GLPE_PRX_DTM_LOG_CFG 0x43C05090
#define IG3_PRX3_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PRX3_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PRX3_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PRX3_GLPE_PRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PRX3_GLPE_PRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PRX3_GLPE_PRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_DTM_LOG_CFG_MODE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PRX3_GLPE_PRX_DTM_LOG_CFG_MODE_S)
#define IG3_PRX3_GLPE_PRX_DTM_LOG_MASK 0x43C05098
#define IG3_PRX3_GLPE_PRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX3_GLPE_PRX_DTM_LOG_MASK_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_LOG_PATTERN 0x43C05094
#define IG3_PRX3_GLPE_PRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX3_GLPE_PRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG 0x43C05084
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_STS 0x43C05088
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PRX3_GLPE_PRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX3_GLPE_PRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PRX3_GLPE_PRX_DTM_TIMESTAMP 0x43C050B0
#define IG3_PRX3_GLPE_PRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX3_GLPE_PRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER 0x43C050B4
#define IG3_PRX3_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX3_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG 0x43C050DC
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS 0x43C050E0
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG 0x43C0509C
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PRX3_GLPE_PRX_DTM_TRIG_CFG_MODE_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_COUNT 0x43C050A8
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX3_GLPE_PRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_MASK 0x43C050A4
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX3_GLPE_PRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_PATTERN 0x43C050A0
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX3_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_TIMESTAMP 0x43C050AC
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PRX3_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX3_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_CTL 0x43C05024
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_S 12
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_S)
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_S 0
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_S)
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA 0x43C05028
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_S 31
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_S)
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_S 30
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_M RDMA_BIT2(32, IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_S)
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_S 24
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_S)
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_S 20
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_S)
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_S 0
#define IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX3_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_S)
#define IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL 0x43C08018
#define IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_S 21
#define IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_M RDMA_MASK3(32, 0x7FF, IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_S)
#define IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_S 16
#define IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_S)
#define IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_S 13
#define IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_S 8
#define IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_S)
#define IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_S 5
#define IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_S)
#define IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_S 0
#define IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX3_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_S)
#define IG3_WRX3_GLPE_WRX_CONFIG 0x43C08000
#define IG3_WRX3_GLPE_WRX_CONFIG_RSVD_S 8
#define IG3_WRX3_GLPE_WRX_CONFIG_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WRX3_GLPE_WRX_CONFIG_RSVD_S)
#define IG3_WRX3_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_S 5
#define IG3_WRX3_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_M RDMA_MASK3(32, 0x7, IG3_WRX3_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_S)
#define IG3_WRX3_GLPE_WRX_CONFIG_DIS_WQE_CACHE_S 4
#define IG3_WRX3_GLPE_WRX_CONFIG_DIS_WQE_CACHE_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_CONFIG_DIS_WQE_CACHE_S)
#define IG3_WRX3_GLPE_WRX_CONFIG_DROP_OOO_IMMED_S 3
#define IG3_WRX3_GLPE_WRX_CONFIG_DROP_OOO_IMMED_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_CONFIG_DROP_OOO_IMMED_S)
#define IG3_WRX3_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_S 2
#define IG3_WRX3_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_S)
#define IG3_WRX3_GLPE_WRX_CONFIG_DIS_Q1_AE_S 1
#define IG3_WRX3_GLPE_WRX_CONFIG_DIS_Q1_AE_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_CONFIG_DIS_Q1_AE_S)
#define IG3_WRX3_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_S 0
#define IG3_WRX3_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_S)
#define IG3_WRX3_GLPE_WRX_DOMAIN_IDS 0x43C08014
#define IG3_WRX3_GLPE_WRX_DOMAIN_IDS_RSVD2_S 11
#define IG3_WRX3_GLPE_WRX_DOMAIN_IDS_RSVD2_M RDMA_MASK3(32, 0x1FFFFF, IG3_WRX3_GLPE_WRX_DOMAIN_IDS_RSVD2_S)
#define IG3_WRX3_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_S 8
#define IG3_WRX3_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX3_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_S)
#define IG3_WRX3_GLPE_WRX_DOMAIN_IDS_RSVD1_S 7
#define IG3_WRX3_GLPE_WRX_DOMAIN_IDS_RSVD1_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DOMAIN_IDS_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_S 4
#define IG3_WRX3_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX3_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_S)
#define IG3_WRX3_GLPE_WRX_DOMAIN_IDS_RSVD0_S 3
#define IG3_WRX3_GLPE_WRX_DOMAIN_IDS_RSVD0_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DOMAIN_IDS_RSVD0_S)
#define IG3_WRX3_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_S 0
#define IG3_WRX3_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX3_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_S)
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_COUNT 0x43C080B8
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX3_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX3_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_CMD 0x43C080CC
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_DATA_H 0x43C080D8
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_DATA_L 0x43C080D4
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_PTR 0x43C080D0
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX3_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_CMD 0x43C080BC
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_DATA_H 0x43C080C8
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_DATA_L 0x43C080C4
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_PTR 0x43C080C0
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX3_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL 0x43C08080
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_RSVD1_S 25
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_WRX3_GLPE_WRX_DTM_CONTROL_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_RSVD2_S 17
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX3_GLPE_WRX_DTM_CONTROL_RSVD2_S)
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_RSVD3_S 9
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_WRX3_GLPE_WRX_DTM_CONTROL_RSVD3_S)
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_BYPASS_S 8
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_CONTROL_BYPASS_S)
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_RSVD4_S 1
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_WRX3_GLPE_WRX_DTM_CONTROL_RSVD4_S)
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_WRX3_GLPE_WRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_WRX3_GLPE_WRX_DTM_ECC_COR_ERR 0x43C080E8
#define IG3_WRX3_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_WRX3_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX3_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_WRX3_GLPE_WRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_WRX3_GLPE_WRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WRX3_GLPE_WRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_WRX3_GLPE_WRX_DTM_ECC_UNCOR_ERR 0x43C080E4
#define IG3_WRX3_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_WRX3_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX3_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_WRX3_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_WRX3_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WRX3_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_WRX3_GLPE_WRX_DTM_GROUP_CFG 0x43C0808C
#define IG3_WRX3_GLPE_WRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_WRX3_GLPE_WRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WRX3_GLPE_WRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_WRX3_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX3_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_WRX3_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_WRX3_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX3_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_WRX3_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_WRX3_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX3_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_WRX3_GLPE_WRX_DTM_LOG_CFG 0x43C08090
#define IG3_WRX3_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_WRX3_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_WRX3_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_WRX3_GLPE_WRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_WRX3_GLPE_WRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_WRX3_GLPE_WRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_DTM_LOG_CFG_MODE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_WRX3_GLPE_WRX_DTM_LOG_CFG_MODE_S)
#define IG3_WRX3_GLPE_WRX_DTM_LOG_MASK 0x43C08098
#define IG3_WRX3_GLPE_WRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_DTM_LOG_MASK_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_LOG_PATTERN 0x43C08094
#define IG3_WRX3_GLPE_WRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG 0x43C08084
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_STS 0x43C08088
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_WRX3_GLPE_WRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX3_GLPE_WRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_WRX3_GLPE_WRX_DTM_TIMESTAMP 0x43C080B0
#define IG3_WRX3_GLPE_WRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER 0x43C080B4
#define IG3_WRX3_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG 0x43C080DC
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS 0x43C080E0
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG 0x43C0809C
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_WRX3_GLPE_WRX_DTM_TRIG_CFG_MODE_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_COUNT 0x43C080A8
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_MASK 0x43C080A4
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_PATTERN 0x43C080A0
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_TIMESTAMP 0x43C080AC
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_WRX3_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHHI 0x43C08020
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WRX3_GLPE_WRX_FWQPFLUSHHI_RSVD0_S)
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHHI_QPID_S 6
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX3_GLPE_WRX_FWQPFLUSHHI_QPID_S)
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WRX3_GLPE_WRX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO 0x43C0801C
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_BUSY_S 31
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_BUSY_S)
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_RSVD0_S)
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_HOSTID_S)
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_PMF_S 0
#define IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WRX3_GLPE_WRX_FWQPFLUSHLO_PMF_S)
#define IG3_WRX3_GLPE_WRX_RQ_CACHE_CTRL 0x43C08004
#define IG3_WRX3_GLPE_WRX_RQ_CACHE_CTRL_RSVD_S 7
#define IG3_WRX3_GLPE_WRX_RQ_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x1FFFFFF, IG3_WRX3_GLPE_WRX_RQ_CACHE_CTRL_RSVD_S)
#define IG3_WRX3_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_S 0
#define IG3_WRX3_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_M RDMA_MASK3(32, 0x7F, IG3_WRX3_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_S)
#define IG3_WRX3_GLPE_WRX_RQ_CACHE_DATA0 0x43C08008
#define IG3_WRX3_GLPE_WRX_RQ_CACHE_DATA0_DATA_S 0
#define IG3_WRX3_GLPE_WRX_RQ_CACHE_DATA0_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_RQ_CACHE_DATA0_DATA_S)
#define IG3_WRX3_GLPE_WRX_RQ_CACHE_DATA1 0x43C0800C
#define IG3_WRX3_GLPE_WRX_RQ_CACHE_DATA1_DATA_S 0
#define IG3_WRX3_GLPE_WRX_RQ_CACHE_DATA1_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_RQ_CACHE_DATA1_DATA_S)
#define IG3_WRX3_GLPE_WRX_RQ_CACHE_DATA2 0x43C08010
#define IG3_WRX3_GLPE_WRX_RQ_CACHE_DATA2_DATA_S 0
#define IG3_WRX3_GLPE_WRX_RQ_CACHE_DATA2_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX3_GLPE_WRX_RQ_CACHE_DATA2_DATA_S)
#define IG3_SQC3_GLPE_SQC_CONFIG 0x43C08470
#define IG3_SQC3_GLPE_SQC_CONFIG_RSVD_S 6
#define IG3_SQC3_GLPE_SQC_CONFIG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_SQC3_GLPE_SQC_CONFIG_RSVD_S)
#define IG3_SQC3_GLPE_SQC_CONFIG_DBL_INDV_DIS_S 3
#define IG3_SQC3_GLPE_SQC_CONFIG_DBL_INDV_DIS_M RDMA_MASK3(32, 0x7, IG3_SQC3_GLPE_SQC_CONFIG_DBL_INDV_DIS_S)
#define IG3_SQC3_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_S 2
#define IG3_SQC3_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_S)
#define IG3_SQC3_GLPE_SQC_CONFIG_DBL_DIS_S 1
#define IG3_SQC3_GLPE_SQC_CONFIG_DBL_DIS_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_CONFIG_DBL_DIS_S)
#define IG3_SQC3_GLPE_SQC_CONFIG_COALESCE_DIS_S 0
#define IG3_SQC3_GLPE_SQC_CONFIG_COALESCE_DIS_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_CONFIG_COALESCE_DIS_S)
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_COUNT 0x43C084B8
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC3_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC3_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_CMD 0x43C084CC
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_DATA_H 0x43C084D8
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_DATA_L 0x43C084D4
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_PTR 0x43C084D0
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC3_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_CMD 0x43C084BC
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_DATA_H 0x43C084C8
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_DATA_L 0x43C084C4
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_PTR 0x43C084C0
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC3_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL 0x43C08480
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_RSVD1_S 25
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SQC3_GLPE_SQC_DTM_CONTROL_RSVD1_S)
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_RSVD2_S 17
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC3_GLPE_SQC_DTM_CONTROL_RSVD2_S)
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_RSVD3_S 9
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SQC3_GLPE_SQC_DTM_CONTROL_RSVD3_S)
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_BYPASS_S 8
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_CONTROL_BYPASS_S)
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_RSVD4_S 1
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SQC3_GLPE_SQC_DTM_CONTROL_RSVD4_S)
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SQC3_GLPE_SQC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SQC3_GLPE_SQC_DTM_ECC_COR_ERR 0x43C084E8
#define IG3_SQC3_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SQC3_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC3_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SQC3_GLPE_SQC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SQC3_GLPE_SQC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC3_GLPE_SQC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SQC3_GLPE_SQC_DTM_ECC_UNCOR_ERR 0x43C084E4
#define IG3_SQC3_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SQC3_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC3_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SQC3_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SQC3_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC3_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SQC3_GLPE_SQC_DTM_GROUP_CFG 0x43C0848C
#define IG3_SQC3_GLPE_SQC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SQC3_GLPE_SQC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SQC3_GLPE_SQC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SQC3_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SQC3_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC3_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SQC3_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SQC3_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC3_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SQC3_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SQC3_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC3_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SQC3_GLPE_SQC_DTM_LOG_CFG 0x43C08490
#define IG3_SQC3_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SQC3_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SQC3_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SQC3_GLPE_SQC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SQC3_GLPE_SQC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SQC3_GLPE_SQC_DTM_LOG_CFG_RSVD1_S)
#define IG3_SQC3_GLPE_SQC_DTM_LOG_CFG_MODE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SQC3_GLPE_SQC_DTM_LOG_CFG_MODE_S)
#define IG3_SQC3_GLPE_SQC_DTM_LOG_MASK 0x43C08498
#define IG3_SQC3_GLPE_SQC_DTM_LOG_MASK_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC3_GLPE_SQC_DTM_LOG_MASK_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_LOG_PATTERN 0x43C08494
#define IG3_SQC3_GLPE_SQC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC3_GLPE_SQC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG 0x43C08484
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_STS 0x43C08488
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SQC3_GLPE_SQC_DTM_MAIN_STS_RSVD1_S)
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC3_GLPE_SQC_DTM_MAIN_STS_RSVD2_S)
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SQC3_GLPE_SQC_DTM_TIMESTAMP 0x43C084B0
#define IG3_SQC3_GLPE_SQC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC3_GLPE_SQC_DTM_TIMESTAMP_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER 0x43C084B4
#define IG3_SQC3_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC3_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG 0x43C084DC
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS 0x43C084E0
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG 0x43C0849C
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_MODE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SQC3_GLPE_SQC_DTM_TRIG_CFG_MODE_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_COUNT 0x43C084A8
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC3_GLPE_SQC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_MASK 0x43C084A4
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC3_GLPE_SQC_DTM_TRIG_MASK_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_PATTERN 0x43C084A0
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC3_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_TIMESTAMP 0x43C084AC
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SQC3_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC3_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHHI 0x43C08460
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_S 26
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_S)
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHHI_QPID_S 6
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHHI_QPID_S)
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_S 0
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_S)
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO 0x43C08464
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_S 31
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_S)
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_S 30
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_S)
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_S 29
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_S)
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_S 26
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_S)
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_S)
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_PMF_S 0
#define IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC3_GLPE_SQC_FWFLRQPFLUSHLO_PMF_S)
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPHI(_i) 0x43C08420 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPHI_MAX_INDEX_I 7
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPHI_RSVD0_S 26
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_SQC3_GLPE_SQC_FWFLUSHDROPHI_RSVD0_S)
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPHI_QPID_S 6
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC3_GLPE_SQC_FWFLUSHDROPHI_QPID_S)
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_S 0
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_SQC3_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_S)
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO(_i) 0x43C08400 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_MAX_INDEX_I 7
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_EN_S 31
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_EN_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_EN_S)
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_RSVD0_S 29
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_RSVD0_S)
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_HOSTID_S 26
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_HOSTID_S)
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_S 24
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_S)
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_S 12
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_S)
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_PMF_S 0
#define IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC3_GLPE_SQC_FWFLUSHDROPLO_PMF_S)
#define IG3_SQC3_GLPE_SQC_FWSYNCRESP(_i) 0x43C08468 + ((_i) * 4) /* _i=0...1 */
#define IG3_SQC3_GLPE_SQC_FWSYNCRESP_MAX_INDEX_I 1
#define IG3_SQC3_GLPE_SQC_FWSYNCRESP_RSVD_S 18
#define IG3_SQC3_GLPE_SQC_FWSYNCRESP_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_SQC3_GLPE_SQC_FWSYNCRESP_RSVD_S)
#define IG3_SQC3_GLPE_SQC_FWSYNCRESP_COUNT_S 8
#define IG3_SQC3_GLPE_SQC_FWSYNCRESP_COUNT_M RDMA_MASK3(32, 0x3FF, IG3_SQC3_GLPE_SQC_FWSYNCRESP_COUNT_S)
#define IG3_SQC3_GLPE_SQC_FWSYNCRESP_TAG_S 0
#define IG3_SQC3_GLPE_SQC_FWSYNCRESP_TAG_M RDMA_MASK3(32, 0xFF, IG3_SQC3_GLPE_SQC_FWSYNCRESP_TAG_S)
#define IG3_SQC3_GLPE_SQC_XLR_DROP(_i) 0x43C08440 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC3_GLPE_SQC_XLR_DROP_MAX_INDEX_I 7
#define IG3_SQC3_GLPE_SQC_XLR_DROP_EN_S 31
#define IG3_SQC3_GLPE_SQC_XLR_DROP_EN_M RDMA_BIT2(32, IG3_SQC3_GLPE_SQC_XLR_DROP_EN_S)
#define IG3_SQC3_GLPE_SQC_XLR_DROP_RSVD0_S 12
#define IG3_SQC3_GLPE_SQC_XLR_DROP_RSVD0_M RDMA_MASK3(32, 0x7FFFF, IG3_SQC3_GLPE_SQC_XLR_DROP_RSVD0_S)
#define IG3_SQC3_GLPE_SQC_XLR_DROP_PMF_S 0
#define IG3_SQC3_GLPE_SQC_XLR_DROP_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC3_GLPE_SQC_XLR_DROP_PMF_S)
#define IG3_SQC3_SQC_ECC_COR_ERR 0x43C08514
#define IG3_SQC3_SQC_ECC_COR_ERR_RSVD_S 12
#define IG3_SQC3_SQC_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC3_SQC_ECC_COR_ERR_RSVD_S)
#define IG3_SQC3_SQC_ECC_COR_ERR_CNT_S 0
#define IG3_SQC3_SQC_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC3_SQC_ECC_COR_ERR_CNT_S)
#define IG3_SQC3_SQC_ECC_UNCOR_ERR 0x43C08510
#define IG3_SQC3_SQC_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SQC3_SQC_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC3_SQC_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SQC3_SQC_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SQC3_SQC_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC3_SQC_ECC_UNCOR_ERR_CNT_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG 0x43C08500
#define IG3_SQC3_SQC_WRK_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_SQC3_SQC_WRK_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC3_SQC_WRK_RAM_CFG_ECC_INST_NUM_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_RSVD3_S 20
#define IG3_SQC3_SQC_WRK_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC3_SQC_WRK_RAM_CFG_RSVD3_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_RM_S 16
#define IG3_SQC3_SQC_WRK_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC3_SQC_WRK_RAM_CFG_RM_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_RSVD2_S 14
#define IG3_SQC3_SQC_WRK_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC3_SQC_WRK_RAM_CFG_RSVD2_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_SQC3_SQC_WRK_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC3_SQC_WRK_RAM_CFG_POWER_GATE_EN_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_RME_S 12
#define IG3_SQC3_SQC_WRK_RAM_CFG_RME_M RDMA_BIT2(32, IG3_SQC3_SQC_WRK_RAM_CFG_RME_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_RSVD1_S 10
#define IG3_SQC3_SQC_WRK_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC3_SQC_WRK_RAM_CFG_RSVD1_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_ERR_CNT_S 9
#define IG3_SQC3_SQC_WRK_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC3_SQC_WRK_RAM_CFG_ERR_CNT_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_FIX_CNT_S 8
#define IG3_SQC3_SQC_WRK_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC3_SQC_WRK_RAM_CFG_FIX_CNT_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_RSVD0_S 6
#define IG3_SQC3_SQC_WRK_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC3_SQC_WRK_RAM_CFG_RSVD0_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_MASK_INT_S 5
#define IG3_SQC3_SQC_WRK_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC3_SQC_WRK_RAM_CFG_MASK_INT_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_LS_BYPASS_S 4
#define IG3_SQC3_SQC_WRK_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC3_SQC_WRK_RAM_CFG_LS_BYPASS_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_LS_FORCE_S 3
#define IG3_SQC3_SQC_WRK_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC3_SQC_WRK_RAM_CFG_LS_FORCE_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_SQC3_SQC_WRK_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC3_SQC_WRK_RAM_CFG_ECC_INVERT_2_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_SQC3_SQC_WRK_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC3_SQC_WRK_RAM_CFG_ECC_INVERT_1_S)
#define IG3_SQC3_SQC_WRK_RAM_CFG_ECC_EN_S 0
#define IG3_SQC3_SQC_WRK_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC3_SQC_WRK_RAM_CFG_ECC_EN_S)
#define IG3_SQC3_SQC_WRK_RAM_STATUS 0x43C08504
#define IG3_SQC3_SQC_WRK_RAM_STATUS_RSVD1_S 30
#define IG3_SQC3_SQC_WRK_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC3_SQC_WRK_RAM_STATUS_RSVD1_S)
#define IG3_SQC3_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC3_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC3_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC3_SQC_WRK_RAM_STATUS_RSVD0_S 4
#define IG3_SQC3_SQC_WRK_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC3_SQC_WRK_RAM_STATUS_RSVD0_S)
#define IG3_SQC3_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC3_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC3_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC3_SQC_WRK_RAM_STATUS_INIT_DONE_S 2
#define IG3_SQC3_SQC_WRK_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC3_SQC_WRK_RAM_STATUS_INIT_DONE_S)
#define IG3_SQC3_SQC_WRK_RAM_STATUS_ECC_FIX_S 1
#define IG3_SQC3_SQC_WRK_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC3_SQC_WRK_RAM_STATUS_ECC_FIX_S)
#define IG3_SQC3_SQC_WRK_RAM_STATUS_ECC_ERR_S 0
#define IG3_SQC3_SQC_WRK_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC3_SQC_WRK_RAM_STATUS_ECC_ERR_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG 0x43C08508
#define IG3_SQC3_SQC_XBUF_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_SQC3_SQC_XBUF_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC3_SQC_XBUF_RAM_CFG_ECC_INST_NUM_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_RSVD3_S 20
#define IG3_SQC3_SQC_XBUF_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC3_SQC_XBUF_RAM_CFG_RSVD3_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_RM_S 16
#define IG3_SQC3_SQC_XBUF_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC3_SQC_XBUF_RAM_CFG_RM_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_RSVD2_S 14
#define IG3_SQC3_SQC_XBUF_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC3_SQC_XBUF_RAM_CFG_RSVD2_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_SQC3_SQC_XBUF_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC3_SQC_XBUF_RAM_CFG_POWER_GATE_EN_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_RME_S 12
#define IG3_SQC3_SQC_XBUF_RAM_CFG_RME_M RDMA_BIT2(32, IG3_SQC3_SQC_XBUF_RAM_CFG_RME_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_RSVD1_S 10
#define IG3_SQC3_SQC_XBUF_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC3_SQC_XBUF_RAM_CFG_RSVD1_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_ERR_CNT_S 9
#define IG3_SQC3_SQC_XBUF_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC3_SQC_XBUF_RAM_CFG_ERR_CNT_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_FIX_CNT_S 8
#define IG3_SQC3_SQC_XBUF_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC3_SQC_XBUF_RAM_CFG_FIX_CNT_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_RSVD0_S 6
#define IG3_SQC3_SQC_XBUF_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC3_SQC_XBUF_RAM_CFG_RSVD0_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_MASK_INT_S 5
#define IG3_SQC3_SQC_XBUF_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC3_SQC_XBUF_RAM_CFG_MASK_INT_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_LS_BYPASS_S 4
#define IG3_SQC3_SQC_XBUF_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC3_SQC_XBUF_RAM_CFG_LS_BYPASS_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_LS_FORCE_S 3
#define IG3_SQC3_SQC_XBUF_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC3_SQC_XBUF_RAM_CFG_LS_FORCE_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_SQC3_SQC_XBUF_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC3_SQC_XBUF_RAM_CFG_ECC_INVERT_2_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_SQC3_SQC_XBUF_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC3_SQC_XBUF_RAM_CFG_ECC_INVERT_1_S)
#define IG3_SQC3_SQC_XBUF_RAM_CFG_ECC_EN_S 0
#define IG3_SQC3_SQC_XBUF_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC3_SQC_XBUF_RAM_CFG_ECC_EN_S)
#define IG3_SQC3_SQC_XBUF_RAM_STATUS 0x43C0850C
#define IG3_SQC3_SQC_XBUF_RAM_STATUS_RSVD1_S 30
#define IG3_SQC3_SQC_XBUF_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC3_SQC_XBUF_RAM_STATUS_RSVD1_S)
#define IG3_SQC3_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC3_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC3_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC3_SQC_XBUF_RAM_STATUS_RSVD0_S 4
#define IG3_SQC3_SQC_XBUF_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC3_SQC_XBUF_RAM_STATUS_RSVD0_S)
#define IG3_SQC3_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC3_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC3_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC3_SQC_XBUF_RAM_STATUS_INIT_DONE_S 2
#define IG3_SQC3_SQC_XBUF_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC3_SQC_XBUF_RAM_STATUS_INIT_DONE_S)
#define IG3_SQC3_SQC_XBUF_RAM_STATUS_ECC_FIX_S 1
#define IG3_SQC3_SQC_XBUF_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC3_SQC_XBUF_RAM_STATUS_ECC_FIX_S)
#define IG3_SQC3_SQC_XBUF_RAM_STATUS_ECC_ERR_S 0
#define IG3_SQC3_SQC_XBUF_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC3_SQC_XBUF_RAM_STATUS_ECC_ERR_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DOMAIN_ID 0x43C08804
#define IG3_SFPRX3_GLPE_SFP_RX_DOMAIN_ID_RSVD_S 3
#define IG3_SFPRX3_GLPE_SFP_RX_DOMAIN_ID_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DOMAIN_ID_RSVD_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_SFPRX3_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_COUNT 0x43C088B8
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_CMD 0x43C088CC
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H 0x43C088D8
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L 0x43C088D4
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_PTR 0x43C088D0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_CMD 0x43C088BC
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H 0x43C088C8
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L 0x43C088C4
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_PTR 0x43C088C0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL 0x43C08880
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_RSVD1_S 25
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_RSVD1_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_RSVD2_S 17
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_RSVD2_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_RSVD3_S 9
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_RSVD3_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_BYPASS_S 8
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_BYPASS_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_RSVD4_S 1
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_RSVD4_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_ECC_COR_ERR 0x43C088E8
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR 0x43C088E4
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_GROUP_CFG 0x43C0888C
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_CFG 0x43C08890
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_CFG_MODE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_CFG_MODE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_MASK 0x43C08898
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_PATTERN 0x43C08894
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG 0x43C08884
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_STS 0x43C08888
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TIMESTAMP 0x43C088B0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER 0x43C088B4
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG 0x43C088DC
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS 0x43C088E0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG 0x43C0889C
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_COUNT 0x43C088A8
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_MASK 0x43C088A4
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_PATTERN 0x43C088A0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP 0x43C088AC
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SFPRX3_GLPE_SFP_RX_ERR_TBL_CLR 0x43C08800
#define IG3_SFPRX3_GLPE_SFP_RX_ERR_TBL_CLR_REQ_S 31
#define IG3_SFPRX3_GLPE_SFP_RX_ERR_TBL_CLR_REQ_M RDMA_BIT2(32, IG3_SFPRX3_GLPE_SFP_RX_ERR_TBL_CLR_REQ_S)
#define IG3_SFPRX3_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_S 12
#define IG3_SFPRX3_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_SFPRX3_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_S)
#define IG3_SFPRX3_GLPE_SFP_RX_ERR_TBL_CLR_PMF_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_ERR_TBL_CLR_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX3_GLPE_SFP_RX_ERR_TBL_CLR_PMF_S)
#define IG3_SFPRX3_GLPE_SFP_RX_PER_MEM 0x43C08808
#define IG3_SFPRX3_GLPE_SFP_RX_PER_MEM_RSVD_S 3
#define IG3_SFPRX3_GLPE_SFP_RX_PER_MEM_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPRX3_GLPE_SFP_RX_PER_MEM_RSVD_S)
#define IG3_SFPRX3_GLPE_SFP_RX_PER_MEM_PER_TYPE_S 0
#define IG3_SFPRX3_GLPE_SFP_RX_PER_MEM_PER_TYPE_M RDMA_MASK3(32, 0x7, IG3_SFPRX3_GLPE_SFP_RX_PER_MEM_PER_TYPE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG 0x43C08C08
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS 0x43C08C0C
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ECC_COR_ERR 0x43C08C34
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR 0x43C08C30
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG 0x43C08C18
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS 0x43C08C1C
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG 0x43C08C20
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS 0x43C08C24
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG 0x43C08C00
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS 0x43C08C04
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG 0x43C08C28
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS 0x43C08C2C
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG 0x43C08C10
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS 0x43C08C14
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG 0x43C08C48
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS 0x43C08C4C
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG 0x43C08C40
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS 0x43C08C44
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG 0x43C08C78
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS 0x43C08C7C
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG 0x43C08C50
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS 0x43C08C54
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG 0x43C08C58
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS 0x43C08C5C
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR 0x43C08C84
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR 0x43C08C80
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG 0x43C08C70
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS 0x43C08C74
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG 0x43C08C60
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS 0x43C08C64
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG 0x43C08C68
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS 0x43C08C6C
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG 0x43C08C38
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS 0x43C08C3C
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_ECC_COR_ERR 0x43C08CCC
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR 0x43C08CC8
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG 0x43C08CD8
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS 0x43C08CDC
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL 0x43C08C90
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_S 31
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_S 26
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_S 18
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA 0x43C08C94
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG 0x43C08C88
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS 0x43C08C8C
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL 0x43C08CA0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_S 31
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_S 26
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA 0x43C08CA4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG 0x43C08C98
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS 0x43C08C9C
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL 0x43C08CB0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_S 31
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_S 26
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_S 18
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA 0x43C08CB4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG 0x43C08CA8
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS 0x43C08CAC
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL 0x43C08CC0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_S 31
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_S 26
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_S 18
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA 0x43C08CC4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG 0x43C08CB8
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS 0x43C08CBC
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG 0x43C08CD0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS 0x43C08CD4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_WTX3_GLPE_WTX_1USCOUNT 0x43C10010
#define IG3_WTX3_GLPE_WTX_1USCOUNT_CNT_S 0
#define IG3_WTX3_GLPE_WTX_1USCOUNT_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_1USCOUNT_CNT_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0 0x43C10120
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_TAG_S 16
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_TAG_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_MODE_S 11
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_MODE_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1 0x43C10124
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_PMF_S 0
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG1_PMF_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG2 0x43C10128
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG2_QPID_S 6
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG2_QPID_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG3 0x43C1012C
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG4 0x43C10130
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_S 0
#define IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_S)
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG 0x43C10020
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG_RSVD3_S 24
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG_RSVD3_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_ARB_CONFIG_RSVD3_S)
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG_RSVD2_S 20
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WTX3_GLPE_WTX_ARB_CONFIG_RSVD2_S)
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_S 16
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX3_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_S)
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG_RSVD1_S 12
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_WTX3_GLPE_WTX_ARB_CONFIG_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_S 8
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX3_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_S)
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG_RSVD0_S 4
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG_RSVD0_M RDMA_MASK3(32, 0xF, IG3_WTX3_GLPE_WTX_ARB_CONFIG_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_S 0
#define IG3_WTX3_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX3_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0 0x43C100F8
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_TAG_S 16
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_TAG_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_MODE_S 11
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_MODE_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1 0x43C100FC
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_PMF_S 0
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG1_PMF_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG2 0x43C10100
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG2_QPID_S 6
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG2_QPID_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG3 0x43C10104
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG4 0x43C10108
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG4_COUNT_S 0
#define IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_CMP_DTM_TRIG4_COUNT_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG 0x43C1017C
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_S 31
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_S 27
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_S 26
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX 0x43C10180
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_CNPCOUNT 0x43C10014
#define IG3_WTX3_GLPE_WTX_CNPCOUNT_CNT_S 0
#define IG3_WTX3_GLPE_WTX_CNPCOUNT_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_CNPCOUNT_CNT_S)
#define IG3_WTX3_GLPE_WTX_CONFIG 0x43C1000C
#define IG3_WTX3_GLPE_WTX_CONFIG_RSVD1_S 28
#define IG3_WTX3_GLPE_WTX_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_WTX3_GLPE_WTX_CONFIG_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_CONFIG_SQ_HSM_ORD_S 25
#define IG3_WTX3_GLPE_WTX_CONFIG_SQ_HSM_ORD_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_CONFIG_SQ_HSM_ORD_S)
#define IG3_WTX3_GLPE_WTX_CONFIG_SQ_WQE_ORD_S 22
#define IG3_WTX3_GLPE_WTX_CONFIG_SQ_WQE_ORD_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_CONFIG_SQ_WQE_ORD_S)
#define IG3_WTX3_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_S 21
#define IG3_WTX3_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_S)
#define IG3_WTX3_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_S 20
#define IG3_WTX3_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_S)
#define IG3_WTX3_GLPE_WTX_CONFIG_RSVD0_S 4
#define IG3_WTX3_GLPE_WTX_CONFIG_RSVD0_M RDMA_MASK3(32, 0xFFFF, IG3_WTX3_GLPE_WTX_CONFIG_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_S 3
#define IG3_WTX3_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_S)
#define IG3_WTX3_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_S 2
#define IG3_WTX3_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_S)
#define IG3_WTX3_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_S 1
#define IG3_WTX3_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_S)
#define IG3_WTX3_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_S 0
#define IG3_WTX3_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG0 0x43C1003C
#define IG3_WTX3_GLPE_WTX_CTCONFIG0_RSVD_S 21
#define IG3_WTX3_GLPE_WTX_CTCONFIG0_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_WTX3_GLPE_WTX_CTCONFIG0_RSVD_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG0_SCHED_S 0
#define IG3_WTX3_GLPE_WTX_CTCONFIG0_SCHED_M RDMA_MASK3(32, 0x1FFFFF, IG3_WTX3_GLPE_WTX_CTCONFIG0_SCHED_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG1 0x43C10040
#define IG3_WTX3_GLPE_WTX_CTCONFIG1_RSVD_S 21
#define IG3_WTX3_GLPE_WTX_CTCONFIG1_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_WTX3_GLPE_WTX_CTCONFIG1_RSVD_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG1_VMRL_S 0
#define IG3_WTX3_GLPE_WTX_CTCONFIG1_VMRL_M RDMA_MASK3(32, 0x1FFFFF, IG3_WTX3_GLPE_WTX_CTCONFIG1_VMRL_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG2 0x43C10044
#define IG3_WTX3_GLPE_WTX_CTCONFIG2_RSVD_S 30
#define IG3_WTX3_GLPE_WTX_CTCONFIG2_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_CTCONFIG2_RSVD_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_S 16
#define IG3_WTX3_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_S 0
#define IG3_WTX3_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX3_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG3 0x43C10048
#define IG3_WTX3_GLPE_WTX_CTCONFIG3_RSVD_S 30
#define IG3_WTX3_GLPE_WTX_CTCONFIG3_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_CTCONFIG3_RSVD_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_S 16
#define IG3_WTX3_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_S 0
#define IG3_WTX3_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX3_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG4 0x43C1004C
#define IG3_WTX3_GLPE_WTX_CTCONFIG4_RSVD_S 30
#define IG3_WTX3_GLPE_WTX_CTCONFIG4_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_CTCONFIG4_RSVD_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_S 16
#define IG3_WTX3_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_S 0
#define IG3_WTX3_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX3_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG5 0x43C10050
#define IG3_WTX3_GLPE_WTX_CTCONFIG5_RSVD_S 20
#define IG3_WTX3_GLPE_WTX_CTCONFIG5_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_CTCONFIG5_RSVD_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG5_BMPKT_S 0
#define IG3_WTX3_GLPE_WTX_CTCONFIG5_BMPKT_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX3_GLPE_WTX_CTCONFIG5_BMPKT_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG6 0x43C10054
#define IG3_WTX3_GLPE_WTX_CTCONFIG6_RSVD_S 13
#define IG3_WTX3_GLPE_WTX_CTCONFIG6_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_WTX3_GLPE_WTX_CTCONFIG6_RSVD_S)
#define IG3_WTX3_GLPE_WTX_CTCONFIG6_BMHDR_S 0
#define IG3_WTX3_GLPE_WTX_CTCONFIG6_BMHDR_M RDMA_MASK3(32, 0x1FFF, IG3_WTX3_GLPE_WTX_CTCONFIG6_BMHDR_S)
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_COUNT 0x43C10238
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX3_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_CMD 0x43C1024C
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_DATA_H 0x43C10258
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_DATA_L 0x43C10254
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_PTR 0x43C10250
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX3_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_CMD 0x43C1023C
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_DATA_H 0x43C10248
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_DATA_L 0x43C10244
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_PTR 0x43C10240
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX3_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL 0x43C10200
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_RSVD1_S 25
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_WTX3_GLPE_WTX_DTM_CONTROL_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_RSVD2_S 17
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX3_GLPE_WTX_DTM_CONTROL_RSVD2_S)
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_RSVD3_S 9
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_WTX3_GLPE_WTX_DTM_CONTROL_RSVD3_S)
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_BYPASS_S 8
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_CONTROL_BYPASS_S)
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_RSVD4_S 1
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_WTX3_GLPE_WTX_DTM_CONTROL_RSVD4_S)
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_WTX3_GLPE_WTX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_WTX3_GLPE_WTX_DTM_ECC_COR_ERR 0x43C10268
#define IG3_WTX3_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX3_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_WTX3_GLPE_WTX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_WTX3_GLPE_WTX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_WTX3_GLPE_WTX_DTM_ECC_UNCOR_ERR 0x43C10264
#define IG3_WTX3_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX3_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_WTX3_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_WTX3_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_WTX3_GLPE_WTX_DTM_GROUP_CFG 0x43C1020C
#define IG3_WTX3_GLPE_WTX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_WTX3_GLPE_WTX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_WTX3_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_WTX3_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_WTX3_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_WTX3_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_WTX3_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_WTX3_GLPE_WTX_DTM_LOG_CFG 0x43C10210
#define IG3_WTX3_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_WTX3_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_WTX3_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_WTX3_GLPE_WTX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_WTX3_GLPE_WTX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_DTM_LOG_CFG_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_DTM_LOG_CFG_MODE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_DTM_LOG_CFG_MODE_S)
#define IG3_WTX3_GLPE_WTX_DTM_LOG_MASK 0x43C10218
#define IG3_WTX3_GLPE_WTX_DTM_LOG_MASK_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_DTM_LOG_MASK_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_LOG_PATTERN 0x43C10214
#define IG3_WTX3_GLPE_WTX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG 0x43C10204
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_STS 0x43C10208
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_WTX3_GLPE_WTX_DTM_MAIN_STS_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX3_GLPE_WTX_DTM_MAIN_STS_RSVD2_S)
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_WTX3_GLPE_WTX_DTM_TIMESTAMP 0x43C10230
#define IG3_WTX3_GLPE_WTX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_DTM_TIMESTAMP_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER 0x43C10234
#define IG3_WTX3_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG 0x43C1025C
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS 0x43C10260
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG 0x43C1021C
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_MODE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_WTX3_GLPE_WTX_DTM_TRIG_CFG_MODE_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_COUNT 0x43C10228
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_MASK 0x43C10224
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_DTM_TRIG_MASK_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_PATTERN 0x43C10220
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_TIMESTAMP 0x43C1022C
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_WTX3_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG 0x43C1014C
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_S 29
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_S 13
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_S 0
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG 0x43C10150
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_S 31
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_S 27
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_S 26
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX 0x43C10154
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHHI 0x43C1005C
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WTX3_GLPE_WTX_FWQPFLUSHHI_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHHI_QPID_S 6
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX3_GLPE_WTX_FWQPFLUSHHI_QPID_S)
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX3_GLPE_WTX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO 0x43C10058
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_BUSY_S 31
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_BUSY_S)
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_HOSTID_S)
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_PMF_S 0
#define IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_FWQPFLUSHLO_PMF_S)
#define IG3_WTX3_GLPE_WTX_HOST_READ_CONFIG 0x43C10038
#define IG3_WTX3_GLPE_WTX_HOST_READ_CONFIG_RSVD_S 8
#define IG3_WTX3_GLPE_WTX_HOST_READ_CONFIG_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX3_GLPE_WTX_HOST_READ_CONFIG_RSVD_S)
#define IG3_WTX3_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_S 0
#define IG3_WTX3_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0 0x43C1010C
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_S 16
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_S 11
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1 0x43C10110
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_S 0
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG2 0x43C10114
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_S 6
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG3 0x43C10118
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG4 0x43C1011C
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_S 0
#define IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG 0x43C1018C
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_S 31
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_S 27
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_S 26
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX 0x43C10190
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG 0x43C10194
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_S 31
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_S 27
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_S 26
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX 0x43C10198
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG 0x43C10184
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_S 31
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_S 27
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_S 26
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX 0x43C10188
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0 0x43C10090
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1 0x43C10094
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG2 0x43C10098
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG3 0x43C1009C
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG4 0x43C100A0
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0 0x43C10060
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1 0x43C10064
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG2 0x43C10068
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG3 0x43C1006C
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG4 0x43C10070
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG5 0x43C10074
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0 0x43C10078
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1 0x43C1007C
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG2 0x43C10080
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG3 0x43C10084
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG4 0x43C10088
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG5 0x43C1008C
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG 0x43C10134
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_S 29
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_S 13
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_S 0
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG 0x43C10138
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_S 31
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_S 27
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_S 26
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX 0x43C1013C
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG 0x43C10140
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_S 29
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_S 13
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_S 0
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG 0x43C10144
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_S 31
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_S 27
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_S 26
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX 0x43C10148
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG 0x43C10164
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_S 29
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_S 13
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_S 0
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG 0x43C10168
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_S 31
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_S 27
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_S 26
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX 0x43C1016C
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG 0x43C10158
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_S 29
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_S 13
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_S 0
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG 0x43C1015C
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_S 31
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_S 27
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_S 26
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX 0x43C10160
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0 0x43C100E4
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_S 16
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_S 11
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1 0x43C100E8
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_S 0
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG2 0x43C100EC
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_S 6
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG3 0x43C100F0
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG4 0x43C100F4
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_S 0
#define IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0 0x43C100D0
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_S 16
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_S 11
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1 0x43C100D4
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_S 0
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG2 0x43C100D8
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_S 6
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG3 0x43C100DC
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG4 0x43C100E0
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_S 0
#define IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_S)
#define IG3_WTX3_GLPE_WTX_SPADS_ASSIGNED(_i) 0x43C10000 + ((_i) * 4) /* _i=0...2 */
#define IG3_WTX3_GLPE_WTX_SPADS_ASSIGNED_MAX_INDEX_I 2
#define IG3_WTX3_GLPE_WTX_SPADS_ASSIGNED_SPAD3_S 24
#define IG3_WTX3_GLPE_WTX_SPADS_ASSIGNED_SPAD3_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPADS_ASSIGNED_SPAD3_S)
#define IG3_WTX3_GLPE_WTX_SPADS_ASSIGNED_SPAD2_S 16
#define IG3_WTX3_GLPE_WTX_SPADS_ASSIGNED_SPAD2_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPADS_ASSIGNED_SPAD2_S)
#define IG3_WTX3_GLPE_WTX_SPADS_ASSIGNED_SPAD1_S 8
#define IG3_WTX3_GLPE_WTX_SPADS_ASSIGNED_SPAD1_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPADS_ASSIGNED_SPAD1_S)
#define IG3_WTX3_GLPE_WTX_SPADS_ASSIGNED_SPAD0_S 0
#define IG3_WTX3_GLPE_WTX_SPADS_ASSIGNED_SPAD0_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPADS_ASSIGNED_SPAD0_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0 0x43C100A4
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_S 16
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_S 11
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1 0x43C100A8
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG2 0x43C100AC
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_S 6
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG3 0x43C100B0
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG4 0x43C100B4
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG5 0x43C100B8
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX3_GLPE_WTX_SPAD_CONFIG0 0x43C10024
#define IG3_WTX3_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_S 24
#define IG3_WTX3_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_S)
#define IG3_WTX3_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_S 16
#define IG3_WTX3_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_S)
#define IG3_WTX3_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_S 8
#define IG3_WTX3_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_S)
#define IG3_WTX3_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_S)
#define IG3_WTX3_GLPE_WTX_SPAD_CONFIG1 0x43C10028
#define IG3_WTX3_GLPE_WTX_SPAD_CONFIG1_RSVD_S 8
#define IG3_WTX3_GLPE_WTX_SPAD_CONFIG1_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX3_GLPE_WTX_SPAD_CONFIG1_RSVD_S)
#define IG3_WTX3_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_S)
#define IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS0 0x43C1002C
#define IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_S 24
#define IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_S)
#define IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_S 16
#define IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_S)
#define IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_S 8
#define IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_S)
#define IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_S)
#define IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS1 0x43C10030
#define IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_S 8
#define IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_S)
#define IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0 0x43C100BC
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_S 16
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_S 11
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1 0x43C100C0
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG2 0x43C100C4
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_S 6
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG3 0x43C100C8
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG4 0x43C100CC
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_S)
#define IG3_WTX3_GLPE_WTX_SPAD_QUEUE_PTR_CTL 0x43C10034
#define IG3_WTX3_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_S 16
#define IG3_WTX3_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_WTX3_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_S)
#define IG3_WTX3_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_S 8
#define IG3_WTX3_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_S)
#define IG3_WTX3_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_S)
#define IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL 0x43C10018
#define IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_RSVD1_S 20
#define IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_S 16
#define IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_M RDMA_MASK3(32, 0xF, IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_S)
#define IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_RSVD0_S 10
#define IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_S 8
#define IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_M RDMA_MASK3(32, 0x3, IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_S)
#define IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_M RDMA_MASK3(32, 0xFF, IG3_WTX3_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_S)
#define IG3_WTX3_GLPE_WTX_SPAD_STAT_DATA 0x43C1001C
#define IG3_WTX3_GLPE_WTX_SPAD_STAT_DATA_DATA_S 0
#define IG3_WTX3_GLPE_WTX_SPAD_STAT_DATA_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX3_GLPE_WTX_SPAD_STAT_DATA_DATA_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG 0x43C10170
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_S 29
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_S 13
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_S 0
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG 0x43C10174
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_S 31
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_S 27
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_S 26
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX 0x43C10178
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX3_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_PTX3_GLPE_ARPCONTROL 0x43C1400C
#define IG3_PTX3_GLPE_ARPCONTROL_ARP_LOCK_ACK_S 31
#define IG3_PTX3_GLPE_ARPCONTROL_ARP_LOCK_ACK_M RDMA_BIT2(32, IG3_PTX3_GLPE_ARPCONTROL_ARP_LOCK_ACK_S)
#define IG3_PTX3_GLPE_ARPCONTROL_ARP_LOCK_REQ_S 30
#define IG3_PTX3_GLPE_ARPCONTROL_ARP_LOCK_REQ_M RDMA_BIT2(32, IG3_PTX3_GLPE_ARPCONTROL_ARP_LOCK_REQ_S)
#define IG3_PTX3_GLPE_ARPCONTROL_RSVD_S 16
#define IG3_PTX3_GLPE_ARPCONTROL_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_PTX3_GLPE_ARPCONTROL_RSVD_S)
#define IG3_PTX3_GLPE_ARPCONTROL_ARP_LOCK_INDEX_S 0
#define IG3_PTX3_GLPE_ARPCONTROL_ARP_LOCK_INDEX_M RDMA_MASK3(32, 0xFFFF, IG3_PTX3_GLPE_ARPCONTROL_ARP_LOCK_INDEX_S)
#define IG3_PTX3_GLPE_CRT_CONFIG0 0x43C14010
#define IG3_PTX3_GLPE_CRT_CONFIG0_RSVD_S 25
#define IG3_PTX3_GLPE_CRT_CONFIG0_RSVD_M RDMA_MASK3(32, 0x7F, IG3_PTX3_GLPE_CRT_CONFIG0_RSVD_S)
#define IG3_PTX3_GLPE_CRT_CONFIG0_QP_FC_EN_S 24
#define IG3_PTX3_GLPE_CRT_CONFIG0_QP_FC_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_CRT_CONFIG0_QP_FC_EN_S)
#define IG3_PTX3_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_S 16
#define IG3_PTX3_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_S)
#define IG3_PTX3_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_S 8
#define IG3_PTX3_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_S)
#define IG3_PTX3_GLPE_CRT_CONFIG0_TX_BUF_SIZE_S 0
#define IG3_PTX3_GLPE_CRT_CONFIG0_TX_BUF_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_CRT_CONFIG0_TX_BUF_SIZE_S)
#define IG3_PTX3_GLPE_CRT_CONFIG1 0x43C14014
#define IG3_PTX3_GLPE_CRT_CONFIG1_RSVD_S 19
#define IG3_PTX3_GLPE_CRT_CONFIG1_RSVD_M RDMA_MASK3(32, 0x1FFF, IG3_PTX3_GLPE_CRT_CONFIG1_RSVD_S)
#define IG3_PTX3_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_S 16
#define IG3_PTX3_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_M RDMA_MASK3(32, 0x7, IG3_PTX3_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_S)
#define IG3_PTX3_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_S 8
#define IG3_PTX3_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_S)
#define IG3_PTX3_GLPE_CRT_CONFIG1_RX_BUF_SIZE_S 0
#define IG3_PTX3_GLPE_CRT_CONFIG1_RX_BUF_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_CRT_CONFIG1_RX_BUF_SIZE_S)
#define IG3_PTX3_GLPE_MAX_INLINE_DATA 0x43C14000
#define IG3_PTX3_GLPE_MAX_INLINE_DATA_RSVD_S 8
#define IG3_PTX3_GLPE_MAX_INLINE_DATA_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX3_GLPE_MAX_INLINE_DATA_RSVD_S)
#define IG3_PTX3_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_S 0
#define IG3_PTX3_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_S)
#define IG3_PTX3_GLPE_MAX_TCP_ACKS 0x43C14004
#define IG3_PTX3_GLPE_MAX_TCP_ACKS_RSVD_S 8
#define IG3_PTX3_GLPE_MAX_TCP_ACKS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX3_GLPE_MAX_TCP_ACKS_RSVD_S)
#define IG3_PTX3_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_S 0
#define IG3_PTX3_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0 0x43C14018
#define IG3_PTX3_GLPE_PTX_CONFIG0_RSVD_31_S 31
#define IG3_PTX3_GLPE_PTX_CONFIG0_RSVD_31_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_RSVD_31_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_S 30
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_S 29
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_S 28
#define IG3_PTX3_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_S 27
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_S 26
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_S 22
#define IG3_PTX3_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_M RDMA_MASK3(32, 0xF, IG3_PTX3_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_S 21
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_S 20
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_RSVD_19_S 19
#define IG3_PTX3_GLPE_PTX_CONFIG0_RSVD_19_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_RSVD_19_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_S 18
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_S 17
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_S 16
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_S 15
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_S 14
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_RSVD_13_7_S 7
#define IG3_PTX3_GLPE_PTX_CONFIG0_RSVD_13_7_M RDMA_MASK3(32, 0x7F, IG3_PTX3_GLPE_PTX_CONFIG0_RSVD_13_7_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_UDP_CS_EN_S 6
#define IG3_PTX3_GLPE_PTX_CONFIG0_UDP_CS_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_UDP_CS_EN_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_Q1_PACING_S 5
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_Q1_PACING_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_DIS_Q1_PACING_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_S 4
#define IG3_PTX3_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_S 3
#define IG3_PTX3_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_S 1
#define IG3_PTX3_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_S)
#define IG3_PTX3_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_S 0
#define IG3_PTX3_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_S)
#define IG3_PTX3_GLPE_PTX_CONFIG1 0x43C1401C
#define IG3_PTX3_GLPE_PTX_CONFIG1_RSVD_S 24
#define IG3_PTX3_GLPE_PTX_CONFIG1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_CONFIG1_RSVD_S)
#define IG3_PTX3_GLPE_PTX_CONFIG1_ACKREQ_PACING_S 21
#define IG3_PTX3_GLPE_PTX_CONFIG1_ACKREQ_PACING_M RDMA_MASK3(32, 0x7, IG3_PTX3_GLPE_PTX_CONFIG1_ACKREQ_PACING_S)
#define IG3_PTX3_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_S 16
#define IG3_PTX3_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_M RDMA_MASK3(32, 0x1F, IG3_PTX3_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_S)
#define IG3_PTX3_GLPE_PTX_CONFIG1_Q1_PACING_MULT_S 0
#define IG3_PTX3_GLPE_PTX_CONFIG1_Q1_PACING_MULT_M RDMA_MASK3(32, 0xFFFF, IG3_PTX3_GLPE_PTX_CONFIG1_Q1_PACING_MULT_S)
#define IG3_PTX3_GLPE_PTX_CONFIG2 0x43C14020
#define IG3_PTX3_GLPE_PTX_CONFIG2_SEND2CPU_S 0
#define IG3_PTX3_GLPE_PTX_CONFIG2_SEND2CPU_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_CONFIG2_SEND2CPU_S)
#define IG3_PTX3_GLPE_PTX_CRT_XMIT_PTR 0x43C1402C
#define IG3_PTX3_GLPE_PTX_CRT_XMIT_PTR_RSVD_S 8
#define IG3_PTX3_GLPE_PTX_CRT_XMIT_PTR_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX3_GLPE_PTX_CRT_XMIT_PTR_RSVD_S)
#define IG3_PTX3_GLPE_PTX_CRT_XMIT_PTR_COUNT_S 0
#define IG3_PTX3_GLPE_PTX_CRT_XMIT_PTR_COUNT_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_CRT_XMIT_PTR_COUNT_S)
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_COUNT 0x43C14138
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX3_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX3_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_CMD 0x43C1414C
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_DATA_H 0x43C14158
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_DATA_L 0x43C14154
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_PTR 0x43C14150
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX3_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_CMD 0x43C1413C
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_DATA_H 0x43C14148
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_DATA_L 0x43C14144
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_PTR 0x43C14140
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX3_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL 0x43C14100
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_RSVD1_S 25
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PTX3_GLPE_PTX_DTM_CONTROL_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_RSVD2_S 17
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX3_GLPE_PTX_DTM_CONTROL_RSVD2_S)
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_RSVD3_S 9
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PTX3_GLPE_PTX_DTM_CONTROL_RSVD3_S)
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_BYPASS_S 8
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_CONTROL_BYPASS_S)
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_RSVD4_S 1
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PTX3_GLPE_PTX_DTM_CONTROL_RSVD4_S)
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PTX3_GLPE_PTX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PTX3_GLPE_PTX_DTM_ECC_COR_ERR 0x43C14168
#define IG3_PTX3_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PTX3_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX3_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PTX3_GLPE_PTX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PTX3_GLPE_PTX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PTX3_GLPE_PTX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PTX3_GLPE_PTX_DTM_ECC_UNCOR_ERR 0x43C14164
#define IG3_PTX3_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PTX3_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX3_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PTX3_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PTX3_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PTX3_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PTX3_GLPE_PTX_DTM_GROUP_CFG 0x43C1410C
#define IG3_PTX3_GLPE_PTX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PTX3_GLPE_PTX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PTX3_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PTX3_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PTX3_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PTX3_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PTX3_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PTX3_GLPE_PTX_DTM_LOG_CFG 0x43C14110
#define IG3_PTX3_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PTX3_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PTX3_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PTX3_GLPE_PTX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PTX3_GLPE_PTX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PTX3_GLPE_PTX_DTM_LOG_CFG_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_DTM_LOG_CFG_MODE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_DTM_LOG_CFG_MODE_S)
#define IG3_PTX3_GLPE_PTX_DTM_LOG_MASK 0x43C14118
#define IG3_PTX3_GLPE_PTX_DTM_LOG_MASK_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_DTM_LOG_MASK_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_LOG_PATTERN 0x43C14114
#define IG3_PTX3_GLPE_PTX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG 0x43C14104
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_STS 0x43C14108
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PTX3_GLPE_PTX_DTM_MAIN_STS_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX3_GLPE_PTX_DTM_MAIN_STS_RSVD2_S)
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PTX3_GLPE_PTX_DTM_TIMESTAMP 0x43C14130
#define IG3_PTX3_GLPE_PTX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_DTM_TIMESTAMP_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER 0x43C14134
#define IG3_PTX3_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG 0x43C1415C
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS 0x43C14160
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG 0x43C1411C
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_MODE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PTX3_GLPE_PTX_DTM_TRIG_CFG_MODE_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_COUNT 0x43C14128
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_MASK 0x43C14124
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_DTM_TRIG_MASK_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_PATTERN 0x43C14120
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_TIMESTAMP 0x43C1412C
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PTX3_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHHI 0x43C14028
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_PTX3_GLPE_PTX_FWQPFLUSHHI_RSVD0_S)
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHHI_QPID_S 6
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX3_GLPE_PTX_FWQPFLUSHHI_QPID_S)
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX3_GLPE_PTX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO 0x43C14024
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_BUSY_S 31
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_BUSY_S)
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_RSVD0_S)
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_HOSTID_S)
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_PMF_S 0
#define IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX3_GLPE_PTX_FWQPFLUSHLO_PMF_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0 0x43C14044
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_TAG_S 16
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_TAG_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_MODE_S 11
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_MODE_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1 0x43C14048
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_PMF_S 0
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG1_PMF_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG2 0x43C1404C
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG2_QPID_S 6
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG2_QPID_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG3 0x43C14050
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG4 0x43C14054
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG4_COUNT_S 0
#define IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_ST0_DTM_TRIG4_COUNT_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0 0x43C14058
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_TAG_S 16
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_TAG_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_MODE_S 11
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_MODE_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1 0x43C1405C
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_PMF_S 0
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG1_PMF_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG2 0x43C14060
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG2_QPID_S 6
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG2_QPID_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG3 0x43C14064
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG4 0x43C14068
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG4_COUNT_S 0
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG4_COUNT_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT0 0x43C14078
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_S 1
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_S 0
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT1 0x43C1407C
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_S 0
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT2 0x43C14080
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_S 0
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE0 0x43C1406C
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_S 1
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_S 0
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE1 0x43C14070
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_S 24
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_S 0
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE2 0x43C14074
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_S 24
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_S)
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_S 0
#define IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX3_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0 0x43C14030
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_S 16
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_S 11
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1 0x43C14034
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_S 0
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG2 0x43C14038
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_S 6
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG3 0x43C1403C
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG4 0x43C14040
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_S 0
#define IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX3_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_S)
#define IG3_PTX3_GLPE_TIMELY_STALL_THRESHOLD 0x43C14008
#define IG3_PTX3_GLPE_TIMELY_STALL_THRESHOLD_RSVD_S 25
#define IG3_PTX3_GLPE_TIMELY_STALL_THRESHOLD_RSVD_M RDMA_MASK3(32, 0x7F, IG3_PTX3_GLPE_TIMELY_STALL_THRESHOLD_RSVD_S)
#define IG3_PTX3_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_S 24
#define IG3_PTX3_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_M RDMA_BIT2(32, IG3_PTX3_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_S)
#define IG3_PTX3_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_S 0
#define IG3_PTX3_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX3_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_COUNT 0x43C144B8
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_CMD 0x43C144CC
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_DATA_H 0x43C144D8
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_DATA_L 0x43C144D4
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_PTR 0x43C144D0
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_CMD 0x43C144BC
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_DATA_H 0x43C144C8
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_DATA_L 0x43C144C4
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_PTR 0x43C144C0
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL 0x43C14480
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_RSVD1_S 25
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_RSVD1_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_RSVD2_S 17
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_RSVD2_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_RSVD3_S 9
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_RSVD3_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_BYPASS_S 8
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_BYPASS_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_RSVD4_S 1
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_RSVD4_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_ECC_COR_ERR 0x43C144E8
#define IG3_SFPTX3_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SFPTX3_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX3_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_ECC_UNCOR_ERR 0x43C144E4
#define IG3_SFPTX3_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SFPTX3_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX3_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_GROUP_CFG 0x43C1448C
#define IG3_SFPTX3_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SFPTX3_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPTX3_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SFPTX3_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX3_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SFPTX3_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX3_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX3_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_LOG_CFG 0x43C14490
#define IG3_SFPTX3_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SFPTX3_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SFPTX3_GLPE_SFPT_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SFPTX3_GLPE_SFPT_DTM_LOG_CFG_RSVD1_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_LOG_CFG_MODE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SFPTX3_GLPE_SFPT_DTM_LOG_CFG_MODE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_LOG_MASK 0x43C14498
#define IG3_SFPTX3_GLPE_SFPT_DTM_LOG_MASK_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_LOG_MASK_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_LOG_PATTERN 0x43C14494
#define IG3_SFPTX3_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG 0x43C14484
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_STS 0x43C14488
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_STS_RSVD1_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_STS_RSVD2_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TIMESTAMP 0x43C144B0
#define IG3_SFPTX3_GLPE_SFPT_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_TIMESTAMP_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER 0x43C144B4
#define IG3_SFPTX3_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG 0x43C144DC
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS 0x43C144E0
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SFPTX3_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG 0x43C1449C
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_MODE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_CFG_MODE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_COUNT 0x43C144A8
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_MASK 0x43C144A4
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_MASK_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_PATTERN 0x43C144A0
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_TIMESTAMP 0x43C144AC
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX3_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SFPTX3_GLPE_SFP_TX_DOMAIN_ID 0x43C14400
#define IG3_SFPTX3_GLPE_SFP_TX_DOMAIN_ID_RSVD_S 3
#define IG3_SFPTX3_GLPE_SFP_TX_DOMAIN_ID_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPTX3_GLPE_SFP_TX_DOMAIN_ID_RSVD_S)
#define IG3_SFPTX3_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_S 0
#define IG3_SFPTX3_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_SFPTX3_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_S)
#define IG3_SFPTX3_GLPE_SFP_TX_PER_MEM 0x43C14404
#define IG3_SFPTX3_GLPE_SFP_TX_PER_MEM_RSVD_S 3
#define IG3_SFPTX3_GLPE_SFP_TX_PER_MEM_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPTX3_GLPE_SFP_TX_PER_MEM_RSVD_S)
#define IG3_SFPTX3_GLPE_SFP_TX_PER_MEM_PER_TYPE_S 0
#define IG3_SFPTX3_GLPE_SFP_TX_PER_MEM_PER_TYPE_M RDMA_MASK3(32, 0x7, IG3_SFPTX3_GLPE_SFP_TX_PER_MEM_PER_TYPE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG 0x43C14800
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS 0x43C14804
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG 0x43C14810
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS 0x43C14814
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ECC_COR_ERR 0x43C14834
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR 0x43C14830
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG 0x43C14818
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS 0x43C1481C
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG 0x43C14808
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS 0x43C1480C
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG 0x43C14828
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS 0x43C1482C
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG 0x43C14820
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS 0x43C14824
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG 0x43C14840
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS 0x43C14844
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG 0x43C14848
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS 0x43C1484C
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG 0x43C14850
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS 0x43C14854
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG 0x43C14858
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS 0x43C1485C
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR 0x43C1487C
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR 0x43C14878
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG 0x43C14860
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS 0x43C14864
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG 0x43C14868
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS 0x43C1486C
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG 0x43C14870
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS 0x43C14874
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG 0x43C14838
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS 0x43C1483C
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL 0x43C148C8
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_S 31
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_S 26
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_S 18
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_DATA 0x43C148CC
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG 0x43C148C0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS 0x43C148C4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_ECC_COR_ERR 0x43C148E4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR 0x43C148E0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL 0x43C148D8
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_S 31
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_S 26
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA 0x43C148DC
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG 0x43C148D0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS 0x43C148D4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL 0x43C14888
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_S 31
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_S 26
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_S 18
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA 0x43C1488C
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG 0x43C14880
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS 0x43C14884
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL 0x43C14898
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_S 31
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_S 26
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA 0x43C1489C
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG 0x43C14890
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS 0x43C14894
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL 0x43C148A8
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_S 31
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_S 26
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_S 18
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA 0x43C148AC
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG 0x43C148A0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS 0x43C148A4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL 0x43C148B8
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_S 31
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_S 26
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_S 18
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA 0x43C148BC
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG 0x43C148B0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_S 20
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_S 16
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_S 14
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_S 10
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_S 6
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_S 5
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS 0x43C148B4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_S 30
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_S 4
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE3_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_S)
#define IG3_DRX3_GLPE_DRX_CONFIG 0x43C20000
#define IG3_DRX3_GLPE_DRX_CONFIG_RSVD1_S 3
#define IG3_DRX3_GLPE_DRX_CONFIG_RSVD1_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_DRX3_GLPE_DRX_CONFIG_RSVD1_S)
#define IG3_DRX3_GLPE_DRX_CONFIG_CRC_MASK_S 0
#define IG3_DRX3_GLPE_DRX_CONFIG_CRC_MASK_M RDMA_MASK3(32, 0x7, IG3_DRX3_GLPE_DRX_CONFIG_CRC_MASK_S)
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_COUNT 0x43C200B8
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX3_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX3_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_CMD 0x43C200CC
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_DATA_H 0x43C200D8
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_DATA_L 0x43C200D4
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_PTR 0x43C200D0
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX3_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_CMD 0x43C200BC
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_DATA_H 0x43C200C8
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_DATA_L 0x43C200C4
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_PTR 0x43C200C0
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX3_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL 0x43C20080
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_RSVD1_S 25
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_DRX3_GLPE_DRX_DTM_CONTROL_RSVD1_S)
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_RSVD2_S 17
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX3_GLPE_DRX_DTM_CONTROL_RSVD2_S)
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_RSVD3_S 9
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_DRX3_GLPE_DRX_DTM_CONTROL_RSVD3_S)
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_BYPASS_S 8
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_CONTROL_BYPASS_S)
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_RSVD4_S 1
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_DRX3_GLPE_DRX_DTM_CONTROL_RSVD4_S)
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_DRX3_GLPE_DRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_DRX3_GLPE_DRX_DTM_ECC_COR_ERR 0x43C200E8
#define IG3_DRX3_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_DRX3_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX3_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_DRX3_GLPE_DRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_DRX3_GLPE_DRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX3_GLPE_DRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_DRX3_GLPE_DRX_DTM_ECC_UNCOR_ERR 0x43C200E4
#define IG3_DRX3_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_DRX3_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX3_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_DRX3_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_DRX3_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX3_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_DRX3_GLPE_DRX_DTM_GROUP_CFG 0x43C2008C
#define IG3_DRX3_GLPE_DRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_DRX3_GLPE_DRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_DRX3_GLPE_DRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_DRX3_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_DRX3_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX3_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_DRX3_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_DRX3_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX3_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_DRX3_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_DRX3_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX3_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_DRX3_GLPE_DRX_DTM_LOG_CFG 0x43C20090
#define IG3_DRX3_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_DRX3_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_DRX3_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_DRX3_GLPE_DRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_DRX3_GLPE_DRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_DRX3_GLPE_DRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_DRX3_GLPE_DRX_DTM_LOG_CFG_MODE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_DRX3_GLPE_DRX_DTM_LOG_CFG_MODE_S)
#define IG3_DRX3_GLPE_DRX_DTM_LOG_MASK 0x43C20098
#define IG3_DRX3_GLPE_DRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX3_GLPE_DRX_DTM_LOG_MASK_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_LOG_PATTERN 0x43C20094
#define IG3_DRX3_GLPE_DRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX3_GLPE_DRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG 0x43C20084
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_STS 0x43C20088
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_DRX3_GLPE_DRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX3_GLPE_DRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_DRX3_GLPE_DRX_DTM_TIMESTAMP 0x43C200B0
#define IG3_DRX3_GLPE_DRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX3_GLPE_DRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER 0x43C200B4
#define IG3_DRX3_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX3_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG 0x43C200DC
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS 0x43C200E0
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DRX3_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG 0x43C2009C
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_DRX3_GLPE_DRX_DTM_TRIG_CFG_MODE_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_COUNT 0x43C200A8
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX3_GLPE_DRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_MASK 0x43C200A4
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX3_GLPE_DRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_PATTERN 0x43C200A0
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX3_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_TIMESTAMP 0x43C200AC
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_DRX3_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX3_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_DRX3_GLPE_DRX_ECC_COR_ERR 0x43C20004
#define IG3_DRX3_GLPE_DRX_ECC_COR_ERR_RSVD_S 12
#define IG3_DRX3_GLPE_DRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX3_GLPE_DRX_ECC_COR_ERR_RSVD_S)
#define IG3_DRX3_GLPE_DRX_ECC_COR_ERR_CNT_S 0
#define IG3_DRX3_GLPE_DRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX3_GLPE_DRX_ECC_COR_ERR_CNT_S)
#define IG3_DRX3_GLPE_DRX_ECC_UNCOR_ERR 0x43C20008
#define IG3_DRX3_GLPE_DRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_DRX3_GLPE_DRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX3_GLPE_DRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_DRX3_GLPE_DRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_DRX3_GLPE_DRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX3_GLPE_DRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_DRX3_GLPE_PBUF_CFG 0x43C2000C
#define IG3_DRX3_GLPE_PBUF_CFG_ECC_INST_NUM_S 25
#define IG3_DRX3_GLPE_PBUF_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DRX3_GLPE_PBUF_CFG_ECC_INST_NUM_S)
#define IG3_DRX3_GLPE_PBUF_CFG_RSVD3_S 20
#define IG3_DRX3_GLPE_PBUF_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DRX3_GLPE_PBUF_CFG_RSVD3_S)
#define IG3_DRX3_GLPE_PBUF_CFG_RM_S 16
#define IG3_DRX3_GLPE_PBUF_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DRX3_GLPE_PBUF_CFG_RM_S)
#define IG3_DRX3_GLPE_PBUF_CFG_RSVD2_S 14
#define IG3_DRX3_GLPE_PBUF_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DRX3_GLPE_PBUF_CFG_RSVD2_S)
#define IG3_DRX3_GLPE_PBUF_CFG_POWER_GATE_EN_S 13
#define IG3_DRX3_GLPE_PBUF_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DRX3_GLPE_PBUF_CFG_POWER_GATE_EN_S)
#define IG3_DRX3_GLPE_PBUF_CFG_RME_S 12
#define IG3_DRX3_GLPE_PBUF_CFG_RME_M RDMA_BIT2(32, IG3_DRX3_GLPE_PBUF_CFG_RME_S)
#define IG3_DRX3_GLPE_PBUF_CFG_RSVD1_S 10
#define IG3_DRX3_GLPE_PBUF_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX3_GLPE_PBUF_CFG_RSVD1_S)
#define IG3_DRX3_GLPE_PBUF_CFG_ERR_CNT_S 9
#define IG3_DRX3_GLPE_PBUF_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DRX3_GLPE_PBUF_CFG_ERR_CNT_S)
#define IG3_DRX3_GLPE_PBUF_CFG_FIX_CNT_S 8
#define IG3_DRX3_GLPE_PBUF_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DRX3_GLPE_PBUF_CFG_FIX_CNT_S)
#define IG3_DRX3_GLPE_PBUF_CFG_RSVD0_S 6
#define IG3_DRX3_GLPE_PBUF_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DRX3_GLPE_PBUF_CFG_RSVD0_S)
#define IG3_DRX3_GLPE_PBUF_CFG_MASK_INT_S 5
#define IG3_DRX3_GLPE_PBUF_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DRX3_GLPE_PBUF_CFG_MASK_INT_S)
#define IG3_DRX3_GLPE_PBUF_CFG_LS_BYPASS_S 4
#define IG3_DRX3_GLPE_PBUF_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DRX3_GLPE_PBUF_CFG_LS_BYPASS_S)
#define IG3_DRX3_GLPE_PBUF_CFG_LS_FORCE_S 3
#define IG3_DRX3_GLPE_PBUF_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DRX3_GLPE_PBUF_CFG_LS_FORCE_S)
#define IG3_DRX3_GLPE_PBUF_CFG_ECC_INVERT_2_S 2
#define IG3_DRX3_GLPE_PBUF_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DRX3_GLPE_PBUF_CFG_ECC_INVERT_2_S)
#define IG3_DRX3_GLPE_PBUF_CFG_ECC_INVERT_1_S 1
#define IG3_DRX3_GLPE_PBUF_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DRX3_GLPE_PBUF_CFG_ECC_INVERT_1_S)
#define IG3_DRX3_GLPE_PBUF_CFG_ECC_EN_S 0
#define IG3_DRX3_GLPE_PBUF_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DRX3_GLPE_PBUF_CFG_ECC_EN_S)
#define IG3_DRX3_GLPE_PBUF_STATUS 0x43C20010
#define IG3_DRX3_GLPE_PBUF_STATUS_RSVD1_S 30
#define IG3_DRX3_GLPE_PBUF_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX3_GLPE_PBUF_STATUS_RSVD1_S)
#define IG3_DRX3_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DRX3_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DRX3_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DRX3_GLPE_PBUF_STATUS_RSVD0_S 4
#define IG3_DRX3_GLPE_PBUF_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DRX3_GLPE_PBUF_STATUS_RSVD0_S)
#define IG3_DRX3_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DRX3_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DRX3_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DRX3_GLPE_PBUF_STATUS_INIT_DONE_S 2
#define IG3_DRX3_GLPE_PBUF_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DRX3_GLPE_PBUF_STATUS_INIT_DONE_S)
#define IG3_DRX3_GLPE_PBUF_STATUS_ECC_FIX_S 1
#define IG3_DRX3_GLPE_PBUF_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DRX3_GLPE_PBUF_STATUS_ECC_FIX_S)
#define IG3_DRX3_GLPE_PBUF_STATUS_ECC_ERR_S 0
#define IG3_DRX3_GLPE_PBUF_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DRX3_GLPE_PBUF_STATUS_ECC_ERR_S)
#define IG3_CMPE3_CMPE_ECC_COR_ERR 0x43C2053C
#define IG3_CMPE3_CMPE_ECC_COR_ERR_RSVD_S 12
#define IG3_CMPE3_CMPE_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE3_CMPE_ECC_COR_ERR_RSVD_S)
#define IG3_CMPE3_CMPE_ECC_COR_ERR_CNT_S 0
#define IG3_CMPE3_CMPE_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE3_CMPE_ECC_COR_ERR_CNT_S)
#define IG3_CMPE3_CMPE_ECC_UNCOR_ERR 0x43C20538
#define IG3_CMPE3_CMPE_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CMPE3_CMPE_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE3_CMPE_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CMPE3_CMPE_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CMPE3_CMPE_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE3_CMPE_ECC_UNCOR_ERR_CNT_S)
#define IG3_CMPE3_GLCM_PECLSADDR 0x43C20484
#define IG3_CMPE3_GLCM_PECLSADDR_RSVD_S 9
#define IG3_CMPE3_GLCM_PECLSADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE3_GLCM_PECLSADDR_RSVD_S)
#define IG3_CMPE3_GLCM_PECLSADDR_CLS_ADDR_S 0
#define IG3_CMPE3_GLCM_PECLSADDR_CLS_ADDR_M RDMA_MASK3(32, 0x1FF, IG3_CMPE3_GLCM_PECLSADDR_CLS_ADDR_S)
#define IG3_CMPE3_GLCM_PECLSDATA0 0x43C20488
#define IG3_CMPE3_GLCM_PECLSDATA0_CLS_DATA_S 0
#define IG3_CMPE3_GLCM_PECLSDATA0_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLCM_PECLSDATA0_CLS_DATA_S)
#define IG3_CMPE3_GLCM_PECLSDATA1 0x43C2048C
#define IG3_CMPE3_GLCM_PECLSDATA1_CLS_DATA_S 0
#define IG3_CMPE3_GLCM_PECLSDATA1_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLCM_PECLSDATA1_CLS_DATA_S)
#define IG3_CMPE3_GLCM_PECLSDATA2 0x43C20490
#define IG3_CMPE3_GLCM_PECLSDATA2_CLS_DATA_S 0
#define IG3_CMPE3_GLCM_PECLSDATA2_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLCM_PECLSDATA2_CLS_DATA_S)
#define IG3_CMPE3_GLCM_PECONFIG 0x43C20480
#define IG3_CMPE3_GLCM_PECONFIG_DBGMUX_EN_S 31
#define IG3_CMPE3_GLCM_PECONFIG_DBGMUX_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECONFIG_DBGMUX_EN_S)
#define IG3_CMPE3_GLCM_PECONFIG_RSVD13_S 30
#define IG3_CMPE3_GLCM_PECONFIG_RSVD13_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECONFIG_RSVD13_S)
#define IG3_CMPE3_GLCM_PECONFIG_DBGMUX_SEL_HI_S 25
#define IG3_CMPE3_GLCM_PECONFIG_DBGMUX_SEL_HI_M RDMA_MASK3(32, 0x1F, IG3_CMPE3_GLCM_PECONFIG_DBGMUX_SEL_HI_S)
#define IG3_CMPE3_GLCM_PECONFIG_DBGMUX_SEL_LO_S 20
#define IG3_CMPE3_GLCM_PECONFIG_DBGMUX_SEL_LO_M RDMA_MASK3(32, 0x1F, IG3_CMPE3_GLCM_PECONFIG_DBGMUX_SEL_LO_S)
#define IG3_CMPE3_GLCM_PECONFIG_RSVD10_S 17
#define IG3_CMPE3_GLCM_PECONFIG_RSVD10_M RDMA_MASK3(32, 0x7, IG3_CMPE3_GLCM_PECONFIG_RSVD10_S)
#define IG3_CMPE3_GLCM_PECONFIG_DBG_WRSEL_S 16
#define IG3_CMPE3_GLCM_PECONFIG_DBG_WRSEL_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECONFIG_DBG_WRSEL_S)
#define IG3_CMPE3_GLCM_PECONFIG_DBG_DWSEL_S 14
#define IG3_CMPE3_GLCM_PECONFIG_DBG_DWSEL_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PECONFIG_DBG_DWSEL_S)
#define IG3_CMPE3_GLCM_PECONFIG_DBG_DPSEL_S 12
#define IG3_CMPE3_GLCM_PECONFIG_DBG_DPSEL_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PECONFIG_DBG_DPSEL_S)
#define IG3_CMPE3_GLCM_PECONFIG_RSVD6_S 7
#define IG3_CMPE3_GLCM_PECONFIG_RSVD6_M RDMA_MASK3(32, 0x1F, IG3_CMPE3_GLCM_PECONFIG_RSVD6_S)
#define IG3_CMPE3_GLCM_PECONFIG_DISABLE_CTXT_PACKING_S 6
#define IG3_CMPE3_GLCM_PECONFIG_DISABLE_CTXT_PACKING_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECONFIG_DISABLE_CTXT_PACKING_S)
#define IG3_CMPE3_GLCM_PECONFIG_DISABLE_LSA_S 5
#define IG3_CMPE3_GLCM_PECONFIG_DISABLE_LSA_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECONFIG_DISABLE_LSA_S)
#define IG3_CMPE3_GLCM_PECONFIG_ENABLE_CRC_S 4
#define IG3_CMPE3_GLCM_PECONFIG_ENABLE_CRC_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECONFIG_ENABLE_CRC_S)
#define IG3_CMPE3_GLCM_PECONFIG_DISABLE_RESCHEDULE_S 3
#define IG3_CMPE3_GLCM_PECONFIG_DISABLE_RESCHEDULE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECONFIG_DISABLE_RESCHEDULE_S)
#define IG3_CMPE3_GLCM_PECONFIG_DISABLE_PACKET_COUNT_S 2
#define IG3_CMPE3_GLCM_PECONFIG_DISABLE_PACKET_COUNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECONFIG_DISABLE_PACKET_COUNT_S)
#define IG3_CMPE3_GLCM_PECONFIG_GLOBAL_LOCK_MODE_S 1
#define IG3_CMPE3_GLCM_PECONFIG_GLOBAL_LOCK_MODE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECONFIG_GLOBAL_LOCK_MODE_S)
#define IG3_CMPE3_GLCM_PECONFIG_RSVD1_S 0
#define IG3_CMPE3_GLCM_PECONFIG_RSVD1_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECONFIG_RSVD1_S)
#define IG3_CMPE3_GLCM_PECTXDGCTL 0x43C204C8
#define IG3_CMPE3_GLCM_PECTXDGCTL_RSVD_S 12
#define IG3_CMPE3_GLCM_PECTXDGCTL_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE3_GLCM_PECTXDGCTL_RSVD_S)
#define IG3_CMPE3_GLCM_PECTXDGCTL_PKTCNT_S 10
#define IG3_CMPE3_GLCM_PECTXDGCTL_PKTCNT_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PECTXDGCTL_PKTCNT_S)
#define IG3_CMPE3_GLCM_PECTXDGCTL_OP_CODE_S 8
#define IG3_CMPE3_GLCM_PECTXDGCTL_OP_CODE_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PECTXDGCTL_OP_CODE_S)
#define IG3_CMPE3_GLCM_PECTXDGCTL_ALLOCATE_S 7
#define IG3_CMPE3_GLCM_PECTXDGCTL_ALLOCATE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECTXDGCTL_ALLOCATE_S)
#define IG3_CMPE3_GLCM_PECTXDGCTL_WRITEBACK_S 6
#define IG3_CMPE3_GLCM_PECTXDGCTL_WRITEBACK_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECTXDGCTL_WRITEBACK_S)
#define IG3_CMPE3_GLCM_PECTXDGCTL_INVALIDATE_S 5
#define IG3_CMPE3_GLCM_PECTXDGCTL_INVALIDATE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECTXDGCTL_INVALIDATE_S)
#define IG3_CMPE3_GLCM_PECTXDGCTL_SUB_LINE_S 0
#define IG3_CMPE3_GLCM_PECTXDGCTL_SUB_LINE_M RDMA_MASK3(32, 0x1F, IG3_CMPE3_GLCM_PECTXDGCTL_SUB_LINE_S)
#define IG3_CMPE3_GLCM_PECTXDGDATA(_i) 0x43C204CC + ((_i) * 4) /* _i=0...3 */
#define IG3_CMPE3_GLCM_PECTXDGDATA_MAX_INDEX_I 3
#define IG3_CMPE3_GLCM_PECTXDGDATA_DATA_S 0
#define IG3_CMPE3_GLCM_PECTXDGDATA_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLCM_PECTXDGDATA_DATA_S)
#define IG3_CMPE3_GLCM_PECTXDGFN 0x43C204C0
#define IG3_CMPE3_GLCM_PECTXDGFN_RSVD_S 20
#define IG3_CMPE3_GLCM_PECTXDGFN_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE3_GLCM_PECTXDGFN_RSVD_S)
#define IG3_CMPE3_GLCM_PECTXDGFN_FUNC_TRIPLET_S 0
#define IG3_CMPE3_GLCM_PECTXDGFN_FUNC_TRIPLET_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE3_GLCM_PECTXDGFN_FUNC_TRIPLET_S)
#define IG3_CMPE3_GLCM_PECTXDGQP 0x43C204C4
#define IG3_CMPE3_GLCM_PECTXDGQP_RSVD_S 24
#define IG3_CMPE3_GLCM_PECTXDGQP_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLCM_PECTXDGQP_RSVD_S)
#define IG3_CMPE3_GLCM_PECTXDGQP_QUEUE_NUM_S 0
#define IG3_CMPE3_GLCM_PECTXDGQP_QUEUE_NUM_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE3_GLCM_PECTXDGQP_QUEUE_NUM_S)
#define IG3_CMPE3_GLCM_PECTXDGSTAT 0x43C204DC
#define IG3_CMPE3_GLCM_PECTXDGSTAT_RSVD_S 2
#define IG3_CMPE3_GLCM_PECTXDGSTAT_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_CMPE3_GLCM_PECTXDGSTAT_RSVD_S)
#define IG3_CMPE3_GLCM_PECTXDGSTAT_CTX_MISS_S 1
#define IG3_CMPE3_GLCM_PECTXDGSTAT_CTX_MISS_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECTXDGSTAT_CTX_MISS_S)
#define IG3_CMPE3_GLCM_PECTXDGSTAT_CTX_DONE_S 0
#define IG3_CMPE3_GLCM_PECTXDGSTAT_CTX_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PECTXDGSTAT_CTX_DONE_S)
#define IG3_CMPE3_GLCM_PEDATAREQHI 0x43C204B4
#define IG3_CMPE3_GLCM_PEDATAREQHI_RSVD_S 24
#define IG3_CMPE3_GLCM_PEDATAREQHI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLCM_PEDATAREQHI_RSVD_S)
#define IG3_CMPE3_GLCM_PEDATAREQHI_DATAREQHI_S 0
#define IG3_CMPE3_GLCM_PEDATAREQHI_DATAREQHI_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE3_GLCM_PEDATAREQHI_DATAREQHI_S)
#define IG3_CMPE3_GLCM_PEDATAREQLO 0x43C204B0
#define IG3_CMPE3_GLCM_PEDATAREQLO_DATAREQLOW_S 0
#define IG3_CMPE3_GLCM_PEDATAREQLO_DATAREQLOW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLCM_PEDATAREQLO_DATAREQLOW_S)
#define IG3_CMPE3_GLCM_PEDATASTALLHI 0x43C204BC
#define IG3_CMPE3_GLCM_PEDATASTALLHI_RSVD_S 24
#define IG3_CMPE3_GLCM_PEDATASTALLHI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLCM_PEDATASTALLHI_RSVD_S)
#define IG3_CMPE3_GLCM_PEDATASTALLHI_DATASTALLHI_S 0
#define IG3_CMPE3_GLCM_PEDATASTALLHI_DATASTALLHI_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE3_GLCM_PEDATASTALLHI_DATASTALLHI_S)
#define IG3_CMPE3_GLCM_PEDATASTALLLO 0x43C204B8
#define IG3_CMPE3_GLCM_PEDATASTALLLO_DATASTALLLOW_S 0
#define IG3_CMPE3_GLCM_PEDATASTALLLO_DATASTALLLOW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLCM_PEDATASTALLLO_DATASTALLLOW_S)
#define IG3_CMPE3_GLCM_PELOCKTBLADDR 0x43C2049C
#define IG3_CMPE3_GLCM_PELOCKTBLADDR_RSVD_S 5
#define IG3_CMPE3_GLCM_PELOCKTBLADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_CMPE3_GLCM_PELOCKTBLADDR_RSVD_S)
#define IG3_CMPE3_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_S 0
#define IG3_CMPE3_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_M RDMA_MASK3(32, 0x1F, IG3_CMPE3_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_S)
#define IG3_CMPE3_GLCM_PELOCKTBLDATA0 0x43C204A0
#define IG3_CMPE3_GLCM_PELOCKTBLDATA0_GPLOCKSEL_S 31
#define IG3_CMPE3_GLCM_PELOCKTBLDATA0_GPLOCKSEL_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PELOCKTBLDATA0_GPLOCKSEL_S)
#define IG3_CMPE3_GLCM_PELOCKTBLDATA0_RSVD_S 24
#define IG3_CMPE3_GLCM_PELOCKTBLDATA0_RSVD_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLCM_PELOCKTBLDATA0_RSVD_S)
#define IG3_CMPE3_GLCM_PELOCKTBLDATA0_QPID_S 0
#define IG3_CMPE3_GLCM_PELOCKTBLDATA0_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE3_GLCM_PELOCKTBLDATA0_QPID_S)
#define IG3_CMPE3_GLCM_PELOCKTBLDATA1 0x43C204A4
#define IG3_CMPE3_GLCM_PELOCKTBLDATA1_RSVD_S 20
#define IG3_CMPE3_GLCM_PELOCKTBLDATA1_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE3_GLCM_PELOCKTBLDATA1_RSVD_S)
#define IG3_CMPE3_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_S 0
#define IG3_CMPE3_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE3_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_S)
#define IG3_CMPE3_GLCM_PELOCKTBLDATA2 0x43C204A8
#define IG3_CMPE3_GLCM_PELOCKTBLDATA2_LOCKSEL_S 0
#define IG3_CMPE3_GLCM_PELOCKTBLDATA2_LOCKSEL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLCM_PELOCKTBLDATA2_LOCKSEL_S)
#define IG3_CMPE3_GLCM_PEPKTCNTADDR 0x43C20494
#define IG3_CMPE3_GLCM_PEPKTCNTADDR_RSVD_S 9
#define IG3_CMPE3_GLCM_PEPKTCNTADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE3_GLCM_PEPKTCNTADDR_RSVD_S)
#define IG3_CMPE3_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_S 0
#define IG3_CMPE3_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_M RDMA_MASK3(32, 0x1FF, IG3_CMPE3_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_S)
#define IG3_CMPE3_GLCM_PEPKTCNTDATA 0x43C20498
#define IG3_CMPE3_GLCM_PEPKTCNTDATA_RSVD1_S 18
#define IG3_CMPE3_GLCM_PEPKTCNTDATA_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE3_GLCM_PEPKTCNTDATA_RSVD1_S)
#define IG3_CMPE3_GLCM_PEPKTCNTDATA_RLRSP_STATE_S 16
#define IG3_CMPE3_GLCM_PEPKTCNTDATA_RLRSP_STATE_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PEPKTCNTDATA_RLRSP_STATE_S)
#define IG3_CMPE3_GLCM_PEPKTCNTDATA_RSVD0_S 14
#define IG3_CMPE3_GLCM_PEPKTCNTDATA_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PEPKTCNTDATA_RSVD0_S)
#define IG3_CMPE3_GLCM_PEPKTCNTDATA_RLREQ_STATE_S 12
#define IG3_CMPE3_GLCM_PEPKTCNTDATA_RLREQ_STATE_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PEPKTCNTDATA_RLREQ_STATE_S)
#define IG3_CMPE3_GLCM_PEPKTCNTDATA_PKTCNT_S 1
#define IG3_CMPE3_GLCM_PEPKTCNTDATA_PKTCNT_M RDMA_MASK3(32, 0x7FF, IG3_CMPE3_GLCM_PEPKTCNTDATA_PKTCNT_S)
#define IG3_CMPE3_GLCM_PEPKTCNTDATA_DONE_S 0
#define IG3_CMPE3_GLCM_PEPKTCNTDATA_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PEPKTCNTDATA_DONE_S)
#define IG3_CMPE3_GLCM_PESTATSCTL 0x43C204AC
#define IG3_CMPE3_GLCM_PESTATSCTL_RSVD_S 2
#define IG3_CMPE3_GLCM_PESTATSCTL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_CMPE3_GLCM_PESTATSCTL_RSVD_S)
#define IG3_CMPE3_GLCM_PESTATSCTL_ENABLE_S 1
#define IG3_CMPE3_GLCM_PESTATSCTL_ENABLE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PESTATSCTL_ENABLE_S)
#define IG3_CMPE3_GLCM_PESTATSCTL_CLEAR_S 0
#define IG3_CMPE3_GLCM_PESTATSCTL_CLEAR_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PESTATSCTL_CLEAR_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG 0x43C20500
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_S 20
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RM_S 16
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RM_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_S 14
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RME_S 12
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RME_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_S 10
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_S 6
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS 0x43C20504
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG 0x43C20508
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_S 20
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RM_S 16
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RM_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_S 14
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RME_S 12
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RME_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_S 10
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_S 6
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS 0x43C2050C
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG 0x43C20510
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_S 20
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RM_S 16
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RM_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_S 14
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RME_S 12
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RME_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_S 10
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_S 6
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS 0x43C20514
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG 0x43C20518
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_S 20
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RM_S 16
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RM_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_S 14
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RME_S 12
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RME_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_S 10
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_S 6
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS 0x43C2051C
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG 0x43C20520
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RSVD3_S 20
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RSVD3_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RM_S 16
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RM_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RSVD2_S 14
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RSVD2_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RME_S 12
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RME_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RSVD1_S 10
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RSVD0_S 6
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS 0x43C20524
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE3_GLCM_PE_CACHESIZE 0x43C204E4
#define IG3_CMPE3_GLCM_PE_CACHESIZE_RSVD_S 26
#define IG3_CMPE3_GLCM_PE_CACHESIZE_RSVD_M RDMA_MASK3(32, 0x3F, IG3_CMPE3_GLCM_PE_CACHESIZE_RSVD_S)
#define IG3_CMPE3_GLCM_PE_CACHESIZE_WAYS_S 16
#define IG3_CMPE3_GLCM_PE_CACHESIZE_WAYS_M RDMA_MASK3(32, 0x3FF, IG3_CMPE3_GLCM_PE_CACHESIZE_WAYS_S)
#define IG3_CMPE3_GLCM_PE_CACHESIZE_SETS_S 12
#define IG3_CMPE3_GLCM_PE_CACHESIZE_SETS_M RDMA_MASK3(32, 0xF, IG3_CMPE3_GLCM_PE_CACHESIZE_SETS_S)
#define IG3_CMPE3_GLCM_PE_CACHESIZE_WORD_SIZE_S 0
#define IG3_CMPE3_GLCM_PE_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFFF, IG3_CMPE3_GLCM_PE_CACHESIZE_WORD_SIZE_S)
#define IG3_CMPE3_GLCM_PE_DPC_COMP 0x43C204F4
#define IG3_CMPE3_GLCM_PE_DPC_COMP_RSVD_S 13
#define IG3_CMPE3_GLCM_PE_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_CMPE3_GLCM_PE_DPC_COMP_RSVD_S)
#define IG3_CMPE3_GLCM_PE_DPC_COMP_COMP_FTYPE_S 11
#define IG3_CMPE3_GLCM_PE_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_DPC_COMP_COMP_FTYPE_S)
#define IG3_CMPE3_GLCM_PE_DPC_COMP_COMP_FNUM_S 1
#define IG3_CMPE3_GLCM_PE_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_CMPE3_GLCM_PE_DPC_COMP_COMP_FNUM_S)
#define IG3_CMPE3_GLCM_PE_DPC_COMP_COMP_VALID_S 0
#define IG3_CMPE3_GLCM_PE_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_DPC_COMP_COMP_VALID_S)
#define IG3_CMPE3_GLCM_PE_DPC_REQ 0x43C204F0
#define IG3_CMPE3_GLCM_PE_DPC_REQ_RSVD_S 12
#define IG3_CMPE3_GLCM_PE_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE3_GLCM_PE_DPC_REQ_RSVD_S)
#define IG3_CMPE3_GLCM_PE_DPC_REQ_REQ_FTYPE_S 10
#define IG3_CMPE3_GLCM_PE_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_DPC_REQ_REQ_FTYPE_S)
#define IG3_CMPE3_GLCM_PE_DPC_REQ_REQ_FNUM_S 0
#define IG3_CMPE3_GLCM_PE_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_CMPE3_GLCM_PE_DPC_REQ_REQ_FNUM_S)
#define IG3_CMPE3_GLCM_PE_E2E_FC 0x43C204F8
#define IG3_CMPE3_GLCM_PE_E2E_FC_RSVD1_S 22
#define IG3_CMPE3_GLCM_PE_E2E_FC_RSVD1_M RDMA_MASK3(32, 0x3FF, IG3_CMPE3_GLCM_PE_E2E_FC_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_S 16
#define IG3_CMPE3_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_M RDMA_MASK3(32, 0x3F, IG3_CMPE3_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_S)
#define IG3_CMPE3_GLCM_PE_E2E_FC_RSVD0_S 9
#define IG3_CMPE3_GLCM_PE_E2E_FC_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLCM_PE_E2E_FC_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_S 0
#define IG3_CMPE3_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_M RDMA_MASK3(32, 0x1FF, IG3_CMPE3_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG 0x43C20528
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_S 20
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RM_S 16
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RM_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_S 14
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RME_S 12
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RME_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_S 10
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_S 6
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS 0x43C2052C
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG 0x43C20530
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_S 20
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RM_S 16
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RM_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_S 14
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RME_S 12
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RME_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_S 10
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_S 6
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS 0x43C20534
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE3_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE3_GLCM_PE_IF_FC 0x43C204FC
#define IG3_CMPE3_GLCM_PE_IF_FC_RSVD1_S 22
#define IG3_CMPE3_GLCM_PE_IF_FC_RSVD1_M RDMA_MASK3(32, 0x3FF, IG3_CMPE3_GLCM_PE_IF_FC_RSVD1_S)
#define IG3_CMPE3_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_S 16
#define IG3_CMPE3_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_M RDMA_MASK3(32, 0x3F, IG3_CMPE3_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_S)
#define IG3_CMPE3_GLCM_PE_IF_FC_RSVD0_S 9
#define IG3_CMPE3_GLCM_PE_IF_FC_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLCM_PE_IF_FC_RSVD0_S)
#define IG3_CMPE3_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_S 0
#define IG3_CMPE3_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_M RDMA_MASK3(32, 0x1FF, IG3_CMPE3_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_S)
#define IG3_CMPE3_GLCM_PE_MAXOSR 0x43C204E0
#define IG3_CMPE3_GLCM_PE_MAXOSR_RSVD_S 6
#define IG3_CMPE3_GLCM_PE_MAXOSR_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_CMPE3_GLCM_PE_MAXOSR_RSVD_S)
#define IG3_CMPE3_GLCM_PE_MAXOSR_MAXOSR_S 0
#define IG3_CMPE3_GLCM_PE_MAXOSR_MAXOSR_M RDMA_MASK3(32, 0x3F, IG3_CMPE3_GLCM_PE_MAXOSR_MAXOSR_S)
#define IG3_CMPE3_GLCM_PE_RLDDBGCTL0 0x43C204E8
#define IG3_CMPE3_GLCM_PE_RLDDBGCTL0_RSVD_S 24
#define IG3_CMPE3_GLCM_PE_RLDDBGCTL0_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLCM_PE_RLDDBGCTL0_RSVD_S)
#define IG3_CMPE3_GLCM_PE_RLDDBGCTL0_QPID_S 0
#define IG3_CMPE3_GLCM_PE_RLDDBGCTL0_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE3_GLCM_PE_RLDDBGCTL0_QPID_S)
#define IG3_CMPE3_GLCM_PE_RLDDBGCTL1 0x43C204EC
#define IG3_CMPE3_GLCM_PE_RLDDBGCTL1_RSVD_S 20
#define IG3_CMPE3_GLCM_PE_RLDDBGCTL1_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE3_GLCM_PE_RLDDBGCTL1_RSVD_S)
#define IG3_CMPE3_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_S 18
#define IG3_CMPE3_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_S)
#define IG3_CMPE3_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_S 6
#define IG3_CMPE3_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CMPE3_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_S)
#define IG3_CMPE3_GLCM_PE_RLDDBGCTL1_PF_NUM_S 0
#define IG3_CMPE3_GLCM_PE_RLDDBGCTL1_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_CMPE3_GLCM_PE_RLDDBGCTL1_PF_NUM_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_COUNT 0x43C205B8
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_CMD 0x43C205CC
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_DATA_H 0x43C205D8
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_DATA_L 0x43C205D4
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_PTR 0x43C205D0
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_CMD 0x43C205BC
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_DATA_H 0x43C205C8
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_DATA_L 0x43C205C4
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_PTR 0x43C205C0
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL 0x43C20580
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_RSVD1_S 25
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_RSVD1_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_RSVD2_S 17
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_RSVD2_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_RSVD3_S 9
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_RSVD3_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_BYPASS_S 8
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_BYPASS_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_RSVD4_S 1
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_RSVD4_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_ECC_COR_ERR 0x43C205E8
#define IG3_CMPE3_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_CMPE3_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE3_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_ECC_UNCOR_ERR 0x43C205E4
#define IG3_CMPE3_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CMPE3_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE3_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_GROUP_CFG 0x43C2058C
#define IG3_CMPE3_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_CMPE3_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_CMPE3_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_CMPE3_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_LOG_CFG 0x43C20590
#define IG3_CMPE3_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_CMPE3_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_CMPE3_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_LOG_CFG_RSVD1_S 2
#define IG3_CMPE3_GLPE_CMPE_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE3_GLPE_CMPE_DTM_LOG_CFG_RSVD1_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_LOG_CFG_MODE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLPE_CMPE_DTM_LOG_CFG_MODE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_LOG_MASK 0x43C20598
#define IG3_CMPE3_GLPE_CMPE_DTM_LOG_MASK_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_LOG_MASK_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_LOG_PATTERN 0x43C20594
#define IG3_CMPE3_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG 0x43C20584
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_STS 0x43C20588
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_STS_RSVD1_S 9
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE3_GLPE_CMPE_DTM_MAIN_STS_RSVD1_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_STS_RSVD2_S 1
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLPE_CMPE_DTM_MAIN_STS_RSVD2_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TIMESTAMP 0x43C205B0
#define IG3_CMPE3_GLPE_CMPE_DTM_TIMESTAMP_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_TIMESTAMP_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER 0x43C205B4
#define IG3_CMPE3_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG 0x43C205DC
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS 0x43C205E0
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE3_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG 0x43C2059C
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_MODE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_CMPE3_GLPE_CMPE_DTM_TRIG_CFG_MODE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_COUNT 0x43C205A8
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_MASK 0x43C205A4
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_MASK_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_TRIG_MASK_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_PATTERN 0x43C205A0
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_TIMESTAMP 0x43C205AC
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_CMPE3_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE3_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_CMPE3_PFCM_PE_CRCERRINFO0(_i) 0x43C20400 + ((_i) * 4) /* _i=0...15 */
#define IG3_CMPE3_PFCM_PE_CRCERRINFO0_MAX_INDEX_I 15
#define IG3_CMPE3_PFCM_PE_CRCERRINFO0_RSVD1_S 18
#define IG3_CMPE3_PFCM_PE_CRCERRINFO0_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE3_PFCM_PE_CRCERRINFO0_RSVD1_S)
#define IG3_CMPE3_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_S 16
#define IG3_CMPE3_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE3_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_S)
#define IG3_CMPE3_PFCM_PE_CRCERRINFO0_VM_VF_NUM_S 4
#define IG3_CMPE3_PFCM_PE_CRCERRINFO0_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CMPE3_PFCM_PE_CRCERRINFO0_VM_VF_NUM_S)
#define IG3_CMPE3_PFCM_PE_CRCERRINFO0_RSVD0_S 1
#define IG3_CMPE3_PFCM_PE_CRCERRINFO0_RSVD0_M RDMA_MASK3(32, 0x7, IG3_CMPE3_PFCM_PE_CRCERRINFO0_RSVD0_S)
#define IG3_CMPE3_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_S 0
#define IG3_CMPE3_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_M RDMA_BIT2(32, IG3_CMPE3_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_S)
#define IG3_CMPE3_PFCM_PE_CRCERRINFO1(_i) 0x43C20440 + ((_i) * 4) /* _i=0...15 */
#define IG3_CMPE3_PFCM_PE_CRCERRINFO1_MAX_INDEX_I 15
#define IG3_CMPE3_PFCM_PE_CRCERRINFO1_RSVD_S 24
#define IG3_CMPE3_PFCM_PE_CRCERRINFO1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE3_PFCM_PE_CRCERRINFO1_RSVD_S)
#define IG3_CMPE3_PFCM_PE_CRCERRINFO1_Q_NUM_S 0
#define IG3_CMPE3_PFCM_PE_CRCERRINFO1_Q_NUM_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE3_PFCM_PE_CRCERRINFO1_Q_NUM_S)
#define IG3_PRX4_GLPE_CC_DCQCN1_CFG(_i) 0x44002000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX4_GLPE_CC_DCQCN1_CFG_MAX_INDEX_I 1031
#define IG3_PRX4_GLPE_CC_DCQCN1_CFG_RSVD2_S 31
#define IG3_PRX4_GLPE_CC_DCQCN1_CFG_RSVD2_M RDMA_BIT2(32, IG3_PRX4_GLPE_CC_DCQCN1_CFG_RSVD2_S)
#define IG3_PRX4_GLPE_CC_DCQCN1_CFG_DCQCN_F_S 28
#define IG3_PRX4_GLPE_CC_DCQCN1_CFG_DCQCN_F_M RDMA_MASK3(32, 0x7, IG3_PRX4_GLPE_CC_DCQCN1_CFG_DCQCN_F_S)
#define IG3_PRX4_GLPE_CC_DCQCN1_CFG_RSVD1_S 25
#define IG3_PRX4_GLPE_CC_DCQCN1_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_PRX4_GLPE_CC_DCQCN1_CFG_RSVD1_S)
#define IG3_PRX4_GLPE_CC_DCQCN1_CFG_DCQCN_B_S 0
#define IG3_PRX4_GLPE_CC_DCQCN1_CFG_DCQCN_B_M RDMA_MASK3(32, 0x1FFFFFF, IG3_PRX4_GLPE_CC_DCQCN1_CFG_DCQCN_B_S)
#define IG3_PRX4_GLPE_CC_DCQCN2_CFG(_i) 0x44004000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX4_GLPE_CC_DCQCN2_CFG_MAX_INDEX_I 1031
#define IG3_PRX4_GLPE_CC_DCQCN2_CFG_RSVD_S 16
#define IG3_PRX4_GLPE_CC_DCQCN2_CFG_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_PRX4_GLPE_CC_DCQCN2_CFG_RSVD_S)
#define IG3_PRX4_GLPE_CC_DCQCN2_CFG_DCQCN_T_S 0
#define IG3_PRX4_GLPE_CC_DCQCN2_CFG_DCQCN_T_M RDMA_MASK3(32, 0xFFFF, IG3_PRX4_GLPE_CC_DCQCN2_CFG_DCQCN_T_S)
#define IG3_PRX4_GLPE_CC_TIMELY_CFG(_i) 0x44000000 + ((_i) * 4) /* _i=0...1031 */
#define IG3_PRX4_GLPE_CC_TIMELY_CFG_MAX_INDEX_I 1031
#define IG3_PRX4_GLPE_CC_TIMELY_CFG_RAI_FACTOR_S 16
#define IG3_PRX4_GLPE_CC_TIMELY_CFG_RAI_FACTOR_M RDMA_MASK3(32, 0xFFFF, IG3_PRX4_GLPE_CC_TIMELY_CFG_RAI_FACTOR_S)
#define IG3_PRX4_GLPE_CC_TIMELY_CFG_HAI_FACTOR_S 0
#define IG3_PRX4_GLPE_CC_TIMELY_CFG_HAI_FACTOR_M RDMA_MASK3(32, 0xFFFF, IG3_PRX4_GLPE_CC_TIMELY_CFG_HAI_FACTOR_S)
#define IG3_PRX4_GLPE_PRX_CONFIG 0x44005020
#define IG3_PRX4_GLPE_PRX_CONFIG_REORDER_CNT_MAX_S 24
#define IG3_PRX4_GLPE_PRX_CONFIG_REORDER_CNT_MAX_M RDMA_MASK3(32, 0xFF, IG3_PRX4_GLPE_PRX_CONFIG_REORDER_CNT_MAX_S)
#define IG3_PRX4_GLPE_PRX_CONFIG_REORDER_CNT_MIN_S 16
#define IG3_PRX4_GLPE_PRX_CONFIG_REORDER_CNT_MIN_M RDMA_MASK3(32, 0xFF, IG3_PRX4_GLPE_PRX_CONFIG_REORDER_CNT_MIN_S)
#define IG3_PRX4_GLPE_PRX_CONFIG_RSVD1_S 12
#define IG3_PRX4_GLPE_PRX_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_PRX4_GLPE_PRX_CONFIG_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_S 8
#define IG3_PRX4_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_M RDMA_MASK3(32, 0xF, IG3_PRX4_GLPE_PRX_CONFIG_HOLD_CTXT_CNT_MAX_S)
#define IG3_PRX4_GLPE_PRX_CONFIG_RSVD0_S 5
#define IG3_PRX4_GLPE_PRX_CONFIG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PRX4_GLPE_PRX_CONFIG_RSVD0_S)
#define IG3_PRX4_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_S 4
#define IG3_PRX4_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_CONFIG_UDA_LEGACY_MODE_S)
#define IG3_PRX4_GLPE_PRX_CONFIG_ONE_HP_TILE_S 3
#define IG3_PRX4_GLPE_PRX_CONFIG_ONE_HP_TILE_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_CONFIG_ONE_HP_TILE_S)
#define IG3_PRX4_GLPE_PRX_CONFIG_DIS_RREC_S 2
#define IG3_PRX4_GLPE_PRX_CONFIG_DIS_RREC_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_CONFIG_DIS_RREC_S)
#define IG3_PRX4_GLPE_PRX_CONFIG_DIS_QR_STALL_S 1
#define IG3_PRX4_GLPE_PRX_CONFIG_DIS_QR_STALL_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_CONFIG_DIS_QR_STALL_S)
#define IG3_PRX4_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_S 0
#define IG3_PRX4_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_CONFIG_DROP_1BYTE_ZWP_S)
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_COUNT 0x440050B8
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX4_GLPE_PRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX4_GLPE_PRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_CMD 0x440050CC
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_DATA_H 0x440050D8
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_DATA_L 0x440050D4
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_PTR 0x440050D0
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX4_GLPE_PRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_CMD 0x440050BC
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_DATA_H 0x440050C8
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_DATA_L 0x440050C4
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_PTR 0x440050C0
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX4_GLPE_PRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL 0x44005080
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_RSVD1_S 25
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PRX4_GLPE_PRX_DTM_CONTROL_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_RSVD2_S 17
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX4_GLPE_PRX_DTM_CONTROL_RSVD2_S)
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_RSVD3_S 9
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PRX4_GLPE_PRX_DTM_CONTROL_RSVD3_S)
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_BYPASS_S 8
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_CONTROL_BYPASS_S)
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_RSVD4_S 1
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PRX4_GLPE_PRX_DTM_CONTROL_RSVD4_S)
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PRX4_GLPE_PRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PRX4_GLPE_PRX_DTM_ECC_COR_ERR 0x440050E8
#define IG3_PRX4_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PRX4_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX4_GLPE_PRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PRX4_GLPE_PRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PRX4_GLPE_PRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PRX4_GLPE_PRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PRX4_GLPE_PRX_DTM_ECC_UNCOR_ERR 0x440050E4
#define IG3_PRX4_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PRX4_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX4_GLPE_PRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PRX4_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PRX4_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PRX4_GLPE_PRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PRX4_GLPE_PRX_DTM_GROUP_CFG 0x4400508C
#define IG3_PRX4_GLPE_PRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PRX4_GLPE_PRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PRX4_GLPE_PRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PRX4_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX4_GLPE_PRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PRX4_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PRX4_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX4_GLPE_PRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PRX4_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PRX4_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PRX4_GLPE_PRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PRX4_GLPE_PRX_DTM_LOG_CFG 0x44005090
#define IG3_PRX4_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PRX4_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PRX4_GLPE_PRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PRX4_GLPE_PRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PRX4_GLPE_PRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PRX4_GLPE_PRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_DTM_LOG_CFG_MODE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PRX4_GLPE_PRX_DTM_LOG_CFG_MODE_S)
#define IG3_PRX4_GLPE_PRX_DTM_LOG_MASK 0x44005098
#define IG3_PRX4_GLPE_PRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX4_GLPE_PRX_DTM_LOG_MASK_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_LOG_PATTERN 0x44005094
#define IG3_PRX4_GLPE_PRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX4_GLPE_PRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG 0x44005084
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_STS 0x44005088
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PRX4_GLPE_PRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PRX4_GLPE_PRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PRX4_GLPE_PRX_DTM_TIMESTAMP 0x440050B0
#define IG3_PRX4_GLPE_PRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX4_GLPE_PRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER 0x440050B4
#define IG3_PRX4_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX4_GLPE_PRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG 0x440050DC
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS 0x440050E0
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG 0x4400509C
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PRX4_GLPE_PRX_DTM_TRIG_CFG_MODE_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_COUNT 0x440050A8
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX4_GLPE_PRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_MASK 0x440050A4
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX4_GLPE_PRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_PATTERN 0x440050A0
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX4_GLPE_PRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_TIMESTAMP 0x440050AC
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PRX4_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PRX4_GLPE_PRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_CTL 0x44005024
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_S 12
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_CTL_RSVD_S)
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_S 0
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_CTL_VDEV_NUM_S)
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA 0x44005028
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_S 31
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_VALID_S)
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_S 30
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_M RDMA_BIT2(32, IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD1_S)
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_S 24
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_PF_NUM_S)
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_S 20
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_M RDMA_MASK3(32, 0xF, IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_RSVD0_S)
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_S 0
#define IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_PRX4_GLPE_PRX_ROCEVMQP1LUT_DATA_QPID_S)
#define IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL 0x44008018
#define IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_S 21
#define IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_M RDMA_MASK3(32, 0x7FF, IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD2_S)
#define IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_S 16
#define IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REM_DATA_Q1_ENDIAN_CTL_S)
#define IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_S 13
#define IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_S 8
#define IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_RSP_ENDIAN_CTL_S)
#define IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_S 5
#define IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_RSVD0_S)
#define IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_S 0
#define IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_M RDMA_MASK3(32, 0x1F, IG3_WRX4_GLPE_WRX_ATOMIC_ENDIAN_CTL_HOST_ATOMIC_REQ_ENDIAN_CTL_S)
#define IG3_WRX4_GLPE_WRX_CONFIG 0x44008000
#define IG3_WRX4_GLPE_WRX_CONFIG_RSVD_S 8
#define IG3_WRX4_GLPE_WRX_CONFIG_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WRX4_GLPE_WRX_CONFIG_RSVD_S)
#define IG3_WRX4_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_S 5
#define IG3_WRX4_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_M RDMA_MASK3(32, 0x7, IG3_WRX4_GLPE_WRX_CONFIG_NUM_PROCESS_UNDER_LOCK_S)
#define IG3_WRX4_GLPE_WRX_CONFIG_DIS_WQE_CACHE_S 4
#define IG3_WRX4_GLPE_WRX_CONFIG_DIS_WQE_CACHE_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_CONFIG_DIS_WQE_CACHE_S)
#define IG3_WRX4_GLPE_WRX_CONFIG_DROP_OOO_IMMED_S 3
#define IG3_WRX4_GLPE_WRX_CONFIG_DROP_OOO_IMMED_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_CONFIG_DROP_OOO_IMMED_S)
#define IG3_WRX4_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_S 2
#define IG3_WRX4_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_CONFIG_DIS_DUP_RREQ_RCVD_S)
#define IG3_WRX4_GLPE_WRX_CONFIG_DIS_Q1_AE_S 1
#define IG3_WRX4_GLPE_WRX_CONFIG_DIS_Q1_AE_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_CONFIG_DIS_Q1_AE_S)
#define IG3_WRX4_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_S 0
#define IG3_WRX4_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_CONFIG_DROP_INV_IN_REXMIT_S)
#define IG3_WRX4_GLPE_WRX_DOMAIN_IDS 0x44008014
#define IG3_WRX4_GLPE_WRX_DOMAIN_IDS_RSVD2_S 11
#define IG3_WRX4_GLPE_WRX_DOMAIN_IDS_RSVD2_M RDMA_MASK3(32, 0x1FFFFF, IG3_WRX4_GLPE_WRX_DOMAIN_IDS_RSVD2_S)
#define IG3_WRX4_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_S 8
#define IG3_WRX4_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX4_GLPE_WRX_DOMAIN_IDS_WRITE_DOMAIN_ID_S)
#define IG3_WRX4_GLPE_WRX_DOMAIN_IDS_RSVD1_S 7
#define IG3_WRX4_GLPE_WRX_DOMAIN_IDS_RSVD1_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DOMAIN_IDS_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_S 4
#define IG3_WRX4_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX4_GLPE_WRX_DOMAIN_IDS_WQE_DOMAIN_ID_S)
#define IG3_WRX4_GLPE_WRX_DOMAIN_IDS_RSVD0_S 3
#define IG3_WRX4_GLPE_WRX_DOMAIN_IDS_RSVD0_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DOMAIN_IDS_RSVD0_S)
#define IG3_WRX4_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_S 0
#define IG3_WRX4_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_WRX4_GLPE_WRX_DOMAIN_IDS_ATOMIC_DOMAIN_ID_S)
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_COUNT 0x440080B8
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX4_GLPE_WRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX4_GLPE_WRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_CMD 0x440080CC
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_DATA_H 0x440080D8
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_DATA_L 0x440080D4
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_PTR 0x440080D0
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX4_GLPE_WRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_CMD 0x440080BC
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_DATA_H 0x440080C8
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_DATA_L 0x440080C4
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_PTR 0x440080C0
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX4_GLPE_WRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL 0x44008080
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_RSVD1_S 25
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_WRX4_GLPE_WRX_DTM_CONTROL_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_RSVD2_S 17
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX4_GLPE_WRX_DTM_CONTROL_RSVD2_S)
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_RSVD3_S 9
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_WRX4_GLPE_WRX_DTM_CONTROL_RSVD3_S)
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_BYPASS_S 8
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_CONTROL_BYPASS_S)
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_RSVD4_S 1
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_WRX4_GLPE_WRX_DTM_CONTROL_RSVD4_S)
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_WRX4_GLPE_WRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_WRX4_GLPE_WRX_DTM_ECC_COR_ERR 0x440080E8
#define IG3_WRX4_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_WRX4_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX4_GLPE_WRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_WRX4_GLPE_WRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_WRX4_GLPE_WRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WRX4_GLPE_WRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_WRX4_GLPE_WRX_DTM_ECC_UNCOR_ERR 0x440080E4
#define IG3_WRX4_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_WRX4_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX4_GLPE_WRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_WRX4_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_WRX4_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WRX4_GLPE_WRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_WRX4_GLPE_WRX_DTM_GROUP_CFG 0x4400808C
#define IG3_WRX4_GLPE_WRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_WRX4_GLPE_WRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WRX4_GLPE_WRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_WRX4_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX4_GLPE_WRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_WRX4_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_WRX4_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX4_GLPE_WRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_WRX4_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_WRX4_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WRX4_GLPE_WRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_WRX4_GLPE_WRX_DTM_LOG_CFG 0x44008090
#define IG3_WRX4_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_WRX4_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_WRX4_GLPE_WRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_WRX4_GLPE_WRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_WRX4_GLPE_WRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_WRX4_GLPE_WRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_DTM_LOG_CFG_MODE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_WRX4_GLPE_WRX_DTM_LOG_CFG_MODE_S)
#define IG3_WRX4_GLPE_WRX_DTM_LOG_MASK 0x44008098
#define IG3_WRX4_GLPE_WRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_DTM_LOG_MASK_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_LOG_PATTERN 0x44008094
#define IG3_WRX4_GLPE_WRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG 0x44008084
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_STS 0x44008088
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_WRX4_GLPE_WRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WRX4_GLPE_WRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_WRX4_GLPE_WRX_DTM_TIMESTAMP 0x440080B0
#define IG3_WRX4_GLPE_WRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER 0x440080B4
#define IG3_WRX4_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG 0x440080DC
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS 0x440080E0
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG 0x4400809C
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_WRX4_GLPE_WRX_DTM_TRIG_CFG_MODE_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_COUNT 0x440080A8
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_MASK 0x440080A4
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_PATTERN 0x440080A0
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_TIMESTAMP 0x440080AC
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_WRX4_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHHI 0x44008020
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WRX4_GLPE_WRX_FWQPFLUSHHI_RSVD0_S)
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHHI_QPID_S 6
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_WRX4_GLPE_WRX_FWQPFLUSHHI_QPID_S)
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WRX4_GLPE_WRX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO 0x4400801C
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_BUSY_S 31
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_BUSY_S)
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_RSVD0_S)
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_HOSTID_S)
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_PMF_S 0
#define IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WRX4_GLPE_WRX_FWQPFLUSHLO_PMF_S)
#define IG3_WRX4_GLPE_WRX_RQ_CACHE_CTRL 0x44008004
#define IG3_WRX4_GLPE_WRX_RQ_CACHE_CTRL_RSVD_S 7
#define IG3_WRX4_GLPE_WRX_RQ_CACHE_CTRL_RSVD_M RDMA_MASK3(32, 0x1FFFFFF, IG3_WRX4_GLPE_WRX_RQ_CACHE_CTRL_RSVD_S)
#define IG3_WRX4_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_S 0
#define IG3_WRX4_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_M RDMA_MASK3(32, 0x7F, IG3_WRX4_GLPE_WRX_RQ_CACHE_CTRL_WQE_IDX_S)
#define IG3_WRX4_GLPE_WRX_RQ_CACHE_DATA0 0x44008008
#define IG3_WRX4_GLPE_WRX_RQ_CACHE_DATA0_DATA_S 0
#define IG3_WRX4_GLPE_WRX_RQ_CACHE_DATA0_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_RQ_CACHE_DATA0_DATA_S)
#define IG3_WRX4_GLPE_WRX_RQ_CACHE_DATA1 0x4400800C
#define IG3_WRX4_GLPE_WRX_RQ_CACHE_DATA1_DATA_S 0
#define IG3_WRX4_GLPE_WRX_RQ_CACHE_DATA1_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_RQ_CACHE_DATA1_DATA_S)
#define IG3_WRX4_GLPE_WRX_RQ_CACHE_DATA2 0x44008010
#define IG3_WRX4_GLPE_WRX_RQ_CACHE_DATA2_DATA_S 0
#define IG3_WRX4_GLPE_WRX_RQ_CACHE_DATA2_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WRX4_GLPE_WRX_RQ_CACHE_DATA2_DATA_S)
#define IG3_SQC4_GLPE_SQC_CONFIG 0x44008470
#define IG3_SQC4_GLPE_SQC_CONFIG_RSVD_S 6
#define IG3_SQC4_GLPE_SQC_CONFIG_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_SQC4_GLPE_SQC_CONFIG_RSVD_S)
#define IG3_SQC4_GLPE_SQC_CONFIG_DBL_INDV_DIS_S 3
#define IG3_SQC4_GLPE_SQC_CONFIG_DBL_INDV_DIS_M RDMA_MASK3(32, 0x7, IG3_SQC4_GLPE_SQC_CONFIG_DBL_INDV_DIS_S)
#define IG3_SQC4_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_S 2
#define IG3_SQC4_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_CONFIG_CRT_XMIT_RAM_EN_S)
#define IG3_SQC4_GLPE_SQC_CONFIG_DBL_DIS_S 1
#define IG3_SQC4_GLPE_SQC_CONFIG_DBL_DIS_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_CONFIG_DBL_DIS_S)
#define IG3_SQC4_GLPE_SQC_CONFIG_COALESCE_DIS_S 0
#define IG3_SQC4_GLPE_SQC_CONFIG_COALESCE_DIS_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_CONFIG_COALESCE_DIS_S)
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_COUNT 0x440084B8
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC4_GLPE_SQC_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC4_GLPE_SQC_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_CMD 0x440084CC
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_DATA_H 0x440084D8
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_DATA_L 0x440084D4
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_PTR 0x440084D0
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC4_GLPE_SQC_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_CMD 0x440084BC
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_DATA_H 0x440084C8
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_DATA_L 0x440084C4
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_PTR 0x440084C0
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC4_GLPE_SQC_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL 0x44008480
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_RSVD1_S 25
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SQC4_GLPE_SQC_DTM_CONTROL_RSVD1_S)
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_RSVD2_S 17
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC4_GLPE_SQC_DTM_CONTROL_RSVD2_S)
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_RSVD3_S 9
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SQC4_GLPE_SQC_DTM_CONTROL_RSVD3_S)
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_BYPASS_S 8
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_CONTROL_BYPASS_S)
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_RSVD4_S 1
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SQC4_GLPE_SQC_DTM_CONTROL_RSVD4_S)
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SQC4_GLPE_SQC_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SQC4_GLPE_SQC_DTM_ECC_COR_ERR 0x440084E8
#define IG3_SQC4_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SQC4_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC4_GLPE_SQC_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SQC4_GLPE_SQC_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SQC4_GLPE_SQC_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC4_GLPE_SQC_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SQC4_GLPE_SQC_DTM_ECC_UNCOR_ERR 0x440084E4
#define IG3_SQC4_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SQC4_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC4_GLPE_SQC_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SQC4_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SQC4_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC4_GLPE_SQC_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SQC4_GLPE_SQC_DTM_GROUP_CFG 0x4400848C
#define IG3_SQC4_GLPE_SQC_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SQC4_GLPE_SQC_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SQC4_GLPE_SQC_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SQC4_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SQC4_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC4_GLPE_SQC_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SQC4_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SQC4_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC4_GLPE_SQC_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SQC4_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SQC4_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SQC4_GLPE_SQC_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SQC4_GLPE_SQC_DTM_LOG_CFG 0x44008490
#define IG3_SQC4_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SQC4_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SQC4_GLPE_SQC_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SQC4_GLPE_SQC_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SQC4_GLPE_SQC_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SQC4_GLPE_SQC_DTM_LOG_CFG_RSVD1_S)
#define IG3_SQC4_GLPE_SQC_DTM_LOG_CFG_MODE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SQC4_GLPE_SQC_DTM_LOG_CFG_MODE_S)
#define IG3_SQC4_GLPE_SQC_DTM_LOG_MASK 0x44008498
#define IG3_SQC4_GLPE_SQC_DTM_LOG_MASK_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC4_GLPE_SQC_DTM_LOG_MASK_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_LOG_PATTERN 0x44008494
#define IG3_SQC4_GLPE_SQC_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC4_GLPE_SQC_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG 0x44008484
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_STS 0x44008488
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SQC4_GLPE_SQC_DTM_MAIN_STS_RSVD1_S)
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SQC4_GLPE_SQC_DTM_MAIN_STS_RSVD2_S)
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SQC4_GLPE_SQC_DTM_TIMESTAMP 0x440084B0
#define IG3_SQC4_GLPE_SQC_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC4_GLPE_SQC_DTM_TIMESTAMP_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER 0x440084B4
#define IG3_SQC4_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC4_GLPE_SQC_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG 0x440084DC
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS 0x440084E0
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG 0x4400849C
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_MODE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SQC4_GLPE_SQC_DTM_TRIG_CFG_MODE_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_COUNT 0x440084A8
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC4_GLPE_SQC_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_MASK 0x440084A4
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC4_GLPE_SQC_DTM_TRIG_MASK_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_PATTERN 0x440084A0
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC4_GLPE_SQC_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_TIMESTAMP 0x440084AC
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SQC4_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SQC4_GLPE_SQC_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHHI 0x44008460
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_S 26
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHHI_RSVD0_S)
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHHI_QPID_S 6
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHHI_QPID_S)
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_S 0
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHHI_PF_NUM_S)
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO 0x44008464
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_S 31
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_BUSY_S)
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_S 30
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_REQ_TYPE_S)
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_S 29
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_RSVD0_S)
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_S 26
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_HOSTID_S)
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_VM_VF_NUM_S)
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_PMF_S 0
#define IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC4_GLPE_SQC_FWFLRQPFLUSHLO_PMF_S)
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPHI(_i) 0x44008420 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPHI_MAX_INDEX_I 7
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPHI_RSVD0_S 26
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_SQC4_GLPE_SQC_FWFLUSHDROPHI_RSVD0_S)
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPHI_QPID_S 6
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC4_GLPE_SQC_FWFLUSHDROPHI_QPID_S)
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_S 0
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_SQC4_GLPE_SQC_FWFLUSHDROPHI_PF_NUM_S)
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO(_i) 0x44008400 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_MAX_INDEX_I 7
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_EN_S 31
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_EN_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_EN_S)
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_RSVD0_S 29
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_RSVD0_S)
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_HOSTID_S 26
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_HOSTID_S)
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_S 24
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_VM_VF_TYPE_S)
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_S 12
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_VM_VF_NUM_S)
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_PMF_S 0
#define IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC4_GLPE_SQC_FWFLUSHDROPLO_PMF_S)
#define IG3_SQC4_GLPE_SQC_FWSYNCRESP(_i) 0x44008468 + ((_i) * 4) /* _i=0...1 */
#define IG3_SQC4_GLPE_SQC_FWSYNCRESP_MAX_INDEX_I 1
#define IG3_SQC4_GLPE_SQC_FWSYNCRESP_RSVD_S 18
#define IG3_SQC4_GLPE_SQC_FWSYNCRESP_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_SQC4_GLPE_SQC_FWSYNCRESP_RSVD_S)
#define IG3_SQC4_GLPE_SQC_FWSYNCRESP_COUNT_S 8
#define IG3_SQC4_GLPE_SQC_FWSYNCRESP_COUNT_M RDMA_MASK3(32, 0x3FF, IG3_SQC4_GLPE_SQC_FWSYNCRESP_COUNT_S)
#define IG3_SQC4_GLPE_SQC_FWSYNCRESP_TAG_S 0
#define IG3_SQC4_GLPE_SQC_FWSYNCRESP_TAG_M RDMA_MASK3(32, 0xFF, IG3_SQC4_GLPE_SQC_FWSYNCRESP_TAG_S)
#define IG3_SQC4_GLPE_SQC_XLR_DROP(_i) 0x44008440 + ((_i) * 4) /* _i=0...7 */
#define IG3_SQC4_GLPE_SQC_XLR_DROP_MAX_INDEX_I 7
#define IG3_SQC4_GLPE_SQC_XLR_DROP_EN_S 31
#define IG3_SQC4_GLPE_SQC_XLR_DROP_EN_M RDMA_BIT2(32, IG3_SQC4_GLPE_SQC_XLR_DROP_EN_S)
#define IG3_SQC4_GLPE_SQC_XLR_DROP_RSVD0_S 12
#define IG3_SQC4_GLPE_SQC_XLR_DROP_RSVD0_M RDMA_MASK3(32, 0x7FFFF, IG3_SQC4_GLPE_SQC_XLR_DROP_RSVD0_S)
#define IG3_SQC4_GLPE_SQC_XLR_DROP_PMF_S 0
#define IG3_SQC4_GLPE_SQC_XLR_DROP_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SQC4_GLPE_SQC_XLR_DROP_PMF_S)
#define IG3_SQC4_SQC_ECC_COR_ERR 0x44008514
#define IG3_SQC4_SQC_ECC_COR_ERR_RSVD_S 12
#define IG3_SQC4_SQC_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC4_SQC_ECC_COR_ERR_RSVD_S)
#define IG3_SQC4_SQC_ECC_COR_ERR_CNT_S 0
#define IG3_SQC4_SQC_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC4_SQC_ECC_COR_ERR_CNT_S)
#define IG3_SQC4_SQC_ECC_UNCOR_ERR 0x44008510
#define IG3_SQC4_SQC_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SQC4_SQC_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SQC4_SQC_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SQC4_SQC_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SQC4_SQC_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SQC4_SQC_ECC_UNCOR_ERR_CNT_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG 0x44008500
#define IG3_SQC4_SQC_WRK_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_SQC4_SQC_WRK_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC4_SQC_WRK_RAM_CFG_ECC_INST_NUM_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_RSVD3_S 20
#define IG3_SQC4_SQC_WRK_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC4_SQC_WRK_RAM_CFG_RSVD3_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_RM_S 16
#define IG3_SQC4_SQC_WRK_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC4_SQC_WRK_RAM_CFG_RM_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_RSVD2_S 14
#define IG3_SQC4_SQC_WRK_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC4_SQC_WRK_RAM_CFG_RSVD2_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_SQC4_SQC_WRK_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC4_SQC_WRK_RAM_CFG_POWER_GATE_EN_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_RME_S 12
#define IG3_SQC4_SQC_WRK_RAM_CFG_RME_M RDMA_BIT2(32, IG3_SQC4_SQC_WRK_RAM_CFG_RME_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_RSVD1_S 10
#define IG3_SQC4_SQC_WRK_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC4_SQC_WRK_RAM_CFG_RSVD1_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_ERR_CNT_S 9
#define IG3_SQC4_SQC_WRK_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC4_SQC_WRK_RAM_CFG_ERR_CNT_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_FIX_CNT_S 8
#define IG3_SQC4_SQC_WRK_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC4_SQC_WRK_RAM_CFG_FIX_CNT_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_RSVD0_S 6
#define IG3_SQC4_SQC_WRK_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC4_SQC_WRK_RAM_CFG_RSVD0_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_MASK_INT_S 5
#define IG3_SQC4_SQC_WRK_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC4_SQC_WRK_RAM_CFG_MASK_INT_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_LS_BYPASS_S 4
#define IG3_SQC4_SQC_WRK_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC4_SQC_WRK_RAM_CFG_LS_BYPASS_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_LS_FORCE_S 3
#define IG3_SQC4_SQC_WRK_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC4_SQC_WRK_RAM_CFG_LS_FORCE_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_SQC4_SQC_WRK_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC4_SQC_WRK_RAM_CFG_ECC_INVERT_2_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_SQC4_SQC_WRK_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC4_SQC_WRK_RAM_CFG_ECC_INVERT_1_S)
#define IG3_SQC4_SQC_WRK_RAM_CFG_ECC_EN_S 0
#define IG3_SQC4_SQC_WRK_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC4_SQC_WRK_RAM_CFG_ECC_EN_S)
#define IG3_SQC4_SQC_WRK_RAM_STATUS 0x44008504
#define IG3_SQC4_SQC_WRK_RAM_STATUS_RSVD1_S 30
#define IG3_SQC4_SQC_WRK_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC4_SQC_WRK_RAM_STATUS_RSVD1_S)
#define IG3_SQC4_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC4_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC4_SQC_WRK_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC4_SQC_WRK_RAM_STATUS_RSVD0_S 4
#define IG3_SQC4_SQC_WRK_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC4_SQC_WRK_RAM_STATUS_RSVD0_S)
#define IG3_SQC4_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC4_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC4_SQC_WRK_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC4_SQC_WRK_RAM_STATUS_INIT_DONE_S 2
#define IG3_SQC4_SQC_WRK_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC4_SQC_WRK_RAM_STATUS_INIT_DONE_S)
#define IG3_SQC4_SQC_WRK_RAM_STATUS_ECC_FIX_S 1
#define IG3_SQC4_SQC_WRK_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC4_SQC_WRK_RAM_STATUS_ECC_FIX_S)
#define IG3_SQC4_SQC_WRK_RAM_STATUS_ECC_ERR_S 0
#define IG3_SQC4_SQC_WRK_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC4_SQC_WRK_RAM_STATUS_ECC_ERR_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG 0x44008508
#define IG3_SQC4_SQC_XBUF_RAM_CFG_ECC_INST_NUM_S 25
#define IG3_SQC4_SQC_XBUF_RAM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SQC4_SQC_XBUF_RAM_CFG_ECC_INST_NUM_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_RSVD3_S 20
#define IG3_SQC4_SQC_XBUF_RAM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SQC4_SQC_XBUF_RAM_CFG_RSVD3_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_RM_S 16
#define IG3_SQC4_SQC_XBUF_RAM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SQC4_SQC_XBUF_RAM_CFG_RM_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_RSVD2_S 14
#define IG3_SQC4_SQC_XBUF_RAM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SQC4_SQC_XBUF_RAM_CFG_RSVD2_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_POWER_GATE_EN_S 13
#define IG3_SQC4_SQC_XBUF_RAM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SQC4_SQC_XBUF_RAM_CFG_POWER_GATE_EN_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_RME_S 12
#define IG3_SQC4_SQC_XBUF_RAM_CFG_RME_M RDMA_BIT2(32, IG3_SQC4_SQC_XBUF_RAM_CFG_RME_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_RSVD1_S 10
#define IG3_SQC4_SQC_XBUF_RAM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC4_SQC_XBUF_RAM_CFG_RSVD1_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_ERR_CNT_S 9
#define IG3_SQC4_SQC_XBUF_RAM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SQC4_SQC_XBUF_RAM_CFG_ERR_CNT_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_FIX_CNT_S 8
#define IG3_SQC4_SQC_XBUF_RAM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SQC4_SQC_XBUF_RAM_CFG_FIX_CNT_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_RSVD0_S 6
#define IG3_SQC4_SQC_XBUF_RAM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SQC4_SQC_XBUF_RAM_CFG_RSVD0_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_MASK_INT_S 5
#define IG3_SQC4_SQC_XBUF_RAM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SQC4_SQC_XBUF_RAM_CFG_MASK_INT_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_LS_BYPASS_S 4
#define IG3_SQC4_SQC_XBUF_RAM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SQC4_SQC_XBUF_RAM_CFG_LS_BYPASS_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_LS_FORCE_S 3
#define IG3_SQC4_SQC_XBUF_RAM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SQC4_SQC_XBUF_RAM_CFG_LS_FORCE_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_ECC_INVERT_2_S 2
#define IG3_SQC4_SQC_XBUF_RAM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SQC4_SQC_XBUF_RAM_CFG_ECC_INVERT_2_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_ECC_INVERT_1_S 1
#define IG3_SQC4_SQC_XBUF_RAM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SQC4_SQC_XBUF_RAM_CFG_ECC_INVERT_1_S)
#define IG3_SQC4_SQC_XBUF_RAM_CFG_ECC_EN_S 0
#define IG3_SQC4_SQC_XBUF_RAM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SQC4_SQC_XBUF_RAM_CFG_ECC_EN_S)
#define IG3_SQC4_SQC_XBUF_RAM_STATUS 0x4400850C
#define IG3_SQC4_SQC_XBUF_RAM_STATUS_RSVD1_S 30
#define IG3_SQC4_SQC_XBUF_RAM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SQC4_SQC_XBUF_RAM_STATUS_RSVD1_S)
#define IG3_SQC4_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SQC4_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SQC4_SQC_XBUF_RAM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SQC4_SQC_XBUF_RAM_STATUS_RSVD0_S 4
#define IG3_SQC4_SQC_XBUF_RAM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SQC4_SQC_XBUF_RAM_STATUS_RSVD0_S)
#define IG3_SQC4_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SQC4_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SQC4_SQC_XBUF_RAM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SQC4_SQC_XBUF_RAM_STATUS_INIT_DONE_S 2
#define IG3_SQC4_SQC_XBUF_RAM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SQC4_SQC_XBUF_RAM_STATUS_INIT_DONE_S)
#define IG3_SQC4_SQC_XBUF_RAM_STATUS_ECC_FIX_S 1
#define IG3_SQC4_SQC_XBUF_RAM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SQC4_SQC_XBUF_RAM_STATUS_ECC_FIX_S)
#define IG3_SQC4_SQC_XBUF_RAM_STATUS_ECC_ERR_S 0
#define IG3_SQC4_SQC_XBUF_RAM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SQC4_SQC_XBUF_RAM_STATUS_ECC_ERR_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DOMAIN_ID 0x44008804
#define IG3_SFPRX4_GLPE_SFP_RX_DOMAIN_ID_RSVD_S 3
#define IG3_SFPRX4_GLPE_SFP_RX_DOMAIN_ID_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DOMAIN_ID_RSVD_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_SFPRX4_GLPE_SFP_RX_DOMAIN_ID_DOMAIN_ID_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_COUNT 0x440088B8
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_CMD 0x440088CC
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H 0x440088D8
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L 0x440088D4
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_PTR 0x440088D0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_CMD 0x440088BC
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H 0x440088C8
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L 0x440088C4
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_PTR 0x440088C0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL 0x44008880
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_RSVD1_S 25
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_RSVD1_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_RSVD2_S 17
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_RSVD2_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_RSVD3_S 9
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_RSVD3_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_BYPASS_S 8
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_BYPASS_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_RSVD4_S 1
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_RSVD4_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_ECC_COR_ERR 0x440088E8
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR 0x440088E4
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_GROUP_CFG 0x4400888C
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_CFG 0x44008890
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_CFG_RSVD1_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_CFG_MODE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_CFG_MODE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_MASK 0x44008898
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_MASK_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_PATTERN 0x44008894
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG 0x44008884
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_STS 0x44008888
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_STS_RSVD1_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_STS_RSVD2_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TIMESTAMP 0x440088B0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_TIMESTAMP_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER 0x440088B4
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG 0x440088DC
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS 0x440088E0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG 0x4400889C
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_CFG_MODE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_COUNT 0x440088A8
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_MASK 0x440088A4
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_MASK_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_PATTERN 0x440088A0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP 0x440088AC
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SFPRX4_GLPE_SFP_RX_ERR_TBL_CLR 0x44008800
#define IG3_SFPRX4_GLPE_SFP_RX_ERR_TBL_CLR_REQ_S 31
#define IG3_SFPRX4_GLPE_SFP_RX_ERR_TBL_CLR_REQ_M RDMA_BIT2(32, IG3_SFPRX4_GLPE_SFP_RX_ERR_TBL_CLR_REQ_S)
#define IG3_SFPRX4_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_S 12
#define IG3_SFPRX4_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_SFPRX4_GLPE_SFP_RX_ERR_TBL_CLR_RSVD_S)
#define IG3_SFPRX4_GLPE_SFP_RX_ERR_TBL_CLR_PMF_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_ERR_TBL_CLR_PMF_M RDMA_MASK3(32, 0xFFF, IG3_SFPRX4_GLPE_SFP_RX_ERR_TBL_CLR_PMF_S)
#define IG3_SFPRX4_GLPE_SFP_RX_PER_MEM 0x44008808
#define IG3_SFPRX4_GLPE_SFP_RX_PER_MEM_RSVD_S 3
#define IG3_SFPRX4_GLPE_SFP_RX_PER_MEM_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPRX4_GLPE_SFP_RX_PER_MEM_RSVD_S)
#define IG3_SFPRX4_GLPE_SFP_RX_PER_MEM_PER_TYPE_S 0
#define IG3_SFPRX4_GLPE_SFP_RX_PER_MEM_PER_TYPE_M RDMA_MASK3(32, 0x7, IG3_SFPRX4_GLPE_SFP_RX_PER_MEM_PER_TYPE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG 0x44008C08
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS 0x44008C0C
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_CC_CFG_CSR_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ECC_COR_ERR 0x44008C34
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_ECC_COR_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR 0x44008C30
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG 0x44008C18
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS 0x44008C1C
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_BUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG 0x44008C20
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS 0x44008C24
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_HDR_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG 0x44008C00
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS 0x44008C04
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_INPUT_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG 0x44008C28
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS 0x44008C2C
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_RCB_CMD_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG 0x44008C10
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS 0x44008C14
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_PRX_ROCEVMQP1LUT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG 0x44008C48
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS 0x44008C4C
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG 0x44008C40
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS 0x44008C44
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_AMP_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG 0x44008C78
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS 0x44008C7C
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG 0x44008C50
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS 0x44008C54
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG 0x44008C58
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS 0x44008C5C
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_DBUF_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR 0x44008C84
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_RSVD_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_ECC_COR_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR 0x44008C80
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG 0x44008C70
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS 0x44008C74
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_FRAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG 0x44008C60
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS 0x44008C64
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG 0x44008C68
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS 0x44008C6C
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_PAL_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG 0x44008C38
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS 0x44008C3C
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_SFPR_WQE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_ECC_COR_ERR 0x44008CCC
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_ECC_COR_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR 0x44008CC8
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG 0x44008CD8
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS 0x44008CDC
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SFPR_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL 0x44008C90
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_S 31
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RD_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_S 26
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_RSVD_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_S 18
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_DW_SEL_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_CTL_ADR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA 0x44008C94
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_DBG_DATA_RD_DW_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG 0x44008C88
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS 0x44008C8C
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_0_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL 0x44008CA0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_S 31
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RD_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_S 26
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_RSVD_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_DW_SEL_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_CTL_ADR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA 0x44008CA4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_DBG_DATA_RD_DW_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG 0x44008C98
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS 0x44008C9C
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL 0x44008CB0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_S 31
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RD_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_S 26
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_RSVD_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_S 18
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_DW_SEL_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_CTL_ADR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA 0x44008CB4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_DBG_DATA_RD_DW_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG 0x44008CA8
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS 0x44008CAC
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_2_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL 0x44008CC0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_S 31
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RD_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_S 26
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_RSVD_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_S 18
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_DW_SEL_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_CTL_ADR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA 0x44008CC4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_DBG_DATA_RD_DW_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG 0x44008CB8
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS 0x44008CBC
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_SPAD_3_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG 0x44008CD0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD3_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_S 16
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RM_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RME_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS 0x44008CD4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_RX_SHCTL_GLPE_WRX_WQE_FIFO_MEM_STATUS_ECC_ERR_S)
#define IG3_WTX4_GLPE_WTX_1USCOUNT 0x44010010
#define IG3_WTX4_GLPE_WTX_1USCOUNT_CNT_S 0
#define IG3_WTX4_GLPE_WTX_1USCOUNT_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_1USCOUNT_CNT_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0 0x44010120
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_TAG_S 16
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_TAG_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_MODE_S 11
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_MODE_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1 0x44010124
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_HOSTID_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_PMF_S 0
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG1_PMF_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG2 0x44010128
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG2_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG2_QPID_S 6
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG2_QPID_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG3 0x4401012C
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG4 0x44010130
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_S 0
#define IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_ABORT_DTM_TRIG4_COUNT_S)
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG 0x44010020
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG_RSVD3_S 24
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG_RSVD3_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_ARB_CONFIG_RSVD3_S)
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG_RSVD2_S 20
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WTX4_GLPE_WTX_ARB_CONFIG_RSVD2_S)
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_S 16
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX4_GLPE_WTX_ARB_CONFIG_SCHD_RSP_ARB_WGHT_S)
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG_RSVD1_S 12
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_WTX4_GLPE_WTX_ARB_CONFIG_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_S 8
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX4_GLPE_WTX_ARB_CONFIG_SCHD_REQ_ARB_WGHT_S)
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG_RSVD0_S 4
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG_RSVD0_M RDMA_MASK3(32, 0xF, IG3_WTX4_GLPE_WTX_ARB_CONFIG_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_S 0
#define IG3_WTX4_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_M RDMA_MASK3(32, 0xF, IG3_WTX4_GLPE_WTX_ARB_CONFIG_PUSH_ARB_WGHT_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0 0x440100F8
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_TAG_S 16
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_TAG_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_MODE_S 11
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_MODE_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1 0x440100FC
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_HOSTID_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_PMF_S 0
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG1_PMF_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG2 0x44010100
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG2_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG2_QPID_S 6
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG2_QPID_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG3 0x44010104
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG4 0x44010108
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG4_COUNT_S 0
#define IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_CMP_DTM_TRIG4_COUNT_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG 0x4401017C
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_S 31
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_FULL_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NFULL_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_S 27
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_OVF_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_S 26
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_UDF_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_RSVD_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX 0x44010180
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_CMP_UPDATE_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_CNPCOUNT 0x44010014
#define IG3_WTX4_GLPE_WTX_CNPCOUNT_CNT_S 0
#define IG3_WTX4_GLPE_WTX_CNPCOUNT_CNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_CNPCOUNT_CNT_S)
#define IG3_WTX4_GLPE_WTX_CONFIG 0x4401000C
#define IG3_WTX4_GLPE_WTX_CONFIG_RSVD1_S 28
#define IG3_WTX4_GLPE_WTX_CONFIG_RSVD1_M RDMA_MASK3(32, 0xF, IG3_WTX4_GLPE_WTX_CONFIG_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_CONFIG_SQ_HSM_ORD_S 25
#define IG3_WTX4_GLPE_WTX_CONFIG_SQ_HSM_ORD_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_CONFIG_SQ_HSM_ORD_S)
#define IG3_WTX4_GLPE_WTX_CONFIG_SQ_WQE_ORD_S 22
#define IG3_WTX4_GLPE_WTX_CONFIG_SQ_WQE_ORD_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_CONFIG_SQ_WQE_ORD_S)
#define IG3_WTX4_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_S 21
#define IG3_WTX4_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CONFIG_SQ_SLOW_START_EN_S)
#define IG3_WTX4_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_S 20
#define IG3_WTX4_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CONFIG_CRT_XMIT_RAM_EN_S)
#define IG3_WTX4_GLPE_WTX_CONFIG_RSVD0_S 4
#define IG3_WTX4_GLPE_WTX_CONFIG_RSVD0_M RDMA_MASK3(32, 0xFFFF, IG3_WTX4_GLPE_WTX_CONFIG_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_S 3
#define IG3_WTX4_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CONFIG_PTX_SPAD_CACHE_EN_S)
#define IG3_WTX4_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_S 2
#define IG3_WTX4_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CONFIG_SHDW_WRITE_RLX_ORD_S)
#define IG3_WTX4_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_S 1
#define IG3_WTX4_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CONFIG_TX_Q1_PACK_EN_S)
#define IG3_WTX4_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_S 0
#define IG3_WTX4_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_CONFIG_TX_SPAD_CACHE_EN_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG0 0x4401003C
#define IG3_WTX4_GLPE_WTX_CTCONFIG0_RSVD_S 21
#define IG3_WTX4_GLPE_WTX_CTCONFIG0_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_WTX4_GLPE_WTX_CTCONFIG0_RSVD_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG0_SCHED_S 0
#define IG3_WTX4_GLPE_WTX_CTCONFIG0_SCHED_M RDMA_MASK3(32, 0x1FFFFF, IG3_WTX4_GLPE_WTX_CTCONFIG0_SCHED_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG1 0x44010040
#define IG3_WTX4_GLPE_WTX_CTCONFIG1_RSVD_S 21
#define IG3_WTX4_GLPE_WTX_CTCONFIG1_RSVD_M RDMA_MASK3(32, 0x7FF, IG3_WTX4_GLPE_WTX_CTCONFIG1_RSVD_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG1_VMRL_S 0
#define IG3_WTX4_GLPE_WTX_CTCONFIG1_VMRL_M RDMA_MASK3(32, 0x1FFFFF, IG3_WTX4_GLPE_WTX_CTCONFIG1_VMRL_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG2 0x44010044
#define IG3_WTX4_GLPE_WTX_CTCONFIG2_RSVD_S 30
#define IG3_WTX4_GLPE_WTX_CTCONFIG2_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_CTCONFIG2_RSVD_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_S 16
#define IG3_WTX4_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_CTCONFIG2_CRTREQTXPKT_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_S 0
#define IG3_WTX4_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX4_GLPE_WTX_CTCONFIG2_CRTREQTXBUF_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG3 0x44010048
#define IG3_WTX4_GLPE_WTX_CTCONFIG3_RSVD_S 30
#define IG3_WTX4_GLPE_WTX_CTCONFIG3_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_CTCONFIG3_RSVD_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_S 16
#define IG3_WTX4_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_CTCONFIG3_CRTREQRXPKT_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_S 0
#define IG3_WTX4_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX4_GLPE_WTX_CTCONFIG3_CRTREQRXBUF_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG4 0x4401004C
#define IG3_WTX4_GLPE_WTX_CTCONFIG4_RSVD_S 30
#define IG3_WTX4_GLPE_WTX_CTCONFIG4_RSVD_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_CTCONFIG4_RSVD_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_S 16
#define IG3_WTX4_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_CTCONFIG4_CRTRSPTXPKT_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_S 0
#define IG3_WTX4_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_M RDMA_MASK3(32, 0xFFFF, IG3_WTX4_GLPE_WTX_CTCONFIG4_CRTRSPTXBUF_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG5 0x44010050
#define IG3_WTX4_GLPE_WTX_CTCONFIG5_RSVD_S 20
#define IG3_WTX4_GLPE_WTX_CTCONFIG5_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_CTCONFIG5_RSVD_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG5_BMPKT_S 0
#define IG3_WTX4_GLPE_WTX_CTCONFIG5_BMPKT_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX4_GLPE_WTX_CTCONFIG5_BMPKT_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG6 0x44010054
#define IG3_WTX4_GLPE_WTX_CTCONFIG6_RSVD_S 13
#define IG3_WTX4_GLPE_WTX_CTCONFIG6_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_WTX4_GLPE_WTX_CTCONFIG6_RSVD_S)
#define IG3_WTX4_GLPE_WTX_CTCONFIG6_BMHDR_S 0
#define IG3_WTX4_GLPE_WTX_CTCONFIG6_BMHDR_M RDMA_MASK3(32, 0x1FFF, IG3_WTX4_GLPE_WTX_CTCONFIG6_BMHDR_S)
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_COUNT 0x44010238
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX4_GLPE_WTX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_CMD 0x4401024C
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_DATA_H 0x44010258
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_DATA_L 0x44010254
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_PTR 0x44010250
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX4_GLPE_WTX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_CMD 0x4401023C
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_DATA_H 0x44010248
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_DATA_L 0x44010244
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_PTR 0x44010240
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX4_GLPE_WTX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL 0x44010200
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_RSVD1_S 25
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_WTX4_GLPE_WTX_DTM_CONTROL_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_RSVD2_S 17
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX4_GLPE_WTX_DTM_CONTROL_RSVD2_S)
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_RSVD3_S 9
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_WTX4_GLPE_WTX_DTM_CONTROL_RSVD3_S)
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_BYPASS_S 8
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_CONTROL_BYPASS_S)
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_RSVD4_S 1
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_WTX4_GLPE_WTX_DTM_CONTROL_RSVD4_S)
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_WTX4_GLPE_WTX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_WTX4_GLPE_WTX_DTM_ECC_COR_ERR 0x44010268
#define IG3_WTX4_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX4_GLPE_WTX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_WTX4_GLPE_WTX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_WTX4_GLPE_WTX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_WTX4_GLPE_WTX_DTM_ECC_UNCOR_ERR 0x44010264
#define IG3_WTX4_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX4_GLPE_WTX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_WTX4_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_WTX4_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_WTX4_GLPE_WTX_DTM_GROUP_CFG 0x4401020C
#define IG3_WTX4_GLPE_WTX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_WTX4_GLPE_WTX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_WTX4_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_WTX4_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_WTX4_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_WTX4_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_WTX4_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_WTX4_GLPE_WTX_DTM_LOG_CFG 0x44010210
#define IG3_WTX4_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_WTX4_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_WTX4_GLPE_WTX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_WTX4_GLPE_WTX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_WTX4_GLPE_WTX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_DTM_LOG_CFG_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_DTM_LOG_CFG_MODE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_DTM_LOG_CFG_MODE_S)
#define IG3_WTX4_GLPE_WTX_DTM_LOG_MASK 0x44010218
#define IG3_WTX4_GLPE_WTX_DTM_LOG_MASK_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_DTM_LOG_MASK_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_LOG_PATTERN 0x44010214
#define IG3_WTX4_GLPE_WTX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG 0x44010204
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_STS 0x44010208
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_WTX4_GLPE_WTX_DTM_MAIN_STS_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_WTX4_GLPE_WTX_DTM_MAIN_STS_RSVD2_S)
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_WTX4_GLPE_WTX_DTM_TIMESTAMP 0x44010230
#define IG3_WTX4_GLPE_WTX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_DTM_TIMESTAMP_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER 0x44010234
#define IG3_WTX4_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG 0x4401025C
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS 0x44010260
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG 0x4401021C
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_MODE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_WTX4_GLPE_WTX_DTM_TRIG_CFG_MODE_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_COUNT 0x44010228
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_MASK 0x44010224
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_DTM_TRIG_MASK_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_PATTERN 0x44010220
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_TIMESTAMP 0x4401022C
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_WTX4_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG 0x4401014C
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_S 29
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_FTHRESH_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_S 13
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_S 0
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_CFG_DEPTH_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG 0x44010150
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_S 31
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_FULL_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_NFULL_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_S 27
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_OVF_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_S 26
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_UDF_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_RSVD_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX 0x44010154
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_FLM_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHHI 0x4401005C
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WTX4_GLPE_WTX_FWQPFLUSHHI_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHHI_QPID_S 6
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_WTX4_GLPE_WTX_FWQPFLUSHHI_QPID_S)
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX4_GLPE_WTX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO 0x44010058
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_BUSY_S 31
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_BUSY_S)
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_HOSTID_S)
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_PMF_S 0
#define IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_FWQPFLUSHLO_PMF_S)
#define IG3_WTX4_GLPE_WTX_HOST_READ_CONFIG 0x44010038
#define IG3_WTX4_GLPE_WTX_HOST_READ_CONFIG_RSVD_S 8
#define IG3_WTX4_GLPE_WTX_HOST_READ_CONFIG_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX4_GLPE_WTX_HOST_READ_CONFIG_RSVD_S)
#define IG3_WTX4_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_S 0
#define IG3_WTX4_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_HOST_READ_CONFIG_RD_DEPTH_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0 0x4401010C
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_S 16
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_S 11
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_MODE_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1 0x44010110
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_HOSTID_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_S 0
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG1_PMF_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG2 0x44010114
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG2_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_S 6
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG2_QPID_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG3 0x44010118
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG4 0x4401011C
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_S 0
#define IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_OC_CMP_DTM_TRIG4_COUNT_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG 0x4401018C
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_S 31
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_FULL_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_NFULL_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_S 27
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_OVF_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_S 26
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_UDF_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_RSVD_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX 0x44010190
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_OC_DATA_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG 0x44010194
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_S 31
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_FULL_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_NFULL_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_S 27
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_OVF_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_S 26
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_UDF_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_RSVD_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX 0x44010198
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_OC_ERR_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG 0x44010184
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_S 31
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_FULL_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_NFULL_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_S 27
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_OVF_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_S 26
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_UDF_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_RSVD_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX 0x44010188
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_OC_TAG_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0 0x44010090
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1 0x44010094
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG2 0x44010098
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG3 0x4401009C
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG4 0x440100A0
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_PUSH_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0 0x44010060
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1 0x44010064
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG2 0x44010068
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG3 0x4401006C
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG4 0x44010070
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG5 0x44010074
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG5_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_REQ_IF_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0 0x44010078
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_S 16
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_S 11
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_MODE_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1 0x4401007C
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_S 0
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG1_PMF_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG2 0x44010080
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_S 6
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG2_QPID_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG3 0x44010084
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG4 0x44010088
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG4_COUNT_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG5 0x4401008C
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG5_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_RSP_IF_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG 0x44010134
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_S 29
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_FTHRESH_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_S 13
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_S 0
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_CFG_DEPTH_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG 0x44010138
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_S 31
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_FULL_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_NFULL_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_S 27
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_OVF_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_S 26
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_UDF_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_RSVD_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX 0x4401013C
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SCHD_REQ_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG 0x44010140
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_S 29
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_FTHRESH_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_S 13
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_S 0
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_CFG_DEPTH_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG 0x44010144
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_S 31
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_FULL_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_NFULL_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_S 27
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_OVF_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_S 26
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_UDF_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_RSVD_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX 0x44010148
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SCHD_RSP_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG 0x44010164
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_S 29
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_FTHRESH_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_S 13
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_S 0
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_CFG_DEPTH_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG 0x44010168
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_S 31
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_FULL_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NFULL_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_S 27
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_OVF_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_S 26
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_UDF_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_RSVD_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX 0x4401016C
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SM_FLM_INFO_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG 0x44010158
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_S 29
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_FTHRESH_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_S 13
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_S 0
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_CFG_DEPTH_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG 0x4401015C
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_S 31
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_FULL_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_NFULL_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_S 27
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_OVF_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_S 26
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_UDF_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_RSVD_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX 0x44010160
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SM_PAL_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0 0x440100E4
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_S 16
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_S 11
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_MODE_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1 0x440100E8
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_HOSTID_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_S 0
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG1_PMF_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG2 0x440100EC
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG2_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_S 6
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG2_QPID_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG3 0x440100F0
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG4 0x440100F4
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_S 0
#define IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_SM_PTX_DTM_TRIG4_COUNT_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0 0x440100D0
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_S 16
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_S 11
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_MODE_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1 0x440100D4
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_HOSTID_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_S 0
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG1_PMF_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG2 0x440100D8
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG2_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_S 6
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG2_QPID_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG3 0x440100DC
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG4 0x440100E0
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_S 0
#define IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_SM_WQE_DTM_TRIG4_COUNT_S)
#define IG3_WTX4_GLPE_WTX_SPADS_ASSIGNED(_i) 0x44010000 + ((_i) * 4) /* _i=0...2 */
#define IG3_WTX4_GLPE_WTX_SPADS_ASSIGNED_MAX_INDEX_I 2
#define IG3_WTX4_GLPE_WTX_SPADS_ASSIGNED_SPAD3_S 24
#define IG3_WTX4_GLPE_WTX_SPADS_ASSIGNED_SPAD3_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPADS_ASSIGNED_SPAD3_S)
#define IG3_WTX4_GLPE_WTX_SPADS_ASSIGNED_SPAD2_S 16
#define IG3_WTX4_GLPE_WTX_SPADS_ASSIGNED_SPAD2_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPADS_ASSIGNED_SPAD2_S)
#define IG3_WTX4_GLPE_WTX_SPADS_ASSIGNED_SPAD1_S 8
#define IG3_WTX4_GLPE_WTX_SPADS_ASSIGNED_SPAD1_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPADS_ASSIGNED_SPAD1_S)
#define IG3_WTX4_GLPE_WTX_SPADS_ASSIGNED_SPAD0_S 0
#define IG3_WTX4_GLPE_WTX_SPADS_ASSIGNED_SPAD0_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPADS_ASSIGNED_SPAD0_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0 0x440100A4
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_S 16
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_S 11
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_MODE_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1 0x440100A8
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_HOSTID_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG1_PMF_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG2 0x440100AC
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_S 6
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_QPID_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG3 0x440100B0
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG4 0x440100B4
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG4_COUNT_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG5 0x440100B8
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_S 1
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_ASGN_DTM_TRIG5_DEALLOC_MASK_S)
#define IG3_WTX4_GLPE_WTX_SPAD_CONFIG0 0x44010024
#define IG3_WTX4_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_S 24
#define IG3_WTX4_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_CONFIG0_CQP_MAX_S)
#define IG3_WTX4_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_S 16
#define IG3_WTX4_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_CONFIG0_RSP_MAX_S)
#define IG3_WTX4_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_S 8
#define IG3_WTX4_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_CONFIG0_REQ_MAX_S)
#define IG3_WTX4_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_CONFIG0_PUSH_MAX_S)
#define IG3_WTX4_GLPE_WTX_SPAD_CONFIG1 0x44010028
#define IG3_WTX4_GLPE_WTX_SPAD_CONFIG1_RSVD_S 8
#define IG3_WTX4_GLPE_WTX_SPAD_CONFIG1_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX4_GLPE_WTX_SPAD_CONFIG1_RSVD_S)
#define IG3_WTX4_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_CONFIG1_FLR_MAX_S)
#define IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS0 0x4401002C
#define IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_S 24
#define IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS0_CQP_COUNT_S)
#define IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_S 16
#define IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS0_RSP_COUNT_S)
#define IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_S 8
#define IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS0_REQ_COUNT_S)
#define IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS0_PUSH_COUNT_S)
#define IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS1 0x44010030
#define IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_S 8
#define IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS1_RSVD_S)
#define IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_DEPTH_STATUS1_FLR_COUNT_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0 0x440100BC
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_S 24
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_S 16
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_S 14
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_S 11
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_MODE_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_S 9
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_TAG_EN_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_S 8
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_QPID_EN_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_S 3
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PMF_EN_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1 0x440100C0
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_S 29
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_S 26
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_HOSTID_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG1_PMF_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG2 0x440100C4
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_S 30
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG2_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_S 6
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG2_QPID_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG2_PF_NUM_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG3 0x440100C8
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG3_THRESHOLD_S)
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG4 0x440100CC
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_SPAD_INTF_DTM_TRIG4_COUNT_S)
#define IG3_WTX4_GLPE_WTX_SPAD_QUEUE_PTR_CTL 0x44010034
#define IG3_WTX4_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_S 16
#define IG3_WTX4_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_M RDMA_MASK3(32, 0xFFFF, IG3_WTX4_GLPE_WTX_SPAD_QUEUE_PTR_CTL_RSVD_S)
#define IG3_WTX4_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_S 8
#define IG3_WTX4_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_NXTPTR_S)
#define IG3_WTX4_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_QUEUE_PTR_CTL_QUEUE_PTR_S)
#define IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL 0x44010018
#define IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_RSVD1_S 20
#define IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_S 16
#define IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_M RDMA_MASK3(32, 0xF, IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_SPAD_WR_DATA_S)
#define IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_RSVD0_S 10
#define IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_S 8
#define IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_M RDMA_MASK3(32, 0x3, IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_SEL_S)
#define IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_M RDMA_MASK3(32, 0xFF, IG3_WTX4_GLPE_WTX_SPAD_STAT_CTL_SPAD_PORT_ID_S)
#define IG3_WTX4_GLPE_WTX_SPAD_STAT_DATA 0x4401001C
#define IG3_WTX4_GLPE_WTX_SPAD_STAT_DATA_DATA_S 0
#define IG3_WTX4_GLPE_WTX_SPAD_STAT_DATA_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_WTX4_GLPE_WTX_SPAD_STAT_DATA_DATA_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG 0x44010170
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_S 29
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD1_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_S 28
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_EN_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_S 16
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_FTHRESH_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_S 13
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_M RDMA_MASK3(32, 0x7, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_RSVD0_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_S 12
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_EN_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_S 0
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_CFG_DEPTH_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG 0x44010174
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_S 31
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_FULL_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NFULL_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_S 27
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_OVF_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_S 26
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_UDF_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_RSVD_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_NUM_ENTRIES_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX 0x44010178
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_S 31
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_FULL_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_S 30
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_EMPTY_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_S 29
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NFULL_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_S 28
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NEMPTY_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_S 27
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_OVF_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_S 26
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_M RDMA_BIT2(32, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_UDF_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_S 12
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_RSVD_S)
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_S 0
#define IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_M RDMA_MASK3(32, 0xFFF, IG3_WTX4_GLPE_WTX_SPIF_CT_TRAN_FIFO_DBG_MAX_NUM_ENTRIES_S)
#define IG3_PTX4_GLPE_ARPCONTROL 0x4401400C
#define IG3_PTX4_GLPE_ARPCONTROL_ARP_LOCK_ACK_S 31
#define IG3_PTX4_GLPE_ARPCONTROL_ARP_LOCK_ACK_M RDMA_BIT2(32, IG3_PTX4_GLPE_ARPCONTROL_ARP_LOCK_ACK_S)
#define IG3_PTX4_GLPE_ARPCONTROL_ARP_LOCK_REQ_S 30
#define IG3_PTX4_GLPE_ARPCONTROL_ARP_LOCK_REQ_M RDMA_BIT2(32, IG3_PTX4_GLPE_ARPCONTROL_ARP_LOCK_REQ_S)
#define IG3_PTX4_GLPE_ARPCONTROL_RSVD_S 16
#define IG3_PTX4_GLPE_ARPCONTROL_RSVD_M RDMA_MASK3(32, 0x3FFF, IG3_PTX4_GLPE_ARPCONTROL_RSVD_S)
#define IG3_PTX4_GLPE_ARPCONTROL_ARP_LOCK_INDEX_S 0
#define IG3_PTX4_GLPE_ARPCONTROL_ARP_LOCK_INDEX_M RDMA_MASK3(32, 0xFFFF, IG3_PTX4_GLPE_ARPCONTROL_ARP_LOCK_INDEX_S)
#define IG3_PTX4_GLPE_CRT_CONFIG0 0x44014010
#define IG3_PTX4_GLPE_CRT_CONFIG0_RSVD_S 25
#define IG3_PTX4_GLPE_CRT_CONFIG0_RSVD_M RDMA_MASK3(32, 0x7F, IG3_PTX4_GLPE_CRT_CONFIG0_RSVD_S)
#define IG3_PTX4_GLPE_CRT_CONFIG0_QP_FC_EN_S 24
#define IG3_PTX4_GLPE_CRT_CONFIG0_QP_FC_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_CRT_CONFIG0_QP_FC_EN_S)
#define IG3_PTX4_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_S 16
#define IG3_PTX4_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_CRT_CONFIG0_TX_OFFSET_PKT_S)
#define IG3_PTX4_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_S 8
#define IG3_PTX4_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_CRT_CONFIG0_TX_OFFSET_PMD_S)
#define IG3_PTX4_GLPE_CRT_CONFIG0_TX_BUF_SIZE_S 0
#define IG3_PTX4_GLPE_CRT_CONFIG0_TX_BUF_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_CRT_CONFIG0_TX_BUF_SIZE_S)
#define IG3_PTX4_GLPE_CRT_CONFIG1 0x44014014
#define IG3_PTX4_GLPE_CRT_CONFIG1_RSVD_S 19
#define IG3_PTX4_GLPE_CRT_CONFIG1_RSVD_M RDMA_MASK3(32, 0x1FFF, IG3_PTX4_GLPE_CRT_CONFIG1_RSVD_S)
#define IG3_PTX4_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_S 16
#define IG3_PTX4_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_M RDMA_MASK3(32, 0x7, IG3_PTX4_GLPE_CRT_CONFIG1_RX_PMD_BUF_CNT_S)
#define IG3_PTX4_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_S 8
#define IG3_PTX4_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_CRT_CONFIG1_RX_OFFSET_PKT_S)
#define IG3_PTX4_GLPE_CRT_CONFIG1_RX_BUF_SIZE_S 0
#define IG3_PTX4_GLPE_CRT_CONFIG1_RX_BUF_SIZE_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_CRT_CONFIG1_RX_BUF_SIZE_S)
#define IG3_PTX4_GLPE_MAX_INLINE_DATA 0x44014000
#define IG3_PTX4_GLPE_MAX_INLINE_DATA_RSVD_S 8
#define IG3_PTX4_GLPE_MAX_INLINE_DATA_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX4_GLPE_MAX_INLINE_DATA_RSVD_S)
#define IG3_PTX4_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_S 0
#define IG3_PTX4_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_MAX_INLINE_DATA_MAX_INLINE_DATA_S)
#define IG3_PTX4_GLPE_MAX_TCP_ACKS 0x44014004
#define IG3_PTX4_GLPE_MAX_TCP_ACKS_RSVD_S 8
#define IG3_PTX4_GLPE_MAX_TCP_ACKS_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX4_GLPE_MAX_TCP_ACKS_RSVD_S)
#define IG3_PTX4_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_S 0
#define IG3_PTX4_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_MAX_TCP_ACKS_MAX_TCP_ACKS_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0 0x44014018
#define IG3_PTX4_GLPE_PTX_CONFIG0_RSVD_31_S 31
#define IG3_PTX4_GLPE_PTX_CONFIG0_RSVD_31_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_RSVD_31_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_S 30
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_DIS_WQE_INV_ADDL_LINES_AE_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_S 29
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_DIS_QUANTA_ABORT_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_S 28
#define IG3_PTX4_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_SET_BOTH_ACKREQ_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_S 27
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_DIS_IW_ID_WR_MO_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_S 26
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_DIS_XMIT_WR64_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_S 22
#define IG3_PTX4_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_M RDMA_MASK3(32, 0xF, IG3_PTX4_GLPE_PTX_CONFIG0_CTXT_LOCK_WQE_LIM_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_S 21
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_DIS_MRKR_CALC_OPT_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_S 20
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_DIS_CMP_COALESCE_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_RSVD_19_S 19
#define IG3_PTX4_GLPE_PTX_CONFIG0_RSVD_19_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_RSVD_19_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_S 18
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_DIS_CMP_SNOOP_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_S 17
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_DIS_1WQE_FRAG_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_S 16
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_DIS_SNDMAX_ACKS_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_S 15
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_DIS_XMIT_WR_FIFO_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_S 14
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_DIS_CTXT_RELEASE_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_RSVD_13_7_S 7
#define IG3_PTX4_GLPE_PTX_CONFIG0_RSVD_13_7_M RDMA_MASK3(32, 0x7F, IG3_PTX4_GLPE_PTX_CONFIG0_RSVD_13_7_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_UDP_CS_EN_S 6
#define IG3_PTX4_GLPE_PTX_CONFIG0_UDP_CS_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_UDP_CS_EN_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_Q1_PACING_S 5
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_Q1_PACING_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_DIS_Q1_PACING_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_S 4
#define IG3_PTX4_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_POLICY_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_S 3
#define IG3_PTX4_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_DIS_DUP_RREQ_FILTER_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_S 1
#define IG3_PTX4_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_CONFIG0_ROCE_DUP_RRESP_OP_POLICY_S)
#define IG3_PTX4_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_S 0
#define IG3_PTX4_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_CONFIG0_ROCE_TRIM_RREQ_EN_S)
#define IG3_PTX4_GLPE_PTX_CONFIG1 0x4401401C
#define IG3_PTX4_GLPE_PTX_CONFIG1_RSVD_S 24
#define IG3_PTX4_GLPE_PTX_CONFIG1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_CONFIG1_RSVD_S)
#define IG3_PTX4_GLPE_PTX_CONFIG1_ACKREQ_PACING_S 21
#define IG3_PTX4_GLPE_PTX_CONFIG1_ACKREQ_PACING_M RDMA_MASK3(32, 0x7, IG3_PTX4_GLPE_PTX_CONFIG1_ACKREQ_PACING_S)
#define IG3_PTX4_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_S 16
#define IG3_PTX4_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_M RDMA_MASK3(32, 0x1F, IG3_PTX4_GLPE_PTX_CONFIG1_CWND_SHIFT_VAL_S)
#define IG3_PTX4_GLPE_PTX_CONFIG1_Q1_PACING_MULT_S 0
#define IG3_PTX4_GLPE_PTX_CONFIG1_Q1_PACING_MULT_M RDMA_MASK3(32, 0xFFFF, IG3_PTX4_GLPE_PTX_CONFIG1_Q1_PACING_MULT_S)
#define IG3_PTX4_GLPE_PTX_CONFIG2 0x44014020
#define IG3_PTX4_GLPE_PTX_CONFIG2_SEND2CPU_S 0
#define IG3_PTX4_GLPE_PTX_CONFIG2_SEND2CPU_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_CONFIG2_SEND2CPU_S)
#define IG3_PTX4_GLPE_PTX_CRT_XMIT_PTR 0x4401402C
#define IG3_PTX4_GLPE_PTX_CRT_XMIT_PTR_RSVD_S 8
#define IG3_PTX4_GLPE_PTX_CRT_XMIT_PTR_RSVD_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX4_GLPE_PTX_CRT_XMIT_PTR_RSVD_S)
#define IG3_PTX4_GLPE_PTX_CRT_XMIT_PTR_COUNT_S 0
#define IG3_PTX4_GLPE_PTX_CRT_XMIT_PTR_COUNT_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_CRT_XMIT_PTR_COUNT_S)
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_COUNT 0x44014138
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX4_GLPE_PTX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX4_GLPE_PTX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_CMD 0x4401414C
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_DATA_H 0x44014158
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_DATA_L 0x44014154
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_PTR 0x44014150
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX4_GLPE_PTX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_CMD 0x4401413C
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_DATA_H 0x44014148
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_DATA_L 0x44014144
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_PTR 0x44014140
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX4_GLPE_PTX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL 0x44014100
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_RSVD1_S 25
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_PTX4_GLPE_PTX_DTM_CONTROL_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_RSVD2_S 17
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX4_GLPE_PTX_DTM_CONTROL_RSVD2_S)
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_RSVD3_S 9
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_PTX4_GLPE_PTX_DTM_CONTROL_RSVD3_S)
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_BYPASS_S 8
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_CONTROL_BYPASS_S)
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_RSVD4_S 1
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_PTX4_GLPE_PTX_DTM_CONTROL_RSVD4_S)
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_PTX4_GLPE_PTX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_PTX4_GLPE_PTX_DTM_ECC_COR_ERR 0x44014168
#define IG3_PTX4_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_PTX4_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX4_GLPE_PTX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_PTX4_GLPE_PTX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_PTX4_GLPE_PTX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PTX4_GLPE_PTX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_PTX4_GLPE_PTX_DTM_ECC_UNCOR_ERR 0x44014164
#define IG3_PTX4_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_PTX4_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX4_GLPE_PTX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_PTX4_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_PTX4_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_PTX4_GLPE_PTX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_PTX4_GLPE_PTX_DTM_GROUP_CFG 0x4401410C
#define IG3_PTX4_GLPE_PTX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_PTX4_GLPE_PTX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_PTX4_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_PTX4_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_PTX4_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_PTX4_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_PTX4_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_PTX4_GLPE_PTX_DTM_LOG_CFG 0x44014110
#define IG3_PTX4_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_PTX4_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_PTX4_GLPE_PTX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_PTX4_GLPE_PTX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_PTX4_GLPE_PTX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_PTX4_GLPE_PTX_DTM_LOG_CFG_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_DTM_LOG_CFG_MODE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_DTM_LOG_CFG_MODE_S)
#define IG3_PTX4_GLPE_PTX_DTM_LOG_MASK 0x44014118
#define IG3_PTX4_GLPE_PTX_DTM_LOG_MASK_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_DTM_LOG_MASK_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_LOG_PATTERN 0x44014114
#define IG3_PTX4_GLPE_PTX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG 0x44014104
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_STS 0x44014108
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_PTX4_GLPE_PTX_DTM_MAIN_STS_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_PTX4_GLPE_PTX_DTM_MAIN_STS_RSVD2_S)
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_PTX4_GLPE_PTX_DTM_TIMESTAMP 0x44014130
#define IG3_PTX4_GLPE_PTX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_DTM_TIMESTAMP_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER 0x44014134
#define IG3_PTX4_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG 0x4401415C
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS 0x44014160
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG 0x4401411C
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_MODE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_PTX4_GLPE_PTX_DTM_TRIG_CFG_MODE_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_COUNT 0x44014128
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_MASK 0x44014124
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_DTM_TRIG_MASK_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_PATTERN 0x44014120
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_TIMESTAMP 0x4401412C
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_PTX4_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHHI 0x44014028
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHHI_RSVD0_S 26
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHHI_RSVD0_M RDMA_MASK3(32, 0x3F, IG3_PTX4_GLPE_PTX_FWQPFLUSHHI_RSVD0_S)
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHHI_QPID_S 6
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHHI_QPID_M RDMA_MASK3(32, 0xFFFFF, IG3_PTX4_GLPE_PTX_FWQPFLUSHHI_QPID_S)
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHHI_PF_NUM_S 0
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHHI_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX4_GLPE_PTX_FWQPFLUSHHI_PF_NUM_S)
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO 0x44014024
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_BUSY_S 31
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_BUSY_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_BUSY_S)
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_S 30
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_REQ_TYPE_S)
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_RSVD0_S 29
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_RSVD0_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_RSVD0_S)
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_HOSTID_S 26
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_HOSTID_S)
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_S 24
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_VM_VF_TYPE_S)
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_S 12
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_VM_VF_NUM_S)
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_PMF_S 0
#define IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX4_GLPE_PTX_FWQPFLUSHLO_PMF_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0 0x44014044
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_TAG_S 16
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_TAG_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_RSVD0_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_MODE_S 11
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_MODE_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1 0x44014048
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_RSVD0_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_HOSTID_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_PMF_S 0
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG1_PMF_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG2 0x4401404C
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG2_RSVD0_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG2_QPID_S 6
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG2_QPID_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG3 0x44014050
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG4 0x44014054
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG4_COUNT_S 0
#define IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_ST0_DTM_TRIG4_COUNT_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0 0x44014058
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_TAG_S 16
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_TAG_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_RSVD0_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_MODE_S 11
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_MODE_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1 0x4401405C
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_RSVD0_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_HOSTID_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_PMF_S 0
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG1_PMF_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG2 0x44014060
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG2_RSVD0_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG2_QPID_S 6
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG2_QPID_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG3 0x44014064
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG4 0x44014068
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG4_COUNT_S 0
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG4_COUNT_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT0 0x44014078
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_S 1
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT0_RSVD_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_S 0
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT0_PKT_TYPE_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT1 0x4401407C
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_S 0
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT1_RSN_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT2 0x44014080
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_S 0
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_CRT2_RSN_MASK_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE0 0x4401406C
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_S 1
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE0_RSVD_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_S 0
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE0_PKT_TYPE_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE1 0x44014070
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_S 24
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE1_RSVD_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_S 0
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE1_PSN_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE2 0x44014074
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_S 24
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE2_RSVD_S)
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_S 0
#define IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX4_GLPE_PTX_ST1_DTM_TRIG_ROCE2_PSN_MASK_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0 0x44014030
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_S 24
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD1_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_S 16
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_M RDMA_MASK3(32, 0xFF, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_S 14
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_RSVD0_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_S 13
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_ALL_TYPES_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_S 11
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_MODE_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_S 10
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_NOT_MATCH_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_S 9
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_TAG_EN_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_S 8
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_QPID_EN_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_S 7
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_TYPE_EN_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_S 6
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_VM_VF_NUM_EN_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_S 5
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_PF_NUM_EN_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_S 4
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_HOSTID_EN_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_S 3
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_PMF_EN_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_S 2
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_FLR_MATCH_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_S 1
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_FLUSH_MATCH_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_S 0
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_M RDMA_BIT2(32, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG0_PKT_MATCH_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1 0x44014034
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_S 29
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_M RDMA_MASK3(32, 0x7, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_RSVD0_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_S 26
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_M RDMA_MASK3(32, 0x7, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_HOSTID_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_S 24
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_TYPE_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_S 12
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_VM_VF_NUM_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_S 0
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_M RDMA_MASK3(32, 0xFFF, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG1_PMF_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG2 0x44014038
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_S 30
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_M RDMA_MASK3(32, 0x3, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG2_RSVD0_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_S 6
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG2_QPID_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_S 0
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG2_PF_NUM_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG3 0x4401403C
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_S 0
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG3_THRESHOLD_S)
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG4 0x44014040
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_S 0
#define IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_PTX4_GLPE_PTX_WTX_IF_DTM_TRIG4_COUNT_S)
#define IG3_PTX4_GLPE_TIMELY_STALL_THRESHOLD 0x44014008
#define IG3_PTX4_GLPE_TIMELY_STALL_THRESHOLD_RSVD_S 25
#define IG3_PTX4_GLPE_TIMELY_STALL_THRESHOLD_RSVD_M RDMA_MASK3(32, 0x7F, IG3_PTX4_GLPE_TIMELY_STALL_THRESHOLD_RSVD_S)
#define IG3_PTX4_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_S 24
#define IG3_PTX4_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_M RDMA_BIT2(32, IG3_PTX4_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_PSN_S)
#define IG3_PTX4_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_S 0
#define IG3_PTX4_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_M RDMA_MASK3(32, 0xFFFFFF, IG3_PTX4_GLPE_TIMELY_STALL_THRESHOLD_TIMELY_THRESH_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_COUNT 0x440144B8
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_CMD 0x440144CC
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_DATA_H 0x440144D8
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_DATA_L 0x440144D4
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_PTR 0x440144D0
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_CMD 0x440144BC
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_DATA_H 0x440144C8
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_DATA_L 0x440144C4
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_PTR 0x440144C0
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL 0x44014480
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_RSVD1_S 25
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_RSVD1_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_RSVD2_S 17
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_RSVD2_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_RSVD3_S 9
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_RSVD3_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_BYPASS_S 8
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_BYPASS_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_RSVD4_S 1
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_RSVD4_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_CONTROL_LOCAL_EN_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_ECC_COR_ERR 0x440144E8
#define IG3_SFPTX4_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_SFPTX4_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX4_GLPE_SFPT_DTM_ECC_COR_ERR_CNT_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_ECC_UNCOR_ERR 0x440144E4
#define IG3_SFPTX4_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_SFPTX4_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_SFPTX4_GLPE_SFPT_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_GROUP_CFG 0x4401448C
#define IG3_SFPTX4_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_SFPTX4_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPTX4_GLPE_SFPT_DTM_GROUP_CFG_RSVD1_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_SFPTX4_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX4_GLPE_SFPT_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_SFPTX4_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX4_GLPE_SFPT_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_SFPTX4_GLPE_SFPT_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_LOG_CFG 0x44014490
#define IG3_SFPTX4_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_SFPTX4_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_LOG_CFG_RSVD1_S 2
#define IG3_SFPTX4_GLPE_SFPT_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_SFPTX4_GLPE_SFPT_DTM_LOG_CFG_RSVD1_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_LOG_CFG_MODE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_SFPTX4_GLPE_SFPT_DTM_LOG_CFG_MODE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_LOG_MASK 0x44014498
#define IG3_SFPTX4_GLPE_SFPT_DTM_LOG_MASK_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_LOG_MASK_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_LOG_PATTERN 0x44014494
#define IG3_SFPTX4_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_LOG_PATTERN_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG 0x44014484
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_RSVD1_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_RSVD2_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_RSVD3_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_STS 0x44014488
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_STS_RSVD1_S 9
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_STS_RSVD1_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_STS_RSVD2_S 1
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_STS_RSVD2_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TIMESTAMP 0x440144B0
#define IG3_SFPTX4_GLPE_SFPT_DTM_TIMESTAMP_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_TIMESTAMP_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER 0x440144B4
#define IG3_SFPTX4_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG 0x440144DC
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS 0x440144E0
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_SFPTX4_GLPE_SFPT_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG 0x4401449C
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_RSVD1_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_RSVD2_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_MODE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_CFG_MODE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_COUNT 0x440144A8
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_COUNT_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_MASK 0x440144A4
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_MASK_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_MASK_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_PATTERN 0x440144A0
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_TIMESTAMP 0x440144AC
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_SFPTX4_GLPE_SFPT_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_SFPTX4_GLPE_SFP_TX_DOMAIN_ID 0x44014400
#define IG3_SFPTX4_GLPE_SFP_TX_DOMAIN_ID_RSVD_S 3
#define IG3_SFPTX4_GLPE_SFP_TX_DOMAIN_ID_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPTX4_GLPE_SFP_TX_DOMAIN_ID_RSVD_S)
#define IG3_SFPTX4_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_S 0
#define IG3_SFPTX4_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_M RDMA_MASK3(32, 0x7, IG3_SFPTX4_GLPE_SFP_TX_DOMAIN_ID_DOMAIN_ID_S)
#define IG3_SFPTX4_GLPE_SFP_TX_PER_MEM 0x44014404
#define IG3_SFPTX4_GLPE_SFP_TX_PER_MEM_RSVD_S 3
#define IG3_SFPTX4_GLPE_SFP_TX_PER_MEM_RSVD_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_SFPTX4_GLPE_SFP_TX_PER_MEM_RSVD_S)
#define IG3_SFPTX4_GLPE_SFP_TX_PER_MEM_PER_TYPE_S 0
#define IG3_SFPTX4_GLPE_SFP_TX_PER_MEM_PER_TYPE_M RDMA_MASK3(32, 0x7, IG3_SFPTX4_GLPE_SFP_TX_PER_MEM_PER_TYPE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG 0x44014800
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS 0x44014804
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_AH_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG 0x44014810
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS 0x44014814
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_ARP_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ECC_COR_ERR 0x44014834
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_ECC_COR_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR 0x44014830
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG 0x44014818
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS 0x4401481C
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_FIFO01_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG 0x44014808
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS 0x4401480C
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_HO_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG 0x44014828
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS 0x4401482C
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_Q1OC_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG 0x44014820
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS 0x44014824
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_PTX_XMIT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG 0x44014840
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS 0x44014844
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG 0x44014848
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS 0x4401484C
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_AMP_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG 0x44014850
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS 0x44014854
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG 0x44014858
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS 0x4401485C
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_DBUF_TAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR 0x4401487C
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_RSVD_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_ECC_COR_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR 0x44014878
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG 0x44014860
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS 0x44014864
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_FRAG_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG 0x44014868
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS 0x4401486C
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CMP_QUE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG 0x44014870
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS 0x44014874
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_PAL_CNTXT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG 0x44014838
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS 0x4401483C
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_SFPT_WQE_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL 0x440148C8
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_S 31
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RD_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_S 26
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_RSVD_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_S 18
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_DW_SEL_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_CTL_ADR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_DATA 0x440148CC
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_DBG_DATA_RD_DW_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG 0x440148C0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS 0x440148C4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_CT_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_ECC_COR_ERR 0x440148E4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_RSVD_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_ECC_COR_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR 0x440148E0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_ECC_UNCOR_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL 0x440148D8
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_S 31
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RD_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_S 26
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_RSVD_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_DW_SEL_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_CTL_ADR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA 0x440148DC
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_DBG_DATA_RD_DW_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG 0x440148D0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS 0x440148D4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_Q1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL 0x44014888
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_S 31
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RD_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_S 26
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_RSVD_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_S 18
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_DW_SEL_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_CTL_ADR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA 0x4401488C
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_DBG_DATA_RD_DW_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG 0x44014880
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS 0x44014884
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_0_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL 0x44014898
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_S 31
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RD_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_S 26
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_RSVD_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_S 18
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_DW_SEL_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_CTL_ADR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA 0x4401489C
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_DBG_DATA_RD_DW_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG 0x44014890
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS 0x44014894
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_1_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL 0x440148A8
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_S 31
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RD_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_S 26
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_RSVD_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_S 18
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_DW_SEL_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_CTL_ADR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA 0x440148AC
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_DBG_DATA_RD_DW_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG 0x440148A0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS 0x440148A4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_2_MEM_STATUS_ECC_ERR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL 0x440148B8
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_S 31
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RD_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_S 26
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_RSVD_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_S 18
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_DW_SEL_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_CTL_ADR_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA 0x440148BC
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_DBG_DATA_RD_DW_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG 0x440148B0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INST_NUM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_S 20
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD3_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_S 16
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RM_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_S 14
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_POWER_GATE_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RME_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_S 10
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_S 9
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ERR_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_S 8
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_FIX_CNT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_S 6
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_S 5
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_MASK_INT_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_BYPASS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_LS_FORCE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_2_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_INVERT_1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_CFG_ECC_EN_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS 0x440148B4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_S 30
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD1_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_S 4
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_RSVD0_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_S 2
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_INIT_DONE_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_S 1
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_FIX_S)
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_S 0
#define IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_TILE4_TX_SHCTL_GLPE_WTX_SPAD_3_MEM_STATUS_ECC_ERR_S)
#define IG3_DRX4_GLPE_DRX_CONFIG 0x44020000
#define IG3_DRX4_GLPE_DRX_CONFIG_RSVD1_S 3
#define IG3_DRX4_GLPE_DRX_CONFIG_RSVD1_M RDMA_MASK3(32, 0x1FFFFFFF, IG3_DRX4_GLPE_DRX_CONFIG_RSVD1_S)
#define IG3_DRX4_GLPE_DRX_CONFIG_CRC_MASK_S 0
#define IG3_DRX4_GLPE_DRX_CONFIG_CRC_MASK_M RDMA_MASK3(32, 0x7, IG3_DRX4_GLPE_DRX_CONFIG_CRC_MASK_S)
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_COUNT 0x440200B8
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX4_GLPE_DRX_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX4_GLPE_DRX_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_CMD 0x440200CC
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_DATA_H 0x440200D8
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_DATA_L 0x440200D4
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_PTR 0x440200D0
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX4_GLPE_DRX_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_CMD 0x440200BC
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_DATA_H 0x440200C8
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_DATA_L 0x440200C4
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_PTR 0x440200C0
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX4_GLPE_DRX_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL 0x44020080
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_RSVD1_S 25
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_DRX4_GLPE_DRX_DTM_CONTROL_RSVD1_S)
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_RSVD2_S 17
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX4_GLPE_DRX_DTM_CONTROL_RSVD2_S)
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_RSVD3_S 9
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_DRX4_GLPE_DRX_DTM_CONTROL_RSVD3_S)
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_BYPASS_S 8
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_CONTROL_BYPASS_S)
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_RSVD4_S 1
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_DRX4_GLPE_DRX_DTM_CONTROL_RSVD4_S)
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_DRX4_GLPE_DRX_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_CONTROL_LOCAL_EN_S)
#define IG3_DRX4_GLPE_DRX_DTM_ECC_COR_ERR 0x440200E8
#define IG3_DRX4_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_DRX4_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX4_GLPE_DRX_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_DRX4_GLPE_DRX_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_DRX4_GLPE_DRX_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX4_GLPE_DRX_DTM_ECC_COR_ERR_CNT_S)
#define IG3_DRX4_GLPE_DRX_DTM_ECC_UNCOR_ERR 0x440200E4
#define IG3_DRX4_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_DRX4_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX4_GLPE_DRX_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_DRX4_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_DRX4_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX4_GLPE_DRX_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_DRX4_GLPE_DRX_DTM_GROUP_CFG 0x4402008C
#define IG3_DRX4_GLPE_DRX_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_DRX4_GLPE_DRX_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_DRX4_GLPE_DRX_DTM_GROUP_CFG_RSVD1_S)
#define IG3_DRX4_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_DRX4_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX4_GLPE_DRX_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_DRX4_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_DRX4_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX4_GLPE_DRX_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_DRX4_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_DRX4_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_DRX4_GLPE_DRX_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_DRX4_GLPE_DRX_DTM_LOG_CFG 0x44020090
#define IG3_DRX4_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_DRX4_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_DRX4_GLPE_DRX_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_DRX4_GLPE_DRX_DTM_LOG_CFG_RSVD1_S 2
#define IG3_DRX4_GLPE_DRX_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_DRX4_GLPE_DRX_DTM_LOG_CFG_RSVD1_S)
#define IG3_DRX4_GLPE_DRX_DTM_LOG_CFG_MODE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_DRX4_GLPE_DRX_DTM_LOG_CFG_MODE_S)
#define IG3_DRX4_GLPE_DRX_DTM_LOG_MASK 0x44020098
#define IG3_DRX4_GLPE_DRX_DTM_LOG_MASK_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX4_GLPE_DRX_DTM_LOG_MASK_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_LOG_PATTERN 0x44020094
#define IG3_DRX4_GLPE_DRX_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX4_GLPE_DRX_DTM_LOG_PATTERN_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG 0x44020084
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_RSVD1_S)
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_RSVD2_S)
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_RSVD3_S)
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_STS 0x44020088
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_STS_RSVD1_S 9
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_DRX4_GLPE_DRX_DTM_MAIN_STS_RSVD1_S)
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_STS_RSVD2_S 1
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_DRX4_GLPE_DRX_DTM_MAIN_STS_RSVD2_S)
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_DRX4_GLPE_DRX_DTM_TIMESTAMP 0x440200B0
#define IG3_DRX4_GLPE_DRX_DTM_TIMESTAMP_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX4_GLPE_DRX_DTM_TIMESTAMP_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER 0x440200B4
#define IG3_DRX4_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX4_GLPE_DRX_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG 0x440200DC
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS 0x440200E0
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DRX4_GLPE_DRX_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG 0x4402009C
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_RSVD1_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_RSVD2_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_MODE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_DRX4_GLPE_DRX_DTM_TRIG_CFG_MODE_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_COUNT 0x440200A8
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX4_GLPE_DRX_DTM_TRIG_COUNT_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_MASK 0x440200A4
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_MASK_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX4_GLPE_DRX_DTM_TRIG_MASK_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_PATTERN 0x440200A0
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX4_GLPE_DRX_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_TIMESTAMP 0x440200AC
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_DRX4_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_DRX4_GLPE_DRX_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_DRX4_GLPE_DRX_ECC_COR_ERR 0x44020004
#define IG3_DRX4_GLPE_DRX_ECC_COR_ERR_RSVD_S 12
#define IG3_DRX4_GLPE_DRX_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX4_GLPE_DRX_ECC_COR_ERR_RSVD_S)
#define IG3_DRX4_GLPE_DRX_ECC_COR_ERR_CNT_S 0
#define IG3_DRX4_GLPE_DRX_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX4_GLPE_DRX_ECC_COR_ERR_CNT_S)
#define IG3_DRX4_GLPE_DRX_ECC_UNCOR_ERR 0x44020008
#define IG3_DRX4_GLPE_DRX_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_DRX4_GLPE_DRX_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_DRX4_GLPE_DRX_ECC_UNCOR_ERR_RSVD_S)
#define IG3_DRX4_GLPE_DRX_ECC_UNCOR_ERR_CNT_S 0
#define IG3_DRX4_GLPE_DRX_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_DRX4_GLPE_DRX_ECC_UNCOR_ERR_CNT_S)
#define IG3_DRX4_GLPE_PBUF_CFG 0x4402000C
#define IG3_DRX4_GLPE_PBUF_CFG_ECC_INST_NUM_S 25
#define IG3_DRX4_GLPE_PBUF_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_DRX4_GLPE_PBUF_CFG_ECC_INST_NUM_S)
#define IG3_DRX4_GLPE_PBUF_CFG_RSVD3_S 20
#define IG3_DRX4_GLPE_PBUF_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_DRX4_GLPE_PBUF_CFG_RSVD3_S)
#define IG3_DRX4_GLPE_PBUF_CFG_RM_S 16
#define IG3_DRX4_GLPE_PBUF_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_DRX4_GLPE_PBUF_CFG_RM_S)
#define IG3_DRX4_GLPE_PBUF_CFG_RSVD2_S 14
#define IG3_DRX4_GLPE_PBUF_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_DRX4_GLPE_PBUF_CFG_RSVD2_S)
#define IG3_DRX4_GLPE_PBUF_CFG_POWER_GATE_EN_S 13
#define IG3_DRX4_GLPE_PBUF_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_DRX4_GLPE_PBUF_CFG_POWER_GATE_EN_S)
#define IG3_DRX4_GLPE_PBUF_CFG_RME_S 12
#define IG3_DRX4_GLPE_PBUF_CFG_RME_M RDMA_BIT2(32, IG3_DRX4_GLPE_PBUF_CFG_RME_S)
#define IG3_DRX4_GLPE_PBUF_CFG_RSVD1_S 10
#define IG3_DRX4_GLPE_PBUF_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX4_GLPE_PBUF_CFG_RSVD1_S)
#define IG3_DRX4_GLPE_PBUF_CFG_ERR_CNT_S 9
#define IG3_DRX4_GLPE_PBUF_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_DRX4_GLPE_PBUF_CFG_ERR_CNT_S)
#define IG3_DRX4_GLPE_PBUF_CFG_FIX_CNT_S 8
#define IG3_DRX4_GLPE_PBUF_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_DRX4_GLPE_PBUF_CFG_FIX_CNT_S)
#define IG3_DRX4_GLPE_PBUF_CFG_RSVD0_S 6
#define IG3_DRX4_GLPE_PBUF_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_DRX4_GLPE_PBUF_CFG_RSVD0_S)
#define IG3_DRX4_GLPE_PBUF_CFG_MASK_INT_S 5
#define IG3_DRX4_GLPE_PBUF_CFG_MASK_INT_M RDMA_BIT2(32, IG3_DRX4_GLPE_PBUF_CFG_MASK_INT_S)
#define IG3_DRX4_GLPE_PBUF_CFG_LS_BYPASS_S 4
#define IG3_DRX4_GLPE_PBUF_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_DRX4_GLPE_PBUF_CFG_LS_BYPASS_S)
#define IG3_DRX4_GLPE_PBUF_CFG_LS_FORCE_S 3
#define IG3_DRX4_GLPE_PBUF_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_DRX4_GLPE_PBUF_CFG_LS_FORCE_S)
#define IG3_DRX4_GLPE_PBUF_CFG_ECC_INVERT_2_S 2
#define IG3_DRX4_GLPE_PBUF_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_DRX4_GLPE_PBUF_CFG_ECC_INVERT_2_S)
#define IG3_DRX4_GLPE_PBUF_CFG_ECC_INVERT_1_S 1
#define IG3_DRX4_GLPE_PBUF_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_DRX4_GLPE_PBUF_CFG_ECC_INVERT_1_S)
#define IG3_DRX4_GLPE_PBUF_CFG_ECC_EN_S 0
#define IG3_DRX4_GLPE_PBUF_CFG_ECC_EN_M RDMA_BIT2(32, IG3_DRX4_GLPE_PBUF_CFG_ECC_EN_S)
#define IG3_DRX4_GLPE_PBUF_STATUS 0x44020010
#define IG3_DRX4_GLPE_PBUF_STATUS_RSVD1_S 30
#define IG3_DRX4_GLPE_PBUF_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_DRX4_GLPE_PBUF_STATUS_RSVD1_S)
#define IG3_DRX4_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_DRX4_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_DRX4_GLPE_PBUF_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_DRX4_GLPE_PBUF_STATUS_RSVD0_S 4
#define IG3_DRX4_GLPE_PBUF_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_DRX4_GLPE_PBUF_STATUS_RSVD0_S)
#define IG3_DRX4_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_DRX4_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_DRX4_GLPE_PBUF_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_DRX4_GLPE_PBUF_STATUS_INIT_DONE_S 2
#define IG3_DRX4_GLPE_PBUF_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_DRX4_GLPE_PBUF_STATUS_INIT_DONE_S)
#define IG3_DRX4_GLPE_PBUF_STATUS_ECC_FIX_S 1
#define IG3_DRX4_GLPE_PBUF_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_DRX4_GLPE_PBUF_STATUS_ECC_FIX_S)
#define IG3_DRX4_GLPE_PBUF_STATUS_ECC_ERR_S 0
#define IG3_DRX4_GLPE_PBUF_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_DRX4_GLPE_PBUF_STATUS_ECC_ERR_S)
#define IG3_CMPE4_CMPE_ECC_COR_ERR 0x4402053C
#define IG3_CMPE4_CMPE_ECC_COR_ERR_RSVD_S 12
#define IG3_CMPE4_CMPE_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE4_CMPE_ECC_COR_ERR_RSVD_S)
#define IG3_CMPE4_CMPE_ECC_COR_ERR_CNT_S 0
#define IG3_CMPE4_CMPE_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE4_CMPE_ECC_COR_ERR_CNT_S)
#define IG3_CMPE4_CMPE_ECC_UNCOR_ERR 0x44020538
#define IG3_CMPE4_CMPE_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CMPE4_CMPE_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE4_CMPE_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CMPE4_CMPE_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CMPE4_CMPE_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE4_CMPE_ECC_UNCOR_ERR_CNT_S)
#define IG3_CMPE4_GLCM_PECLSADDR 0x44020484
#define IG3_CMPE4_GLCM_PECLSADDR_RSVD_S 9
#define IG3_CMPE4_GLCM_PECLSADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE4_GLCM_PECLSADDR_RSVD_S)
#define IG3_CMPE4_GLCM_PECLSADDR_CLS_ADDR_S 0
#define IG3_CMPE4_GLCM_PECLSADDR_CLS_ADDR_M RDMA_MASK3(32, 0x1FF, IG3_CMPE4_GLCM_PECLSADDR_CLS_ADDR_S)
#define IG3_CMPE4_GLCM_PECLSDATA0 0x44020488
#define IG3_CMPE4_GLCM_PECLSDATA0_CLS_DATA_S 0
#define IG3_CMPE4_GLCM_PECLSDATA0_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLCM_PECLSDATA0_CLS_DATA_S)
#define IG3_CMPE4_GLCM_PECLSDATA1 0x4402048C
#define IG3_CMPE4_GLCM_PECLSDATA1_CLS_DATA_S 0
#define IG3_CMPE4_GLCM_PECLSDATA1_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLCM_PECLSDATA1_CLS_DATA_S)
#define IG3_CMPE4_GLCM_PECLSDATA2 0x44020490
#define IG3_CMPE4_GLCM_PECLSDATA2_CLS_DATA_S 0
#define IG3_CMPE4_GLCM_PECLSDATA2_CLS_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLCM_PECLSDATA2_CLS_DATA_S)
#define IG3_CMPE4_GLCM_PECONFIG 0x44020480
#define IG3_CMPE4_GLCM_PECONFIG_DBGMUX_EN_S 31
#define IG3_CMPE4_GLCM_PECONFIG_DBGMUX_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECONFIG_DBGMUX_EN_S)
#define IG3_CMPE4_GLCM_PECONFIG_RSVD13_S 30
#define IG3_CMPE4_GLCM_PECONFIG_RSVD13_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECONFIG_RSVD13_S)
#define IG3_CMPE4_GLCM_PECONFIG_DBGMUX_SEL_HI_S 25
#define IG3_CMPE4_GLCM_PECONFIG_DBGMUX_SEL_HI_M RDMA_MASK3(32, 0x1F, IG3_CMPE4_GLCM_PECONFIG_DBGMUX_SEL_HI_S)
#define IG3_CMPE4_GLCM_PECONFIG_DBGMUX_SEL_LO_S 20
#define IG3_CMPE4_GLCM_PECONFIG_DBGMUX_SEL_LO_M RDMA_MASK3(32, 0x1F, IG3_CMPE4_GLCM_PECONFIG_DBGMUX_SEL_LO_S)
#define IG3_CMPE4_GLCM_PECONFIG_RSVD10_S 17
#define IG3_CMPE4_GLCM_PECONFIG_RSVD10_M RDMA_MASK3(32, 0x7, IG3_CMPE4_GLCM_PECONFIG_RSVD10_S)
#define IG3_CMPE4_GLCM_PECONFIG_DBG_WRSEL_S 16
#define IG3_CMPE4_GLCM_PECONFIG_DBG_WRSEL_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECONFIG_DBG_WRSEL_S)
#define IG3_CMPE4_GLCM_PECONFIG_DBG_DWSEL_S 14
#define IG3_CMPE4_GLCM_PECONFIG_DBG_DWSEL_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PECONFIG_DBG_DWSEL_S)
#define IG3_CMPE4_GLCM_PECONFIG_DBG_DPSEL_S 12
#define IG3_CMPE4_GLCM_PECONFIG_DBG_DPSEL_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PECONFIG_DBG_DPSEL_S)
#define IG3_CMPE4_GLCM_PECONFIG_RSVD6_S 7
#define IG3_CMPE4_GLCM_PECONFIG_RSVD6_M RDMA_MASK3(32, 0x1F, IG3_CMPE4_GLCM_PECONFIG_RSVD6_S)
#define IG3_CMPE4_GLCM_PECONFIG_DISABLE_CTXT_PACKING_S 6
#define IG3_CMPE4_GLCM_PECONFIG_DISABLE_CTXT_PACKING_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECONFIG_DISABLE_CTXT_PACKING_S)
#define IG3_CMPE4_GLCM_PECONFIG_DISABLE_LSA_S 5
#define IG3_CMPE4_GLCM_PECONFIG_DISABLE_LSA_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECONFIG_DISABLE_LSA_S)
#define IG3_CMPE4_GLCM_PECONFIG_ENABLE_CRC_S 4
#define IG3_CMPE4_GLCM_PECONFIG_ENABLE_CRC_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECONFIG_ENABLE_CRC_S)
#define IG3_CMPE4_GLCM_PECONFIG_DISABLE_RESCHEDULE_S 3
#define IG3_CMPE4_GLCM_PECONFIG_DISABLE_RESCHEDULE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECONFIG_DISABLE_RESCHEDULE_S)
#define IG3_CMPE4_GLCM_PECONFIG_DISABLE_PACKET_COUNT_S 2
#define IG3_CMPE4_GLCM_PECONFIG_DISABLE_PACKET_COUNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECONFIG_DISABLE_PACKET_COUNT_S)
#define IG3_CMPE4_GLCM_PECONFIG_GLOBAL_LOCK_MODE_S 1
#define IG3_CMPE4_GLCM_PECONFIG_GLOBAL_LOCK_MODE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECONFIG_GLOBAL_LOCK_MODE_S)
#define IG3_CMPE4_GLCM_PECONFIG_RSVD1_S 0
#define IG3_CMPE4_GLCM_PECONFIG_RSVD1_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECONFIG_RSVD1_S)
#define IG3_CMPE4_GLCM_PECTXDGCTL 0x440204C8
#define IG3_CMPE4_GLCM_PECTXDGCTL_RSVD_S 12
#define IG3_CMPE4_GLCM_PECTXDGCTL_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE4_GLCM_PECTXDGCTL_RSVD_S)
#define IG3_CMPE4_GLCM_PECTXDGCTL_PKTCNT_S 10
#define IG3_CMPE4_GLCM_PECTXDGCTL_PKTCNT_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PECTXDGCTL_PKTCNT_S)
#define IG3_CMPE4_GLCM_PECTXDGCTL_OP_CODE_S 8
#define IG3_CMPE4_GLCM_PECTXDGCTL_OP_CODE_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PECTXDGCTL_OP_CODE_S)
#define IG3_CMPE4_GLCM_PECTXDGCTL_ALLOCATE_S 7
#define IG3_CMPE4_GLCM_PECTXDGCTL_ALLOCATE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECTXDGCTL_ALLOCATE_S)
#define IG3_CMPE4_GLCM_PECTXDGCTL_WRITEBACK_S 6
#define IG3_CMPE4_GLCM_PECTXDGCTL_WRITEBACK_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECTXDGCTL_WRITEBACK_S)
#define IG3_CMPE4_GLCM_PECTXDGCTL_INVALIDATE_S 5
#define IG3_CMPE4_GLCM_PECTXDGCTL_INVALIDATE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECTXDGCTL_INVALIDATE_S)
#define IG3_CMPE4_GLCM_PECTXDGCTL_SUB_LINE_S 0
#define IG3_CMPE4_GLCM_PECTXDGCTL_SUB_LINE_M RDMA_MASK3(32, 0x1F, IG3_CMPE4_GLCM_PECTXDGCTL_SUB_LINE_S)
#define IG3_CMPE4_GLCM_PECTXDGDATA(_i) 0x440204CC + ((_i) * 4) /* _i=0...3 */
#define IG3_CMPE4_GLCM_PECTXDGDATA_MAX_INDEX_I 3
#define IG3_CMPE4_GLCM_PECTXDGDATA_DATA_S 0
#define IG3_CMPE4_GLCM_PECTXDGDATA_DATA_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLCM_PECTXDGDATA_DATA_S)
#define IG3_CMPE4_GLCM_PECTXDGFN 0x440204C0
#define IG3_CMPE4_GLCM_PECTXDGFN_RSVD_S 20
#define IG3_CMPE4_GLCM_PECTXDGFN_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE4_GLCM_PECTXDGFN_RSVD_S)
#define IG3_CMPE4_GLCM_PECTXDGFN_FUNC_TRIPLET_S 0
#define IG3_CMPE4_GLCM_PECTXDGFN_FUNC_TRIPLET_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE4_GLCM_PECTXDGFN_FUNC_TRIPLET_S)
#define IG3_CMPE4_GLCM_PECTXDGQP 0x440204C4
#define IG3_CMPE4_GLCM_PECTXDGQP_RSVD_S 24
#define IG3_CMPE4_GLCM_PECTXDGQP_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLCM_PECTXDGQP_RSVD_S)
#define IG3_CMPE4_GLCM_PECTXDGQP_QUEUE_NUM_S 0
#define IG3_CMPE4_GLCM_PECTXDGQP_QUEUE_NUM_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE4_GLCM_PECTXDGQP_QUEUE_NUM_S)
#define IG3_CMPE4_GLCM_PECTXDGSTAT 0x440204DC
#define IG3_CMPE4_GLCM_PECTXDGSTAT_RSVD_S 2
#define IG3_CMPE4_GLCM_PECTXDGSTAT_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_CMPE4_GLCM_PECTXDGSTAT_RSVD_S)
#define IG3_CMPE4_GLCM_PECTXDGSTAT_CTX_MISS_S 1
#define IG3_CMPE4_GLCM_PECTXDGSTAT_CTX_MISS_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECTXDGSTAT_CTX_MISS_S)
#define IG3_CMPE4_GLCM_PECTXDGSTAT_CTX_DONE_S 0
#define IG3_CMPE4_GLCM_PECTXDGSTAT_CTX_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PECTXDGSTAT_CTX_DONE_S)
#define IG3_CMPE4_GLCM_PEDATAREQHI 0x440204B4
#define IG3_CMPE4_GLCM_PEDATAREQHI_RSVD_S 24
#define IG3_CMPE4_GLCM_PEDATAREQHI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLCM_PEDATAREQHI_RSVD_S)
#define IG3_CMPE4_GLCM_PEDATAREQHI_DATAREQHI_S 0
#define IG3_CMPE4_GLCM_PEDATAREQHI_DATAREQHI_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE4_GLCM_PEDATAREQHI_DATAREQHI_S)
#define IG3_CMPE4_GLCM_PEDATAREQLO 0x440204B0
#define IG3_CMPE4_GLCM_PEDATAREQLO_DATAREQLOW_S 0
#define IG3_CMPE4_GLCM_PEDATAREQLO_DATAREQLOW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLCM_PEDATAREQLO_DATAREQLOW_S)
#define IG3_CMPE4_GLCM_PEDATASTALLHI 0x440204BC
#define IG3_CMPE4_GLCM_PEDATASTALLHI_RSVD_S 24
#define IG3_CMPE4_GLCM_PEDATASTALLHI_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLCM_PEDATASTALLHI_RSVD_S)
#define IG3_CMPE4_GLCM_PEDATASTALLHI_DATASTALLHI_S 0
#define IG3_CMPE4_GLCM_PEDATASTALLHI_DATASTALLHI_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE4_GLCM_PEDATASTALLHI_DATASTALLHI_S)
#define IG3_CMPE4_GLCM_PEDATASTALLLO 0x440204B8
#define IG3_CMPE4_GLCM_PEDATASTALLLO_DATASTALLLOW_S 0
#define IG3_CMPE4_GLCM_PEDATASTALLLO_DATASTALLLOW_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLCM_PEDATASTALLLO_DATASTALLLOW_S)
#define IG3_CMPE4_GLCM_PELOCKTBLADDR 0x4402049C
#define IG3_CMPE4_GLCM_PELOCKTBLADDR_RSVD_S 5
#define IG3_CMPE4_GLCM_PELOCKTBLADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFFF, IG3_CMPE4_GLCM_PELOCKTBLADDR_RSVD_S)
#define IG3_CMPE4_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_S 0
#define IG3_CMPE4_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_M RDMA_MASK3(32, 0x1F, IG3_CMPE4_GLCM_PELOCKTBLADDR_LOCKTBL_ADDR_S)
#define IG3_CMPE4_GLCM_PELOCKTBLDATA0 0x440204A0
#define IG3_CMPE4_GLCM_PELOCKTBLDATA0_GPLOCKSEL_S 31
#define IG3_CMPE4_GLCM_PELOCKTBLDATA0_GPLOCKSEL_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PELOCKTBLDATA0_GPLOCKSEL_S)
#define IG3_CMPE4_GLCM_PELOCKTBLDATA0_RSVD_S 24
#define IG3_CMPE4_GLCM_PELOCKTBLDATA0_RSVD_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLCM_PELOCKTBLDATA0_RSVD_S)
#define IG3_CMPE4_GLCM_PELOCKTBLDATA0_QPID_S 0
#define IG3_CMPE4_GLCM_PELOCKTBLDATA0_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE4_GLCM_PELOCKTBLDATA0_QPID_S)
#define IG3_CMPE4_GLCM_PELOCKTBLDATA1 0x440204A4
#define IG3_CMPE4_GLCM_PELOCKTBLDATA1_RSVD_S 20
#define IG3_CMPE4_GLCM_PELOCKTBLDATA1_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE4_GLCM_PELOCKTBLDATA1_RSVD_S)
#define IG3_CMPE4_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_S 0
#define IG3_CMPE4_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE4_GLCM_PELOCKTBLDATA1_FUNC_TRIPLET_S)
#define IG3_CMPE4_GLCM_PELOCKTBLDATA2 0x440204A8
#define IG3_CMPE4_GLCM_PELOCKTBLDATA2_LOCKSEL_S 0
#define IG3_CMPE4_GLCM_PELOCKTBLDATA2_LOCKSEL_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLCM_PELOCKTBLDATA2_LOCKSEL_S)
#define IG3_CMPE4_GLCM_PEPKTCNTADDR 0x44020494
#define IG3_CMPE4_GLCM_PEPKTCNTADDR_RSVD_S 9
#define IG3_CMPE4_GLCM_PEPKTCNTADDR_RSVD_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE4_GLCM_PEPKTCNTADDR_RSVD_S)
#define IG3_CMPE4_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_S 0
#define IG3_CMPE4_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_M RDMA_MASK3(32, 0x1FF, IG3_CMPE4_GLCM_PEPKTCNTADDR_PKTCNT_ADDR_S)
#define IG3_CMPE4_GLCM_PEPKTCNTDATA 0x44020498
#define IG3_CMPE4_GLCM_PEPKTCNTDATA_RSVD1_S 18
#define IG3_CMPE4_GLCM_PEPKTCNTDATA_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE4_GLCM_PEPKTCNTDATA_RSVD1_S)
#define IG3_CMPE4_GLCM_PEPKTCNTDATA_RLRSP_STATE_S 16
#define IG3_CMPE4_GLCM_PEPKTCNTDATA_RLRSP_STATE_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PEPKTCNTDATA_RLRSP_STATE_S)
#define IG3_CMPE4_GLCM_PEPKTCNTDATA_RSVD0_S 14
#define IG3_CMPE4_GLCM_PEPKTCNTDATA_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PEPKTCNTDATA_RSVD0_S)
#define IG3_CMPE4_GLCM_PEPKTCNTDATA_RLREQ_STATE_S 12
#define IG3_CMPE4_GLCM_PEPKTCNTDATA_RLREQ_STATE_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PEPKTCNTDATA_RLREQ_STATE_S)
#define IG3_CMPE4_GLCM_PEPKTCNTDATA_PKTCNT_S 1
#define IG3_CMPE4_GLCM_PEPKTCNTDATA_PKTCNT_M RDMA_MASK3(32, 0x7FF, IG3_CMPE4_GLCM_PEPKTCNTDATA_PKTCNT_S)
#define IG3_CMPE4_GLCM_PEPKTCNTDATA_DONE_S 0
#define IG3_CMPE4_GLCM_PEPKTCNTDATA_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PEPKTCNTDATA_DONE_S)
#define IG3_CMPE4_GLCM_PESTATSCTL 0x440204AC
#define IG3_CMPE4_GLCM_PESTATSCTL_RSVD_S 2
#define IG3_CMPE4_GLCM_PESTATSCTL_RSVD_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_CMPE4_GLCM_PESTATSCTL_RSVD_S)
#define IG3_CMPE4_GLCM_PESTATSCTL_ENABLE_S 1
#define IG3_CMPE4_GLCM_PESTATSCTL_ENABLE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PESTATSCTL_ENABLE_S)
#define IG3_CMPE4_GLCM_PESTATSCTL_CLEAR_S 0
#define IG3_CMPE4_GLCM_PESTATSCTL_CLEAR_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PESTATSCTL_CLEAR_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG 0x44020500
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_S 20
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RSVD3_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RM_S 16
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RM_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_S 14
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RSVD2_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RME_S 12
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RME_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_S 10
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_S 6
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_MASK_INT_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_CFG_ECC_EN_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS 0x44020504
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG 0x44020508
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_S 20
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RSVD3_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RM_S 16
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RM_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_S 14
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RSVD2_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RME_S 12
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RME_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_S 10
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_S 6
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_MASK_INT_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_CFG_ECC_EN_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS 0x4402050C
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE0_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG 0x44020510
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_S 20
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RSVD3_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RM_S 16
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RM_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_S 14
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RSVD2_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RME_S 12
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RME_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_S 10
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_S 6
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_MASK_INT_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_CFG_ECC_EN_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS 0x44020514
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_0_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG 0x44020518
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_S 20
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RSVD3_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RM_S 16
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RM_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_S 14
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RSVD2_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RME_S 12
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RME_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_S 10
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_S 6
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_MASK_INT_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_CFG_ECC_EN_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS 0x4402051C
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE1_1_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG 0x44020520
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RSVD3_S 20
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RSVD3_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RM_S 16
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RM_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RSVD2_S 14
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RSVD2_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RME_S 12
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RME_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RSVD1_S 10
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RSVD0_S 6
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_MASK_INT_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE2_MEM_CFG_ECC_EN_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS 0x44020524
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_CACHE2_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE4_GLCM_PE_CACHESIZE 0x440204E4
#define IG3_CMPE4_GLCM_PE_CACHESIZE_RSVD_S 26
#define IG3_CMPE4_GLCM_PE_CACHESIZE_RSVD_M RDMA_MASK3(32, 0x3F, IG3_CMPE4_GLCM_PE_CACHESIZE_RSVD_S)
#define IG3_CMPE4_GLCM_PE_CACHESIZE_WAYS_S 16
#define IG3_CMPE4_GLCM_PE_CACHESIZE_WAYS_M RDMA_MASK3(32, 0x3FF, IG3_CMPE4_GLCM_PE_CACHESIZE_WAYS_S)
#define IG3_CMPE4_GLCM_PE_CACHESIZE_SETS_S 12
#define IG3_CMPE4_GLCM_PE_CACHESIZE_SETS_M RDMA_MASK3(32, 0xF, IG3_CMPE4_GLCM_PE_CACHESIZE_SETS_S)
#define IG3_CMPE4_GLCM_PE_CACHESIZE_WORD_SIZE_S 0
#define IG3_CMPE4_GLCM_PE_CACHESIZE_WORD_SIZE_M RDMA_MASK3(32, 0xFFF, IG3_CMPE4_GLCM_PE_CACHESIZE_WORD_SIZE_S)
#define IG3_CMPE4_GLCM_PE_DPC_COMP 0x440204F4
#define IG3_CMPE4_GLCM_PE_DPC_COMP_RSVD_S 13
#define IG3_CMPE4_GLCM_PE_DPC_COMP_RSVD_M RDMA_MASK3(32, 0x7FFFF, IG3_CMPE4_GLCM_PE_DPC_COMP_RSVD_S)
#define IG3_CMPE4_GLCM_PE_DPC_COMP_COMP_FTYPE_S 11
#define IG3_CMPE4_GLCM_PE_DPC_COMP_COMP_FTYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_DPC_COMP_COMP_FTYPE_S)
#define IG3_CMPE4_GLCM_PE_DPC_COMP_COMP_FNUM_S 1
#define IG3_CMPE4_GLCM_PE_DPC_COMP_COMP_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_CMPE4_GLCM_PE_DPC_COMP_COMP_FNUM_S)
#define IG3_CMPE4_GLCM_PE_DPC_COMP_COMP_VALID_S 0
#define IG3_CMPE4_GLCM_PE_DPC_COMP_COMP_VALID_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_DPC_COMP_COMP_VALID_S)
#define IG3_CMPE4_GLCM_PE_DPC_REQ 0x440204F0
#define IG3_CMPE4_GLCM_PE_DPC_REQ_RSVD_S 12
#define IG3_CMPE4_GLCM_PE_DPC_REQ_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE4_GLCM_PE_DPC_REQ_RSVD_S)
#define IG3_CMPE4_GLCM_PE_DPC_REQ_REQ_FTYPE_S 10
#define IG3_CMPE4_GLCM_PE_DPC_REQ_REQ_FTYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_DPC_REQ_REQ_FTYPE_S)
#define IG3_CMPE4_GLCM_PE_DPC_REQ_REQ_FNUM_S 0
#define IG3_CMPE4_GLCM_PE_DPC_REQ_REQ_FNUM_M RDMA_MASK3(32, 0x3FF, IG3_CMPE4_GLCM_PE_DPC_REQ_REQ_FNUM_S)
#define IG3_CMPE4_GLCM_PE_E2E_FC 0x440204F8
#define IG3_CMPE4_GLCM_PE_E2E_FC_RSVD1_S 22
#define IG3_CMPE4_GLCM_PE_E2E_FC_RSVD1_M RDMA_MASK3(32, 0x3FF, IG3_CMPE4_GLCM_PE_E2E_FC_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_S 16
#define IG3_CMPE4_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_M RDMA_MASK3(32, 0x3F, IG3_CMPE4_GLCM_PE_E2E_FC_HMC_FC_THRESHOLD_S)
#define IG3_CMPE4_GLCM_PE_E2E_FC_RSVD0_S 9
#define IG3_CMPE4_GLCM_PE_E2E_FC_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLCM_PE_E2E_FC_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_S 0
#define IG3_CMPE4_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_M RDMA_MASK3(32, 0x1FF, IG3_CMPE4_GLCM_PE_E2E_FC_CMPE_FC_THRESHOLD_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG 0x44020528
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_S 20
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RSVD3_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RM_S 16
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RM_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_S 14
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RSVD2_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RME_S 12
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RME_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_S 10
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_S 6
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_MASK_INT_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_CFG_ECC_EN_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS 0x4402052C
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_EVICTBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG 0x44020530
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ECC_INST_NUM_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_S 20
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RSVD3_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RM_S 16
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RM_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_S 14
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RSVD2_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_POWER_GATE_EN_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RME_S 12
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RME_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RME_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_S 10
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_S 9
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ERR_CNT_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_S 8
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_FIX_CNT_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_S 6
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_S 5
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_MASK_INT_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_S 4
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_LS_BYPASS_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_S 3
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_LS_FORCE_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_2_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ECC_INVERT_1_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_S 0
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_CFG_ECC_EN_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS 0x44020534
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_S 30
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_S 4
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_S 2
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_INIT_DONE_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_S 1
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_ECC_FIX_S)
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_S 0
#define IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE4_GLCM_PE_FILLBUF_MEM_STATUS_ECC_ERR_S)
#define IG3_CMPE4_GLCM_PE_IF_FC 0x440204FC
#define IG3_CMPE4_GLCM_PE_IF_FC_RSVD1_S 22
#define IG3_CMPE4_GLCM_PE_IF_FC_RSVD1_M RDMA_MASK3(32, 0x3FF, IG3_CMPE4_GLCM_PE_IF_FC_RSVD1_S)
#define IG3_CMPE4_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_S 16
#define IG3_CMPE4_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_M RDMA_MASK3(32, 0x3F, IG3_CMPE4_GLCM_PE_IF_FC_HMC_FC_THRESHOLD_S)
#define IG3_CMPE4_GLCM_PE_IF_FC_RSVD0_S 9
#define IG3_CMPE4_GLCM_PE_IF_FC_RSVD0_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLCM_PE_IF_FC_RSVD0_S)
#define IG3_CMPE4_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_S 0
#define IG3_CMPE4_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_M RDMA_MASK3(32, 0x1FF, IG3_CMPE4_GLCM_PE_IF_FC_CMPE_FC_THRESHOLD_S)
#define IG3_CMPE4_GLCM_PE_MAXOSR 0x440204E0
#define IG3_CMPE4_GLCM_PE_MAXOSR_RSVD_S 6
#define IG3_CMPE4_GLCM_PE_MAXOSR_RSVD_M RDMA_MASK3(32, 0x3FFFFFF, IG3_CMPE4_GLCM_PE_MAXOSR_RSVD_S)
#define IG3_CMPE4_GLCM_PE_MAXOSR_MAXOSR_S 0
#define IG3_CMPE4_GLCM_PE_MAXOSR_MAXOSR_M RDMA_MASK3(32, 0x3F, IG3_CMPE4_GLCM_PE_MAXOSR_MAXOSR_S)
#define IG3_CMPE4_GLCM_PE_RLDDBGCTL0 0x440204E8
#define IG3_CMPE4_GLCM_PE_RLDDBGCTL0_RSVD_S 24
#define IG3_CMPE4_GLCM_PE_RLDDBGCTL0_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLCM_PE_RLDDBGCTL0_RSVD_S)
#define IG3_CMPE4_GLCM_PE_RLDDBGCTL0_QPID_S 0
#define IG3_CMPE4_GLCM_PE_RLDDBGCTL0_QPID_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE4_GLCM_PE_RLDDBGCTL0_QPID_S)
#define IG3_CMPE4_GLCM_PE_RLDDBGCTL1 0x440204EC
#define IG3_CMPE4_GLCM_PE_RLDDBGCTL1_RSVD_S 20
#define IG3_CMPE4_GLCM_PE_RLDDBGCTL1_RSVD_M RDMA_MASK3(32, 0xFFF, IG3_CMPE4_GLCM_PE_RLDDBGCTL1_RSVD_S)
#define IG3_CMPE4_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_S 18
#define IG3_CMPE4_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLCM_PE_RLDDBGCTL1_VM_VF_TYPE_S)
#define IG3_CMPE4_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_S 6
#define IG3_CMPE4_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CMPE4_GLCM_PE_RLDDBGCTL1_VM_VF_NUM_S)
#define IG3_CMPE4_GLCM_PE_RLDDBGCTL1_PF_NUM_S 0
#define IG3_CMPE4_GLCM_PE_RLDDBGCTL1_PF_NUM_M RDMA_MASK3(32, 0x3F, IG3_CMPE4_GLCM_PE_RLDDBGCTL1_PF_NUM_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_COUNT 0x440205B8
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_S 20
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_COUNT_RSVD1_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_COUNT_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_CMD 0x440205CC
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_S 1
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_CMD_RSVD1_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_CMD_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_DATA_H 0x440205D8
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_DATA_H_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_DATA_L 0x440205D4
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_DATA_L_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_PTR 0x440205D0
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_S 20
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_PTR_RSVD1_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_RD_PTR_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_CMD 0x440205BC
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_S 1
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_CMD_RSVD1_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_CMD_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_DATA_H 0x440205C8
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_DATA_H_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_DATA_L 0x440205C4
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_DATA_L_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_PTR 0x440205C0
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_S 20
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_M RDMA_MASK3(32, 0xFFF, IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_PTR_RSVD1_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_BUFFER_WR_PTR_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL 0x44020580
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_RSVD1_S 25
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_RSVD1_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_RSVD1_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_S 24
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_SOFT_CLEAR_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_RSVD2_S 17
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_RSVD2_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_S 16
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_FORCE_TRIG_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_RSVD3_S 9
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_RSVD3_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_RSVD3_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_BYPASS_S 8
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_BYPASS_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_BYPASS_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_RSVD4_S 1
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_RSVD4_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_RSVD4_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_CONTROL_LOCAL_EN_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_ECC_COR_ERR 0x440205E8
#define IG3_CMPE4_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_S 12
#define IG3_CMPE4_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_ECC_COR_ERR_RSVD_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE4_GLPE_CMPE_DTM_ECC_COR_ERR_CNT_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_ECC_UNCOR_ERR 0x440205E4
#define IG3_CMPE4_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_S 12
#define IG3_CMPE4_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_M RDMA_MASK3(32, 0xFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_ECC_UNCOR_ERR_RSVD_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_M RDMA_MASK3(32, 0xFFF, IG3_CMPE4_GLPE_CMPE_DTM_ECC_UNCOR_ERR_CNT_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_GROUP_CFG 0x4402058C
#define IG3_CMPE4_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_S 24
#define IG3_CMPE4_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLPE_CMPE_DTM_GROUP_CFG_RSVD1_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_S 16
#define IG3_CMPE4_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLPE_CMPE_DTM_GROUP_CFG_TRIG_GROUP_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_S 8
#define IG3_CMPE4_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLPE_CMPE_DTM_GROUP_CFG_LOG_MSGROUP_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLPE_CMPE_DTM_GROUP_CFG_LOG_LSGROUP_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_LOG_CFG 0x44020590
#define IG3_CMPE4_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_S 16
#define IG3_CMPE4_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_M RDMA_MASK3(32, 0xFFFF, IG3_CMPE4_GLPE_CMPE_DTM_LOG_CFG_LOG_POST_TRIG_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_LOG_CFG_RSVD1_S 2
#define IG3_CMPE4_GLPE_CMPE_DTM_LOG_CFG_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE4_GLPE_CMPE_DTM_LOG_CFG_RSVD1_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_LOG_CFG_MODE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_LOG_CFG_MODE_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLPE_CMPE_DTM_LOG_CFG_MODE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_LOG_MASK 0x44020598
#define IG3_CMPE4_GLPE_CMPE_DTM_LOG_MASK_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_LOG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_LOG_MASK_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_LOG_PATTERN 0x44020594
#define IG3_CMPE4_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_LOG_PATTERN_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG 0x44020584
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_S 26
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_M RDMA_MASK3(32, 0x3F, IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_RSVD1_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_S 24
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_EXTMODE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_S 17
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_RSVD2_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_S 16
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_TIMESTAMP_DIS_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_S 1
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_M RDMA_MASK3(32, 0x7FFF, IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_RSVD3_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_MAIN_CFG_EXT_TRIGOUT_DIS_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_STS 0x44020588
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_STS_RSVD1_S 9
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_STS_RSVD1_M RDMA_MASK3(32, 0x7FFFFF, IG3_CMPE4_GLPE_CMPE_DTM_MAIN_STS_RSVD1_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_S 8
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_MAIN_STS_TRACE_ERR_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_STS_RSVD2_S 1
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_STS_RSVD2_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLPE_CMPE_DTM_MAIN_STS_RSVD2_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_MAIN_STS_TRACE_DONE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TIMESTAMP 0x440205B0
#define IG3_CMPE4_GLPE_CMPE_DTM_TIMESTAMP_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_TIMESTAMP_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER 0x440205B4
#define IG3_CMPE4_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_TIMESTAMP_ROLLOVER_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG 0x440205DC
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S 25
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_M RDMA_MASK3(32, 0x7F, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INST_NUM_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_S 20
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_M RDMA_MASK3(32, 0x1F, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD3_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_S 16
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_M RDMA_MASK3(32, 0xF, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RM_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_S 14
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD2_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S 13
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_POWER_GATE_EN_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_S 12
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RME_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_S 10
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD1_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_S 9
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ERR_CNT_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_S 8
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_FIX_CNT_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_S 6
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_RSVD0_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_S 5
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_MASK_INT_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S 4
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_BYPASS_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_S 3
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_LS_FORCE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S 2
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_2_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S 1
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_INVERT_1_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_CFG_ECC_EN_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS 0x440205E0
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_S 30
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_M RDMA_MASK3(32, 0x3, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD1_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S 12
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_M RDMA_MASK3(32, 0x3FFFF, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERROR_ADDRESS_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_S 4
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_RSVD0_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S 3
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_GLOBAL_INIT_DONE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S 2
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_INIT_DONE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S 1
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_FIX_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_M RDMA_BIT2(32, IG3_CMPE4_GLPE_CMPE_DTM_TRACE_BUFFER_STATUS_ECC_ERR_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG 0x4402059C
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_S 24
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_RSVD1_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_S 16
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_EVENT_WIDTH_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_S 8
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_COUNTDOWN_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_S 4
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_M RDMA_MASK3(32, 0xF, IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_RSVD2_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_MODE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_MODE_M RDMA_MASK3(32, 0xF, IG3_CMPE4_GLPE_CMPE_DTM_TRIG_CFG_MODE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_COUNT 0x440205A8
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_TRIG_COUNT_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_MASK 0x440205A4
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_MASK_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_MASK_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_TRIG_MASK_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_PATTERN 0x440205A0
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_TRIG_PATTERN_VALUE_S)
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_TIMESTAMP 0x440205AC
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_S 0
#define IG3_CMPE4_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_M RDMA_MASK3(32, 0xFFFFFFFF, IG3_CMPE4_GLPE_CMPE_DTM_TRIG_TIMESTAMP_VALUE_S)
#define IG3_CMPE4_PFCM_PE_CRCERRINFO0(_i) 0x44020400 + ((_i) * 4) /* _i=0...15 */
#define IG3_CMPE4_PFCM_PE_CRCERRINFO0_MAX_INDEX_I 15
#define IG3_CMPE4_PFCM_PE_CRCERRINFO0_RSVD1_S 18
#define IG3_CMPE4_PFCM_PE_CRCERRINFO0_RSVD1_M RDMA_MASK3(32, 0x3FFF, IG3_CMPE4_PFCM_PE_CRCERRINFO0_RSVD1_S)
#define IG3_CMPE4_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_S 16
#define IG3_CMPE4_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_M RDMA_MASK3(32, 0x3, IG3_CMPE4_PFCM_PE_CRCERRINFO0_VM_VF_TYPE_S)
#define IG3_CMPE4_PFCM_PE_CRCERRINFO0_VM_VF_NUM_S 4
#define IG3_CMPE4_PFCM_PE_CRCERRINFO0_VM_VF_NUM_M RDMA_MASK3(32, 0xFFF, IG3_CMPE4_PFCM_PE_CRCERRINFO0_VM_VF_NUM_S)
#define IG3_CMPE4_PFCM_PE_CRCERRINFO0_RSVD0_S 1
#define IG3_CMPE4_PFCM_PE_CRCERRINFO0_RSVD0_M RDMA_MASK3(32, 0x7, IG3_CMPE4_PFCM_PE_CRCERRINFO0_RSVD0_S)
#define IG3_CMPE4_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_S 0
#define IG3_CMPE4_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_M RDMA_BIT2(32, IG3_CMPE4_PFCM_PE_CRCERRINFO0_ERROR_DETECTED_S)
#define IG3_CMPE4_PFCM_PE_CRCERRINFO1(_i) 0x44020440 + ((_i) * 4) /* _i=0...15 */
#define IG3_CMPE4_PFCM_PE_CRCERRINFO1_MAX_INDEX_I 15
#define IG3_CMPE4_PFCM_PE_CRCERRINFO1_RSVD_S 24
#define IG3_CMPE4_PFCM_PE_CRCERRINFO1_RSVD_M RDMA_MASK3(32, 0xFF, IG3_CMPE4_PFCM_PE_CRCERRINFO1_RSVD_S)
#define IG3_CMPE4_PFCM_PE_CRCERRINFO1_Q_NUM_S 0
#define IG3_CMPE4_PFCM_PE_CRCERRINFO1_Q_NUM_M RDMA_MASK3(32, 0xFFFFFF, IG3_CMPE4_PFCM_PE_CRCERRINFO1_Q_NUM_S)
#define IG3_GPV_COMP_ID_0 0x44E01FF0
#define IG3_GPV_COMP_ID_0_RSVD0_S 8
#define IG3_GPV_COMP_ID_0_RSVD0_M RDMA_MASK3(32, 0xFFFFFF, IG3_GPV_COMP_ID_0_RSVD0_S)
#define IG3_GPV_COMP_ID_0_COMP_ID_0_S 0
#define IG3_GPV_COMP_ID_0_COMP_ID_0_M RDMA_MASK3(32, 0xFF, IG3_GPV_COMP_ID_0_COMP_ID_0_S)
#define IG3_GPV_COMP_ID_1 0x44E01FF4
#define IG3_GPV_COMP_ID_1_RSVD0_S 8
#define IG3_GPV_COMP_ID_1_RSVD0_M RDMA_MASK3(32, 0xFFFFFF, IG3_GPV_COMP_ID_1_RSVD0_S)
#define IG3_GPV_COMP_ID_1_COMP_ID_1_S 0
#define IG3_GPV_COMP_ID_1_COMP_ID_1_M RDMA_MASK3(32, 0xFF, IG3_GPV_COMP_ID_1_COMP_ID_1_S)
#define IG3_GPV_COMP_ID_2 0x44E01FF8
#define IG3_GPV_COMP_ID_2_RSVD0_S 8
#define IG3_GPV_COMP_ID_2_RSVD0_M RDMA_MASK3(32, 0xFFFFFF, IG3_GPV_COMP_ID_2_RSVD0_S)
#define IG3_GPV_COMP_ID_2_COMP_ID_2_S 0
#define IG3_GPV_COMP_ID_2_COMP_ID_2_M RDMA_MASK3(32, 0xFF, IG3_GPV_COMP_ID_2_COMP_ID_2_S)
#define IG3_GPV_COMP_ID_3 0x44E01FFC
#define IG3_GPV_COMP_ID_3_RSVD0_S 8
#define IG3_GPV_COMP_ID_3_RSVD0_M RDMA_MASK3(32, 0xFFFFFF, IG3_GPV_COMP_ID_3_RSVD0_S)
#define IG3_GPV_COMP_ID_3_COMP_ID_3_S 0
#define IG3_GPV_COMP_ID_3_COMP_ID_3_M RDMA_MASK3(32, 0xFF, IG3_GPV_COMP_ID_3_COMP_ID_3_S)
#define IG3_GPV_CQP_SLV_FN_MOD 0x44E43108
#define IG3_GPV_CQP_SLV_FN_MOD_RSVD0_S 2
#define IG3_GPV_CQP_SLV_FN_MOD_RSVD0_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_GPV_CQP_SLV_FN_MOD_RSVD0_S)
#define IG3_GPV_CQP_SLV_FN_MOD_FN_MOD_S 0
#define IG3_GPV_CQP_SLV_FN_MOD_FN_MOD_M RDMA_MASK3(32, 0x3, IG3_GPV_CQP_SLV_FN_MOD_FN_MOD_S)
#define IG3_GPV_CQP_SLV_FN_MOD_AHB 0x44E43028
#define IG3_GPV_CQP_SLV_FN_MOD_AHB_RSVD0_S 2
#define IG3_GPV_CQP_SLV_FN_MOD_AHB_RSVD0_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_GPV_CQP_SLV_FN_MOD_AHB_RSVD0_S)
#define IG3_GPV_CQP_SLV_FN_MOD_AHB_WR_INC_OVERRIDE_S 1
#define IG3_GPV_CQP_SLV_FN_MOD_AHB_WR_INC_OVERRIDE_M RDMA_BIT2(32, IG3_GPV_CQP_SLV_FN_MOD_AHB_WR_INC_OVERRIDE_S)
#define IG3_GPV_CQP_SLV_FN_MOD_AHB_RD_INC_OVERRIDE_S 0
#define IG3_GPV_CQP_SLV_FN_MOD_AHB_RD_INC_OVERRIDE_M RDMA_BIT2(32, IG3_GPV_CQP_SLV_FN_MOD_AHB_RD_INC_OVERRIDE_S)
#define IG3_GPV_NSS_MSTR_FN_MOD_ISS_BM 0x44E02008
#define IG3_GPV_NSS_MSTR_FN_MOD_ISS_BM_RSVD0_S 2
#define IG3_GPV_NSS_MSTR_FN_MOD_ISS_BM_RSVD0_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_GPV_NSS_MSTR_FN_MOD_ISS_BM_RSVD0_S)
#define IG3_GPV_NSS_MSTR_FN_MOD_ISS_BM_FN_MOD_ISS_BM_S 0
#define IG3_GPV_NSS_MSTR_FN_MOD_ISS_BM_FN_MOD_ISS_BM_M RDMA_MASK3(32, 0x3, IG3_GPV_NSS_MSTR_FN_MOD_ISS_BM_FN_MOD_ISS_BM_S)
#define IG3_GPV_NSS_MSTR_SECURITY 0x44E0000C
#define IG3_GPV_NSS_MSTR_SECURITY_RSVD0_S 16
#define IG3_GPV_NSS_MSTR_SECURITY_RSVD0_M RDMA_MASK3(32, 0xFFFF, IG3_GPV_NSS_MSTR_SECURITY_RSVD0_S)
#define IG3_GPV_NSS_MSTR_SECURITY_SECURITY1_S 0
#define IG3_GPV_NSS_MSTR_SECURITY_SECURITY1_M RDMA_MASK3(32, 0xFFFF, IG3_GPV_NSS_MSTR_SECURITY_SECURITY1_S)
#define IG3_GPV_NSS_SLV_FN_MOD 0x44E42108
#define IG3_GPV_NSS_SLV_FN_MOD_RSVD0_S 2
#define IG3_GPV_NSS_SLV_FN_MOD_RSVD0_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_GPV_NSS_SLV_FN_MOD_RSVD0_S)
#define IG3_GPV_NSS_SLV_FN_MOD_FN_MOD_S 0
#define IG3_GPV_NSS_SLV_FN_MOD_FN_MOD_M RDMA_MASK3(32, 0x3, IG3_GPV_NSS_SLV_FN_MOD_FN_MOD_S)
#define IG3_GPV_OOP_SLV_FN_MOD 0x44E45108
#define IG3_GPV_OOP_SLV_FN_MOD_RSVD0_S 2
#define IG3_GPV_OOP_SLV_FN_MOD_RSVD0_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_GPV_OOP_SLV_FN_MOD_RSVD0_S)
#define IG3_GPV_OOP_SLV_FN_MOD_FN_MOD_S 0
#define IG3_GPV_OOP_SLV_FN_MOD_FN_MOD_M RDMA_MASK3(32, 0x3, IG3_GPV_OOP_SLV_FN_MOD_FN_MOD_S)
#define IG3_GPV_OOP_SLV_FN_MOD_AHB 0x44E45028
#define IG3_GPV_OOP_SLV_FN_MOD_AHB_RSVD0_S 2
#define IG3_GPV_OOP_SLV_FN_MOD_AHB_RSVD0_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_GPV_OOP_SLV_FN_MOD_AHB_RSVD0_S)
#define IG3_GPV_OOP_SLV_FN_MOD_AHB_WR_INC_OVERRIDE_S 1
#define IG3_GPV_OOP_SLV_FN_MOD_AHB_WR_INC_OVERRIDE_M RDMA_BIT2(32, IG3_GPV_OOP_SLV_FN_MOD_AHB_WR_INC_OVERRIDE_S)
#define IG3_GPV_OOP_SLV_FN_MOD_AHB_RD_INC_OVERRIDE_S 0
#define IG3_GPV_OOP_SLV_FN_MOD_AHB_RD_INC_OVERRIDE_M RDMA_BIT2(32, IG3_GPV_OOP_SLV_FN_MOD_AHB_RD_INC_OVERRIDE_S)
#define IG3_GPV_PEIP_IB_FN_MOD2 0x44E03024
#define IG3_GPV_PEIP_IB_FN_MOD2_RSVD0_S 1
#define IG3_GPV_PEIP_IB_FN_MOD2_RSVD0_M RDMA_MASK3(32, 0x7FFFFFFF, IG3_GPV_PEIP_IB_FN_MOD2_RSVD0_S)
#define IG3_GPV_PEIP_IB_FN_MOD2_BYPASS_MERGE_S 0
#define IG3_GPV_PEIP_IB_FN_MOD2_BYPASS_MERGE_M RDMA_BIT2(32, IG3_GPV_PEIP_IB_FN_MOD2_BYPASS_MERGE_S)
#define IG3_GPV_PEIP_IB_FN_MOD_ISS_BM 0x44E03008
#define IG3_GPV_PEIP_IB_FN_MOD_ISS_BM_RSVD0_S 2
#define IG3_GPV_PEIP_IB_FN_MOD_ISS_BM_RSVD0_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_GPV_PEIP_IB_FN_MOD_ISS_BM_RSVD0_S)
#define IG3_GPV_PEIP_IB_FN_MOD_ISS_BM_FN_MOD_ISS_BM_S 0
#define IG3_GPV_PEIP_IB_FN_MOD_ISS_BM_FN_MOD_ISS_BM_M RDMA_MASK3(32, 0x3, IG3_GPV_PEIP_IB_FN_MOD_ISS_BM_FN_MOD_ISS_BM_S)
#define IG3_GPV_PERIPH_ID_0 0x44E01FE0
#define IG3_GPV_PERIPH_ID_0_RSVD0_S 8
#define IG3_GPV_PERIPH_ID_0_RSVD0_M RDMA_MASK3(32, 0xFFFFFF, IG3_GPV_PERIPH_ID_0_RSVD0_S)
#define IG3_GPV_PERIPH_ID_0_PERIPH_ID_0_S 0
#define IG3_GPV_PERIPH_ID_0_PERIPH_ID_0_M RDMA_MASK3(32, 0xFF, IG3_GPV_PERIPH_ID_0_PERIPH_ID_0_S)
#define IG3_GPV_PERIPH_ID_1 0x44E01FE4
#define IG3_GPV_PERIPH_ID_1_RSVD0_S 8
#define IG3_GPV_PERIPH_ID_1_RSVD0_M RDMA_MASK3(32, 0xFFFFFF, IG3_GPV_PERIPH_ID_1_RSVD0_S)
#define IG3_GPV_PERIPH_ID_1_PERIPH_ID_1_S 0
#define IG3_GPV_PERIPH_ID_1_PERIPH_ID_1_M RDMA_MASK3(32, 0xFF, IG3_GPV_PERIPH_ID_1_PERIPH_ID_1_S)
#define IG3_GPV_PERIPH_ID_2 0x44E01FE8
#define IG3_GPV_PERIPH_ID_2_RSVD0_S 8
#define IG3_GPV_PERIPH_ID_2_RSVD0_M RDMA_MASK3(32, 0xFFFFFF, IG3_GPV_PERIPH_ID_2_RSVD0_S)
#define IG3_GPV_PERIPH_ID_2_PERIPH_ID_2_S 0
#define IG3_GPV_PERIPH_ID_2_PERIPH_ID_2_M RDMA_MASK3(32, 0xFF, IG3_GPV_PERIPH_ID_2_PERIPH_ID_2_S)
#define IG3_GPV_PERIPH_ID_3 0x44E01FEC
#define IG3_GPV_PERIPH_ID_3_RSVD0_S 8
#define IG3_GPV_PERIPH_ID_3_RSVD0_M RDMA_MASK3(32, 0xFFFFFF, IG3_GPV_PERIPH_ID_3_RSVD0_S)
#define IG3_GPV_PERIPH_ID_3_REV_AND_S 4
#define IG3_GPV_PERIPH_ID_3_REV_AND_M RDMA_MASK3(32, 0xF, IG3_GPV_PERIPH_ID_3_REV_AND_S)
#define IG3_GPV_PERIPH_ID_3_CUST_MOD_NUM_S 0
#define IG3_GPV_PERIPH_ID_3_CUST_MOD_NUM_M RDMA_MASK3(32, 0xF, IG3_GPV_PERIPH_ID_3_CUST_MOD_NUM_S)
#define IG3_GPV_PERIPH_ID_4 0x44E01FD0
#define IG3_GPV_PERIPH_ID_4_RSVD0_S 8
#define IG3_GPV_PERIPH_ID_4_RSVD0_M RDMA_MASK3(32, 0xFFFFFF, IG3_GPV_PERIPH_ID_4_RSVD0_S)
#define IG3_GPV_PERIPH_ID_4_PERIPH_ID_4_S 0
#define IG3_GPV_PERIPH_ID_4_PERIPH_ID_4_M RDMA_MASK3(32, 0xFF, IG3_GPV_PERIPH_ID_4_PERIPH_ID_4_S)
#define IG3_GPV_PERIPH_ID_5 0x44E01FD4
#define IG3_GPV_PERIPH_ID_5_RSVD0_S 8
#define IG3_GPV_PERIPH_ID_5_RSVD0_M RDMA_MASK3(32, 0xFFFFFF, IG3_GPV_PERIPH_ID_5_RSVD0_S)
#define IG3_GPV_PERIPH_ID_5_PERIPH_ID_5_S 0
#define IG3_GPV_PERIPH_ID_5_PERIPH_ID_5_M RDMA_MASK3(32, 0xFF, IG3_GPV_PERIPH_ID_5_PERIPH_ID_5_S)
#define IG3_GPV_PERIPH_ID_6 0x44E01FD8
#define IG3_GPV_PERIPH_ID_6_RSVD0_S 8
#define IG3_GPV_PERIPH_ID_6_RSVD0_M RDMA_MASK3(32, 0xFFFFFF, IG3_GPV_PERIPH_ID_6_RSVD0_S)
#define IG3_GPV_PERIPH_ID_6_PERIPH_ID_6_S 0
#define IG3_GPV_PERIPH_ID_6_PERIPH_ID_6_M RDMA_MASK3(32, 0xFF, IG3_GPV_PERIPH_ID_6_PERIPH_ID_6_S)
#define IG3_GPV_PERIPH_ID_7 0x44E01FDC
#define IG3_GPV_PERIPH_ID_7_RSVD0_S 8
#define IG3_GPV_PERIPH_ID_7_RSVD0_M RDMA_MASK3(32, 0xFFFFFF, IG3_GPV_PERIPH_ID_7_RSVD0_S)
#define IG3_GPV_PERIPH_ID_7_PERIPH_ID_7_S 0
#define IG3_GPV_PERIPH_ID_7_PERIPH_ID_7_M RDMA_MASK3(32, 0xFF, IG3_GPV_PERIPH_ID_7_PERIPH_ID_7_S)
#define IG3_GPV_TEP_SLV_FN_MOD 0x44E44108
#define IG3_GPV_TEP_SLV_FN_MOD_RSVD0_S 2
#define IG3_GPV_TEP_SLV_FN_MOD_RSVD0_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_GPV_TEP_SLV_FN_MOD_RSVD0_S)
#define IG3_GPV_TEP_SLV_FN_MOD_FN_MOD_S 0
#define IG3_GPV_TEP_SLV_FN_MOD_FN_MOD_M RDMA_MASK3(32, 0x3, IG3_GPV_TEP_SLV_FN_MOD_FN_MOD_S)
#define IG3_GPV_TEP_SLV_FN_MOD_AHB 0x44E44028
#define IG3_GPV_TEP_SLV_FN_MOD_AHB_RSVD0_S 2
#define IG3_GPV_TEP_SLV_FN_MOD_AHB_RSVD0_M RDMA_MASK3(32, 0x3FFFFFFF, IG3_GPV_TEP_SLV_FN_MOD_AHB_RSVD0_S)
#define IG3_GPV_TEP_SLV_FN_MOD_AHB_WR_INC_OVERRIDE_S 1
#define IG3_GPV_TEP_SLV_FN_MOD_AHB_WR_INC_OVERRIDE_M RDMA_BIT2(32, IG3_GPV_TEP_SLV_FN_MOD_AHB_WR_INC_OVERRIDE_S)
#define IG3_GPV_TEP_SLV_FN_MOD_AHB_RD_INC_OVERRIDE_S 0
#define IG3_GPV_TEP_SLV_FN_MOD_AHB_RD_INC_OVERRIDE_M RDMA_BIT2(32, IG3_GPV_TEP_SLV_FN_MOD_AHB_RD_INC_OVERRIDE_S)

#define IG3_VFINT_DYN_CTLN_0 0x00003800 /* from CPK */
#define IG3_VF_DB_ADDR_OFFSET (64 * 1024) /* from CPK */

#define IG3_DB_ADDR_OFFSET (192 * 1024 * 1024)
#define IG3_GLPCI_LBARCTRL 0x0009DE74  /* from CPK */

#define IG3_GLINT_BASE                    0x08900000
#define IG3_GLINT_DYN_CTL(_INT)           (IG3_GLINT_BASE + ((_INT) * 0x1000))
#define IG3_GLINT_DYN_CTL_INTENA_S        0
#define IG3_GLINT_DYN_CTL_INTENA_M        BIT(IG3_GLINT_DYN_CTL_INTENA_S)
#define IG3_GLINT_DYN_CTL_CLEARPBA_S      1
#define IG3_GLINT_DYN_CTL_CLEARPBA_M      BIT(IG3_GLINT_DYN_CTL_CLEARPBA_S)
#define IG3_GLINT_DYN_CTL_SWINT_TRIG_S    2
#define IG3_GLINT_DYN_CTL_SWINT_TRIG_M    BIT(IG3_GLINT_DYN_CTL_SWINT_TRIG_S)
#define IG3_GLINT_DYN_CTL_ITR_INDX_S      3
#define IG3_GLINT_DYN_CTL_INTERVAL_S      5
#define IG3_GLINT_DYN_CTL_INTERVAL_M      BIT(IG3_GLINT_DYN_CTL_INTERVAL_S)
#define IG3_GLINT_DYN_CTL_SW_ITR_INDX_ENA_S       24
#define IG3_GLINT_DYN_CTL_SW_ITR_INDX_ENA_M BIT(IG3_GLINT_DYN_CTL_SW_ITR_INDX_ENA_S)
#define IG3_GLINT_DYN_CTL_SW_ITR_INDX_S   25
#define IG3_GLINT_DYN_CTL_SW_ITR_INDX_M   BIT(IG3_GLINT_DYN_CTL_SW_ITR_INDX_S)
#define IG3_GLINT_DYN_CTL_INTENA_MSK_S    31
#define IG3_GLINT_DYN_CTL_INTENA_MSK_M    BIT(IG3_GLINT_DYN_CTL_INTENA_MSK_S)
#define IG3_GLINT_ITR(_i, _INT) (IG3_GLINT_BASE + (((_INT)+(((_i)+1) * 4)) * 0x1000))

#endif /* IG3RDMA_REGS_H */
